""" Cisco_IOS_XR_mpls_te_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR mpls\-te package operational data.

This module contains definitions
for the following management objects\:
  mpls\-te\: MPLS Traffic Engineering operational data
  mpls\-lcac\-standby\: mpls lcac standby
  mpls\-lcac\: mpls lcac
  mpls\-pce\: mpls pce
  mpls\-pce\-stdby\: mpls pce stdby
  mpls\-tp\: mpls tp
  mpls\-te\-standby\: mpls te standby

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class AdmissionPolicy(Enum):
    """
    AdmissionPolicy

    Deprecated

    .. data:: reject_all = 0

    	Deprecated

    .. data:: allow_all = 1

    	Deprecated

    .. data:: reject_huge = 2

    	Deprecated

    .. data:: allow_if_room = 3

    	Deprecated

    """

    reject_all = Enum.YLeaf(0, "reject-all")

    allow_all = Enum.YLeaf(1, "allow-all")

    reject_huge = Enum.YLeaf(2, "reject-huge")

    allow_if_room = Enum.YLeaf(3, "allow-if-room")


class AutoBackupProtection(Enum):
    """
    AutoBackupProtection

    Auto backup protection

    .. data:: protection_none = 0

    	No Autobackup Protection

    .. data:: protection_next_hop = 1

    	NHOP Autobackup Protection

    .. data:: protection_next_next_hop = 2

    	NNHOP Autobackup Protection

    """

    protection_none = Enum.YLeaf(0, "protection-none")

    protection_next_hop = Enum.YLeaf(1, "protection-next-hop")

    protection_next_next_hop = Enum.YLeaf(2, "protection-next-next-hop")


class AutoBackupSrlgMode(Enum):
    """
    AutoBackupSrlgMode

    Auto backup srlg mode

    .. data:: srlg_not_set = 0

    	Autobackup SRLG type not set

    .. data:: srlg_strict = 1

    	Autobackup SRLG Strict

    .. data:: srlg_preferred = 2

    	Autobackup SRLG Preferred

    .. data:: srlg_weighted = 3

    	Autobackup Weighted SRLG

    """

    srlg_not_set = Enum.YLeaf(0, "srlg-not-set")

    srlg_strict = Enum.YLeaf(1, "srlg-strict")

    srlg_preferred = Enum.YLeaf(2, "srlg-preferred")

    srlg_weighted = Enum.YLeaf(3, "srlg-weighted")


class BandwidthAccountingCollection(Enum):
    """
    BandwidthAccountingCollection

    Types of bandwidth accounting collection

    .. data:: rsvp_te = 0

    	RSVP TE

    .. data:: segment_routing = 1

    	Segment Routing

    """

    rsvp_te = Enum.YLeaf(0, "rsvp-te")

    segment_routing = Enum.YLeaf(1, "segment-routing")


class BandwidthStateEnum(Enum):
    """
    BandwidthStateEnum

    Types of bandwidth states

    .. data:: bandwidth_held = 0

    	Bandwidth is held, is not guaranteed when it is

    	time to reserve

    .. data:: bandwidth_reserved = 1

    	Bandwidth is reserved and can be used for

    	forwarding

    .. data:: bandwidth_unknown = 2

    	Bandwidth is unknown

    """

    bandwidth_held = Enum.YLeaf(0, "bandwidth-held")

    bandwidth_reserved = Enum.YLeaf(1, "bandwidth-reserved")

    bandwidth_unknown = Enum.YLeaf(2, "bandwidth-unknown")


class BandwidthTypeEnum(Enum):
    """
    BandwidthTypeEnum

    Types of bandwidth pools

    .. data:: pool0 = 0

    	Bandwidth from the pool0

    .. data:: pool1 = 1

    	Pool1 bandwidth

    .. data:: unknown = 2

    	Unknown Bandwidth

    """

    pool0 = Enum.YLeaf(0, "pool0")

    pool1 = Enum.YLeaf(1, "pool1")

    unknown = Enum.YLeaf(2, "unknown")


class BandwidthUnitEnum(Enum):
    """
    BandwidthUnitEnum

    Types of bandwidth units

    .. data:: kilo_bits_per_second = 0

    	kilobits per second

    .. data:: kilo_bytes_per_second = 1

    	kilobytes per second

    """

    kilo_bits_per_second = Enum.YLeaf(0, "kilo-bits-per-second")

    kilo_bytes_per_second = Enum.YLeaf(1, "kilo-bytes-per-second")


class Ctype(Enum):
    """
    Ctype

    Ctype

    .. data:: ctype_null = 0

    	CTYPE NULL

    .. data:: ctype_ipv4 = 1

    	CTYPE IPV4

    .. data:: ctype_ipv4_p2p_tunnel = 7

    	CTYPE IPV4 P2P TUNNEL

    .. data:: ctype_ipv6_p2p_tunnel = 8

    	CTYPE IPV6 P2P TUNNEL

    .. data:: ctype_ipv4_uni = 9

    	CTYPE IPV4 UNI

    .. data:: ctype_ipv4_p2mp_tunnel = 13

    	CTYPE IPV4 P2MP TUNNEL

    .. data:: ctype_ipv6_p2mp_tunnel = 14

    	CTYPE IPV6 P2MP TUNNEL

    """

    ctype_null = Enum.YLeaf(0, "ctype-null")

    ctype_ipv4 = Enum.YLeaf(1, "ctype-ipv4")

    ctype_ipv4_p2p_tunnel = Enum.YLeaf(7, "ctype-ipv4-p2p-tunnel")

    ctype_ipv6_p2p_tunnel = Enum.YLeaf(8, "ctype-ipv6-p2p-tunnel")

    ctype_ipv4_uni = Enum.YLeaf(9, "ctype-ipv4-uni")

    ctype_ipv4_p2mp_tunnel = Enum.YLeaf(13, "ctype-ipv4-p2mp-tunnel")

    ctype_ipv6_p2mp_tunnel = Enum.YLeaf(14, "ctype-ipv6-p2mp-tunnel")


class FlexLspLockoutOrigination(Enum):
    """
    FlexLspLockoutOrigination

    TE Flex LSP Lockout Origination

    .. data:: lockout_origination_none = 0

    	Flex LSP Lockout Origination None

    .. data:: lockout_origination_local = 1

    	Flex LSP Lockout Originated From Local

    .. data:: lockout_origination_remote = 2

    	Flex LSP Lockout Originated From Remote

    """

    lockout_origination_none = Enum.YLeaf(0, "lockout-origination-none")

    lockout_origination_local = Enum.YLeaf(1, "lockout-origination-local")

    lockout_origination_remote = Enum.YLeaf(2, "lockout-origination-remote")


class FloodingTrigger(Enum):
    """
    FloodingTrigger

    Types of flooding triggers

    .. data:: flooding_reason_unknown = 0

    	Not known what caused flooding

    .. data:: link_up = 1

    	TE link came Up

    .. data:: link_down = 2

    	TE link went Down

    .. data:: threshold_up = 3

    	Up threshold crossed in pool0

    .. data:: threshold_down = 4

    	Down threshold crossed in pool0

    .. data:: threshold_up_pool1 = 5

    	Up threshold crossed in pool1

    .. data:: threshold_down_pool1 = 6

    	Down threshold crossed in pool1

    .. data:: timer_expired = 7

    	Periodic timer expired

    .. data:: bandwidth_change = 8

    	Link BW changed

    .. data:: user = 9

    	User triggered flooding

    .. data:: rsvp_timeout = 10

    	RSVP timed out

    .. data:: rsvp_reconnect = 11

    	RSVP reconnected

    .. data:: te_exited = 12

    	TE-control process exited

    .. data:: srlg_change = 13

    	Link SRLG changed

    .. data:: hw_oor_green = 14

    	HW resources are green

    .. data:: hw_oor_yellow = 15

    	HW resources are yellow

    .. data:: hw_oor_red = 16

    	HW resources are red

    .. data:: hw_oor_recovery_duration_expired = 17

    	HW Resources are back to normal and the

    	transition period is over

    .. data:: lsp_oor_green = 18

    	LSP resources are green

    .. data:: lsp_oor_yellow = 19

    	LSP resources are yellow

    .. data:: lsp_oor_red = 20

    	LSP resources are red

    .. data:: lsp_oor_recovery_duration_expired = 21

    	LSP resources are back to normal and the

    	transition period is over

    .. data:: max_res_bandwidth_threshold_up = 22

    	Max reservable bandwidth up threshold crossed

    .. data:: max_res_bandwidth_threshold_down = 23

    	Max reservable bandwidth down threshold crossed

    """

    flooding_reason_unknown = Enum.YLeaf(0, "flooding-reason-unknown")

    link_up = Enum.YLeaf(1, "link-up")

    link_down = Enum.YLeaf(2, "link-down")

    threshold_up = Enum.YLeaf(3, "threshold-up")

    threshold_down = Enum.YLeaf(4, "threshold-down")

    threshold_up_pool1 = Enum.YLeaf(5, "threshold-up-pool1")

    threshold_down_pool1 = Enum.YLeaf(6, "threshold-down-pool1")

    timer_expired = Enum.YLeaf(7, "timer-expired")

    bandwidth_change = Enum.YLeaf(8, "bandwidth-change")

    user = Enum.YLeaf(9, "user")

    rsvp_timeout = Enum.YLeaf(10, "rsvp-timeout")

    rsvp_reconnect = Enum.YLeaf(11, "rsvp-reconnect")

    te_exited = Enum.YLeaf(12, "te-exited")

    srlg_change = Enum.YLeaf(13, "srlg-change")

    hw_oor_green = Enum.YLeaf(14, "hw-oor-green")

    hw_oor_yellow = Enum.YLeaf(15, "hw-oor-yellow")

    hw_oor_red = Enum.YLeaf(16, "hw-oor-red")

    hw_oor_recovery_duration_expired = Enum.YLeaf(17, "hw-oor-recovery-duration-expired")

    lsp_oor_green = Enum.YLeaf(18, "lsp-oor-green")

    lsp_oor_yellow = Enum.YLeaf(19, "lsp-oor-yellow")

    lsp_oor_red = Enum.YLeaf(20, "lsp-oor-red")

    lsp_oor_recovery_duration_expired = Enum.YLeaf(21, "lsp-oor-recovery-duration-expired")

    max_res_bandwidth_threshold_up = Enum.YLeaf(22, "max-res-bandwidth-threshold-up")

    max_res_bandwidth_threshold_down = Enum.YLeaf(23, "max-res-bandwidth-threshold-down")


class GmplsUniMgmtDwdmCs(Enum):
    """
    GmplsUniMgmtDwdmCs

    GMPLS\-UNI DWDM channel spacings

    .. data:: not_set = 0

    	Not Set

    .. data:: dwdm100g_hz = 1

    	100GHz

    .. data:: dwdm50g_hz = 2

    	50GHz

    .. data:: dwdm25g_hz = 3

    	25GHz

    .. data:: dwdm12g_hz = 4

    	12.5GHz

    """

    not_set = Enum.YLeaf(0, "not-set")

    dwdm100g_hz = Enum.YLeaf(1, "dwdm100g-hz")

    dwdm50g_hz = Enum.YLeaf(2, "dwdm50g-hz")

    dwdm25g_hz = Enum.YLeaf(3, "dwdm25g-hz")

    dwdm12g_hz = Enum.YLeaf(4, "dwdm12g-hz")


class GmplsUniMgmtWdmGrid(Enum):
    """
    GmplsUniMgmtWdmGrid

    GMPLS\-UNI WDM grid

    .. data:: not_set = 0

    	Not Set

    .. data:: dwdm = 1

    	DWDM

    .. data:: cwdm = 2

    	CWDM

    """

    not_set = Enum.YLeaf(0, "not-set")

    dwdm = Enum.YLeaf(1, "dwdm")

    cwdm = Enum.YLeaf(2, "cwdm")


class HwOorState(Enum):
    """
    HwOorState

    NPU resources states

    .. data:: oor_green = 0

    	NPU resources are in normal state

    .. data:: oor_yellow = 1

    	NPU resources are in minor state

    .. data:: oor_red = 2

    	NPU resources are in Major state

    """

    oor_green = Enum.YLeaf(0, "oor-green")

    oor_yellow = Enum.YLeaf(1, "oor-yellow")

    oor_red = Enum.YLeaf(2, "oor-red")


class IgpOspfAreaFormat(Enum):
    """
    IgpOspfAreaFormat

    OSPF area format

    .. data:: igp_area_format_number = 0

    	Numbered area format

    .. data:: igp_area_format_ip_addr = 1

    	IP address area format

    """

    igp_area_format_number = Enum.YLeaf(0, "igp-area-format-number")

    igp_area_format_ip_addr = Enum.YLeaf(1, "igp-area-format-ip-addr")


class IgpProtocol(Enum):
    """
    IgpProtocol

    IGP type

    .. data:: none = 0

    	No IGP protocol specified

    .. data:: isis = 1

    	IS IS

    .. data:: ospf = 2

    	OSPF

    """

    none = Enum.YLeaf(0, "none")

    isis = Enum.YLeaf(1, "isis")

    ospf = Enum.YLeaf(2, "ospf")


class IgpSubnet(Enum):
    """
    IgpSubnet

    Subnet type

    .. data:: igp_subnet_type_none = 0

    	No subnet type specified

    .. data:: p2p = 1

    	Point-to-point subnet

    .. data:: broadcast = 2

    	Broadcast subnet

    .. data:: non_broadcast_multiaccess = 3

    	Non-broadcast multi-access subnet

    .. data:: p2mp = 4

    	Point-to-multipoint subnet

    .. data:: loopback = 5

    	Loopback subnet

    """

    igp_subnet_type_none = Enum.YLeaf(0, "igp-subnet-type-none")

    p2p = Enum.YLeaf(1, "p2p")

    broadcast = Enum.YLeaf(2, "broadcast")

    non_broadcast_multiaccess = Enum.YLeaf(3, "non-broadcast-multiaccess")

    p2mp = Enum.YLeaf(4, "p2mp")

    loopback = Enum.YLeaf(5, "loopback")


class IgpteAaMetricMode(Enum):
    """
    IgpteAaMetricMode

    Autoroute\-announce metric type

    .. data:: metric_mode_none = 0

    	No metric type specified

    .. data:: relative = 1

    	Relative metric

    .. data:: absolute = 2

    	Absolute metric

    .. data:: constant = 3

    	Constant metric

    """

    metric_mode_none = Enum.YLeaf(0, "metric-mode-none")

    relative = Enum.YLeaf(1, "relative")

    absolute = Enum.YLeaf(2, "absolute")

    constant = Enum.YLeaf(3, "constant")


class IgpteLibBwModel(Enum):
    """
    IgpteLibBwModel

    Bandwidth model

    .. data:: rdm = 0

    	Russian Dolls Model

    .. data:: mam = 1

    	Maximum Allocation Model

    .. data:: not_set = 2

    	No model set

    """

    rdm = Enum.YLeaf(0, "rdm")

    mam = Enum.YLeaf(1, "mam")

    not_set = Enum.YLeaf(2, "not-set")


class LinkDirectionEnum(Enum):
    """
    LinkDirectionEnum

    Link direction types

    .. data:: link_direction_up_stream = 0

    	Upstream direction, Tail to Head

    .. data:: link_direction_down_stream = 1

    	Upstream direction, Head to Tail

    .. data:: link_direction_unknown = 2

    	Unknown direction

    """

    link_direction_up_stream = Enum.YLeaf(0, "link-direction-up-stream")

    link_direction_down_stream = Enum.YLeaf(1, "link-direction-down-stream")

    link_direction_unknown = Enum.YLeaf(2, "link-direction-unknown")


class LspAdminStatus(Enum):
    """
    LspAdminStatus

    LSP Admin Status

    .. data:: mpls_te_lsp_admin_up = 0

    	MPLS TE lsp admin up

    .. data:: mpls_te_lsp_admin_shutdown = 1

    	MPLS TE lsp admin shutdown

    """

    mpls_te_lsp_admin_up = Enum.YLeaf(0, "mpls-te-lsp-admin-up")

    mpls_te_lsp_admin_shutdown = Enum.YLeaf(1, "mpls-te-lsp-admin-shutdown")


class LspOorState(Enum):
    """
    LspOorState

    LSP OOR states

    .. data:: lsp_oor_green = 0

    	LSP numbers are in normal state

    .. data:: lsp_oor_yellow = 1

    	LSP numbers exceed the minor threshold

    .. data:: lsp_oor_red = 2

    	LSP numbers exceed the major threshold

    """

    lsp_oor_green = Enum.YLeaf(0, "lsp-oor-green")

    lsp_oor_yellow = Enum.YLeaf(1, "lsp-oor-yellow")

    lsp_oor_red = Enum.YLeaf(2, "lsp-oor-red")


class LspOperStatus(Enum):
    """
    LspOperStatus

    LSP Admin Status

    .. data:: mpls_te_lsp_oper_up = 0

    	MPLS TE lsp operational up

    .. data:: mpls_te_lsp_oper_down = 1

    	MPLS TE lsp operational down

    """

    mpls_te_lsp_oper_up = Enum.YLeaf(0, "mpls-te-lsp-oper-up")

    mpls_te_lsp_oper_down = Enum.YLeaf(1, "mpls-te-lsp-oper-down")


class MplsLibC(Enum):
    """
    MplsLibC

    Mpls lib c

    .. data:: mpls_lib_c_type_null = 0

    	NULL Ctype

    .. data:: mpls_lib_c_type_ipv4 = 1

    	IPv4 UDP

    .. data:: mpls_lib_c_type_ipv4_p2p_tunnel = 7

    	IPv4 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv6_p2p_tunnel = 8

    	IPv6 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv4_uni = 9

    	IPv4 unicast

    .. data:: mpls_lib_c_type_ipv4_p2mp_tunnel = 13

    	IPv4 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv6_p2mp_tunnel = 14

    	IPv6 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv4_tp_tunnel = 15

    	IPv4 transport protocol tunnel

    .. data:: mpls_lib_c_type_ipv6_tp_tunnel = 16

    	IPv6 transport protocol tunnel

    .. data:: mpls_lib_c_type_p2p_binding_label = 17

    	P2P transport tunnel binding label

    """

    mpls_lib_c_type_null = Enum.YLeaf(0, "mpls-lib-c-type-null")

    mpls_lib_c_type_ipv4 = Enum.YLeaf(1, "mpls-lib-c-type-ipv4")

    mpls_lib_c_type_ipv4_p2p_tunnel = Enum.YLeaf(7, "mpls-lib-c-type-ipv4-p2p-tunnel")

    mpls_lib_c_type_ipv6_p2p_tunnel = Enum.YLeaf(8, "mpls-lib-c-type-ipv6-p2p-tunnel")

    mpls_lib_c_type_ipv4_uni = Enum.YLeaf(9, "mpls-lib-c-type-ipv4-uni")

    mpls_lib_c_type_ipv4_p2mp_tunnel = Enum.YLeaf(13, "mpls-lib-c-type-ipv4-p2mp-tunnel")

    mpls_lib_c_type_ipv6_p2mp_tunnel = Enum.YLeaf(14, "mpls-lib-c-type-ipv6-p2mp-tunnel")

    mpls_lib_c_type_ipv4_tp_tunnel = Enum.YLeaf(15, "mpls-lib-c-type-ipv4-tp-tunnel")

    mpls_lib_c_type_ipv6_tp_tunnel = Enum.YLeaf(16, "mpls-lib-c-type-ipv6-tp-tunnel")

    mpls_lib_c_type_p2p_binding_label = Enum.YLeaf(17, "mpls-lib-c-type-p2p-binding-label")


class MplsMteTunnelFailReason(Enum):
    """
    MplsMteTunnelFailReason

    Reason for tunnel being down

    .. data:: mtunnel_fail_reason_unapplicable = 0

    	None of the reasons below is valid

    .. data:: mtunnel_fail_reason_shutdown = 1

    	Tunnel interface is shutdown

    .. data:: mtunnel_fail_reason_no_destination = 2

    	No destination is configured

    .. data:: mtunnel_fail_reason_no_path_option = 3

    	No path option is configured

    .. data:: mtunnel_fail_reason_no_source = 4

    	No ip source address is configured

    .. data:: mtunnel_fail_reason_collaborator_disc = 5

    	Collaborator not connected

    .. data:: mtunnel_fail_reason_unmatched_class_type_priority = 6

    	The class type and priority do not match any of

    	the TE-classes

    .. data:: mtunnel_fail_reason_invalid_bidir_cfg = 7

    	Configured bidirectional, incomplete switching

    	capability config

    .. data:: mtunnel_fail_reason_po_switchover = 8

    	Manual path-option switchover failed due to

    	destination(s) down

    .. data:: mtunnel_fail_reason_no_tunnel_id = 9

    	No tunnel-id is configured

    .. data:: mtunnel_fail_reason_no_link = 10

    	Tunnel's egress link doesn't exist

    .. data:: mtunnel_fail_reason_link_shutdown = 11

    	Tunnel's egress link is shut down

    .. data:: mtunnel_fail_reason_link_lmp_down = 12

    	LMP is down on the tunnel's egress link

    .. data:: mtunnel_fail_reason_source_destination_same = 13

    	Tunnel source and destination addresses are the

    	same

    .. data:: mtunnel_fail_reason_otn_no_odu_level = 14

    	OTN tunnel does not have odu-level set

    .. data:: mtunnel_fail_reason_bidir_assoc_id_missing = 15

    	Bidirectional is configured without Association

    	ID

    .. data:: mtunnel_fail_reason_bfdgal_on_unidirectional = 16

    	BFD GAL mode is supported on bidirectional

    	tunnels only

    """

    mtunnel_fail_reason_unapplicable = Enum.YLeaf(0, "mtunnel-fail-reason-unapplicable")

    mtunnel_fail_reason_shutdown = Enum.YLeaf(1, "mtunnel-fail-reason-shutdown")

    mtunnel_fail_reason_no_destination = Enum.YLeaf(2, "mtunnel-fail-reason-no-destination")

    mtunnel_fail_reason_no_path_option = Enum.YLeaf(3, "mtunnel-fail-reason-no-path-option")

    mtunnel_fail_reason_no_source = Enum.YLeaf(4, "mtunnel-fail-reason-no-source")

    mtunnel_fail_reason_collaborator_disc = Enum.YLeaf(5, "mtunnel-fail-reason-collaborator-disc")

    mtunnel_fail_reason_unmatched_class_type_priority = Enum.YLeaf(6, "mtunnel-fail-reason-unmatched-class-type-priority")

    mtunnel_fail_reason_invalid_bidir_cfg = Enum.YLeaf(7, "mtunnel-fail-reason-invalid-bidir-cfg")

    mtunnel_fail_reason_po_switchover = Enum.YLeaf(8, "mtunnel-fail-reason-po-switchover")

    mtunnel_fail_reason_no_tunnel_id = Enum.YLeaf(9, "mtunnel-fail-reason-no-tunnel-id")

    mtunnel_fail_reason_no_link = Enum.YLeaf(10, "mtunnel-fail-reason-no-link")

    mtunnel_fail_reason_link_shutdown = Enum.YLeaf(11, "mtunnel-fail-reason-link-shutdown")

    mtunnel_fail_reason_link_lmp_down = Enum.YLeaf(12, "mtunnel-fail-reason-link-lmp-down")

    mtunnel_fail_reason_source_destination_same = Enum.YLeaf(13, "mtunnel-fail-reason-source-destination-same")

    mtunnel_fail_reason_otn_no_odu_level = Enum.YLeaf(14, "mtunnel-fail-reason-otn-no-odu-level")

    mtunnel_fail_reason_bidir_assoc_id_missing = Enum.YLeaf(15, "mtunnel-fail-reason-bidir-assoc-id-missing")

    mtunnel_fail_reason_bfdgal_on_unidirectional = Enum.YLeaf(16, "mtunnel-fail-reason-bfdgal-on-unidirectional")


class MplsProtection(Enum):
    """
    MplsProtection

    MPLS Protection Type

    .. data:: mpls_protection_type_unprotected = 0

    	MPLS no protection is desired

    .. data:: mpls_protection_type_link = 1

    	MPLS link protection is desired

    .. data:: mpls_protection_type_link_node = 2

    	MPLS node and link protection are both desired

    """

    mpls_protection_type_unprotected = Enum.YLeaf(0, "mpls-protection-type-unprotected")

    mpls_protection_type_link = Enum.YLeaf(1, "mpls-protection-type-link")

    mpls_protection_type_link_node = Enum.YLeaf(2, "mpls-protection-type-link-node")


class MplsTeAfi(Enum):
    """
    MplsTeAfi

    Mpls te afi

    .. data:: ipv4_unicast = 0

    	MPLS TE IPv4 unicast

    .. data:: ipv4_multicast = 1

    	MPLS TE IPv4 multicast

    .. data:: ipv6_unicast = 2

    	MPLS TE IPv6 unicast

    .. data:: ipv6_multicast = 3

    	MPLS TE IPv6 multicast

    """

    ipv4_unicast = Enum.YLeaf(0, "ipv4-unicast")

    ipv4_multicast = Enum.YLeaf(1, "ipv4-multicast")

    ipv6_unicast = Enum.YLeaf(2, "ipv6-unicast")

    ipv6_multicast = Enum.YLeaf(3, "ipv6-multicast")


class MplsTeAttrSet(Enum):
    """
    MplsTeAttrSet

    Mpls te attr set

    .. data:: not_used = 0

    	Not used

    .. data:: static = 1

    	Static

    .. data:: lsp = 2

    	LSP

    .. data:: unassigned = 3

    	Unassigned

    .. data:: auto_backup = 4

    	Auto backup

    .. data:: auto_mesh = 5

    	Auto mesh

    .. data:: xro = 6

    	XRO

    .. data:: p2mp_te = 7

    	P2MP TE

    .. data:: otn_pp = 8

    	OTN Path Protection

    .. data:: p2p_te = 9

    	P2P TE

    """

    not_used = Enum.YLeaf(0, "not-used")

    static = Enum.YLeaf(1, "static")

    lsp = Enum.YLeaf(2, "lsp")

    unassigned = Enum.YLeaf(3, "unassigned")

    auto_backup = Enum.YLeaf(4, "auto-backup")

    auto_mesh = Enum.YLeaf(5, "auto-mesh")

    xro = Enum.YLeaf(6, "xro")

    p2mp_te = Enum.YLeaf(7, "p2mp-te")

    otn_pp = Enum.YLeaf(8, "otn-pp")

    p2p_te = Enum.YLeaf(9, "p2p-te")


class MplsTeBackup(Enum):
    """
    MplsTeBackup

    FRR backup tunnel type

    .. data:: backup_static = 0

    	Backup type is static

    .. data:: backup_auto = 1

    	Backup type is auto-tunnel

    """

    backup_static = Enum.YLeaf(0, "backup-static")

    backup_auto = Enum.YLeaf(1, "backup-auto")


class MplsTeBackupStatus(Enum):
    """
    MplsTeBackupStatus

    FRR backup status

    .. data:: backup_none = 0

    	Backup not found

    .. data:: backup_unused = 1

    	Backup status undefined

    .. data:: backup_next_next_hop = 2

    	Backup is next next hop safe (node protection)

    .. data:: backup_next_hop = 3

    	Backup is next hop safe (link protection)

    .. data:: backup_next_next_hop_srlg = 4

    	Backup is next next hop and SRLG safe (node

    	protection)

    .. data:: backup_next_hop_srlg = 5

    	Backup is next hop and SRLG safe (link

    	protection)

    """

    backup_none = Enum.YLeaf(0, "backup-none")

    backup_unused = Enum.YLeaf(1, "backup-unused")

    backup_next_next_hop = Enum.YLeaf(2, "backup-next-next-hop")

    backup_next_hop = Enum.YLeaf(3, "backup-next-hop")

    backup_next_next_hop_srlg = Enum.YLeaf(4, "backup-next-next-hop-srlg")

    backup_next_hop_srlg = Enum.YLeaf(5, "backup-next-hop-srlg")


class MplsTeBackupUsage(Enum):
    """
    MplsTeBackupUsage

    FRR backup tunnel usage status

    .. data:: backup_not_protecting = 0

    	Backup is not protecting any LSP

    .. data:: backup_protecting = 1

    	Backup is protecting at least one LSP

    """

    backup_not_protecting = Enum.YLeaf(0, "backup-not-protecting")

    backup_protecting = Enum.YLeaf(1, "backup-protecting")


class MplsTeBfdSessionDownAction1(Enum):
    """
    MplsTeBfdSessionDownAction1

    BFD session down action

    .. data:: reopt = 0

    	BFD session down action reoptimization

    .. data:: re_setup = 1

    	BFD session down action tear down and resetup

    """

    reopt = Enum.YLeaf(0, "reopt")

    re_setup = Enum.YLeaf(1, "re-setup")


class MplsTeBwLimit(Enum):
    """
    MplsTeBwLimit

    Bandwidth limit type

    .. data:: bandwidth_limited = 0

    	Bandwidth is limited

    .. data:: bandwidth_unlimited = 1

    	Bandwidth is unlimited

    .. data:: bandwidth_none = 2

    	Bandwidth is None

    """

    bandwidth_limited = Enum.YLeaf(0, "bandwidth-limited")

    bandwidth_unlimited = Enum.YLeaf(1, "bandwidth-unlimited")

    bandwidth_none = Enum.YLeaf(2, "bandwidth-none")


class MplsTeBwPool(Enum):
    """
    MplsTeBwPool

    Bandwidth pool type

    .. data:: te_bandwidth_pool0 = 0

    	Bandwidth pool type is pool0

    .. data:: te_bandwidth_pool1 = 1

    	Bandwidth pool type is pool1

    .. data:: te_bandwidth_any_pool = 2

    	Bandwidth pool type is any pool

    """

    te_bandwidth_pool0 = Enum.YLeaf(0, "te-bandwidth-pool0")

    te_bandwidth_pool1 = Enum.YLeaf(1, "te-bandwidth-pool1")

    te_bandwidth_any_pool = Enum.YLeaf(2, "te-bandwidth-any-pool")


class MplsTeDsteClassStatus(Enum):
    """
    MplsTeDsteClassStatus

    DSTE class status

    .. data:: configured = 0

    	The TE class is explicitely configured

    .. data:: default = 1

    	The TE class is a default

    .. data:: unused = 2

    	The TE class is unused due to a configuration

    	conflict

    """

    configured = Enum.YLeaf(0, "configured")

    default = Enum.YLeaf(1, "default")

    unused = Enum.YLeaf(2, "unused")


class MplsTeFrrSharing(Enum):
    """
    MplsTeFrrSharing

    FRR sharing type

    .. data:: sharing_none = 0

    	No Fate Sharing

    .. data:: sharing_pri_oi_backup_oi_parent = 1

    	Primary Sharing outgoing interface with the

    	Parent of the backup outgoing interface

    .. data:: sharing_pri_oi_parent_backup_oi = 2

    	Primary Sharing Parent of the outgoing

    	interface with the backup outgoing interface

    .. data:: sharing_pri_oi_parent_backup_oi_parent = 3

    	Primary Sharing Parent of the outgoing

    	interface with the Parent of the backup

    	outgoing interface

    """

    sharing_none = Enum.YLeaf(0, "sharing-none")

    sharing_pri_oi_backup_oi_parent = Enum.YLeaf(1, "sharing-pri-oi-backup-oi-parent")

    sharing_pri_oi_parent_backup_oi = Enum.YLeaf(2, "sharing-pri-oi-parent-backup-oi")

    sharing_pri_oi_parent_backup_oi_parent = Enum.YLeaf(3, "sharing-pri-oi-parent-backup-oi-parent")


class MplsTeFrrState(Enum):
    """
    MplsTeFrrState

    FRR state

    .. data:: frr_inactive = 0

    	FRR state is inactive

    .. data:: frr_active = 1

    	FRR state is active

    .. data:: frr_ready = 2

    	FRR state is ready

    """

    frr_inactive = Enum.YLeaf(0, "frr-inactive")

    frr_active = Enum.YLeaf(1, "frr-active")

    frr_ready = Enum.YLeaf(2, "frr-ready")


class MplsTeIepHop(Enum):
    """
    MplsTeIepHop

    Explicit path hop type

    .. data:: iep_hop_type_unknown = 0

    	Unknown IEP hop type

    .. data:: iep_hop_type_strict_next = 1

    	Strict next IEP hop type

    .. data:: iep_hop_type_exclude = 2

    	Exclude IEP hop type

    .. data:: iep_hop_type_exclude_node = 3

    	Exclude Node IEP hop type

    .. data:: iep_hop_type_exclude_srlg = 4

    	Exclude SRLG IEP hop type

    .. data:: iep_hop_type_loose_next = 5

    	Loose next IEP hop type

    .. data:: iep_hop_type_next = 6

    	Next IEP hop type

    .. data:: iep_hop_type_share_srlg = 7

    	Weighted SRLG IEP hop type

    """

    iep_hop_type_unknown = Enum.YLeaf(0, "iep-hop-type-unknown")

    iep_hop_type_strict_next = Enum.YLeaf(1, "iep-hop-type-strict-next")

    iep_hop_type_exclude = Enum.YLeaf(2, "iep-hop-type-exclude")

    iep_hop_type_exclude_node = Enum.YLeaf(3, "iep-hop-type-exclude-node")

    iep_hop_type_exclude_srlg = Enum.YLeaf(4, "iep-hop-type-exclude-srlg")

    iep_hop_type_loose_next = Enum.YLeaf(5, "iep-hop-type-loose-next")

    iep_hop_type_next = Enum.YLeaf(6, "iep-hop-type-next")

    iep_hop_type_share_srlg = Enum.YLeaf(7, "iep-hop-type-share-srlg")


class MplsTeIgpProtocol(Enum):
    """
    MplsTeIgpProtocol

    Mpls te igp protocol

    .. data:: none = 0

    	Not set

    .. data:: isis = 1

    	IS IS

    .. data:: ospf = 2

    	OSPF

    """

    none = Enum.YLeaf(0, "none")

    isis = Enum.YLeaf(1, "isis")

    ospf = Enum.YLeaf(2, "ospf")


class MplsTeLoadshare(Enum):
    """
    MplsTeLoadshare

    load\-share type

    .. data:: loadshare_equal = 0

    	Equal load-sharing on this tunnel

    .. data:: loadshare_bandwidth_based = 1

    	Loadshare inferred from bandwidth configuration

    .. data:: loadshare_configured = 2

    	Loadshare determined from explicit

    	configuration

    """

    loadshare_equal = Enum.YLeaf(0, "loadshare-equal")

    loadshare_bandwidth_based = Enum.YLeaf(1, "loadshare-bandwidth-based")

    loadshare_configured = Enum.YLeaf(2, "loadshare-configured")


class MplsTeLsp(Enum):
    """
    MplsTeLsp

    LSP Types

    .. data:: mpls_te_lsp_type_not_set = 0

    	Tunnel type not set

    .. data:: mpls_te_lsp_type_p2p = 1

    	Point-to-point packet TE tunnel

    .. data:: mpls_te_lsp_type_p2mp = 2

    	Point-to-multipoint tunnel

    .. data:: mpls_te_lsp_type_gmpls_ouni = 3

    	Bidirectional GMPLS UNI tunnel

    .. data:: mpls_te_lsp_type_gmpls_nni = 4

    	Bidirectional GMPLS NNI tunnel

    .. data:: mpls_te_lsp_type_p2p_bidir = 5

    	Bidirectional packet point-to-point tunnel

    .. data:: mpls_te_lsp_type_gmpls_tp = 6

    	Bidirectional GMPLS TP tunnel

    .. data:: mpls_te_lsp_type_gmpls_nni_otn = 7

    	Bidirectional GMPLS OTN NNI tunnel

    .. data:: mpls_te_lsp_type_segment_routing_p2p = 8

    	Point-to-point segment-routing packet TE tunnel

    """

    mpls_te_lsp_type_not_set = Enum.YLeaf(0, "mpls-te-lsp-type-not-set")

    mpls_te_lsp_type_p2p = Enum.YLeaf(1, "mpls-te-lsp-type-p2p")

    mpls_te_lsp_type_p2mp = Enum.YLeaf(2, "mpls-te-lsp-type-p2mp")

    mpls_te_lsp_type_gmpls_ouni = Enum.YLeaf(3, "mpls-te-lsp-type-gmpls-ouni")

    mpls_te_lsp_type_gmpls_nni = Enum.YLeaf(4, "mpls-te-lsp-type-gmpls-nni")

    mpls_te_lsp_type_p2p_bidir = Enum.YLeaf(5, "mpls-te-lsp-type-p2p-bidir")

    mpls_te_lsp_type_gmpls_tp = Enum.YLeaf(6, "mpls-te-lsp-type-gmpls-tp")

    mpls_te_lsp_type_gmpls_nni_otn = Enum.YLeaf(7, "mpls-te-lsp-type-gmpls-nni-otn")

    mpls_te_lsp_type_segment_routing_p2p = Enum.YLeaf(8, "mpls-te-lsp-type-segment-routing-p2p")


class MplsTeLspMode(Enum):
    """
    MplsTeLspMode

    Mpls te lsp mode

    .. data:: mpls_te_lsp_mode_not_set = 0

    	LSP mode not set

    .. data:: mpls_te_lsp_mode_current = 1

    	Current LSP

    .. data:: mpls_te_lsp_mode_reopt = 2

    	Reoptimized LSP

    .. data:: mpls_te_lsp_mode_clean = 3

    	Cleaned LSP

    .. data:: mpls_te_lsp_mode_standby = 4

    	Standby LSP

    .. data:: mpls_te_lsp_mode_pp_clean = 5

    	Delay PP Clean LSP

    .. data:: mpls_te_lsp_mode_restore = 6

    	Restore LSP

    .. data:: mpls_te_lsp_mode_reopt_standby = 7

    	Reopt Standby LSP

    """

    mpls_te_lsp_mode_not_set = Enum.YLeaf(0, "mpls-te-lsp-mode-not-set")

    mpls_te_lsp_mode_current = Enum.YLeaf(1, "mpls-te-lsp-mode-current")

    mpls_te_lsp_mode_reopt = Enum.YLeaf(2, "mpls-te-lsp-mode-reopt")

    mpls_te_lsp_mode_clean = Enum.YLeaf(3, "mpls-te-lsp-mode-clean")

    mpls_te_lsp_mode_standby = Enum.YLeaf(4, "mpls-te-lsp-mode-standby")

    mpls_te_lsp_mode_pp_clean = Enum.YLeaf(5, "mpls-te-lsp-mode-pp-clean")

    mpls_te_lsp_mode_restore = Enum.YLeaf(6, "mpls-te-lsp-mode-restore")

    mpls_te_lsp_mode_reopt_standby = Enum.YLeaf(7, "mpls-te-lsp-mode-reopt-standby")


class MplsTeLspRole(Enum):
    """
    MplsTeLspRole

    MPLS TE LSP Role

    .. data:: mpls_te_lsp_role_unknown = 0

    	MPLS TE lsp role unknown

    .. data:: mpls_te_lsp_role_head = 1

    	MPLS TE lsp role head

    .. data:: mpls_te_lsp_role_transit = 2

    	MPLS TE lsp role transit

    .. data:: mpls_te_lsp_role_tail = 3

    	MPLS TE lsp role tail

    """

    mpls_te_lsp_role_unknown = Enum.YLeaf(0, "mpls-te-lsp-role-unknown")

    mpls_te_lsp_role_head = Enum.YLeaf(1, "mpls-te-lsp-role-head")

    mpls_te_lsp_role_transit = Enum.YLeaf(2, "mpls-te-lsp-role-transit")

    mpls_te_lsp_role_tail = Enum.YLeaf(3, "mpls-te-lsp-role-tail")


class MplsTeLspWrapState(Enum):
    """
    MplsTeLspWrapState

    LSP Wrap state

    .. data:: lsp_wrap_not_ready = 0

    	LSP Wrap state is not ready

    .. data:: lsp_wrap_active = 1

    	LSP Wrap state is active

    .. data:: lsp_wrap_ready = 2

    	LSP Wrap state is ready

    """

    lsp_wrap_not_ready = Enum.YLeaf(0, "lsp-wrap-not-ready")

    lsp_wrap_active = Enum.YLeaf(1, "lsp-wrap-active")

    lsp_wrap_ready = Enum.YLeaf(2, "lsp-wrap-ready")


class MplsTeMetric(Enum):
    """
    MplsTeMetric

    Metric type

    .. data:: metric_not_set = 0

    	Metric type not set

    .. data:: metric_igp = 1

    	Metric for IGP routes

    .. data:: metric_te = 2

    	Metric for MPLS traffic engineering tunnels

    .. data:: metric_delay = 3

    	Delay Metric

    """

    metric_not_set = Enum.YLeaf(0, "metric-not-set")

    metric_igp = Enum.YLeaf(1, "metric-igp")

    metric_te = Enum.YLeaf(2, "metric-te")

    metric_delay = Enum.YLeaf(3, "metric-delay")


class MplsTeMetricQualifier(Enum):
    """
    MplsTeMetricQualifier

    Metric qualifier

    .. data:: metric_default = 0

    	Default metric

    .. data:: metric_global = 1

    	This metric was specified globally

    .. data:: metric_interface = 2

    	This metric was specified on this particular

    	tunnel

    """

    metric_default = Enum.YLeaf(0, "metric-default")

    metric_global = Enum.YLeaf(1, "metric-global")

    metric_interface = Enum.YLeaf(2, "metric-interface")


class MplsTeMgmtGmplsLabel(Enum):
    """
    MplsTeMgmtGmplsLabel

    GMPLS label type

    .. data:: not_set = 0

    	Not Set

    .. data:: fixed_wdm = 1

    	Fixed-grid WDM

    .. data:: fixed_g709otn = 2

    	Fixed-size G709 OTN

    """

    not_set = Enum.YLeaf(0, "not-set")

    fixed_wdm = Enum.YLeaf(1, "fixed-wdm")

    fixed_g709otn = Enum.YLeaf(2, "fixed-g709otn")


class MplsTeMgmtGmplsLabelOrigin(Enum):
    """
    MplsTeMgmtGmplsLabelOrigin

    GMPLS label source

    .. data:: not_set = 0

    	Not set

    .. data:: uni_c = 1

    	UNI C

    .. data:: uni_n = 2

    	UNI N

    """

    not_set = Enum.YLeaf(0, "not-set")

    uni_c = Enum.YLeaf(1, "uni-c")

    uni_n = Enum.YLeaf(2, "uni-n")


class MplsTeNextHop(Enum):
    """
    MplsTeNextHop

    Mpls te next hop

    .. data:: egress_resolve = 0

    	Egress Resolve

    .. data:: autoroute_dest = 1

    	Autoroute Dest

    """

    egress_resolve = Enum.YLeaf(0, "egress-resolve")

    autoroute_dest = Enum.YLeaf(1, "autoroute-dest")


class MplsTeNode(Enum):
    """
    MplsTeNode

    Mpls te node

    .. data:: router = 1

    	Router

    .. data:: network = 2

    	Network

    """

    router = Enum.YLeaf(1, "router")

    network = Enum.YLeaf(2, "network")


class MplsTeP2MpTimer(Enum):
    """
    MplsTeP2MpTimer

    P2MP timer types

    .. data:: lmrib_restart = 0

    	P2MP Local Multicast RIB restart

    .. data:: lmrib_recovery = 1

    	P2MP LMRIB recovery

    .. data:: rsvp_restart = 2

    	P2MP RSVP restart

    .. data:: lsd_restart = 3

    	LSD restart

    .. data:: lsd_recovery = 4

    	LSD recovery

    .. data:: clear_in_progress_bandwidth = 5

    	Timer to clear the inprogress bandwidth for all

    	the nodes in the topology

    .. data:: rsi_restart = 6

    	RSI restart

    .. data:: rsi_recovery = 7

    	RSI recovery

    .. data:: ipv4_caps_replay = 8

    	Timer to timeout the replay of IPv4 Caps after

    	a TE or IM restart

    .. data:: retry_acl_registration_timer = 9

    	Timer to retry ACL registration

    .. data:: mpls_te_exit = 10

    	MPLS TE Exit

    .. data:: mpls_te_nsr_peer_restart = 11

    	MPLS TE NSR Peer Restart

    .. data:: mpls_te_issu_peer_restart = 12

    	MPLS TE ISSU Peer Restart

    .. data:: bfd_restart = 13

    	BFD restart

    .. data:: bfd_recovery = 14

    	BFD recovery

    .. data:: im_oc_restart = 15

    	IM Optical Connection restart

    .. data:: im_oc_recovery = 16

    	IM Optical Connection recovery

    .. data:: rib_restart = 17

    	RIB restart

    .. data:: rib_recovery = 18

    	RIB recovery

    .. data:: rib_next_hop_route_cleanup = 19

    	RIB next-hop route cleanup

    .. data:: rsi_srlg_producer_retry = 20

    	RSI SRLG-producer connection retry

    .. data:: eoc_reg_retry = 21

    	End-of-Config registration retry

    .. data:: fib_restart = 22

    	FIB restart

    .. data:: fib_recovery = 23

    	FIB recovery

    .. data:: fib_next_hop_route_cleanup = 24

    	FIB next-hop route cleanup

    .. data:: fib_next_hop_register_retry = 25

    	FIB next-hop register retry

    .. data:: tun_backend_scan_retry = 26

    	Tunnel Backend Scan Retry

    .. data:: tunnel_checkpoint_list_service = 27

    	Tunnel Checkpoint list service

    .. data:: tunnel_service_binding_sid_allocation_retry = 28

    	Tunnel Service Binding SID Allocation Retry

    .. data:: timer_not_used = 29

    	Do not use

    """

    lmrib_restart = Enum.YLeaf(0, "lmrib-restart")

    lmrib_recovery = Enum.YLeaf(1, "lmrib-recovery")

    rsvp_restart = Enum.YLeaf(2, "rsvp-restart")

    lsd_restart = Enum.YLeaf(3, "lsd-restart")

    lsd_recovery = Enum.YLeaf(4, "lsd-recovery")

    clear_in_progress_bandwidth = Enum.YLeaf(5, "clear-in-progress-bandwidth")

    rsi_restart = Enum.YLeaf(6, "rsi-restart")

    rsi_recovery = Enum.YLeaf(7, "rsi-recovery")

    ipv4_caps_replay = Enum.YLeaf(8, "ipv4-caps-replay")

    retry_acl_registration_timer = Enum.YLeaf(9, "retry-acl-registration-timer")

    mpls_te_exit = Enum.YLeaf(10, "mpls-te-exit")

    mpls_te_nsr_peer_restart = Enum.YLeaf(11, "mpls-te-nsr-peer-restart")

    mpls_te_issu_peer_restart = Enum.YLeaf(12, "mpls-te-issu-peer-restart")

    bfd_restart = Enum.YLeaf(13, "bfd-restart")

    bfd_recovery = Enum.YLeaf(14, "bfd-recovery")

    im_oc_restart = Enum.YLeaf(15, "im-oc-restart")

    im_oc_recovery = Enum.YLeaf(16, "im-oc-recovery")

    rib_restart = Enum.YLeaf(17, "rib-restart")

    rib_recovery = Enum.YLeaf(18, "rib-recovery")

    rib_next_hop_route_cleanup = Enum.YLeaf(19, "rib-next-hop-route-cleanup")

    rsi_srlg_producer_retry = Enum.YLeaf(20, "rsi-srlg-producer-retry")

    eoc_reg_retry = Enum.YLeaf(21, "eoc-reg-retry")

    fib_restart = Enum.YLeaf(22, "fib-restart")

    fib_recovery = Enum.YLeaf(23, "fib-recovery")

    fib_next_hop_route_cleanup = Enum.YLeaf(24, "fib-next-hop-route-cleanup")

    fib_next_hop_register_retry = Enum.YLeaf(25, "fib-next-hop-register-retry")

    tun_backend_scan_retry = Enum.YLeaf(26, "tun-backend-scan-retry")

    tunnel_checkpoint_list_service = Enum.YLeaf(27, "tunnel-checkpoint-list-service")

    tunnel_service_binding_sid_allocation_retry = Enum.YLeaf(28, "tunnel-service-binding-sid-allocation-retry")

    timer_not_used = Enum.YLeaf(29, "timer-not-used")


class MplsTePath(Enum):
    """
    MplsTePath

    Mpls te path

    .. data:: not_set = 0

    	Not set

    .. data:: dynamic = 1

    	Dynamic

    .. data:: explicit_name = 3

    	Explicit name

    .. data:: explicit_id = 4

    	Explicit ID

    .. data:: no_ero = 5

    	No ERO

    .. data:: segment_routing = 6

    	Segment Routing

    """

    not_set = Enum.YLeaf(0, "not-set")

    dynamic = Enum.YLeaf(1, "dynamic")

    explicit_name = Enum.YLeaf(3, "explicit-name")

    explicit_id = Enum.YLeaf(4, "explicit-id")

    no_ero = Enum.YLeaf(5, "no-ero")

    segment_routing = Enum.YLeaf(6, "segment-routing")


class MplsTePathoption(Enum):
    """
    MplsTePathoption

    Path\-option type

    .. data:: path_option_unknown = 0

    	Unknown Path Option

    .. data:: path_option_dynamic = 1

    	Dynamic Path Option

    .. data:: path_option_explicit_name = 2

    	Explicit name Path Option

    .. data:: path_option_explicit_id = 3

    	Explicit Identifier Path Option

    .. data:: path_option_pce = 4

    	PCE Path Option

    .. data:: path_option_no_ero = 5

    	No-ERO Path Option

    .. data:: path_option_segment_routing = 6

    	Segment-Routing Path Option

    """

    path_option_unknown = Enum.YLeaf(0, "path-option-unknown")

    path_option_dynamic = Enum.YLeaf(1, "path-option-dynamic")

    path_option_explicit_name = Enum.YLeaf(2, "path-option-explicit-name")

    path_option_explicit_id = Enum.YLeaf(3, "path-option-explicit-id")

    path_option_pce = Enum.YLeaf(4, "path-option-pce")

    path_option_no_ero = Enum.YLeaf(5, "path-option-no-ero")

    path_option_segment_routing = Enum.YLeaf(6, "path-option-segment-routing")


class MplsTePceFailReasons(Enum):
    """
    MplsTePceFailReasons

    PCE failure reasons

    .. data:: te_pce_fail_no_reason = 0

    	No reason

    .. data:: te_pce_fail_no_pce = 1

    	No PCE to send request

    .. data:: te_pce_fail_sub_pool = 2

    	Sub pool bandwidth tunnel

    .. data:: te_pce_fail_intra_area = 3

    	Intra Area Tunnel

    .. data:: te_pce_fail_gmpls = 4

    	GMPLS Tunnel

    .. data:: te_pce_fail_pending = 5

    	Pending request

    .. data:: te_pce_fail_oor = 6

    	OOR condition

    .. data:: te_pce_fail_bidirectional = 7

    	Bi directional

    .. data:: te_pce_fail_no_path = 8

    	No Path received from PCE

    .. data:: te_pce_fail_request_timeout = 9

    	Request Timeout

    """

    te_pce_fail_no_reason = Enum.YLeaf(0, "te-pce-fail-no-reason")

    te_pce_fail_no_pce = Enum.YLeaf(1, "te-pce-fail-no-pce")

    te_pce_fail_sub_pool = Enum.YLeaf(2, "te-pce-fail-sub-pool")

    te_pce_fail_intra_area = Enum.YLeaf(3, "te-pce-fail-intra-area")

    te_pce_fail_gmpls = Enum.YLeaf(4, "te-pce-fail-gmpls")

    te_pce_fail_pending = Enum.YLeaf(5, "te-pce-fail-pending")

    te_pce_fail_oor = Enum.YLeaf(6, "te-pce-fail-oor")

    te_pce_fail_bidirectional = Enum.YLeaf(7, "te-pce-fail-bidirectional")

    te_pce_fail_no_path = Enum.YLeaf(8, "te-pce-fail-no-path")

    te_pce_fail_request_timeout = Enum.YLeaf(9, "te-pce-fail-request-timeout")


class MplsTeProtocol(Enum):
    """
    MplsTeProtocol

    MPLS TE Protocol Type

    .. data:: mpls_te_signaling_type_unknown = 0

    	MPLS TE signaling type unknown

    .. data:: mpls_te_signaling_type_rsvp = 1

    	MPLS TE signaling type RSVP

    """

    mpls_te_signaling_type_unknown = Enum.YLeaf(0, "mpls-te-signaling-type-unknown")

    mpls_te_signaling_type_rsvp = Enum.YLeaf(1, "mpls-te-signaling-type-rsvp")


class MplsTeReoptDecisionReason(Enum):
    """
    MplsTeReoptDecisionReason

    Reoptimization decision

    .. data:: decision_reason_none = 0

    	No reason

    .. data:: not_superset = 1

    	Reopt LSP not signalled because it is not a

    	superset of the current LSP

    .. data:: superset = 2

    	Reopt LSP is signalled because it is a superset

    	of the current LSP

    .. data:: lsp_frr_active = 3

    	Reopt LSP is signalled because the current LSP

    	is in FRR

    .. data:: bandwidth_change = 4

    	Reopt LSP is signalled  because there is a

    	bandwidth change

    .. data:: metric_type_change = 5

    	Reopt LSP is signalled because there is a

    	metric type change

    .. data:: better_path_option_indexes = 6

    	Reopt LSP is signalled because it has better

    	path option indexes than the current LSP

    .. data:: inter_area_preferred_path_exists = 7

    	Reopt LSP is signalled because an inter-area

    	preferred path exists

    .. data:: inter_area_preferred_tree_exists = 8

    	Reopt LSP is signalled because an inter-area

    	preferred tree exists

    .. data:: worse_path_option_indexes = 9

    	Reopt LSP is not signalled because it has worse

    	path option indexes than the current LSP

    .. data:: better_cumulative_metric = 10

    	Reopt LSP is signalled because it has better

    	path option indexes than the current LSP

    .. data:: worse_cumulative_metric = 11

    	Reopt LSP is not signalled because it has worse

    	cumulative metric than the current LSP

    .. data:: identical = 12

    	Reopt LSP is not signalled because it is

    	identical to the current LSP

    .. data:: no_s2_ls = 13

    	Reopt LSP is not signalled because it has no

    	S2Ls

    .. data:: no_current_lsp = 14

    	Reopt LSP not signalled, no current LSP

    .. data:: user_path_option_switchover = 15

    	Reopt LSP signalled due to user requested

    	path-option switchover

    .. data:: better_hops = 16

    	Reopt LSP is signalled because it has more S2Ls

    	with less hops than the current LSP

    .. data:: worse_hops = 17

    	Reopt LSP is not signalled because it has less

    	S2Ls with less hops than the current LSP

    .. data:: pce_force = 18

    	PCE based reoptimization triggered by CLI with

    	force option than the current LSP

    .. data:: affinity_changed = 19

    	Reopt LSP is signalled  because there is an

    	affinity change

    .. data:: cost_limit = 20

    	Reopt LSP is signalled  because the path cost

    	limit is crossed

    .. data:: sig_timeout = 21

    	Re-opt LSP could not be signalled within

    	signalling timeout

    .. data:: not_superset_inst_timer_expired = 22

    	Re-opt LSP is not a superset when the install

    	timer expired

    .. data:: path_verifiction_failed = 23

    	Re-opt LSP path verification failed

    .. data:: soft_preemption_recovery = 24

    	Re-opt LSP is signalled because of soft

    	preemption recovery

    .. data:: iep_changed = 25

    	Re-opt LSP is signalled because the inuse

    	explicit-path has changed

    .. data:: po_changed = 26

    	Re-opt LSP is signalled because the inuse

    	path-option has changed

    .. data:: dest_changed = 27

    	Re-opt LSP is signalled because the destination

    	has changed

    .. data:: better_igp_area = 28

    	Reopt LSP is signalled because its path was

    	calculated in a preferred IGP-area to the

    	current LSP

    .. data:: worse_igp_area = 29

    	Reopt LSP is not signalled because its path was

    	calculated in a worse IGP-area than the current

    	LSP

    .. data:: better_bandwidth_load_balancing = 30

    	Reopt LSP is signalled because it gives better

    	bandwidth load balancing than the current LSP

    .. data:: worse_bandwidth_load_balancing = 31

    	Reopt LSP is not signalled because it gives

    	worse bandwidth load balancing than the current

    	LSP

    .. data:: bfd_session_down = 32

    	Reopt LSP is signaled because BFD sesssion went

    	down

    .. data:: auto_pcc_reopt = 33

    	Re-opt LSP is signalled because it was

    	triggered by a PCE

    .. data:: sr_egress_path_changed = 34

    	Reopt LSP is signaled because the egress

    	path(s) changed

    .. data:: overload_bit_set = 35

    	Reopt LSP is signalled because the current LSP

    	uses an OL node

    .. data:: better_diversity = 36

    	Reopt LSP is signalled because it has better

    	diversity than the current LSP

    .. data:: worse_diversity = 37

    	Reopt LSP is not signalled because it has worse

    	diversity than the current lsp

    .. data:: bfd_session_type_changed = 38

    	Reopt LSP is signalled because BFD sesssion

    	tyep is changed

    .. data:: lsp_drop_mode = 39

    	Reopt LSP is signalled because current LSP is

    	in drop mode

    .. data:: strict_spf = 40

    	Reopt LSP is signalled because it uses strict

    	SPF while current doesn't

    .. data:: not_used = 41

    	Not used, must be last entry

    """

    decision_reason_none = Enum.YLeaf(0, "decision-reason-none")

    not_superset = Enum.YLeaf(1, "not-superset")

    superset = Enum.YLeaf(2, "superset")

    lsp_frr_active = Enum.YLeaf(3, "lsp-frr-active")

    bandwidth_change = Enum.YLeaf(4, "bandwidth-change")

    metric_type_change = Enum.YLeaf(5, "metric-type-change")

    better_path_option_indexes = Enum.YLeaf(6, "better-path-option-indexes")

    inter_area_preferred_path_exists = Enum.YLeaf(7, "inter-area-preferred-path-exists")

    inter_area_preferred_tree_exists = Enum.YLeaf(8, "inter-area-preferred-tree-exists")

    worse_path_option_indexes = Enum.YLeaf(9, "worse-path-option-indexes")

    better_cumulative_metric = Enum.YLeaf(10, "better-cumulative-metric")

    worse_cumulative_metric = Enum.YLeaf(11, "worse-cumulative-metric")

    identical = Enum.YLeaf(12, "identical")

    no_s2_ls = Enum.YLeaf(13, "no-s2-ls")

    no_current_lsp = Enum.YLeaf(14, "no-current-lsp")

    user_path_option_switchover = Enum.YLeaf(15, "user-path-option-switchover")

    better_hops = Enum.YLeaf(16, "better-hops")

    worse_hops = Enum.YLeaf(17, "worse-hops")

    pce_force = Enum.YLeaf(18, "pce-force")

    affinity_changed = Enum.YLeaf(19, "affinity-changed")

    cost_limit = Enum.YLeaf(20, "cost-limit")

    sig_timeout = Enum.YLeaf(21, "sig-timeout")

    not_superset_inst_timer_expired = Enum.YLeaf(22, "not-superset-inst-timer-expired")

    path_verifiction_failed = Enum.YLeaf(23, "path-verifiction-failed")

    soft_preemption_recovery = Enum.YLeaf(24, "soft-preemption-recovery")

    iep_changed = Enum.YLeaf(25, "iep-changed")

    po_changed = Enum.YLeaf(26, "po-changed")

    dest_changed = Enum.YLeaf(27, "dest-changed")

    better_igp_area = Enum.YLeaf(28, "better-igp-area")

    worse_igp_area = Enum.YLeaf(29, "worse-igp-area")

    better_bandwidth_load_balancing = Enum.YLeaf(30, "better-bandwidth-load-balancing")

    worse_bandwidth_load_balancing = Enum.YLeaf(31, "worse-bandwidth-load-balancing")

    bfd_session_down = Enum.YLeaf(32, "bfd-session-down")

    auto_pcc_reopt = Enum.YLeaf(33, "auto-pcc-reopt")

    sr_egress_path_changed = Enum.YLeaf(34, "sr-egress-path-changed")

    overload_bit_set = Enum.YLeaf(35, "overload-bit-set")

    better_diversity = Enum.YLeaf(36, "better-diversity")

    worse_diversity = Enum.YLeaf(37, "worse-diversity")

    bfd_session_type_changed = Enum.YLeaf(38, "bfd-session-type-changed")

    lsp_drop_mode = Enum.YLeaf(39, "lsp-drop-mode")

    strict_spf = Enum.YLeaf(40, "strict-spf")

    not_used = Enum.YLeaf(41, "not-used")


class MplsTeSoftPreemptionResolution(Enum):
    """
    MplsTeSoftPreemptionResolution

    The possible ways for soft preemption to end

    .. data:: soft_preemption_resolution_none = 0

    	No Soft Preemption Resolution

    .. data:: soft_preemption_resolution_pending = 1

    	Soft Preemption has no resolution since it is

    	still pending

    .. data:: soft_preemption_resolution_reopt_completed = 2

    	The soft preempted LSP has been reoptimized

    .. data:: soft_preemption_resolution_teardown = 3

    	The soft preempted LSP has been torn

    .. data:: soft_preemption_resolution_frr_triggered = 4

    	The soft preempted LSP has been fast rerouted

    .. data:: soft_preemption_resolution_path_protetion_switchover = 5

    	The soft preempted LSP was switched with the

    	protection LSP

    """

    soft_preemption_resolution_none = Enum.YLeaf(0, "soft-preemption-resolution-none")

    soft_preemption_resolution_pending = Enum.YLeaf(1, "soft-preemption-resolution-pending")

    soft_preemption_resolution_reopt_completed = Enum.YLeaf(2, "soft-preemption-resolution-reopt-completed")

    soft_preemption_resolution_teardown = Enum.YLeaf(3, "soft-preemption-resolution-teardown")

    soft_preemption_resolution_frr_triggered = Enum.YLeaf(4, "soft-preemption-resolution-frr-triggered")

    soft_preemption_resolution_path_protetion_switchover = Enum.YLeaf(5, "soft-preemption-resolution-path-protetion-switchover")


class MplsTeSoftPreemptionState(Enum):
    """
    MplsTeSoftPreemptionState

    The possible states for soft preemption

    .. data:: soft_preemption_not_pending = 0

    	Soft Preemption has not been triggered and is

    	not pending

    .. data:: soft_preemption_pending = 1

    	Soft Preemption has been triggered and is

    	pending

    """

    soft_preemption_not_pending = Enum.YLeaf(0, "soft-preemption-not-pending")

    soft_preemption_pending = Enum.YLeaf(1, "soft-preemption-pending")


class MplsTeTermination(Enum):
    """
    MplsTeTermination

    Termination type

    .. data:: none = 0

    	Local termination none

    .. data:: ether = 1

    	Local termination type Ether

    """

    none = Enum.YLeaf(0, "none")

    ether = Enum.YLeaf(1, "ether")


class MplsTeTunnelAnnounce(Enum):
    """
    MplsTeTunnelAnnounce

    Type of TE tunnel announcement to IGP

    .. data:: announce_type_not_set = 0

    	Tunnel announcement type not set

    .. data:: autoroute = 1

    	Autoroute-announced tunnel

    .. data:: forward_adjacency = 2

    	Forwarding-adjacency tunnel

    """

    announce_type_not_set = Enum.YLeaf(0, "announce-type-not-set")

    autoroute = Enum.YLeaf(1, "autoroute")

    forward_adjacency = Enum.YLeaf(2, "forward-adjacency")


class MplsTeTunnelRole(Enum):
    """
    MplsTeTunnelRole

    Mpls te tunnel role

    .. data:: tunnel_unknown = 0

    	Undefined tunnel role

    .. data:: tunnel_head = 1

    	Tunnel role is head

    .. data:: tunnel_mid = 2

    	Tunnel role is midpoint

    .. data:: tunnel_tail = 3

    	Tunnel role is tail

    """

    tunnel_unknown = Enum.YLeaf(0, "tunnel-unknown")

    tunnel_head = Enum.YLeaf(1, "tunnel-head")

    tunnel_mid = Enum.YLeaf(2, "tunnel-mid")

    tunnel_tail = Enum.YLeaf(3, "tunnel-tail")


class MplsTeTunnelState(Enum):
    """
    MplsTeTunnelState

    Tunnel state

    .. data:: state_down = 0

    	Tunnel state is down

    .. data:: state_up = 1

    	Tunnel state is up

    .. data:: state_down_policy = 2

    	Tunnel state is down as it has been deactivated

    	administratively

    .. data:: state_lockout = 3

    	Tunnel state is lockout

    """

    state_down = Enum.YLeaf(0, "state-down")

    state_up = Enum.YLeaf(1, "state-up")

    state_down_policy = Enum.YLeaf(2, "state-down-policy")

    state_lockout = Enum.YLeaf(3, "state-lockout")


class MplsTeTunnelsProcessStatus(Enum):
    """
    MplsTeTunnelsProcessStatus

    Mpls te tunnels process status

    .. data:: not_running = 0

    	MPLS TE process is not running

    .. data:: running = 1

    	MPLS TE process is running

    .. data:: not_registered_with_rsvp = 2

    	MPLS TE process has not registered with RSVP

    """

    not_running = Enum.YLeaf(0, "not-running")

    running = Enum.YLeaf(1, "running")

    not_registered_with_rsvp = Enum.YLeaf(2, "not-registered-with-rsvp")


class MplsTeTunnelsSignalingStatus(Enum):
    """
    MplsTeTunnelsSignalingStatus

    Tunnel signalling status

    .. data:: down = 0

    	The tunnel is down

    .. data:: recovering = 1

    	The tunnel is recovering

    .. data:: recovered = 2

    	The tunnel is recovered

    .. data:: connected = 3

    	The tunnel is connected

    .. data:: disabled = 4

    	The tunnel signalling is disabled

    .. data:: proceeding = 5

    	The tunnel signalling is proceeding

    .. data:: wait_bfd_session_up = 6

    	The tunnel is waiting for BFD session up

    .. data:: wait_sr_segment_path_up = 7

    	The tunnel is waiting for SR segment path

    .. data:: wait_local_label = 8

    	The tunnel is waiting for a local label

    .. data:: wait_local_label_rewrite = 9

    	The tunnel is waiting for a local label rewrite

    """

    down = Enum.YLeaf(0, "down")

    recovering = Enum.YLeaf(1, "recovering")

    recovered = Enum.YLeaf(2, "recovered")

    connected = Enum.YLeaf(3, "connected")

    disabled = Enum.YLeaf(4, "disabled")

    proceeding = Enum.YLeaf(5, "proceeding")

    wait_bfd_session_up = Enum.YLeaf(6, "wait-bfd-session-up")

    wait_sr_segment_path_up = Enum.YLeaf(7, "wait-sr-segment-path-up")

    wait_local_label = Enum.YLeaf(8, "wait-local-label")

    wait_local_label_rewrite = Enum.YLeaf(9, "wait-local-label-rewrite")


class MplsTeUni(Enum):
    """
    MplsTeUni

    Uni\-Type type

    .. data:: none = 0

    	Uni-Type none

    .. data:: xc = 1

    	Uni-Type type XC

    .. data:: term = 2

    	Uni-Type Termination

    """

    none = Enum.YLeaf(0, "none")

    xc = Enum.YLeaf(1, "xc")

    term = Enum.YLeaf(2, "term")


class MplsTpLspBfdState(Enum):
    """
    MplsTpLspBfdState

    Transport profile LSP BFD states

    .. data:: down = 0

    	BFD down

    .. data:: up = 1

    	BFD up

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")


class MplsTpLspOamState(Enum):
    """
    MplsTpLspOamState

    Transport profile LSP OAM states

    .. data:: none = 0

    	No fault

    .. data:: ldi = 1

    	LDI

    .. data:: lkr = 2

    	LKR

    .. data:: ais = 3

    	AIS

    """

    none = Enum.YLeaf(0, "none")

    ldi = Enum.YLeaf(1, "ldi")

    lkr = Enum.YLeaf(2, "lkr")

    ais = Enum.YLeaf(3, "ais")


class MplsTpLspState(Enum):
    """
    MplsTpLspState

    Transport profile LSP states

    .. data:: down = 0

    	Down

    .. data:: up = 1

    	Up

    .. data:: active = 2

    	Up (active)

    .. data:: unknown = 3

    	Unknown

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")

    active = Enum.YLeaf(2, "active")

    unknown = Enum.YLeaf(3, "unknown")


class MplsTpTunnelActiveLsp(Enum):
    """
    MplsTpTunnelActiveLsp

    Transport profile tunnel active LSP

    .. data:: working = 0

    	Working LSP

    .. data:: protect = 1

    	Protect LSP

    .. data:: none = 2

    	Neither working nor protection LSP is active

    """

    working = Enum.YLeaf(0, "working")

    protect = Enum.YLeaf(1, "protect")

    none = Enum.YLeaf(2, "none")


class MplsTpTunnelState(Enum):
    """
    MplsTpTunnelState

    Transport profile tunnel states

    .. data:: admin_down = 0

    	Tunnel is administratively down

    .. data:: admin_up = 1

    	Tunnel is administratively up

    .. data:: oper_up = 2

    	Tunnel is operationally up

    .. data:: oper_down = 3

    	Tunnel is operationally down

    """

    admin_down = Enum.YLeaf(0, "admin-down")

    admin_up = Enum.YLeaf(1, "admin-up")

    oper_up = Enum.YLeaf(2, "oper-up")

    oper_down = Enum.YLeaf(3, "oper-down")


class MplsTpTunnelSwitchoverTrig(Enum):
    """
    MplsTpTunnelSwitchoverTrig

    Transport profile protection switchover triggers

    .. data:: none = 0

    	No Trigger

    .. data:: bfd = 1

    	Trigger is BFD

    .. data:: local_lockout = 2

    	Trigger is local lockout

    .. data:: remote_lockout = 3

    	Trigger is remote lockout

    .. data:: ais = 4

    	Trigger is AIS

    .. data:: ldi = 5

    	Trigger is LDI

    .. data:: lkr = 6

    	Trigger is LKR

    .. data:: link_down = 7

    	Trigger is due to link down event

    """

    none = Enum.YLeaf(0, "none")

    bfd = Enum.YLeaf(1, "bfd")

    local_lockout = Enum.YLeaf(2, "local-lockout")

    remote_lockout = Enum.YLeaf(3, "remote-lockout")

    ais = Enum.YLeaf(4, "ais")

    ldi = Enum.YLeaf(5, "ldi")

    lkr = Enum.YLeaf(6, "lkr")

    link_down = Enum.YLeaf(7, "link-down")


class MtePathOption(Enum):
    """
    MtePathOption

    Path Option Type

    .. data:: none = 0

    	No Path Option type

    .. data:: dynamic = 1

    	Dynamic Path Option type

    .. data:: explicit = 2

    	Explicit Path Option type

    .. data:: no_ero = 3

    	No ERO Path Option type

    .. data:: segment_routing = 4

    	One SID SegmentRouting Path Option type

    .. data:: po_count = 5

    	Number of Path option types

    """

    none = Enum.YLeaf(0, "none")

    dynamic = Enum.YLeaf(1, "dynamic")

    explicit = Enum.YLeaf(2, "explicit")

    no_ero = Enum.YLeaf(3, "no-ero")

    segment_routing = Enum.YLeaf(4, "segment-routing")

    po_count = Enum.YLeaf(5, "po-count")


class MteReoptTrigger(Enum):
    """
    MteReoptTrigger

    Reoptimization trigger

    .. data:: no_trigger = 0

    	No trigger

    .. data:: timer_trigger = 1

    	Timer Trigger

    .. data:: bandwidth_change_trigger = 2

    	Bandwidth Change Trigger

    .. data:: auto_bandwidth_overflow_trigger = 3

    	Auto Bandwidth Overflow Trigger

    .. data:: auto_bandwidth_underflow_trigger = 4

    	Auto Bandwidth Underflow Trigger

    .. data:: auto_bandwidth_adjustment_trigger = 5

    	Auto Bandwidth Adjustment Trigger

    .. data:: metric_type_change_trigger = 6

    	Metric Type Change Trigger

    .. data:: user_trigger = 7

    	User Trigger

    .. data:: frr_trigger = 8

    	FRR Trigger

    .. data:: remerge_error_trigger = 9

    	Remerge Error Trigger

    .. data:: preferred_path_trigger = 10

    	Reception of the preferred path exists path

    	error

    .. data:: preferred_tree_trigger = 11

    	Reception of the preferred tree exists path

    	error

    .. data:: due_to_maximum_metric = 12

    	Reoptimization triggered due to receiving an

    	LSA with MAX metric

    .. data:: path_option_switchover_trigger = 13

    	Path option switchover

    .. data:: path_protection_switchover_trigger = 14

    	Path Protection Switchover Trigger

    .. data:: iep_enable_reoptimization_trigger = 15

    	IEP Enable Reoptimization Trigger

    .. data:: affinity_path_verification_fail_trigger = 16

    	Affinity path verification failure trigger

    .. data:: cost_limit_path_verification_fail_trigger = 17

    	Cost limit path verification failure trigger

    .. data:: soft_preemption_trigger = 18

    	Soft preemption trigger

    .. data:: iep_changed = 19

    	Explicit path has changed

    .. data:: po_changed = 20

    	Path-option has changed

    .. data:: dest_changed = 21

    	Destination has changed

    .. data:: reopt_try_to_force_it = 22

    	Reoptimization with try-to-force-it option

    .. data:: topology_change_trigger = 23

    	Topology change trigger

    .. data:: reopt_link_up_event = 24

    	Topology link-up event trigger

    .. data:: bfd_session_down_trigger = 25

    	FRR enabled and BFD session down trigger

    .. data:: reverse_assoc_s2l_received_trigger = 26

    	Reverse associated S2L received trigger

    .. data:: gmpls_uni_multilayer_trigger = 27

    	Multilayer recovery for GMPLS-UNI

    .. data:: gmpls_uni_user_trigger = 28

    	User-triggered GMPLS-UNI reopt request

    .. data:: path_selection_tiebreaker_change_trigger = 29

    	Path Selection Tiebreaker Change Trigger

    .. data:: sr_egress_path_change_trigger = 30

    	Segment-Routing Egress Path Change Trigger

    .. data:: overload_bit_trigger = 31

    	Overload-bit set on current path

    .. data:: pce_trigger = 32

    	PCE Trigger

    .. data:: lockout_metric_trigger = 33

    	Reoptimization triggered due to receiving an

    	LSA with Lockout metric

    .. data:: bfd_session_config_change_trigger = 34

    	BFD session configuration change

    .. data:: higher_priority_po_change_trigger = 35

    	Higher priority path option changed

    .. data:: sr_area_spf_support_change_trigger = 36

    	Segment-Routing IGP Area SPF Support Change

    	Trigger

    .. data:: trigger_not_used = 37

    	Not used

    """

    no_trigger = Enum.YLeaf(0, "no-trigger")

    timer_trigger = Enum.YLeaf(1, "timer-trigger")

    bandwidth_change_trigger = Enum.YLeaf(2, "bandwidth-change-trigger")

    auto_bandwidth_overflow_trigger = Enum.YLeaf(3, "auto-bandwidth-overflow-trigger")

    auto_bandwidth_underflow_trigger = Enum.YLeaf(4, "auto-bandwidth-underflow-trigger")

    auto_bandwidth_adjustment_trigger = Enum.YLeaf(5, "auto-bandwidth-adjustment-trigger")

    metric_type_change_trigger = Enum.YLeaf(6, "metric-type-change-trigger")

    user_trigger = Enum.YLeaf(7, "user-trigger")

    frr_trigger = Enum.YLeaf(8, "frr-trigger")

    remerge_error_trigger = Enum.YLeaf(9, "remerge-error-trigger")

    preferred_path_trigger = Enum.YLeaf(10, "preferred-path-trigger")

    preferred_tree_trigger = Enum.YLeaf(11, "preferred-tree-trigger")

    due_to_maximum_metric = Enum.YLeaf(12, "due-to-maximum-metric")

    path_option_switchover_trigger = Enum.YLeaf(13, "path-option-switchover-trigger")

    path_protection_switchover_trigger = Enum.YLeaf(14, "path-protection-switchover-trigger")

    iep_enable_reoptimization_trigger = Enum.YLeaf(15, "iep-enable-reoptimization-trigger")

    affinity_path_verification_fail_trigger = Enum.YLeaf(16, "affinity-path-verification-fail-trigger")

    cost_limit_path_verification_fail_trigger = Enum.YLeaf(17, "cost-limit-path-verification-fail-trigger")

    soft_preemption_trigger = Enum.YLeaf(18, "soft-preemption-trigger")

    iep_changed = Enum.YLeaf(19, "iep-changed")

    po_changed = Enum.YLeaf(20, "po-changed")

    dest_changed = Enum.YLeaf(21, "dest-changed")

    reopt_try_to_force_it = Enum.YLeaf(22, "reopt-try-to-force-it")

    topology_change_trigger = Enum.YLeaf(23, "topology-change-trigger")

    reopt_link_up_event = Enum.YLeaf(24, "reopt-link-up-event")

    bfd_session_down_trigger = Enum.YLeaf(25, "bfd-session-down-trigger")

    reverse_assoc_s2l_received_trigger = Enum.YLeaf(26, "reverse-assoc-s2l-received-trigger")

    gmpls_uni_multilayer_trigger = Enum.YLeaf(27, "gmpls-uni-multilayer-trigger")

    gmpls_uni_user_trigger = Enum.YLeaf(28, "gmpls-uni-user-trigger")

    path_selection_tiebreaker_change_trigger = Enum.YLeaf(29, "path-selection-tiebreaker-change-trigger")

    sr_egress_path_change_trigger = Enum.YLeaf(30, "sr-egress-path-change-trigger")

    overload_bit_trigger = Enum.YLeaf(31, "overload-bit-trigger")

    pce_trigger = Enum.YLeaf(32, "pce-trigger")

    lockout_metric_trigger = Enum.YLeaf(33, "lockout-metric-trigger")

    bfd_session_config_change_trigger = Enum.YLeaf(34, "bfd-session-config-change-trigger")

    higher_priority_po_change_trigger = Enum.YLeaf(35, "higher-priority-po-change-trigger")

    sr_area_spf_support_change_trigger = Enum.YLeaf(36, "sr-area-spf-support-change-trigger")

    trigger_not_used = Enum.YLeaf(37, "trigger-not-used")


class MteTunnelAdminState(Enum):
    """
    MteTunnelAdminState

    Tunnel admin state

    .. data:: tunnel_state_admin_unknown = 0

    	Tunnel is in unknown state

    .. data:: admin_shutdown = 1

    	Tunnel is in admin shutdown state

    .. data:: admin_up = 2

    	Tunnel is in admin up state

    """

    tunnel_state_admin_unknown = Enum.YLeaf(0, "tunnel-state-admin-unknown")

    admin_shutdown = Enum.YLeaf(1, "admin-shutdown")

    admin_up = Enum.YLeaf(2, "admin-up")


class MteTunnelOperState(Enum):
    """
    MteTunnelOperState

    Tunnel operational state

    .. data:: tunnel_state_oper_unknown = 0

    	Tunnel is in unknown state

    .. data:: operational_down = 1

    	Tunnel is in operational down state

    .. data:: operational_up = 2

    	Tunnel is in operational up state

    """

    tunnel_state_oper_unknown = Enum.YLeaf(0, "tunnel-state-oper-unknown")

    operational_down = Enum.YLeaf(1, "operational-down")

    operational_up = Enum.YLeaf(2, "operational-up")


class OcMplsTeLsp(Enum):
    """
    OcMplsTeLsp

    OC MPLS TE LSP Type

    .. data:: oc_mpls_te_lsp_type_not_set = 0

    	MPLS TE lsp type not set

    .. data:: oc_mpls_te_lsp_type_p2p = 1

    	MPLS TE lsp type point to point

    .. data:: oc_mpls_te_lsp_type_p2mp = 2

    	MPLS TE lsp type point to multi-point

    """

    oc_mpls_te_lsp_type_not_set = Enum.YLeaf(0, "oc-mpls-te-lsp-type-not-set")

    oc_mpls_te_lsp_type_p2p = Enum.YLeaf(1, "oc-mpls-te-lsp-type-p2p")

    oc_mpls_te_lsp_type_p2mp = Enum.YLeaf(2, "oc-mpls-te-lsp-type-p2mp")


class OcMplsTeMetric(Enum):
    """
    OcMplsTeMetric

    OC MPLS TE Metric Type

    .. data:: oc_mpls_te_metric_type_igp = 0

    	MPLS TE metric type IGP

    .. data:: oc_mpls_te_metric_type_te = 1

    	MPLS TE metric type TE

    """

    oc_mpls_te_metric_type_igp = Enum.YLeaf(0, "oc-mpls-te-metric-type-igp")

    oc_mpls_te_metric_type_te = Enum.YLeaf(1, "oc-mpls-te-metric-type-te")


class OcMplsTeTunnel(Enum):
    """
    OcMplsTeTunnel

    Oc mpls te tunnel

    .. data:: unknown = 0

    	UNKNOWN

    .. data:: p2p = 1

    	P2P

    .. data:: p2mp = 2

    	P2MP

    """

    unknown = Enum.YLeaf(0, "unknown")

    p2p = Enum.YLeaf(1, "p2p")

    p2mp = Enum.YLeaf(2, "p2mp")


class PceLspAutorouteMetric(Enum):
    """
    PceLspAutorouteMetric

    Autoroute Metric Type

    .. data:: none = 0

    	None

    .. data:: relative = 1

    	Relative

    .. data:: absolute = 2

    	Absolute

    """

    none = Enum.YLeaf(0, "none")

    relative = Enum.YLeaf(1, "relative")

    absolute = Enum.YLeaf(2, "absolute")


class PceLspOperState(Enum):
    """
    PceLspOperState

    LSP Operational state

    .. data:: down = 0

    	Down

    .. data:: up = 1

    	Up

    .. data:: active = 2

    	Active

    .. data:: going_down = 3

    	Going down

    .. data:: going_up = 4

    	Going Up

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")

    active = Enum.YLeaf(2, "active")

    going_down = Enum.YLeaf(3, "going-down")

    going_up = Enum.YLeaf(4, "going-up")


class PceSrSid(Enum):
    """
    PceSrSid

    PCE SID type

    .. data:: unknown_segment_id = 0

    	Unknown type

    .. data:: ipv4_node_segment_id = 1

    	IPv4 Node ID

    .. data:: ipv4_adjacency_segment_id = 2

    	IPv4 Adjacency ID

    """

    unknown_segment_id = Enum.YLeaf(0, "unknown-segment-id")

    ipv4_node_segment_id = Enum.YLeaf(1, "ipv4-node-segment-id")

    ipv4_adjacency_segment_id = Enum.YLeaf(2, "ipv4-adjacency-segment-id")


class PceState(Enum):
    """
    PceState

    PCE State

    .. data:: tcp_close = 0

    	TCP close

    .. data:: tcp_listen = 1

    	TCP listen

    .. data:: tcp_connect = 2

    	TCP connect

    .. data:: pcep_closed = 3

    	PCEP closed

    .. data:: pcep_opening = 4

    	PCEP opening

    .. data:: pcep_open = 5

    	PCEP open

    """

    tcp_close = Enum.YLeaf(0, "tcp-close")

    tcp_listen = Enum.YLeaf(1, "tcp-listen")

    tcp_connect = Enum.YLeaf(2, "tcp-connect")

    pcep_closed = Enum.YLeaf(3, "pcep-closed")

    pcep_opening = Enum.YLeaf(4, "pcep-opening")

    pcep_open = Enum.YLeaf(5, "pcep-open")


class PceTunPathState(Enum):
    """
    PceTunPathState

    PCE Request State

    .. data:: state_none = 0

    	None

    .. data:: state_pending = 1

    	Request Pending

    .. data:: state_received_path = 2

    	Path Received

    .. data:: state_no_peer = 3

    	No peer to forward

    .. data:: state_pcep_down = 4

    	PCEP to the peer is down

    .. data:: state_received_no_path = 5

    	Path Received No Path

    """

    state_none = Enum.YLeaf(0, "state-none")

    state_pending = Enum.YLeaf(1, "state-pending")

    state_received_path = Enum.YLeaf(2, "state-received-path")

    state_no_peer = Enum.YLeaf(3, "state-no-peer")

    state_pcep_down = Enum.YLeaf(4, "state-pcep-down")

    state_received_no_path = Enum.YLeaf(5, "state-received-no-path")


class PceTunnelState(Enum):
    """
    PceTunnelState

    PCE Tunnel State

    .. data:: tunnel_state_none = 0

    	None

    .. data:: tunnel_state_admin_down = 1

    	AdminDown

    .. data:: tunnel_state_down = 2

    	Down

    .. data:: tunnel_state_up = 3

    	Up

    """

    tunnel_state_none = Enum.YLeaf(0, "tunnel-state-none")

    tunnel_state_admin_down = Enum.YLeaf(1, "tunnel-state-admin-down")

    tunnel_state_down = Enum.YLeaf(2, "tunnel-state-down")

    tunnel_state_up = Enum.YLeaf(3, "tunnel-state-up")


class ResourceProvider(Enum):
    """
    ResourceProvider

    The resource provider type

    .. data:: resource_provider_none = 0

    	Unknown

    .. data:: packet_switch_capable = 1

    	Packet Switch Capable

    .. data:: time_division_multiplex = 2

    	TDM - SONET/SDH

    .. data:: lambda_switch_capable = 3

    	Lambda Switch Capable

    .. data:: fiber_switch_capable = 4

    	Fiber Switch Capable

    .. data:: g709odu_capable = 5

    	Resource provider of type G709-ODU

    """

    resource_provider_none = Enum.YLeaf(0, "resource-provider-none")

    packet_switch_capable = Enum.YLeaf(1, "packet-switch-capable")

    time_division_multiplex = Enum.YLeaf(2, "time-division-multiplex")

    lambda_switch_capable = Enum.YLeaf(3, "lambda-switch-capable")

    fiber_switch_capable = Enum.YLeaf(4, "fiber-switch-capable")

    g709odu_capable = Enum.YLeaf(5, "g709odu-capable")


class RrrDsteMigrationMode(Enum):
    """
    RrrDsteMigrationMode

    DS\-TE migration mode

    .. data:: rrr_dste_mode_none = 0

    	No DSTE mode set

    .. data:: rrr_dste_mode_prestandard = 1

    	Pre-standard DSTE

    .. data:: rrr_dste_mode_standard = 3

    	IETF-standard DSTE

    """

    rrr_dste_mode_none = Enum.YLeaf(0, "rrr-dste-mode-none")

    rrr_dste_mode_prestandard = Enum.YLeaf(1, "rrr-dste-mode-prestandard")

    rrr_dste_mode_standard = Enum.YLeaf(3, "rrr-dste-mode-standard")


class RsvpMgmtEroSubobj(Enum):
    """
    RsvpMgmtEroSubobj

    RSVP ERO Types

    .. data:: rsvp_mgmt_ero_type_ipv4 = 1

    	IPv4 ERO Type

    .. data:: rsvp_mgmt_ero_type_un_num = 4

    	Unnumbered ERO Type

    """

    rsvp_mgmt_ero_type_ipv4 = Enum.YLeaf(1, "rsvp-mgmt-ero-type-ipv4")

    rsvp_mgmt_ero_type_un_num = Enum.YLeaf(4, "rsvp-mgmt-ero-type-un-num")


class RsvpMgmtEroSubobjStatus(Enum):
    """
    RsvpMgmtEroSubobjStatus

    RSVP ERO Status

    .. data:: rsvp_mgmt_ero_status_not_available = 0

    	ERO is not available in topology

    .. data:: rsvp_mgmt_ero_status_available = 1

    	ERO is available in topology

    .. data:: rsvp_mgmt_ero_status_bw_not_available = 2

    	ERO doesn't have bw available in topology

    """

    rsvp_mgmt_ero_status_not_available = Enum.YLeaf(0, "rsvp-mgmt-ero-status-not-available")

    rsvp_mgmt_ero_status_available = Enum.YLeaf(1, "rsvp-mgmt-ero-status-available")

    rsvp_mgmt_ero_status_bw_not_available = Enum.YLeaf(2, "rsvp-mgmt-ero-status-bw-not-available")


class RsvpMgmtRroSubobj(Enum):
    """
    RsvpMgmtRroSubobj

    RSVP RRO Types

    .. data:: ipv4rro_type = 1

    	IPv4 RRO Type

    .. data:: label_rro_type = 3

    	Label RRO Type

    .. data:: unnumbered_rro_type = 4

    	Unnumbered RRO Type

    .. data:: srlg_rro_type = 34

    	SRLG RRO Type

    """

    ipv4rro_type = Enum.YLeaf(1, "ipv4rro-type")

    label_rro_type = Enum.YLeaf(3, "label-rro-type")

    unnumbered_rro_type = Enum.YLeaf(4, "unnumbered-rro-type")

    srlg_rro_type = Enum.YLeaf(34, "srlg-rro-type")


class SignalingAgentEnum(Enum):
    """
    SignalingAgentEnum

    Deprecated \- Signaling Agent

    .. data:: no_signaling = 0

    	Deprecated - No signaling protocol configured

    .. data:: rsvp_signaling = 1

    	Deprecated - RSVP is the signaling protocol

    """

    no_signaling = Enum.YLeaf(0, "no-signaling")

    rsvp_signaling = Enum.YLeaf(1, "rsvp-signaling")


class TeAcl(Enum):
    """
    TeAcl

    Te acl

    .. data:: acl_type_unknown = 0

    	Unknown type of ACL

    .. data:: acl_type_access_list = 1

    	Access-list type of ACL

    .. data:: acl_type_prefix_list = 2

    	Prefix-list type of ACL

    .. data:: acl_type_unregistered = 3

    	ACL failed to register to ACL infra

    """

    acl_type_unknown = Enum.YLeaf(0, "acl-type-unknown")

    acl_type_access_list = Enum.YLeaf(1, "acl-type-access-list")

    acl_type_prefix_list = Enum.YLeaf(2, "acl-type-prefix-list")

    acl_type_unregistered = Enum.YLeaf(3, "acl-type-unregistered")


class TeAddr(Enum):
    """
    TeAddr

    TE Address Types

    .. data:: not_set = 0

    	Address not set

    .. data:: ipv4 = 1

    	IPv4

    .. data:: ipv4_unnumbered = 2

    	IPv4 Unnumbered

    """

    not_set = Enum.YLeaf(0, "not-set")

    ipv4 = Enum.YLeaf(1, "ipv4")

    ipv4_unnumbered = Enum.YLeaf(2, "ipv4-unnumbered")


class TeAffinityTable(Enum):
    """
    TeAffinityTable

    Affinity Table IDs

    .. data:: affinity_table_mapping = 0

    	Mapping affinity table

    .. data:: affinity_table_forward_reference = 1

    	Forward reference affinity table

    .. data:: affinity_table_count = 2

    	Number of affinity tables

    """

    affinity_table_mapping = Enum.YLeaf(0, "affinity-table-mapping")

    affinity_table_forward_reference = Enum.YLeaf(1, "affinity-table-forward-reference")

    affinity_table_count = Enum.YLeaf(2, "affinity-table-count")


class TeApsSncMode(Enum):
    """
    TeApsSncMode

    APS ANC Modes

    .. data:: snc_mode_not_set = 0

    	TE OTN Subnetwork Connection Mode Not Set

    .. data:: snc_mode_n = 1

    	TE OTN Subnetwork Connection Mode N

    .. data:: snc_mode_i = 2

    	TE OTN Subnetwork Connection Mode I

    .. data:: snc_mode_s = 3

    	TE OTN Subnetwork Connection Mode S

    """

    snc_mode_not_set = Enum.YLeaf(0, "snc-mode-not-set")

    snc_mode_n = Enum.YLeaf(1, "snc-mode-n")

    snc_mode_i = Enum.YLeaf(2, "snc-mode-i")

    snc_mode_s = Enum.YLeaf(3, "snc-mode-s")


class TeAssociationTieRole(Enum):
    """
    TeAssociationTieRole

    TE Association Tie Breaker Role

    .. data:: none = 0

    	Association Role None

    .. data:: master = 1

    	Association Role Master

    .. data:: slave = 2

    	Association Role Slave

    """

    none = Enum.YLeaf(0, "none")

    master = Enum.YLeaf(1, "master")

    slave = Enum.YLeaf(2, "slave")


class TeAttributeSetSrPrepend(Enum):
    """
    TeAttributeSetSrPrepend

    Attribute Set SR prepend type

    .. data:: te_attribute_set_sr_prepend_not_set = 0

    	Not set

    .. data:: te_attribute_set_sr_prepend_next_label = 1

    	Next label

    .. data:: te_attribute_set_sr_prepend_bgp_nhop = 2

    	BGP NHOP

    """

    te_attribute_set_sr_prepend_not_set = Enum.YLeaf(0, "te-attribute-set-sr-prepend-not-set")

    te_attribute_set_sr_prepend_next_label = Enum.YLeaf(1, "te-attribute-set-sr-prepend-next-label")

    te_attribute_set_sr_prepend_bgp_nhop = Enum.YLeaf(2, "te-attribute-set-sr-prepend-bgp-nhop")


class TeAutoTunExpPathHop(Enum):
    """
    TeAutoTunExpPathHop

    Auto tunnel hop type

    .. data:: ipv4_address_type = 0

    	IPv4 Address Type

    .. data:: mpls_label_type = 1

    	MPLS Label Type

    .. data:: ipv4_and_label_type = 2

    	IPv4 Address and MPLS Label Type

    """

    ipv4_address_type = Enum.YLeaf(0, "ipv4-address-type")

    mpls_label_type = Enum.YLeaf(1, "mpls-label-type")

    ipv4_and_label_type = Enum.YLeaf(2, "ipv4-and-label-type")


class TeAutobwAppRej(Enum):
    """
    TeAutobwAppRej

    Reason for auto\-bandwidth application rejection

    .. data:: application_allowed = 0

    	Application allowed

    .. data:: auto_bw_disabled = 1

    	Auto-bw disabled

    .. data:: tunnel_is_down = 2

    	TunnelIsDown

    .. data:: tunnel_is_frr = 3

    	TunnelIsFRRActive

    .. data:: tunnel_is_backup = 4

    	TunnelIsBackup

    .. data:: tunnel_is_lock_down = 5

    	TunnelIsLockdown

    """

    application_allowed = Enum.YLeaf(0, "application-allowed")

    auto_bw_disabled = Enum.YLeaf(1, "auto-bw-disabled")

    tunnel_is_down = Enum.YLeaf(2, "tunnel-is-down")

    tunnel_is_frr = Enum.YLeaf(3, "tunnel-is-frr")

    tunnel_is_backup = Enum.YLeaf(4, "tunnel-is-backup")

    tunnel_is_lock_down = Enum.YLeaf(5, "tunnel-is-lock-down")


class TeAutobwAppTrigger(Enum):
    """
    TeAutobwAppTrigger

    Auto\-bandwidth application trigger

    .. data:: application_none = 0

    	No BW Application

    .. data:: application_periodic = 1

    	BW Application Periodic

    .. data:: application_manual = 2

    	BW Application Manual

    .. data:: application_overflow = 3

    	BW Application Overflow

    .. data:: application_underflow = 4

    	BW Application Underflow

    """

    application_none = Enum.YLeaf(0, "application-none")

    application_periodic = Enum.YLeaf(1, "application-periodic")

    application_manual = Enum.YLeaf(2, "application-manual")

    application_overflow = Enum.YLeaf(3, "application-overflow")

    application_underflow = Enum.YLeaf(4, "application-underflow")


class TeBfdLspSessionState(Enum):
    """
    TeBfdLspSessionState

    TE BFDOverLSP Session State

    .. data:: bfd_over_lsp_session_state_none = 0

    	BFDOverLSP session state none

    .. data:: bfd_over_lsp_session_state_created = 1

    	BFDOverLSP session state created

    .. data:: bfd_over_lsp_session_state_up = 2

    	BFDOverLSP session state up

    .. data:: bfd_over_lsp_session_state_down = 3

    	BFDOverLSP session state down

    .. data:: bfd_over_lsp_session_state_admin_down = 4

    	BFDOverLSP session state admin down

    .. data:: bfd_over_lsp_session_state_deleted = 5

    	BFDOverLSP sesssion state deleted

    .. data:: bfd_over_lsp_session_state_create_failed = 6

    	BFDOverLSP session state create failed

    """

    bfd_over_lsp_session_state_none = Enum.YLeaf(0, "bfd-over-lsp-session-state-none")

    bfd_over_lsp_session_state_created = Enum.YLeaf(1, "bfd-over-lsp-session-state-created")

    bfd_over_lsp_session_state_up = Enum.YLeaf(2, "bfd-over-lsp-session-state-up")

    bfd_over_lsp_session_state_down = Enum.YLeaf(3, "bfd-over-lsp-session-state-down")

    bfd_over_lsp_session_state_admin_down = Enum.YLeaf(4, "bfd-over-lsp-session-state-admin-down")

    bfd_over_lsp_session_state_deleted = Enum.YLeaf(5, "bfd-over-lsp-session-state-deleted")

    bfd_over_lsp_session_state_create_failed = Enum.YLeaf(6, "bfd-over-lsp-session-state-create-failed")


class TeBfdReversePath(Enum):
    """
    TeBfdReversePath

    BFD Reverse Path Type

    .. data:: bfd_reverse_path_none = 0

    	BFD reverse path not enabled

    .. data:: bfd_reverse_path_binding_label = 1

    	BFD reverse path binding label

    """

    bfd_reverse_path_none = Enum.YLeaf(0, "bfd-reverse-path-none")

    bfd_reverse_path_binding_label = Enum.YLeaf(1, "bfd-reverse-path-binding-label")


class TeControllerState(Enum):
    """
    TeControllerState

    Controller States

    .. data:: notready = 0

    	Controller not ready

    .. data:: admin_down = 1

    	Controller is admin down

    .. data:: down = 2

    	Controller is operationally down

    .. data:: shutdown = 3

    	Controller is shutdown

    .. data:: error_disabled = 4

    	Controller is disabled due to error

    .. data:: up = 5

    	Controller is operationally up

    .. data:: unknown = 6

    	Controller state unknown

    """

    notready = Enum.YLeaf(0, "notready")

    admin_down = Enum.YLeaf(1, "admin-down")

    down = Enum.YLeaf(2, "down")

    shutdown = Enum.YLeaf(3, "shutdown")

    error_disabled = Enum.YLeaf(4, "error-disabled")

    up = Enum.YLeaf(5, "up")

    unknown = Enum.YLeaf(6, "unknown")


class TeDestinationState(Enum):
    """
    TeDestinationState

    P2MP destination state

    .. data:: destination_disabled = 0

    	The destination is disabled in configuration

    .. data:: destination_down = 1

    	The destination is down

    .. data:: destination_up = 2

    	The destination is up

    """

    destination_disabled = Enum.YLeaf(0, "destination-disabled")

    destination_down = Enum.YLeaf(1, "destination-down")

    destination_up = Enum.YLeaf(2, "destination-up")


class TeHopLimitIgnore(Enum):
    """
    TeHopLimitIgnore

    Te hop limit ignore

    .. data:: ignore_unknown = 0

    	Ignore for an unknown reason

    .. data:: ignore_explicit = 1

    	Ignore due to explicit path option

    .. data:: ignore_pce = 2

    	Ignore due to PCE path option

    """

    ignore_unknown = Enum.YLeaf(0, "ignore-unknown")

    ignore_explicit = Enum.YLeaf(1, "ignore-explicit")

    ignore_pce = Enum.YLeaf(2, "ignore-pce")


class TeMeshgroup(Enum):
    """
    TeMeshgroup

    Te meshgroup

    .. data:: meshgroup_type_automesh = 0

    	automesh type of Meshgroup

    .. data:: meshgroup_type_onehop = 1

    	onehop type of Meshgroup

    """

    meshgroup_type_automesh = Enum.YLeaf(0, "meshgroup-type-automesh")

    meshgroup_type_onehop = Enum.YLeaf(1, "meshgroup-type-onehop")


class TeMgmtGenericFspec(Enum):
    """
    TeMgmtGenericFspec

    TE generic FSpec types

    .. data:: te_generic_fspec_type_g709otn = 0

    	TE G709 OTN FSpec type

    """

    te_generic_fspec_type_g709otn = Enum.YLeaf(0, "te-generic-fspec-type-g709otn")


class TeMgmtGenericTspec(Enum):
    """
    TeMgmtGenericTspec

    TE generic TSpec types

    .. data:: te_generic_tspec_type_g709otn = 0

    	TE G709 OTN TSpec type

    """

    te_generic_tspec_type_g709otn = Enum.YLeaf(0, "te-generic-tspec-type-g709otn")


class TeOduCapability(Enum):
    """
    TeOduCapability

    Te ODU Capability Types

    .. data:: not_set = 0

    	Odu capability Type Not Set

    .. data:: fixed = 1

    	Fixed ODUs

    .. data:: flex = 2

    	Flex ODUs

    """

    not_set = Enum.YLeaf(0, "not-set")

    fixed = Enum.YLeaf(1, "fixed")

    flex = Enum.YLeaf(2, "flex")


class TeOduLevel(Enum):
    """
    TeOduLevel

    G.709 OTN ODU levels

    .. data:: te_odu_level_not_set = 0

    	Not set

    .. data:: te_odu_level_one = 1

    	ODU 1

    .. data:: te_odu_level_two = 2

    	ODU 2

    .. data:: te_odu_level_three = 3

    	ODU 3

    .. data:: te_odu_level_four = 4

    	ODU 4

    .. data:: te_odu_zero = 10

    	ODU 0

    .. data:: te_odu_level_two_e = 11

    	ODU 2E

    .. data:: te_odu_level_flex_cbr = 20

    	ODU Flex CBR

    .. data:: te_odu_level_flex_gfpf_resizeable = 21

    	ODU Flex GFP-F resizable

    .. data:: te_odu_level_flex_gfpf_non_resizable = 22

    	ODU Flex GFP-F non resizable

    .. data:: te_odu_level_one_e = 23

    	ODU 1E

    .. data:: te_odu_level_one_f = 24

    	ODU 1F

    .. data:: te_odu_level_two_f = 25

    	ODU 2F

    .. data:: te_odu_level_three_e_one = 26

    	ODU 3E1

    .. data:: te_odu_level_three_e_two = 27

    	ODU 3E2

    .. data:: te_odu_level_c_two = 38

    	ODU C2

    .. data:: te_odu_level_c_three = 39

    	ODU C3

    .. data:: te_odu_level_c_four = 40

    	ODU C4

    """

    te_odu_level_not_set = Enum.YLeaf(0, "te-odu-level-not-set")

    te_odu_level_one = Enum.YLeaf(1, "te-odu-level-one")

    te_odu_level_two = Enum.YLeaf(2, "te-odu-level-two")

    te_odu_level_three = Enum.YLeaf(3, "te-odu-level-three")

    te_odu_level_four = Enum.YLeaf(4, "te-odu-level-four")

    te_odu_zero = Enum.YLeaf(10, "te-odu-zero")

    te_odu_level_two_e = Enum.YLeaf(11, "te-odu-level-two-e")

    te_odu_level_flex_cbr = Enum.YLeaf(20, "te-odu-level-flex-cbr")

    te_odu_level_flex_gfpf_resizeable = Enum.YLeaf(21, "te-odu-level-flex-gfpf-resizeable")

    te_odu_level_flex_gfpf_non_resizable = Enum.YLeaf(22, "te-odu-level-flex-gfpf-non-resizable")

    te_odu_level_one_e = Enum.YLeaf(23, "te-odu-level-one-e")

    te_odu_level_one_f = Enum.YLeaf(24, "te-odu-level-one-f")

    te_odu_level_two_f = Enum.YLeaf(25, "te-odu-level-two-f")

    te_odu_level_three_e_one = Enum.YLeaf(26, "te-odu-level-three-e-one")

    te_odu_level_three_e_two = Enum.YLeaf(27, "te-odu-level-three-e-two")

    te_odu_level_c_two = Enum.YLeaf(38, "te-odu-level-c-two")

    te_odu_level_c_three = Enum.YLeaf(39, "te-odu-level-c-three")

    te_odu_level_c_four = Enum.YLeaf(40, "te-odu-level-c-four")


class TeP2MpS2LDeletionCause(Enum):
    """
    TeP2MpS2LDeletionCause

    S2L Deletion location

    .. data:: no_cause = 0

    	No cause recorded

    .. data:: hpath_cr_err = 1

    	Head Path creation

    .. data:: hpath_chg_setup = 2

    	Head Path change setup

    .. data:: hpath_chg_up_err = 3

    	Head Path change while up

    .. data:: hresv_cr_err = 4

    	Head RESV creation

    .. data:: hresv_chg_err = 5

    	Head RESV change

    .. data:: hresv_chg_err_up = 6

    	Head RESV change while up

    .. data:: hlbl_avail_err = 7

    	Head Label available

    .. data:: hup_lbl_avail_err = 8

    	Head upstream Label available

    .. data:: hfrr_act_err = 9

    	Head FRR active

    .. data:: hbkup_ch_err = 10

    	Head Backup change

    .. data:: hpath_ch_frr_err = 11

    	Head Path change FRR

    .. data:: hcleanup = 12

    	Head Cleanup handling

    .. data:: hlingering_cleanup = 13

    	Head lingering cleanup

    .. data:: hpat_err = 14

    	Head Path error

    .. data:: hresv_err = 15

    	Head Resv error

    .. data:: hresv_del = 16

    	Head Resv delete

    .. data:: hrw_fail = 17

    	Head rewrite failure

    .. data:: hup_rw_fail = 18

    	Head upstream rewrite failure

    .. data:: ha_failure = 19

    	HA failure

    .. data:: rw_del = 20

    	Rewrite Delete

    .. data:: up_rw_del = 21

    	Upstream Rewrite Delete

    .. data:: mpath_cr = 22

    	Mid path creation

    .. data:: mpath_chg_setup_err = 23

    	Mid Path change setup

    .. data:: mpath_chg_up_err = 24

    	Mid Path change while up

    .. data:: mresv_cr_err = 25

    	Mid Resv creation

    .. data:: mresv_chg_err = 26

    	Mid Resv change

    .. data:: mresv_chg_err_up = 27

    	Mid Resv change while up

    .. data:: mlbl_avail_err = 28

    	Mid: cannot get local label

    .. data:: mlbl_rel_err = 29

    	Mid: cannot release local label

    .. data:: mup_lbl_avail_err = 30

    	Mid: cannot get upstream label

    .. data:: mup_lbl_rel_err = 31

    	Mid: cannot release upstream label

    .. data:: mfrr_act_err = 32

    	Mid FRR active

    .. data:: mbkup_ch_err = 33

    	Mid Backup change

    .. data:: mpath_ch_frr_err = 34

    	Mid Path change FRR

    .. data:: mresv_del = 35

    	Mid Resv Delete handling

    .. data:: mresv_err = 36

    	Mid Resv Error handling

    .. data:: mpreempt = 37

    	Mid Premption

    .. data:: mcleanup = 38

    	Mid Cleanup handling

    .. data:: mlingering_cleanup = 39

    	Mid lingering cleanup

    .. data:: mrw_fail = 40

    	mid rewrite failure

    .. data:: mup_rw_fail = 41

    	mid upstream rewrite failure

    .. data:: tpath_cr_err = 42

    	Tail Path creation

    .. data:: tpath_chg_err = 43

    	Tail Path change

    .. data:: tresv_cr_err = 44

    	Tail RESV creation

    .. data:: tlbl_avail_err = 45

    	Tail: cannot release local label

    .. data:: tcleanup = 46

    	Tail Cleanup

    .. data:: tlingering_cleanup = 47

    	Tail lingering cleanup

    .. data:: lbl_err = 48

    	Local label related error

    .. data:: qfailure = 49

    	FSM Queueing failure

    .. data:: rsvp_recovery = 50

    	RSVP Recovery

    .. data:: lsd_recovery = 51

    	LSD Recovery

    .. data:: lmrib_recovery = 52

    	LMRIB Recovery

    .. data:: te_restart = 53

    	TE Restart

    .. data:: switchover = 54

    	Switchover

    .. data:: master_te_recovery = 55

    	Master TE recovery

    .. data:: optical_r_mgr_recovery = 56

    	Optical Resource Manager Recovery

    .. data:: te_exit = 57

    	TE Exited

    .. data:: bkup_assign_fail = 58

    	RSVP Backup Assign Failed

    .. data:: bfd_fail = 59

    	BFD Session Failure

    .. data:: bfd_recovery = 60

    	BFD Recovery

    .. data:: lsp_wrap_act_err = 61

    	Mid LSP Wrap active

    .. data:: lsp_wrap_rw_err = 62

    	Mid LSP Wrap Rewrite

    .. data:: fsm_cause_must_be_last = 63

    	Not used, must be last entry

    """

    no_cause = Enum.YLeaf(0, "no-cause")

    hpath_cr_err = Enum.YLeaf(1, "hpath-cr-err")

    hpath_chg_setup = Enum.YLeaf(2, "hpath-chg-setup")

    hpath_chg_up_err = Enum.YLeaf(3, "hpath-chg-up-err")

    hresv_cr_err = Enum.YLeaf(4, "hresv-cr-err")

    hresv_chg_err = Enum.YLeaf(5, "hresv-chg-err")

    hresv_chg_err_up = Enum.YLeaf(6, "hresv-chg-err-up")

    hlbl_avail_err = Enum.YLeaf(7, "hlbl-avail-err")

    hup_lbl_avail_err = Enum.YLeaf(8, "hup-lbl-avail-err")

    hfrr_act_err = Enum.YLeaf(9, "hfrr-act-err")

    hbkup_ch_err = Enum.YLeaf(10, "hbkup-ch-err")

    hpath_ch_frr_err = Enum.YLeaf(11, "hpath-ch-frr-err")

    hcleanup = Enum.YLeaf(12, "hcleanup")

    hlingering_cleanup = Enum.YLeaf(13, "hlingering-cleanup")

    hpat_err = Enum.YLeaf(14, "hpat-err")

    hresv_err = Enum.YLeaf(15, "hresv-err")

    hresv_del = Enum.YLeaf(16, "hresv-del")

    hrw_fail = Enum.YLeaf(17, "hrw-fail")

    hup_rw_fail = Enum.YLeaf(18, "hup-rw-fail")

    ha_failure = Enum.YLeaf(19, "ha-failure")

    rw_del = Enum.YLeaf(20, "rw-del")

    up_rw_del = Enum.YLeaf(21, "up-rw-del")

    mpath_cr = Enum.YLeaf(22, "mpath-cr")

    mpath_chg_setup_err = Enum.YLeaf(23, "mpath-chg-setup-err")

    mpath_chg_up_err = Enum.YLeaf(24, "mpath-chg-up-err")

    mresv_cr_err = Enum.YLeaf(25, "mresv-cr-err")

    mresv_chg_err = Enum.YLeaf(26, "mresv-chg-err")

    mresv_chg_err_up = Enum.YLeaf(27, "mresv-chg-err-up")

    mlbl_avail_err = Enum.YLeaf(28, "mlbl-avail-err")

    mlbl_rel_err = Enum.YLeaf(29, "mlbl-rel-err")

    mup_lbl_avail_err = Enum.YLeaf(30, "mup-lbl-avail-err")

    mup_lbl_rel_err = Enum.YLeaf(31, "mup-lbl-rel-err")

    mfrr_act_err = Enum.YLeaf(32, "mfrr-act-err")

    mbkup_ch_err = Enum.YLeaf(33, "mbkup-ch-err")

    mpath_ch_frr_err = Enum.YLeaf(34, "mpath-ch-frr-err")

    mresv_del = Enum.YLeaf(35, "mresv-del")

    mresv_err = Enum.YLeaf(36, "mresv-err")

    mpreempt = Enum.YLeaf(37, "mpreempt")

    mcleanup = Enum.YLeaf(38, "mcleanup")

    mlingering_cleanup = Enum.YLeaf(39, "mlingering-cleanup")

    mrw_fail = Enum.YLeaf(40, "mrw-fail")

    mup_rw_fail = Enum.YLeaf(41, "mup-rw-fail")

    tpath_cr_err = Enum.YLeaf(42, "tpath-cr-err")

    tpath_chg_err = Enum.YLeaf(43, "tpath-chg-err")

    tresv_cr_err = Enum.YLeaf(44, "tresv-cr-err")

    tlbl_avail_err = Enum.YLeaf(45, "tlbl-avail-err")

    tcleanup = Enum.YLeaf(46, "tcleanup")

    tlingering_cleanup = Enum.YLeaf(47, "tlingering-cleanup")

    lbl_err = Enum.YLeaf(48, "lbl-err")

    qfailure = Enum.YLeaf(49, "qfailure")

    rsvp_recovery = Enum.YLeaf(50, "rsvp-recovery")

    lsd_recovery = Enum.YLeaf(51, "lsd-recovery")

    lmrib_recovery = Enum.YLeaf(52, "lmrib-recovery")

    te_restart = Enum.YLeaf(53, "te-restart")

    switchover = Enum.YLeaf(54, "switchover")

    master_te_recovery = Enum.YLeaf(55, "master-te-recovery")

    optical_r_mgr_recovery = Enum.YLeaf(56, "optical-r-mgr-recovery")

    te_exit = Enum.YLeaf(57, "te-exit")

    bkup_assign_fail = Enum.YLeaf(58, "bkup-assign-fail")

    bfd_fail = Enum.YLeaf(59, "bfd-fail")

    bfd_recovery = Enum.YLeaf(60, "bfd-recovery")

    lsp_wrap_act_err = Enum.YLeaf(61, "lsp-wrap-act-err")

    lsp_wrap_rw_err = Enum.YLeaf(62, "lsp-wrap-rw-err")

    fsm_cause_must_be_last = Enum.YLeaf(63, "fsm-cause-must-be-last")


class TeP2MpS2LDeletionSubcause(Enum):
    """
    TeP2MpS2LDeletionSubcause

    S2L deletion subcause

    .. data:: no_subcause = 0

    	No subcause recorded

    .. data:: cleanup_req = 1

    	Normal cleanup requested

    .. data:: invalid_data = 2

    	Invalid Data passed

    .. data:: fsm_inv_ctxt = 3

    	Invalid FSM context passed in

    .. data:: fsm_inv_ctxt_data = 4

    	Invalid data passed in FSM context

    .. data:: fsm_inv_role = 5

    	Failed due to Invalid Role

    .. data:: ll_failure = 6

    	Local Label get failed

    .. data:: ll_rel_fail = 7

    	Local Label release failed

    .. data:: ll_mismatch = 8

    	Local label mismatch detected

    .. data:: ll_invalid = 9

    	Local label invalid

    .. data:: ll_set_failure = 10

    	Local Label set failed

    .. data:: bad_out_label = 11

    	Bad label received from neighbor

    .. data:: sl_err = 12

    	Failed to process suggested label received from

    	neighbor

    .. data:: rl_mismatch = 13

    	Incorrect recovery label received from neighbor

    .. data:: sl_alloc_err = 14

    	Failed to allocate suggested/ acceptable label

    .. data:: upstream_downstream_label_mismatch = 15

    	Upstream label does not match downstream label

    .. data:: upstream_label_failure = 16

    	Upstream Label get failed

    .. data:: upstream_label_rel_fail = 17

    	Upstream Label release failed

    .. data:: upstream_label_mismatch = 18

    	Upstream label mismatch detected

    .. data:: upstream_label_invalid = 19

    	Upstream label invalid

    .. data:: bad_upstream_label = 20

    	Bad Upstream label

    .. data:: ul_set_failure = 21

    	Upstream Label set failed

    .. data:: gmpls_label_alloc_err = 22

    	Failed to allocate GMPLS Label

    .. data:: gmpls_label_clone_err = 23

    	Failed to clone GMPLS Label

    .. data:: rw_err = 24

    	Unable to perform RW operation

    .. data:: up_rw_err = 25

    	Unable to perform upstream RW operation

    .. data:: path_admit = 26

    	Path admission failure

    .. data:: bw = 27

    	BW allocation failure

    .. data:: admit_resv = 28

    	Reservation admission failure

    .. data:: rrrm_err = 29

    	Resource Reservation removal error

    .. data:: hardware_out_of_resources = 30

    	NPU HW-OOR

    .. data:: comp_rid = 31

    	Failure to compute RID

    .. data:: comp_lcl_rid = 32

    	Failure to compute local RID

    .. data:: comp_up_rid = 33

    	Failure to compute upstream RID

    .. data:: comp_down_rid = 34

    	Failure to compute downstream RID

    .. data:: rest_if_hop = 35

    	Failure to reset IF or HOP

    .. data:: inv_in_if = 36

    	Invalid Ingress IF

    .. data:: nh_err = 37

    	Outgoing IF or Next Hop failure

    .. data:: inv_in_ero = 38

    	Invalid incoming ERO

    .. data:: out_ero_fail = 39

    	Outcoming ERO failure

    .. data:: frr_bk_asssign = 40

    	Frr backup assignment failure

    .. data:: frr_bk_rm = 41

    	Frr backup removal failure

    .. data:: frr_bk_send = 42

    	Frr backup send to RSVP failed

    .. data:: frr_needs_del = 43

    	FRR deletion required

    .. data:: frr_reopt_lsp = 44

    	FRR not allowed on reopt LSP

    .. data:: rsvp_api_h = 45

    	RSVP API Handler Failure

    .. data:: insane_path = 46

    	Invalid Path message

    .. data:: remerge_chk_fail = 47

    	Failed in finding remerge

    .. data:: remerge_detected = 48

    	Remerge detected

    .. data:: xro = 49

    	XRO processing failed

    .. data:: resv_bw_set = 50

    	Failed to set Resv Bandwidth

    .. data:: resv_prep_fail = 51

    	Failed to prepare out Resv

    .. data:: path_ch_proc = 52

    	Failure in path change Processing

    .. data:: path_ch_frr = 53

    	Failure in path change for FRR

    .. data:: path_ch_sess_attri_fl = 54

    	Failure in path change for session attribute

    	flags

    .. data:: path_ch_bw_ch = 55

    	Failure in path change: Bandwidth change not

    	allowed

    .. data:: path_err_proc = 56

    	Failure in path Error Processing

    .. data:: path_err = 57

    	Path Error Rcvd

    .. data:: path_err_wpsr = 58

    	Path Error with PSR flag Rcvd

    .. data:: path_del = 59

    	Path Delete request

    .. data:: resv_ch_proc = 60

    	Failure in Resv change processing

    .. data:: resv_ch_rro = 61

    	Failure in Resv change RRO

    .. data:: resv_del = 62

    	Resv Delete processing

    .. data:: resv_err = 63

    	Resv Error processing

    .. data:: perr_send_fail = 64

    	Failed to send Path Error

    .. data:: perr_proc_fail = 65

    	Failed to process Path Error

    .. data:: perr_rcv = 66

    	Received Path Error

    .. data:: resv_err_rcv = 67

    	Received Resv Error

    .. data:: flowspec = 68

    	Flowspec failure

    .. data:: setup_conn_api_fail = 69

    	S2L State set API failed

    .. data:: path_not_replayed = 70

    	RSVP did not replay the path

    .. data:: resv_not_replayed = 71

    	RSVP did not replay the resv

    .. data:: rewrite_not_replayed = 72

    	LMRIB did not replay rewrite

    .. data:: label_not_replayed = 73

    	RW mgr did not replay rewrite

    .. data:: connection_not_ready = 74

    	TE connection is not ready with LSD/LMRIB/RSVP

    .. data:: master_did_not_replay = 75

    	The master TE did not replay this S2L

    .. data:: head_s2l_has_no_vif = 76

    	S2L head has no associated tunnel VIF

    .. data:: frr_assigned_s2l_has_no_backup = 77

    	FRR-assigned S2L has no backup

    .. data:: frr_assigned_s2l_has_down_backup = 78

    	FRR-assigned S2L has down backup

    .. data:: out_link_down_and_no_frr = 79

    	Outgoing link is down and there is no FRR

    .. data:: collaborator_timeout_rsvp = 80

    	RSVP connection timed out

    .. data:: collaborator_timeout_lsd = 81

    	LSD connection timed out

    .. data:: collaborator_timeout_lmrib = 82

    	LMRIB connection time dout

    .. data:: collaborator_timeout_im = 83

    	IM connection timed out

    .. data:: collaborator_timeout_error = 84

    	Error in processing connection timeout

    .. data:: topo_flush = 85

    	Topology Failure

    .. data:: area_shut = 86

    	IGP Area Shutdown

    .. data:: active_po_del = 87

    	active pathoption deleted

    .. data:: path_verify_failed = 88

    	Path verification failed

    .. data:: srlg_path_verify_failed = 89

    	Srlg Path verification failed

    .. data:: affinity_path_verify_failed = 90

    	Affinity Path verification failed

    .. data:: aff_fail_delayed_tear_timeout_failed = 91

    	Affinity Failure Delayed Tear timeout failed

    .. data:: cost_limit_verify_failed = 92

    	Cost Limit verification failed

    .. data:: path_setup_timeout = 93

    	Path Setup Timed out

    .. data:: vif_destroyed = 94

    	tunnel IF destroyed

    .. data:: vif_shut = 95

    	tunnel IF shutdown

    .. data:: lsp_shut = 96

    	LSP shutdown

    .. data:: gmpls_uni_head = 97

    	link configured to run as GMPLS-UNI head

    .. data:: head_resetup = 98

    	tunnel is to be resetup

    .. data:: none_head_resetup = 99

    	mid or tail tunnel is to be resetup

    .. data:: dest_disabled = 100

    	Destination disabled

    .. data:: iep_ch_act_po = 101

    	Explicit Path changed for inuse path-option

    .. data:: iep_ch_reopt = 102

    	Reopt LSP affected by Explicit Path change

    .. data:: iep_ch_standby = 103

    	Standby LSP affected by Explicit Path change

    .. data:: dste_mode_ch = 104

    	DSTE mode change

    .. data:: reopt_del_frr_act = 105

    	Deleting reopt LSP on FRR active

    .. data:: new_reopt_tear_old = 106

    	New Reopt is in progress, tearing old reopt LSP

    .. data:: reopt_failed_verify = 107

    	Reopt LSP failed verification

    .. data:: reopt_failed_install = 108

    	Reopt LSP failed at install time

    .. data:: reopt_failed_rw = 109

    	Rewrite failed for Reopt LSP

    .. data:: reopt_failed_not_superset = 110

    	Reopt LSP has less number of destinations Up

    	than the current LSP.

    .. data:: dclean_at_install_time = 111

    	Tear delayed clean LSP at install time

    .. data:: dclean_at_clean_timer = 112

    	Tear delayed clean LSP at cleanup timer expiry

    .. data:: dclean_at_reopt_active = 113

    	Tear delayed clean LSP at Reopt Activation

    .. data:: lcl_notif_head = 114

    	Local Link Failure

    .. data:: in_if_fail = 115

    	Failure of ingress IF

    .. data:: out_if_fail = 116

    	Failure of egress IF

    .. data:: if_fail_lc_oir = 117

    	Failure of IF on LC OIR

    .. data:: te_rid_rm = 118

    	TE RID removed

    .. data:: te_rsvp_oos_bkup = 119

    	TE and RSVP are OOS for backup assignment

    .. data:: in_if_fail_exp_null_cfg_ch = 120

    	Explicit null config changed

    .. data:: new_curr_lsp_sig = 121

    	Signaling new current LSP, cleanup old LSP

    .. data:: new_reopt_lsp_sig = 122

    	Signaling new reopt LSP, cleanup old LSP

    .. data:: new_stdby_lsp_sig = 123

    	Signaling new standby LSP, cleanup old LSP

    .. data:: new_restore_lsp_sig = 124

    	Signaling new restore LSP, cleanup old LSP

    .. data:: new_cl_pp_lsp_sig = 125

    	Signaling new clean path-protect LSP, cleanup

    	old LSP

    .. data:: chkpt_recovery_failed = 126

    	Failed to recover LSP from check-point

    .. data:: stdby_cr_failed = 127

    	Failed to create standby LSP

    .. data:: reopt_lsp_rej = 128

    	Reopt LSP is rejected

    .. data:: reopt_po_sw_failed = 129

    	Reopt Path-option switchover failed

    .. data:: failed_to_find_path = 130

    	Failed to find a Path

    .. data:: sig_rcv_fail_path_cr_ch = 131

    	Signaling API failed to proc Path change or

    	create

    .. data:: lsp_db_shut = 132

    	LSP database shutdown

    .. data:: reopt_hold_start = 133

    	Starting holddown for Reopt LSP

    .. data:: vif_lspid_mismatch = 134

    	VIF has no LSP with this ID

    .. data:: s2l_has_no_vif = 135

    	Headend S2L with no associated VIF

    .. data:: overload_reopt_timeout = 136

    	Reoptimization timeout with OL-bit set at

    	midpoint

    .. data:: hop_limit_exceeded = 137

    	Hop Limit Exceeded

    .. data:: lingering_current_lsp = 138

    	Cleanup lingering current LSP

    .. data:: lingering_standby_lsp = 139

    	Cleanup lingering standby LSP

    .. data:: lingering_restore_lsp = 140

    	Cleanup lingering restore LSP

    .. data:: double_lockout = 141

    	Double lock out on the tunnel

    .. data:: lockout_no_protection = 142

    	Lock out on the tunnel with no protection

    	available

    .. data:: lockout_cleanup = 143

    	Lock out on reopt or delayed clean lsp

    .. data:: te_ppsw_lsp_mismatch = 144

    	LSP id of the current mismatched with the PP

    	LSP id in standby

    .. data:: te_stdbyup_no_curr_lsp = 145

    	Standby LSP up but current LSP not found

    .. data:: stdby_failed_rw = 146

    	Rewrite failed for Standby LSP

    .. data:: reopt_lsp_tear_ppsw = 147

    	Reopt LSP teardown because of path protection

    	switchover

    .. data:: delay_pp_lsp_tear_ppsw = 148

    	Delay PP LSP teardown on rew results of path

    	protection switchover

    .. data:: stdby_failed_verify = 149

    	Stdby LSP failed verification

    .. data:: stdby_not_needed_due_to_restore = 150

    	Stdby is not needed since the restore LSP is

    	installed

    .. data:: restore_failed_verify = 151

    	Restore LSP failed verification

    .. data:: restore_failed_install = 152

    	Restore LSP failed at install time

    .. data:: restore_failed_rewrite = 153

    	Restore LSP failed at rewrite

    .. data:: te_ppsw_cfg_rmvd = 154

    	Path protection configuration remove under the

    	tunnel I/F

    .. data:: te_ppsw_manual_ppsw = 155

    	Manual Path protection switchover

    .. data:: te_ppsw_bidir_p_chg_ppsw = 156

    	Bidirectional Path Change protection switchover

    .. data:: te_ppsw_bidir_lockout_ppsw = 157

    	Flex LSP lockout metric protection switchover

    .. data:: dclean_at_pp_clean_timer = 158

    	Tear delayed pp clean LSP at pp cleanup timer

    	expiry

    .. data:: reopt_standby_failed = 159

    	Creating the reopt standby failed

    .. data:: standby_reoptimized = 160

    	Tear down old standby LSP because standby

    	reoptimized

    .. data:: standby_reoptimize_aborted = 161

    	Tear down new standby LSP because switchover is

    	underway

    .. data:: te_reoptup_no_curr_lsp = 162

    	Reopt LSP up but current LSP not found

    .. data:: te_reopt_curr_lsp_down = 163

    	destroying reopt as current LSP torn

    .. data:: te_cleanedt_curr_lsp_down = 164

    	Destroying cleaned as current LSP torn

    .. data:: te_delay_lsp_up = 165

    	Delay clean or pp clean LSP came up

    .. data:: no_route_due_to_affinity = 166

    	No route, no RIB due to affinity

    .. data:: no_rib_lkup_bad_ero_gmpls = 167

    	Skipping RIB Lookup, Bad GMPLS ERO

    .. data:: cleanup_lingering = 168

    	Cleanup in lingering state

    .. data:: te_s2l_del_sc_soft_preemption_timeout = 169

    	Soft preemption timed out

    .. data:: te_s2l_del_sc_soft_preempted_non_current = 170

    	The head S2L was soft preempted while it is not

    	current

    .. data:: te_s2l_del_sc_vif_sync_lsp_del = 171

    	The head S2L was deleted due to LSP deleted in

    	VIF Sync

    .. data:: rsvp_api_cleanup_req = 172

    	RSVP API cleanup requested

    .. data:: te_s2l_del_sc_frr_wrong_backup = 173

    	TE and RSVP FRR active on different backups

    .. data:: te_s2l_del_sc_bfd_session_create_failed = 174

    	The BFD session create failed

    .. data:: te_s2l_del_sc_bfd_session_bringup_timeout = 175

    	The BFD session failed to up before bringup

    	timer timeout

    .. data:: te_s2l_del_sc_bfd_session_down = 176

    	The BFD session went down

    .. data:: te_s2l_del_sc_bfd_session_not_replayed = 177

    	BFD did not replay the session

    .. data:: te_s2l_del_sc_reopt_p2mp_egress_info_fail = 178

    	P2MP egress information programming failed for

    	reoptimized LSP

    .. data:: non_curr_frr_lcl_notif_event = 179

    	FRR local notification event on non-current LSP

    .. data:: unsupported_encoding = 180

    	The encoding type is not supported

    .. data:: unsupported_gpid = 181

    	The GPID is not supported

    .. data:: unsupported_switching_type = 182

    	The switching type is not supported

    .. data:: upstream_label_change_not_permitted = 183

    	Upstream label change is not allowed

    .. data:: encoding_type_change_not_permitted = 184

    	Encoding Type change is not allowed

    .. data:: aps_protect_info_change_failed = 185

    	Failed to process APS Protect info change

    .. data:: incorrect_lsp_type = 186

    	Incorrect or unsupported connection type

    .. data:: local_hop_error = 187

    	Failed to compute local hop

    .. data:: unsupported_gmpls_attributes = 188

    	Incorrect or unsupported GMPLS attributes

    .. data:: gmpls_uni_reopt_triggered = 189

    	GMPLS-UNI reoptimization triggered from network

    .. data:: maximum_acceptable_label_retries = 190

    	Maxed out acceptable upstream label retries

    .. data:: invalid_direction = 191

    	Invalid direction for GMPLS LSP

    .. data:: invalid_rewrite_context = 192

    	Invalid RW context in callback

    .. data:: invalid_label_context = 193

    	Invalid Label context in callback

    .. data:: dwdm_capability_changed = 194

    	DWDM Capability for TE link changed

    .. data:: dwdm_capability_removed = 195

    	DWDM Capability for TE link removed

    .. data:: dwdm_wavelength_removed = 196

    	DWDM wavelength channel attribute for TE link

    	removed

    .. data:: gmpls_uni_multilayer_restoration = 197

    	GMPLS-UNI multilayer restoration

    .. data:: gmpls_uni_user_triggered_reoptimization = 198

    	User-triggered GMPLS-UNI reoptimization

    .. data:: gmpls_uni_active_path_change_triggered_reopt = 199

    	GMPLS-UNI reoptimization triggered by Active

    	Path change

    .. data:: passive_match_err = 200

    	Failed in finding a matching passive vif

    .. data:: egress_control_err = 201

    	Failed in egress control

    .. data:: egress_control_map_err = 202

    	Could not resolve egress control

    .. data:: restore_not_needed_for_current = 203

    	Restore not needed now for current LSP

    .. data:: restore_not_needed_for_standby = 204

    	Restore not needed now for standby LSP

    .. data:: restore_dp_down = 205

    	Restore down in data plane

    .. data:: current_not_needed_dp_down = 206

    	Current not needed now as down in data plane

    .. data:: bad_protct_obj = 207

    	Bad protection object

    .. data:: optical_link_down = 208

    	TE optical link down

    .. data:: optical_link_lsp_out_of_sync = 209

    	TE optical link and LSP out of sync

    .. data:: optical_link_owner_out_of_sync = 210

    	TE optical link owner type out of sync

    .. data:: optical_link_interface_handle_out_of_sync = 211

    	TE optical link interface handle out of sync

    .. data:: optical_link_hop_out_of_sync = 212

    	TE optical link next/prev hop out of sync

    .. data:: optical_link_role_out_of_sync = 213

    	TE optical link role out of sync

    .. data:: optical_link_downstream_router_id_out_of_sync = 214

    	TE optical link downstream router-ID out of

    	sync

    .. data:: optical_link_upstream_router_id_out_of_sync = 215

    	TE optical link upstream router-ID out of sync

    .. data:: optical_link_encoding_type_out_of_sync = 216

    	TE optical link encoding type out of sync

    .. data:: optical_link_switching_type_out_of_sync = 217

    	TE optical link switching type out of sync

    .. data:: optical_link_gpid_out_of_sync = 218

    	TE optical link GPID out of sync

    .. data:: egress_optical_link_not_found = 219

    	Egress optical TE link (head) not found

    .. data:: ingress_optical_link_not_found = 220

    	Ingress optical TE link (tail) not found

    .. data:: sync_dest_state = 221

    	Syncing of the destination state change

    .. data:: prot_object_err = 222

    	Protection Object Error

    .. data:: reverse_s2l_deleted = 223

    	Reverse Associated S2L Deleted

    .. data:: cancel_inprogress_by_slave = 224

    	In-progress S2L cancelled by slave

    .. data:: invalid_reverse_ero = 225

    	Bad Reverse ERO

    .. data:: reverse_lsp_not_found = 226

    	Switchover Reverse LSP Not Found

    .. data:: reverse_lsp_not_present = 227

    	Switchover Reverse LSP Not Present

    .. data:: associated_vif_down = 228

    	Associated VIF moved to Down

    .. data:: vif_sync_processing = 229

    	Tunnel interface sync processing caused

    	deletion

    .. data:: incoming_interface_lockout = 230

    	Incoming interface locked out

    .. data:: sr_egress_path_changed = 231

    	SR egress path changed on non-current S2L

    .. data:: in_if_fail_imp_null_cfg_ch = 232

    	Implicit null config changed

    .. data:: reverse_lsp_failure = 233

    	Reverse LSP Failure

    .. data:: lsp_wrap_label_error = 234

    	LSP Wrap Label Error

    .. data:: lsp_wrap_rewrite_error = 235

    	LSP Wrap Rewrite Error

    .. data:: transit_lsp_out_of_resources = 236

    	LSP OOR

    .. data:: fsm_sc_must_be_last = 237

    	Not used, must be last entry

    """

    no_subcause = Enum.YLeaf(0, "no-subcause")

    cleanup_req = Enum.YLeaf(1, "cleanup-req")

    invalid_data = Enum.YLeaf(2, "invalid-data")

    fsm_inv_ctxt = Enum.YLeaf(3, "fsm-inv-ctxt")

    fsm_inv_ctxt_data = Enum.YLeaf(4, "fsm-inv-ctxt-data")

    fsm_inv_role = Enum.YLeaf(5, "fsm-inv-role")

    ll_failure = Enum.YLeaf(6, "ll-failure")

    ll_rel_fail = Enum.YLeaf(7, "ll-rel-fail")

    ll_mismatch = Enum.YLeaf(8, "ll-mismatch")

    ll_invalid = Enum.YLeaf(9, "ll-invalid")

    ll_set_failure = Enum.YLeaf(10, "ll-set-failure")

    bad_out_label = Enum.YLeaf(11, "bad-out-label")

    sl_err = Enum.YLeaf(12, "sl-err")

    rl_mismatch = Enum.YLeaf(13, "rl-mismatch")

    sl_alloc_err = Enum.YLeaf(14, "sl-alloc-err")

    upstream_downstream_label_mismatch = Enum.YLeaf(15, "upstream-downstream-label-mismatch")

    upstream_label_failure = Enum.YLeaf(16, "upstream-label-failure")

    upstream_label_rel_fail = Enum.YLeaf(17, "upstream-label-rel-fail")

    upstream_label_mismatch = Enum.YLeaf(18, "upstream-label-mismatch")

    upstream_label_invalid = Enum.YLeaf(19, "upstream-label-invalid")

    bad_upstream_label = Enum.YLeaf(20, "bad-upstream-label")

    ul_set_failure = Enum.YLeaf(21, "ul-set-failure")

    gmpls_label_alloc_err = Enum.YLeaf(22, "gmpls-label-alloc-err")

    gmpls_label_clone_err = Enum.YLeaf(23, "gmpls-label-clone-err")

    rw_err = Enum.YLeaf(24, "rw-err")

    up_rw_err = Enum.YLeaf(25, "up-rw-err")

    path_admit = Enum.YLeaf(26, "path-admit")

    bw = Enum.YLeaf(27, "bw")

    admit_resv = Enum.YLeaf(28, "admit-resv")

    rrrm_err = Enum.YLeaf(29, "rrrm-err")

    hardware_out_of_resources = Enum.YLeaf(30, "hardware-out-of-resources")

    comp_rid = Enum.YLeaf(31, "comp-rid")

    comp_lcl_rid = Enum.YLeaf(32, "comp-lcl-rid")

    comp_up_rid = Enum.YLeaf(33, "comp-up-rid")

    comp_down_rid = Enum.YLeaf(34, "comp-down-rid")

    rest_if_hop = Enum.YLeaf(35, "rest-if-hop")

    inv_in_if = Enum.YLeaf(36, "inv-in-if")

    nh_err = Enum.YLeaf(37, "nh-err")

    inv_in_ero = Enum.YLeaf(38, "inv-in-ero")

    out_ero_fail = Enum.YLeaf(39, "out-ero-fail")

    frr_bk_asssign = Enum.YLeaf(40, "frr-bk-asssign")

    frr_bk_rm = Enum.YLeaf(41, "frr-bk-rm")

    frr_bk_send = Enum.YLeaf(42, "frr-bk-send")

    frr_needs_del = Enum.YLeaf(43, "frr-needs-del")

    frr_reopt_lsp = Enum.YLeaf(44, "frr-reopt-lsp")

    rsvp_api_h = Enum.YLeaf(45, "rsvp-api-h")

    insane_path = Enum.YLeaf(46, "insane-path")

    remerge_chk_fail = Enum.YLeaf(47, "remerge-chk-fail")

    remerge_detected = Enum.YLeaf(48, "remerge-detected")

    xro = Enum.YLeaf(49, "xro")

    resv_bw_set = Enum.YLeaf(50, "resv-bw-set")

    resv_prep_fail = Enum.YLeaf(51, "resv-prep-fail")

    path_ch_proc = Enum.YLeaf(52, "path-ch-proc")

    path_ch_frr = Enum.YLeaf(53, "path-ch-frr")

    path_ch_sess_attri_fl = Enum.YLeaf(54, "path-ch-sess-attri-fl")

    path_ch_bw_ch = Enum.YLeaf(55, "path-ch-bw-ch")

    path_err_proc = Enum.YLeaf(56, "path-err-proc")

    path_err = Enum.YLeaf(57, "path-err")

    path_err_wpsr = Enum.YLeaf(58, "path-err-wpsr")

    path_del = Enum.YLeaf(59, "path-del")

    resv_ch_proc = Enum.YLeaf(60, "resv-ch-proc")

    resv_ch_rro = Enum.YLeaf(61, "resv-ch-rro")

    resv_del = Enum.YLeaf(62, "resv-del")

    resv_err = Enum.YLeaf(63, "resv-err")

    perr_send_fail = Enum.YLeaf(64, "perr-send-fail")

    perr_proc_fail = Enum.YLeaf(65, "perr-proc-fail")

    perr_rcv = Enum.YLeaf(66, "perr-rcv")

    resv_err_rcv = Enum.YLeaf(67, "resv-err-rcv")

    flowspec = Enum.YLeaf(68, "flowspec")

    setup_conn_api_fail = Enum.YLeaf(69, "setup-conn-api-fail")

    path_not_replayed = Enum.YLeaf(70, "path-not-replayed")

    resv_not_replayed = Enum.YLeaf(71, "resv-not-replayed")

    rewrite_not_replayed = Enum.YLeaf(72, "rewrite-not-replayed")

    label_not_replayed = Enum.YLeaf(73, "label-not-replayed")

    connection_not_ready = Enum.YLeaf(74, "connection-not-ready")

    master_did_not_replay = Enum.YLeaf(75, "master-did-not-replay")

    head_s2l_has_no_vif = Enum.YLeaf(76, "head-s2l-has-no-vif")

    frr_assigned_s2l_has_no_backup = Enum.YLeaf(77, "frr-assigned-s2l-has-no-backup")

    frr_assigned_s2l_has_down_backup = Enum.YLeaf(78, "frr-assigned-s2l-has-down-backup")

    out_link_down_and_no_frr = Enum.YLeaf(79, "out-link-down-and-no-frr")

    collaborator_timeout_rsvp = Enum.YLeaf(80, "collaborator-timeout-rsvp")

    collaborator_timeout_lsd = Enum.YLeaf(81, "collaborator-timeout-lsd")

    collaborator_timeout_lmrib = Enum.YLeaf(82, "collaborator-timeout-lmrib")

    collaborator_timeout_im = Enum.YLeaf(83, "collaborator-timeout-im")

    collaborator_timeout_error = Enum.YLeaf(84, "collaborator-timeout-error")

    topo_flush = Enum.YLeaf(85, "topo-flush")

    area_shut = Enum.YLeaf(86, "area-shut")

    active_po_del = Enum.YLeaf(87, "active-po-del")

    path_verify_failed = Enum.YLeaf(88, "path-verify-failed")

    srlg_path_verify_failed = Enum.YLeaf(89, "srlg-path-verify-failed")

    affinity_path_verify_failed = Enum.YLeaf(90, "affinity-path-verify-failed")

    aff_fail_delayed_tear_timeout_failed = Enum.YLeaf(91, "aff-fail-delayed-tear-timeout-failed")

    cost_limit_verify_failed = Enum.YLeaf(92, "cost-limit-verify-failed")

    path_setup_timeout = Enum.YLeaf(93, "path-setup-timeout")

    vif_destroyed = Enum.YLeaf(94, "vif-destroyed")

    vif_shut = Enum.YLeaf(95, "vif-shut")

    lsp_shut = Enum.YLeaf(96, "lsp-shut")

    gmpls_uni_head = Enum.YLeaf(97, "gmpls-uni-head")

    head_resetup = Enum.YLeaf(98, "head-resetup")

    none_head_resetup = Enum.YLeaf(99, "none-head-resetup")

    dest_disabled = Enum.YLeaf(100, "dest-disabled")

    iep_ch_act_po = Enum.YLeaf(101, "iep-ch-act-po")

    iep_ch_reopt = Enum.YLeaf(102, "iep-ch-reopt")

    iep_ch_standby = Enum.YLeaf(103, "iep-ch-standby")

    dste_mode_ch = Enum.YLeaf(104, "dste-mode-ch")

    reopt_del_frr_act = Enum.YLeaf(105, "reopt-del-frr-act")

    new_reopt_tear_old = Enum.YLeaf(106, "new-reopt-tear-old")

    reopt_failed_verify = Enum.YLeaf(107, "reopt-failed-verify")

    reopt_failed_install = Enum.YLeaf(108, "reopt-failed-install")

    reopt_failed_rw = Enum.YLeaf(109, "reopt-failed-rw")

    reopt_failed_not_superset = Enum.YLeaf(110, "reopt-failed-not-superset")

    dclean_at_install_time = Enum.YLeaf(111, "dclean-at-install-time")

    dclean_at_clean_timer = Enum.YLeaf(112, "dclean-at-clean-timer")

    dclean_at_reopt_active = Enum.YLeaf(113, "dclean-at-reopt-active")

    lcl_notif_head = Enum.YLeaf(114, "lcl-notif-head")

    in_if_fail = Enum.YLeaf(115, "in-if-fail")

    out_if_fail = Enum.YLeaf(116, "out-if-fail")

    if_fail_lc_oir = Enum.YLeaf(117, "if-fail-lc-oir")

    te_rid_rm = Enum.YLeaf(118, "te-rid-rm")

    te_rsvp_oos_bkup = Enum.YLeaf(119, "te-rsvp-oos-bkup")

    in_if_fail_exp_null_cfg_ch = Enum.YLeaf(120, "in-if-fail-exp-null-cfg-ch")

    new_curr_lsp_sig = Enum.YLeaf(121, "new-curr-lsp-sig")

    new_reopt_lsp_sig = Enum.YLeaf(122, "new-reopt-lsp-sig")

    new_stdby_lsp_sig = Enum.YLeaf(123, "new-stdby-lsp-sig")

    new_restore_lsp_sig = Enum.YLeaf(124, "new-restore-lsp-sig")

    new_cl_pp_lsp_sig = Enum.YLeaf(125, "new-cl-pp-lsp-sig")

    chkpt_recovery_failed = Enum.YLeaf(126, "chkpt-recovery-failed")

    stdby_cr_failed = Enum.YLeaf(127, "stdby-cr-failed")

    reopt_lsp_rej = Enum.YLeaf(128, "reopt-lsp-rej")

    reopt_po_sw_failed = Enum.YLeaf(129, "reopt-po-sw-failed")

    failed_to_find_path = Enum.YLeaf(130, "failed-to-find-path")

    sig_rcv_fail_path_cr_ch = Enum.YLeaf(131, "sig-rcv-fail-path-cr-ch")

    lsp_db_shut = Enum.YLeaf(132, "lsp-db-shut")

    reopt_hold_start = Enum.YLeaf(133, "reopt-hold-start")

    vif_lspid_mismatch = Enum.YLeaf(134, "vif-lspid-mismatch")

    s2l_has_no_vif = Enum.YLeaf(135, "s2l-has-no-vif")

    overload_reopt_timeout = Enum.YLeaf(136, "overload-reopt-timeout")

    hop_limit_exceeded = Enum.YLeaf(137, "hop-limit-exceeded")

    lingering_current_lsp = Enum.YLeaf(138, "lingering-current-lsp")

    lingering_standby_lsp = Enum.YLeaf(139, "lingering-standby-lsp")

    lingering_restore_lsp = Enum.YLeaf(140, "lingering-restore-lsp")

    double_lockout = Enum.YLeaf(141, "double-lockout")

    lockout_no_protection = Enum.YLeaf(142, "lockout-no-protection")

    lockout_cleanup = Enum.YLeaf(143, "lockout-cleanup")

    te_ppsw_lsp_mismatch = Enum.YLeaf(144, "te-ppsw-lsp-mismatch")

    te_stdbyup_no_curr_lsp = Enum.YLeaf(145, "te-stdbyup-no-curr-lsp")

    stdby_failed_rw = Enum.YLeaf(146, "stdby-failed-rw")

    reopt_lsp_tear_ppsw = Enum.YLeaf(147, "reopt-lsp-tear-ppsw")

    delay_pp_lsp_tear_ppsw = Enum.YLeaf(148, "delay-pp-lsp-tear-ppsw")

    stdby_failed_verify = Enum.YLeaf(149, "stdby-failed-verify")

    stdby_not_needed_due_to_restore = Enum.YLeaf(150, "stdby-not-needed-due-to-restore")

    restore_failed_verify = Enum.YLeaf(151, "restore-failed-verify")

    restore_failed_install = Enum.YLeaf(152, "restore-failed-install")

    restore_failed_rewrite = Enum.YLeaf(153, "restore-failed-rewrite")

    te_ppsw_cfg_rmvd = Enum.YLeaf(154, "te-ppsw-cfg-rmvd")

    te_ppsw_manual_ppsw = Enum.YLeaf(155, "te-ppsw-manual-ppsw")

    te_ppsw_bidir_p_chg_ppsw = Enum.YLeaf(156, "te-ppsw-bidir-p-chg-ppsw")

    te_ppsw_bidir_lockout_ppsw = Enum.YLeaf(157, "te-ppsw-bidir-lockout-ppsw")

    dclean_at_pp_clean_timer = Enum.YLeaf(158, "dclean-at-pp-clean-timer")

    reopt_standby_failed = Enum.YLeaf(159, "reopt-standby-failed")

    standby_reoptimized = Enum.YLeaf(160, "standby-reoptimized")

    standby_reoptimize_aborted = Enum.YLeaf(161, "standby-reoptimize-aborted")

    te_reoptup_no_curr_lsp = Enum.YLeaf(162, "te-reoptup-no-curr-lsp")

    te_reopt_curr_lsp_down = Enum.YLeaf(163, "te-reopt-curr-lsp-down")

    te_cleanedt_curr_lsp_down = Enum.YLeaf(164, "te-cleanedt-curr-lsp-down")

    te_delay_lsp_up = Enum.YLeaf(165, "te-delay-lsp-up")

    no_route_due_to_affinity = Enum.YLeaf(166, "no-route-due-to-affinity")

    no_rib_lkup_bad_ero_gmpls = Enum.YLeaf(167, "no-rib-lkup-bad-ero-gmpls")

    cleanup_lingering = Enum.YLeaf(168, "cleanup-lingering")

    te_s2l_del_sc_soft_preemption_timeout = Enum.YLeaf(169, "te-s2l-del-sc-soft-preemption-timeout")

    te_s2l_del_sc_soft_preempted_non_current = Enum.YLeaf(170, "te-s2l-del-sc-soft-preempted-non-current")

    te_s2l_del_sc_vif_sync_lsp_del = Enum.YLeaf(171, "te-s2l-del-sc-vif-sync-lsp-del")

    rsvp_api_cleanup_req = Enum.YLeaf(172, "rsvp-api-cleanup-req")

    te_s2l_del_sc_frr_wrong_backup = Enum.YLeaf(173, "te-s2l-del-sc-frr-wrong-backup")

    te_s2l_del_sc_bfd_session_create_failed = Enum.YLeaf(174, "te-s2l-del-sc-bfd-session-create-failed")

    te_s2l_del_sc_bfd_session_bringup_timeout = Enum.YLeaf(175, "te-s2l-del-sc-bfd-session-bringup-timeout")

    te_s2l_del_sc_bfd_session_down = Enum.YLeaf(176, "te-s2l-del-sc-bfd-session-down")

    te_s2l_del_sc_bfd_session_not_replayed = Enum.YLeaf(177, "te-s2l-del-sc-bfd-session-not-replayed")

    te_s2l_del_sc_reopt_p2mp_egress_info_fail = Enum.YLeaf(178, "te-s2l-del-sc-reopt-p2mp-egress-info-fail")

    non_curr_frr_lcl_notif_event = Enum.YLeaf(179, "non-curr-frr-lcl-notif-event")

    unsupported_encoding = Enum.YLeaf(180, "unsupported-encoding")

    unsupported_gpid = Enum.YLeaf(181, "unsupported-gpid")

    unsupported_switching_type = Enum.YLeaf(182, "unsupported-switching-type")

    upstream_label_change_not_permitted = Enum.YLeaf(183, "upstream-label-change-not-permitted")

    encoding_type_change_not_permitted = Enum.YLeaf(184, "encoding-type-change-not-permitted")

    aps_protect_info_change_failed = Enum.YLeaf(185, "aps-protect-info-change-failed")

    incorrect_lsp_type = Enum.YLeaf(186, "incorrect-lsp-type")

    local_hop_error = Enum.YLeaf(187, "local-hop-error")

    unsupported_gmpls_attributes = Enum.YLeaf(188, "unsupported-gmpls-attributes")

    gmpls_uni_reopt_triggered = Enum.YLeaf(189, "gmpls-uni-reopt-triggered")

    maximum_acceptable_label_retries = Enum.YLeaf(190, "maximum-acceptable-label-retries")

    invalid_direction = Enum.YLeaf(191, "invalid-direction")

    invalid_rewrite_context = Enum.YLeaf(192, "invalid-rewrite-context")

    invalid_label_context = Enum.YLeaf(193, "invalid-label-context")

    dwdm_capability_changed = Enum.YLeaf(194, "dwdm-capability-changed")

    dwdm_capability_removed = Enum.YLeaf(195, "dwdm-capability-removed")

    dwdm_wavelength_removed = Enum.YLeaf(196, "dwdm-wavelength-removed")

    gmpls_uni_multilayer_restoration = Enum.YLeaf(197, "gmpls-uni-multilayer-restoration")

    gmpls_uni_user_triggered_reoptimization = Enum.YLeaf(198, "gmpls-uni-user-triggered-reoptimization")

    gmpls_uni_active_path_change_triggered_reopt = Enum.YLeaf(199, "gmpls-uni-active-path-change-triggered-reopt")

    passive_match_err = Enum.YLeaf(200, "passive-match-err")

    egress_control_err = Enum.YLeaf(201, "egress-control-err")

    egress_control_map_err = Enum.YLeaf(202, "egress-control-map-err")

    restore_not_needed_for_current = Enum.YLeaf(203, "restore-not-needed-for-current")

    restore_not_needed_for_standby = Enum.YLeaf(204, "restore-not-needed-for-standby")

    restore_dp_down = Enum.YLeaf(205, "restore-dp-down")

    current_not_needed_dp_down = Enum.YLeaf(206, "current-not-needed-dp-down")

    bad_protct_obj = Enum.YLeaf(207, "bad-protct-obj")

    optical_link_down = Enum.YLeaf(208, "optical-link-down")

    optical_link_lsp_out_of_sync = Enum.YLeaf(209, "optical-link-lsp-out-of-sync")

    optical_link_owner_out_of_sync = Enum.YLeaf(210, "optical-link-owner-out-of-sync")

    optical_link_interface_handle_out_of_sync = Enum.YLeaf(211, "optical-link-interface-handle-out-of-sync")

    optical_link_hop_out_of_sync = Enum.YLeaf(212, "optical-link-hop-out-of-sync")

    optical_link_role_out_of_sync = Enum.YLeaf(213, "optical-link-role-out-of-sync")

    optical_link_downstream_router_id_out_of_sync = Enum.YLeaf(214, "optical-link-downstream-router-id-out-of-sync")

    optical_link_upstream_router_id_out_of_sync = Enum.YLeaf(215, "optical-link-upstream-router-id-out-of-sync")

    optical_link_encoding_type_out_of_sync = Enum.YLeaf(216, "optical-link-encoding-type-out-of-sync")

    optical_link_switching_type_out_of_sync = Enum.YLeaf(217, "optical-link-switching-type-out-of-sync")

    optical_link_gpid_out_of_sync = Enum.YLeaf(218, "optical-link-gpid-out-of-sync")

    egress_optical_link_not_found = Enum.YLeaf(219, "egress-optical-link-not-found")

    ingress_optical_link_not_found = Enum.YLeaf(220, "ingress-optical-link-not-found")

    sync_dest_state = Enum.YLeaf(221, "sync-dest-state")

    prot_object_err = Enum.YLeaf(222, "prot-object-err")

    reverse_s2l_deleted = Enum.YLeaf(223, "reverse-s2l-deleted")

    cancel_inprogress_by_slave = Enum.YLeaf(224, "cancel-inprogress-by-slave")

    invalid_reverse_ero = Enum.YLeaf(225, "invalid-reverse-ero")

    reverse_lsp_not_found = Enum.YLeaf(226, "reverse-lsp-not-found")

    reverse_lsp_not_present = Enum.YLeaf(227, "reverse-lsp-not-present")

    associated_vif_down = Enum.YLeaf(228, "associated-vif-down")

    vif_sync_processing = Enum.YLeaf(229, "vif-sync-processing")

    incoming_interface_lockout = Enum.YLeaf(230, "incoming-interface-lockout")

    sr_egress_path_changed = Enum.YLeaf(231, "sr-egress-path-changed")

    in_if_fail_imp_null_cfg_ch = Enum.YLeaf(232, "in-if-fail-imp-null-cfg-ch")

    reverse_lsp_failure = Enum.YLeaf(233, "reverse-lsp-failure")

    lsp_wrap_label_error = Enum.YLeaf(234, "lsp-wrap-label-error")

    lsp_wrap_rewrite_error = Enum.YLeaf(235, "lsp-wrap-rewrite-error")

    transit_lsp_out_of_resources = Enum.YLeaf(236, "transit-lsp-out-of-resources")

    fsm_sc_must_be_last = Enum.YLeaf(237, "fsm-sc-must-be-last")


class TePathInvalAction(Enum):
    """
    TePathInvalAction

    Path selection invalidation action type

    .. data:: none = 0

    	TE path selection invalidation action none

    .. data:: tear = 1

    	TE path selection invalidation action tear

    .. data:: drop = 2

    	TE path selection invalidation action drop

    """

    none = Enum.YLeaf(0, "none")

    tear = Enum.YLeaf(1, "tear")

    drop = Enum.YLeaf(2, "drop")


class TePathProtProfile(Enum):
    """
    TePathProtProfile

    Path Protection Profile Type

    .. data:: path_prot_profile_type1_plus0 = 0

    	TE Path Option 1PLUS0

    .. data:: path_prot_profile_type1_plus_r = 1

    	TE Path Option 1PLUSR

    .. data:: path_prot_profile_type1_plus1 = 16

    	TE Path Option 1PLUS1

    .. data:: path_prot_profile_type1_plus1_plus_r = 32

    	TE Path Option 1PLUS1PLUSR

    .. data:: path_prot_profile_type_invalid = 255

    	TE Path Option Invalid

    """

    path_prot_profile_type1_plus0 = Enum.YLeaf(0, "path-prot-profile-type1-plus0")

    path_prot_profile_type1_plus_r = Enum.YLeaf(1, "path-prot-profile-type1-plus-r")

    path_prot_profile_type1_plus1 = Enum.YLeaf(16, "path-prot-profile-type1-plus1")

    path_prot_profile_type1_plus1_plus_r = Enum.YLeaf(32, "path-prot-profile-type1-plus1-plus-r")

    path_prot_profile_type_invalid = Enum.YLeaf(255, "path-prot-profile-type-invalid")


class TePathSelectionTiebreaker(Enum):
    """
    TePathSelectionTiebreaker

    Path selection tiebreaker type

    .. data:: min_fill = 1

    	Min Fill

    .. data:: max_fill = 2

    	Max Fill

    .. data:: random = 3

    	Random

    """

    min_fill = Enum.YLeaf(1, "min-fill")

    max_fill = Enum.YLeaf(2, "max-fill")

    random = Enum.YLeaf(3, "random")


class TePceDisjoint(Enum):
    """
    TePceDisjoint

    PCE Disjoint Path type

    .. data:: none = 0

    	PCE Disjoint Type none

    .. data:: link = 1

    	PCE Disjoint Type link

    .. data:: node = 2

    	PCE Disjoint Type node

    .. data:: srlg = 3

    	PCE Disjoint Type srlg

    """

    none = Enum.YLeaf(0, "none")

    link = Enum.YLeaf(1, "link")

    node = Enum.YLeaf(2, "node")

    srlg = Enum.YLeaf(3, "srlg")


class TePnrRevertOptions(Enum):
    """
    TePnrRevertOptions

    PNR Options

    .. data:: pnr_optionnot_set = 0

    	TE Protection Restore Option Not Set

    .. data:: pnr_option_revertive = 1

    	TE Protection Restore Option Revertive

    .. data:: pnr_option_non_revertive = 2

    	TE Protection Restore Option Non-revertive

    """

    pnr_optionnot_set = Enum.YLeaf(0, "pnr-optionnot-set")

    pnr_option_revertive = Enum.YLeaf(1, "pnr-option-revertive")

    pnr_option_non_revertive = Enum.YLeaf(2, "pnr-option-non-revertive")


class TePpDiversity(Enum):
    """
    TePpDiversity

    Diversity of Protection or Restoration Path from

    Protected Path

    .. data:: diversity_none = 0

    	Standby LSP not diverse

    .. data:: link = 1

    	Standby LSP link diverse

    .. data:: node = 2

    	Standby LSP node diverse

    .. data:: node_link = 3

    	Standby LSP node and link diverse

    .. data:: srlg = 4

    	Standby SRLG diverse

    .. data:: diversity_user = 5

    	Standby LSP using user defined explicit path

    .. data:: diversity_reverse_ero = 6

    	Standby LSP using Reverse ERO

    """

    diversity_none = Enum.YLeaf(0, "diversity-none")

    link = Enum.YLeaf(1, "link")

    node = Enum.YLeaf(2, "node")

    node_link = Enum.YLeaf(3, "node-link")

    srlg = Enum.YLeaf(4, "srlg")

    diversity_user = Enum.YLeaf(5, "diversity-user")

    diversity_reverse_ero = Enum.YLeaf(6, "diversity-reverse-ero")


class TeProcRole(Enum):
    """
    TeProcRole

    TE Process Role

    .. data:: unknown = 0

    	Unknown

    .. data:: v1_active = 1

    	V1 Active

    .. data:: v2_active = 2

    	V2 Active

    .. data:: v1_standby = 3

    	V1 Standby

    .. data:: v2_standby = 4

    	V2 Standby

    .. data:: v1_active_post_big_bang = 5

    	V1 Active post big bang

    .. data:: v1_standby_post_big_bang = 6

    	V1 Standby post big bang

    .. data:: number_of_role = 7

    	Number of role

    """

    unknown = Enum.YLeaf(0, "unknown")

    v1_active = Enum.YLeaf(1, "v1-active")

    v2_active = Enum.YLeaf(2, "v2-active")

    v1_standby = Enum.YLeaf(3, "v1-standby")

    v2_standby = Enum.YLeaf(4, "v2-standby")

    v1_active_post_big_bang = Enum.YLeaf(5, "v1-active-post-big-bang")

    v1_standby_post_big_bang = Enum.YLeaf(6, "v1-standby-post-big-bang")

    number_of_role = Enum.YLeaf(7, "number-of-role")


class TeProtect(Enum):
    """
    TeProtect

    Protection Types

    .. data:: protect_type1_plus1_unidir_no_aps = 4

    	Protection Type Uni-directional No APS

    .. data:: protect_type1_plus1_unidir_aps = 8

    	Protection Type Uni-directional APS

    .. data:: protect_type1_plus1_bidir_aps = 16

    	Protection Type Bi-directional APS

    .. data:: protect_type_not_set = 255

    	Protection Type Not Set

    """

    protect_type1_plus1_unidir_no_aps = Enum.YLeaf(4, "protect-type1-plus1-unidir-no-aps")

    protect_type1_plus1_unidir_aps = Enum.YLeaf(8, "protect-type1-plus1-unidir-aps")

    protect_type1_plus1_bidir_aps = Enum.YLeaf(16, "protect-type1-plus1-bidir-aps")

    protect_type_not_set = Enum.YLeaf(255, "protect-type-not-set")


class TeRestorationStyle(Enum):
    """
    TeRestorationStyle

    PNR Options

    .. data:: restoration_style_not_set = 0

    	TE Restoration Style Not Set

    .. data:: restoration_style_keep_failed_lsp = 1

    	TE Restoration Style is to Keep Failed Lsp

    .. data:: restoration_style_delete_failed_lsp = 2

    	TE Restoration Style is to Delete Failed Lsp

    """

    restoration_style_not_set = Enum.YLeaf(0, "restoration-style-not-set")

    restoration_style_keep_failed_lsp = Enum.YLeaf(1, "restoration-style-keep-failed-lsp")

    restoration_style_delete_failed_lsp = Enum.YLeaf(2, "restoration-style-delete-failed-lsp")


class TeRevEroRejectReasons(Enum):
    """
    TeRevEroRejectReasons

    TE Reverse ERO Reject Reasons

    .. data:: none = 0

    	None

    .. data:: bad_reverse_ero = 1

    	Bad Reverse ERO

    .. data:: tie_rejected = 2

    	Tie Rejected

    .. data:: standby_not_required = 3

    	Standby Not Required

    .. data:: admin_state = 4

    	Admin State

    .. data:: priority = 5

    	Priority

    .. data:: class_type = 6

    	Class Type

    .. data:: bad_association = 7

    	Bad Associated Tunnel

    """

    none = Enum.YLeaf(0, "none")

    bad_reverse_ero = Enum.YLeaf(1, "bad-reverse-ero")

    tie_rejected = Enum.YLeaf(2, "tie-rejected")

    standby_not_required = Enum.YLeaf(3, "standby-not-required")

    admin_state = Enum.YLeaf(4, "admin-state")

    priority = Enum.YLeaf(5, "priority")

    class_type = Enum.YLeaf(6, "class-type")

    bad_association = Enum.YLeaf(7, "bad-association")


class TeS2LOutputRwExplicitNull(Enum):
    """
    TeS2LOutputRwExplicitNull

    Explicit\-null type

    .. data:: tes2l_output_rw_exp_null = 0

    	No explicit null imposed

    .. data:: tes2l_output_rw_exp_null_v4 = 1

    	IPv4 explicit null imposed

    .. data:: tes2l_output_rw_exp_null_v6 = 2

    	IPv6 explicit null imposed

    """

    tes2l_output_rw_exp_null = Enum.YLeaf(0, "tes2l-output-rw-exp-null")

    tes2l_output_rw_exp_null_v4 = Enum.YLeaf(1, "tes2l-output-rw-exp-null-v4")

    tes2l_output_rw_exp_null_v6 = Enum.YLeaf(2, "tes2l-output-rw-exp-null-v6")


class TeS2LSrPathSelection(Enum):
    """
    TeS2LSrPathSelection

    Segment\-routing path selection type

    .. data:: te_s2l_sr_path_selection_any = 0

    	TE S2L Segment-Routing Path Selection type Any

    .. data:: te_s2l_sr_path_selection_adj_unprotected = 1

    	TE S2L Segment-Routing Path Selection type

    	Adjacency Unprotected

    .. data:: te_s2l_sr_path_selection_adj_protected = 2

    	TE S2L Segment-Routing Path Selection type

    	Adjacency Protected

    """

    te_s2l_sr_path_selection_any = Enum.YLeaf(0, "te-s2l-sr-path-selection-any")

    te_s2l_sr_path_selection_adj_unprotected = Enum.YLeaf(1, "te-s2l-sr-path-selection-adj-unprotected")

    te_s2l_sr_path_selection_adj_protected = Enum.YLeaf(2, "te-s2l-sr-path-selection-adj-protected")


class TeSchFreq(Enum):
    """
    TeSchFreq

    Te sch freq

    .. data:: sch_freq_not_set = 0

    	Schedule reversion frequency not set

    .. data:: sch_freq_set_once = 1

    	Schedule reversion frequency set only once

    .. data:: sch_freq_set_daily = 2

    	Schedule reversion frequency set daily

    .. data:: sch_freq_set_weekly = 3

    	Schedule reversion frequency set weekly

    """

    sch_freq_not_set = Enum.YLeaf(0, "sch-freq-not-set")

    sch_freq_set_once = Enum.YLeaf(1, "sch-freq-set-once")

    sch_freq_set_daily = Enum.YLeaf(2, "sch-freq-set-daily")

    sch_freq_set_weekly = Enum.YLeaf(3, "sch-freq-set-weekly")


class TeServTunClient(Enum):
    """
    TeServTunClient

    Te serv tun client

    .. data:: te_serv_auto_tun_client_invalid = 0

    	te serv auto tun client invalid

    .. data:: te_serv_p2mp_tun_client_mvpn = 1

    	te serv p2mp tun client mvpn

    .. data:: te_serv_p2mp_tun_client_vpls = 2

    	te serv p2mp tun client vpls

    .. data:: te_serv_p2mp_tun_client_mvpn6 = 3

    	te serv p2mp tun client mvpn6

    .. data:: te_serv_p2p_tun_client_bgp = 4

    	te serv p2p tun client bgp

    .. data:: te_serv_p2p_tun_client_staticv4 = 5

    	te serv p2p tun client staticv4

    .. data:: te_serv_p2p_tun_client_staticv6 = 6

    	te serv p2p tun client staticv6

    .. data:: te_serv_p2p_tun_client_isis = 7

    	te serv p2p tun client isis

    .. data:: te_serv_p2p_tun_client_ospf = 8

    	te serv p2p tun client ospf

    .. data:: te_serv_auto_tun_client_count = 9

    	te serv auto tun client count

    """

    te_serv_auto_tun_client_invalid = Enum.YLeaf(0, "te-serv-auto-tun-client-invalid")

    te_serv_p2mp_tun_client_mvpn = Enum.YLeaf(1, "te-serv-p2mp-tun-client-mvpn")

    te_serv_p2mp_tun_client_vpls = Enum.YLeaf(2, "te-serv-p2mp-tun-client-vpls")

    te_serv_p2mp_tun_client_mvpn6 = Enum.YLeaf(3, "te-serv-p2mp-tun-client-mvpn6")

    te_serv_p2p_tun_client_bgp = Enum.YLeaf(4, "te-serv-p2p-tun-client-bgp")

    te_serv_p2p_tun_client_staticv4 = Enum.YLeaf(5, "te-serv-p2p-tun-client-staticv4")

    te_serv_p2p_tun_client_staticv6 = Enum.YLeaf(6, "te-serv-p2p-tun-client-staticv6")

    te_serv_p2p_tun_client_isis = Enum.YLeaf(7, "te-serv-p2p-tun-client-isis")

    te_serv_p2p_tun_client_ospf = Enum.YLeaf(8, "te-serv-p2p-tun-client-ospf")

    te_serv_auto_tun_client_count = Enum.YLeaf(9, "te-serv-auto-tun-client-count")


class TeSigNameAppend(Enum):
    """
    TeSigNameAppend

    Te sig name append

    .. data:: none = 0

    	Option is Not Set for appending to

    	signalled-name

    .. data:: address = 1

    	Option is to append Address to signalled-name

    .. data:: name = 2

    	Option is to append Name to signalled-name

    """

    none = Enum.YLeaf(0, "none")

    address = Enum.YLeaf(1, "address")

    name = Enum.YLeaf(2, "name")


class TeSrSid(Enum):
    """
    TeSrSid

    Segment\-Routing SID types

    .. data:: srsid_not_set = 0

    	Type not set

    .. data:: srsid_node = 1

    	Segment-Routing Node

    .. data:: srsid_adj = 2

    	Segment-Routing Link

    .. data:: srsid_unknown = 3

    	Segment-Routing Unknown

    """

    srsid_not_set = Enum.YLeaf(0, "srsid-not-set")

    srsid_node = Enum.YLeaf(1, "srsid-node")

    srsid_adj = Enum.YLeaf(2, "srsid-adj")

    srsid_unknown = Enum.YLeaf(3, "srsid-unknown")


class TeSrlgCollectRequest(Enum):
    """
    TeSrlgCollectRequest

    SRLG\-collection request machansim

    .. data:: none = 0

    	No SRLG-collection request

    .. data:: mandatory = 1

    	Mandatory SRLG-collection request

    .. data:: optional = 2

    	Optional SRLG-collection request

    """

    none = Enum.YLeaf(0, "none")

    mandatory = Enum.YLeaf(1, "mandatory")

    optional = Enum.YLeaf(2, "optional")


class TeStatsSigFilter(Enum):
    """
    TeStatsSigFilter

    TE Signaling Filter types

    .. data:: te_stat_sig_filter_vif = 0

    	te stat sig filter vif

    .. data:: te_stat_sig_filter_lsp = 1

    	te stat sig filter lsp

    """

    te_stat_sig_filter_vif = Enum.YLeaf(0, "te-stat-sig-filter-vif")

    te_stat_sig_filter_lsp = Enum.YLeaf(1, "te-stat-sig-filter-lsp")


class TeSyncNotReadyReason(Enum):
    """
    TeSyncNotReadyReason

    Te sync not ready reason

    .. data:: idt_in_progress = 0

    	IDT in progress

    .. data:: standby_not_connected = 1

    	Standby not connected

    .. data:: collaborator_disconnected = 2

    	Collaborator disconnected

    .. data:: collaborator_timeout = 3

    	Collaborator timeout

    .. data:: unknown = 4

    	Unknown

    """

    idt_in_progress = Enum.YLeaf(0, "idt-in-progress")

    standby_not_connected = Enum.YLeaf(1, "standby-not-connected")

    collaborator_disconnected = Enum.YLeaf(2, "collaborator-disconnected")

    collaborator_timeout = Enum.YLeaf(3, "collaborator-timeout")

    unknown = Enum.YLeaf(4, "unknown")


class TeSyncPendingReason(Enum):
    """
    TeSyncPendingReason

    Te sync pending reason

    .. data:: current_lspoos = 0

    	Current LSP OOS

    .. data:: reopt_lspoos = 1

    	Reopt LSP OOS

    .. data:: standby_lspoos = 2

    	Standby LSP OOS

    .. data:: standby_reopt_lspoos = 3

    	Standby Reopt LSP OOS

    .. data:: restore_lspoos = 4

    	Restore LSP OOS

    .. data:: invalid_sync_id = 5

    	Invalid internal ID

    .. data:: null_pointer = 6

    	Null pointer

    .. data:: pending_flag = 7

    	Pending flag set

    .. data:: del_from_act_flag = 8

    	Deleted by Active set

    .. data:: oos_from_act_flag = 9

    	OOS with Active set

    .. data:: unknown = 10

    	Unknown

    """

    current_lspoos = Enum.YLeaf(0, "current-lspoos")

    reopt_lspoos = Enum.YLeaf(1, "reopt-lspoos")

    standby_lspoos = Enum.YLeaf(2, "standby-lspoos")

    standby_reopt_lspoos = Enum.YLeaf(3, "standby-reopt-lspoos")

    restore_lspoos = Enum.YLeaf(4, "restore-lspoos")

    invalid_sync_id = Enum.YLeaf(5, "invalid-sync-id")

    null_pointer = Enum.YLeaf(6, "null-pointer")

    pending_flag = Enum.YLeaf(7, "pending-flag")

    del_from_act_flag = Enum.YLeaf(8, "del-from-act-flag")

    oos_from_act_flag = Enum.YLeaf(9, "oos-from-act-flag")

    unknown = Enum.YLeaf(10, "unknown")


class TeSyncStatusShow(Enum):
    """
    TeSyncStatusShow

    Te sync status show

    .. data:: master_sync_status_show = 0

    	Master sync status information

    .. data:: slave_sync_status_show = 1

    	Slave sync status information

    """

    master_sync_status_show = Enum.YLeaf(0, "master-sync-status-show")

    slave_sync_status_show = Enum.YLeaf(1, "slave-sync-status-show")


class TeTargetAddr(Enum):
    """
    TeTargetAddr

    TE Target Address Type

    .. data:: invalid_te_target_type = 0

    	Invalid TE Target Type

    .. data:: te_target_type_ipv4 = 1

    	TE Target IPv4 Type

    .. data:: te_target_type_label = 2

    	TE Target Label Type

    """

    invalid_te_target_type = Enum.YLeaf(0, "invalid-te-target-type")

    te_target_type_ipv4 = Enum.YLeaf(1, "te-target-type-ipv4")

    te_target_type_label = Enum.YLeaf(2, "te-target-type-label")


class TeVifBfd(Enum):
    """
    TeVifBfd

    BFD Type

    .. data:: bfd_disabled = 0

    	BFD Fast Detect Not Enabled

    .. data:: bfd_enabled = 1

    	Regular BFD Enabled

    .. data:: sbfd_enabled = 2

    	SBFD Enabled

    """

    bfd_disabled = Enum.YLeaf(0, "bfd-disabled")

    bfd_enabled = Enum.YLeaf(1, "bfd-enabled")

    sbfd_enabled = Enum.YLeaf(2, "sbfd-enabled")


class TeVifBfdEncapMode(Enum):
    """
    TeVifBfdEncapMode

    BFD Encap Mode

    .. data:: ip = 0

    	BFD Encap Mode IP

    .. data:: gal = 1

    	BFD Encap Mode GAL

    """

    ip = Enum.YLeaf(0, "ip")

    gal = Enum.YLeaf(1, "gal")


class TeXroAttribute(Enum):
    """
    TeXroAttribute

    XRO exclusion type

    .. data:: interface = 0

    	Exclude the interface specified

    .. data:: node = 1

    	Exclude the node specified

    .. data:: srl_gs = 2

    	Exclude all SRLGs related to the data specified

    """

    interface = Enum.YLeaf(0, "interface")

    node = Enum.YLeaf(1, "node")

    srl_gs = Enum.YLeaf(2, "srl-gs")


class TeXroExclusion(Enum):
    """
    TeXroExclusion

    XRO exclusion type

    .. data:: mandatory = 0

    	Mandatory exclusion

    .. data:: best_effort = 1

    	Best-effort exclusion

    """

    mandatory = Enum.YLeaf(0, "mandatory")

    best_effort = Enum.YLeaf(1, "best-effort")


class TeXroSubobj(Enum):
    """
    TeXroSubobj

    XRO sub\-object type

    .. data:: ipv4 = 1

    	IPv4 prefix

    .. data:: ipv6 = 2

    	IPv6 prefix

    .. data:: unnumbered = 6

    	Unnumbered

    .. data:: as_ = 32

    	Autonomous System

    .. data:: srlg = 34

    	SRLG

    .. data:: p2p_lsp = 36

    	P2P LSP

    """

    ipv4 = Enum.YLeaf(1, "ipv4")

    ipv6 = Enum.YLeaf(2, "ipv6")

    unnumbered = Enum.YLeaf(6, "unnumbered")

    as_ = Enum.YLeaf(32, "as")

    srlg = Enum.YLeaf(34, "srlg")

    p2p_lsp = Enum.YLeaf(36, "p2p-lsp")


class TpLinkState(Enum):
    """
    TpLinkState

    Transport profile link state

    .. data:: down = 0

    	TP link state is down

    .. data:: admin_down = 1

    	TP link state is administratively down

    .. data:: up = 2

    	TP link state is up

    .. data:: unknown = 3

    	TP link state is unknown

    """

    down = Enum.YLeaf(0, "down")

    admin_down = Enum.YLeaf(1, "admin-down")

    up = Enum.YLeaf(2, "up")

    unknown = Enum.YLeaf(3, "unknown")


class TpMidLspStatus(Enum):
    """
    TpMidLspStatus

    Transport profile mid\-point LSP states

    .. data:: up = 0

    	TP LSP Up

    .. data:: down = 1

    	TP LSP Down

    """

    up = Enum.YLeaf(0, "up")

    down = Enum.YLeaf(1, "down")


class TunnelAttributeSet(Enum):
    """
    TunnelAttributeSet

    Tunnel attribute set

    .. data:: tunnel_attribute_set_none = 0

    	No Tunnel AttributeSet configured

    .. data:: tunnel_attribute_set_static = 1

    	Tunnel AttributeSet Type is Static

    .. data:: tunnel_attribute_set_path_option = 2

    	Tunnel AttributeSet Type is Path Option

    .. data:: tunnel_attribute_set_not_used = 3

    	None

    .. data:: tunnel_attribute_set_auto_backup = 4

    	Tunnel AttributeSet Type is AutoBackup

    .. data:: tunnel_attribute_set_auto_mesh = 5

    	Tunnel AttributeSet Type is AutoMesh

    .. data:: tunnel_attribute_set_xro = 6

    	Tunnel AttributeSet Type is XRO

    .. data:: tunnel_attribute_set_p2mpte = 7

    	Tunnel AttributeSet Type is P2MP TE

    .. data:: tunnel_attribute_aps_pp = 8

    	Tunnel AttributeSet Type is APS Path Protection

    .. data:: tunnel_attribute_set_p2p_te = 9

    	Tunnel AttributeSet Type is P2P TE

    """

    tunnel_attribute_set_none = Enum.YLeaf(0, "tunnel-attribute-set-none")

    tunnel_attribute_set_static = Enum.YLeaf(1, "tunnel-attribute-set-static")

    tunnel_attribute_set_path_option = Enum.YLeaf(2, "tunnel-attribute-set-path-option")

    tunnel_attribute_set_not_used = Enum.YLeaf(3, "tunnel-attribute-set-not-used")

    tunnel_attribute_set_auto_backup = Enum.YLeaf(4, "tunnel-attribute-set-auto-backup")

    tunnel_attribute_set_auto_mesh = Enum.YLeaf(5, "tunnel-attribute-set-auto-mesh")

    tunnel_attribute_set_xro = Enum.YLeaf(6, "tunnel-attribute-set-xro")

    tunnel_attribute_set_p2mpte = Enum.YLeaf(7, "tunnel-attribute-set-p2mpte")

    tunnel_attribute_aps_pp = Enum.YLeaf(8, "tunnel-attribute-aps-pp")

    tunnel_attribute_set_p2p_te = Enum.YLeaf(9, "tunnel-attribute-set-p2p-te")


class TunnelStateEnum(Enum):
    """
    TunnelStateEnum

    Types of tunnel admission states

    .. data:: tunnel_state_unknown = 0

    	No known state

    .. data:: new = 1

    	Tunnel is new

    .. data:: preempting = 2

    	Tunnel is being preempted

    .. data:: admitting = 3

    	Path being admitted

    .. data:: half_admitted = 4

    	Path was admitted partially and was then

    	rejected

    .. data:: admitted = 5

    	Path is already admitted successfully

    .. data:: reservation_admitting = 6

    	Reservation being admitted

    .. data:: reservation_half_admitted = 7

    	Reservation was admitted partially and was then

    	rejected

    .. data:: reservation_admitted = 8

    	Reservation is already admitted successfully

    """

    tunnel_state_unknown = Enum.YLeaf(0, "tunnel-state-unknown")

    new = Enum.YLeaf(1, "new")

    preempting = Enum.YLeaf(2, "preempting")

    admitting = Enum.YLeaf(3, "admitting")

    half_admitted = Enum.YLeaf(4, "half-admitted")

    admitted = Enum.YLeaf(5, "admitted")

    reservation_admitting = Enum.YLeaf(6, "reservation-admitting")

    reservation_half_admitted = Enum.YLeaf(7, "reservation-half-admitted")

    reservation_admitted = Enum.YLeaf(8, "reservation-admitted")



class MplsTe(Entity):
    """
    MPLS Traffic Engineering operational data
    
    .. attribute:: affinity_map
    
    	Affinity name to value mapping
    	**type**\:   :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap>`
    
    .. attribute:: announce_tunnels_info
    
    	Announced tunnels (forwarding adjacency and autoroute annonce)
    	**type**\:   :py:class:`AnnounceTunnelsInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo>`
    
    .. attribute:: attribute_sets
    
    	AttributeSet information
    	**type**\:   :py:class:`AttributeSets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets>`
    
    .. attribute:: auto_route_destination_entries
    
    	MPLS TE autoroute destination table indexed by tunnel
    	**type**\:   :py:class:`AutoRouteDestinationEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries>`
    
    .. attribute:: auto_tunnel
    
    	Auto tunnel information
    	**type**\:   :py:class:`AutoTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel>`
    
    .. attribute:: auto_tunnel_services
    
    	MPLS TE Auto Tunnel Services
    	**type**\:   :py:class:`AutoTunnelServices <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices>`
    
    .. attribute:: bfd
    
    	MPLS TE BFD Oper Info
    	**type**\:   :py:class:`Bfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd>`
    
    .. attribute:: collaborator_timers
    
    	TE Collaborator timer status
    	**type**\:   :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.CollaboratorTimers>`
    
    .. attribute:: diff_serv_te_classes
    
    	The configured Diff Serv TE classes
    	**type**\:   :py:class:`DiffServTeClasses <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.DiffServTeClasses>`
    
    .. attribute:: fast_reroute
    
    	Represent all the fastreroute info in MPLS\-TE
    	**type**\:   :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute>`
    
    .. attribute:: fib_next_hop_label_routes
    
    	MPLS TE FIB nexthop label route database
    	**type**\:   :py:class:`FibNextHopLabelRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes>`
    
    .. attribute:: fib_next_hop_routes
    
    	MPLS TE FIB nexthop route database
    	**type**\:   :py:class:`FibNextHopRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes>`
    
    .. attribute:: forwarding_adjacency_destinations
    
    	Announced Destination tunnel
    	**type**\:   :py:class:`ForwardingAdjacencyDestinations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations>`
    
    .. attribute:: hardware_out_of_resources
    
    	NPU Hardware OOR Information
    	**type**\:   :py:class:`HardwareOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources>`
    
    .. attribute:: igp_area_briefs
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:   :py:class:`IgpAreaBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs>`
    
    .. attribute:: igp_areas
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:   :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas>`
    
    .. attribute:: issu
    
    	MPLS TE ISSU information
    	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu>`
    
    .. attribute:: lsp_out_of_resources
    
    	LSP OOR information
    	**type**\:   :py:class:`LspOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources>`
    
    .. attribute:: maximum_tunnels
    
    	MPLS Traffic Engineering Tunnels
    	**type**\:   :py:class:`MaximumTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.MaximumTunnels>`
    
    .. attribute:: next_hop_routes
    
    	MPLS TE nexthop route database
    	**type**\:   :py:class:`NextHopRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes>`
    
    .. attribute:: nsr
    
    	MPLS TE NSR information
    	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr>`
    
    .. attribute:: open_config
    
    	OpenConfig MPLS TE operational data
    	**type**\:   :py:class:`OpenConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.OpenConfig>`
    
    .. attribute:: p2mp
    
    	P2MP Information
    	**type**\:   :py:class:`P2Mp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp>`
    
    .. attribute:: p2p_p2mp_tunnel
    
    	P2P or P2MP tunnels
    	**type**\:   :py:class:`P2PP2MpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel>`
    
    .. attribute:: path_protection
    
    	MPLS TE path protection info
    	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection>`
    
    .. attribute:: segment_routing
    
    	The Segment Routing database in MPLS\-TE
    	**type**\:   :py:class:`SegmentRouting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting>`
    
    .. attribute:: signalling_counters
    
    	TE counters
    	**type**\:   :py:class:`SignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters>`
    
    .. attribute:: soft_preemption
    
    	Soft Preemption information
    	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SoftPreemption>`
    
    .. attribute:: te_mib
    
    	TE MIB information
    	**type**\:   :py:class:`TeMib <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TeMib>`
    
    .. attribute:: topology
    
    	The topology information in MPLS\-TE
    	**type**\:   :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology>`
    
    .. attribute:: topology_briefs
    
    	MPLS\-TE topology brief table
    	**type**\:   :py:class:`TopologyBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs>`
    
    .. attribute:: topology_nodes
    
    	A node in the MPLS\-TE topology
    	**type**\:   :py:class:`TopologyNodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes>`
    
    .. attribute:: tunnels
    
    	Failure protection provided for tunnels
    	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels>`
    
    .. attribute:: wrap_protection
    
    	Represent all the LSP Wrap Protection info in MPLS\-TE
    	**type**\:   :py:class:`WrapProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsTe, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-te"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.affinity_map = MplsTe.AffinityMap()
        self.affinity_map.parent = self
        self._children_name_map["affinity_map"] = "affinity-map"
        self._children_yang_names.add("affinity-map")

        self.announce_tunnels_info = MplsTe.AnnounceTunnelsInfo()
        self.announce_tunnels_info.parent = self
        self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"
        self._children_yang_names.add("announce-tunnels-info")

        self.attribute_sets = MplsTe.AttributeSets()
        self.attribute_sets.parent = self
        self._children_name_map["attribute_sets"] = "attribute-sets"
        self._children_yang_names.add("attribute-sets")

        self.auto_route_destination_entries = MplsTe.AutoRouteDestinationEntries()
        self.auto_route_destination_entries.parent = self
        self._children_name_map["auto_route_destination_entries"] = "auto-route-destination-entries"
        self._children_yang_names.add("auto-route-destination-entries")

        self.auto_tunnel = MplsTe.AutoTunnel()
        self.auto_tunnel.parent = self
        self._children_name_map["auto_tunnel"] = "auto-tunnel"
        self._children_yang_names.add("auto-tunnel")

        self.auto_tunnel_services = MplsTe.AutoTunnelServices()
        self.auto_tunnel_services.parent = self
        self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"
        self._children_yang_names.add("auto-tunnel-services")

        self.bfd = MplsTe.Bfd()
        self.bfd.parent = self
        self._children_name_map["bfd"] = "bfd"
        self._children_yang_names.add("bfd")

        self.collaborator_timers = MplsTe.CollaboratorTimers()
        self.collaborator_timers.parent = self
        self._children_name_map["collaborator_timers"] = "collaborator-timers"
        self._children_yang_names.add("collaborator-timers")

        self.diff_serv_te_classes = MplsTe.DiffServTeClasses()
        self.diff_serv_te_classes.parent = self
        self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"
        self._children_yang_names.add("diff-serv-te-classes")

        self.fast_reroute = MplsTe.FastReroute()
        self.fast_reroute.parent = self
        self._children_name_map["fast_reroute"] = "fast-reroute"
        self._children_yang_names.add("fast-reroute")

        self.fib_next_hop_label_routes = MplsTe.FibNextHopLabelRoutes()
        self.fib_next_hop_label_routes.parent = self
        self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"
        self._children_yang_names.add("fib-next-hop-label-routes")

        self.fib_next_hop_routes = MplsTe.FibNextHopRoutes()
        self.fib_next_hop_routes.parent = self
        self._children_name_map["fib_next_hop_routes"] = "fib-next-hop-routes"
        self._children_yang_names.add("fib-next-hop-routes")

        self.forwarding_adjacency_destinations = MplsTe.ForwardingAdjacencyDestinations()
        self.forwarding_adjacency_destinations.parent = self
        self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"
        self._children_yang_names.add("forwarding-adjacency-destinations")

        self.hardware_out_of_resources = MplsTe.HardwareOutOfResources()
        self.hardware_out_of_resources.parent = self
        self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"
        self._children_yang_names.add("hardware-out-of-resources")

        self.igp_area_briefs = MplsTe.IgpAreaBriefs()
        self.igp_area_briefs.parent = self
        self._children_name_map["igp_area_briefs"] = "igp-area-briefs"
        self._children_yang_names.add("igp-area-briefs")

        self.igp_areas = MplsTe.IgpAreas()
        self.igp_areas.parent = self
        self._children_name_map["igp_areas"] = "igp-areas"
        self._children_yang_names.add("igp-areas")

        self.issu = MplsTe.Issu()
        self.issu.parent = self
        self._children_name_map["issu"] = "issu"
        self._children_yang_names.add("issu")

        self.lsp_out_of_resources = MplsTe.LspOutOfResources()
        self.lsp_out_of_resources.parent = self
        self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"
        self._children_yang_names.add("lsp-out-of-resources")

        self.maximum_tunnels = MplsTe.MaximumTunnels()
        self.maximum_tunnels.parent = self
        self._children_name_map["maximum_tunnels"] = "maximum-tunnels"
        self._children_yang_names.add("maximum-tunnels")

        self.next_hop_routes = MplsTe.NextHopRoutes()
        self.next_hop_routes.parent = self
        self._children_name_map["next_hop_routes"] = "next-hop-routes"
        self._children_yang_names.add("next-hop-routes")

        self.nsr = MplsTe.Nsr()
        self.nsr.parent = self
        self._children_name_map["nsr"] = "nsr"
        self._children_yang_names.add("nsr")

        self.open_config = MplsTe.OpenConfig()
        self.open_config.parent = self
        self._children_name_map["open_config"] = "open-config"
        self._children_yang_names.add("open-config")

        self.p2mp = MplsTe.P2Mp()
        self.p2mp.parent = self
        self._children_name_map["p2mp"] = "p2mp"
        self._children_yang_names.add("p2mp")

        self.p2p_p2mp_tunnel = MplsTe.P2PP2MpTunnel()
        self.p2p_p2mp_tunnel.parent = self
        self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"
        self._children_yang_names.add("p2p-p2mp-tunnel")

        self.path_protection = MplsTe.PathProtection()
        self.path_protection.parent = self
        self._children_name_map["path_protection"] = "path-protection"
        self._children_yang_names.add("path-protection")

        self.segment_routing = MplsTe.SegmentRouting()
        self.segment_routing.parent = self
        self._children_name_map["segment_routing"] = "segment-routing"
        self._children_yang_names.add("segment-routing")

        self.signalling_counters = MplsTe.SignallingCounters()
        self.signalling_counters.parent = self
        self._children_name_map["signalling_counters"] = "signalling-counters"
        self._children_yang_names.add("signalling-counters")

        self.soft_preemption = MplsTe.SoftPreemption()
        self.soft_preemption.parent = self
        self._children_name_map["soft_preemption"] = "soft-preemption"
        self._children_yang_names.add("soft-preemption")

        self.te_mib = MplsTe.TeMib()
        self.te_mib.parent = self
        self._children_name_map["te_mib"] = "te-mib"
        self._children_yang_names.add("te-mib")

        self.topology = MplsTe.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"
        self._children_yang_names.add("topology")

        self.topology_briefs = MplsTe.TopologyBriefs()
        self.topology_briefs.parent = self
        self._children_name_map["topology_briefs"] = "topology-briefs"
        self._children_yang_names.add("topology-briefs")

        self.topology_nodes = MplsTe.TopologyNodes()
        self.topology_nodes.parent = self
        self._children_name_map["topology_nodes"] = "topology-nodes"
        self._children_yang_names.add("topology-nodes")

        self.tunnels = MplsTe.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._children_yang_names.add("tunnels")

        self.wrap_protection = MplsTe.WrapProtection()
        self.wrap_protection.parent = self
        self._children_name_map["wrap_protection"] = "wrap-protection"
        self._children_yang_names.add("wrap-protection")


    class SegmentRouting(Entity):
        """
        The Segment Routing database in MPLS\-TE
        
        .. attribute:: sr_node_infos
        
        	Segment\-Routing nodes database in MPLS\-TE
        	**type**\:   :py:class:`SrNodeInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos>`
        
        .. attribute:: sr_prefix_infos
        
        	Segment\-Routing prefixes database in MPLS\-TE
        	**type**\:   :py:class:`SrPrefixInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos>`
        
        .. attribute:: srigp_area_infos
        
        	Segment\-Routing information about IGP areas
        	**type**\:   :py:class:`SrigpAreaInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrigpAreaInfos>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.SegmentRouting, self).__init__()

            self.yang_name = "segment-routing"
            self.yang_parent_name = "mpls-te"

            self.sr_node_infos = MplsTe.SegmentRouting.SrNodeInfos()
            self.sr_node_infos.parent = self
            self._children_name_map["sr_node_infos"] = "sr-node-infos"
            self._children_yang_names.add("sr-node-infos")

            self.sr_prefix_infos = MplsTe.SegmentRouting.SrPrefixInfos()
            self.sr_prefix_infos.parent = self
            self._children_name_map["sr_prefix_infos"] = "sr-prefix-infos"
            self._children_yang_names.add("sr-prefix-infos")

            self.srigp_area_infos = MplsTe.SegmentRouting.SrigpAreaInfos()
            self.srigp_area_infos.parent = self
            self._children_name_map["srigp_area_infos"] = "srigp-area-infos"
            self._children_yang_names.add("srigp-area-infos")


        class SrigpAreaInfos(Entity):
            """
            Segment\-Routing information about IGP areas
            
            .. attribute:: srigp_area_info
            
            	A Segment\-Routing IGP area information
            	**type**\: list of    :py:class:`SrigpAreaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SegmentRouting.SrigpAreaInfos, self).__init__()

                self.yang_name = "srigp-area-infos"
                self.yang_parent_name = "segment-routing"

                self.srigp_area_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SegmentRouting.SrigpAreaInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SegmentRouting.SrigpAreaInfos, self).__setattr__(name, value)


            class SrigpAreaInfo(Entity):
                """
                A Segment\-Routing IGP area information
                
                .. attribute:: protocol  <key>
                
                	IGP protocol type
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: igp_instance  <key>
                
                	IGP instance
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: area  <key>
                
                	IGP area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_area_format
                
                	IGP\-area format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: igp_instance_xr
                
                	IGP Instance name
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                .. attribute:: segment_routing_enabled
                
                	True if the Segment\-Routing is enabled in this area
                	**type**\:  bool
                
                .. attribute:: strict_spf_enabled
                
                	True if the strict SPF is enabled in this area
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo, self).__init__()

                    self.yang_name = "srigp-area-info"
                    self.yang_parent_name = "srigp-area-infos"

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_area = YLeaf(YType.uint32, "igp-area")

                    self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                    self.igp_instance_xr = YLeaf(YType.str, "igp-instance-xr")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.segment_routing_enabled = YLeaf(YType.boolean, "segment-routing-enabled")

                    self.strict_spf_enabled = YLeaf(YType.boolean, "strict-spf-enabled")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("protocol",
                                    "igp_instance",
                                    "area",
                                    "igp_area",
                                    "igp_area_format",
                                    "igp_instance_xr",
                                    "igp_type",
                                    "segment_routing_enabled",
                                    "strict_spf_enabled") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.protocol.is_set or
                        self.igp_instance.is_set or
                        self.area.is_set or
                        self.igp_area.is_set or
                        self.igp_area_format.is_set or
                        self.igp_instance_xr.is_set or
                        self.igp_type.is_set or
                        self.segment_routing_enabled.is_set or
                        self.strict_spf_enabled.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_area_format.yfilter != YFilter.not_set or
                        self.igp_instance_xr.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set or
                        self.segment_routing_enabled.yfilter != YFilter.not_set or
                        self.strict_spf_enabled.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "srigp-area-info" + "[protocol='" + self.protocol.get() + "']" + "[igp-instance='" + self.igp_instance.get() + "']" + "[area='" + self.area.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/srigp-area-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                    if (self.igp_instance_xr.is_set or self.igp_instance_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance_xr.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())
                    if (self.segment_routing_enabled.is_set or self.segment_routing_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_routing_enabled.get_name_leafdata())
                    if (self.strict_spf_enabled.is_set or self.strict_spf_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.strict_spf_enabled.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "protocol" or name == "igp-instance" or name == "area" or name == "igp-area" or name == "igp-area-format" or name == "igp-instance-xr" or name == "igp-type" or name == "segment-routing-enabled" or name == "strict-spf-enabled"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area-format"):
                        self.igp_area_format = value
                        self.igp_area_format.value_namespace = name_space
                        self.igp_area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance-xr"):
                        self.igp_instance_xr = value
                        self.igp_instance_xr.value_namespace = name_space
                        self.igp_instance_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "segment-routing-enabled"):
                        self.segment_routing_enabled = value
                        self.segment_routing_enabled.value_namespace = name_space
                        self.segment_routing_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "strict-spf-enabled"):
                        self.strict_spf_enabled = value
                        self.strict_spf_enabled.value_namespace = name_space
                        self.strict_spf_enabled.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.srigp_area_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.srigp_area_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "srigp-area-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "srigp-area-info"):
                    for c in self.srigp_area_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.srigp_area_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "srigp-area-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class SrNodeInfos(Entity):
            """
            Segment\-Routing nodes database in MPLS\-TE
            
            .. attribute:: sr_node_info
            
            	A Segment\-Routing node information
            	**type**\: list of    :py:class:`SrNodeInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SegmentRouting.SrNodeInfos, self).__init__()

                self.yang_name = "sr-node-infos"
                self.yang_parent_name = "segment-routing"

                self.sr_node_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SegmentRouting.SrNodeInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SegmentRouting.SrNodeInfos, self).__setattr__(name, value)


            class SrNodeInfo(Entity):
                """
                A Segment\-Routing node information
                
                .. attribute:: protocol  <key>
                
                	IGP protocol type
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: igp_instance  <key>
                
                	IGP instance
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: area  <key>
                
                	IGP area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_node_id  <key>
                
                	Node's IGP ID
                	**type**\:  str
                
                .. attribute:: igp_area
                
                	IGP area which this node belongs to
                	**type**\:   :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea>`
                
                .. attribute:: local_node_igp_id
                
                	The local node's IGP id formatted as string
                	**type**\:  str
                
                .. attribute:: local_node_te_router_id
                
                	The local node's TE router\-id
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: node_link
                
                	This node's link information
                	**type**\: list of    :py:class:`NodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink>`
                
                .. attribute:: sr_node_info
                
                	Segment\-Routing Node information
                	**type**\:   :py:class:`SrNodeInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo>`
                
                .. attribute:: topology_node_is_router
                
                	TRUE if this is a router node; FALSE if it's a network node
                	**type**\:  bool
                
                .. attribute:: topology_node_overloaded
                
                	Flag to indicate whether this node is overloaded
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo, self).__init__()

                    self.yang_name = "sr-node-info"
                    self.yang_parent_name = "sr-node-infos"

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_node_id = YLeaf(YType.str, "igp-node-id")

                    self.local_node_igp_id = YLeaf(YType.str, "local-node-igp-id")

                    self.local_node_te_router_id = YLeaf(YType.str, "local-node-te-router-id")

                    self.topology_node_is_router = YLeaf(YType.boolean, "topology-node-is-router")

                    self.topology_node_overloaded = YLeaf(YType.boolean, "topology-node-overloaded")

                    self.igp_area = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea()
                    self.igp_area.parent = self
                    self._children_name_map["igp_area"] = "igp-area"
                    self._children_yang_names.add("igp-area")

                    self.sr_node_info = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo()
                    self.sr_node_info.parent = self
                    self._children_name_map["sr_node_info"] = "sr-node-info"
                    self._children_yang_names.add("sr-node-info")

                    self.node_link = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("protocol",
                                    "igp_instance",
                                    "area",
                                    "igp_node_id",
                                    "local_node_igp_id",
                                    "local_node_te_router_id",
                                    "topology_node_is_router",
                                    "topology_node_overloaded") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo, self).__setattr__(name, value)


                class IgpArea(Entity):
                    """
                    IGP area which this node belongs to
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: igp_instance_xr
                    
                    	IGP Instance name
                    	**type**\:  str
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    .. attribute:: segment_routing_enabled
                    
                    	True if the Segment\-Routing is enabled in this area
                    	**type**\:  bool
                    
                    .. attribute:: strict_spf_enabled
                    
                    	True if the strict SPF is enabled in this area
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea, self).__init__()

                        self.yang_name = "igp-area"
                        self.yang_parent_name = "sr-node-info"

                        self.igp_area = YLeaf(YType.uint32, "igp-area")

                        self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                        self.igp_instance_xr = YLeaf(YType.str, "igp-instance-xr")

                        self.igp_type = YLeaf(YType.enumeration, "igp-type")

                        self.segment_routing_enabled = YLeaf(YType.boolean, "segment-routing-enabled")

                        self.strict_spf_enabled = YLeaf(YType.boolean, "strict-spf-enabled")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("igp_area",
                                        "igp_area_format",
                                        "igp_instance_xr",
                                        "igp_type",
                                        "segment_routing_enabled",
                                        "strict_spf_enabled") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.igp_area.is_set or
                            self.igp_area_format.is_set or
                            self.igp_instance_xr.is_set or
                            self.igp_type.is_set or
                            self.segment_routing_enabled.is_set or
                            self.strict_spf_enabled.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.igp_area.yfilter != YFilter.not_set or
                            self.igp_area_format.yfilter != YFilter.not_set or
                            self.igp_instance_xr.yfilter != YFilter.not_set or
                            self.igp_type.yfilter != YFilter.not_set or
                            self.segment_routing_enabled.yfilter != YFilter.not_set or
                            self.strict_spf_enabled.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "igp-area" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area.get_name_leafdata())
                        if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                        if (self.igp_instance_xr.is_set or self.igp_instance_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_instance_xr.get_name_leafdata())
                        if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_type.get_name_leafdata())
                        if (self.segment_routing_enabled.is_set or self.segment_routing_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_enabled.get_name_leafdata())
                        if (self.strict_spf_enabled.is_set or self.strict_spf_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict_spf_enabled.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "igp-area" or name == "igp-area-format" or name == "igp-instance-xr" or name == "igp-type" or name == "segment-routing-enabled" or name == "strict-spf-enabled"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "igp-area"):
                            self.igp_area = value
                            self.igp_area.value_namespace = name_space
                            self.igp_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-format"):
                            self.igp_area_format = value
                            self.igp_area_format.value_namespace = name_space
                            self.igp_area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-instance-xr"):
                            self.igp_instance_xr = value
                            self.igp_instance_xr.value_namespace = name_space
                            self.igp_instance_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-type"):
                            self.igp_type = value
                            self.igp_type.value_namespace = name_space
                            self.igp_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-enabled"):
                            self.segment_routing_enabled = value
                            self.segment_routing_enabled.value_namespace = name_space
                            self.segment_routing_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict-spf-enabled"):
                            self.strict_spf_enabled = value
                            self.strict_spf_enabled.value_namespace = name_space
                            self.strict_spf_enabled.value_namespace_prefix = name_space_prefix


                class SrNodeInfo(Entity):
                    """
                    Segment\-Routing Node information
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo, self).__init__()

                        self.yang_name = "sr-node-info"
                        self.yang_parent_name = "sr-node-info"

                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                        self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                        self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                        self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("segment_id",
                                        "segment_id_local_absolute_value",
                                        "srgb_size",
                                        "srgb_start") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.segment_id.is_set or
                            self.segment_id_local_absolute_value.is_set or
                            self.srgb_size.is_set or
                            self.srgb_start.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.segment_id.yfilter != YFilter.not_set or
                            self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                            self.srgb_size.yfilter != YFilter.not_set or
                            self.srgb_start.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-node-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                        if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                        if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_size.get_name_leafdata())
                        if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_start.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "segment-id"):
                            self.segment_id = value
                            self.segment_id.value_namespace = name_space
                            self.segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-local-absolute-value"):
                            self.segment_id_local_absolute_value = value
                            self.segment_id_local_absolute_value.value_namespace = name_space
                            self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-size"):
                            self.srgb_size = value
                            self.srgb_size.value_namespace = name_space
                            self.srgb_size.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-start"):
                            self.srgb_start = value
                            self.srgb_start.value_namespace = name_space
                            self.srgb_start.value_namespace_prefix = name_space_prefix


                class NodeLink(Entity):
                    """
                    This node's link information
                    
                    .. attribute:: adjacency_sids
                    
                    	Adjacency SIDs assigned for adjacency nodes
                    	**type**\: list of    :py:class:`AdjacencySids <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup>`
                    
                    .. attribute:: topology_link_extended_affinity_bit
                    
                    	The link's affinity bits (colors)
                    	**type**\: list of    :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit>`
                    
                    .. attribute:: topology_link_fragment_id
                    
                    	Neighbor's link version counter
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_igp_metric
                    
                    	The link's IGP metric
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_interface_address
                    
                    	Link's local interface address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: topology_link_interface_id
                    
                    	Link's local interface ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_neighbor_address
                    
                    	Link's neighbor interface address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: topology_link_neighbor_generation
                    
                    	Neighbor's link version counter
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_neighbor_id
                    
                    	Link's neighbor interface ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_neighbor_node_id
                    
                    	Node id of neighbor
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_neighbor_system_id
                    
                    	System id of neighbor
                    	**type**\:  str
                    
                    .. attribute:: topology_link_te_metric
                    
                    	The link's TE metric
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: topology_link_type
                    
                    	Link type
                    	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink, self).__init__()

                        self.yang_name = "node-link"
                        self.yang_parent_name = "sr-node-info"

                        self.topology_link_fragment_id = YLeaf(YType.uint32, "topology-link-fragment-id")

                        self.topology_link_igp_metric = YLeaf(YType.uint32, "topology-link-igp-metric")

                        self.topology_link_interface_address = YLeaf(YType.str, "topology-link-interface-address")

                        self.topology_link_interface_id = YLeaf(YType.uint32, "topology-link-interface-id")

                        self.topology_link_neighbor_address = YLeaf(YType.str, "topology-link-neighbor-address")

                        self.topology_link_neighbor_generation = YLeaf(YType.uint32, "topology-link-neighbor-generation")

                        self.topology_link_neighbor_id = YLeaf(YType.uint32, "topology-link-neighbor-id")

                        self.topology_link_neighbor_node_id = YLeaf(YType.uint32, "topology-link-neighbor-node-id")

                        self.topology_link_neighbor_system_id = YLeaf(YType.str, "topology-link-neighbor-system-id")

                        self.topology_link_te_metric = YLeaf(YType.uint32, "topology-link-te-metric")

                        self.topology_link_type = YLeaf(YType.enumeration, "topology-link-type")

                        self.adjacency_sids = YList(self)
                        self.shared_risk_link_group = YList(self)
                        self.topology_link_extended_affinity_bit = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("topology_link_fragment_id",
                                        "topology_link_igp_metric",
                                        "topology_link_interface_address",
                                        "topology_link_interface_id",
                                        "topology_link_neighbor_address",
                                        "topology_link_neighbor_generation",
                                        "topology_link_neighbor_id",
                                        "topology_link_neighbor_node_id",
                                        "topology_link_neighbor_system_id",
                                        "topology_link_te_metric",
                                        "topology_link_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink, self).__setattr__(name, value)


                    class TopologyLinkExtendedAffinityBit(Entity):
                        """
                        The link's affinity bits (colors)
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                            self.yang_name = "topology-link-extended-affinity-bit"
                            self.yang_parent_name = "node-link"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-extended-affinity-bit" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "node-link"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class AdjacencySids(Entity):
                        """
                        Adjacency SIDs assigned for adjacency nodes
                        
                        .. attribute:: adjacency_sid
                        
                        	The adjacency SID assigned for the topology node
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flag_b
                        
                        	IGP Flag B
                        	**type**\:  bool
                        
                        .. attribute:: flag_f
                        
                        	IGP Flag F
                        	**type**\:  bool
                        
                        .. attribute:: flag_l
                        
                        	IGP Flag L
                        	**type**\:  bool
                        
                        .. attribute:: flag_s
                        
                        	IGP Flag S
                        	**type**\:  bool
                        
                        .. attribute:: flag_v
                        
                        	IGP Flag V
                        	**type**\:  bool
                        
                        .. attribute:: link_type
                        
                        	Link Type
                        	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                        
                        .. attribute:: local_addr
                        
                        	Local Address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: nbr_node_igpid
                        
                        	The neighbor node's IGP ID
                        	**type**\:  str
                        
                        .. attribute:: nbr_node_te_router_id
                        
                        	The neigbor node's TE router\-id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: remote_addr
                        
                        	Remote Address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids, self).__init__()

                            self.yang_name = "adjacency-sids"
                            self.yang_parent_name = "node-link"

                            self.adjacency_sid = YLeaf(YType.uint32, "adjacency-sid")

                            self.flag_b = YLeaf(YType.boolean, "flag-b")

                            self.flag_f = YLeaf(YType.boolean, "flag-f")

                            self.flag_l = YLeaf(YType.boolean, "flag-l")

                            self.flag_s = YLeaf(YType.boolean, "flag-s")

                            self.flag_v = YLeaf(YType.boolean, "flag-v")

                            self.link_type = YLeaf(YType.enumeration, "link-type")

                            self.local_addr = YLeaf(YType.str, "local-addr")

                            self.nbr_node_igpid = YLeaf(YType.str, "nbr-node-igpid")

                            self.nbr_node_te_router_id = YLeaf(YType.str, "nbr-node-te-router-id")

                            self.remote_addr = YLeaf(YType.str, "remote-addr")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjacency_sid",
                                            "flag_b",
                                            "flag_f",
                                            "flag_l",
                                            "flag_s",
                                            "flag_v",
                                            "link_type",
                                            "local_addr",
                                            "nbr_node_igpid",
                                            "nbr_node_te_router_id",
                                            "remote_addr") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.adjacency_sid.is_set or
                                self.flag_b.is_set or
                                self.flag_f.is_set or
                                self.flag_l.is_set or
                                self.flag_s.is_set or
                                self.flag_v.is_set or
                                self.link_type.is_set or
                                self.local_addr.is_set or
                                self.nbr_node_igpid.is_set or
                                self.nbr_node_te_router_id.is_set or
                                self.remote_addr.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjacency_sid.yfilter != YFilter.not_set or
                                self.flag_b.yfilter != YFilter.not_set or
                                self.flag_f.yfilter != YFilter.not_set or
                                self.flag_l.yfilter != YFilter.not_set or
                                self.flag_s.yfilter != YFilter.not_set or
                                self.flag_v.yfilter != YFilter.not_set or
                                self.link_type.yfilter != YFilter.not_set or
                                self.local_addr.yfilter != YFilter.not_set or
                                self.nbr_node_igpid.yfilter != YFilter.not_set or
                                self.nbr_node_te_router_id.yfilter != YFilter.not_set or
                                self.remote_addr.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "adjacency-sids" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjacency_sid.is_set or self.adjacency_sid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjacency_sid.get_name_leafdata())
                            if (self.flag_b.is_set or self.flag_b.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flag_b.get_name_leafdata())
                            if (self.flag_f.is_set or self.flag_f.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flag_f.get_name_leafdata())
                            if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flag_l.get_name_leafdata())
                            if (self.flag_s.is_set or self.flag_s.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flag_s.get_name_leafdata())
                            if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flag_v.get_name_leafdata())
                            if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_type.get_name_leafdata())
                            if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_addr.get_name_leafdata())
                            if (self.nbr_node_igpid.is_set or self.nbr_node_igpid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nbr_node_igpid.get_name_leafdata())
                            if (self.nbr_node_te_router_id.is_set or self.nbr_node_te_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nbr_node_te_router_id.get_name_leafdata())
                            if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_addr.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "adjacency-sid" or name == "flag-b" or name == "flag-f" or name == "flag-l" or name == "flag-s" or name == "flag-v" or name == "link-type" or name == "local-addr" or name == "nbr-node-igpid" or name == "nbr-node-te-router-id" or name == "remote-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjacency-sid"):
                                self.adjacency_sid = value
                                self.adjacency_sid.value_namespace = name_space
                                self.adjacency_sid.value_namespace_prefix = name_space_prefix
                            if(value_path == "flag-b"):
                                self.flag_b = value
                                self.flag_b.value_namespace = name_space
                                self.flag_b.value_namespace_prefix = name_space_prefix
                            if(value_path == "flag-f"):
                                self.flag_f = value
                                self.flag_f.value_namespace = name_space
                                self.flag_f.value_namespace_prefix = name_space_prefix
                            if(value_path == "flag-l"):
                                self.flag_l = value
                                self.flag_l.value_namespace = name_space
                                self.flag_l.value_namespace_prefix = name_space_prefix
                            if(value_path == "flag-s"):
                                self.flag_s = value
                                self.flag_s.value_namespace = name_space
                                self.flag_s.value_namespace_prefix = name_space_prefix
                            if(value_path == "flag-v"):
                                self.flag_v = value
                                self.flag_v.value_namespace = name_space
                                self.flag_v.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-type"):
                                self.link_type = value
                                self.link_type.value_namespace = name_space
                                self.link_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-addr"):
                                self.local_addr = value
                                self.local_addr.value_namespace = name_space
                                self.local_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "nbr-node-igpid"):
                                self.nbr_node_igpid = value
                                self.nbr_node_igpid.value_namespace = name_space
                                self.nbr_node_igpid.value_namespace_prefix = name_space_prefix
                            if(value_path == "nbr-node-te-router-id"):
                                self.nbr_node_te_router_id = value
                                self.nbr_node_te_router_id.value_namespace = name_space
                                self.nbr_node_te_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-addr"):
                                self.remote_addr = value
                                self.remote_addr.value_namespace = name_space
                                self.remote_addr.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.adjacency_sids:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        for c in self.topology_link_extended_affinity_bit:
                            if (c.has_data()):
                                return True
                        return (
                            self.topology_link_fragment_id.is_set or
                            self.topology_link_igp_metric.is_set or
                            self.topology_link_interface_address.is_set or
                            self.topology_link_interface_id.is_set or
                            self.topology_link_neighbor_address.is_set or
                            self.topology_link_neighbor_generation.is_set or
                            self.topology_link_neighbor_id.is_set or
                            self.topology_link_neighbor_node_id.is_set or
                            self.topology_link_neighbor_system_id.is_set or
                            self.topology_link_te_metric.is_set or
                            self.topology_link_type.is_set)

                    def has_operation(self):
                        for c in self.adjacency_sids:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        for c in self.topology_link_extended_affinity_bit:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.topology_link_fragment_id.yfilter != YFilter.not_set or
                            self.topology_link_igp_metric.yfilter != YFilter.not_set or
                            self.topology_link_interface_address.yfilter != YFilter.not_set or
                            self.topology_link_interface_id.yfilter != YFilter.not_set or
                            self.topology_link_neighbor_address.yfilter != YFilter.not_set or
                            self.topology_link_neighbor_generation.yfilter != YFilter.not_set or
                            self.topology_link_neighbor_id.yfilter != YFilter.not_set or
                            self.topology_link_neighbor_node_id.yfilter != YFilter.not_set or
                            self.topology_link_neighbor_system_id.yfilter != YFilter.not_set or
                            self.topology_link_te_metric.yfilter != YFilter.not_set or
                            self.topology_link_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "node-link" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.topology_link_fragment_id.is_set or self.topology_link_fragment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_fragment_id.get_name_leafdata())
                        if (self.topology_link_igp_metric.is_set or self.topology_link_igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_igp_metric.get_name_leafdata())
                        if (self.topology_link_interface_address.is_set or self.topology_link_interface_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_interface_address.get_name_leafdata())
                        if (self.topology_link_interface_id.is_set or self.topology_link_interface_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_interface_id.get_name_leafdata())
                        if (self.topology_link_neighbor_address.is_set or self.topology_link_neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_neighbor_address.get_name_leafdata())
                        if (self.topology_link_neighbor_generation.is_set or self.topology_link_neighbor_generation.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_neighbor_generation.get_name_leafdata())
                        if (self.topology_link_neighbor_id.is_set or self.topology_link_neighbor_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_neighbor_id.get_name_leafdata())
                        if (self.topology_link_neighbor_node_id.is_set or self.topology_link_neighbor_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_neighbor_node_id.get_name_leafdata())
                        if (self.topology_link_neighbor_system_id.is_set or self.topology_link_neighbor_system_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_neighbor_system_id.get_name_leafdata())
                        if (self.topology_link_te_metric.is_set or self.topology_link_te_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_te_metric.get_name_leafdata())
                        if (self.topology_link_type.is_set or self.topology_link_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_link_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "adjacency-sids"):
                            for c in self.adjacency_sids:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.adjacency_sids.append(c)
                            return c

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        if (child_yang_name == "topology-link-extended-affinity-bit"):
                            for c in self.topology_link_extended_affinity_bit:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.topology_link_extended_affinity_bit.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "adjacency-sids" or name == "shared-risk-link-group" or name == "topology-link-extended-affinity-bit" or name == "topology-link-fragment-id" or name == "topology-link-igp-metric" or name == "topology-link-interface-address" or name == "topology-link-interface-id" or name == "topology-link-neighbor-address" or name == "topology-link-neighbor-generation" or name == "topology-link-neighbor-id" or name == "topology-link-neighbor-node-id" or name == "topology-link-neighbor-system-id" or name == "topology-link-te-metric" or name == "topology-link-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "topology-link-fragment-id"):
                            self.topology_link_fragment_id = value
                            self.topology_link_fragment_id.value_namespace = name_space
                            self.topology_link_fragment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-igp-metric"):
                            self.topology_link_igp_metric = value
                            self.topology_link_igp_metric.value_namespace = name_space
                            self.topology_link_igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-interface-address"):
                            self.topology_link_interface_address = value
                            self.topology_link_interface_address.value_namespace = name_space
                            self.topology_link_interface_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-interface-id"):
                            self.topology_link_interface_id = value
                            self.topology_link_interface_id.value_namespace = name_space
                            self.topology_link_interface_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-neighbor-address"):
                            self.topology_link_neighbor_address = value
                            self.topology_link_neighbor_address.value_namespace = name_space
                            self.topology_link_neighbor_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-neighbor-generation"):
                            self.topology_link_neighbor_generation = value
                            self.topology_link_neighbor_generation.value_namespace = name_space
                            self.topology_link_neighbor_generation.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-neighbor-id"):
                            self.topology_link_neighbor_id = value
                            self.topology_link_neighbor_id.value_namespace = name_space
                            self.topology_link_neighbor_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-neighbor-node-id"):
                            self.topology_link_neighbor_node_id = value
                            self.topology_link_neighbor_node_id.value_namespace = name_space
                            self.topology_link_neighbor_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-neighbor-system-id"):
                            self.topology_link_neighbor_system_id = value
                            self.topology_link_neighbor_system_id.value_namespace = name_space
                            self.topology_link_neighbor_system_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-te-metric"):
                            self.topology_link_te_metric = value
                            self.topology_link_te_metric.value_namespace = name_space
                            self.topology_link_te_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-link-type"):
                            self.topology_link_type = value
                            self.topology_link_type.value_namespace = name_space
                            self.topology_link_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.node_link:
                        if (c.has_data()):
                            return True
                    return (
                        self.protocol.is_set or
                        self.igp_instance.is_set or
                        self.area.is_set or
                        self.igp_node_id.is_set or
                        self.local_node_igp_id.is_set or
                        self.local_node_te_router_id.is_set or
                        self.topology_node_is_router.is_set or
                        self.topology_node_overloaded.is_set or
                        (self.igp_area is not None and self.igp_area.has_data()) or
                        (self.sr_node_info is not None and self.sr_node_info.has_data()))

                def has_operation(self):
                    for c in self.node_link:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_node_id.yfilter != YFilter.not_set or
                        self.local_node_igp_id.yfilter != YFilter.not_set or
                        self.local_node_te_router_id.yfilter != YFilter.not_set or
                        self.topology_node_is_router.yfilter != YFilter.not_set or
                        self.topology_node_overloaded.yfilter != YFilter.not_set or
                        (self.igp_area is not None and self.igp_area.has_operation()) or
                        (self.sr_node_info is not None and self.sr_node_info.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sr-node-info" + "[protocol='" + self.protocol.get() + "']" + "[igp-instance='" + self.igp_instance.get() + "']" + "[area='" + self.area.get() + "']" + "[igp-node-id='" + self.igp_node_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/sr-node-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_node_id.is_set or self.igp_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_node_id.get_name_leafdata())
                    if (self.local_node_igp_id.is_set or self.local_node_igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_node_igp_id.get_name_leafdata())
                    if (self.local_node_te_router_id.is_set or self.local_node_te_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_node_te_router_id.get_name_leafdata())
                    if (self.topology_node_is_router.is_set or self.topology_node_is_router.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_node_is_router.get_name_leafdata())
                    if (self.topology_node_overloaded.is_set or self.topology_node_overloaded.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_node_overloaded.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "igp-area"):
                        if (self.igp_area is None):
                            self.igp_area = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea()
                            self.igp_area.parent = self
                            self._children_name_map["igp_area"] = "igp-area"
                        return self.igp_area

                    if (child_yang_name == "node-link"):
                        for c in self.node_link:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.node_link.append(c)
                        return c

                    if (child_yang_name == "sr-node-info"):
                        if (self.sr_node_info is None):
                            self.sr_node_info = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo()
                            self.sr_node_info.parent = self
                            self._children_name_map["sr_node_info"] = "sr-node-info"
                        return self.sr_node_info

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "igp-area" or name == "node-link" or name == "sr-node-info" or name == "protocol" or name == "igp-instance" or name == "area" or name == "igp-node-id" or name == "local-node-igp-id" or name == "local-node-te-router-id" or name == "topology-node-is-router" or name == "topology-node-overloaded"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-node-id"):
                        self.igp_node_id = value
                        self.igp_node_id.value_namespace = name_space
                        self.igp_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-node-igp-id"):
                        self.local_node_igp_id = value
                        self.local_node_igp_id.value_namespace = name_space
                        self.local_node_igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-node-te-router-id"):
                        self.local_node_te_router_id = value
                        self.local_node_te_router_id.value_namespace = name_space
                        self.local_node_te_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-node-is-router"):
                        self.topology_node_is_router = value
                        self.topology_node_is_router.value_namespace = name_space
                        self.topology_node_is_router.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-node-overloaded"):
                        self.topology_node_overloaded = value
                        self.topology_node_overloaded.value_namespace = name_space
                        self.topology_node_overloaded.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.sr_node_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.sr_node_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "sr-node-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sr-node-info"):
                    for c in self.sr_node_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.sr_node_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sr-node-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class SrPrefixInfos(Entity):
            """
            Segment\-Routing prefixes database in MPLS\-TE
            
            .. attribute:: sr_prefix_info
            
            	A Segment\-Routing prefix information
            	**type**\: list of    :py:class:`SrPrefixInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SegmentRouting.SrPrefixInfos, self).__init__()

                self.yang_name = "sr-prefix-infos"
                self.yang_parent_name = "segment-routing"

                self.sr_prefix_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SegmentRouting.SrPrefixInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SegmentRouting.SrPrefixInfos, self).__setattr__(name, value)


            class SrPrefixInfo(Entity):
                """
                A Segment\-Routing prefix information
                
                .. attribute:: protocol  <key>
                
                	IGP protocol type
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: igp_instance  <key>
                
                	IGP instance
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: area  <key>
                
                	IGP area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: prefix  <key>
                
                	Segment\-Routing prefix
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: prefix_length  <key>
                
                	Prefix' length
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: advertizing_node
                
                	Advertizing nodes
                	**type**\: list of    :py:class:`AdvertizingNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode>`
                
                .. attribute:: flag_e
                
                	Prefix\-SID subTLV E\-flag
                	**type**\:  bool
                
                .. attribute:: flag_l
                
                	Prefix\-SID subTLV L\-flag
                	**type**\:  bool
                
                .. attribute:: flag_n
                
                	Prefix\-SID subTLV N\-flag
                	**type**\:  bool
                
                .. attribute:: flag_p
                
                	Prefix\-SID subTLV P\-flag
                	**type**\:  bool
                
                .. attribute:: flag_r
                
                	Prefix\-SID subTLV R\-flag
                	**type**\:  bool
                
                .. attribute:: flag_v
                
                	Prefix\-SID subTLV V\-flag
                	**type**\:  bool
                
                .. attribute:: igp_area
                
                	An IGP area where the prefix belongs to
                	**type**\:   :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea>`
                
                .. attribute:: prefix_length_xr
                
                	Length of the prefix
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: prefix_sid
                
                	Segment\-Routing prefix SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: prefix_strict_sid
                
                	Segment\-Routing prefix Strict SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: prefix_xr
                
                	Prefix
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sr_path
                
                	Segment\-Routing paths to prefix
                	**type**\: list of    :py:class:`SrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath>`
                
                .. attribute:: strict_advertizing_node
                
                	Advertizing nodes for Strict SPF
                	**type**\: list of    :py:class:`StrictAdvertizingNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode>`
                
                .. attribute:: strict_flag_e
                
                	Prefix\-SID subTLV E\-flag for strict SID
                	**type**\:  bool
                
                .. attribute:: strict_flag_l
                
                	Prefix\-SID subTLV L\-flag for strict SID
                	**type**\:  bool
                
                .. attribute:: strict_flag_p
                
                	Prefix\-SID subTLV P\-flag for strict SID
                	**type**\:  bool
                
                .. attribute:: strict_flag_v
                
                	Prefix\-SID subTLV V\-flag for strict SID
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo, self).__init__()

                    self.yang_name = "sr-prefix-info"
                    self.yang_parent_name = "sr-prefix-infos"

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.area = YLeaf(YType.int32, "area")

                    self.prefix = YLeaf(YType.str, "prefix")

                    self.prefix_length = YLeaf(YType.int32, "prefix-length")

                    self.flag_e = YLeaf(YType.boolean, "flag-e")

                    self.flag_l = YLeaf(YType.boolean, "flag-l")

                    self.flag_n = YLeaf(YType.boolean, "flag-n")

                    self.flag_p = YLeaf(YType.boolean, "flag-p")

                    self.flag_r = YLeaf(YType.boolean, "flag-r")

                    self.flag_v = YLeaf(YType.boolean, "flag-v")

                    self.prefix_length_xr = YLeaf(YType.uint8, "prefix-length-xr")

                    self.prefix_sid = YLeaf(YType.uint32, "prefix-sid")

                    self.prefix_strict_sid = YLeaf(YType.uint32, "prefix-strict-sid")

                    self.prefix_xr = YLeaf(YType.str, "prefix-xr")

                    self.strict_flag_e = YLeaf(YType.boolean, "strict-flag-e")

                    self.strict_flag_l = YLeaf(YType.boolean, "strict-flag-l")

                    self.strict_flag_p = YLeaf(YType.boolean, "strict-flag-p")

                    self.strict_flag_v = YLeaf(YType.boolean, "strict-flag-v")

                    self.igp_area = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea()
                    self.igp_area.parent = self
                    self._children_name_map["igp_area"] = "igp-area"
                    self._children_yang_names.add("igp-area")

                    self.advertizing_node = YList(self)
                    self.sr_path = YList(self)
                    self.strict_advertizing_node = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("protocol",
                                    "igp_instance",
                                    "area",
                                    "prefix",
                                    "prefix_length",
                                    "flag_e",
                                    "flag_l",
                                    "flag_n",
                                    "flag_p",
                                    "flag_r",
                                    "flag_v",
                                    "prefix_length_xr",
                                    "prefix_sid",
                                    "prefix_strict_sid",
                                    "prefix_xr",
                                    "strict_flag_e",
                                    "strict_flag_l",
                                    "strict_flag_p",
                                    "strict_flag_v") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo, self).__setattr__(name, value)


                class IgpArea(Entity):
                    """
                    An IGP area where the prefix belongs to
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: igp_instance_xr
                    
                    	IGP Instance name
                    	**type**\:  str
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    .. attribute:: segment_routing_enabled
                    
                    	True if the Segment\-Routing is enabled in this area
                    	**type**\:  bool
                    
                    .. attribute:: strict_spf_enabled
                    
                    	True if the strict SPF is enabled in this area
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea, self).__init__()

                        self.yang_name = "igp-area"
                        self.yang_parent_name = "sr-prefix-info"

                        self.igp_area = YLeaf(YType.uint32, "igp-area")

                        self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                        self.igp_instance_xr = YLeaf(YType.str, "igp-instance-xr")

                        self.igp_type = YLeaf(YType.enumeration, "igp-type")

                        self.segment_routing_enabled = YLeaf(YType.boolean, "segment-routing-enabled")

                        self.strict_spf_enabled = YLeaf(YType.boolean, "strict-spf-enabled")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("igp_area",
                                        "igp_area_format",
                                        "igp_instance_xr",
                                        "igp_type",
                                        "segment_routing_enabled",
                                        "strict_spf_enabled") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.igp_area.is_set or
                            self.igp_area_format.is_set or
                            self.igp_instance_xr.is_set or
                            self.igp_type.is_set or
                            self.segment_routing_enabled.is_set or
                            self.strict_spf_enabled.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.igp_area.yfilter != YFilter.not_set or
                            self.igp_area_format.yfilter != YFilter.not_set or
                            self.igp_instance_xr.yfilter != YFilter.not_set or
                            self.igp_type.yfilter != YFilter.not_set or
                            self.segment_routing_enabled.yfilter != YFilter.not_set or
                            self.strict_spf_enabled.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "igp-area" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area.get_name_leafdata())
                        if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                        if (self.igp_instance_xr.is_set or self.igp_instance_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_instance_xr.get_name_leafdata())
                        if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_type.get_name_leafdata())
                        if (self.segment_routing_enabled.is_set or self.segment_routing_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_enabled.get_name_leafdata())
                        if (self.strict_spf_enabled.is_set or self.strict_spf_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict_spf_enabled.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "igp-area" or name == "igp-area-format" or name == "igp-instance-xr" or name == "igp-type" or name == "segment-routing-enabled" or name == "strict-spf-enabled"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "igp-area"):
                            self.igp_area = value
                            self.igp_area.value_namespace = name_space
                            self.igp_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-format"):
                            self.igp_area_format = value
                            self.igp_area_format.value_namespace = name_space
                            self.igp_area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-instance-xr"):
                            self.igp_instance_xr = value
                            self.igp_instance_xr.value_namespace = name_space
                            self.igp_instance_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-type"):
                            self.igp_type = value
                            self.igp_type.value_namespace = name_space
                            self.igp_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-enabled"):
                            self.segment_routing_enabled = value
                            self.segment_routing_enabled.value_namespace = name_space
                            self.segment_routing_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict-spf-enabled"):
                            self.strict_spf_enabled = value
                            self.strict_spf_enabled.value_namespace = name_space
                            self.strict_spf_enabled.value_namespace_prefix = name_space_prefix


                class SrPath(Entity):
                    """
                    Segment\-Routing paths to prefix
                    
                    .. attribute:: backup_path
                    
                    	Backup Segment\-Routing Path
                    	**type**\:   :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath>`
                    
                    .. attribute:: has_backup_path
                    
                    	Backup Path is available
                    	**type**\:  bool
                    
                    .. attribute:: primary_path
                    
                    	Primary Segment\-Routing Path
                    	**type**\:   :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath, self).__init__()

                        self.yang_name = "sr-path"
                        self.yang_parent_name = "sr-prefix-info"

                        self.has_backup_path = YLeaf(YType.boolean, "has-backup-path")

                        self.backup_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath()
                        self.backup_path.parent = self
                        self._children_name_map["backup_path"] = "backup-path"
                        self._children_yang_names.add("backup-path")

                        self.primary_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath()
                        self.primary_path.parent = self
                        self._children_name_map["primary_path"] = "primary-path"
                        self._children_yang_names.add("primary-path")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("has_backup_path") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath, self).__setattr__(name, value)


                    class PrimaryPath(Entity):
                        """
                        Primary Segment\-Routing Path
                        
                        .. attribute:: backup_path_id
                        
                        	Backup Path Identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: next_hop
                        
                        	Next hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: outgoing_interface
                        
                        	Outgoing Interface Name
                        	**type**\:  str
                        
                        .. attribute:: outgoing_label
                        
                        	Outgoing Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: outgoing_strict_label
                        
                        	Outgoing Label for Strict SPF
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_id
                        
                        	Path Identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath, self).__init__()

                            self.yang_name = "primary-path"
                            self.yang_parent_name = "sr-path"

                            self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                            self.next_hop = YLeaf(YType.str, "next-hop")

                            self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                            self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                            self.outgoing_strict_label = YLeaf(YType.uint32, "outgoing-strict-label")

                            self.path_id = YLeaf(YType.uint32, "path-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_path_id",
                                            "next_hop",
                                            "outgoing_interface",
                                            "outgoing_label",
                                            "outgoing_strict_label",
                                            "path_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backup_path_id.is_set or
                                self.next_hop.is_set or
                                self.outgoing_interface.is_set or
                                self.outgoing_label.is_set or
                                self.outgoing_strict_label.is_set or
                                self.path_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_path_id.yfilter != YFilter.not_set or
                                self.next_hop.yfilter != YFilter.not_set or
                                self.outgoing_interface.yfilter != YFilter.not_set or
                                self.outgoing_label.yfilter != YFilter.not_set or
                                self.outgoing_strict_label.yfilter != YFilter.not_set or
                                self.path_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "primary-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                            if (self.next_hop.is_set or self.next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop.get_name_leafdata())
                            if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outgoing_interface.get_name_leafdata())
                            if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                            if (self.outgoing_strict_label.is_set or self.outgoing_strict_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outgoing_strict_label.get_name_leafdata())
                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-path-id" or name == "next-hop" or name == "outgoing-interface" or name == "outgoing-label" or name == "outgoing-strict-label" or name == "path-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-path-id"):
                                self.backup_path_id = value
                                self.backup_path_id.value_namespace = name_space
                                self.backup_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop"):
                                self.next_hop = value
                                self.next_hop.value_namespace = name_space
                                self.next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "outgoing-interface"):
                                self.outgoing_interface = value
                                self.outgoing_interface.value_namespace = name_space
                                self.outgoing_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "outgoing-label"):
                                self.outgoing_label = value
                                self.outgoing_label.value_namespace = name_space
                                self.outgoing_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "outgoing-strict-label"):
                                self.outgoing_strict_label = value
                                self.outgoing_strict_label.value_namespace = name_space
                                self.outgoing_strict_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-id"):
                                self.path_id = value
                                self.path_id.value_namespace = name_space
                                self.path_id.value_namespace_prefix = name_space_prefix


                    class BackupPath(Entity):
                        """
                        Backup Segment\-Routing Path
                        
                        .. attribute:: next_hop
                        
                        	Next hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: outgoing_interface
                        
                        	Outgoing Interface Name
                        	**type**\:  str
                        
                        .. attribute:: outgoing_labels_stack
                        
                        	Outgoing Labels Stack
                        	**type**\: list of    :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack>`
                        
                        .. attribute:: outgoing_strict_labels_stack
                        
                        	Outgoing Labels Stack for Strict SPF
                        	**type**\: list of    :py:class:`OutgoingStrictLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath, self).__init__()

                            self.yang_name = "backup-path"
                            self.yang_parent_name = "sr-path"

                            self.next_hop = YLeaf(YType.str, "next-hop")

                            self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                            self.outgoing_labels_stack = YList(self)
                            self.outgoing_strict_labels_stack = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("next_hop",
                                            "outgoing_interface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath, self).__setattr__(name, value)


                        class OutgoingLabelsStack(Entity):
                            """
                            Outgoing Labels Stack
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack, self).__init__()

                                self.yang_name = "outgoing-labels-stack"
                                self.yang_parent_name = "backup-path"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "outgoing-labels-stack" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class OutgoingStrictLabelsStack(Entity):
                            """
                            Outgoing Labels Stack for Strict SPF
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack, self).__init__()

                                self.yang_name = "outgoing-strict-labels-stack"
                                self.yang_parent_name = "backup-path"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "outgoing-strict-labels-stack" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.outgoing_labels_stack:
                                if (c.has_data()):
                                    return True
                            for c in self.outgoing_strict_labels_stack:
                                if (c.has_data()):
                                    return True
                            return (
                                self.next_hop.is_set or
                                self.outgoing_interface.is_set)

                        def has_operation(self):
                            for c in self.outgoing_labels_stack:
                                if (c.has_operation()):
                                    return True
                            for c in self.outgoing_strict_labels_stack:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.next_hop.yfilter != YFilter.not_set or
                                self.outgoing_interface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backup-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.next_hop.is_set or self.next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop.get_name_leafdata())
                            if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outgoing_interface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "outgoing-labels-stack"):
                                for c in self.outgoing_labels_stack:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.outgoing_labels_stack.append(c)
                                return c

                            if (child_yang_name == "outgoing-strict-labels-stack"):
                                for c in self.outgoing_strict_labels_stack:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.outgoing_strict_labels_stack.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "outgoing-labels-stack" or name == "outgoing-strict-labels-stack" or name == "next-hop" or name == "outgoing-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "next-hop"):
                                self.next_hop = value
                                self.next_hop.value_namespace = name_space
                                self.next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "outgoing-interface"):
                                self.outgoing_interface = value
                                self.outgoing_interface.value_namespace = name_space
                                self.outgoing_interface.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.has_backup_path.is_set or
                            (self.backup_path is not None and self.backup_path.has_data()) or
                            (self.primary_path is not None and self.primary_path.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.has_backup_path.yfilter != YFilter.not_set or
                            (self.backup_path is not None and self.backup_path.has_operation()) or
                            (self.primary_path is not None and self.primary_path.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.has_backup_path.is_set or self.has_backup_path.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_backup_path.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "backup-path"):
                            if (self.backup_path is None):
                                self.backup_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath()
                                self.backup_path.parent = self
                                self._children_name_map["backup_path"] = "backup-path"
                            return self.backup_path

                        if (child_yang_name == "primary-path"):
                            if (self.primary_path is None):
                                self.primary_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath()
                                self.primary_path.parent = self
                                self._children_name_map["primary_path"] = "primary-path"
                            return self.primary_path

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backup-path" or name == "primary-path" or name == "has-backup-path"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "has-backup-path"):
                            self.has_backup_path = value
                            self.has_backup_path.value_namespace = name_space
                            self.has_backup_path.value_namespace_prefix = name_space_prefix


                class AdvertizingNode(Entity):
                    """
                    Advertizing nodes
                    
                    .. attribute:: node_id
                    
                    	Node Identifier
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode, self).__init__()

                        self.yang_name = "advertizing-node"
                        self.yang_parent_name = "sr-prefix-info"

                        self.node_id = YLeaf(YType.str, "node-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("node_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode, self).__setattr__(name, value)

                    def has_data(self):
                        return self.node_id.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "advertizing-node" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "node-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix


                class StrictAdvertizingNode(Entity):
                    """
                    Advertizing nodes for Strict SPF
                    
                    .. attribute:: node_id
                    
                    	Node Identifier
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode, self).__init__()

                        self.yang_name = "strict-advertizing-node"
                        self.yang_parent_name = "sr-prefix-info"

                        self.node_id = YLeaf(YType.str, "node-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("node_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode, self).__setattr__(name, value)

                    def has_data(self):
                        return self.node_id.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "strict-advertizing-node" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "node-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.advertizing_node:
                        if (c.has_data()):
                            return True
                    for c in self.sr_path:
                        if (c.has_data()):
                            return True
                    for c in self.strict_advertizing_node:
                        if (c.has_data()):
                            return True
                    return (
                        self.protocol.is_set or
                        self.igp_instance.is_set or
                        self.area.is_set or
                        self.prefix.is_set or
                        self.prefix_length.is_set or
                        self.flag_e.is_set or
                        self.flag_l.is_set or
                        self.flag_n.is_set or
                        self.flag_p.is_set or
                        self.flag_r.is_set or
                        self.flag_v.is_set or
                        self.prefix_length_xr.is_set or
                        self.prefix_sid.is_set or
                        self.prefix_strict_sid.is_set or
                        self.prefix_xr.is_set or
                        self.strict_flag_e.is_set or
                        self.strict_flag_l.is_set or
                        self.strict_flag_p.is_set or
                        self.strict_flag_v.is_set or
                        (self.igp_area is not None and self.igp_area.has_data()))

                def has_operation(self):
                    for c in self.advertizing_node:
                        if (c.has_operation()):
                            return True
                    for c in self.sr_path:
                        if (c.has_operation()):
                            return True
                    for c in self.strict_advertizing_node:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.prefix.yfilter != YFilter.not_set or
                        self.prefix_length.yfilter != YFilter.not_set or
                        self.flag_e.yfilter != YFilter.not_set or
                        self.flag_l.yfilter != YFilter.not_set or
                        self.flag_n.yfilter != YFilter.not_set or
                        self.flag_p.yfilter != YFilter.not_set or
                        self.flag_r.yfilter != YFilter.not_set or
                        self.flag_v.yfilter != YFilter.not_set or
                        self.prefix_length_xr.yfilter != YFilter.not_set or
                        self.prefix_sid.yfilter != YFilter.not_set or
                        self.prefix_strict_sid.yfilter != YFilter.not_set or
                        self.prefix_xr.yfilter != YFilter.not_set or
                        self.strict_flag_e.yfilter != YFilter.not_set or
                        self.strict_flag_l.yfilter != YFilter.not_set or
                        self.strict_flag_p.yfilter != YFilter.not_set or
                        self.strict_flag_v.yfilter != YFilter.not_set or
                        (self.igp_area is not None and self.igp_area.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sr-prefix-info" + "[protocol='" + self.protocol.get() + "']" + "[igp-instance='" + self.igp_instance.get() + "']" + "[area='" + self.area.get() + "']" + "[prefix='" + self.prefix.get() + "']" + "[prefix-length='" + self.prefix_length.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/sr-prefix-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix.get_name_leafdata())
                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                    if (self.flag_e.is_set or self.flag_e.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_e.get_name_leafdata())
                    if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_l.get_name_leafdata())
                    if (self.flag_n.is_set or self.flag_n.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_n.get_name_leafdata())
                    if (self.flag_p.is_set or self.flag_p.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_p.get_name_leafdata())
                    if (self.flag_r.is_set or self.flag_r.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_r.get_name_leafdata())
                    if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flag_v.get_name_leafdata())
                    if (self.prefix_length_xr.is_set or self.prefix_length_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_length_xr.get_name_leafdata())
                    if (self.prefix_sid.is_set or self.prefix_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_sid.get_name_leafdata())
                    if (self.prefix_strict_sid.is_set or self.prefix_strict_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_strict_sid.get_name_leafdata())
                    if (self.prefix_xr.is_set or self.prefix_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_xr.get_name_leafdata())
                    if (self.strict_flag_e.is_set or self.strict_flag_e.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.strict_flag_e.get_name_leafdata())
                    if (self.strict_flag_l.is_set or self.strict_flag_l.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.strict_flag_l.get_name_leafdata())
                    if (self.strict_flag_p.is_set or self.strict_flag_p.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.strict_flag_p.get_name_leafdata())
                    if (self.strict_flag_v.is_set or self.strict_flag_v.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.strict_flag_v.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "advertizing-node"):
                        for c in self.advertizing_node:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.advertizing_node.append(c)
                        return c

                    if (child_yang_name == "igp-area"):
                        if (self.igp_area is None):
                            self.igp_area = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea()
                            self.igp_area.parent = self
                            self._children_name_map["igp_area"] = "igp-area"
                        return self.igp_area

                    if (child_yang_name == "sr-path"):
                        for c in self.sr_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.sr_path.append(c)
                        return c

                    if (child_yang_name == "strict-advertizing-node"):
                        for c in self.strict_advertizing_node:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.strict_advertizing_node.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "advertizing-node" or name == "igp-area" or name == "sr-path" or name == "strict-advertizing-node" or name == "protocol" or name == "igp-instance" or name == "area" or name == "prefix" or name == "prefix-length" or name == "flag-e" or name == "flag-l" or name == "flag-n" or name == "flag-p" or name == "flag-r" or name == "flag-v" or name == "prefix-length-xr" or name == "prefix-sid" or name == "prefix-strict-sid" or name == "prefix-xr" or name == "strict-flag-e" or name == "strict-flag-l" or name == "strict-flag-p" or name == "strict-flag-v"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix"):
                        self.prefix = value
                        self.prefix.value_namespace = name_space
                        self.prefix.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-length"):
                        self.prefix_length = value
                        self.prefix_length.value_namespace = name_space
                        self.prefix_length.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-e"):
                        self.flag_e = value
                        self.flag_e.value_namespace = name_space
                        self.flag_e.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-l"):
                        self.flag_l = value
                        self.flag_l.value_namespace = name_space
                        self.flag_l.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-n"):
                        self.flag_n = value
                        self.flag_n.value_namespace = name_space
                        self.flag_n.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-p"):
                        self.flag_p = value
                        self.flag_p.value_namespace = name_space
                        self.flag_p.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-r"):
                        self.flag_r = value
                        self.flag_r.value_namespace = name_space
                        self.flag_r.value_namespace_prefix = name_space_prefix
                    if(value_path == "flag-v"):
                        self.flag_v = value
                        self.flag_v.value_namespace = name_space
                        self.flag_v.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-length-xr"):
                        self.prefix_length_xr = value
                        self.prefix_length_xr.value_namespace = name_space
                        self.prefix_length_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-sid"):
                        self.prefix_sid = value
                        self.prefix_sid.value_namespace = name_space
                        self.prefix_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-strict-sid"):
                        self.prefix_strict_sid = value
                        self.prefix_strict_sid.value_namespace = name_space
                        self.prefix_strict_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-xr"):
                        self.prefix_xr = value
                        self.prefix_xr.value_namespace = name_space
                        self.prefix_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "strict-flag-e"):
                        self.strict_flag_e = value
                        self.strict_flag_e.value_namespace = name_space
                        self.strict_flag_e.value_namespace_prefix = name_space_prefix
                    if(value_path == "strict-flag-l"):
                        self.strict_flag_l = value
                        self.strict_flag_l.value_namespace = name_space
                        self.strict_flag_l.value_namespace_prefix = name_space_prefix
                    if(value_path == "strict-flag-p"):
                        self.strict_flag_p = value
                        self.strict_flag_p.value_namespace = name_space
                        self.strict_flag_p.value_namespace_prefix = name_space_prefix
                    if(value_path == "strict-flag-v"):
                        self.strict_flag_v = value
                        self.strict_flag_v.value_namespace = name_space
                        self.strict_flag_v.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.sr_prefix_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.sr_prefix_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "sr-prefix-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sr-prefix-info"):
                    for c in self.sr_prefix_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.sr_prefix_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sr-prefix-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.sr_node_infos is not None and self.sr_node_infos.has_data()) or
                (self.sr_prefix_infos is not None and self.sr_prefix_infos.has_data()) or
                (self.srigp_area_infos is not None and self.srigp_area_infos.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.sr_node_infos is not None and self.sr_node_infos.has_operation()) or
                (self.sr_prefix_infos is not None and self.sr_prefix_infos.has_operation()) or
                (self.srigp_area_infos is not None and self.srigp_area_infos.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "segment-routing" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "sr-node-infos"):
                if (self.sr_node_infos is None):
                    self.sr_node_infos = MplsTe.SegmentRouting.SrNodeInfos()
                    self.sr_node_infos.parent = self
                    self._children_name_map["sr_node_infos"] = "sr-node-infos"
                return self.sr_node_infos

            if (child_yang_name == "sr-prefix-infos"):
                if (self.sr_prefix_infos is None):
                    self.sr_prefix_infos = MplsTe.SegmentRouting.SrPrefixInfos()
                    self.sr_prefix_infos.parent = self
                    self._children_name_map["sr_prefix_infos"] = "sr-prefix-infos"
                return self.sr_prefix_infos

            if (child_yang_name == "srigp-area-infos"):
                if (self.srigp_area_infos is None):
                    self.srigp_area_infos = MplsTe.SegmentRouting.SrigpAreaInfos()
                    self.srigp_area_infos.parent = self
                    self._children_name_map["srigp_area_infos"] = "srigp-area-infos"
                return self.srigp_area_infos

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "sr-node-infos" or name == "sr-prefix-infos" or name == "srigp-area-infos"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FibNextHopRoutes(Entity):
        """
        MPLS TE FIB nexthop route database
        
        .. attribute:: fib_next_hop_route
        
        	MPLS TE FIB nexthop route
        	**type**\: list of    :py:class:`FibNextHopRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.FibNextHopRoutes, self).__init__()

            self.yang_name = "fib-next-hop-routes"
            self.yang_parent_name = "mpls-te"

            self.fib_next_hop_route = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.FibNextHopRoutes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.FibNextHopRoutes, self).__setattr__(name, value)


        class FibNextHopRoute(Entity):
            """
            MPLS TE FIB nexthop route
            
            .. attribute:: prefix_address  <key>
            
            	Prefix Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\:  bool
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\:  bool
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\:  bool
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of    :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath>`
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: route_version
            
            	Route version
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FibNextHopRoutes.FibNextHopRoute, self).__init__()

                self.yang_name = "fib-next-hop-route"
                self.yang_parent_name = "fib-next-hop-routes"

                self.prefix_address = YLeaf(YType.str, "prefix-address")

                self.create_time = YLeaf(YType.uint32, "create-time")

                self.expire_time = YLeaf(YType.uint32, "expire-time")

                self.is_notified = YLeaf(YType.boolean, "is-notified")

                self.is_registered = YLeaf(YType.boolean, "is-registered")

                self.is_stale = YLeaf(YType.boolean, "is-stale")

                self.last_update_time = YLeaf(YType.uint32, "last-update-time")

                self.last_used_time = YLeaf(YType.uint32, "last-used-time")

                self.prefix_addr = YLeaf(YType.str, "prefix-addr")

                self.route_version = YLeaf(YType.uint64, "route-version")

                self.target_address = MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"
                self._children_yang_names.add("target-address")

                self.next_hop_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("prefix_address",
                                "create_time",
                                "expire_time",
                                "is_notified",
                                "is_registered",
                                "is_stale",
                                "last_update_time",
                                "last_used_time",
                                "prefix_addr",
                                "route_version") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FibNextHopRoutes.FibNextHopRoute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FibNextHopRoutes.FibNextHopRoute, self).__setattr__(name, value)


            class TargetAddress(Entity):
                """
                Next Hop Target Address
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: type
                
                	type
                	**type**\:   :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-route"

                    self.ip_address = YLeaf(YType.str, "ip-address")

                    self.label = YLeaf(YType.uint32, "label")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ip_address",
                                    "label",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.ip_address.is_set or
                        self.label.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ip_address.yfilter != YFilter.not_set or
                        self.label.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "target-address" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ip_address.is_set or self.ip_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ip_address.get_name_leafdata())
                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ip-address" or name == "label" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ip-address"):
                        self.ip_address = value
                        self.ip_address.value_namespace = name_space
                        self.ip_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "label"):
                        self.label = value
                        self.label.value_namespace = name_space
                        self.label.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix


            class NextHopPath(Entity):
                """
                Next Hop Paths
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of    :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack>`
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-route"

                    self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                    self.interface = YLeaf(YType.str, "interface")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.path_id = YLeaf(YType.uint32, "path-id")

                    self.pure_backup = YLeaf(YType.boolean, "pure-backup")

                    self.label_stack = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("backup_path_id",
                                    "interface",
                                    "next_hop_address",
                                    "path_id",
                                    "pure_backup") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath, self).__setattr__(name, value)


                class LabelStack(Entity):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "label-stack" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.label_stack:
                        if (c.has_data()):
                            return True
                    return (
                        self.backup_path_id.is_set or
                        self.interface.is_set or
                        self.next_hop_address.is_set or
                        self.path_id.is_set or
                        self.pure_backup.is_set)

                def has_operation(self):
                    for c in self.label_stack:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.backup_path_id.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.path_id.yfilter != YFilter.not_set or
                        self.pure_backup.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "next-hop-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_id.get_name_leafdata())
                    if (self.pure_backup.is_set or self.pure_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pure_backup.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "label-stack"):
                        for c in self.label_stack:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.label_stack.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "label-stack" or name == "backup-path-id" or name == "interface" or name == "next-hop-address" or name == "path-id" or name == "pure-backup"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "backup-path-id"):
                        self.backup_path_id = value
                        self.backup_path_id.value_namespace = name_space
                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-id"):
                        self.path_id = value
                        self.path_id.value_namespace = name_space
                        self.path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "pure-backup"):
                        self.pure_backup = value
                        self.pure_backup.value_namespace = name_space
                        self.pure_backup.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.next_hop_path:
                    if (c.has_data()):
                        return True
                return (
                    self.prefix_address.is_set or
                    self.create_time.is_set or
                    self.expire_time.is_set or
                    self.is_notified.is_set or
                    self.is_registered.is_set or
                    self.is_stale.is_set or
                    self.last_update_time.is_set or
                    self.last_used_time.is_set or
                    self.prefix_addr.is_set or
                    self.route_version.is_set or
                    (self.target_address is not None and self.target_address.has_data()))

            def has_operation(self):
                for c in self.next_hop_path:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.prefix_address.yfilter != YFilter.not_set or
                    self.create_time.yfilter != YFilter.not_set or
                    self.expire_time.yfilter != YFilter.not_set or
                    self.is_notified.yfilter != YFilter.not_set or
                    self.is_registered.yfilter != YFilter.not_set or
                    self.is_stale.yfilter != YFilter.not_set or
                    self.last_update_time.yfilter != YFilter.not_set or
                    self.last_used_time.yfilter != YFilter.not_set or
                    self.prefix_addr.yfilter != YFilter.not_set or
                    self.route_version.yfilter != YFilter.not_set or
                    (self.target_address is not None and self.target_address.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "fib-next-hop-route" + "[prefix-address='" + self.prefix_address.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fib-next-hop-routes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.prefix_address.is_set or self.prefix_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_address.get_name_leafdata())
                if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create_time.get_name_leafdata())
                if (self.expire_time.is_set or self.expire_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expire_time.get_name_leafdata())
                if (self.is_notified.is_set or self.is_notified.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_notified.get_name_leafdata())
                if (self.is_registered.is_set or self.is_registered.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_registered.get_name_leafdata())
                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                if (self.last_update_time.is_set or self.last_update_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_update_time.get_name_leafdata())
                if (self.last_used_time.is_set or self.last_used_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_used_time.get_name_leafdata())
                if (self.prefix_addr.is_set or self.prefix_addr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_addr.get_name_leafdata())
                if (self.route_version.is_set or self.route_version.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.route_version.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "next-hop-path"):
                    for c in self.next_hop_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.next_hop_path.append(c)
                    return c

                if (child_yang_name == "target-address"):
                    if (self.target_address is None):
                        self.target_address = MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress()
                        self.target_address.parent = self
                        self._children_name_map["target_address"] = "target-address"
                    return self.target_address

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "next-hop-path" or name == "target-address" or name == "prefix-address" or name == "create-time" or name == "expire-time" or name == "is-notified" or name == "is-registered" or name == "is-stale" or name == "last-update-time" or name == "last-used-time" or name == "prefix-addr" or name == "route-version"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "prefix-address"):
                    self.prefix_address = value
                    self.prefix_address.value_namespace = name_space
                    self.prefix_address.value_namespace_prefix = name_space_prefix
                if(value_path == "create-time"):
                    self.create_time = value
                    self.create_time.value_namespace = name_space
                    self.create_time.value_namespace_prefix = name_space_prefix
                if(value_path == "expire-time"):
                    self.expire_time = value
                    self.expire_time.value_namespace = name_space
                    self.expire_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-notified"):
                    self.is_notified = value
                    self.is_notified.value_namespace = name_space
                    self.is_notified.value_namespace_prefix = name_space_prefix
                if(value_path == "is-registered"):
                    self.is_registered = value
                    self.is_registered.value_namespace = name_space
                    self.is_registered.value_namespace_prefix = name_space_prefix
                if(value_path == "is-stale"):
                    self.is_stale = value
                    self.is_stale.value_namespace = name_space
                    self.is_stale.value_namespace_prefix = name_space_prefix
                if(value_path == "last-update-time"):
                    self.last_update_time = value
                    self.last_update_time.value_namespace = name_space
                    self.last_update_time.value_namespace_prefix = name_space_prefix
                if(value_path == "last-used-time"):
                    self.last_used_time = value
                    self.last_used_time.value_namespace = name_space
                    self.last_used_time.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-addr"):
                    self.prefix_addr = value
                    self.prefix_addr.value_namespace = name_space
                    self.prefix_addr.value_namespace_prefix = name_space_prefix
                if(value_path == "route-version"):
                    self.route_version = value
                    self.route_version.value_namespace = name_space
                    self.route_version.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.fib_next_hop_route:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.fib_next_hop_route:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "fib-next-hop-routes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "fib-next-hop-route"):
                for c in self.fib_next_hop_route:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.FibNextHopRoutes.FibNextHopRoute()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.fib_next_hop_route.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "fib-next-hop-route"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class NextHopRoutes(Entity):
        """
        MPLS TE nexthop route database
        
        .. attribute:: next_hop_route
        
        	MPLS TE nexthop route
        	**type**\: list of    :py:class:`NextHopRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.NextHopRoutes, self).__init__()

            self.yang_name = "next-hop-routes"
            self.yang_parent_name = "mpls-te"

            self.next_hop_route = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.NextHopRoutes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.NextHopRoutes, self).__setattr__(name, value)


        class NextHopRoute(Entity):
            """
            MPLS TE nexthop route
            
            .. attribute:: active_route
            
            	active route
            	**type**\:   :py:class:`ActiveRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute>`
            
            .. attribute:: backup_route
            
            	backup route
            	**type**\:   :py:class:`BackupRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.BackupRoute>`
            
            .. attribute:: create_time
            
            	CreateTime
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: exact_match
            
            	ExactMatch
            	**type**\:  bool
            
            .. attribute:: expire_time
            
            	ExpireTime
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: installed_tunnel_path_num
            
            	InstalledTunnelPathNum
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_used_time
            
            	LastUsedTime
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_hop_type
            
            	Next\-hop Route Type
            	**type**\:   :py:class:`MplsTeNextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNextHop>`
            
            .. attribute:: prefix_address
            
            	Prefix Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: prefix_address_xr
            
            	prefix address xr
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: prefix_length
            
            	Prefix Length
            	**type**\:  int
            
            	**range:** 0..32
            
            .. attribute:: prefix_length_xr
            
            	prefix length xr
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tunnel_path
            
            	tunnel path
            	**type**\: list of    :py:class:`TunnelPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.TunnelPath>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.NextHopRoutes.NextHopRoute, self).__init__()

                self.yang_name = "next-hop-route"
                self.yang_parent_name = "next-hop-routes"

                self.create_time = YLeaf(YType.uint32, "create-time")

                self.exact_match = YLeaf(YType.boolean, "exact-match")

                self.expire_time = YLeaf(YType.uint32, "expire-time")

                self.installed_tunnel_path_num = YLeaf(YType.uint32, "installed-tunnel-path-num")

                self.last_used_time = YLeaf(YType.uint32, "last-used-time")

                self.next_hop_type = YLeaf(YType.enumeration, "next-hop-type")

                self.prefix_address = YLeaf(YType.str, "prefix-address")

                self.prefix_address_xr = YLeaf(YType.str, "prefix-address-xr")

                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                self.prefix_length_xr = YLeaf(YType.uint32, "prefix-length-xr")

                self.active_route = MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute()
                self.active_route.parent = self
                self._children_name_map["active_route"] = "active-route"
                self._children_yang_names.add("active-route")

                self.backup_route = MplsTe.NextHopRoutes.NextHopRoute.BackupRoute()
                self.backup_route.parent = self
                self._children_name_map["backup_route"] = "backup-route"
                self._children_yang_names.add("backup-route")

                self.tunnel_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("create_time",
                                "exact_match",
                                "expire_time",
                                "installed_tunnel_path_num",
                                "last_used_time",
                                "next_hop_type",
                                "prefix_address",
                                "prefix_address_xr",
                                "prefix_length",
                                "prefix_length_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.NextHopRoutes.NextHopRoute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.NextHopRoutes.NextHopRoute, self).__setattr__(name, value)


            class ActiveRoute(Entity):
                """
                active route
                
                .. attribute:: is_connected
                
                	IsConnected
                	**type**\:  bool
                
                .. attribute:: is_default
                
                	IsDefault
                	**type**\:  bool
                
                .. attribute:: is_populated
                
                	IsPopulated
                	**type**\:  bool
                
                .. attribute:: is_registered
                
                	IsRegistered
                	**type**\:  bool
                
                .. attribute:: is_stale
                
                	IsStale
                	**type**\:  bool
                
                .. attribute:: last_update_time
                
                	LastUpdateTime
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_path
                
                	next hop path
                	**type**\: list of    :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath>`
                
                .. attribute:: route_distance
                
                	RouteDistance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: route_metric
                
                	RouteMetric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: route_protocol_name
                
                	RouteProtocolName
                	**type**\:  str
                
                .. attribute:: route_type
                
                	RouteType
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute, self).__init__()

                    self.yang_name = "active-route"
                    self.yang_parent_name = "next-hop-route"

                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                    self.is_default = YLeaf(YType.boolean, "is-default")

                    self.is_populated = YLeaf(YType.boolean, "is-populated")

                    self.is_registered = YLeaf(YType.boolean, "is-registered")

                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                    self.last_update_time = YLeaf(YType.uint32, "last-update-time")

                    self.route_distance = YLeaf(YType.uint32, "route-distance")

                    self.route_metric = YLeaf(YType.uint32, "route-metric")

                    self.route_protocol_name = YLeaf(YType.str, "route-protocol-name")

                    self.route_type = YLeaf(YType.uint16, "route-type")

                    self.next_hop_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_connected",
                                    "is_default",
                                    "is_populated",
                                    "is_registered",
                                    "is_stale",
                                    "last_update_time",
                                    "route_distance",
                                    "route_metric",
                                    "route_protocol_name",
                                    "route_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute, self).__setattr__(name, value)


                class NextHopPath(Entity):
                    """
                    next hop path
                    
                    .. attribute:: abr_address
                    
                    	ABRAddress
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: address
                    
                    	Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: interface
                    
                    	Interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath, self).__init__()

                        self.yang_name = "next-hop-path"
                        self.yang_parent_name = "active-route"

                        self.abr_address = YLeaf(YType.str, "abr-address")

                        self.address = YLeaf(YType.str, "address")

                        self.interface = YLeaf(YType.str, "interface")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("abr_address",
                                        "address",
                                        "interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.abr_address.is_set or
                            self.address.is_set or
                            self.interface.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.abr_address.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.interface.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "next-hop-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/active-route/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.abr_address.is_set or self.abr_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.abr_address.get_name_leafdata())
                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address.get_name_leafdata())
                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "abr-address" or name == "address" or name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "abr-address"):
                            self.abr_address = value
                            self.abr_address.value_namespace = name_space
                            self.abr_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "address"):
                            self.address = value
                            self.address.value_namespace = name_space
                            self.address.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface"):
                            self.interface = value
                            self.interface.value_namespace = name_space
                            self.interface.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.next_hop_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.is_connected.is_set or
                        self.is_default.is_set or
                        self.is_populated.is_set or
                        self.is_registered.is_set or
                        self.is_stale.is_set or
                        self.last_update_time.is_set or
                        self.route_distance.is_set or
                        self.route_metric.is_set or
                        self.route_protocol_name.is_set or
                        self.route_type.is_set)

                def has_operation(self):
                    for c in self.next_hop_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_connected.yfilter != YFilter.not_set or
                        self.is_default.yfilter != YFilter.not_set or
                        self.is_populated.yfilter != YFilter.not_set or
                        self.is_registered.yfilter != YFilter.not_set or
                        self.is_stale.yfilter != YFilter.not_set or
                        self.last_update_time.yfilter != YFilter.not_set or
                        self.route_distance.yfilter != YFilter.not_set or
                        self.route_metric.yfilter != YFilter.not_set or
                        self.route_protocol_name.yfilter != YFilter.not_set or
                        self.route_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "active-route" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_default.get_name_leafdata())
                    if (self.is_populated.is_set or self.is_populated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_populated.get_name_leafdata())
                    if (self.is_registered.is_set or self.is_registered.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered.get_name_leafdata())
                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                    if (self.last_update_time.is_set or self.last_update_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_update_time.get_name_leafdata())
                    if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_distance.get_name_leafdata())
                    if (self.route_metric.is_set or self.route_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_metric.get_name_leafdata())
                    if (self.route_protocol_name.is_set or self.route_protocol_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_protocol_name.get_name_leafdata())
                    if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "next-hop-path"):
                        for c in self.next_hop_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.next_hop_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "next-hop-path" or name == "is-connected" or name == "is-default" or name == "is-populated" or name == "is-registered" or name == "is-stale" or name == "last-update-time" or name == "route-distance" or name == "route-metric" or name == "route-protocol-name" or name == "route-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-connected"):
                        self.is_connected = value
                        self.is_connected.value_namespace = name_space
                        self.is_connected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-default"):
                        self.is_default = value
                        self.is_default.value_namespace = name_space
                        self.is_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-populated"):
                        self.is_populated = value
                        self.is_populated.value_namespace = name_space
                        self.is_populated.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered"):
                        self.is_registered = value
                        self.is_registered.value_namespace = name_space
                        self.is_registered.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-stale"):
                        self.is_stale = value
                        self.is_stale.value_namespace = name_space
                        self.is_stale.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-update-time"):
                        self.last_update_time = value
                        self.last_update_time.value_namespace = name_space
                        self.last_update_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-distance"):
                        self.route_distance = value
                        self.route_distance.value_namespace = name_space
                        self.route_distance.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-metric"):
                        self.route_metric = value
                        self.route_metric.value_namespace = name_space
                        self.route_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-protocol-name"):
                        self.route_protocol_name = value
                        self.route_protocol_name.value_namespace = name_space
                        self.route_protocol_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-type"):
                        self.route_type = value
                        self.route_type.value_namespace = name_space
                        self.route_type.value_namespace_prefix = name_space_prefix


            class BackupRoute(Entity):
                """
                backup route
                
                .. attribute:: is_connected
                
                	IsConnected
                	**type**\:  bool
                
                .. attribute:: is_default
                
                	IsDefault
                	**type**\:  bool
                
                .. attribute:: is_populated
                
                	IsPopulated
                	**type**\:  bool
                
                .. attribute:: is_registered
                
                	IsRegistered
                	**type**\:  bool
                
                .. attribute:: is_stale
                
                	IsStale
                	**type**\:  bool
                
                .. attribute:: last_update_time
                
                	LastUpdateTime
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_path
                
                	next hop path
                	**type**\: list of    :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath>`
                
                .. attribute:: route_distance
                
                	RouteDistance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: route_metric
                
                	RouteMetric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: route_protocol_name
                
                	RouteProtocolName
                	**type**\:  str
                
                .. attribute:: route_type
                
                	RouteType
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute, self).__init__()

                    self.yang_name = "backup-route"
                    self.yang_parent_name = "next-hop-route"

                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                    self.is_default = YLeaf(YType.boolean, "is-default")

                    self.is_populated = YLeaf(YType.boolean, "is-populated")

                    self.is_registered = YLeaf(YType.boolean, "is-registered")

                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                    self.last_update_time = YLeaf(YType.uint32, "last-update-time")

                    self.route_distance = YLeaf(YType.uint32, "route-distance")

                    self.route_metric = YLeaf(YType.uint32, "route-metric")

                    self.route_protocol_name = YLeaf(YType.str, "route-protocol-name")

                    self.route_type = YLeaf(YType.uint16, "route-type")

                    self.next_hop_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_connected",
                                    "is_default",
                                    "is_populated",
                                    "is_registered",
                                    "is_stale",
                                    "last_update_time",
                                    "route_distance",
                                    "route_metric",
                                    "route_protocol_name",
                                    "route_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute, self).__setattr__(name, value)


                class NextHopPath(Entity):
                    """
                    next hop path
                    
                    .. attribute:: abr_address
                    
                    	ABRAddress
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: address
                    
                    	Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: interface
                    
                    	Interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath, self).__init__()

                        self.yang_name = "next-hop-path"
                        self.yang_parent_name = "backup-route"

                        self.abr_address = YLeaf(YType.str, "abr-address")

                        self.address = YLeaf(YType.str, "address")

                        self.interface = YLeaf(YType.str, "interface")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("abr_address",
                                        "address",
                                        "interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.abr_address.is_set or
                            self.address.is_set or
                            self.interface.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.abr_address.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.interface.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "next-hop-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/backup-route/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.abr_address.is_set or self.abr_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.abr_address.get_name_leafdata())
                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address.get_name_leafdata())
                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "abr-address" or name == "address" or name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "abr-address"):
                            self.abr_address = value
                            self.abr_address.value_namespace = name_space
                            self.abr_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "address"):
                            self.address = value
                            self.address.value_namespace = name_space
                            self.address.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface"):
                            self.interface = value
                            self.interface.value_namespace = name_space
                            self.interface.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.next_hop_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.is_connected.is_set or
                        self.is_default.is_set or
                        self.is_populated.is_set or
                        self.is_registered.is_set or
                        self.is_stale.is_set or
                        self.last_update_time.is_set or
                        self.route_distance.is_set or
                        self.route_metric.is_set or
                        self.route_protocol_name.is_set or
                        self.route_type.is_set)

                def has_operation(self):
                    for c in self.next_hop_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_connected.yfilter != YFilter.not_set or
                        self.is_default.yfilter != YFilter.not_set or
                        self.is_populated.yfilter != YFilter.not_set or
                        self.is_registered.yfilter != YFilter.not_set or
                        self.is_stale.yfilter != YFilter.not_set or
                        self.last_update_time.yfilter != YFilter.not_set or
                        self.route_distance.yfilter != YFilter.not_set or
                        self.route_metric.yfilter != YFilter.not_set or
                        self.route_protocol_name.yfilter != YFilter.not_set or
                        self.route_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "backup-route" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_default.get_name_leafdata())
                    if (self.is_populated.is_set or self.is_populated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_populated.get_name_leafdata())
                    if (self.is_registered.is_set or self.is_registered.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered.get_name_leafdata())
                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                    if (self.last_update_time.is_set or self.last_update_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_update_time.get_name_leafdata())
                    if (self.route_distance.is_set or self.route_distance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_distance.get_name_leafdata())
                    if (self.route_metric.is_set or self.route_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_metric.get_name_leafdata())
                    if (self.route_protocol_name.is_set or self.route_protocol_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_protocol_name.get_name_leafdata())
                    if (self.route_type.is_set or self.route_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.route_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "next-hop-path"):
                        for c in self.next_hop_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.next_hop_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "next-hop-path" or name == "is-connected" or name == "is-default" or name == "is-populated" or name == "is-registered" or name == "is-stale" or name == "last-update-time" or name == "route-distance" or name == "route-metric" or name == "route-protocol-name" or name == "route-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-connected"):
                        self.is_connected = value
                        self.is_connected.value_namespace = name_space
                        self.is_connected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-default"):
                        self.is_default = value
                        self.is_default.value_namespace = name_space
                        self.is_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-populated"):
                        self.is_populated = value
                        self.is_populated.value_namespace = name_space
                        self.is_populated.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered"):
                        self.is_registered = value
                        self.is_registered.value_namespace = name_space
                        self.is_registered.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-stale"):
                        self.is_stale = value
                        self.is_stale.value_namespace = name_space
                        self.is_stale.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-update-time"):
                        self.last_update_time = value
                        self.last_update_time.value_namespace = name_space
                        self.last_update_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-distance"):
                        self.route_distance = value
                        self.route_distance.value_namespace = name_space
                        self.route_distance.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-metric"):
                        self.route_metric = value
                        self.route_metric.value_namespace = name_space
                        self.route_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-protocol-name"):
                        self.route_protocol_name = value
                        self.route_protocol_name.value_namespace = name_space
                        self.route_protocol_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "route-type"):
                        self.route_type = value
                        self.route_type.value_namespace = name_space
                        self.route_type.value_namespace_prefix = name_space_prefix


            class TunnelPath(Entity):
                """
                tunnel path
                
                .. attribute:: install_time
                
                	InstallTime
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: installed_metric
                
                	InstalledMetric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface_handle
                
                	InterfaceHandle
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: tunnel_id
                
                	TunnelID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.NextHopRoutes.NextHopRoute.TunnelPath, self).__init__()

                    self.yang_name = "tunnel-path"
                    self.yang_parent_name = "next-hop-route"

                    self.install_time = YLeaf(YType.uint32, "install-time")

                    self.installed_metric = YLeaf(YType.uint32, "installed-metric")

                    self.interface_handle = YLeaf(YType.str, "interface-handle")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("install_time",
                                    "installed_metric",
                                    "interface_handle",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.NextHopRoutes.NextHopRoute.TunnelPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.NextHopRoutes.NextHopRoute.TunnelPath, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.install_time.is_set or
                        self.installed_metric.is_set or
                        self.interface_handle.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.install_time.yfilter != YFilter.not_set or
                        self.installed_metric.yfilter != YFilter.not_set or
                        self.interface_handle.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.install_time.is_set or self.install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.install_time.get_name_leafdata())
                    if (self.installed_metric.is_set or self.installed_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.installed_metric.get_name_leafdata())
                    if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_handle.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "install-time" or name == "installed-metric" or name == "interface-handle" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "install-time"):
                        self.install_time = value
                        self.install_time.value_namespace = name_space
                        self.install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "installed-metric"):
                        self.installed_metric = value
                        self.installed_metric.value_namespace = name_space
                        self.installed_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-handle"):
                        self.interface_handle = value
                        self.interface_handle.value_namespace = name_space
                        self.interface_handle.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_path:
                    if (c.has_data()):
                        return True
                return (
                    self.create_time.is_set or
                    self.exact_match.is_set or
                    self.expire_time.is_set or
                    self.installed_tunnel_path_num.is_set or
                    self.last_used_time.is_set or
                    self.next_hop_type.is_set or
                    self.prefix_address.is_set or
                    self.prefix_address_xr.is_set or
                    self.prefix_length.is_set or
                    self.prefix_length_xr.is_set or
                    (self.active_route is not None and self.active_route.has_data()) or
                    (self.backup_route is not None and self.backup_route.has_data()))

            def has_operation(self):
                for c in self.tunnel_path:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.create_time.yfilter != YFilter.not_set or
                    self.exact_match.yfilter != YFilter.not_set or
                    self.expire_time.yfilter != YFilter.not_set or
                    self.installed_tunnel_path_num.yfilter != YFilter.not_set or
                    self.last_used_time.yfilter != YFilter.not_set or
                    self.next_hop_type.yfilter != YFilter.not_set or
                    self.prefix_address.yfilter != YFilter.not_set or
                    self.prefix_address_xr.yfilter != YFilter.not_set or
                    self.prefix_length.yfilter != YFilter.not_set or
                    self.prefix_length_xr.yfilter != YFilter.not_set or
                    (self.active_route is not None and self.active_route.has_operation()) or
                    (self.backup_route is not None and self.backup_route.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "next-hop-route" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create_time.get_name_leafdata())
                if (self.exact_match.is_set or self.exact_match.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.exact_match.get_name_leafdata())
                if (self.expire_time.is_set or self.expire_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expire_time.get_name_leafdata())
                if (self.installed_tunnel_path_num.is_set or self.installed_tunnel_path_num.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.installed_tunnel_path_num.get_name_leafdata())
                if (self.last_used_time.is_set or self.last_used_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_used_time.get_name_leafdata())
                if (self.next_hop_type.is_set or self.next_hop_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_hop_type.get_name_leafdata())
                if (self.prefix_address.is_set or self.prefix_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_address.get_name_leafdata())
                if (self.prefix_address_xr.is_set or self.prefix_address_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_address_xr.get_name_leafdata())
                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_length.get_name_leafdata())
                if (self.prefix_length_xr.is_set or self.prefix_length_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_length_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "active-route"):
                    if (self.active_route is None):
                        self.active_route = MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute()
                        self.active_route.parent = self
                        self._children_name_map["active_route"] = "active-route"
                    return self.active_route

                if (child_yang_name == "backup-route"):
                    if (self.backup_route is None):
                        self.backup_route = MplsTe.NextHopRoutes.NextHopRoute.BackupRoute()
                        self.backup_route.parent = self
                        self._children_name_map["backup_route"] = "backup-route"
                    return self.backup_route

                if (child_yang_name == "tunnel-path"):
                    for c in self.tunnel_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.NextHopRoutes.NextHopRoute.TunnelPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_path.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "active-route" or name == "backup-route" or name == "tunnel-path" or name == "create-time" or name == "exact-match" or name == "expire-time" or name == "installed-tunnel-path-num" or name == "last-used-time" or name == "next-hop-type" or name == "prefix-address" or name == "prefix-address-xr" or name == "prefix-length" or name == "prefix-length-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "create-time"):
                    self.create_time = value
                    self.create_time.value_namespace = name_space
                    self.create_time.value_namespace_prefix = name_space_prefix
                if(value_path == "exact-match"):
                    self.exact_match = value
                    self.exact_match.value_namespace = name_space
                    self.exact_match.value_namespace_prefix = name_space_prefix
                if(value_path == "expire-time"):
                    self.expire_time = value
                    self.expire_time.value_namespace = name_space
                    self.expire_time.value_namespace_prefix = name_space_prefix
                if(value_path == "installed-tunnel-path-num"):
                    self.installed_tunnel_path_num = value
                    self.installed_tunnel_path_num.value_namespace = name_space
                    self.installed_tunnel_path_num.value_namespace_prefix = name_space_prefix
                if(value_path == "last-used-time"):
                    self.last_used_time = value
                    self.last_used_time.value_namespace = name_space
                    self.last_used_time.value_namespace_prefix = name_space_prefix
                if(value_path == "next-hop-type"):
                    self.next_hop_type = value
                    self.next_hop_type.value_namespace = name_space
                    self.next_hop_type.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-address"):
                    self.prefix_address = value
                    self.prefix_address.value_namespace = name_space
                    self.prefix_address.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-address-xr"):
                    self.prefix_address_xr = value
                    self.prefix_address_xr.value_namespace = name_space
                    self.prefix_address_xr.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-length"):
                    self.prefix_length = value
                    self.prefix_length.value_namespace = name_space
                    self.prefix_length.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-length-xr"):
                    self.prefix_length_xr = value
                    self.prefix_length_xr.value_namespace = name_space
                    self.prefix_length_xr.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.next_hop_route:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.next_hop_route:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "next-hop-routes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "next-hop-route"):
                for c in self.next_hop_route:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.NextHopRoutes.NextHopRoute()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.next_hop_route.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "next-hop-route"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AutoRouteDestinationEntries(Entity):
        """
        MPLS TE autoroute destination table indexed by
        tunnel
        
        .. attribute:: auto_route_destination_entry
        
        	MPLS TE autoroute destination info for one tunnel
        	**type**\: list of    :py:class:`AutoRouteDestinationEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AutoRouteDestinationEntries, self).__init__()

            self.yang_name = "auto-route-destination-entries"
            self.yang_parent_name = "mpls-te"

            self.auto_route_destination_entry = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.AutoRouteDestinationEntries, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.AutoRouteDestinationEntries, self).__setattr__(name, value)


        class AutoRouteDestinationEntry(Entity):
            """
            MPLS TE autoroute destination info for one
            tunnel
            
            .. attribute:: tunnel_id  <key>
            
            	Tunnel ID
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: tunnel_autoroute_dest
            
            	tunnel autoroute dest
            	**type**\: list of    :py:class:`TunnelAutorouteDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest>`
            
            .. attribute:: tunnel_id_xr
            
            	tunnel id xr
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry, self).__init__()

                self.yang_name = "auto-route-destination-entry"
                self.yang_parent_name = "auto-route-destination-entries"

                self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                self.tunnel_id_xr = YLeaf(YType.uint16, "tunnel-id-xr")

                self.tunnel_autoroute_dest = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("tunnel_id",
                                "tunnel_id_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry, self).__setattr__(name, value)


            class TunnelAutorouteDest(Entity):
                """
                tunnel autoroute dest
                
                .. attribute:: install_time
                
                	InstallTime
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface_handle
                
                	InterfaceHandle
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: metric
                
                	Metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: prefix_address
                
                	PrefixAddress
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: prefix_length
                
                	PrefixLength
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, self).__init__()

                    self.yang_name = "tunnel-autoroute-dest"
                    self.yang_parent_name = "auto-route-destination-entry"

                    self.install_time = YLeaf(YType.uint32, "install-time")

                    self.interface_handle = YLeaf(YType.str, "interface-handle")

                    self.metric = YLeaf(YType.uint32, "metric")

                    self.prefix_address = YLeaf(YType.str, "prefix-address")

                    self.prefix_length = YLeaf(YType.uint32, "prefix-length")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("install_time",
                                    "interface_handle",
                                    "metric",
                                    "prefix_address",
                                    "prefix_length") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.install_time.is_set or
                        self.interface_handle.is_set or
                        self.metric.is_set or
                        self.prefix_address.is_set or
                        self.prefix_length.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.install_time.yfilter != YFilter.not_set or
                        self.interface_handle.yfilter != YFilter.not_set or
                        self.metric.yfilter != YFilter.not_set or
                        self.prefix_address.yfilter != YFilter.not_set or
                        self.prefix_length.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-autoroute-dest" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.install_time.is_set or self.install_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.install_time.get_name_leafdata())
                    if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_handle.get_name_leafdata())
                    if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric.get_name_leafdata())
                    if (self.prefix_address.is_set or self.prefix_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_address.get_name_leafdata())
                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "install-time" or name == "interface-handle" or name == "metric" or name == "prefix-address" or name == "prefix-length"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "install-time"):
                        self.install_time = value
                        self.install_time.value_namespace = name_space
                        self.install_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-handle"):
                        self.interface_handle = value
                        self.interface_handle.value_namespace = name_space
                        self.interface_handle.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric"):
                        self.metric = value
                        self.metric.value_namespace = name_space
                        self.metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-address"):
                        self.prefix_address = value
                        self.prefix_address.value_namespace = name_space
                        self.prefix_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "prefix-length"):
                        self.prefix_length = value
                        self.prefix_length.value_namespace = name_space
                        self.prefix_length.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_autoroute_dest:
                    if (c.has_data()):
                        return True
                return (
                    self.tunnel_id.is_set or
                    self.tunnel_id_xr.is_set)

            def has_operation(self):
                for c in self.tunnel_autoroute_dest:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.tunnel_id.yfilter != YFilter.not_set or
                    self.tunnel_id_xr.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "auto-route-destination-entry" + "[tunnel-id='" + self.tunnel_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-route-destination-entries/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-autoroute-dest"):
                    for c in self.tunnel_autoroute_dest:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_autoroute_dest.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-autoroute-dest" or name == "tunnel-id" or name == "tunnel-id-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "tunnel-id"):
                    self.tunnel_id = value
                    self.tunnel_id.value_namespace = name_space
                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-id-xr"):
                    self.tunnel_id_xr = value
                    self.tunnel_id_xr.value_namespace = name_space
                    self.tunnel_id_xr.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.auto_route_destination_entry:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.auto_route_destination_entry:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "auto-route-destination-entries" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "auto-route-destination-entry"):
                for c in self.auto_route_destination_entry:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.auto_route_destination_entry.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "auto-route-destination-entry"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TeMib(Entity):
        """
        TE MIB information
        
        .. attribute:: scalars
        
        	MIB Scalar information
        	**type**\:   :py:class:`Scalars <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TeMib.Scalars>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.TeMib, self).__init__()

            self.yang_name = "te-mib"
            self.yang_parent_name = "mpls-te"

            self.scalars = MplsTe.TeMib.Scalars()
            self.scalars.parent = self
            self._children_name_map["scalars"] = "scalars"
            self._children_yang_names.add("scalars")


        class Scalars(Entity):
            """
            MIB Scalar information
            
            .. attribute:: mpls_tunnel_active
            
            	mpls tunnel active
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: mpls_tunnel_configured
            
            	mpls tunnel configured
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: mpls_tunnel_max_hops
            
            	mpls tunnel max hops
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: mpls_tunnel_notification_max_rate
            
            	mpls tunnel notification max rate
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: mpls_tunnel_te_dist_proto
            
            	mpls tunnel te dist proto
            	**type**\:  int
            
            	**range:** 0..255
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.TeMib.Scalars, self).__init__()

                self.yang_name = "scalars"
                self.yang_parent_name = "te-mib"

                self.mpls_tunnel_active = YLeaf(YType.uint32, "mpls-tunnel-active")

                self.mpls_tunnel_configured = YLeaf(YType.uint32, "mpls-tunnel-configured")

                self.mpls_tunnel_max_hops = YLeaf(YType.uint32, "mpls-tunnel-max-hops")

                self.mpls_tunnel_notification_max_rate = YLeaf(YType.uint32, "mpls-tunnel-notification-max-rate")

                self.mpls_tunnel_te_dist_proto = YLeaf(YType.uint8, "mpls-tunnel-te-dist-proto")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("mpls_tunnel_active",
                                "mpls_tunnel_configured",
                                "mpls_tunnel_max_hops",
                                "mpls_tunnel_notification_max_rate",
                                "mpls_tunnel_te_dist_proto") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.TeMib.Scalars, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.TeMib.Scalars, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.mpls_tunnel_active.is_set or
                    self.mpls_tunnel_configured.is_set or
                    self.mpls_tunnel_max_hops.is_set or
                    self.mpls_tunnel_notification_max_rate.is_set or
                    self.mpls_tunnel_te_dist_proto.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.mpls_tunnel_active.yfilter != YFilter.not_set or
                    self.mpls_tunnel_configured.yfilter != YFilter.not_set or
                    self.mpls_tunnel_max_hops.yfilter != YFilter.not_set or
                    self.mpls_tunnel_notification_max_rate.yfilter != YFilter.not_set or
                    self.mpls_tunnel_te_dist_proto.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "scalars" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/te-mib/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.mpls_tunnel_active.is_set or self.mpls_tunnel_active.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mpls_tunnel_active.get_name_leafdata())
                if (self.mpls_tunnel_configured.is_set or self.mpls_tunnel_configured.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mpls_tunnel_configured.get_name_leafdata())
                if (self.mpls_tunnel_max_hops.is_set or self.mpls_tunnel_max_hops.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mpls_tunnel_max_hops.get_name_leafdata())
                if (self.mpls_tunnel_notification_max_rate.is_set or self.mpls_tunnel_notification_max_rate.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mpls_tunnel_notification_max_rate.get_name_leafdata())
                if (self.mpls_tunnel_te_dist_proto.is_set or self.mpls_tunnel_te_dist_proto.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mpls_tunnel_te_dist_proto.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "mpls-tunnel-active" or name == "mpls-tunnel-configured" or name == "mpls-tunnel-max-hops" or name == "mpls-tunnel-notification-max-rate" or name == "mpls-tunnel-te-dist-proto"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "mpls-tunnel-active"):
                    self.mpls_tunnel_active = value
                    self.mpls_tunnel_active.value_namespace = name_space
                    self.mpls_tunnel_active.value_namespace_prefix = name_space_prefix
                if(value_path == "mpls-tunnel-configured"):
                    self.mpls_tunnel_configured = value
                    self.mpls_tunnel_configured.value_namespace = name_space
                    self.mpls_tunnel_configured.value_namespace_prefix = name_space_prefix
                if(value_path == "mpls-tunnel-max-hops"):
                    self.mpls_tunnel_max_hops = value
                    self.mpls_tunnel_max_hops.value_namespace = name_space
                    self.mpls_tunnel_max_hops.value_namespace_prefix = name_space_prefix
                if(value_path == "mpls-tunnel-notification-max-rate"):
                    self.mpls_tunnel_notification_max_rate = value
                    self.mpls_tunnel_notification_max_rate.value_namespace = name_space
                    self.mpls_tunnel_notification_max_rate.value_namespace_prefix = name_space_prefix
                if(value_path == "mpls-tunnel-te-dist-proto"):
                    self.mpls_tunnel_te_dist_proto = value
                    self.mpls_tunnel_te_dist_proto.value_namespace = name_space
                    self.mpls_tunnel_te_dist_proto.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.scalars is not None and self.scalars.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.scalars is not None and self.scalars.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "te-mib" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "scalars"):
                if (self.scalars is None):
                    self.scalars = MplsTe.TeMib.Scalars()
                    self.scalars.parent = self
                    self._children_name_map["scalars"] = "scalars"
                return self.scalars

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "scalars"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class HardwareOutOfResources(Entity):
        """
        NPU Hardware OOR Information
        
        .. attribute:: summary
        
        	HW OOR Summary information
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.HardwareOutOfResources, self).__init__()

            self.yang_name = "hardware-out-of-resources"
            self.yang_parent_name = "mpls-te"

            self.summary = MplsTe.HardwareOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            HW OOR Summary information
            
            .. attribute:: hardware_out_of_resources_state
            
            	Array of NPU HW OOR info per state
            	**type**\: list of    :py:class:`HardwareOutOfResourcesState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.HardwareOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "hardware-out-of-resources"

                self.hardware_out_of_resources_state = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.HardwareOutOfResources.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.HardwareOutOfResources.Summary, self).__setattr__(name, value)


            class HardwareOutOfResourcesState(Entity):
                """
                Array of NPU HW OOR info per state
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the NPU HW OOR state
                	**type**\:  bool
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this  NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: percentage
                
                .. attribute:: hw_oor_state
                
                	The HW\-OOR state that this information belong to
                	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: node_protection_disable
                
                	Disable FRR node protection when the link is in this NPU HW OOR state
                	**type**\:  bool
                
                .. attribute:: statistics
                
                	NPU HW OOR Statistics per state
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics>`
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green OOR state is entered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: minute
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__init__()

                    self.yang_name = "hardware-out-of-resources-state"
                    self.yang_parent_name = "summary"

                    self.accept_reopt = YLeaf(YType.boolean, "accept-reopt")

                    self.available_bw_percentage = YLeaf(YType.uint32, "available-bw-percentage")

                    self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                    self.minimum_lsp_bandwidth = YLeaf(YType.uint32, "minimum-lsp-bandwidth")

                    self.node_protection_disable = YLeaf(YType.boolean, "node-protection-disable")

                    self.te_metric_penalty = YLeaf(YType.uint32, "te-metric-penalty")

                    self.transition_duration = YLeaf(YType.uint32, "transition-duration")

                    self.statistics = MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accept_reopt",
                                    "available_bw_percentage",
                                    "hw_oor_state",
                                    "minimum_lsp_bandwidth",
                                    "node_protection_disable",
                                    "te_metric_penalty",
                                    "transition_duration") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    NPU HW OOR Statistics per state
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hw_oor_state
                    
                    	The HW\-OOR state that these statistics belong to
                    	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    .. attribute:: node_protection_disable_number
                    
                    	Number of times this OOR state disabled node protection assignment
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "hardware-out-of-resources-state"

                        self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                        self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                        self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                        self.node_protection_disable_number = YLeaf(YType.uint32, "node-protection-disable-number")

                        self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                        self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                        self.transitions = YLeaf(YType.uint32, "transitions")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("accepted_ls_ps_number",
                                        "accepted_reopt_ls_ps_number",
                                        "hw_oor_state",
                                        "node_protection_disable_number",
                                        "rejected_ls_ps_number",
                                        "rejected_reopt_ls_ps_number",
                                        "transitions") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.accepted_ls_ps_number.is_set or
                            self.accepted_reopt_ls_ps_number.is_set or
                            self.hw_oor_state.is_set or
                            self.node_protection_disable_number.is_set or
                            self.rejected_ls_ps_number.is_set or
                            self.rejected_reopt_ls_ps_number.is_set or
                            self.transitions.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                            self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.hw_oor_state.yfilter != YFilter.not_set or
                            self.node_protection_disable_number.yfilter != YFilter.not_set or
                            self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.transitions.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/summary/hardware-out-of-resources-state/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                        if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                        if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                        if (self.node_protection_disable_number.is_set or self.node_protection_disable_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_protection_disable_number.get_name_leafdata())
                        if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                        if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                        if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.transitions.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "hw-oor-state" or name == "node-protection-disable-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "accepted-ls-ps-number"):
                            self.accepted_ls_ps_number = value
                            self.accepted_ls_ps_number.value_namespace = name_space
                            self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "accepted-reopt-ls-ps-number"):
                            self.accepted_reopt_ls_ps_number = value
                            self.accepted_reopt_ls_ps_number.value_namespace = name_space
                            self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-state"):
                            self.hw_oor_state = value
                            self.hw_oor_state.value_namespace = name_space
                            self.hw_oor_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-protection-disable-number"):
                            self.node_protection_disable_number = value
                            self.node_protection_disable_number.value_namespace = name_space
                            self.node_protection_disable_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-ls-ps-number"):
                            self.rejected_ls_ps_number = value
                            self.rejected_ls_ps_number.value_namespace = name_space
                            self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-reopt-ls-ps-number"):
                            self.rejected_reopt_ls_ps_number = value
                            self.rejected_reopt_ls_ps_number.value_namespace = name_space
                            self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "transitions"):
                            self.transitions = value
                            self.transitions.value_namespace = name_space
                            self.transitions.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.accept_reopt.is_set or
                        self.available_bw_percentage.is_set or
                        self.hw_oor_state.is_set or
                        self.minimum_lsp_bandwidth.is_set or
                        self.node_protection_disable.is_set or
                        self.te_metric_penalty.is_set or
                        self.transition_duration.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accept_reopt.yfilter != YFilter.not_set or
                        self.available_bw_percentage.yfilter != YFilter.not_set or
                        self.hw_oor_state.yfilter != YFilter.not_set or
                        self.minimum_lsp_bandwidth.yfilter != YFilter.not_set or
                        self.node_protection_disable.yfilter != YFilter.not_set or
                        self.te_metric_penalty.yfilter != YFilter.not_set or
                        self.transition_duration.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "hardware-out-of-resources-state" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accept_reopt.is_set or self.accept_reopt.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accept_reopt.get_name_leafdata())
                    if (self.available_bw_percentage.is_set or self.available_bw_percentage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bw_percentage.get_name_leafdata())
                    if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                    if (self.minimum_lsp_bandwidth.is_set or self.minimum_lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.minimum_lsp_bandwidth.get_name_leafdata())
                    if (self.node_protection_disable.is_set or self.node_protection_disable.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_protection_disable.get_name_leafdata())
                    if (self.te_metric_penalty.is_set or self.te_metric_penalty.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric_penalty.get_name_leafdata())
                    if (self.transition_duration.is_set or self.transition_duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transition_duration.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "statistics" or name == "accept-reopt" or name == "available-bw-percentage" or name == "hw-oor-state" or name == "minimum-lsp-bandwidth" or name == "node-protection-disable" or name == "te-metric-penalty" or name == "transition-duration"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accept-reopt"):
                        self.accept_reopt = value
                        self.accept_reopt.value_namespace = name_space
                        self.accept_reopt.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bw-percentage"):
                        self.available_bw_percentage = value
                        self.available_bw_percentage.value_namespace = name_space
                        self.available_bw_percentage.value_namespace_prefix = name_space_prefix
                    if(value_path == "hw-oor-state"):
                        self.hw_oor_state = value
                        self.hw_oor_state.value_namespace = name_space
                        self.hw_oor_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "minimum-lsp-bandwidth"):
                        self.minimum_lsp_bandwidth = value
                        self.minimum_lsp_bandwidth.value_namespace = name_space
                        self.minimum_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-protection-disable"):
                        self.node_protection_disable = value
                        self.node_protection_disable.value_namespace = name_space
                        self.node_protection_disable.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric-penalty"):
                        self.te_metric_penalty = value
                        self.te_metric_penalty.value_namespace = name_space
                        self.te_metric_penalty.value_namespace_prefix = name_space_prefix
                    if(value_path == "transition-duration"):
                        self.transition_duration = value
                        self.transition_duration.value_namespace = name_space
                        self.transition_duration.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.hardware_out_of_resources_state:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.hardware_out_of_resources_state:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "hardware-out-of-resources-state"):
                    for c in self.hardware_out_of_resources_state:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.hardware_out_of_resources_state.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "hardware-out-of-resources-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.summary is not None and self.summary.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "hardware-out-of-resources" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTe.HardwareOutOfResources.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class P2PP2MpTunnel(Entity):
        """
        P2P or P2MP tunnels
        
        .. attribute:: nni_tunnels
        
        	GMPLS NNI tunnels
        	**type**\:   :py:class:`NniTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels>`
        
        .. attribute:: tunnel_heads
        
        	Restrict display to P2P or P2MP head tunnels
        	**type**\:   :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads>`
        
        .. attribute:: tunnel_remote_briefs
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:   :py:class:`TunnelRemoteBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs>`
        
        .. attribute:: tunnel_remotes
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:   :py:class:`TunnelRemotes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.P2PP2MpTunnel, self).__init__()

            self.yang_name = "p2p-p2mp-tunnel"
            self.yang_parent_name = "mpls-te"

            self.nni_tunnels = MplsTe.P2PP2MpTunnel.NniTunnels()
            self.nni_tunnels.parent = self
            self._children_name_map["nni_tunnels"] = "nni-tunnels"
            self._children_yang_names.add("nni-tunnels")

            self.tunnel_heads = MplsTe.P2PP2MpTunnel.TunnelHeads()
            self.tunnel_heads.parent = self
            self._children_name_map["tunnel_heads"] = "tunnel-heads"
            self._children_yang_names.add("tunnel-heads")

            self.tunnel_remote_briefs = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs()
            self.tunnel_remote_briefs.parent = self
            self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"
            self._children_yang_names.add("tunnel-remote-briefs")

            self.tunnel_remotes = MplsTe.P2PP2MpTunnel.TunnelRemotes()
            self.tunnel_remotes.parent = self
            self._children_name_map["tunnel_remotes"] = "tunnel-remotes"
            self._children_yang_names.add("tunnel-remotes")


        class TunnelRemoteBriefs(Entity):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote_brief
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of    :py:class:`TunnelRemoteBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs, self).__init__()

                self.yang_name = "tunnel-remote-briefs"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_remote_brief = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs, self).__setattr__(name, value)


            class TunnelRemoteBrief(Entity):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec>`
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L>`
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: uptime
                
                	Time in seconds since the LSP was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__init__()

                    self.yang_name = "tunnel-remote-brief"
                    self.yang_parent_name = "tunnel-remote-briefs"

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                    self.s2l = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("lsp_id",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "ctype",
                                    "destination_address",
                                    "p2mp_id",
                                    "signaled_name",
                                    "uptime") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote-brief"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix


                class S2L(Entity):
                    """
                    array of S2L structures
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\:  str
                    
                    .. attribute:: oper_state
                    
                    	Oper state of S2L
                    	**type**\:  bool
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the S2L was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote-brief"

                        self.egress_interface = YLeaf(YType.str, "egress-interface")

                        self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                        self.oper_state = YLeaf(YType.boolean, "oper-state")

                        self.role = YLeaf(YType.enumeration, "role")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._children_yang_names.add("s2l-fec")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("egress_interface",
                                        "ingress_interface",
                                        "oper_state",
                                        "role",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__setattr__(name, value)


                    class S2LFec(Entity):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"

                            self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                            self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                            self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                            self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                            self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                            self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                            self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                            self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                            self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                            self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_fec_ctype",
                                            "s2l_fec_dest",
                                            "s2l_fec_extended_tunnel_id",
                                            "s2l_fec_lsp_id",
                                            "s2l_fec_p2mp_id",
                                            "s2l_fec_source",
                                            "s2l_fec_subgroup_id",
                                            "s2l_fec_subgroup_originator",
                                            "s2l_fec_tunnel_id",
                                            "s2l_fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.s2l_fec_ctype.is_set or
                                self.s2l_fec_dest.is_set or
                                self.s2l_fec_extended_tunnel_id.is_set or
                                self.s2l_fec_lsp_id.is_set or
                                self.s2l_fec_p2mp_id.is_set or
                                self.s2l_fec_source.is_set or
                                self.s2l_fec_subgroup_id.is_set or
                                self.s2l_fec_subgroup_originator.is_set or
                                self.s2l_fec_tunnel_id.is_set or
                                self.s2l_fec_vrf.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                self.s2l_fec_dest.yfilter != YFilter.not_set or
                                self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_source.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_vrf.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                            if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                            if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                            if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                            if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                            if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                            if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                            if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-fec-ctype"):
                                self.s2l_fec_ctype = value
                                self.s2l_fec_ctype.value_namespace = name_space
                                self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-dest"):
                                self.s2l_fec_dest = value
                                self.s2l_fec_dest.value_namespace = name_space
                                self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-extended-tunnel-id"):
                                self.s2l_fec_extended_tunnel_id = value
                                self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-lsp-id"):
                                self.s2l_fec_lsp_id = value
                                self.s2l_fec_lsp_id.value_namespace = name_space
                                self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-p2mp-id"):
                                self.s2l_fec_p2mp_id = value
                                self.s2l_fec_p2mp_id.value_namespace = name_space
                                self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-source"):
                                self.s2l_fec_source = value
                                self.s2l_fec_source.value_namespace = name_space
                                self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-id"):
                                self.s2l_fec_subgroup_id = value
                                self.s2l_fec_subgroup_id.value_namespace = name_space
                                self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-originator"):
                                self.s2l_fec_subgroup_originator = value
                                self.s2l_fec_subgroup_originator.value_namespace = name_space
                                self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-tunnel-id"):
                                self.s2l_fec_tunnel_id = value
                                self.s2l_fec_tunnel_id.value_namespace = name_space
                                self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-vrf"):
                                self.s2l_fec_vrf = value
                                self.s2l_fec_vrf.value_namespace = name_space
                                self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.egress_interface.is_set or
                            self.ingress_interface.is_set or
                            self.oper_state.is_set or
                            self.role.is_set or
                            self.uptime.is_set or
                            (self.s2l_fec is not None and self.s2l_fec.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.egress_interface.yfilter != YFilter.not_set or
                            self.ingress_interface.yfilter != YFilter.not_set or
                            self.oper_state.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.s2l_fec is not None and self.s2l_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface.get_name_leafdata())
                        if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                        if (self.oper_state.is_set or self.oper_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oper_state.get_name_leafdata())
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-fec"):
                            if (self.s2l_fec is None):
                                self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                            return self.s2l_fec

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-fec" or name == "egress-interface" or name == "ingress-interface" or name == "oper-state" or name == "role" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "egress-interface"):
                            self.egress_interface = value
                            self.egress_interface.value_namespace = name_space
                            self.egress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface"):
                            self.ingress_interface = value
                            self.ingress_interface.value_namespace = name_space
                            self.ingress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "oper-state"):
                            self.oper_state = value
                            self.oper_state.value_namespace = name_space
                            self.oper_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    return (
                        self.lsp_id.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.p2mp_id.is_set or
                        self.signaled_name.is_set or
                        self.uptime.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-remote-brief" + "[lsp-id='" + self.lsp_id.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-remote-briefs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "s2l" or name == "lsp-id" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "source-address" or name == "ctype" or name == "destination-address" or name == "p2mp-id" or name == "signaled-name" or name == "uptime"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_remote_brief:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_remote_brief:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-remote-briefs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-remote-brief"):
                    for c in self.tunnel_remote_brief:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_remote_brief.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-remote-brief"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelRemotes(Entity):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of    :py:class:`TunnelRemote <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2PP2MpTunnel.TunnelRemotes, self).__init__()

                self.yang_name = "tunnel-remotes"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_remote = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes, self).__setattr__(name, value)


            class TunnelRemote(Entity):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: dste_class_index
                
                	Matching DSTE class index
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: dste_class_match
                
                	Do the class type and priority match a DSTE class
                	**type**\:  bool
                
                .. attribute:: frr_active_reason
                
                	P2MP LSP FRR active reason
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_frr_failed
                
                	P2MP LSP has FRR Failed
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: lsp_bandwidth
                
                	P2MP LSP Bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_bandwidth_type
                
                	The LSP bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec>`
                
                .. attribute:: lsp_hold_priority
                
                	LSP hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_setup_priority
                
                	LSP setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reoptimize_reason
                
                	Reason for re\-optimization
                	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                
                .. attribute:: reoptimize_trigger
                
                	Re\-optimize trigger
                	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                
                .. attribute:: s2_ls_down
                
                	Number of down S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2_ls_proceeding
                
                	Number of proceeding S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2_ls_up
                
                	Number of connected S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L>`
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: timer_left
                
                	Time in seconds left to take next action if any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: type
                
                	The type of this LSP
                	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__init__()

                    self.yang_name = "tunnel-remote"
                    self.yang_parent_name = "tunnel-remotes"

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                    self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                    self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                    self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                    self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                    self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                    self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                    self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                    self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                    self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                    self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.timer_left = YLeaf(YType.uint32, "timer-left")

                    self.type = YLeaf(YType.enumeration, "type")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                    self.s2l = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("lsp_id",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "ctype",
                                    "destination_address",
                                    "p2mp_id",
                                    "dste_class_index",
                                    "dste_class_match",
                                    "frr_active_reason",
                                    "is_frr_failed",
                                    "is_interface",
                                    "is_passive",
                                    "last_path_change",
                                    "lsp_bandwidth",
                                    "lsp_bandwidth_type",
                                    "lsp_hold_priority",
                                    "lsp_setup_priority",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "reoptimize_reason",
                                    "reoptimize_trigger",
                                    "s2_ls_down",
                                    "s2_ls_proceeding",
                                    "s2_ls_up",
                                    "signaled_name",
                                    "timer_left",
                                    "type",
                                    "uptime") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix


                class S2L(Entity):
                    """
                    array of S2L structures
                    
                    .. attribute:: abr_auto_discovered
                    
                    	Next ABR auto discovered
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: active_path_option
                    
                    	The path option used to find the path for this S2L
                    	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption>`
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association>`
                    
                    .. attribute:: backup_tunnel_interface
                    
                    	Interface handle of the backup tunnel
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: diversity_info
                    
                    	S2L Diversity Information
                    	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo>`
                    
                    .. attribute:: downstream_router_id
                    
                    	Downstream router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\:  str
                    
                    .. attribute:: egress_interface_brief
                    
                    	Egress Interface in brief format
                    	**type**\:  str
                    
                    .. attribute:: egress_interface_state
                    
                    	State of Outgoing Interface
                    	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    .. attribute:: expanded_ero_affinity_bits
                    
                    	The Outgoing ERO's affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_affinity_mask
                    
                    	The Outgoing ERO's affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_area_id
                    
                    	Indicates the protocol and area used to find Outgoing ERO
                    	**type**\:  str
                    
                    .. attribute:: expanded_ero_metric
                    
                    	The metric value of the expanded path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_metric_type
                    
                    	The Outgoing ERO's selection metric
                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    .. attribute:: flex_info
                    
                    	FlexLSP S2L Information
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo>`
                    
                    .. attribute:: frr_out_tunnel_interface
                    
                    	FRR out tunnel intface
                    	**type**\:  str
                    
                    .. attribute:: fspec
                    
                    	The F spec info
                    	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec>`
                    
                    .. attribute:: generic_fspec
                    
                    	Generic FSpec
                    	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec>`
                    
                    .. attribute:: generic_tspec
                    
                    	Generic TSpec
                    	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec>`
                    
                    .. attribute:: gmpls_labels
                    
                    	GMPLS labels
                    	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels>`
                    
                    .. attribute:: head_end_bfd_info
                    
                    	The Head\-end BFD info
                    	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo>`
                    
                    .. attribute:: in_ero
                    
                    	Incoming ERO for this S2L
                    	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro>`
                    
                    .. attribute:: in_xro
                    
                    	Incoming XRO for this S2L
                    	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro>`
                    
                    .. attribute:: incoming_address
                    
                    	Incoming interface address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: incoming_address_generic
                    
                    	Incoming interface address
                    	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric>`
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface_brief
                    
                    	Ingress Interface in brief format
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface_state
                    
                    	State of Incoming Interface
                    	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    .. attribute:: is_bandwidth_protect
                    
                    	BW Protection Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_expanded_ero
                    
                    	TRUE if this LSR expanded a loose path
                    	**type**\:  bool
                    
                    .. attribute:: is_frr_enabled
                    
                    	FRR Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_node_protected
                    
                    	Node Protection Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_optical
                    
                    	Is Optical
                    	**type**\:  bool
                    
                    .. attribute:: local_router_id
                    
                    	Local router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_wrap_info
                    
                    	Lsp Wrap  Related information
                    	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo>`
                    
                    .. attribute:: next_hop_address
                    
                    	Next hop address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: next_hop_address_generic
                    
                    	Next hop address
                    	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric>`
                    
                    .. attribute:: node_hop_count
                    
                    	Hop count
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: otn_s2l
                    
                    	Otn S2L Information
                    	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L>`
                    
                    .. attribute:: out_ero
                    
                    	Outgoing ERO for this S2L
                    	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro>`
                    
                    .. attribute:: out_xro
                    
                    	Outgoing XRO for this S2L
                    	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro>`
                    
                    .. attribute:: outbound_frr_state
                    
                    	Indicates outbound FRR state
                    	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                    
                    .. attribute:: path_affinity_array
                    
                    	Tunnel's Path hops with affinity
                    	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray>`
                    
                    .. attribute:: path_reeval_query_mid
                    
                    	Loose path reevaluation query received at mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_rro
                    
                    	Path RRO for this S2L
                    	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro>`
                    
                    .. attribute:: path_rro_enabled
                    
                    	Path RRO Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: path_using_strict_spf
                    
                    	Path is using Strict SPF
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_area
                    
                    	IGP\-area in which the S2L path was calculated
                    	**type**\:  str
                    
                    .. attribute:: previous_hop_address
                    
                    	Previous hop address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: previous_hop_address_generic
                    
                    	Previous hop address
                    	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric>`
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection>`
                    
                    .. attribute:: resv_rro
                    
                    	Resv RRO for this S2L
                    	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro>`
                    
                    .. attribute:: reverse_ero_in
                    
                    	 Reverse Incoming ERO for this S2L
                    	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn>`
                    
                    .. attribute:: reverse_lsp_connected
                    
                    	Reverse Associated Bidir LSP Connected
                    	**type**\:  bool
                    
                    .. attribute:: reverse_lsp_fec
                    
                    	Reverse Associated Bidir LSP FEC
                    	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec>`
                    
                    .. attribute:: reverse_lsp_name
                    
                    	Reverse Associated Bidir LSP Name
                    	**type**\:  str
                    
                    .. attribute:: reverse_lsp_present
                    
                    	Reverse Associated Bidir LSP Present
                    	**type**\:  bool
                    
                    .. attribute:: reverse_tspec
                    
                    	The Reverse T spec info
                    	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec>`
                    
                    .. attribute:: reverse_weight
                    
                    	The reverse path weight
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: s2l_convergence
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence>`
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec>`
                    
                    .. attribute:: s2l_local_label
                    
                    	Local label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_reverse_ero_obj_present
                    
                    	 S2l Reverse ERO Object Present
                    	**type**\:  bool
                    
                    .. attribute:: s2l_reverse_lsp_sub_obj
                    
                    	Reverse LSP Sub Objects
                    	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj>`
                    
                    .. attribute:: s2l_reverse_tspec_obj_present
                    
                    	 S2L Reverse TSpec Object Present
                    	**type**\:  bool
                    
                    .. attribute:: s2l_segment_routing_path
                    
                    	Segment\-Routing S2L path info
                    	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The S2L's excluded srlg groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup>`
                    
                    .. attribute:: signalling_status
                    
                    	Signaling status
                    	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                    
                    .. attribute:: soft_preemption
                    
                    	The soft preemption info for this LSP
                    	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption>`
                    
                    .. attribute:: srlg_collection
                    
                    	SRLG\-collection data
                    	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection>`
                    
                    .. attribute:: tail_end_bfd_info
                    
                    	The Tail\-end BFD info
                    	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo>`
                    
                    .. attribute:: time_since_last_preferred_path_exists_send_mid
                    
                    	Time since last preferred path exists msg send from mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: time_since_last_preferred_tree_exists_send_mid
                    
                    	Time since last preferred tree exists msg send from mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: time_since_last_query_received_mid
                    
                    	Time since last reevaluation query received at mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tspec
                    
                    	The T spec info
                    	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec>`
                    
                    .. attribute:: upstream_router_id
                    
                    	Upstream router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weight
                    
                    	The path's weight
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote"

                        self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                        self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                        self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                        self.egress_interface = YLeaf(YType.str, "egress-interface")

                        self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                        self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                        self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                        self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                        self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                        self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                        self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                        self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                        self.incoming_address = YLeaf(YType.str, "incoming-address")

                        self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                        self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                        self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                        self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                        self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                        self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                        self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                        self.is_optical = YLeaf(YType.boolean, "is-optical")

                        self.local_router_id = YLeaf(YType.str, "local-router-id")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                        self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                        self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                        self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                        self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                        self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                        self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                        self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                        self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                        self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                        self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                        self.role = YLeaf(YType.enumeration, "role")

                        self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                        self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                        self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                        self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                        self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                        self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                        self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                        self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                        self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.weight = YLeaf(YType.uint64, "weight")

                        self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption()
                        self.active_path_option.parent = self
                        self._children_name_map["active_path_option"] = "active-path-option"
                        self._children_yang_names.add("active-path-option")

                        self.association = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo()
                        self.diversity_info.parent = self
                        self._children_name_map["diversity_info"] = "diversity-info"
                        self._children_yang_names.add("diversity-info")

                        self.flex_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.fspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec()
                        self.fspec.parent = self
                        self._children_name_map["fspec"] = "fspec"
                        self._children_yang_names.add("fspec")

                        self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec()
                        self.generic_fspec.parent = self
                        self._children_name_map["generic_fspec"] = "generic-fspec"
                        self._children_yang_names.add("generic-fspec")

                        self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec()
                        self.generic_tspec.parent = self
                        self._children_name_map["generic_tspec"] = "generic-tspec"
                        self._children_yang_names.add("generic-tspec")

                        self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels()
                        self.gmpls_labels.parent = self
                        self._children_name_map["gmpls_labels"] = "gmpls-labels"
                        self._children_yang_names.add("gmpls-labels")

                        self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo()
                        self.head_end_bfd_info.parent = self
                        self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                        self._children_yang_names.add("head-end-bfd-info")

                        self.in_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro()
                        self.in_xro.parent = self
                        self._children_name_map["in_xro"] = "in-xro"
                        self._children_yang_names.add("in-xro")

                        self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric()
                        self.incoming_address_generic.parent = self
                        self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                        self._children_yang_names.add("incoming-address-generic")

                        self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo()
                        self.lsp_wrap_info.parent = self
                        self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                        self._children_yang_names.add("lsp-wrap-info")

                        self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric()
                        self.next_hop_address_generic.parent = self
                        self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                        self._children_yang_names.add("next-hop-address-generic")

                        self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L()
                        self.otn_s2l.parent = self
                        self._children_name_map["otn_s2l"] = "otn-s2l"
                        self._children_yang_names.add("otn-s2l")

                        self.out_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro()
                        self.out_xro.parent = self
                        self._children_name_map["out_xro"] = "out-xro"
                        self._children_yang_names.add("out-xro")

                        self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric()
                        self.previous_hop_address_generic.parent = self
                        self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                        self._children_yang_names.add("previous-hop-address-generic")

                        self.protection = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec()
                        self.reverse_lsp_fec.parent = self
                        self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                        self._children_yang_names.add("reverse-lsp-fec")

                        self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec()
                        self.reverse_tspec.parent = self
                        self._children_name_map["reverse_tspec"] = "reverse-tspec"
                        self._children_yang_names.add("reverse-tspec")

                        self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence()
                        self.s2l_convergence.parent = self
                        self._children_name_map["s2l_convergence"] = "s2l-convergence"
                        self._children_yang_names.add("s2l-convergence")

                        self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._children_yang_names.add("s2l-fec")

                        self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption()
                        self.soft_preemption.parent = self
                        self._children_name_map["soft_preemption"] = "soft-preemption"
                        self._children_yang_names.add("soft-preemption")

                        self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection()
                        self.srlg_collection.parent = self
                        self._children_name_map["srlg_collection"] = "srlg-collection"
                        self._children_yang_names.add("srlg-collection")

                        self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo()
                        self.tail_end_bfd_info.parent = self
                        self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                        self._children_yang_names.add("tail-end-bfd-info")

                        self.tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec()
                        self.tspec.parent = self
                        self._children_name_map["tspec"] = "tspec"
                        self._children_yang_names.add("tspec")

                        self.in_ero = YList(self)
                        self.out_ero = YList(self)
                        self.path_affinity_array = YList(self)
                        self.path_rro = YList(self)
                        self.resv_rro = YList(self)
                        self.reverse_ero_in = YList(self)
                        self.s2l_reverse_lsp_sub_obj = YList(self)
                        self.s2l_segment_routing_path = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("abr_auto_discovered",
                                        "backup_tunnel_interface",
                                        "downstream_router_id",
                                        "egress_interface",
                                        "egress_interface_brief",
                                        "egress_interface_state",
                                        "expanded_ero_affinity_bits",
                                        "expanded_ero_affinity_mask",
                                        "expanded_ero_area_id",
                                        "expanded_ero_metric",
                                        "expanded_ero_metric_type",
                                        "frr_out_tunnel_interface",
                                        "incoming_address",
                                        "ingress_interface",
                                        "ingress_interface_brief",
                                        "ingress_interface_state",
                                        "is_bandwidth_protect",
                                        "is_expanded_ero",
                                        "is_frr_enabled",
                                        "is_node_protected",
                                        "is_optical",
                                        "local_router_id",
                                        "next_hop_address",
                                        "node_hop_count",
                                        "outbound_frr_state",
                                        "path_reeval_query_mid",
                                        "path_rro_enabled",
                                        "path_using_strict_spf",
                                        "pcalc_area",
                                        "previous_hop_address",
                                        "reverse_lsp_connected",
                                        "reverse_lsp_name",
                                        "reverse_lsp_present",
                                        "reverse_weight",
                                        "role",
                                        "s2l_local_label",
                                        "s2l_out_label",
                                        "s2l_reverse_ero_obj_present",
                                        "s2l_reverse_tspec_obj_present",
                                        "signalling_status",
                                        "time_since_last_preferred_path_exists_send_mid",
                                        "time_since_last_preferred_tree_exists_send_mid",
                                        "time_since_last_query_received_mid",
                                        "upstream_router_id",
                                        "uptime",
                                        "weight") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__setattr__(name, value)


                    class S2LFec(Entity):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"

                            self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                            self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                            self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                            self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                            self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                            self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                            self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                            self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                            self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                            self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_fec_ctype",
                                            "s2l_fec_dest",
                                            "s2l_fec_extended_tunnel_id",
                                            "s2l_fec_lsp_id",
                                            "s2l_fec_p2mp_id",
                                            "s2l_fec_source",
                                            "s2l_fec_subgroup_id",
                                            "s2l_fec_subgroup_originator",
                                            "s2l_fec_tunnel_id",
                                            "s2l_fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.s2l_fec_ctype.is_set or
                                self.s2l_fec_dest.is_set or
                                self.s2l_fec_extended_tunnel_id.is_set or
                                self.s2l_fec_lsp_id.is_set or
                                self.s2l_fec_p2mp_id.is_set or
                                self.s2l_fec_source.is_set or
                                self.s2l_fec_subgroup_id.is_set or
                                self.s2l_fec_subgroup_originator.is_set or
                                self.s2l_fec_tunnel_id.is_set or
                                self.s2l_fec_vrf.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                self.s2l_fec_dest.yfilter != YFilter.not_set or
                                self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_source.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_vrf.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                            if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                            if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                            if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                            if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                            if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                            if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                            if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-fec-ctype"):
                                self.s2l_fec_ctype = value
                                self.s2l_fec_ctype.value_namespace = name_space
                                self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-dest"):
                                self.s2l_fec_dest = value
                                self.s2l_fec_dest.value_namespace = name_space
                                self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-extended-tunnel-id"):
                                self.s2l_fec_extended_tunnel_id = value
                                self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-lsp-id"):
                                self.s2l_fec_lsp_id = value
                                self.s2l_fec_lsp_id.value_namespace = name_space
                                self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-p2mp-id"):
                                self.s2l_fec_p2mp_id = value
                                self.s2l_fec_p2mp_id.value_namespace = name_space
                                self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-source"):
                                self.s2l_fec_source = value
                                self.s2l_fec_source.value_namespace = name_space
                                self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-id"):
                                self.s2l_fec_subgroup_id = value
                                self.s2l_fec_subgroup_id.value_namespace = name_space
                                self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-originator"):
                                self.s2l_fec_subgroup_originator = value
                                self.s2l_fec_subgroup_originator.value_namespace = name_space
                                self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-tunnel-id"):
                                self.s2l_fec_tunnel_id = value
                                self.s2l_fec_tunnel_id.value_namespace = name_space
                                self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-vrf"):
                                self.s2l_fec_vrf = value
                                self.s2l_fec_vrf.value_namespace = name_space
                                self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                    class ActivePathOption(Entity):
                        """
                        The path option used to find the path for this
                        S2L
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__init__()

                            self.yang_name = "active-path-option"
                            self.yang_parent_name = "s2l"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "active-path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "active-path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "active-path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "active-path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "active-path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "active-path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class OutXro(Entity):
                        """
                        Outgoing XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__init__()

                            self.yang_name = "out-xro"
                            self.yang_parent_name = "s2l"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "out-xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                    class InXro(Entity):
                        """
                        Incoming XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__init__()

                            self.yang_name = "in-xro"
                            self.yang_parent_name = "s2l"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "in-xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "in-xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                    class Tspec(Entity):
                        """
                        The T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__init__()

                            self.yang_name = "tspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class GenericTspec(Entity):
                        """
                        Generic TSpec
                        
                        .. attribute:: otntspec
                        
                        	TE TSpec for G709 OTN
                        	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec>`
                        
                        .. attribute:: tspec_type
                        
                        	TSpecType
                        	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__init__()

                            self.yang_name = "generic-tspec"
                            self.yang_parent_name = "s2l"

                            self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                            self.otntspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec()
                            self.otntspec.parent = self
                            self._children_name_map["otntspec"] = "otntspec"
                            self._children_yang_names.add("otntspec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tspec_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__setattr__(name, value)


                        class Otntspec(Entity):
                            """
                            TE TSpec for G709 OTN
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__init__()

                                self.yang_name = "otntspec"
                                self.yang_parent_name = "generic-tspec"

                                self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                self.multiplier = YLeaf(YType.uint16, "multiplier")

                                self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                self.nvc = YLeaf(YType.uint16, "nvc")

                                self.signal_type = YLeaf(YType.uint8, "signal-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bit_rate",
                                                "multiplier",
                                                "nmc_or_tolerance",
                                                "nvc",
                                                "signal_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bit_rate.is_set or
                                    self.multiplier.is_set or
                                    self.nmc_or_tolerance.is_set or
                                    self.nvc.is_set or
                                    self.signal_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bit_rate.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                    self.nvc.yfilter != YFilter.not_set or
                                    self.signal_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otntspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nvc.get_name_leafdata())
                                if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signal_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bit-rate"):
                                    self.bit_rate = value
                                    self.bit_rate.value_namespace = name_space
                                    self.bit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "nmc-or-tolerance"):
                                    self.nmc_or_tolerance = value
                                    self.nmc_or_tolerance.value_namespace = name_space
                                    self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                if(value_path == "nvc"):
                                    self.nvc = value
                                    self.nvc.value_namespace = name_space
                                    self.nvc.value_namespace_prefix = name_space_prefix
                                if(value_path == "signal-type"):
                                    self.signal_type = value
                                    self.signal_type.value_namespace = name_space
                                    self.signal_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tspec_type.is_set or
                                (self.otntspec is not None and self.otntspec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tspec_type.yfilter != YFilter.not_set or
                                (self.otntspec is not None and self.otntspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "generic-tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tspec_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "otntspec"):
                                if (self.otntspec is None):
                                    self.otntspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec()
                                    self.otntspec.parent = self
                                    self._children_name_map["otntspec"] = "otntspec"
                                return self.otntspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "otntspec" or name == "tspec-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tspec-type"):
                                self.tspec_type = value
                                self.tspec_type.value_namespace = name_space
                                self.tspec_type.value_namespace_prefix = name_space_prefix


                    class Fspec(Entity):
                        """
                        The F spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__init__()

                            self.yang_name = "fspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class GenericFspec(Entity):
                        """
                        Generic FSpec
                        
                        .. attribute:: fspec_type
                        
                        	FSpecType
                        	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                        
                        .. attribute:: otnfspec
                        
                        	TE FSpec for G709 OTN
                        	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__init__()

                            self.yang_name = "generic-fspec"
                            self.yang_parent_name = "s2l"

                            self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                            self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec()
                            self.otnfspec.parent = self
                            self._children_name_map["otnfspec"] = "otnfspec"
                            self._children_yang_names.add("otnfspec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fspec_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__setattr__(name, value)


                        class Otnfspec(Entity):
                            """
                            TE FSpec for G709 OTN
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__init__()

                                self.yang_name = "otnfspec"
                                self.yang_parent_name = "generic-fspec"

                                self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                self.multiplier = YLeaf(YType.uint16, "multiplier")

                                self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                self.nvc = YLeaf(YType.uint16, "nvc")

                                self.signal_type = YLeaf(YType.uint8, "signal-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bit_rate",
                                                "multiplier",
                                                "nmc_or_tolerance",
                                                "nvc",
                                                "signal_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bit_rate.is_set or
                                    self.multiplier.is_set or
                                    self.nmc_or_tolerance.is_set or
                                    self.nvc.is_set or
                                    self.signal_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bit_rate.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                    self.nvc.yfilter != YFilter.not_set or
                                    self.signal_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otnfspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nvc.get_name_leafdata())
                                if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signal_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bit-rate"):
                                    self.bit_rate = value
                                    self.bit_rate.value_namespace = name_space
                                    self.bit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "nmc-or-tolerance"):
                                    self.nmc_or_tolerance = value
                                    self.nmc_or_tolerance.value_namespace = name_space
                                    self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                if(value_path == "nvc"):
                                    self.nvc = value
                                    self.nvc.value_namespace = name_space
                                    self.nvc.value_namespace_prefix = name_space_prefix
                                if(value_path == "signal-type"):
                                    self.signal_type = value
                                    self.signal_type.value_namespace = name_space
                                    self.signal_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fspec_type.is_set or
                                (self.otnfspec is not None and self.otnfspec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fspec_type.yfilter != YFilter.not_set or
                                (self.otnfspec is not None and self.otnfspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "generic-fspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fspec_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "otnfspec"):
                                if (self.otnfspec is None):
                                    self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec()
                                    self.otnfspec.parent = self
                                    self._children_name_map["otnfspec"] = "otnfspec"
                                return self.otnfspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "otnfspec" or name == "fspec-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fspec-type"):
                                self.fspec_type = value
                                self.fspec_type.value_namespace = name_space
                                self.fspec_type.value_namespace_prefix = name_space_prefix


                    class NextHopAddressGeneric(Entity):
                        """
                        Next hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric, self).__init__()

                            self.yang_name = "next-hop-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "next-hop-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "next-hop-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class PreviousHopAddressGeneric(Entity):
                        """
                        Previous hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric, self).__init__()

                            self.yang_name = "previous-hop-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "previous-hop-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-hop-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class IncomingAddressGeneric(Entity):
                        """
                        Incoming interface address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric, self).__init__()

                            self.yang_name = "incoming-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "incoming-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "incoming-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class S2LConvergence(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__init__()

                            self.yang_name = "s2l-convergence"
                            self.yang_parent_name = "s2l"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-convergence" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                    class SoftPreemption(Entity):
                        """
                        The soft preemption info for this LSP.
                        
                        .. attribute:: fr_rrewrite
                        
                        	FRR\-rewrite during soft preemption
                        	**type**\:  bool
                        
                        .. attribute:: fr_rrewrite_tunnel_name
                        
                        	The tunnel name of the backup
                        	**type**\:  str
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: soft_preemption_link
                        
                        	Name of the link where the soft preemption occurred
                        	**type**\:  str
                        
                        .. attribute:: soft_preemption_timestamp
                        
                        	The POSIX timestamp when the soft preemption occurred
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: status
                        
                        	The current state of the soft preemption operation
                        	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                        
                        .. attribute:: time_to_hard_preemption
                        
                        	The number of seconds until hard preemption is triggered
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__init__()

                            self.yang_name = "soft-preemption"
                            self.yang_parent_name = "s2l"

                            self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                            self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                            self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                            self.status = YLeaf(YType.enumeration, "status")

                            self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fr_rrewrite",
                                            "fr_rrewrite_tunnel_name",
                                            "preempting_link_address",
                                            "soft_preemption_link",
                                            "soft_preemption_timestamp",
                                            "status",
                                            "time_to_hard_preemption") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fr_rrewrite.is_set or
                                self.fr_rrewrite_tunnel_name.is_set or
                                self.preempting_link_address.is_set or
                                self.soft_preemption_link.is_set or
                                self.soft_preemption_timestamp.is_set or
                                self.status.is_set or
                                self.time_to_hard_preemption.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fr_rrewrite.yfilter != YFilter.not_set or
                                self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.soft_preemption_link.yfilter != YFilter.not_set or
                                self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                self.status.yfilter != YFilter.not_set or
                                self.time_to_hard_preemption.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                            if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                            if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                            if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.status.get_name_leafdata())
                            if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fr-rrewrite"):
                                self.fr_rrewrite = value
                                self.fr_rrewrite.value_namespace = name_space
                                self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "fr-rrewrite-tunnel-name"):
                                self.fr_rrewrite_tunnel_name = value
                                self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-link"):
                                self.soft_preemption_link = value
                                self.soft_preemption_link.value_namespace = name_space
                                self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-timestamp"):
                                self.soft_preemption_timestamp = value
                                self.soft_preemption_timestamp.value_namespace = name_space
                                self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "status"):
                                self.status = value
                                self.status.value_namespace = name_space
                                self.status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-to-hard-preemption"):
                                self.time_to_hard_preemption = value
                                self.time_to_hard_preemption.value_namespace = name_space
                                self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                    class GmplsLabels(Entity):
                        """
                        GMPLS labels
                        
                        .. attribute:: path_egress_label
                        
                        	Path message (upstream) egress label
                        	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel>`
                        
                        .. attribute:: path_ingress_label
                        
                        	Path message (upstream) ingress label
                        	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel>`
                        
                        .. attribute:: resv_egress_label
                        
                        	Resv message (downstream) egress label
                        	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel>`
                        
                        .. attribute:: resv_ingress_label
                        
                        	Resv message (downstream) ingress label
                        	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels, self).__init__()

                            self.yang_name = "gmpls-labels"
                            self.yang_parent_name = "s2l"

                            self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel()
                            self.path_egress_label.parent = self
                            self._children_name_map["path_egress_label"] = "path-egress-label"
                            self._children_yang_names.add("path-egress-label")

                            self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel()
                            self.path_ingress_label.parent = self
                            self._children_name_map["path_ingress_label"] = "path-ingress-label"
                            self._children_yang_names.add("path-ingress-label")

                            self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel()
                            self.resv_egress_label.parent = self
                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                            self._children_yang_names.add("resv-egress-label")

                            self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel()
                            self.resv_ingress_label.parent = self
                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                            self._children_yang_names.add("resv-ingress-label")


                        class PathIngressLabel(Entity):
                            """
                            Path message (upstream) ingress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                self.yang_name = "path-ingress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-ingress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-ingress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-ingress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class PathEgressLabel(Entity):
                            """
                            Path message (upstream) egress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                self.yang_name = "path-egress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-egress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-egress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-egress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class ResvIngressLabel(Entity):
                            """
                            Resv message (downstream) ingress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                self.yang_name = "resv-ingress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-ingress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-ingress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-ingress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class ResvEgressLabel(Entity):
                            """
                            Resv message (downstream) egress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                self.yang_name = "resv-egress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-egress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-egress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-egress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-labels" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-egress-label"):
                                if (self.path_egress_label is None):
                                    self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"
                                return self.path_egress_label

                            if (child_yang_name == "path-ingress-label"):
                                if (self.path_ingress_label is None):
                                    self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                return self.path_ingress_label

                            if (child_yang_name == "resv-egress-label"):
                                if (self.resv_egress_label is None):
                                    self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                return self.resv_egress_label

                            if (child_yang_name == "resv-ingress-label"):
                                if (self.resv_ingress_label is None):
                                    self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                return self.resv_ingress_label

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class OtnS2L(Entity):
                        """
                        Otn S2L Information
                        
                        .. attribute:: aps
                        
                        	APS Info for OTN S2L
                        	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps>`
                        
                        .. attribute:: otn
                        
                        	Info Related to OTN technology in S2L
                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L, self).__init__()

                            self.yang_name = "otn-s2l"
                            self.yang_parent_name = "s2l"

                            self.aps = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps()
                            self.aps.parent = self
                            self._children_name_map["aps"] = "aps"
                            self._children_yang_names.add("aps")

                            self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn()
                            self.otn.parent = self
                            self._children_name_map["otn"] = "otn"
                            self._children_yang_names.add("otn")


                        class Otn(Entity):
                            """
                            Info Related to OTN technology in S2L
                            
                            .. attribute:: bandwidth
                            
                            	OTN Bandwidth for s2l
                            	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth>`
                            
                            .. attribute:: cross_connect_id
                            
                            	Cross connect id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: gpid
                            
                            	Gpid Payload
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: incoming_controller
                            
                            	Incoming Controller
                            	**type**\:  str
                            
                            .. attribute:: incoming_controller_ifhandle
                            
                            	Incoming Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: incoming_controller_state
                            
                            	State of Incoming Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: incoming_sub_controller
                            
                            	Incoming Sub Controller
                            	**type**\:  str
                            
                            .. attribute:: incoming_sub_controller_ifhandle
                            
                            	Incoming Sub Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: incoming_sub_controller_state
                            
                            	State of Incoming Sub Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: is_connected
                            
                            	True if subcontrollers are connected
                            	**type**\:  bool
                            
                            .. attribute:: labels
                            
                            	Labels
                            	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels>`
                            
                            .. attribute:: outgoing_controller
                            
                            	Outgoing Controller
                            	**type**\:  str
                            
                            .. attribute:: outgoing_controller_ifhandle
                            
                            	Outgoing Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: outgoing_controller_state
                            
                            	State of Outgoing Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: outgoing_sub_controller
                            
                            	Outgoing Sub Controller
                            	**type**\:  str
                            
                            .. attribute:: outgoing_sub_controller_ifhandle
                            
                            	Outgoing Sub Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: outgoing_sub_controller_state
                            
                            	State of Outgoing Sub Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: uptime
                            
                            	XC Uptime
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__init__()

                                self.yang_name = "otn"
                                self.yang_parent_name = "otn-s2l"

                                self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                self.gpid = YLeaf(YType.uint16, "gpid")

                                self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                self.is_connected = YLeaf(YType.boolean, "is-connected")

                                self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                self.uptime = YLeaf(YType.uint32, "uptime")

                                self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth()
                                self.bandwidth.parent = self
                                self._children_name_map["bandwidth"] = "bandwidth"
                                self._children_yang_names.add("bandwidth")

                                self.labels = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels()
                                self.labels.parent = self
                                self._children_name_map["labels"] = "labels"
                                self._children_yang_names.add("labels")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("cross_connect_id",
                                                "gpid",
                                                "incoming_controller",
                                                "incoming_controller_ifhandle",
                                                "incoming_controller_state",
                                                "incoming_sub_controller",
                                                "incoming_sub_controller_ifhandle",
                                                "incoming_sub_controller_state",
                                                "is_connected",
                                                "outgoing_controller",
                                                "outgoing_controller_ifhandle",
                                                "outgoing_controller_state",
                                                "outgoing_sub_controller",
                                                "outgoing_sub_controller_ifhandle",
                                                "outgoing_sub_controller_state",
                                                "uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                            class Bandwidth(Entity):
                                """
                                OTN Bandwidth for s2l
                                
                                .. attribute:: odu_flex_cbr
                                
                                	Odu flex CBR info
                                	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                
                                .. attribute:: odu_flex_gfp_f_non_res
                                
                                	Odu flex GFP\-F non\-resizable info
                                	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                
                                .. attribute:: odu_flex_gfp_f_res
                                
                                	Odu flex GFP\-F resizable info
                                	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                
                                .. attribute:: odu_level
                                
                                	ODULevel
                                	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                    self.yang_name = "bandwidth"
                                    self.yang_parent_name = "otn"

                                    self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                    self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                    self.odu_flex_cbr.parent = self
                                    self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    self._children_yang_names.add("odu-flex-cbr")

                                    self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                    self.odu_flex_gfp_f_non_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                    self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                    self.odu_flex_gfp_f_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    self._children_yang_names.add("odu-flex-gfp-f-res")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("odu_level") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                class OduFlexCbr(Entity):
                                    """
                                    Odu flex CBR info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tolerance
                                    
                                    	Tolerance
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                        self.yang_name = "odu-flex-cbr"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        self.tolerance = YLeaf(YType.uint16, "tolerance")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate",
                                                        "tolerance") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bit_rate.is_set or
                                            self.tolerance.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set or
                                            self.tolerance.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-cbr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                        if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tolerance.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate" or name == "tolerance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tolerance"):
                                            self.tolerance = value
                                            self.tolerance.value_namespace = name_space
                                            self.tolerance.value_namespace_prefix = name_space_prefix


                                class OduFlexGfpFRes(Entity):
                                    """
                                    Odu flex GFP\-F resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-res"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.bit_rate.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix


                                class OduFlexGfpFNonRes(Entity):
                                    """
                                    Odu flex GFP\-F non\-resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-non-res"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.bit_rate.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.odu_level.is_set or
                                        (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                        (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                        (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.odu_level.yfilter != YFilter.not_set or
                                        (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                        (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                        (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bandwidth" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.odu_level.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "odu-flex-cbr"):
                                        if (self.odu_flex_cbr is None):
                                            self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                            self.odu_flex_cbr.parent = self
                                            self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        return self.odu_flex_cbr

                                    if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                        if (self.odu_flex_gfp_f_non_res is None):
                                            self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                            self.odu_flex_gfp_f_non_res.parent = self
                                            self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        return self.odu_flex_gfp_f_non_res

                                    if (child_yang_name == "odu-flex-gfp-f-res"):
                                        if (self.odu_flex_gfp_f_res is None):
                                            self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                            self.odu_flex_gfp_f_res.parent = self
                                            self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        return self.odu_flex_gfp_f_res

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "odu-level"):
                                        self.odu_level = value
                                        self.odu_level.value_namespace = name_space
                                        self.odu_level.value_namespace_prefix = name_space_prefix


                            class Labels(Entity):
                                """
                                Labels
                                
                                .. attribute:: path_egress_label
                                
                                	Path message (upstream) egress label
                                	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                
                                .. attribute:: path_ingress_label
                                
                                	Path message (upstream) ingress label
                                	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                
                                .. attribute:: resv_egress_label
                                
                                	Resv message (downstream) egress label
                                	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                
                                .. attribute:: resv_ingress_label
                                
                                	Resv message (downstream) ingress label
                                	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels, self).__init__()

                                    self.yang_name = "labels"
                                    self.yang_parent_name = "otn"

                                    self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"
                                    self._children_yang_names.add("path-egress-label")

                                    self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    self._children_yang_names.add("path-ingress-label")

                                    self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    self._children_yang_names.add("resv-egress-label")

                                    self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    self._children_yang_names.add("resv-ingress-label")


                                class PathIngressLabel(Entity):
                                    """
                                    Path message (upstream) ingress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                        self.yang_name = "path-ingress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-ingress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-ingress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "path-ingress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class PathEgressLabel(Entity):
                                    """
                                    Path message (upstream) egress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                        self.yang_name = "path-egress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-egress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-egress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "path-egress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class ResvIngressLabel(Entity):
                                    """
                                    Resv message (downstream) ingress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                        self.yang_name = "resv-ingress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-ingress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-ingress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "resv-ingress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class ResvEgressLabel(Entity):
                                    """
                                    Resv message (downstream) egress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                        self.yang_name = "resv-egress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-egress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-egress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "resv-egress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                        (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                        (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                        (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                        (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                        (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                        (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "labels" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "path-egress-label"):
                                        if (self.path_egress_label is None):
                                            self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                            self.path_egress_label.parent = self
                                            self._children_name_map["path_egress_label"] = "path-egress-label"
                                        return self.path_egress_label

                                    if (child_yang_name == "path-ingress-label"):
                                        if (self.path_ingress_label is None):
                                            self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                            self.path_ingress_label.parent = self
                                            self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        return self.path_ingress_label

                                    if (child_yang_name == "resv-egress-label"):
                                        if (self.resv_egress_label is None):
                                            self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                            self.resv_egress_label.parent = self
                                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        return self.resv_egress_label

                                    if (child_yang_name == "resv-ingress-label"):
                                        if (self.resv_ingress_label is None):
                                            self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                            self.resv_ingress_label.parent = self
                                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        return self.resv_ingress_label

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.cross_connect_id.is_set or
                                    self.gpid.is_set or
                                    self.incoming_controller.is_set or
                                    self.incoming_controller_ifhandle.is_set or
                                    self.incoming_controller_state.is_set or
                                    self.incoming_sub_controller.is_set or
                                    self.incoming_sub_controller_ifhandle.is_set or
                                    self.incoming_sub_controller_state.is_set or
                                    self.is_connected.is_set or
                                    self.outgoing_controller.is_set or
                                    self.outgoing_controller_ifhandle.is_set or
                                    self.outgoing_controller_state.is_set or
                                    self.outgoing_sub_controller.is_set or
                                    self.outgoing_sub_controller_ifhandle.is_set or
                                    self.outgoing_sub_controller_state.is_set or
                                    self.uptime.is_set or
                                    (self.bandwidth is not None and self.bandwidth.has_data()) or
                                    (self.labels is not None and self.labels.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.cross_connect_id.yfilter != YFilter.not_set or
                                    self.gpid.yfilter != YFilter.not_set or
                                    self.incoming_controller.yfilter != YFilter.not_set or
                                    self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.incoming_controller_state.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                    self.is_connected.yfilter != YFilter.not_set or
                                    self.outgoing_controller.yfilter != YFilter.not_set or
                                    self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.outgoing_controller_state.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                    self.uptime.yfilter != YFilter.not_set or
                                    (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                    (self.labels is not None and self.labels.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.gpid.get_name_leafdata())
                                if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_connected.get_name_leafdata())
                                if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bandwidth"):
                                    if (self.bandwidth is None):
                                        self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth()
                                        self.bandwidth.parent = self
                                        self._children_name_map["bandwidth"] = "bandwidth"
                                    return self.bandwidth

                                if (child_yang_name == "labels"):
                                    if (self.labels is None):
                                        self.labels = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels()
                                        self.labels.parent = self
                                        self._children_name_map["labels"] = "labels"
                                    return self.labels

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "cross-connect-id"):
                                    self.cross_connect_id = value
                                    self.cross_connect_id.value_namespace = name_space
                                    self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "gpid"):
                                    self.gpid = value
                                    self.gpid.value_namespace = name_space
                                    self.gpid.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller"):
                                    self.incoming_controller = value
                                    self.incoming_controller.value_namespace = name_space
                                    self.incoming_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller-ifhandle"):
                                    self.incoming_controller_ifhandle = value
                                    self.incoming_controller_ifhandle.value_namespace = name_space
                                    self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller-state"):
                                    self.incoming_controller_state = value
                                    self.incoming_controller_state.value_namespace = name_space
                                    self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller"):
                                    self.incoming_sub_controller = value
                                    self.incoming_sub_controller.value_namespace = name_space
                                    self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller-ifhandle"):
                                    self.incoming_sub_controller_ifhandle = value
                                    self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                    self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller-state"):
                                    self.incoming_sub_controller_state = value
                                    self.incoming_sub_controller_state.value_namespace = name_space
                                    self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-connected"):
                                    self.is_connected = value
                                    self.is_connected.value_namespace = name_space
                                    self.is_connected.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller"):
                                    self.outgoing_controller = value
                                    self.outgoing_controller.value_namespace = name_space
                                    self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller-ifhandle"):
                                    self.outgoing_controller_ifhandle = value
                                    self.outgoing_controller_ifhandle.value_namespace = name_space
                                    self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller-state"):
                                    self.outgoing_controller_state = value
                                    self.outgoing_controller_state.value_namespace = name_space
                                    self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller"):
                                    self.outgoing_sub_controller = value
                                    self.outgoing_sub_controller.value_namespace = name_space
                                    self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller-ifhandle"):
                                    self.outgoing_sub_controller_ifhandle = value
                                    self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                    self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller-state"):
                                    self.outgoing_sub_controller_state = value
                                    self.outgoing_sub_controller_state.value_namespace = name_space
                                    self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "uptime"):
                                    self.uptime = value
                                    self.uptime.value_namespace = name_space
                                    self.uptime.value_namespace_prefix = name_space_prefix


                        class Aps(Entity):
                            """
                            APS Info for OTN S2L
                            
                            .. attribute:: protection_info
                            
                            	Protection Info
                            	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps, self).__init__()

                                self.yang_name = "aps"
                                self.yang_parent_name = "otn-s2l"

                                self.protection_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo()
                                self.protection_info.parent = self
                                self._children_name_map["protection_info"] = "protection-info"
                                self._children_yang_names.add("protection-info")


                            class ProtectionInfo(Entity):
                                """
                                Protection Info
                                
                                .. attribute:: ho_timeout
                                
                                	Hold\-Off timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_hopresent
                                
                                	Is Hold\-Off timeout present
                                	**type**\:  bool
                                
                                .. attribute:: is_snc_mode_present
                                
                                	Is SNC mode present
                                	**type**\:  bool
                                
                                .. attribute:: is_wtr_present
                                
                                	Is Wait\-to\-Restore timeout present
                                	**type**\:  bool
                                
                                .. attribute:: nbit
                                
                                	Notification bit 
                                	**type**\:  bool
                                
                                .. attribute:: obit
                                
                                	Operational bit
                                	**type**\:  bool
                                
                                .. attribute:: path_prot_profile_type
                                
                                	Path protection profile type
                                	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                
                                .. attribute:: pbit
                                
                                	Protecting bit
                                	**type**\:  bool
                                
                                .. attribute:: protect_type
                                
                                	LSP Protect Type
                                	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                
                                .. attribute:: sbit
                                
                                	Secondary bit
                                	**type**\:  bool
                                
                                .. attribute:: snc_mode
                                
                                	SNC mode
                                	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                
                                .. attribute:: tcm_id
                                
                                	TCM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wtr_timeout
                                
                                	Wait\-to\-Restore timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                    self.yang_name = "protection-info"
                                    self.yang_parent_name = "aps"

                                    self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                    self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                    self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                    self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                    self.nbit = YLeaf(YType.boolean, "nbit")

                                    self.obit = YLeaf(YType.boolean, "obit")

                                    self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                    self.pbit = YLeaf(YType.boolean, "pbit")

                                    self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                    self.sbit = YLeaf(YType.boolean, "sbit")

                                    self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                    self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                    self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ho_timeout",
                                                    "is_hopresent",
                                                    "is_snc_mode_present",
                                                    "is_wtr_present",
                                                    "nbit",
                                                    "obit",
                                                    "path_prot_profile_type",
                                                    "pbit",
                                                    "protect_type",
                                                    "sbit",
                                                    "snc_mode",
                                                    "tcm_id",
                                                    "wtr_timeout") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ho_timeout.is_set or
                                        self.is_hopresent.is_set or
                                        self.is_snc_mode_present.is_set or
                                        self.is_wtr_present.is_set or
                                        self.nbit.is_set or
                                        self.obit.is_set or
                                        self.path_prot_profile_type.is_set or
                                        self.pbit.is_set or
                                        self.protect_type.is_set or
                                        self.sbit.is_set or
                                        self.snc_mode.is_set or
                                        self.tcm_id.is_set or
                                        self.wtr_timeout.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ho_timeout.yfilter != YFilter.not_set or
                                        self.is_hopresent.yfilter != YFilter.not_set or
                                        self.is_snc_mode_present.yfilter != YFilter.not_set or
                                        self.is_wtr_present.yfilter != YFilter.not_set or
                                        self.nbit.yfilter != YFilter.not_set or
                                        self.obit.yfilter != YFilter.not_set or
                                        self.path_prot_profile_type.yfilter != YFilter.not_set or
                                        self.pbit.yfilter != YFilter.not_set or
                                        self.protect_type.yfilter != YFilter.not_set or
                                        self.sbit.yfilter != YFilter.not_set or
                                        self.snc_mode.yfilter != YFilter.not_set or
                                        self.tcm_id.yfilter != YFilter.not_set or
                                        self.wtr_timeout.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protection-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                    if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                    if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                    if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                    if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nbit.get_name_leafdata())
                                    if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.obit.get_name_leafdata())
                                    if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                    if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pbit.get_name_leafdata())
                                    if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protect_type.get_name_leafdata())
                                    if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sbit.get_name_leafdata())
                                    if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                    if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                    if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ho-timeout"):
                                        self.ho_timeout = value
                                        self.ho_timeout.value_namespace = name_space
                                        self.ho_timeout.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-hopresent"):
                                        self.is_hopresent = value
                                        self.is_hopresent.value_namespace = name_space
                                        self.is_hopresent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-snc-mode-present"):
                                        self.is_snc_mode_present = value
                                        self.is_snc_mode_present.value_namespace = name_space
                                        self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-wtr-present"):
                                        self.is_wtr_present = value
                                        self.is_wtr_present.value_namespace = name_space
                                        self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nbit"):
                                        self.nbit = value
                                        self.nbit.value_namespace = name_space
                                        self.nbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "obit"):
                                        self.obit = value
                                        self.obit.value_namespace = name_space
                                        self.obit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-prot-profile-type"):
                                        self.path_prot_profile_type = value
                                        self.path_prot_profile_type.value_namespace = name_space
                                        self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pbit"):
                                        self.pbit = value
                                        self.pbit.value_namespace = name_space
                                        self.pbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protect-type"):
                                        self.protect_type = value
                                        self.protect_type.value_namespace = name_space
                                        self.protect_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sbit"):
                                        self.sbit = value
                                        self.sbit.value_namespace = name_space
                                        self.sbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "snc-mode"):
                                        self.snc_mode = value
                                        self.snc_mode.value_namespace = name_space
                                        self.snc_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tcm-id"):
                                        self.tcm_id = value
                                        self.tcm_id.value_namespace = name_space
                                        self.tcm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wtr-timeout"):
                                        self.wtr_timeout = value
                                        self.wtr_timeout.value_namespace = name_space
                                        self.wtr_timeout.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.protection_info is not None and self.protection_info.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.protection_info is not None and self.protection_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "aps" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "protection-info"):
                                    if (self.protection_info is None):
                                        self.protection_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo()
                                        self.protection_info.parent = self
                                        self._children_name_map["protection_info"] = "protection-info"
                                    return self.protection_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "protection-info"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.aps is not None and self.aps.has_data()) or
                                (self.otn is not None and self.otn.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.aps is not None and self.aps.has_operation()) or
                                (self.otn is not None and self.otn.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn-s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "aps"):
                                if (self.aps is None):
                                    self.aps = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps()
                                    self.aps.parent = self
                                    self._children_name_map["aps"] = "aps"
                                return self.aps

                            if (child_yang_name == "otn"):
                                if (self.otn is None):
                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                return self.otn

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "aps" or name == "otn"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HeadEndBfdInfo(Entity):
                        """
                        The Head\-end BFD info
                        
                        .. attribute:: bfd_reverse_path_label
                        
                        	BFD reverse path labels
                        	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                        
                        .. attribute:: bfd_reverse_path_stale
                        
                        	The BFD reverse path is stale compared to configuration
                        	**type**\:  bool
                        
                        .. attribute:: creation_time
                        
                        	Time in seconds since the BFD session created
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: deletion_history
                        
                        	BFD Session Deletion History
                        	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory>`
                        
                        .. attribute:: is_redundant
                        
                        	sBFD session is redundant
                        	**type**\:  bool
                        
                        .. attribute:: lspbfd_type
                        
                        	LSP BFD type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__init__()

                            self.yang_name = "head-end-bfd-info"
                            self.yang_parent_name = "s2l"

                            self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                            self.creation_time = YLeaf(YType.uint32, "creation-time")

                            self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                            self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                            self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory()
                            self.deletion_history.parent = self
                            self._children_name_map["deletion_history"] = "deletion-history"
                            self._children_yang_names.add("deletion-history")

                            self.session_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._children_yang_names.add("session-info")

                            self.bfd_reverse_path_label = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_reverse_path_stale",
                                            "creation_time",
                                            "is_redundant",
                                            "lspbfd_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                        class SessionInfo(Entity):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("state",
                                                "state_change_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.state.is_set or
                                    self.state_change_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_change_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "session-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "state" or name == "state-change-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-change-time"):
                                    self.state_change_time = value
                                    self.state_change_time.value_namespace = name_space
                                    self.state_change_time.value_namespace_prefix = name_space_prefix


                        class DeletionHistory(Entity):
                            """
                            BFD Session Deletion History
                            
                            .. attribute:: deletion_diagnostic_code
                            
                            	Diagnostic Code for the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: deletion_reason
                            
                            	Reason for the BFD session get deleted
                            	**type**\:  str
                            
                            .. attribute:: deletion_time
                            
                            	Time stamp of the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID of the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                self.yang_name = "deletion-history"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("deletion_diagnostic_code",
                                                "deletion_reason",
                                                "deletion_time",
                                                "lsp_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.deletion_diagnostic_code.is_set or
                                    self.deletion_reason.is_set or
                                    self.deletion_time.is_set or
                                    self.lsp_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                    self.deletion_reason.yfilter != YFilter.not_set or
                                    self.deletion_time.yfilter != YFilter.not_set or
                                    self.lsp_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "deletion-history" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "deletion-diagnostic-code"):
                                    self.deletion_diagnostic_code = value
                                    self.deletion_diagnostic_code.value_namespace = name_space
                                    self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "deletion-reason"):
                                    self.deletion_reason = value
                                    self.deletion_reason.value_namespace = name_space
                                    self.deletion_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "deletion-time"):
                                    self.deletion_time = value
                                    self.deletion_time.value_namespace = name_space
                                    self.deletion_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-id"):
                                    self.lsp_id = value
                                    self.lsp_id.value_namespace = name_space
                                    self.lsp_id.value_namespace_prefix = name_space_prefix


                        class BfdReversePathLabel(Entity):
                            """
                            BFD reverse path labels
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                self.yang_name = "bfd-reverse-path-label"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bfd-reverse-path-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.bfd_reverse_path_label:
                                if (c.has_data()):
                                    return True
                            return (
                                self.bfd_reverse_path_stale.is_set or
                                self.creation_time.is_set or
                                self.is_redundant.is_set or
                                self.lspbfd_type.is_set or
                                (self.deletion_history is not None and self.deletion_history.has_data()) or
                                (self.session_info is not None and self.session_info.has_data()))

                        def has_operation(self):
                            for c in self.bfd_reverse_path_label:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.is_redundant.yfilter != YFilter.not_set or
                                self.lspbfd_type.yfilter != YFilter.not_set or
                                (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                (self.session_info is not None and self.session_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "head-end-bfd-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_redundant.get_name_leafdata())
                            if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bfd-reverse-path-label"):
                                for c in self.bfd_reverse_path_label:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.bfd_reverse_path_label.append(c)
                                return c

                            if (child_yang_name == "deletion-history"):
                                if (self.deletion_history is None):
                                    self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory()
                                    self.deletion_history.parent = self
                                    self._children_name_map["deletion_history"] = "deletion-history"
                                return self.deletion_history

                            if (child_yang_name == "session-info"):
                                if (self.session_info is None):
                                    self.session_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo()
                                    self.session_info.parent = self
                                    self._children_name_map["session_info"] = "session-info"
                                return self.session_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-reverse-path-stale"):
                                self.bfd_reverse_path_stale = value
                                self.bfd_reverse_path_stale.value_namespace = name_space
                                self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-redundant"):
                                self.is_redundant = value
                                self.is_redundant.value_namespace = name_space
                                self.is_redundant.value_namespace_prefix = name_space_prefix
                            if(value_path == "lspbfd-type"):
                                self.lspbfd_type = value
                                self.lspbfd_type.value_namespace = name_space
                                self.lspbfd_type.value_namespace_prefix = name_space_prefix


                    class TailEndBfdInfo(Entity):
                        """
                        The Tail\-end BFD info
                        
                        .. attribute:: failure_diagnostic_code
                        
                        	BFD session failure diagnostic code
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: failure_reason
                        
                        	BFD session failure reason
                        	**type**\:  str
                        
                        .. attribute:: local_discriminator
                        
                        	BFD Local Discriminator
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in mini second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: remote_discriminator
                        
                        	BFD Remote Discrminator
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__init__()

                            self.yang_name = "tail-end-bfd-info"
                            self.yang_parent_name = "s2l"

                            self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                            self.failure_reason = YLeaf(YType.str, "failure-reason")

                            self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                            self.session_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._children_yang_names.add("session-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("failure_diagnostic_code",
                                            "failure_reason",
                                            "local_discriminator",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "remote_discriminator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                        class SessionInfo(Entity):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "tail-end-bfd-info"

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("state",
                                                "state_change_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.state.is_set or
                                    self.state_change_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_change_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "session-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "state" or name == "state-change-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-change-time"):
                                    self.state_change_time = value
                                    self.state_change_time.value_namespace = name_space
                                    self.state_change_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.failure_diagnostic_code.is_set or
                                self.failure_reason.is_set or
                                self.local_discriminator.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.remote_discriminator.is_set or
                                (self.session_info is not None and self.session_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                self.failure_reason.yfilter != YFilter.not_set or
                                self.local_discriminator.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.remote_discriminator.yfilter != YFilter.not_set or
                                (self.session_info is not None and self.session_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tail-end-bfd-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                            if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.failure_reason.get_name_leafdata())
                            if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "session-info"):
                                if (self.session_info is None):
                                    self.session_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo()
                                    self.session_info.parent = self
                                    self._children_name_map["session_info"] = "session-info"
                                return self.session_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "failure-diagnostic-code"):
                                self.failure_diagnostic_code = value
                                self.failure_diagnostic_code.value_namespace = name_space
                                self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                            if(value_path == "failure-reason"):
                                self.failure_reason = value
                                self.failure_reason.value_namespace = name_space
                                self.failure_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-discriminator"):
                                self.local_discriminator = value
                                self.local_discriminator.value_namespace = name_space
                                self.local_discriminator.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-discriminator"):
                                self.remote_discriminator = value
                                self.remote_discriminator.value_namespace = name_space
                                self.remote_discriminator.value_namespace_prefix = name_space_prefix


                    class SrlgCollection(Entity):
                        """
                        SRLG\-collection data
                        
                        .. attribute:: discovered_srlg
                        
                        	Discovered SRLGs
                        	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg>`
                        
                        .. attribute:: srlg_collect_type
                        
                        	SRLG\-collection mechanism
                        	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__init__()

                            self.yang_name = "srlg-collection"
                            self.yang_parent_name = "s2l"

                            self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                            self.discovered_srlg = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("srlg_collect_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__setattr__(name, value)


                        class DiscoveredSrlg(Entity):
                            """
                            Discovered SRLGs
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                self.yang_name = "discovered-srlg"
                                self.yang_parent_name = "srlg-collection"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovered-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.discovered_srlg:
                                if (c.has_data()):
                                    return True
                            return self.srlg_collect_type.is_set

                        def has_operation(self):
                            for c in self.discovered_srlg:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.srlg_collect_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlg-collection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "discovered-srlg"):
                                for c in self.discovered_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.discovered_srlg.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "srlg-collect-type"):
                                self.srlg_collect_type = value
                                self.srlg_collect_type.value_namespace = name_space
                                self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "s2l"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "s2l"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLspFec(Entity):
                        """
                        Reverse Associated Bidir LSP FEC
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__init__()

                            self.yang_name = "reverse-lsp-fec"
                            self.yang_parent_name = "s2l"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "reverse-lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class ReverseTspec(Entity):
                        """
                        The Reverse T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__init__()

                            self.yang_name = "reverse-tspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class FlexInfo(Entity):
                        """
                        FlexLSP S2L Information
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "s2l"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class LspWrapInfo(Entity):
                        """
                        Lsp Wrap  Related information
                        
                        .. attribute:: lsp_wrap_protection_enable
                        
                        	LSP Wrap protection enabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_wrap_protection_label
                        
                        	LSP Wrap Merge Point Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsp_wrap_protection_state
                        
                        	LSP wrap protection state
                        	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                        
                        .. attribute:: reverse_egress_interface
                        
                        	Reverse Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_label
                        
                        	Reverse LSP label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__init__()

                            self.yang_name = "lsp-wrap-info"
                            self.yang_parent_name = "s2l"

                            self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                            self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                            self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                            self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                            self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_wrap_protection_enable",
                                            "lsp_wrap_protection_label",
                                            "lsp_wrap_protection_state",
                                            "reverse_egress_interface",
                                            "reverse_lsp_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_wrap_protection_enable.is_set or
                                self.lsp_wrap_protection_label.is_set or
                                self.lsp_wrap_protection_state.is_set or
                                self.reverse_egress_interface.is_set or
                                self.reverse_lsp_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                self.reverse_egress_interface.yfilter != YFilter.not_set or
                                self.reverse_lsp_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-wrap-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                            if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                            if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                            if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                            if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-wrap-protection-enable"):
                                self.lsp_wrap_protection_enable = value
                                self.lsp_wrap_protection_enable.value_namespace = name_space
                                self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-wrap-protection-label"):
                                self.lsp_wrap_protection_label = value
                                self.lsp_wrap_protection_label.value_namespace = name_space
                                self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-wrap-protection-state"):
                                self.lsp_wrap_protection_state = value
                                self.lsp_wrap_protection_state.value_namespace = name_space
                                self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-egress-interface"):
                                self.reverse_egress_interface = value
                                self.reverse_egress_interface.value_namespace = name_space
                                self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-label"):
                                self.reverse_lsp_label = value
                                self.reverse_lsp_label.value_namespace = name_space
                                self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        S2L Diversity Information
                        
                        .. attribute:: diversity_type
                        
                        	S2L path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "s2l"

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.diversity_type.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class S2LReverseLspSubObj(Entity):
                        """
                        Reverse LSP Sub Objects
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__init__()

                            self.yang_name = "s2l-reverse-lsp-sub-obj"
                            self.yang_parent_name = "s2l"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The S2L's excluded srlg groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "s2l"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class OutEro(Entity):
                        """
                        Outgoing ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__init__()

                            self.yang_name = "out-ero"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "out-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "out-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class InEro(Entity):
                        """
                        Incoming ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__init__()

                            self.yang_name = "in-ero"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "in-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "in-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "in-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class PathRro(Entity):
                        """
                        Path RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject>`
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject>`
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject>`
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__init__()

                            self.yang_name = "path-rro"
                            self.yang_parent_name = "s2l"

                            self.rro_type = YLeaf(YType.enumeration, "rro-type")

                            self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                            self._children_yang_names.add("ipv4rro-sub-object")

                            self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                            self._children_yang_names.add("label-rro-sub-object")

                            self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._children_yang_names.add("srlg-rro-sub-object")

                            self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                            self._children_yang_names.add("unnumbered-rro-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rro_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__setattr__(name, value)


                        class Ipv4RroSubObject(Entity):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags>`
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.rro_address = YLeaf(YType.str, "rro-address")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.rro_address.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_address.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "rro-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-address"):
                                    self.rro_address = value
                                    self.rro_address.value_namespace = name_space
                                    self.rro_address.value_namespace_prefix = name_space_prefix


                        class LabelRroSubObject(Entity):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags>`
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\:  bool
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                self.label = YLeaf(YType.uint32, "label")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                                self.variable_length_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_label_variable_length",
                                                "label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_global_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.is_global_label.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_global_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-global-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-global-label"):
                                        self.is_global_label = value
                                        self.is_global_label.value_namespace = name_space
                                        self.is_global_label.value_namespace_prefix = name_space_prefix


                            class VariableLengthLabel(Entity):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "variable-length-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.variable_length_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_label_variable_length.is_set or
                                    self.label.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                for c in self.variable_length_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_label_variable_length.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                if (child_yang_name == "variable-length-label"):
                                    for c in self.variable_length_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.variable_length_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-label-variable-length"):
                                    self.is_label_variable_length = value
                                    self.is_label_variable_length.value_namespace = name_space
                                    self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix


                        class UnnumberedRroSubObject(Entity):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_id = YLeaf(YType.uint32, "interface-id")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_address",
                                                "interface_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_address.is_set or
                                    self.interface_id.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_id.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-id"):
                                    self.interface_id = value
                                    self.interface_id.value_namespace = name_space
                                    self.interface_id.value_namespace_prefix = name_space_prefix


                        class SrlgRroSubObject(Entity):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.srl_gs = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                            class SrlGs(Entity):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srl-gs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.srl_gs:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.srl_gs:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "srl-gs"):
                                    for c in self.srl_gs:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.srl_gs.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "srl-gs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.rro_type.is_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rro_type.yfilter != YFilter.not_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-rro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rro_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4rro-sub-object"):
                                if (self.ipv4rro_sub_object is None):
                                    self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject()
                                    self.ipv4rro_sub_object.parent = self
                                    self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                return self.ipv4rro_sub_object

                            if (child_yang_name == "label-rro-sub-object"):
                                if (self.label_rro_sub_object is None):
                                    self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject()
                                    self.label_rro_sub_object.parent = self
                                    self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                return self.label_rro_sub_object

                            if (child_yang_name == "srlg-rro-sub-object"):
                                if (self.srlg_rro_sub_object is None):
                                    self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject()
                                    self.srlg_rro_sub_object.parent = self
                                    self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                return self.srlg_rro_sub_object

                            if (child_yang_name == "unnumbered-rro-sub-object"):
                                if (self.unnumbered_rro_sub_object is None):
                                    self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject()
                                    self.unnumbered_rro_sub_object.parent = self
                                    self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                return self.unnumbered_rro_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rro-type"):
                                self.rro_type = value
                                self.rro_type.value_namespace = name_space
                                self.rro_type.value_namespace_prefix = name_space_prefix


                    class ResvRro(Entity):
                        """
                        Resv RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject>`
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject>`
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject>`
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__init__()

                            self.yang_name = "resv-rro"
                            self.yang_parent_name = "s2l"

                            self.rro_type = YLeaf(YType.enumeration, "rro-type")

                            self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                            self._children_yang_names.add("ipv4rro-sub-object")

                            self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                            self._children_yang_names.add("label-rro-sub-object")

                            self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._children_yang_names.add("srlg-rro-sub-object")

                            self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                            self._children_yang_names.add("unnumbered-rro-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rro_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__setattr__(name, value)


                        class Ipv4RroSubObject(Entity):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.rro_address = YLeaf(YType.str, "rro-address")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.rro_address.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_address.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "rro-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-address"):
                                    self.rro_address = value
                                    self.rro_address.value_namespace = name_space
                                    self.rro_address.value_namespace_prefix = name_space_prefix


                        class LabelRroSubObject(Entity):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags>`
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\:  bool
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                self.label = YLeaf(YType.uint32, "label")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                                self.variable_length_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_label_variable_length",
                                                "label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_global_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.is_global_label.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_global_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-global-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-global-label"):
                                        self.is_global_label = value
                                        self.is_global_label.value_namespace = name_space
                                        self.is_global_label.value_namespace_prefix = name_space_prefix


                            class VariableLengthLabel(Entity):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "variable-length-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.variable_length_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_label_variable_length.is_set or
                                    self.label.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                for c in self.variable_length_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_label_variable_length.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                if (child_yang_name == "variable-length-label"):
                                    for c in self.variable_length_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.variable_length_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-label-variable-length"):
                                    self.is_label_variable_length = value
                                    self.is_label_variable_length.value_namespace = name_space
                                    self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix


                        class UnnumberedRroSubObject(Entity):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_id = YLeaf(YType.uint32, "interface-id")

                                self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_address",
                                                "interface_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_address.is_set or
                                    self.interface_id.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_id.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-id"):
                                    self.interface_id = value
                                    self.interface_id.value_namespace = name_space
                                    self.interface_id.value_namespace_prefix = name_space_prefix


                        class SrlgRroSubObject(Entity):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.srl_gs = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                            class SrlGs(Entity):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srl-gs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.srl_gs:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.srl_gs:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "srl-gs"):
                                    for c in self.srl_gs:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.srl_gs.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "srl-gs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.rro_type.is_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rro_type.yfilter != YFilter.not_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "resv-rro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rro_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4rro-sub-object"):
                                if (self.ipv4rro_sub_object is None):
                                    self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject()
                                    self.ipv4rro_sub_object.parent = self
                                    self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                return self.ipv4rro_sub_object

                            if (child_yang_name == "label-rro-sub-object"):
                                if (self.label_rro_sub_object is None):
                                    self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject()
                                    self.label_rro_sub_object.parent = self
                                    self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                return self.label_rro_sub_object

                            if (child_yang_name == "srlg-rro-sub-object"):
                                if (self.srlg_rro_sub_object is None):
                                    self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject()
                                    self.srlg_rro_sub_object.parent = self
                                    self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                return self.srlg_rro_sub_object

                            if (child_yang_name == "unnumbered-rro-sub-object"):
                                if (self.unnumbered_rro_sub_object is None):
                                    self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject()
                                    self.unnumbered_rro_sub_object.parent = self
                                    self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                return self.unnumbered_rro_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rro-type"):
                                self.rro_type = value
                                self.rro_type.value_namespace = name_space
                                self.rro_type.value_namespace_prefix = name_space_prefix


                    class PathAffinityArray(Entity):
                        """
                        Tunnel's Path hops with affinity
                        
                        .. attribute:: hop_address
                        
                        	Hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: hop_affinity
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hop_extended_affinity
                        
                        	Hop affinity
                        	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__init__()

                            self.yang_name = "path-affinity-array"
                            self.yang_parent_name = "s2l"

                            self.hop_address = YLeaf(YType.str, "hop-address")

                            self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                            self.hop_extended_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("hop_address",
                                            "hop_affinity") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__setattr__(name, value)


                        class HopExtendedAffinity(Entity):
                            """
                            Hop affinity
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                self.yang_name = "hop-extended-affinity"
                                self.yang_parent_name = "path-affinity-array"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "hop-extended-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.hop_extended_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.hop_address.is_set or
                                self.hop_affinity.is_set)

                        def has_operation(self):
                            for c in self.hop_extended_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.hop_address.yfilter != YFilter.not_set or
                                self.hop_affinity.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-affinity-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_address.get_name_leafdata())
                            if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "hop-extended-affinity"):
                                for c in self.hop_extended_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.hop_extended_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "hop-address"):
                                self.hop_address = value
                                self.hop_address.value_namespace = name_space
                                self.hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "hop-affinity"):
                                self.hop_affinity = value
                                self.hop_affinity.value_namespace = name_space
                                self.hop_affinity.value_namespace_prefix = name_space_prefix


                    class ReverseEroIn(Entity):
                        """
                         Reverse Incoming ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__init__()

                            self.yang_name = "reverse-ero-in"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-in" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class S2LSegmentRoutingPath(Entity):
                        """
                        Segment\-Routing S2L path info
                        
                        .. attribute:: has_entropy_label
                        
                        	Hop has EL specified
                        	**type**\:  bool
                        
                        .. attribute:: has_ip_addresses
                        
                        	Node has IP addresses specified
                        	**type**\:  bool
                        
                        .. attribute:: has_mpls_label
                        
                        	Hop has MPLS label specified
                        	**type**\:  bool
                        
                        .. attribute:: local_addr
                        
                        	Local IP address of adjacency or Node ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: mpls_label_value
                        
                        	The MPLS label value
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remote_addr
                        
                        	Remote IP address of adjacency
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: sid_type
                        
                        	Type of the SID
                        	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__init__()

                            self.yang_name = "s2l-segment-routing-path"
                            self.yang_parent_name = "s2l"

                            self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                            self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                            self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                            self.local_addr = YLeaf(YType.str, "local-addr")

                            self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                            self.remote_addr = YLeaf(YType.str, "remote-addr")

                            self.sid_type = YLeaf(YType.enumeration, "sid-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("has_entropy_label",
                                            "has_ip_addresses",
                                            "has_mpls_label",
                                            "local_addr",
                                            "mpls_label_value",
                                            "remote_addr",
                                            "sid_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.has_entropy_label.is_set or
                                self.has_ip_addresses.is_set or
                                self.has_mpls_label.is_set or
                                self.local_addr.is_set or
                                self.mpls_label_value.is_set or
                                self.remote_addr.is_set or
                                self.sid_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.has_entropy_label.yfilter != YFilter.not_set or
                                self.has_ip_addresses.yfilter != YFilter.not_set or
                                self.has_mpls_label.yfilter != YFilter.not_set or
                                self.local_addr.yfilter != YFilter.not_set or
                                self.mpls_label_value.yfilter != YFilter.not_set or
                                self.remote_addr.yfilter != YFilter.not_set or
                                self.sid_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-segment-routing-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                            if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                            if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                            if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_addr.get_name_leafdata())
                            if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                            if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_addr.get_name_leafdata())
                            if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sid_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "has-entropy-label"):
                                self.has_entropy_label = value
                                self.has_entropy_label.value_namespace = name_space
                                self.has_entropy_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-ip-addresses"):
                                self.has_ip_addresses = value
                                self.has_ip_addresses.value_namespace = name_space
                                self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-mpls-label"):
                                self.has_mpls_label = value
                                self.has_mpls_label.value_namespace = name_space
                                self.has_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-addr"):
                                self.local_addr = value
                                self.local_addr.value_namespace = name_space
                                self.local_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label-value"):
                                self.mpls_label_value = value
                                self.mpls_label_value.value_namespace = name_space
                                self.mpls_label_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-addr"):
                                self.remote_addr = value
                                self.remote_addr.value_namespace = name_space
                                self.remote_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "sid-type"):
                                self.sid_type = value
                                self.sid_type.value_namespace = name_space
                                self.sid_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.in_ero:
                            if (c.has_data()):
                                return True
                        for c in self.out_ero:
                            if (c.has_data()):
                                return True
                        for c in self.path_affinity_array:
                            if (c.has_data()):
                                return True
                        for c in self.path_rro:
                            if (c.has_data()):
                                return True
                        for c in self.resv_rro:
                            if (c.has_data()):
                                return True
                        for c in self.reverse_ero_in:
                            if (c.has_data()):
                                return True
                        for c in self.s2l_reverse_lsp_sub_obj:
                            if (c.has_data()):
                                return True
                        for c in self.s2l_segment_routing_path:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.abr_auto_discovered.is_set or
                            self.backup_tunnel_interface.is_set or
                            self.downstream_router_id.is_set or
                            self.egress_interface.is_set or
                            self.egress_interface_brief.is_set or
                            self.egress_interface_state.is_set or
                            self.expanded_ero_affinity_bits.is_set or
                            self.expanded_ero_affinity_mask.is_set or
                            self.expanded_ero_area_id.is_set or
                            self.expanded_ero_metric.is_set or
                            self.expanded_ero_metric_type.is_set or
                            self.frr_out_tunnel_interface.is_set or
                            self.incoming_address.is_set or
                            self.ingress_interface.is_set or
                            self.ingress_interface_brief.is_set or
                            self.ingress_interface_state.is_set or
                            self.is_bandwidth_protect.is_set or
                            self.is_expanded_ero.is_set or
                            self.is_frr_enabled.is_set or
                            self.is_node_protected.is_set or
                            self.is_optical.is_set or
                            self.local_router_id.is_set or
                            self.next_hop_address.is_set or
                            self.node_hop_count.is_set or
                            self.outbound_frr_state.is_set or
                            self.path_reeval_query_mid.is_set or
                            self.path_rro_enabled.is_set or
                            self.path_using_strict_spf.is_set or
                            self.pcalc_area.is_set or
                            self.previous_hop_address.is_set or
                            self.reverse_lsp_connected.is_set or
                            self.reverse_lsp_name.is_set or
                            self.reverse_lsp_present.is_set or
                            self.reverse_weight.is_set or
                            self.role.is_set or
                            self.s2l_local_label.is_set or
                            self.s2l_out_label.is_set or
                            self.s2l_reverse_ero_obj_present.is_set or
                            self.s2l_reverse_tspec_obj_present.is_set or
                            self.signalling_status.is_set or
                            self.time_since_last_preferred_path_exists_send_mid.is_set or
                            self.time_since_last_preferred_tree_exists_send_mid.is_set or
                            self.time_since_last_query_received_mid.is_set or
                            self.upstream_router_id.is_set or
                            self.uptime.is_set or
                            self.weight.is_set or
                            (self.active_path_option is not None and self.active_path_option.has_data()) or
                            (self.association is not None and self.association.has_data()) or
                            (self.diversity_info is not None and self.diversity_info.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.fspec is not None and self.fspec.has_data()) or
                            (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                            (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                            (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                            (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                            (self.in_xro is not None and self.in_xro.has_data()) or
                            (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                            (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                            (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                            (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                            (self.out_xro is not None and self.out_xro.has_data()) or
                            (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                            (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                            (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                            (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                            (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                            (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                            (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                            (self.tspec is not None and self.tspec.has_data()))

                    def has_operation(self):
                        for c in self.in_ero:
                            if (c.has_operation()):
                                return True
                        for c in self.out_ero:
                            if (c.has_operation()):
                                return True
                        for c in self.path_affinity_array:
                            if (c.has_operation()):
                                return True
                        for c in self.path_rro:
                            if (c.has_operation()):
                                return True
                        for c in self.resv_rro:
                            if (c.has_operation()):
                                return True
                        for c in self.reverse_ero_in:
                            if (c.has_operation()):
                                return True
                        for c in self.s2l_reverse_lsp_sub_obj:
                            if (c.has_operation()):
                                return True
                        for c in self.s2l_segment_routing_path:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.abr_auto_discovered.yfilter != YFilter.not_set or
                            self.backup_tunnel_interface.yfilter != YFilter.not_set or
                            self.downstream_router_id.yfilter != YFilter.not_set or
                            self.egress_interface.yfilter != YFilter.not_set or
                            self.egress_interface_brief.yfilter != YFilter.not_set or
                            self.egress_interface_state.yfilter != YFilter.not_set or
                            self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                            self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                            self.expanded_ero_area_id.yfilter != YFilter.not_set or
                            self.expanded_ero_metric.yfilter != YFilter.not_set or
                            self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                            self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                            self.incoming_address.yfilter != YFilter.not_set or
                            self.ingress_interface.yfilter != YFilter.not_set or
                            self.ingress_interface_brief.yfilter != YFilter.not_set or
                            self.ingress_interface_state.yfilter != YFilter.not_set or
                            self.is_bandwidth_protect.yfilter != YFilter.not_set or
                            self.is_expanded_ero.yfilter != YFilter.not_set or
                            self.is_frr_enabled.yfilter != YFilter.not_set or
                            self.is_node_protected.yfilter != YFilter.not_set or
                            self.is_optical.yfilter != YFilter.not_set or
                            self.local_router_id.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.node_hop_count.yfilter != YFilter.not_set or
                            self.outbound_frr_state.yfilter != YFilter.not_set or
                            self.path_reeval_query_mid.yfilter != YFilter.not_set or
                            self.path_rro_enabled.yfilter != YFilter.not_set or
                            self.path_using_strict_spf.yfilter != YFilter.not_set or
                            self.pcalc_area.yfilter != YFilter.not_set or
                            self.previous_hop_address.yfilter != YFilter.not_set or
                            self.reverse_lsp_connected.yfilter != YFilter.not_set or
                            self.reverse_lsp_name.yfilter != YFilter.not_set or
                            self.reverse_lsp_present.yfilter != YFilter.not_set or
                            self.reverse_weight.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            self.s2l_local_label.yfilter != YFilter.not_set or
                            self.s2l_out_label.yfilter != YFilter.not_set or
                            self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                            self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                            self.signalling_status.yfilter != YFilter.not_set or
                            self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                            self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                            self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                            self.upstream_router_id.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            self.weight.yfilter != YFilter.not_set or
                            (self.active_path_option is not None and self.active_path_option.has_operation()) or
                            (self.association is not None and self.association.has_operation()) or
                            (self.diversity_info is not None and self.diversity_info.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.fspec is not None and self.fspec.has_operation()) or
                            (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                            (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                            (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                            (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                            (self.in_xro is not None and self.in_xro.has_operation()) or
                            (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                            (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                            (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                            (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                            (self.out_xro is not None and self.out_xro.has_operation()) or
                            (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                            (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                            (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                            (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                            (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                            (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                            (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                            (self.tspec is not None and self.tspec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                        if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                        if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                        if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface.get_name_leafdata())
                        if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                        if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                        if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                        if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                        if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                        if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                        if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                        if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                        if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_address.get_name_leafdata())
                        if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                        if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                        if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                        if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                        if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                        if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                        if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                        if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_optical.get_name_leafdata())
                        if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_router_id.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                        if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                        if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                        if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                        if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                        if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                        if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                        if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                        if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                        if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                        if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())
                        if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                        if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                        if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                        if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                        if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signalling_status.get_name_leafdata())
                        if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                        if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                        if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                        if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())
                        if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.weight.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "active-path-option"):
                            if (self.active_path_option is None):
                                self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption()
                                self.active_path_option.parent = self
                                self._children_name_map["active_path_option"] = "active-path-option"
                            return self.active_path_option

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "diversity-info"):
                            if (self.diversity_info is None):
                                self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo()
                                self.diversity_info.parent = self
                                self._children_name_map["diversity_info"] = "diversity-info"
                            return self.diversity_info

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "fspec"):
                            if (self.fspec is None):
                                self.fspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec()
                                self.fspec.parent = self
                                self._children_name_map["fspec"] = "fspec"
                            return self.fspec

                        if (child_yang_name == "generic-fspec"):
                            if (self.generic_fspec is None):
                                self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec()
                                self.generic_fspec.parent = self
                                self._children_name_map["generic_fspec"] = "generic-fspec"
                            return self.generic_fspec

                        if (child_yang_name == "generic-tspec"):
                            if (self.generic_tspec is None):
                                self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec()
                                self.generic_tspec.parent = self
                                self._children_name_map["generic_tspec"] = "generic-tspec"
                            return self.generic_tspec

                        if (child_yang_name == "gmpls-labels"):
                            if (self.gmpls_labels is None):
                                self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels()
                                self.gmpls_labels.parent = self
                                self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            return self.gmpls_labels

                        if (child_yang_name == "head-end-bfd-info"):
                            if (self.head_end_bfd_info is None):
                                self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo()
                                self.head_end_bfd_info.parent = self
                                self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            return self.head_end_bfd_info

                        if (child_yang_name == "in-ero"):
                            for c in self.in_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.in_ero.append(c)
                            return c

                        if (child_yang_name == "in-xro"):
                            if (self.in_xro is None):
                                self.in_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro()
                                self.in_xro.parent = self
                                self._children_name_map["in_xro"] = "in-xro"
                            return self.in_xro

                        if (child_yang_name == "incoming-address-generic"):
                            if (self.incoming_address_generic is None):
                                self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric()
                                self.incoming_address_generic.parent = self
                                self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            return self.incoming_address_generic

                        if (child_yang_name == "lsp-wrap-info"):
                            if (self.lsp_wrap_info is None):
                                self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo()
                                self.lsp_wrap_info.parent = self
                                self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            return self.lsp_wrap_info

                        if (child_yang_name == "next-hop-address-generic"):
                            if (self.next_hop_address_generic is None):
                                self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric()
                                self.next_hop_address_generic.parent = self
                                self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            return self.next_hop_address_generic

                        if (child_yang_name == "otn-s2l"):
                            if (self.otn_s2l is None):
                                self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L()
                                self.otn_s2l.parent = self
                                self._children_name_map["otn_s2l"] = "otn-s2l"
                            return self.otn_s2l

                        if (child_yang_name == "out-ero"):
                            for c in self.out_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.out_ero.append(c)
                            return c

                        if (child_yang_name == "out-xro"):
                            if (self.out_xro is None):
                                self.out_xro = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro()
                                self.out_xro.parent = self
                                self._children_name_map["out_xro"] = "out-xro"
                            return self.out_xro

                        if (child_yang_name == "path-affinity-array"):
                            for c in self.path_affinity_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_affinity_array.append(c)
                            return c

                        if (child_yang_name == "path-rro"):
                            for c in self.path_rro:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_rro.append(c)
                            return c

                        if (child_yang_name == "previous-hop-address-generic"):
                            if (self.previous_hop_address_generic is None):
                                self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric()
                                self.previous_hop_address_generic.parent = self
                                self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            return self.previous_hop_address_generic

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "resv-rro"):
                            for c in self.resv_rro:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.resv_rro.append(c)
                            return c

                        if (child_yang_name == "reverse-ero-in"):
                            for c in self.reverse_ero_in:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.reverse_ero_in.append(c)
                            return c

                        if (child_yang_name == "reverse-lsp-fec"):
                            if (self.reverse_lsp_fec is None):
                                self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec()
                                self.reverse_lsp_fec.parent = self
                                self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            return self.reverse_lsp_fec

                        if (child_yang_name == "reverse-tspec"):
                            if (self.reverse_tspec is None):
                                self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec()
                                self.reverse_tspec.parent = self
                                self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            return self.reverse_tspec

                        if (child_yang_name == "s2l-convergence"):
                            if (self.s2l_convergence is None):
                                self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence()
                                self.s2l_convergence.parent = self
                                self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            return self.s2l_convergence

                        if (child_yang_name == "s2l-fec"):
                            if (self.s2l_fec is None):
                                self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                            return self.s2l_fec

                        if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                            for c in self.s2l_reverse_lsp_sub_obj:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_reverse_lsp_sub_obj.append(c)
                            return c

                        if (child_yang_name == "s2l-segment-routing-path"):
                            for c in self.s2l_segment_routing_path:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_segment_routing_path.append(c)
                            return c

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        if (child_yang_name == "soft-preemption"):
                            if (self.soft_preemption is None):
                                self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption()
                                self.soft_preemption.parent = self
                                self._children_name_map["soft_preemption"] = "soft-preemption"
                            return self.soft_preemption

                        if (child_yang_name == "srlg-collection"):
                            if (self.srlg_collection is None):
                                self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection()
                                self.srlg_collection.parent = self
                                self._children_name_map["srlg_collection"] = "srlg-collection"
                            return self.srlg_collection

                        if (child_yang_name == "tail-end-bfd-info"):
                            if (self.tail_end_bfd_info is None):
                                self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo()
                                self.tail_end_bfd_info.parent = self
                                self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            return self.tail_end_bfd_info

                        if (child_yang_name == "tspec"):
                            if (self.tspec is None):
                                self.tspec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec()
                                self.tspec.parent = self
                                self._children_name_map["tspec"] = "tspec"
                            return self.tspec

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "abr-auto-discovered"):
                            self.abr_auto_discovered = value
                            self.abr_auto_discovered.value_namespace = name_space
                            self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-tunnel-interface"):
                            self.backup_tunnel_interface = value
                            self.backup_tunnel_interface.value_namespace = name_space
                            self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "downstream-router-id"):
                            self.downstream_router_id = value
                            self.downstream_router_id.value_namespace = name_space
                            self.downstream_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface"):
                            self.egress_interface = value
                            self.egress_interface.value_namespace = name_space
                            self.egress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface-brief"):
                            self.egress_interface_brief = value
                            self.egress_interface_brief.value_namespace = name_space
                            self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface-state"):
                            self.egress_interface_state = value
                            self.egress_interface_state.value_namespace = name_space
                            self.egress_interface_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-affinity-bits"):
                            self.expanded_ero_affinity_bits = value
                            self.expanded_ero_affinity_bits.value_namespace = name_space
                            self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-affinity-mask"):
                            self.expanded_ero_affinity_mask = value
                            self.expanded_ero_affinity_mask.value_namespace = name_space
                            self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-area-id"):
                            self.expanded_ero_area_id = value
                            self.expanded_ero_area_id.value_namespace = name_space
                            self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-metric"):
                            self.expanded_ero_metric = value
                            self.expanded_ero_metric.value_namespace = name_space
                            self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-metric-type"):
                            self.expanded_ero_metric_type = value
                            self.expanded_ero_metric_type.value_namespace = name_space
                            self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-out-tunnel-interface"):
                            self.frr_out_tunnel_interface = value
                            self.frr_out_tunnel_interface.value_namespace = name_space
                            self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-address"):
                            self.incoming_address = value
                            self.incoming_address.value_namespace = name_space
                            self.incoming_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface"):
                            self.ingress_interface = value
                            self.ingress_interface.value_namespace = name_space
                            self.ingress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface-brief"):
                            self.ingress_interface_brief = value
                            self.ingress_interface_brief.value_namespace = name_space
                            self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface-state"):
                            self.ingress_interface_state = value
                            self.ingress_interface_state.value_namespace = name_space
                            self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-protect"):
                            self.is_bandwidth_protect = value
                            self.is_bandwidth_protect.value_namespace = name_space
                            self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-expanded-ero"):
                            self.is_expanded_ero = value
                            self.is_expanded_ero.value_namespace = name_space
                            self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-enabled"):
                            self.is_frr_enabled = value
                            self.is_frr_enabled.value_namespace = name_space
                            self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-node-protected"):
                            self.is_node_protected = value
                            self.is_node_protected.value_namespace = name_space
                            self.is_node_protected.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-optical"):
                            self.is_optical = value
                            self.is_optical.value_namespace = name_space
                            self.is_optical.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-router-id"):
                            self.local_router_id = value
                            self.local_router_id.value_namespace = name_space
                            self.local_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-hop-count"):
                            self.node_hop_count = value
                            self.node_hop_count.value_namespace = name_space
                            self.node_hop_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-frr-state"):
                            self.outbound_frr_state = value
                            self.outbound_frr_state.value_namespace = name_space
                            self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-reeval-query-mid"):
                            self.path_reeval_query_mid = value
                            self.path_reeval_query_mid.value_namespace = name_space
                            self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-rro-enabled"):
                            self.path_rro_enabled = value
                            self.path_rro_enabled.value_namespace = name_space
                            self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-using-strict-spf"):
                            self.path_using_strict_spf = value
                            self.path_using_strict_spf.value_namespace = name_space
                            self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-area"):
                            self.pcalc_area = value
                            self.pcalc_area.value_namespace = name_space
                            self.pcalc_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "previous-hop-address"):
                            self.previous_hop_address = value
                            self.previous_hop_address.value_namespace = name_space
                            self.previous_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-connected"):
                            self.reverse_lsp_connected = value
                            self.reverse_lsp_connected.value_namespace = name_space
                            self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-name"):
                            self.reverse_lsp_name = value
                            self.reverse_lsp_name.value_namespace = name_space
                            self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-present"):
                            self.reverse_lsp_present = value
                            self.reverse_lsp_present.value_namespace = name_space
                            self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-weight"):
                            self.reverse_weight = value
                            self.reverse_weight.value_namespace = name_space
                            self.reverse_weight.value_namespace_prefix = name_space_prefix
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-local-label"):
                            self.s2l_local_label = value
                            self.s2l_local_label.value_namespace = name_space
                            self.s2l_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-out-label"):
                            self.s2l_out_label = value
                            self.s2l_out_label.value_namespace = name_space
                            self.s2l_out_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-reverse-ero-obj-present"):
                            self.s2l_reverse_ero_obj_present = value
                            self.s2l_reverse_ero_obj_present.value_namespace = name_space
                            self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-reverse-tspec-obj-present"):
                            self.s2l_reverse_tspec_obj_present = value
                            self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                            self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "signalling-status"):
                            self.signalling_status = value
                            self.signalling_status.value_namespace = name_space
                            self.signalling_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                            self.time_since_last_preferred_path_exists_send_mid = value
                            self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                            self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                            self.time_since_last_preferred_tree_exists_send_mid = value
                            self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                            self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-query-received-mid"):
                            self.time_since_last_query_received_mid = value
                            self.time_since_last_query_received_mid.value_namespace = name_space
                            self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "upstream-router-id"):
                            self.upstream_router_id = value
                            self.upstream_router_id.value_namespace = name_space
                            self.upstream_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "weight"):
                            self.weight = value
                            self.weight.value_namespace = name_space
                            self.weight.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    return (
                        self.lsp_id.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.p2mp_id.is_set or
                        self.dste_class_index.is_set or
                        self.dste_class_match.is_set or
                        self.frr_active_reason.is_set or
                        self.is_frr_failed.is_set or
                        self.is_interface.is_set or
                        self.is_passive.is_set or
                        self.last_path_change.is_set or
                        self.lsp_bandwidth.is_set or
                        self.lsp_bandwidth_type.is_set or
                        self.lsp_hold_priority.is_set or
                        self.lsp_setup_priority.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.reoptimize_reason.is_set or
                        self.reoptimize_trigger.is_set or
                        self.s2_ls_down.is_set or
                        self.s2_ls_proceeding.is_set or
                        self.s2_ls_up.is_set or
                        self.signaled_name.is_set or
                        self.timer_left.is_set or
                        self.type.is_set or
                        self.uptime.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.dste_class_index.yfilter != YFilter.not_set or
                        self.dste_class_match.yfilter != YFilter.not_set or
                        self.frr_active_reason.yfilter != YFilter.not_set or
                        self.is_frr_failed.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.lsp_bandwidth.yfilter != YFilter.not_set or
                        self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                        self.lsp_hold_priority.yfilter != YFilter.not_set or
                        self.lsp_setup_priority.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.reoptimize_reason.yfilter != YFilter.not_set or
                        self.reoptimize_trigger.yfilter != YFilter.not_set or
                        self.s2_ls_down.yfilter != YFilter.not_set or
                        self.s2_ls_proceeding.yfilter != YFilter.not_set or
                        self.s2_ls_up.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.timer_left.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-remote" + "[lsp-id='" + self.lsp_id.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-remotes/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                    if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                    if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                    if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                    if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                    if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                    if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                    if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                    if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                    if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                    if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_left.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "s2l" or name == "lsp-id" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "source-address" or name == "ctype" or name == "destination-address" or name == "p2mp-id" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "dste-class-index"):
                        self.dste_class_index = value
                        self.dste_class_index.value_namespace = name_space
                        self.dste_class_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "dste-class-match"):
                        self.dste_class_match = value
                        self.dste_class_match.value_namespace = name_space
                        self.dste_class_match.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-reason"):
                        self.frr_active_reason = value
                        self.frr_active_reason.value_namespace = name_space
                        self.frr_active_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-frr-failed"):
                        self.is_frr_failed = value
                        self.is_frr_failed.value_namespace = name_space
                        self.is_frr_failed.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth"):
                        self.lsp_bandwidth = value
                        self.lsp_bandwidth.value_namespace = name_space
                        self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth-type"):
                        self.lsp_bandwidth_type = value
                        self.lsp_bandwidth_type.value_namespace = name_space
                        self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-hold-priority"):
                        self.lsp_hold_priority = value
                        self.lsp_hold_priority.value_namespace = name_space
                        self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-setup-priority"):
                        self.lsp_setup_priority = value
                        self.lsp_setup_priority.value_namespace = name_space
                        self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-reason"):
                        self.reoptimize_reason = value
                        self.reoptimize_reason.value_namespace = name_space
                        self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-trigger"):
                        self.reoptimize_trigger = value
                        self.reoptimize_trigger.value_namespace = name_space
                        self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-down"):
                        self.s2_ls_down = value
                        self.s2_ls_down.value_namespace = name_space
                        self.s2_ls_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-proceeding"):
                        self.s2_ls_proceeding = value
                        self.s2_ls_proceeding.value_namespace = name_space
                        self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-up"):
                        self.s2_ls_up = value
                        self.s2_ls_up.value_namespace = name_space
                        self.s2_ls_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-left"):
                        self.timer_left = value
                        self.timer_left.value_namespace = name_space
                        self.timer_left.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_remote:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_remote:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-remotes" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-remote"):
                    for c in self.tunnel_remote:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2PP2MpTunnel.TunnelRemotes.TunnelRemote()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_remote.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-remote"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class NniTunnels(Entity):
            """
            GMPLS NNI tunnels
            
            .. attribute:: nni_tunnel
            
            	GMPLS\-NNI tail tunnel
            	**type**\: list of    :py:class:`NniTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2PP2MpTunnel.NniTunnels, self).__init__()

                self.yang_name = "nni-tunnels"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.nni_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2PP2MpTunnel.NniTunnels, self).__setattr__(name, value)


            class NniTunnel(Entity):
                """
                GMPLS\-NNI tail tunnel
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:   :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\:  bool
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\:  str
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:   :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup>`
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:   :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh>`
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:   :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc>`
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\:  bool
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\:  bool
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:   :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo>`
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:   :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir>`
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\:  bool
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:   :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp>`
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config>`
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:   :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp>`
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination>`
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\:  bool
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:   :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo>`
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\:  bool
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:   :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History>`
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:   :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\:  bool
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\:  bool
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\:  bool
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\:  bool
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\:  bool
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:   :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\:  bool
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:   :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:   :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir>`
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo>`
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\:  str
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection>`
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:   :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation>`
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:   :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:   :py:class:`ReoptimizedP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp>`
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:   :py:class:`ReoptimizedStandbyP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp>`
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\:  bool
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption>`
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:   :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence>`
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:   :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo>`
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\:  str
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:   :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp>`
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\:  bool
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:   :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp>`
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:   :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:   :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel>`
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet>`
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__init__()

                    self.yang_name = "nni-tunnel"
                    self.yang_parent_name = "nni-tunnels"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.admin_state = YLeaf(YType.enumeration, "admin-state")

                    self.affinity_failure_delayed_tear_time_remained = YLeaf(YType.uint32, "affinity-failure-delayed-tear-time-remained")

                    self.affinity_failure_reopt_disabled = YLeaf(YType.boolean, "affinity-failure-reopt-disabled")

                    self.affinity_failure_reopt_time_remained = YLeaf(YType.uint32, "affinity-failure-reopt-time-remained")

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.auto_route = YLeaf(YType.boolean, "auto-route")

                    self.autoroute_announce_exclude_segment_routing = YLeaf(YType.boolean, "autoroute-announce-exclude-segment-routing")

                    self.bandwidth_requested = YLeaf(YType.uint32, "bandwidth-requested")

                    self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                    self.binding_label_exists = YLeaf(YType.boolean, "binding-label-exists")

                    self.create_time = YLeaf(YType.uint32, "create-time")

                    self.destination_disabled_count = YLeaf(YType.uint32, "destination-disabled-count")

                    self.destination_down_count = YLeaf(YType.uint32, "destination-down-count")

                    self.destination_up_count = YLeaf(YType.uint32, "destination-up-count")

                    self.drop_mode = YLeaf(YType.boolean, "drop-mode")

                    self.explicit_path_change = YLeaf(YType.boolean, "explicit-path-change")

                    self.fail_reason = YLeaf(YType.enumeration, "fail-reason")

                    self.forwarding_adjacency = YLeaf(YType.boolean, "forwarding-adjacency")

                    self.hop_limit_ignored_reason = YLeaf(YType.enumeration, "hop-limit-ignored-reason")

                    self.invalidation_time_remained = YLeaf(YType.uint32, "invalidation-time-remained")

                    self.is_auto_backup = YLeaf(YType.boolean, "is-auto-backup")

                    self.is_auto_pcc = YLeaf(YType.boolean, "is-auto-pcc")

                    self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                    self.is_hop_limit_ignore = YLeaf(YType.boolean, "is-hop-limit-ignore")

                    self.is_inter_area_tunnel = YLeaf(YType.boolean, "is-inter-area-tunnel")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_named = YLeaf(YType.boolean, "is-named")

                    self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.is_pce_delegated = YLeaf(YType.boolean, "is-pce-delegated")

                    self.last_hop_ifindex = YLeaf(YType.uint32, "last-hop-ifindex")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.load_share_factor = YLeaf(YType.uint32, "load-share-factor")

                    self.load_share_type = YLeaf(YType.enumeration, "load-share-type")

                    self.lsp_wrap_label = YLeaf(YType.uint32, "lsp-wrap-label")

                    self.lsp_wrap_protection_enabled = YLeaf(YType.boolean, "lsp-wrap-protection-enabled")

                    self.metric_qualifier = YLeaf(YType.enumeration, "metric-qualifier")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                    self.operational_state = YLeaf(YType.enumeration, "operational-state")

                    self.operational_state_changes = YLeaf(YType.uint32, "operational-state-changes")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.passive_tunnel_name = YLeaf(YType.str, "passive-tunnel-name")

                    self.path_option_change = YLeaf(YType.boolean, "path-option-change")

                    self.pce_fail_reason = YLeaf(YType.enumeration, "pce-fail-reason")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.re_opt_hold_down_timer_remaining = YLeaf(YType.uint32, "re-opt-hold-down-timer-remaining")

                    self.reroute_pending = YLeaf(YType.boolean, "reroute-pending")

                    self.role_standby = YLeaf(YType.boolean, "role-standby")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.snmp_index = YLeaf(YType.uint32, "snmp-index")

                    self.tie_breaker = YLeaf(YType.enumeration, "tie-breaker")

                    self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                    self.tiebreaker_type = YLeaf(YType.uint32, "tiebreaker-type")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                    self.tunnel_recovering = YLeaf(YType.boolean, "tunnel-recovering")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.xro_attribute_set_name = YLeaf(YType.str, "xro-attribute-set-name")

                    self.auto_backup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"
                    self._children_yang_names.add("auto-backup")

                    self.auto_mesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"
                    self._children_yang_names.add("auto-mesh")

                    self.auto_pcc = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"
                    self._children_yang_names.add("auto-pcc")

                    self.bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"
                    self._children_yang_names.add("bfd-info")

                    self.bidir = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"
                    self._children_yang_names.add("bidir")

                    self.cleaned_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                    self._children_yang_names.add("cleaned-lsp")

                    self.config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"
                    self._children_yang_names.add("config")

                    self.delay_clean_pp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                    self._children_yang_names.add("delay-clean-pp-lsp")

                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"
                    self._children_yang_names.add("flex-info")

                    self.history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"
                    self._children_yang_names.add("history")

                    self.otn_bidir = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"
                    self._children_yang_names.add("otn-bidir")

                    self.p2p_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"
                    self._children_yang_names.add("p2p-info")

                    self.path_protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.pce_delegation = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"
                    self._children_yang_names.add("pce-delegation")

                    self.reoptimized_p2mp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-p2mp-lsp")

                    self.reoptimized_standby_p2mp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-standby-p2mp-lsp")

                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"
                    self._children_yang_names.add("soft-preemption")

                    self.te_tunnel_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                    self._children_yang_names.add("te-tunnel-convergence")

                    self.transport_tunnel_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                    self._children_yang_names.add("transport-tunnel-info")

                    self.tunnel_current_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                    self._children_yang_names.add("tunnel-current-lsp")

                    self.tunnel_restoration_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                    self._children_yang_names.add("tunnel-restoration-lsp")

                    self.tunnel_standby_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                    self._children_yang_names.add("tunnel-standby-lsp")

                    self.wdm_unitunnel = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                    self._children_yang_names.add("wdm-unitunnel")

                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                    self._children_yang_names.add("xro-attribute-set")

                    self.destination = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "source_address",
                                    "destination_address",
                                    "admin_state",
                                    "affinity_failure_delayed_tear_time_remained",
                                    "affinity_failure_reopt_disabled",
                                    "affinity_failure_reopt_time_remained",
                                    "area_id",
                                    "auto_route",
                                    "autoroute_announce_exclude_segment_routing",
                                    "bandwidth_requested",
                                    "bandwidth_type",
                                    "binding_label",
                                    "binding_label_exists",
                                    "create_time",
                                    "destination_disabled_count",
                                    "destination_down_count",
                                    "destination_up_count",
                                    "drop_mode",
                                    "explicit_path_change",
                                    "fail_reason",
                                    "forwarding_adjacency",
                                    "hop_limit_ignored_reason",
                                    "invalidation_time_remained",
                                    "is_auto_backup",
                                    "is_auto_pcc",
                                    "is_bandwidth_protect",
                                    "is_hop_limit_ignore",
                                    "is_inter_area_tunnel",
                                    "is_interface",
                                    "is_named",
                                    "is_node_protected",
                                    "is_passive",
                                    "is_pce_delegated",
                                    "last_hop_ifindex",
                                    "last_path_change",
                                    "load_share_factor",
                                    "load_share_type",
                                    "lsp_wrap_label",
                                    "lsp_wrap_protection_enabled",
                                    "metric_qualifier",
                                    "metric_type",
                                    "operational_state",
                                    "operational_state_changes",
                                    "outbound_frr_state",
                                    "passive_tunnel_name",
                                    "path_option_change",
                                    "pce_fail_reason",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "re_opt_hold_down_timer_remaining",
                                    "reroute_pending",
                                    "role_standby",
                                    "signaled_name",
                                    "snmp_index",
                                    "tie_breaker",
                                    "tiebreaker_qualifier",
                                    "tiebreaker_type",
                                    "tunnel_attribute_set_name",
                                    "tunnel_attribute_set_type",
                                    "tunnel_interface_name",
                                    "tunnel_recovering",
                                    "uptime",
                                    "xro_attribute_set_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__setattr__(name, value)


                class Config(Entity):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity>`
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of    :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination>`
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:   :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig>`
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:   :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig>`
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\:  bool
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\:  bool
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\:  bool
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\:  bool
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\:  str
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\:  bool
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "nni-tunnel"

                        self.affinity_failure_reopt_timer = YLeaf(YType.uint32, "affinity-failure-reopt-timer")

                        self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                        self.backup_bandwidth_flags = YLeaf(YType.uint8, "backup-bandwidth-flags")

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.config_load_share = YLeaf(YType.uint32, "config-load-share")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.cost_limit_global = YLeaf(YType.uint32, "cost-limit-global")

                        self.disable_affinity_failure_reopt = YLeaf(YType.boolean, "disable-affinity-failure-reopt")

                        self.explicit_null_imposition = YLeaf(YType.boolean, "explicit-null-imposition")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.hop_limit = YLeaf(YType.uint8, "hop-limit")

                        self.interface_configured_bandwidth = YLeaf(YType.uint32, "interface-configured-bandwidth")

                        self.is_backup_tunnel = YLeaf(YType.boolean, "is-backup-tunnel")

                        self.is_in_config = YLeaf(YType.boolean, "is-in-config")

                        self.is_p2mp = YLeaf(YType.boolean, "is-p2mp")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_action_source = YLeaf(YType.uint32, "path-invalidation-action-source")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_invalidation_timeout_source = YLeaf(YType.uint32, "path-invalidation-timeout-source")

                        self.path_protection_enabled = YLeaf(YType.boolean, "path-protection-enabled")

                        self.payload_type = YLeaf(YType.uint16, "payload-type")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.segment_routing_path_selection = YLeaf(YType.enumeration, "segment-routing-path-selection")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.soft_preempt = YLeaf(YType.boolean, "soft-preempt")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"
                        self._children_yang_names.add("bfd-config")

                        self.bidirectional_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"
                        self._children_yang_names.add("bidirectional-config")

                        self.autoroute_destination = YList(self)
                        self.policy_class_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_failure_reopt_timer",
                                        "backup_bandwidth",
                                        "backup_bandwidth_flags",
                                        "bandwidth_type",
                                        "config_load_share",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "cost_limit_global",
                                        "disable_affinity_failure_reopt",
                                        "explicit_null_imposition",
                                        "fast_reroute",
                                        "forward_class",
                                        "hold_priority",
                                        "hop_limit",
                                        "interface_configured_bandwidth",
                                        "is_backup_tunnel",
                                        "is_in_config",
                                        "is_p2mp",
                                        "path_invalidation_action",
                                        "path_invalidation_action_source",
                                        "path_invalidation_timeout",
                                        "path_invalidation_timeout_source",
                                        "path_protection_enabled",
                                        "payload_type",
                                        "policy_class",
                                        "record_route",
                                        "segment_routing_path_selection",
                                        "setup_priority",
                                        "signaled_name",
                                        "soft_preempt",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BidirectionalConfig(Entity):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\:  bool
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: association_type
                        
                        	Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"

                            self.association_corouted = YLeaf(YType.boolean, "association-corouted")

                            self.association_global_id = YLeaf(YType.uint32, "association-global-id")

                            self.association_id = YLeaf(YType.uint16, "association-id")

                            self.association_source = YLeaf(YType.str, "association-source")

                            self.association_type = YLeaf(YType.uint16, "association-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("association_corouted",
                                            "association_global_id",
                                            "association_id",
                                            "association_source",
                                            "association_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.association_corouted.is_set or
                                self.association_global_id.is_set or
                                self.association_id.is_set or
                                self.association_source.is_set or
                                self.association_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.association_corouted.yfilter != YFilter.not_set or
                                self.association_global_id.yfilter != YFilter.not_set or
                                self.association_id.yfilter != YFilter.not_set or
                                self.association_source.yfilter != YFilter.not_set or
                                self.association_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bidirectional-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.association_corouted.is_set or self.association_corouted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_corouted.get_name_leafdata())
                            if (self.association_global_id.is_set or self.association_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_global_id.get_name_leafdata())
                            if (self.association_id.is_set or self.association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_id.get_name_leafdata())
                            if (self.association_source.is_set or self.association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_source.get_name_leafdata())
                            if (self.association_type.is_set or self.association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association-corouted" or name == "association-global-id" or name == "association-id" or name == "association-source" or name == "association-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "association-corouted"):
                                self.association_corouted = value
                                self.association_corouted.value_namespace = name_space
                                self.association_corouted.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-global-id"):
                                self.association_global_id = value
                                self.association_global_id.value_namespace = name_space
                                self.association_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-id"):
                                self.association_id = value
                                self.association_id.value_namespace = name_space
                                self.association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-source"):
                                self.association_source = value
                                self.association_source.value_namespace = name_space
                                self.association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-type"):
                                self.association_type = value
                                self.association_type.value_namespace = name_space
                                self.association_type.value_namespace_prefix = name_space_prefix


                    class BfdConfig(Entity):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:   :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\:  bool
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:   :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\:  bool
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\:  bool
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\:  bool
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"

                            self.bfd_encap_mode = YLeaf(YType.enumeration, "bfd-encap-mode")

                            self.bfd_fast_detecting_enabled = YLeaf(YType.boolean, "bfd-fast-detecting-enabled")

                            self.bfd_session_down_action = YLeaf(YType.enumeration, "bfd-session-down-action")

                            self.bfd_session_down_reopt_timeout = YLeaf(YType.uint32, "bfd-session-down-reopt-timeout")

                            self.bfd_type = YLeaf(YType.enumeration, "bfd-type")

                            self.bring_up_timeout = YLeaf(YType.uint16, "bring-up-timeout")

                            self.bring_up_timeout_default = YLeaf(YType.boolean, "bring-up-timeout-default")

                            self.dampening_initial_wait = YLeaf(YType.uint32, "dampening-initial-wait")

                            self.dampening_initial_wait_default = YLeaf(YType.boolean, "dampening-initial-wait-default")

                            self.dampening_max_wait = YLeaf(YType.uint32, "dampening-max-wait")

                            self.dampening_max_wait_default = YLeaf(YType.boolean, "dampening-max-wait-default")

                            self.dampening_secondary_wait = YLeaf(YType.uint32, "dampening-secondary-wait")

                            self.dampening_secondary_wait_default = YLeaf(YType.boolean, "dampening-secondary-wait-default")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.periodic_lsp_ping_disabled = YLeaf(YType.boolean, "periodic-lsp-ping-disabled")

                            self.periodic_lsp_ping_interval = YLeaf(YType.uint32, "periodic-lsp-ping-interval")

                            self.periodic_lsp_ping_interval_default = YLeaf(YType.boolean, "periodic-lsp-ping-interval-default")

                            self.sbfd_target_id = YLeaf(YType.str, "sbfd-target-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_encap_mode",
                                            "bfd_fast_detecting_enabled",
                                            "bfd_session_down_action",
                                            "bfd_session_down_reopt_timeout",
                                            "bfd_type",
                                            "bring_up_timeout",
                                            "bring_up_timeout_default",
                                            "dampening_initial_wait",
                                            "dampening_initial_wait_default",
                                            "dampening_max_wait",
                                            "dampening_max_wait_default",
                                            "dampening_secondary_wait",
                                            "dampening_secondary_wait_default",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "periodic_lsp_ping_disabled",
                                            "periodic_lsp_ping_interval",
                                            "periodic_lsp_ping_interval_default",
                                            "sbfd_target_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_encap_mode.is_set or
                                self.bfd_fast_detecting_enabled.is_set or
                                self.bfd_session_down_action.is_set or
                                self.bfd_session_down_reopt_timeout.is_set or
                                self.bfd_type.is_set or
                                self.bring_up_timeout.is_set or
                                self.bring_up_timeout_default.is_set or
                                self.dampening_initial_wait.is_set or
                                self.dampening_initial_wait_default.is_set or
                                self.dampening_max_wait.is_set or
                                self.dampening_max_wait_default.is_set or
                                self.dampening_secondary_wait.is_set or
                                self.dampening_secondary_wait_default.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.periodic_lsp_ping_disabled.is_set or
                                self.periodic_lsp_ping_interval.is_set or
                                self.periodic_lsp_ping_interval_default.is_set or
                                self.sbfd_target_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_encap_mode.yfilter != YFilter.not_set or
                                self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set or
                                self.bfd_session_down_action.yfilter != YFilter.not_set or
                                self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set or
                                self.bfd_type.yfilter != YFilter.not_set or
                                self.bring_up_timeout.yfilter != YFilter.not_set or
                                self.bring_up_timeout_default.yfilter != YFilter.not_set or
                                self.dampening_initial_wait.yfilter != YFilter.not_set or
                                self.dampening_initial_wait_default.yfilter != YFilter.not_set or
                                self.dampening_max_wait.yfilter != YFilter.not_set or
                                self.dampening_max_wait_default.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait_default.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set or
                                self.sbfd_target_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_encap_mode.is_set or self.bfd_encap_mode.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_encap_mode.get_name_leafdata())
                            if (self.bfd_fast_detecting_enabled.is_set or self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_fast_detecting_enabled.get_name_leafdata())
                            if (self.bfd_session_down_action.is_set or self.bfd_session_down_action.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_action.get_name_leafdata())
                            if (self.bfd_session_down_reopt_timeout.is_set or self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_reopt_timeout.get_name_leafdata())
                            if (self.bfd_type.is_set or self.bfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_type.get_name_leafdata())
                            if (self.bring_up_timeout.is_set or self.bring_up_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout.get_name_leafdata())
                            if (self.bring_up_timeout_default.is_set or self.bring_up_timeout_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout_default.get_name_leafdata())
                            if (self.dampening_initial_wait.is_set or self.dampening_initial_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait.get_name_leafdata())
                            if (self.dampening_initial_wait_default.is_set or self.dampening_initial_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait_default.get_name_leafdata())
                            if (self.dampening_max_wait.is_set or self.dampening_max_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait.get_name_leafdata())
                            if (self.dampening_max_wait_default.is_set or self.dampening_max_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait_default.get_name_leafdata())
                            if (self.dampening_secondary_wait.is_set or self.dampening_secondary_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait.get_name_leafdata())
                            if (self.dampening_secondary_wait_default.is_set or self.dampening_secondary_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait_default.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.periodic_lsp_ping_disabled.is_set or self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_disabled.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval.is_set or self.periodic_lsp_ping_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval_default.is_set or self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval_default.get_name_leafdata())
                            if (self.sbfd_target_id.is_set or self.sbfd_target_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sbfd_target_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-encap-mode" or name == "bfd-fast-detecting-enabled" or name == "bfd-session-down-action" or name == "bfd-session-down-reopt-timeout" or name == "bfd-type" or name == "bring-up-timeout" or name == "bring-up-timeout-default" or name == "dampening-initial-wait" or name == "dampening-initial-wait-default" or name == "dampening-max-wait" or name == "dampening-max-wait-default" or name == "dampening-secondary-wait" or name == "dampening-secondary-wait-default" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "periodic-lsp-ping-disabled" or name == "periodic-lsp-ping-interval" or name == "periodic-lsp-ping-interval-default" or name == "sbfd-target-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-encap-mode"):
                                self.bfd_encap_mode = value
                                self.bfd_encap_mode.value_namespace = name_space
                                self.bfd_encap_mode.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-fast-detecting-enabled"):
                                self.bfd_fast_detecting_enabled = value
                                self.bfd_fast_detecting_enabled.value_namespace = name_space
                                self.bfd_fast_detecting_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-action"):
                                self.bfd_session_down_action = value
                                self.bfd_session_down_action.value_namespace = name_space
                                self.bfd_session_down_action.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-reopt-timeout"):
                                self.bfd_session_down_reopt_timeout = value
                                self.bfd_session_down_reopt_timeout.value_namespace = name_space
                                self.bfd_session_down_reopt_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-type"):
                                self.bfd_type = value
                                self.bfd_type.value_namespace = name_space
                                self.bfd_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout"):
                                self.bring_up_timeout = value
                                self.bring_up_timeout.value_namespace = name_space
                                self.bring_up_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout-default"):
                                self.bring_up_timeout_default = value
                                self.bring_up_timeout_default.value_namespace = name_space
                                self.bring_up_timeout_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait"):
                                self.dampening_initial_wait = value
                                self.dampening_initial_wait.value_namespace = name_space
                                self.dampening_initial_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait-default"):
                                self.dampening_initial_wait_default = value
                                self.dampening_initial_wait_default.value_namespace = name_space
                                self.dampening_initial_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait"):
                                self.dampening_max_wait = value
                                self.dampening_max_wait.value_namespace = name_space
                                self.dampening_max_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait-default"):
                                self.dampening_max_wait_default = value
                                self.dampening_max_wait_default.value_namespace = name_space
                                self.dampening_max_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait"):
                                self.dampening_secondary_wait = value
                                self.dampening_secondary_wait.value_namespace = name_space
                                self.dampening_secondary_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait-default"):
                                self.dampening_secondary_wait_default = value
                                self.dampening_secondary_wait_default.value_namespace = name_space
                                self.dampening_secondary_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-disabled"):
                                self.periodic_lsp_ping_disabled = value
                                self.periodic_lsp_ping_disabled.value_namespace = name_space
                                self.periodic_lsp_ping_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval"):
                                self.periodic_lsp_ping_interval = value
                                self.periodic_lsp_ping_interval.value_namespace = name_space
                                self.periodic_lsp_ping_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval-default"):
                                self.periodic_lsp_ping_interval_default = value
                                self.periodic_lsp_ping_interval_default.value_namespace = name_space
                                self.periodic_lsp_ping_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "sbfd-target-id"):
                                self.sbfd_target_id = value
                                self.sbfd_target_id.value_namespace = name_space
                                self.sbfd_target_id.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class AutorouteDestination(Entity):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.prefix_length = YLeaf(YType.uint16, "prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "autoroute-destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.autoroute_destination:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_failure_reopt_timer.is_set or
                            self.backup_bandwidth.is_set or
                            self.backup_bandwidth_flags.is_set or
                            self.bandwidth_type.is_set or
                            self.config_load_share.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.cost_limit_global.is_set or
                            self.disable_affinity_failure_reopt.is_set or
                            self.explicit_null_imposition.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.hold_priority.is_set or
                            self.hop_limit.is_set or
                            self.interface_configured_bandwidth.is_set or
                            self.is_backup_tunnel.is_set or
                            self.is_in_config.is_set or
                            self.is_p2mp.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_action_source.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_invalidation_timeout_source.is_set or
                            self.path_protection_enabled.is_set or
                            self.payload_type.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.segment_routing_path_selection.is_set or
                            self.setup_priority.is_set or
                            self.signaled_name.is_set or
                            self.soft_preempt.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_name.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_config is not None and self.bfd_config.has_data()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_data()))

                    def has_operation(self):
                        for c in self.autoroute_destination:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_failure_reopt_timer.yfilter != YFilter.not_set or
                            self.backup_bandwidth.yfilter != YFilter.not_set or
                            self.backup_bandwidth_flags.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.config_load_share.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.cost_limit_global.yfilter != YFilter.not_set or
                            self.disable_affinity_failure_reopt.yfilter != YFilter.not_set or
                            self.explicit_null_imposition.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.hop_limit.yfilter != YFilter.not_set or
                            self.interface_configured_bandwidth.yfilter != YFilter.not_set or
                            self.is_backup_tunnel.yfilter != YFilter.not_set or
                            self.is_in_config.yfilter != YFilter.not_set or
                            self.is_p2mp.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_action_source.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout_source.yfilter != YFilter.not_set or
                            self.path_protection_enabled.yfilter != YFilter.not_set or
                            self.payload_type.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.segment_routing_path_selection.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.soft_preempt.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_config is not None and self.bfd_config.has_operation()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "config" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_failure_reopt_timer.is_set or self.affinity_failure_reopt_timer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_failure_reopt_timer.get_name_leafdata())
                        if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                        if (self.backup_bandwidth_flags.is_set or self.backup_bandwidth_flags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth_flags.get_name_leafdata())
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.config_load_share.is_set or self.config_load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.config_load_share.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.cost_limit_global.is_set or self.cost_limit_global.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit_global.get_name_leafdata())
                        if (self.disable_affinity_failure_reopt.is_set or self.disable_affinity_failure_reopt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.disable_affinity_failure_reopt.get_name_leafdata())
                        if (self.explicit_null_imposition.is_set or self.explicit_null_imposition.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.explicit_null_imposition.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hop_limit.get_name_leafdata())
                        if (self.interface_configured_bandwidth.is_set or self.interface_configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_configured_bandwidth.get_name_leafdata())
                        if (self.is_backup_tunnel.is_set or self.is_backup_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup_tunnel.get_name_leafdata())
                        if (self.is_in_config.is_set or self.is_in_config.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_in_config.get_name_leafdata())
                        if (self.is_p2mp.is_set or self.is_p2mp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_p2mp.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_action_source.is_set or self.path_invalidation_action_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action_source.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_invalidation_timeout_source.is_set or self.path_invalidation_timeout_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout_source.get_name_leafdata())
                        if (self.path_protection_enabled.is_set or self.path_protection_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_enabled.get_name_leafdata())
                        if (self.payload_type.is_set or self.payload_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.payload_type.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.segment_routing_path_selection.is_set or self.segment_routing_path_selection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_path_selection.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.soft_preempt.is_set or self.soft_preempt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preempt.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "autoroute-destination"):
                            for c in self.autoroute_destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.autoroute_destination.append(c)
                            return c

                        if (child_yang_name == "bfd-config"):
                            if (self.bfd_config is None):
                                self.bfd_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                                self.bfd_config.parent = self
                                self._children_name_map["bfd_config"] = "bfd-config"
                            return self.bfd_config

                        if (child_yang_name == "bidirectional-config"):
                            if (self.bidirectional_config is None):
                                self.bidirectional_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                                self.bidirectional_config.parent = self
                                self._children_name_map["bidirectional_config"] = "bidirectional-config"
                            return self.bidirectional_config

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "autoroute-destination" or name == "bfd-config" or name == "bidirectional-config" or name == "policy-class-entry" or name == "affinity-failure-reopt-timer" or name == "backup-bandwidth" or name == "backup-bandwidth-flags" or name == "bandwidth-type" or name == "config-load-share" or name == "configured-bandwidth" or name == "cost-limit" or name == "cost-limit-global" or name == "disable-affinity-failure-reopt" or name == "explicit-null-imposition" or name == "fast-reroute" or name == "forward-class" or name == "hold-priority" or name == "hop-limit" or name == "interface-configured-bandwidth" or name == "is-backup-tunnel" or name == "is-in-config" or name == "is-p2mp" or name == "path-invalidation-action" or name == "path-invalidation-action-source" or name == "path-invalidation-timeout" or name == "path-invalidation-timeout-source" or name == "path-protection-enabled" or name == "payload-type" or name == "policy-class" or name == "record-route" or name == "segment-routing-path-selection" or name == "setup-priority" or name == "signaled-name" or name == "soft-preempt" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-failure-reopt-timer"):
                            self.affinity_failure_reopt_timer = value
                            self.affinity_failure_reopt_timer.value_namespace = name_space
                            self.affinity_failure_reopt_timer.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth"):
                            self.backup_bandwidth = value
                            self.backup_bandwidth.value_namespace = name_space
                            self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth-flags"):
                            self.backup_bandwidth_flags = value
                            self.backup_bandwidth_flags.value_namespace = name_space
                            self.backup_bandwidth_flags.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "config-load-share"):
                            self.config_load_share = value
                            self.config_load_share.value_namespace = name_space
                            self.config_load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit-global"):
                            self.cost_limit_global = value
                            self.cost_limit_global.value_namespace = name_space
                            self.cost_limit_global.value_namespace_prefix = name_space_prefix
                        if(value_path == "disable-affinity-failure-reopt"):
                            self.disable_affinity_failure_reopt = value
                            self.disable_affinity_failure_reopt.value_namespace = name_space
                            self.disable_affinity_failure_reopt.value_namespace_prefix = name_space_prefix
                        if(value_path == "explicit-null-imposition"):
                            self.explicit_null_imposition = value
                            self.explicit_null_imposition.value_namespace = name_space
                            self.explicit_null_imposition.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "hop-limit"):
                            self.hop_limit = value
                            self.hop_limit.value_namespace = name_space
                            self.hop_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-configured-bandwidth"):
                            self.interface_configured_bandwidth = value
                            self.interface_configured_bandwidth.value_namespace = name_space
                            self.interface_configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup-tunnel"):
                            self.is_backup_tunnel = value
                            self.is_backup_tunnel.value_namespace = name_space
                            self.is_backup_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-in-config"):
                            self.is_in_config = value
                            self.is_in_config.value_namespace = name_space
                            self.is_in_config.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-p2mp"):
                            self.is_p2mp = value
                            self.is_p2mp.value_namespace = name_space
                            self.is_p2mp.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action-source"):
                            self.path_invalidation_action_source = value
                            self.path_invalidation_action_source.value_namespace = name_space
                            self.path_invalidation_action_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout-source"):
                            self.path_invalidation_timeout_source = value
                            self.path_invalidation_timeout_source.value_namespace = name_space
                            self.path_invalidation_timeout_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-enabled"):
                            self.path_protection_enabled = value
                            self.path_protection_enabled.value_namespace = name_space
                            self.path_protection_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "payload-type"):
                            self.payload_type = value
                            self.payload_type.value_namespace = name_space
                            self.payload_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-path-selection"):
                            self.segment_routing_path_selection = value
                            self.segment_routing_path_selection.value_namespace = name_space
                            self.segment_routing_path_selection.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preempt"):
                            self.soft_preempt = value
                            self.soft_preempt.value_namespace = name_space
                            self.soft_preempt.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class TunnelCurrentLsp(Entity):
                    """
                    Current LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedP2MpLsp(Entity):
                    """
                    Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelStandbyLsp(Entity):
                    """
                    Standby LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedStandbyP2MpLsp(Entity):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-standby-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelRestorationLsp(Entity):
                    """
                    Restoration LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-restoration-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class DelayCleanPpLsp(Entity):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "delay-clean-pp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class CleanedLsp(Entity):
                    """
                    Cleaned LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "cleaned-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class P2PInfo(Entity):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:   :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig>`
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:   :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper>`
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus>`
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.is_bidirectional = YLeaf(YType.boolean, "is-bidirectional")

                        self.auto_bandwidth_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                        self._children_yang_names.add("auto-bandwidth-config")

                        self.auto_bandwidth_oper = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._children_yang_names.add("auto-bandwidth-oper")

                        self.auto_bandwidth_status = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        self._children_yang_names.add("auto-bandwidth-status")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bidirectional") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__setattr__(name, value)


                    class AutoBandwidthStatus(Entity):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\:  bool
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"

                            self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                            self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_auto_bandwidth_enabled",
                                            "reactivation_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_auto_bandwidth_enabled.is_set or
                                self.reactivation_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                                self.reactivation_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-status" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                            if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-auto-bandwidth-enabled"):
                                self.is_auto_bandwidth_enabled = value
                                self.is_auto_bandwidth_enabled.value_namespace = name_space
                                self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "reactivation-time"):
                                self.reactivation_time = value
                                self.reactivation_time.value_namespace = name_space
                                self.reactivation_time.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthConfig(Entity):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\:  bool
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"

                            self.adjustment_threshold_percent = YLeaf(YType.uint32, "adjustment-threshold-percent")

                            self.adjustment_threshold_value = YLeaf(YType.uint32, "adjustment-threshold-value")

                            self.application_frequency = YLeaf(YType.uint32, "application-frequency")

                            self.collection_frequency = YLeaf(YType.uint32, "collection-frequency")

                            self.is_auto_bandwidth_collect_only = YLeaf(YType.boolean, "is-auto-bandwidth-collect-only")

                            self.maximum_bandwidth = YLeaf(YType.uint32, "maximum-bandwidth")

                            self.minimum_bandwidth = YLeaf(YType.uint32, "minimum-bandwidth")

                            self.overflow_threshold_limit = YLeaf(YType.uint32, "overflow-threshold-limit")

                            self.overflow_threshold_percent = YLeaf(YType.uint32, "overflow-threshold-percent")

                            self.overflow_threshold_value = YLeaf(YType.uint32, "overflow-threshold-value")

                            self.underflow_threshold_limit = YLeaf(YType.uint32, "underflow-threshold-limit")

                            self.underflow_threshold_percent = YLeaf(YType.uint32, "underflow-threshold-percent")

                            self.underflow_threshold_value = YLeaf(YType.uint32, "underflow-threshold-value")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_threshold_percent",
                                            "adjustment_threshold_value",
                                            "application_frequency",
                                            "collection_frequency",
                                            "is_auto_bandwidth_collect_only",
                                            "maximum_bandwidth",
                                            "minimum_bandwidth",
                                            "overflow_threshold_limit",
                                            "overflow_threshold_percent",
                                            "overflow_threshold_value",
                                            "underflow_threshold_limit",
                                            "underflow_threshold_percent",
                                            "underflow_threshold_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.adjustment_threshold_percent.is_set or
                                self.adjustment_threshold_value.is_set or
                                self.application_frequency.is_set or
                                self.collection_frequency.is_set or
                                self.is_auto_bandwidth_collect_only.is_set or
                                self.maximum_bandwidth.is_set or
                                self.minimum_bandwidth.is_set or
                                self.overflow_threshold_limit.is_set or
                                self.overflow_threshold_percent.is_set or
                                self.overflow_threshold_value.is_set or
                                self.underflow_threshold_limit.is_set or
                                self.underflow_threshold_percent.is_set or
                                self.underflow_threshold_value.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_threshold_percent.yfilter != YFilter.not_set or
                                self.adjustment_threshold_value.yfilter != YFilter.not_set or
                                self.application_frequency.yfilter != YFilter.not_set or
                                self.collection_frequency.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set or
                                self.maximum_bandwidth.yfilter != YFilter.not_set or
                                self.minimum_bandwidth.yfilter != YFilter.not_set or
                                self.overflow_threshold_limit.yfilter != YFilter.not_set or
                                self.overflow_threshold_percent.yfilter != YFilter.not_set or
                                self.overflow_threshold_value.yfilter != YFilter.not_set or
                                self.underflow_threshold_limit.yfilter != YFilter.not_set or
                                self.underflow_threshold_percent.yfilter != YFilter.not_set or
                                self.underflow_threshold_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_threshold_percent.is_set or self.adjustment_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_percent.get_name_leafdata())
                            if (self.adjustment_threshold_value.is_set or self.adjustment_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_value.get_name_leafdata())
                            if (self.application_frequency.is_set or self.application_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_frequency.get_name_leafdata())
                            if (self.collection_frequency.is_set or self.collection_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_frequency.get_name_leafdata())
                            if (self.is_auto_bandwidth_collect_only.is_set or self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_collect_only.get_name_leafdata())
                            if (self.maximum_bandwidth.is_set or self.maximum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_bandwidth.get_name_leafdata())
                            if (self.minimum_bandwidth.is_set or self.minimum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.minimum_bandwidth.get_name_leafdata())
                            if (self.overflow_threshold_limit.is_set or self.overflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_limit.get_name_leafdata())
                            if (self.overflow_threshold_percent.is_set or self.overflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_percent.get_name_leafdata())
                            if (self.overflow_threshold_value.is_set or self.overflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_value.get_name_leafdata())
                            if (self.underflow_threshold_limit.is_set or self.underflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_limit.get_name_leafdata())
                            if (self.underflow_threshold_percent.is_set or self.underflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_percent.get_name_leafdata())
                            if (self.underflow_threshold_value.is_set or self.underflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "adjustment-threshold-percent" or name == "adjustment-threshold-value" or name == "application-frequency" or name == "collection-frequency" or name == "is-auto-bandwidth-collect-only" or name == "maximum-bandwidth" or name == "minimum-bandwidth" or name == "overflow-threshold-limit" or name == "overflow-threshold-percent" or name == "overflow-threshold-value" or name == "underflow-threshold-limit" or name == "underflow-threshold-percent" or name == "underflow-threshold-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-threshold-percent"):
                                self.adjustment_threshold_percent = value
                                self.adjustment_threshold_percent.value_namespace = name_space
                                self.adjustment_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "adjustment-threshold-value"):
                                self.adjustment_threshold_value = value
                                self.adjustment_threshold_value.value_namespace = name_space
                                self.adjustment_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-frequency"):
                                self.application_frequency = value
                                self.application_frequency.value_namespace = name_space
                                self.application_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-frequency"):
                                self.collection_frequency = value
                                self.collection_frequency.value_namespace = name_space
                                self.collection_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-auto-bandwidth-collect-only"):
                                self.is_auto_bandwidth_collect_only = value
                                self.is_auto_bandwidth_collect_only.value_namespace = name_space
                                self.is_auto_bandwidth_collect_only.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-bandwidth"):
                                self.maximum_bandwidth = value
                                self.maximum_bandwidth.value_namespace = name_space
                                self.maximum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "minimum-bandwidth"):
                                self.minimum_bandwidth = value
                                self.minimum_bandwidth.value_namespace = name_space
                                self.minimum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-limit"):
                                self.overflow_threshold_limit = value
                                self.overflow_threshold_limit.value_namespace = name_space
                                self.overflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-percent"):
                                self.overflow_threshold_percent = value
                                self.overflow_threshold_percent.value_namespace = name_space
                                self.overflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-value"):
                                self.overflow_threshold_value = value
                                self.overflow_threshold_value.value_namespace = name_space
                                self.overflow_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-limit"):
                                self.underflow_threshold_limit = value
                                self.underflow_threshold_limit.value_namespace = name_space
                                self.underflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-percent"):
                                self.underflow_threshold_percent = value
                                self.underflow_threshold_percent.value_namespace = name_space
                                self.underflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-value"):
                                self.underflow_threshold_value = value
                                self.underflow_threshold_value.value_namespace = name_space
                                self.underflow_threshold_value.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthOper(Entity):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:   :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:   :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"

                            self.application_jitter = YLeaf(YType.uint32, "application-jitter")

                            self.application_reject_reason = YLeaf(YType.enumeration, "application-reject-reason")

                            self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                            self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                            self.collect_only_requested_bandwidth = YLeaf(YType.uint32, "collect-only-requested-bandwidth")

                            self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                            self.last_application_trigger = YLeaf(YType.enumeration, "last-application-trigger")

                            self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                            self.overflow_early_bw_applications = YLeaf(YType.uint32, "overflow-early-bw-applications")

                            self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                            self.threshold_overflows = YLeaf(YType.uint32, "threshold-overflows")

                            self.threshold_underflows = YLeaf(YType.uint32, "threshold-underflows")

                            self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                            self.time_left_collection = YLeaf(YType.uint32, "time-left-collection")

                            self.underflow_early_bw_applications = YLeaf(YType.uint32, "underflow-early-bw-applications")

                            self.underflow_highest_bandwidth = YLeaf(YType.uint32, "underflow-highest-bandwidth")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_jitter",
                                            "application_reject_reason",
                                            "bandwidth_applications",
                                            "bandwidth_pool_type",
                                            "collect_only_requested_bandwidth",
                                            "highest_bandwidth",
                                            "last_application_trigger",
                                            "last_bandwidth_applied",
                                            "overflow_early_bw_applications",
                                            "samples_collected",
                                            "threshold_overflows",
                                            "threshold_underflows",
                                            "time_left_application",
                                            "time_left_collection",
                                            "underflow_early_bw_applications",
                                            "underflow_highest_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_jitter.is_set or
                                self.application_reject_reason.is_set or
                                self.bandwidth_applications.is_set or
                                self.bandwidth_pool_type.is_set or
                                self.collect_only_requested_bandwidth.is_set or
                                self.highest_bandwidth.is_set or
                                self.last_application_trigger.is_set or
                                self.last_bandwidth_applied.is_set or
                                self.overflow_early_bw_applications.is_set or
                                self.samples_collected.is_set or
                                self.threshold_overflows.is_set or
                                self.threshold_underflows.is_set or
                                self.time_left_application.is_set or
                                self.time_left_collection.is_set or
                                self.underflow_early_bw_applications.is_set or
                                self.underflow_highest_bandwidth.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_jitter.yfilter != YFilter.not_set or
                                self.application_reject_reason.yfilter != YFilter.not_set or
                                self.bandwidth_applications.yfilter != YFilter.not_set or
                                self.bandwidth_pool_type.yfilter != YFilter.not_set or
                                self.collect_only_requested_bandwidth.yfilter != YFilter.not_set or
                                self.highest_bandwidth.yfilter != YFilter.not_set or
                                self.last_application_trigger.yfilter != YFilter.not_set or
                                self.last_bandwidth_applied.yfilter != YFilter.not_set or
                                self.overflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.samples_collected.yfilter != YFilter.not_set or
                                self.threshold_overflows.yfilter != YFilter.not_set or
                                self.threshold_underflows.yfilter != YFilter.not_set or
                                self.time_left_application.yfilter != YFilter.not_set or
                                self.time_left_collection.yfilter != YFilter.not_set or
                                self.underflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.underflow_highest_bandwidth.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-oper" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_jitter.is_set or self.application_jitter.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_jitter.get_name_leafdata())
                            if (self.application_reject_reason.is_set or self.application_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_reject_reason.get_name_leafdata())
                            if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                            if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                            if (self.collect_only_requested_bandwidth.is_set or self.collect_only_requested_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collect_only_requested_bandwidth.get_name_leafdata())
                            if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                            if (self.last_application_trigger.is_set or self.last_application_trigger.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_trigger.get_name_leafdata())
                            if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                            if (self.overflow_early_bw_applications.is_set or self.overflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_early_bw_applications.get_name_leafdata())
                            if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.samples_collected.get_name_leafdata())
                            if (self.threshold_overflows.is_set or self.threshold_overflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_overflows.get_name_leafdata())
                            if (self.threshold_underflows.is_set or self.threshold_underflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_underflows.get_name_leafdata())
                            if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_application.get_name_leafdata())
                            if (self.time_left_collection.is_set or self.time_left_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_collection.get_name_leafdata())
                            if (self.underflow_early_bw_applications.is_set or self.underflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_early_bw_applications.get_name_leafdata())
                            if (self.underflow_highest_bandwidth.is_set or self.underflow_highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_highest_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-jitter" or name == "application-reject-reason" or name == "bandwidth-applications" or name == "bandwidth-pool-type" or name == "collect-only-requested-bandwidth" or name == "highest-bandwidth" or name == "last-application-trigger" or name == "last-bandwidth-applied" or name == "overflow-early-bw-applications" or name == "samples-collected" or name == "threshold-overflows" or name == "threshold-underflows" or name == "time-left-application" or name == "time-left-collection" or name == "underflow-early-bw-applications" or name == "underflow-highest-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-jitter"):
                                self.application_jitter = value
                                self.application_jitter.value_namespace = name_space
                                self.application_jitter.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-reject-reason"):
                                self.application_reject_reason = value
                                self.application_reject_reason.value_namespace = name_space
                                self.application_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-applications"):
                                self.bandwidth_applications = value
                                self.bandwidth_applications.value_namespace = name_space
                                self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-pool-type"):
                                self.bandwidth_pool_type = value
                                self.bandwidth_pool_type.value_namespace = name_space
                                self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "collect-only-requested-bandwidth"):
                                self.collect_only_requested_bandwidth = value
                                self.collect_only_requested_bandwidth.value_namespace = name_space
                                self.collect_only_requested_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "highest-bandwidth"):
                                self.highest_bandwidth = value
                                self.highest_bandwidth.value_namespace = name_space
                                self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-trigger"):
                                self.last_application_trigger = value
                                self.last_application_trigger.value_namespace = name_space
                                self.last_application_trigger.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-bandwidth-applied"):
                                self.last_bandwidth_applied = value
                                self.last_bandwidth_applied.value_namespace = name_space
                                self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-early-bw-applications"):
                                self.overflow_early_bw_applications = value
                                self.overflow_early_bw_applications.value_namespace = name_space
                                self.overflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "samples-collected"):
                                self.samples_collected = value
                                self.samples_collected.value_namespace = name_space
                                self.samples_collected.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-overflows"):
                                self.threshold_overflows = value
                                self.threshold_overflows.value_namespace = name_space
                                self.threshold_overflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-underflows"):
                                self.threshold_underflows = value
                                self.threshold_underflows.value_namespace = name_space
                                self.threshold_underflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-application"):
                                self.time_left_application = value
                                self.time_left_application.value_namespace = name_space
                                self.time_left_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-collection"):
                                self.time_left_collection = value
                                self.time_left_collection.value_namespace = name_space
                                self.time_left_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-early-bw-applications"):
                                self.underflow_early_bw_applications = value
                                self.underflow_early_bw_applications.value_namespace = name_space
                                self.underflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-highest-bandwidth"):
                                self.underflow_highest_bandwidth = value
                                self.underflow_highest_bandwidth.value_namespace = name_space
                                self.underflow_highest_bandwidth.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.is_bidirectional.is_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_data()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_data()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bidirectional.yfilter != YFilter.not_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_operation()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_operation()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "p2p-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bidirectional.is_set or self.is_bidirectional.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bidirectional.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "auto-bandwidth-config"):
                            if (self.auto_bandwidth_config is None):
                                self.auto_bandwidth_config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig()
                                self.auto_bandwidth_config.parent = self
                                self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                            return self.auto_bandwidth_config

                        if (child_yang_name == "auto-bandwidth-oper"):
                            if (self.auto_bandwidth_oper is None):
                                self.auto_bandwidth_oper = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper()
                                self.auto_bandwidth_oper.parent = self
                                self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                            return self.auto_bandwidth_oper

                        if (child_yang_name == "auto-bandwidth-status"):
                            if (self.auto_bandwidth_status is None):
                                self.auto_bandwidth_status = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus()
                                self.auto_bandwidth_status.parent = self
                                self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                            return self.auto_bandwidth_status

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-bandwidth-config" or name == "auto-bandwidth-oper" or name == "auto-bandwidth-status" or name == "is-bidirectional"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bidirectional"):
                            self.is_bidirectional = value
                            self.is_bidirectional.value_namespace = name_space
                            self.is_bidirectional.value_namespace_prefix = name_space_prefix


                class History(Entity):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:   :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup>`
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:   :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup>`
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:   :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup>`
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:   :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup>`
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:   :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail>`
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:   :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail>`
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:   :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup>`
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:   :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup>`
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:   :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup>`
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:   :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup>`
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:   :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "nni-tunnel"

                        self.current_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"
                        self._children_yang_names.add("current-setup")

                        self.gmpls_other_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                        self._children_yang_names.add("gmpls-other-protect-setup")

                        self.gmpls_other_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                        self._children_yang_names.add("gmpls-other-setup")

                        self.gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                        self._children_yang_names.add("gmpls-path-protect-setup")

                        self.last_re_opt_fail = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                        self._children_yang_names.add("last-re-opt-fail")

                        self.last_stdby_re_opt_fail = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._children_yang_names.add("last-stdby-re-opt-fail")

                        self.previous_gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                        self._children_yang_names.add("previous-gmpls-path-protect-setup")

                        self.previous_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"
                        self._children_yang_names.add("previous-setup")

                        self.reopt_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"
                        self._children_yang_names.add("reopt-setup")

                        self.standby_reopt_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                        self._children_yang_names.add("standby-reopt-setup")

                        self.standby_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"
                        self._children_yang_names.add("standby-setup")


                    class CurrentSetup(Entity):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:   :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes>`
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\:  str
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"

                            self.current_setup_last_error = YLeaf(YType.str, "current-setup-last-error")

                            self.current_setup_timer = YLeaf(YType.uint32, "current-setup-timer")

                            self.selection_reason = YLeaf(YType.str, "selection-reason")

                            self.connected_uptimes = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._children_yang_names.add("connected-uptimes")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("current_setup_last_error",
                                            "current_setup_timer",
                                            "selection_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__setattr__(name, value)


                        class ConnectedUptimes(Entity):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"

                                self.current_lsp_uptime = YLeaf(YType.uint32, "current-lsp-uptime")

                                self.current_uptime = YLeaf(YType.uint32, "current-uptime")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("current_lsp_uptime",
                                                "current_uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.current_lsp_uptime.is_set or
                                    self.current_uptime.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.current_lsp_uptime.yfilter != YFilter.not_set or
                                    self.current_uptime.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "connected-uptimes" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.current_lsp_uptime.is_set or self.current_lsp_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_lsp_uptime.get_name_leafdata())
                                if (self.current_uptime.is_set or self.current_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "current-lsp-uptime" or name == "current-uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "current-lsp-uptime"):
                                    self.current_lsp_uptime = value
                                    self.current_lsp_uptime.value_namespace = name_space
                                    self.current_lsp_uptime.value_namespace_prefix = name_space_prefix
                                if(value_path == "current-uptime"):
                                    self.current_uptime = value
                                    self.current_uptime.value_namespace = name_space
                                    self.current_uptime.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.current_setup_last_error.is_set or
                                self.current_setup_timer.is_set or
                                self.selection_reason.is_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.current_setup_last_error.yfilter != YFilter.not_set or
                                self.current_setup_timer.yfilter != YFilter.not_set or
                                self.selection_reason.yfilter != YFilter.not_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "current-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.current_setup_last_error.is_set or self.current_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_last_error.get_name_leafdata())
                            if (self.current_setup_timer.is_set or self.current_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_timer.get_name_leafdata())
                            if (self.selection_reason.is_set or self.selection_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.selection_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "connected-uptimes"):
                                if (self.connected_uptimes is None):
                                    self.connected_uptimes = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                                    self.connected_uptimes.parent = self
                                    self._children_name_map["connected_uptimes"] = "connected-uptimes"
                                return self.connected_uptimes

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "connected-uptimes" or name == "current-setup-last-error" or name == "current-setup-timer" or name == "selection-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "current-setup-last-error"):
                                self.current_setup_last_error = value
                                self.current_setup_last_error.value_namespace = name_space
                                self.current_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "current-setup-timer"):
                                self.current_setup_timer = value
                                self.current_setup_timer.value_namespace = name_space
                                self.current_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "selection-reason"):
                                self.selection_reason = value
                                self.selection_reason.value_namespace = name_space
                                self.selection_reason.value_namespace_prefix = name_space_prefix


                    class ReoptSetup(Entity):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class GmplsPathProtectSetup(Entity):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\:  str
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.protecting_setup_last_error = YLeaf(YType.str, "protecting-setup-last-error")

                            self.protecting_setup_timer = YLeaf(YType.uint32, "protecting-setup-timer")

                            self.protecting_setup_uptime = YLeaf(YType.uint32, "protecting-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protecting_setup_last_error",
                                            "protecting_setup_timer",
                                            "protecting_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.protecting_setup_last_error.is_set or
                                self.protecting_setup_timer.is_set or
                                self.protecting_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protecting_setup_last_error.yfilter != YFilter.not_set or
                                self.protecting_setup_timer.yfilter != YFilter.not_set or
                                self.protecting_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protecting_setup_last_error.is_set or self.protecting_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_last_error.get_name_leafdata())
                            if (self.protecting_setup_timer.is_set or self.protecting_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_timer.get_name_leafdata())
                            if (self.protecting_setup_uptime.is_set or self.protecting_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protecting-setup-last-error" or name == "protecting-setup-timer" or name == "protecting-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protecting-setup-last-error"):
                                self.protecting_setup_last_error = value
                                self.protecting_setup_last_error.value_namespace = name_space
                                self.protecting_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-timer"):
                                self.protecting_setup_timer = value
                                self.protecting_setup_timer.value_namespace = name_space
                                self.protecting_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-uptime"):
                                self.protecting_setup_uptime = value
                                self.protecting_setup_uptime.value_namespace = name_space
                                self.protecting_setup_uptime.value_namespace_prefix = name_space_prefix


                    class PreviousSetup(Entity):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"

                            self.previous_fail_reason = YLeaf(YType.str, "previous-fail-reason")

                            self.previous_path_option = YLeaf(YType.str, "previous-path-option")

                            self.previous_setup_last_error = YLeaf(YType.str, "previous-setup-last-error")

                            self.previous_tunnel_instance = YLeaf(YType.uint32, "previous-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_fail_reason",
                                            "previous_path_option",
                                            "previous_setup_last_error",
                                            "previous_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_fail_reason.is_set or
                                self.previous_path_option.is_set or
                                self.previous_setup_last_error.is_set or
                                self.previous_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_fail_reason.yfilter != YFilter.not_set or
                                self.previous_path_option.yfilter != YFilter.not_set or
                                self.previous_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_fail_reason.is_set or self.previous_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_fail_reason.get_name_leafdata())
                            if (self.previous_path_option.is_set or self.previous_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_path_option.get_name_leafdata())
                            if (self.previous_setup_last_error.is_set or self.previous_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_setup_last_error.get_name_leafdata())
                            if (self.previous_tunnel_instance.is_set or self.previous_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-fail-reason" or name == "previous-path-option" or name == "previous-setup-last-error" or name == "previous-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-fail-reason"):
                                self.previous_fail_reason = value
                                self.previous_fail_reason.value_namespace = name_space
                                self.previous_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-path-option"):
                                self.previous_path_option = value
                                self.previous_path_option.value_namespace = name_space
                                self.previous_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-setup-last-error"):
                                self.previous_setup_last_error = value
                                self.previous_setup_last_error.value_namespace = name_space
                                self.previous_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-tunnel-instance"):
                                self.previous_tunnel_instance = value
                                self.previous_tunnel_instance.value_namespace = name_space
                                self.previous_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class PreviousGmplsPathProtectSetup(Entity):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.previous_protect_fail_reason = YLeaf(YType.str, "previous-protect-fail-reason")

                            self.previous_protect_path_option = YLeaf(YType.str, "previous-protect-path-option")

                            self.previous_protect_setup_last_error = YLeaf(YType.str, "previous-protect-setup-last-error")

                            self.previous_protect_tunnel_instance = YLeaf(YType.uint32, "previous-protect-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_protect_fail_reason",
                                            "previous_protect_path_option",
                                            "previous_protect_setup_last_error",
                                            "previous_protect_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_protect_fail_reason.is_set or
                                self.previous_protect_path_option.is_set or
                                self.previous_protect_setup_last_error.is_set or
                                self.previous_protect_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_protect_fail_reason.yfilter != YFilter.not_set or
                                self.previous_protect_path_option.yfilter != YFilter.not_set or
                                self.previous_protect_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_protect_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_protect_fail_reason.is_set or self.previous_protect_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_fail_reason.get_name_leafdata())
                            if (self.previous_protect_path_option.is_set or self.previous_protect_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_path_option.get_name_leafdata())
                            if (self.previous_protect_setup_last_error.is_set or self.previous_protect_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_setup_last_error.get_name_leafdata())
                            if (self.previous_protect_tunnel_instance.is_set or self.previous_protect_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-protect-fail-reason" or name == "previous-protect-path-option" or name == "previous-protect-setup-last-error" or name == "previous-protect-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-protect-fail-reason"):
                                self.previous_protect_fail_reason = value
                                self.previous_protect_fail_reason.value_namespace = name_space
                                self.previous_protect_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-path-option"):
                                self.previous_protect_path_option = value
                                self.previous_protect_path_option.value_namespace = name_space
                                self.previous_protect_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-setup-last-error"):
                                self.previous_protect_setup_last_error = value
                                self.previous_protect_setup_last_error.value_namespace = name_space
                                self.previous_protect_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-tunnel-instance"):
                                self.previous_protect_tunnel_instance = value
                                self.previous_protect_tunnel_instance.value_namespace = name_space
                                self.previous_protect_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class GmplsOtherSetup(Entity):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class GmplsOtherProtectSetup(Entity):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class StandbySetup(Entity):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"

                            self.standby_lsp_uptime = YLeaf(YType.uint32, "standby-lsp-uptime")

                            self.standby_setup_timer = YLeaf(YType.uint32, "standby-setup-timer")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("standby_lsp_uptime",
                                            "standby_setup_timer") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.standby_lsp_uptime.is_set or
                                self.standby_setup_timer.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.standby_lsp_uptime.yfilter != YFilter.not_set or
                                self.standby_setup_timer.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.standby_lsp_uptime.is_set or self.standby_lsp_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_lsp_uptime.get_name_leafdata())
                            if (self.standby_setup_timer.is_set or self.standby_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_setup_timer.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "standby-lsp-uptime" or name == "standby-setup-timer"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "standby-lsp-uptime"):
                                self.standby_lsp_uptime = value
                                self.standby_lsp_uptime.value_namespace = name_space
                                self.standby_lsp_uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "standby-setup-timer"):
                                self.standby_setup_timer = value
                                self.standby_setup_timer.value_namespace = name_space
                                self.standby_setup_timer.value_namespace_prefix = name_space_prefix


                    class StandbyReoptSetup(Entity):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class LastReOptFail(Entity):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix


                    class LastStdbyReOptFail(Entity):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-stdby-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.current_setup is not None and self.current_setup.has_data()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_data()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_data()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_data()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_data()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_data()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_data()) or
                            (self.previous_setup is not None and self.previous_setup.has_data()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_data()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_data()) or
                            (self.standby_setup is not None and self.standby_setup.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.current_setup is not None and self.current_setup.has_operation()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_operation()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_operation()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_operation()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_operation()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_operation()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_operation()) or
                            (self.previous_setup is not None and self.previous_setup.has_operation()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_operation()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_operation()) or
                            (self.standby_setup is not None and self.standby_setup.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "current-setup"):
                            if (self.current_setup is None):
                                self.current_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                                self.current_setup.parent = self
                                self._children_name_map["current_setup"] = "current-setup"
                            return self.current_setup

                        if (child_yang_name == "gmpls-other-protect-setup"):
                            if (self.gmpls_other_protect_setup is None):
                                self.gmpls_other_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                                self.gmpls_other_protect_setup.parent = self
                                self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                            return self.gmpls_other_protect_setup

                        if (child_yang_name == "gmpls-other-setup"):
                            if (self.gmpls_other_setup is None):
                                self.gmpls_other_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                                self.gmpls_other_setup.parent = self
                                self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                            return self.gmpls_other_setup

                        if (child_yang_name == "gmpls-path-protect-setup"):
                            if (self.gmpls_path_protect_setup is None):
                                self.gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                                self.gmpls_path_protect_setup.parent = self
                                self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                            return self.gmpls_path_protect_setup

                        if (child_yang_name == "last-re-opt-fail"):
                            if (self.last_re_opt_fail is None):
                                self.last_re_opt_fail = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                                self.last_re_opt_fail.parent = self
                                self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                            return self.last_re_opt_fail

                        if (child_yang_name == "last-stdby-re-opt-fail"):
                            if (self.last_stdby_re_opt_fail is None):
                                self.last_stdby_re_opt_fail = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                                self.last_stdby_re_opt_fail.parent = self
                                self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                            return self.last_stdby_re_opt_fail

                        if (child_yang_name == "previous-gmpls-path-protect-setup"):
                            if (self.previous_gmpls_path_protect_setup is None):
                                self.previous_gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                                self.previous_gmpls_path_protect_setup.parent = self
                                self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                            return self.previous_gmpls_path_protect_setup

                        if (child_yang_name == "previous-setup"):
                            if (self.previous_setup is None):
                                self.previous_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                                self.previous_setup.parent = self
                                self._children_name_map["previous_setup"] = "previous-setup"
                            return self.previous_setup

                        if (child_yang_name == "reopt-setup"):
                            if (self.reopt_setup is None):
                                self.reopt_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                                self.reopt_setup.parent = self
                                self._children_name_map["reopt_setup"] = "reopt-setup"
                            return self.reopt_setup

                        if (child_yang_name == "standby-reopt-setup"):
                            if (self.standby_reopt_setup is None):
                                self.standby_reopt_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                                self.standby_reopt_setup.parent = self
                                self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                            return self.standby_reopt_setup

                        if (child_yang_name == "standby-setup"):
                            if (self.standby_setup is None):
                                self.standby_setup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                                self.standby_setup.parent = self
                                self._children_name_map["standby_setup"] = "standby-setup"
                            return self.standby_setup

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "current-setup" or name == "gmpls-other-protect-setup" or name == "gmpls-other-setup" or name == "gmpls-path-protect-setup" or name == "last-re-opt-fail" or name == "last-stdby-re-opt-fail" or name == "previous-gmpls-path-protect-setup" or name == "previous-setup" or name == "reopt-setup" or name == "standby-reopt-setup" or name == "standby-setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "nni-tunnel"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class AutoBackup(Entity):
                    """
                    Autobackup Information
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\:  str
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of    :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep>`
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\:  bool
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\:  bool
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\:  str
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:   :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "nni-tunnel"

                        self.ab_protected_interface = YLeaf(YType.str, "ab-protected-interface")

                        self.ab_protection_type = YLeaf(YType.enumeration, "ab-protection-type")

                        self.is_unused_removal_timer_running = YLeaf(YType.boolean, "is-unused-removal-timer-running")

                        self.is_using_srlg = YLeaf(YType.boolean, "is-using-srlg")

                        self.protected_address = YLeaf(YType.str, "protected-address")

                        self.protected_ls_ps = YLeaf(YType.uint32, "protected-ls-ps")

                        self.protected_s2_ls = YLeaf(YType.uint32, "protected-s2-ls")

                        self.sharing_families = YLeaf(YType.uint32, "sharing-families")

                        self.srlg_prot_type = YLeaf(YType.enumeration, "srlg-prot-type")

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.unused_removal_remaining_time = YLeaf(YType.uint32, "unused-removal-remaining-time")

                        self.weighted_srlg_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                        self._children_yang_names.add("weighted-srlg-info")

                        self.iep = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("ab_protected_interface",
                                        "ab_protection_type",
                                        "is_unused_removal_timer_running",
                                        "is_using_srlg",
                                        "protected_address",
                                        "protected_ls_ps",
                                        "protected_s2_ls",
                                        "sharing_families",
                                        "srlg_prot_type",
                                        "tunnel_attribute_set_name",
                                        "unused_removal_remaining_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__setattr__(name, value)


                    class WeightedSrlgInfo(Entity):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of    :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of    :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)


                        class ProtectedInterfaceSrlg(Entity):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                                self.srlg = YLeaf(YType.uint32, "srlg")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admin_weight",
                                                "srlg",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admin_weight.is_set or
                                    self.srlg.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admin_weight.yfilter != YFilter.not_set or
                                    self.srlg.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protected-interface-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                                if (self.srlg.is_set or self.srlg.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admin-weight" or name == "srlg" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admin-weight"):
                                    self.admin_weight = value
                                    self.admin_weight.value_namespace = name_space
                                    self.admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg"):
                                    self.srlg = value
                                    self.srlg.value_namespace = name_space
                                    self.srlg.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class WeightedSrlgHop(Entity):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of    :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.aggregate_admin_weight = YLeaf(YType.uint64, "aggregate-admin-weight")

                                self.from_address = YLeaf(YType.str, "from-address")

                                self.to_address = YLeaf(YType.str, "to-address")

                                self.common_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("aggregate_admin_weight",
                                                "from_address",
                                                "to_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)


                            class CommonSrlg(Entity):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "common-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.common_srlg:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.aggregate_admin_weight.is_set or
                                    self.from_address.is_set or
                                    self.to_address.is_set)

                            def has_operation(self):
                                for c in self.common_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.aggregate_admin_weight.yfilter != YFilter.not_set or
                                    self.from_address.yfilter != YFilter.not_set or
                                    self.to_address.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "weighted-srlg-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.aggregate_admin_weight.is_set or self.aggregate_admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.aggregate_admin_weight.get_name_leafdata())
                                if (self.from_address.is_set or self.from_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.from_address.get_name_leafdata())
                                if (self.to_address.is_set or self.to_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.to_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "common-srlg"):
                                    for c in self.common_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.common_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "common-srlg" or name == "aggregate-admin-weight" or name == "from-address" or name == "to-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "aggregate-admin-weight"):
                                    self.aggregate_admin_weight = value
                                    self.aggregate_admin_weight.value_namespace = name_space
                                    self.aggregate_admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "from-address"):
                                    self.from_address = value
                                    self.from_address.value_namespace = name_space
                                    self.from_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "to-address"):
                                    self.to_address = value
                                    self.to_address.value_namespace = name_space
                                    self.to_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_data()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_operation()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "weighted-srlg-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protected-interface-srlg"):
                                for c in self.protected_interface_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protected_interface_srlg.append(c)
                                return c

                            if (child_yang_name == "weighted-srlg-hop"):
                                for c in self.weighted_srlg_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.weighted_srlg_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface-srlg" or name == "weighted-srlg-hop"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Iep(Entity):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of    :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop>`
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"

                            self.path_option_id = YLeaf(YType.uint32, "path-option-id")

                            self.iep_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("path_option_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__setattr__(name, value)


                        class IepHop(Entity):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:   :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"

                                self.hop_index = YLeaf(YType.uint32, "hop-index")

                                self.iep_hop_address = YLeaf(YType.str, "iep-hop-address")

                                self.iep_hop_type = YLeaf(YType.enumeration, "iep-hop-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_index",
                                                "iep_hop_address",
                                                "iep_hop_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.hop_index.is_set or
                                    self.iep_hop_address.is_set or
                                    self.iep_hop_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_index.yfilter != YFilter.not_set or
                                    self.iep_hop_address.yfilter != YFilter.not_set or
                                    self.iep_hop_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iep-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_index.is_set or self.hop_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_index.get_name_leafdata())
                                if (self.iep_hop_address.is_set or self.iep_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_address.get_name_leafdata())
                                if (self.iep_hop_type.is_set or self.iep_hop_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-index" or name == "iep-hop-address" or name == "iep-hop-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-index"):
                                    self.hop_index = value
                                    self.hop_index.value_namespace = name_space
                                    self.hop_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-address"):
                                    self.iep_hop_address = value
                                    self.iep_hop_address.value_namespace = name_space
                                    self.iep_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-type"):
                                    self.iep_hop_type = value
                                    self.iep_hop_type.value_namespace = name_space
                                    self.iep_hop_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.iep_hop:
                                if (c.has_data()):
                                    return True
                            return self.path_option_id.is_set

                        def has_operation(self):
                            for c in self.iep_hop:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.path_option_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "iep" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.path_option_id.is_set or self.path_option_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "iep-hop"):
                                for c in self.iep_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.iep_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "iep-hop" or name == "path-option-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "path-option-id"):
                                self.path_option_id = value
                                self.path_option_id.value_namespace = name_space
                                self.path_option_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.iep:
                            if (c.has_data()):
                                return True
                        return (
                            self.ab_protected_interface.is_set or
                            self.ab_protection_type.is_set or
                            self.is_unused_removal_timer_running.is_set or
                            self.is_using_srlg.is_set or
                            self.protected_address.is_set or
                            self.protected_ls_ps.is_set or
                            self.protected_s2_ls.is_set or
                            self.sharing_families.is_set or
                            self.srlg_prot_type.is_set or
                            self.tunnel_attribute_set_name.is_set or
                            self.unused_removal_remaining_time.is_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_data()))

                    def has_operation(self):
                        for c in self.iep:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.ab_protected_interface.yfilter != YFilter.not_set or
                            self.ab_protection_type.yfilter != YFilter.not_set or
                            self.is_unused_removal_timer_running.yfilter != YFilter.not_set or
                            self.is_using_srlg.yfilter != YFilter.not_set or
                            self.protected_address.yfilter != YFilter.not_set or
                            self.protected_ls_ps.yfilter != YFilter.not_set or
                            self.protected_s2_ls.yfilter != YFilter.not_set or
                            self.sharing_families.yfilter != YFilter.not_set or
                            self.srlg_prot_type.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.unused_removal_remaining_time.yfilter != YFilter.not_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-backup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.ab_protected_interface.is_set or self.ab_protected_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protected_interface.get_name_leafdata())
                        if (self.ab_protection_type.is_set or self.ab_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protection_type.get_name_leafdata())
                        if (self.is_unused_removal_timer_running.is_set or self.is_unused_removal_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unused_removal_timer_running.get_name_leafdata())
                        if (self.is_using_srlg.is_set or self.is_using_srlg.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_using_srlg.get_name_leafdata())
                        if (self.protected_address.is_set or self.protected_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_address.get_name_leafdata())
                        if (self.protected_ls_ps.is_set or self.protected_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_ls_ps.get_name_leafdata())
                        if (self.protected_s2_ls.is_set or self.protected_s2_ls.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_s2_ls.get_name_leafdata())
                        if (self.sharing_families.is_set or self.sharing_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sharing_families.get_name_leafdata())
                        if (self.srlg_prot_type.is_set or self.srlg_prot_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_prot_type.get_name_leafdata())
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.unused_removal_remaining_time.is_set or self.unused_removal_remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unused_removal_remaining_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "iep"):
                            for c in self.iep:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.iep.append(c)
                            return c

                        if (child_yang_name == "weighted-srlg-info"):
                            if (self.weighted_srlg_info is None):
                                self.weighted_srlg_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                                self.weighted_srlg_info.parent = self
                                self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                            return self.weighted_srlg_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "iep" or name == "weighted-srlg-info" or name == "ab-protected-interface" or name == "ab-protection-type" or name == "is-unused-removal-timer-running" or name == "is-using-srlg" or name == "protected-address" or name == "protected-ls-ps" or name == "protected-s2-ls" or name == "sharing-families" or name == "srlg-prot-type" or name == "tunnel-attribute-set-name" or name == "unused-removal-remaining-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "ab-protected-interface"):
                            self.ab_protected_interface = value
                            self.ab_protected_interface.value_namespace = name_space
                            self.ab_protected_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ab-protection-type"):
                            self.ab_protection_type = value
                            self.ab_protection_type.value_namespace = name_space
                            self.ab_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unused-removal-timer-running"):
                            self.is_unused_removal_timer_running = value
                            self.is_unused_removal_timer_running.value_namespace = name_space
                            self.is_unused_removal_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-using-srlg"):
                            self.is_using_srlg = value
                            self.is_using_srlg.value_namespace = name_space
                            self.is_using_srlg.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-address"):
                            self.protected_address = value
                            self.protected_address.value_namespace = name_space
                            self.protected_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-ls-ps"):
                            self.protected_ls_ps = value
                            self.protected_ls_ps.value_namespace = name_space
                            self.protected_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-s2-ls"):
                            self.protected_s2_ls = value
                            self.protected_s2_ls.value_namespace = name_space
                            self.protected_s2_ls.value_namespace_prefix = name_space_prefix
                        if(value_path == "sharing-families"):
                            self.sharing_families = value
                            self.sharing_families.value_namespace = name_space
                            self.sharing_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-prot-type"):
                            self.srlg_prot_type = value
                            self.srlg_prot_type.value_namespace = name_space
                            self.srlg_prot_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "unused-removal-remaining-time"):
                            self.unused_removal_remaining_time = value
                            self.unused_removal_remaining_time.value_namespace = name_space
                            self.unused_removal_remaining_time.value_namespace_prefix = name_space_prefix


                class AutoMesh(Entity):
                    """
                    Automesh Information
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "nni-tunnel"

                        self.is_tunnel_unused_timer_running = YLeaf(YType.boolean, "is-tunnel-unused-timer-running")

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.mesh_group_type = YLeaf(YType.enumeration, "mesh-group-type")

                        self.remaining_unused_time = YLeaf(YType.uint32, "remaining-unused-time")

                        self.tunnel_destination_list_name = YLeaf(YType.str, "tunnel-destination-list-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_tunnel_unused_timer_running",
                                        "mesh_group_id",
                                        "mesh_group_type",
                                        "remaining_unused_time",
                                        "tunnel_destination_list_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_tunnel_unused_timer_running.is_set or
                            self.mesh_group_id.is_set or
                            self.mesh_group_type.is_set or
                            self.remaining_unused_time.is_set or
                            self.tunnel_destination_list_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.mesh_group_type.yfilter != YFilter.not_set or
                            self.remaining_unused_time.yfilter != YFilter.not_set or
                            self.tunnel_destination_list_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-mesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_tunnel_unused_timer_running.is_set or self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_tunnel_unused_timer_running.get_name_leafdata())
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.mesh_group_type.is_set or self.mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_type.get_name_leafdata())
                        if (self.remaining_unused_time.is_set or self.remaining_unused_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_unused_time.get_name_leafdata())
                        if (self.tunnel_destination_list_name.is_set or self.tunnel_destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_destination_list_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-tunnel-unused-timer-running" or name == "mesh-group-id" or name == "mesh-group-type" or name == "remaining-unused-time" or name == "tunnel-destination-list-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-tunnel-unused-timer-running"):
                            self.is_tunnel_unused_timer_running = value
                            self.is_tunnel_unused_timer_running.value_namespace = name_space
                            self.is_tunnel_unused_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-type"):
                            self.mesh_group_type = value
                            self.mesh_group_type.value_namespace = name_space
                            self.mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-unused-time"):
                            self.remaining_unused_time = value
                            self.remaining_unused_time.value_namespace = name_space
                            self.remaining_unused_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-destination-list-name"):
                            self.tunnel_destination_list_name = value
                            self.tunnel_destination_list_name.value_namespace = name_space
                            self.tunnel_destination_list_name.value_namespace_prefix = name_space_prefix


                class AutoPcc(Entity):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\:  str
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\:  bool
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "nni-tunnel"

                        self.creator_address = YLeaf(YType.str, "creator-address")

                        self.creator_id = YLeaf(YType.str, "creator-id")

                        self.has_creator_id = YLeaf(YType.boolean, "has-creator-id")

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plspid = YLeaf(YType.uint32, "plspid")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("creator_address",
                                        "creator_id",
                                        "has_creator_id",
                                        "operationally_up",
                                        "owner_address",
                                        "plspid",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.creator_address.is_set or
                            self.creator_id.is_set or
                            self.has_creator_id.is_set or
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plspid.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.creator_address.yfilter != YFilter.not_set or
                            self.creator_id.yfilter != YFilter.not_set or
                            self.has_creator_id.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plspid.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-pcc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.creator_address.is_set or self.creator_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_address.get_name_leafdata())
                        if (self.creator_id.is_set or self.creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_id.get_name_leafdata())
                        if (self.has_creator_id.is_set or self.has_creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_creator_id.get_name_leafdata())
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plspid.is_set or self.plspid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plspid.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "creator-address" or name == "creator-id" or name == "has-creator-id" or name == "operationally-up" or name == "owner-address" or name == "plspid" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "creator-address"):
                            self.creator_address = value
                            self.creator_address.value_namespace = name_space
                            self.creator_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "creator-id"):
                            self.creator_id = value
                            self.creator_id.value_namespace = name_space
                            self.creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-creator-id"):
                            self.has_creator_id = value
                            self.has_creator_id.value_namespace = name_space
                            self.has_creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plspid"):
                            self.plspid = value
                            self.plspid.value_namespace = name_space
                            self.plspid.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class PceDelegation(Entity):
                    """
                    PCE Delegation information
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "nni-tunnel"

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plsp_id = YLeaf(YType.uint32, "plsp-id")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("operationally_up",
                                        "owner_address",
                                        "plsp_id",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plsp_id.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plsp_id.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pce-delegation" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plsp_id.is_set or self.plsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plsp_id.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "operationally-up" or name == "owner-address" or name == "plsp-id" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plsp-id"):
                            self.plsp_id = value
                            self.plsp_id.value_namespace = name_space
                            self.plsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class SoftPreemption(Entity):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:   :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:   :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters>`
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of    :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError>`
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "nni-tunnel"

                        self.preemption_pending_resolution = YLeaf(YType.enumeration, "preemption-pending-resolution")

                        self.status = YLeaf(YType.enumeration, "status")

                        self.time_in_preemption_pending = YLeaf(YType.uint16, "time-in-preemption-pending")

                        self.soft_preemption_counters = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                        self._children_yang_names.add("soft-preemption-counters")

                        self.soft_preemption_path_error = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("preemption_pending_resolution",
                                        "status",
                                        "time_in_preemption_pending") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__setattr__(name, value)


                    class SoftPreemptionCounters(Entity):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"

                            self.frr_triggered_ls_ps = YLeaf(YType.uint32, "frr-triggered-ls-ps")

                            self.path_protection_switchover_ls_ps = YLeaf(YType.uint32, "path-protection-switchover-ls-ps")

                            self.reopt_completed_ls_ps = YLeaf(YType.uint32, "reopt-completed-ls-ps")

                            self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                            self.time_in_preemption_pending_avg = YLeaf(YType.uint16, "time-in-preemption-pending-avg")

                            self.time_in_preemption_pending_max = YLeaf(YType.uint16, "time-in-preemption-pending-max")

                            self.time_in_preemption_pending_min = YLeaf(YType.uint16, "time-in-preemption-pending-min")

                            self.torn_down_ls_ps = YLeaf(YType.uint32, "torn-down-ls-ps")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_triggered_ls_ps",
                                            "path_protection_switchover_ls_ps",
                                            "reopt_completed_ls_ps",
                                            "soft_preemption_events",
                                            "time_in_preemption_pending_avg",
                                            "time_in_preemption_pending_max",
                                            "time_in_preemption_pending_min",
                                            "torn_down_ls_ps") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_triggered_ls_ps.is_set or
                                self.path_protection_switchover_ls_ps.is_set or
                                self.reopt_completed_ls_ps.is_set or
                                self.soft_preemption_events.is_set or
                                self.time_in_preemption_pending_avg.is_set or
                                self.time_in_preemption_pending_max.is_set or
                                self.time_in_preemption_pending_min.is_set or
                                self.torn_down_ls_ps.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_triggered_ls_ps.yfilter != YFilter.not_set or
                                self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set or
                                self.reopt_completed_ls_ps.yfilter != YFilter.not_set or
                                self.soft_preemption_events.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_avg.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_max.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_min.yfilter != YFilter.not_set or
                                self.torn_down_ls_ps.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_triggered_ls_ps.is_set or self.frr_triggered_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_triggered_ls_ps.get_name_leafdata())
                            if (self.path_protection_switchover_ls_ps.is_set or self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_ls_ps.get_name_leafdata())
                            if (self.reopt_completed_ls_ps.is_set or self.reopt_completed_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reopt_completed_ls_ps.get_name_leafdata())
                            if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                            if (self.time_in_preemption_pending_avg.is_set or self.time_in_preemption_pending_avg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_avg.get_name_leafdata())
                            if (self.time_in_preemption_pending_max.is_set or self.time_in_preemption_pending_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_max.get_name_leafdata())
                            if (self.time_in_preemption_pending_min.is_set or self.time_in_preemption_pending_min.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_min.get_name_leafdata())
                            if (self.torn_down_ls_ps.is_set or self.torn_down_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.torn_down_ls_ps.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-triggered-ls-ps" or name == "path-protection-switchover-ls-ps" or name == "reopt-completed-ls-ps" or name == "soft-preemption-events" or name == "time-in-preemption-pending-avg" or name == "time-in-preemption-pending-max" or name == "time-in-preemption-pending-min" or name == "torn-down-ls-ps"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-triggered-ls-ps"):
                                self.frr_triggered_ls_ps = value
                                self.frr_triggered_ls_ps.value_namespace = name_space
                                self.frr_triggered_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-ls-ps"):
                                self.path_protection_switchover_ls_ps = value
                                self.path_protection_switchover_ls_ps.value_namespace = name_space
                                self.path_protection_switchover_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "reopt-completed-ls-ps"):
                                self.reopt_completed_ls_ps = value
                                self.reopt_completed_ls_ps.value_namespace = name_space
                                self.reopt_completed_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-events"):
                                self.soft_preemption_events = value
                                self.soft_preemption_events.value_namespace = name_space
                                self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-avg"):
                                self.time_in_preemption_pending_avg = value
                                self.time_in_preemption_pending_avg.value_namespace = name_space
                                self.time_in_preemption_pending_avg.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-max"):
                                self.time_in_preemption_pending_max = value
                                self.time_in_preemption_pending_max.value_namespace = name_space
                                self.time_in_preemption_pending_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-min"):
                                self.time_in_preemption_pending_min = value
                                self.time_in_preemption_pending_min.value_namespace = name_space
                                self.time_in_preemption_pending_min.value_namespace_prefix = name_space_prefix
                            if(value_path == "torn-down-ls-ps"):
                                self.torn_down_ls_ps = value
                                self.torn_down_ls_ps.value_namespace = name_space
                                self.torn_down_ls_ps.value_namespace_prefix = name_space_prefix


                    class SoftPreemptionPathError(Entity):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preempting_link_address",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preempting_link_address.is_set or
                                self.timestamp.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-path-error" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preempting-link-address" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_data()):
                                return True
                        return (
                            self.preemption_pending_resolution.is_set or
                            self.status.is_set or
                            self.time_in_preemption_pending.is_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_data()))

                    def has_operation(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.preemption_pending_resolution.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.time_in_preemption_pending.yfilter != YFilter.not_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "soft-preemption" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.preemption_pending_resolution.is_set or self.preemption_pending_resolution.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.preemption_pending_resolution.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.time_in_preemption_pending.is_set or self.time_in_preemption_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_in_preemption_pending.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "soft-preemption-counters"):
                            if (self.soft_preemption_counters is None):
                                self.soft_preemption_counters = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                                self.soft_preemption_counters.parent = self
                                self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                            return self.soft_preemption_counters

                        if (child_yang_name == "soft-preemption-path-error"):
                            for c in self.soft_preemption_path_error:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.soft_preemption_path_error.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "soft-preemption-counters" or name == "soft-preemption-path-error" or name == "preemption-pending-resolution" or name == "status" or name == "time-in-preemption-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "preemption-pending-resolution"):
                            self.preemption_pending_resolution = value
                            self.preemption_pending_resolution.value_namespace = name_space
                            self.preemption_pending_resolution.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-in-preemption-pending"):
                            self.time_in_preemption_pending = value
                            self.time_in_preemption_pending.value_namespace = name_space
                            self.time_in_preemption_pending.value_namespace_prefix = name_space_prefix


                class WdmUnitunnel(Entity):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\:  str
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "nni-tunnel"

                        self.controlled_interface = YLeaf(YType.str, "controlled-interface")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                        self.label_origin = YLeaf(YType.enumeration, "label-origin")

                        self.local_optical_router_id = YLeaf(YType.str, "local-optical-router-id")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                        self.remote_optical_router_id = YLeaf(YType.str, "remote-optical-router-id")

                        self.source_address = YLeaf(YType.str, "source-address")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        self.tunnel_role = YLeaf(YType.enumeration, "tunnel-role")

                        self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("controlled_interface",
                                        "destination_address",
                                        "extended_tunnel_id",
                                        "label_origin",
                                        "local_optical_router_id",
                                        "lsp_id",
                                        "remote_optical_router_id",
                                        "source_address",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_role",
                                        "tunnel_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.controlled_interface.is_set or
                            self.destination_address.is_set or
                            self.extended_tunnel_id.is_set or
                            self.label_origin.is_set or
                            self.local_optical_router_id.is_set or
                            self.lsp_id.is_set or
                            self.remote_optical_router_id.is_set or
                            self.source_address.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_role.is_set or
                            self.tunnel_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.controlled_interface.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.extended_tunnel_id.yfilter != YFilter.not_set or
                            self.label_origin.yfilter != YFilter.not_set or
                            self.local_optical_router_id.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.remote_optical_router_id.yfilter != YFilter.not_set or
                            self.source_address.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_role.yfilter != YFilter.not_set or
                            self.tunnel_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "wdm-unitunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.controlled_interface.is_set or self.controlled_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.controlled_interface.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                        if (self.label_origin.is_set or self.label_origin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_origin.get_name_leafdata())
                        if (self.local_optical_router_id.is_set or self.local_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_optical_router_id.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.remote_optical_router_id.is_set or self.remote_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_optical_router_id.get_name_leafdata())
                        if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_address.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_role.is_set or self.tunnel_role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_role.get_name_leafdata())
                        if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "controlled-interface" or name == "destination-address" or name == "extended-tunnel-id" or name == "label-origin" or name == "local-optical-router-id" or name == "lsp-id" or name == "remote-optical-router-id" or name == "source-address" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-role" or name == "tunnel-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "controlled-interface"):
                            self.controlled_interface = value
                            self.controlled_interface.value_namespace = name_space
                            self.controlled_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "extended-tunnel-id"):
                            self.extended_tunnel_id = value
                            self.extended_tunnel_id.value_namespace = name_space
                            self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "label-origin"):
                            self.label_origin = value
                            self.label_origin.value_namespace = name_space
                            self.label_origin.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-optical-router-id"):
                            self.local_optical_router_id = value
                            self.local_optical_router_id.value_namespace = name_space
                            self.local_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-optical-router-id"):
                            self.remote_optical_router_id = value
                            self.remote_optical_router_id.value_namespace = name_space
                            self.remote_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-address"):
                            self.source_address = value
                            self.source_address.value_namespace = name_space
                            self.source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-role"):
                            self.tunnel_role = value
                            self.tunnel_role.value_namespace = name_space
                            self.tunnel_role.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-state"):
                            self.tunnel_state = value
                            self.tunnel_state.value_namespace = name_space
                            self.tunnel_state.value_namespace_prefix = name_space_prefix


                class TransportTunnelInfo(Entity):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of    :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo>`
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:   :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni>`
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of    :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro>`
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn>`
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:   :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni>`
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.status_homepath_working = YLeaf(YType.boolean, "status-homepath-working")

                        self.egress_static_uni = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"
                        self._children_yang_names.add("egress-static-uni")

                        self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"
                        self._children_yang_names.add("otn")

                        self.static_uni = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"
                        self._children_yang_names.add("static-uni")

                        self.diversity_info = YList(self)
                        self.homepath_ero = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("status_homepath_working") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__setattr__(name, value)


                    class Otn(Entity):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:   :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.bandwidth_cfg = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._children_yang_names.add("bandwidth-cfg")


                        class BandwidthCfg(Entity):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"

                                self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                self._children_yang_names.add("odu-flex-cbr")

                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                self._children_yang_names.add("odu-flex-gfp-f-res")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("odu_level") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)


                            class OduFlexCbr(Entity):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.tolerance = YLeaf(YType.uint16, "tolerance")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "tolerance") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.tolerance.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.tolerance.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-cbr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tolerance.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "tolerance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tolerance"):
                                        self.tolerance = value
                                        self.tolerance.value_namespace = name_space
                                        self.tolerance.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFRes(Entity):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFNonRes(Entity):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.odu_level.is_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.odu_level.yfilter != YFilter.not_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-cfg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.odu_level.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "odu-flex-cbr"):
                                    if (self.odu_flex_cbr is None):
                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    return self.odu_flex_cbr

                                if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                    if (self.odu_flex_gfp_f_non_res is None):
                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    return self.odu_flex_gfp_f_non_res

                                if (child_yang_name == "odu-flex-gfp-f-res"):
                                    if (self.odu_flex_gfp_f_res is None):
                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    return self.odu_flex_gfp_f_res

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "odu-level"):
                                    self.odu_level = value
                                    self.odu_level.value_namespace = name_space
                                    self.odu_level.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-cfg"):
                                if (self.bandwidth_cfg is None):
                                    self.bandwidth_cfg = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                                    self.bandwidth_cfg.parent = self
                                    self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                                return self.bandwidth_cfg

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-cfg"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class StaticUni(Entity):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\:  str
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\:  bool
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.client_if_handle = YLeaf(YType.str, "client-if-handle")

                            self.client_odu_if_handle = YLeaf(YType.str, "client-odu-if-handle")

                            self.client_odu_name = YLeaf(YType.str, "client-odu-name")

                            self.client_port = YLeaf(YType.str, "client-port")

                            self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                            self.is_connected = YLeaf(YType.boolean, "is-connected")

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.static_uni_type = YLeaf(YType.enumeration, "static-uni-type")

                            self.term_client_if_handle = YLeaf(YType.str, "term-client-if-handle")

                            self.term_client_port = YLeaf(YType.str, "term-client-port")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("client_if_handle",
                                            "client_odu_if_handle",
                                            "client_odu_name",
                                            "client_port",
                                            "cross_connect_id",
                                            "is_connected",
                                            "local_termination",
                                            "static_uni_type",
                                            "term_client_if_handle",
                                            "term_client_port",
                                            "uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.client_if_handle.is_set or
                                self.client_odu_if_handle.is_set or
                                self.client_odu_name.is_set or
                                self.client_port.is_set or
                                self.cross_connect_id.is_set or
                                self.is_connected.is_set or
                                self.local_termination.is_set or
                                self.static_uni_type.is_set or
                                self.term_client_if_handle.is_set or
                                self.term_client_port.is_set or
                                self.uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.client_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_name.yfilter != YFilter.not_set or
                                self.client_port.yfilter != YFilter.not_set or
                                self.cross_connect_id.yfilter != YFilter.not_set or
                                self.is_connected.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.static_uni_type.yfilter != YFilter.not_set or
                                self.term_client_if_handle.yfilter != YFilter.not_set or
                                self.term_client_port.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.client_if_handle.is_set or self.client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_if_handle.get_name_leafdata())
                            if (self.client_odu_if_handle.is_set or self.client_odu_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_if_handle.get_name_leafdata())
                            if (self.client_odu_name.is_set or self.client_odu_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_name.get_name_leafdata())
                            if (self.client_port.is_set or self.client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_port.get_name_leafdata())
                            if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                            if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_connected.get_name_leafdata())
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.static_uni_type.is_set or self.static_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.static_uni_type.get_name_leafdata())
                            if (self.term_client_if_handle.is_set or self.term_client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_if_handle.get_name_leafdata())
                            if (self.term_client_port.is_set or self.term_client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_port.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "client-if-handle" or name == "client-odu-if-handle" or name == "client-odu-name" or name == "client-port" or name == "cross-connect-id" or name == "is-connected" or name == "local-termination" or name == "static-uni-type" or name == "term-client-if-handle" or name == "term-client-port" or name == "uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "client-if-handle"):
                                self.client_if_handle = value
                                self.client_if_handle.value_namespace = name_space
                                self.client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-if-handle"):
                                self.client_odu_if_handle = value
                                self.client_odu_if_handle.value_namespace = name_space
                                self.client_odu_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-name"):
                                self.client_odu_name = value
                                self.client_odu_name.value_namespace = name_space
                                self.client_odu_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-port"):
                                self.client_port = value
                                self.client_port.value_namespace = name_space
                                self.client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "cross-connect-id"):
                                self.cross_connect_id = value
                                self.cross_connect_id.value_namespace = name_space
                                self.cross_connect_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-connected"):
                                self.is_connected = value
                                self.is_connected.value_namespace = name_space
                                self.is_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "static-uni-type"):
                                self.static_uni_type = value
                                self.static_uni_type.value_namespace = name_space
                                self.static_uni_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-if-handle"):
                                self.term_client_if_handle = value
                                self.term_client_if_handle.value_namespace = name_space
                                self.term_client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-port"):
                                self.term_client_port = value
                                self.term_client_port.value_namespace = name_space
                                self.term_client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix


                    class EgressStaticUni(Entity):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:   :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:   :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.remote_uni_type = YLeaf(YType.enumeration, "remote-uni-type")

                            self.egress_port = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"
                            self._children_yang_names.add("egress-port")

                            self.term_egress_port = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._children_yang_names.add("term-egress-port")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("local_termination",
                                            "remote_uni_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)


                        class EgressPort(Entity):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class TermEgressPort(Entity):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "term-egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.local_termination.is_set or
                                self.remote_uni_type.is_set or
                                (self.egress_port is not None and self.egress_port.has_data()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.remote_uni_type.yfilter != YFilter.not_set or
                                (self.egress_port is not None and self.egress_port.has_operation()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "egress-static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.remote_uni_type.is_set or self.remote_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_uni_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "egress-port"):
                                if (self.egress_port is None):
                                    self.egress_port = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                                    self.egress_port.parent = self
                                    self._children_name_map["egress_port"] = "egress-port"
                                return self.egress_port

                            if (child_yang_name == "term-egress-port"):
                                if (self.term_egress_port is None):
                                    self.term_egress_port = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                                    self.term_egress_port.parent = self
                                    self._children_name_map["term_egress_port"] = "term-egress-port"
                                return self.term_egress_port

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "egress-port" or name == "term-egress-port" or name == "local-termination" or name == "remote-uni-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-uni-type"):
                                self.remote_uni_type = value
                                self.remote_uni_type.value_namespace = name_space
                                self.remote_uni_type.value_namespace_prefix = name_space_prefix


                    class HomepathEro(Entity):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "homepath-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.tunnel_id.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.diversity_info:
                            if (c.has_data()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_data()):
                                return True
                        return (
                            self.status_homepath_working.is_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_data()) or
                            (self.otn is not None and self.otn.has_data()) or
                            (self.static_uni is not None and self.static_uni.has_data()))

                    def has_operation(self):
                        for c in self.diversity_info:
                            if (c.has_operation()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.status_homepath_working.yfilter != YFilter.not_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_operation()) or
                            (self.otn is not None and self.otn.has_operation()) or
                            (self.static_uni is not None and self.static_uni.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transport-tunnel-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.status_homepath_working.is_set or self.status_homepath_working.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status_homepath_working.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "diversity-info"):
                            for c in self.diversity_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.diversity_info.append(c)
                            return c

                        if (child_yang_name == "egress-static-uni"):
                            if (self.egress_static_uni is None):
                                self.egress_static_uni = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                                self.egress_static_uni.parent = self
                                self._children_name_map["egress_static_uni"] = "egress-static-uni"
                            return self.egress_static_uni

                        if (child_yang_name == "homepath-ero"):
                            for c in self.homepath_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.homepath_ero.append(c)
                            return c

                        if (child_yang_name == "otn"):
                            if (self.otn is None):
                                self.otn = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                            return self.otn

                        if (child_yang_name == "static-uni"):
                            if (self.static_uni is None):
                                self.static_uni = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                                self.static_uni.parent = self
                                self._children_name_map["static_uni"] = "static-uni"
                            return self.static_uni

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "diversity-info" or name == "egress-static-uni" or name == "homepath-ero" or name == "otn" or name == "static-uni" or name == "status-homepath-working"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "status-homepath-working"):
                            self.status_homepath_working = value
                            self.status_homepath_working.value_namespace = name_space
                            self.status_homepath_working.value_namespace_prefix = name_space_prefix


                class BfdInfo(Entity):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\:  bool
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of    :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo>`
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:   :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters>`
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\:  str
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.bfd_session_up = YLeaf(YType.boolean, "bfd-session-up")

                        self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                        self.failure_reason = YLeaf(YType.str, "failure-reason")

                        self.maximum_session_up_interval = YLeaf(YType.uint32, "maximum-session-up-interval")

                        self.minimum_session_up_interval = YLeaf(YType.uint32, "minimum-session-up-interval")

                        self.session_up_time = YLeaf(YType.uint32, "session-up-time")

                        self.event_counters = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"
                        self._children_yang_names.add("event-counters")

                        self.dampening_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_up",
                                        "failure_diagnostic_code",
                                        "failure_reason",
                                        "maximum_session_up_interval",
                                        "minimum_session_up_interval",
                                        "session_up_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__setattr__(name, value)


                    class EventCounters(Entity):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"

                            self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                            self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                            self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                            self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                            self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                            self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                            self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                            self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                            self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("session_admin_down_events",
                                            "session_create_events",
                                            "session_create_timeout_events",
                                            "session_creation_failed_events",
                                            "session_down_events",
                                            "session_gracefully_delete_events",
                                            "session_non_gracefully_delete_events",
                                            "session_replay_events",
                                            "session_up_events") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.session_admin_down_events.is_set or
                                self.session_create_events.is_set or
                                self.session_create_timeout_events.is_set or
                                self.session_creation_failed_events.is_set or
                                self.session_down_events.is_set or
                                self.session_gracefully_delete_events.is_set or
                                self.session_non_gracefully_delete_events.is_set or
                                self.session_replay_events.is_set or
                                self.session_up_events.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.session_admin_down_events.yfilter != YFilter.not_set or
                                self.session_create_events.yfilter != YFilter.not_set or
                                self.session_create_timeout_events.yfilter != YFilter.not_set or
                                self.session_creation_failed_events.yfilter != YFilter.not_set or
                                self.session_down_events.yfilter != YFilter.not_set or
                                self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_replay_events.yfilter != YFilter.not_set or
                                self.session_up_events.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "event-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                            if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_events.get_name_leafdata())
                            if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                            if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                            if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_down_events.get_name_leafdata())
                            if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                            if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                            if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                            if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_up_events.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "session-admin-down-events"):
                                self.session_admin_down_events = value
                                self.session_admin_down_events.value_namespace = name_space
                                self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-events"):
                                self.session_create_events = value
                                self.session_create_events.value_namespace = name_space
                                self.session_create_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-timeout-events"):
                                self.session_create_timeout_events = value
                                self.session_create_timeout_events.value_namespace = name_space
                                self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-creation-failed-events"):
                                self.session_creation_failed_events = value
                                self.session_creation_failed_events.value_namespace = name_space
                                self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-down-events"):
                                self.session_down_events = value
                                self.session_down_events.value_namespace = name_space
                                self.session_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-gracefully-delete-events"):
                                self.session_gracefully_delete_events = value
                                self.session_gracefully_delete_events.value_namespace = name_space
                                self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-non-gracefully-delete-events"):
                                self.session_non_gracefully_delete_events = value
                                self.session_non_gracefully_delete_events.value_namespace = name_space
                                self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-replay-events"):
                                self.session_replay_events = value
                                self.session_replay_events.value_namespace = name_space
                                self.session_replay_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-up-events"):
                                self.session_up_events = value
                                self.session_up_events.value_namespace = name_space
                                self.session_up_events.value_namespace_prefix = name_space_prefix


                    class DampeningInfo(Entity):
                        """
                        Path option dampening info
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"

                            self.backoff_count = YLeaf(YType.uint32, "backoff-count")

                            self.hold_down_time = YLeaf(YType.uint32, "hold-down-time")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.remained_time = YLeaf(YType.uint32, "remained-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_count",
                                            "hold_down_time",
                                            "option_index",
                                            "remained_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_count.is_set or
                                self.hold_down_time.is_set or
                                self.option_index.is_set or
                                self.remained_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_count.yfilter != YFilter.not_set or
                                self.hold_down_time.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.remained_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "dampening-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_count.is_set or self.backoff_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_count.get_name_leafdata())
                            if (self.hold_down_time.is_set or self.hold_down_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_down_time.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.remained_time.is_set or self.remained_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remained_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-count" or name == "hold-down-time" or name == "option-index" or name == "remained-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-count"):
                                self.backoff_count = value
                                self.backoff_count.value_namespace = name_space
                                self.backoff_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-down-time"):
                                self.hold_down_time = value
                                self.hold_down_time.value_namespace = name_space
                                self.hold_down_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "remained-time"):
                                self.remained_time = value
                                self.remained_time.value_namespace = name_space
                                self.remained_time.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.dampening_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bfd_session_up.is_set or
                            self.failure_diagnostic_code.is_set or
                            self.failure_reason.is_set or
                            self.maximum_session_up_interval.is_set or
                            self.minimum_session_up_interval.is_set or
                            self.session_up_time.is_set or
                            (self.event_counters is not None and self.event_counters.has_data()))

                    def has_operation(self):
                        for c in self.dampening_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_up.yfilter != YFilter.not_set or
                            self.failure_diagnostic_code.yfilter != YFilter.not_set or
                            self.failure_reason.yfilter != YFilter.not_set or
                            self.maximum_session_up_interval.yfilter != YFilter.not_set or
                            self.minimum_session_up_interval.yfilter != YFilter.not_set or
                            self.session_up_time.yfilter != YFilter.not_set or
                            (self.event_counters is not None and self.event_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_up.is_set or self.bfd_session_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_up.get_name_leafdata())
                        if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                        if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_reason.get_name_leafdata())
                        if (self.maximum_session_up_interval.is_set or self.maximum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_session_up_interval.get_name_leafdata())
                        if (self.minimum_session_up_interval.is_set or self.minimum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.minimum_session_up_interval.get_name_leafdata())
                        if (self.session_up_time.is_set or self.session_up_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_up_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "dampening-info"):
                            for c in self.dampening_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.dampening_info.append(c)
                            return c

                        if (child_yang_name == "event-counters"):
                            if (self.event_counters is None):
                                self.event_counters = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                                self.event_counters.parent = self
                                self._children_name_map["event_counters"] = "event-counters"
                            return self.event_counters

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "dampening-info" or name == "event-counters" or name == "bfd-session-up" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "maximum-session-up-interval" or name == "minimum-session-up-interval" or name == "session-up-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-up"):
                            self.bfd_session_up = value
                            self.bfd_session_up.value_namespace = name_space
                            self.bfd_session_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-diagnostic-code"):
                            self.failure_diagnostic_code = value
                            self.failure_diagnostic_code.value_namespace = name_space
                            self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-reason"):
                            self.failure_reason = value
                            self.failure_reason.value_namespace = name_space
                            self.failure_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-session-up-interval"):
                            self.maximum_session_up_interval = value
                            self.maximum_session_up_interval.value_namespace = name_space
                            self.maximum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "minimum-session-up-interval"):
                            self.minimum_session_up_interval = value
                            self.minimum_session_up_interval.value_namespace = name_space
                            self.minimum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-up-time"):
                            self.session_up_time = value
                            self.session_up_time.value_namespace = name_space
                            self.session_up_time.value_namespace_prefix = name_space_prefix


                class OtnBidir(Entity):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps>`
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:   :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "nni-tunnel"

                        self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"
                        self._children_yang_names.add("aps")

                        self.restoration = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._children_yang_names.add("restoration")


                    class Aps(Entity):
                        """
                        APS Protection Info
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:   :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"

                            self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.protection_profile = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._children_yang_names.add("protection-profile")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("active_lsp",
                                            "diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__setattr__(name, value)


                        class ProtectionProfile(Entity):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection-profile" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.active_lsp.is_set or
                                self.diversity_type.is_set or
                                (self.protection_profile is not None and self.protection_profile.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.active_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                (self.protection_profile is not None and self.protection_profile.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "aps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.active_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protection-profile"):
                                if (self.protection_profile is None):
                                    self.protection_profile = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                                    self.protection_profile.parent = self
                                    self._children_name_map["protection_profile"] = "protection-profile"
                                return self.protection_profile

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protection-profile" or name == "active-lsp" or name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "active-lsp"):
                                self.active_lsp = value
                                self.active_lsp.value_namespace = name_space
                                self.active_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class Restoration(Entity):
                        """
                        Restoration Info
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"

                            self.diverse_lsp = YLeaf(YType.enumeration, "diverse-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.revert_option = YLeaf(YType.enumeration, "revert-option")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diverse_lsp",
                                            "diversity_type",
                                            "revert_option") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.diverse_lsp.is_set or
                                self.diversity_type.is_set or
                                self.revert_option.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diverse_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                self.revert_option.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "restoration" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diverse_lsp.is_set or self.diverse_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diverse_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())
                            if (self.revert_option.is_set or self.revert_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.revert_option.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diverse-lsp" or name == "diversity-type" or name == "revert-option"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diverse-lsp"):
                                self.diverse_lsp = value
                                self.diverse_lsp.value_namespace = name_space
                                self.diverse_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "revert-option"):
                                self.revert_option = value
                                self.revert_option.value_namespace = name_space
                                self.revert_option.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.aps is not None and self.aps.has_data()) or
                            (self.restoration is not None and self.restoration.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.aps is not None and self.aps.has_operation()) or
                            (self.restoration is not None and self.restoration.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "otn-bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "aps"):
                            if (self.aps is None):
                                self.aps = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                            return self.aps

                        if (child_yang_name == "restoration"):
                            if (self.restoration is None):
                                self.restoration = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                                self.restoration.parent = self
                                self._children_name_map["restoration"] = "restoration"
                            return self.restoration

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "aps" or name == "restoration"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Bidir(Entity):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:   :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent>`
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt>`
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby>`
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "nni-tunnel"

                        self.reverse_bandwidth = YLeaf(YType.uint32, "reverse-bandwidth")

                        self.reverse_bandwidth_standby = YLeaf(YType.uint32, "reverse-bandwidth-standby")

                        self.reverse_ero_error_current = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                        self._children_yang_names.add("reverse-ero-error-current")

                        self.reverse_ero_error_reopt = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                        self._children_yang_names.add("reverse-ero-error-reopt")

                        self.reverse_ero_error_standby = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                        self._children_yang_names.add("reverse-ero-error-standby")

                        self.reverse_ero_error_standby_reopt = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._children_yang_names.add("reverse-ero-error-standby-reopt")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("reverse_bandwidth",
                                        "reverse_bandwidth_standby") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__setattr__(name, value)


                    class ReverseEroErrorCurrent(Entity):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-current" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorReopt(Entity):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandby(Entity):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandbyReopt(Entity):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.reverse_bandwidth.is_set or
                            self.reverse_bandwidth_standby.is_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_data()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_data()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_data()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.reverse_bandwidth.yfilter != YFilter.not_set or
                            self.reverse_bandwidth_standby.yfilter != YFilter.not_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_operation()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_operation()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_operation()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.reverse_bandwidth.is_set or self.reverse_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth.get_name_leafdata())
                        if (self.reverse_bandwidth_standby.is_set or self.reverse_bandwidth_standby.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth_standby.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "reverse-ero-error-current"):
                            if (self.reverse_ero_error_current is None):
                                self.reverse_ero_error_current = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                                self.reverse_ero_error_current.parent = self
                                self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                            return self.reverse_ero_error_current

                        if (child_yang_name == "reverse-ero-error-reopt"):
                            if (self.reverse_ero_error_reopt is None):
                                self.reverse_ero_error_reopt = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                                self.reverse_ero_error_reopt.parent = self
                                self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                            return self.reverse_ero_error_reopt

                        if (child_yang_name == "reverse-ero-error-standby"):
                            if (self.reverse_ero_error_standby is None):
                                self.reverse_ero_error_standby = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                                self.reverse_ero_error_standby.parent = self
                                self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                            return self.reverse_ero_error_standby

                        if (child_yang_name == "reverse-ero-error-standby-reopt"):
                            if (self.reverse_ero_error_standby_reopt is None):
                                self.reverse_ero_error_standby_reopt = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                                self.reverse_ero_error_standby_reopt.parent = self
                                self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                            return self.reverse_ero_error_standby_reopt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "reverse-ero-error-current" or name == "reverse-ero-error-reopt" or name == "reverse-ero-error-standby" or name == "reverse-ero-error-standby-reopt" or name == "reverse-bandwidth" or name == "reverse-bandwidth-standby"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "reverse-bandwidth"):
                            self.reverse_bandwidth = value
                            self.reverse_bandwidth.value_namespace = name_space
                            self.reverse_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-bandwidth-standby"):
                            self.reverse_bandwidth_standby = value
                            self.reverse_bandwidth_standby.value_namespace = name_space
                            self.reverse_bandwidth_standby.value_namespace_prefix = name_space_prefix


                class XroAttributeSet(Entity):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "nni-tunnel"

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._children_yang_names.add("attribute-set-union")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("tunnel_attribute_set_name",
                                        "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__setattr__(name, value)


                    class AttributeSetUnion(Entity):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"

                            self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                            self._children_yang_names.add("attribute-set-aps-pp")

                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                            self._children_yang_names.add("attribute-set-autobackup")

                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                            self._children_yang_names.add("attribute-set-automesh")

                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                            self._children_yang_names.add("attribute-set-p2mpte")

                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._children_yang_names.add("attribute-set-p2p-te")

                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                            self._children_yang_names.add("attribute-set-path-option")

                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                            self._children_yang_names.add("attribute-set-xro")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                        class AttributeSetPathOption(Entity):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\:  str
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\:  bool
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"

                                self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                self.generation = YLeaf(YType.uint32, "generation")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                self._children_yang_names.add("bfd-reverse-path")

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bandwidth_type",
                                                "configured_bandwidth",
                                                "cost_limit",
                                                "dste_class_type",
                                                "exclude_list_name",
                                                "generation",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_bfd_reverse_pat_configured",
                                                "is_cost_limit_configured",
                                                "is_exclude_list_name_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "path_invalidation_action",
                                                "path_invalidation_timeout",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class BfdReversePath(Entity):
                                """
                                BFD reverse path
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                                    self.path_type = YLeaf(YType.enumeration, "path-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("binding_label",
                                                    "path_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.binding_label.is_set or
                                        self.path_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.binding_label.yfilter != YFilter.not_set or
                                        self.path_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding-label" or name == "path-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "binding-label"):
                                        self.binding_label = value
                                        self.binding_label.value_namespace = name_space
                                        self.binding_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-type"):
                                        self.path_type = value
                                        self.path_type.value_namespace = name_space
                                        self.path_type.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class VersionInfo(Entity):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\:  str
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.attribute_type = YLeaf(YType.str, "attribute-type")

                                    self.generation = YLeaf(YType.uint32, "generation")

                                    self.is_default = YLeaf(YType.boolean, "is-default")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute_type",
                                                    "generation",
                                                    "is_default") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute_type.is_set or
                                        self.generation.is_set or
                                        self.is_default.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute_type.yfilter != YFilter.not_set or
                                        self.generation.yfilter != YFilter.not_set or
                                        self.is_default.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "version-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                    if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.generation.get_name_leafdata())
                                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_default.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute-type"):
                                        self.attribute_type = value
                                        self.attribute_type.value_namespace = name_space
                                        self.attribute_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "generation"):
                                        self.generation = value
                                        self.generation.value_namespace = name_space
                                        self.generation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-default"):
                                        self.is_default = value
                                        self.is_default.value_namespace = name_space
                                        self.is_default.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bandwidth_type.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.cost_limit.is_set or
                                    self.dste_class_type.is_set or
                                    self.exclude_list_name.is_set or
                                    self.generation.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_bfd_reverse_pat_configured.is_set or
                                    self.is_cost_limit_configured.is_set or
                                    self.is_exclude_list_name_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.path_invalidation_action.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bandwidth_type.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.cost_limit.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.exclude_list_name.yfilter != YFilter.not_set or
                                    self.generation.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                    self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                    self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "bfd-reverse-path"):
                                    if (self.bfd_reverse_path is None):
                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                    return self.bfd_reverse_path

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                if (child_yang_name == "version-info"):
                                    for c in self.version_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.version_info.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bandwidth-type"):
                                    self.bandwidth_type = value
                                    self.bandwidth_type.value_namespace = name_space
                                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "cost-limit"):
                                    self.cost_limit = value
                                    self.cost_limit.value_namespace = name_space
                                    self.cost_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "exclude-list-name"):
                                    self.exclude_list_name = value
                                    self.exclude_list_name.value_namespace = name_space
                                    self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "generation"):
                                    self.generation = value
                                    self.generation.value_namespace = name_space
                                    self.generation.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bfd-reverse-pat-configured"):
                                    self.is_bfd_reverse_pat_configured = value
                                    self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                    self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-cost-limit-configured"):
                                    self.is_cost_limit_configured = value
                                    self.is_cost_limit_configured.value_namespace = name_space
                                    self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-exclude-list-name-configured"):
                                    self.is_exclude_list_name_configured = value
                                    self.is_exclude_list_name_configured.value_namespace = name_space
                                    self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-action"):
                                    self.path_invalidation_action = value
                                    self.path_invalidation_action.value_namespace = name_space
                                    self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutobackup(Entity):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                                self._children_yang_names.add("signalled-name")

                                self.policy_class_entry = YList(self)
                                self.protected_interface = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_priority",
                                                "is_affinity_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "is_signalled_name_configured",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                            class SignalledName(Entity):
                                """
                                Signalled name
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\:  bool
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\:  str
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                    self.name = YLeaf(YType.str, "name")

                                    self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                    self.source_type = YLeaf(YType.enumeration, "source-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_mp_addresses",
                                                    "name",
                                                    "protected_interface_type",
                                                    "source_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_mp_addresses.is_set or
                                        self.name.is_set or
                                        self.protected_interface_type.is_set or
                                        self.source_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_mp_addresses.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set or
                                        self.protected_interface_type.yfilter != YFilter.not_set or
                                        self.source_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalled-name" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())
                                    if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                    if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-mp-addresses"):
                                        self.is_mp_addresses = value
                                        self.is_mp_addresses.value_namespace = name_space
                                        self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protected-interface-type"):
                                        self.protected_interface_type = value
                                        self.protected_interface_type.value_namespace = name_space
                                        self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-type"):
                                        self.source_type = value
                                        self.source_type.value_namespace = name_space
                                        self.source_type.value_namespace_prefix = name_space_prefix


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ProtectedInterface(Entity):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.protected_interface = YLeaf(YType.str, "protected-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("protected_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.protected_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.protected_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protected-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protected-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "protected-interface"):
                                        self.protected_interface = value
                                        self.protected_interface.value_namespace = name_space
                                        self.protected_interface.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.is_signalled_name_configured.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.signalled_name is not None and self.signalled_name.has_data()))

                            def has_operation(self):
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.signalled_name is not None and self.signalled_name.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-autobackup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "protected-interface"):
                                    for c in self.protected_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protected_interface.append(c)
                                    return c

                                if (child_yang_name == "signalled-name"):
                                    if (self.signalled_name is None):
                                        self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                    return self.signalled_name

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-signalled-name-configured"):
                                    self.is_signalled_name_configured = value
                                    self.is_signalled_name_configured.value_namespace = name_space
                                    self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutomesh(Entity):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\:  bool
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\:  bool
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\:  bool
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"

                                self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.forward_class = YLeaf(YType.uint32, "forward-class")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.load_share = YLeaf(YType.uint32, "load-share")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.mesh_group_id = YList(self)
                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_bandwidth_collect",
                                                "auto_route_announce",
                                                "bandwidth",
                                                "configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "forward_class",
                                                "frr_bandwidth_protection",
                                                "frr_node_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_interface_bw_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "load_share",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority",
                                                "soft_preemption_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class MeshGroupId(Entity):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mesh-group-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.mesh_group_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.auto_bandwidth_collect.is_set or
                                    self.auto_route_announce.is_set or
                                    self.bandwidth.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.forward_class.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.frr_node_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_interface_bw_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.load_share.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    self.soft_preemption_configured.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()))

                            def has_operation(self):
                                for c in self.mesh_group_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                    self.auto_route_announce.yfilter != YFilter.not_set or
                                    self.bandwidth.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.forward_class.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.frr_node_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.load_share.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    self.soft_preemption_configured.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-automesh" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_class.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.load_share.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "mesh-group-id"):
                                    for c in self.mesh_group_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.mesh_group_id.append(c)
                                    return c

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-bandwidth-collect"):
                                    self.auto_bandwidth_collect = value
                                    self.auto_bandwidth_collect.value_namespace = name_space
                                    self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-route-announce"):
                                    self.auto_route_announce = value
                                    self.auto_route_announce.value_namespace = name_space
                                    self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                if(value_path == "bandwidth"):
                                    self.bandwidth = value
                                    self.bandwidth.value_namespace = name_space
                                    self.bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-class"):
                                    self.forward_class = value
                                    self.forward_class.value_namespace = name_space
                                    self.forward_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-node-protection"):
                                    self.frr_node_protection = value
                                    self.frr_node_protection.value_namespace = name_space
                                    self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-bw-configured"):
                                    self.is_interface_bw_configured = value
                                    self.is_interface_bw_configured.value_namespace = name_space
                                    self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "load-share"):
                                    self.load_share = value
                                    self.load_share.value_namespace = name_space
                                    self.load_share.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-configured"):
                                    self.soft_preemption_configured = value
                                    self.soft_preemption_configured.value_namespace = name_space
                                    self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                        class AttributeSetXro(Entity):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"

                                self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._children_yang_names.add("xro")


                            class Xro(Entity):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\:  bool
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"

                                    self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                    self.xro_subobject = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("mutual_diversity_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                class XroSubobject(Entity):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                        self._children_yang_names.add("as-subobject")

                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        self._children_yang_names.add("ipv4-subobject")

                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        self._children_yang_names.add("ipv6-subobject")

                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._children_yang_names.add("lsp-subobject")

                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        self._children_yang_names.add("srlg-subobject")

                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        self._children_yang_names.add("unnumbered-subobject")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                    class Ipv4Subobject(Entity):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv4-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class Ipv6Subobject(Entity):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv6-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class UnnumberedSubobject(Entity):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.interface_id = YLeaf(YType.uint32, "interface-id")

                                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute",
                                                            "exclusion_type",
                                                            "interface_id",
                                                            "te_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.interface_id.is_set or
                                                self.te_router_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.interface_id.yfilter != YFilter.not_set or
                                                self.te_router_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unnumbered-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_id.get_name_leafdata())
                                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-id"):
                                                self.interface_id = value
                                                self.interface_id.value_namespace = name_space
                                                self.interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-router-id"):
                                                self.te_router_id = value
                                                self.te_router_id.value_namespace = name_space
                                                self.te_router_id.value_namespace_prefix = name_space_prefix


                                    class AsSubobject(Entity):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.as_number = YLeaf(YType.uint16, "as-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("as_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.as_number.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.as_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "as-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "as-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "as-number"):
                                                self.as_number = value
                                                self.as_number.value_namespace = name_space
                                                self.as_number.value_namespace_prefix = name_space_prefix


                                    class SrlgSubobject(Entity):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("exclusion_type",
                                                            "srlg_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.exclusion_type.is_set or
                                                self.srlg_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.srlg_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "srlg-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "exclusion-type" or name == "srlg-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "srlg-id"):
                                                self.srlg_id = value
                                                self.srlg_id.value_namespace = name_space
                                                self.srlg_id.value_namespace_prefix = name_space_prefix


                                    class LspSubobject(Entity):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\:  bool
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                            self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                            self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                            self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._children_yang_names.add("fec")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("destination_node_exception",
                                                            "exclusion_type",
                                                            "ignore_lsp_id",
                                                            "penultimate_node_exception",
                                                            "processing_node_exception") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                        class Fec(Entity):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"

                                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                self.fec_source = YLeaf(YType.str, "fec-source")

                                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._children_yang_names.add("fec-destination-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_extended_tunnel_id",
                                                                "fec_lsp_id",
                                                                "fec_source",
                                                                "fec_tunnel_id",
                                                                "fec_vrf") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                            class FecDestinationInfo(Entity):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"

                                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("fec_ctype",
                                                                    "fec_destination_p2mp_id",
                                                                    "p2p_lsp_destination") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.fec_ctype.is_set or
                                                        self.fec_destination_p2mp_id.is_set or
                                                        self.p2p_lsp_destination.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.fec_ctype.yfilter != YFilter.not_set or
                                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "fec-destination-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "fec-ctype"):
                                                        self.fec_ctype = value
                                                        self.fec_ctype.value_namespace = name_space
                                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fec-destination-p2mp-id"):
                                                        self.fec_destination_p2mp_id = value
                                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "p2p-lsp-destination"):
                                                        self.p2p_lsp_destination = value
                                                        self.p2p_lsp_destination.value_namespace = name_space
                                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.fec_extended_tunnel_id.is_set or
                                                    self.fec_lsp_id.is_set or
                                                    self.fec_source.is_set or
                                                    self.fec_tunnel_id.is_set or
                                                    self.fec_vrf.is_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                                    self.fec_source.yfilter != YFilter.not_set or
                                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_vrf.yfilter != YFilter.not_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "fec-destination-info"):
                                                    if (self.fec_destination_info is None):
                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                    return self.fec_destination_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-extended-tunnel-id"):
                                                    self.fec_extended_tunnel_id = value
                                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-lsp-id"):
                                                    self.fec_lsp_id = value
                                                    self.fec_lsp_id.value_namespace = name_space
                                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-source"):
                                                    self.fec_source = value
                                                    self.fec_source.value_namespace = name_space
                                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-tunnel-id"):
                                                    self.fec_tunnel_id = value
                                                    self.fec_tunnel_id.value_namespace = name_space
                                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-vrf"):
                                                    self.fec_vrf = value
                                                    self.fec_vrf.value_namespace = name_space
                                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.destination_node_exception.is_set or
                                                self.exclusion_type.is_set or
                                                self.ignore_lsp_id.is_set or
                                                self.penultimate_node_exception.is_set or
                                                self.processing_node_exception.is_set or
                                                (self.fec is not None and self.fec.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.destination_node_exception.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                self.processing_node_exception.yfilter != YFilter.not_set or
                                                (self.fec is not None and self.fec.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsp-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                            if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                            if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec"):
                                                if (self.fec is None):
                                                    self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                return self.fec

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "destination-node-exception"):
                                                self.destination_node_exception = value
                                                self.destination_node_exception.value_namespace = name_space
                                                self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ignore-lsp-id"):
                                                self.ignore_lsp_id = value
                                                self.ignore_lsp_id.value_namespace = name_space
                                                self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "penultimate-node-exception"):
                                                self.penultimate_node_exception = value
                                                self.penultimate_node_exception.value_namespace = name_space
                                                self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "processing-node-exception"):
                                                self.processing_node_exception = value
                                                self.processing_node_exception.value_namespace = name_space
                                                self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.type.is_set or
                                            (self.as_subobject is not None and self.as_subobject.has_data()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set or
                                            (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "xro-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "as-subobject"):
                                            if (self.as_subobject is None):
                                                self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                            return self.as_subobject

                                        if (child_yang_name == "ipv4-subobject"):
                                            if (self.ipv4_subobject is None):
                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                            return self.ipv4_subobject

                                        if (child_yang_name == "ipv6-subobject"):
                                            if (self.ipv6_subobject is None):
                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                            return self.ipv6_subobject

                                        if (child_yang_name == "lsp-subobject"):
                                            if (self.lsp_subobject is None):
                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                            return self.lsp_subobject

                                        if (child_yang_name == "srlg-subobject"):
                                            if (self.srlg_subobject is None):
                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                            return self.srlg_subobject

                                        if (child_yang_name == "unnumbered-subobject"):
                                            if (self.unnumbered_subobject is None):
                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                            return self.unnumbered_subobject

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.xro_subobject:
                                        if (c.has_data()):
                                            return True
                                    return self.mutual_diversity_flag.is_set

                                def has_operation(self):
                                    for c in self.xro_subobject:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "xro-subobject"):
                                        for c in self.xro_subobject:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.xro_subobject.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "mutual-diversity-flag"):
                                        self.mutual_diversity_flag = value
                                        self.mutual_diversity_flag.value_namespace = name_space
                                        self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.xro is not None and self.xro.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.xro is not None and self.xro.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro"):
                                    if (self.xro is None):
                                        self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                    return self.xro

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class AttributeSetP2Mpte(Entity):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "frr_bandwidth_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_priority_configured",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2mpte" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetApsPp(Entity):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-aps-pp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                        class AttributeSetP2PTe(Entity):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                                self._children_yang_names.add("prepend-list")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_affinity_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_path_select_configured",
                                                "is_path_selection_metric_configured",
                                                "is_path_selection_segment_routing_adjacency_protection_configured",
                                                "is_path_selection_segment_routing_margin_configured",
                                                "is_path_selection_segment_routing_margin_relative",
                                                "is_path_selection_segment_routing_segment_limit_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "is_prepend_list_configured",
                                                "path_invalidation_timeout",
                                                "path_selection_invalidation_action",
                                                "path_selection_metric",
                                                "path_selection_segment_routing_adjacency_protection",
                                                "path_selection_segment_routing_margin",
                                                "path_selection_segment_routing_segment_limit",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PrependList(Entity):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.prepend_entry = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                class PrependEntry(Entity):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.next_label = YLeaf(YType.uint32, "next-label")

                                        self.type = YLeaf(YType.enumeration, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("index",
                                                        "next_label",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.index.is_set or
                                            self.next_label.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.next_label.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prepend-entry" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_label.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "index" or name == "next-label" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-label"):
                                            self.next_label = value
                                            self.next_label.value_namespace = name_space
                                            self.next_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.prepend_entry:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.prepend_entry:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "prepend-list" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "prepend-entry"):
                                        for c in self.prepend_entry:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.prepend_entry.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prepend-entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_affinity_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_path_select_configured.is_set or
                                    self.is_path_selection_metric_configured.is_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_relative.is_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.is_prepend_list_configured.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.path_selection_invalidation_action.is_set or
                                    self.path_selection_metric.is_set or
                                    self.path_selection_segment_routing_adjacency_protection.is_set or
                                    self.path_selection_segment_routing_margin.is_set or
                                    self.path_selection_segment_routing_segment_limit.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.prepend_list is not None and self.prepend_list.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_path_select_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_selection_metric.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.prepend_list is not None and self.prepend_list.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2p-te" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "prepend-list"):
                                    if (self.prepend_list is None):
                                        self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                    return self.prepend_list

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-select-configured"):
                                    self.is_path_select_configured = value
                                    self.is_path_select_configured.value_namespace = name_space
                                    self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-metric-configured"):
                                    self.is_path_selection_metric_configured = value
                                    self.is_path_selection_metric_configured.value_namespace = name_space
                                    self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                    self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                    self.is_path_selection_segment_routing_margin_configured = value
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                    self.is_path_selection_segment_routing_margin_relative = value
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                    self.is_path_selection_segment_routing_segment_limit_configured = value
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-prepend-list-configured"):
                                    self.is_prepend_list_configured = value
                                    self.is_prepend_list_configured.value_namespace = name_space
                                    self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-invalidation-action"):
                                    self.path_selection_invalidation_action = value
                                    self.path_selection_invalidation_action.value_namespace = name_space
                                    self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-metric"):
                                    self.path_selection_metric = value
                                    self.path_selection_metric.value_namespace = name_space
                                    self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                    self.path_selection_segment_routing_adjacency_protection = value
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-margin"):
                                    self.path_selection_segment_routing_margin = value
                                    self.path_selection_segment_routing_margin.value_namespace = name_space
                                    self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-segment-limit"):
                                    self.path_selection_segment_routing_segment_limit = value
                                    self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                    self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tunnel_attribute_set_type.is_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attribute-set-union" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set-aps-pp"):
                                if (self.attribute_set_aps_pp is None):
                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                return self.attribute_set_aps_pp

                            if (child_yang_name == "attribute-set-autobackup"):
                                if (self.attribute_set_autobackup is None):
                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                return self.attribute_set_autobackup

                            if (child_yang_name == "attribute-set-automesh"):
                                if (self.attribute_set_automesh is None):
                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                return self.attribute_set_automesh

                            if (child_yang_name == "attribute-set-p2mpte"):
                                if (self.attribute_set_p2mpte is None):
                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                return self.attribute_set_p2mpte

                            if (child_yang_name == "attribute-set-p2p-te"):
                                if (self.attribute_set_p2p_te is None):
                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                return self.attribute_set_p2p_te

                            if (child_yang_name == "attribute-set-path-option"):
                                if (self.attribute_set_path_option is None):
                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                return self.attribute_set_path_option

                            if (child_yang_name == "attribute-set-xro"):
                                if (self.attribute_set_xro is None):
                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                return self.attribute_set_xro

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-attribute-set-type"):
                                self.tunnel_attribute_set_type = value
                                self.tunnel_attribute_set_type.value_namespace = name_space
                                self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.tunnel_attribute_set_name.is_set or
                            self.tunnel_attribute_set_name_crc32.is_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "xro-attribute-set" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attribute-set-union"):
                            if (self.attribute_set_union is None):
                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                            return self.attribute_set_union

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name-crc32"):
                            self.tunnel_attribute_set_name_crc32 = value
                            self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                            self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                class TeTunnelConvergence(Entity):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp>`
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "nni-tunnel"

                        self.binding_label_rewrite_time = YLeaf(YType.uint64, "binding-label-rewrite-time")

                        self.convergence_complete_time = YLeaf(YType.uint64, "convergence-complete-time")

                        self.frr_trigger_time = YLeaf(YType.uint64, "frr-trigger-time")

                        self.is_convergence_in_progress = YLeaf(YType.boolean, "is-convergence-in-progress")

                        self.pcalc_complete_time = YLeaf(YType.uint64, "pcalc-complete-time")

                        self.vif_creation_time = YLeaf(YType.uint64, "vif-creation-time")

                        self.convergence_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._children_yang_names.add("convergence-lsp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("binding_label_rewrite_time",
                                        "convergence_complete_time",
                                        "frr_trigger_time",
                                        "is_convergence_in_progress",
                                        "pcalc_complete_time",
                                        "vif_creation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__setattr__(name, value)


                    class ConvergenceLsp(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "convergence-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.binding_label_rewrite_time.is_set or
                            self.convergence_complete_time.is_set or
                            self.frr_trigger_time.is_set or
                            self.is_convergence_in_progress.is_set or
                            self.pcalc_complete_time.is_set or
                            self.vif_creation_time.is_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.binding_label_rewrite_time.yfilter != YFilter.not_set or
                            self.convergence_complete_time.yfilter != YFilter.not_set or
                            self.frr_trigger_time.yfilter != YFilter.not_set or
                            self.is_convergence_in_progress.yfilter != YFilter.not_set or
                            self.pcalc_complete_time.yfilter != YFilter.not_set or
                            self.vif_creation_time.yfilter != YFilter.not_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-tunnel-convergence" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.binding_label_rewrite_time.is_set or self.binding_label_rewrite_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_label_rewrite_time.get_name_leafdata())
                        if (self.convergence_complete_time.is_set or self.convergence_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.convergence_complete_time.get_name_leafdata())
                        if (self.frr_trigger_time.is_set or self.frr_trigger_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_trigger_time.get_name_leafdata())
                        if (self.is_convergence_in_progress.is_set or self.is_convergence_in_progress.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_convergence_in_progress.get_name_leafdata())
                        if (self.pcalc_complete_time.is_set or self.pcalc_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_complete_time.get_name_leafdata())
                        if (self.vif_creation_time.is_set or self.vif_creation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vif_creation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "convergence-lsp"):
                            if (self.convergence_lsp is None):
                                self.convergence_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                                self.convergence_lsp.parent = self
                                self._children_name_map["convergence_lsp"] = "convergence-lsp"
                            return self.convergence_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "convergence-lsp" or name == "binding-label-rewrite-time" or name == "convergence-complete-time" or name == "frr-trigger-time" or name == "is-convergence-in-progress" or name == "pcalc-complete-time" or name == "vif-creation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "binding-label-rewrite-time"):
                            self.binding_label_rewrite_time = value
                            self.binding_label_rewrite_time.value_namespace = name_space
                            self.binding_label_rewrite_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "convergence-complete-time"):
                            self.convergence_complete_time = value
                            self.convergence_complete_time.value_namespace = name_space
                            self.convergence_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-trigger-time"):
                            self.frr_trigger_time = value
                            self.frr_trigger_time.value_namespace = name_space
                            self.frr_trigger_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-convergence-in-progress"):
                            self.is_convergence_in_progress = value
                            self.is_convergence_in_progress.value_namespace = name_space
                            self.is_convergence_in_progress.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-complete-time"):
                            self.pcalc_complete_time = value
                            self.pcalc_complete_time.value_namespace = name_space
                            self.pcalc_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "vif-creation-time"):
                            self.vif_creation_time = value
                            self.vif_creation_time.value_namespace = name_space
                            self.vif_creation_time.value_namespace_prefix = name_space_prefix


                class FlexInfo(Entity):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\:  bool
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\:  bool
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\:  bool
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\:  bool
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\:  bool
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:   :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                        self.fault_in_label = YLeaf(YType.uint32, "fault-in-label")

                        self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                        self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                        self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                        self.fault_time = YLeaf(YType.uint32, "fault-time")

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_lsp_id = YLeaf(YType.uint16, "lockout-lsp-id")

                        self.lockout_timestamp = YLeaf(YType.uint32, "lockout-timestamp")

                        self.origination = YLeaf(YType.enumeration, "origination")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fault_ais",
                                        "fault_in_label",
                                        "fault_ldi",
                                        "fault_ldi_lockout",
                                        "fault_lkr",
                                        "fault_time",
                                        "is_lockout",
                                        "lockout_lsp_id",
                                        "lockout_timestamp",
                                        "origination") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.fault_ais.is_set or
                            self.fault_in_label.is_set or
                            self.fault_ldi.is_set or
                            self.fault_ldi_lockout.is_set or
                            self.fault_lkr.is_set or
                            self.fault_time.is_set or
                            self.is_lockout.is_set or
                            self.lockout_lsp_id.is_set or
                            self.lockout_timestamp.is_set or
                            self.origination.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fault_ais.yfilter != YFilter.not_set or
                            self.fault_in_label.yfilter != YFilter.not_set or
                            self.fault_ldi.yfilter != YFilter.not_set or
                            self.fault_ldi_lockout.yfilter != YFilter.not_set or
                            self.fault_lkr.yfilter != YFilter.not_set or
                            self.fault_time.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_lsp_id.yfilter != YFilter.not_set or
                            self.lockout_timestamp.yfilter != YFilter.not_set or
                            self.origination.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flex-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ais.get_name_leafdata())
                        if (self.fault_in_label.is_set or self.fault_in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_in_label.get_name_leafdata())
                        if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                        if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                        if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                        if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_time.get_name_leafdata())
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_lsp_id.is_set or self.lockout_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_lsp_id.get_name_leafdata())
                        if (self.lockout_timestamp.is_set or self.lockout_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_timestamp.get_name_leafdata())
                        if (self.origination.is_set or self.origination.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.origination.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fault-ais" or name == "fault-in-label" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "is-lockout" or name == "lockout-lsp-id" or name == "lockout-timestamp" or name == "origination"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fault-ais"):
                            self.fault_ais = value
                            self.fault_ais.value_namespace = name_space
                            self.fault_ais.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-in-label"):
                            self.fault_in_label = value
                            self.fault_in_label.value_namespace = name_space
                            self.fault_in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi"):
                            self.fault_ldi = value
                            self.fault_ldi.value_namespace = name_space
                            self.fault_ldi.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi-lockout"):
                            self.fault_ldi_lockout = value
                            self.fault_ldi_lockout.value_namespace = name_space
                            self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-lkr"):
                            self.fault_lkr = value
                            self.fault_lkr.value_namespace = name_space
                            self.fault_lkr.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-time"):
                            self.fault_time = value
                            self.fault_time.value_namespace = name_space
                            self.fault_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-lsp-id"):
                            self.lockout_lsp_id = value
                            self.lockout_lsp_id.value_namespace = name_space
                            self.lockout_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-timestamp"):
                            self.lockout_timestamp = value
                            self.lockout_timestamp.value_namespace = name_space
                            self.lockout_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "origination"):
                            self.origination = value
                            self.origination.value_namespace = name_space
                            self.origination.value_namespace_prefix = name_space_prefix


                class Destination(Entity):
                    """
                    Destinations array
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionCause>`
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:   :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:   :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization>`
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\:  bool
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of    :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption>`
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of    :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry>`
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\:  bool
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\:  bool
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "nni-tunnel"

                        self.active_path_option_index = YLeaf(YType.uint32, "active-path-option-index")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.destination_deletion_cause = YLeaf(YType.enumeration, "destination-deletion-cause")

                        self.destination_deletion_sub_cause = YLeaf(YType.enumeration, "destination-deletion-sub-cause")

                        self.destination_deletion_timestamp = YLeaf(YType.uint32, "destination-deletion-timestamp")

                        self.destination_state = YLeaf(YType.enumeration, "destination-state")

                        self.is_inter_area = YLeaf(YType.boolean, "is-inter-area")

                        self.path_change_time = YLeaf(YType.uint32, "path-change-time")

                        self.path_option_exhausted = YLeaf(YType.boolean, "path-option-exhausted")

                        self.s2l_exist = YLeaf(YType.boolean, "s2l-exist")

                        self.total_uptime = YLeaf(YType.uint32, "total-uptime")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.inter_area_reoptimization = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                        self._children_yang_names.add("inter-area-reoptimization")

                        self.path_option = YList(self)
                        self.path_option_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("active_path_option_index",
                                        "destination_address",
                                        "destination_deletion_cause",
                                        "destination_deletion_sub_cause",
                                        "destination_deletion_timestamp",
                                        "destination_state",
                                        "is_inter_area",
                                        "path_change_time",
                                        "path_option_exhausted",
                                        "s2l_exist",
                                        "total_uptime",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__setattr__(name, value)


                    class InterAreaReoptimization(Entity):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"

                            self.preferred_path_error_node = YLeaf(YType.str, "preferred-path-error-node")

                            self.preferred_tree_error_node = YLeaf(YType.str, "preferred-tree-error-node")

                            self.received_preferred_path_errors = YLeaf(YType.uint16, "received-preferred-path-errors")

                            self.received_preferred_tree_errors = YLeaf(YType.uint16, "received-preferred-tree-errors")

                            self.sent_path_queries = YLeaf(YType.uint16, "sent-path-queries")

                            self.time_since_last_preferred_path_error = YLeaf(YType.uint32, "time-since-last-preferred-path-error")

                            self.time_since_last_preferred_tree_error = YLeaf(YType.uint32, "time-since-last-preferred-tree-error")

                            self.time_since_last_query_sent = YLeaf(YType.uint32, "time-since-last-query-sent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preferred_path_error_node",
                                            "preferred_tree_error_node",
                                            "received_preferred_path_errors",
                                            "received_preferred_tree_errors",
                                            "sent_path_queries",
                                            "time_since_last_preferred_path_error",
                                            "time_since_last_preferred_tree_error",
                                            "time_since_last_query_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preferred_path_error_node.is_set or
                                self.preferred_tree_error_node.is_set or
                                self.received_preferred_path_errors.is_set or
                                self.received_preferred_tree_errors.is_set or
                                self.sent_path_queries.is_set or
                                self.time_since_last_preferred_path_error.is_set or
                                self.time_since_last_preferred_tree_error.is_set or
                                self.time_since_last_query_sent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preferred_path_error_node.yfilter != YFilter.not_set or
                                self.preferred_tree_error_node.yfilter != YFilter.not_set or
                                self.received_preferred_path_errors.yfilter != YFilter.not_set or
                                self.received_preferred_tree_errors.yfilter != YFilter.not_set or
                                self.sent_path_queries.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_error.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set or
                                self.time_since_last_query_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "inter-area-reoptimization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preferred_path_error_node.is_set or self.preferred_path_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_path_error_node.get_name_leafdata())
                            if (self.preferred_tree_error_node.is_set or self.preferred_tree_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_tree_error_node.get_name_leafdata())
                            if (self.received_preferred_path_errors.is_set or self.received_preferred_path_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_path_errors.get_name_leafdata())
                            if (self.received_preferred_tree_errors.is_set or self.received_preferred_tree_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_tree_errors.get_name_leafdata())
                            if (self.sent_path_queries.is_set or self.sent_path_queries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sent_path_queries.get_name_leafdata())
                            if (self.time_since_last_preferred_path_error.is_set or self.time_since_last_preferred_path_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_error.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_error.is_set or self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_error.get_name_leafdata())
                            if (self.time_since_last_query_sent.is_set or self.time_since_last_query_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preferred-path-error-node" or name == "preferred-tree-error-node" or name == "received-preferred-path-errors" or name == "received-preferred-tree-errors" or name == "sent-path-queries" or name == "time-since-last-preferred-path-error" or name == "time-since-last-preferred-tree-error" or name == "time-since-last-query-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preferred-path-error-node"):
                                self.preferred_path_error_node = value
                                self.preferred_path_error_node.value_namespace = name_space
                                self.preferred_path_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "preferred-tree-error-node"):
                                self.preferred_tree_error_node = value
                                self.preferred_tree_error_node.value_namespace = name_space
                                self.preferred_tree_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-path-errors"):
                                self.received_preferred_path_errors = value
                                self.received_preferred_path_errors.value_namespace = name_space
                                self.received_preferred_path_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-tree-errors"):
                                self.received_preferred_tree_errors = value
                                self.received_preferred_tree_errors.value_namespace = name_space
                                self.received_preferred_tree_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "sent-path-queries"):
                                self.sent_path_queries = value
                                self.sent_path_queries.value_namespace = name_space
                                self.sent_path_queries.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-error"):
                                self.time_since_last_preferred_path_error = value
                                self.time_since_last_preferred_path_error.value_namespace = name_space
                                self.time_since_last_preferred_path_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-error"):
                                self.time_since_last_preferred_tree_error = value
                                self.time_since_last_preferred_tree_error.value_namespace = name_space
                                self.time_since_last_preferred_tree_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-sent"):
                                self.time_since_last_query_sent = value
                                self.time_since_last_query_sent.value_namespace = name_space
                                self.time_since_last_query_sent.value_namespace_prefix = name_space_prefix


                    class PathOptionEntry(Entity):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class PathOption(Entity):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.path_option:
                            if (c.has_data()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.active_path_option_index.is_set or
                            self.destination_address.is_set or
                            self.destination_deletion_cause.is_set or
                            self.destination_deletion_sub_cause.is_set or
                            self.destination_deletion_timestamp.is_set or
                            self.destination_state.is_set or
                            self.is_inter_area.is_set or
                            self.path_change_time.is_set or
                            self.path_option_exhausted.is_set or
                            self.s2l_exist.is_set or
                            self.total_uptime.is_set or
                            self.uptime.is_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_data()))

                    def has_operation(self):
                        for c in self.path_option:
                            if (c.has_operation()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.active_path_option_index.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.destination_deletion_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_sub_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_timestamp.yfilter != YFilter.not_set or
                            self.destination_state.yfilter != YFilter.not_set or
                            self.is_inter_area.yfilter != YFilter.not_set or
                            self.path_change_time.yfilter != YFilter.not_set or
                            self.path_option_exhausted.yfilter != YFilter.not_set or
                            self.s2l_exist.yfilter != YFilter.not_set or
                            self.total_uptime.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.active_path_option_index.is_set or self.active_path_option_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active_path_option_index.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.destination_deletion_cause.is_set or self.destination_deletion_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_cause.get_name_leafdata())
                        if (self.destination_deletion_sub_cause.is_set or self.destination_deletion_sub_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_sub_cause.get_name_leafdata())
                        if (self.destination_deletion_timestamp.is_set or self.destination_deletion_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_timestamp.get_name_leafdata())
                        if (self.destination_state.is_set or self.destination_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_state.get_name_leafdata())
                        if (self.is_inter_area.is_set or self.is_inter_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_inter_area.get_name_leafdata())
                        if (self.path_change_time.is_set or self.path_change_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_change_time.get_name_leafdata())
                        if (self.path_option_exhausted.is_set or self.path_option_exhausted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_option_exhausted.get_name_leafdata())
                        if (self.s2l_exist.is_set or self.s2l_exist.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_exist.get_name_leafdata())
                        if (self.total_uptime.is_set or self.total_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_uptime.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "inter-area-reoptimization"):
                            if (self.inter_area_reoptimization is None):
                                self.inter_area_reoptimization = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                                self.inter_area_reoptimization.parent = self
                                self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                            return self.inter_area_reoptimization

                        if (child_yang_name == "path-option"):
                            for c in self.path_option:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option.append(c)
                            return c

                        if (child_yang_name == "path-option-entry"):
                            for c in self.path_option_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "inter-area-reoptimization" or name == "path-option" or name == "path-option-entry" or name == "active-path-option-index" or name == "destination-address" or name == "destination-deletion-cause" or name == "destination-deletion-sub-cause" or name == "destination-deletion-timestamp" or name == "destination-state" or name == "is-inter-area" or name == "path-change-time" or name == "path-option-exhausted" or name == "s2l-exist" or name == "total-uptime" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "active-path-option-index"):
                            self.active_path_option_index = value
                            self.active_path_option_index.value_namespace = name_space
                            self.active_path_option_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-cause"):
                            self.destination_deletion_cause = value
                            self.destination_deletion_cause.value_namespace = name_space
                            self.destination_deletion_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-sub-cause"):
                            self.destination_deletion_sub_cause = value
                            self.destination_deletion_sub_cause.value_namespace = name_space
                            self.destination_deletion_sub_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-timestamp"):
                            self.destination_deletion_timestamp = value
                            self.destination_deletion_timestamp.value_namespace = name_space
                            self.destination_deletion_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-state"):
                            self.destination_state = value
                            self.destination_state.value_namespace = name_space
                            self.destination_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-inter-area"):
                            self.is_inter_area = value
                            self.is_inter_area.value_namespace = name_space
                            self.is_inter_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-change-time"):
                            self.path_change_time = value
                            self.path_change_time.value_namespace = name_space
                            self.path_change_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-option-exhausted"):
                            self.path_option_exhausted = value
                            self.path_option_exhausted.value_namespace = name_space
                            self.path_option_exhausted.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-exist"):
                            self.s2l_exist = value
                            self.s2l_exist.value_namespace = name_space
                            self.s2l_exist.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-uptime"):
                            self.total_uptime = value
                            self.total_uptime.value_namespace = name_space
                            self.total_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.admin_state.is_set or
                        self.affinity_failure_delayed_tear_time_remained.is_set or
                        self.affinity_failure_reopt_disabled.is_set or
                        self.affinity_failure_reopt_time_remained.is_set or
                        self.area_id.is_set or
                        self.auto_route.is_set or
                        self.autoroute_announce_exclude_segment_routing.is_set or
                        self.bandwidth_requested.is_set or
                        self.bandwidth_type.is_set or
                        self.binding_label.is_set or
                        self.binding_label_exists.is_set or
                        self.create_time.is_set or
                        self.destination_disabled_count.is_set or
                        self.destination_down_count.is_set or
                        self.destination_up_count.is_set or
                        self.drop_mode.is_set or
                        self.explicit_path_change.is_set or
                        self.fail_reason.is_set or
                        self.forwarding_adjacency.is_set or
                        self.hop_limit_ignored_reason.is_set or
                        self.invalidation_time_remained.is_set or
                        self.is_auto_backup.is_set or
                        self.is_auto_pcc.is_set or
                        self.is_bandwidth_protect.is_set or
                        self.is_hop_limit_ignore.is_set or
                        self.is_inter_area_tunnel.is_set or
                        self.is_interface.is_set or
                        self.is_named.is_set or
                        self.is_node_protected.is_set or
                        self.is_passive.is_set or
                        self.is_pce_delegated.is_set or
                        self.last_hop_ifindex.is_set or
                        self.last_path_change.is_set or
                        self.load_share_factor.is_set or
                        self.load_share_type.is_set or
                        self.lsp_wrap_label.is_set or
                        self.lsp_wrap_protection_enabled.is_set or
                        self.metric_qualifier.is_set or
                        self.metric_type.is_set or
                        self.operational_state.is_set or
                        self.operational_state_changes.is_set or
                        self.outbound_frr_state.is_set or
                        self.passive_tunnel_name.is_set or
                        self.path_option_change.is_set or
                        self.pce_fail_reason.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.re_opt_hold_down_timer_remaining.is_set or
                        self.reroute_pending.is_set or
                        self.role_standby.is_set or
                        self.signaled_name.is_set or
                        self.snmp_index.is_set or
                        self.tie_breaker.is_set or
                        self.tiebreaker_qualifier.is_set or
                        self.tiebreaker_type.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_attribute_set_type.is_set or
                        self.tunnel_interface_name.is_set or
                        self.tunnel_recovering.is_set or
                        self.uptime.is_set or
                        self.xro_attribute_set_name.is_set or
                        (self.auto_backup is not None and self.auto_backup.has_data()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_data()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_data()) or
                        (self.bfd_info is not None and self.bfd_info.has_data()) or
                        (self.bidir is not None and self.bidir.has_data()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_data()) or
                        (self.config is not None and self.config.has_data()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_data()) or
                        (self.flex_info is not None and self.flex_info.has_data()) or
                        (self.history is not None and self.history.has_data()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_data()) or
                        (self.p2p_info is not None and self.p2p_info.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_data()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_data()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_data()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_data()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_data()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_data()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_data()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_data()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_data()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                def has_operation(self):
                    for c in self.destination:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.admin_state.yfilter != YFilter.not_set or
                        self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.auto_route.yfilter != YFilter.not_set or
                        self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set or
                        self.bandwidth_requested.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.binding_label.yfilter != YFilter.not_set or
                        self.binding_label_exists.yfilter != YFilter.not_set or
                        self.create_time.yfilter != YFilter.not_set or
                        self.destination_disabled_count.yfilter != YFilter.not_set or
                        self.destination_down_count.yfilter != YFilter.not_set or
                        self.destination_up_count.yfilter != YFilter.not_set or
                        self.drop_mode.yfilter != YFilter.not_set or
                        self.explicit_path_change.yfilter != YFilter.not_set or
                        self.fail_reason.yfilter != YFilter.not_set or
                        self.forwarding_adjacency.yfilter != YFilter.not_set or
                        self.hop_limit_ignored_reason.yfilter != YFilter.not_set or
                        self.invalidation_time_remained.yfilter != YFilter.not_set or
                        self.is_auto_backup.yfilter != YFilter.not_set or
                        self.is_auto_pcc.yfilter != YFilter.not_set or
                        self.is_bandwidth_protect.yfilter != YFilter.not_set or
                        self.is_hop_limit_ignore.yfilter != YFilter.not_set or
                        self.is_inter_area_tunnel.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_named.yfilter != YFilter.not_set or
                        self.is_node_protected.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.is_pce_delegated.yfilter != YFilter.not_set or
                        self.last_hop_ifindex.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.load_share_factor.yfilter != YFilter.not_set or
                        self.load_share_type.yfilter != YFilter.not_set or
                        self.lsp_wrap_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set or
                        self.metric_qualifier.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set or
                        self.operational_state.yfilter != YFilter.not_set or
                        self.operational_state_changes.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.passive_tunnel_name.yfilter != YFilter.not_set or
                        self.path_option_change.yfilter != YFilter.not_set or
                        self.pce_fail_reason.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set or
                        self.reroute_pending.yfilter != YFilter.not_set or
                        self.role_standby.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.snmp_index.yfilter != YFilter.not_set or
                        self.tie_breaker.yfilter != YFilter.not_set or
                        self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                        self.tiebreaker_type.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        self.tunnel_interface_name.yfilter != YFilter.not_set or
                        self.tunnel_recovering.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        self.xro_attribute_set_name.yfilter != YFilter.not_set or
                        (self.auto_backup is not None and self.auto_backup.has_operation()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_operation()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_operation()) or
                        (self.bfd_info is not None and self.bfd_info.has_operation()) or
                        (self.bidir is not None and self.bidir.has_operation()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_operation()) or
                        (self.config is not None and self.config.has_operation()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_operation()) or
                        (self.flex_info is not None and self.flex_info.has_operation()) or
                        (self.history is not None and self.history.has_operation()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_operation()) or
                        (self.p2p_info is not None and self.p2p_info.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_operation()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_operation()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_operation()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_operation()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_operation()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_operation()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_operation()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_operation()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_operation()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nni-tunnel" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/nni-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.admin_state.is_set or self.admin_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_state.get_name_leafdata())
                    if (self.affinity_failure_delayed_tear_time_remained.is_set or self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_delayed_tear_time_remained.get_name_leafdata())
                    if (self.affinity_failure_reopt_disabled.is_set or self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_disabled.get_name_leafdata())
                    if (self.affinity_failure_reopt_time_remained.is_set or self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_time_remained.get_name_leafdata())
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.auto_route.is_set or self.auto_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_route.get_name_leafdata())
                    if (self.autoroute_announce_exclude_segment_routing.is_set or self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autoroute_announce_exclude_segment_routing.get_name_leafdata())
                    if (self.bandwidth_requested.is_set or self.bandwidth_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_requested.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                    if (self.binding_label_exists.is_set or self.binding_label_exists.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label_exists.get_name_leafdata())
                    if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.create_time.get_name_leafdata())
                    if (self.destination_disabled_count.is_set or self.destination_disabled_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_disabled_count.get_name_leafdata())
                    if (self.destination_down_count.is_set or self.destination_down_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_down_count.get_name_leafdata())
                    if (self.destination_up_count.is_set or self.destination_up_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_up_count.get_name_leafdata())
                    if (self.drop_mode.is_set or self.drop_mode.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.drop_mode.get_name_leafdata())
                    if (self.explicit_path_change.is_set or self.explicit_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.explicit_path_change.get_name_leafdata())
                    if (self.fail_reason.is_set or self.fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fail_reason.get_name_leafdata())
                    if (self.forwarding_adjacency.is_set or self.forwarding_adjacency.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency.get_name_leafdata())
                    if (self.hop_limit_ignored_reason.is_set or self.hop_limit_ignored_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit_ignored_reason.get_name_leafdata())
                    if (self.invalidation_time_remained.is_set or self.invalidation_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.invalidation_time_remained.get_name_leafdata())
                    if (self.is_auto_backup.is_set or self.is_auto_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_backup.get_name_leafdata())
                    if (self.is_auto_pcc.is_set or self.is_auto_pcc.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_pcc.get_name_leafdata())
                    if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                    if (self.is_hop_limit_ignore.is_set or self.is_hop_limit_ignore.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_hop_limit_ignore.get_name_leafdata())
                    if (self.is_inter_area_tunnel.is_set or self.is_inter_area_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_inter_area_tunnel.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_named.is_set or self.is_named.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_named.get_name_leafdata())
                    if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.is_pce_delegated.is_set or self.is_pce_delegated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_delegated.get_name_leafdata())
                    if (self.last_hop_ifindex.is_set or self.last_hop_ifindex.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_hop_ifindex.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.load_share_factor.is_set or self.load_share_factor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_factor.get_name_leafdata())
                    if (self.load_share_type.is_set or self.load_share_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_type.get_name_leafdata())
                    if (self.lsp_wrap_label.is_set or self.lsp_wrap_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_enabled.is_set or self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enabled.get_name_leafdata())
                    if (self.metric_qualifier.is_set or self.metric_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_qualifier.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                    if (self.operational_state.is_set or self.operational_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state.get_name_leafdata())
                    if (self.operational_state_changes.is_set or self.operational_state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state_changes.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.passive_tunnel_name.is_set or self.passive_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.passive_tunnel_name.get_name_leafdata())
                    if (self.path_option_change.is_set or self.path_option_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_option_change.get_name_leafdata())
                    if (self.pce_fail_reason.is_set or self.pce_fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_fail_reason.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.re_opt_hold_down_timer_remaining.is_set or self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.re_opt_hold_down_timer_remaining.get_name_leafdata())
                    if (self.reroute_pending.is_set or self.reroute_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reroute_pending.get_name_leafdata())
                    if (self.role_standby.is_set or self.role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role_standby.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.snmp_index.is_set or self.snmp_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.snmp_index.get_name_leafdata())
                    if (self.tie_breaker.is_set or self.tie_breaker.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tie_breaker.get_name_leafdata())
                    if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                    if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())
                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())
                    if (self.tunnel_recovering.is_set or self.tunnel_recovering.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_recovering.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())
                    if (self.xro_attribute_set_name.is_set or self.xro_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.xro_attribute_set_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-backup"):
                        if (self.auto_backup is None):
                            self.auto_backup = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup()
                            self.auto_backup.parent = self
                            self._children_name_map["auto_backup"] = "auto-backup"
                        return self.auto_backup

                    if (child_yang_name == "auto-mesh"):
                        if (self.auto_mesh is None):
                            self.auto_mesh = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh()
                            self.auto_mesh.parent = self
                            self._children_name_map["auto_mesh"] = "auto-mesh"
                        return self.auto_mesh

                    if (child_yang_name == "auto-pcc"):
                        if (self.auto_pcc is None):
                            self.auto_pcc = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc()
                            self.auto_pcc.parent = self
                            self._children_name_map["auto_pcc"] = "auto-pcc"
                        return self.auto_pcc

                    if (child_yang_name == "bfd-info"):
                        if (self.bfd_info is None):
                            self.bfd_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo()
                            self.bfd_info.parent = self
                            self._children_name_map["bfd_info"] = "bfd-info"
                        return self.bfd_info

                    if (child_yang_name == "bidir"):
                        if (self.bidir is None):
                            self.bidir = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir()
                            self.bidir.parent = self
                            self._children_name_map["bidir"] = "bidir"
                        return self.bidir

                    if (child_yang_name == "cleaned-lsp"):
                        if (self.cleaned_lsp is None):
                            self.cleaned_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                            self.cleaned_lsp.parent = self
                            self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                        return self.cleaned_lsp

                    if (child_yang_name == "config"):
                        if (self.config is None):
                            self.config = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Config()
                            self.config.parent = self
                            self._children_name_map["config"] = "config"
                        return self.config

                    if (child_yang_name == "delay-clean-pp-lsp"):
                        if (self.delay_clean_pp_lsp is None):
                            self.delay_clean_pp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                            self.delay_clean_pp_lsp.parent = self
                            self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                        return self.delay_clean_pp_lsp

                    if (child_yang_name == "destination"):
                        for c in self.destination:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination.append(c)
                        return c

                    if (child_yang_name == "flex-info"):
                        if (self.flex_info is None):
                            self.flex_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                        return self.flex_info

                    if (child_yang_name == "history"):
                        if (self.history is None):
                            self.history = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.History()
                            self.history.parent = self
                            self._children_name_map["history"] = "history"
                        return self.history

                    if (child_yang_name == "otn-bidir"):
                        if (self.otn_bidir is None):
                            self.otn_bidir = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir()
                            self.otn_bidir.parent = self
                            self._children_name_map["otn_bidir"] = "otn-bidir"
                        return self.otn_bidir

                    if (child_yang_name == "p2p-info"):
                        if (self.p2p_info is None):
                            self.p2p_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo()
                            self.p2p_info.parent = self
                            self._children_name_map["p2p_info"] = "p2p-info"
                        return self.p2p_info

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "pce-delegation"):
                        if (self.pce_delegation is None):
                            self.pce_delegation = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation()
                            self.pce_delegation.parent = self
                            self._children_name_map["pce_delegation"] = "pce-delegation"
                        return self.pce_delegation

                    if (child_yang_name == "reoptimized-p2mp-lsp"):
                        if (self.reoptimized_p2mp_lsp is None):
                            self.reoptimized_p2mp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp()
                            self.reoptimized_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                        return self.reoptimized_p2mp_lsp

                    if (child_yang_name == "reoptimized-standby-p2mp-lsp"):
                        if (self.reoptimized_standby_p2mp_lsp is None):
                            self.reoptimized_standby_p2mp_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp()
                            self.reoptimized_standby_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                        return self.reoptimized_standby_p2mp_lsp

                    if (child_yang_name == "soft-preemption"):
                        if (self.soft_preemption is None):
                            self.soft_preemption = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                        return self.soft_preemption

                    if (child_yang_name == "te-tunnel-convergence"):
                        if (self.te_tunnel_convergence is None):
                            self.te_tunnel_convergence = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                            self.te_tunnel_convergence.parent = self
                            self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                        return self.te_tunnel_convergence

                    if (child_yang_name == "transport-tunnel-info"):
                        if (self.transport_tunnel_info is None):
                            self.transport_tunnel_info = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                            self.transport_tunnel_info.parent = self
                            self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                        return self.transport_tunnel_info

                    if (child_yang_name == "tunnel-current-lsp"):
                        if (self.tunnel_current_lsp is None):
                            self.tunnel_current_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                            self.tunnel_current_lsp.parent = self
                            self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                        return self.tunnel_current_lsp

                    if (child_yang_name == "tunnel-restoration-lsp"):
                        if (self.tunnel_restoration_lsp is None):
                            self.tunnel_restoration_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                            self.tunnel_restoration_lsp.parent = self
                            self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                        return self.tunnel_restoration_lsp

                    if (child_yang_name == "tunnel-standby-lsp"):
                        if (self.tunnel_standby_lsp is None):
                            self.tunnel_standby_lsp = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                            self.tunnel_standby_lsp.parent = self
                            self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                        return self.tunnel_standby_lsp

                    if (child_yang_name == "wdm-unitunnel"):
                        if (self.wdm_unitunnel is None):
                            self.wdm_unitunnel = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                            self.wdm_unitunnel.parent = self
                            self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                        return self.wdm_unitunnel

                    if (child_yang_name == "xro-attribute-set"):
                        if (self.xro_attribute_set is None):
                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                        return self.xro_attribute_set

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-backup" or name == "auto-mesh" or name == "auto-pcc" or name == "bfd-info" or name == "bidir" or name == "cleaned-lsp" or name == "config" or name == "delay-clean-pp-lsp" or name == "destination" or name == "flex-info" or name == "history" or name == "otn-bidir" or name == "p2p-info" or name == "path-protection" or name == "pce-delegation" or name == "reoptimized-p2mp-lsp" or name == "reoptimized-standby-p2mp-lsp" or name == "soft-preemption" or name == "te-tunnel-convergence" or name == "transport-tunnel-info" or name == "tunnel-current-lsp" or name == "tunnel-restoration-lsp" or name == "tunnel-standby-lsp" or name == "wdm-unitunnel" or name == "xro-attribute-set" or name == "tunnel-id" or name == "source-address" or name == "destination-address" or name == "admin-state" or name == "affinity-failure-delayed-tear-time-remained" or name == "affinity-failure-reopt-disabled" or name == "affinity-failure-reopt-time-remained" or name == "area-id" or name == "auto-route" or name == "autoroute-announce-exclude-segment-routing" or name == "bandwidth-requested" or name == "bandwidth-type" or name == "binding-label" or name == "binding-label-exists" or name == "create-time" or name == "destination-disabled-count" or name == "destination-down-count" or name == "destination-up-count" or name == "drop-mode" or name == "explicit-path-change" or name == "fail-reason" or name == "forwarding-adjacency" or name == "hop-limit-ignored-reason" or name == "invalidation-time-remained" or name == "is-auto-backup" or name == "is-auto-pcc" or name == "is-bandwidth-protect" or name == "is-hop-limit-ignore" or name == "is-inter-area-tunnel" or name == "is-interface" or name == "is-named" or name == "is-node-protected" or name == "is-passive" or name == "is-pce-delegated" or name == "last-hop-ifindex" or name == "last-path-change" or name == "load-share-factor" or name == "load-share-type" or name == "lsp-wrap-label" or name == "lsp-wrap-protection-enabled" or name == "metric-qualifier" or name == "metric-type" or name == "operational-state" or name == "operational-state-changes" or name == "outbound-frr-state" or name == "passive-tunnel-name" or name == "path-option-change" or name == "pce-fail-reason" or name == "persistent-bytes" or name == "persistent-packets" or name == "re-opt-hold-down-timer-remaining" or name == "reroute-pending" or name == "role-standby" or name == "signaled-name" or name == "snmp-index" or name == "tie-breaker" or name == "tiebreaker-qualifier" or name == "tiebreaker-type" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-type" or name == "tunnel-interface-name" or name == "tunnel-recovering" or name == "uptime" or name == "xro-attribute-set-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-state"):
                        self.admin_state = value
                        self.admin_state.value_namespace = name_space
                        self.admin_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-delayed-tear-time-remained"):
                        self.affinity_failure_delayed_tear_time_remained = value
                        self.affinity_failure_delayed_tear_time_remained.value_namespace = name_space
                        self.affinity_failure_delayed_tear_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-disabled"):
                        self.affinity_failure_reopt_disabled = value
                        self.affinity_failure_reopt_disabled.value_namespace = name_space
                        self.affinity_failure_reopt_disabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-time-remained"):
                        self.affinity_failure_reopt_time_remained = value
                        self.affinity_failure_reopt_time_remained.value_namespace = name_space
                        self.affinity_failure_reopt_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-route"):
                        self.auto_route = value
                        self.auto_route.value_namespace = name_space
                        self.auto_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "autoroute-announce-exclude-segment-routing"):
                        self.autoroute_announce_exclude_segment_routing = value
                        self.autoroute_announce_exclude_segment_routing.value_namespace = name_space
                        self.autoroute_announce_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-requested"):
                        self.bandwidth_requested = value
                        self.bandwidth_requested.value_namespace = name_space
                        self.bandwidth_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label"):
                        self.binding_label = value
                        self.binding_label.value_namespace = name_space
                        self.binding_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label-exists"):
                        self.binding_label_exists = value
                        self.binding_label_exists.value_namespace = name_space
                        self.binding_label_exists.value_namespace_prefix = name_space_prefix
                    if(value_path == "create-time"):
                        self.create_time = value
                        self.create_time.value_namespace = name_space
                        self.create_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-disabled-count"):
                        self.destination_disabled_count = value
                        self.destination_disabled_count.value_namespace = name_space
                        self.destination_disabled_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-down-count"):
                        self.destination_down_count = value
                        self.destination_down_count.value_namespace = name_space
                        self.destination_down_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-up-count"):
                        self.destination_up_count = value
                        self.destination_up_count.value_namespace = name_space
                        self.destination_up_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "drop-mode"):
                        self.drop_mode = value
                        self.drop_mode.value_namespace = name_space
                        self.drop_mode.value_namespace_prefix = name_space_prefix
                    if(value_path == "explicit-path-change"):
                        self.explicit_path_change = value
                        self.explicit_path_change.value_namespace = name_space
                        self.explicit_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "fail-reason"):
                        self.fail_reason = value
                        self.fail_reason.value_namespace = name_space
                        self.fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency"):
                        self.forwarding_adjacency = value
                        self.forwarding_adjacency.value_namespace = name_space
                        self.forwarding_adjacency.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit-ignored-reason"):
                        self.hop_limit_ignored_reason = value
                        self.hop_limit_ignored_reason.value_namespace = name_space
                        self.hop_limit_ignored_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "invalidation-time-remained"):
                        self.invalidation_time_remained = value
                        self.invalidation_time_remained.value_namespace = name_space
                        self.invalidation_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-backup"):
                        self.is_auto_backup = value
                        self.is_auto_backup.value_namespace = name_space
                        self.is_auto_backup.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-pcc"):
                        self.is_auto_pcc = value
                        self.is_auto_pcc.value_namespace = name_space
                        self.is_auto_pcc.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bandwidth-protect"):
                        self.is_bandwidth_protect = value
                        self.is_bandwidth_protect.value_namespace = name_space
                        self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-hop-limit-ignore"):
                        self.is_hop_limit_ignore = value
                        self.is_hop_limit_ignore.value_namespace = name_space
                        self.is_hop_limit_ignore.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-inter-area-tunnel"):
                        self.is_inter_area_tunnel = value
                        self.is_inter_area_tunnel.value_namespace = name_space
                        self.is_inter_area_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-named"):
                        self.is_named = value
                        self.is_named.value_namespace = name_space
                        self.is_named.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-node-protected"):
                        self.is_node_protected = value
                        self.is_node_protected.value_namespace = name_space
                        self.is_node_protected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-delegated"):
                        self.is_pce_delegated = value
                        self.is_pce_delegated.value_namespace = name_space
                        self.is_pce_delegated.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-hop-ifindex"):
                        self.last_hop_ifindex = value
                        self.last_hop_ifindex.value_namespace = name_space
                        self.last_hop_ifindex.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-factor"):
                        self.load_share_factor = value
                        self.load_share_factor.value_namespace = name_space
                        self.load_share_factor.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-type"):
                        self.load_share_type = value
                        self.load_share_type.value_namespace = name_space
                        self.load_share_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-label"):
                        self.lsp_wrap_label = value
                        self.lsp_wrap_label.value_namespace = name_space
                        self.lsp_wrap_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enabled"):
                        self.lsp_wrap_protection_enabled = value
                        self.lsp_wrap_protection_enabled.value_namespace = name_space
                        self.lsp_wrap_protection_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-qualifier"):
                        self.metric_qualifier = value
                        self.metric_qualifier.value_namespace = name_space
                        self.metric_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state"):
                        self.operational_state = value
                        self.operational_state.value_namespace = name_space
                        self.operational_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state-changes"):
                        self.operational_state_changes = value
                        self.operational_state_changes.value_namespace = name_space
                        self.operational_state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "passive-tunnel-name"):
                        self.passive_tunnel_name = value
                        self.passive_tunnel_name.value_namespace = name_space
                        self.passive_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-option-change"):
                        self.path_option_change = value
                        self.path_option_change.value_namespace = name_space
                        self.path_option_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-fail-reason"):
                        self.pce_fail_reason = value
                        self.pce_fail_reason.value_namespace = name_space
                        self.pce_fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "re-opt-hold-down-timer-remaining"):
                        self.re_opt_hold_down_timer_remaining = value
                        self.re_opt_hold_down_timer_remaining.value_namespace = name_space
                        self.re_opt_hold_down_timer_remaining.value_namespace_prefix = name_space_prefix
                    if(value_path == "reroute-pending"):
                        self.reroute_pending = value
                        self.reroute_pending.value_namespace = name_space
                        self.reroute_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "role-standby"):
                        self.role_standby = value
                        self.role_standby.value_namespace = name_space
                        self.role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "snmp-index"):
                        self.snmp_index = value
                        self.snmp_index.value_namespace = name_space
                        self.snmp_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "tie-breaker"):
                        self.tie_breaker = value
                        self.tie_breaker.value_namespace = name_space
                        self.tie_breaker.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-qualifier"):
                        self.tiebreaker_qualifier = value
                        self.tiebreaker_qualifier.value_namespace = name_space
                        self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-type"):
                        self.tiebreaker_type = value
                        self.tiebreaker_type.value_namespace = name_space
                        self.tiebreaker_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface-name"):
                        self.tunnel_interface_name = value
                        self.tunnel_interface_name.value_namespace = name_space
                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-recovering"):
                        self.tunnel_recovering = value
                        self.tunnel_recovering.value_namespace = name_space
                        self.tunnel_recovering.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix
                    if(value_path == "xro-attribute-set-name"):
                        self.xro_attribute_set_name = value
                        self.xro_attribute_set_name.value_namespace = name_space
                        self.xro_attribute_set_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.nni_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.nni_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nni-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nni-tunnel"):
                    for c in self.nni_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2PP2MpTunnel.NniTunnels.NniTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.nni_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nni-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelHeads(Entity):
            """
            Restrict display to P2P or P2MP head tunnels
            
            .. attribute:: tunnel_head
            
            	mpls te p2p or p2mp tunnels
            	**type**\: list of    :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2PP2MpTunnel.TunnelHeads, self).__init__()

                self.yang_name = "tunnel-heads"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_head = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads, self).__setattr__(name, value)


            class TunnelHead(Entity):
                """
                mpls te p2p or p2mp tunnels
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:   :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\:  bool
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\:  str
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:   :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup>`
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:   :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh>`
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:   :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc>`
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\:  bool
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\:  bool
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:   :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo>`
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:   :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir>`
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\:  bool
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:   :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp>`
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config>`
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:   :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp>`
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination>`
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\:  bool
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:   :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo>`
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\:  bool
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:   :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History>`
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:   :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\:  bool
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\:  bool
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\:  bool
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\:  bool
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\:  bool
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:   :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\:  bool
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:   :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:   :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir>`
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo>`
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\:  str
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection>`
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:   :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation>`
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:   :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:   :py:class:`ReoptimizedP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp>`
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:   :py:class:`ReoptimizedStandbyP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp>`
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\:  bool
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption>`
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:   :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence>`
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:   :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo>`
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\:  str
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:   :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp>`
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\:  bool
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:   :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp>`
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:   :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:   :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel>`
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet>`
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__init__()

                    self.yang_name = "tunnel-head"
                    self.yang_parent_name = "tunnel-heads"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.admin_state = YLeaf(YType.enumeration, "admin-state")

                    self.affinity_failure_delayed_tear_time_remained = YLeaf(YType.uint32, "affinity-failure-delayed-tear-time-remained")

                    self.affinity_failure_reopt_disabled = YLeaf(YType.boolean, "affinity-failure-reopt-disabled")

                    self.affinity_failure_reopt_time_remained = YLeaf(YType.uint32, "affinity-failure-reopt-time-remained")

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.auto_route = YLeaf(YType.boolean, "auto-route")

                    self.autoroute_announce_exclude_segment_routing = YLeaf(YType.boolean, "autoroute-announce-exclude-segment-routing")

                    self.bandwidth_requested = YLeaf(YType.uint32, "bandwidth-requested")

                    self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                    self.binding_label_exists = YLeaf(YType.boolean, "binding-label-exists")

                    self.create_time = YLeaf(YType.uint32, "create-time")

                    self.destination_disabled_count = YLeaf(YType.uint32, "destination-disabled-count")

                    self.destination_down_count = YLeaf(YType.uint32, "destination-down-count")

                    self.destination_up_count = YLeaf(YType.uint32, "destination-up-count")

                    self.drop_mode = YLeaf(YType.boolean, "drop-mode")

                    self.explicit_path_change = YLeaf(YType.boolean, "explicit-path-change")

                    self.fail_reason = YLeaf(YType.enumeration, "fail-reason")

                    self.forwarding_adjacency = YLeaf(YType.boolean, "forwarding-adjacency")

                    self.hop_limit_ignored_reason = YLeaf(YType.enumeration, "hop-limit-ignored-reason")

                    self.invalidation_time_remained = YLeaf(YType.uint32, "invalidation-time-remained")

                    self.is_auto_backup = YLeaf(YType.boolean, "is-auto-backup")

                    self.is_auto_pcc = YLeaf(YType.boolean, "is-auto-pcc")

                    self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                    self.is_hop_limit_ignore = YLeaf(YType.boolean, "is-hop-limit-ignore")

                    self.is_inter_area_tunnel = YLeaf(YType.boolean, "is-inter-area-tunnel")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_named = YLeaf(YType.boolean, "is-named")

                    self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.is_pce_delegated = YLeaf(YType.boolean, "is-pce-delegated")

                    self.last_hop_ifindex = YLeaf(YType.uint32, "last-hop-ifindex")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.load_share_factor = YLeaf(YType.uint32, "load-share-factor")

                    self.load_share_type = YLeaf(YType.enumeration, "load-share-type")

                    self.lsp_wrap_label = YLeaf(YType.uint32, "lsp-wrap-label")

                    self.lsp_wrap_protection_enabled = YLeaf(YType.boolean, "lsp-wrap-protection-enabled")

                    self.metric_qualifier = YLeaf(YType.enumeration, "metric-qualifier")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                    self.operational_state = YLeaf(YType.enumeration, "operational-state")

                    self.operational_state_changes = YLeaf(YType.uint32, "operational-state-changes")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.passive_tunnel_name = YLeaf(YType.str, "passive-tunnel-name")

                    self.path_option_change = YLeaf(YType.boolean, "path-option-change")

                    self.pce_fail_reason = YLeaf(YType.enumeration, "pce-fail-reason")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.re_opt_hold_down_timer_remaining = YLeaf(YType.uint32, "re-opt-hold-down-timer-remaining")

                    self.reroute_pending = YLeaf(YType.boolean, "reroute-pending")

                    self.role_standby = YLeaf(YType.boolean, "role-standby")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.snmp_index = YLeaf(YType.uint32, "snmp-index")

                    self.tie_breaker = YLeaf(YType.enumeration, "tie-breaker")

                    self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                    self.tiebreaker_type = YLeaf(YType.uint32, "tiebreaker-type")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                    self.tunnel_recovering = YLeaf(YType.boolean, "tunnel-recovering")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.xro_attribute_set_name = YLeaf(YType.str, "xro-attribute-set-name")

                    self.auto_backup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"
                    self._children_yang_names.add("auto-backup")

                    self.auto_mesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"
                    self._children_yang_names.add("auto-mesh")

                    self.auto_pcc = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"
                    self._children_yang_names.add("auto-pcc")

                    self.bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"
                    self._children_yang_names.add("bfd-info")

                    self.bidir = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"
                    self._children_yang_names.add("bidir")

                    self.cleaned_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                    self._children_yang_names.add("cleaned-lsp")

                    self.config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"
                    self._children_yang_names.add("config")

                    self.delay_clean_pp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                    self._children_yang_names.add("delay-clean-pp-lsp")

                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"
                    self._children_yang_names.add("flex-info")

                    self.history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"
                    self._children_yang_names.add("history")

                    self.otn_bidir = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"
                    self._children_yang_names.add("otn-bidir")

                    self.p2p_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"
                    self._children_yang_names.add("p2p-info")

                    self.path_protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.pce_delegation = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"
                    self._children_yang_names.add("pce-delegation")

                    self.reoptimized_p2mp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-p2mp-lsp")

                    self.reoptimized_standby_p2mp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-standby-p2mp-lsp")

                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"
                    self._children_yang_names.add("soft-preemption")

                    self.te_tunnel_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                    self._children_yang_names.add("te-tunnel-convergence")

                    self.transport_tunnel_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                    self._children_yang_names.add("transport-tunnel-info")

                    self.tunnel_current_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                    self._children_yang_names.add("tunnel-current-lsp")

                    self.tunnel_restoration_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                    self._children_yang_names.add("tunnel-restoration-lsp")

                    self.tunnel_standby_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                    self._children_yang_names.add("tunnel-standby-lsp")

                    self.wdm_unitunnel = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                    self._children_yang_names.add("wdm-unitunnel")

                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                    self._children_yang_names.add("xro-attribute-set")

                    self.destination = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "admin_state",
                                    "affinity_failure_delayed_tear_time_remained",
                                    "affinity_failure_reopt_disabled",
                                    "affinity_failure_reopt_time_remained",
                                    "area_id",
                                    "auto_route",
                                    "autoroute_announce_exclude_segment_routing",
                                    "bandwidth_requested",
                                    "bandwidth_type",
                                    "binding_label",
                                    "binding_label_exists",
                                    "create_time",
                                    "destination_disabled_count",
                                    "destination_down_count",
                                    "destination_up_count",
                                    "drop_mode",
                                    "explicit_path_change",
                                    "fail_reason",
                                    "forwarding_adjacency",
                                    "hop_limit_ignored_reason",
                                    "invalidation_time_remained",
                                    "is_auto_backup",
                                    "is_auto_pcc",
                                    "is_bandwidth_protect",
                                    "is_hop_limit_ignore",
                                    "is_inter_area_tunnel",
                                    "is_interface",
                                    "is_named",
                                    "is_node_protected",
                                    "is_passive",
                                    "is_pce_delegated",
                                    "last_hop_ifindex",
                                    "last_path_change",
                                    "load_share_factor",
                                    "load_share_type",
                                    "lsp_wrap_label",
                                    "lsp_wrap_protection_enabled",
                                    "metric_qualifier",
                                    "metric_type",
                                    "operational_state",
                                    "operational_state_changes",
                                    "outbound_frr_state",
                                    "passive_tunnel_name",
                                    "path_option_change",
                                    "pce_fail_reason",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "re_opt_hold_down_timer_remaining",
                                    "reroute_pending",
                                    "role_standby",
                                    "signaled_name",
                                    "snmp_index",
                                    "tie_breaker",
                                    "tiebreaker_qualifier",
                                    "tiebreaker_type",
                                    "tunnel_attribute_set_name",
                                    "tunnel_attribute_set_type",
                                    "tunnel_interface_name",
                                    "tunnel_recovering",
                                    "uptime",
                                    "xro_attribute_set_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__setattr__(name, value)


                class Config(Entity):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity>`
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of    :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination>`
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:   :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig>`
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:   :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig>`
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\:  bool
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\:  bool
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\:  bool
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\:  bool
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\:  str
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\:  bool
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "tunnel-head"

                        self.affinity_failure_reopt_timer = YLeaf(YType.uint32, "affinity-failure-reopt-timer")

                        self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                        self.backup_bandwidth_flags = YLeaf(YType.uint8, "backup-bandwidth-flags")

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.config_load_share = YLeaf(YType.uint32, "config-load-share")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.cost_limit_global = YLeaf(YType.uint32, "cost-limit-global")

                        self.disable_affinity_failure_reopt = YLeaf(YType.boolean, "disable-affinity-failure-reopt")

                        self.explicit_null_imposition = YLeaf(YType.boolean, "explicit-null-imposition")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.hop_limit = YLeaf(YType.uint8, "hop-limit")

                        self.interface_configured_bandwidth = YLeaf(YType.uint32, "interface-configured-bandwidth")

                        self.is_backup_tunnel = YLeaf(YType.boolean, "is-backup-tunnel")

                        self.is_in_config = YLeaf(YType.boolean, "is-in-config")

                        self.is_p2mp = YLeaf(YType.boolean, "is-p2mp")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_action_source = YLeaf(YType.uint32, "path-invalidation-action-source")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_invalidation_timeout_source = YLeaf(YType.uint32, "path-invalidation-timeout-source")

                        self.path_protection_enabled = YLeaf(YType.boolean, "path-protection-enabled")

                        self.payload_type = YLeaf(YType.uint16, "payload-type")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.segment_routing_path_selection = YLeaf(YType.enumeration, "segment-routing-path-selection")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.soft_preempt = YLeaf(YType.boolean, "soft-preempt")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"
                        self._children_yang_names.add("bfd-config")

                        self.bidirectional_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"
                        self._children_yang_names.add("bidirectional-config")

                        self.autoroute_destination = YList(self)
                        self.policy_class_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_failure_reopt_timer",
                                        "backup_bandwidth",
                                        "backup_bandwidth_flags",
                                        "bandwidth_type",
                                        "config_load_share",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "cost_limit_global",
                                        "disable_affinity_failure_reopt",
                                        "explicit_null_imposition",
                                        "fast_reroute",
                                        "forward_class",
                                        "hold_priority",
                                        "hop_limit",
                                        "interface_configured_bandwidth",
                                        "is_backup_tunnel",
                                        "is_in_config",
                                        "is_p2mp",
                                        "path_invalidation_action",
                                        "path_invalidation_action_source",
                                        "path_invalidation_timeout",
                                        "path_invalidation_timeout_source",
                                        "path_protection_enabled",
                                        "payload_type",
                                        "policy_class",
                                        "record_route",
                                        "segment_routing_path_selection",
                                        "setup_priority",
                                        "signaled_name",
                                        "soft_preempt",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BidirectionalConfig(Entity):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\:  bool
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: association_type
                        
                        	Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"

                            self.association_corouted = YLeaf(YType.boolean, "association-corouted")

                            self.association_global_id = YLeaf(YType.uint32, "association-global-id")

                            self.association_id = YLeaf(YType.uint16, "association-id")

                            self.association_source = YLeaf(YType.str, "association-source")

                            self.association_type = YLeaf(YType.uint16, "association-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("association_corouted",
                                            "association_global_id",
                                            "association_id",
                                            "association_source",
                                            "association_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.association_corouted.is_set or
                                self.association_global_id.is_set or
                                self.association_id.is_set or
                                self.association_source.is_set or
                                self.association_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.association_corouted.yfilter != YFilter.not_set or
                                self.association_global_id.yfilter != YFilter.not_set or
                                self.association_id.yfilter != YFilter.not_set or
                                self.association_source.yfilter != YFilter.not_set or
                                self.association_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bidirectional-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.association_corouted.is_set or self.association_corouted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_corouted.get_name_leafdata())
                            if (self.association_global_id.is_set or self.association_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_global_id.get_name_leafdata())
                            if (self.association_id.is_set or self.association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_id.get_name_leafdata())
                            if (self.association_source.is_set or self.association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_source.get_name_leafdata())
                            if (self.association_type.is_set or self.association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association-corouted" or name == "association-global-id" or name == "association-id" or name == "association-source" or name == "association-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "association-corouted"):
                                self.association_corouted = value
                                self.association_corouted.value_namespace = name_space
                                self.association_corouted.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-global-id"):
                                self.association_global_id = value
                                self.association_global_id.value_namespace = name_space
                                self.association_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-id"):
                                self.association_id = value
                                self.association_id.value_namespace = name_space
                                self.association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-source"):
                                self.association_source = value
                                self.association_source.value_namespace = name_space
                                self.association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-type"):
                                self.association_type = value
                                self.association_type.value_namespace = name_space
                                self.association_type.value_namespace_prefix = name_space_prefix


                    class BfdConfig(Entity):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:   :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\:  bool
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:   :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\:  bool
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\:  bool
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\:  bool
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"

                            self.bfd_encap_mode = YLeaf(YType.enumeration, "bfd-encap-mode")

                            self.bfd_fast_detecting_enabled = YLeaf(YType.boolean, "bfd-fast-detecting-enabled")

                            self.bfd_session_down_action = YLeaf(YType.enumeration, "bfd-session-down-action")

                            self.bfd_session_down_reopt_timeout = YLeaf(YType.uint32, "bfd-session-down-reopt-timeout")

                            self.bfd_type = YLeaf(YType.enumeration, "bfd-type")

                            self.bring_up_timeout = YLeaf(YType.uint16, "bring-up-timeout")

                            self.bring_up_timeout_default = YLeaf(YType.boolean, "bring-up-timeout-default")

                            self.dampening_initial_wait = YLeaf(YType.uint32, "dampening-initial-wait")

                            self.dampening_initial_wait_default = YLeaf(YType.boolean, "dampening-initial-wait-default")

                            self.dampening_max_wait = YLeaf(YType.uint32, "dampening-max-wait")

                            self.dampening_max_wait_default = YLeaf(YType.boolean, "dampening-max-wait-default")

                            self.dampening_secondary_wait = YLeaf(YType.uint32, "dampening-secondary-wait")

                            self.dampening_secondary_wait_default = YLeaf(YType.boolean, "dampening-secondary-wait-default")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.periodic_lsp_ping_disabled = YLeaf(YType.boolean, "periodic-lsp-ping-disabled")

                            self.periodic_lsp_ping_interval = YLeaf(YType.uint32, "periodic-lsp-ping-interval")

                            self.periodic_lsp_ping_interval_default = YLeaf(YType.boolean, "periodic-lsp-ping-interval-default")

                            self.sbfd_target_id = YLeaf(YType.str, "sbfd-target-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_encap_mode",
                                            "bfd_fast_detecting_enabled",
                                            "bfd_session_down_action",
                                            "bfd_session_down_reopt_timeout",
                                            "bfd_type",
                                            "bring_up_timeout",
                                            "bring_up_timeout_default",
                                            "dampening_initial_wait",
                                            "dampening_initial_wait_default",
                                            "dampening_max_wait",
                                            "dampening_max_wait_default",
                                            "dampening_secondary_wait",
                                            "dampening_secondary_wait_default",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "periodic_lsp_ping_disabled",
                                            "periodic_lsp_ping_interval",
                                            "periodic_lsp_ping_interval_default",
                                            "sbfd_target_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_encap_mode.is_set or
                                self.bfd_fast_detecting_enabled.is_set or
                                self.bfd_session_down_action.is_set or
                                self.bfd_session_down_reopt_timeout.is_set or
                                self.bfd_type.is_set or
                                self.bring_up_timeout.is_set or
                                self.bring_up_timeout_default.is_set or
                                self.dampening_initial_wait.is_set or
                                self.dampening_initial_wait_default.is_set or
                                self.dampening_max_wait.is_set or
                                self.dampening_max_wait_default.is_set or
                                self.dampening_secondary_wait.is_set or
                                self.dampening_secondary_wait_default.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.periodic_lsp_ping_disabled.is_set or
                                self.periodic_lsp_ping_interval.is_set or
                                self.periodic_lsp_ping_interval_default.is_set or
                                self.sbfd_target_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_encap_mode.yfilter != YFilter.not_set or
                                self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set or
                                self.bfd_session_down_action.yfilter != YFilter.not_set or
                                self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set or
                                self.bfd_type.yfilter != YFilter.not_set or
                                self.bring_up_timeout.yfilter != YFilter.not_set or
                                self.bring_up_timeout_default.yfilter != YFilter.not_set or
                                self.dampening_initial_wait.yfilter != YFilter.not_set or
                                self.dampening_initial_wait_default.yfilter != YFilter.not_set or
                                self.dampening_max_wait.yfilter != YFilter.not_set or
                                self.dampening_max_wait_default.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait_default.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set or
                                self.sbfd_target_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_encap_mode.is_set or self.bfd_encap_mode.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_encap_mode.get_name_leafdata())
                            if (self.bfd_fast_detecting_enabled.is_set or self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_fast_detecting_enabled.get_name_leafdata())
                            if (self.bfd_session_down_action.is_set or self.bfd_session_down_action.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_action.get_name_leafdata())
                            if (self.bfd_session_down_reopt_timeout.is_set or self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_reopt_timeout.get_name_leafdata())
                            if (self.bfd_type.is_set or self.bfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_type.get_name_leafdata())
                            if (self.bring_up_timeout.is_set or self.bring_up_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout.get_name_leafdata())
                            if (self.bring_up_timeout_default.is_set or self.bring_up_timeout_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout_default.get_name_leafdata())
                            if (self.dampening_initial_wait.is_set or self.dampening_initial_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait.get_name_leafdata())
                            if (self.dampening_initial_wait_default.is_set or self.dampening_initial_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait_default.get_name_leafdata())
                            if (self.dampening_max_wait.is_set or self.dampening_max_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait.get_name_leafdata())
                            if (self.dampening_max_wait_default.is_set or self.dampening_max_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait_default.get_name_leafdata())
                            if (self.dampening_secondary_wait.is_set or self.dampening_secondary_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait.get_name_leafdata())
                            if (self.dampening_secondary_wait_default.is_set or self.dampening_secondary_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait_default.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.periodic_lsp_ping_disabled.is_set or self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_disabled.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval.is_set or self.periodic_lsp_ping_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval_default.is_set or self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval_default.get_name_leafdata())
                            if (self.sbfd_target_id.is_set or self.sbfd_target_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sbfd_target_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-encap-mode" or name == "bfd-fast-detecting-enabled" or name == "bfd-session-down-action" or name == "bfd-session-down-reopt-timeout" or name == "bfd-type" or name == "bring-up-timeout" or name == "bring-up-timeout-default" or name == "dampening-initial-wait" or name == "dampening-initial-wait-default" or name == "dampening-max-wait" or name == "dampening-max-wait-default" or name == "dampening-secondary-wait" or name == "dampening-secondary-wait-default" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "periodic-lsp-ping-disabled" or name == "periodic-lsp-ping-interval" or name == "periodic-lsp-ping-interval-default" or name == "sbfd-target-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-encap-mode"):
                                self.bfd_encap_mode = value
                                self.bfd_encap_mode.value_namespace = name_space
                                self.bfd_encap_mode.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-fast-detecting-enabled"):
                                self.bfd_fast_detecting_enabled = value
                                self.bfd_fast_detecting_enabled.value_namespace = name_space
                                self.bfd_fast_detecting_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-action"):
                                self.bfd_session_down_action = value
                                self.bfd_session_down_action.value_namespace = name_space
                                self.bfd_session_down_action.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-reopt-timeout"):
                                self.bfd_session_down_reopt_timeout = value
                                self.bfd_session_down_reopt_timeout.value_namespace = name_space
                                self.bfd_session_down_reopt_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-type"):
                                self.bfd_type = value
                                self.bfd_type.value_namespace = name_space
                                self.bfd_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout"):
                                self.bring_up_timeout = value
                                self.bring_up_timeout.value_namespace = name_space
                                self.bring_up_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout-default"):
                                self.bring_up_timeout_default = value
                                self.bring_up_timeout_default.value_namespace = name_space
                                self.bring_up_timeout_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait"):
                                self.dampening_initial_wait = value
                                self.dampening_initial_wait.value_namespace = name_space
                                self.dampening_initial_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait-default"):
                                self.dampening_initial_wait_default = value
                                self.dampening_initial_wait_default.value_namespace = name_space
                                self.dampening_initial_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait"):
                                self.dampening_max_wait = value
                                self.dampening_max_wait.value_namespace = name_space
                                self.dampening_max_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait-default"):
                                self.dampening_max_wait_default = value
                                self.dampening_max_wait_default.value_namespace = name_space
                                self.dampening_max_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait"):
                                self.dampening_secondary_wait = value
                                self.dampening_secondary_wait.value_namespace = name_space
                                self.dampening_secondary_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait-default"):
                                self.dampening_secondary_wait_default = value
                                self.dampening_secondary_wait_default.value_namespace = name_space
                                self.dampening_secondary_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-disabled"):
                                self.periodic_lsp_ping_disabled = value
                                self.periodic_lsp_ping_disabled.value_namespace = name_space
                                self.periodic_lsp_ping_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval"):
                                self.periodic_lsp_ping_interval = value
                                self.periodic_lsp_ping_interval.value_namespace = name_space
                                self.periodic_lsp_ping_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval-default"):
                                self.periodic_lsp_ping_interval_default = value
                                self.periodic_lsp_ping_interval_default.value_namespace = name_space
                                self.periodic_lsp_ping_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "sbfd-target-id"):
                                self.sbfd_target_id = value
                                self.sbfd_target_id.value_namespace = name_space
                                self.sbfd_target_id.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class AutorouteDestination(Entity):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.prefix_length = YLeaf(YType.uint16, "prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "autoroute-destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.autoroute_destination:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_failure_reopt_timer.is_set or
                            self.backup_bandwidth.is_set or
                            self.backup_bandwidth_flags.is_set or
                            self.bandwidth_type.is_set or
                            self.config_load_share.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.cost_limit_global.is_set or
                            self.disable_affinity_failure_reopt.is_set or
                            self.explicit_null_imposition.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.hold_priority.is_set or
                            self.hop_limit.is_set or
                            self.interface_configured_bandwidth.is_set or
                            self.is_backup_tunnel.is_set or
                            self.is_in_config.is_set or
                            self.is_p2mp.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_action_source.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_invalidation_timeout_source.is_set or
                            self.path_protection_enabled.is_set or
                            self.payload_type.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.segment_routing_path_selection.is_set or
                            self.setup_priority.is_set or
                            self.signaled_name.is_set or
                            self.soft_preempt.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_name.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_config is not None and self.bfd_config.has_data()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_data()))

                    def has_operation(self):
                        for c in self.autoroute_destination:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_failure_reopt_timer.yfilter != YFilter.not_set or
                            self.backup_bandwidth.yfilter != YFilter.not_set or
                            self.backup_bandwidth_flags.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.config_load_share.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.cost_limit_global.yfilter != YFilter.not_set or
                            self.disable_affinity_failure_reopt.yfilter != YFilter.not_set or
                            self.explicit_null_imposition.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.hop_limit.yfilter != YFilter.not_set or
                            self.interface_configured_bandwidth.yfilter != YFilter.not_set or
                            self.is_backup_tunnel.yfilter != YFilter.not_set or
                            self.is_in_config.yfilter != YFilter.not_set or
                            self.is_p2mp.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_action_source.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout_source.yfilter != YFilter.not_set or
                            self.path_protection_enabled.yfilter != YFilter.not_set or
                            self.payload_type.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.segment_routing_path_selection.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.soft_preempt.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_config is not None and self.bfd_config.has_operation()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "config" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_failure_reopt_timer.is_set or self.affinity_failure_reopt_timer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_failure_reopt_timer.get_name_leafdata())
                        if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                        if (self.backup_bandwidth_flags.is_set or self.backup_bandwidth_flags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth_flags.get_name_leafdata())
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.config_load_share.is_set or self.config_load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.config_load_share.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.cost_limit_global.is_set or self.cost_limit_global.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit_global.get_name_leafdata())
                        if (self.disable_affinity_failure_reopt.is_set or self.disable_affinity_failure_reopt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.disable_affinity_failure_reopt.get_name_leafdata())
                        if (self.explicit_null_imposition.is_set or self.explicit_null_imposition.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.explicit_null_imposition.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hop_limit.get_name_leafdata())
                        if (self.interface_configured_bandwidth.is_set or self.interface_configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_configured_bandwidth.get_name_leafdata())
                        if (self.is_backup_tunnel.is_set or self.is_backup_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup_tunnel.get_name_leafdata())
                        if (self.is_in_config.is_set or self.is_in_config.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_in_config.get_name_leafdata())
                        if (self.is_p2mp.is_set or self.is_p2mp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_p2mp.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_action_source.is_set or self.path_invalidation_action_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action_source.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_invalidation_timeout_source.is_set or self.path_invalidation_timeout_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout_source.get_name_leafdata())
                        if (self.path_protection_enabled.is_set or self.path_protection_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_enabled.get_name_leafdata())
                        if (self.payload_type.is_set or self.payload_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.payload_type.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.segment_routing_path_selection.is_set or self.segment_routing_path_selection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_path_selection.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.soft_preempt.is_set or self.soft_preempt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preempt.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "autoroute-destination"):
                            for c in self.autoroute_destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.autoroute_destination.append(c)
                            return c

                        if (child_yang_name == "bfd-config"):
                            if (self.bfd_config is None):
                                self.bfd_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                                self.bfd_config.parent = self
                                self._children_name_map["bfd_config"] = "bfd-config"
                            return self.bfd_config

                        if (child_yang_name == "bidirectional-config"):
                            if (self.bidirectional_config is None):
                                self.bidirectional_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                                self.bidirectional_config.parent = self
                                self._children_name_map["bidirectional_config"] = "bidirectional-config"
                            return self.bidirectional_config

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "autoroute-destination" or name == "bfd-config" or name == "bidirectional-config" or name == "policy-class-entry" or name == "affinity-failure-reopt-timer" or name == "backup-bandwidth" or name == "backup-bandwidth-flags" or name == "bandwidth-type" or name == "config-load-share" or name == "configured-bandwidth" or name == "cost-limit" or name == "cost-limit-global" or name == "disable-affinity-failure-reopt" or name == "explicit-null-imposition" or name == "fast-reroute" or name == "forward-class" or name == "hold-priority" or name == "hop-limit" or name == "interface-configured-bandwidth" or name == "is-backup-tunnel" or name == "is-in-config" or name == "is-p2mp" or name == "path-invalidation-action" or name == "path-invalidation-action-source" or name == "path-invalidation-timeout" or name == "path-invalidation-timeout-source" or name == "path-protection-enabled" or name == "payload-type" or name == "policy-class" or name == "record-route" or name == "segment-routing-path-selection" or name == "setup-priority" or name == "signaled-name" or name == "soft-preempt" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-failure-reopt-timer"):
                            self.affinity_failure_reopt_timer = value
                            self.affinity_failure_reopt_timer.value_namespace = name_space
                            self.affinity_failure_reopt_timer.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth"):
                            self.backup_bandwidth = value
                            self.backup_bandwidth.value_namespace = name_space
                            self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth-flags"):
                            self.backup_bandwidth_flags = value
                            self.backup_bandwidth_flags.value_namespace = name_space
                            self.backup_bandwidth_flags.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "config-load-share"):
                            self.config_load_share = value
                            self.config_load_share.value_namespace = name_space
                            self.config_load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit-global"):
                            self.cost_limit_global = value
                            self.cost_limit_global.value_namespace = name_space
                            self.cost_limit_global.value_namespace_prefix = name_space_prefix
                        if(value_path == "disable-affinity-failure-reopt"):
                            self.disable_affinity_failure_reopt = value
                            self.disable_affinity_failure_reopt.value_namespace = name_space
                            self.disable_affinity_failure_reopt.value_namespace_prefix = name_space_prefix
                        if(value_path == "explicit-null-imposition"):
                            self.explicit_null_imposition = value
                            self.explicit_null_imposition.value_namespace = name_space
                            self.explicit_null_imposition.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "hop-limit"):
                            self.hop_limit = value
                            self.hop_limit.value_namespace = name_space
                            self.hop_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-configured-bandwidth"):
                            self.interface_configured_bandwidth = value
                            self.interface_configured_bandwidth.value_namespace = name_space
                            self.interface_configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup-tunnel"):
                            self.is_backup_tunnel = value
                            self.is_backup_tunnel.value_namespace = name_space
                            self.is_backup_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-in-config"):
                            self.is_in_config = value
                            self.is_in_config.value_namespace = name_space
                            self.is_in_config.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-p2mp"):
                            self.is_p2mp = value
                            self.is_p2mp.value_namespace = name_space
                            self.is_p2mp.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action-source"):
                            self.path_invalidation_action_source = value
                            self.path_invalidation_action_source.value_namespace = name_space
                            self.path_invalidation_action_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout-source"):
                            self.path_invalidation_timeout_source = value
                            self.path_invalidation_timeout_source.value_namespace = name_space
                            self.path_invalidation_timeout_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-enabled"):
                            self.path_protection_enabled = value
                            self.path_protection_enabled.value_namespace = name_space
                            self.path_protection_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "payload-type"):
                            self.payload_type = value
                            self.payload_type.value_namespace = name_space
                            self.payload_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-path-selection"):
                            self.segment_routing_path_selection = value
                            self.segment_routing_path_selection.value_namespace = name_space
                            self.segment_routing_path_selection.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preempt"):
                            self.soft_preempt = value
                            self.soft_preempt.value_namespace = name_space
                            self.soft_preempt.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class TunnelCurrentLsp(Entity):
                    """
                    Current LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedP2MpLsp(Entity):
                    """
                    Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelStandbyLsp(Entity):
                    """
                    Standby LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedStandbyP2MpLsp(Entity):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-standby-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelRestorationLsp(Entity):
                    """
                    Restoration LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-restoration-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class DelayCleanPpLsp(Entity):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "delay-clean-pp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class CleanedLsp(Entity):
                    """
                    Cleaned LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "cleaned-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class P2PInfo(Entity):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:   :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig>`
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:   :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper>`
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus>`
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "tunnel-head"

                        self.is_bidirectional = YLeaf(YType.boolean, "is-bidirectional")

                        self.auto_bandwidth_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                        self._children_yang_names.add("auto-bandwidth-config")

                        self.auto_bandwidth_oper = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._children_yang_names.add("auto-bandwidth-oper")

                        self.auto_bandwidth_status = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        self._children_yang_names.add("auto-bandwidth-status")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bidirectional") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__setattr__(name, value)


                    class AutoBandwidthStatus(Entity):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\:  bool
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"

                            self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                            self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_auto_bandwidth_enabled",
                                            "reactivation_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_auto_bandwidth_enabled.is_set or
                                self.reactivation_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                                self.reactivation_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-status" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                            if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-auto-bandwidth-enabled"):
                                self.is_auto_bandwidth_enabled = value
                                self.is_auto_bandwidth_enabled.value_namespace = name_space
                                self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "reactivation-time"):
                                self.reactivation_time = value
                                self.reactivation_time.value_namespace = name_space
                                self.reactivation_time.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthConfig(Entity):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\:  bool
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"

                            self.adjustment_threshold_percent = YLeaf(YType.uint32, "adjustment-threshold-percent")

                            self.adjustment_threshold_value = YLeaf(YType.uint32, "adjustment-threshold-value")

                            self.application_frequency = YLeaf(YType.uint32, "application-frequency")

                            self.collection_frequency = YLeaf(YType.uint32, "collection-frequency")

                            self.is_auto_bandwidth_collect_only = YLeaf(YType.boolean, "is-auto-bandwidth-collect-only")

                            self.maximum_bandwidth = YLeaf(YType.uint32, "maximum-bandwidth")

                            self.minimum_bandwidth = YLeaf(YType.uint32, "minimum-bandwidth")

                            self.overflow_threshold_limit = YLeaf(YType.uint32, "overflow-threshold-limit")

                            self.overflow_threshold_percent = YLeaf(YType.uint32, "overflow-threshold-percent")

                            self.overflow_threshold_value = YLeaf(YType.uint32, "overflow-threshold-value")

                            self.underflow_threshold_limit = YLeaf(YType.uint32, "underflow-threshold-limit")

                            self.underflow_threshold_percent = YLeaf(YType.uint32, "underflow-threshold-percent")

                            self.underflow_threshold_value = YLeaf(YType.uint32, "underflow-threshold-value")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_threshold_percent",
                                            "adjustment_threshold_value",
                                            "application_frequency",
                                            "collection_frequency",
                                            "is_auto_bandwidth_collect_only",
                                            "maximum_bandwidth",
                                            "minimum_bandwidth",
                                            "overflow_threshold_limit",
                                            "overflow_threshold_percent",
                                            "overflow_threshold_value",
                                            "underflow_threshold_limit",
                                            "underflow_threshold_percent",
                                            "underflow_threshold_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.adjustment_threshold_percent.is_set or
                                self.adjustment_threshold_value.is_set or
                                self.application_frequency.is_set or
                                self.collection_frequency.is_set or
                                self.is_auto_bandwidth_collect_only.is_set or
                                self.maximum_bandwidth.is_set or
                                self.minimum_bandwidth.is_set or
                                self.overflow_threshold_limit.is_set or
                                self.overflow_threshold_percent.is_set or
                                self.overflow_threshold_value.is_set or
                                self.underflow_threshold_limit.is_set or
                                self.underflow_threshold_percent.is_set or
                                self.underflow_threshold_value.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_threshold_percent.yfilter != YFilter.not_set or
                                self.adjustment_threshold_value.yfilter != YFilter.not_set or
                                self.application_frequency.yfilter != YFilter.not_set or
                                self.collection_frequency.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set or
                                self.maximum_bandwidth.yfilter != YFilter.not_set or
                                self.minimum_bandwidth.yfilter != YFilter.not_set or
                                self.overflow_threshold_limit.yfilter != YFilter.not_set or
                                self.overflow_threshold_percent.yfilter != YFilter.not_set or
                                self.overflow_threshold_value.yfilter != YFilter.not_set or
                                self.underflow_threshold_limit.yfilter != YFilter.not_set or
                                self.underflow_threshold_percent.yfilter != YFilter.not_set or
                                self.underflow_threshold_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_threshold_percent.is_set or self.adjustment_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_percent.get_name_leafdata())
                            if (self.adjustment_threshold_value.is_set or self.adjustment_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_value.get_name_leafdata())
                            if (self.application_frequency.is_set or self.application_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_frequency.get_name_leafdata())
                            if (self.collection_frequency.is_set or self.collection_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_frequency.get_name_leafdata())
                            if (self.is_auto_bandwidth_collect_only.is_set or self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_collect_only.get_name_leafdata())
                            if (self.maximum_bandwidth.is_set or self.maximum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_bandwidth.get_name_leafdata())
                            if (self.minimum_bandwidth.is_set or self.minimum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.minimum_bandwidth.get_name_leafdata())
                            if (self.overflow_threshold_limit.is_set or self.overflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_limit.get_name_leafdata())
                            if (self.overflow_threshold_percent.is_set or self.overflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_percent.get_name_leafdata())
                            if (self.overflow_threshold_value.is_set or self.overflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_value.get_name_leafdata())
                            if (self.underflow_threshold_limit.is_set or self.underflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_limit.get_name_leafdata())
                            if (self.underflow_threshold_percent.is_set or self.underflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_percent.get_name_leafdata())
                            if (self.underflow_threshold_value.is_set or self.underflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "adjustment-threshold-percent" or name == "adjustment-threshold-value" or name == "application-frequency" or name == "collection-frequency" or name == "is-auto-bandwidth-collect-only" or name == "maximum-bandwidth" or name == "minimum-bandwidth" or name == "overflow-threshold-limit" or name == "overflow-threshold-percent" or name == "overflow-threshold-value" or name == "underflow-threshold-limit" or name == "underflow-threshold-percent" or name == "underflow-threshold-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-threshold-percent"):
                                self.adjustment_threshold_percent = value
                                self.adjustment_threshold_percent.value_namespace = name_space
                                self.adjustment_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "adjustment-threshold-value"):
                                self.adjustment_threshold_value = value
                                self.adjustment_threshold_value.value_namespace = name_space
                                self.adjustment_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-frequency"):
                                self.application_frequency = value
                                self.application_frequency.value_namespace = name_space
                                self.application_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-frequency"):
                                self.collection_frequency = value
                                self.collection_frequency.value_namespace = name_space
                                self.collection_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-auto-bandwidth-collect-only"):
                                self.is_auto_bandwidth_collect_only = value
                                self.is_auto_bandwidth_collect_only.value_namespace = name_space
                                self.is_auto_bandwidth_collect_only.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-bandwidth"):
                                self.maximum_bandwidth = value
                                self.maximum_bandwidth.value_namespace = name_space
                                self.maximum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "minimum-bandwidth"):
                                self.minimum_bandwidth = value
                                self.minimum_bandwidth.value_namespace = name_space
                                self.minimum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-limit"):
                                self.overflow_threshold_limit = value
                                self.overflow_threshold_limit.value_namespace = name_space
                                self.overflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-percent"):
                                self.overflow_threshold_percent = value
                                self.overflow_threshold_percent.value_namespace = name_space
                                self.overflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-value"):
                                self.overflow_threshold_value = value
                                self.overflow_threshold_value.value_namespace = name_space
                                self.overflow_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-limit"):
                                self.underflow_threshold_limit = value
                                self.underflow_threshold_limit.value_namespace = name_space
                                self.underflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-percent"):
                                self.underflow_threshold_percent = value
                                self.underflow_threshold_percent.value_namespace = name_space
                                self.underflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-value"):
                                self.underflow_threshold_value = value
                                self.underflow_threshold_value.value_namespace = name_space
                                self.underflow_threshold_value.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthOper(Entity):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:   :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:   :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"

                            self.application_jitter = YLeaf(YType.uint32, "application-jitter")

                            self.application_reject_reason = YLeaf(YType.enumeration, "application-reject-reason")

                            self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                            self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                            self.collect_only_requested_bandwidth = YLeaf(YType.uint32, "collect-only-requested-bandwidth")

                            self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                            self.last_application_trigger = YLeaf(YType.enumeration, "last-application-trigger")

                            self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                            self.overflow_early_bw_applications = YLeaf(YType.uint32, "overflow-early-bw-applications")

                            self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                            self.threshold_overflows = YLeaf(YType.uint32, "threshold-overflows")

                            self.threshold_underflows = YLeaf(YType.uint32, "threshold-underflows")

                            self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                            self.time_left_collection = YLeaf(YType.uint32, "time-left-collection")

                            self.underflow_early_bw_applications = YLeaf(YType.uint32, "underflow-early-bw-applications")

                            self.underflow_highest_bandwidth = YLeaf(YType.uint32, "underflow-highest-bandwidth")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_jitter",
                                            "application_reject_reason",
                                            "bandwidth_applications",
                                            "bandwidth_pool_type",
                                            "collect_only_requested_bandwidth",
                                            "highest_bandwidth",
                                            "last_application_trigger",
                                            "last_bandwidth_applied",
                                            "overflow_early_bw_applications",
                                            "samples_collected",
                                            "threshold_overflows",
                                            "threshold_underflows",
                                            "time_left_application",
                                            "time_left_collection",
                                            "underflow_early_bw_applications",
                                            "underflow_highest_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_jitter.is_set or
                                self.application_reject_reason.is_set or
                                self.bandwidth_applications.is_set or
                                self.bandwidth_pool_type.is_set or
                                self.collect_only_requested_bandwidth.is_set or
                                self.highest_bandwidth.is_set or
                                self.last_application_trigger.is_set or
                                self.last_bandwidth_applied.is_set or
                                self.overflow_early_bw_applications.is_set or
                                self.samples_collected.is_set or
                                self.threshold_overflows.is_set or
                                self.threshold_underflows.is_set or
                                self.time_left_application.is_set or
                                self.time_left_collection.is_set or
                                self.underflow_early_bw_applications.is_set or
                                self.underflow_highest_bandwidth.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_jitter.yfilter != YFilter.not_set or
                                self.application_reject_reason.yfilter != YFilter.not_set or
                                self.bandwidth_applications.yfilter != YFilter.not_set or
                                self.bandwidth_pool_type.yfilter != YFilter.not_set or
                                self.collect_only_requested_bandwidth.yfilter != YFilter.not_set or
                                self.highest_bandwidth.yfilter != YFilter.not_set or
                                self.last_application_trigger.yfilter != YFilter.not_set or
                                self.last_bandwidth_applied.yfilter != YFilter.not_set or
                                self.overflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.samples_collected.yfilter != YFilter.not_set or
                                self.threshold_overflows.yfilter != YFilter.not_set or
                                self.threshold_underflows.yfilter != YFilter.not_set or
                                self.time_left_application.yfilter != YFilter.not_set or
                                self.time_left_collection.yfilter != YFilter.not_set or
                                self.underflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.underflow_highest_bandwidth.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-oper" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_jitter.is_set or self.application_jitter.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_jitter.get_name_leafdata())
                            if (self.application_reject_reason.is_set or self.application_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_reject_reason.get_name_leafdata())
                            if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                            if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                            if (self.collect_only_requested_bandwidth.is_set or self.collect_only_requested_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collect_only_requested_bandwidth.get_name_leafdata())
                            if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                            if (self.last_application_trigger.is_set or self.last_application_trigger.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_trigger.get_name_leafdata())
                            if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                            if (self.overflow_early_bw_applications.is_set or self.overflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_early_bw_applications.get_name_leafdata())
                            if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.samples_collected.get_name_leafdata())
                            if (self.threshold_overflows.is_set or self.threshold_overflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_overflows.get_name_leafdata())
                            if (self.threshold_underflows.is_set or self.threshold_underflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_underflows.get_name_leafdata())
                            if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_application.get_name_leafdata())
                            if (self.time_left_collection.is_set or self.time_left_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_collection.get_name_leafdata())
                            if (self.underflow_early_bw_applications.is_set or self.underflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_early_bw_applications.get_name_leafdata())
                            if (self.underflow_highest_bandwidth.is_set or self.underflow_highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_highest_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-jitter" or name == "application-reject-reason" or name == "bandwidth-applications" or name == "bandwidth-pool-type" or name == "collect-only-requested-bandwidth" or name == "highest-bandwidth" or name == "last-application-trigger" or name == "last-bandwidth-applied" or name == "overflow-early-bw-applications" or name == "samples-collected" or name == "threshold-overflows" or name == "threshold-underflows" or name == "time-left-application" or name == "time-left-collection" or name == "underflow-early-bw-applications" or name == "underflow-highest-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-jitter"):
                                self.application_jitter = value
                                self.application_jitter.value_namespace = name_space
                                self.application_jitter.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-reject-reason"):
                                self.application_reject_reason = value
                                self.application_reject_reason.value_namespace = name_space
                                self.application_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-applications"):
                                self.bandwidth_applications = value
                                self.bandwidth_applications.value_namespace = name_space
                                self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-pool-type"):
                                self.bandwidth_pool_type = value
                                self.bandwidth_pool_type.value_namespace = name_space
                                self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "collect-only-requested-bandwidth"):
                                self.collect_only_requested_bandwidth = value
                                self.collect_only_requested_bandwidth.value_namespace = name_space
                                self.collect_only_requested_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "highest-bandwidth"):
                                self.highest_bandwidth = value
                                self.highest_bandwidth.value_namespace = name_space
                                self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-trigger"):
                                self.last_application_trigger = value
                                self.last_application_trigger.value_namespace = name_space
                                self.last_application_trigger.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-bandwidth-applied"):
                                self.last_bandwidth_applied = value
                                self.last_bandwidth_applied.value_namespace = name_space
                                self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-early-bw-applications"):
                                self.overflow_early_bw_applications = value
                                self.overflow_early_bw_applications.value_namespace = name_space
                                self.overflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "samples-collected"):
                                self.samples_collected = value
                                self.samples_collected.value_namespace = name_space
                                self.samples_collected.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-overflows"):
                                self.threshold_overflows = value
                                self.threshold_overflows.value_namespace = name_space
                                self.threshold_overflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-underflows"):
                                self.threshold_underflows = value
                                self.threshold_underflows.value_namespace = name_space
                                self.threshold_underflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-application"):
                                self.time_left_application = value
                                self.time_left_application.value_namespace = name_space
                                self.time_left_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-collection"):
                                self.time_left_collection = value
                                self.time_left_collection.value_namespace = name_space
                                self.time_left_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-early-bw-applications"):
                                self.underflow_early_bw_applications = value
                                self.underflow_early_bw_applications.value_namespace = name_space
                                self.underflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-highest-bandwidth"):
                                self.underflow_highest_bandwidth = value
                                self.underflow_highest_bandwidth.value_namespace = name_space
                                self.underflow_highest_bandwidth.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.is_bidirectional.is_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_data()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_data()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bidirectional.yfilter != YFilter.not_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_operation()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_operation()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "p2p-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bidirectional.is_set or self.is_bidirectional.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bidirectional.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "auto-bandwidth-config"):
                            if (self.auto_bandwidth_config is None):
                                self.auto_bandwidth_config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig()
                                self.auto_bandwidth_config.parent = self
                                self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                            return self.auto_bandwidth_config

                        if (child_yang_name == "auto-bandwidth-oper"):
                            if (self.auto_bandwidth_oper is None):
                                self.auto_bandwidth_oper = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper()
                                self.auto_bandwidth_oper.parent = self
                                self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                            return self.auto_bandwidth_oper

                        if (child_yang_name == "auto-bandwidth-status"):
                            if (self.auto_bandwidth_status is None):
                                self.auto_bandwidth_status = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus()
                                self.auto_bandwidth_status.parent = self
                                self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                            return self.auto_bandwidth_status

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-bandwidth-config" or name == "auto-bandwidth-oper" or name == "auto-bandwidth-status" or name == "is-bidirectional"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bidirectional"):
                            self.is_bidirectional = value
                            self.is_bidirectional.value_namespace = name_space
                            self.is_bidirectional.value_namespace_prefix = name_space_prefix


                class History(Entity):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:   :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup>`
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:   :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup>`
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:   :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup>`
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:   :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup>`
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:   :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail>`
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:   :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail>`
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:   :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup>`
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:   :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup>`
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:   :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup>`
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:   :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup>`
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:   :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "tunnel-head"

                        self.current_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"
                        self._children_yang_names.add("current-setup")

                        self.gmpls_other_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                        self._children_yang_names.add("gmpls-other-protect-setup")

                        self.gmpls_other_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                        self._children_yang_names.add("gmpls-other-setup")

                        self.gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                        self._children_yang_names.add("gmpls-path-protect-setup")

                        self.last_re_opt_fail = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                        self._children_yang_names.add("last-re-opt-fail")

                        self.last_stdby_re_opt_fail = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._children_yang_names.add("last-stdby-re-opt-fail")

                        self.previous_gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                        self._children_yang_names.add("previous-gmpls-path-protect-setup")

                        self.previous_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"
                        self._children_yang_names.add("previous-setup")

                        self.reopt_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"
                        self._children_yang_names.add("reopt-setup")

                        self.standby_reopt_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                        self._children_yang_names.add("standby-reopt-setup")

                        self.standby_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"
                        self._children_yang_names.add("standby-setup")


                    class CurrentSetup(Entity):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:   :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes>`
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\:  str
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"

                            self.current_setup_last_error = YLeaf(YType.str, "current-setup-last-error")

                            self.current_setup_timer = YLeaf(YType.uint32, "current-setup-timer")

                            self.selection_reason = YLeaf(YType.str, "selection-reason")

                            self.connected_uptimes = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._children_yang_names.add("connected-uptimes")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("current_setup_last_error",
                                            "current_setup_timer",
                                            "selection_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__setattr__(name, value)


                        class ConnectedUptimes(Entity):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"

                                self.current_lsp_uptime = YLeaf(YType.uint32, "current-lsp-uptime")

                                self.current_uptime = YLeaf(YType.uint32, "current-uptime")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("current_lsp_uptime",
                                                "current_uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.current_lsp_uptime.is_set or
                                    self.current_uptime.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.current_lsp_uptime.yfilter != YFilter.not_set or
                                    self.current_uptime.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "connected-uptimes" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.current_lsp_uptime.is_set or self.current_lsp_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_lsp_uptime.get_name_leafdata())
                                if (self.current_uptime.is_set or self.current_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "current-lsp-uptime" or name == "current-uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "current-lsp-uptime"):
                                    self.current_lsp_uptime = value
                                    self.current_lsp_uptime.value_namespace = name_space
                                    self.current_lsp_uptime.value_namespace_prefix = name_space_prefix
                                if(value_path == "current-uptime"):
                                    self.current_uptime = value
                                    self.current_uptime.value_namespace = name_space
                                    self.current_uptime.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.current_setup_last_error.is_set or
                                self.current_setup_timer.is_set or
                                self.selection_reason.is_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.current_setup_last_error.yfilter != YFilter.not_set or
                                self.current_setup_timer.yfilter != YFilter.not_set or
                                self.selection_reason.yfilter != YFilter.not_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "current-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.current_setup_last_error.is_set or self.current_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_last_error.get_name_leafdata())
                            if (self.current_setup_timer.is_set or self.current_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_timer.get_name_leafdata())
                            if (self.selection_reason.is_set or self.selection_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.selection_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "connected-uptimes"):
                                if (self.connected_uptimes is None):
                                    self.connected_uptimes = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                                    self.connected_uptimes.parent = self
                                    self._children_name_map["connected_uptimes"] = "connected-uptimes"
                                return self.connected_uptimes

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "connected-uptimes" or name == "current-setup-last-error" or name == "current-setup-timer" or name == "selection-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "current-setup-last-error"):
                                self.current_setup_last_error = value
                                self.current_setup_last_error.value_namespace = name_space
                                self.current_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "current-setup-timer"):
                                self.current_setup_timer = value
                                self.current_setup_timer.value_namespace = name_space
                                self.current_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "selection-reason"):
                                self.selection_reason = value
                                self.selection_reason.value_namespace = name_space
                                self.selection_reason.value_namespace_prefix = name_space_prefix


                    class ReoptSetup(Entity):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class GmplsPathProtectSetup(Entity):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\:  str
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.protecting_setup_last_error = YLeaf(YType.str, "protecting-setup-last-error")

                            self.protecting_setup_timer = YLeaf(YType.uint32, "protecting-setup-timer")

                            self.protecting_setup_uptime = YLeaf(YType.uint32, "protecting-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protecting_setup_last_error",
                                            "protecting_setup_timer",
                                            "protecting_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.protecting_setup_last_error.is_set or
                                self.protecting_setup_timer.is_set or
                                self.protecting_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protecting_setup_last_error.yfilter != YFilter.not_set or
                                self.protecting_setup_timer.yfilter != YFilter.not_set or
                                self.protecting_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protecting_setup_last_error.is_set or self.protecting_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_last_error.get_name_leafdata())
                            if (self.protecting_setup_timer.is_set or self.protecting_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_timer.get_name_leafdata())
                            if (self.protecting_setup_uptime.is_set or self.protecting_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protecting-setup-last-error" or name == "protecting-setup-timer" or name == "protecting-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protecting-setup-last-error"):
                                self.protecting_setup_last_error = value
                                self.protecting_setup_last_error.value_namespace = name_space
                                self.protecting_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-timer"):
                                self.protecting_setup_timer = value
                                self.protecting_setup_timer.value_namespace = name_space
                                self.protecting_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-uptime"):
                                self.protecting_setup_uptime = value
                                self.protecting_setup_uptime.value_namespace = name_space
                                self.protecting_setup_uptime.value_namespace_prefix = name_space_prefix


                    class PreviousSetup(Entity):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"

                            self.previous_fail_reason = YLeaf(YType.str, "previous-fail-reason")

                            self.previous_path_option = YLeaf(YType.str, "previous-path-option")

                            self.previous_setup_last_error = YLeaf(YType.str, "previous-setup-last-error")

                            self.previous_tunnel_instance = YLeaf(YType.uint32, "previous-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_fail_reason",
                                            "previous_path_option",
                                            "previous_setup_last_error",
                                            "previous_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_fail_reason.is_set or
                                self.previous_path_option.is_set or
                                self.previous_setup_last_error.is_set or
                                self.previous_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_fail_reason.yfilter != YFilter.not_set or
                                self.previous_path_option.yfilter != YFilter.not_set or
                                self.previous_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_fail_reason.is_set or self.previous_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_fail_reason.get_name_leafdata())
                            if (self.previous_path_option.is_set or self.previous_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_path_option.get_name_leafdata())
                            if (self.previous_setup_last_error.is_set or self.previous_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_setup_last_error.get_name_leafdata())
                            if (self.previous_tunnel_instance.is_set or self.previous_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-fail-reason" or name == "previous-path-option" or name == "previous-setup-last-error" or name == "previous-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-fail-reason"):
                                self.previous_fail_reason = value
                                self.previous_fail_reason.value_namespace = name_space
                                self.previous_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-path-option"):
                                self.previous_path_option = value
                                self.previous_path_option.value_namespace = name_space
                                self.previous_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-setup-last-error"):
                                self.previous_setup_last_error = value
                                self.previous_setup_last_error.value_namespace = name_space
                                self.previous_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-tunnel-instance"):
                                self.previous_tunnel_instance = value
                                self.previous_tunnel_instance.value_namespace = name_space
                                self.previous_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class PreviousGmplsPathProtectSetup(Entity):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.previous_protect_fail_reason = YLeaf(YType.str, "previous-protect-fail-reason")

                            self.previous_protect_path_option = YLeaf(YType.str, "previous-protect-path-option")

                            self.previous_protect_setup_last_error = YLeaf(YType.str, "previous-protect-setup-last-error")

                            self.previous_protect_tunnel_instance = YLeaf(YType.uint32, "previous-protect-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_protect_fail_reason",
                                            "previous_protect_path_option",
                                            "previous_protect_setup_last_error",
                                            "previous_protect_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_protect_fail_reason.is_set or
                                self.previous_protect_path_option.is_set or
                                self.previous_protect_setup_last_error.is_set or
                                self.previous_protect_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_protect_fail_reason.yfilter != YFilter.not_set or
                                self.previous_protect_path_option.yfilter != YFilter.not_set or
                                self.previous_protect_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_protect_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_protect_fail_reason.is_set or self.previous_protect_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_fail_reason.get_name_leafdata())
                            if (self.previous_protect_path_option.is_set or self.previous_protect_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_path_option.get_name_leafdata())
                            if (self.previous_protect_setup_last_error.is_set or self.previous_protect_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_setup_last_error.get_name_leafdata())
                            if (self.previous_protect_tunnel_instance.is_set or self.previous_protect_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-protect-fail-reason" or name == "previous-protect-path-option" or name == "previous-protect-setup-last-error" or name == "previous-protect-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-protect-fail-reason"):
                                self.previous_protect_fail_reason = value
                                self.previous_protect_fail_reason.value_namespace = name_space
                                self.previous_protect_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-path-option"):
                                self.previous_protect_path_option = value
                                self.previous_protect_path_option.value_namespace = name_space
                                self.previous_protect_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-setup-last-error"):
                                self.previous_protect_setup_last_error = value
                                self.previous_protect_setup_last_error.value_namespace = name_space
                                self.previous_protect_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-tunnel-instance"):
                                self.previous_protect_tunnel_instance = value
                                self.previous_protect_tunnel_instance.value_namespace = name_space
                                self.previous_protect_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class GmplsOtherSetup(Entity):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class GmplsOtherProtectSetup(Entity):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class StandbySetup(Entity):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"

                            self.standby_lsp_uptime = YLeaf(YType.uint32, "standby-lsp-uptime")

                            self.standby_setup_timer = YLeaf(YType.uint32, "standby-setup-timer")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("standby_lsp_uptime",
                                            "standby_setup_timer") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.standby_lsp_uptime.is_set or
                                self.standby_setup_timer.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.standby_lsp_uptime.yfilter != YFilter.not_set or
                                self.standby_setup_timer.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.standby_lsp_uptime.is_set or self.standby_lsp_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_lsp_uptime.get_name_leafdata())
                            if (self.standby_setup_timer.is_set or self.standby_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_setup_timer.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "standby-lsp-uptime" or name == "standby-setup-timer"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "standby-lsp-uptime"):
                                self.standby_lsp_uptime = value
                                self.standby_lsp_uptime.value_namespace = name_space
                                self.standby_lsp_uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "standby-setup-timer"):
                                self.standby_setup_timer = value
                                self.standby_setup_timer.value_namespace = name_space
                                self.standby_setup_timer.value_namespace_prefix = name_space_prefix


                    class StandbyReoptSetup(Entity):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class LastReOptFail(Entity):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix


                    class LastStdbyReOptFail(Entity):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-stdby-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.current_setup is not None and self.current_setup.has_data()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_data()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_data()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_data()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_data()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_data()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_data()) or
                            (self.previous_setup is not None and self.previous_setup.has_data()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_data()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_data()) or
                            (self.standby_setup is not None and self.standby_setup.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.current_setup is not None and self.current_setup.has_operation()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_operation()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_operation()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_operation()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_operation()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_operation()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_operation()) or
                            (self.previous_setup is not None and self.previous_setup.has_operation()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_operation()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_operation()) or
                            (self.standby_setup is not None and self.standby_setup.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "current-setup"):
                            if (self.current_setup is None):
                                self.current_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                                self.current_setup.parent = self
                                self._children_name_map["current_setup"] = "current-setup"
                            return self.current_setup

                        if (child_yang_name == "gmpls-other-protect-setup"):
                            if (self.gmpls_other_protect_setup is None):
                                self.gmpls_other_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                                self.gmpls_other_protect_setup.parent = self
                                self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                            return self.gmpls_other_protect_setup

                        if (child_yang_name == "gmpls-other-setup"):
                            if (self.gmpls_other_setup is None):
                                self.gmpls_other_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                                self.gmpls_other_setup.parent = self
                                self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                            return self.gmpls_other_setup

                        if (child_yang_name == "gmpls-path-protect-setup"):
                            if (self.gmpls_path_protect_setup is None):
                                self.gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                                self.gmpls_path_protect_setup.parent = self
                                self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                            return self.gmpls_path_protect_setup

                        if (child_yang_name == "last-re-opt-fail"):
                            if (self.last_re_opt_fail is None):
                                self.last_re_opt_fail = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                                self.last_re_opt_fail.parent = self
                                self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                            return self.last_re_opt_fail

                        if (child_yang_name == "last-stdby-re-opt-fail"):
                            if (self.last_stdby_re_opt_fail is None):
                                self.last_stdby_re_opt_fail = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                                self.last_stdby_re_opt_fail.parent = self
                                self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                            return self.last_stdby_re_opt_fail

                        if (child_yang_name == "previous-gmpls-path-protect-setup"):
                            if (self.previous_gmpls_path_protect_setup is None):
                                self.previous_gmpls_path_protect_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                                self.previous_gmpls_path_protect_setup.parent = self
                                self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                            return self.previous_gmpls_path_protect_setup

                        if (child_yang_name == "previous-setup"):
                            if (self.previous_setup is None):
                                self.previous_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                                self.previous_setup.parent = self
                                self._children_name_map["previous_setup"] = "previous-setup"
                            return self.previous_setup

                        if (child_yang_name == "reopt-setup"):
                            if (self.reopt_setup is None):
                                self.reopt_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                                self.reopt_setup.parent = self
                                self._children_name_map["reopt_setup"] = "reopt-setup"
                            return self.reopt_setup

                        if (child_yang_name == "standby-reopt-setup"):
                            if (self.standby_reopt_setup is None):
                                self.standby_reopt_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                                self.standby_reopt_setup.parent = self
                                self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                            return self.standby_reopt_setup

                        if (child_yang_name == "standby-setup"):
                            if (self.standby_setup is None):
                                self.standby_setup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                                self.standby_setup.parent = self
                                self._children_name_map["standby_setup"] = "standby-setup"
                            return self.standby_setup

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "current-setup" or name == "gmpls-other-protect-setup" or name == "gmpls-other-setup" or name == "gmpls-path-protect-setup" or name == "last-re-opt-fail" or name == "last-stdby-re-opt-fail" or name == "previous-gmpls-path-protect-setup" or name == "previous-setup" or name == "reopt-setup" or name == "standby-reopt-setup" or name == "standby-setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-head"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class AutoBackup(Entity):
                    """
                    Autobackup Information
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\:  str
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of    :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep>`
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\:  bool
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\:  bool
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\:  str
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:   :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "tunnel-head"

                        self.ab_protected_interface = YLeaf(YType.str, "ab-protected-interface")

                        self.ab_protection_type = YLeaf(YType.enumeration, "ab-protection-type")

                        self.is_unused_removal_timer_running = YLeaf(YType.boolean, "is-unused-removal-timer-running")

                        self.is_using_srlg = YLeaf(YType.boolean, "is-using-srlg")

                        self.protected_address = YLeaf(YType.str, "protected-address")

                        self.protected_ls_ps = YLeaf(YType.uint32, "protected-ls-ps")

                        self.protected_s2_ls = YLeaf(YType.uint32, "protected-s2-ls")

                        self.sharing_families = YLeaf(YType.uint32, "sharing-families")

                        self.srlg_prot_type = YLeaf(YType.enumeration, "srlg-prot-type")

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.unused_removal_remaining_time = YLeaf(YType.uint32, "unused-removal-remaining-time")

                        self.weighted_srlg_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                        self._children_yang_names.add("weighted-srlg-info")

                        self.iep = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("ab_protected_interface",
                                        "ab_protection_type",
                                        "is_unused_removal_timer_running",
                                        "is_using_srlg",
                                        "protected_address",
                                        "protected_ls_ps",
                                        "protected_s2_ls",
                                        "sharing_families",
                                        "srlg_prot_type",
                                        "tunnel_attribute_set_name",
                                        "unused_removal_remaining_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__setattr__(name, value)


                    class WeightedSrlgInfo(Entity):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of    :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of    :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)


                        class ProtectedInterfaceSrlg(Entity):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                                self.srlg = YLeaf(YType.uint32, "srlg")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admin_weight",
                                                "srlg",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admin_weight.is_set or
                                    self.srlg.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admin_weight.yfilter != YFilter.not_set or
                                    self.srlg.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protected-interface-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                                if (self.srlg.is_set or self.srlg.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admin-weight" or name == "srlg" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admin-weight"):
                                    self.admin_weight = value
                                    self.admin_weight.value_namespace = name_space
                                    self.admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg"):
                                    self.srlg = value
                                    self.srlg.value_namespace = name_space
                                    self.srlg.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class WeightedSrlgHop(Entity):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of    :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.aggregate_admin_weight = YLeaf(YType.uint64, "aggregate-admin-weight")

                                self.from_address = YLeaf(YType.str, "from-address")

                                self.to_address = YLeaf(YType.str, "to-address")

                                self.common_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("aggregate_admin_weight",
                                                "from_address",
                                                "to_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)


                            class CommonSrlg(Entity):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "common-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.common_srlg:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.aggregate_admin_weight.is_set or
                                    self.from_address.is_set or
                                    self.to_address.is_set)

                            def has_operation(self):
                                for c in self.common_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.aggregate_admin_weight.yfilter != YFilter.not_set or
                                    self.from_address.yfilter != YFilter.not_set or
                                    self.to_address.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "weighted-srlg-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.aggregate_admin_weight.is_set or self.aggregate_admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.aggregate_admin_weight.get_name_leafdata())
                                if (self.from_address.is_set or self.from_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.from_address.get_name_leafdata())
                                if (self.to_address.is_set or self.to_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.to_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "common-srlg"):
                                    for c in self.common_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.common_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "common-srlg" or name == "aggregate-admin-weight" or name == "from-address" or name == "to-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "aggregate-admin-weight"):
                                    self.aggregate_admin_weight = value
                                    self.aggregate_admin_weight.value_namespace = name_space
                                    self.aggregate_admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "from-address"):
                                    self.from_address = value
                                    self.from_address.value_namespace = name_space
                                    self.from_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "to-address"):
                                    self.to_address = value
                                    self.to_address.value_namespace = name_space
                                    self.to_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_data()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_operation()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "weighted-srlg-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protected-interface-srlg"):
                                for c in self.protected_interface_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protected_interface_srlg.append(c)
                                return c

                            if (child_yang_name == "weighted-srlg-hop"):
                                for c in self.weighted_srlg_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.weighted_srlg_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface-srlg" or name == "weighted-srlg-hop"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Iep(Entity):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of    :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop>`
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"

                            self.path_option_id = YLeaf(YType.uint32, "path-option-id")

                            self.iep_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("path_option_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__setattr__(name, value)


                        class IepHop(Entity):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:   :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"

                                self.hop_index = YLeaf(YType.uint32, "hop-index")

                                self.iep_hop_address = YLeaf(YType.str, "iep-hop-address")

                                self.iep_hop_type = YLeaf(YType.enumeration, "iep-hop-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_index",
                                                "iep_hop_address",
                                                "iep_hop_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.hop_index.is_set or
                                    self.iep_hop_address.is_set or
                                    self.iep_hop_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_index.yfilter != YFilter.not_set or
                                    self.iep_hop_address.yfilter != YFilter.not_set or
                                    self.iep_hop_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iep-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_index.is_set or self.hop_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_index.get_name_leafdata())
                                if (self.iep_hop_address.is_set or self.iep_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_address.get_name_leafdata())
                                if (self.iep_hop_type.is_set or self.iep_hop_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-index" or name == "iep-hop-address" or name == "iep-hop-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-index"):
                                    self.hop_index = value
                                    self.hop_index.value_namespace = name_space
                                    self.hop_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-address"):
                                    self.iep_hop_address = value
                                    self.iep_hop_address.value_namespace = name_space
                                    self.iep_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-type"):
                                    self.iep_hop_type = value
                                    self.iep_hop_type.value_namespace = name_space
                                    self.iep_hop_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.iep_hop:
                                if (c.has_data()):
                                    return True
                            return self.path_option_id.is_set

                        def has_operation(self):
                            for c in self.iep_hop:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.path_option_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "iep" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.path_option_id.is_set or self.path_option_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "iep-hop"):
                                for c in self.iep_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.iep_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "iep-hop" or name == "path-option-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "path-option-id"):
                                self.path_option_id = value
                                self.path_option_id.value_namespace = name_space
                                self.path_option_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.iep:
                            if (c.has_data()):
                                return True
                        return (
                            self.ab_protected_interface.is_set or
                            self.ab_protection_type.is_set or
                            self.is_unused_removal_timer_running.is_set or
                            self.is_using_srlg.is_set or
                            self.protected_address.is_set or
                            self.protected_ls_ps.is_set or
                            self.protected_s2_ls.is_set or
                            self.sharing_families.is_set or
                            self.srlg_prot_type.is_set or
                            self.tunnel_attribute_set_name.is_set or
                            self.unused_removal_remaining_time.is_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_data()))

                    def has_operation(self):
                        for c in self.iep:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.ab_protected_interface.yfilter != YFilter.not_set or
                            self.ab_protection_type.yfilter != YFilter.not_set or
                            self.is_unused_removal_timer_running.yfilter != YFilter.not_set or
                            self.is_using_srlg.yfilter != YFilter.not_set or
                            self.protected_address.yfilter != YFilter.not_set or
                            self.protected_ls_ps.yfilter != YFilter.not_set or
                            self.protected_s2_ls.yfilter != YFilter.not_set or
                            self.sharing_families.yfilter != YFilter.not_set or
                            self.srlg_prot_type.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.unused_removal_remaining_time.yfilter != YFilter.not_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-backup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.ab_protected_interface.is_set or self.ab_protected_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protected_interface.get_name_leafdata())
                        if (self.ab_protection_type.is_set or self.ab_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protection_type.get_name_leafdata())
                        if (self.is_unused_removal_timer_running.is_set or self.is_unused_removal_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unused_removal_timer_running.get_name_leafdata())
                        if (self.is_using_srlg.is_set or self.is_using_srlg.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_using_srlg.get_name_leafdata())
                        if (self.protected_address.is_set or self.protected_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_address.get_name_leafdata())
                        if (self.protected_ls_ps.is_set or self.protected_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_ls_ps.get_name_leafdata())
                        if (self.protected_s2_ls.is_set or self.protected_s2_ls.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_s2_ls.get_name_leafdata())
                        if (self.sharing_families.is_set or self.sharing_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sharing_families.get_name_leafdata())
                        if (self.srlg_prot_type.is_set or self.srlg_prot_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_prot_type.get_name_leafdata())
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.unused_removal_remaining_time.is_set or self.unused_removal_remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unused_removal_remaining_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "iep"):
                            for c in self.iep:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.iep.append(c)
                            return c

                        if (child_yang_name == "weighted-srlg-info"):
                            if (self.weighted_srlg_info is None):
                                self.weighted_srlg_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                                self.weighted_srlg_info.parent = self
                                self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                            return self.weighted_srlg_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "iep" or name == "weighted-srlg-info" or name == "ab-protected-interface" or name == "ab-protection-type" or name == "is-unused-removal-timer-running" or name == "is-using-srlg" or name == "protected-address" or name == "protected-ls-ps" or name == "protected-s2-ls" or name == "sharing-families" or name == "srlg-prot-type" or name == "tunnel-attribute-set-name" or name == "unused-removal-remaining-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "ab-protected-interface"):
                            self.ab_protected_interface = value
                            self.ab_protected_interface.value_namespace = name_space
                            self.ab_protected_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ab-protection-type"):
                            self.ab_protection_type = value
                            self.ab_protection_type.value_namespace = name_space
                            self.ab_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unused-removal-timer-running"):
                            self.is_unused_removal_timer_running = value
                            self.is_unused_removal_timer_running.value_namespace = name_space
                            self.is_unused_removal_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-using-srlg"):
                            self.is_using_srlg = value
                            self.is_using_srlg.value_namespace = name_space
                            self.is_using_srlg.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-address"):
                            self.protected_address = value
                            self.protected_address.value_namespace = name_space
                            self.protected_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-ls-ps"):
                            self.protected_ls_ps = value
                            self.protected_ls_ps.value_namespace = name_space
                            self.protected_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-s2-ls"):
                            self.protected_s2_ls = value
                            self.protected_s2_ls.value_namespace = name_space
                            self.protected_s2_ls.value_namespace_prefix = name_space_prefix
                        if(value_path == "sharing-families"):
                            self.sharing_families = value
                            self.sharing_families.value_namespace = name_space
                            self.sharing_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-prot-type"):
                            self.srlg_prot_type = value
                            self.srlg_prot_type.value_namespace = name_space
                            self.srlg_prot_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "unused-removal-remaining-time"):
                            self.unused_removal_remaining_time = value
                            self.unused_removal_remaining_time.value_namespace = name_space
                            self.unused_removal_remaining_time.value_namespace_prefix = name_space_prefix


                class AutoMesh(Entity):
                    """
                    Automesh Information
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "tunnel-head"

                        self.is_tunnel_unused_timer_running = YLeaf(YType.boolean, "is-tunnel-unused-timer-running")

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.mesh_group_type = YLeaf(YType.enumeration, "mesh-group-type")

                        self.remaining_unused_time = YLeaf(YType.uint32, "remaining-unused-time")

                        self.tunnel_destination_list_name = YLeaf(YType.str, "tunnel-destination-list-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_tunnel_unused_timer_running",
                                        "mesh_group_id",
                                        "mesh_group_type",
                                        "remaining_unused_time",
                                        "tunnel_destination_list_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_tunnel_unused_timer_running.is_set or
                            self.mesh_group_id.is_set or
                            self.mesh_group_type.is_set or
                            self.remaining_unused_time.is_set or
                            self.tunnel_destination_list_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.mesh_group_type.yfilter != YFilter.not_set or
                            self.remaining_unused_time.yfilter != YFilter.not_set or
                            self.tunnel_destination_list_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-mesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_tunnel_unused_timer_running.is_set or self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_tunnel_unused_timer_running.get_name_leafdata())
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.mesh_group_type.is_set or self.mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_type.get_name_leafdata())
                        if (self.remaining_unused_time.is_set or self.remaining_unused_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_unused_time.get_name_leafdata())
                        if (self.tunnel_destination_list_name.is_set or self.tunnel_destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_destination_list_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-tunnel-unused-timer-running" or name == "mesh-group-id" or name == "mesh-group-type" or name == "remaining-unused-time" or name == "tunnel-destination-list-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-tunnel-unused-timer-running"):
                            self.is_tunnel_unused_timer_running = value
                            self.is_tunnel_unused_timer_running.value_namespace = name_space
                            self.is_tunnel_unused_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-type"):
                            self.mesh_group_type = value
                            self.mesh_group_type.value_namespace = name_space
                            self.mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-unused-time"):
                            self.remaining_unused_time = value
                            self.remaining_unused_time.value_namespace = name_space
                            self.remaining_unused_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-destination-list-name"):
                            self.tunnel_destination_list_name = value
                            self.tunnel_destination_list_name.value_namespace = name_space
                            self.tunnel_destination_list_name.value_namespace_prefix = name_space_prefix


                class AutoPcc(Entity):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\:  str
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\:  bool
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "tunnel-head"

                        self.creator_address = YLeaf(YType.str, "creator-address")

                        self.creator_id = YLeaf(YType.str, "creator-id")

                        self.has_creator_id = YLeaf(YType.boolean, "has-creator-id")

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plspid = YLeaf(YType.uint32, "plspid")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("creator_address",
                                        "creator_id",
                                        "has_creator_id",
                                        "operationally_up",
                                        "owner_address",
                                        "plspid",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.creator_address.is_set or
                            self.creator_id.is_set or
                            self.has_creator_id.is_set or
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plspid.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.creator_address.yfilter != YFilter.not_set or
                            self.creator_id.yfilter != YFilter.not_set or
                            self.has_creator_id.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plspid.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-pcc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.creator_address.is_set or self.creator_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_address.get_name_leafdata())
                        if (self.creator_id.is_set or self.creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_id.get_name_leafdata())
                        if (self.has_creator_id.is_set or self.has_creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_creator_id.get_name_leafdata())
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plspid.is_set or self.plspid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plspid.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "creator-address" or name == "creator-id" or name == "has-creator-id" or name == "operationally-up" or name == "owner-address" or name == "plspid" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "creator-address"):
                            self.creator_address = value
                            self.creator_address.value_namespace = name_space
                            self.creator_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "creator-id"):
                            self.creator_id = value
                            self.creator_id.value_namespace = name_space
                            self.creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-creator-id"):
                            self.has_creator_id = value
                            self.has_creator_id.value_namespace = name_space
                            self.has_creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plspid"):
                            self.plspid = value
                            self.plspid.value_namespace = name_space
                            self.plspid.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class PceDelegation(Entity):
                    """
                    PCE Delegation information
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "tunnel-head"

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plsp_id = YLeaf(YType.uint32, "plsp-id")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("operationally_up",
                                        "owner_address",
                                        "plsp_id",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plsp_id.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plsp_id.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pce-delegation" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plsp_id.is_set or self.plsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plsp_id.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "operationally-up" or name == "owner-address" or name == "plsp-id" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plsp-id"):
                            self.plsp_id = value
                            self.plsp_id.value_namespace = name_space
                            self.plsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class SoftPreemption(Entity):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:   :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:   :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters>`
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of    :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError>`
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "tunnel-head"

                        self.preemption_pending_resolution = YLeaf(YType.enumeration, "preemption-pending-resolution")

                        self.status = YLeaf(YType.enumeration, "status")

                        self.time_in_preemption_pending = YLeaf(YType.uint16, "time-in-preemption-pending")

                        self.soft_preemption_counters = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                        self._children_yang_names.add("soft-preemption-counters")

                        self.soft_preemption_path_error = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("preemption_pending_resolution",
                                        "status",
                                        "time_in_preemption_pending") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__setattr__(name, value)


                    class SoftPreemptionCounters(Entity):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"

                            self.frr_triggered_ls_ps = YLeaf(YType.uint32, "frr-triggered-ls-ps")

                            self.path_protection_switchover_ls_ps = YLeaf(YType.uint32, "path-protection-switchover-ls-ps")

                            self.reopt_completed_ls_ps = YLeaf(YType.uint32, "reopt-completed-ls-ps")

                            self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                            self.time_in_preemption_pending_avg = YLeaf(YType.uint16, "time-in-preemption-pending-avg")

                            self.time_in_preemption_pending_max = YLeaf(YType.uint16, "time-in-preemption-pending-max")

                            self.time_in_preemption_pending_min = YLeaf(YType.uint16, "time-in-preemption-pending-min")

                            self.torn_down_ls_ps = YLeaf(YType.uint32, "torn-down-ls-ps")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_triggered_ls_ps",
                                            "path_protection_switchover_ls_ps",
                                            "reopt_completed_ls_ps",
                                            "soft_preemption_events",
                                            "time_in_preemption_pending_avg",
                                            "time_in_preemption_pending_max",
                                            "time_in_preemption_pending_min",
                                            "torn_down_ls_ps") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_triggered_ls_ps.is_set or
                                self.path_protection_switchover_ls_ps.is_set or
                                self.reopt_completed_ls_ps.is_set or
                                self.soft_preemption_events.is_set or
                                self.time_in_preemption_pending_avg.is_set or
                                self.time_in_preemption_pending_max.is_set or
                                self.time_in_preemption_pending_min.is_set or
                                self.torn_down_ls_ps.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_triggered_ls_ps.yfilter != YFilter.not_set or
                                self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set or
                                self.reopt_completed_ls_ps.yfilter != YFilter.not_set or
                                self.soft_preemption_events.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_avg.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_max.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_min.yfilter != YFilter.not_set or
                                self.torn_down_ls_ps.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_triggered_ls_ps.is_set or self.frr_triggered_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_triggered_ls_ps.get_name_leafdata())
                            if (self.path_protection_switchover_ls_ps.is_set or self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_ls_ps.get_name_leafdata())
                            if (self.reopt_completed_ls_ps.is_set or self.reopt_completed_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reopt_completed_ls_ps.get_name_leafdata())
                            if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                            if (self.time_in_preemption_pending_avg.is_set or self.time_in_preemption_pending_avg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_avg.get_name_leafdata())
                            if (self.time_in_preemption_pending_max.is_set or self.time_in_preemption_pending_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_max.get_name_leafdata())
                            if (self.time_in_preemption_pending_min.is_set or self.time_in_preemption_pending_min.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_min.get_name_leafdata())
                            if (self.torn_down_ls_ps.is_set or self.torn_down_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.torn_down_ls_ps.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-triggered-ls-ps" or name == "path-protection-switchover-ls-ps" or name == "reopt-completed-ls-ps" or name == "soft-preemption-events" or name == "time-in-preemption-pending-avg" or name == "time-in-preemption-pending-max" or name == "time-in-preemption-pending-min" or name == "torn-down-ls-ps"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-triggered-ls-ps"):
                                self.frr_triggered_ls_ps = value
                                self.frr_triggered_ls_ps.value_namespace = name_space
                                self.frr_triggered_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-ls-ps"):
                                self.path_protection_switchover_ls_ps = value
                                self.path_protection_switchover_ls_ps.value_namespace = name_space
                                self.path_protection_switchover_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "reopt-completed-ls-ps"):
                                self.reopt_completed_ls_ps = value
                                self.reopt_completed_ls_ps.value_namespace = name_space
                                self.reopt_completed_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-events"):
                                self.soft_preemption_events = value
                                self.soft_preemption_events.value_namespace = name_space
                                self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-avg"):
                                self.time_in_preemption_pending_avg = value
                                self.time_in_preemption_pending_avg.value_namespace = name_space
                                self.time_in_preemption_pending_avg.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-max"):
                                self.time_in_preemption_pending_max = value
                                self.time_in_preemption_pending_max.value_namespace = name_space
                                self.time_in_preemption_pending_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-min"):
                                self.time_in_preemption_pending_min = value
                                self.time_in_preemption_pending_min.value_namespace = name_space
                                self.time_in_preemption_pending_min.value_namespace_prefix = name_space_prefix
                            if(value_path == "torn-down-ls-ps"):
                                self.torn_down_ls_ps = value
                                self.torn_down_ls_ps.value_namespace = name_space
                                self.torn_down_ls_ps.value_namespace_prefix = name_space_prefix


                    class SoftPreemptionPathError(Entity):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preempting_link_address",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preempting_link_address.is_set or
                                self.timestamp.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-path-error" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preempting-link-address" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_data()):
                                return True
                        return (
                            self.preemption_pending_resolution.is_set or
                            self.status.is_set or
                            self.time_in_preemption_pending.is_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_data()))

                    def has_operation(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.preemption_pending_resolution.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.time_in_preemption_pending.yfilter != YFilter.not_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "soft-preemption" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.preemption_pending_resolution.is_set or self.preemption_pending_resolution.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.preemption_pending_resolution.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.time_in_preemption_pending.is_set or self.time_in_preemption_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_in_preemption_pending.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "soft-preemption-counters"):
                            if (self.soft_preemption_counters is None):
                                self.soft_preemption_counters = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                                self.soft_preemption_counters.parent = self
                                self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                            return self.soft_preemption_counters

                        if (child_yang_name == "soft-preemption-path-error"):
                            for c in self.soft_preemption_path_error:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.soft_preemption_path_error.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "soft-preemption-counters" or name == "soft-preemption-path-error" or name == "preemption-pending-resolution" or name == "status" or name == "time-in-preemption-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "preemption-pending-resolution"):
                            self.preemption_pending_resolution = value
                            self.preemption_pending_resolution.value_namespace = name_space
                            self.preemption_pending_resolution.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-in-preemption-pending"):
                            self.time_in_preemption_pending = value
                            self.time_in_preemption_pending.value_namespace = name_space
                            self.time_in_preemption_pending.value_namespace_prefix = name_space_prefix


                class WdmUnitunnel(Entity):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\:  str
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "tunnel-head"

                        self.controlled_interface = YLeaf(YType.str, "controlled-interface")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                        self.label_origin = YLeaf(YType.enumeration, "label-origin")

                        self.local_optical_router_id = YLeaf(YType.str, "local-optical-router-id")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                        self.remote_optical_router_id = YLeaf(YType.str, "remote-optical-router-id")

                        self.source_address = YLeaf(YType.str, "source-address")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        self.tunnel_role = YLeaf(YType.enumeration, "tunnel-role")

                        self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("controlled_interface",
                                        "destination_address",
                                        "extended_tunnel_id",
                                        "label_origin",
                                        "local_optical_router_id",
                                        "lsp_id",
                                        "remote_optical_router_id",
                                        "source_address",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_role",
                                        "tunnel_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.controlled_interface.is_set or
                            self.destination_address.is_set or
                            self.extended_tunnel_id.is_set or
                            self.label_origin.is_set or
                            self.local_optical_router_id.is_set or
                            self.lsp_id.is_set or
                            self.remote_optical_router_id.is_set or
                            self.source_address.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_role.is_set or
                            self.tunnel_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.controlled_interface.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.extended_tunnel_id.yfilter != YFilter.not_set or
                            self.label_origin.yfilter != YFilter.not_set or
                            self.local_optical_router_id.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.remote_optical_router_id.yfilter != YFilter.not_set or
                            self.source_address.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_role.yfilter != YFilter.not_set or
                            self.tunnel_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "wdm-unitunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.controlled_interface.is_set or self.controlled_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.controlled_interface.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                        if (self.label_origin.is_set or self.label_origin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_origin.get_name_leafdata())
                        if (self.local_optical_router_id.is_set or self.local_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_optical_router_id.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.remote_optical_router_id.is_set or self.remote_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_optical_router_id.get_name_leafdata())
                        if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_address.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_role.is_set or self.tunnel_role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_role.get_name_leafdata())
                        if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "controlled-interface" or name == "destination-address" or name == "extended-tunnel-id" or name == "label-origin" or name == "local-optical-router-id" or name == "lsp-id" or name == "remote-optical-router-id" or name == "source-address" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-role" or name == "tunnel-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "controlled-interface"):
                            self.controlled_interface = value
                            self.controlled_interface.value_namespace = name_space
                            self.controlled_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "extended-tunnel-id"):
                            self.extended_tunnel_id = value
                            self.extended_tunnel_id.value_namespace = name_space
                            self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "label-origin"):
                            self.label_origin = value
                            self.label_origin.value_namespace = name_space
                            self.label_origin.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-optical-router-id"):
                            self.local_optical_router_id = value
                            self.local_optical_router_id.value_namespace = name_space
                            self.local_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-optical-router-id"):
                            self.remote_optical_router_id = value
                            self.remote_optical_router_id.value_namespace = name_space
                            self.remote_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-address"):
                            self.source_address = value
                            self.source_address.value_namespace = name_space
                            self.source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-role"):
                            self.tunnel_role = value
                            self.tunnel_role.value_namespace = name_space
                            self.tunnel_role.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-state"):
                            self.tunnel_state = value
                            self.tunnel_state.value_namespace = name_space
                            self.tunnel_state.value_namespace_prefix = name_space_prefix


                class TransportTunnelInfo(Entity):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of    :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo>`
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:   :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni>`
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of    :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro>`
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn>`
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:   :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni>`
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "tunnel-head"

                        self.status_homepath_working = YLeaf(YType.boolean, "status-homepath-working")

                        self.egress_static_uni = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"
                        self._children_yang_names.add("egress-static-uni")

                        self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"
                        self._children_yang_names.add("otn")

                        self.static_uni = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"
                        self._children_yang_names.add("static-uni")

                        self.diversity_info = YList(self)
                        self.homepath_ero = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("status_homepath_working") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__setattr__(name, value)


                    class Otn(Entity):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:   :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.bandwidth_cfg = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._children_yang_names.add("bandwidth-cfg")


                        class BandwidthCfg(Entity):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"

                                self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                self._children_yang_names.add("odu-flex-cbr")

                                self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                self._children_yang_names.add("odu-flex-gfp-f-res")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("odu_level") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)


                            class OduFlexCbr(Entity):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.tolerance = YLeaf(YType.uint16, "tolerance")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "tolerance") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.tolerance.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.tolerance.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-cbr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tolerance.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "tolerance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tolerance"):
                                        self.tolerance = value
                                        self.tolerance.value_namespace = name_space
                                        self.tolerance.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFRes(Entity):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFNonRes(Entity):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.odu_level.is_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.odu_level.yfilter != YFilter.not_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-cfg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.odu_level.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "odu-flex-cbr"):
                                    if (self.odu_flex_cbr is None):
                                        self.odu_flex_cbr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    return self.odu_flex_cbr

                                if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                    if (self.odu_flex_gfp_f_non_res is None):
                                        self.odu_flex_gfp_f_non_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    return self.odu_flex_gfp_f_non_res

                                if (child_yang_name == "odu-flex-gfp-f-res"):
                                    if (self.odu_flex_gfp_f_res is None):
                                        self.odu_flex_gfp_f_res = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    return self.odu_flex_gfp_f_res

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "odu-level"):
                                    self.odu_level = value
                                    self.odu_level.value_namespace = name_space
                                    self.odu_level.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-cfg"):
                                if (self.bandwidth_cfg is None):
                                    self.bandwidth_cfg = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                                    self.bandwidth_cfg.parent = self
                                    self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                                return self.bandwidth_cfg

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-cfg"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class StaticUni(Entity):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\:  str
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\:  bool
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.client_if_handle = YLeaf(YType.str, "client-if-handle")

                            self.client_odu_if_handle = YLeaf(YType.str, "client-odu-if-handle")

                            self.client_odu_name = YLeaf(YType.str, "client-odu-name")

                            self.client_port = YLeaf(YType.str, "client-port")

                            self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                            self.is_connected = YLeaf(YType.boolean, "is-connected")

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.static_uni_type = YLeaf(YType.enumeration, "static-uni-type")

                            self.term_client_if_handle = YLeaf(YType.str, "term-client-if-handle")

                            self.term_client_port = YLeaf(YType.str, "term-client-port")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("client_if_handle",
                                            "client_odu_if_handle",
                                            "client_odu_name",
                                            "client_port",
                                            "cross_connect_id",
                                            "is_connected",
                                            "local_termination",
                                            "static_uni_type",
                                            "term_client_if_handle",
                                            "term_client_port",
                                            "uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.client_if_handle.is_set or
                                self.client_odu_if_handle.is_set or
                                self.client_odu_name.is_set or
                                self.client_port.is_set or
                                self.cross_connect_id.is_set or
                                self.is_connected.is_set or
                                self.local_termination.is_set or
                                self.static_uni_type.is_set or
                                self.term_client_if_handle.is_set or
                                self.term_client_port.is_set or
                                self.uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.client_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_name.yfilter != YFilter.not_set or
                                self.client_port.yfilter != YFilter.not_set or
                                self.cross_connect_id.yfilter != YFilter.not_set or
                                self.is_connected.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.static_uni_type.yfilter != YFilter.not_set or
                                self.term_client_if_handle.yfilter != YFilter.not_set or
                                self.term_client_port.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.client_if_handle.is_set or self.client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_if_handle.get_name_leafdata())
                            if (self.client_odu_if_handle.is_set or self.client_odu_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_if_handle.get_name_leafdata())
                            if (self.client_odu_name.is_set or self.client_odu_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_name.get_name_leafdata())
                            if (self.client_port.is_set or self.client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_port.get_name_leafdata())
                            if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                            if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_connected.get_name_leafdata())
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.static_uni_type.is_set or self.static_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.static_uni_type.get_name_leafdata())
                            if (self.term_client_if_handle.is_set or self.term_client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_if_handle.get_name_leafdata())
                            if (self.term_client_port.is_set or self.term_client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_port.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "client-if-handle" or name == "client-odu-if-handle" or name == "client-odu-name" or name == "client-port" or name == "cross-connect-id" or name == "is-connected" or name == "local-termination" or name == "static-uni-type" or name == "term-client-if-handle" or name == "term-client-port" or name == "uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "client-if-handle"):
                                self.client_if_handle = value
                                self.client_if_handle.value_namespace = name_space
                                self.client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-if-handle"):
                                self.client_odu_if_handle = value
                                self.client_odu_if_handle.value_namespace = name_space
                                self.client_odu_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-name"):
                                self.client_odu_name = value
                                self.client_odu_name.value_namespace = name_space
                                self.client_odu_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-port"):
                                self.client_port = value
                                self.client_port.value_namespace = name_space
                                self.client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "cross-connect-id"):
                                self.cross_connect_id = value
                                self.cross_connect_id.value_namespace = name_space
                                self.cross_connect_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-connected"):
                                self.is_connected = value
                                self.is_connected.value_namespace = name_space
                                self.is_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "static-uni-type"):
                                self.static_uni_type = value
                                self.static_uni_type.value_namespace = name_space
                                self.static_uni_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-if-handle"):
                                self.term_client_if_handle = value
                                self.term_client_if_handle.value_namespace = name_space
                                self.term_client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-port"):
                                self.term_client_port = value
                                self.term_client_port.value_namespace = name_space
                                self.term_client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix


                    class EgressStaticUni(Entity):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:   :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:   :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.remote_uni_type = YLeaf(YType.enumeration, "remote-uni-type")

                            self.egress_port = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"
                            self._children_yang_names.add("egress-port")

                            self.term_egress_port = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._children_yang_names.add("term-egress-port")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("local_termination",
                                            "remote_uni_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)


                        class EgressPort(Entity):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class TermEgressPort(Entity):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "term-egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.local_termination.is_set or
                                self.remote_uni_type.is_set or
                                (self.egress_port is not None and self.egress_port.has_data()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.remote_uni_type.yfilter != YFilter.not_set or
                                (self.egress_port is not None and self.egress_port.has_operation()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "egress-static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.remote_uni_type.is_set or self.remote_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_uni_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "egress-port"):
                                if (self.egress_port is None):
                                    self.egress_port = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                                    self.egress_port.parent = self
                                    self._children_name_map["egress_port"] = "egress-port"
                                return self.egress_port

                            if (child_yang_name == "term-egress-port"):
                                if (self.term_egress_port is None):
                                    self.term_egress_port = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                                    self.term_egress_port.parent = self
                                    self._children_name_map["term_egress_port"] = "term-egress-port"
                                return self.term_egress_port

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "egress-port" or name == "term-egress-port" or name == "local-termination" or name == "remote-uni-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-uni-type"):
                                self.remote_uni_type = value
                                self.remote_uni_type.value_namespace = name_space
                                self.remote_uni_type.value_namespace_prefix = name_space_prefix


                    class HomepathEro(Entity):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "homepath-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.tunnel_id.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.diversity_info:
                            if (c.has_data()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_data()):
                                return True
                        return (
                            self.status_homepath_working.is_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_data()) or
                            (self.otn is not None and self.otn.has_data()) or
                            (self.static_uni is not None and self.static_uni.has_data()))

                    def has_operation(self):
                        for c in self.diversity_info:
                            if (c.has_operation()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.status_homepath_working.yfilter != YFilter.not_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_operation()) or
                            (self.otn is not None and self.otn.has_operation()) or
                            (self.static_uni is not None and self.static_uni.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transport-tunnel-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.status_homepath_working.is_set or self.status_homepath_working.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status_homepath_working.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "diversity-info"):
                            for c in self.diversity_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.diversity_info.append(c)
                            return c

                        if (child_yang_name == "egress-static-uni"):
                            if (self.egress_static_uni is None):
                                self.egress_static_uni = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                                self.egress_static_uni.parent = self
                                self._children_name_map["egress_static_uni"] = "egress-static-uni"
                            return self.egress_static_uni

                        if (child_yang_name == "homepath-ero"):
                            for c in self.homepath_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.homepath_ero.append(c)
                            return c

                        if (child_yang_name == "otn"):
                            if (self.otn is None):
                                self.otn = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                            return self.otn

                        if (child_yang_name == "static-uni"):
                            if (self.static_uni is None):
                                self.static_uni = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                                self.static_uni.parent = self
                                self._children_name_map["static_uni"] = "static-uni"
                            return self.static_uni

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "diversity-info" or name == "egress-static-uni" or name == "homepath-ero" or name == "otn" or name == "static-uni" or name == "status-homepath-working"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "status-homepath-working"):
                            self.status_homepath_working = value
                            self.status_homepath_working.value_namespace = name_space
                            self.status_homepath_working.value_namespace_prefix = name_space_prefix


                class BfdInfo(Entity):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\:  bool
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of    :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo>`
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:   :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters>`
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\:  str
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "tunnel-head"

                        self.bfd_session_up = YLeaf(YType.boolean, "bfd-session-up")

                        self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                        self.failure_reason = YLeaf(YType.str, "failure-reason")

                        self.maximum_session_up_interval = YLeaf(YType.uint32, "maximum-session-up-interval")

                        self.minimum_session_up_interval = YLeaf(YType.uint32, "minimum-session-up-interval")

                        self.session_up_time = YLeaf(YType.uint32, "session-up-time")

                        self.event_counters = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"
                        self._children_yang_names.add("event-counters")

                        self.dampening_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_up",
                                        "failure_diagnostic_code",
                                        "failure_reason",
                                        "maximum_session_up_interval",
                                        "minimum_session_up_interval",
                                        "session_up_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__setattr__(name, value)


                    class EventCounters(Entity):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"

                            self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                            self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                            self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                            self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                            self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                            self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                            self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                            self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                            self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("session_admin_down_events",
                                            "session_create_events",
                                            "session_create_timeout_events",
                                            "session_creation_failed_events",
                                            "session_down_events",
                                            "session_gracefully_delete_events",
                                            "session_non_gracefully_delete_events",
                                            "session_replay_events",
                                            "session_up_events") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.session_admin_down_events.is_set or
                                self.session_create_events.is_set or
                                self.session_create_timeout_events.is_set or
                                self.session_creation_failed_events.is_set or
                                self.session_down_events.is_set or
                                self.session_gracefully_delete_events.is_set or
                                self.session_non_gracefully_delete_events.is_set or
                                self.session_replay_events.is_set or
                                self.session_up_events.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.session_admin_down_events.yfilter != YFilter.not_set or
                                self.session_create_events.yfilter != YFilter.not_set or
                                self.session_create_timeout_events.yfilter != YFilter.not_set or
                                self.session_creation_failed_events.yfilter != YFilter.not_set or
                                self.session_down_events.yfilter != YFilter.not_set or
                                self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_replay_events.yfilter != YFilter.not_set or
                                self.session_up_events.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "event-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                            if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_events.get_name_leafdata())
                            if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                            if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                            if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_down_events.get_name_leafdata())
                            if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                            if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                            if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                            if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_up_events.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "session-admin-down-events"):
                                self.session_admin_down_events = value
                                self.session_admin_down_events.value_namespace = name_space
                                self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-events"):
                                self.session_create_events = value
                                self.session_create_events.value_namespace = name_space
                                self.session_create_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-timeout-events"):
                                self.session_create_timeout_events = value
                                self.session_create_timeout_events.value_namespace = name_space
                                self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-creation-failed-events"):
                                self.session_creation_failed_events = value
                                self.session_creation_failed_events.value_namespace = name_space
                                self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-down-events"):
                                self.session_down_events = value
                                self.session_down_events.value_namespace = name_space
                                self.session_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-gracefully-delete-events"):
                                self.session_gracefully_delete_events = value
                                self.session_gracefully_delete_events.value_namespace = name_space
                                self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-non-gracefully-delete-events"):
                                self.session_non_gracefully_delete_events = value
                                self.session_non_gracefully_delete_events.value_namespace = name_space
                                self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-replay-events"):
                                self.session_replay_events = value
                                self.session_replay_events.value_namespace = name_space
                                self.session_replay_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-up-events"):
                                self.session_up_events = value
                                self.session_up_events.value_namespace = name_space
                                self.session_up_events.value_namespace_prefix = name_space_prefix


                    class DampeningInfo(Entity):
                        """
                        Path option dampening info
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"

                            self.backoff_count = YLeaf(YType.uint32, "backoff-count")

                            self.hold_down_time = YLeaf(YType.uint32, "hold-down-time")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.remained_time = YLeaf(YType.uint32, "remained-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_count",
                                            "hold_down_time",
                                            "option_index",
                                            "remained_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_count.is_set or
                                self.hold_down_time.is_set or
                                self.option_index.is_set or
                                self.remained_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_count.yfilter != YFilter.not_set or
                                self.hold_down_time.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.remained_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "dampening-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_count.is_set or self.backoff_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_count.get_name_leafdata())
                            if (self.hold_down_time.is_set or self.hold_down_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_down_time.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.remained_time.is_set or self.remained_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remained_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-count" or name == "hold-down-time" or name == "option-index" or name == "remained-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-count"):
                                self.backoff_count = value
                                self.backoff_count.value_namespace = name_space
                                self.backoff_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-down-time"):
                                self.hold_down_time = value
                                self.hold_down_time.value_namespace = name_space
                                self.hold_down_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "remained-time"):
                                self.remained_time = value
                                self.remained_time.value_namespace = name_space
                                self.remained_time.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.dampening_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bfd_session_up.is_set or
                            self.failure_diagnostic_code.is_set or
                            self.failure_reason.is_set or
                            self.maximum_session_up_interval.is_set or
                            self.minimum_session_up_interval.is_set or
                            self.session_up_time.is_set or
                            (self.event_counters is not None and self.event_counters.has_data()))

                    def has_operation(self):
                        for c in self.dampening_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_up.yfilter != YFilter.not_set or
                            self.failure_diagnostic_code.yfilter != YFilter.not_set or
                            self.failure_reason.yfilter != YFilter.not_set or
                            self.maximum_session_up_interval.yfilter != YFilter.not_set or
                            self.minimum_session_up_interval.yfilter != YFilter.not_set or
                            self.session_up_time.yfilter != YFilter.not_set or
                            (self.event_counters is not None and self.event_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_up.is_set or self.bfd_session_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_up.get_name_leafdata())
                        if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                        if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_reason.get_name_leafdata())
                        if (self.maximum_session_up_interval.is_set or self.maximum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_session_up_interval.get_name_leafdata())
                        if (self.minimum_session_up_interval.is_set or self.minimum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.minimum_session_up_interval.get_name_leafdata())
                        if (self.session_up_time.is_set or self.session_up_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_up_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "dampening-info"):
                            for c in self.dampening_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.dampening_info.append(c)
                            return c

                        if (child_yang_name == "event-counters"):
                            if (self.event_counters is None):
                                self.event_counters = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                                self.event_counters.parent = self
                                self._children_name_map["event_counters"] = "event-counters"
                            return self.event_counters

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "dampening-info" or name == "event-counters" or name == "bfd-session-up" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "maximum-session-up-interval" or name == "minimum-session-up-interval" or name == "session-up-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-up"):
                            self.bfd_session_up = value
                            self.bfd_session_up.value_namespace = name_space
                            self.bfd_session_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-diagnostic-code"):
                            self.failure_diagnostic_code = value
                            self.failure_diagnostic_code.value_namespace = name_space
                            self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-reason"):
                            self.failure_reason = value
                            self.failure_reason.value_namespace = name_space
                            self.failure_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-session-up-interval"):
                            self.maximum_session_up_interval = value
                            self.maximum_session_up_interval.value_namespace = name_space
                            self.maximum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "minimum-session-up-interval"):
                            self.minimum_session_up_interval = value
                            self.minimum_session_up_interval.value_namespace = name_space
                            self.minimum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-up-time"):
                            self.session_up_time = value
                            self.session_up_time.value_namespace = name_space
                            self.session_up_time.value_namespace_prefix = name_space_prefix


                class OtnBidir(Entity):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps>`
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:   :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "tunnel-head"

                        self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"
                        self._children_yang_names.add("aps")

                        self.restoration = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._children_yang_names.add("restoration")


                    class Aps(Entity):
                        """
                        APS Protection Info
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:   :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"

                            self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.protection_profile = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._children_yang_names.add("protection-profile")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("active_lsp",
                                            "diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__setattr__(name, value)


                        class ProtectionProfile(Entity):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection-profile" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.active_lsp.is_set or
                                self.diversity_type.is_set or
                                (self.protection_profile is not None and self.protection_profile.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.active_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                (self.protection_profile is not None and self.protection_profile.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "aps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.active_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protection-profile"):
                                if (self.protection_profile is None):
                                    self.protection_profile = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                                    self.protection_profile.parent = self
                                    self._children_name_map["protection_profile"] = "protection-profile"
                                return self.protection_profile

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protection-profile" or name == "active-lsp" or name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "active-lsp"):
                                self.active_lsp = value
                                self.active_lsp.value_namespace = name_space
                                self.active_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class Restoration(Entity):
                        """
                        Restoration Info
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"

                            self.diverse_lsp = YLeaf(YType.enumeration, "diverse-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.revert_option = YLeaf(YType.enumeration, "revert-option")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diverse_lsp",
                                            "diversity_type",
                                            "revert_option") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.diverse_lsp.is_set or
                                self.diversity_type.is_set or
                                self.revert_option.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diverse_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                self.revert_option.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "restoration" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diverse_lsp.is_set or self.diverse_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diverse_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())
                            if (self.revert_option.is_set or self.revert_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.revert_option.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diverse-lsp" or name == "diversity-type" or name == "revert-option"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diverse-lsp"):
                                self.diverse_lsp = value
                                self.diverse_lsp.value_namespace = name_space
                                self.diverse_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "revert-option"):
                                self.revert_option = value
                                self.revert_option.value_namespace = name_space
                                self.revert_option.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.aps is not None and self.aps.has_data()) or
                            (self.restoration is not None and self.restoration.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.aps is not None and self.aps.has_operation()) or
                            (self.restoration is not None and self.restoration.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "otn-bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "aps"):
                            if (self.aps is None):
                                self.aps = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                            return self.aps

                        if (child_yang_name == "restoration"):
                            if (self.restoration is None):
                                self.restoration = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                                self.restoration.parent = self
                                self._children_name_map["restoration"] = "restoration"
                            return self.restoration

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "aps" or name == "restoration"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Bidir(Entity):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:   :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent>`
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt>`
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby>`
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "tunnel-head"

                        self.reverse_bandwidth = YLeaf(YType.uint32, "reverse-bandwidth")

                        self.reverse_bandwidth_standby = YLeaf(YType.uint32, "reverse-bandwidth-standby")

                        self.reverse_ero_error_current = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                        self._children_yang_names.add("reverse-ero-error-current")

                        self.reverse_ero_error_reopt = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                        self._children_yang_names.add("reverse-ero-error-reopt")

                        self.reverse_ero_error_standby = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                        self._children_yang_names.add("reverse-ero-error-standby")

                        self.reverse_ero_error_standby_reopt = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._children_yang_names.add("reverse-ero-error-standby-reopt")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("reverse_bandwidth",
                                        "reverse_bandwidth_standby") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__setattr__(name, value)


                    class ReverseEroErrorCurrent(Entity):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-current" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorReopt(Entity):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandby(Entity):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandbyReopt(Entity):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.reverse_bandwidth.is_set or
                            self.reverse_bandwidth_standby.is_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_data()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_data()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_data()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.reverse_bandwidth.yfilter != YFilter.not_set or
                            self.reverse_bandwidth_standby.yfilter != YFilter.not_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_operation()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_operation()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_operation()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.reverse_bandwidth.is_set or self.reverse_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth.get_name_leafdata())
                        if (self.reverse_bandwidth_standby.is_set or self.reverse_bandwidth_standby.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth_standby.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "reverse-ero-error-current"):
                            if (self.reverse_ero_error_current is None):
                                self.reverse_ero_error_current = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                                self.reverse_ero_error_current.parent = self
                                self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                            return self.reverse_ero_error_current

                        if (child_yang_name == "reverse-ero-error-reopt"):
                            if (self.reverse_ero_error_reopt is None):
                                self.reverse_ero_error_reopt = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                                self.reverse_ero_error_reopt.parent = self
                                self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                            return self.reverse_ero_error_reopt

                        if (child_yang_name == "reverse-ero-error-standby"):
                            if (self.reverse_ero_error_standby is None):
                                self.reverse_ero_error_standby = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                                self.reverse_ero_error_standby.parent = self
                                self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                            return self.reverse_ero_error_standby

                        if (child_yang_name == "reverse-ero-error-standby-reopt"):
                            if (self.reverse_ero_error_standby_reopt is None):
                                self.reverse_ero_error_standby_reopt = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                                self.reverse_ero_error_standby_reopt.parent = self
                                self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                            return self.reverse_ero_error_standby_reopt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "reverse-ero-error-current" or name == "reverse-ero-error-reopt" or name == "reverse-ero-error-standby" or name == "reverse-ero-error-standby-reopt" or name == "reverse-bandwidth" or name == "reverse-bandwidth-standby"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "reverse-bandwidth"):
                            self.reverse_bandwidth = value
                            self.reverse_bandwidth.value_namespace = name_space
                            self.reverse_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-bandwidth-standby"):
                            self.reverse_bandwidth_standby = value
                            self.reverse_bandwidth_standby.value_namespace = name_space
                            self.reverse_bandwidth_standby.value_namespace_prefix = name_space_prefix


                class XroAttributeSet(Entity):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "tunnel-head"

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._children_yang_names.add("attribute-set-union")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("tunnel_attribute_set_name",
                                        "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__setattr__(name, value)


                    class AttributeSetUnion(Entity):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"

                            self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                            self._children_yang_names.add("attribute-set-aps-pp")

                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                            self._children_yang_names.add("attribute-set-autobackup")

                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                            self._children_yang_names.add("attribute-set-automesh")

                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                            self._children_yang_names.add("attribute-set-p2mpte")

                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._children_yang_names.add("attribute-set-p2p-te")

                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                            self._children_yang_names.add("attribute-set-path-option")

                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                            self._children_yang_names.add("attribute-set-xro")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                        class AttributeSetPathOption(Entity):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\:  str
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\:  bool
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"

                                self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                self.generation = YLeaf(YType.uint32, "generation")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                self._children_yang_names.add("bfd-reverse-path")

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bandwidth_type",
                                                "configured_bandwidth",
                                                "cost_limit",
                                                "dste_class_type",
                                                "exclude_list_name",
                                                "generation",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_bfd_reverse_pat_configured",
                                                "is_cost_limit_configured",
                                                "is_exclude_list_name_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "path_invalidation_action",
                                                "path_invalidation_timeout",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class BfdReversePath(Entity):
                                """
                                BFD reverse path
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                                    self.path_type = YLeaf(YType.enumeration, "path-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("binding_label",
                                                    "path_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.binding_label.is_set or
                                        self.path_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.binding_label.yfilter != YFilter.not_set or
                                        self.path_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding-label" or name == "path-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "binding-label"):
                                        self.binding_label = value
                                        self.binding_label.value_namespace = name_space
                                        self.binding_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-type"):
                                        self.path_type = value
                                        self.path_type.value_namespace = name_space
                                        self.path_type.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class VersionInfo(Entity):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\:  str
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.attribute_type = YLeaf(YType.str, "attribute-type")

                                    self.generation = YLeaf(YType.uint32, "generation")

                                    self.is_default = YLeaf(YType.boolean, "is-default")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute_type",
                                                    "generation",
                                                    "is_default") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute_type.is_set or
                                        self.generation.is_set or
                                        self.is_default.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute_type.yfilter != YFilter.not_set or
                                        self.generation.yfilter != YFilter.not_set or
                                        self.is_default.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "version-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                    if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.generation.get_name_leafdata())
                                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_default.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute-type"):
                                        self.attribute_type = value
                                        self.attribute_type.value_namespace = name_space
                                        self.attribute_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "generation"):
                                        self.generation = value
                                        self.generation.value_namespace = name_space
                                        self.generation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-default"):
                                        self.is_default = value
                                        self.is_default.value_namespace = name_space
                                        self.is_default.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bandwidth_type.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.cost_limit.is_set or
                                    self.dste_class_type.is_set or
                                    self.exclude_list_name.is_set or
                                    self.generation.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_bfd_reverse_pat_configured.is_set or
                                    self.is_cost_limit_configured.is_set or
                                    self.is_exclude_list_name_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.path_invalidation_action.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bandwidth_type.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.cost_limit.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.exclude_list_name.yfilter != YFilter.not_set or
                                    self.generation.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                    self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                    self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "bfd-reverse-path"):
                                    if (self.bfd_reverse_path is None):
                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                    return self.bfd_reverse_path

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                if (child_yang_name == "version-info"):
                                    for c in self.version_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.version_info.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bandwidth-type"):
                                    self.bandwidth_type = value
                                    self.bandwidth_type.value_namespace = name_space
                                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "cost-limit"):
                                    self.cost_limit = value
                                    self.cost_limit.value_namespace = name_space
                                    self.cost_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "exclude-list-name"):
                                    self.exclude_list_name = value
                                    self.exclude_list_name.value_namespace = name_space
                                    self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "generation"):
                                    self.generation = value
                                    self.generation.value_namespace = name_space
                                    self.generation.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bfd-reverse-pat-configured"):
                                    self.is_bfd_reverse_pat_configured = value
                                    self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                    self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-cost-limit-configured"):
                                    self.is_cost_limit_configured = value
                                    self.is_cost_limit_configured.value_namespace = name_space
                                    self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-exclude-list-name-configured"):
                                    self.is_exclude_list_name_configured = value
                                    self.is_exclude_list_name_configured.value_namespace = name_space
                                    self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-action"):
                                    self.path_invalidation_action = value
                                    self.path_invalidation_action.value_namespace = name_space
                                    self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutobackup(Entity):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                                self._children_yang_names.add("signalled-name")

                                self.policy_class_entry = YList(self)
                                self.protected_interface = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_priority",
                                                "is_affinity_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "is_signalled_name_configured",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                            class SignalledName(Entity):
                                """
                                Signalled name
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\:  bool
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\:  str
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                    self.name = YLeaf(YType.str, "name")

                                    self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                    self.source_type = YLeaf(YType.enumeration, "source-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_mp_addresses",
                                                    "name",
                                                    "protected_interface_type",
                                                    "source_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_mp_addresses.is_set or
                                        self.name.is_set or
                                        self.protected_interface_type.is_set or
                                        self.source_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_mp_addresses.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set or
                                        self.protected_interface_type.yfilter != YFilter.not_set or
                                        self.source_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalled-name" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())
                                    if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                    if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-mp-addresses"):
                                        self.is_mp_addresses = value
                                        self.is_mp_addresses.value_namespace = name_space
                                        self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protected-interface-type"):
                                        self.protected_interface_type = value
                                        self.protected_interface_type.value_namespace = name_space
                                        self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-type"):
                                        self.source_type = value
                                        self.source_type.value_namespace = name_space
                                        self.source_type.value_namespace_prefix = name_space_prefix


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ProtectedInterface(Entity):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.protected_interface = YLeaf(YType.str, "protected-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("protected_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.protected_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.protected_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protected-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protected-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "protected-interface"):
                                        self.protected_interface = value
                                        self.protected_interface.value_namespace = name_space
                                        self.protected_interface.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.is_signalled_name_configured.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.signalled_name is not None and self.signalled_name.has_data()))

                            def has_operation(self):
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.signalled_name is not None and self.signalled_name.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-autobackup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "protected-interface"):
                                    for c in self.protected_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protected_interface.append(c)
                                    return c

                                if (child_yang_name == "signalled-name"):
                                    if (self.signalled_name is None):
                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                    return self.signalled_name

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-signalled-name-configured"):
                                    self.is_signalled_name_configured = value
                                    self.is_signalled_name_configured.value_namespace = name_space
                                    self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutomesh(Entity):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\:  bool
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\:  bool
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\:  bool
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"

                                self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.forward_class = YLeaf(YType.uint32, "forward-class")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.load_share = YLeaf(YType.uint32, "load-share")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.mesh_group_id = YList(self)
                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_bandwidth_collect",
                                                "auto_route_announce",
                                                "bandwidth",
                                                "configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "forward_class",
                                                "frr_bandwidth_protection",
                                                "frr_node_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_interface_bw_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "load_share",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority",
                                                "soft_preemption_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class MeshGroupId(Entity):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mesh-group-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.mesh_group_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.auto_bandwidth_collect.is_set or
                                    self.auto_route_announce.is_set or
                                    self.bandwidth.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.forward_class.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.frr_node_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_interface_bw_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.load_share.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    self.soft_preemption_configured.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()))

                            def has_operation(self):
                                for c in self.mesh_group_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                    self.auto_route_announce.yfilter != YFilter.not_set or
                                    self.bandwidth.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.forward_class.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.frr_node_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.load_share.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    self.soft_preemption_configured.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-automesh" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_class.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.load_share.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "mesh-group-id"):
                                    for c in self.mesh_group_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.mesh_group_id.append(c)
                                    return c

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-bandwidth-collect"):
                                    self.auto_bandwidth_collect = value
                                    self.auto_bandwidth_collect.value_namespace = name_space
                                    self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-route-announce"):
                                    self.auto_route_announce = value
                                    self.auto_route_announce.value_namespace = name_space
                                    self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                if(value_path == "bandwidth"):
                                    self.bandwidth = value
                                    self.bandwidth.value_namespace = name_space
                                    self.bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-class"):
                                    self.forward_class = value
                                    self.forward_class.value_namespace = name_space
                                    self.forward_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-node-protection"):
                                    self.frr_node_protection = value
                                    self.frr_node_protection.value_namespace = name_space
                                    self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-bw-configured"):
                                    self.is_interface_bw_configured = value
                                    self.is_interface_bw_configured.value_namespace = name_space
                                    self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "load-share"):
                                    self.load_share = value
                                    self.load_share.value_namespace = name_space
                                    self.load_share.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-configured"):
                                    self.soft_preemption_configured = value
                                    self.soft_preemption_configured.value_namespace = name_space
                                    self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                        class AttributeSetXro(Entity):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"

                                self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._children_yang_names.add("xro")


                            class Xro(Entity):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\:  bool
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"

                                    self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                    self.xro_subobject = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("mutual_diversity_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                class XroSubobject(Entity):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                        self._children_yang_names.add("as-subobject")

                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        self._children_yang_names.add("ipv4-subobject")

                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        self._children_yang_names.add("ipv6-subobject")

                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._children_yang_names.add("lsp-subobject")

                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        self._children_yang_names.add("srlg-subobject")

                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        self._children_yang_names.add("unnumbered-subobject")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                    class Ipv4Subobject(Entity):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv4-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class Ipv6Subobject(Entity):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv6-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class UnnumberedSubobject(Entity):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.interface_id = YLeaf(YType.uint32, "interface-id")

                                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute",
                                                            "exclusion_type",
                                                            "interface_id",
                                                            "te_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.interface_id.is_set or
                                                self.te_router_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.interface_id.yfilter != YFilter.not_set or
                                                self.te_router_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unnumbered-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_id.get_name_leafdata())
                                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-id"):
                                                self.interface_id = value
                                                self.interface_id.value_namespace = name_space
                                                self.interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-router-id"):
                                                self.te_router_id = value
                                                self.te_router_id.value_namespace = name_space
                                                self.te_router_id.value_namespace_prefix = name_space_prefix


                                    class AsSubobject(Entity):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.as_number = YLeaf(YType.uint16, "as-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("as_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.as_number.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.as_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "as-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "as-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "as-number"):
                                                self.as_number = value
                                                self.as_number.value_namespace = name_space
                                                self.as_number.value_namespace_prefix = name_space_prefix


                                    class SrlgSubobject(Entity):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("exclusion_type",
                                                            "srlg_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.exclusion_type.is_set or
                                                self.srlg_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.srlg_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "srlg-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "exclusion-type" or name == "srlg-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "srlg-id"):
                                                self.srlg_id = value
                                                self.srlg_id.value_namespace = name_space
                                                self.srlg_id.value_namespace_prefix = name_space_prefix


                                    class LspSubobject(Entity):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\:  bool
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                            self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                            self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._children_yang_names.add("fec")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("destination_node_exception",
                                                            "exclusion_type",
                                                            "ignore_lsp_id",
                                                            "penultimate_node_exception",
                                                            "processing_node_exception") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                        class Fec(Entity):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"

                                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                self.fec_source = YLeaf(YType.str, "fec-source")

                                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._children_yang_names.add("fec-destination-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_extended_tunnel_id",
                                                                "fec_lsp_id",
                                                                "fec_source",
                                                                "fec_tunnel_id",
                                                                "fec_vrf") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                            class FecDestinationInfo(Entity):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"

                                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("fec_ctype",
                                                                    "fec_destination_p2mp_id",
                                                                    "p2p_lsp_destination") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.fec_ctype.is_set or
                                                        self.fec_destination_p2mp_id.is_set or
                                                        self.p2p_lsp_destination.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.fec_ctype.yfilter != YFilter.not_set or
                                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "fec-destination-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "fec-ctype"):
                                                        self.fec_ctype = value
                                                        self.fec_ctype.value_namespace = name_space
                                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fec-destination-p2mp-id"):
                                                        self.fec_destination_p2mp_id = value
                                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "p2p-lsp-destination"):
                                                        self.p2p_lsp_destination = value
                                                        self.p2p_lsp_destination.value_namespace = name_space
                                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.fec_extended_tunnel_id.is_set or
                                                    self.fec_lsp_id.is_set or
                                                    self.fec_source.is_set or
                                                    self.fec_tunnel_id.is_set or
                                                    self.fec_vrf.is_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                                    self.fec_source.yfilter != YFilter.not_set or
                                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_vrf.yfilter != YFilter.not_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "fec-destination-info"):
                                                    if (self.fec_destination_info is None):
                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                    return self.fec_destination_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-extended-tunnel-id"):
                                                    self.fec_extended_tunnel_id = value
                                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-lsp-id"):
                                                    self.fec_lsp_id = value
                                                    self.fec_lsp_id.value_namespace = name_space
                                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-source"):
                                                    self.fec_source = value
                                                    self.fec_source.value_namespace = name_space
                                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-tunnel-id"):
                                                    self.fec_tunnel_id = value
                                                    self.fec_tunnel_id.value_namespace = name_space
                                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-vrf"):
                                                    self.fec_vrf = value
                                                    self.fec_vrf.value_namespace = name_space
                                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.destination_node_exception.is_set or
                                                self.exclusion_type.is_set or
                                                self.ignore_lsp_id.is_set or
                                                self.penultimate_node_exception.is_set or
                                                self.processing_node_exception.is_set or
                                                (self.fec is not None and self.fec.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.destination_node_exception.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                self.processing_node_exception.yfilter != YFilter.not_set or
                                                (self.fec is not None and self.fec.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsp-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                            if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                            if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec"):
                                                if (self.fec is None):
                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                return self.fec

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "destination-node-exception"):
                                                self.destination_node_exception = value
                                                self.destination_node_exception.value_namespace = name_space
                                                self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ignore-lsp-id"):
                                                self.ignore_lsp_id = value
                                                self.ignore_lsp_id.value_namespace = name_space
                                                self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "penultimate-node-exception"):
                                                self.penultimate_node_exception = value
                                                self.penultimate_node_exception.value_namespace = name_space
                                                self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "processing-node-exception"):
                                                self.processing_node_exception = value
                                                self.processing_node_exception.value_namespace = name_space
                                                self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.type.is_set or
                                            (self.as_subobject is not None and self.as_subobject.has_data()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set or
                                            (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "xro-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "as-subobject"):
                                            if (self.as_subobject is None):
                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                            return self.as_subobject

                                        if (child_yang_name == "ipv4-subobject"):
                                            if (self.ipv4_subobject is None):
                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                            return self.ipv4_subobject

                                        if (child_yang_name == "ipv6-subobject"):
                                            if (self.ipv6_subobject is None):
                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                            return self.ipv6_subobject

                                        if (child_yang_name == "lsp-subobject"):
                                            if (self.lsp_subobject is None):
                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                            return self.lsp_subobject

                                        if (child_yang_name == "srlg-subobject"):
                                            if (self.srlg_subobject is None):
                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                            return self.srlg_subobject

                                        if (child_yang_name == "unnumbered-subobject"):
                                            if (self.unnumbered_subobject is None):
                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                            return self.unnumbered_subobject

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.xro_subobject:
                                        if (c.has_data()):
                                            return True
                                    return self.mutual_diversity_flag.is_set

                                def has_operation(self):
                                    for c in self.xro_subobject:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "xro-subobject"):
                                        for c in self.xro_subobject:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.xro_subobject.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "mutual-diversity-flag"):
                                        self.mutual_diversity_flag = value
                                        self.mutual_diversity_flag.value_namespace = name_space
                                        self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.xro is not None and self.xro.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.xro is not None and self.xro.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro"):
                                    if (self.xro is None):
                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                    return self.xro

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class AttributeSetP2Mpte(Entity):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "frr_bandwidth_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_priority_configured",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2mpte" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetApsPp(Entity):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-aps-pp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                        class AttributeSetP2PTe(Entity):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                                self._children_yang_names.add("prepend-list")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_affinity_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_path_select_configured",
                                                "is_path_selection_metric_configured",
                                                "is_path_selection_segment_routing_adjacency_protection_configured",
                                                "is_path_selection_segment_routing_margin_configured",
                                                "is_path_selection_segment_routing_margin_relative",
                                                "is_path_selection_segment_routing_segment_limit_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "is_prepend_list_configured",
                                                "path_invalidation_timeout",
                                                "path_selection_invalidation_action",
                                                "path_selection_metric",
                                                "path_selection_segment_routing_adjacency_protection",
                                                "path_selection_segment_routing_margin",
                                                "path_selection_segment_routing_segment_limit",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PrependList(Entity):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.prepend_entry = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                class PrependEntry(Entity):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.next_label = YLeaf(YType.uint32, "next-label")

                                        self.type = YLeaf(YType.enumeration, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("index",
                                                        "next_label",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.index.is_set or
                                            self.next_label.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.next_label.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prepend-entry" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_label.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "index" or name == "next-label" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-label"):
                                            self.next_label = value
                                            self.next_label.value_namespace = name_space
                                            self.next_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.prepend_entry:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.prepend_entry:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "prepend-list" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "prepend-entry"):
                                        for c in self.prepend_entry:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.prepend_entry.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prepend-entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_affinity_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_path_select_configured.is_set or
                                    self.is_path_selection_metric_configured.is_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_relative.is_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.is_prepend_list_configured.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.path_selection_invalidation_action.is_set or
                                    self.path_selection_metric.is_set or
                                    self.path_selection_segment_routing_adjacency_protection.is_set or
                                    self.path_selection_segment_routing_margin.is_set or
                                    self.path_selection_segment_routing_segment_limit.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.prepend_list is not None and self.prepend_list.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_path_select_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_selection_metric.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.prepend_list is not None and self.prepend_list.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2p-te" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "prepend-list"):
                                    if (self.prepend_list is None):
                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                    return self.prepend_list

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-select-configured"):
                                    self.is_path_select_configured = value
                                    self.is_path_select_configured.value_namespace = name_space
                                    self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-metric-configured"):
                                    self.is_path_selection_metric_configured = value
                                    self.is_path_selection_metric_configured.value_namespace = name_space
                                    self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                    self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                    self.is_path_selection_segment_routing_margin_configured = value
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                    self.is_path_selection_segment_routing_margin_relative = value
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                    self.is_path_selection_segment_routing_segment_limit_configured = value
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-prepend-list-configured"):
                                    self.is_prepend_list_configured = value
                                    self.is_prepend_list_configured.value_namespace = name_space
                                    self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-invalidation-action"):
                                    self.path_selection_invalidation_action = value
                                    self.path_selection_invalidation_action.value_namespace = name_space
                                    self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-metric"):
                                    self.path_selection_metric = value
                                    self.path_selection_metric.value_namespace = name_space
                                    self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                    self.path_selection_segment_routing_adjacency_protection = value
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-margin"):
                                    self.path_selection_segment_routing_margin = value
                                    self.path_selection_segment_routing_margin.value_namespace = name_space
                                    self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-segment-limit"):
                                    self.path_selection_segment_routing_segment_limit = value
                                    self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                    self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tunnel_attribute_set_type.is_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attribute-set-union" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set-aps-pp"):
                                if (self.attribute_set_aps_pp is None):
                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                return self.attribute_set_aps_pp

                            if (child_yang_name == "attribute-set-autobackup"):
                                if (self.attribute_set_autobackup is None):
                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                return self.attribute_set_autobackup

                            if (child_yang_name == "attribute-set-automesh"):
                                if (self.attribute_set_automesh is None):
                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                return self.attribute_set_automesh

                            if (child_yang_name == "attribute-set-p2mpte"):
                                if (self.attribute_set_p2mpte is None):
                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                return self.attribute_set_p2mpte

                            if (child_yang_name == "attribute-set-p2p-te"):
                                if (self.attribute_set_p2p_te is None):
                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                return self.attribute_set_p2p_te

                            if (child_yang_name == "attribute-set-path-option"):
                                if (self.attribute_set_path_option is None):
                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                return self.attribute_set_path_option

                            if (child_yang_name == "attribute-set-xro"):
                                if (self.attribute_set_xro is None):
                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                return self.attribute_set_xro

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-attribute-set-type"):
                                self.tunnel_attribute_set_type = value
                                self.tunnel_attribute_set_type.value_namespace = name_space
                                self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.tunnel_attribute_set_name.is_set or
                            self.tunnel_attribute_set_name_crc32.is_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "xro-attribute-set" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attribute-set-union"):
                            if (self.attribute_set_union is None):
                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                            return self.attribute_set_union

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name-crc32"):
                            self.tunnel_attribute_set_name_crc32 = value
                            self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                            self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                class TeTunnelConvergence(Entity):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp>`
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "tunnel-head"

                        self.binding_label_rewrite_time = YLeaf(YType.uint64, "binding-label-rewrite-time")

                        self.convergence_complete_time = YLeaf(YType.uint64, "convergence-complete-time")

                        self.frr_trigger_time = YLeaf(YType.uint64, "frr-trigger-time")

                        self.is_convergence_in_progress = YLeaf(YType.boolean, "is-convergence-in-progress")

                        self.pcalc_complete_time = YLeaf(YType.uint64, "pcalc-complete-time")

                        self.vif_creation_time = YLeaf(YType.uint64, "vif-creation-time")

                        self.convergence_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._children_yang_names.add("convergence-lsp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("binding_label_rewrite_time",
                                        "convergence_complete_time",
                                        "frr_trigger_time",
                                        "is_convergence_in_progress",
                                        "pcalc_complete_time",
                                        "vif_creation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__setattr__(name, value)


                    class ConvergenceLsp(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "convergence-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.binding_label_rewrite_time.is_set or
                            self.convergence_complete_time.is_set or
                            self.frr_trigger_time.is_set or
                            self.is_convergence_in_progress.is_set or
                            self.pcalc_complete_time.is_set or
                            self.vif_creation_time.is_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.binding_label_rewrite_time.yfilter != YFilter.not_set or
                            self.convergence_complete_time.yfilter != YFilter.not_set or
                            self.frr_trigger_time.yfilter != YFilter.not_set or
                            self.is_convergence_in_progress.yfilter != YFilter.not_set or
                            self.pcalc_complete_time.yfilter != YFilter.not_set or
                            self.vif_creation_time.yfilter != YFilter.not_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-tunnel-convergence" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.binding_label_rewrite_time.is_set or self.binding_label_rewrite_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_label_rewrite_time.get_name_leafdata())
                        if (self.convergence_complete_time.is_set or self.convergence_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.convergence_complete_time.get_name_leafdata())
                        if (self.frr_trigger_time.is_set or self.frr_trigger_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_trigger_time.get_name_leafdata())
                        if (self.is_convergence_in_progress.is_set or self.is_convergence_in_progress.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_convergence_in_progress.get_name_leafdata())
                        if (self.pcalc_complete_time.is_set or self.pcalc_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_complete_time.get_name_leafdata())
                        if (self.vif_creation_time.is_set or self.vif_creation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vif_creation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "convergence-lsp"):
                            if (self.convergence_lsp is None):
                                self.convergence_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                                self.convergence_lsp.parent = self
                                self._children_name_map["convergence_lsp"] = "convergence-lsp"
                            return self.convergence_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "convergence-lsp" or name == "binding-label-rewrite-time" or name == "convergence-complete-time" or name == "frr-trigger-time" or name == "is-convergence-in-progress" or name == "pcalc-complete-time" or name == "vif-creation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "binding-label-rewrite-time"):
                            self.binding_label_rewrite_time = value
                            self.binding_label_rewrite_time.value_namespace = name_space
                            self.binding_label_rewrite_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "convergence-complete-time"):
                            self.convergence_complete_time = value
                            self.convergence_complete_time.value_namespace = name_space
                            self.convergence_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-trigger-time"):
                            self.frr_trigger_time = value
                            self.frr_trigger_time.value_namespace = name_space
                            self.frr_trigger_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-convergence-in-progress"):
                            self.is_convergence_in_progress = value
                            self.is_convergence_in_progress.value_namespace = name_space
                            self.is_convergence_in_progress.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-complete-time"):
                            self.pcalc_complete_time = value
                            self.pcalc_complete_time.value_namespace = name_space
                            self.pcalc_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "vif-creation-time"):
                            self.vif_creation_time = value
                            self.vif_creation_time.value_namespace = name_space
                            self.vif_creation_time.value_namespace_prefix = name_space_prefix


                class FlexInfo(Entity):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\:  bool
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\:  bool
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\:  bool
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\:  bool
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\:  bool
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:   :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "tunnel-head"

                        self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                        self.fault_in_label = YLeaf(YType.uint32, "fault-in-label")

                        self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                        self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                        self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                        self.fault_time = YLeaf(YType.uint32, "fault-time")

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_lsp_id = YLeaf(YType.uint16, "lockout-lsp-id")

                        self.lockout_timestamp = YLeaf(YType.uint32, "lockout-timestamp")

                        self.origination = YLeaf(YType.enumeration, "origination")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fault_ais",
                                        "fault_in_label",
                                        "fault_ldi",
                                        "fault_ldi_lockout",
                                        "fault_lkr",
                                        "fault_time",
                                        "is_lockout",
                                        "lockout_lsp_id",
                                        "lockout_timestamp",
                                        "origination") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.fault_ais.is_set or
                            self.fault_in_label.is_set or
                            self.fault_ldi.is_set or
                            self.fault_ldi_lockout.is_set or
                            self.fault_lkr.is_set or
                            self.fault_time.is_set or
                            self.is_lockout.is_set or
                            self.lockout_lsp_id.is_set or
                            self.lockout_timestamp.is_set or
                            self.origination.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fault_ais.yfilter != YFilter.not_set or
                            self.fault_in_label.yfilter != YFilter.not_set or
                            self.fault_ldi.yfilter != YFilter.not_set or
                            self.fault_ldi_lockout.yfilter != YFilter.not_set or
                            self.fault_lkr.yfilter != YFilter.not_set or
                            self.fault_time.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_lsp_id.yfilter != YFilter.not_set or
                            self.lockout_timestamp.yfilter != YFilter.not_set or
                            self.origination.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flex-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ais.get_name_leafdata())
                        if (self.fault_in_label.is_set or self.fault_in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_in_label.get_name_leafdata())
                        if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                        if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                        if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                        if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_time.get_name_leafdata())
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_lsp_id.is_set or self.lockout_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_lsp_id.get_name_leafdata())
                        if (self.lockout_timestamp.is_set or self.lockout_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_timestamp.get_name_leafdata())
                        if (self.origination.is_set or self.origination.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.origination.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fault-ais" or name == "fault-in-label" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "is-lockout" or name == "lockout-lsp-id" or name == "lockout-timestamp" or name == "origination"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fault-ais"):
                            self.fault_ais = value
                            self.fault_ais.value_namespace = name_space
                            self.fault_ais.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-in-label"):
                            self.fault_in_label = value
                            self.fault_in_label.value_namespace = name_space
                            self.fault_in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi"):
                            self.fault_ldi = value
                            self.fault_ldi.value_namespace = name_space
                            self.fault_ldi.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi-lockout"):
                            self.fault_ldi_lockout = value
                            self.fault_ldi_lockout.value_namespace = name_space
                            self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-lkr"):
                            self.fault_lkr = value
                            self.fault_lkr.value_namespace = name_space
                            self.fault_lkr.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-time"):
                            self.fault_time = value
                            self.fault_time.value_namespace = name_space
                            self.fault_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-lsp-id"):
                            self.lockout_lsp_id = value
                            self.lockout_lsp_id.value_namespace = name_space
                            self.lockout_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-timestamp"):
                            self.lockout_timestamp = value
                            self.lockout_timestamp.value_namespace = name_space
                            self.lockout_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "origination"):
                            self.origination = value
                            self.origination.value_namespace = name_space
                            self.origination.value_namespace_prefix = name_space_prefix


                class Destination(Entity):
                    """
                    Destinations array
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionCause>`
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:   :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:   :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization>`
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\:  bool
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of    :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption>`
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of    :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry>`
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\:  bool
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\:  bool
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "tunnel-head"

                        self.active_path_option_index = YLeaf(YType.uint32, "active-path-option-index")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.destination_deletion_cause = YLeaf(YType.enumeration, "destination-deletion-cause")

                        self.destination_deletion_sub_cause = YLeaf(YType.enumeration, "destination-deletion-sub-cause")

                        self.destination_deletion_timestamp = YLeaf(YType.uint32, "destination-deletion-timestamp")

                        self.destination_state = YLeaf(YType.enumeration, "destination-state")

                        self.is_inter_area = YLeaf(YType.boolean, "is-inter-area")

                        self.path_change_time = YLeaf(YType.uint32, "path-change-time")

                        self.path_option_exhausted = YLeaf(YType.boolean, "path-option-exhausted")

                        self.s2l_exist = YLeaf(YType.boolean, "s2l-exist")

                        self.total_uptime = YLeaf(YType.uint32, "total-uptime")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.inter_area_reoptimization = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                        self._children_yang_names.add("inter-area-reoptimization")

                        self.path_option = YList(self)
                        self.path_option_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("active_path_option_index",
                                        "destination_address",
                                        "destination_deletion_cause",
                                        "destination_deletion_sub_cause",
                                        "destination_deletion_timestamp",
                                        "destination_state",
                                        "is_inter_area",
                                        "path_change_time",
                                        "path_option_exhausted",
                                        "s2l_exist",
                                        "total_uptime",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__setattr__(name, value)


                    class InterAreaReoptimization(Entity):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"

                            self.preferred_path_error_node = YLeaf(YType.str, "preferred-path-error-node")

                            self.preferred_tree_error_node = YLeaf(YType.str, "preferred-tree-error-node")

                            self.received_preferred_path_errors = YLeaf(YType.uint16, "received-preferred-path-errors")

                            self.received_preferred_tree_errors = YLeaf(YType.uint16, "received-preferred-tree-errors")

                            self.sent_path_queries = YLeaf(YType.uint16, "sent-path-queries")

                            self.time_since_last_preferred_path_error = YLeaf(YType.uint32, "time-since-last-preferred-path-error")

                            self.time_since_last_preferred_tree_error = YLeaf(YType.uint32, "time-since-last-preferred-tree-error")

                            self.time_since_last_query_sent = YLeaf(YType.uint32, "time-since-last-query-sent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preferred_path_error_node",
                                            "preferred_tree_error_node",
                                            "received_preferred_path_errors",
                                            "received_preferred_tree_errors",
                                            "sent_path_queries",
                                            "time_since_last_preferred_path_error",
                                            "time_since_last_preferred_tree_error",
                                            "time_since_last_query_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preferred_path_error_node.is_set or
                                self.preferred_tree_error_node.is_set or
                                self.received_preferred_path_errors.is_set or
                                self.received_preferred_tree_errors.is_set or
                                self.sent_path_queries.is_set or
                                self.time_since_last_preferred_path_error.is_set or
                                self.time_since_last_preferred_tree_error.is_set or
                                self.time_since_last_query_sent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preferred_path_error_node.yfilter != YFilter.not_set or
                                self.preferred_tree_error_node.yfilter != YFilter.not_set or
                                self.received_preferred_path_errors.yfilter != YFilter.not_set or
                                self.received_preferred_tree_errors.yfilter != YFilter.not_set or
                                self.sent_path_queries.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_error.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set or
                                self.time_since_last_query_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "inter-area-reoptimization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preferred_path_error_node.is_set or self.preferred_path_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_path_error_node.get_name_leafdata())
                            if (self.preferred_tree_error_node.is_set or self.preferred_tree_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_tree_error_node.get_name_leafdata())
                            if (self.received_preferred_path_errors.is_set or self.received_preferred_path_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_path_errors.get_name_leafdata())
                            if (self.received_preferred_tree_errors.is_set or self.received_preferred_tree_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_tree_errors.get_name_leafdata())
                            if (self.sent_path_queries.is_set or self.sent_path_queries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sent_path_queries.get_name_leafdata())
                            if (self.time_since_last_preferred_path_error.is_set or self.time_since_last_preferred_path_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_error.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_error.is_set or self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_error.get_name_leafdata())
                            if (self.time_since_last_query_sent.is_set or self.time_since_last_query_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preferred-path-error-node" or name == "preferred-tree-error-node" or name == "received-preferred-path-errors" or name == "received-preferred-tree-errors" or name == "sent-path-queries" or name == "time-since-last-preferred-path-error" or name == "time-since-last-preferred-tree-error" or name == "time-since-last-query-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preferred-path-error-node"):
                                self.preferred_path_error_node = value
                                self.preferred_path_error_node.value_namespace = name_space
                                self.preferred_path_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "preferred-tree-error-node"):
                                self.preferred_tree_error_node = value
                                self.preferred_tree_error_node.value_namespace = name_space
                                self.preferred_tree_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-path-errors"):
                                self.received_preferred_path_errors = value
                                self.received_preferred_path_errors.value_namespace = name_space
                                self.received_preferred_path_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-tree-errors"):
                                self.received_preferred_tree_errors = value
                                self.received_preferred_tree_errors.value_namespace = name_space
                                self.received_preferred_tree_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "sent-path-queries"):
                                self.sent_path_queries = value
                                self.sent_path_queries.value_namespace = name_space
                                self.sent_path_queries.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-error"):
                                self.time_since_last_preferred_path_error = value
                                self.time_since_last_preferred_path_error.value_namespace = name_space
                                self.time_since_last_preferred_path_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-error"):
                                self.time_since_last_preferred_tree_error = value
                                self.time_since_last_preferred_tree_error.value_namespace = name_space
                                self.time_since_last_preferred_tree_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-sent"):
                                self.time_since_last_query_sent = value
                                self.time_since_last_query_sent.value_namespace = name_space
                                self.time_since_last_query_sent.value_namespace_prefix = name_space_prefix


                    class PathOptionEntry(Entity):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class PathOption(Entity):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.path_option:
                            if (c.has_data()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.active_path_option_index.is_set or
                            self.destination_address.is_set or
                            self.destination_deletion_cause.is_set or
                            self.destination_deletion_sub_cause.is_set or
                            self.destination_deletion_timestamp.is_set or
                            self.destination_state.is_set or
                            self.is_inter_area.is_set or
                            self.path_change_time.is_set or
                            self.path_option_exhausted.is_set or
                            self.s2l_exist.is_set or
                            self.total_uptime.is_set or
                            self.uptime.is_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_data()))

                    def has_operation(self):
                        for c in self.path_option:
                            if (c.has_operation()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.active_path_option_index.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.destination_deletion_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_sub_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_timestamp.yfilter != YFilter.not_set or
                            self.destination_state.yfilter != YFilter.not_set or
                            self.is_inter_area.yfilter != YFilter.not_set or
                            self.path_change_time.yfilter != YFilter.not_set or
                            self.path_option_exhausted.yfilter != YFilter.not_set or
                            self.s2l_exist.yfilter != YFilter.not_set or
                            self.total_uptime.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.active_path_option_index.is_set or self.active_path_option_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active_path_option_index.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.destination_deletion_cause.is_set or self.destination_deletion_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_cause.get_name_leafdata())
                        if (self.destination_deletion_sub_cause.is_set or self.destination_deletion_sub_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_sub_cause.get_name_leafdata())
                        if (self.destination_deletion_timestamp.is_set or self.destination_deletion_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_timestamp.get_name_leafdata())
                        if (self.destination_state.is_set or self.destination_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_state.get_name_leafdata())
                        if (self.is_inter_area.is_set or self.is_inter_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_inter_area.get_name_leafdata())
                        if (self.path_change_time.is_set or self.path_change_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_change_time.get_name_leafdata())
                        if (self.path_option_exhausted.is_set or self.path_option_exhausted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_option_exhausted.get_name_leafdata())
                        if (self.s2l_exist.is_set or self.s2l_exist.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_exist.get_name_leafdata())
                        if (self.total_uptime.is_set or self.total_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_uptime.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "inter-area-reoptimization"):
                            if (self.inter_area_reoptimization is None):
                                self.inter_area_reoptimization = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                                self.inter_area_reoptimization.parent = self
                                self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                            return self.inter_area_reoptimization

                        if (child_yang_name == "path-option"):
                            for c in self.path_option:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option.append(c)
                            return c

                        if (child_yang_name == "path-option-entry"):
                            for c in self.path_option_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "inter-area-reoptimization" or name == "path-option" or name == "path-option-entry" or name == "active-path-option-index" or name == "destination-address" or name == "destination-deletion-cause" or name == "destination-deletion-sub-cause" or name == "destination-deletion-timestamp" or name == "destination-state" or name == "is-inter-area" or name == "path-change-time" or name == "path-option-exhausted" or name == "s2l-exist" or name == "total-uptime" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "active-path-option-index"):
                            self.active_path_option_index = value
                            self.active_path_option_index.value_namespace = name_space
                            self.active_path_option_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-cause"):
                            self.destination_deletion_cause = value
                            self.destination_deletion_cause.value_namespace = name_space
                            self.destination_deletion_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-sub-cause"):
                            self.destination_deletion_sub_cause = value
                            self.destination_deletion_sub_cause.value_namespace = name_space
                            self.destination_deletion_sub_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-timestamp"):
                            self.destination_deletion_timestamp = value
                            self.destination_deletion_timestamp.value_namespace = name_space
                            self.destination_deletion_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-state"):
                            self.destination_state = value
                            self.destination_state.value_namespace = name_space
                            self.destination_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-inter-area"):
                            self.is_inter_area = value
                            self.is_inter_area.value_namespace = name_space
                            self.is_inter_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-change-time"):
                            self.path_change_time = value
                            self.path_change_time.value_namespace = name_space
                            self.path_change_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-option-exhausted"):
                            self.path_option_exhausted = value
                            self.path_option_exhausted.value_namespace = name_space
                            self.path_option_exhausted.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-exist"):
                            self.s2l_exist = value
                            self.s2l_exist.value_namespace = name_space
                            self.s2l_exist.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-uptime"):
                            self.total_uptime = value
                            self.total_uptime.value_namespace = name_space
                            self.total_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_name.is_set or
                        self.admin_state.is_set or
                        self.affinity_failure_delayed_tear_time_remained.is_set or
                        self.affinity_failure_reopt_disabled.is_set or
                        self.affinity_failure_reopt_time_remained.is_set or
                        self.area_id.is_set or
                        self.auto_route.is_set or
                        self.autoroute_announce_exclude_segment_routing.is_set or
                        self.bandwidth_requested.is_set or
                        self.bandwidth_type.is_set or
                        self.binding_label.is_set or
                        self.binding_label_exists.is_set or
                        self.create_time.is_set or
                        self.destination_disabled_count.is_set or
                        self.destination_down_count.is_set or
                        self.destination_up_count.is_set or
                        self.drop_mode.is_set or
                        self.explicit_path_change.is_set or
                        self.fail_reason.is_set or
                        self.forwarding_adjacency.is_set or
                        self.hop_limit_ignored_reason.is_set or
                        self.invalidation_time_remained.is_set or
                        self.is_auto_backup.is_set or
                        self.is_auto_pcc.is_set or
                        self.is_bandwidth_protect.is_set or
                        self.is_hop_limit_ignore.is_set or
                        self.is_inter_area_tunnel.is_set or
                        self.is_interface.is_set or
                        self.is_named.is_set or
                        self.is_node_protected.is_set or
                        self.is_passive.is_set or
                        self.is_pce_delegated.is_set or
                        self.last_hop_ifindex.is_set or
                        self.last_path_change.is_set or
                        self.load_share_factor.is_set or
                        self.load_share_type.is_set or
                        self.lsp_wrap_label.is_set or
                        self.lsp_wrap_protection_enabled.is_set or
                        self.metric_qualifier.is_set or
                        self.metric_type.is_set or
                        self.operational_state.is_set or
                        self.operational_state_changes.is_set or
                        self.outbound_frr_state.is_set or
                        self.passive_tunnel_name.is_set or
                        self.path_option_change.is_set or
                        self.pce_fail_reason.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.re_opt_hold_down_timer_remaining.is_set or
                        self.reroute_pending.is_set or
                        self.role_standby.is_set or
                        self.signaled_name.is_set or
                        self.snmp_index.is_set or
                        self.tie_breaker.is_set or
                        self.tiebreaker_qualifier.is_set or
                        self.tiebreaker_type.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_attribute_set_type.is_set or
                        self.tunnel_interface_name.is_set or
                        self.tunnel_recovering.is_set or
                        self.uptime.is_set or
                        self.xro_attribute_set_name.is_set or
                        (self.auto_backup is not None and self.auto_backup.has_data()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_data()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_data()) or
                        (self.bfd_info is not None and self.bfd_info.has_data()) or
                        (self.bidir is not None and self.bidir.has_data()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_data()) or
                        (self.config is not None and self.config.has_data()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_data()) or
                        (self.flex_info is not None and self.flex_info.has_data()) or
                        (self.history is not None and self.history.has_data()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_data()) or
                        (self.p2p_info is not None and self.p2p_info.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_data()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_data()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_data()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_data()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_data()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_data()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_data()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_data()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_data()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                def has_operation(self):
                    for c in self.destination:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.admin_state.yfilter != YFilter.not_set or
                        self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.auto_route.yfilter != YFilter.not_set or
                        self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set or
                        self.bandwidth_requested.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.binding_label.yfilter != YFilter.not_set or
                        self.binding_label_exists.yfilter != YFilter.not_set or
                        self.create_time.yfilter != YFilter.not_set or
                        self.destination_disabled_count.yfilter != YFilter.not_set or
                        self.destination_down_count.yfilter != YFilter.not_set or
                        self.destination_up_count.yfilter != YFilter.not_set or
                        self.drop_mode.yfilter != YFilter.not_set or
                        self.explicit_path_change.yfilter != YFilter.not_set or
                        self.fail_reason.yfilter != YFilter.not_set or
                        self.forwarding_adjacency.yfilter != YFilter.not_set or
                        self.hop_limit_ignored_reason.yfilter != YFilter.not_set or
                        self.invalidation_time_remained.yfilter != YFilter.not_set or
                        self.is_auto_backup.yfilter != YFilter.not_set or
                        self.is_auto_pcc.yfilter != YFilter.not_set or
                        self.is_bandwidth_protect.yfilter != YFilter.not_set or
                        self.is_hop_limit_ignore.yfilter != YFilter.not_set or
                        self.is_inter_area_tunnel.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_named.yfilter != YFilter.not_set or
                        self.is_node_protected.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.is_pce_delegated.yfilter != YFilter.not_set or
                        self.last_hop_ifindex.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.load_share_factor.yfilter != YFilter.not_set or
                        self.load_share_type.yfilter != YFilter.not_set or
                        self.lsp_wrap_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set or
                        self.metric_qualifier.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set or
                        self.operational_state.yfilter != YFilter.not_set or
                        self.operational_state_changes.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.passive_tunnel_name.yfilter != YFilter.not_set or
                        self.path_option_change.yfilter != YFilter.not_set or
                        self.pce_fail_reason.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set or
                        self.reroute_pending.yfilter != YFilter.not_set or
                        self.role_standby.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.snmp_index.yfilter != YFilter.not_set or
                        self.tie_breaker.yfilter != YFilter.not_set or
                        self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                        self.tiebreaker_type.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        self.tunnel_interface_name.yfilter != YFilter.not_set or
                        self.tunnel_recovering.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        self.xro_attribute_set_name.yfilter != YFilter.not_set or
                        (self.auto_backup is not None and self.auto_backup.has_operation()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_operation()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_operation()) or
                        (self.bfd_info is not None and self.bfd_info.has_operation()) or
                        (self.bidir is not None and self.bidir.has_operation()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_operation()) or
                        (self.config is not None and self.config.has_operation()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_operation()) or
                        (self.flex_info is not None and self.flex_info.has_operation()) or
                        (self.history is not None and self.history.has_operation()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_operation()) or
                        (self.p2p_info is not None and self.p2p_info.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_operation()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_operation()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_operation()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_operation()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_operation()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_operation()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_operation()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_operation()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_operation()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-head" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-heads/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.admin_state.is_set or self.admin_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_state.get_name_leafdata())
                    if (self.affinity_failure_delayed_tear_time_remained.is_set or self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_delayed_tear_time_remained.get_name_leafdata())
                    if (self.affinity_failure_reopt_disabled.is_set or self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_disabled.get_name_leafdata())
                    if (self.affinity_failure_reopt_time_remained.is_set or self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_time_remained.get_name_leafdata())
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.auto_route.is_set or self.auto_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_route.get_name_leafdata())
                    if (self.autoroute_announce_exclude_segment_routing.is_set or self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autoroute_announce_exclude_segment_routing.get_name_leafdata())
                    if (self.bandwidth_requested.is_set or self.bandwidth_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_requested.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                    if (self.binding_label_exists.is_set or self.binding_label_exists.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label_exists.get_name_leafdata())
                    if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.create_time.get_name_leafdata())
                    if (self.destination_disabled_count.is_set or self.destination_disabled_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_disabled_count.get_name_leafdata())
                    if (self.destination_down_count.is_set or self.destination_down_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_down_count.get_name_leafdata())
                    if (self.destination_up_count.is_set or self.destination_up_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_up_count.get_name_leafdata())
                    if (self.drop_mode.is_set or self.drop_mode.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.drop_mode.get_name_leafdata())
                    if (self.explicit_path_change.is_set or self.explicit_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.explicit_path_change.get_name_leafdata())
                    if (self.fail_reason.is_set or self.fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fail_reason.get_name_leafdata())
                    if (self.forwarding_adjacency.is_set or self.forwarding_adjacency.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency.get_name_leafdata())
                    if (self.hop_limit_ignored_reason.is_set or self.hop_limit_ignored_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit_ignored_reason.get_name_leafdata())
                    if (self.invalidation_time_remained.is_set or self.invalidation_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.invalidation_time_remained.get_name_leafdata())
                    if (self.is_auto_backup.is_set or self.is_auto_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_backup.get_name_leafdata())
                    if (self.is_auto_pcc.is_set or self.is_auto_pcc.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_pcc.get_name_leafdata())
                    if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                    if (self.is_hop_limit_ignore.is_set or self.is_hop_limit_ignore.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_hop_limit_ignore.get_name_leafdata())
                    if (self.is_inter_area_tunnel.is_set or self.is_inter_area_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_inter_area_tunnel.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_named.is_set or self.is_named.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_named.get_name_leafdata())
                    if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.is_pce_delegated.is_set or self.is_pce_delegated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_delegated.get_name_leafdata())
                    if (self.last_hop_ifindex.is_set or self.last_hop_ifindex.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_hop_ifindex.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.load_share_factor.is_set or self.load_share_factor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_factor.get_name_leafdata())
                    if (self.load_share_type.is_set or self.load_share_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_type.get_name_leafdata())
                    if (self.lsp_wrap_label.is_set or self.lsp_wrap_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_enabled.is_set or self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enabled.get_name_leafdata())
                    if (self.metric_qualifier.is_set or self.metric_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_qualifier.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                    if (self.operational_state.is_set or self.operational_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state.get_name_leafdata())
                    if (self.operational_state_changes.is_set or self.operational_state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state_changes.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.passive_tunnel_name.is_set or self.passive_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.passive_tunnel_name.get_name_leafdata())
                    if (self.path_option_change.is_set or self.path_option_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_option_change.get_name_leafdata())
                    if (self.pce_fail_reason.is_set or self.pce_fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_fail_reason.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.re_opt_hold_down_timer_remaining.is_set or self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.re_opt_hold_down_timer_remaining.get_name_leafdata())
                    if (self.reroute_pending.is_set or self.reroute_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reroute_pending.get_name_leafdata())
                    if (self.role_standby.is_set or self.role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role_standby.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.snmp_index.is_set or self.snmp_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.snmp_index.get_name_leafdata())
                    if (self.tie_breaker.is_set or self.tie_breaker.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tie_breaker.get_name_leafdata())
                    if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                    if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())
                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())
                    if (self.tunnel_recovering.is_set or self.tunnel_recovering.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_recovering.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())
                    if (self.xro_attribute_set_name.is_set or self.xro_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.xro_attribute_set_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-backup"):
                        if (self.auto_backup is None):
                            self.auto_backup = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                            self.auto_backup.parent = self
                            self._children_name_map["auto_backup"] = "auto-backup"
                        return self.auto_backup

                    if (child_yang_name == "auto-mesh"):
                        if (self.auto_mesh is None):
                            self.auto_mesh = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                            self.auto_mesh.parent = self
                            self._children_name_map["auto_mesh"] = "auto-mesh"
                        return self.auto_mesh

                    if (child_yang_name == "auto-pcc"):
                        if (self.auto_pcc is None):
                            self.auto_pcc = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                            self.auto_pcc.parent = self
                            self._children_name_map["auto_pcc"] = "auto-pcc"
                        return self.auto_pcc

                    if (child_yang_name == "bfd-info"):
                        if (self.bfd_info is None):
                            self.bfd_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                            self.bfd_info.parent = self
                            self._children_name_map["bfd_info"] = "bfd-info"
                        return self.bfd_info

                    if (child_yang_name == "bidir"):
                        if (self.bidir is None):
                            self.bidir = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir()
                            self.bidir.parent = self
                            self._children_name_map["bidir"] = "bidir"
                        return self.bidir

                    if (child_yang_name == "cleaned-lsp"):
                        if (self.cleaned_lsp is None):
                            self.cleaned_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                            self.cleaned_lsp.parent = self
                            self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                        return self.cleaned_lsp

                    if (child_yang_name == "config"):
                        if (self.config is None):
                            self.config = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config()
                            self.config.parent = self
                            self._children_name_map["config"] = "config"
                        return self.config

                    if (child_yang_name == "delay-clean-pp-lsp"):
                        if (self.delay_clean_pp_lsp is None):
                            self.delay_clean_pp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                            self.delay_clean_pp_lsp.parent = self
                            self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                        return self.delay_clean_pp_lsp

                    if (child_yang_name == "destination"):
                        for c in self.destination:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination.append(c)
                        return c

                    if (child_yang_name == "flex-info"):
                        if (self.flex_info is None):
                            self.flex_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                        return self.flex_info

                    if (child_yang_name == "history"):
                        if (self.history is None):
                            self.history = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.History()
                            self.history.parent = self
                            self._children_name_map["history"] = "history"
                        return self.history

                    if (child_yang_name == "otn-bidir"):
                        if (self.otn_bidir is None):
                            self.otn_bidir = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                            self.otn_bidir.parent = self
                            self._children_name_map["otn_bidir"] = "otn-bidir"
                        return self.otn_bidir

                    if (child_yang_name == "p2p-info"):
                        if (self.p2p_info is None):
                            self.p2p_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo()
                            self.p2p_info.parent = self
                            self._children_name_map["p2p_info"] = "p2p-info"
                        return self.p2p_info

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "pce-delegation"):
                        if (self.pce_delegation is None):
                            self.pce_delegation = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                            self.pce_delegation.parent = self
                            self._children_name_map["pce_delegation"] = "pce-delegation"
                        return self.pce_delegation

                    if (child_yang_name == "reoptimized-p2mp-lsp"):
                        if (self.reoptimized_p2mp_lsp is None):
                            self.reoptimized_p2mp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp()
                            self.reoptimized_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                        return self.reoptimized_p2mp_lsp

                    if (child_yang_name == "reoptimized-standby-p2mp-lsp"):
                        if (self.reoptimized_standby_p2mp_lsp is None):
                            self.reoptimized_standby_p2mp_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp()
                            self.reoptimized_standby_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                        return self.reoptimized_standby_p2mp_lsp

                    if (child_yang_name == "soft-preemption"):
                        if (self.soft_preemption is None):
                            self.soft_preemption = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                        return self.soft_preemption

                    if (child_yang_name == "te-tunnel-convergence"):
                        if (self.te_tunnel_convergence is None):
                            self.te_tunnel_convergence = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                            self.te_tunnel_convergence.parent = self
                            self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                        return self.te_tunnel_convergence

                    if (child_yang_name == "transport-tunnel-info"):
                        if (self.transport_tunnel_info is None):
                            self.transport_tunnel_info = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                            self.transport_tunnel_info.parent = self
                            self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                        return self.transport_tunnel_info

                    if (child_yang_name == "tunnel-current-lsp"):
                        if (self.tunnel_current_lsp is None):
                            self.tunnel_current_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                            self.tunnel_current_lsp.parent = self
                            self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                        return self.tunnel_current_lsp

                    if (child_yang_name == "tunnel-restoration-lsp"):
                        if (self.tunnel_restoration_lsp is None):
                            self.tunnel_restoration_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                            self.tunnel_restoration_lsp.parent = self
                            self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                        return self.tunnel_restoration_lsp

                    if (child_yang_name == "tunnel-standby-lsp"):
                        if (self.tunnel_standby_lsp is None):
                            self.tunnel_standby_lsp = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                            self.tunnel_standby_lsp.parent = self
                            self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                        return self.tunnel_standby_lsp

                    if (child_yang_name == "wdm-unitunnel"):
                        if (self.wdm_unitunnel is None):
                            self.wdm_unitunnel = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                            self.wdm_unitunnel.parent = self
                            self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                        return self.wdm_unitunnel

                    if (child_yang_name == "xro-attribute-set"):
                        if (self.xro_attribute_set is None):
                            self.xro_attribute_set = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                        return self.xro_attribute_set

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-backup" or name == "auto-mesh" or name == "auto-pcc" or name == "bfd-info" or name == "bidir" or name == "cleaned-lsp" or name == "config" or name == "delay-clean-pp-lsp" or name == "destination" or name == "flex-info" or name == "history" or name == "otn-bidir" or name == "p2p-info" or name == "path-protection" or name == "pce-delegation" or name == "reoptimized-p2mp-lsp" or name == "reoptimized-standby-p2mp-lsp" or name == "soft-preemption" or name == "te-tunnel-convergence" or name == "transport-tunnel-info" or name == "tunnel-current-lsp" or name == "tunnel-restoration-lsp" or name == "tunnel-standby-lsp" or name == "wdm-unitunnel" or name == "xro-attribute-set" or name == "tunnel-name" or name == "admin-state" or name == "affinity-failure-delayed-tear-time-remained" or name == "affinity-failure-reopt-disabled" or name == "affinity-failure-reopt-time-remained" or name == "area-id" or name == "auto-route" or name == "autoroute-announce-exclude-segment-routing" or name == "bandwidth-requested" or name == "bandwidth-type" or name == "binding-label" or name == "binding-label-exists" or name == "create-time" or name == "destination-disabled-count" or name == "destination-down-count" or name == "destination-up-count" or name == "drop-mode" or name == "explicit-path-change" or name == "fail-reason" or name == "forwarding-adjacency" or name == "hop-limit-ignored-reason" or name == "invalidation-time-remained" or name == "is-auto-backup" or name == "is-auto-pcc" or name == "is-bandwidth-protect" or name == "is-hop-limit-ignore" or name == "is-inter-area-tunnel" or name == "is-interface" or name == "is-named" or name == "is-node-protected" or name == "is-passive" or name == "is-pce-delegated" or name == "last-hop-ifindex" or name == "last-path-change" or name == "load-share-factor" or name == "load-share-type" or name == "lsp-wrap-label" or name == "lsp-wrap-protection-enabled" or name == "metric-qualifier" or name == "metric-type" or name == "operational-state" or name == "operational-state-changes" or name == "outbound-frr-state" or name == "passive-tunnel-name" or name == "path-option-change" or name == "pce-fail-reason" or name == "persistent-bytes" or name == "persistent-packets" or name == "re-opt-hold-down-timer-remaining" or name == "reroute-pending" or name == "role-standby" or name == "signaled-name" or name == "snmp-index" or name == "tie-breaker" or name == "tiebreaker-qualifier" or name == "tiebreaker-type" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-type" or name == "tunnel-interface-name" or name == "tunnel-recovering" or name == "uptime" or name == "xro-attribute-set-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-state"):
                        self.admin_state = value
                        self.admin_state.value_namespace = name_space
                        self.admin_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-delayed-tear-time-remained"):
                        self.affinity_failure_delayed_tear_time_remained = value
                        self.affinity_failure_delayed_tear_time_remained.value_namespace = name_space
                        self.affinity_failure_delayed_tear_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-disabled"):
                        self.affinity_failure_reopt_disabled = value
                        self.affinity_failure_reopt_disabled.value_namespace = name_space
                        self.affinity_failure_reopt_disabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-time-remained"):
                        self.affinity_failure_reopt_time_remained = value
                        self.affinity_failure_reopt_time_remained.value_namespace = name_space
                        self.affinity_failure_reopt_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-route"):
                        self.auto_route = value
                        self.auto_route.value_namespace = name_space
                        self.auto_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "autoroute-announce-exclude-segment-routing"):
                        self.autoroute_announce_exclude_segment_routing = value
                        self.autoroute_announce_exclude_segment_routing.value_namespace = name_space
                        self.autoroute_announce_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-requested"):
                        self.bandwidth_requested = value
                        self.bandwidth_requested.value_namespace = name_space
                        self.bandwidth_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label"):
                        self.binding_label = value
                        self.binding_label.value_namespace = name_space
                        self.binding_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label-exists"):
                        self.binding_label_exists = value
                        self.binding_label_exists.value_namespace = name_space
                        self.binding_label_exists.value_namespace_prefix = name_space_prefix
                    if(value_path == "create-time"):
                        self.create_time = value
                        self.create_time.value_namespace = name_space
                        self.create_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-disabled-count"):
                        self.destination_disabled_count = value
                        self.destination_disabled_count.value_namespace = name_space
                        self.destination_disabled_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-down-count"):
                        self.destination_down_count = value
                        self.destination_down_count.value_namespace = name_space
                        self.destination_down_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-up-count"):
                        self.destination_up_count = value
                        self.destination_up_count.value_namespace = name_space
                        self.destination_up_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "drop-mode"):
                        self.drop_mode = value
                        self.drop_mode.value_namespace = name_space
                        self.drop_mode.value_namespace_prefix = name_space_prefix
                    if(value_path == "explicit-path-change"):
                        self.explicit_path_change = value
                        self.explicit_path_change.value_namespace = name_space
                        self.explicit_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "fail-reason"):
                        self.fail_reason = value
                        self.fail_reason.value_namespace = name_space
                        self.fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency"):
                        self.forwarding_adjacency = value
                        self.forwarding_adjacency.value_namespace = name_space
                        self.forwarding_adjacency.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit-ignored-reason"):
                        self.hop_limit_ignored_reason = value
                        self.hop_limit_ignored_reason.value_namespace = name_space
                        self.hop_limit_ignored_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "invalidation-time-remained"):
                        self.invalidation_time_remained = value
                        self.invalidation_time_remained.value_namespace = name_space
                        self.invalidation_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-backup"):
                        self.is_auto_backup = value
                        self.is_auto_backup.value_namespace = name_space
                        self.is_auto_backup.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-pcc"):
                        self.is_auto_pcc = value
                        self.is_auto_pcc.value_namespace = name_space
                        self.is_auto_pcc.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bandwidth-protect"):
                        self.is_bandwidth_protect = value
                        self.is_bandwidth_protect.value_namespace = name_space
                        self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-hop-limit-ignore"):
                        self.is_hop_limit_ignore = value
                        self.is_hop_limit_ignore.value_namespace = name_space
                        self.is_hop_limit_ignore.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-inter-area-tunnel"):
                        self.is_inter_area_tunnel = value
                        self.is_inter_area_tunnel.value_namespace = name_space
                        self.is_inter_area_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-named"):
                        self.is_named = value
                        self.is_named.value_namespace = name_space
                        self.is_named.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-node-protected"):
                        self.is_node_protected = value
                        self.is_node_protected.value_namespace = name_space
                        self.is_node_protected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-delegated"):
                        self.is_pce_delegated = value
                        self.is_pce_delegated.value_namespace = name_space
                        self.is_pce_delegated.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-hop-ifindex"):
                        self.last_hop_ifindex = value
                        self.last_hop_ifindex.value_namespace = name_space
                        self.last_hop_ifindex.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-factor"):
                        self.load_share_factor = value
                        self.load_share_factor.value_namespace = name_space
                        self.load_share_factor.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-type"):
                        self.load_share_type = value
                        self.load_share_type.value_namespace = name_space
                        self.load_share_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-label"):
                        self.lsp_wrap_label = value
                        self.lsp_wrap_label.value_namespace = name_space
                        self.lsp_wrap_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enabled"):
                        self.lsp_wrap_protection_enabled = value
                        self.lsp_wrap_protection_enabled.value_namespace = name_space
                        self.lsp_wrap_protection_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-qualifier"):
                        self.metric_qualifier = value
                        self.metric_qualifier.value_namespace = name_space
                        self.metric_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state"):
                        self.operational_state = value
                        self.operational_state.value_namespace = name_space
                        self.operational_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state-changes"):
                        self.operational_state_changes = value
                        self.operational_state_changes.value_namespace = name_space
                        self.operational_state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "passive-tunnel-name"):
                        self.passive_tunnel_name = value
                        self.passive_tunnel_name.value_namespace = name_space
                        self.passive_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-option-change"):
                        self.path_option_change = value
                        self.path_option_change.value_namespace = name_space
                        self.path_option_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-fail-reason"):
                        self.pce_fail_reason = value
                        self.pce_fail_reason.value_namespace = name_space
                        self.pce_fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "re-opt-hold-down-timer-remaining"):
                        self.re_opt_hold_down_timer_remaining = value
                        self.re_opt_hold_down_timer_remaining.value_namespace = name_space
                        self.re_opt_hold_down_timer_remaining.value_namespace_prefix = name_space_prefix
                    if(value_path == "reroute-pending"):
                        self.reroute_pending = value
                        self.reroute_pending.value_namespace = name_space
                        self.reroute_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "role-standby"):
                        self.role_standby = value
                        self.role_standby.value_namespace = name_space
                        self.role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "snmp-index"):
                        self.snmp_index = value
                        self.snmp_index.value_namespace = name_space
                        self.snmp_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "tie-breaker"):
                        self.tie_breaker = value
                        self.tie_breaker.value_namespace = name_space
                        self.tie_breaker.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-qualifier"):
                        self.tiebreaker_qualifier = value
                        self.tiebreaker_qualifier.value_namespace = name_space
                        self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-type"):
                        self.tiebreaker_type = value
                        self.tiebreaker_type.value_namespace = name_space
                        self.tiebreaker_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface-name"):
                        self.tunnel_interface_name = value
                        self.tunnel_interface_name.value_namespace = name_space
                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-recovering"):
                        self.tunnel_recovering = value
                        self.tunnel_recovering.value_namespace = name_space
                        self.tunnel_recovering.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix
                    if(value_path == "xro-attribute-set-name"):
                        self.xro_attribute_set_name = value
                        self.xro_attribute_set_name.value_namespace = name_space
                        self.xro_attribute_set_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_head:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_head:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-heads" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-head"):
                    for c in self.tunnel_head:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2PP2MpTunnel.TunnelHeads.TunnelHead()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_head.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-head"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.nni_tunnels is not None and self.nni_tunnels.has_data()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_data()) or
                (self.tunnel_remote_briefs is not None and self.tunnel_remote_briefs.has_data()) or
                (self.tunnel_remotes is not None and self.tunnel_remotes.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.nni_tunnels is not None and self.nni_tunnels.has_operation()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_operation()) or
                (self.tunnel_remote_briefs is not None and self.tunnel_remote_briefs.has_operation()) or
                (self.tunnel_remotes is not None and self.tunnel_remotes.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "p2p-p2mp-tunnel" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "nni-tunnels"):
                if (self.nni_tunnels is None):
                    self.nni_tunnels = MplsTe.P2PP2MpTunnel.NniTunnels()
                    self.nni_tunnels.parent = self
                    self._children_name_map["nni_tunnels"] = "nni-tunnels"
                return self.nni_tunnels

            if (child_yang_name == "tunnel-heads"):
                if (self.tunnel_heads is None):
                    self.tunnel_heads = MplsTe.P2PP2MpTunnel.TunnelHeads()
                    self.tunnel_heads.parent = self
                    self._children_name_map["tunnel_heads"] = "tunnel-heads"
                return self.tunnel_heads

            if (child_yang_name == "tunnel-remote-briefs"):
                if (self.tunnel_remote_briefs is None):
                    self.tunnel_remote_briefs = MplsTe.P2PP2MpTunnel.TunnelRemoteBriefs()
                    self.tunnel_remote_briefs.parent = self
                    self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"
                return self.tunnel_remote_briefs

            if (child_yang_name == "tunnel-remotes"):
                if (self.tunnel_remotes is None):
                    self.tunnel_remotes = MplsTe.P2PP2MpTunnel.TunnelRemotes()
                    self.tunnel_remotes.parent = self
                    self._children_name_map["tunnel_remotes"] = "tunnel-remotes"
                return self.tunnel_remotes

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "nni-tunnels" or name == "tunnel-heads" or name == "tunnel-remote-briefs" or name == "tunnel-remotes"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TopologyNodes(Entity):
        """
        A node in the MPLS\-TE topology
        
        .. attribute:: topology_node
        
        	A node in the MPLS\-TE topology
        	**type**\: list of    :py:class:`TopologyNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.TopologyNodes, self).__init__()

            self.yang_name = "topology-nodes"
            self.yang_parent_name = "mpls-te"

            self.topology_node = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.TopologyNodes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.TopologyNodes, self).__setattr__(name, value)


        class TopologyNode(Entity):
            """
            A node in the MPLS\-TE topology
            
            .. attribute:: protocol  <key>
            
            	IGP protocol type
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: igp_id  <key>
            
            	IGP instance
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area  <key>
            
            	IGP area
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: topology_node_type  <key>
            
            	Node type
            	**type**\:   :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            .. attribute:: igp_node_id  <key>
            
            	IGP Node ID
            	**type**\:  str
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of    :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink>`
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\:  bool
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:   :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg>`
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.TopologyNodes.TopologyNode, self).__init__()

                self.yang_name = "topology-node"
                self.yang_parent_name = "topology-nodes"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.igp_id = YLeaf(YType.str, "igp-id")

                self.area = YLeaf(YType.int32, "area")

                self.topology_node_type = YLeaf(YType.enumeration, "topology-node-type")

                self.igp_node_id = YLeaf(YType.str, "igp-node-id")

                self.topology_node_overloaded = YLeaf(YType.boolean, "topology-node-overloaded")

                self.topology_node_te_router_id = YLeaf(YType.str, "topology-node-te-router-id")

                self.topology_node_sid_and_srbg = MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                self._children_yang_names.add("topology-node-sid-and-srbg")

                self.topology_node_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "igp_id",
                                "area",
                                "topology_node_type",
                                "igp_node_id",
                                "topology_node_overloaded",
                                "topology_node_te_router_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.TopologyNodes.TopologyNode, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.TopologyNodes.TopologyNode, self).__setattr__(name, value)


            class TopologyNodeSidAndSrbg(Entity):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-node"

                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                    self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                    self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                    self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("segment_id",
                                    "segment_id_local_absolute_value",
                                    "srgb_size",
                                    "srgb_start") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.segment_id.is_set or
                        self.segment_id_local_absolute_value.is_set or
                        self.srgb_size.is_set or
                        self.srgb_start.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.segment_id.yfilter != YFilter.not_set or
                        self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                        self.srgb_size.yfilter != YFilter.not_set or
                        self.srgb_start.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-sid-and-srbg" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                    if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                    if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_size.get_name_leafdata())
                    if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_start.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "segment-id"):
                        self.segment_id = value
                        self.segment_id.value_namespace = name_space
                        self.segment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "segment-id-local-absolute-value"):
                        self.segment_id_local_absolute_value = value
                        self.segment_id_local_absolute_value.value_namespace = name_space
                        self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-size"):
                        self.srgb_size = value
                        self.srgb_size.value_namespace = name_space
                        self.srgb_size.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-start"):
                        self.srgb_start = value
                        self.srgb_start.value_namespace = name_space
                        self.srgb_start.value_namespace_prefix = name_space_prefix


            class TopologyNodeLink(Entity):
                """
                This node's link information
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of    :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid>`
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities>`
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup>`
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:   :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth>`
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:   :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of    :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\:  str
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-node"

                    self.topology_link_affinity_bits = YLeaf(YType.uint32, "topology-link-affinity-bits")

                    self.topology_link_bandwidth_model = YLeaf(YType.enumeration, "topology-link-bandwidth-model")

                    self.topology_link_encoding = YLeaf(YType.uint8, "topology-link-encoding")

                    self.topology_link_fragment_id = YLeaf(YType.uint32, "topology-link-fragment-id")

                    self.topology_link_igp_metric = YLeaf(YType.uint32, "topology-link-igp-metric")

                    self.topology_link_interface_address = YLeaf(YType.str, "topology-link-interface-address")

                    self.topology_link_interface_id = YLeaf(YType.uint32, "topology-link-interface-id")

                    self.topology_link_neighbor_address = YLeaf(YType.str, "topology-link-neighbor-address")

                    self.topology_link_neighbor_generation = YLeaf(YType.uint32, "topology-link-neighbor-generation")

                    self.topology_link_neighbor_id = YLeaf(YType.uint32, "topology-link-neighbor-id")

                    self.topology_link_neighbor_node_id = YLeaf(YType.uint32, "topology-link-neighbor-node-id")

                    self.topology_link_neighbor_system_id = YLeaf(YType.str, "topology-link-neighbor-system-id")

                    self.topology_link_switching_capability = YLeaf(YType.uint8, "topology-link-switching-capability")

                    self.topology_link_te_metric = YLeaf(YType.uint32, "topology-link-te-metric")

                    self.topology_link_type = YLeaf(YType.enumeration, "topology-link-type")

                    self.topology_link_uni_delay = YLeaf(YType.uint32, "topology-link-uni-delay")

                    self.odu_link_capabilities = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.topology_link_bandwidth = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                    self._children_yang_names.add("topology-link-bandwidth")

                    self.adjacency_sid = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.topology_link_extended_affinity_bit = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("topology_link_affinity_bits",
                                    "topology_link_bandwidth_model",
                                    "topology_link_encoding",
                                    "topology_link_fragment_id",
                                    "topology_link_igp_metric",
                                    "topology_link_interface_address",
                                    "topology_link_interface_id",
                                    "topology_link_neighbor_address",
                                    "topology_link_neighbor_generation",
                                    "topology_link_neighbor_id",
                                    "topology_link_neighbor_node_id",
                                    "topology_link_neighbor_system_id",
                                    "topology_link_switching_capability",
                                    "topology_link_te_metric",
                                    "topology_link_type",
                                    "topology_link_uni_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink, self).__setattr__(name, value)


                class TopologyLinkBandwidth(Entity):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"

                        self.bandwidth_migration_mode = YLeaf(YType.enumeration, "bandwidth-migration-mode")

                        self.topology_link_bandwidth_prestandard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                        self._children_yang_names.add("topology-link-bandwidth-prestandard")

                        self.topology_link_bandwidth_standard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._children_yang_names.add("topology-link-bandwidth-standard")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_migration_mode") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)


                    class TopologyLinkBandwidthPrestandard(Entity):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topology_link_prestandard_bandwidth_physical = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-physical")

                            self.topology_link_prestandard_bandwidth_reservation_global = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-global")

                            self.topology_link_prestandard_bandwidth_reservation_subpool = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-subpool")

                            self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._children_yang_names.add("topology-link-prestandard-bandwidth-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topology_link_prestandard_bandwidth_physical",
                                            "topology_link_prestandard_bandwidth_reservation_global",
                                            "topology_link_prestandard_bandwidth_reservation_subpool") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)


                        class TopologyLinkPrestandardBandwidthDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(Entity):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(Entity):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(Entity):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-subpool" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topology-link-prestandard-bandwidth-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topology-link-prestandard-bandwidth-allocated"):
                                    for c in self.topology_link_prestandard_bandwidth_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_allocated.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-global"):
                                    for c in self.topology_link_prestandard_bandwidth_available_global:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_global.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_subpool.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topology-link-prestandard-bandwidth-allocated" or name == "topology-link-prestandard-bandwidth-available-global" or name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topology_link_prestandard_bandwidth_physical.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-prestandard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topology_link_prestandard_bandwidth_physical.is_set or self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_physical.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_global.is_set or self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_global.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_subpool.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topology-link-prestandard-bandwidth-detail"):
                                if (self.topology_link_prestandard_bandwidth_detail is None):
                                    self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                                    self.topology_link_prestandard_bandwidth_detail.parent = self
                                    self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                                return self.topology_link_prestandard_bandwidth_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topology-link-prestandard-bandwidth-detail" or name == "topology-link-prestandard-bandwidth-physical" or name == "topology-link-prestandard-bandwidth-reservation-global" or name == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topology-link-prestandard-bandwidth-physical"):
                                self.topology_link_prestandard_bandwidth_physical = value
                                self.topology_link_prestandard_bandwidth_physical.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-global"):
                                self.topology_link_prestandard_bandwidth_reservation_global = value
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                self.topology_link_prestandard_bandwidth_reservation_subpool = value
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace_prefix = name_space_prefix


                    class TopologyLinkBandwidthStandard(Entity):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topo_link_std_bw_physical = YLeaf(YType.uint32, "topo-link-std-bw-physical")

                            self.topo_link_std_bw_res_max = YLeaf(YType.uint32, "topo-link-std-bw-res-max")

                            self.topo_link_std_bw_res_pool0 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool0")

                            self.topo_link_std_bw_res_pool1 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool1")

                            self.topo_link_std_bw_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._children_yang_names.add("topo-link-std-bw-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topo_link_std_bw_physical",
                                            "topo_link_std_bw_res_max",
                                            "topo_link_std_bw_res_pool0",
                                            "topo_link_std_bw_res_pool1") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)


                        class TopoLinkStdBwDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)


                            class TopoLinkStdBwAllocated(Entity):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopoLinkStdBwAvailable(Entity):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-available" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topo-link-std-bw-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topo-link-std-bw-allocated"):
                                    for c in self.topo_link_std_bw_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_allocated.append(c)
                                    return c

                                if (child_yang_name == "topo-link-std-bw-available"):
                                    for c in self.topo_link_std_bw_available:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_available.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topo-link-std-bw-allocated" or name == "topo-link-std-bw-available"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topo_link_std_bw_physical.is_set or
                                self.topo_link_std_bw_res_max.is_set or
                                self.topo_link_std_bw_res_pool0.is_set or
                                self.topo_link_std_bw_res_pool1.is_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_physical.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_max.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-standard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topo_link_std_bw_physical.is_set or self.topo_link_std_bw_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_physical.get_name_leafdata())
                            if (self.topo_link_std_bw_res_max.is_set or self.topo_link_std_bw_res_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_max.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool0.is_set or self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool0.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool1.is_set or self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool1.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topo-link-std-bw-detail"):
                                if (self.topo_link_std_bw_detail is None):
                                    self.topo_link_std_bw_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                                    self.topo_link_std_bw_detail.parent = self
                                    self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                                return self.topo_link_std_bw_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topo-link-std-bw-detail" or name == "topo-link-std-bw-physical" or name == "topo-link-std-bw-res-max" or name == "topo-link-std-bw-res-pool0" or name == "topo-link-std-bw-res-pool1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topo-link-std-bw-physical"):
                                self.topo_link_std_bw_physical = value
                                self.topo_link_std_bw_physical.value_namespace = name_space
                                self.topo_link_std_bw_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-max"):
                                self.topo_link_std_bw_res_max = value
                                self.topo_link_std_bw_res_max.value_namespace = name_space
                                self.topo_link_std_bw_res_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool0"):
                                self.topo_link_std_bw_res_pool0 = value
                                self.topo_link_std_bw_res_pool0.value_namespace = name_space
                                self.topo_link_std_bw_res_pool0.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool1"):
                                self.topo_link_std_bw_res_pool1 = value
                                self.topo_link_std_bw_res_pool1.value_namespace = name_space
                                self.topo_link_std_bw_res_pool1.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.bandwidth_migration_mode.is_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_data()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_migration_mode.yfilter != YFilter.not_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_operation()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_migration_mode.is_set or self.bandwidth_migration_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_migration_mode.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "topology-link-bandwidth-prestandard"):
                            if (self.topology_link_bandwidth_prestandard is None):
                                self.topology_link_bandwidth_prestandard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                                self.topology_link_bandwidth_prestandard.parent = self
                                self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                            return self.topology_link_bandwidth_prestandard

                        if (child_yang_name == "topology-link-bandwidth-standard"):
                            if (self.topology_link_bandwidth_standard is None):
                                self.topology_link_bandwidth_standard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                                self.topology_link_bandwidth_standard.parent = self
                                self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                            return self.topology_link_bandwidth_standard

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "topology-link-bandwidth-prestandard" or name == "topology-link-bandwidth-standard" or name == "bandwidth-migration-mode"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-migration-mode"):
                            self.bandwidth_migration_mode = value
                            self.bandwidth_migration_mode.value_namespace = name_space
                            self.bandwidth_migration_mode.value_namespace_prefix = name_space_prefix


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TopologyLinkExtendedAffinityBit(Entity):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-extended-affinity-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class AdjacencySid(Entity):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\:  bool
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\:  bool
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\:  bool
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\:  bool
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\:  bool
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\:  str
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"

                        self.adjacency_sid = YLeaf(YType.uint32, "adjacency-sid")

                        self.flag_b = YLeaf(YType.boolean, "flag-b")

                        self.flag_f = YLeaf(YType.boolean, "flag-f")

                        self.flag_l = YLeaf(YType.boolean, "flag-l")

                        self.flag_s = YLeaf(YType.boolean, "flag-s")

                        self.flag_v = YLeaf(YType.boolean, "flag-v")

                        self.link_type = YLeaf(YType.enumeration, "link-type")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.nbr_node_igpid = YLeaf(YType.str, "nbr-node-igpid")

                        self.nbr_node_te_router_id = YLeaf(YType.str, "nbr-node-te-router-id")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("adjacency_sid",
                                        "flag_b",
                                        "flag_f",
                                        "flag_l",
                                        "flag_s",
                                        "flag_v",
                                        "link_type",
                                        "local_addr",
                                        "nbr_node_igpid",
                                        "nbr_node_te_router_id",
                                        "remote_addr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.adjacency_sid.is_set or
                            self.flag_b.is_set or
                            self.flag_f.is_set or
                            self.flag_l.is_set or
                            self.flag_s.is_set or
                            self.flag_v.is_set or
                            self.link_type.is_set or
                            self.local_addr.is_set or
                            self.nbr_node_igpid.is_set or
                            self.nbr_node_te_router_id.is_set or
                            self.remote_addr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.adjacency_sid.yfilter != YFilter.not_set or
                            self.flag_b.yfilter != YFilter.not_set or
                            self.flag_f.yfilter != YFilter.not_set or
                            self.flag_l.yfilter != YFilter.not_set or
                            self.flag_s.yfilter != YFilter.not_set or
                            self.flag_v.yfilter != YFilter.not_set or
                            self.link_type.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.nbr_node_igpid.yfilter != YFilter.not_set or
                            self.nbr_node_te_router_id.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "adjacency-sid" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.adjacency_sid.is_set or self.adjacency_sid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.adjacency_sid.get_name_leafdata())
                        if (self.flag_b.is_set or self.flag_b.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_b.get_name_leafdata())
                        if (self.flag_f.is_set or self.flag_f.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_f.get_name_leafdata())
                        if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_l.get_name_leafdata())
                        if (self.flag_s.is_set or self.flag_s.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_s.get_name_leafdata())
                        if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_v.get_name_leafdata())
                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_type.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.nbr_node_igpid.is_set or self.nbr_node_igpid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_igpid.get_name_leafdata())
                        if (self.nbr_node_te_router_id.is_set or self.nbr_node_te_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_te_router_id.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "adjacency-sid" or name == "flag-b" or name == "flag-f" or name == "flag-l" or name == "flag-s" or name == "flag-v" or name == "link-type" or name == "local-addr" or name == "nbr-node-igpid" or name == "nbr-node-te-router-id" or name == "remote-addr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "adjacency-sid"):
                            self.adjacency_sid = value
                            self.adjacency_sid.value_namespace = name_space
                            self.adjacency_sid.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-b"):
                            self.flag_b = value
                            self.flag_b.value_namespace = name_space
                            self.flag_b.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-f"):
                            self.flag_f = value
                            self.flag_f.value_namespace = name_space
                            self.flag_f.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-l"):
                            self.flag_l = value
                            self.flag_l.value_namespace = name_space
                            self.flag_l.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-s"):
                            self.flag_s = value
                            self.flag_s.value_namespace = name_space
                            self.flag_s.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-v"):
                            self.flag_v = value
                            self.flag_v.value_namespace = name_space
                            self.flag_v.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-type"):
                            self.link_type = value
                            self.link_type.value_namespace = name_space
                            self.link_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-igpid"):
                            self.nbr_node_igpid = value
                            self.nbr_node_igpid.value_namespace = name_space
                            self.nbr_node_igpid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-te-router-id"):
                            self.nbr_node_te_router_id = value
                            self.nbr_node_te_router_id.value_namespace = name_space
                            self.nbr_node_te_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.adjacency_sid:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_data()):
                            return True
                    return (
                        self.topology_link_affinity_bits.is_set or
                        self.topology_link_bandwidth_model.is_set or
                        self.topology_link_encoding.is_set or
                        self.topology_link_fragment_id.is_set or
                        self.topology_link_igp_metric.is_set or
                        self.topology_link_interface_address.is_set or
                        self.topology_link_interface_id.is_set or
                        self.topology_link_neighbor_address.is_set or
                        self.topology_link_neighbor_generation.is_set or
                        self.topology_link_neighbor_id.is_set or
                        self.topology_link_neighbor_node_id.is_set or
                        self.topology_link_neighbor_system_id.is_set or
                        self.topology_link_switching_capability.is_set or
                        self.topology_link_te_metric.is_set or
                        self.topology_link_type.is_set or
                        self.topology_link_uni_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.adjacency_sid:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.topology_link_affinity_bits.yfilter != YFilter.not_set or
                        self.topology_link_bandwidth_model.yfilter != YFilter.not_set or
                        self.topology_link_encoding.yfilter != YFilter.not_set or
                        self.topology_link_fragment_id.yfilter != YFilter.not_set or
                        self.topology_link_igp_metric.yfilter != YFilter.not_set or
                        self.topology_link_interface_address.yfilter != YFilter.not_set or
                        self.topology_link_interface_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_address.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_generation.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_node_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_system_id.yfilter != YFilter.not_set or
                        self.topology_link_switching_capability.yfilter != YFilter.not_set or
                        self.topology_link_te_metric.yfilter != YFilter.not_set or
                        self.topology_link_type.yfilter != YFilter.not_set or
                        self.topology_link_uni_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.topology_link_affinity_bits.is_set or self.topology_link_affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_affinity_bits.get_name_leafdata())
                    if (self.topology_link_bandwidth_model.is_set or self.topology_link_bandwidth_model.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_bandwidth_model.get_name_leafdata())
                    if (self.topology_link_encoding.is_set or self.topology_link_encoding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_encoding.get_name_leafdata())
                    if (self.topology_link_fragment_id.is_set or self.topology_link_fragment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_fragment_id.get_name_leafdata())
                    if (self.topology_link_igp_metric.is_set or self.topology_link_igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_igp_metric.get_name_leafdata())
                    if (self.topology_link_interface_address.is_set or self.topology_link_interface_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_address.get_name_leafdata())
                    if (self.topology_link_interface_id.is_set or self.topology_link_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_id.get_name_leafdata())
                    if (self.topology_link_neighbor_address.is_set or self.topology_link_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_address.get_name_leafdata())
                    if (self.topology_link_neighbor_generation.is_set or self.topology_link_neighbor_generation.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_generation.get_name_leafdata())
                    if (self.topology_link_neighbor_id.is_set or self.topology_link_neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_id.get_name_leafdata())
                    if (self.topology_link_neighbor_node_id.is_set or self.topology_link_neighbor_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_node_id.get_name_leafdata())
                    if (self.topology_link_neighbor_system_id.is_set or self.topology_link_neighbor_system_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_system_id.get_name_leafdata())
                    if (self.topology_link_switching_capability.is_set or self.topology_link_switching_capability.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_switching_capability.get_name_leafdata())
                    if (self.topology_link_te_metric.is_set or self.topology_link_te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_te_metric.get_name_leafdata())
                    if (self.topology_link_type.is_set or self.topology_link_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_type.get_name_leafdata())
                    if (self.topology_link_uni_delay.is_set or self.topology_link_uni_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_uni_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "adjacency-sid"):
                        for c in self.adjacency_sid:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.adjacency_sid.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "topology-link-bandwidth"):
                        if (self.topology_link_bandwidth is None):
                            self.topology_link_bandwidth = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                            self.topology_link_bandwidth.parent = self
                            self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                        return self.topology_link_bandwidth

                    if (child_yang_name == "topology-link-extended-affinity-bit"):
                        for c in self.topology_link_extended_affinity_bit:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.topology_link_extended_affinity_bit.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "adjacency-sid" or name == "odu-link-capabilities" or name == "shared-risk-link-group" or name == "topology-link-bandwidth" or name == "topology-link-extended-affinity-bit" or name == "topology-link-affinity-bits" or name == "topology-link-bandwidth-model" or name == "topology-link-encoding" or name == "topology-link-fragment-id" or name == "topology-link-igp-metric" or name == "topology-link-interface-address" or name == "topology-link-interface-id" or name == "topology-link-neighbor-address" or name == "topology-link-neighbor-generation" or name == "topology-link-neighbor-id" or name == "topology-link-neighbor-node-id" or name == "topology-link-neighbor-system-id" or name == "topology-link-switching-capability" or name == "topology-link-te-metric" or name == "topology-link-type" or name == "topology-link-uni-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "topology-link-affinity-bits"):
                        self.topology_link_affinity_bits = value
                        self.topology_link_affinity_bits.value_namespace = name_space
                        self.topology_link_affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-bandwidth-model"):
                        self.topology_link_bandwidth_model = value
                        self.topology_link_bandwidth_model.value_namespace = name_space
                        self.topology_link_bandwidth_model.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-encoding"):
                        self.topology_link_encoding = value
                        self.topology_link_encoding.value_namespace = name_space
                        self.topology_link_encoding.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-fragment-id"):
                        self.topology_link_fragment_id = value
                        self.topology_link_fragment_id.value_namespace = name_space
                        self.topology_link_fragment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-igp-metric"):
                        self.topology_link_igp_metric = value
                        self.topology_link_igp_metric.value_namespace = name_space
                        self.topology_link_igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-address"):
                        self.topology_link_interface_address = value
                        self.topology_link_interface_address.value_namespace = name_space
                        self.topology_link_interface_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-id"):
                        self.topology_link_interface_id = value
                        self.topology_link_interface_id.value_namespace = name_space
                        self.topology_link_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-address"):
                        self.topology_link_neighbor_address = value
                        self.topology_link_neighbor_address.value_namespace = name_space
                        self.topology_link_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-generation"):
                        self.topology_link_neighbor_generation = value
                        self.topology_link_neighbor_generation.value_namespace = name_space
                        self.topology_link_neighbor_generation.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-id"):
                        self.topology_link_neighbor_id = value
                        self.topology_link_neighbor_id.value_namespace = name_space
                        self.topology_link_neighbor_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-node-id"):
                        self.topology_link_neighbor_node_id = value
                        self.topology_link_neighbor_node_id.value_namespace = name_space
                        self.topology_link_neighbor_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-system-id"):
                        self.topology_link_neighbor_system_id = value
                        self.topology_link_neighbor_system_id.value_namespace = name_space
                        self.topology_link_neighbor_system_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-switching-capability"):
                        self.topology_link_switching_capability = value
                        self.topology_link_switching_capability.value_namespace = name_space
                        self.topology_link_switching_capability.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-te-metric"):
                        self.topology_link_te_metric = value
                        self.topology_link_te_metric.value_namespace = name_space
                        self.topology_link_te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-type"):
                        self.topology_link_type = value
                        self.topology_link_type.value_namespace = name_space
                        self.topology_link_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-uni-delay"):
                        self.topology_link_uni_delay = value
                        self.topology_link_uni_delay.value_namespace = name_space
                        self.topology_link_uni_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.topology_node_link:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.igp_id.is_set or
                    self.area.is_set or
                    self.topology_node_type.is_set or
                    self.igp_node_id.is_set or
                    self.topology_node_overloaded.is_set or
                    self.topology_node_te_router_id.is_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_data()))

            def has_operation(self):
                for c in self.topology_node_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.igp_id.yfilter != YFilter.not_set or
                    self.area.yfilter != YFilter.not_set or
                    self.topology_node_type.yfilter != YFilter.not_set or
                    self.igp_node_id.yfilter != YFilter.not_set or
                    self.topology_node_overloaded.yfilter != YFilter.not_set or
                    self.topology_node_te_router_id.yfilter != YFilter.not_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "topology-node" + "[protocol='" + self.protocol.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + "[area='" + self.area.get() + "']" + "[topology-node-type='" + self.topology_node_type.get() + "']" + "[igp-node-id='" + self.igp_node_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology-nodes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_id.get_name_leafdata())
                if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area.get_name_leafdata())
                if (self.topology_node_type.is_set or self.topology_node_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_type.get_name_leafdata())
                if (self.igp_node_id.is_set or self.igp_node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_node_id.get_name_leafdata())
                if (self.topology_node_overloaded.is_set or self.topology_node_overloaded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_overloaded.get_name_leafdata())
                if (self.topology_node_te_router_id.is_set or self.topology_node_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_te_router_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "topology-node-link"):
                    for c in self.topology_node_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.topology_node_link.append(c)
                    return c

                if (child_yang_name == "topology-node-sid-and-srbg"):
                    if (self.topology_node_sid_and_srbg is None):
                        self.topology_node_sid_and_srbg = MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                        self.topology_node_sid_and_srbg.parent = self
                        self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                    return self.topology_node_sid_and_srbg

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "topology-node-link" or name == "topology-node-sid-and-srbg" or name == "protocol" or name == "igp-id" or name == "area" or name == "topology-node-type" or name == "igp-node-id" or name == "topology-node-overloaded" or name == "topology-node-te-router-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-id"):
                    self.igp_id = value
                    self.igp_id.value_namespace = name_space
                    self.igp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "area"):
                    self.area = value
                    self.area.value_namespace = name_space
                    self.area.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-type"):
                    self.topology_node_type = value
                    self.topology_node_type.value_namespace = name_space
                    self.topology_node_type.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-node-id"):
                    self.igp_node_id = value
                    self.igp_node_id.value_namespace = name_space
                    self.igp_node_id.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-overloaded"):
                    self.topology_node_overloaded = value
                    self.topology_node_overloaded.value_namespace = name_space
                    self.topology_node_overloaded.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-te-router-id"):
                    self.topology_node_te_router_id = value
                    self.topology_node_te_router_id.value_namespace = name_space
                    self.topology_node_te_router_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.topology_node:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.topology_node:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology-nodes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "topology-node"):
                for c in self.topology_node:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.TopologyNodes.TopologyNode()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.topology_node.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "topology-node"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AnnounceTunnelsInfo(Entity):
        """
        Announced tunnels (forwarding adjacency and
        autoroute annonce)
        
        .. attribute:: all_autoroute_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:   :py:class:`AllAutorouteTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable>`
        
        .. attribute:: autoroute_announce_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:   :py:class:`AutorouteAnnounceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AnnounceTunnelsInfo, self).__init__()

            self.yang_name = "announce-tunnels-info"
            self.yang_parent_name = "mpls-te"

            self.all_autoroute_table = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable()
            self.all_autoroute_table.parent = self
            self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
            self._children_yang_names.add("all-autoroute-table")

            self.autoroute_announce_table = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable()
            self.autoroute_announce_table.parent = self
            self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"
            self._children_yang_names.add("autoroute-announce-table")


        class AutorouteAnnounceTable(Entity):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of    :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__init__()

                self.yang_name = "autoroute-announce-table"
                self.yang_parent_name = "announce-tunnels-info"

                self.announce_dest = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__setattr__(name, value)


            class AnnounceDest(Entity):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: protocol  <key>
                
                	The IGP protocol used by the tunnel
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: area  <key>
                
                	Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_id  <key>
                
                	IGP Instance ID
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: destination
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of    :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "autoroute-announce-table"

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_id = YLeaf(YType.str, "igp-id")

                    self.announced_tunnels_count = YLeaf(YType.uint16, "announced-tunnels-count")

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.autorouted_tunnels_count = YLeaf(YType.uint16, "autorouted-tunnels-count")

                    self.destination = YLeaf(YType.str, "destination")

                    self.forwarding_adjacency_tunnels_count = YLeaf(YType.uint16, "forwarding-adjacency-tunnels-count")

                    self.igp_area = YLeaf(YType.uint32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.total_tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("destination_address",
                                    "protocol",
                                    "area",
                                    "igp_id",
                                    "announced_tunnels_count",
                                    "area_format",
                                    "autorouted_tunnels_count",
                                    "destination",
                                    "forwarding_adjacency_tunnels_count",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__setattr__(name, value)


                class TotalTunnel(Entity):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:   :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\:  bool
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:   :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"

                        self.announce_type = YLeaf(YType.enumeration, "announce-type")

                        self.area_format = YLeaf(YType.enumeration, "area-format")

                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                        self.igp_metric = YLeaf(YType.int32, "igp-metric")

                        self.is_auto_mesh_aa = YLeaf(YType.boolean, "is-auto-mesh-aa")

                        self.is_exclude_segment_routing = YLeaf(YType.boolean, "is-exclude-segment-routing")

                        self.is_sr = YLeaf(YType.boolean, "is-sr")

                        self.is_sr_strict = YLeaf(YType.boolean, "is-sr-strict")

                        self.mesh_group_idaa = YLeaf(YType.uint32, "mesh-group-idaa")

                        self.mode = YLeaf(YType.enumeration, "mode")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.tunnel_loadshare = YLeaf(YType.uint32, "tunnel-loadshare")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                        self.ig_ps = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("announce_type",
                                        "area_format",
                                        "hold_time",
                                        "igp_metric",
                                        "is_auto_mesh_aa",
                                        "is_exclude_segment_routing",
                                        "is_sr",
                                        "is_sr_strict",
                                        "mesh_group_idaa",
                                        "mode",
                                        "next_hop_address",
                                        "tunnel_loadshare",
                                        "tunnel_name",
                                        "tunnel_sig_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)


                    class IgPs(Entity):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"

                            self.afi = YLeaf(YType.enumeration, "afi")

                            self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("afi",
                                            "igp_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.afi.is_set or
                                self.igp_area_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.afi.yfilter != YFilter.not_set or
                                self.igp_area_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ig-ps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.afi.get_name_leafdata())
                            if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "afi" or name == "igp-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "afi"):
                                self.afi = value
                                self.afi.value_namespace = name_space
                                self.afi.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-area-id"):
                                self.igp_area_id = value
                                self.igp_area_id.value_namespace = name_space
                                self.igp_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.ig_ps:
                            if (c.has_data()):
                                return True
                        return (
                            self.announce_type.is_set or
                            self.area_format.is_set or
                            self.hold_time.is_set or
                            self.igp_metric.is_set or
                            self.is_auto_mesh_aa.is_set or
                            self.is_exclude_segment_routing.is_set or
                            self.is_sr.is_set or
                            self.is_sr_strict.is_set or
                            self.mesh_group_idaa.is_set or
                            self.mode.is_set or
                            self.next_hop_address.is_set or
                            self.tunnel_loadshare.is_set or
                            self.tunnel_name.is_set or
                            self.tunnel_sig_name.is_set)

                    def has_operation(self):
                        for c in self.ig_ps:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.announce_type.yfilter != YFilter.not_set or
                            self.area_format.yfilter != YFilter.not_set or
                            self.hold_time.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_auto_mesh_aa.yfilter != YFilter.not_set or
                            self.is_exclude_segment_routing.yfilter != YFilter.not_set or
                            self.is_sr.yfilter != YFilter.not_set or
                            self.is_sr_strict.yfilter != YFilter.not_set or
                            self.mesh_group_idaa.yfilter != YFilter.not_set or
                            self.mode.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.tunnel_loadshare.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            self.tunnel_sig_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-tunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.announce_type.is_set or self.announce_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.announce_type.get_name_leafdata())
                        if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_format.get_name_leafdata())
                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_auto_mesh_aa.is_set or self.is_auto_mesh_aa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_mesh_aa.get_name_leafdata())
                        if (self.is_exclude_segment_routing.is_set or self.is_exclude_segment_routing.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_segment_routing.get_name_leafdata())
                        if (self.is_sr.is_set or self.is_sr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr.get_name_leafdata())
                        if (self.is_sr_strict.is_set or self.is_sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr_strict.get_name_leafdata())
                        if (self.mesh_group_idaa.is_set or self.mesh_group_idaa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_idaa.get_name_leafdata())
                        if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mode.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.tunnel_loadshare.is_set or self.tunnel_loadshare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loadshare.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                        if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ig-ps"):
                            for c in self.ig_ps:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.ig_ps.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ig-ps" or name == "announce-type" or name == "area-format" or name == "hold-time" or name == "igp-metric" or name == "is-auto-mesh-aa" or name == "is-exclude-segment-routing" or name == "is-sr" or name == "is-sr-strict" or name == "mesh-group-idaa" or name == "mode" or name == "next-hop-address" or name == "tunnel-loadshare" or name == "tunnel-name" or name == "tunnel-sig-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "announce-type"):
                            self.announce_type = value
                            self.announce_type.value_namespace = name_space
                            self.announce_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "area-format"):
                            self.area_format = value
                            self.area_format.value_namespace = name_space
                            self.area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-time"):
                            self.hold_time = value
                            self.hold_time.value_namespace = name_space
                            self.hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-auto-mesh-aa"):
                            self.is_auto_mesh_aa = value
                            self.is_auto_mesh_aa.value_namespace = name_space
                            self.is_auto_mesh_aa.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-segment-routing"):
                            self.is_exclude_segment_routing = value
                            self.is_exclude_segment_routing.value_namespace = name_space
                            self.is_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr"):
                            self.is_sr = value
                            self.is_sr.value_namespace = name_space
                            self.is_sr.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr-strict"):
                            self.is_sr_strict = value
                            self.is_sr_strict.value_namespace = name_space
                            self.is_sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-idaa"):
                            self.mesh_group_idaa = value
                            self.mesh_group_idaa.value_namespace = name_space
                            self.mesh_group_idaa.value_namespace_prefix = name_space_prefix
                        if(value_path == "mode"):
                            self.mode = value
                            self.mode.value_namespace = name_space
                            self.mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loadshare"):
                            self.tunnel_loadshare = value
                            self.tunnel_loadshare.value_namespace = name_space
                            self.tunnel_loadshare.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-sig-name"):
                            self.tunnel_sig_name = value
                            self.tunnel_sig_name.value_namespace = name_space
                            self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.total_tunnel:
                        if (c.has_data()):
                            return True
                    return (
                        self.destination_address.is_set or
                        self.protocol.is_set or
                        self.area.is_set or
                        self.igp_id.is_set or
                        self.announced_tunnels_count.is_set or
                        self.area_format.is_set or
                        self.autorouted_tunnels_count.is_set or
                        self.destination.is_set or
                        self.forwarding_adjacency_tunnels_count.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    for c in self.total_tunnel:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_id.yfilter != YFilter.not_set or
                        self.announced_tunnels_count.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.autorouted_tunnels_count.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "announce-dest" + "[destination-address='" + self.destination_address.get() + "']" + "[protocol='" + self.protocol.get() + "']" + "[area='" + self.area.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/autoroute-announce-table/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_id.get_name_leafdata())
                    if (self.announced_tunnels_count.is_set or self.announced_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced_tunnels_count.get_name_leafdata())
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.autorouted_tunnels_count.is_set or self.autorouted_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autorouted_tunnels_count.get_name_leafdata())
                    if (self.destination.is_set or self.destination.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination.get_name_leafdata())
                    if (self.forwarding_adjacency_tunnels_count.is_set or self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency_tunnels_count.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "total-tunnel"):
                        for c in self.total_tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.total_tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-tunnel" or name == "destination-address" or name == "protocol" or name == "area" or name == "igp-id" or name == "announced-tunnels-count" or name == "area-format" or name == "autorouted-tunnels-count" or name == "destination" or name == "forwarding-adjacency-tunnels-count" or name == "igp-area" or name == "igp-instance" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-id"):
                        self.igp_id = value
                        self.igp_id.value_namespace = name_space
                        self.igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "announced-tunnels-count"):
                        self.announced_tunnels_count = value
                        self.announced_tunnels_count.value_namespace = name_space
                        self.announced_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "autorouted-tunnels-count"):
                        self.autorouted_tunnels_count = value
                        self.autorouted_tunnels_count.value_namespace = name_space
                        self.autorouted_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination = value
                        self.destination.value_namespace = name_space
                        self.destination.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency-tunnels-count"):
                        self.forwarding_adjacency_tunnels_count = value
                        self.forwarding_adjacency_tunnels_count.value_namespace = name_space
                        self.forwarding_adjacency_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.announce_dest:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.announce_dest:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "autoroute-announce-table" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "announce-dest"):
                    for c in self.announce_dest:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.announce_dest.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announce-dest"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class AllAutorouteTable(Entity):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of    :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable, self).__init__()

                self.yang_name = "all-autoroute-table"
                self.yang_parent_name = "announce-tunnels-info"

                self.announce_dest = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable, self).__setattr__(name, value)


            class AnnounceDest(Entity):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: protocol  <key>
                
                	The IGP protocol used by the tunnel
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: area  <key>
                
                	Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_id  <key>
                
                	IGP Instance ID
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: destination
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of    :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "all-autoroute-table"

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_id = YLeaf(YType.str, "igp-id")

                    self.announced_tunnels_count = YLeaf(YType.uint16, "announced-tunnels-count")

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.autorouted_tunnels_count = YLeaf(YType.uint16, "autorouted-tunnels-count")

                    self.destination = YLeaf(YType.str, "destination")

                    self.forwarding_adjacency_tunnels_count = YLeaf(YType.uint16, "forwarding-adjacency-tunnels-count")

                    self.igp_area = YLeaf(YType.uint32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.total_tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("destination_address",
                                    "protocol",
                                    "area",
                                    "igp_id",
                                    "announced_tunnels_count",
                                    "area_format",
                                    "autorouted_tunnels_count",
                                    "destination",
                                    "forwarding_adjacency_tunnels_count",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__setattr__(name, value)


                class TotalTunnel(Entity):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:   :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\:  bool
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:   :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"

                        self.announce_type = YLeaf(YType.enumeration, "announce-type")

                        self.area_format = YLeaf(YType.enumeration, "area-format")

                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                        self.igp_metric = YLeaf(YType.int32, "igp-metric")

                        self.is_auto_mesh_aa = YLeaf(YType.boolean, "is-auto-mesh-aa")

                        self.is_exclude_segment_routing = YLeaf(YType.boolean, "is-exclude-segment-routing")

                        self.is_sr = YLeaf(YType.boolean, "is-sr")

                        self.is_sr_strict = YLeaf(YType.boolean, "is-sr-strict")

                        self.mesh_group_idaa = YLeaf(YType.uint32, "mesh-group-idaa")

                        self.mode = YLeaf(YType.enumeration, "mode")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.tunnel_loadshare = YLeaf(YType.uint32, "tunnel-loadshare")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                        self.ig_ps = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("announce_type",
                                        "area_format",
                                        "hold_time",
                                        "igp_metric",
                                        "is_auto_mesh_aa",
                                        "is_exclude_segment_routing",
                                        "is_sr",
                                        "is_sr_strict",
                                        "mesh_group_idaa",
                                        "mode",
                                        "next_hop_address",
                                        "tunnel_loadshare",
                                        "tunnel_name",
                                        "tunnel_sig_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)


                    class IgPs(Entity):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"

                            self.afi = YLeaf(YType.enumeration, "afi")

                            self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("afi",
                                            "igp_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.afi.is_set or
                                self.igp_area_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.afi.yfilter != YFilter.not_set or
                                self.igp_area_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ig-ps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.afi.get_name_leafdata())
                            if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "afi" or name == "igp-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "afi"):
                                self.afi = value
                                self.afi.value_namespace = name_space
                                self.afi.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-area-id"):
                                self.igp_area_id = value
                                self.igp_area_id.value_namespace = name_space
                                self.igp_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.ig_ps:
                            if (c.has_data()):
                                return True
                        return (
                            self.announce_type.is_set or
                            self.area_format.is_set or
                            self.hold_time.is_set or
                            self.igp_metric.is_set or
                            self.is_auto_mesh_aa.is_set or
                            self.is_exclude_segment_routing.is_set or
                            self.is_sr.is_set or
                            self.is_sr_strict.is_set or
                            self.mesh_group_idaa.is_set or
                            self.mode.is_set or
                            self.next_hop_address.is_set or
                            self.tunnel_loadshare.is_set or
                            self.tunnel_name.is_set or
                            self.tunnel_sig_name.is_set)

                    def has_operation(self):
                        for c in self.ig_ps:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.announce_type.yfilter != YFilter.not_set or
                            self.area_format.yfilter != YFilter.not_set or
                            self.hold_time.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_auto_mesh_aa.yfilter != YFilter.not_set or
                            self.is_exclude_segment_routing.yfilter != YFilter.not_set or
                            self.is_sr.yfilter != YFilter.not_set or
                            self.is_sr_strict.yfilter != YFilter.not_set or
                            self.mesh_group_idaa.yfilter != YFilter.not_set or
                            self.mode.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.tunnel_loadshare.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            self.tunnel_sig_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-tunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.announce_type.is_set or self.announce_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.announce_type.get_name_leafdata())
                        if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_format.get_name_leafdata())
                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_auto_mesh_aa.is_set or self.is_auto_mesh_aa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_mesh_aa.get_name_leafdata())
                        if (self.is_exclude_segment_routing.is_set or self.is_exclude_segment_routing.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_segment_routing.get_name_leafdata())
                        if (self.is_sr.is_set or self.is_sr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr.get_name_leafdata())
                        if (self.is_sr_strict.is_set or self.is_sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr_strict.get_name_leafdata())
                        if (self.mesh_group_idaa.is_set or self.mesh_group_idaa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_idaa.get_name_leafdata())
                        if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mode.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.tunnel_loadshare.is_set or self.tunnel_loadshare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loadshare.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                        if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ig-ps"):
                            for c in self.ig_ps:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.ig_ps.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ig-ps" or name == "announce-type" or name == "area-format" or name == "hold-time" or name == "igp-metric" or name == "is-auto-mesh-aa" or name == "is-exclude-segment-routing" or name == "is-sr" or name == "is-sr-strict" or name == "mesh-group-idaa" or name == "mode" or name == "next-hop-address" or name == "tunnel-loadshare" or name == "tunnel-name" or name == "tunnel-sig-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "announce-type"):
                            self.announce_type = value
                            self.announce_type.value_namespace = name_space
                            self.announce_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "area-format"):
                            self.area_format = value
                            self.area_format.value_namespace = name_space
                            self.area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-time"):
                            self.hold_time = value
                            self.hold_time.value_namespace = name_space
                            self.hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-auto-mesh-aa"):
                            self.is_auto_mesh_aa = value
                            self.is_auto_mesh_aa.value_namespace = name_space
                            self.is_auto_mesh_aa.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-segment-routing"):
                            self.is_exclude_segment_routing = value
                            self.is_exclude_segment_routing.value_namespace = name_space
                            self.is_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr"):
                            self.is_sr = value
                            self.is_sr.value_namespace = name_space
                            self.is_sr.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr-strict"):
                            self.is_sr_strict = value
                            self.is_sr_strict.value_namespace = name_space
                            self.is_sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-idaa"):
                            self.mesh_group_idaa = value
                            self.mesh_group_idaa.value_namespace = name_space
                            self.mesh_group_idaa.value_namespace_prefix = name_space_prefix
                        if(value_path == "mode"):
                            self.mode = value
                            self.mode.value_namespace = name_space
                            self.mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loadshare"):
                            self.tunnel_loadshare = value
                            self.tunnel_loadshare.value_namespace = name_space
                            self.tunnel_loadshare.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-sig-name"):
                            self.tunnel_sig_name = value
                            self.tunnel_sig_name.value_namespace = name_space
                            self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.total_tunnel:
                        if (c.has_data()):
                            return True
                    return (
                        self.destination_address.is_set or
                        self.protocol.is_set or
                        self.area.is_set or
                        self.igp_id.is_set or
                        self.announced_tunnels_count.is_set or
                        self.area_format.is_set or
                        self.autorouted_tunnels_count.is_set or
                        self.destination.is_set or
                        self.forwarding_adjacency_tunnels_count.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    for c in self.total_tunnel:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_id.yfilter != YFilter.not_set or
                        self.announced_tunnels_count.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.autorouted_tunnels_count.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "announce-dest" + "[destination-address='" + self.destination_address.get() + "']" + "[protocol='" + self.protocol.get() + "']" + "[area='" + self.area.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/all-autoroute-table/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_id.get_name_leafdata())
                    if (self.announced_tunnels_count.is_set or self.announced_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced_tunnels_count.get_name_leafdata())
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.autorouted_tunnels_count.is_set or self.autorouted_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autorouted_tunnels_count.get_name_leafdata())
                    if (self.destination.is_set or self.destination.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination.get_name_leafdata())
                    if (self.forwarding_adjacency_tunnels_count.is_set or self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency_tunnels_count.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "total-tunnel"):
                        for c in self.total_tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.total_tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-tunnel" or name == "destination-address" or name == "protocol" or name == "area" or name == "igp-id" or name == "announced-tunnels-count" or name == "area-format" or name == "autorouted-tunnels-count" or name == "destination" or name == "forwarding-adjacency-tunnels-count" or name == "igp-area" or name == "igp-instance" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-id"):
                        self.igp_id = value
                        self.igp_id.value_namespace = name_space
                        self.igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "announced-tunnels-count"):
                        self.announced_tunnels_count = value
                        self.announced_tunnels_count.value_namespace = name_space
                        self.announced_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "autorouted-tunnels-count"):
                        self.autorouted_tunnels_count = value
                        self.autorouted_tunnels_count.value_namespace = name_space
                        self.autorouted_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination = value
                        self.destination.value_namespace = name_space
                        self.destination.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency-tunnels-count"):
                        self.forwarding_adjacency_tunnels_count = value
                        self.forwarding_adjacency_tunnels_count.value_namespace = name_space
                        self.forwarding_adjacency_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.announce_dest:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.announce_dest:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "all-autoroute-table" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "announce-dest"):
                    for c in self.announce_dest:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.announce_dest.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announce-dest"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.all_autoroute_table is not None and self.all_autoroute_table.has_data()) or
                (self.autoroute_announce_table is not None and self.autoroute_announce_table.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.all_autoroute_table is not None and self.all_autoroute_table.has_operation()) or
                (self.autoroute_announce_table is not None and self.autoroute_announce_table.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "announce-tunnels-info" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "all-autoroute-table"):
                if (self.all_autoroute_table is None):
                    self.all_autoroute_table = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable()
                    self.all_autoroute_table.parent = self
                    self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
                return self.all_autoroute_table

            if (child_yang_name == "autoroute-announce-table"):
                if (self.autoroute_announce_table is None):
                    self.autoroute_announce_table = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable()
                    self.autoroute_announce_table.parent = self
                    self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"
                return self.autoroute_announce_table

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "all-autoroute-table" or name == "autoroute-announce-table"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class CollaboratorTimers(Entity):
        """
        TE Collaborator timer status
        
        .. attribute:: p2mp_timer
        
        	Description of all P2MP timers
        	**type**\: list of    :py:class:`P2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.CollaboratorTimers.P2MpTimer>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.CollaboratorTimers, self).__init__()

            self.yang_name = "collaborator-timers"
            self.yang_parent_name = "mpls-te"

            self.p2mp_timer = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.CollaboratorTimers, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.CollaboratorTimers, self).__setattr__(name, value)


        class P2MpTimer(Entity):
            """
            Description of all P2MP timers
            
            .. attribute:: duration
            
            	The expiry delay in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: expiry_time
            
            	Date when the timer last expired in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: is_running
            
            	True if the timer is running
            	**type**\:  bool
            
            .. attribute:: start_time
            
            	Date when timer was last started in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: stop_time
            
            	Date when the timer was last stopped in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: timer_name
            
            	Timer Name
            	**type**\:  str
            
            .. attribute:: timer_type
            
            	Timer Type
            	**type**\:   :py:class:`MplsTeP2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2MpTimer>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.CollaboratorTimers.P2MpTimer, self).__init__()

                self.yang_name = "p2mp-timer"
                self.yang_parent_name = "collaborator-timers"

                self.duration = YLeaf(YType.uint32, "duration")

                self.expiry_time = YLeaf(YType.uint32, "expiry-time")

                self.is_running = YLeaf(YType.boolean, "is-running")

                self.start_time = YLeaf(YType.uint32, "start-time")

                self.stop_time = YLeaf(YType.uint32, "stop-time")

                self.timer_name = YLeaf(YType.str, "timer-name")

                self.timer_type = YLeaf(YType.enumeration, "timer-type")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("duration",
                                "expiry_time",
                                "is_running",
                                "start_time",
                                "stop_time",
                                "timer_name",
                                "timer_type") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.duration.is_set or
                    self.expiry_time.is_set or
                    self.is_running.is_set or
                    self.start_time.is_set or
                    self.stop_time.is_set or
                    self.timer_name.is_set or
                    self.timer_type.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.duration.yfilter != YFilter.not_set or
                    self.expiry_time.yfilter != YFilter.not_set or
                    self.is_running.yfilter != YFilter.not_set or
                    self.start_time.yfilter != YFilter.not_set or
                    self.stop_time.yfilter != YFilter.not_set or
                    self.timer_name.yfilter != YFilter.not_set or
                    self.timer_type.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "p2mp-timer" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/collaborator-timers/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.duration.get_name_leafdata())
                if (self.expiry_time.is_set or self.expiry_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expiry_time.get_name_leafdata())
                if (self.is_running.is_set or self.is_running.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_running.get_name_leafdata())
                if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.start_time.get_name_leafdata())
                if (self.stop_time.is_set or self.stop_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stop_time.get_name_leafdata())
                if (self.timer_name.is_set or self.timer_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timer_name.get_name_leafdata())
                if (self.timer_type.is_set or self.timer_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timer_type.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "duration" or name == "expiry-time" or name == "is-running" or name == "start-time" or name == "stop-time" or name == "timer-name" or name == "timer-type"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "duration"):
                    self.duration = value
                    self.duration.value_namespace = name_space
                    self.duration.value_namespace_prefix = name_space_prefix
                if(value_path == "expiry-time"):
                    self.expiry_time = value
                    self.expiry_time.value_namespace = name_space
                    self.expiry_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-running"):
                    self.is_running = value
                    self.is_running.value_namespace = name_space
                    self.is_running.value_namespace_prefix = name_space_prefix
                if(value_path == "start-time"):
                    self.start_time = value
                    self.start_time.value_namespace = name_space
                    self.start_time.value_namespace_prefix = name_space_prefix
                if(value_path == "stop-time"):
                    self.stop_time = value
                    self.stop_time.value_namespace = name_space
                    self.stop_time.value_namespace_prefix = name_space_prefix
                if(value_path == "timer-name"):
                    self.timer_name = value
                    self.timer_name.value_namespace = name_space
                    self.timer_name.value_namespace_prefix = name_space_prefix
                if(value_path == "timer-type"):
                    self.timer_type = value
                    self.timer_type.value_namespace = name_space
                    self.timer_type.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.p2mp_timer:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.p2mp_timer:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "collaborator-timers" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "p2mp-timer"):
                for c in self.p2mp_timer:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.CollaboratorTimers.P2MpTimer()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.p2mp_timer.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "p2mp-timer"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AutoTunnel(Entity):
        """
        Auto tunnel information.
        
        .. attribute:: backup
        
        	Auto tunnel backup information
        	**type**\:   :py:class:`Backup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup>`
        
        .. attribute:: mesh
        
        	Auto tunnel mesh information
        	**type**\:   :py:class:`Mesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh>`
        
        .. attribute:: pcc
        
        	Auto tunnel PCC (Path Computation Client) information
        	**type**\:   :py:class:`Pcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Pcc>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AutoTunnel, self).__init__()

            self.yang_name = "auto-tunnel"
            self.yang_parent_name = "mpls-te"

            self.backup = MplsTe.AutoTunnel.Backup()
            self.backup.parent = self
            self._children_name_map["backup"] = "backup"
            self._children_yang_names.add("backup")

            self.mesh = MplsTe.AutoTunnel.Mesh()
            self.mesh.parent = self
            self._children_name_map["mesh"] = "mesh"
            self._children_yang_names.add("mesh")

            self.pcc = MplsTe.AutoTunnel.Pcc()
            self.pcc.parent = self
            self._children_name_map["pcc"] = "pcc"
            self._children_yang_names.add("pcc")


        class Pcc(Entity):
            """
            Auto tunnel PCC (Path Computation Client)
            information.
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel pcc summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Pcc.Summary>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AutoTunnel.Pcc, self).__init__()

                self.yang_name = "pcc"
                self.yang_parent_name = "auto-tunnel"

                self.summary = MplsTe.AutoTunnel.Pcc.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel pcc summary information
                
                .. attribute:: down_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pcc_auto_tunnel
                
                	Total number of stateful PCE client auto\-tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Pcc.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "pcc"

                    self.down_pcc_auto_tunnels = YLeaf(YType.uint32, "down-pcc-auto-tunnels")

                    self.pcc_auto_tunnel = YLeaf(YType.uint32, "pcc-auto-tunnel")

                    self.up_pcc_auto_tunnels = YLeaf(YType.uint32, "up-pcc-auto-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("down_pcc_auto_tunnels",
                                    "pcc_auto_tunnel",
                                    "up_pcc_auto_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Pcc.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Pcc.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.down_pcc_auto_tunnels.is_set or
                        self.pcc_auto_tunnel.is_set or
                        self.up_pcc_auto_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.down_pcc_auto_tunnels.yfilter != YFilter.not_set or
                        self.pcc_auto_tunnel.yfilter != YFilter.not_set or
                        self.up_pcc_auto_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/pcc/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.down_pcc_auto_tunnels.is_set or self.down_pcc_auto_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_pcc_auto_tunnels.get_name_leafdata())
                    if (self.pcc_auto_tunnel.is_set or self.pcc_auto_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pcc_auto_tunnel.get_name_leafdata())
                    if (self.up_pcc_auto_tunnels.is_set or self.up_pcc_auto_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_pcc_auto_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "down-pcc-auto-tunnels" or name == "pcc-auto-tunnel" or name == "up-pcc-auto-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "down-pcc-auto-tunnels"):
                        self.down_pcc_auto_tunnels = value
                        self.down_pcc_auto_tunnels.value_namespace = name_space
                        self.down_pcc_auto_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "pcc-auto-tunnel"):
                        self.pcc_auto_tunnel = value
                        self.pcc_auto_tunnel.value_namespace = name_space
                        self.pcc_auto_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-pcc-auto-tunnels"):
                        self.up_pcc_auto_tunnels = value
                        self.up_pcc_auto_tunnels.value_namespace = name_space
                        self.up_pcc_auto_tunnels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (self.summary is not None and self.summary.has_data())

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.summary is not None and self.summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "pcc" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTe.AutoTunnel.Pcc.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "summary"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Mesh(Entity):
            """
            Auto tunnel mesh information.
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel mesh configuration information
            	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Config>`
            
            .. attribute:: mesh_groups
            
            	Display auto\-tunnel mesh group
            	**type**\:   :py:class:`MeshGroups <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups>`
            
            .. attribute:: one_hop
            
            	MPLS TE auto\-tunnel mesh onehop information
            	**type**\:   :py:class:`OneHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop>`
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel mesh counters (stats) information
            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Statistics>`
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel mesh summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Summary>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AutoTunnel.Mesh, self).__init__()

                self.yang_name = "mesh"
                self.yang_parent_name = "auto-tunnel"

                self.config = MplsTe.AutoTunnel.Mesh.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._children_yang_names.add("config")

                self.mesh_groups = MplsTe.AutoTunnel.Mesh.MeshGroups()
                self.mesh_groups.parent = self
                self._children_name_map["mesh_groups"] = "mesh-groups"
                self._children_yang_names.add("mesh-groups")

                self.one_hop = MplsTe.AutoTunnel.Mesh.OneHop()
                self.one_hop.parent = self
                self._children_name_map["one_hop"] = "one-hop"
                self._children_yang_names.add("one-hop")

                self.statistics = MplsTe.AutoTunnel.Mesh.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
                self._children_yang_names.add("statistics")

                self.summary = MplsTe.AutoTunnel.Mesh.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")


            class MeshGroups(Entity):
                """
                Display auto\-tunnel mesh group
                
                .. attribute:: mesh_group
                
                	Display auto\-tunnel mesh group information
                	**type**\: list of    :py:class:`MeshGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Mesh.MeshGroups, self).__init__()

                    self.yang_name = "mesh-groups"
                    self.yang_parent_name = "mesh"

                    self.mesh_group = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Mesh.MeshGroups, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Mesh.MeshGroups, self).__setattr__(name, value)


                class MeshGroup(Entity):
                    """
                    Display auto\-tunnel mesh group information
                    
                    .. attribute:: mesh_group_id  <key>
                    
                    	Mesh group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: attribute_set_name
                    
                    	Attribute set name
                    	**type**\:  str
                    
                    .. attribute:: auto_mesh_group_type
                    
                    	Meshgroup Type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: auto_mesh_total_destinations
                    
                    	Total number of destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_tunnels
                    
                    	Total number of automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination
                    
                    	List of destinations for this meshgroup
                    	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination>`
                    
                    .. attribute:: destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    .. attribute:: destination_list_type
                    
                    	Type of the  destlist
                    	**type**\:   :py:class:`TeAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAcl>`
                    
                    .. attribute:: down_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_attribute_set_configured
                    
                    	Is any attribute\-set associated to this meshgroup
                    	**type**\:  bool
                    
                    .. attribute:: is_attribute_set_in_db
                    
                    	Flag to indicate the existence of attribute set found in database
                    	**type**\:  bool
                    
                    .. attribute:: is_destination_list_configured
                    
                    	Is any destiantion\-list associated to this meshgroup
                    	**type**\:  bool
                    
                    .. attribute:: is_meshgroup_disabled
                    
                    	Is the meshgroup disabled
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id_xr
                    
                    	Meshgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remaining_time
                    
                    	Remaining time for recreate timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: up_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__init__()

                        self.yang_name = "mesh-group"
                        self.yang_parent_name = "mesh-groups"

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.attribute_set_name = YLeaf(YType.str, "attribute-set-name")

                        self.auto_mesh_group_type = YLeaf(YType.enumeration, "auto-mesh-group-type")

                        self.auto_mesh_total_destinations = YLeaf(YType.uint32, "auto-mesh-total-destinations")

                        self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                        self.destination_list_name = YLeaf(YType.str, "destination-list-name")

                        self.destination_list_type = YLeaf(YType.enumeration, "destination-list-type")

                        self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                        self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                        self.is_attribute_set_configured = YLeaf(YType.boolean, "is-attribute-set-configured")

                        self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                        self.is_destination_list_configured = YLeaf(YType.boolean, "is-destination-list-configured")

                        self.is_meshgroup_disabled = YLeaf(YType.boolean, "is-meshgroup-disabled")

                        self.mesh_group_id_xr = YLeaf(YType.uint32, "mesh-group-id-xr")

                        self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                        self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                        self.destination = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("mesh_group_id",
                                        "attribute_set_name",
                                        "auto_mesh_group_type",
                                        "auto_mesh_total_destinations",
                                        "auto_mesh_tunnels",
                                        "destination_list_name",
                                        "destination_list_type",
                                        "down_auto_mesh_tunnels",
                                        "frr_auto_mesh_tunnels",
                                        "is_attribute_set_configured",
                                        "is_attribute_set_in_db",
                                        "is_destination_list_configured",
                                        "is_meshgroup_disabled",
                                        "mesh_group_id_xr",
                                        "remaining_time",
                                        "up_auto_mesh_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__setattr__(name, value)


                    class Destination(Entity):
                        """
                        List of destinations for this meshgroup
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: operational_status
                        
                        	Tunnel operational status
                        	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                        
                        .. attribute:: remaining_time
                        
                        	Remaining time for unused timer in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__init__()

                            self.yang_name = "destination"
                            self.yang_parent_name = "mesh-group"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.operational_status = YLeaf(YType.enumeration, "operational-status")

                            self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "operational_status",
                                            "remaining_time",
                                            "tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.operational_status.is_set or
                                self.remaining_time.is_set or
                                self.tunnel_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.operational_status.yfilter != YFilter.not_set or
                                self.remaining_time.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.operational_status.is_set or self.operational_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.operational_status.get_name_leafdata())
                            if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remaining_time.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "operational-status" or name == "remaining-time" or name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "operational-status"):
                                self.operational_status = value
                                self.operational_status.value_namespace = name_space
                                self.operational_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "remaining-time"):
                                self.remaining_time = value
                                self.remaining_time.value_namespace = name_space
                                self.remaining_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.destination:
                            if (c.has_data()):
                                return True
                        return (
                            self.mesh_group_id.is_set or
                            self.attribute_set_name.is_set or
                            self.auto_mesh_group_type.is_set or
                            self.auto_mesh_total_destinations.is_set or
                            self.auto_mesh_tunnels.is_set or
                            self.destination_list_name.is_set or
                            self.destination_list_type.is_set or
                            self.down_auto_mesh_tunnels.is_set or
                            self.frr_auto_mesh_tunnels.is_set or
                            self.is_attribute_set_configured.is_set or
                            self.is_attribute_set_in_db.is_set or
                            self.is_destination_list_configured.is_set or
                            self.is_meshgroup_disabled.is_set or
                            self.mesh_group_id_xr.is_set or
                            self.remaining_time.is_set or
                            self.up_auto_mesh_tunnels.is_set)

                    def has_operation(self):
                        for c in self.destination:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.attribute_set_name.yfilter != YFilter.not_set or
                            self.auto_mesh_group_type.yfilter != YFilter.not_set or
                            self.auto_mesh_total_destinations.yfilter != YFilter.not_set or
                            self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.destination_list_name.yfilter != YFilter.not_set or
                            self.destination_list_type.yfilter != YFilter.not_set or
                            self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.is_attribute_set_configured.yfilter != YFilter.not_set or
                            self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                            self.is_destination_list_configured.yfilter != YFilter.not_set or
                            self.is_meshgroup_disabled.yfilter != YFilter.not_set or
                            self.mesh_group_id_xr.yfilter != YFilter.not_set or
                            self.remaining_time.yfilter != YFilter.not_set or
                            self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mesh-group" + "[mesh-group-id='" + self.mesh_group_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/mesh-groups/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.attribute_set_name.is_set or self.attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.attribute_set_name.get_name_leafdata())
                        if (self.auto_mesh_group_type.is_set or self.auto_mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_group_type.get_name_leafdata())
                        if (self.auto_mesh_total_destinations.is_set or self.auto_mesh_total_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_total_destinations.get_name_leafdata())
                        if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                        if (self.destination_list_name.is_set or self.destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_list_name.get_name_leafdata())
                        if (self.destination_list_type.is_set or self.destination_list_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_list_type.get_name_leafdata())
                        if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                        if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                        if (self.is_attribute_set_configured.is_set or self.is_attribute_set_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_attribute_set_configured.get_name_leafdata())
                        if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                        if (self.is_destination_list_configured.is_set or self.is_destination_list_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_destination_list_configured.get_name_leafdata())
                        if (self.is_meshgroup_disabled.is_set or self.is_meshgroup_disabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_meshgroup_disabled.get_name_leafdata())
                        if (self.mesh_group_id_xr.is_set or self.mesh_group_id_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id_xr.get_name_leafdata())
                        if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_time.get_name_leafdata())
                        if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "destination"):
                            for c in self.destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.destination.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "destination" or name == "mesh-group-id" or name == "attribute-set-name" or name == "auto-mesh-group-type" or name == "auto-mesh-total-destinations" or name == "auto-mesh-tunnels" or name == "destination-list-name" or name == "destination-list-type" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "is-attribute-set-configured" or name == "is-attribute-set-in-db" or name == "is-destination-list-configured" or name == "is-meshgroup-disabled" or name == "mesh-group-id-xr" or name == "remaining-time" or name == "up-auto-mesh-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "attribute-set-name"):
                            self.attribute_set_name = value
                            self.attribute_set_name.value_namespace = name_space
                            self.attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-group-type"):
                            self.auto_mesh_group_type = value
                            self.auto_mesh_group_type.value_namespace = name_space
                            self.auto_mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-total-destinations"):
                            self.auto_mesh_total_destinations = value
                            self.auto_mesh_total_destinations.value_namespace = name_space
                            self.auto_mesh_total_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-tunnels"):
                            self.auto_mesh_tunnels = value
                            self.auto_mesh_tunnels.value_namespace = name_space
                            self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-list-name"):
                            self.destination_list_name = value
                            self.destination_list_name.value_namespace = name_space
                            self.destination_list_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-list-type"):
                            self.destination_list_type = value
                            self.destination_list_type.value_namespace = name_space
                            self.destination_list_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-mesh-tunnels"):
                            self.down_auto_mesh_tunnels = value
                            self.down_auto_mesh_tunnels.value_namespace = name_space
                            self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-mesh-tunnels"):
                            self.frr_auto_mesh_tunnels = value
                            self.frr_auto_mesh_tunnels.value_namespace = name_space
                            self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-attribute-set-configured"):
                            self.is_attribute_set_configured = value
                            self.is_attribute_set_configured.value_namespace = name_space
                            self.is_attribute_set_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-attribute-set-in-db"):
                            self.is_attribute_set_in_db = value
                            self.is_attribute_set_in_db.value_namespace = name_space
                            self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-destination-list-configured"):
                            self.is_destination_list_configured = value
                            self.is_destination_list_configured.value_namespace = name_space
                            self.is_destination_list_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-meshgroup-disabled"):
                            self.is_meshgroup_disabled = value
                            self.is_meshgroup_disabled.value_namespace = name_space
                            self.is_meshgroup_disabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id-xr"):
                            self.mesh_group_id_xr = value
                            self.mesh_group_id_xr.value_namespace = name_space
                            self.mesh_group_id_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-time"):
                            self.remaining_time = value
                            self.remaining_time.value_namespace = name_space
                            self.remaining_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-mesh-tunnels"):
                            self.up_auto_mesh_tunnels = value
                            self.up_auto_mesh_tunnels.value_namespace = name_space
                            self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.mesh_group:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.mesh_group:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "mesh-groups" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "mesh-group"):
                        for c in self.mesh_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mesh_group.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "mesh-group"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Statistics(Entity):
                """
                MPLS TE auto\-tunnel mesh counters (stats)
                information
                
                .. attribute:: connected
                
                	Number of connected automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: created
                
                	Number of connected automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_cleared_time
                
                	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: removed_in_use
                
                	Number of automesh tunnels removed while up and in use
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_range_exceeded
                
                	Number of automesh tunnel attempts rejected because the total number exceeds the range
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_unused
                
                	Number of automesh tunnels removed while unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Mesh.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "mesh"

                    self.connected = YLeaf(YType.uint32, "connected")

                    self.created = YLeaf(YType.uint32, "created")

                    self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                    self.removed_in_use = YLeaf(YType.uint32, "removed-in-use")

                    self.removed_range_exceeded = YLeaf(YType.uint32, "removed-range-exceeded")

                    self.removed_unused = YLeaf(YType.uint32, "removed-unused")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("connected",
                                    "created",
                                    "last_cleared_time",
                                    "removed_in_use",
                                    "removed_range_exceeded",
                                    "removed_unused") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Mesh.Statistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Mesh.Statistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.connected.is_set or
                        self.created.is_set or
                        self.last_cleared_time.is_set or
                        self.removed_in_use.is_set or
                        self.removed_range_exceeded.is_set or
                        self.removed_unused.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.connected.yfilter != YFilter.not_set or
                        self.created.yfilter != YFilter.not_set or
                        self.last_cleared_time.yfilter != YFilter.not_set or
                        self.removed_in_use.yfilter != YFilter.not_set or
                        self.removed_range_exceeded.yfilter != YFilter.not_set or
                        self.removed_unused.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.connected.is_set or self.connected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connected.get_name_leafdata())
                    if (self.created.is_set or self.created.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.created.get_name_leafdata())
                    if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_cleared_time.get_name_leafdata())
                    if (self.removed_in_use.is_set or self.removed_in_use.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_in_use.get_name_leafdata())
                    if (self.removed_range_exceeded.is_set or self.removed_range_exceeded.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_range_exceeded.get_name_leafdata())
                    if (self.removed_unused.is_set or self.removed_unused.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_unused.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "connected" or name == "created" or name == "last-cleared-time" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "connected"):
                        self.connected = value
                        self.connected.value_namespace = name_space
                        self.connected.value_namespace_prefix = name_space_prefix
                    if(value_path == "created"):
                        self.created = value
                        self.created.value_namespace = name_space
                        self.created.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-cleared-time"):
                        self.last_cleared_time = value
                        self.last_cleared_time.value_namespace = name_space
                        self.last_cleared_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-in-use"):
                        self.removed_in_use = value
                        self.removed_in_use.value_namespace = name_space
                        self.removed_in_use.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-range-exceeded"):
                        self.removed_range_exceeded = value
                        self.removed_range_exceeded.value_namespace = name_space
                        self.removed_range_exceeded.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-unused"):
                        self.removed_unused = value
                        self.removed_unused.value_namespace = name_space
                        self.removed_unused.value_namespace_prefix = name_space_prefix


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel mesh summary information
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Mesh.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "mesh"

                    self.auto_mesh_destinations = YLeaf(YType.uint32, "auto-mesh-destinations")

                    self.auto_mesh_groups = YLeaf(YType.uint32, "auto-mesh-groups")

                    self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                    self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_destinations",
                                    "auto_mesh_groups",
                                    "auto_mesh_tunnels",
                                    "down_auto_mesh_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Mesh.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Mesh.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_destinations.is_set or
                        self.auto_mesh_groups.is_set or
                        self.auto_mesh_tunnels.is_set or
                        self.down_auto_mesh_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_destinations.is_set or self.auto_mesh_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_destinations.get_name_leafdata())
                    if (self.auto_mesh_groups.is_set or self.auto_mesh_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_groups.get_name_leafdata())
                    if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-destinations" or name == "auto-mesh-groups" or name == "auto-mesh-tunnels" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-destinations"):
                        self.auto_mesh_destinations = value
                        self.auto_mesh_destinations.value_namespace = name_space
                        self.auto_mesh_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-groups"):
                        self.auto_mesh_groups = value
                        self.auto_mesh_groups.value_namespace = name_space
                        self.auto_mesh_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-tunnels"):
                        self.auto_mesh_tunnels = value
                        self.auto_mesh_tunnels.value_namespace = name_space
                        self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-tunnels"):
                        self.down_auto_mesh_tunnels = value
                        self.down_auto_mesh_tunnels.value_namespace = name_space
                        self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-tunnels"):
                        self.up_auto_mesh_tunnels = value
                        self.up_auto_mesh_tunnels.value_namespace = name_space
                        self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix


            class Config(Entity):
                """
                MPLS TE auto\-tunnel mesh configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel mesh feature is configured 
                	**type**\:  bool
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Mesh.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "mesh"

                    self.is_configured = YLeaf(YType.boolean, "is-configured")

                    self.max_tunnel_id = YLeaf(YType.uint16, "max-tunnel-id")

                    self.min_tunnel_id = YLeaf(YType.uint16, "min-tunnel-id")

                    self.unused_removal_timeout_configured = YLeaf(YType.uint32, "unused-removal-timeout-configured")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_configured",
                                    "max_tunnel_id",
                                    "min_tunnel_id",
                                    "unused_removal_timeout_configured") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Mesh.Config, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Mesh.Config, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.is_configured.is_set or
                        self.max_tunnel_id.is_set or
                        self.min_tunnel_id.is_set or
                        self.unused_removal_timeout_configured.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_configured.yfilter != YFilter.not_set or
                        self.max_tunnel_id.yfilter != YFilter.not_set or
                        self.min_tunnel_id.yfilter != YFilter.not_set or
                        self.unused_removal_timeout_configured.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "config" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_configured.get_name_leafdata())
                    if (self.max_tunnel_id.is_set or self.max_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_tunnel_id.get_name_leafdata())
                    if (self.min_tunnel_id.is_set or self.min_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.min_tunnel_id.get_name_leafdata())
                    if (self.unused_removal_timeout_configured.is_set or self.unused_removal_timeout_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_removal_timeout_configured.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "is-configured" or name == "max-tunnel-id" or name == "min-tunnel-id" or name == "unused-removal-timeout-configured"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-configured"):
                        self.is_configured = value
                        self.is_configured.value_namespace = name_space
                        self.is_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-tunnel-id"):
                        self.max_tunnel_id = value
                        self.max_tunnel_id.value_namespace = name_space
                        self.max_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "min-tunnel-id"):
                        self.min_tunnel_id = value
                        self.min_tunnel_id.value_namespace = name_space
                        self.min_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-removal-timeout-configured"):
                        self.unused_removal_timeout_configured = value
                        self.unused_removal_timeout_configured.value_namespace = name_space
                        self.unused_removal_timeout_configured.value_namespace_prefix = name_space_prefix


            class OneHop(Entity):
                """
                MPLS TE auto\-tunnel mesh onehop information
                
                .. attribute:: interfaces
                
                	Display auto\-tunnel onehop interfaces
                	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces>`
                
                .. attribute:: statistics
                
                	MPLS TE auto\-tunnel mesh onehop counters (stats) information
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Statistics>`
                
                .. attribute:: summary
                
                	MPLS TE auto\-tunnel mesh onehop summary information
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Summary>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Mesh.OneHop, self).__init__()

                    self.yang_name = "one-hop"
                    self.yang_parent_name = "mesh"

                    self.interfaces = MplsTe.AutoTunnel.Mesh.OneHop.Interfaces()
                    self.interfaces.parent = self
                    self._children_name_map["interfaces"] = "interfaces"
                    self._children_yang_names.add("interfaces")

                    self.statistics = MplsTe.AutoTunnel.Mesh.OneHop.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.summary = MplsTe.AutoTunnel.Mesh.OneHop.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")


                class Interfaces(Entity):
                    """
                    Display auto\-tunnel onehop interfaces
                    
                    .. attribute:: interface
                    
                    	Display auto\-tunnel mesh onehop interface information
                    	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces, self).__init__()

                        self.yang_name = "interfaces"
                        self.yang_parent_name = "one-hop"

                        self.interface = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces, self).__setattr__(name, value)


                    class Interface(Entity):
                        """
                        Display auto\-tunnel mesh onehop interface
                        information
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface Name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: interface_name_xr
                        
                        	Interface name
                        	**type**\:  str
                        
                        .. attribute:: tunnel
                        
                        	Onehop tunnels created for this interface
                        	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interfaces"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                            self.tunnel = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "interface_name_xr") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__setattr__(name, value)


                        class Tunnel(Entity):
                            """
                            Onehop tunnels created for this interface
                            
                            .. attribute:: destination_address
                            
                            	Destination Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: tunnel_lspid
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "interface"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.tunnel_lspid = YLeaf(YType.uint16, "tunnel-lspid")

                                self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address",
                                                "mesh_group_id",
                                                "tunnel_id",
                                                "tunnel_lspid",
                                                "tunnel_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.destination_address.is_set or
                                    self.mesh_group_id.is_set or
                                    self.tunnel_id.is_set or
                                    self.tunnel_lspid.is_set or
                                    self.tunnel_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.mesh_group_id.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    self.tunnel_lspid.yfilter != YFilter.not_set or
                                    self.tunnel_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tunnel" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                if (self.tunnel_lspid.is_set or self.tunnel_lspid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_lspid.get_name_leafdata())
                                if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "destination-address" or name == "mesh-group-id" or name == "tunnel-id" or name == "tunnel-lspid" or name == "tunnel-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "mesh-group-id"):
                                    self.mesh_group_id = value
                                    self.mesh_group_id.value_namespace = name_space
                                    self.mesh_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-lspid"):
                                    self.tunnel_lspid = value
                                    self.tunnel_lspid.value_namespace = name_space
                                    self.tunnel_lspid.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-state"):
                                    self.tunnel_state = value
                                    self.tunnel_state.value_namespace = name_space
                                    self.tunnel_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.tunnel:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.interface_name_xr.is_set)

                        def has_operation(self):
                            for c in self.tunnel:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.interface_name_xr.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/interfaces/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "tunnel"):
                                for c in self.tunnel:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.tunnel.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel" or name == "interface-name" or name == "interface-name-xr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-name-xr"):
                                self.interface_name_xr = value
                                self.interface_name_xr.value_namespace = name_space
                                self.interface_name_xr.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.interface:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.interface:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interfaces" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "interface"):
                            for c in self.interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    MPLS TE auto\-tunnel mesh onehop counters
                    (stats) information
                    
                    .. attribute:: connected
                    
                    	Number of connected automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: created
                    
                    	Number of connected automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: last_cleared_time
                    
                    	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: removed_in_use
                    
                    	Number of automesh tunnels removed while up and in use
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: removed_range_exceeded
                    
                    	Number of automesh tunnel attempts rejected because the total number exceeds the range
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: removed_unused
                    
                    	Number of automesh tunnels removed while unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Mesh.OneHop.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "one-hop"

                        self.connected = YLeaf(YType.uint32, "connected")

                        self.created = YLeaf(YType.uint32, "created")

                        self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                        self.removed_in_use = YLeaf(YType.uint32, "removed-in-use")

                        self.removed_range_exceeded = YLeaf(YType.uint32, "removed-range-exceeded")

                        self.removed_unused = YLeaf(YType.uint32, "removed-unused")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("connected",
                                        "created",
                                        "last_cleared_time",
                                        "removed_in_use",
                                        "removed_range_exceeded",
                                        "removed_unused") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Mesh.OneHop.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Mesh.OneHop.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.connected.is_set or
                            self.created.is_set or
                            self.last_cleared_time.is_set or
                            self.removed_in_use.is_set or
                            self.removed_range_exceeded.is_set or
                            self.removed_unused.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.connected.yfilter != YFilter.not_set or
                            self.created.yfilter != YFilter.not_set or
                            self.last_cleared_time.yfilter != YFilter.not_set or
                            self.removed_in_use.yfilter != YFilter.not_set or
                            self.removed_range_exceeded.yfilter != YFilter.not_set or
                            self.removed_unused.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.connected.is_set or self.connected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.connected.get_name_leafdata())
                        if (self.created.is_set or self.created.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.created.get_name_leafdata())
                        if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_cleared_time.get_name_leafdata())
                        if (self.removed_in_use.is_set or self.removed_in_use.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_in_use.get_name_leafdata())
                        if (self.removed_range_exceeded.is_set or self.removed_range_exceeded.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_range_exceeded.get_name_leafdata())
                        if (self.removed_unused.is_set or self.removed_unused.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_unused.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "connected" or name == "created" or name == "last-cleared-time" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "connected"):
                            self.connected = value
                            self.connected.value_namespace = name_space
                            self.connected.value_namespace_prefix = name_space_prefix
                        if(value_path == "created"):
                            self.created = value
                            self.created.value_namespace = name_space
                            self.created.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-cleared-time"):
                            self.last_cleared_time = value
                            self.last_cleared_time.value_namespace = name_space
                            self.last_cleared_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-in-use"):
                            self.removed_in_use = value
                            self.removed_in_use.value_namespace = name_space
                            self.removed_in_use.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-range-exceeded"):
                            self.removed_range_exceeded = value
                            self.removed_range_exceeded.value_namespace = name_space
                            self.removed_range_exceeded.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-unused"):
                            self.removed_unused = value
                            self.removed_unused.value_namespace = name_space
                            self.removed_unused.value_namespace_prefix = name_space_prefix


                class Summary(Entity):
                    """
                    MPLS TE auto\-tunnel mesh onehop summary
                    information
                    
                    .. attribute:: auto_mesh_one_hop_destinations
                    
                    	Total number of automesh onehop destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_one_hop_groups
                    
                    	Total number of automesh onehop mesh\-groups
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh onehop tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Mesh.OneHop.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "one-hop"

                        self.auto_mesh_one_hop_destinations = YLeaf(YType.uint32, "auto-mesh-one-hop-destinations")

                        self.auto_mesh_one_hop_groups = YLeaf(YType.uint32, "auto-mesh-one-hop-groups")

                        self.auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "auto-mesh-one-hop-tunnels")

                        self.down_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "down-auto-mesh-one-hop-tunnels")

                        self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                        self.up_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "up-auto-mesh-one-hop-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_mesh_one_hop_destinations",
                                        "auto_mesh_one_hop_groups",
                                        "auto_mesh_one_hop_tunnels",
                                        "down_auto_mesh_one_hop_tunnels",
                                        "frr_auto_mesh_tunnels",
                                        "up_auto_mesh_one_hop_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Mesh.OneHop.Summary, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Mesh.OneHop.Summary, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_mesh_one_hop_destinations.is_set or
                            self.auto_mesh_one_hop_groups.is_set or
                            self.auto_mesh_one_hop_tunnels.is_set or
                            self.down_auto_mesh_one_hop_tunnels.is_set or
                            self.frr_auto_mesh_tunnels.is_set or
                            self.up_auto_mesh_one_hop_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                            self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_mesh_one_hop_destinations.is_set or self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_destinations.get_name_leafdata())
                        if (self.auto_mesh_one_hop_groups.is_set or self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_groups.get_name_leafdata())
                        if (self.auto_mesh_one_hop_tunnels.is_set or self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_tunnels.get_name_leafdata())
                        if (self.down_auto_mesh_one_hop_tunnels.is_set or self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_mesh_one_hop_tunnels.get_name_leafdata())
                        if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                        if (self.up_auto_mesh_one_hop_tunnels.is_set or self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_mesh_one_hop_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-mesh-one-hop-destinations" or name == "auto-mesh-one-hop-groups" or name == "auto-mesh-one-hop-tunnels" or name == "down-auto-mesh-one-hop-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-one-hop-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-mesh-one-hop-destinations"):
                            self.auto_mesh_one_hop_destinations = value
                            self.auto_mesh_one_hop_destinations.value_namespace = name_space
                            self.auto_mesh_one_hop_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-one-hop-groups"):
                            self.auto_mesh_one_hop_groups = value
                            self.auto_mesh_one_hop_groups.value_namespace = name_space
                            self.auto_mesh_one_hop_groups.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-one-hop-tunnels"):
                            self.auto_mesh_one_hop_tunnels = value
                            self.auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-mesh-one-hop-tunnels"):
                            self.down_auto_mesh_one_hop_tunnels = value
                            self.down_auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.down_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-mesh-tunnels"):
                            self.frr_auto_mesh_tunnels = value
                            self.frr_auto_mesh_tunnels.value_namespace = name_space
                            self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-mesh-one-hop-tunnels"):
                            self.up_auto_mesh_one_hop_tunnels = value
                            self.up_auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.up_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.interfaces is not None and self.interfaces.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()) or
                        (self.summary is not None and self.summary.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.interfaces is not None and self.interfaces.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "one-hop" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "interfaces"):
                        if (self.interfaces is None):
                            self.interfaces = MplsTe.AutoTunnel.Mesh.OneHop.Interfaces()
                            self.interfaces.parent = self
                            self._children_name_map["interfaces"] = "interfaces"
                        return self.interfaces

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.AutoTunnel.Mesh.OneHop.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = MplsTe.AutoTunnel.Mesh.OneHop.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interfaces" or name == "statistics" or name == "summary"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    (self.config is not None and self.config.has_data()) or
                    (self.mesh_groups is not None and self.mesh_groups.has_data()) or
                    (self.one_hop is not None and self.one_hop.has_data()) or
                    (self.statistics is not None and self.statistics.has_data()) or
                    (self.summary is not None and self.summary.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.config is not None and self.config.has_operation()) or
                    (self.mesh_groups is not None and self.mesh_groups.has_operation()) or
                    (self.one_hop is not None and self.one_hop.has_operation()) or
                    (self.statistics is not None and self.statistics.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "mesh" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "config"):
                    if (self.config is None):
                        self.config = MplsTe.AutoTunnel.Mesh.Config()
                        self.config.parent = self
                        self._children_name_map["config"] = "config"
                    return self.config

                if (child_yang_name == "mesh-groups"):
                    if (self.mesh_groups is None):
                        self.mesh_groups = MplsTe.AutoTunnel.Mesh.MeshGroups()
                        self.mesh_groups.parent = self
                        self._children_name_map["mesh_groups"] = "mesh-groups"
                    return self.mesh_groups

                if (child_yang_name == "one-hop"):
                    if (self.one_hop is None):
                        self.one_hop = MplsTe.AutoTunnel.Mesh.OneHop()
                        self.one_hop.parent = self
                        self._children_name_map["one_hop"] = "one-hop"
                    return self.one_hop

                if (child_yang_name == "statistics"):
                    if (self.statistics is None):
                        self.statistics = MplsTe.AutoTunnel.Mesh.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                    return self.statistics

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTe.AutoTunnel.Mesh.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "config" or name == "mesh-groups" or name == "one-hop" or name == "statistics" or name == "summary"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Backup(Entity):
            """
            Auto tunnel backup information.
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel backup configuration information
            	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Config>`
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel backup counters (stats) information
            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics>`
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel backup summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Summary>`
            
            .. attribute:: tunnels
            
            	auto\-tunnel backup information
            	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Tunnels>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AutoTunnel.Backup, self).__init__()

                self.yang_name = "backup"
                self.yang_parent_name = "auto-tunnel"

                self.config = MplsTe.AutoTunnel.Backup.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._children_yang_names.add("config")

                self.statistics = MplsTe.AutoTunnel.Backup.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
                self._children_yang_names.add("statistics")

                self.summary = MplsTe.AutoTunnel.Backup.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.tunnels = MplsTe.AutoTunnel.Backup.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
                self._children_yang_names.add("tunnels")


            class Tunnels(Entity):
                """
                auto\-tunnel backup information
                
                .. attribute:: tunnel
                
                	Display auto tunnel backup tunnel information
                	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Tunnels.Tunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Backup.Tunnels, self).__init__()

                    self.yang_name = "tunnels"
                    self.yang_parent_name = "backup"

                    self.tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Backup.Tunnels, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Backup.Tunnels, self).__setattr__(name, value)


                class Tunnel(Entity):
                    """
                    Display auto tunnel backup tunnel information
                    
                    .. attribute:: backup_tunnel_name  <key>
                    
                    	Backup tunnel name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: atb_protection_type
                    
                    	Type of protection offered by this auto\-tunnel backup
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: operational_status
                    
                    	Tunnel operational status
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: protected_flows
                    
                    	Number of protected flows
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_interface_name
                    
                    	Interface protected by this auto\-tunnel backup
                    	**type**\:  str
                    
                    .. attribute:: protected_router_id
                    
                    	Router ID of node protected by this auto\-tunnel backup
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_mode
                    
                    	SRLG exclude mode for this auto\-tunnel backup
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Tunnels.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tunnels"

                        self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                        self.atb_protection_type = YLeaf(YType.enumeration, "atb-protection-type")

                        self.operational_status = YLeaf(YType.enumeration, "operational-status")

                        self.protected_flows = YLeaf(YType.uint32, "protected-flows")

                        self.protected_interface_name = YLeaf(YType.str, "protected-interface-name")

                        self.protected_router_id = YLeaf(YType.str, "protected-router-id")

                        self.srlg_mode = YLeaf(YType.enumeration, "srlg-mode")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("backup_tunnel_name",
                                        "atb_protection_type",
                                        "operational_status",
                                        "protected_flows",
                                        "protected_interface_name",
                                        "protected_router_id",
                                        "srlg_mode",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Tunnels.Tunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Tunnels.Tunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.backup_tunnel_name.is_set or
                            self.atb_protection_type.is_set or
                            self.operational_status.is_set or
                            self.protected_flows.is_set or
                            self.protected_interface_name.is_set or
                            self.protected_router_id.is_set or
                            self.srlg_mode.is_set or
                            self.tunnel_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.backup_tunnel_name.yfilter != YFilter.not_set or
                            self.atb_protection_type.yfilter != YFilter.not_set or
                            self.operational_status.yfilter != YFilter.not_set or
                            self.protected_flows.yfilter != YFilter.not_set or
                            self.protected_interface_name.yfilter != YFilter.not_set or
                            self.protected_router_id.yfilter != YFilter.not_set or
                            self.srlg_mode.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel" + "[backup-tunnel-name='" + self.backup_tunnel_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/tunnels/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                        if (self.atb_protection_type.is_set or self.atb_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.atb_protection_type.get_name_leafdata())
                        if (self.operational_status.is_set or self.operational_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operational_status.get_name_leafdata())
                        if (self.protected_flows.is_set or self.protected_flows.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_flows.get_name_leafdata())
                        if (self.protected_interface_name.is_set or self.protected_interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_interface_name.get_name_leafdata())
                        if (self.protected_router_id.is_set or self.protected_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_router_id.get_name_leafdata())
                        if (self.srlg_mode.is_set or self.srlg_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_mode.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backup-tunnel-name" or name == "atb-protection-type" or name == "operational-status" or name == "protected-flows" or name == "protected-interface-name" or name == "protected-router-id" or name == "srlg-mode" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "backup-tunnel-name"):
                            self.backup_tunnel_name = value
                            self.backup_tunnel_name.value_namespace = name_space
                            self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "atb-protection-type"):
                            self.atb_protection_type = value
                            self.atb_protection_type.value_namespace = name_space
                            self.atb_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "operational-status"):
                            self.operational_status = value
                            self.operational_status.value_namespace = name_space
                            self.operational_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-flows"):
                            self.protected_flows = value
                            self.protected_flows.value_namespace = name_space
                            self.protected_flows.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-interface-name"):
                            self.protected_interface_name = value
                            self.protected_interface_name.value_namespace = name_space
                            self.protected_interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-router-id"):
                            self.protected_router_id = value
                            self.protected_router_id.value_namespace = name_space
                            self.protected_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-mode"):
                            self.srlg_mode = value
                            self.srlg_mode.value_namespace = name_space
                            self.srlg_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.tunnel:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.tunnel:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnels" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "tunnel"):
                        for c in self.tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.AutoTunnel.Backup.Tunnels.Tunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Statistics(Entity):
                """
                MPLS TE auto\-tunnel backup counters (stats)
                information
                
                .. attribute:: connected
                
                	Number of connected auto backup tunnels
                	**type**\:   :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.Connected>`
                
                .. attribute:: created
                
                	Number of connected auto backup tunnels
                	**type**\:   :py:class:`Created <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.Created>`
                
                .. attribute:: last_cleared_time
                
                	Timestamp when the stat has been cleared
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_down
                
                	Number of NNHOP auto backup tunnels removed while down
                	**type**\:   :py:class:`RemovedDown <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedDown>`
                
                .. attribute:: removed_in_use
                
                	Number of auto backup tunnels removed while up and in use
                	**type**\:   :py:class:`RemovedInUse <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse>`
                
                .. attribute:: removed_range_exceeded
                
                	Number of auto backup tunnel attempts rejected because the total number exceeds the range
                	**type**\:   :py:class:`RemovedRangeExceeded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded>`
                
                .. attribute:: removed_unused
                
                	Number of auto backup tunnels removed while unused
                	**type**\:   :py:class:`RemovedUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Backup.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "backup"

                    self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                    self.connected = MplsTe.AutoTunnel.Backup.Statistics.Connected()
                    self.connected.parent = self
                    self._children_name_map["connected"] = "connected"
                    self._children_yang_names.add("connected")

                    self.created = MplsTe.AutoTunnel.Backup.Statistics.Created()
                    self.created.parent = self
                    self._children_name_map["created"] = "created"
                    self._children_yang_names.add("created")

                    self.removed_down = MplsTe.AutoTunnel.Backup.Statistics.RemovedDown()
                    self.removed_down.parent = self
                    self._children_name_map["removed_down"] = "removed-down"
                    self._children_yang_names.add("removed-down")

                    self.removed_in_use = MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse()
                    self.removed_in_use.parent = self
                    self._children_name_map["removed_in_use"] = "removed-in-use"
                    self._children_yang_names.add("removed-in-use")

                    self.removed_range_exceeded = MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                    self.removed_range_exceeded.parent = self
                    self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                    self._children_yang_names.add("removed-range-exceeded")

                    self.removed_unused = MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused()
                    self.removed_unused.parent = self
                    self._children_name_map["removed_unused"] = "removed-unused"
                    self._children_yang_names.add("removed-unused")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("last_cleared_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Backup.Statistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Backup.Statistics, self).__setattr__(name, value)


                class Created(Entity):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.Created, self).__init__()

                        self.yang_name = "created"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.Created, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.Created, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "created" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class Connected(Entity):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.Connected, self).__init__()

                        self.yang_name = "connected"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.Connected, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.Connected, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "connected" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedDown(Entity):
                    """
                    Number of NNHOP auto backup tunnels removed
                    while down
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.RemovedDown, self).__init__()

                        self.yang_name = "removed-down"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.RemovedDown, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.RemovedDown, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-down" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedUnused(Entity):
                    """
                    Number of auto backup tunnels removed while
                    unused
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused, self).__init__()

                        self.yang_name = "removed-unused"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-unused" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedInUse(Entity):
                    """
                    Number of auto backup tunnels removed while up
                    and in use
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse, self).__init__()

                        self.yang_name = "removed-in-use"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-in-use" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedRangeExceeded(Entity):
                    """
                    Number of auto backup tunnel attempts rejected
                    because the total number exceeds the range
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__init__()

                        self.yang_name = "removed-range-exceeded"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-range-exceeded" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.last_cleared_time.is_set or
                        (self.connected is not None and self.connected.has_data()) or
                        (self.created is not None and self.created.has_data()) or
                        (self.removed_down is not None and self.removed_down.has_data()) or
                        (self.removed_in_use is not None and self.removed_in_use.has_data()) or
                        (self.removed_range_exceeded is not None and self.removed_range_exceeded.has_data()) or
                        (self.removed_unused is not None and self.removed_unused.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.last_cleared_time.yfilter != YFilter.not_set or
                        (self.connected is not None and self.connected.has_operation()) or
                        (self.created is not None and self.created.has_operation()) or
                        (self.removed_down is not None and self.removed_down.has_operation()) or
                        (self.removed_in_use is not None and self.removed_in_use.has_operation()) or
                        (self.removed_range_exceeded is not None and self.removed_range_exceeded.has_operation()) or
                        (self.removed_unused is not None and self.removed_unused.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_cleared_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "connected"):
                        if (self.connected is None):
                            self.connected = MplsTe.AutoTunnel.Backup.Statistics.Connected()
                            self.connected.parent = self
                            self._children_name_map["connected"] = "connected"
                        return self.connected

                    if (child_yang_name == "created"):
                        if (self.created is None):
                            self.created = MplsTe.AutoTunnel.Backup.Statistics.Created()
                            self.created.parent = self
                            self._children_name_map["created"] = "created"
                        return self.created

                    if (child_yang_name == "removed-down"):
                        if (self.removed_down is None):
                            self.removed_down = MplsTe.AutoTunnel.Backup.Statistics.RemovedDown()
                            self.removed_down.parent = self
                            self._children_name_map["removed_down"] = "removed-down"
                        return self.removed_down

                    if (child_yang_name == "removed-in-use"):
                        if (self.removed_in_use is None):
                            self.removed_in_use = MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse()
                            self.removed_in_use.parent = self
                            self._children_name_map["removed_in_use"] = "removed-in-use"
                        return self.removed_in_use

                    if (child_yang_name == "removed-range-exceeded"):
                        if (self.removed_range_exceeded is None):
                            self.removed_range_exceeded = MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                            self.removed_range_exceeded.parent = self
                            self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                        return self.removed_range_exceeded

                    if (child_yang_name == "removed-unused"):
                        if (self.removed_unused is None):
                            self.removed_unused = MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused()
                            self.removed_unused.parent = self
                            self._children_name_map["removed_unused"] = "removed-unused"
                        return self.removed_unused

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "connected" or name == "created" or name == "removed-down" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused" or name == "last-cleared-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "last-cleared-time"):
                        self.last_cleared_time = value
                        self.last_cleared_time.value_namespace = name_space
                        self.last_cleared_time.value_namespace_prefix = name_space_prefix


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel backup summary information
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Backup.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "backup"

                    self.autobackups = YLeaf(YType.uint32, "autobackups")

                    self.down_autobackups = YLeaf(YType.uint32, "down-autobackups")

                    self.next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-autobackup-protected-ls-ps")

                    self.next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2-ls")

                    self.next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2l-families")

                    self.next_hop_autobackups = YLeaf(YType.uint32, "next-hop-autobackups")

                    self.next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-ls-ps")

                    self.next_next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2-ls")

                    self.next_next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackups = YLeaf(YType.uint32, "next-next-hop-autobackups")

                    self.next_next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2l-families")

                    self.srlg_preferred_autobackups = YLeaf(YType.uint32, "srlg-preferred-autobackups")

                    self.srlg_strict_autobackups = YLeaf(YType.uint32, "srlg-strict-autobackups")

                    self.srlg_weighted_autobackups = YLeaf(YType.uint32, "srlg-weighted-autobackups")

                    self.unused_autobackups = YLeaf(YType.uint32, "unused-autobackups")

                    self.up_autobackups = YLeaf(YType.uint32, "up-autobackups")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("autobackups",
                                    "down_autobackups",
                                    "next_hop_autobackup_protected_ls_ps",
                                    "next_hop_autobackup_protected_s2_ls",
                                    "next_hop_autobackup_protected_s2l_families",
                                    "next_hop_autobackups",
                                    "next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_hop_srlg_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackup_protected_ls_ps",
                                    "next_next_hop_autobackup_protected_s2_ls",
                                    "next_next_hop_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackups",
                                    "next_next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_next_hop_srlg_autobackup_protected_s2l_families",
                                    "srlg_preferred_autobackups",
                                    "srlg_strict_autobackups",
                                    "srlg_weighted_autobackups",
                                    "unused_autobackups",
                                    "up_autobackups") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Backup.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Backup.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.autobackups.is_set or
                        self.down_autobackups.is_set or
                        self.next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_hop_autobackups.is_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackups.is_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.srlg_preferred_autobackups.is_set or
                        self.srlg_strict_autobackups.is_set or
                        self.srlg_weighted_autobackups.is_set or
                        self.unused_autobackups.is_set or
                        self.up_autobackups.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.autobackups.yfilter != YFilter.not_set or
                        self.down_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.srlg_preferred_autobackups.yfilter != YFilter.not_set or
                        self.srlg_strict_autobackups.yfilter != YFilter.not_set or
                        self.srlg_weighted_autobackups.yfilter != YFilter.not_set or
                        self.unused_autobackups.yfilter != YFilter.not_set or
                        self.up_autobackups.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.autobackups.is_set or self.autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autobackups.get_name_leafdata())
                    if (self.down_autobackups.is_set or self.down_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_autobackups.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_ls_ps.is_set or self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2_ls.is_set or self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2l_families.is_set or self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_hop_autobackups.is_set or self.next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackups.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_ls_ps.is_set or self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2_ls.is_set or self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2l_families.is_set or self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackups.is_set or self.next_next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackups.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.srlg_preferred_autobackups.is_set or self.srlg_preferred_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_preferred_autobackups.get_name_leafdata())
                    if (self.srlg_strict_autobackups.is_set or self.srlg_strict_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_strict_autobackups.get_name_leafdata())
                    if (self.srlg_weighted_autobackups.is_set or self.srlg_weighted_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_weighted_autobackups.get_name_leafdata())
                    if (self.unused_autobackups.is_set or self.unused_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_autobackups.get_name_leafdata())
                    if (self.up_autobackups.is_set or self.up_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_autobackups.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "autobackups" or name == "down-autobackups" or name == "next-hop-autobackup-protected-ls-ps" or name == "next-hop-autobackup-protected-s2-ls" or name == "next-hop-autobackup-protected-s2l-families" or name == "next-hop-autobackups" or name == "next-hop-srlg-autobackup-protected-ls-ps" or name == "next-hop-srlg-autobackup-protected-s2-ls" or name == "next-hop-srlg-autobackup-protected-s2l-families" or name == "next-next-hop-autobackup-protected-ls-ps" or name == "next-next-hop-autobackup-protected-s2-ls" or name == "next-next-hop-autobackup-protected-s2l-families" or name == "next-next-hop-autobackups" or name == "next-next-hop-srlg-autobackup-protected-ls-ps" or name == "next-next-hop-srlg-autobackup-protected-s2-ls" or name == "next-next-hop-srlg-autobackup-protected-s2l-families" or name == "srlg-preferred-autobackups" or name == "srlg-strict-autobackups" or name == "srlg-weighted-autobackups" or name == "unused-autobackups" or name == "up-autobackups"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "autobackups"):
                        self.autobackups = value
                        self.autobackups.value_namespace = name_space
                        self.autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-autobackups"):
                        self.down_autobackups = value
                        self.down_autobackups.value_namespace = name_space
                        self.down_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-ls-ps"):
                        self.next_hop_autobackup_protected_ls_ps = value
                        self.next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2-ls"):
                        self.next_hop_autobackup_protected_s2_ls = value
                        self.next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2l-families"):
                        self.next_hop_autobackup_protected_s2l_families = value
                        self.next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackups"):
                        self.next_hop_autobackups = value
                        self.next_hop_autobackups.value_namespace = name_space
                        self.next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-ls-ps"):
                        self.next_next_hop_autobackup_protected_ls_ps = value
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2-ls"):
                        self.next_next_hop_autobackup_protected_s2_ls = value
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2l-families"):
                        self.next_next_hop_autobackup_protected_s2l_families = value
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackups"):
                        self.next_next_hop_autobackups = value
                        self.next_next_hop_autobackups.value_namespace = name_space
                        self.next_next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-preferred-autobackups"):
                        self.srlg_preferred_autobackups = value
                        self.srlg_preferred_autobackups.value_namespace = name_space
                        self.srlg_preferred_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-strict-autobackups"):
                        self.srlg_strict_autobackups = value
                        self.srlg_strict_autobackups.value_namespace = name_space
                        self.srlg_strict_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-weighted-autobackups"):
                        self.srlg_weighted_autobackups = value
                        self.srlg_weighted_autobackups.value_namespace = name_space
                        self.srlg_weighted_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-autobackups"):
                        self.unused_autobackups = value
                        self.unused_autobackups.value_namespace = name_space
                        self.unused_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-autobackups"):
                        self.up_autobackups = value
                        self.up_autobackups.value_namespace = name_space
                        self.up_autobackups.value_namespace_prefix = name_space_prefix


            class Config(Entity):
                """
                MPLS TE auto\-tunnel backup configuration
                information
                
                .. attribute:: interface_count
                
                	Number of TE link interfaces with auto\-tunnel backup configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel bacukp feature is configured 
                	**type**\:  bool
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnel.Backup.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "backup"

                    self.interface_count = YLeaf(YType.uint32, "interface-count")

                    self.is_configured = YLeaf(YType.boolean, "is-configured")

                    self.max_tunnel_id = YLeaf(YType.uint16, "max-tunnel-id")

                    self.min_tunnel_id = YLeaf(YType.uint16, "min-tunnel-id")

                    self.unused_removal_timeout_configured = YLeaf(YType.uint32, "unused-removal-timeout-configured")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_count",
                                    "is_configured",
                                    "max_tunnel_id",
                                    "min_tunnel_id",
                                    "unused_removal_timeout_configured") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnel.Backup.Config, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnel.Backup.Config, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_count.is_set or
                        self.is_configured.is_set or
                        self.max_tunnel_id.is_set or
                        self.min_tunnel_id.is_set or
                        self.unused_removal_timeout_configured.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_count.yfilter != YFilter.not_set or
                        self.is_configured.yfilter != YFilter.not_set or
                        self.max_tunnel_id.yfilter != YFilter.not_set or
                        self.min_tunnel_id.yfilter != YFilter.not_set or
                        self.unused_removal_timeout_configured.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "config" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_count.is_set or self.interface_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_count.get_name_leafdata())
                    if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_configured.get_name_leafdata())
                    if (self.max_tunnel_id.is_set or self.max_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_tunnel_id.get_name_leafdata())
                    if (self.min_tunnel_id.is_set or self.min_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.min_tunnel_id.get_name_leafdata())
                    if (self.unused_removal_timeout_configured.is_set or self.unused_removal_timeout_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_removal_timeout_configured.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-count" or name == "is-configured" or name == "max-tunnel-id" or name == "min-tunnel-id" or name == "unused-removal-timeout-configured"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-count"):
                        self.interface_count = value
                        self.interface_count.value_namespace = name_space
                        self.interface_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-configured"):
                        self.is_configured = value
                        self.is_configured.value_namespace = name_space
                        self.is_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-tunnel-id"):
                        self.max_tunnel_id = value
                        self.max_tunnel_id.value_namespace = name_space
                        self.max_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "min-tunnel-id"):
                        self.min_tunnel_id = value
                        self.min_tunnel_id.value_namespace = name_space
                        self.min_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-removal-timeout-configured"):
                        self.unused_removal_timeout_configured = value
                        self.unused_removal_timeout_configured.value_namespace = name_space
                        self.unused_removal_timeout_configured.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    (self.config is not None and self.config.has_data()) or
                    (self.statistics is not None and self.statistics.has_data()) or
                    (self.summary is not None and self.summary.has_data()) or
                    (self.tunnels is not None and self.tunnels.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.config is not None and self.config.has_operation()) or
                    (self.statistics is not None and self.statistics.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()) or
                    (self.tunnels is not None and self.tunnels.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "backup" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "config"):
                    if (self.config is None):
                        self.config = MplsTe.AutoTunnel.Backup.Config()
                        self.config.parent = self
                        self._children_name_map["config"] = "config"
                    return self.config

                if (child_yang_name == "statistics"):
                    if (self.statistics is None):
                        self.statistics = MplsTe.AutoTunnel.Backup.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                    return self.statistics

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTe.AutoTunnel.Backup.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                if (child_yang_name == "tunnels"):
                    if (self.tunnels is None):
                        self.tunnels = MplsTe.AutoTunnel.Backup.Tunnels()
                        self.tunnels.parent = self
                        self._children_name_map["tunnels"] = "tunnels"
                    return self.tunnels

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "config" or name == "statistics" or name == "summary" or name == "tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.backup is not None and self.backup.has_data()) or
                (self.mesh is not None and self.mesh.has_data()) or
                (self.pcc is not None and self.pcc.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.backup is not None and self.backup.has_operation()) or
                (self.mesh is not None and self.mesh.has_operation()) or
                (self.pcc is not None and self.pcc.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "auto-tunnel" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "backup"):
                if (self.backup is None):
                    self.backup = MplsTe.AutoTunnel.Backup()
                    self.backup.parent = self
                    self._children_name_map["backup"] = "backup"
                return self.backup

            if (child_yang_name == "mesh"):
                if (self.mesh is None):
                    self.mesh = MplsTe.AutoTunnel.Mesh()
                    self.mesh.parent = self
                    self._children_name_map["mesh"] = "mesh"
                return self.mesh

            if (child_yang_name == "pcc"):
                if (self.pcc is None):
                    self.pcc = MplsTe.AutoTunnel.Pcc()
                    self.pcc.parent = self
                    self._children_name_map["pcc"] = "pcc"
                return self.pcc

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "backup" or name == "mesh" or name == "pcc"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SoftPreemption(Entity):
        """
        Soft Preemption information.
        
        .. attribute:: statistics
        
        	MPLS TE soft preemption stats information
        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SoftPreemption.Statistics>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.SoftPreemption, self).__init__()

            self.yang_name = "soft-preemption"
            self.yang_parent_name = "mpls-te"

            self.statistics = MplsTe.SoftPreemption.Statistics()
            self.statistics.parent = self
            self._children_name_map["statistics"] = "statistics"
            self._children_yang_names.add("statistics")


        class Statistics(Entity):
            """
            MPLS TE soft preemption stats information
            
            .. attribute:: frr_triggered_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and then fast rerouted at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: minimum_time_in_soft_preempted_state
            
            	The minimum number of seconds an LSP remained in the soft preempted state
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: path_protected_switchover_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are replaced with the path protection LSP. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: reoptimized_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are reoptimized. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preempted_head_ls_ps
            
            	Number of soft preempted LSPs at the headend. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preemption_events
            
            	The number of soft preemption events triggered
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: time_in_soft_preempted_state_avg
            
            	The average number of seconds an LSP remained in the soft preempted state. This excludes the timed out LSPs
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_max
            
            	The maximum number of seconds an LSP remained in the soft preempted state without being hard preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: timed_out_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and timed out at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: torn_down_soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node and torn down before timing out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: torndown_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are torn down instead of being reoptimized. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SoftPreemption.Statistics, self).__init__()

                self.yang_name = "statistics"
                self.yang_parent_name = "soft-preemption"

                self.frr_triggered_soft_preempted_lsp_ss = YLeaf(YType.uint32, "frr-triggered-soft-preempted-lsp-ss")

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.minimum_time_in_soft_preempted_state = YLeaf(YType.uint16, "minimum-time-in-soft-preempted-state")

                self.path_protected_switchover_soft_preempted_ls_ps = YLeaf(YType.uint32, "path-protected-switchover-soft-preempted-ls-ps")

                self.reoptimized_soft_preempted_ls_ps = YLeaf(YType.uint32, "reoptimized-soft-preempted-ls-ps")

                self.soft_preempted_head_ls_ps = YLeaf(YType.uint32, "soft-preempted-head-ls-ps")

                self.soft_preempted_ls_ps = YLeaf(YType.uint32, "soft-preempted-ls-ps")

                self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                self.time_in_soft_preempted_state_avg = YLeaf(YType.uint16, "time-in-soft-preempted-state-avg")

                self.time_in_soft_preempted_state_max = YLeaf(YType.uint16, "time-in-soft-preempted-state-max")

                self.timed_out_soft_preempted_lsp_ss = YLeaf(YType.uint32, "timed-out-soft-preempted-lsp-ss")

                self.torn_down_soft_preempted_ls_ps = YLeaf(YType.uint32, "torn-down-soft-preempted-ls-ps")

                self.torndown_soft_preempted_ls_ps = YLeaf(YType.uint32, "torndown-soft-preempted-ls-ps")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("frr_triggered_soft_preempted_lsp_ss",
                                "last_cleared_timestamp",
                                "minimum_time_in_soft_preempted_state",
                                "path_protected_switchover_soft_preempted_ls_ps",
                                "reoptimized_soft_preempted_ls_ps",
                                "soft_preempted_head_ls_ps",
                                "soft_preempted_ls_ps",
                                "soft_preemption_events",
                                "time_in_soft_preempted_state_avg",
                                "time_in_soft_preempted_state_max",
                                "timed_out_soft_preempted_lsp_ss",
                                "torn_down_soft_preempted_ls_ps",
                                "torndown_soft_preempted_ls_ps") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SoftPreemption.Statistics, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SoftPreemption.Statistics, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.frr_triggered_soft_preempted_lsp_ss.is_set or
                    self.last_cleared_timestamp.is_set or
                    self.minimum_time_in_soft_preempted_state.is_set or
                    self.path_protected_switchover_soft_preempted_ls_ps.is_set or
                    self.reoptimized_soft_preempted_ls_ps.is_set or
                    self.soft_preempted_head_ls_ps.is_set or
                    self.soft_preempted_ls_ps.is_set or
                    self.soft_preemption_events.is_set or
                    self.time_in_soft_preempted_state_avg.is_set or
                    self.time_in_soft_preempted_state_max.is_set or
                    self.timed_out_soft_preempted_lsp_ss.is_set or
                    self.torn_down_soft_preempted_ls_ps.is_set or
                    self.torndown_soft_preempted_ls_ps.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.frr_triggered_soft_preempted_lsp_ss.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    self.minimum_time_in_soft_preempted_state.yfilter != YFilter.not_set or
                    self.path_protected_switchover_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.reoptimized_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_head_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preemption_events.yfilter != YFilter.not_set or
                    self.time_in_soft_preempted_state_avg.yfilter != YFilter.not_set or
                    self.time_in_soft_preempted_state_max.yfilter != YFilter.not_set or
                    self.timed_out_soft_preempted_lsp_ss.yfilter != YFilter.not_set or
                    self.torn_down_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.torndown_soft_preempted_ls_ps.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "statistics" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/soft-preemption/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.frr_triggered_soft_preempted_lsp_ss.is_set or self.frr_triggered_soft_preempted_lsp_ss.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_triggered_soft_preempted_lsp_ss.get_name_leafdata())
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())
                if (self.minimum_time_in_soft_preempted_state.is_set or self.minimum_time_in_soft_preempted_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.minimum_time_in_soft_preempted_state.get_name_leafdata())
                if (self.path_protected_switchover_soft_preempted_ls_ps.is_set or self.path_protected_switchover_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protected_switchover_soft_preempted_ls_ps.get_name_leafdata())
                if (self.reoptimized_soft_preempted_ls_ps.is_set or self.reoptimized_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reoptimized_soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preempted_head_ls_ps.is_set or self.soft_preempted_head_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_head_ls_ps.get_name_leafdata())
                if (self.soft_preempted_ls_ps.is_set or self.soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                if (self.time_in_soft_preempted_state_avg.is_set or self.time_in_soft_preempted_state_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.time_in_soft_preempted_state_avg.get_name_leafdata())
                if (self.time_in_soft_preempted_state_max.is_set or self.time_in_soft_preempted_state_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.time_in_soft_preempted_state_max.get_name_leafdata())
                if (self.timed_out_soft_preempted_lsp_ss.is_set or self.timed_out_soft_preempted_lsp_ss.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timed_out_soft_preempted_lsp_ss.get_name_leafdata())
                if (self.torn_down_soft_preempted_ls_ps.is_set or self.torn_down_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.torn_down_soft_preempted_ls_ps.get_name_leafdata())
                if (self.torndown_soft_preempted_ls_ps.is_set or self.torndown_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.torndown_soft_preempted_ls_ps.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "frr-triggered-soft-preempted-lsp-ss" or name == "last-cleared-timestamp" or name == "minimum-time-in-soft-preempted-state" or name == "path-protected-switchover-soft-preempted-ls-ps" or name == "reoptimized-soft-preempted-ls-ps" or name == "soft-preempted-head-ls-ps" or name == "soft-preempted-ls-ps" or name == "soft-preemption-events" or name == "time-in-soft-preempted-state-avg" or name == "time-in-soft-preempted-state-max" or name == "timed-out-soft-preempted-lsp-ss" or name == "torn-down-soft-preempted-ls-ps" or name == "torndown-soft-preempted-ls-ps"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "frr-triggered-soft-preempted-lsp-ss"):
                    self.frr_triggered_soft_preempted_lsp_ss = value
                    self.frr_triggered_soft_preempted_lsp_ss.value_namespace = name_space
                    self.frr_triggered_soft_preempted_lsp_ss.value_namespace_prefix = name_space_prefix
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "minimum-time-in-soft-preempted-state"):
                    self.minimum_time_in_soft_preempted_state = value
                    self.minimum_time_in_soft_preempted_state.value_namespace = name_space
                    self.minimum_time_in_soft_preempted_state.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protected-switchover-soft-preempted-ls-ps"):
                    self.path_protected_switchover_soft_preempted_ls_ps = value
                    self.path_protected_switchover_soft_preempted_ls_ps.value_namespace = name_space
                    self.path_protected_switchover_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "reoptimized-soft-preempted-ls-ps"):
                    self.reoptimized_soft_preempted_ls_ps = value
                    self.reoptimized_soft_preempted_ls_ps.value_namespace = name_space
                    self.reoptimized_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-head-ls-ps"):
                    self.soft_preempted_head_ls_ps = value
                    self.soft_preempted_head_ls_ps.value_namespace = name_space
                    self.soft_preempted_head_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps"):
                    self.soft_preempted_ls_ps = value
                    self.soft_preempted_ls_ps.value_namespace = name_space
                    self.soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preemption-events"):
                    self.soft_preemption_events = value
                    self.soft_preemption_events.value_namespace = name_space
                    self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                if(value_path == "time-in-soft-preempted-state-avg"):
                    self.time_in_soft_preempted_state_avg = value
                    self.time_in_soft_preempted_state_avg.value_namespace = name_space
                    self.time_in_soft_preempted_state_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "time-in-soft-preempted-state-max"):
                    self.time_in_soft_preempted_state_max = value
                    self.time_in_soft_preempted_state_max.value_namespace = name_space
                    self.time_in_soft_preempted_state_max.value_namespace_prefix = name_space_prefix
                if(value_path == "timed-out-soft-preempted-lsp-ss"):
                    self.timed_out_soft_preempted_lsp_ss = value
                    self.timed_out_soft_preempted_lsp_ss.value_namespace = name_space
                    self.timed_out_soft_preempted_lsp_ss.value_namespace_prefix = name_space_prefix
                if(value_path == "torn-down-soft-preempted-ls-ps"):
                    self.torn_down_soft_preempted_ls_ps = value
                    self.torn_down_soft_preempted_ls_ps.value_namespace = name_space
                    self.torn_down_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "torndown-soft-preempted-ls-ps"):
                    self.torndown_soft_preempted_ls_ps = value
                    self.torndown_soft_preempted_ls_ps.value_namespace = name_space
                    self.torndown_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.statistics is not None and self.statistics.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.statistics is not None and self.statistics.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemption" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "statistics"):
                if (self.statistics is None):
                    self.statistics = MplsTe.SoftPreemption.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                return self.statistics

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "statistics"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class ForwardingAdjacencyDestinations(Entity):
        """
        Announced Destination tunnel
        
        .. attribute:: forwarding_adjacency_destination
        
        	Forwarding Adjacencies for a destination
        	**type**\: list of    :py:class:`ForwardingAdjacencyDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.ForwardingAdjacencyDestinations, self).__init__()

            self.yang_name = "forwarding-adjacency-destinations"
            self.yang_parent_name = "mpls-te"

            self.forwarding_adjacency_destination = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.ForwardingAdjacencyDestinations, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.ForwardingAdjacencyDestinations, self).__setattr__(name, value)


        class ForwardingAdjacencyDestination(Entity):
            """
            Forwarding Adjacencies for a destination
            
            .. attribute:: destination_address  <key>
            
            	Destination address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: adjacencies
            
            	Number of Forwarding Adjacencies
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: destination_address_xr
            
            	The tunnel destination
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: forward_adjacency
            
            	Forwarding\-adjacency list
            	**type**\: list of    :py:class:`ForwardAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency>`
            
            .. attribute:: ipv6_adjacencies
            
            	Number of IPv6 Forwarding Adjacencies
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__init__()

                self.yang_name = "forwarding-adjacency-destination"
                self.yang_parent_name = "forwarding-adjacency-destinations"

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.adjacencies = YLeaf(YType.uint32, "adjacencies")

                self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                self.ipv6_adjacencies = YLeaf(YType.uint32, "ipv6-adjacencies")

                self.forward_adjacency = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("destination_address",
                                "adjacencies",
                                "destination_address_xr",
                                "ipv6_adjacencies") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__setattr__(name, value)


            class ForwardAdjacency(Entity):
                """
                Forwarding\-adjacency list
                
                .. attribute:: hold_time
                
                	Hold time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: ig_ps
                
                	List of IGPs to which it is announced
                	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs>`
                
                .. attribute:: is_adjacency_up
                
                	True if adj is up
                	**type**\:  bool
                
                .. attribute:: traffic_share
                
                	Traffic Share
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	The tunnel name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__init__()

                    self.yang_name = "forward-adjacency"
                    self.yang_parent_name = "forwarding-adjacency-destination"

                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                    self.is_adjacency_up = YLeaf(YType.boolean, "is-adjacency-up")

                    self.traffic_share = YLeaf(YType.uint32, "traffic-share")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.ig_ps = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("hold_time",
                                    "is_adjacency_up",
                                    "traffic_share",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__setattr__(name, value)


                class IgPs(Entity):
                    """
                    List of IGPs to which it is announced
                    
                    .. attribute:: afi
                    
                    	AFI
                    	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    .. attribute:: igp_area_id
                    
                    	The IGP Instance and Area ID
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__init__()

                        self.yang_name = "ig-ps"
                        self.yang_parent_name = "forward-adjacency"

                        self.afi = YLeaf(YType.enumeration, "afi")

                        self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("afi",
                                        "igp_area_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.afi.is_set or
                            self.igp_area_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.afi.yfilter != YFilter.not_set or
                            self.igp_area_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ig-ps" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.afi.get_name_leafdata())
                        if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "afi" or name == "igp-area-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "afi"):
                            self.afi = value
                            self.afi.value_namespace = name_space
                            self.afi.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-id"):
                            self.igp_area_id = value
                            self.igp_area_id.value_namespace = name_space
                            self.igp_area_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.ig_ps:
                        if (c.has_data()):
                            return True
                    return (
                        self.hold_time.is_set or
                        self.is_adjacency_up.is_set or
                        self.traffic_share.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    for c in self.ig_ps:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.hold_time.yfilter != YFilter.not_set or
                        self.is_adjacency_up.yfilter != YFilter.not_set or
                        self.traffic_share.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forward-adjacency" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                    if (self.is_adjacency_up.is_set or self.is_adjacency_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_adjacency_up.get_name_leafdata())
                    if (self.traffic_share.is_set or self.traffic_share.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.traffic_share.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ig-ps"):
                        for c in self.ig_ps:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.ig_ps.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ig-ps" or name == "hold-time" or name == "is-adjacency-up" or name == "traffic-share" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "hold-time"):
                        self.hold_time = value
                        self.hold_time.value_namespace = name_space
                        self.hold_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-adjacency-up"):
                        self.is_adjacency_up = value
                        self.is_adjacency_up.value_namespace = name_space
                        self.is_adjacency_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "traffic-share"):
                        self.traffic_share = value
                        self.traffic_share.value_namespace = name_space
                        self.traffic_share.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.forward_adjacency:
                    if (c.has_data()):
                        return True
                return (
                    self.destination_address.is_set or
                    self.adjacencies.is_set or
                    self.destination_address_xr.is_set or
                    self.ipv6_adjacencies.is_set)

            def has_operation(self):
                for c in self.forward_adjacency:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.adjacencies.yfilter != YFilter.not_set or
                    self.destination_address_xr.yfilter != YFilter.not_set or
                    self.ipv6_adjacencies.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "forwarding-adjacency-destination" + "[destination-address='" + self.destination_address.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/forwarding-adjacency-destinations/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.adjacencies.is_set or self.adjacencies.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.adjacencies.get_name_leafdata())
                if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                if (self.ipv6_adjacencies.is_set or self.ipv6_adjacencies.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ipv6_adjacencies.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "forward-adjacency"):
                    for c in self.forward_adjacency:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.forward_adjacency.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "forward-adjacency" or name == "destination-address" or name == "adjacencies" or name == "destination-address-xr" or name == "ipv6-adjacencies"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "adjacencies"):
                    self.adjacencies = value
                    self.adjacencies.value_namespace = name_space
                    self.adjacencies.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address-xr"):
                    self.destination_address_xr = value
                    self.destination_address_xr.value_namespace = name_space
                    self.destination_address_xr.value_namespace_prefix = name_space_prefix
                if(value_path == "ipv6-adjacencies"):
                    self.ipv6_adjacencies = value
                    self.ipv6_adjacencies.value_namespace = name_space
                    self.ipv6_adjacencies.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.forwarding_adjacency_destination:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.forwarding_adjacency_destination:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "forwarding-adjacency-destinations" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "forwarding-adjacency-destination"):
                for c in self.forwarding_adjacency_destination:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.forwarding_adjacency_destination.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "forwarding-adjacency-destination"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class IgpAreas(Entity):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area
        
        	An IGP instance
        	**type**\: list of    :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.IgpAreas, self).__init__()

            self.yang_name = "igp-areas"
            self.yang_parent_name = "mpls-te"

            self.igp_area = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.IgpAreas, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.IgpAreas, self).__setattr__(name, value)


        class IgpArea(Entity):
            """
            An IGP instance
            
            .. attribute:: protocol  <key>
            
            	The IGP protocol
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: process_tag  <key>
            
            	IGP Process Tag
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area>`
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\:  str
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\:  str
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\:  bool
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of    :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.SecondaryRouterId>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.IgpAreas.IgpArea, self).__init__()

                self.yang_name = "igp-area"
                self.yang_parent_name = "igp-areas"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.process_tag = YLeaf(YType.str, "process-tag")

                self.configured_te_router_id = YLeaf(YType.str, "configured-te-router-id")

                self.connection_down_count = YLeaf(YType.uint32, "connection-down-count")

                self.connection_up_count = YLeaf(YType.uint32, "connection-up-count")

                self.global_router_id = YLeaf(YType.str, "global-router-id")

                self.globall_router_id_optical = YLeaf(YType.str, "globall-router-id-optical")

                self.igp_system_id = YLeaf(YType.str, "igp-system-id")

                self.igp_type = YLeaf(YType.enumeration, "igp-type")

                self.in_use_te_router_id = YLeaf(YType.str, "in-use-te-router-id")

                self.instance_name = YLeaf(YType.str, "instance-name")

                self.is_connection_up = YLeaf(YType.boolean, "is-connection-up")

                self.area = YList(self)
                self.secondary_router_id = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "process_tag",
                                "configured_te_router_id",
                                "connection_down_count",
                                "connection_up_count",
                                "global_router_id",
                                "globall_router_id_optical",
                                "igp_system_id",
                                "igp_type",
                                "in_use_te_router_id",
                                "instance_name",
                                "is_connection_up") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.IgpAreas.IgpArea, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.IgpAreas.IgpArea, self).__setattr__(name, value)


            class SecondaryRouterId(Entity):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.IgpAreas.IgpArea.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area"

                    self.entry = YLeaf(YType.str, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.IgpAreas.IgpArea.SecondaryRouterId, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.IgpAreas.IgpArea.SecondaryRouterId, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "secondary-router-id" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix


            class Area(Entity):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:   :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area.ActiveData>`
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_number
                
                	Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.IgpAreas.IgpArea.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area"

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.area_index = YLeaf(YType.uint32, "area-index")

                    self.area_number = YLeaf(YType.uint32, "area-number")

                    self.is_config_ready = YLeaf(YType.boolean, "is-config-ready")

                    self.active_data = MplsTe.IgpAreas.IgpArea.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._children_yang_names.add("active-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_format",
                                    "area_index",
                                    "area_number",
                                    "is_config_ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.IgpAreas.IgpArea.Area, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.IgpAreas.IgpArea.Area, self).__setattr__(name, value)


                class ActiveData(Entity):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:   :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics>`
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\:  bool
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\:  bool
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.IgpAreas.IgpArea.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"

                        self.interfaces_count = YLeaf(YType.uint32, "interfaces-count")

                        self.link_idt_received = YLeaf(YType.boolean, "link-idt-received")

                        self.p2mp_destination_count = YLeaf(YType.uint32, "p2mp-destination-count")

                        self.p2p_autoroute_announced_count = YLeaf(YType.uint32, "p2p-autoroute-announced-count")

                        self.p2p_forwarding_adjacency_count = YLeaf(YType.uint32, "p2p-forwarding-adjacency-count")

                        self.p2p_heads_count = YLeaf(YType.uint32, "p2p-heads-count")

                        self.sr_strict = YLeaf(YType.boolean, "sr-strict")

                        self.topology_idt_received = YLeaf(YType.boolean, "topology-idt-received")

                        self.tunnel_loose_hops = YLeaf(YType.uint32, "tunnel-loose-hops")

                        self.area_statistics = MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._children_yang_names.add("area-statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interfaces_count",
                                        "link_idt_received",
                                        "p2mp_destination_count",
                                        "p2p_autoroute_announced_count",
                                        "p2p_forwarding_adjacency_count",
                                        "p2p_heads_count",
                                        "sr_strict",
                                        "topology_idt_received",
                                        "tunnel_loose_hops") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.IgpAreas.IgpArea.Area.ActiveData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.IgpAreas.IgpArea.Area.ActiveData, self).__setattr__(name, value)


                    class AreaStatistics(Entity):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"

                            self.area_adjacency_announce_messages = YLeaf(YType.uint32, "area-adjacency-announce-messages")

                            self.area_adjacency_request_messages = YLeaf(YType.uint32, "area-adjacency-request-messages")

                            self.area_flood_messages = YLeaf(YType.uint32, "area-flood-messages")

                            self.area_lsa_announce_messages = YLeaf(YType.uint32, "area-lsa-announce-messages")

                            self.area_lsa_delete_messages = YLeaf(YType.uint32, "area-lsa-delete-messages")

                            self.area_lsa_fragment_announce_messages = YLeaf(YType.uint32, "area-lsa-fragment-announce-messages")

                            self.area_lsa_fragment_delete_messages = YLeaf(YType.uint32, "area-lsa-fragment-delete-messages")

                            self.area_tunnel_announce_messages = YLeaf(YType.uint32, "area-tunnel-announce-messages")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_adjacency_announce_messages",
                                            "area_adjacency_request_messages",
                                            "area_flood_messages",
                                            "area_lsa_announce_messages",
                                            "area_lsa_delete_messages",
                                            "area_lsa_fragment_announce_messages",
                                            "area_lsa_fragment_delete_messages",
                                            "area_tunnel_announce_messages") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.area_adjacency_announce_messages.is_set or
                                self.area_adjacency_request_messages.is_set or
                                self.area_flood_messages.is_set or
                                self.area_lsa_announce_messages.is_set or
                                self.area_lsa_delete_messages.is_set or
                                self.area_lsa_fragment_announce_messages.is_set or
                                self.area_lsa_fragment_delete_messages.is_set or
                                self.area_tunnel_announce_messages.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_adjacency_announce_messages.yfilter != YFilter.not_set or
                                self.area_adjacency_request_messages.yfilter != YFilter.not_set or
                                self.area_flood_messages.yfilter != YFilter.not_set or
                                self.area_lsa_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_delete_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set or
                                self.area_tunnel_announce_messages.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_adjacency_announce_messages.is_set or self.area_adjacency_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_announce_messages.get_name_leafdata())
                            if (self.area_adjacency_request_messages.is_set or self.area_adjacency_request_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_request_messages.get_name_leafdata())
                            if (self.area_flood_messages.is_set or self.area_flood_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_flood_messages.get_name_leafdata())
                            if (self.area_lsa_announce_messages.is_set or self.area_lsa_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_announce_messages.get_name_leafdata())
                            if (self.area_lsa_delete_messages.is_set or self.area_lsa_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_delete_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_announce_messages.is_set or self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_announce_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_delete_messages.is_set or self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_delete_messages.get_name_leafdata())
                            if (self.area_tunnel_announce_messages.is_set or self.area_tunnel_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_tunnel_announce_messages.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-adjacency-announce-messages" or name == "area-adjacency-request-messages" or name == "area-flood-messages" or name == "area-lsa-announce-messages" or name == "area-lsa-delete-messages" or name == "area-lsa-fragment-announce-messages" or name == "area-lsa-fragment-delete-messages" or name == "area-tunnel-announce-messages"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-adjacency-announce-messages"):
                                self.area_adjacency_announce_messages = value
                                self.area_adjacency_announce_messages.value_namespace = name_space
                                self.area_adjacency_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-adjacency-request-messages"):
                                self.area_adjacency_request_messages = value
                                self.area_adjacency_request_messages.value_namespace = name_space
                                self.area_adjacency_request_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-flood-messages"):
                                self.area_flood_messages = value
                                self.area_flood_messages.value_namespace = name_space
                                self.area_flood_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-announce-messages"):
                                self.area_lsa_announce_messages = value
                                self.area_lsa_announce_messages.value_namespace = name_space
                                self.area_lsa_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-delete-messages"):
                                self.area_lsa_delete_messages = value
                                self.area_lsa_delete_messages.value_namespace = name_space
                                self.area_lsa_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-announce-messages"):
                                self.area_lsa_fragment_announce_messages = value
                                self.area_lsa_fragment_announce_messages.value_namespace = name_space
                                self.area_lsa_fragment_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-delete-messages"):
                                self.area_lsa_fragment_delete_messages = value
                                self.area_lsa_fragment_delete_messages.value_namespace = name_space
                                self.area_lsa_fragment_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-tunnel-announce-messages"):
                                self.area_tunnel_announce_messages = value
                                self.area_tunnel_announce_messages.value_namespace = name_space
                                self.area_tunnel_announce_messages.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.interfaces_count.is_set or
                            self.link_idt_received.is_set or
                            self.p2mp_destination_count.is_set or
                            self.p2p_autoroute_announced_count.is_set or
                            self.p2p_forwarding_adjacency_count.is_set or
                            self.p2p_heads_count.is_set or
                            self.sr_strict.is_set or
                            self.topology_idt_received.is_set or
                            self.tunnel_loose_hops.is_set or
                            (self.area_statistics is not None and self.area_statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interfaces_count.yfilter != YFilter.not_set or
                            self.link_idt_received.yfilter != YFilter.not_set or
                            self.p2mp_destination_count.yfilter != YFilter.not_set or
                            self.p2p_autoroute_announced_count.yfilter != YFilter.not_set or
                            self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set or
                            self.p2p_heads_count.yfilter != YFilter.not_set or
                            self.sr_strict.yfilter != YFilter.not_set or
                            self.topology_idt_received.yfilter != YFilter.not_set or
                            self.tunnel_loose_hops.yfilter != YFilter.not_set or
                            (self.area_statistics is not None and self.area_statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "active-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interfaces_count.is_set or self.interfaces_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interfaces_count.get_name_leafdata())
                        if (self.link_idt_received.is_set or self.link_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_idt_received.get_name_leafdata())
                        if (self.p2mp_destination_count.is_set or self.p2mp_destination_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2mp_destination_count.get_name_leafdata())
                        if (self.p2p_autoroute_announced_count.is_set or self.p2p_autoroute_announced_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_autoroute_announced_count.get_name_leafdata())
                        if (self.p2p_forwarding_adjacency_count.is_set or self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_forwarding_adjacency_count.get_name_leafdata())
                        if (self.p2p_heads_count.is_set or self.p2p_heads_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_heads_count.get_name_leafdata())
                        if (self.sr_strict.is_set or self.sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sr_strict.get_name_leafdata())
                        if (self.topology_idt_received.is_set or self.topology_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_idt_received.get_name_leafdata())
                        if (self.tunnel_loose_hops.is_set or self.tunnel_loose_hops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loose_hops.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-statistics"):
                            if (self.area_statistics is None):
                                self.area_statistics = MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                                self.area_statistics.parent = self
                                self._children_name_map["area_statistics"] = "area-statistics"
                            return self.area_statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-statistics" or name == "interfaces-count" or name == "link-idt-received" or name == "p2mp-destination-count" or name == "p2p-autoroute-announced-count" or name == "p2p-forwarding-adjacency-count" or name == "p2p-heads-count" or name == "sr-strict" or name == "topology-idt-received" or name == "tunnel-loose-hops"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interfaces-count"):
                            self.interfaces_count = value
                            self.interfaces_count.value_namespace = name_space
                            self.interfaces_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-idt-received"):
                            self.link_idt_received = value
                            self.link_idt_received.value_namespace = name_space
                            self.link_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2mp-destination-count"):
                            self.p2mp_destination_count = value
                            self.p2mp_destination_count.value_namespace = name_space
                            self.p2mp_destination_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-autoroute-announced-count"):
                            self.p2p_autoroute_announced_count = value
                            self.p2p_autoroute_announced_count.value_namespace = name_space
                            self.p2p_autoroute_announced_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-forwarding-adjacency-count"):
                            self.p2p_forwarding_adjacency_count = value
                            self.p2p_forwarding_adjacency_count.value_namespace = name_space
                            self.p2p_forwarding_adjacency_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-heads-count"):
                            self.p2p_heads_count = value
                            self.p2p_heads_count.value_namespace = name_space
                            self.p2p_heads_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "sr-strict"):
                            self.sr_strict = value
                            self.sr_strict.value_namespace = name_space
                            self.sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-idt-received"):
                            self.topology_idt_received = value
                            self.topology_idt_received.value_namespace = name_space
                            self.topology_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loose-hops"):
                            self.tunnel_loose_hops = value
                            self.tunnel_loose_hops.value_namespace = name_space
                            self.tunnel_loose_hops.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_format.is_set or
                        self.area_index.is_set or
                        self.area_number.is_set or
                        self.is_config_ready.is_set or
                        (self.active_data is not None and self.active_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.area_index.yfilter != YFilter.not_set or
                        self.area_number.yfilter != YFilter.not_set or
                        self.is_config_ready.yfilter != YFilter.not_set or
                        (self.active_data is not None and self.active_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "area" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.area_index.is_set or self.area_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_index.get_name_leafdata())
                    if (self.area_number.is_set or self.area_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_number.get_name_leafdata())
                    if (self.is_config_ready.is_set or self.is_config_ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_config_ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "active-data"):
                        if (self.active_data is None):
                            self.active_data = MplsTe.IgpAreas.IgpArea.Area.ActiveData()
                            self.active_data.parent = self
                            self._children_name_map["active_data"] = "active-data"
                        return self.active_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active-data" or name == "area-format" or name == "area-index" or name == "area-number" or name == "is-config-ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-index"):
                        self.area_index = value
                        self.area_index.value_namespace = name_space
                        self.area_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-number"):
                        self.area_number = value
                        self.area_number.value_namespace = name_space
                        self.area_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-config-ready"):
                        self.is_config_ready = value
                        self.is_config_ready.value_namespace = name_space
                        self.is_config_ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.area:
                    if (c.has_data()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.process_tag.is_set or
                    self.configured_te_router_id.is_set or
                    self.connection_down_count.is_set or
                    self.connection_up_count.is_set or
                    self.global_router_id.is_set or
                    self.globall_router_id_optical.is_set or
                    self.igp_system_id.is_set or
                    self.igp_type.is_set or
                    self.in_use_te_router_id.is_set or
                    self.instance_name.is_set or
                    self.is_connection_up.is_set)

            def has_operation(self):
                for c in self.area:
                    if (c.has_operation()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.process_tag.yfilter != YFilter.not_set or
                    self.configured_te_router_id.yfilter != YFilter.not_set or
                    self.connection_down_count.yfilter != YFilter.not_set or
                    self.connection_up_count.yfilter != YFilter.not_set or
                    self.global_router_id.yfilter != YFilter.not_set or
                    self.globall_router_id_optical.yfilter != YFilter.not_set or
                    self.igp_system_id.yfilter != YFilter.not_set or
                    self.igp_type.yfilter != YFilter.not_set or
                    self.in_use_te_router_id.yfilter != YFilter.not_set or
                    self.instance_name.yfilter != YFilter.not_set or
                    self.is_connection_up.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-area" + "[protocol='" + self.protocol.get() + "']" + "[process-tag='" + self.process_tag.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/igp-areas/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.process_tag.is_set or self.process_tag.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.process_tag.get_name_leafdata())
                if (self.configured_te_router_id.is_set or self.configured_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_te_router_id.get_name_leafdata())
                if (self.connection_down_count.is_set or self.connection_down_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_down_count.get_name_leafdata())
                if (self.connection_up_count.is_set or self.connection_up_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_up_count.get_name_leafdata())
                if (self.global_router_id.is_set or self.global_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.global_router_id.get_name_leafdata())
                if (self.globall_router_id_optical.is_set or self.globall_router_id_optical.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.globall_router_id_optical.get_name_leafdata())
                if (self.igp_system_id.is_set or self.igp_system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_system_id.get_name_leafdata())
                if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_type.get_name_leafdata())
                if (self.in_use_te_router_id.is_set or self.in_use_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.in_use_te_router_id.get_name_leafdata())
                if (self.instance_name.is_set or self.instance_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.instance_name.get_name_leafdata())
                if (self.is_connection_up.is_set or self.is_connection_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_connection_up.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "area"):
                    for c in self.area:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.IgpAreas.IgpArea.Area()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.area.append(c)
                    return c

                if (child_yang_name == "secondary-router-id"):
                    for c in self.secondary_router_id:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.IgpAreas.IgpArea.SecondaryRouterId()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.secondary_router_id.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area" or name == "secondary-router-id" or name == "protocol" or name == "process-tag" or name == "configured-te-router-id" or name == "connection-down-count" or name == "connection-up-count" or name == "global-router-id" or name == "globall-router-id-optical" or name == "igp-system-id" or name == "igp-type" or name == "in-use-te-router-id" or name == "instance-name" or name == "is-connection-up"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "process-tag"):
                    self.process_tag = value
                    self.process_tag.value_namespace = name_space
                    self.process_tag.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-te-router-id"):
                    self.configured_te_router_id = value
                    self.configured_te_router_id.value_namespace = name_space
                    self.configured_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-down-count"):
                    self.connection_down_count = value
                    self.connection_down_count.value_namespace = name_space
                    self.connection_down_count.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-up-count"):
                    self.connection_up_count = value
                    self.connection_up_count.value_namespace = name_space
                    self.connection_up_count.value_namespace_prefix = name_space_prefix
                if(value_path == "global-router-id"):
                    self.global_router_id = value
                    self.global_router_id.value_namespace = name_space
                    self.global_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "globall-router-id-optical"):
                    self.globall_router_id_optical = value
                    self.globall_router_id_optical.value_namespace = name_space
                    self.globall_router_id_optical.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-system-id"):
                    self.igp_system_id = value
                    self.igp_system_id.value_namespace = name_space
                    self.igp_system_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-type"):
                    self.igp_type = value
                    self.igp_type.value_namespace = name_space
                    self.igp_type.value_namespace_prefix = name_space_prefix
                if(value_path == "in-use-te-router-id"):
                    self.in_use_te_router_id = value
                    self.in_use_te_router_id.value_namespace = name_space
                    self.in_use_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "instance-name"):
                    self.instance_name = value
                    self.instance_name.value_namespace = name_space
                    self.instance_name.value_namespace_prefix = name_space_prefix
                if(value_path == "is-connection-up"):
                    self.is_connection_up = value
                    self.is_connection_up.value_namespace = name_space
                    self.is_connection_up.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.igp_area:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.igp_area:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "igp-areas" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-area"):
                for c in self.igp_area:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.IgpAreas.IgpArea()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.igp_area.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-area"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class WrapProtection(Entity):
        """
        Represent all the LSP Wrap Protection info in
        MPLS\-TE
        
        .. attribute:: protected_lsps
        
        	The set of wrap protected LSPs available in MPLS\-TE
        	**type**\:   :py:class:`ProtectedLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection.ProtectedLsps>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.WrapProtection, self).__init__()

            self.yang_name = "wrap-protection"
            self.yang_parent_name = "mpls-te"

            self.protected_lsps = MplsTe.WrapProtection.ProtectedLsps()
            self.protected_lsps.parent = self
            self._children_name_map["protected_lsps"] = "protected-lsps"
            self._children_yang_names.add("protected-lsps")


        class ProtectedLsps(Entity):
            """
            The set of wrap protected LSPs available in
            MPLS\-TE
            
            .. attribute:: protected_lsp
            
            	Wrap protection info for a given protected LSP
            	**type**\: list of    :py:class:`ProtectedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.WrapProtection.ProtectedLsps, self).__init__()

                self.yang_name = "protected-lsps"
                self.yang_parent_name = "wrap-protection"

                self.protected_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.WrapProtection.ProtectedLsps, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.WrapProtection.ProtectedLsps, self).__setattr__(name, value)


            class ProtectedLsp(Entity):
                """
                Wrap protection info for a given protected LSP
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup Orig ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: session_type  <key>
                
                	Session Type
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_wrap_protection_enable
                
                	LSP Wrap protection enabled
                	**type**\:  bool
                
                .. attribute:: lsp_wrap_protection_label
                
                	LSP Wrap Merge Point Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_state
                
                	LSP wrap protection state
                	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: reverse_egress_interface
                
                	Reverse Egress Interface
                	**type**\:  str
                
                .. attribute:: reverse_lsp_label
                
                	Reverse LSP label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp, self).__init__()

                    self.yang_name = "protected-lsp"
                    self.yang_parent_name = "protected-lsps"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.session_type = YLeaf(YType.enumeration, "session-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.extended_tunnel_id_xr = YLeaf(YType.str, "extended-tunnel-id-xr")

                    self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                    self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                    self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                    self.p2mp_id_xr = YLeaf(YType.uint32, "p2mp-id-xr")

                    self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                    self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                    self.source_address_xr = YLeaf(YType.str, "source-address-xr")

                    self.sub_group_id_xr = YLeaf(YType.uint16, "sub-group-id-xr")

                    self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    self.tunnel_id_xr = YLeaf(YType.uint16, "tunnel-id-xr")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "sub_group_id",
                                    "sub_group_originator",
                                    "p2mp_id",
                                    "session_type",
                                    "destination_address_xr",
                                    "extended_tunnel_id_xr",
                                    "lsp_wrap_protection_enable",
                                    "lsp_wrap_protection_label",
                                    "lsp_wrap_protection_state",
                                    "p2mp_id_xr",
                                    "reverse_egress_interface",
                                    "reverse_lsp_label",
                                    "source_address_xr",
                                    "sub_group_id_xr",
                                    "sub_group_original_id",
                                    "tunnel_id_xr",
                                    "tunnel_instance",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.sub_group_id.is_set or
                        self.sub_group_originator.is_set or
                        self.p2mp_id.is_set or
                        self.session_type.is_set or
                        self.destination_address_xr.is_set or
                        self.extended_tunnel_id_xr.is_set or
                        self.lsp_wrap_protection_enable.is_set or
                        self.lsp_wrap_protection_label.is_set or
                        self.lsp_wrap_protection_state.is_set or
                        self.p2mp_id_xr.is_set or
                        self.reverse_egress_interface.is_set or
                        self.reverse_lsp_label.is_set or
                        self.source_address_xr.is_set or
                        self.sub_group_id_xr.is_set or
                        self.sub_group_original_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_instance.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.session_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.extended_tunnel_id_xr.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                        self.p2mp_id_xr.yfilter != YFilter.not_set or
                        self.reverse_egress_interface.yfilter != YFilter.not_set or
                        self.reverse_lsp_label.yfilter != YFilter.not_set or
                        self.source_address_xr.yfilter != YFilter.not_set or
                        self.sub_group_id_xr.yfilter != YFilter.not_set or
                        self.sub_group_original_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protected-lsp" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[session-type='" + self.session_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/wrap-protection/protected-lsps/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.session_type.is_set or self.session_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.extended_tunnel_id_xr.is_set or self.extended_tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id_xr.get_name_leafdata())
                    if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                    if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                    if (self.p2mp_id_xr.is_set or self.p2mp_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id_xr.get_name_leafdata())
                    if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                    if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())
                    if (self.source_address_xr.is_set or self.source_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address_xr.get_name_leafdata())
                    if (self.sub_group_id_xr.is_set or self.sub_group_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id_xr.get_name_leafdata())
                    if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "sub-group-id" or name == "sub-group-originator" or name == "p2mp-id" or name == "session-type" or name == "destination-address-xr" or name == "extended-tunnel-id-xr" or name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "p2mp-id-xr" or name == "reverse-egress-interface" or name == "reverse-lsp-label" or name == "source-address-xr" or name == "sub-group-id-xr" or name == "sub-group-original-id" or name == "tunnel-id-xr" or name == "tunnel-instance" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-type"):
                        self.session_type = value
                        self.session_type.value_namespace = name_space
                        self.session_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id-xr"):
                        self.extended_tunnel_id_xr = value
                        self.extended_tunnel_id_xr.value_namespace = name_space
                        self.extended_tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enable"):
                        self.lsp_wrap_protection_enable = value
                        self.lsp_wrap_protection_enable.value_namespace = name_space
                        self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-label"):
                        self.lsp_wrap_protection_label = value
                        self.lsp_wrap_protection_label.value_namespace = name_space
                        self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-state"):
                        self.lsp_wrap_protection_state = value
                        self.lsp_wrap_protection_state.value_namespace = name_space
                        self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id-xr"):
                        self.p2mp_id_xr = value
                        self.p2mp_id_xr.value_namespace = name_space
                        self.p2mp_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-egress-interface"):
                        self.reverse_egress_interface = value
                        self.reverse_egress_interface.value_namespace = name_space
                        self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-lsp-label"):
                        self.reverse_lsp_label = value
                        self.reverse_lsp_label.value_namespace = name_space
                        self.reverse_lsp_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address-xr"):
                        self.source_address_xr = value
                        self.source_address_xr.value_namespace = name_space
                        self.source_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id-xr"):
                        self.sub_group_id_xr = value
                        self.sub_group_id_xr.value_namespace = name_space
                        self.sub_group_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-original-id"):
                        self.sub_group_original_id = value
                        self.sub_group_original_id.value_namespace = name_space
                        self.sub_group_original_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protected_lsp:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protected_lsp:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protected-lsps" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/wrap-protection/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protected-lsp"):
                    for c in self.protected_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protected_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protected-lsp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.protected_lsps is not None and self.protected_lsps.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.protected_lsps is not None and self.protected_lsps.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "wrap-protection" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "protected-lsps"):
                if (self.protected_lsps is None):
                    self.protected_lsps = MplsTe.WrapProtection.ProtectedLsps()
                    self.protected_lsps.parent = self
                    self._children_name_map["protected_lsps"] = "protected-lsps"
                return self.protected_lsps

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "protected-lsps"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Topology(Entity):
        """
        The topology information in MPLS\-TE
        
        .. attribute:: configured_srlgs
        
        	Set of configured SRLG
        	**type**\:   :py:class:`ConfiguredSrlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs>`
        
        .. attribute:: destination_paths
        
        	This table models the path calculation capabilities in MPLS\-TE.A GET operation for the complete table will return no entries.See the class DestinationPath for more details
        	**type**\:   :py:class:`DestinationPaths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths>`
        
        .. attribute:: global_
        
        	Global information about the overall MPLS\-TE topology
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global_>`
        
        .. attribute:: path_tunnels
        
        	MPLS\-Te topology path info
        	**type**\:   :py:class:`PathTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels>`
        
        .. attribute:: srlgs
        
        	Set of SRLG operational value for the overall MPLS\-TE topology
        	**type**\:   :py:class:`Srlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-te"

            self.configured_srlgs = MplsTe.Topology.ConfiguredSrlgs()
            self.configured_srlgs.parent = self
            self._children_name_map["configured_srlgs"] = "configured-srlgs"
            self._children_yang_names.add("configured-srlgs")

            self.destination_paths = MplsTe.Topology.DestinationPaths()
            self.destination_paths.parent = self
            self._children_name_map["destination_paths"] = "destination-paths"
            self._children_yang_names.add("destination-paths")

            self.global_ = MplsTe.Topology.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.path_tunnels = MplsTe.Topology.PathTunnels()
            self.path_tunnels.parent = self
            self._children_name_map["path_tunnels"] = "path-tunnels"
            self._children_yang_names.add("path-tunnels")

            self.srlgs = MplsTe.Topology.Srlgs()
            self.srlgs.parent = self
            self._children_name_map["srlgs"] = "srlgs"
            self._children_yang_names.add("srlgs")


        class Global_(Entity):
            """
            Global information about the overall MPLS\-TE
            topology
            
            .. attribute:: areas
            
            	Information for areas
            	**type**\: list of    :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global_.Areas>`
            
            .. attribute:: hold_down_interval
            
            	Interval in seconds to hold down a neighbor after a signalling error
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: link_add_remove_count
            
            	Link add/remove counter
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: local_model_id
            
            	Local BC Model ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Topology.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"

                self.hold_down_interval = YLeaf(YType.uint32, "hold-down-interval")

                self.link_add_remove_count = YLeaf(YType.uint32, "link-add-remove-count")

                self.local_model_id = YLeaf(YType.uint32, "local-model-id")

                self.areas = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("hold_down_interval",
                                "link_add_remove_count",
                                "local_model_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Topology.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Topology.Global_, self).__setattr__(name, value)


            class Areas(Entity):
                """
                Information for areas
                
                .. attribute:: area_id
                
                	The area's id
                	**type**\:  str
                
                .. attribute:: local_sid_and_srbg
                
                	Local SID and SRBG
                	**type**\:   :py:class:`LocalSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global_.Areas.LocalSidAndSrbg>`
                
                .. attribute:: node_id
                
                	The node's IGP id
                	**type**\:  str
                
                .. attribute:: protocol
                
                	Protocol used
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Topology.Global_.Areas, self).__init__()

                    self.yang_name = "areas"
                    self.yang_parent_name = "global"

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.local_sid_and_srbg = MplsTe.Topology.Global_.Areas.LocalSidAndSrbg()
                    self.local_sid_and_srbg.parent = self
                    self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                    self._children_yang_names.add("local-sid-and-srbg")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_id",
                                    "node_id",
                                    "protocol") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Topology.Global_.Areas, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Topology.Global_.Areas, self).__setattr__(name, value)


                class LocalSidAndSrbg(Entity):
                    """
                    Local SID and SRBG
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.Global_.Areas.LocalSidAndSrbg, self).__init__()

                        self.yang_name = "local-sid-and-srbg"
                        self.yang_parent_name = "areas"

                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                        self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                        self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                        self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("segment_id",
                                        "segment_id_local_absolute_value",
                                        "srgb_size",
                                        "srgb_start") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.Global_.Areas.LocalSidAndSrbg, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.Global_.Areas.LocalSidAndSrbg, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.segment_id.is_set or
                            self.segment_id_local_absolute_value.is_set or
                            self.srgb_size.is_set or
                            self.srgb_start.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.segment_id.yfilter != YFilter.not_set or
                            self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                            self.srgb_size.yfilter != YFilter.not_set or
                            self.srgb_start.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "local-sid-and-srbg" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/global/areas/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                        if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                        if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_size.get_name_leafdata())
                        if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_start.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "segment-id"):
                            self.segment_id = value
                            self.segment_id.value_namespace = name_space
                            self.segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-local-absolute-value"):
                            self.segment_id_local_absolute_value = value
                            self.segment_id_local_absolute_value.value_namespace = name_space
                            self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-size"):
                            self.srgb_size = value
                            self.srgb_size.value_namespace = name_space
                            self.srgb_size.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-start"):
                            self.srgb_start = value
                            self.srgb_start.value_namespace = name_space
                            self.srgb_start.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_id.is_set or
                        self.node_id.is_set or
                        self.protocol.is_set or
                        (self.local_sid_and_srbg is not None and self.local_sid_and_srbg.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        (self.local_sid_and_srbg is not None and self.local_sid_and_srbg.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "areas" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/global/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "local-sid-and-srbg"):
                        if (self.local_sid_and_srbg is None):
                            self.local_sid_and_srbg = MplsTe.Topology.Global_.Areas.LocalSidAndSrbg()
                            self.local_sid_and_srbg.parent = self
                            self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                        return self.local_sid_and_srbg

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "local-sid-and-srbg" or name == "area-id" or name == "node-id" or name == "protocol"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.areas:
                    if (c.has_data()):
                        return True
                return (
                    self.hold_down_interval.is_set or
                    self.link_add_remove_count.is_set or
                    self.local_model_id.is_set)

            def has_operation(self):
                for c in self.areas:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.hold_down_interval.yfilter != YFilter.not_set or
                    self.link_add_remove_count.yfilter != YFilter.not_set or
                    self.local_model_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.hold_down_interval.is_set or self.hold_down_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hold_down_interval.get_name_leafdata())
                if (self.link_add_remove_count.is_set or self.link_add_remove_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_add_remove_count.get_name_leafdata())
                if (self.local_model_id.is_set or self.local_model_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_model_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "areas"):
                    for c in self.areas:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Topology.Global_.Areas()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.areas.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "areas" or name == "hold-down-interval" or name == "link-add-remove-count" or name == "local-model-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "hold-down-interval"):
                    self.hold_down_interval = value
                    self.hold_down_interval.value_namespace = name_space
                    self.hold_down_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "link-add-remove-count"):
                    self.link_add_remove_count = value
                    self.link_add_remove_count.value_namespace = name_space
                    self.link_add_remove_count.value_namespace_prefix = name_space_prefix
                if(value_path == "local-model-id"):
                    self.local_model_id = value
                    self.local_model_id.value_namespace = name_space
                    self.local_model_id.value_namespace_prefix = name_space_prefix


        class DestinationPaths(Entity):
            """
            This table models the path calculation
            capabilities in MPLS\-TE.A GET operation for the
            complete table will return no entries.See the
            class DestinationPath for more details.
            
            .. attribute:: destination_path
            
            	A GET operation on this class returns the best available path in the TE topology to reach the specified destination while satisfying the specified constraints
            	**type**\: list of    :py:class:`DestinationPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Topology.DestinationPaths, self).__init__()

                self.yang_name = "destination-paths"
                self.yang_parent_name = "topology"

                self.destination_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Topology.DestinationPaths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Topology.DestinationPaths, self).__setattr__(name, value)


            class DestinationPath(Entity):
                """
                A GET operation on this class returns the best
                available path in the TE topology to reach the
                specified destination while satisfying the
                specified constraints.
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity>`
                
                .. attribute:: affinity_bits
                
                	Affinity Bits
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: affinity_mask
                
                	Affinity Mask
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: bandwidth
                
                	Bandwidth in kbps
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: cost_limit
                
                	Cost Limit
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_ip_address
                
                	Exclude SRLG IP Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	Hold Priority
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of    :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Hop>`
                
                .. attribute:: hop_limit
                
                	Hop Limit
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_area
                
                	IGP Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_instance
                
                	IGP Instance
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: igp_type
                
                	IGP Type
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\:  bool
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\:  bool
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\:  bool
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\:  bool
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: path_id
                
                	This is the ID of the explicit path to be used for this path calculation query
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: path_name
                
                	This is the name of the explicit path to be used for this path calculation query
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: path_type
                
                	Path Type
                	**type**\:   :py:class:`MplsTePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePath>`
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	Setup Priority
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup>`
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of    :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment>`
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Topology.DestinationPaths.DestinationPath, self).__init__()

                    self.yang_name = "destination-path"
                    self.yang_parent_name = "destination-paths"

                    self.accumulated_admin_weight = YLeaf(YType.uint64, "accumulated-admin-weight")

                    self.affinity_bits = YLeaf(YType.int32, "affinity-bits")

                    self.affinity_mask = YLeaf(YType.int32, "affinity-mask")

                    self.bandwidth = YLeaf(YType.int32, "bandwidth")

                    self.bandwidth_type = YLeaf(YType.uint64, "bandwidth-type")

                    self.cost_limit = YLeaf(YType.int32, "cost-limit")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.exclude_srlg_address = YLeaf(YType.str, "exclude-srlg-address")

                    self.exclude_srlg_ip_address = YLeaf(YType.str, "exclude-srlg-ip-address")

                    self.hold_priority = YLeaf(YType.int32, "hold-priority")

                    self.hold_priority_xr = YLeaf(YType.uint32, "hold-priority-xr")

                    self.hop_limit = YLeaf(YType.int32, "hop-limit")

                    self.igp_area = YLeaf(YType.int32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.is_full_path = YLeaf(YType.boolean, "is-full-path")

                    self.is_partial_path = YLeaf(YType.boolean, "is-partial-path")

                    self.is_segment_routing_db_checked = YLeaf(YType.boolean, "is-segment-routing-db-checked")

                    self.is_topology_checked = YLeaf(YType.boolean, "is-topology-checked")

                    self.mininum_bandwidth = YLeaf(YType.uint64, "mininum-bandwidth")

                    self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                    self.path_id = YLeaf(YType.int32, "path-id")

                    self.path_name = YLeaf(YType.str, "path-name")

                    self.path_type = YLeaf(YType.enumeration, "path-type")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.int32, "setup-priority")

                    self.setup_priority_xr = YLeaf(YType.uint32, "setup-priority-xr")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.affinity = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"
                    self._children_yang_names.add("affinity")

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accumulated_admin_weight",
                                    "affinity_bits",
                                    "affinity_mask",
                                    "bandwidth",
                                    "bandwidth_type",
                                    "cost_limit",
                                    "destination_address",
                                    "destination_address_xr",
                                    "exclude_srlg_address",
                                    "exclude_srlg_ip_address",
                                    "hold_priority",
                                    "hold_priority_xr",
                                    "hop_limit",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type",
                                    "is_full_path",
                                    "is_partial_path",
                                    "is_segment_routing_db_checked",
                                    "is_topology_checked",
                                    "mininum_bandwidth",
                                    "node_hop_count",
                                    "path_id",
                                    "path_name",
                                    "path_type",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "setup_priority_xr",
                                    "tunnel_id_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Topology.DestinationPaths.DestinationPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Topology.DestinationPaths.DestinationPath, self).__setattr__(name, value)


                class Affinity(Entity):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "destination-path"

                        self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                        self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                        self.named_affinity = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bits",
                                        "affinity_mask") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity, self).__setattr__(name, value)


                    class NamedAffinity(Entity):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"

                            self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                            self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                            self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("constraint_type",
                                            "constraint_value",
                                            "forward_ref_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__setattr__(name, value)


                        class ConstraintExtendedValue(Entity):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "constraint-extended-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class ExtendedForwardRefValue(Entity):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "extended-forward-ref-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.constraint_extended_value:
                                if (c.has_data()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_data()):
                                    return True
                            return (
                                self.constraint_type.is_set or
                                self.constraint_value.is_set or
                                self.forward_ref_value.is_set)

                        def has_operation(self):
                            for c in self.constraint_extended_value:
                                if (c.has_operation()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.constraint_type.yfilter != YFilter.not_set or
                                self.constraint_value.yfilter != YFilter.not_set or
                                self.forward_ref_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "named-affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_type.get_name_leafdata())
                            if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_value.get_name_leafdata())
                            if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "constraint-extended-value"):
                                for c in self.constraint_extended_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.constraint_extended_value.append(c)
                                return c

                            if (child_yang_name == "extended-forward-ref-value"):
                                for c in self.extended_forward_ref_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.extended_forward_ref_value.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "constraint-type"):
                                self.constraint_type = value
                                self.constraint_type.value_namespace = name_space
                                self.constraint_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "constraint-value"):
                                self.constraint_value = value
                                self.constraint_value.value_namespace = name_space
                                self.constraint_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "forward-ref-value"):
                                self.forward_ref_value = value
                                self.forward_ref_value.value_namespace = name_space
                                self.forward_ref_value.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.named_affinity:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bits.is_set or
                            self.affinity_mask.is_set)

                    def has_operation(self):
                        for c in self.named_affinity:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bits.yfilter != YFilter.not_set or
                            self.affinity_mask.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                        if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "named-affinity"):
                            for c in self.named_affinity:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.named_affinity.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bits"):
                            self.affinity_bits = value
                            self.affinity_bits.value_namespace = name_space
                            self.affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-mask"):
                            self.affinity_mask = value
                            self.affinity_mask.value_namespace = name_space
                            self.affinity_mask.value_namespace_prefix = name_space_prefix


                class Hop(Entity):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.DestinationPaths.DestinationPath.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "destination-path"

                        self.entry = YLeaf(YType.str, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.Hop, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.Hop, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hop" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "destination-path"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class SrSegment(Entity):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\:  bool
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\:  bool
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\:  bool
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "destination-path"

                        self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                        self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                        self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                        self.sid_type = YLeaf(YType.enumeration, "sid-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("has_entropy_label",
                                        "has_ip_addresses",
                                        "has_mpls_label",
                                        "local_addr",
                                        "mpls_label_value",
                                        "remote_addr",
                                        "sid_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.has_entropy_label.is_set or
                            self.has_ip_addresses.is_set or
                            self.has_mpls_label.is_set or
                            self.local_addr.is_set or
                            self.mpls_label_value.is_set or
                            self.remote_addr.is_set or
                            self.sid_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.has_entropy_label.yfilter != YFilter.not_set or
                            self.has_ip_addresses.yfilter != YFilter.not_set or
                            self.has_mpls_label.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.mpls_label_value.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set or
                            self.sid_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-segment" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                        if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                        if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())
                        if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sid_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "has-entropy-label"):
                            self.has_entropy_label = value
                            self.has_entropy_label.value_namespace = name_space
                            self.has_entropy_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-ip-addresses"):
                            self.has_ip_addresses = value
                            self.has_ip_addresses.value_namespace = name_space
                            self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-mpls-label"):
                            self.has_mpls_label = value
                            self.has_mpls_label.value_namespace = name_space
                            self.has_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label-value"):
                            self.mpls_label_value = value
                            self.mpls_label_value.value_namespace = name_space
                            self.mpls_label_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sid-type"):
                            self.sid_type = value
                            self.sid_type.value_namespace = name_space
                            self.sid_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.hop:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_data()):
                            return True
                    return (
                        self.accumulated_admin_weight.is_set or
                        self.affinity_bits.is_set or
                        self.affinity_mask.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_type.is_set or
                        self.cost_limit.is_set or
                        self.destination_address.is_set or
                        self.destination_address_xr.is_set or
                        self.exclude_srlg_address.is_set or
                        self.exclude_srlg_ip_address.is_set or
                        self.hold_priority.is_set or
                        self.hold_priority_xr.is_set or
                        self.hop_limit.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set or
                        self.is_full_path.is_set or
                        self.is_partial_path.is_set or
                        self.is_segment_routing_db_checked.is_set or
                        self.is_topology_checked.is_set or
                        self.mininum_bandwidth.is_set or
                        self.node_hop_count.is_set or
                        self.path_id.is_set or
                        self.path_name.is_set or
                        self.path_type.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.setup_priority_xr.is_set or
                        self.tunnel_id_xr.is_set or
                        (self.affinity is not None and self.affinity.has_data()))

                def has_operation(self):
                    for c in self.hop:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accumulated_admin_weight.yfilter != YFilter.not_set or
                        self.affinity_bits.yfilter != YFilter.not_set or
                        self.affinity_mask.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.cost_limit.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.exclude_srlg_address.yfilter != YFilter.not_set or
                        self.exclude_srlg_ip_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.hold_priority_xr.yfilter != YFilter.not_set or
                        self.hop_limit.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set or
                        self.is_full_path.yfilter != YFilter.not_set or
                        self.is_partial_path.yfilter != YFilter.not_set or
                        self.is_segment_routing_db_checked.yfilter != YFilter.not_set or
                        self.is_topology_checked.yfilter != YFilter.not_set or
                        self.mininum_bandwidth.yfilter != YFilter.not_set or
                        self.node_hop_count.yfilter != YFilter.not_set or
                        self.path_id.yfilter != YFilter.not_set or
                        self.path_name.yfilter != YFilter.not_set or
                        self.path_type.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.setup_priority_xr.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        (self.affinity is not None and self.affinity.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "destination-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accumulated_admin_weight.is_set or self.accumulated_admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accumulated_admin_weight.get_name_leafdata())
                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost_limit.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.exclude_srlg_address.is_set or self.exclude_srlg_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_address.get_name_leafdata())
                    if (self.exclude_srlg_ip_address.is_set or self.exclude_srlg_ip_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_ip_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.hold_priority_xr.is_set or self.hold_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority_xr.get_name_leafdata())
                    if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())
                    if (self.is_full_path.is_set or self.is_full_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_full_path.get_name_leafdata())
                    if (self.is_partial_path.is_set or self.is_partial_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_partial_path.get_name_leafdata())
                    if (self.is_segment_routing_db_checked.is_set or self.is_segment_routing_db_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing_db_checked.get_name_leafdata())
                    if (self.is_topology_checked.is_set or self.is_topology_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_topology_checked.get_name_leafdata())
                    if (self.mininum_bandwidth.is_set or self.mininum_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mininum_bandwidth.get_name_leafdata())
                    if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_id.get_name_leafdata())
                    if (self.path_name.is_set or self.path_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_name.get_name_leafdata())
                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_type.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.setup_priority_xr.is_set or self.setup_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority_xr.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity"):
                        if (self.affinity is None):
                            self.affinity = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity()
                            self.affinity.parent = self
                            self._children_name_map["affinity"] = "affinity"
                        return self.affinity

                    if (child_yang_name == "hop"):
                        for c in self.hop:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.DestinationPaths.DestinationPath.Hop()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.hop.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "sr-segment"):
                        for c in self.sr_segment:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.sr_segment.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity" or name == "hop" or name == "shared-risk-link-group" or name == "sr-segment" or name == "accumulated-admin-weight" or name == "affinity-bits" or name == "affinity-mask" or name == "bandwidth" or name == "bandwidth-type" or name == "cost-limit" or name == "destination-address" or name == "destination-address-xr" or name == "exclude-srlg-address" or name == "exclude-srlg-ip-address" or name == "hold-priority" or name == "hold-priority-xr" or name == "hop-limit" or name == "igp-area" or name == "igp-instance" or name == "igp-type" or name == "is-full-path" or name == "is-partial-path" or name == "is-segment-routing-db-checked" or name == "is-topology-checked" or name == "mininum-bandwidth" or name == "node-hop-count" or name == "path-id" or name == "path-name" or name == "path-type" or name == "requested-bandwidth" or name == "setup-priority" or name == "setup-priority-xr" or name == "tunnel-id-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accumulated-admin-weight"):
                        self.accumulated_admin_weight = value
                        self.accumulated_admin_weight.value_namespace = name_space
                        self.accumulated_admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-bits"):
                        self.affinity_bits = value
                        self.affinity_bits.value_namespace = name_space
                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-mask"):
                        self.affinity_mask = value
                        self.affinity_mask.value_namespace = name_space
                        self.affinity_mask.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "cost-limit"):
                        self.cost_limit = value
                        self.cost_limit.value_namespace = name_space
                        self.cost_limit.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-address"):
                        self.exclude_srlg_address = value
                        self.exclude_srlg_address.value_namespace = name_space
                        self.exclude_srlg_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-ip-address"):
                        self.exclude_srlg_ip_address = value
                        self.exclude_srlg_ip_address.value_namespace = name_space
                        self.exclude_srlg_ip_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority-xr"):
                        self.hold_priority_xr = value
                        self.hold_priority_xr.value_namespace = name_space
                        self.hold_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit"):
                        self.hop_limit = value
                        self.hop_limit.value_namespace = name_space
                        self.hop_limit.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-full-path"):
                        self.is_full_path = value
                        self.is_full_path.value_namespace = name_space
                        self.is_full_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-partial-path"):
                        self.is_partial_path = value
                        self.is_partial_path.value_namespace = name_space
                        self.is_partial_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing-db-checked"):
                        self.is_segment_routing_db_checked = value
                        self.is_segment_routing_db_checked.value_namespace = name_space
                        self.is_segment_routing_db_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-topology-checked"):
                        self.is_topology_checked = value
                        self.is_topology_checked.value_namespace = name_space
                        self.is_topology_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "mininum-bandwidth"):
                        self.mininum_bandwidth = value
                        self.mininum_bandwidth.value_namespace = name_space
                        self.mininum_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-hop-count"):
                        self.node_hop_count = value
                        self.node_hop_count.value_namespace = name_space
                        self.node_hop_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-id"):
                        self.path_id = value
                        self.path_id.value_namespace = name_space
                        self.path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-name"):
                        self.path_name = value
                        self.path_name.value_namespace = name_space
                        self.path_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-type"):
                        self.path_type = value
                        self.path_type.value_namespace = name_space
                        self.path_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority-xr"):
                        self.setup_priority_xr = value
                        self.setup_priority_xr.value_namespace = name_space
                        self.setup_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.destination_path:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.destination_path:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "destination-paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "destination-path"):
                    for c in self.destination_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Topology.DestinationPaths.DestinationPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.destination_path.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "destination-path"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ConfiguredSrlgs(Entity):
            """
            Set of configured SRLG
            
            .. attribute:: configured_srlg
            
            	Configured SRLG value and the addresses using it
            	**type**\: list of    :py:class:`ConfiguredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Topology.ConfiguredSrlgs, self).__init__()

                self.yang_name = "configured-srlgs"
                self.yang_parent_name = "topology"

                self.configured_srlg = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Topology.ConfiguredSrlgs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Topology.ConfiguredSrlgs, self).__setattr__(name, value)


            class ConfiguredSrlg(Entity):
                """
                Configured SRLG value and the addresses using
                it
                
                .. attribute:: srlg_number  <key>
                
                	SRLG Number
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_admin_weight_configured
                
                	Set to TRUE if the admin weight is explicitely configured
                	**type**\:  bool
                
                .. attribute:: srlg_link
                
                	Link associated with the SRLG
                	**type**\: list of    :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink>`
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\:  str
                
                .. attribute:: srlg_number_xr
                
                	SRLG number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__init__()

                    self.yang_name = "configured-srlg"
                    self.yang_parent_name = "configured-srlgs"

                    self.srlg_number = YLeaf(YType.int32, "srlg-number")

                    self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                    self.is_admin_weight_configured = YLeaf(YType.boolean, "is-admin-weight-configured")

                    self.srlg_name = YLeaf(YType.str, "srlg-name")

                    self.srlg_number_xr = YLeaf(YType.uint32, "srlg-number-xr")

                    self.srlg_link = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("srlg_number",
                                    "admin_weight",
                                    "is_admin_weight_configured",
                                    "srlg_name",
                                    "srlg_number_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__setattr__(name, value)


                class SrlgLink(Entity):
                    """
                    Link associated with the SRLG
                    
                    .. attribute:: local_address
                    
                    	Local address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_address
                    
                    	Remote address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__init__()

                        self.yang_name = "srlg-link"
                        self.yang_parent_name = "configured-srlg"

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("local_address",
                                        "remote_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.local_address.is_set or
                            self.remote_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "srlg-link" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "local-address" or name == "remote-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.srlg_link:
                        if (c.has_data()):
                            return True
                    return (
                        self.srlg_number.is_set or
                        self.admin_weight.is_set or
                        self.is_admin_weight_configured.is_set or
                        self.srlg_name.is_set or
                        self.srlg_number_xr.is_set)

                def has_operation(self):
                    for c in self.srlg_link:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.srlg_number.yfilter != YFilter.not_set or
                        self.admin_weight.yfilter != YFilter.not_set or
                        self.is_admin_weight_configured.yfilter != YFilter.not_set or
                        self.srlg_name.yfilter != YFilter.not_set or
                        self.srlg_number_xr.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "configured-srlg" + "[srlg-number='" + self.srlg_number.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/configured-srlgs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.srlg_number.is_set or self.srlg_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number.get_name_leafdata())
                    if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_weight.get_name_leafdata())
                    if (self.is_admin_weight_configured.is_set or self.is_admin_weight_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_admin_weight_configured.get_name_leafdata())
                    if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_name.get_name_leafdata())
                    if (self.srlg_number_xr.is_set or self.srlg_number_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "srlg-link"):
                        for c in self.srlg_link:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.srlg_link.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "srlg-link" or name == "srlg-number" or name == "admin-weight" or name == "is-admin-weight-configured" or name == "srlg-name" or name == "srlg-number-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "srlg-number"):
                        self.srlg_number = value
                        self.srlg_number.value_namespace = name_space
                        self.srlg_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-weight"):
                        self.admin_weight = value
                        self.admin_weight.value_namespace = name_space
                        self.admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-admin-weight-configured"):
                        self.is_admin_weight_configured = value
                        self.is_admin_weight_configured.value_namespace = name_space
                        self.is_admin_weight_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-name"):
                        self.srlg_name = value
                        self.srlg_name.value_namespace = name_space
                        self.srlg_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-number-xr"):
                        self.srlg_number_xr = value
                        self.srlg_number_xr.value_namespace = name_space
                        self.srlg_number_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.configured_srlg:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.configured_srlg:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "configured-srlgs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "configured-srlg"):
                    for c in self.configured_srlg:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.configured_srlg.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "configured-srlg"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Srlgs(Entity):
            """
            Set of SRLG operational value for the overall
            MPLS\-TE topology
            
            .. attribute:: srlg
            
            	SRLG operational value for the overall MPLS\-TE topology
            	**type**\: list of    :py:class:`Srlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Topology.Srlgs, self).__init__()

                self.yang_name = "srlgs"
                self.yang_parent_name = "topology"

                self.srlg = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Topology.Srlgs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Topology.Srlgs, self).__setattr__(name, value)


            class Srlg(Entity):
                """
                SRLG operational value for the overall MPLS\-TE
                topology
                
                .. attribute:: srlg_number  <key>
                
                	SRLG Number
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_areas
                
                	Topology areas in this SRLG
                	**type**\: list of    :py:class:`SrlgAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas>`
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Topology.Srlgs.Srlg, self).__init__()

                    self.yang_name = "srlg"
                    self.yang_parent_name = "srlgs"

                    self.srlg_number = YLeaf(YType.int32, "srlg-number")

                    self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                    self.srlg_name = YLeaf(YType.str, "srlg-name")

                    self.srlg_areas = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("srlg_number",
                                    "admin_weight",
                                    "srlg_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Topology.Srlgs.Srlg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Topology.Srlgs.Srlg, self).__setattr__(name, value)


                class SrlgAreas(Entity):
                    """
                    Topology areas in this SRLG
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: igp_instance
                    
                    	IGP Instance name
                    	**type**\:  str
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    .. attribute:: srlg_link
                    
                    	Links in this SRLG/area
                    	**type**\: list of    :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas, self).__init__()

                        self.yang_name = "srlg-areas"
                        self.yang_parent_name = "srlg"

                        self.igp_area = YLeaf(YType.uint32, "igp-area")

                        self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                        self.igp_instance = YLeaf(YType.str, "igp-instance")

                        self.igp_type = YLeaf(YType.enumeration, "igp-type")

                        self.srlg_link = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("igp_area",
                                        "igp_area_format",
                                        "igp_instance",
                                        "igp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas, self).__setattr__(name, value)


                    class SrlgLink(Entity):
                        """
                        Links in this SRLG/area
                        
                        .. attribute:: link_address
                        
                        	Link address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: link_address_generic
                        
                        	Link address
                        	**type**\:   :py:class:`LinkAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric>`
                        
                        .. attribute:: te_router_id
                        
                        	Link TE router\-id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__init__()

                            self.yang_name = "srlg-link"
                            self.yang_parent_name = "srlg-areas"

                            self.link_address = YLeaf(YType.str, "link-address")

                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                            self.link_address_generic = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                            self.link_address_generic.parent = self
                            self._children_name_map["link_address_generic"] = "link-address-generic"
                            self._children_yang_names.add("link-address-generic")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("link_address",
                                            "te_router_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__setattr__(name, value)


                        class LinkAddressGeneric(Entity):
                            """
                            Link address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, self).__init__()

                                self.yang_name = "link-address-generic"
                                self.yang_parent_name = "srlg-link"

                                self.te_addr = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "link-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "link-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.link_address.is_set or
                                self.te_router_id.is_set or
                                (self.link_address_generic is not None and self.link_address_generic.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.link_address.yfilter != YFilter.not_set or
                                self.te_router_id.yfilter != YFilter.not_set or
                                (self.link_address_generic is not None and self.link_address_generic.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlg-link" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_address.get_name_leafdata())
                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "link-address-generic"):
                                if (self.link_address_generic is None):
                                    self.link_address_generic = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                                    self.link_address_generic.parent = self
                                    self._children_name_map["link_address_generic"] = "link-address-generic"
                                return self.link_address_generic

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "link-address-generic" or name == "link-address" or name == "te-router-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "link-address"):
                                self.link_address = value
                                self.link_address.value_namespace = name_space
                                self.link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "te-router-id"):
                                self.te_router_id = value
                                self.te_router_id.value_namespace = name_space
                                self.te_router_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.srlg_link:
                            if (c.has_data()):
                                return True
                        return (
                            self.igp_area.is_set or
                            self.igp_area_format.is_set or
                            self.igp_instance.is_set or
                            self.igp_type.is_set)

                    def has_operation(self):
                        for c in self.srlg_link:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.igp_area.yfilter != YFilter.not_set or
                            self.igp_area_format.yfilter != YFilter.not_set or
                            self.igp_instance.yfilter != YFilter.not_set or
                            self.igp_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "srlg-areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area.get_name_leafdata())
                        if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                        if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_instance.get_name_leafdata())
                        if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "srlg-link"):
                            for c in self.srlg_link:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlg_link.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "srlg-link" or name == "igp-area" or name == "igp-area-format" or name == "igp-instance" or name == "igp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "igp-area"):
                            self.igp_area = value
                            self.igp_area.value_namespace = name_space
                            self.igp_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-format"):
                            self.igp_area_format = value
                            self.igp_area_format.value_namespace = name_space
                            self.igp_area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-instance"):
                            self.igp_instance = value
                            self.igp_instance.value_namespace = name_space
                            self.igp_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-type"):
                            self.igp_type = value
                            self.igp_type.value_namespace = name_space
                            self.igp_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.srlg_areas:
                        if (c.has_data()):
                            return True
                    return (
                        self.srlg_number.is_set or
                        self.admin_weight.is_set or
                        self.srlg_name.is_set)

                def has_operation(self):
                    for c in self.srlg_areas:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.srlg_number.yfilter != YFilter.not_set or
                        self.admin_weight.yfilter != YFilter.not_set or
                        self.srlg_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "srlg" + "[srlg-number='" + self.srlg_number.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/srlgs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.srlg_number.is_set or self.srlg_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number.get_name_leafdata())
                    if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_weight.get_name_leafdata())
                    if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "srlg-areas"):
                        for c in self.srlg_areas:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.Srlgs.Srlg.SrlgAreas()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.srlg_areas.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "srlg-areas" or name == "srlg-number" or name == "admin-weight" or name == "srlg-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "srlg-number"):
                        self.srlg_number = value
                        self.srlg_number.value_namespace = name_space
                        self.srlg_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-weight"):
                        self.admin_weight = value
                        self.admin_weight.value_namespace = name_space
                        self.admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-name"):
                        self.srlg_name = value
                        self.srlg_name.value_namespace = name_space
                        self.srlg_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.srlg:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.srlg:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "srlgs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "srlg"):
                    for c in self.srlg:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Topology.Srlgs.Srlg()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.srlg.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "srlg"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class PathTunnels(Entity):
            """
            MPLS\-Te topology path info
            
            .. attribute:: path_tunnel
            
            	MPLS\-TE topology path taken by the specified tunnel
            	**type**\: list of    :py:class:`PathTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Topology.PathTunnels, self).__init__()

                self.yang_name = "path-tunnels"
                self.yang_parent_name = "topology"

                self.path_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Topology.PathTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Topology.PathTunnels, self).__setattr__(name, value)


            class PathTunnel(Entity):
                """
                MPLS\-TE topology path taken by the specified
                tunnel
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity>`
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of    :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Hop>`
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\:  bool
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\:  bool
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\:  bool
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\:  bool
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup>`
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of    :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.SrSegment>`
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Topology.PathTunnels.PathTunnel, self).__init__()

                    self.yang_name = "path-tunnel"
                    self.yang_parent_name = "path-tunnels"

                    self.accumulated_admin_weight = YLeaf(YType.uint64, "accumulated-admin-weight")

                    self.bandwidth_type = YLeaf(YType.uint64, "bandwidth-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.exclude_srlg_address = YLeaf(YType.str, "exclude-srlg-address")

                    self.hold_priority_xr = YLeaf(YType.uint32, "hold-priority-xr")

                    self.is_full_path = YLeaf(YType.boolean, "is-full-path")

                    self.is_partial_path = YLeaf(YType.boolean, "is-partial-path")

                    self.is_segment_routing_db_checked = YLeaf(YType.boolean, "is-segment-routing-db-checked")

                    self.is_topology_checked = YLeaf(YType.boolean, "is-topology-checked")

                    self.mininum_bandwidth = YLeaf(YType.uint64, "mininum-bandwidth")

                    self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority_xr = YLeaf(YType.uint32, "setup-priority-xr")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.affinity = MplsTe.Topology.PathTunnels.PathTunnel.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"
                    self._children_yang_names.add("affinity")

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accumulated_admin_weight",
                                    "bandwidth_type",
                                    "destination_address_xr",
                                    "exclude_srlg_address",
                                    "hold_priority_xr",
                                    "is_full_path",
                                    "is_partial_path",
                                    "is_segment_routing_db_checked",
                                    "is_topology_checked",
                                    "mininum_bandwidth",
                                    "node_hop_count",
                                    "requested_bandwidth",
                                    "setup_priority_xr",
                                    "tunnel_id",
                                    "tunnel_id_xr",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Topology.PathTunnels.PathTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Topology.PathTunnels.PathTunnel, self).__setattr__(name, value)


                class Affinity(Entity):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "path-tunnel"

                        self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                        self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                        self.named_affinity = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bits",
                                        "affinity_mask") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity, self).__setattr__(name, value)


                    class NamedAffinity(Entity):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"

                            self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                            self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                            self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("constraint_type",
                                            "constraint_value",
                                            "forward_ref_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__setattr__(name, value)


                        class ConstraintExtendedValue(Entity):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "constraint-extended-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class ExtendedForwardRefValue(Entity):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "extended-forward-ref-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.constraint_extended_value:
                                if (c.has_data()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_data()):
                                    return True
                            return (
                                self.constraint_type.is_set or
                                self.constraint_value.is_set or
                                self.forward_ref_value.is_set)

                        def has_operation(self):
                            for c in self.constraint_extended_value:
                                if (c.has_operation()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.constraint_type.yfilter != YFilter.not_set or
                                self.constraint_value.yfilter != YFilter.not_set or
                                self.forward_ref_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "named-affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_type.get_name_leafdata())
                            if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_value.get_name_leafdata())
                            if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "constraint-extended-value"):
                                for c in self.constraint_extended_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.constraint_extended_value.append(c)
                                return c

                            if (child_yang_name == "extended-forward-ref-value"):
                                for c in self.extended_forward_ref_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.extended_forward_ref_value.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "constraint-type"):
                                self.constraint_type = value
                                self.constraint_type.value_namespace = name_space
                                self.constraint_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "constraint-value"):
                                self.constraint_value = value
                                self.constraint_value.value_namespace = name_space
                                self.constraint_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "forward-ref-value"):
                                self.forward_ref_value = value
                                self.forward_ref_value.value_namespace = name_space
                                self.forward_ref_value.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.named_affinity:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bits.is_set or
                            self.affinity_mask.is_set)

                    def has_operation(self):
                        for c in self.named_affinity:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bits.yfilter != YFilter.not_set or
                            self.affinity_mask.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                        if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "named-affinity"):
                            for c in self.named_affinity:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.named_affinity.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bits"):
                            self.affinity_bits = value
                            self.affinity_bits.value_namespace = name_space
                            self.affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-mask"):
                            self.affinity_mask = value
                            self.affinity_mask.value_namespace = name_space
                            self.affinity_mask.value_namespace_prefix = name_space_prefix


                class Hop(Entity):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.PathTunnels.PathTunnel.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "path-tunnel"

                        self.entry = YLeaf(YType.str, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.Hop, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.PathTunnels.PathTunnel.Hop, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hop" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "path-tunnel"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class SrSegment(Entity):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\:  bool
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\:  bool
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\:  bool
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Topology.PathTunnels.PathTunnel.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "path-tunnel"

                        self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                        self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                        self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                        self.sid_type = YLeaf(YType.enumeration, "sid-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("has_entropy_label",
                                        "has_ip_addresses",
                                        "has_mpls_label",
                                        "local_addr",
                                        "mpls_label_value",
                                        "remote_addr",
                                        "sid_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.SrSegment, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Topology.PathTunnels.PathTunnel.SrSegment, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.has_entropy_label.is_set or
                            self.has_ip_addresses.is_set or
                            self.has_mpls_label.is_set or
                            self.local_addr.is_set or
                            self.mpls_label_value.is_set or
                            self.remote_addr.is_set or
                            self.sid_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.has_entropy_label.yfilter != YFilter.not_set or
                            self.has_ip_addresses.yfilter != YFilter.not_set or
                            self.has_mpls_label.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.mpls_label_value.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set or
                            self.sid_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-segment" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                        if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                        if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())
                        if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sid_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "has-entropy-label"):
                            self.has_entropy_label = value
                            self.has_entropy_label.value_namespace = name_space
                            self.has_entropy_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-ip-addresses"):
                            self.has_ip_addresses = value
                            self.has_ip_addresses.value_namespace = name_space
                            self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-mpls-label"):
                            self.has_mpls_label = value
                            self.has_mpls_label.value_namespace = name_space
                            self.has_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label-value"):
                            self.mpls_label_value = value
                            self.mpls_label_value.value_namespace = name_space
                            self.mpls_label_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sid-type"):
                            self.sid_type = value
                            self.sid_type.value_namespace = name_space
                            self.sid_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.hop:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_data()):
                            return True
                    return (
                        self.accumulated_admin_weight.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address_xr.is_set or
                        self.exclude_srlg_address.is_set or
                        self.hold_priority_xr.is_set or
                        self.is_full_path.is_set or
                        self.is_partial_path.is_set or
                        self.is_segment_routing_db_checked.is_set or
                        self.is_topology_checked.is_set or
                        self.mininum_bandwidth.is_set or
                        self.node_hop_count.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority_xr.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_name.is_set or
                        (self.affinity is not None and self.affinity.has_data()))

                def has_operation(self):
                    for c in self.hop:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accumulated_admin_weight.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.exclude_srlg_address.yfilter != YFilter.not_set or
                        self.hold_priority_xr.yfilter != YFilter.not_set or
                        self.is_full_path.yfilter != YFilter.not_set or
                        self.is_partial_path.yfilter != YFilter.not_set or
                        self.is_segment_routing_db_checked.yfilter != YFilter.not_set or
                        self.is_topology_checked.yfilter != YFilter.not_set or
                        self.mininum_bandwidth.yfilter != YFilter.not_set or
                        self.node_hop_count.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority_xr.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.affinity is not None and self.affinity.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-tunnel" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accumulated_admin_weight.is_set or self.accumulated_admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accumulated_admin_weight.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.exclude_srlg_address.is_set or self.exclude_srlg_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_address.get_name_leafdata())
                    if (self.hold_priority_xr.is_set or self.hold_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority_xr.get_name_leafdata())
                    if (self.is_full_path.is_set or self.is_full_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_full_path.get_name_leafdata())
                    if (self.is_partial_path.is_set or self.is_partial_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_partial_path.get_name_leafdata())
                    if (self.is_segment_routing_db_checked.is_set or self.is_segment_routing_db_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing_db_checked.get_name_leafdata())
                    if (self.is_topology_checked.is_set or self.is_topology_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_topology_checked.get_name_leafdata())
                    if (self.mininum_bandwidth.is_set or self.mininum_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mininum_bandwidth.get_name_leafdata())
                    if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority_xr.is_set or self.setup_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority_xr.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity"):
                        if (self.affinity is None):
                            self.affinity = MplsTe.Topology.PathTunnels.PathTunnel.Affinity()
                            self.affinity.parent = self
                            self._children_name_map["affinity"] = "affinity"
                        return self.affinity

                    if (child_yang_name == "hop"):
                        for c in self.hop:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.PathTunnels.PathTunnel.Hop()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.hop.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "sr-segment"):
                        for c in self.sr_segment:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Topology.PathTunnels.PathTunnel.SrSegment()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.sr_segment.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity" or name == "hop" or name == "shared-risk-link-group" or name == "sr-segment" or name == "accumulated-admin-weight" or name == "bandwidth-type" or name == "destination-address-xr" or name == "exclude-srlg-address" or name == "hold-priority-xr" or name == "is-full-path" or name == "is-partial-path" or name == "is-segment-routing-db-checked" or name == "is-topology-checked" or name == "mininum-bandwidth" or name == "node-hop-count" or name == "requested-bandwidth" or name == "setup-priority-xr" or name == "tunnel-id" or name == "tunnel-id-xr" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accumulated-admin-weight"):
                        self.accumulated_admin_weight = value
                        self.accumulated_admin_weight.value_namespace = name_space
                        self.accumulated_admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-address"):
                        self.exclude_srlg_address = value
                        self.exclude_srlg_address.value_namespace = name_space
                        self.exclude_srlg_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority-xr"):
                        self.hold_priority_xr = value
                        self.hold_priority_xr.value_namespace = name_space
                        self.hold_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-full-path"):
                        self.is_full_path = value
                        self.is_full_path.value_namespace = name_space
                        self.is_full_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-partial-path"):
                        self.is_partial_path = value
                        self.is_partial_path.value_namespace = name_space
                        self.is_partial_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing-db-checked"):
                        self.is_segment_routing_db_checked = value
                        self.is_segment_routing_db_checked.value_namespace = name_space
                        self.is_segment_routing_db_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-topology-checked"):
                        self.is_topology_checked = value
                        self.is_topology_checked.value_namespace = name_space
                        self.is_topology_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "mininum-bandwidth"):
                        self.mininum_bandwidth = value
                        self.mininum_bandwidth.value_namespace = name_space
                        self.mininum_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-hop-count"):
                        self.node_hop_count = value
                        self.node_hop_count.value_namespace = name_space
                        self.node_hop_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority-xr"):
                        self.setup_priority_xr = value
                        self.setup_priority_xr.value_namespace = name_space
                        self.setup_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.path_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.path_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "path-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-tunnel"):
                    for c in self.path_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Topology.PathTunnels.PathTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.path_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.configured_srlgs is not None and self.configured_srlgs.has_data()) or
                (self.destination_paths is not None and self.destination_paths.has_data()) or
                (self.global_ is not None and self.global_.has_data()) or
                (self.path_tunnels is not None and self.path_tunnels.has_data()) or
                (self.srlgs is not None and self.srlgs.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.configured_srlgs is not None and self.configured_srlgs.has_operation()) or
                (self.destination_paths is not None and self.destination_paths.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.path_tunnels is not None and self.path_tunnels.has_operation()) or
                (self.srlgs is not None and self.srlgs.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "configured-srlgs"):
                if (self.configured_srlgs is None):
                    self.configured_srlgs = MplsTe.Topology.ConfiguredSrlgs()
                    self.configured_srlgs.parent = self
                    self._children_name_map["configured_srlgs"] = "configured-srlgs"
                return self.configured_srlgs

            if (child_yang_name == "destination-paths"):
                if (self.destination_paths is None):
                    self.destination_paths = MplsTe.Topology.DestinationPaths()
                    self.destination_paths.parent = self
                    self._children_name_map["destination_paths"] = "destination-paths"
                return self.destination_paths

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsTe.Topology.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "path-tunnels"):
                if (self.path_tunnels is None):
                    self.path_tunnels = MplsTe.Topology.PathTunnels()
                    self.path_tunnels.parent = self
                    self._children_name_map["path_tunnels"] = "path-tunnels"
                return self.path_tunnels

            if (child_yang_name == "srlgs"):
                if (self.srlgs is None):
                    self.srlgs = MplsTe.Topology.Srlgs()
                    self.srlgs.parent = self
                    self._children_name_map["srlgs"] = "srlgs"
                return self.srlgs

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "configured-srlgs" or name == "destination-paths" or name == "global" or name == "path-tunnels" or name == "srlgs"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SignallingCounters(Entity):
        """
        TE counters
        
        .. attribute:: head_signalling_counters
        
        	Sig Head Table TE counters
        	**type**\:   :py:class:`HeadSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters>`
        
        .. attribute:: heads_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`HeadsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters>`
        
        .. attribute:: issu
        
        	MPLS TE ISSU counters
        	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Issu>`
        
        .. attribute:: mids_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`MidsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.MidsCounters>`
        
        .. attribute:: remote_signalling_counters
        
        	Sig mid tail Table TE counters
        	**type**\:   :py:class:`RemoteSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters>`
        
        .. attribute:: signalling_summary
        
        	Send\-Recv count summary for TE Signaling
        	**type**\:   :py:class:`SignallingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.SignallingSummary>`
        
        .. attribute:: signallings
        
        	TE counters
        	**type**\:   :py:class:`Signallings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings>`
        
        .. attribute:: tails_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`TailsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.TailsCounters>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.SignallingCounters, self).__init__()

            self.yang_name = "signalling-counters"
            self.yang_parent_name = "mpls-te"

            self.head_signalling_counters = MplsTe.SignallingCounters.HeadSignallingCounters()
            self.head_signalling_counters.parent = self
            self._children_name_map["head_signalling_counters"] = "head-signalling-counters"
            self._children_yang_names.add("head-signalling-counters")

            self.heads_counters = MplsTe.SignallingCounters.HeadsCounters()
            self.heads_counters.parent = self
            self._children_name_map["heads_counters"] = "heads-counters"
            self._children_yang_names.add("heads-counters")

            self.issu = MplsTe.SignallingCounters.Issu()
            self.issu.parent = self
            self._children_name_map["issu"] = "issu"
            self._children_yang_names.add("issu")

            self.mids_counters = MplsTe.SignallingCounters.MidsCounters()
            self.mids_counters.parent = self
            self._children_name_map["mids_counters"] = "mids-counters"
            self._children_yang_names.add("mids-counters")

            self.remote_signalling_counters = MplsTe.SignallingCounters.RemoteSignallingCounters()
            self.remote_signalling_counters.parent = self
            self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"
            self._children_yang_names.add("remote-signalling-counters")

            self.signalling_summary = MplsTe.SignallingCounters.SignallingSummary()
            self.signalling_summary.parent = self
            self._children_name_map["signalling_summary"] = "signalling-summary"
            self._children_yang_names.add("signalling-summary")

            self.signallings = MplsTe.SignallingCounters.Signallings()
            self.signallings.parent = self
            self._children_name_map["signallings"] = "signallings"
            self._children_yang_names.add("signallings")

            self.tails_counters = MplsTe.SignallingCounters.TailsCounters()
            self.tails_counters.parent = self
            self._children_name_map["tails_counters"] = "tails-counters"
            self._children_yang_names.add("tails-counters")


        class Issu(Entity):
            """
            MPLS TE ISSU counters
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp, in seconds, when these statistics are cleared              since 00\:00\:00 UTC, January 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: last_idt_states
            
            	Last IDT States
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: total_deletions
            
            	Total deletions
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_id_ts
            
            	Total IDTs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_nac_ks
            
            	Total NACKs
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_states
            
            	Total states
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.Issu, self).__init__()

                self.yang_name = "issu"
                self.yang_parent_name = "signalling-counters"

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.last_idt_states = YLeaf(YType.uint32, "last-idt-states")

                self.role = YLeaf(YType.enumeration, "role")

                self.total_deletions = YLeaf(YType.uint32, "total-deletions")

                self.total_id_ts = YLeaf(YType.uint32, "total-id-ts")

                self.total_nac_ks = YLeaf(YType.uint64, "total-nac-ks")

                self.total_states = YLeaf(YType.uint32, "total-states")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("last_cleared_timestamp",
                                "last_idt_states",
                                "role",
                                "total_deletions",
                                "total_id_ts",
                                "total_nac_ks",
                                "total_states") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.Issu, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.Issu, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.last_cleared_timestamp.is_set or
                    self.last_idt_states.is_set or
                    self.role.is_set or
                    self.total_deletions.is_set or
                    self.total_id_ts.is_set or
                    self.total_nac_ks.is_set or
                    self.total_states.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    self.last_idt_states.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    self.total_deletions.yfilter != YFilter.not_set or
                    self.total_id_ts.yfilter != YFilter.not_set or
                    self.total_nac_ks.yfilter != YFilter.not_set or
                    self.total_states.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "issu" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())
                if (self.last_idt_states.is_set or self.last_idt_states.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_idt_states.get_name_leafdata())
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())
                if (self.total_deletions.is_set or self.total_deletions.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_deletions.get_name_leafdata())
                if (self.total_id_ts.is_set or self.total_id_ts.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_id_ts.get_name_leafdata())
                if (self.total_nac_ks.is_set or self.total_nac_ks.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_nac_ks.get_name_leafdata())
                if (self.total_states.is_set or self.total_states.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_states.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "last-cleared-timestamp" or name == "last-idt-states" or name == "role" or name == "total-deletions" or name == "total-id-ts" or name == "total-nac-ks" or name == "total-states"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "last-idt-states"):
                    self.last_idt_states = value
                    self.last_idt_states.value_namespace = name_space
                    self.last_idt_states.value_namespace_prefix = name_space_prefix
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix
                if(value_path == "total-deletions"):
                    self.total_deletions = value
                    self.total_deletions.value_namespace = name_space
                    self.total_deletions.value_namespace_prefix = name_space_prefix
                if(value_path == "total-id-ts"):
                    self.total_id_ts = value
                    self.total_id_ts.value_namespace = name_space
                    self.total_id_ts.value_namespace_prefix = name_space_prefix
                if(value_path == "total-nac-ks"):
                    self.total_nac_ks = value
                    self.total_nac_ks.value_namespace = name_space
                    self.total_nac_ks.value_namespace_prefix = name_space_prefix
                if(value_path == "total-states"):
                    self.total_states = value
                    self.total_states.value_namespace = name_space
                    self.total_states.value_namespace_prefix = name_space_prefix


        class HeadsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: heads_counter
            
            	MPLS TE counters signalling head
            	**type**\: list of    :py:class:`HeadsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.HeadsCounters, self).__init__()

                self.yang_name = "heads-counters"
                self.yang_parent_name = "signalling-counters"

                self.heads_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.HeadsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.HeadsCounters, self).__setattr__(name, value)


            class HeadsCounter(Entity):
                """
                MPLS TE counters signalling head
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter, self).__init__()

                    self.yang_name = "heads-counter"
                    self.yang_parent_name = "heads-counters"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                    self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.destination_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "tunnel_name",
                                    "tunnel_sig_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    VIF stats
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "heads-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class DestinationStatistic(Entity):
                    """
                    List of Destination Stats
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic>`
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "heads-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.s2l_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        Destination stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                    class S2LStatistic(Entity):
                        """
                        List of S2L Stats
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics>`
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                            self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                            self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "sub_group_id",
                                            "sub_group_originator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            S2L stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.sub_group_id.is_set or
                                self.sub_group_originator.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.sub_group_id.yfilter != YFilter.not_set or
                                self.sub_group_originator.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                            if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-id"):
                                self.sub_group_id = value
                                self.sub_group_id.value_namespace = name_space
                                self.sub_group_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-originator"):
                                self.sub_group_originator = value
                                self.sub_group_originator.value_namespace = name_space
                                self.sub_group_originator.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.destination_address.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        for c in self.s2l_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-statistic"):
                            for c in self.s2l_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_statistic.append(c)
                            return c

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_sig_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.destination_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_sig_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "heads-counter" + "[tunnel-id='" + self.tunnel_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/heads-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "destination-statistic"):
                        for c in self.destination_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "destination-statistic" or name == "statistics" or name == "tunnel-id" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-sig-name"):
                        self.tunnel_sig_name = value
                        self.tunnel_sig_name.value_namespace = name_space
                        self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.heads_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.heads_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "heads-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "heads-counter"):
                    for c in self.heads_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.HeadsCounters.HeadsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.heads_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "heads-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class MidsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: mids_counter
            
            	MPLS TE counters signalling mid
            	**type**\: list of    :py:class:`MidsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.MidsCounters.MidsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.MidsCounters, self).__init__()

                self.yang_name = "mids-counters"
                self.yang_parent_name = "signalling-counters"

                self.mids_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.MidsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.MidsCounters, self).__setattr__(name, value)


            class MidsCounter(Entity):
                """
                MPLS TE counters signalling mid
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.MidsCounters.MidsCounter, self).__init__()

                    self.yang_name = "mids-counter"
                    self.yang_parent_name = "mids-counters"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.MidsCounters.MidsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.MidsCounters.MidsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "mids-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "mids-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "mids-counter" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/mids-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.SignallingCounters.MidsCounters.MidsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.mids_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.mids_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "mids-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "mids-counter"):
                    for c in self.mids_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.MidsCounters.MidsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.mids_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "mids-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class HeadSignallingCounters(Entity):
            """
            Sig Head Table TE counters
            
            .. attribute:: head_signalling_counter
            
            	TE stats
            	**type**\: list of    :py:class:`HeadSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.HeadSignallingCounters, self).__init__()

                self.yang_name = "head-signalling-counters"
                self.yang_parent_name = "signalling-counters"

                self.head_signalling_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.HeadSignallingCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.HeadSignallingCounters, self).__setattr__(name, value)


            class HeadSignallingCounter(Entity):
                """
                TE stats
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__init__()

                    self.yang_name = "head-signalling-counter"
                    self.yang_parent_name = "head-signalling-counters"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                    self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.destination_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "lsp_id",
                                    "tunnel_name",
                                    "tunnel_sig_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    VIF stats
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "head-signalling-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class DestinationStatistic(Entity):
                    """
                    List of Destination Stats
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic>`
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "head-signalling-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.s2l_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        Destination stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                    class S2LStatistic(Entity):
                        """
                        List of S2L Stats
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics>`
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                            self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                            self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "sub_group_id",
                                            "sub_group_originator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            S2L stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.sub_group_id.is_set or
                                self.sub_group_originator.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.sub_group_id.yfilter != YFilter.not_set or
                                self.sub_group_originator.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                            if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-id"):
                                self.sub_group_id = value
                                self.sub_group_id.value_namespace = name_space
                                self.sub_group_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-originator"):
                                self.sub_group_originator = value
                                self.sub_group_originator.value_namespace = name_space
                                self.sub_group_originator.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.destination_address.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        for c in self.s2l_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-statistic"):
                            for c in self.s2l_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_statistic.append(c)
                            return c

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_sig_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.destination_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_sig_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "head-signalling-counter" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/head-signalling-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "destination-statistic"):
                        for c in self.destination_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "destination-statistic" or name == "statistics" or name == "ctype" or name == "tunnel-id" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-sig-name"):
                        self.tunnel_sig_name = value
                        self.tunnel_sig_name.value_namespace = name_space
                        self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.head_signalling_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.head_signalling_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "head-signalling-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "head-signalling-counter"):
                    for c in self.head_signalling_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.head_signalling_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-signalling-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RemoteSignallingCounters(Entity):
            """
            Sig mid tail Table TE counters
            
            .. attribute:: remote_signalling_counter
            
            	TE stats
            	**type**\: list of    :py:class:`RemoteSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.RemoteSignallingCounters, self).__init__()

                self.yang_name = "remote-signalling-counters"
                self.yang_parent_name = "signalling-counters"

                self.remote_signalling_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.RemoteSignallingCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.RemoteSignallingCounters, self).__setattr__(name, value)


            class RemoteSignallingCounter(Entity):
                """
                TE stats
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup originator
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__init__()

                    self.yang_name = "remote-signalling-counter"
                    self.yang_parent_name = "remote-signalling-counters"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "p2mp_id",
                                    "lsp_id",
                                    "source_address",
                                    "destination_address",
                                    "sub_group_originator",
                                    "sub_group_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "remote-signalling-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "remote-signalling-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.p2mp_id.is_set or
                        self.lsp_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.sub_group_originator.is_set or
                        self.sub_group_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "remote-signalling-counter" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/remote-signalling-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "ctype" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "p2mp-id" or name == "lsp-id" or name == "source-address" or name == "destination-address" or name == "sub-group-originator" or name == "sub-group-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.remote_signalling_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.remote_signalling_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "remote-signalling-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "remote-signalling-counter"):
                    for c in self.remote_signalling_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.remote_signalling_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "remote-signalling-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TailsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: tails_counter
            
            	MPLS TE counters signalling mid
            	**type**\: list of    :py:class:`TailsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.TailsCounters.TailsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.TailsCounters, self).__init__()

                self.yang_name = "tails-counters"
                self.yang_parent_name = "signalling-counters"

                self.tails_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.TailsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.TailsCounters, self).__setattr__(name, value)


            class TailsCounter(Entity):
                """
                MPLS TE counters signalling mid
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.TailsCounters.TailsCounter, self).__init__()

                    self.yang_name = "tails-counter"
                    self.yang_parent_name = "tails-counters"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.TailsCounters.TailsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.TailsCounters.TailsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "tails-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "tails-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tails-counter" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/tails-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.SignallingCounters.TailsCounters.TailsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tails_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tails_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tails-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tails-counter"):
                    for c in self.tails_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.TailsCounters.TailsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tails_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tails-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Signallings(Entity):
            """
            TE counters
            
            .. attribute:: signalling
            
            	TE Sig
            	**type**\: list of    :py:class:`Signalling <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.Signallings, self).__init__()

                self.yang_name = "signallings"
                self.yang_parent_name = "signalling-counters"

                self.signalling = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.Signallings, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.Signallings, self).__setattr__(name, value)


            class Signalling(Entity):
                """
                TE Sig
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup originator
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: te_signalling_filter_data
                
                	TE Signaling Filter data
                	**type**\:   :py:class:`TeSignallingFilterData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.SignallingCounters.Signallings.Signalling, self).__init__()

                    self.yang_name = "signalling"
                    self.yang_parent_name = "signallings"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.te_signalling_filter_data = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                    self.te_signalling_filter_data.parent = self
                    self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                    self._children_yang_names.add("te-signalling-filter-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "p2mp_id",
                                    "lsp_id",
                                    "source_address",
                                    "destination_address",
                                    "sub_group_originator",
                                    "sub_group_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.SignallingCounters.Signallings.Signalling, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.SignallingCounters.Signallings.Signalling, self).__setattr__(name, value)


                class TeSignallingFilterData(Entity):
                    """
                    TE Signaling Filter data
                    
                    .. attribute:: statistics_filter
                    
                    	StatisticsFilter
                    	**type**\:   :py:class:`TeStatsSigFilter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeStatsSigFilter>`
                    
                    .. attribute:: te_signalling_filter_lsp
                    
                    	LSP data
                    	**type**\:   :py:class:`TeSignallingFilterLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp>`
                    
                    .. attribute:: te_signalling_filter_vif
                    
                    	VIF data
                    	**type**\:   :py:class:`TeSignallingFilterVif <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__init__()

                        self.yang_name = "te-signalling-filter-data"
                        self.yang_parent_name = "signalling"

                        self.statistics_filter = YLeaf(YType.enumeration, "statistics-filter")

                        self.te_signalling_filter_lsp = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                        self.te_signalling_filter_lsp.parent = self
                        self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                        self._children_yang_names.add("te-signalling-filter-lsp")

                        self.te_signalling_filter_vif = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                        self.te_signalling_filter_vif.parent = self
                        self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"
                        self._children_yang_names.add("te-signalling-filter-vif")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("statistics_filter") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__setattr__(name, value)


                    class TeSignallingFilterVif(Entity):
                        """
                        VIF data
                        
                        .. attribute:: destination_statistic
                        
                        	List of Destination Stats
                        	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic>`
                        
                        .. attribute:: lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: statistics
                        
                        	VIF stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\:  str
                        
                        .. attribute:: tunnel_sig_name
                        
                        	Tunnel Signalled\-Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__init__()

                            self.yang_name = "te-signalling-filter-vif"
                            self.yang_parent_name = "te-signalling-filter-data"

                            self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                            self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                            self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                            self.destination_statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_id",
                                            "tunnel_name",
                                            "tunnel_sig_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            VIF stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-vif"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                        class DestinationStatistic(Entity):
                            """
                            List of Destination Stats
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_statistic
                            
                            	List of S2L Stats
                            	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic>`
                            
                            .. attribute:: statistics
                            
                            	Destination stats
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__init__()

                                self.yang_name = "destination-statistic"
                                self.yang_parent_name = "te-signalling-filter-vif"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")

                                self.s2l_statistic = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__setattr__(name, value)


                            class Statistics(Entity):
                                """
                                Destination stats
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "destination-statistic"

                                    self.events_count = YLeaf(YType.uint32, "events-count")

                                    self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                    self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                    self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                    self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                    self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                    self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                    self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                    self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                    self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                    self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                    self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                    self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                    self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                    self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                    self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                    self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                    self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                    self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                    self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                    self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                    self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                    self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                    self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("events_count",
                                                    "events_total_count",
                                                    "rx_backup_assign_err_event",
                                                    "rx_event_unknown",
                                                    "rx_path_change_event",
                                                    "rx_path_create_event",
                                                    "rx_path_delete_event",
                                                    "rx_path_error_event",
                                                    "rx_path_reeval_query_event",
                                                    "rx_resv_change_event",
                                                    "rx_resv_create_event",
                                                    "rx_resv_delete_event",
                                                    "rx_resv_error_event",
                                                    "tx_backup_assign_event",
                                                    "tx_event_unknown",
                                                    "tx_path_change_event",
                                                    "tx_path_create_event",
                                                    "tx_path_delete_event",
                                                    "tx_path_error_event",
                                                    "tx_path_reeval_query_event",
                                                    "tx_resv_change_event",
                                                    "tx_resv_create_event",
                                                    "tx_resv_delete_event",
                                                    "tx_resv_error_event") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.events_count.is_set or
                                        self.events_total_count.is_set or
                                        self.rx_backup_assign_err_event.is_set or
                                        self.rx_event_unknown.is_set or
                                        self.rx_path_change_event.is_set or
                                        self.rx_path_create_event.is_set or
                                        self.rx_path_delete_event.is_set or
                                        self.rx_path_error_event.is_set or
                                        self.rx_path_reeval_query_event.is_set or
                                        self.rx_resv_change_event.is_set or
                                        self.rx_resv_create_event.is_set or
                                        self.rx_resv_delete_event.is_set or
                                        self.rx_resv_error_event.is_set or
                                        self.tx_backup_assign_event.is_set or
                                        self.tx_event_unknown.is_set or
                                        self.tx_path_change_event.is_set or
                                        self.tx_path_create_event.is_set or
                                        self.tx_path_delete_event.is_set or
                                        self.tx_path_error_event.is_set or
                                        self.tx_path_reeval_query_event.is_set or
                                        self.tx_resv_change_event.is_set or
                                        self.tx_resv_create_event.is_set or
                                        self.tx_resv_delete_event.is_set or
                                        self.tx_resv_error_event.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.events_count.yfilter != YFilter.not_set or
                                        self.events_total_count.yfilter != YFilter.not_set or
                                        self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                        self.rx_event_unknown.yfilter != YFilter.not_set or
                                        self.rx_path_change_event.yfilter != YFilter.not_set or
                                        self.rx_path_create_event.yfilter != YFilter.not_set or
                                        self.rx_path_delete_event.yfilter != YFilter.not_set or
                                        self.rx_path_error_event.yfilter != YFilter.not_set or
                                        self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.rx_resv_change_event.yfilter != YFilter.not_set or
                                        self.rx_resv_create_event.yfilter != YFilter.not_set or
                                        self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.rx_resv_error_event.yfilter != YFilter.not_set or
                                        self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                        self.tx_event_unknown.yfilter != YFilter.not_set or
                                        self.tx_path_change_event.yfilter != YFilter.not_set or
                                        self.tx_path_create_event.yfilter != YFilter.not_set or
                                        self.tx_path_delete_event.yfilter != YFilter.not_set or
                                        self.tx_path_error_event.yfilter != YFilter.not_set or
                                        self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.tx_resv_change_event.yfilter != YFilter.not_set or
                                        self.tx_resv_create_event.yfilter != YFilter.not_set or
                                        self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.tx_resv_error_event.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_count.get_name_leafdata())
                                    if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                    if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                    if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                    if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                    if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                    if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                    if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                    if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                    if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                    if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                    if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                    if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                    if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                    if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                    if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                    if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                    if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                    if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                    if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                    if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                    if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                    if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                    if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "events-count"):
                                        self.events_count = value
                                        self.events_count.value_namespace = name_space
                                        self.events_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "events-total-count"):
                                        self.events_total_count = value
                                        self.events_total_count.value_namespace = name_space
                                        self.events_total_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-backup-assign-err-event"):
                                        self.rx_backup_assign_err_event = value
                                        self.rx_backup_assign_err_event.value_namespace = name_space
                                        self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-event-unknown"):
                                        self.rx_event_unknown = value
                                        self.rx_event_unknown.value_namespace = name_space
                                        self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-change-event"):
                                        self.rx_path_change_event = value
                                        self.rx_path_change_event.value_namespace = name_space
                                        self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-create-event"):
                                        self.rx_path_create_event = value
                                        self.rx_path_create_event.value_namespace = name_space
                                        self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-delete-event"):
                                        self.rx_path_delete_event = value
                                        self.rx_path_delete_event.value_namespace = name_space
                                        self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-error-event"):
                                        self.rx_path_error_event = value
                                        self.rx_path_error_event.value_namespace = name_space
                                        self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-reeval-query-event"):
                                        self.rx_path_reeval_query_event = value
                                        self.rx_path_reeval_query_event.value_namespace = name_space
                                        self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-change-event"):
                                        self.rx_resv_change_event = value
                                        self.rx_resv_change_event.value_namespace = name_space
                                        self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-create-event"):
                                        self.rx_resv_create_event = value
                                        self.rx_resv_create_event.value_namespace = name_space
                                        self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-delete-event"):
                                        self.rx_resv_delete_event = value
                                        self.rx_resv_delete_event.value_namespace = name_space
                                        self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-error-event"):
                                        self.rx_resv_error_event = value
                                        self.rx_resv_error_event.value_namespace = name_space
                                        self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-backup-assign-event"):
                                        self.tx_backup_assign_event = value
                                        self.tx_backup_assign_event.value_namespace = name_space
                                        self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-event-unknown"):
                                        self.tx_event_unknown = value
                                        self.tx_event_unknown.value_namespace = name_space
                                        self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-change-event"):
                                        self.tx_path_change_event = value
                                        self.tx_path_change_event.value_namespace = name_space
                                        self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-create-event"):
                                        self.tx_path_create_event = value
                                        self.tx_path_create_event.value_namespace = name_space
                                        self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-delete-event"):
                                        self.tx_path_delete_event = value
                                        self.tx_path_delete_event.value_namespace = name_space
                                        self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-error-event"):
                                        self.tx_path_error_event = value
                                        self.tx_path_error_event.value_namespace = name_space
                                        self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-reeval-query-event"):
                                        self.tx_path_reeval_query_event = value
                                        self.tx_path_reeval_query_event.value_namespace = name_space
                                        self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-change-event"):
                                        self.tx_resv_change_event = value
                                        self.tx_resv_change_event.value_namespace = name_space
                                        self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-create-event"):
                                        self.tx_resv_create_event = value
                                        self.tx_resv_create_event.value_namespace = name_space
                                        self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-delete-event"):
                                        self.tx_resv_delete_event = value
                                        self.tx_resv_delete_event.value_namespace = name_space
                                        self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-error-event"):
                                        self.tx_resv_error_event = value
                                        self.tx_resv_error_event.value_namespace = name_space
                                        self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                            class S2LStatistic(Entity):
                                """
                                List of S2L Stats
                                
                                .. attribute:: destination_address
                                
                                	Destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: statistics
                                
                                	S2L stats
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics>`
                                
                                .. attribute:: sub_group_id
                                
                                	subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_group_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__init__()

                                    self.yang_name = "s2l-statistic"
                                    self.yang_parent_name = "destination-statistic"

                                    self.destination_address = YLeaf(YType.str, "destination-address")

                                    self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                                    self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_address",
                                                    "sub_group_id",
                                                    "sub_group_originator") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                                class Statistics(Entity):
                                    """
                                    S2L stats
                                    
                                    .. attribute:: events_count
                                    
                                    	TE Signaling event count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: events_total_count
                                    
                                    	Total TE Signalling event count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_backup_assign_err_event
                                    
                                    	Error on Backup Assign event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_event_unknown
                                    
                                    	RX Unknown events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_change_event
                                    
                                    	RX Path Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_create_event
                                    
                                    	RX Path Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_delete_event
                                    
                                    	RX Path Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_error_event
                                    
                                    	RX Path Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_reeval_query_event
                                    
                                    	RX Path Reeval Query event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_change_event
                                    
                                    	RX Resv Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_create_event
                                    
                                    	RX Resv Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_delete_event
                                    
                                    	RX Resv Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_error_event
                                    
                                    	RX Resv Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_backup_assign_event
                                    
                                    	Backup Assign event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_event_unknown
                                    
                                    	Unknown TX events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_change_event
                                    
                                    	TX Path Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_create_event
                                    
                                    	TX Path Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_delete_event
                                    
                                    	TX Path Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_error_event
                                    
                                    	TX Path Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_reeval_query_event
                                    
                                    	TX Path Reeval Query event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_change_event
                                    
                                    	TX Resv Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_create_event
                                    
                                    	TX Resv Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_delete_event
                                    
                                    	TX Resv Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_error_event
                                    
                                    	TX Resv Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "s2l-statistic"

                                        self.events_count = YLeaf(YType.uint32, "events-count")

                                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("events_count",
                                                        "events_total_count",
                                                        "rx_backup_assign_err_event",
                                                        "rx_event_unknown",
                                                        "rx_path_change_event",
                                                        "rx_path_create_event",
                                                        "rx_path_delete_event",
                                                        "rx_path_error_event",
                                                        "rx_path_reeval_query_event",
                                                        "rx_resv_change_event",
                                                        "rx_resv_create_event",
                                                        "rx_resv_delete_event",
                                                        "rx_resv_error_event",
                                                        "tx_backup_assign_event",
                                                        "tx_event_unknown",
                                                        "tx_path_change_event",
                                                        "tx_path_create_event",
                                                        "tx_path_delete_event",
                                                        "tx_path_error_event",
                                                        "tx_path_reeval_query_event",
                                                        "tx_resv_change_event",
                                                        "tx_resv_create_event",
                                                        "tx_resv_delete_event",
                                                        "tx_resv_error_event") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.events_count.is_set or
                                            self.events_total_count.is_set or
                                            self.rx_backup_assign_err_event.is_set or
                                            self.rx_event_unknown.is_set or
                                            self.rx_path_change_event.is_set or
                                            self.rx_path_create_event.is_set or
                                            self.rx_path_delete_event.is_set or
                                            self.rx_path_error_event.is_set or
                                            self.rx_path_reeval_query_event.is_set or
                                            self.rx_resv_change_event.is_set or
                                            self.rx_resv_create_event.is_set or
                                            self.rx_resv_delete_event.is_set or
                                            self.rx_resv_error_event.is_set or
                                            self.tx_backup_assign_event.is_set or
                                            self.tx_event_unknown.is_set or
                                            self.tx_path_change_event.is_set or
                                            self.tx_path_create_event.is_set or
                                            self.tx_path_delete_event.is_set or
                                            self.tx_path_error_event.is_set or
                                            self.tx_path_reeval_query_event.is_set or
                                            self.tx_resv_change_event.is_set or
                                            self.tx_resv_create_event.is_set or
                                            self.tx_resv_delete_event.is_set or
                                            self.tx_resv_error_event.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.events_count.yfilter != YFilter.not_set or
                                            self.events_total_count.yfilter != YFilter.not_set or
                                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                            self.rx_event_unknown.yfilter != YFilter.not_set or
                                            self.rx_path_change_event.yfilter != YFilter.not_set or
                                            self.rx_path_create_event.yfilter != YFilter.not_set or
                                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                                            self.rx_path_error_event.yfilter != YFilter.not_set or
                                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                            self.tx_event_unknown.yfilter != YFilter.not_set or
                                            self.tx_path_change_event.yfilter != YFilter.not_set or
                                            self.tx_path_create_event.yfilter != YFilter.not_set or
                                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                                            self.tx_path_error_event.yfilter != YFilter.not_set or
                                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.events_count.get_name_leafdata())
                                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "events-count"):
                                            self.events_count = value
                                            self.events_count.value_namespace = name_space
                                            self.events_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "events-total-count"):
                                            self.events_total_count = value
                                            self.events_total_count.value_namespace = name_space
                                            self.events_total_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-backup-assign-err-event"):
                                            self.rx_backup_assign_err_event = value
                                            self.rx_backup_assign_err_event.value_namespace = name_space
                                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-event-unknown"):
                                            self.rx_event_unknown = value
                                            self.rx_event_unknown.value_namespace = name_space
                                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-change-event"):
                                            self.rx_path_change_event = value
                                            self.rx_path_change_event.value_namespace = name_space
                                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-create-event"):
                                            self.rx_path_create_event = value
                                            self.rx_path_create_event.value_namespace = name_space
                                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-delete-event"):
                                            self.rx_path_delete_event = value
                                            self.rx_path_delete_event.value_namespace = name_space
                                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-error-event"):
                                            self.rx_path_error_event = value
                                            self.rx_path_error_event.value_namespace = name_space
                                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-reeval-query-event"):
                                            self.rx_path_reeval_query_event = value
                                            self.rx_path_reeval_query_event.value_namespace = name_space
                                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-change-event"):
                                            self.rx_resv_change_event = value
                                            self.rx_resv_change_event.value_namespace = name_space
                                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-create-event"):
                                            self.rx_resv_create_event = value
                                            self.rx_resv_create_event.value_namespace = name_space
                                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-delete-event"):
                                            self.rx_resv_delete_event = value
                                            self.rx_resv_delete_event.value_namespace = name_space
                                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-error-event"):
                                            self.rx_resv_error_event = value
                                            self.rx_resv_error_event.value_namespace = name_space
                                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-backup-assign-event"):
                                            self.tx_backup_assign_event = value
                                            self.tx_backup_assign_event.value_namespace = name_space
                                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-event-unknown"):
                                            self.tx_event_unknown = value
                                            self.tx_event_unknown.value_namespace = name_space
                                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-change-event"):
                                            self.tx_path_change_event = value
                                            self.tx_path_change_event.value_namespace = name_space
                                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-create-event"):
                                            self.tx_path_create_event = value
                                            self.tx_path_create_event.value_namespace = name_space
                                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-delete-event"):
                                            self.tx_path_delete_event = value
                                            self.tx_path_delete_event.value_namespace = name_space
                                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-error-event"):
                                            self.tx_path_error_event = value
                                            self.tx_path_error_event.value_namespace = name_space
                                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-reeval-query-event"):
                                            self.tx_path_reeval_query_event = value
                                            self.tx_path_reeval_query_event.value_namespace = name_space
                                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-change-event"):
                                            self.tx_resv_change_event = value
                                            self.tx_resv_change_event.value_namespace = name_space
                                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-create-event"):
                                            self.tx_resv_create_event = value
                                            self.tx_resv_create_event.value_namespace = name_space
                                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-delete-event"):
                                            self.tx_resv_delete_event = value
                                            self.tx_resv_delete_event.value_namespace = name_space
                                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-error-event"):
                                            self.tx_resv_error_event = value
                                            self.tx_resv_error_event.value_namespace = name_space
                                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_address.is_set or
                                        self.sub_group_id.is_set or
                                        self.sub_group_originator.is_set or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_address.yfilter != YFilter.not_set or
                                        self.sub_group_id.yfilter != YFilter.not_set or
                                        self.sub_group_originator.yfilter != YFilter.not_set or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-statistic" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-address"):
                                        self.destination_address = value
                                        self.destination_address.value_namespace = name_space
                                        self.destination_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-group-id"):
                                        self.sub_group_id = value
                                        self.sub_group_id.value_namespace = name_space
                                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-group-originator"):
                                        self.sub_group_originator = value
                                        self.sub_group_originator.value_namespace = name_space
                                        self.sub_group_originator.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_statistic:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.destination_address.is_set or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                for c in self.s2l_statistic:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "destination-statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-statistic"):
                                    for c in self.s2l_statistic:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_statistic.append(c)
                                    return c

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.destination_statistic:
                                if (c.has_data()):
                                    return True
                            return (
                                self.lsp_id.is_set or
                                self.tunnel_name.is_set or
                                self.tunnel_sig_name.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            for c in self.destination_statistic:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set or
                                self.tunnel_sig_name.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "te-signalling-filter-vif" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                            if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "destination-statistic"):
                                for c in self.destination_statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.destination_statistic.append(c)
                                return c

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-statistic" or name == "statistics" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-sig-name"):
                                self.tunnel_sig_name = value
                                self.tunnel_sig_name.value_namespace = name_space
                                self.tunnel_sig_name.value_namespace_prefix = name_space_prefix


                    class TeSignallingFilterLsp(Entity):
                        """
                        LSP data
                        
                        .. attribute:: s2l_statistic
                        
                        	List of S2L Statistics
                        	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic>`
                        
                        .. attribute:: statistics
                        
                        	LSP statistics
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__init__()

                            self.yang_name = "te-signalling-filter-lsp"
                            self.yang_parent_name = "te-signalling-filter-data"

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                            self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                            self.s2l_statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            LSP statistics
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-lsp"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                        class S2LStatistic(Entity):
                            """
                            List of S2L Statistics
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: statistics
                            
                            	S2L stats
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics>`
                            
                            .. attribute:: sub_group_id
                            
                            	subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_group_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__init__()

                                self.yang_name = "s2l-statistic"
                                self.yang_parent_name = "te-signalling-filter-lsp"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                                self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                                self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address",
                                                "sub_group_id",
                                                "sub_group_originator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__setattr__(name, value)


                            class Statistics(Entity):
                                """
                                S2L stats
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "s2l-statistic"

                                    self.events_count = YLeaf(YType.uint32, "events-count")

                                    self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                    self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                    self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                    self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                    self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                    self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                    self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                    self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                    self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                    self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                    self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                    self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                    self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                    self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                    self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                    self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                    self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                    self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                    self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                    self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                    self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                    self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                    self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("events_count",
                                                    "events_total_count",
                                                    "rx_backup_assign_err_event",
                                                    "rx_event_unknown",
                                                    "rx_path_change_event",
                                                    "rx_path_create_event",
                                                    "rx_path_delete_event",
                                                    "rx_path_error_event",
                                                    "rx_path_reeval_query_event",
                                                    "rx_resv_change_event",
                                                    "rx_resv_create_event",
                                                    "rx_resv_delete_event",
                                                    "rx_resv_error_event",
                                                    "tx_backup_assign_event",
                                                    "tx_event_unknown",
                                                    "tx_path_change_event",
                                                    "tx_path_create_event",
                                                    "tx_path_delete_event",
                                                    "tx_path_error_event",
                                                    "tx_path_reeval_query_event",
                                                    "tx_resv_change_event",
                                                    "tx_resv_create_event",
                                                    "tx_resv_delete_event",
                                                    "tx_resv_error_event") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.events_count.is_set or
                                        self.events_total_count.is_set or
                                        self.rx_backup_assign_err_event.is_set or
                                        self.rx_event_unknown.is_set or
                                        self.rx_path_change_event.is_set or
                                        self.rx_path_create_event.is_set or
                                        self.rx_path_delete_event.is_set or
                                        self.rx_path_error_event.is_set or
                                        self.rx_path_reeval_query_event.is_set or
                                        self.rx_resv_change_event.is_set or
                                        self.rx_resv_create_event.is_set or
                                        self.rx_resv_delete_event.is_set or
                                        self.rx_resv_error_event.is_set or
                                        self.tx_backup_assign_event.is_set or
                                        self.tx_event_unknown.is_set or
                                        self.tx_path_change_event.is_set or
                                        self.tx_path_create_event.is_set or
                                        self.tx_path_delete_event.is_set or
                                        self.tx_path_error_event.is_set or
                                        self.tx_path_reeval_query_event.is_set or
                                        self.tx_resv_change_event.is_set or
                                        self.tx_resv_create_event.is_set or
                                        self.tx_resv_delete_event.is_set or
                                        self.tx_resv_error_event.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.events_count.yfilter != YFilter.not_set or
                                        self.events_total_count.yfilter != YFilter.not_set or
                                        self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                        self.rx_event_unknown.yfilter != YFilter.not_set or
                                        self.rx_path_change_event.yfilter != YFilter.not_set or
                                        self.rx_path_create_event.yfilter != YFilter.not_set or
                                        self.rx_path_delete_event.yfilter != YFilter.not_set or
                                        self.rx_path_error_event.yfilter != YFilter.not_set or
                                        self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.rx_resv_change_event.yfilter != YFilter.not_set or
                                        self.rx_resv_create_event.yfilter != YFilter.not_set or
                                        self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.rx_resv_error_event.yfilter != YFilter.not_set or
                                        self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                        self.tx_event_unknown.yfilter != YFilter.not_set or
                                        self.tx_path_change_event.yfilter != YFilter.not_set or
                                        self.tx_path_create_event.yfilter != YFilter.not_set or
                                        self.tx_path_delete_event.yfilter != YFilter.not_set or
                                        self.tx_path_error_event.yfilter != YFilter.not_set or
                                        self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.tx_resv_change_event.yfilter != YFilter.not_set or
                                        self.tx_resv_create_event.yfilter != YFilter.not_set or
                                        self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.tx_resv_error_event.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_count.get_name_leafdata())
                                    if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                    if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                    if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                    if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                    if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                    if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                    if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                    if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                    if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                    if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                    if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                    if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                    if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                    if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                    if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                    if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                    if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                    if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                    if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                    if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                    if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                    if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                    if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "events-count"):
                                        self.events_count = value
                                        self.events_count.value_namespace = name_space
                                        self.events_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "events-total-count"):
                                        self.events_total_count = value
                                        self.events_total_count.value_namespace = name_space
                                        self.events_total_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-backup-assign-err-event"):
                                        self.rx_backup_assign_err_event = value
                                        self.rx_backup_assign_err_event.value_namespace = name_space
                                        self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-event-unknown"):
                                        self.rx_event_unknown = value
                                        self.rx_event_unknown.value_namespace = name_space
                                        self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-change-event"):
                                        self.rx_path_change_event = value
                                        self.rx_path_change_event.value_namespace = name_space
                                        self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-create-event"):
                                        self.rx_path_create_event = value
                                        self.rx_path_create_event.value_namespace = name_space
                                        self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-delete-event"):
                                        self.rx_path_delete_event = value
                                        self.rx_path_delete_event.value_namespace = name_space
                                        self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-error-event"):
                                        self.rx_path_error_event = value
                                        self.rx_path_error_event.value_namespace = name_space
                                        self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-reeval-query-event"):
                                        self.rx_path_reeval_query_event = value
                                        self.rx_path_reeval_query_event.value_namespace = name_space
                                        self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-change-event"):
                                        self.rx_resv_change_event = value
                                        self.rx_resv_change_event.value_namespace = name_space
                                        self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-create-event"):
                                        self.rx_resv_create_event = value
                                        self.rx_resv_create_event.value_namespace = name_space
                                        self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-delete-event"):
                                        self.rx_resv_delete_event = value
                                        self.rx_resv_delete_event.value_namespace = name_space
                                        self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-error-event"):
                                        self.rx_resv_error_event = value
                                        self.rx_resv_error_event.value_namespace = name_space
                                        self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-backup-assign-event"):
                                        self.tx_backup_assign_event = value
                                        self.tx_backup_assign_event.value_namespace = name_space
                                        self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-event-unknown"):
                                        self.tx_event_unknown = value
                                        self.tx_event_unknown.value_namespace = name_space
                                        self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-change-event"):
                                        self.tx_path_change_event = value
                                        self.tx_path_change_event.value_namespace = name_space
                                        self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-create-event"):
                                        self.tx_path_create_event = value
                                        self.tx_path_create_event.value_namespace = name_space
                                        self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-delete-event"):
                                        self.tx_path_delete_event = value
                                        self.tx_path_delete_event.value_namespace = name_space
                                        self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-error-event"):
                                        self.tx_path_error_event = value
                                        self.tx_path_error_event.value_namespace = name_space
                                        self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-reeval-query-event"):
                                        self.tx_path_reeval_query_event = value
                                        self.tx_path_reeval_query_event.value_namespace = name_space
                                        self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-change-event"):
                                        self.tx_resv_change_event = value
                                        self.tx_resv_change_event.value_namespace = name_space
                                        self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-create-event"):
                                        self.tx_resv_create_event = value
                                        self.tx_resv_create_event.value_namespace = name_space
                                        self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-delete-event"):
                                        self.tx_resv_delete_event = value
                                        self.tx_resv_delete_event.value_namespace = name_space
                                        self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-error-event"):
                                        self.tx_resv_error_event = value
                                        self.tx_resv_error_event.value_namespace = name_space
                                        self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.destination_address.is_set or
                                    self.sub_group_id.is_set or
                                    self.sub_group_originator.is_set or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.sub_group_id.yfilter != YFilter.not_set or
                                    self.sub_group_originator.yfilter != YFilter.not_set or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                                if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-group-id"):
                                    self.sub_group_id = value
                                    self.sub_group_id.value_namespace = name_space
                                    self.sub_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-group-originator"):
                                    self.sub_group_originator = value
                                    self.sub_group_originator.value_namespace = name_space
                                    self.sub_group_originator.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_statistic:
                                if (c.has_data()):
                                    return True
                            return (
                                self.tunnel_name.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            for c in self.s2l_statistic:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "te-signalling-filter-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-statistic"):
                                for c in self.s2l_statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_statistic.append(c)
                                return c

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-statistic" or name == "statistics" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.statistics_filter.is_set or
                            (self.te_signalling_filter_lsp is not None and self.te_signalling_filter_lsp.has_data()) or
                            (self.te_signalling_filter_vif is not None and self.te_signalling_filter_vif.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.statistics_filter.yfilter != YFilter.not_set or
                            (self.te_signalling_filter_lsp is not None and self.te_signalling_filter_lsp.has_operation()) or
                            (self.te_signalling_filter_vif is not None and self.te_signalling_filter_vif.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-signalling-filter-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.statistics_filter.is_set or self.statistics_filter.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.statistics_filter.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "te-signalling-filter-lsp"):
                            if (self.te_signalling_filter_lsp is None):
                                self.te_signalling_filter_lsp = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                                self.te_signalling_filter_lsp.parent = self
                                self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                            return self.te_signalling_filter_lsp

                        if (child_yang_name == "te-signalling-filter-vif"):
                            if (self.te_signalling_filter_vif is None):
                                self.te_signalling_filter_vif = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                                self.te_signalling_filter_vif.parent = self
                                self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"
                            return self.te_signalling_filter_vif

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "te-signalling-filter-lsp" or name == "te-signalling-filter-vif" or name == "statistics-filter"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "statistics-filter"):
                            self.statistics_filter = value
                            self.statistics_filter.value_namespace = name_space
                            self.statistics_filter.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.p2mp_id.is_set or
                        self.lsp_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.sub_group_originator.is_set or
                        self.sub_group_id.is_set or
                        (self.te_signalling_filter_data is not None and self.te_signalling_filter_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        (self.te_signalling_filter_data is not None and self.te_signalling_filter_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "signalling" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/signallings/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "te-signalling-filter-data"):
                        if (self.te_signalling_filter_data is None):
                            self.te_signalling_filter_data = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                            self.te_signalling_filter_data.parent = self
                            self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                        return self.te_signalling_filter_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "te-signalling-filter-data" or name == "ctype" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "p2mp-id" or name == "lsp-id" or name == "source-address" or name == "destination-address" or name == "sub-group-originator" or name == "sub-group-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.signalling:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.signalling:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "signallings" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "signalling"):
                    for c in self.signalling:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.SignallingCounters.Signallings.Signalling()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.signalling.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "signalling"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class SignallingSummary(Entity):
            """
            Send\-Recv count summary for TE Signaling
            
            .. attribute:: events_count
            
            	TE Signaling event count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: events_total_count
            
            	Total TE Signalling event count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_backup_assign_err_event
            
            	Error on Backup Assign event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_event_unknown
            
            	RX Unknown events
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_change_event
            
            	RX Path Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_create_event
            
            	RX Path Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_delete_event
            
            	RX Path Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_error_event
            
            	RX Path Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_reeval_query_event
            
            	RX Path Reeval Query event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_change_event
            
            	RX Resv Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_create_event
            
            	RX Resv Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_delete_event
            
            	RX Resv Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_error_event
            
            	RX Resv Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_backup_assign_event
            
            	Backup Assign event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_event_unknown
            
            	Unknown TX events
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_change_event
            
            	TX Path Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_create_event
            
            	TX Path Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_delete_event
            
            	TX Path Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_error_event
            
            	TX Path Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_reeval_query_event
            
            	TX Path Reeval Query event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_change_event
            
            	TX Resv Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_create_event
            
            	TX Resv Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_delete_event
            
            	TX Resv Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_error_event
            
            	TX Resv Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.SignallingCounters.SignallingSummary, self).__init__()

                self.yang_name = "signalling-summary"
                self.yang_parent_name = "signalling-counters"

                self.events_count = YLeaf(YType.uint32, "events-count")

                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("events_count",
                                "events_total_count",
                                "rx_backup_assign_err_event",
                                "rx_event_unknown",
                                "rx_path_change_event",
                                "rx_path_create_event",
                                "rx_path_delete_event",
                                "rx_path_error_event",
                                "rx_path_reeval_query_event",
                                "rx_resv_change_event",
                                "rx_resv_create_event",
                                "rx_resv_delete_event",
                                "rx_resv_error_event",
                                "tx_backup_assign_event",
                                "tx_event_unknown",
                                "tx_path_change_event",
                                "tx_path_create_event",
                                "tx_path_delete_event",
                                "tx_path_error_event",
                                "tx_path_reeval_query_event",
                                "tx_resv_change_event",
                                "tx_resv_create_event",
                                "tx_resv_delete_event",
                                "tx_resv_error_event") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.SignallingCounters.SignallingSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.SignallingCounters.SignallingSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.events_count.is_set or
                    self.events_total_count.is_set or
                    self.rx_backup_assign_err_event.is_set or
                    self.rx_event_unknown.is_set or
                    self.rx_path_change_event.is_set or
                    self.rx_path_create_event.is_set or
                    self.rx_path_delete_event.is_set or
                    self.rx_path_error_event.is_set or
                    self.rx_path_reeval_query_event.is_set or
                    self.rx_resv_change_event.is_set or
                    self.rx_resv_create_event.is_set or
                    self.rx_resv_delete_event.is_set or
                    self.rx_resv_error_event.is_set or
                    self.tx_backup_assign_event.is_set or
                    self.tx_event_unknown.is_set or
                    self.tx_path_change_event.is_set or
                    self.tx_path_create_event.is_set or
                    self.tx_path_delete_event.is_set or
                    self.tx_path_error_event.is_set or
                    self.tx_path_reeval_query_event.is_set or
                    self.tx_resv_change_event.is_set or
                    self.tx_resv_create_event.is_set or
                    self.tx_resv_delete_event.is_set or
                    self.tx_resv_error_event.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.events_count.yfilter != YFilter.not_set or
                    self.events_total_count.yfilter != YFilter.not_set or
                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                    self.rx_event_unknown.yfilter != YFilter.not_set or
                    self.rx_path_change_event.yfilter != YFilter.not_set or
                    self.rx_path_create_event.yfilter != YFilter.not_set or
                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                    self.rx_path_error_event.yfilter != YFilter.not_set or
                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                    self.tx_event_unknown.yfilter != YFilter.not_set or
                    self.tx_path_change_event.yfilter != YFilter.not_set or
                    self.tx_path_create_event.yfilter != YFilter.not_set or
                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                    self.tx_path_error_event.yfilter != YFilter.not_set or
                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                    self.tx_resv_error_event.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "signalling-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.events_count.get_name_leafdata())
                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "events-count"):
                    self.events_count = value
                    self.events_count.value_namespace = name_space
                    self.events_count.value_namespace_prefix = name_space_prefix
                if(value_path == "events-total-count"):
                    self.events_total_count = value
                    self.events_total_count.value_namespace = name_space
                    self.events_total_count.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-backup-assign-err-event"):
                    self.rx_backup_assign_err_event = value
                    self.rx_backup_assign_err_event.value_namespace = name_space
                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-event-unknown"):
                    self.rx_event_unknown = value
                    self.rx_event_unknown.value_namespace = name_space
                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-change-event"):
                    self.rx_path_change_event = value
                    self.rx_path_change_event.value_namespace = name_space
                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-create-event"):
                    self.rx_path_create_event = value
                    self.rx_path_create_event.value_namespace = name_space
                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-delete-event"):
                    self.rx_path_delete_event = value
                    self.rx_path_delete_event.value_namespace = name_space
                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-error-event"):
                    self.rx_path_error_event = value
                    self.rx_path_error_event.value_namespace = name_space
                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-reeval-query-event"):
                    self.rx_path_reeval_query_event = value
                    self.rx_path_reeval_query_event.value_namespace = name_space
                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-change-event"):
                    self.rx_resv_change_event = value
                    self.rx_resv_change_event.value_namespace = name_space
                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-create-event"):
                    self.rx_resv_create_event = value
                    self.rx_resv_create_event.value_namespace = name_space
                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-delete-event"):
                    self.rx_resv_delete_event = value
                    self.rx_resv_delete_event.value_namespace = name_space
                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-error-event"):
                    self.rx_resv_error_event = value
                    self.rx_resv_error_event.value_namespace = name_space
                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-backup-assign-event"):
                    self.tx_backup_assign_event = value
                    self.tx_backup_assign_event.value_namespace = name_space
                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-event-unknown"):
                    self.tx_event_unknown = value
                    self.tx_event_unknown.value_namespace = name_space
                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-change-event"):
                    self.tx_path_change_event = value
                    self.tx_path_change_event.value_namespace = name_space
                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-create-event"):
                    self.tx_path_create_event = value
                    self.tx_path_create_event.value_namespace = name_space
                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-delete-event"):
                    self.tx_path_delete_event = value
                    self.tx_path_delete_event.value_namespace = name_space
                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-error-event"):
                    self.tx_path_error_event = value
                    self.tx_path_error_event.value_namespace = name_space
                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-reeval-query-event"):
                    self.tx_path_reeval_query_event = value
                    self.tx_path_reeval_query_event.value_namespace = name_space
                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-change-event"):
                    self.tx_resv_change_event = value
                    self.tx_resv_change_event.value_namespace = name_space
                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-create-event"):
                    self.tx_resv_create_event = value
                    self.tx_resv_create_event.value_namespace = name_space
                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-delete-event"):
                    self.tx_resv_delete_event = value
                    self.tx_resv_delete_event.value_namespace = name_space
                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-error-event"):
                    self.tx_resv_error_event = value
                    self.tx_resv_error_event.value_namespace = name_space
                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.head_signalling_counters is not None and self.head_signalling_counters.has_data()) or
                (self.heads_counters is not None and self.heads_counters.has_data()) or
                (self.issu is not None and self.issu.has_data()) or
                (self.mids_counters is not None and self.mids_counters.has_data()) or
                (self.remote_signalling_counters is not None and self.remote_signalling_counters.has_data()) or
                (self.signalling_summary is not None and self.signalling_summary.has_data()) or
                (self.signallings is not None and self.signallings.has_data()) or
                (self.tails_counters is not None and self.tails_counters.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.head_signalling_counters is not None and self.head_signalling_counters.has_operation()) or
                (self.heads_counters is not None and self.heads_counters.has_operation()) or
                (self.issu is not None and self.issu.has_operation()) or
                (self.mids_counters is not None and self.mids_counters.has_operation()) or
                (self.remote_signalling_counters is not None and self.remote_signalling_counters.has_operation()) or
                (self.signalling_summary is not None and self.signalling_summary.has_operation()) or
                (self.signallings is not None and self.signallings.has_operation()) or
                (self.tails_counters is not None and self.tails_counters.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "signalling-counters" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "head-signalling-counters"):
                if (self.head_signalling_counters is None):
                    self.head_signalling_counters = MplsTe.SignallingCounters.HeadSignallingCounters()
                    self.head_signalling_counters.parent = self
                    self._children_name_map["head_signalling_counters"] = "head-signalling-counters"
                return self.head_signalling_counters

            if (child_yang_name == "heads-counters"):
                if (self.heads_counters is None):
                    self.heads_counters = MplsTe.SignallingCounters.HeadsCounters()
                    self.heads_counters.parent = self
                    self._children_name_map["heads_counters"] = "heads-counters"
                return self.heads_counters

            if (child_yang_name == "issu"):
                if (self.issu is None):
                    self.issu = MplsTe.SignallingCounters.Issu()
                    self.issu.parent = self
                    self._children_name_map["issu"] = "issu"
                return self.issu

            if (child_yang_name == "mids-counters"):
                if (self.mids_counters is None):
                    self.mids_counters = MplsTe.SignallingCounters.MidsCounters()
                    self.mids_counters.parent = self
                    self._children_name_map["mids_counters"] = "mids-counters"
                return self.mids_counters

            if (child_yang_name == "remote-signalling-counters"):
                if (self.remote_signalling_counters is None):
                    self.remote_signalling_counters = MplsTe.SignallingCounters.RemoteSignallingCounters()
                    self.remote_signalling_counters.parent = self
                    self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"
                return self.remote_signalling_counters

            if (child_yang_name == "signalling-summary"):
                if (self.signalling_summary is None):
                    self.signalling_summary = MplsTe.SignallingCounters.SignallingSummary()
                    self.signalling_summary.parent = self
                    self._children_name_map["signalling_summary"] = "signalling-summary"
                return self.signalling_summary

            if (child_yang_name == "signallings"):
                if (self.signallings is None):
                    self.signallings = MplsTe.SignallingCounters.Signallings()
                    self.signallings.parent = self
                    self._children_name_map["signallings"] = "signallings"
                return self.signallings

            if (child_yang_name == "tails-counters"):
                if (self.tails_counters is None):
                    self.tails_counters = MplsTe.SignallingCounters.TailsCounters()
                    self.tails_counters.parent = self
                    self._children_name_map["tails_counters"] = "tails-counters"
                return self.tails_counters

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "head-signalling-counters" or name == "heads-counters" or name == "issu" or name == "mids-counters" or name == "remote-signalling-counters" or name == "signalling-summary" or name == "signallings" or name == "tails-counters"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class DiffServTeClasses(Entity):
        """
        The configured Diff Serv TE classes
        
        .. attribute:: te_class
        
        	te class
        	**type**\: list of    :py:class:`TeClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.DiffServTeClasses.TeClass>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.DiffServTeClasses, self).__init__()

            self.yang_name = "diff-serv-te-classes"
            self.yang_parent_name = "mpls-te"

            self.te_class = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.DiffServTeClasses, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.DiffServTeClasses, self).__setattr__(name, value)


        class TeClass(Entity):
            """
            te class
            
            .. attribute:: class_number
            
            	The DS\-TE class number from 0 to 7
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: class_status
            
            	The status of the TE class
            	**type**\:   :py:class:`MplsTeDsteClassStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeDsteClassStatus>`
            
            .. attribute:: class_type
            
            	The class type of the TE class
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: priority
            
            	The priority of the TE class
            	**type**\:  int
            
            	**range:** 0..255
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.DiffServTeClasses.TeClass, self).__init__()

                self.yang_name = "te-class"
                self.yang_parent_name = "diff-serv-te-classes"

                self.class_number = YLeaf(YType.uint8, "class-number")

                self.class_status = YLeaf(YType.enumeration, "class-status")

                self.class_type = YLeaf(YType.uint8, "class-type")

                self.priority = YLeaf(YType.uint8, "priority")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("class_number",
                                "class_status",
                                "class_type",
                                "priority") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.DiffServTeClasses.TeClass, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.DiffServTeClasses.TeClass, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.class_number.is_set or
                    self.class_status.is_set or
                    self.class_type.is_set or
                    self.priority.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.class_number.yfilter != YFilter.not_set or
                    self.class_status.yfilter != YFilter.not_set or
                    self.class_type.yfilter != YFilter.not_set or
                    self.priority.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "te-class" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/diff-serv-te-classes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.class_number.is_set or self.class_number.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_number.get_name_leafdata())
                if (self.class_status.is_set or self.class_status.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_status.get_name_leafdata())
                if (self.class_type.is_set or self.class_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_type.get_name_leafdata())
                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.priority.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "class-number" or name == "class-status" or name == "class-type" or name == "priority"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "class-number"):
                    self.class_number = value
                    self.class_number.value_namespace = name_space
                    self.class_number.value_namespace_prefix = name_space_prefix
                if(value_path == "class-status"):
                    self.class_status = value
                    self.class_status.value_namespace = name_space
                    self.class_status.value_namespace_prefix = name_space_prefix
                if(value_path == "class-type"):
                    self.class_type = value
                    self.class_type.value_namespace = name_space
                    self.class_type.value_namespace_prefix = name_space_prefix
                if(value_path == "priority"):
                    self.priority = value
                    self.priority.value_namespace = name_space
                    self.priority.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.te_class:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.te_class:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "diff-serv-te-classes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "te-class"):
                for c in self.te_class:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.DiffServTeClasses.TeClass()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.te_class.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "te-class"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Issu(Entity):
        """
        MPLS TE ISSU information
        
        .. attribute:: detail
        
        	MPLS TE ISSU Status information
        	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail>`
        
        .. attribute:: status
        
        	MPLS TE ISSU Status information
        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.Issu, self).__init__()

            self.yang_name = "issu"
            self.yang_parent_name = "mpls-te"

            self.detail = MplsTe.Issu.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._children_yang_names.add("detail")

            self.status = MplsTe.Issu.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"
            self._children_yang_names.add("status")


        class Status(Entity):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Issu.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "issu"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTe.Issu.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Issu.Status, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Issu.Status, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Issu.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Issu.Status.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Issu.Status.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "status" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTe.Issu.Status.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix


        class Detail(Entity):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Issu.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "issu"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTe.Issu.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Issu.Detail, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Issu.Detail, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Issu.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Issu.Detail.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Issu.Detail.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "detail" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTe.Issu.Detail.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.detail is not None and self.detail.has_data()) or
                (self.status is not None and self.status.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.detail is not None and self.detail.has_operation()) or
                (self.status is not None and self.status.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "issu" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "detail"):
                if (self.detail is None):
                    self.detail = MplsTe.Issu.Detail()
                    self.detail.parent = self
                    self._children_name_map["detail"] = "detail"
                return self.detail

            if (child_yang_name == "status"):
                if (self.status is None):
                    self.status = MplsTe.Issu.Status()
                    self.status.parent = self
                    self._children_name_map["status"] = "status"
                return self.status

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "detail" or name == "status"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FastReroute(Entity):
        """
        Represent all the fastreroute info in MPLS\-TE
        
        .. attribute:: backup_tunnels
        
        	The set of fastreroute backup tunnels available in MPLS\-TE
        	**type**\:   :py:class:`BackupTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.BackupTunnels>`
        
        .. attribute:: promotion
        
        	The info about the promotion timer of backup tunnels
        	**type**\:   :py:class:`Promotion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Promotion>`
        
        .. attribute:: protected_interfaces
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:   :py:class:`ProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.ProtectedInterfaces>`
        
        .. attribute:: protections
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:   :py:class:`Protections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Protections>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.FastReroute, self).__init__()

            self.yang_name = "fast-reroute"
            self.yang_parent_name = "mpls-te"

            self.backup_tunnels = MplsTe.FastReroute.BackupTunnels()
            self.backup_tunnels.parent = self
            self._children_name_map["backup_tunnels"] = "backup-tunnels"
            self._children_yang_names.add("backup-tunnels")

            self.promotion = MplsTe.FastReroute.Promotion()
            self.promotion.parent = self
            self._children_name_map["promotion"] = "promotion"
            self._children_yang_names.add("promotion")

            self.protected_interfaces = MplsTe.FastReroute.ProtectedInterfaces()
            self.protected_interfaces.parent = self
            self._children_name_map["protected_interfaces"] = "protected-interfaces"
            self._children_yang_names.add("protected-interfaces")

            self.protections = MplsTe.FastReroute.Protections()
            self.protections.parent = self
            self._children_name_map["protections"] = "protections"
            self._children_yang_names.add("protections")


        class BackupTunnels(Entity):
            """
            The set of fastreroute backup tunnels available
            in MPLS\-TE
            
            .. attribute:: backup_tunnel
            
            	Fastreroute info for a given backup tunnel
            	**type**\: list of    :py:class:`BackupTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.BackupTunnels.BackupTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FastReroute.BackupTunnels, self).__init__()

                self.yang_name = "backup-tunnels"
                self.yang_parent_name = "fast-reroute"

                self.backup_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FastReroute.BackupTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FastReroute.BackupTunnels, self).__setattr__(name, value)


            class BackupTunnel(Entity):
                """
                Fastreroute info for a given backup tunnel
                
                .. attribute:: tunnel_name  <key>
                
                	Backup tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: interface_name  <key>
                
                	Protected interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:   :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:   :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\:  bool
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\:  bool
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\:  str
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\:  bool
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\:  str
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FastReroute.BackupTunnels.BackupTunnel, self).__init__()

                    self.yang_name = "backup-tunnel"
                    self.yang_parent_name = "backup-tunnels"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.backup_tunnel_id = YLeaf(YType.uint32, "backup-tunnel-id")

                    self.backup_tunnel_name_xr = YLeaf(YType.str, "backup-tunnel-name-xr")

                    self.backup_type = YLeaf(YType.enumeration, "backup-type")

                    self.backup_usage = YLeaf(YType.enumeration, "backup-usage")

                    self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.connection_status = YLeaf(YType.enumeration, "connection-status")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.frr_active_ls_ps = YLeaf(YType.uint32, "frr-active-ls-ps")

                    self.frr_active_soft_preempted_ls_ps = YLeaf(YType.uint32, "frr-active-soft-preempted-ls-ps")

                    self.general_status = YLeaf(YType.enumeration, "general-status")

                    self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                    self.in_use_bandwidth = YLeaf(YType.uint32, "in-use-bandwidth")

                    self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                    self.ls_ps = YLeaf(YType.uint32, "ls-ps")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.prot_interface_autobackup_config = YLeaf(YType.enumeration, "prot-interface-autobackup-config")

                    self.prot_interface_srlg_config = YLeaf(YType.enumeration, "prot-interface-srlg-config")

                    self.recreate_remaining_time = YLeaf(YType.uint32, "recreate-remaining-time")

                    self.recreate_timer_is_running = YLeaf(YType.boolean, "recreate-timer-is-running")

                    self.s2_ls = YLeaf(YType.uint32, "s2-ls")

                    self.s2l_families = YLeaf(YType.uint32, "s2l-families")

                    self.soft_preempted_in_use_bandwidth = YLeaf(YType.uint32, "soft-preempted-in-use-bandwidth")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "interface_name",
                                    "backup_status",
                                    "backup_tunnel_id",
                                    "backup_tunnel_name_xr",
                                    "backup_type",
                                    "backup_usage",
                                    "bandwidth",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "connection_status",
                                    "destination_address",
                                    "frr_active_ls_ps",
                                    "frr_active_soft_preempted_ls_ps",
                                    "general_status",
                                    "has_attribute_set",
                                    "in_use_bandwidth",
                                    "is_attribute_set_in_db",
                                    "ls_ps",
                                    "output_interface_name",
                                    "prot_interface_autobackup_config",
                                    "prot_interface_srlg_config",
                                    "recreate_remaining_time",
                                    "recreate_timer_is_running",
                                    "s2_ls",
                                    "s2l_families",
                                    "soft_preempted_in_use_bandwidth",
                                    "source_address",
                                    "tunnel_attribute_set_name",
                                    "tunnel_instance") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FastReroute.BackupTunnels.BackupTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FastReroute.BackupTunnels.BackupTunnel, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.interface_name.is_set or
                        self.backup_status.is_set or
                        self.backup_tunnel_id.is_set or
                        self.backup_tunnel_name_xr.is_set or
                        self.backup_type.is_set or
                        self.backup_usage.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.connection_status.is_set or
                        self.destination_address.is_set or
                        self.frr_active_ls_ps.is_set or
                        self.frr_active_soft_preempted_ls_ps.is_set or
                        self.general_status.is_set or
                        self.has_attribute_set.is_set or
                        self.in_use_bandwidth.is_set or
                        self.is_attribute_set_in_db.is_set or
                        self.ls_ps.is_set or
                        self.output_interface_name.is_set or
                        self.prot_interface_autobackup_config.is_set or
                        self.prot_interface_srlg_config.is_set or
                        self.recreate_remaining_time.is_set or
                        self.recreate_timer_is_running.is_set or
                        self.s2_ls.is_set or
                        self.s2l_families.is_set or
                        self.soft_preempted_in_use_bandwidth.is_set or
                        self.source_address.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_instance.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.backup_tunnel_id.yfilter != YFilter.not_set or
                        self.backup_tunnel_name_xr.yfilter != YFilter.not_set or
                        self.backup_type.yfilter != YFilter.not_set or
                        self.backup_usage.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.connection_status.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.frr_active_ls_ps.yfilter != YFilter.not_set or
                        self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                        self.general_status.yfilter != YFilter.not_set or
                        self.has_attribute_set.yfilter != YFilter.not_set or
                        self.in_use_bandwidth.yfilter != YFilter.not_set or
                        self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                        self.ls_ps.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        self.prot_interface_autobackup_config.yfilter != YFilter.not_set or
                        self.prot_interface_srlg_config.yfilter != YFilter.not_set or
                        self.recreate_remaining_time.yfilter != YFilter.not_set or
                        self.recreate_timer_is_running.yfilter != YFilter.not_set or
                        self.s2_ls.yfilter != YFilter.not_set or
                        self.s2l_families.yfilter != YFilter.not_set or
                        self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "backup-tunnel" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/backup-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.backup_tunnel_id.is_set or self.backup_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_id.get_name_leafdata())
                    if (self.backup_tunnel_name_xr.is_set or self.backup_tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name_xr.get_name_leafdata())
                    if (self.backup_type.is_set or self.backup_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_type.get_name_leafdata())
                    if (self.backup_usage.is_set or self.backup_usage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_usage.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.connection_status.is_set or self.connection_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connection_status.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.frr_active_ls_ps.is_set or self.frr_active_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_ls_ps.get_name_leafdata())
                    if (self.frr_active_soft_preempted_ls_ps.is_set or self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_soft_preempted_ls_ps.get_name_leafdata())
                    if (self.general_status.is_set or self.general_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.general_status.get_name_leafdata())
                    if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                    if (self.in_use_bandwidth.is_set or self.in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.in_use_bandwidth.get_name_leafdata())
                    if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                    if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ls_ps.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                    if (self.prot_interface_autobackup_config.is_set or self.prot_interface_autobackup_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_autobackup_config.get_name_leafdata())
                    if (self.prot_interface_srlg_config.is_set or self.prot_interface_srlg_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_srlg_config.get_name_leafdata())
                    if (self.recreate_remaining_time.is_set or self.recreate_remaining_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_remaining_time.get_name_leafdata())
                    if (self.recreate_timer_is_running.is_set or self.recreate_timer_is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_timer_is_running.get_name_leafdata())
                    if (self.s2_ls.is_set or self.s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls.get_name_leafdata())
                    if (self.s2l_families.is_set or self.s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2l_families.get_name_leafdata())
                    if (self.soft_preempted_in_use_bandwidth.is_set or self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_in_use_bandwidth.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "interface-name" or name == "backup-status" or name == "backup-tunnel-id" or name == "backup-tunnel-name-xr" or name == "backup-type" or name == "backup-usage" or name == "bandwidth" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "connection-status" or name == "destination-address" or name == "frr-active-ls-ps" or name == "frr-active-soft-preempted-ls-ps" or name == "general-status" or name == "has-attribute-set" or name == "in-use-bandwidth" or name == "is-attribute-set-in-db" or name == "ls-ps" or name == "output-interface-name" or name == "prot-interface-autobackup-config" or name == "prot-interface-srlg-config" or name == "recreate-remaining-time" or name == "recreate-timer-is-running" or name == "s2-ls" or name == "s2l-families" or name == "soft-preempted-in-use-bandwidth" or name == "source-address" or name == "tunnel-attribute-set-name" or name == "tunnel-instance"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-id"):
                        self.backup_tunnel_id = value
                        self.backup_tunnel_id.value_namespace = name_space
                        self.backup_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name-xr"):
                        self.backup_tunnel_name_xr = value
                        self.backup_tunnel_name_xr.value_namespace = name_space
                        self.backup_tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-type"):
                        self.backup_type = value
                        self.backup_type.value_namespace = name_space
                        self.backup_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-usage"):
                        self.backup_usage = value
                        self.backup_usage.value_namespace = name_space
                        self.backup_usage.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "connection-status"):
                        self.connection_status = value
                        self.connection_status.value_namespace = name_space
                        self.connection_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-ls-ps"):
                        self.frr_active_ls_ps = value
                        self.frr_active_ls_ps.value_namespace = name_space
                        self.frr_active_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-soft-preempted-ls-ps"):
                        self.frr_active_soft_preempted_ls_ps = value
                        self.frr_active_soft_preempted_ls_ps.value_namespace = name_space
                        self.frr_active_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "general-status"):
                        self.general_status = value
                        self.general_status.value_namespace = name_space
                        self.general_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-attribute-set"):
                        self.has_attribute_set = value
                        self.has_attribute_set.value_namespace = name_space
                        self.has_attribute_set.value_namespace_prefix = name_space_prefix
                    if(value_path == "in-use-bandwidth"):
                        self.in_use_bandwidth = value
                        self.in_use_bandwidth.value_namespace = name_space
                        self.in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-set-in-db"):
                        self.is_attribute_set_in_db = value
                        self.is_attribute_set_in_db.value_namespace = name_space
                        self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                    if(value_path == "ls-ps"):
                        self.ls_ps = value
                        self.ls_ps.value_namespace = name_space
                        self.ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-autobackup-config"):
                        self.prot_interface_autobackup_config = value
                        self.prot_interface_autobackup_config.value_namespace = name_space
                        self.prot_interface_autobackup_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-srlg-config"):
                        self.prot_interface_srlg_config = value
                        self.prot_interface_srlg_config.value_namespace = name_space
                        self.prot_interface_srlg_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-remaining-time"):
                        self.recreate_remaining_time = value
                        self.recreate_remaining_time.value_namespace = name_space
                        self.recreate_remaining_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-timer-is-running"):
                        self.recreate_timer_is_running = value
                        self.recreate_timer_is_running.value_namespace = name_space
                        self.recreate_timer_is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls"):
                        self.s2_ls = value
                        self.s2_ls.value_namespace = name_space
                        self.s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2l-families"):
                        self.s2l_families = value
                        self.s2l_families.value_namespace = name_space
                        self.s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-in-use-bandwidth"):
                        self.soft_preempted_in_use_bandwidth = value
                        self.soft_preempted_in_use_bandwidth.value_namespace = name_space
                        self.soft_preempted_in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.backup_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.backup_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "backup-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "backup-tunnel"):
                    for c in self.backup_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.FastReroute.BackupTunnels.BackupTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.backup_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "backup-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ProtectedInterfaces(Entity):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protected_interface
            
            	Fastreroute info for a given protected interface
            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FastReroute.ProtectedInterfaces, self).__init__()

                self.yang_name = "protected-interfaces"
                self.yang_parent_name = "fast-reroute"

                self.protected_interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FastReroute.ProtectedInterfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FastReroute.ProtectedInterfaces, self).__setattr__(name, value)


            class ProtectedInterface(Entity):
                """
                Fastreroute info for a given protected
                interface
                
                .. attribute:: interface_name  <key>
                
                	Protected interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: backup_tunnel_name  <key>
                
                	Backup tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:   :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:   :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\:  bool
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\:  bool
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\:  str
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\:  bool
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\:  str
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__init__()

                    self.yang_name = "protected-interface"
                    self.yang_parent_name = "protected-interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.backup_tunnel_id = YLeaf(YType.uint32, "backup-tunnel-id")

                    self.backup_tunnel_name_xr = YLeaf(YType.str, "backup-tunnel-name-xr")

                    self.backup_type = YLeaf(YType.enumeration, "backup-type")

                    self.backup_usage = YLeaf(YType.enumeration, "backup-usage")

                    self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.connection_status = YLeaf(YType.enumeration, "connection-status")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.frr_active_ls_ps = YLeaf(YType.uint32, "frr-active-ls-ps")

                    self.frr_active_soft_preempted_ls_ps = YLeaf(YType.uint32, "frr-active-soft-preempted-ls-ps")

                    self.general_status = YLeaf(YType.enumeration, "general-status")

                    self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                    self.in_use_bandwidth = YLeaf(YType.uint32, "in-use-bandwidth")

                    self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                    self.ls_ps = YLeaf(YType.uint32, "ls-ps")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.prot_interface_autobackup_config = YLeaf(YType.enumeration, "prot-interface-autobackup-config")

                    self.prot_interface_srlg_config = YLeaf(YType.enumeration, "prot-interface-srlg-config")

                    self.recreate_remaining_time = YLeaf(YType.uint32, "recreate-remaining-time")

                    self.recreate_timer_is_running = YLeaf(YType.boolean, "recreate-timer-is-running")

                    self.s2_ls = YLeaf(YType.uint32, "s2-ls")

                    self.s2l_families = YLeaf(YType.uint32, "s2l-families")

                    self.soft_preempted_in_use_bandwidth = YLeaf(YType.uint32, "soft-preempted-in-use-bandwidth")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "backup_tunnel_name",
                                    "backup_status",
                                    "backup_tunnel_id",
                                    "backup_tunnel_name_xr",
                                    "backup_type",
                                    "backup_usage",
                                    "bandwidth",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "connection_status",
                                    "destination_address",
                                    "frr_active_ls_ps",
                                    "frr_active_soft_preempted_ls_ps",
                                    "general_status",
                                    "has_attribute_set",
                                    "in_use_bandwidth",
                                    "is_attribute_set_in_db",
                                    "ls_ps",
                                    "output_interface_name",
                                    "prot_interface_autobackup_config",
                                    "prot_interface_srlg_config",
                                    "recreate_remaining_time",
                                    "recreate_timer_is_running",
                                    "s2_ls",
                                    "s2l_families",
                                    "soft_preempted_in_use_bandwidth",
                                    "source_address",
                                    "tunnel_attribute_set_name",
                                    "tunnel_instance") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.backup_tunnel_name.is_set or
                        self.backup_status.is_set or
                        self.backup_tunnel_id.is_set or
                        self.backup_tunnel_name_xr.is_set or
                        self.backup_type.is_set or
                        self.backup_usage.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.connection_status.is_set or
                        self.destination_address.is_set or
                        self.frr_active_ls_ps.is_set or
                        self.frr_active_soft_preempted_ls_ps.is_set or
                        self.general_status.is_set or
                        self.has_attribute_set.is_set or
                        self.in_use_bandwidth.is_set or
                        self.is_attribute_set_in_db.is_set or
                        self.ls_ps.is_set or
                        self.output_interface_name.is_set or
                        self.prot_interface_autobackup_config.is_set or
                        self.prot_interface_srlg_config.is_set or
                        self.recreate_remaining_time.is_set or
                        self.recreate_timer_is_running.is_set or
                        self.s2_ls.is_set or
                        self.s2l_families.is_set or
                        self.soft_preempted_in_use_bandwidth.is_set or
                        self.source_address.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_instance.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.backup_tunnel_name.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.backup_tunnel_id.yfilter != YFilter.not_set or
                        self.backup_tunnel_name_xr.yfilter != YFilter.not_set or
                        self.backup_type.yfilter != YFilter.not_set or
                        self.backup_usage.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.connection_status.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.frr_active_ls_ps.yfilter != YFilter.not_set or
                        self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                        self.general_status.yfilter != YFilter.not_set or
                        self.has_attribute_set.yfilter != YFilter.not_set or
                        self.in_use_bandwidth.yfilter != YFilter.not_set or
                        self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                        self.ls_ps.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        self.prot_interface_autobackup_config.yfilter != YFilter.not_set or
                        self.prot_interface_srlg_config.yfilter != YFilter.not_set or
                        self.recreate_remaining_time.yfilter != YFilter.not_set or
                        self.recreate_timer_is_running.yfilter != YFilter.not_set or
                        self.s2_ls.yfilter != YFilter.not_set or
                        self.s2l_families.yfilter != YFilter.not_set or
                        self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protected-interface" + "[interface-name='" + self.interface_name.get() + "']" + "[backup-tunnel-name='" + self.backup_tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/protected-interfaces/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.backup_tunnel_id.is_set or self.backup_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_id.get_name_leafdata())
                    if (self.backup_tunnel_name_xr.is_set or self.backup_tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name_xr.get_name_leafdata())
                    if (self.backup_type.is_set or self.backup_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_type.get_name_leafdata())
                    if (self.backup_usage.is_set or self.backup_usage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_usage.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.connection_status.is_set or self.connection_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connection_status.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.frr_active_ls_ps.is_set or self.frr_active_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_ls_ps.get_name_leafdata())
                    if (self.frr_active_soft_preempted_ls_ps.is_set or self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_soft_preempted_ls_ps.get_name_leafdata())
                    if (self.general_status.is_set or self.general_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.general_status.get_name_leafdata())
                    if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                    if (self.in_use_bandwidth.is_set or self.in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.in_use_bandwidth.get_name_leafdata())
                    if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                    if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ls_ps.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                    if (self.prot_interface_autobackup_config.is_set or self.prot_interface_autobackup_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_autobackup_config.get_name_leafdata())
                    if (self.prot_interface_srlg_config.is_set or self.prot_interface_srlg_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_srlg_config.get_name_leafdata())
                    if (self.recreate_remaining_time.is_set or self.recreate_remaining_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_remaining_time.get_name_leafdata())
                    if (self.recreate_timer_is_running.is_set or self.recreate_timer_is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_timer_is_running.get_name_leafdata())
                    if (self.s2_ls.is_set or self.s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls.get_name_leafdata())
                    if (self.s2l_families.is_set or self.s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2l_families.get_name_leafdata())
                    if (self.soft_preempted_in_use_bandwidth.is_set or self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_in_use_bandwidth.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-name" or name == "backup-tunnel-name" or name == "backup-status" or name == "backup-tunnel-id" or name == "backup-tunnel-name-xr" or name == "backup-type" or name == "backup-usage" or name == "bandwidth" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "connection-status" or name == "destination-address" or name == "frr-active-ls-ps" or name == "frr-active-soft-preempted-ls-ps" or name == "general-status" or name == "has-attribute-set" or name == "in-use-bandwidth" or name == "is-attribute-set-in-db" or name == "ls-ps" or name == "output-interface-name" or name == "prot-interface-autobackup-config" or name == "prot-interface-srlg-config" or name == "recreate-remaining-time" or name == "recreate-timer-is-running" or name == "s2-ls" or name == "s2l-families" or name == "soft-preempted-in-use-bandwidth" or name == "source-address" or name == "tunnel-attribute-set-name" or name == "tunnel-instance"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name"):
                        self.backup_tunnel_name = value
                        self.backup_tunnel_name.value_namespace = name_space
                        self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-id"):
                        self.backup_tunnel_id = value
                        self.backup_tunnel_id.value_namespace = name_space
                        self.backup_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name-xr"):
                        self.backup_tunnel_name_xr = value
                        self.backup_tunnel_name_xr.value_namespace = name_space
                        self.backup_tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-type"):
                        self.backup_type = value
                        self.backup_type.value_namespace = name_space
                        self.backup_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-usage"):
                        self.backup_usage = value
                        self.backup_usage.value_namespace = name_space
                        self.backup_usage.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "connection-status"):
                        self.connection_status = value
                        self.connection_status.value_namespace = name_space
                        self.connection_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-ls-ps"):
                        self.frr_active_ls_ps = value
                        self.frr_active_ls_ps.value_namespace = name_space
                        self.frr_active_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-soft-preempted-ls-ps"):
                        self.frr_active_soft_preempted_ls_ps = value
                        self.frr_active_soft_preempted_ls_ps.value_namespace = name_space
                        self.frr_active_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "general-status"):
                        self.general_status = value
                        self.general_status.value_namespace = name_space
                        self.general_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-attribute-set"):
                        self.has_attribute_set = value
                        self.has_attribute_set.value_namespace = name_space
                        self.has_attribute_set.value_namespace_prefix = name_space_prefix
                    if(value_path == "in-use-bandwidth"):
                        self.in_use_bandwidth = value
                        self.in_use_bandwidth.value_namespace = name_space
                        self.in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-set-in-db"):
                        self.is_attribute_set_in_db = value
                        self.is_attribute_set_in_db.value_namespace = name_space
                        self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                    if(value_path == "ls-ps"):
                        self.ls_ps = value
                        self.ls_ps.value_namespace = name_space
                        self.ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-autobackup-config"):
                        self.prot_interface_autobackup_config = value
                        self.prot_interface_autobackup_config.value_namespace = name_space
                        self.prot_interface_autobackup_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-srlg-config"):
                        self.prot_interface_srlg_config = value
                        self.prot_interface_srlg_config.value_namespace = name_space
                        self.prot_interface_srlg_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-remaining-time"):
                        self.recreate_remaining_time = value
                        self.recreate_remaining_time.value_namespace = name_space
                        self.recreate_remaining_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-timer-is-running"):
                        self.recreate_timer_is_running = value
                        self.recreate_timer_is_running.value_namespace = name_space
                        self.recreate_timer_is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls"):
                        self.s2_ls = value
                        self.s2_ls.value_namespace = name_space
                        self.s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2l-families"):
                        self.s2l_families = value
                        self.s2l_families.value_namespace = name_space
                        self.s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-in-use-bandwidth"):
                        self.soft_preempted_in_use_bandwidth = value
                        self.soft_preempted_in_use_bandwidth.value_namespace = name_space
                        self.soft_preempted_in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protected_interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protected_interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protected-interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protected-interface"):
                    for c in self.protected_interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protected_interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protected-interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Protections(Entity):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protection
            
            	Fastreroute info for a given protection interface
            	**type**\: list of    :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Protections.Protection>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FastReroute.Protections, self).__init__()

                self.yang_name = "protections"
                self.yang_parent_name = "fast-reroute"

                self.protection = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FastReroute.Protections, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FastReroute.Protections, self).__setattr__(name, value)


            class Protection(Entity):
                """
                Fastreroute info for a given protection
                interface
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup Orig ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: session_type  <key>
                
                	Session Type
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_status
                
                	Tunnel Admin status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: backup_bandwidth
                
                	Backup bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_next_hop_address
                
                	S2L Nexthop of the backup tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: backup_status
                
                	Backup status
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_output_interface
                
                	Output interface of bkup tunnel
                	**type**\:  str
                
                .. attribute:: frr_output_label
                
                	FRR output label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_output_tunnel_interface
                
                	FRR output tunnel intface
                	**type**\:  str
                
                .. attribute:: inbound_frr_state
                
                	Indicates inbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: input_label
                
                	Input label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_frr_requested
                
                	TRUE if frr protection is on
                	**type**\:  bool
                
                .. attribute:: is_p2mp_tunnel
                
                	Is P2P or P2MP Tunnel
                	**type**\:  bool
                
                .. attribute:: is_signalled
                
                	Indicates whether signalled
                	**type**\:  bool
                
                .. attribute:: lsp_bandwidth_type
                
                	LSP bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: next_hop_address
                
                	Next hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: operation_status
                
                	Tunnel operational status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: original_input_interface
                
                	Input intface of the LSP
                	**type**\:  str
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: output_interface_lsp
                
                	Output intface of the LSP
                	**type**\:  str
                
                .. attribute:: output_label
                
                	Output label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: previous_hop_address
                
                	Previous hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: role
                
                	Role of LSP
                	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                
                .. attribute:: sharing_type
                
                	Outgoing i/f Sharing type
                	**type**\:   :py:class:`MplsTeFrrSharing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrSharing>`
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FastReroute.Protections.Protection, self).__init__()

                    self.yang_name = "protection"
                    self.yang_parent_name = "protections"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.session_type = YLeaf(YType.int32, "session-type")

                    self.admin_status = YLeaf(YType.enumeration, "admin-status")

                    self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                    self.backup_next_hop_address = YLeaf(YType.str, "backup-next-hop-address")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.extended_tunnel_id_xr = YLeaf(YType.str, "extended-tunnel-id-xr")

                    self.frr_output_interface = YLeaf(YType.str, "frr-output-interface")

                    self.frr_output_label = YLeaf(YType.uint32, "frr-output-label")

                    self.frr_output_tunnel_interface = YLeaf(YType.str, "frr-output-tunnel-interface")

                    self.inbound_frr_state = YLeaf(YType.enumeration, "inbound-frr-state")

                    self.input_label = YLeaf(YType.uint32, "input-label")

                    self.is_frr_requested = YLeaf(YType.boolean, "is-frr-requested")

                    self.is_p2mp_tunnel = YLeaf(YType.boolean, "is-p2mp-tunnel")

                    self.is_signalled = YLeaf(YType.boolean, "is-signalled")

                    self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.operation_status = YLeaf(YType.enumeration, "operation-status")

                    self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.output_interface_lsp = YLeaf(YType.str, "output-interface-lsp")

                    self.output_label = YLeaf(YType.uint32, "output-label")

                    self.p2mp_id_xr = YLeaf(YType.uint32, "p2mp-id-xr")

                    self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                    self.role = YLeaf(YType.enumeration, "role")

                    self.sharing_type = YLeaf(YType.enumeration, "sharing-type")

                    self.source_address_xr = YLeaf(YType.str, "source-address-xr")

                    self.sub_group_id_xr = YLeaf(YType.uint16, "sub-group-id-xr")

                    self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "sub_group_id",
                                    "sub_group_originator",
                                    "p2mp_id",
                                    "session_type",
                                    "admin_status",
                                    "backup_bandwidth",
                                    "backup_next_hop_address",
                                    "backup_status",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "destination_address_xr",
                                    "extended_tunnel_id_xr",
                                    "frr_output_interface",
                                    "frr_output_label",
                                    "frr_output_tunnel_interface",
                                    "inbound_frr_state",
                                    "input_label",
                                    "is_frr_requested",
                                    "is_p2mp_tunnel",
                                    "is_signalled",
                                    "lsp_bandwidth_type",
                                    "next_hop_address",
                                    "operation_status",
                                    "original_input_interface",
                                    "outbound_frr_state",
                                    "output_interface_lsp",
                                    "output_label",
                                    "p2mp_id_xr",
                                    "previous_hop_address",
                                    "role",
                                    "sharing_type",
                                    "source_address_xr",
                                    "sub_group_id_xr",
                                    "sub_group_original_id",
                                    "tunnel_id_xr",
                                    "tunnel_instance",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FastReroute.Protections.Protection, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FastReroute.Protections.Protection, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.sub_group_id.is_set or
                        self.sub_group_originator.is_set or
                        self.p2mp_id.is_set or
                        self.session_type.is_set or
                        self.admin_status.is_set or
                        self.backup_bandwidth.is_set or
                        self.backup_next_hop_address.is_set or
                        self.backup_status.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.destination_address_xr.is_set or
                        self.extended_tunnel_id_xr.is_set or
                        self.frr_output_interface.is_set or
                        self.frr_output_label.is_set or
                        self.frr_output_tunnel_interface.is_set or
                        self.inbound_frr_state.is_set or
                        self.input_label.is_set or
                        self.is_frr_requested.is_set or
                        self.is_p2mp_tunnel.is_set or
                        self.is_signalled.is_set or
                        self.lsp_bandwidth_type.is_set or
                        self.next_hop_address.is_set or
                        self.operation_status.is_set or
                        self.original_input_interface.is_set or
                        self.outbound_frr_state.is_set or
                        self.output_interface_lsp.is_set or
                        self.output_label.is_set or
                        self.p2mp_id_xr.is_set or
                        self.previous_hop_address.is_set or
                        self.role.is_set or
                        self.sharing_type.is_set or
                        self.source_address_xr.is_set or
                        self.sub_group_id_xr.is_set or
                        self.sub_group_original_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_instance.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.session_type.yfilter != YFilter.not_set or
                        self.admin_status.yfilter != YFilter.not_set or
                        self.backup_bandwidth.yfilter != YFilter.not_set or
                        self.backup_next_hop_address.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.extended_tunnel_id_xr.yfilter != YFilter.not_set or
                        self.frr_output_interface.yfilter != YFilter.not_set or
                        self.frr_output_label.yfilter != YFilter.not_set or
                        self.frr_output_tunnel_interface.yfilter != YFilter.not_set or
                        self.inbound_frr_state.yfilter != YFilter.not_set or
                        self.input_label.yfilter != YFilter.not_set or
                        self.is_frr_requested.yfilter != YFilter.not_set or
                        self.is_p2mp_tunnel.yfilter != YFilter.not_set or
                        self.is_signalled.yfilter != YFilter.not_set or
                        self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.operation_status.yfilter != YFilter.not_set or
                        self.original_input_interface.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.output_interface_lsp.yfilter != YFilter.not_set or
                        self.output_label.yfilter != YFilter.not_set or
                        self.p2mp_id_xr.yfilter != YFilter.not_set or
                        self.previous_hop_address.yfilter != YFilter.not_set or
                        self.role.yfilter != YFilter.not_set or
                        self.sharing_type.yfilter != YFilter.not_set or
                        self.source_address_xr.yfilter != YFilter.not_set or
                        self.sub_group_id_xr.yfilter != YFilter.not_set or
                        self.sub_group_original_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protection" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[session-type='" + self.session_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/protections/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.session_type.is_set or self.session_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_type.get_name_leafdata())
                    if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_status.get_name_leafdata())
                    if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                    if (self.backup_next_hop_address.is_set or self.backup_next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_next_hop_address.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.extended_tunnel_id_xr.is_set or self.extended_tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id_xr.get_name_leafdata())
                    if (self.frr_output_interface.is_set or self.frr_output_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_interface.get_name_leafdata())
                    if (self.frr_output_label.is_set or self.frr_output_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_label.get_name_leafdata())
                    if (self.frr_output_tunnel_interface.is_set or self.frr_output_tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_tunnel_interface.get_name_leafdata())
                    if (self.inbound_frr_state.is_set or self.inbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.inbound_frr_state.get_name_leafdata())
                    if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.input_label.get_name_leafdata())
                    if (self.is_frr_requested.is_set or self.is_frr_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_frr_requested.get_name_leafdata())
                    if (self.is_p2mp_tunnel.is_set or self.is_p2mp_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_p2mp_tunnel.get_name_leafdata())
                    if (self.is_signalled.is_set or self.is_signalled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_signalled.get_name_leafdata())
                    if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.operation_status.is_set or self.operation_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operation_status.get_name_leafdata())
                    if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.output_interface_lsp.is_set or self.output_interface_lsp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_lsp.get_name_leafdata())
                    if (self.output_label.is_set or self.output_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_label.get_name_leafdata())
                    if (self.p2mp_id_xr.is_set or self.p2mp_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id_xr.get_name_leafdata())
                    if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                    if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role.get_name_leafdata())
                    if (self.sharing_type.is_set or self.sharing_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sharing_type.get_name_leafdata())
                    if (self.source_address_xr.is_set or self.source_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address_xr.get_name_leafdata())
                    if (self.sub_group_id_xr.is_set or self.sub_group_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id_xr.get_name_leafdata())
                    if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "sub-group-id" or name == "sub-group-originator" or name == "p2mp-id" or name == "session-type" or name == "admin-status" or name == "backup-bandwidth" or name == "backup-next-hop-address" or name == "backup-status" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "destination-address-xr" or name == "extended-tunnel-id-xr" or name == "frr-output-interface" or name == "frr-output-label" or name == "frr-output-tunnel-interface" or name == "inbound-frr-state" or name == "input-label" or name == "is-frr-requested" or name == "is-p2mp-tunnel" or name == "is-signalled" or name == "lsp-bandwidth-type" or name == "next-hop-address" or name == "operation-status" or name == "original-input-interface" or name == "outbound-frr-state" or name == "output-interface-lsp" or name == "output-label" or name == "p2mp-id-xr" or name == "previous-hop-address" or name == "role" or name == "sharing-type" or name == "source-address-xr" or name == "sub-group-id-xr" or name == "sub-group-original-id" or name == "tunnel-id-xr" or name == "tunnel-instance" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-type"):
                        self.session_type = value
                        self.session_type.value_namespace = name_space
                        self.session_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-status"):
                        self.admin_status = value
                        self.admin_status.value_namespace = name_space
                        self.admin_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-bandwidth"):
                        self.backup_bandwidth = value
                        self.backup_bandwidth.value_namespace = name_space
                        self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-next-hop-address"):
                        self.backup_next_hop_address = value
                        self.backup_next_hop_address.value_namespace = name_space
                        self.backup_next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id-xr"):
                        self.extended_tunnel_id_xr = value
                        self.extended_tunnel_id_xr.value_namespace = name_space
                        self.extended_tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-interface"):
                        self.frr_output_interface = value
                        self.frr_output_interface.value_namespace = name_space
                        self.frr_output_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-label"):
                        self.frr_output_label = value
                        self.frr_output_label.value_namespace = name_space
                        self.frr_output_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-tunnel-interface"):
                        self.frr_output_tunnel_interface = value
                        self.frr_output_tunnel_interface.value_namespace = name_space
                        self.frr_output_tunnel_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "inbound-frr-state"):
                        self.inbound_frr_state = value
                        self.inbound_frr_state.value_namespace = name_space
                        self.inbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "input-label"):
                        self.input_label = value
                        self.input_label.value_namespace = name_space
                        self.input_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-frr-requested"):
                        self.is_frr_requested = value
                        self.is_frr_requested.value_namespace = name_space
                        self.is_frr_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-p2mp-tunnel"):
                        self.is_p2mp_tunnel = value
                        self.is_p2mp_tunnel.value_namespace = name_space
                        self.is_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-signalled"):
                        self.is_signalled = value
                        self.is_signalled.value_namespace = name_space
                        self.is_signalled.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth-type"):
                        self.lsp_bandwidth_type = value
                        self.lsp_bandwidth_type.value_namespace = name_space
                        self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "operation-status"):
                        self.operation_status = value
                        self.operation_status.value_namespace = name_space
                        self.operation_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "original-input-interface"):
                        self.original_input_interface = value
                        self.original_input_interface.value_namespace = name_space
                        self.original_input_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-lsp"):
                        self.output_interface_lsp = value
                        self.output_interface_lsp.value_namespace = name_space
                        self.output_interface_lsp.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-label"):
                        self.output_label = value
                        self.output_label.value_namespace = name_space
                        self.output_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id-xr"):
                        self.p2mp_id_xr = value
                        self.p2mp_id_xr.value_namespace = name_space
                        self.p2mp_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "previous-hop-address"):
                        self.previous_hop_address = value
                        self.previous_hop_address.value_namespace = name_space
                        self.previous_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "role"):
                        self.role = value
                        self.role.value_namespace = name_space
                        self.role.value_namespace_prefix = name_space_prefix
                    if(value_path == "sharing-type"):
                        self.sharing_type = value
                        self.sharing_type.value_namespace = name_space
                        self.sharing_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address-xr"):
                        self.source_address_xr = value
                        self.source_address_xr.value_namespace = name_space
                        self.source_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id-xr"):
                        self.sub_group_id_xr = value
                        self.sub_group_id_xr.value_namespace = name_space
                        self.sub_group_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-original-id"):
                        self.sub_group_original_id = value
                        self.sub_group_original_id.value_namespace = name_space
                        self.sub_group_original_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protection:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protection:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protections" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protection"):
                    for c in self.protection:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.FastReroute.Protections.Protection()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protection.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protection"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Promotion(Entity):
            """
            The info about the promotion timer of backup
            tunnels
            
            .. attribute:: is_configured
            
            	Indicate if periodic promotion is configured 
            	**type**\:  bool
            
            .. attribute:: promotion_period
            
            	Promotion period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: remaining_time
            
            	Remaining time for next promotion in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FastReroute.Promotion, self).__init__()

                self.yang_name = "promotion"
                self.yang_parent_name = "fast-reroute"

                self.is_configured = YLeaf(YType.boolean, "is-configured")

                self.promotion_period = YLeaf(YType.uint32, "promotion-period")

                self.remaining_time = YLeaf(YType.uint32, "remaining-time")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_configured",
                                "promotion_period",
                                "remaining_time") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FastReroute.Promotion, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FastReroute.Promotion, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.is_configured.is_set or
                    self.promotion_period.is_set or
                    self.remaining_time.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_configured.yfilter != YFilter.not_set or
                    self.promotion_period.yfilter != YFilter.not_set or
                    self.remaining_time.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "promotion" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_configured.get_name_leafdata())
                if (self.promotion_period.is_set or self.promotion_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.promotion_period.get_name_leafdata())
                if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.remaining_time.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "is-configured" or name == "promotion-period" or name == "remaining-time"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-configured"):
                    self.is_configured = value
                    self.is_configured.value_namespace = name_space
                    self.is_configured.value_namespace_prefix = name_space_prefix
                if(value_path == "promotion-period"):
                    self.promotion_period = value
                    self.promotion_period.value_namespace = name_space
                    self.promotion_period.value_namespace_prefix = name_space_prefix
                if(value_path == "remaining-time"):
                    self.remaining_time = value
                    self.remaining_time.value_namespace = name_space
                    self.remaining_time.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.backup_tunnels is not None and self.backup_tunnels.has_data()) or
                (self.promotion is not None and self.promotion.has_data()) or
                (self.protected_interfaces is not None and self.protected_interfaces.has_data()) or
                (self.protections is not None and self.protections.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.backup_tunnels is not None and self.backup_tunnels.has_operation()) or
                (self.promotion is not None and self.promotion.has_operation()) or
                (self.protected_interfaces is not None and self.protected_interfaces.has_operation()) or
                (self.protections is not None and self.protections.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "fast-reroute" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "backup-tunnels"):
                if (self.backup_tunnels is None):
                    self.backup_tunnels = MplsTe.FastReroute.BackupTunnels()
                    self.backup_tunnels.parent = self
                    self._children_name_map["backup_tunnels"] = "backup-tunnels"
                return self.backup_tunnels

            if (child_yang_name == "promotion"):
                if (self.promotion is None):
                    self.promotion = MplsTe.FastReroute.Promotion()
                    self.promotion.parent = self
                    self._children_name_map["promotion"] = "promotion"
                return self.promotion

            if (child_yang_name == "protected-interfaces"):
                if (self.protected_interfaces is None):
                    self.protected_interfaces = MplsTe.FastReroute.ProtectedInterfaces()
                    self.protected_interfaces.parent = self
                    self._children_name_map["protected_interfaces"] = "protected-interfaces"
                return self.protected_interfaces

            if (child_yang_name == "protections"):
                if (self.protections is None):
                    self.protections = MplsTe.FastReroute.Protections()
                    self.protections.parent = self
                    self._children_name_map["protections"] = "protections"
                return self.protections

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "backup-tunnels" or name == "promotion" or name == "protected-interfaces" or name == "protections"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AttributeSets(Entity):
        """
        AttributeSet information.
        
        .. attribute:: attribute_set
        
        	MPLS TE attribute\-set information
        	**type**\: list of    :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AttributeSets, self).__init__()

            self.yang_name = "attribute-sets"
            self.yang_parent_name = "mpls-te"

            self.attribute_set = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.AttributeSets, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.AttributeSets, self).__setattr__(name, value)


        class AttributeSet(Entity):
            """
            MPLS TE attribute\-set information
            
            .. attribute:: attribute_set_type  <key>
            
            	Attribute Set Type
            	**type**\:   :py:class:`MplsTeAttrSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAttrSet>`
            
            .. attribute:: attribute_set_name  <key>
            
            	Attribute Set Name
            	**type**\:  str
            
            	**length:** 1..64
            
            .. attribute:: attribute_set_union
            
            	Union of Attribute Sets
            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion>`
            
            .. attribute:: tunnel_attribute_set_name
            
            	Attribute Set Name
            	**type**\:  str
            
            .. attribute:: tunnel_attribute_set_name_crc32
            
            	Attribute Set name CRC32 value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AttributeSets.AttributeSet, self).__init__()

                self.yang_name = "attribute-set"
                self.yang_parent_name = "attribute-sets"

                self.attribute_set_type = YLeaf(YType.enumeration, "attribute-set-type")

                self.attribute_set_name = YLeaf(YType.str, "attribute-set-name")

                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                self.attribute_set_union = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion()
                self.attribute_set_union.parent = self
                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                self._children_yang_names.add("attribute-set-union")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("attribute_set_type",
                                "attribute_set_name",
                                "tunnel_attribute_set_name",
                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AttributeSets.AttributeSet, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AttributeSets.AttributeSet, self).__setattr__(name, value)


            class AttributeSetUnion(Entity):
                """
                Union of Attribute Sets
                
                .. attribute:: attribute_set_aps_pp
                
                	Attribute Set OTN APS Path Protection
                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                
                .. attribute:: attribute_set_autobackup
                
                	MPLS TE Auto\-backup Attribute Set
                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                
                .. attribute:: attribute_set_automesh
                
                	MPLS TE Auto\-mesh Attribute Set
                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                
                .. attribute:: attribute_set_p2mpte
                
                	MPLS TE P2MP\-TE Attribute Set
                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                
                .. attribute:: attribute_set_p2p_te
                
                	MPLS TE P2P\-TE Attribute Set
                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                
                .. attribute:: attribute_set_path_option
                
                	MPLS TE Path Option Attribute Set
                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                
                .. attribute:: attribute_set_xro
                
                	Attribute Set XRO
                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                
                .. attribute:: tunnel_attribute_set_type
                
                	TunnelAttributeSetType
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion, self).__init__()

                    self.yang_name = "attribute-set-union"
                    self.yang_parent_name = "attribute-set"

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.attribute_set_aps_pp = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                    self.attribute_set_aps_pp.parent = self
                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                    self._children_yang_names.add("attribute-set-aps-pp")

                    self.attribute_set_autobackup = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                    self.attribute_set_autobackup.parent = self
                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                    self._children_yang_names.add("attribute-set-autobackup")

                    self.attribute_set_automesh = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                    self.attribute_set_automesh.parent = self
                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                    self._children_yang_names.add("attribute-set-automesh")

                    self.attribute_set_p2mpte = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                    self.attribute_set_p2mpte.parent = self
                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                    self._children_yang_names.add("attribute-set-p2mpte")

                    self.attribute_set_p2p_te = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                    self.attribute_set_p2p_te.parent = self
                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                    self._children_yang_names.add("attribute-set-p2p-te")

                    self.attribute_set_path_option = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                    self.attribute_set_path_option.parent = self
                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                    self._children_yang_names.add("attribute-set-path-option")

                    self.attribute_set_xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                    self.attribute_set_xro.parent = self
                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                    self._children_yang_names.add("attribute-set-xro")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                class AttributeSetPathOption(Entity):
                    """
                    MPLS TE Path Option Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_reverse_path
                    
                    	BFD reverse path
                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: exclude_list_name
                    
                    	Exclude list name
                    	**type**\:  str
                    
                    .. attribute:: generation
                    
                    	Generation
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bfd_reverse_pat_configured
                    
                    	Is BFD reverse path configured
                    	**type**\:  bool
                    
                    .. attribute:: is_cost_limit_configured
                    
                    	Is Cost Limit configured
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_list_name_configured
                    
                    	Is exclude list name configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is path invalidation action configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is path invalidation timeout configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                    
                    .. attribute:: version_info
                    
                    	Version Info
                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                        self.yang_name = "attribute-set-path-option"
                        self.yang_parent_name = "attribute-set-union"

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                        self.generation = YLeaf(YType.uint32, "generation")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_reverse_path = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                        self.bfd_reverse_path.parent = self
                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                        self._children_yang_names.add("bfd-reverse-path")

                        self.tunnel_id = YList(self)
                        self.version_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_type",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "dste_class_type",
                                        "exclude_list_name",
                                        "generation",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_bfd_reverse_pat_configured",
                                        "is_cost_limit_configured",
                                        "is_exclude_list_name_configured",
                                        "is_path_invalidation_action_configured",
                                        "is_path_invalidation_timeout_configured",
                                        "is_pce_configured",
                                        "is_pce_disj_group_id_configured",
                                        "is_pce_disj_source_configured",
                                        "is_pce_disj_type_configured",
                                        "is_pceb_dj_source_configured",
                                        "is_pcebd_group_id_configured",
                                        "path_invalidation_action",
                                        "path_invalidation_timeout",
                                        "pcebd_group_id",
                                        "pcebd_source_address",
                                        "pcedp_group_id",
                                        "pcedp_source_address",
                                        "pcedp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BfdReversePath(Entity):
                        """
                        BFD reverse path
                        
                        .. attribute:: binding_label
                        
                        	BFD reverse path binding label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_type
                        
                        	BFD reverse path type
                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                            self.yang_name = "bfd-reverse-path"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                            self.path_type = YLeaf(YType.enumeration, "path-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("binding_label",
                                            "path_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.binding_label.is_set or
                                self.path_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.binding_label.yfilter != YFilter.not_set or
                                self.path_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-reverse-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "binding-label" or name == "path-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "binding-label"):
                                self.binding_label = value
                                self.binding_label.value_namespace = name_space
                                self.binding_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-type"):
                                self.path_type = value
                                self.path_type.value_namespace = name_space
                                self.path_type.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class VersionInfo(Entity):
                        """
                        Version Info
                        
                        .. attribute:: attribute_type
                        
                        	Attribute Type
                        	**type**\:  str
                        
                        .. attribute:: generation
                        
                        	Generation
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_default
                        
                        	Is default
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                            self.yang_name = "version-info"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                            self.generation = YLeaf(YType.uint32, "generation")

                            self.is_default = YLeaf(YType.boolean, "is-default")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_type",
                                            "generation",
                                            "is_default") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.attribute_type.is_set or
                                self.generation.is_set or
                                self.is_default.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_type.yfilter != YFilter.not_set or
                                self.generation.yfilter != YFilter.not_set or
                                self.is_default.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "version-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.generation.get_name_leafdata())
                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_default.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-type"):
                                self.attribute_type = value
                                self.attribute_type.value_namespace = name_space
                                self.attribute_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "generation"):
                                self.generation = value
                                self.generation.value_namespace = name_space
                                self.generation.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-default"):
                                self.is_default = value
                                self.is_default.value_namespace = name_space
                                self.is_default.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        for c in self.version_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_type.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.dste_class_type.is_set or
                            self.exclude_list_name.is_set or
                            self.generation.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_bfd_reverse_pat_configured.is_set or
                            self.is_cost_limit_configured.is_set or
                            self.is_exclude_list_name_configured.is_set or
                            self.is_path_invalidation_action_configured.is_set or
                            self.is_path_invalidation_timeout_configured.is_set or
                            self.is_pce_configured.is_set or
                            self.is_pce_disj_group_id_configured.is_set or
                            self.is_pce_disj_source_configured.is_set or
                            self.is_pce_disj_type_configured.is_set or
                            self.is_pceb_dj_source_configured.is_set or
                            self.is_pcebd_group_id_configured.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.pcebd_group_id.is_set or
                            self.pcebd_source_address.is_set or
                            self.pcedp_group_id.is_set or
                            self.pcedp_source_address.is_set or
                            self.pcedp_type.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        for c in self.version_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.exclude_list_name.yfilter != YFilter.not_set or
                            self.generation.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                            self.is_pce_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.pcebd_group_id.yfilter != YFilter.not_set or
                            self.pcebd_source_address.yfilter != YFilter.not_set or
                            self.pcedp_group_id.yfilter != YFilter.not_set or
                            self.pcedp_source_address.yfilter != YFilter.not_set or
                            self.pcedp_type.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-path-option" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.generation.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "bfd-reverse-path"):
                            if (self.bfd_reverse_path is None):
                                self.bfd_reverse_path = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                            return self.bfd_reverse_path

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        if (child_yang_name == "version-info"):
                            for c in self.version_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.version_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "exclude-list-name"):
                            self.exclude_list_name = value
                            self.exclude_list_name.value_namespace = name_space
                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "generation"):
                            self.generation = value
                            self.generation.value_namespace = name_space
                            self.generation.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bfd-reverse-pat-configured"):
                            self.is_bfd_reverse_pat_configured = value
                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-cost-limit-configured"):
                            self.is_cost_limit_configured = value
                            self.is_cost_limit_configured.value_namespace = name_space
                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-list-name-configured"):
                            self.is_exclude_list_name_configured = value
                            self.is_exclude_list_name_configured.value_namespace = name_space
                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-action-configured"):
                            self.is_path_invalidation_action_configured = value
                            self.is_path_invalidation_action_configured.value_namespace = name_space
                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-timeout-configured"):
                            self.is_path_invalidation_timeout_configured = value
                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-configured"):
                            self.is_pce_configured = value
                            self.is_pce_configured.value_namespace = name_space
                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-group-id-configured"):
                            self.is_pce_disj_group_id_configured = value
                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-source-configured"):
                            self.is_pce_disj_source_configured = value
                            self.is_pce_disj_source_configured.value_namespace = name_space
                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-type-configured"):
                            self.is_pce_disj_type_configured = value
                            self.is_pce_disj_type_configured.value_namespace = name_space
                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pceb-dj-source-configured"):
                            self.is_pceb_dj_source_configured = value
                            self.is_pceb_dj_source_configured.value_namespace = name_space
                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pcebd-group-id-configured"):
                            self.is_pcebd_group_id_configured = value
                            self.is_pcebd_group_id_configured.value_namespace = name_space
                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-group-id"):
                            self.pcebd_group_id = value
                            self.pcebd_group_id.value_namespace = name_space
                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-source-address"):
                            self.pcebd_source_address = value
                            self.pcebd_source_address.value_namespace = name_space
                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-group-id"):
                            self.pcedp_group_id = value
                            self.pcedp_group_id.value_namespace = name_space
                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-source-address"):
                            self.pcedp_source_address = value
                            self.pcedp_source_address.value_namespace = name_space
                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-type"):
                            self.pcedp_type = value
                            self.pcedp_type.value_namespace = name_space
                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                class AttributeSetAutobackup(Entity):
                    """
                    MPLS TE Auto\-backup Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: is_signalled_name_configured
                    
                    	Is signalled name configured
                    	**type**\:  bool
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                    
                    .. attribute:: protected_interface
                    
                    	Array of Protected Interface Names
                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signalled_name
                    
                    	Signalled name
                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                        self.yang_name = "attribute-set-autobackup"
                        self.yang_parent_name = "attribute-set-union"

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.signalled_name = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                        self.signalled_name.parent = self
                        self._children_name_map["signalled_name"] = "signalled-name"
                        self._children_yang_names.add("signalled-name")

                        self.policy_class_entry = YList(self)
                        self.protected_interface = YList(self)
                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hold_priority",
                                        "is_affinity_configured",
                                        "is_policyclass_configured",
                                        "is_priority_configured",
                                        "is_signalled_name_configured",
                                        "policy_class",
                                        "record_route",
                                        "setup_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                    class SignalledName(Entity):
                        """
                        Signalled name
                        
                        .. attribute:: is_mp_addresses
                        
                        	MP address appended
                        	**type**\:  bool
                        
                        .. attribute:: name
                        
                        	Signalled name
                        	**type**\:  str
                        
                        .. attribute:: protected_interface_type
                        
                        	Protected interface address or name
                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        .. attribute:: source_type
                        
                        	Source address or name
                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                            self.yang_name = "signalled-name"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                            self.name = YLeaf(YType.str, "name")

                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                            self.source_type = YLeaf(YType.enumeration, "source-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_mp_addresses",
                                            "name",
                                            "protected_interface_type",
                                            "source_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_mp_addresses.is_set or
                                self.name.is_set or
                                self.protected_interface_type.is_set or
                                self.source_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set or
                                self.protected_interface_type.yfilter != YFilter.not_set or
                                self.source_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "signalled-name" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())
                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-mp-addresses"):
                                self.is_mp_addresses = value
                                self.is_mp_addresses.value_namespace = name_space
                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-interface-type"):
                                self.protected_interface_type = value
                                self.protected_interface_type.value_namespace = name_space
                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-type"):
                                self.source_type = value
                                self.source_type.value_namespace = name_space
                                self.source_type.value_namespace_prefix = name_space_prefix


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class ProtectedInterface(Entity):
                        """
                        Array of Protected Interface Names
                        
                        .. attribute:: protected_interface
                        
                        	Protected Interface Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                            self.yang_name = "protected-interface"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protected_interface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                        def has_data(self):
                            return self.protected_interface.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protected_interface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protected-interface" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protected-interface"):
                                self.protected_interface = value
                                self.protected_interface.value_namespace = name_space
                                self.protected_interface.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        for c in self.protected_interface:
                            if (c.has_data()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_policyclass_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.is_signalled_name_configured.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.setup_priority.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()) or
                            (self.signalled_name is not None and self.signalled_name.has_data()))

                    def has_operation(self):
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        for c in self.protected_interface:
                            if (c.has_operation()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()) or
                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-autobackup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        if (child_yang_name == "protected-interface"):
                            for c in self.protected_interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.protected_interface.append(c)
                            return c

                        if (child_yang_name == "signalled-name"):
                            if (self.signalled_name is None):
                                self.signalled_name = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                            return self.signalled_name

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-policyclass-configured"):
                            self.is_policyclass_configured = value
                            self.is_policyclass_configured.value_namespace = name_space
                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-signalled-name-configured"):
                            self.is_signalled_name_configured = value
                            self.is_signalled_name_configured.value_namespace = name_space
                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix


                class AttributeSetAutomesh(Entity):
                    """
                    MPLS TE Auto\-mesh Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                    
                    .. attribute:: auto_bandwidth_collect
                    
                    	Auto bandwidth collect only
                    	**type**\:  bool
                    
                    .. attribute:: auto_route_announce
                    
                    	Announce auto route to IGP
                    	**type**\:  bool
                    
                    .. attribute:: bandwidth
                    
                    	IM bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\:  bool
                    
                    .. attribute:: frr_node_protection
                    
                    	FRR Node protection
                    	**type**\:  bool
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_interface_bw_configured
                    
                    	Is Interface BW configured
                    	**type**\:  bool
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: load_share
                    
                    	Load Share
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                    
                    .. attribute:: mesh_group_id
                    
                    	Meshgroup ID
                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: soft_preemption_configured
                    
                    	Soft preemption is configured
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                        self.yang_name = "attribute-set-automesh"
                        self.yang_parent_name = "attribute-set-union"

                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.load_share = YLeaf(YType.uint32, "load-share")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.mesh_group_id = YList(self)
                        self.policy_class_entry = YList(self)
                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_bandwidth_collect",
                                        "auto_route_announce",
                                        "bandwidth",
                                        "configured_bandwidth",
                                        "dste_class_type",
                                        "fast_reroute",
                                        "forward_class",
                                        "frr_bandwidth_protection",
                                        "frr_node_protection",
                                        "hold_priority",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_interface_bw_configured",
                                        "is_policyclass_configured",
                                        "is_priority_configured",
                                        "load_share",
                                        "policy_class",
                                        "record_route",
                                        "setup_priority",
                                        "soft_preemption_configured") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class MeshGroupId(Entity):
                        """
                        Meshgroup ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                            self.yang_name = "mesh-group-id"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mesh-group-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.mesh_group_id:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.auto_bandwidth_collect.is_set or
                            self.auto_route_announce.is_set or
                            self.bandwidth.is_set or
                            self.configured_bandwidth.is_set or
                            self.dste_class_type.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.frr_bandwidth_protection.is_set or
                            self.frr_node_protection.is_set or
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_interface_bw_configured.is_set or
                            self.is_policyclass_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.load_share.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.setup_priority.is_set or
                            self.soft_preemption_configured.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()))

                    def has_operation(self):
                        for c in self.mesh_group_id:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                            self.auto_route_announce.yfilter != YFilter.not_set or
                            self.bandwidth.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                            self.frr_node_protection.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.load_share.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-automesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.load_share.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "mesh-group-id"):
                            for c in self.mesh_group_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mesh_group_id.append(c)
                            return c

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-bandwidth-collect"):
                            self.auto_bandwidth_collect = value
                            self.auto_bandwidth_collect.value_namespace = name_space
                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-route-announce"):
                            self.auto_route_announce = value
                            self.auto_route_announce.value_namespace = name_space
                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth"):
                            self.bandwidth = value
                            self.bandwidth.value_namespace = name_space
                            self.bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-bandwidth-protection"):
                            self.frr_bandwidth_protection = value
                            self.frr_bandwidth_protection.value_namespace = name_space
                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-node-protection"):
                            self.frr_node_protection = value
                            self.frr_node_protection.value_namespace = name_space
                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface-bw-configured"):
                            self.is_interface_bw_configured = value
                            self.is_interface_bw_configured.value_namespace = name_space
                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-policyclass-configured"):
                            self.is_policyclass_configured = value
                            self.is_policyclass_configured.value_namespace = name_space
                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "load-share"):
                            self.load_share = value
                            self.load_share.value_namespace = name_space
                            self.load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preemption-configured"):
                            self.soft_preemption_configured = value
                            self.soft_preemption_configured.value_namespace = name_space
                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                class AttributeSetXro(Entity):
                    """
                    Attribute Set XRO
                    
                    .. attribute:: xro
                    
                    	The XRO specified by this attribute\-set
                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                        self.yang_name = "attribute-set-xro"
                        self.yang_parent_name = "attribute-set-union"

                        self.xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                        self.xro.parent = self
                        self._children_name_map["xro"] = "xro"
                        self._children_yang_names.add("xro")


                    class Xro(Entity):
                        """
                        The XRO specified by this attribute\-set
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                            self.yang_name = "xro"
                            self.yang_parent_name = "attribute-set-xro"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.xro is not None and self.xro.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.xro is not None and self.xro.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-xro" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "xro"):
                            if (self.xro is None):
                                self.xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                            return self.xro

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "xro"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AttributeSetP2Mpte(Entity):
                    """
                    MPLS TE P2MP\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\:  bool
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\:  bool
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                        self.yang_name = "attribute-set-p2mpte"
                        self.yang_parent_name = "attribute-set-union"

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("configured_bandwidth",
                                        "dste_class_type",
                                        "fast_reroute",
                                        "frr_bandwidth_protection",
                                        "hold_priority",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_priority_configured",
                                        "setup_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2mpte"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2mpte"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.configured_bandwidth.is_set or
                            self.dste_class_type.is_set or
                            self.fast_reroute.is_set or
                            self.frr_bandwidth_protection.is_set or
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.setup_priority.is_set or
                            (self.affinity is not None and self.affinity.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-p2mpte" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-bandwidth-protection"):
                            self.frr_bandwidth_protection = value
                            self.frr_bandwidth_protection.value_namespace = name_space
                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix


                class AttributeSetApsPp(Entity):
                    """
                    Attribute Set OTN APS Path Protection
                    
                    .. attribute:: hold_off_time
                    
                    	Hold\-off time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_prot_profile_type
                    
                    	Path Protection Profile Type
                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                    
                    .. attribute:: protection_mode
                    
                    	Protection Restoration Mode
                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                    
                    .. attribute:: protection_type
                    
                    	Protection Type
                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                    
                    .. attribute:: restoration_style
                    
                    	Restoration Style
                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                    
                    .. attribute:: revert_schedule
                    
                    	Revert Schedule
                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                    
                    .. attribute:: snc_mode
                    
                    	Sub\-network Connection Mode
                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                    
                    .. attribute:: tcm_id
                    
                    	Sub\-network Connection Monitoring Mode
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: wait_to_restore_time
                    
                    	Wait to restore time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                        self.yang_name = "attribute-set-aps-pp"
                        self.yang_parent_name = "attribute-set-union"

                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                        self.revert_schedule = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                        self.revert_schedule.parent = self
                        self._children_name_map["revert_schedule"] = "revert-schedule"
                        self._children_yang_names.add("revert-schedule")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hold_off_time",
                                        "path_prot_profile_type",
                                        "protection_mode",
                                        "protection_type",
                                        "restoration_style",
                                        "snc_mode",
                                        "tcm_id",
                                        "wait_to_restore_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                    class RevertSchedule(Entity):
                        """
                        Revert Schedule
                        
                        .. attribute:: duration
                        
                        	Duration for scheduled reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_tries
                        
                        	Max tries for scheduled reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: schedule_date
                        
                        	Schedule time for reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: schedule_frequency
                        
                        	Schedule frequency for reversion
                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                        
                        .. attribute:: schedulename
                        
                        	Schedule name identifier
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                            self.yang_name = "revert-schedule"
                            self.yang_parent_name = "attribute-set-aps-pp"

                            self.duration = YLeaf(YType.uint32, "duration")

                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                            self.schedulename = YLeaf(YType.str, "schedulename")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("duration",
                                            "max_tries",
                                            "schedule_date",
                                            "schedule_frequency",
                                            "schedulename") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.duration.is_set or
                                self.max_tries.is_set or
                                self.schedule_date.is_set or
                                self.schedule_frequency.is_set or
                                self.schedulename.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.duration.yfilter != YFilter.not_set or
                                self.max_tries.yfilter != YFilter.not_set or
                                self.schedule_date.yfilter != YFilter.not_set or
                                self.schedule_frequency.yfilter != YFilter.not_set or
                                self.schedulename.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "revert-schedule" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.duration.get_name_leafdata())
                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "duration"):
                                self.duration = value
                                self.duration.value_namespace = name_space
                                self.duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-tries"):
                                self.max_tries = value
                                self.max_tries.value_namespace = name_space
                                self.max_tries.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedule-date"):
                                self.schedule_date = value
                                self.schedule_date.value_namespace = name_space
                                self.schedule_date.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedule-frequency"):
                                self.schedule_frequency = value
                                self.schedule_frequency.value_namespace = name_space
                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedulename"):
                                self.schedulename = value
                                self.schedulename.value_namespace = name_space
                                self.schedulename.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.hold_off_time.is_set or
                            self.path_prot_profile_type.is_set or
                            self.protection_mode.is_set or
                            self.protection_type.is_set or
                            self.restoration_style.is_set or
                            self.snc_mode.is_set or
                            self.tcm_id.is_set or
                            self.wait_to_restore_time.is_set or
                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hold_off_time.yfilter != YFilter.not_set or
                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                            self.protection_mode.yfilter != YFilter.not_set or
                            self.protection_type.yfilter != YFilter.not_set or
                            self.restoration_style.yfilter != YFilter.not_set or
                            self.snc_mode.yfilter != YFilter.not_set or
                            self.tcm_id.yfilter != YFilter.not_set or
                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-aps-pp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "revert-schedule"):
                            if (self.revert_schedule is None):
                                self.revert_schedule = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                            return self.revert_schedule

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hold-off-time"):
                            self.hold_off_time = value
                            self.hold_off_time.value_namespace = name_space
                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-prot-profile-type"):
                            self.path_prot_profile_type = value
                            self.path_prot_profile_type.value_namespace = name_space
                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "protection-mode"):
                            self.protection_mode = value
                            self.protection_mode.value_namespace = name_space
                            self.protection_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "protection-type"):
                            self.protection_type = value
                            self.protection_type.value_namespace = name_space
                            self.protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "restoration-style"):
                            self.restoration_style = value
                            self.restoration_style.value_namespace = name_space
                            self.restoration_style.value_namespace_prefix = name_space_prefix
                        if(value_path == "snc-mode"):
                            self.snc_mode = value
                            self.snc_mode.value_namespace = name_space
                            self.snc_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "tcm-id"):
                            self.tcm_id = value
                            self.tcm_id.value_namespace = name_space
                            self.tcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "wait-to-restore-time"):
                            self.wait_to_restore_time = value
                            self.wait_to_restore_time.value_namespace = name_space
                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                class AttributeSetP2PTe(Entity):
                    """
                    MPLS TE P2P\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is Path Invalidation action configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is Path Invalidation timeout configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_select_configured
                    
                    	Is any of the path selection parameters configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_metric_configured
                    
                    	Is path selection metric configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                    
                    	Is path selection segment routing configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_margin_configured
                    
                    	Is path selection margin configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_margin_relative
                    
                    	Path selection margin is\_relative
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                    
                    	Is path selection segment limit configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_prepend_list_configured
                    
                    	Is SR prepend list configured
                    	**type**\:  bool
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_selection_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                    
                    .. attribute:: path_selection_metric
                    
                    	Path selection metric type
                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    .. attribute:: path_selection_segment_routing_adjacency_protection
                    
                    	Path selection segment\-routing type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: path_selection_segment_routing_margin
                    
                    	Path selection margin
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_selection_segment_routing_segment_limit
                    
                    	Is path selection segment limit configured
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    .. attribute:: prepend_list
                    
                    	SR prepend list
                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                        self.yang_name = "attribute-set-p2p-te"
                        self.yang_parent_name = "attribute-set-union"

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.prepend_list = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                        self.prepend_list.parent = self
                        self._children_name_map["prepend_list"] = "prepend-list"
                        self._children_yang_names.add("prepend-list")

                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_affinity_configured",
                                        "is_path_invalidation_action_configured",
                                        "is_path_invalidation_timeout_configured",
                                        "is_path_select_configured",
                                        "is_path_selection_metric_configured",
                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                        "is_path_selection_segment_routing_margin_configured",
                                        "is_path_selection_segment_routing_margin_relative",
                                        "is_path_selection_segment_routing_segment_limit_configured",
                                        "is_pce_configured",
                                        "is_pce_disj_group_id_configured",
                                        "is_pce_disj_source_configured",
                                        "is_pce_disj_type_configured",
                                        "is_pceb_dj_source_configured",
                                        "is_pcebd_group_id_configured",
                                        "is_prepend_list_configured",
                                        "path_invalidation_timeout",
                                        "path_selection_invalidation_action",
                                        "path_selection_metric",
                                        "path_selection_segment_routing_adjacency_protection",
                                        "path_selection_segment_routing_margin",
                                        "path_selection_segment_routing_segment_limit",
                                        "pcebd_group_id",
                                        "pcebd_source_address",
                                        "pcedp_group_id",
                                        "pcedp_source_address",
                                        "pcedp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PrependList(Entity):
                        """
                        SR prepend list
                        
                        .. attribute:: prepend_entry
                        
                        	List of prepend entries
                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                            self.yang_name = "prepend-list"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.prepend_entry = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                        class PrependEntry(Entity):
                            """
                            List of prepend entries
                            
                            .. attribute:: index
                            
                            	Prepend index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: next_label
                            
                            	Prepend next label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: type
                            
                            	Prepend Type
                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                self.yang_name = "prepend-entry"
                                self.yang_parent_name = "prepend-list"

                                self.index = YLeaf(YType.uint32, "index")

                                self.next_label = YLeaf(YType.uint32, "next-label")

                                self.type = YLeaf(YType.enumeration, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("index",
                                                "next_label",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.index.is_set or
                                    self.next_label.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.index.yfilter != YFilter.not_set or
                                    self.next_label.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "prepend-entry" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.index.get_name_leafdata())
                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "index" or name == "next-label" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "index"):
                                    self.index = value
                                    self.index.value_namespace = name_space
                                    self.index.value_namespace_prefix = name_space_prefix
                                if(value_path == "next-label"):
                                    self.next_label = value
                                    self.next_label.value_namespace = name_space
                                    self.next_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.prepend_entry:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.prepend_entry:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "prepend-list" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "prepend-entry"):
                                for c in self.prepend_entry:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.prepend_entry.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prepend-entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_affinity_configured.is_set or
                            self.is_path_invalidation_action_configured.is_set or
                            self.is_path_invalidation_timeout_configured.is_set or
                            self.is_path_select_configured.is_set or
                            self.is_path_selection_metric_configured.is_set or
                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                            self.is_path_selection_segment_routing_margin_configured.is_set or
                            self.is_path_selection_segment_routing_margin_relative.is_set or
                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                            self.is_pce_configured.is_set or
                            self.is_pce_disj_group_id_configured.is_set or
                            self.is_pce_disj_source_configured.is_set or
                            self.is_pce_disj_type_configured.is_set or
                            self.is_pceb_dj_source_configured.is_set or
                            self.is_pcebd_group_id_configured.is_set or
                            self.is_prepend_list_configured.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_selection_invalidation_action.is_set or
                            self.path_selection_metric.is_set or
                            self.path_selection_segment_routing_adjacency_protection.is_set or
                            self.path_selection_segment_routing_margin.is_set or
                            self.path_selection_segment_routing_segment_limit.is_set or
                            self.pcebd_group_id.is_set or
                            self.pcebd_source_address.is_set or
                            self.pcedp_group_id.is_set or
                            self.pcedp_source_address.is_set or
                            self.pcedp_type.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()) or
                            (self.prepend_list is not None and self.prepend_list.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                            self.is_path_select_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                            self.is_pce_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                            self.path_selection_metric.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                            self.pcebd_group_id.yfilter != YFilter.not_set or
                            self.pcebd_source_address.yfilter != YFilter.not_set or
                            self.pcedp_group_id.yfilter != YFilter.not_set or
                            self.pcedp_source_address.yfilter != YFilter.not_set or
                            self.pcedp_type.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()) or
                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-p2p-te" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "prepend-list"):
                            if (self.prepend_list is None):
                                self.prepend_list = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                            return self.prepend_list

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-action-configured"):
                            self.is_path_invalidation_action_configured = value
                            self.is_path_invalidation_action_configured.value_namespace = name_space
                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-timeout-configured"):
                            self.is_path_invalidation_timeout_configured = value
                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-select-configured"):
                            self.is_path_select_configured = value
                            self.is_path_select_configured.value_namespace = name_space
                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-metric-configured"):
                            self.is_path_selection_metric_configured = value
                            self.is_path_selection_metric_configured.value_namespace = name_space
                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                            self.is_path_selection_segment_routing_margin_configured = value
                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                            self.is_path_selection_segment_routing_margin_relative = value
                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                            self.is_path_selection_segment_routing_segment_limit_configured = value
                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-configured"):
                            self.is_pce_configured = value
                            self.is_pce_configured.value_namespace = name_space
                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-group-id-configured"):
                            self.is_pce_disj_group_id_configured = value
                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-source-configured"):
                            self.is_pce_disj_source_configured = value
                            self.is_pce_disj_source_configured.value_namespace = name_space
                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-type-configured"):
                            self.is_pce_disj_type_configured = value
                            self.is_pce_disj_type_configured.value_namespace = name_space
                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pceb-dj-source-configured"):
                            self.is_pceb_dj_source_configured = value
                            self.is_pceb_dj_source_configured.value_namespace = name_space
                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pcebd-group-id-configured"):
                            self.is_pcebd_group_id_configured = value
                            self.is_pcebd_group_id_configured.value_namespace = name_space
                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-prepend-list-configured"):
                            self.is_prepend_list_configured = value
                            self.is_prepend_list_configured.value_namespace = name_space
                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-invalidation-action"):
                            self.path_selection_invalidation_action = value
                            self.path_selection_invalidation_action.value_namespace = name_space
                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-metric"):
                            self.path_selection_metric = value
                            self.path_selection_metric.value_namespace = name_space
                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                            self.path_selection_segment_routing_adjacency_protection = value
                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-margin"):
                            self.path_selection_segment_routing_margin = value
                            self.path_selection_segment_routing_margin.value_namespace = name_space
                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-segment-limit"):
                            self.path_selection_segment_routing_segment_limit = value
                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-group-id"):
                            self.pcebd_group_id = value
                            self.pcebd_group_id.value_namespace = name_space
                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-source-address"):
                            self.pcebd_source_address = value
                            self.pcebd_source_address.value_namespace = name_space
                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-group-id"):
                            self.pcedp_group_id = value
                            self.pcedp_group_id.value_namespace = name_space
                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-source-address"):
                            self.pcedp_source_address = value
                            self.pcedp_source_address.value_namespace = name_space
                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-type"):
                            self.pcedp_type = value
                            self.pcedp_type.value_namespace = name_space
                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_attribute_set_type.is_set or
                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "attribute-set-union" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "attribute-set-aps-pp"):
                        if (self.attribute_set_aps_pp is None):
                            self.attribute_set_aps_pp = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                        return self.attribute_set_aps_pp

                    if (child_yang_name == "attribute-set-autobackup"):
                        if (self.attribute_set_autobackup is None):
                            self.attribute_set_autobackup = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                        return self.attribute_set_autobackup

                    if (child_yang_name == "attribute-set-automesh"):
                        if (self.attribute_set_automesh is None):
                            self.attribute_set_automesh = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                        return self.attribute_set_automesh

                    if (child_yang_name == "attribute-set-p2mpte"):
                        if (self.attribute_set_p2mpte is None):
                            self.attribute_set_p2mpte = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                        return self.attribute_set_p2mpte

                    if (child_yang_name == "attribute-set-p2p-te"):
                        if (self.attribute_set_p2p_te is None):
                            self.attribute_set_p2p_te = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                        return self.attribute_set_p2p_te

                    if (child_yang_name == "attribute-set-path-option"):
                        if (self.attribute_set_path_option is None):
                            self.attribute_set_path_option = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                        return self.attribute_set_path_option

                    if (child_yang_name == "attribute-set-xro"):
                        if (self.attribute_set_xro is None):
                            self.attribute_set_xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                        return self.attribute_set_xro

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.attribute_set_type.is_set or
                    self.attribute_set_name.is_set or
                    self.tunnel_attribute_set_name.is_set or
                    self.tunnel_attribute_set_name_crc32.is_set or
                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.attribute_set_type.yfilter != YFilter.not_set or
                    self.attribute_set_name.yfilter != YFilter.not_set or
                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "attribute-set" + "[attribute-set-type='" + self.attribute_set_type.get() + "']" + "[attribute-set-name='" + self.attribute_set_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/attribute-sets/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.attribute_set_type.is_set or self.attribute_set_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.attribute_set_type.get_name_leafdata())
                if (self.attribute_set_name.is_set or self.attribute_set_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.attribute_set_name.get_name_leafdata())
                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "attribute-set-union"):
                    if (self.attribute_set_union is None):
                        self.attribute_set_union = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                    return self.attribute_set_union

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "attribute-set-union" or name == "attribute-set-type" or name == "attribute-set-name" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "attribute-set-type"):
                    self.attribute_set_type = value
                    self.attribute_set_type.value_namespace = name_space
                    self.attribute_set_type.value_namespace_prefix = name_space_prefix
                if(value_path == "attribute-set-name"):
                    self.attribute_set_name = value
                    self.attribute_set_name.value_namespace = name_space
                    self.attribute_set_name.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-attribute-set-name"):
                    self.tunnel_attribute_set_name = value
                    self.tunnel_attribute_set_name.value_namespace = name_space
                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-attribute-set-name-crc32"):
                    self.tunnel_attribute_set_name_crc32 = value
                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.attribute_set:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.attribute_set:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "attribute-sets" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "attribute-set"):
                for c in self.attribute_set:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.AttributeSets.AttributeSet()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.attribute_set.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "attribute-set"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class IgpAreaBriefs(Entity):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area_brief
        
        	An IGP instance Brief info
        	**type**\: list of    :py:class:`IgpAreaBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.IgpAreaBriefs, self).__init__()

            self.yang_name = "igp-area-briefs"
            self.yang_parent_name = "mpls-te"

            self.igp_area_brief = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.IgpAreaBriefs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.IgpAreaBriefs, self).__setattr__(name, value)


        class IgpAreaBrief(Entity):
            """
            An IGP instance Brief info
            
            .. attribute:: protocol  <key>
            
            	The IGP protocol
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: process_tag  <key>
            
            	IGP Process Tag
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area>`
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\:  str
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\:  str
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\:  bool
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of    :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.IgpAreaBriefs.IgpAreaBrief, self).__init__()

                self.yang_name = "igp-area-brief"
                self.yang_parent_name = "igp-area-briefs"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.process_tag = YLeaf(YType.str, "process-tag")

                self.configured_te_router_id = YLeaf(YType.str, "configured-te-router-id")

                self.connection_down_count = YLeaf(YType.uint32, "connection-down-count")

                self.connection_up_count = YLeaf(YType.uint32, "connection-up-count")

                self.global_router_id = YLeaf(YType.str, "global-router-id")

                self.globall_router_id_optical = YLeaf(YType.str, "globall-router-id-optical")

                self.igp_system_id = YLeaf(YType.str, "igp-system-id")

                self.igp_type = YLeaf(YType.enumeration, "igp-type")

                self.in_use_te_router_id = YLeaf(YType.str, "in-use-te-router-id")

                self.instance_name = YLeaf(YType.str, "instance-name")

                self.is_connection_up = YLeaf(YType.boolean, "is-connection-up")

                self.area = YList(self)
                self.secondary_router_id = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "process_tag",
                                "configured_te_router_id",
                                "connection_down_count",
                                "connection_up_count",
                                "global_router_id",
                                "globall_router_id_optical",
                                "igp_system_id",
                                "igp_type",
                                "in_use_te_router_id",
                                "instance_name",
                                "is_connection_up") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.IgpAreaBriefs.IgpAreaBrief, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.IgpAreaBriefs.IgpAreaBrief, self).__setattr__(name, value)


            class SecondaryRouterId(Entity):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area-brief"

                    self.entry = YLeaf(YType.str, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "secondary-router-id" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix


            class Area(Entity):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:   :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData>`
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_number
                
                	Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area-brief"

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.area_index = YLeaf(YType.uint32, "area-index")

                    self.area_number = YLeaf(YType.uint32, "area-number")

                    self.is_config_ready = YLeaf(YType.boolean, "is-config-ready")

                    self.active_data = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._children_yang_names.add("active-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_format",
                                    "area_index",
                                    "area_number",
                                    "is_config_ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area, self).__setattr__(name, value)


                class ActiveData(Entity):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:   :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics>`
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\:  bool
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\:  bool
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"

                        self.interfaces_count = YLeaf(YType.uint32, "interfaces-count")

                        self.link_idt_received = YLeaf(YType.boolean, "link-idt-received")

                        self.p2mp_destination_count = YLeaf(YType.uint32, "p2mp-destination-count")

                        self.p2p_autoroute_announced_count = YLeaf(YType.uint32, "p2p-autoroute-announced-count")

                        self.p2p_forwarding_adjacency_count = YLeaf(YType.uint32, "p2p-forwarding-adjacency-count")

                        self.p2p_heads_count = YLeaf(YType.uint32, "p2p-heads-count")

                        self.sr_strict = YLeaf(YType.boolean, "sr-strict")

                        self.topology_idt_received = YLeaf(YType.boolean, "topology-idt-received")

                        self.tunnel_loose_hops = YLeaf(YType.uint32, "tunnel-loose-hops")

                        self.area_statistics = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._children_yang_names.add("area-statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interfaces_count",
                                        "link_idt_received",
                                        "p2mp_destination_count",
                                        "p2p_autoroute_announced_count",
                                        "p2p_forwarding_adjacency_count",
                                        "p2p_heads_count",
                                        "sr_strict",
                                        "topology_idt_received",
                                        "tunnel_loose_hops") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__setattr__(name, value)


                    class AreaStatistics(Entity):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"

                            self.area_adjacency_announce_messages = YLeaf(YType.uint32, "area-adjacency-announce-messages")

                            self.area_adjacency_request_messages = YLeaf(YType.uint32, "area-adjacency-request-messages")

                            self.area_flood_messages = YLeaf(YType.uint32, "area-flood-messages")

                            self.area_lsa_announce_messages = YLeaf(YType.uint32, "area-lsa-announce-messages")

                            self.area_lsa_delete_messages = YLeaf(YType.uint32, "area-lsa-delete-messages")

                            self.area_lsa_fragment_announce_messages = YLeaf(YType.uint32, "area-lsa-fragment-announce-messages")

                            self.area_lsa_fragment_delete_messages = YLeaf(YType.uint32, "area-lsa-fragment-delete-messages")

                            self.area_tunnel_announce_messages = YLeaf(YType.uint32, "area-tunnel-announce-messages")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_adjacency_announce_messages",
                                            "area_adjacency_request_messages",
                                            "area_flood_messages",
                                            "area_lsa_announce_messages",
                                            "area_lsa_delete_messages",
                                            "area_lsa_fragment_announce_messages",
                                            "area_lsa_fragment_delete_messages",
                                            "area_tunnel_announce_messages") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.area_adjacency_announce_messages.is_set or
                                self.area_adjacency_request_messages.is_set or
                                self.area_flood_messages.is_set or
                                self.area_lsa_announce_messages.is_set or
                                self.area_lsa_delete_messages.is_set or
                                self.area_lsa_fragment_announce_messages.is_set or
                                self.area_lsa_fragment_delete_messages.is_set or
                                self.area_tunnel_announce_messages.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_adjacency_announce_messages.yfilter != YFilter.not_set or
                                self.area_adjacency_request_messages.yfilter != YFilter.not_set or
                                self.area_flood_messages.yfilter != YFilter.not_set or
                                self.area_lsa_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_delete_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set or
                                self.area_tunnel_announce_messages.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_adjacency_announce_messages.is_set or self.area_adjacency_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_announce_messages.get_name_leafdata())
                            if (self.area_adjacency_request_messages.is_set or self.area_adjacency_request_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_request_messages.get_name_leafdata())
                            if (self.area_flood_messages.is_set or self.area_flood_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_flood_messages.get_name_leafdata())
                            if (self.area_lsa_announce_messages.is_set or self.area_lsa_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_announce_messages.get_name_leafdata())
                            if (self.area_lsa_delete_messages.is_set or self.area_lsa_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_delete_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_announce_messages.is_set or self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_announce_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_delete_messages.is_set or self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_delete_messages.get_name_leafdata())
                            if (self.area_tunnel_announce_messages.is_set or self.area_tunnel_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_tunnel_announce_messages.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-adjacency-announce-messages" or name == "area-adjacency-request-messages" or name == "area-flood-messages" or name == "area-lsa-announce-messages" or name == "area-lsa-delete-messages" or name == "area-lsa-fragment-announce-messages" or name == "area-lsa-fragment-delete-messages" or name == "area-tunnel-announce-messages"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-adjacency-announce-messages"):
                                self.area_adjacency_announce_messages = value
                                self.area_adjacency_announce_messages.value_namespace = name_space
                                self.area_adjacency_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-adjacency-request-messages"):
                                self.area_adjacency_request_messages = value
                                self.area_adjacency_request_messages.value_namespace = name_space
                                self.area_adjacency_request_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-flood-messages"):
                                self.area_flood_messages = value
                                self.area_flood_messages.value_namespace = name_space
                                self.area_flood_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-announce-messages"):
                                self.area_lsa_announce_messages = value
                                self.area_lsa_announce_messages.value_namespace = name_space
                                self.area_lsa_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-delete-messages"):
                                self.area_lsa_delete_messages = value
                                self.area_lsa_delete_messages.value_namespace = name_space
                                self.area_lsa_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-announce-messages"):
                                self.area_lsa_fragment_announce_messages = value
                                self.area_lsa_fragment_announce_messages.value_namespace = name_space
                                self.area_lsa_fragment_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-delete-messages"):
                                self.area_lsa_fragment_delete_messages = value
                                self.area_lsa_fragment_delete_messages.value_namespace = name_space
                                self.area_lsa_fragment_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-tunnel-announce-messages"):
                                self.area_tunnel_announce_messages = value
                                self.area_tunnel_announce_messages.value_namespace = name_space
                                self.area_tunnel_announce_messages.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.interfaces_count.is_set or
                            self.link_idt_received.is_set or
                            self.p2mp_destination_count.is_set or
                            self.p2p_autoroute_announced_count.is_set or
                            self.p2p_forwarding_adjacency_count.is_set or
                            self.p2p_heads_count.is_set or
                            self.sr_strict.is_set or
                            self.topology_idt_received.is_set or
                            self.tunnel_loose_hops.is_set or
                            (self.area_statistics is not None and self.area_statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interfaces_count.yfilter != YFilter.not_set or
                            self.link_idt_received.yfilter != YFilter.not_set or
                            self.p2mp_destination_count.yfilter != YFilter.not_set or
                            self.p2p_autoroute_announced_count.yfilter != YFilter.not_set or
                            self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set or
                            self.p2p_heads_count.yfilter != YFilter.not_set or
                            self.sr_strict.yfilter != YFilter.not_set or
                            self.topology_idt_received.yfilter != YFilter.not_set or
                            self.tunnel_loose_hops.yfilter != YFilter.not_set or
                            (self.area_statistics is not None and self.area_statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "active-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interfaces_count.is_set or self.interfaces_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interfaces_count.get_name_leafdata())
                        if (self.link_idt_received.is_set or self.link_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_idt_received.get_name_leafdata())
                        if (self.p2mp_destination_count.is_set or self.p2mp_destination_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2mp_destination_count.get_name_leafdata())
                        if (self.p2p_autoroute_announced_count.is_set or self.p2p_autoroute_announced_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_autoroute_announced_count.get_name_leafdata())
                        if (self.p2p_forwarding_adjacency_count.is_set or self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_forwarding_adjacency_count.get_name_leafdata())
                        if (self.p2p_heads_count.is_set or self.p2p_heads_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_heads_count.get_name_leafdata())
                        if (self.sr_strict.is_set or self.sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sr_strict.get_name_leafdata())
                        if (self.topology_idt_received.is_set or self.topology_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_idt_received.get_name_leafdata())
                        if (self.tunnel_loose_hops.is_set or self.tunnel_loose_hops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loose_hops.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-statistics"):
                            if (self.area_statistics is None):
                                self.area_statistics = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                                self.area_statistics.parent = self
                                self._children_name_map["area_statistics"] = "area-statistics"
                            return self.area_statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-statistics" or name == "interfaces-count" or name == "link-idt-received" or name == "p2mp-destination-count" or name == "p2p-autoroute-announced-count" or name == "p2p-forwarding-adjacency-count" or name == "p2p-heads-count" or name == "sr-strict" or name == "topology-idt-received" or name == "tunnel-loose-hops"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interfaces-count"):
                            self.interfaces_count = value
                            self.interfaces_count.value_namespace = name_space
                            self.interfaces_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-idt-received"):
                            self.link_idt_received = value
                            self.link_idt_received.value_namespace = name_space
                            self.link_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2mp-destination-count"):
                            self.p2mp_destination_count = value
                            self.p2mp_destination_count.value_namespace = name_space
                            self.p2mp_destination_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-autoroute-announced-count"):
                            self.p2p_autoroute_announced_count = value
                            self.p2p_autoroute_announced_count.value_namespace = name_space
                            self.p2p_autoroute_announced_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-forwarding-adjacency-count"):
                            self.p2p_forwarding_adjacency_count = value
                            self.p2p_forwarding_adjacency_count.value_namespace = name_space
                            self.p2p_forwarding_adjacency_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-heads-count"):
                            self.p2p_heads_count = value
                            self.p2p_heads_count.value_namespace = name_space
                            self.p2p_heads_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "sr-strict"):
                            self.sr_strict = value
                            self.sr_strict.value_namespace = name_space
                            self.sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-idt-received"):
                            self.topology_idt_received = value
                            self.topology_idt_received.value_namespace = name_space
                            self.topology_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loose-hops"):
                            self.tunnel_loose_hops = value
                            self.tunnel_loose_hops.value_namespace = name_space
                            self.tunnel_loose_hops.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_format.is_set or
                        self.area_index.is_set or
                        self.area_number.is_set or
                        self.is_config_ready.is_set or
                        (self.active_data is not None and self.active_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.area_index.yfilter != YFilter.not_set or
                        self.area_number.yfilter != YFilter.not_set or
                        self.is_config_ready.yfilter != YFilter.not_set or
                        (self.active_data is not None and self.active_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "area" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.area_index.is_set or self.area_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_index.get_name_leafdata())
                    if (self.area_number.is_set or self.area_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_number.get_name_leafdata())
                    if (self.is_config_ready.is_set or self.is_config_ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_config_ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "active-data"):
                        if (self.active_data is None):
                            self.active_data = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                            self.active_data.parent = self
                            self._children_name_map["active_data"] = "active-data"
                        return self.active_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active-data" or name == "area-format" or name == "area-index" or name == "area-number" or name == "is-config-ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-index"):
                        self.area_index = value
                        self.area_index.value_namespace = name_space
                        self.area_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-number"):
                        self.area_number = value
                        self.area_number.value_namespace = name_space
                        self.area_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-config-ready"):
                        self.is_config_ready = value
                        self.is_config_ready.value_namespace = name_space
                        self.is_config_ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.area:
                    if (c.has_data()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.process_tag.is_set or
                    self.configured_te_router_id.is_set or
                    self.connection_down_count.is_set or
                    self.connection_up_count.is_set or
                    self.global_router_id.is_set or
                    self.globall_router_id_optical.is_set or
                    self.igp_system_id.is_set or
                    self.igp_type.is_set or
                    self.in_use_te_router_id.is_set or
                    self.instance_name.is_set or
                    self.is_connection_up.is_set)

            def has_operation(self):
                for c in self.area:
                    if (c.has_operation()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.process_tag.yfilter != YFilter.not_set or
                    self.configured_te_router_id.yfilter != YFilter.not_set or
                    self.connection_down_count.yfilter != YFilter.not_set or
                    self.connection_up_count.yfilter != YFilter.not_set or
                    self.global_router_id.yfilter != YFilter.not_set or
                    self.globall_router_id_optical.yfilter != YFilter.not_set or
                    self.igp_system_id.yfilter != YFilter.not_set or
                    self.igp_type.yfilter != YFilter.not_set or
                    self.in_use_te_router_id.yfilter != YFilter.not_set or
                    self.instance_name.yfilter != YFilter.not_set or
                    self.is_connection_up.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-area-brief" + "[protocol='" + self.protocol.get() + "']" + "[process-tag='" + self.process_tag.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/igp-area-briefs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.process_tag.is_set or self.process_tag.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.process_tag.get_name_leafdata())
                if (self.configured_te_router_id.is_set or self.configured_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_te_router_id.get_name_leafdata())
                if (self.connection_down_count.is_set or self.connection_down_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_down_count.get_name_leafdata())
                if (self.connection_up_count.is_set or self.connection_up_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_up_count.get_name_leafdata())
                if (self.global_router_id.is_set or self.global_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.global_router_id.get_name_leafdata())
                if (self.globall_router_id_optical.is_set or self.globall_router_id_optical.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.globall_router_id_optical.get_name_leafdata())
                if (self.igp_system_id.is_set or self.igp_system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_system_id.get_name_leafdata())
                if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_type.get_name_leafdata())
                if (self.in_use_te_router_id.is_set or self.in_use_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.in_use_te_router_id.get_name_leafdata())
                if (self.instance_name.is_set or self.instance_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.instance_name.get_name_leafdata())
                if (self.is_connection_up.is_set or self.is_connection_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_connection_up.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "area"):
                    for c in self.area:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.area.append(c)
                    return c

                if (child_yang_name == "secondary-router-id"):
                    for c in self.secondary_router_id:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.secondary_router_id.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area" or name == "secondary-router-id" or name == "protocol" or name == "process-tag" or name == "configured-te-router-id" or name == "connection-down-count" or name == "connection-up-count" or name == "global-router-id" or name == "globall-router-id-optical" or name == "igp-system-id" or name == "igp-type" or name == "in-use-te-router-id" or name == "instance-name" or name == "is-connection-up"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "process-tag"):
                    self.process_tag = value
                    self.process_tag.value_namespace = name_space
                    self.process_tag.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-te-router-id"):
                    self.configured_te_router_id = value
                    self.configured_te_router_id.value_namespace = name_space
                    self.configured_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-down-count"):
                    self.connection_down_count = value
                    self.connection_down_count.value_namespace = name_space
                    self.connection_down_count.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-up-count"):
                    self.connection_up_count = value
                    self.connection_up_count.value_namespace = name_space
                    self.connection_up_count.value_namespace_prefix = name_space_prefix
                if(value_path == "global-router-id"):
                    self.global_router_id = value
                    self.global_router_id.value_namespace = name_space
                    self.global_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "globall-router-id-optical"):
                    self.globall_router_id_optical = value
                    self.globall_router_id_optical.value_namespace = name_space
                    self.globall_router_id_optical.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-system-id"):
                    self.igp_system_id = value
                    self.igp_system_id.value_namespace = name_space
                    self.igp_system_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-type"):
                    self.igp_type = value
                    self.igp_type.value_namespace = name_space
                    self.igp_type.value_namespace_prefix = name_space_prefix
                if(value_path == "in-use-te-router-id"):
                    self.in_use_te_router_id = value
                    self.in_use_te_router_id.value_namespace = name_space
                    self.in_use_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "instance-name"):
                    self.instance_name = value
                    self.instance_name.value_namespace = name_space
                    self.instance_name.value_namespace_prefix = name_space_prefix
                if(value_path == "is-connection-up"):
                    self.is_connection_up = value
                    self.is_connection_up.value_namespace = name_space
                    self.is_connection_up.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.igp_area_brief:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.igp_area_brief:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "igp-area-briefs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-area-brief"):
                for c in self.igp_area_brief:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.IgpAreaBriefs.IgpAreaBrief()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.igp_area_brief.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-area-brief"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Tunnels(Entity):
        """
        Failure protection provided for tunnels
        
        .. attribute:: summary
        
        	Summary of tunnel info
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary>`
        
        .. attribute:: tunnel_auto_bandwidths
        
        	Auto Bandwidth Brief Table
        	**type**\:   :py:class:`TunnelAutoBandwidths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths>`
        
        .. attribute:: tunnel_flex_lsps
        
        	Flex LSP
        	**type**\:   :py:class:`TunnelFlexLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps>`
        
        .. attribute:: tunnel_path_protections
        
        	Path protection
        	**type**\:   :py:class:`TunnelPathProtections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-te"

            self.summary = MplsTe.Tunnels.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")

            self.tunnel_auto_bandwidths = MplsTe.Tunnels.TunnelAutoBandwidths()
            self.tunnel_auto_bandwidths.parent = self
            self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"
            self._children_yang_names.add("tunnel-auto-bandwidths")

            self.tunnel_flex_lsps = MplsTe.Tunnels.TunnelFlexLsps()
            self.tunnel_flex_lsps.parent = self
            self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"
            self._children_yang_names.add("tunnel-flex-lsps")

            self.tunnel_path_protections = MplsTe.Tunnels.TunnelPathProtections()
            self.tunnel_path_protections.parent = self
            self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
            self._children_yang_names.add("tunnel-path-protections")


        class TunnelFlexLsps(Entity):
            """
            Flex LSP
            
            .. attribute:: tunnel_flex_lsp
            
            	Flex LSP
            	**type**\: list of    :py:class:`TunnelFlexLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Tunnels.TunnelFlexLsps, self).__init__()

                self.yang_name = "tunnel-flex-lsps"
                self.yang_parent_name = "tunnels"

                self.tunnel_flex_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Tunnels.TunnelFlexLsps, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Tunnels.TunnelFlexLsps, self).__setattr__(name, value)


            class TunnelFlexLsp(Entity):
                """
                Flex LSP
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\:  bool
                
                .. attribute:: protect_lsp
                
                	 Protect LSP info
                	**type**\:   :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp>`
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tun_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: working_lsp
                
                	 Working LSP info
                	**type**\:   :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__init__()

                    self.yang_name = "tunnel-flex-lsp"
                    self.yang_parent_name = "tunnel-flex-lsps"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.is_tunnel_up = YLeaf(YType.boolean, "is-tunnel-up")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tun_id = YLeaf(YType.uint16, "tun-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.protect_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._children_yang_names.add("protect-lsp")

                    self.working_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"
                    self._children_yang_names.add("working-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "is_tunnel_up",
                                    "source_address",
                                    "tun_id",
                                    "tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__setattr__(name, value)


                class WorkingLsp(Entity):
                    """
                     Working LSP info
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association>`
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo>`
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\:  bool
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection>`
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:   :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"

                        self.is_operational = YLeaf(YType.boolean, "is-operational")

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"
                        self._children_yang_names.add("reverse-lsp")

                        self.lsp_hop = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_operational",
                                        "lsp_local_label",
                                        "lsp_mode",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__setattr__(name, value)


                    class FlexInfo(Entity):
                        """
                        Flex Info
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "working-lsp"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/flex-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "working-lsp"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/association/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "working-lsp"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLsp(Entity):
                        """
                        Reverse LSP information
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "working-lsp"

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reverse_lsp_connected",
                                            "reverse_lsp_present") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__setattr__(name, value)


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/reverse-lsp-fec/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/association/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_present.is_set or
                                (self.association is not None and self.association.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                (self.association is not None and self.association.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association" or name == "protection" or name == "reverse-lsp-fec" or name == "reverse-lsp-connected" or name == "reverse-lsp-present"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "working-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_operational.is_set or
                            self.lsp_local_label.is_set or
                            self.lsp_mode.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set or
                            (self.association is not None and self.association.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_data()))

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_operational.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_mode.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set or
                            (self.association is not None and self.association.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "working-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_operational.is_set or self.is_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_operational.get_name_leafdata())
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "reverse-lsp"):
                            if (self.reverse_lsp is None):
                                self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                                self.reverse_lsp.parent = self
                                self._children_name_map["reverse_lsp"] = "reverse-lsp"
                            return self.reverse_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "association" or name == "flex-info" or name == "lsp-hop" or name == "protection" or name == "reverse-lsp" or name == "is-operational" or name == "lsp-local-label" or name == "lsp-mode" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-operational"):
                            self.is_operational = value
                            self.is_operational.value_namespace = name_space
                            self.is_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-mode"):
                            self.lsp_mode = value
                            self.lsp_mode.value_namespace = name_space
                            self.lsp_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix


                class ProtectLsp(Entity):
                    """
                     Protect LSP info
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association>`
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo>`
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\:  bool
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection>`
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:   :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"

                        self.is_operational = YLeaf(YType.boolean, "is-operational")

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"
                        self._children_yang_names.add("reverse-lsp")

                        self.lsp_hop = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_operational",
                                        "lsp_local_label",
                                        "lsp_mode",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__setattr__(name, value)


                    class FlexInfo(Entity):
                        """
                        Flex Info
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "protect-lsp"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/flex-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "protect-lsp"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/association/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "protect-lsp"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLsp(Entity):
                        """
                        Reverse LSP information
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "protect-lsp"

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reverse_lsp_connected",
                                            "reverse_lsp_present") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__setattr__(name, value)


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/reverse-lsp-fec/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/association/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_present.is_set or
                                (self.association is not None and self.association.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                (self.association is not None and self.association.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association" or name == "protection" or name == "reverse-lsp-fec" or name == "reverse-lsp-connected" or name == "reverse-lsp-present"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "protect-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_operational.is_set or
                            self.lsp_local_label.is_set or
                            self.lsp_mode.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set or
                            (self.association is not None and self.association.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_data()))

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_operational.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_mode.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set or
                            (self.association is not None and self.association.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protect-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_operational.is_set or self.is_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_operational.get_name_leafdata())
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "reverse-lsp"):
                            if (self.reverse_lsp is None):
                                self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                                self.reverse_lsp.parent = self
                                self._children_name_map["reverse_lsp"] = "reverse-lsp"
                            return self.reverse_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "association" or name == "flex-info" or name == "lsp-hop" or name == "protection" or name == "reverse-lsp" or name == "is-operational" or name == "lsp-local-label" or name == "lsp-mode" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-operational"):
                            self.is_operational = value
                            self.is_operational.value_namespace = name_space
                            self.is_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-mode"):
                            self.lsp_mode = value
                            self.lsp_mode.value_namespace = name_space
                            self.lsp_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.is_tunnel_up.is_set or
                        self.source_address.is_set or
                        self.tun_id.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_name.is_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_data()) or
                        (self.working_lsp is not None and self.working_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.is_tunnel_up.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tun_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_operation()) or
                        (self.working_lsp is not None and self.working_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-flex-lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.is_tunnel_up.is_set or self.is_tunnel_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_tunnel_up.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tun_id.is_set or self.tun_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tun_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "protect-lsp"):
                        if (self.protect_lsp is None):
                            self.protect_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                            self.protect_lsp.parent = self
                            self._children_name_map["protect_lsp"] = "protect-lsp"
                        return self.protect_lsp

                    if (child_yang_name == "working-lsp"):
                        if (self.working_lsp is None):
                            self.working_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                            self.working_lsp.parent = self
                            self._children_name_map["working_lsp"] = "working-lsp"
                        return self.working_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "protect-lsp" or name == "working-lsp" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "is-tunnel-up" or name == "source-address" or name == "tun-id" or name == "tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-tunnel-up"):
                        self.is_tunnel_up = value
                        self.is_tunnel_up.value_namespace = name_space
                        self.is_tunnel_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tun-id"):
                        self.tun_id = value
                        self.tun_id.value_namespace = name_space
                        self.tun_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_flex_lsp:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_flex_lsp:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-flex-lsps" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-flex-lsp"):
                    for c in self.tunnel_flex_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_flex_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-flex-lsp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelAutoBandwidths(Entity):
            """
            Auto Bandwidth Brief Table
            
            .. attribute:: tunnel_auto_bandwidth
            
            	Auto Bandwidth info bag
            	**type**\: list of    :py:class:`TunnelAutoBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Tunnels.TunnelAutoBandwidths, self).__init__()

                self.yang_name = "tunnel-auto-bandwidths"
                self.yang_parent_name = "tunnels"

                self.tunnel_auto_bandwidth = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Tunnels.TunnelAutoBandwidths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Tunnels.TunnelAutoBandwidths, self).__setattr__(name, value)


            class TunnelAutoBandwidth(Entity):
                """
                Auto Bandwidth info bag
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: auto_bandwidth_status
                
                	Tunnels's AutoBandwidth Status information
                	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus>`
                
                .. attribute:: bandwidth_applications
                
                	Total number of bandwidth applications requested by auto\-bw
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: highest_bandwidth
                
                	Highest bandwidth registered within current application period
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_bandwidth_applied
                
                	Last bandwidth requested by auto\-bw for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_sample_bandwidth
                
                	Last sample bandwidth collected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: samples_collected
                
                	Number of samples collected within current application period
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: signaled_name
                
                	Tunnel signaled name
                	**type**\:  str
                
                .. attribute:: signalled_bandwidth
                
                	Signalled bandwidth for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: time_left_application
                
                	Time left until next auto\-bw application algorithm is performed
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_lsp_id
                
                	Tunnel Lsp Id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\:  str
                
                .. attribute:: tunnel_requested_bandwidth
                
                	Requested Bandwidth for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__init__()

                    self.yang_name = "tunnel-auto-bandwidth"
                    self.yang_parent_name = "tunnel-auto-bandwidths"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                    self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                    self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                    self.last_sample_bandwidth = YLeaf(YType.uint32, "last-sample-bandwidth")

                    self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.signalled_bandwidth = YLeaf(YType.uint32, "signalled-bandwidth")

                    self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                    self.tunnel_name_xr = YLeaf(YType.str, "tunnel-name-xr")

                    self.tunnel_requested_bandwidth = YLeaf(YType.uint32, "tunnel-requested-bandwidth")

                    self.auto_bandwidth_status = MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                    self.auto_bandwidth_status.parent = self
                    self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                    self._children_yang_names.add("auto-bandwidth-status")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "bandwidth_applications",
                                    "highest_bandwidth",
                                    "last_bandwidth_applied",
                                    "last_sample_bandwidth",
                                    "samples_collected",
                                    "signaled_name",
                                    "signalled_bandwidth",
                                    "time_left_application",
                                    "tunnel_lsp_id",
                                    "tunnel_name_xr",
                                    "tunnel_requested_bandwidth") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__setattr__(name, value)


                class AutoBandwidthStatus(Entity):
                    """
                    Tunnels's AutoBandwidth Status information
                    
                    .. attribute:: is_auto_bandwidth_enabled
                    
                    	TRUE if auto\-bw is enabled for the tunnel
                    	**type**\:  bool
                    
                    .. attribute:: reactivation_time
                    
                    	Time until auto\-bw gets activated if activation has been delayed due to failover
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__init__()

                        self.yang_name = "auto-bandwidth-status"
                        self.yang_parent_name = "tunnel-auto-bandwidth"

                        self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                        self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_auto_bandwidth_enabled",
                                        "reactivation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_auto_bandwidth_enabled.is_set or
                            self.reactivation_time.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                            self.reactivation_time.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-bandwidth-status" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                        if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-auto-bandwidth-enabled"):
                            self.is_auto_bandwidth_enabled = value
                            self.is_auto_bandwidth_enabled.value_namespace = name_space
                            self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "reactivation-time"):
                            self.reactivation_time = value
                            self.reactivation_time.value_namespace = name_space
                            self.reactivation_time.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.bandwidth_applications.is_set or
                        self.highest_bandwidth.is_set or
                        self.last_bandwidth_applied.is_set or
                        self.last_sample_bandwidth.is_set or
                        self.samples_collected.is_set or
                        self.signaled_name.is_set or
                        self.signalled_bandwidth.is_set or
                        self.time_left_application.is_set or
                        self.tunnel_lsp_id.is_set or
                        self.tunnel_name_xr.is_set or
                        self.tunnel_requested_bandwidth.is_set or
                        (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.bandwidth_applications.yfilter != YFilter.not_set or
                        self.highest_bandwidth.yfilter != YFilter.not_set or
                        self.last_bandwidth_applied.yfilter != YFilter.not_set or
                        self.last_sample_bandwidth.yfilter != YFilter.not_set or
                        self.samples_collected.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.signalled_bandwidth.yfilter != YFilter.not_set or
                        self.time_left_application.yfilter != YFilter.not_set or
                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name_xr.yfilter != YFilter.not_set or
                        self.tunnel_requested_bandwidth.yfilter != YFilter.not_set or
                        (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-auto-bandwidth" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-auto-bandwidths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                    if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                    if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                    if (self.last_sample_bandwidth.is_set or self.last_sample_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_sample_bandwidth.get_name_leafdata())
                    if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.samples_collected.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.signalled_bandwidth.is_set or self.signalled_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signalled_bandwidth.get_name_leafdata())
                    if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.time_left_application.get_name_leafdata())
                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                    if (self.tunnel_name_xr.is_set or self.tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name_xr.get_name_leafdata())
                    if (self.tunnel_requested_bandwidth.is_set or self.tunnel_requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_requested_bandwidth.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-bandwidth-status"):
                        if (self.auto_bandwidth_status is None):
                            self.auto_bandwidth_status = MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                            self.auto_bandwidth_status.parent = self
                            self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        return self.auto_bandwidth_status

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-bandwidth-status" or name == "tunnel-name" or name == "bandwidth-applications" or name == "highest-bandwidth" or name == "last-bandwidth-applied" or name == "last-sample-bandwidth" or name == "samples-collected" or name == "signaled-name" or name == "signalled-bandwidth" or name == "time-left-application" or name == "tunnel-lsp-id" or name == "tunnel-name-xr" or name == "tunnel-requested-bandwidth"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-applications"):
                        self.bandwidth_applications = value
                        self.bandwidth_applications.value_namespace = name_space
                        self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                    if(value_path == "highest-bandwidth"):
                        self.highest_bandwidth = value
                        self.highest_bandwidth.value_namespace = name_space
                        self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-bandwidth-applied"):
                        self.last_bandwidth_applied = value
                        self.last_bandwidth_applied.value_namespace = name_space
                        self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-sample-bandwidth"):
                        self.last_sample_bandwidth = value
                        self.last_sample_bandwidth.value_namespace = name_space
                        self.last_sample_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "samples-collected"):
                        self.samples_collected = value
                        self.samples_collected.value_namespace = name_space
                        self.samples_collected.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "signalled-bandwidth"):
                        self.signalled_bandwidth = value
                        self.signalled_bandwidth.value_namespace = name_space
                        self.signalled_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "time-left-application"):
                        self.time_left_application = value
                        self.time_left_application.value_namespace = name_space
                        self.time_left_application.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-lsp-id"):
                        self.tunnel_lsp_id = value
                        self.tunnel_lsp_id.value_namespace = name_space
                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name-xr"):
                        self.tunnel_name_xr = value
                        self.tunnel_name_xr.value_namespace = name_space
                        self.tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-requested-bandwidth"):
                        self.tunnel_requested_bandwidth = value
                        self.tunnel_requested_bandwidth.value_namespace = name_space
                        self.tunnel_requested_bandwidth.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_auto_bandwidth:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_auto_bandwidth:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-auto-bandwidths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-auto-bandwidth"):
                    for c in self.tunnel_auto_bandwidth:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_auto_bandwidth.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-auto-bandwidth"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Summary(Entity):
            """
            Summary of tunnel info
            
            .. attribute:: activated_heads
            
            	Total tunnel heads activated
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: auto_bandwidth_collection_period
            
            	Collection period in minutes
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: minute
            
            .. attribute:: auto_bandwidth_tunnels
            
            	Counter with number of auto\-bw enabled tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: auto_mesh_one_hop_summary
            
            	Automesh Onehop summary
            	**type**\:   :py:class:`AutoMeshOneHopSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoMeshOneHopSummary>`
            
            .. attribute:: auto_mesh_summary
            
            	Automesh summary
            	**type**\:   :py:class:`AutoMeshSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoMeshSummary>`
            
            .. attribute:: auto_tun_server_summary
            
            	Auto\-tunnel server tunnel summary
            	**type**\:   :py:class:`AutoTunServerSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary>`
            
            .. attribute:: autobackup_summary
            
            	Autobackup summary
            	**type**\:   :py:class:`AutobackupSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutobackupSummary>`
            
            .. attribute:: backup_tunnels
            
            	FRR backup tunnels in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: backups_assigned
            
            	FRR backup tunnels assigned
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_associated
            
            	Associated Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_proceeding
            
            	Proceeding Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_standby
            
            	Standby Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels
            
            	Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_associated
            
            	Associated Bidirectional Head Tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_corouted
            
            	Corouted Bidirectional Head Tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_associated
            
            	Associated Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_proceeding
            
            	Proceeding Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_standby
            
            	Standby Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_tunnels
            
            	Bidirectional Mid Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_tunnels_up
            
            	Connected Bidirectional Mid Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps
            
            	Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_associated
            
            	Associated Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_corouted
            
            	Corouted Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_proceeding
            
            	Proceeding Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_standby
            
            	Standby Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_up
            
            	Connected Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2mp_s2_ls
            
            	P2MP S2Ls BW Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2p_s2_ls
            
            	p2p S2Ls BW Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2p_tunnels
            
            	P2P FRR BW protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_tunnels
            
            	FRR BW protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: current_tunnel_convergence_summary
            
            	Current Tunnel convergemce summary information
            	**type**\:   :py:class:`CurrentTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary>`
            
            .. attribute:: deactivated_heads
            
            	Total tunnel heads deactivated
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: dynamic_up_p2p_head_tunnels
            
            	p2p Tunnel up via a dynamic path
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_config_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces with FRR configuration
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_config_p2p_head_tunnels
            
            	p2p Tunnel interfaces with FRR configuration
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_head_tunnels
            
            	FRR tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_mid_point_tunnels
            
            	FRR tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2mp_head_s2_ls
            
            	P2MP S2Ls with FRR requested at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls with FRR requested at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_head_s2_ls
            
            	p2p S2Ls with FRR requested at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_head_tunnels
            
            	P2P FRR tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_mid_point_s2_ls
            
            	p2p S2Ls with FRR requested at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_mid_point_tunnels
            
            	P2P FRR tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_protected_interfaces
            
            	FRR Protected Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: gmpls_nni_summary
            
            	GMPLS\-NNI summary
            	**type**\:   :py:class:`GmplsNniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.GmplsNniSummary>`
            
            .. attribute:: gmpls_uni_summary
            
            	GMPLS\-UNI summary
            	**type**\:   :py:class:`GmplsUniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.GmplsUniSummary>`
            
            .. attribute:: is_forwarding_enabled
            
            	TRUE if forwarding is enabled
            	**type**\:  bool
            
            .. attribute:: is_periodic_reoptimization_on
            
            	TRUE if periodic reoptimization is on
            	**type**\:  bool
            
            .. attribute:: is_promotion_on
            
            	TRUE if periodic frr promotion is on
            	**type**\:  bool
            
            .. attribute:: is_rsvp_process_enabled
            
            	Status of rsvp
            	**type**\:  bool
            
            .. attribute:: last_tunnel_convergence_summary
            
            	Last Tunnel convergemce summary information
            	**type**\:   :py:class:`LastTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary>`
            
            .. attribute:: link_and_node_diverse_paths
            
            	Link and Node diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_diverse_paths
            
            	Link diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_protected_p2mp_s2_ls
            
            	P2MP S2Ls Link Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_p2p_s2_ls
            
            	p2p S2Ls Link Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_p2p_tunnels
            
            	P2P FRR link protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_tunnels
            
            	FRR link protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_check_time
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_promotion_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_reoptimization_timer
            
            	Time left till next reoptimization (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_verify_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: node_diverse_paths
            
            	Node diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: node_protected_p2p_tunnels
            
            	P2P FRR node protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: node_protected_tunnels
            
            	FRR node protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_head_destinations
            
            	P2MP Destinations at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_head_tunnels
            
            	P2MP Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_mid_point_s2_ls
            
            	P2MP S2Ls at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_tail_s2_ls
            
            	P2MP S2Ls at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_destinations
            
            	p2p Destinations at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_destinations_up
            
            	p2p Destinations in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_tunnels
            
            	p2p Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_mid_point_s2_ls
            
            	p2p S2Ls at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_tail_s2_ls
            
            	p2p S2Ls at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_tail_tunnels
            
            	p2p Tunnel tail interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: path_protect_configured_tunnels
            
            	Tunnels configured with Path Protect
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: path_protect_configured_tunnels_standby_up
            
            	Tunnels with standby LSP up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: path_protect_configured_tunnels_up
            
            	Path Protect configured tunnels connected/up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: pcalc_tie_breaker_type
            
            	PCALC tiebreaker type
            	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
            
            .. attribute:: pcalc_tiebreaker
            
            	Deprecated \- replaced by PCALCTiebreakerType
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2mp_head_s2_ls
            
            	P2MP S2Ls in signalling\-proceeding state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in signalling=proceeding state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2p_head_s2_ls
            
            	p2p S2Ls in signalling\-proceeding state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2p_mid_point_s2_ls
            
            	p2p S2Ls in signalling=proceeding state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: promotion_period
            
            	FRR promotion period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: protected_head_tunnels
            
            	FRR protected tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_mid_point_tunnels
            
            	FRR protected tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Protected at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Protected at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_head_s2_ls
            
            	p2p S2Ls FRR Protected at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_head_tunnels
            
            	P2P FRR protected tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Protected at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_mid_point_tunnels
            
            	P2P FRR protected tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: recovered_heads
            
            	Number of heads recovered
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: recovering_p2p_head_s2_ls
            
            	p2p S2Ls recovering at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: reoptimization_period
            
            	Reoptimization period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: rerouted_head_tunnels
            
            	FRR rerouted tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_interfaces
            
            	FRR Rerouted Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_mid_point_tunnels
            
            	FRR rerouted tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_head_s2_ls
            
            	p2p S2Ls FRR Rerouted at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_head_tunnels
            
            	P2P FRR rerouted tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Rerouted at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_mid_point_tunnels
            
            	P2P FRR rerouted tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: te_process_status
            
            	Status of te\_control
            	**type**\:   :py:class:`MplsTeTunnelsProcessStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsProcessStatus>`
            
            .. attribute:: tiebreaker_qualifier
            
            	Describes how the path selection tiebreaker was specified\:default, or globally set
            	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
            
            .. attribute:: tunnel_check_period
            
            	Tunnel head check period (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: tunnel_verify_period
            
            	Tunnel head verify period (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: up_p2mp_head_destinations
            
            	P2MP Destinations in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_head_s2_ls
            
            	P2MP S2Ls in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in Up state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_tail_s2_ls
            
            	P2MP S2Ls in Up state at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_head_s2_ls
            
            	p2p S2Ls in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_head_tunnels
            
            	p2p Tunnel interfaces in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_mid_point_s2_ls
            
            	p2p S2Ls in Up state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_tail_s2_ls
            
            	p2p S2Ls in Up state at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: user_defined_paths
            
            	User defined paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Tunnels.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "tunnels"

                self.activated_heads = YLeaf(YType.uint32, "activated-heads")

                self.auto_bandwidth_collection_period = YLeaf(YType.uint32, "auto-bandwidth-collection-period")

                self.auto_bandwidth_tunnels = YLeaf(YType.uint32, "auto-bandwidth-tunnels")

                self.backup_tunnels = YLeaf(YType.uint32, "backup-tunnels")

                self.backups_assigned = YLeaf(YType.uint32, "backups-assigned")

                self.bidir_head_ls_ps_associated = YLeaf(YType.uint32, "bidir-head-ls-ps-associated")

                self.bidir_head_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-head-ls-ps-proceeding")

                self.bidir_head_ls_ps_standby = YLeaf(YType.uint32, "bidir-head-ls-ps-standby")

                self.bidir_head_ls_ps_up = YLeaf(YType.uint32, "bidir-head-ls-ps-up")

                self.bidir_head_tunnels = YLeaf(YType.uint32, "bidir-head-tunnels")

                self.bidir_head_tunnels_associated = YLeaf(YType.uint32, "bidir-head-tunnels-associated")

                self.bidir_head_tunnels_corouted = YLeaf(YType.uint32, "bidir-head-tunnels-corouted")

                self.bidir_head_tunnels_up = YLeaf(YType.uint32, "bidir-head-tunnels-up")

                self.bidir_mid_ls_ps_associated = YLeaf(YType.uint32, "bidir-mid-ls-ps-associated")

                self.bidir_mid_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-mid-ls-ps-proceeding")

                self.bidir_mid_ls_ps_standby = YLeaf(YType.uint32, "bidir-mid-ls-ps-standby")

                self.bidir_mid_tunnels = YLeaf(YType.uint32, "bidir-mid-tunnels")

                self.bidir_mid_tunnels_up = YLeaf(YType.uint32, "bidir-mid-tunnels-up")

                self.bidir_tail_ls_ps = YLeaf(YType.uint32, "bidir-tail-ls-ps")

                self.bidir_tail_ls_ps_associated = YLeaf(YType.uint32, "bidir-tail-ls-ps-associated")

                self.bidir_tail_ls_ps_corouted = YLeaf(YType.uint32, "bidir-tail-ls-ps-corouted")

                self.bidir_tail_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-tail-ls-ps-proceeding")

                self.bidir_tail_ls_ps_standby = YLeaf(YType.uint32, "bidir-tail-ls-ps-standby")

                self.bidir_tail_ls_ps_up = YLeaf(YType.uint32, "bidir-tail-ls-ps-up")

                self.bw_protected_p2mp_s2_ls = YLeaf(YType.uint32, "bw-protected-p2mp-s2-ls")

                self.bw_protected_p2p_s2_ls = YLeaf(YType.uint32, "bw-protected-p2p-s2-ls")

                self.bw_protected_p2p_tunnels = YLeaf(YType.uint32, "bw-protected-p2p-tunnels")

                self.bw_protected_tunnels = YLeaf(YType.uint32, "bw-protected-tunnels")

                self.deactivated_heads = YLeaf(YType.uint32, "deactivated-heads")

                self.dynamic_up_p2p_head_tunnels = YLeaf(YType.uint32, "dynamic-up-p2p-head-tunnels")

                self.frr_config_p2mp_head_tunnels = YLeaf(YType.uint32, "frr-config-p2mp-head-tunnels")

                self.frr_config_p2p_head_tunnels = YLeaf(YType.uint32, "frr-config-p2p-head-tunnels")

                self.frr_head_tunnels = YLeaf(YType.uint32, "frr-head-tunnels")

                self.frr_mid_point_tunnels = YLeaf(YType.uint32, "frr-mid-point-tunnels")

                self.frr_p2mp_head_s2_ls = YLeaf(YType.uint32, "frr-p2mp-head-s2-ls")

                self.frr_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "frr-p2mp-mid-point-s2-ls")

                self.frr_p2p_head_s2_ls = YLeaf(YType.uint32, "frr-p2p-head-s2-ls")

                self.frr_p2p_head_tunnels = YLeaf(YType.uint32, "frr-p2p-head-tunnels")

                self.frr_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "frr-p2p-mid-point-s2-ls")

                self.frr_p2p_mid_point_tunnels = YLeaf(YType.uint32, "frr-p2p-mid-point-tunnels")

                self.frr_protected_interfaces = YLeaf(YType.uint32, "frr-protected-interfaces")

                self.is_forwarding_enabled = YLeaf(YType.boolean, "is-forwarding-enabled")

                self.is_periodic_reoptimization_on = YLeaf(YType.boolean, "is-periodic-reoptimization-on")

                self.is_promotion_on = YLeaf(YType.boolean, "is-promotion-on")

                self.is_rsvp_process_enabled = YLeaf(YType.boolean, "is-rsvp-process-enabled")

                self.link_and_node_diverse_paths = YLeaf(YType.uint16, "link-and-node-diverse-paths")

                self.link_diverse_paths = YLeaf(YType.uint16, "link-diverse-paths")

                self.link_protected_p2mp_s2_ls = YLeaf(YType.uint32, "link-protected-p2mp-s2-ls")

                self.link_protected_p2p_s2_ls = YLeaf(YType.uint32, "link-protected-p2p-s2-ls")

                self.link_protected_p2p_tunnels = YLeaf(YType.uint32, "link-protected-p2p-tunnels")

                self.link_protected_tunnels = YLeaf(YType.uint32, "link-protected-tunnels")

                self.next_check_time = YLeaf(YType.uint32, "next-check-time")

                self.next_promotion_timer = YLeaf(YType.uint32, "next-promotion-timer")

                self.next_reoptimization_timer = YLeaf(YType.uint32, "next-reoptimization-timer")

                self.next_verify_timer = YLeaf(YType.uint32, "next-verify-timer")

                self.node_diverse_paths = YLeaf(YType.uint16, "node-diverse-paths")

                self.node_protected_p2p_tunnels = YLeaf(YType.uint32, "node-protected-p2p-tunnels")

                self.node_protected_tunnels = YLeaf(YType.uint32, "node-protected-tunnels")

                self.p2mp_head_destinations = YLeaf(YType.uint32, "p2mp-head-destinations")

                self.p2mp_head_tunnels = YLeaf(YType.uint32, "p2mp-head-tunnels")

                self.p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "p2mp-mid-point-s2-ls")

                self.p2mp_tail_s2_ls = YLeaf(YType.uint32, "p2mp-tail-s2-ls")

                self.p2p_head_destinations = YLeaf(YType.uint32, "p2p-head-destinations")

                self.p2p_head_destinations_up = YLeaf(YType.uint32, "p2p-head-destinations-up")

                self.p2p_head_tunnels = YLeaf(YType.uint32, "p2p-head-tunnels")

                self.p2p_mid_point_s2_ls = YLeaf(YType.uint32, "p2p-mid-point-s2-ls")

                self.p2p_tail_s2_ls = YLeaf(YType.uint32, "p2p-tail-s2-ls")

                self.p2p_tail_tunnels = YLeaf(YType.uint32, "p2p-tail-tunnels")

                self.path_protect_configured_tunnels = YLeaf(YType.uint16, "path-protect-configured-tunnels")

                self.path_protect_configured_tunnels_standby_up = YLeaf(YType.uint16, "path-protect-configured-tunnels-standby-up")

                self.path_protect_configured_tunnels_up = YLeaf(YType.uint16, "path-protect-configured-tunnels-up")

                self.pcalc_tie_breaker_type = YLeaf(YType.enumeration, "pcalc-tie-breaker-type")

                self.pcalc_tiebreaker = YLeaf(YType.uint32, "pcalc-tiebreaker")

                self.proceeding_p2mp_head_s2_ls = YLeaf(YType.uint32, "proceeding-p2mp-head-s2-ls")

                self.proceeding_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "proceeding-p2mp-mid-point-s2-ls")

                self.proceeding_p2p_head_s2_ls = YLeaf(YType.uint32, "proceeding-p2p-head-s2-ls")

                self.proceeding_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "proceeding-p2p-mid-point-s2-ls")

                self.promotion_period = YLeaf(YType.uint32, "promotion-period")

                self.protected_head_tunnels = YLeaf(YType.uint32, "protected-head-tunnels")

                self.protected_mid_point_tunnels = YLeaf(YType.uint32, "protected-mid-point-tunnels")

                self.protected_p2mp_head_s2_ls = YLeaf(YType.uint32, "protected-p2mp-head-s2-ls")

                self.protected_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "protected-p2mp-mid-point-s2-ls")

                self.protected_p2p_head_s2_ls = YLeaf(YType.uint32, "protected-p2p-head-s2-ls")

                self.protected_p2p_head_tunnels = YLeaf(YType.uint32, "protected-p2p-head-tunnels")

                self.protected_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "protected-p2p-mid-point-s2-ls")

                self.protected_p2p_mid_point_tunnels = YLeaf(YType.uint32, "protected-p2p-mid-point-tunnels")

                self.recovered_heads = YLeaf(YType.uint32, "recovered-heads")

                self.recovering_p2p_head_s2_ls = YLeaf(YType.uint32, "recovering-p2p-head-s2-ls")

                self.reoptimization_period = YLeaf(YType.uint32, "reoptimization-period")

                self.rerouted_head_tunnels = YLeaf(YType.uint32, "rerouted-head-tunnels")

                self.rerouted_interfaces = YLeaf(YType.uint32, "rerouted-interfaces")

                self.rerouted_mid_point_tunnels = YLeaf(YType.uint32, "rerouted-mid-point-tunnels")

                self.rerouted_p2mp_head_s2_ls = YLeaf(YType.uint32, "rerouted-p2mp-head-s2-ls")

                self.rerouted_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "rerouted-p2mp-mid-point-s2-ls")

                self.rerouted_p2p_head_s2_ls = YLeaf(YType.uint32, "rerouted-p2p-head-s2-ls")

                self.rerouted_p2p_head_tunnels = YLeaf(YType.uint32, "rerouted-p2p-head-tunnels")

                self.rerouted_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "rerouted-p2p-mid-point-s2-ls")

                self.rerouted_p2p_mid_point_tunnels = YLeaf(YType.uint32, "rerouted-p2p-mid-point-tunnels")

                self.te_process_status = YLeaf(YType.enumeration, "te-process-status")

                self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                self.tunnel_check_period = YLeaf(YType.uint32, "tunnel-check-period")

                self.tunnel_verify_period = YLeaf(YType.uint32, "tunnel-verify-period")

                self.up_p2mp_head_destinations = YLeaf(YType.uint32, "up-p2mp-head-destinations")

                self.up_p2mp_head_s2_ls = YLeaf(YType.uint32, "up-p2mp-head-s2-ls")

                self.up_p2mp_head_tunnels = YLeaf(YType.uint32, "up-p2mp-head-tunnels")

                self.up_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "up-p2mp-mid-point-s2-ls")

                self.up_p2mp_tail_s2_ls = YLeaf(YType.uint32, "up-p2mp-tail-s2-ls")

                self.up_p2p_head_s2_ls = YLeaf(YType.uint32, "up-p2p-head-s2-ls")

                self.up_p2p_head_tunnels = YLeaf(YType.uint32, "up-p2p-head-tunnels")

                self.up_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "up-p2p-mid-point-s2-ls")

                self.up_p2p_tail_s2_ls = YLeaf(YType.uint32, "up-p2p-tail-s2-ls")

                self.user_defined_paths = YLeaf(YType.uint16, "user-defined-paths")

                self.auto_mesh_one_hop_summary = MplsTe.Tunnels.Summary.AutoMeshOneHopSummary()
                self.auto_mesh_one_hop_summary.parent = self
                self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"
                self._children_yang_names.add("auto-mesh-one-hop-summary")

                self.auto_mesh_summary = MplsTe.Tunnels.Summary.AutoMeshSummary()
                self.auto_mesh_summary.parent = self
                self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"
                self._children_yang_names.add("auto-mesh-summary")

                self.auto_tun_server_summary = MplsTe.Tunnels.Summary.AutoTunServerSummary()
                self.auto_tun_server_summary.parent = self
                self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                self._children_yang_names.add("auto-tun-server-summary")

                self.autobackup_summary = MplsTe.Tunnels.Summary.AutobackupSummary()
                self.autobackup_summary.parent = self
                self._children_name_map["autobackup_summary"] = "autobackup-summary"
                self._children_yang_names.add("autobackup-summary")

                self.current_tunnel_convergence_summary = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                self.current_tunnel_convergence_summary.parent = self
                self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"
                self._children_yang_names.add("current-tunnel-convergence-summary")

                self.gmpls_nni_summary = MplsTe.Tunnels.Summary.GmplsNniSummary()
                self.gmpls_nni_summary.parent = self
                self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"
                self._children_yang_names.add("gmpls-nni-summary")

                self.gmpls_uni_summary = MplsTe.Tunnels.Summary.GmplsUniSummary()
                self.gmpls_uni_summary.parent = self
                self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"
                self._children_yang_names.add("gmpls-uni-summary")

                self.last_tunnel_convergence_summary = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary()
                self.last_tunnel_convergence_summary.parent = self
                self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"
                self._children_yang_names.add("last-tunnel-convergence-summary")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("activated_heads",
                                "auto_bandwidth_collection_period",
                                "auto_bandwidth_tunnels",
                                "backup_tunnels",
                                "backups_assigned",
                                "bidir_head_ls_ps_associated",
                                "bidir_head_ls_ps_proceeding",
                                "bidir_head_ls_ps_standby",
                                "bidir_head_ls_ps_up",
                                "bidir_head_tunnels",
                                "bidir_head_tunnels_associated",
                                "bidir_head_tunnels_corouted",
                                "bidir_head_tunnels_up",
                                "bidir_mid_ls_ps_associated",
                                "bidir_mid_ls_ps_proceeding",
                                "bidir_mid_ls_ps_standby",
                                "bidir_mid_tunnels",
                                "bidir_mid_tunnels_up",
                                "bidir_tail_ls_ps",
                                "bidir_tail_ls_ps_associated",
                                "bidir_tail_ls_ps_corouted",
                                "bidir_tail_ls_ps_proceeding",
                                "bidir_tail_ls_ps_standby",
                                "bidir_tail_ls_ps_up",
                                "bw_protected_p2mp_s2_ls",
                                "bw_protected_p2p_s2_ls",
                                "bw_protected_p2p_tunnels",
                                "bw_protected_tunnels",
                                "deactivated_heads",
                                "dynamic_up_p2p_head_tunnels",
                                "frr_config_p2mp_head_tunnels",
                                "frr_config_p2p_head_tunnels",
                                "frr_head_tunnels",
                                "frr_mid_point_tunnels",
                                "frr_p2mp_head_s2_ls",
                                "frr_p2mp_mid_point_s2_ls",
                                "frr_p2p_head_s2_ls",
                                "frr_p2p_head_tunnels",
                                "frr_p2p_mid_point_s2_ls",
                                "frr_p2p_mid_point_tunnels",
                                "frr_protected_interfaces",
                                "is_forwarding_enabled",
                                "is_periodic_reoptimization_on",
                                "is_promotion_on",
                                "is_rsvp_process_enabled",
                                "link_and_node_diverse_paths",
                                "link_diverse_paths",
                                "link_protected_p2mp_s2_ls",
                                "link_protected_p2p_s2_ls",
                                "link_protected_p2p_tunnels",
                                "link_protected_tunnels",
                                "next_check_time",
                                "next_promotion_timer",
                                "next_reoptimization_timer",
                                "next_verify_timer",
                                "node_diverse_paths",
                                "node_protected_p2p_tunnels",
                                "node_protected_tunnels",
                                "p2mp_head_destinations",
                                "p2mp_head_tunnels",
                                "p2mp_mid_point_s2_ls",
                                "p2mp_tail_s2_ls",
                                "p2p_head_destinations",
                                "p2p_head_destinations_up",
                                "p2p_head_tunnels",
                                "p2p_mid_point_s2_ls",
                                "p2p_tail_s2_ls",
                                "p2p_tail_tunnels",
                                "path_protect_configured_tunnels",
                                "path_protect_configured_tunnels_standby_up",
                                "path_protect_configured_tunnels_up",
                                "pcalc_tie_breaker_type",
                                "pcalc_tiebreaker",
                                "proceeding_p2mp_head_s2_ls",
                                "proceeding_p2mp_mid_point_s2_ls",
                                "proceeding_p2p_head_s2_ls",
                                "proceeding_p2p_mid_point_s2_ls",
                                "promotion_period",
                                "protected_head_tunnels",
                                "protected_mid_point_tunnels",
                                "protected_p2mp_head_s2_ls",
                                "protected_p2mp_mid_point_s2_ls",
                                "protected_p2p_head_s2_ls",
                                "protected_p2p_head_tunnels",
                                "protected_p2p_mid_point_s2_ls",
                                "protected_p2p_mid_point_tunnels",
                                "recovered_heads",
                                "recovering_p2p_head_s2_ls",
                                "reoptimization_period",
                                "rerouted_head_tunnels",
                                "rerouted_interfaces",
                                "rerouted_mid_point_tunnels",
                                "rerouted_p2mp_head_s2_ls",
                                "rerouted_p2mp_mid_point_s2_ls",
                                "rerouted_p2p_head_s2_ls",
                                "rerouted_p2p_head_tunnels",
                                "rerouted_p2p_mid_point_s2_ls",
                                "rerouted_p2p_mid_point_tunnels",
                                "te_process_status",
                                "tiebreaker_qualifier",
                                "tunnel_check_period",
                                "tunnel_verify_period",
                                "up_p2mp_head_destinations",
                                "up_p2mp_head_s2_ls",
                                "up_p2mp_head_tunnels",
                                "up_p2mp_mid_point_s2_ls",
                                "up_p2mp_tail_s2_ls",
                                "up_p2p_head_s2_ls",
                                "up_p2p_head_tunnels",
                                "up_p2p_mid_point_s2_ls",
                                "up_p2p_tail_s2_ls",
                                "user_defined_paths") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Tunnels.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Tunnels.Summary, self).__setattr__(name, value)


            class AutobackupSummary(Entity):
                """
                Autobackup summary
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.AutobackupSummary, self).__init__()

                    self.yang_name = "autobackup-summary"
                    self.yang_parent_name = "summary"

                    self.autobackups = YLeaf(YType.uint32, "autobackups")

                    self.down_autobackups = YLeaf(YType.uint32, "down-autobackups")

                    self.next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-autobackup-protected-ls-ps")

                    self.next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2-ls")

                    self.next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2l-families")

                    self.next_hop_autobackups = YLeaf(YType.uint32, "next-hop-autobackups")

                    self.next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-ls-ps")

                    self.next_next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2-ls")

                    self.next_next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackups = YLeaf(YType.uint32, "next-next-hop-autobackups")

                    self.next_next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2l-families")

                    self.srlg_preferred_autobackups = YLeaf(YType.uint32, "srlg-preferred-autobackups")

                    self.srlg_strict_autobackups = YLeaf(YType.uint32, "srlg-strict-autobackups")

                    self.srlg_weighted_autobackups = YLeaf(YType.uint32, "srlg-weighted-autobackups")

                    self.unused_autobackups = YLeaf(YType.uint32, "unused-autobackups")

                    self.up_autobackups = YLeaf(YType.uint32, "up-autobackups")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("autobackups",
                                    "down_autobackups",
                                    "next_hop_autobackup_protected_ls_ps",
                                    "next_hop_autobackup_protected_s2_ls",
                                    "next_hop_autobackup_protected_s2l_families",
                                    "next_hop_autobackups",
                                    "next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_hop_srlg_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackup_protected_ls_ps",
                                    "next_next_hop_autobackup_protected_s2_ls",
                                    "next_next_hop_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackups",
                                    "next_next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_next_hop_srlg_autobackup_protected_s2l_families",
                                    "srlg_preferred_autobackups",
                                    "srlg_strict_autobackups",
                                    "srlg_weighted_autobackups",
                                    "unused_autobackups",
                                    "up_autobackups") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.AutobackupSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.AutobackupSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.autobackups.is_set or
                        self.down_autobackups.is_set or
                        self.next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_hop_autobackups.is_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackups.is_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.srlg_preferred_autobackups.is_set or
                        self.srlg_strict_autobackups.is_set or
                        self.srlg_weighted_autobackups.is_set or
                        self.unused_autobackups.is_set or
                        self.up_autobackups.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.autobackups.yfilter != YFilter.not_set or
                        self.down_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.srlg_preferred_autobackups.yfilter != YFilter.not_set or
                        self.srlg_strict_autobackups.yfilter != YFilter.not_set or
                        self.srlg_weighted_autobackups.yfilter != YFilter.not_set or
                        self.unused_autobackups.yfilter != YFilter.not_set or
                        self.up_autobackups.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "autobackup-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.autobackups.is_set or self.autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autobackups.get_name_leafdata())
                    if (self.down_autobackups.is_set or self.down_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_autobackups.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_ls_ps.is_set or self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2_ls.is_set or self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2l_families.is_set or self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_hop_autobackups.is_set or self.next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackups.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_ls_ps.is_set or self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2_ls.is_set or self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2l_families.is_set or self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackups.is_set or self.next_next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackups.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.srlg_preferred_autobackups.is_set or self.srlg_preferred_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_preferred_autobackups.get_name_leafdata())
                    if (self.srlg_strict_autobackups.is_set or self.srlg_strict_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_strict_autobackups.get_name_leafdata())
                    if (self.srlg_weighted_autobackups.is_set or self.srlg_weighted_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_weighted_autobackups.get_name_leafdata())
                    if (self.unused_autobackups.is_set or self.unused_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_autobackups.get_name_leafdata())
                    if (self.up_autobackups.is_set or self.up_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_autobackups.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "autobackups" or name == "down-autobackups" or name == "next-hop-autobackup-protected-ls-ps" or name == "next-hop-autobackup-protected-s2-ls" or name == "next-hop-autobackup-protected-s2l-families" or name == "next-hop-autobackups" or name == "next-hop-srlg-autobackup-protected-ls-ps" or name == "next-hop-srlg-autobackup-protected-s2-ls" or name == "next-hop-srlg-autobackup-protected-s2l-families" or name == "next-next-hop-autobackup-protected-ls-ps" or name == "next-next-hop-autobackup-protected-s2-ls" or name == "next-next-hop-autobackup-protected-s2l-families" or name == "next-next-hop-autobackups" or name == "next-next-hop-srlg-autobackup-protected-ls-ps" or name == "next-next-hop-srlg-autobackup-protected-s2-ls" or name == "next-next-hop-srlg-autobackup-protected-s2l-families" or name == "srlg-preferred-autobackups" or name == "srlg-strict-autobackups" or name == "srlg-weighted-autobackups" or name == "unused-autobackups" or name == "up-autobackups"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "autobackups"):
                        self.autobackups = value
                        self.autobackups.value_namespace = name_space
                        self.autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-autobackups"):
                        self.down_autobackups = value
                        self.down_autobackups.value_namespace = name_space
                        self.down_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-ls-ps"):
                        self.next_hop_autobackup_protected_ls_ps = value
                        self.next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2-ls"):
                        self.next_hop_autobackup_protected_s2_ls = value
                        self.next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2l-families"):
                        self.next_hop_autobackup_protected_s2l_families = value
                        self.next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackups"):
                        self.next_hop_autobackups = value
                        self.next_hop_autobackups.value_namespace = name_space
                        self.next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-ls-ps"):
                        self.next_next_hop_autobackup_protected_ls_ps = value
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2-ls"):
                        self.next_next_hop_autobackup_protected_s2_ls = value
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2l-families"):
                        self.next_next_hop_autobackup_protected_s2l_families = value
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackups"):
                        self.next_next_hop_autobackups = value
                        self.next_next_hop_autobackups.value_namespace = name_space
                        self.next_next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-preferred-autobackups"):
                        self.srlg_preferred_autobackups = value
                        self.srlg_preferred_autobackups.value_namespace = name_space
                        self.srlg_preferred_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-strict-autobackups"):
                        self.srlg_strict_autobackups = value
                        self.srlg_strict_autobackups.value_namespace = name_space
                        self.srlg_strict_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-weighted-autobackups"):
                        self.srlg_weighted_autobackups = value
                        self.srlg_weighted_autobackups.value_namespace = name_space
                        self.srlg_weighted_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-autobackups"):
                        self.unused_autobackups = value
                        self.unused_autobackups.value_namespace = name_space
                        self.unused_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-autobackups"):
                        self.up_autobackups = value
                        self.up_autobackups.value_namespace = name_space
                        self.up_autobackups.value_namespace_prefix = name_space_prefix


            class AutoMeshSummary(Entity):
                """
                Automesh summary
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.AutoMeshSummary, self).__init__()

                    self.yang_name = "auto-mesh-summary"
                    self.yang_parent_name = "summary"

                    self.auto_mesh_destinations = YLeaf(YType.uint32, "auto-mesh-destinations")

                    self.auto_mesh_groups = YLeaf(YType.uint32, "auto-mesh-groups")

                    self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                    self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_destinations",
                                    "auto_mesh_groups",
                                    "auto_mesh_tunnels",
                                    "down_auto_mesh_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.AutoMeshSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.AutoMeshSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_destinations.is_set or
                        self.auto_mesh_groups.is_set or
                        self.auto_mesh_tunnels.is_set or
                        self.down_auto_mesh_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-mesh-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_destinations.is_set or self.auto_mesh_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_destinations.get_name_leafdata())
                    if (self.auto_mesh_groups.is_set or self.auto_mesh_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_groups.get_name_leafdata())
                    if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-destinations" or name == "auto-mesh-groups" or name == "auto-mesh-tunnels" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-destinations"):
                        self.auto_mesh_destinations = value
                        self.auto_mesh_destinations.value_namespace = name_space
                        self.auto_mesh_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-groups"):
                        self.auto_mesh_groups = value
                        self.auto_mesh_groups.value_namespace = name_space
                        self.auto_mesh_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-tunnels"):
                        self.auto_mesh_tunnels = value
                        self.auto_mesh_tunnels.value_namespace = name_space
                        self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-tunnels"):
                        self.down_auto_mesh_tunnels = value
                        self.down_auto_mesh_tunnels.value_namespace = name_space
                        self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-tunnels"):
                        self.up_auto_mesh_tunnels = value
                        self.up_auto_mesh_tunnels.value_namespace = name_space
                        self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix


            class AutoMeshOneHopSummary(Entity):
                """
                Automesh Onehop summary
                
                .. attribute:: auto_mesh_one_hop_destinations
                
                	Total number of automesh onehop destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_one_hop_groups
                
                	Total number of automesh onehop mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh onehop tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.AutoMeshOneHopSummary, self).__init__()

                    self.yang_name = "auto-mesh-one-hop-summary"
                    self.yang_parent_name = "summary"

                    self.auto_mesh_one_hop_destinations = YLeaf(YType.uint32, "auto-mesh-one-hop-destinations")

                    self.auto_mesh_one_hop_groups = YLeaf(YType.uint32, "auto-mesh-one-hop-groups")

                    self.auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "auto-mesh-one-hop-tunnels")

                    self.down_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "down-auto-mesh-one-hop-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "up-auto-mesh-one-hop-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_one_hop_destinations",
                                    "auto_mesh_one_hop_groups",
                                    "auto_mesh_one_hop_tunnels",
                                    "down_auto_mesh_one_hop_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_one_hop_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.AutoMeshOneHopSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.AutoMeshOneHopSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_one_hop_destinations.is_set or
                        self.auto_mesh_one_hop_groups.is_set or
                        self.auto_mesh_one_hop_tunnels.is_set or
                        self.down_auto_mesh_one_hop_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_one_hop_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-mesh-one-hop-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_one_hop_destinations.is_set or self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_destinations.get_name_leafdata())
                    if (self.auto_mesh_one_hop_groups.is_set or self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_groups.get_name_leafdata())
                    if (self.auto_mesh_one_hop_tunnels.is_set or self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_one_hop_tunnels.is_set or self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_one_hop_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_one_hop_tunnels.is_set or self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_one_hop_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-one-hop-destinations" or name == "auto-mesh-one-hop-groups" or name == "auto-mesh-one-hop-tunnels" or name == "down-auto-mesh-one-hop-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-one-hop-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-one-hop-destinations"):
                        self.auto_mesh_one_hop_destinations = value
                        self.auto_mesh_one_hop_destinations.value_namespace = name_space
                        self.auto_mesh_one_hop_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-one-hop-groups"):
                        self.auto_mesh_one_hop_groups = value
                        self.auto_mesh_one_hop_groups.value_namespace = name_space
                        self.auto_mesh_one_hop_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-one-hop-tunnels"):
                        self.auto_mesh_one_hop_tunnels = value
                        self.auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-one-hop-tunnels"):
                        self.down_auto_mesh_one_hop_tunnels = value
                        self.down_auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.down_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-one-hop-tunnels"):
                        self.up_auto_mesh_one_hop_tunnels = value
                        self.up_auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.up_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix


            class GmplsUniSummary(Entity):
                """
                GMPLS\-UNI summary
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.GmplsUniSummary, self).__init__()

                    self.yang_name = "gmpls-uni-summary"
                    self.yang_parent_name = "summary"

                    self.heads_down = YLeaf(YType.uint32, "heads-down")

                    self.heads_up = YLeaf(YType.uint32, "heads-up")

                    self.tails_down = YLeaf(YType.uint32, "tails-down")

                    self.tails_up = YLeaf(YType.uint32, "tails-up")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("heads_down",
                                    "heads_up",
                                    "tails_down",
                                    "tails_up") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.GmplsUniSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.GmplsUniSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.heads_down.is_set or
                        self.heads_up.is_set or
                        self.tails_down.is_set or
                        self.tails_up.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.heads_down.yfilter != YFilter.not_set or
                        self.heads_up.yfilter != YFilter.not_set or
                        self.tails_down.yfilter != YFilter.not_set or
                        self.tails_up.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "gmpls-uni-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.heads_down.is_set or self.heads_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_down.get_name_leafdata())
                    if (self.heads_up.is_set or self.heads_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_up.get_name_leafdata())
                    if (self.tails_down.is_set or self.tails_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_down.get_name_leafdata())
                    if (self.tails_up.is_set or self.tails_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_up.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "heads-down" or name == "heads-up" or name == "tails-down" or name == "tails-up"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "heads-down"):
                        self.heads_down = value
                        self.heads_down.value_namespace = name_space
                        self.heads_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "heads-up"):
                        self.heads_up = value
                        self.heads_up.value_namespace = name_space
                        self.heads_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-down"):
                        self.tails_down = value
                        self.tails_down.value_namespace = name_space
                        self.tails_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-up"):
                        self.tails_up = value
                        self.tails_up.value_namespace = name_space
                        self.tails_up.value_namespace_prefix = name_space_prefix


            class GmplsNniSummary(Entity):
                """
                GMPLS\-NNI summary
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: mids_down
                
                	Tunnel mids in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: mids_up
                
                	Tunnel mids in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.GmplsNniSummary, self).__init__()

                    self.yang_name = "gmpls-nni-summary"
                    self.yang_parent_name = "summary"

                    self.heads_down = YLeaf(YType.uint32, "heads-down")

                    self.heads_up = YLeaf(YType.uint32, "heads-up")

                    self.mids_down = YLeaf(YType.uint32, "mids-down")

                    self.mids_up = YLeaf(YType.uint32, "mids-up")

                    self.tails_down = YLeaf(YType.uint32, "tails-down")

                    self.tails_up = YLeaf(YType.uint32, "tails-up")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("heads_down",
                                    "heads_up",
                                    "mids_down",
                                    "mids_up",
                                    "tails_down",
                                    "tails_up") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.GmplsNniSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.GmplsNniSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.heads_down.is_set or
                        self.heads_up.is_set or
                        self.mids_down.is_set or
                        self.mids_up.is_set or
                        self.tails_down.is_set or
                        self.tails_up.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.heads_down.yfilter != YFilter.not_set or
                        self.heads_up.yfilter != YFilter.not_set or
                        self.mids_down.yfilter != YFilter.not_set or
                        self.mids_up.yfilter != YFilter.not_set or
                        self.tails_down.yfilter != YFilter.not_set or
                        self.tails_up.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "gmpls-nni-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.heads_down.is_set or self.heads_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_down.get_name_leafdata())
                    if (self.heads_up.is_set or self.heads_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_up.get_name_leafdata())
                    if (self.mids_down.is_set or self.mids_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mids_down.get_name_leafdata())
                    if (self.mids_up.is_set or self.mids_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mids_up.get_name_leafdata())
                    if (self.tails_down.is_set or self.tails_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_down.get_name_leafdata())
                    if (self.tails_up.is_set or self.tails_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_up.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "heads-down" or name == "heads-up" or name == "mids-down" or name == "mids-up" or name == "tails-down" or name == "tails-up"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "heads-down"):
                        self.heads_down = value
                        self.heads_down.value_namespace = name_space
                        self.heads_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "heads-up"):
                        self.heads_up = value
                        self.heads_up.value_namespace = name_space
                        self.heads_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "mids-down"):
                        self.mids_down = value
                        self.mids_down.value_namespace = name_space
                        self.mids_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "mids-up"):
                        self.mids_up = value
                        self.mids_up.value_namespace = name_space
                        self.mids_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-down"):
                        self.tails_down = value
                        self.tails_down.value_namespace = name_space
                        self.tails_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-up"):
                        self.tails_up = value
                        self.tails_up.value_namespace = name_space
                        self.tails_up.value_namespace_prefix = name_space_prefix


            class CurrentTunnelConvergenceSummary(Entity):
                """
                Current Tunnel convergemce summary information
                
                .. attribute:: table_frr_trigger
                
                	Table FRR trigger entry
                	**type**\:   :py:class:`TableFrrTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger>`
                
                .. attribute:: table_label_rewrite
                
                	Table label rewrite entry
                	**type**\:   :py:class:`TableLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite>`
                
                .. attribute:: table_path_out
                
                	Table path\-out entry
                	**type**\:   :py:class:`TablePathOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut>`
                
                .. attribute:: table_pcalc
                
                	Table PCALC entry
                	**type**\:   :py:class:`TablePcalc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc>`
                
                .. attribute:: table_resv_in
                
                	Table resv\-in entry
                	**type**\:   :py:class:`TableResvIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn>`
                
                .. attribute:: table_tunnel_rewrite
                
                	Table Tunnel rewrite entry
                	**type**\:   :py:class:`TableTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite>`
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "current-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"

                    self.tunnel_converged_count = YLeaf(YType.uint32, "tunnel-converged-count")

                    self.tunnel_frr_active_count = YLeaf(YType.uint32, "tunnel-frr-active-count")

                    self.tunnel_frr_total_count = YLeaf(YType.uint32, "tunnel-frr-total-count")

                    self.tunnel_total_convergence_complete_time = YLeaf(YType.uint64, "tunnel-total-convergence-complete-time")

                    self.table_frr_trigger = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger()
                    self.table_frr_trigger.parent = self
                    self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                    self._children_yang_names.add("table-frr-trigger")

                    self.table_label_rewrite = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite()
                    self.table_label_rewrite.parent = self
                    self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                    self._children_yang_names.add("table-label-rewrite")

                    self.table_path_out = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut()
                    self.table_path_out.parent = self
                    self._children_name_map["table_path_out"] = "table-path-out"
                    self._children_yang_names.add("table-path-out")

                    self.table_pcalc = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc()
                    self.table_pcalc.parent = self
                    self._children_name_map["table_pcalc"] = "table-pcalc"
                    self._children_yang_names.add("table-pcalc")

                    self.table_resv_in = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn()
                    self.table_resv_in.parent = self
                    self._children_name_map["table_resv_in"] = "table-resv-in"
                    self._children_yang_names.add("table-resv-in")

                    self.table_tunnel_rewrite = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite()
                    self.table_tunnel_rewrite.parent = self
                    self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                    self._children_yang_names.add("table-tunnel-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_converged_count",
                                    "tunnel_frr_active_count",
                                    "tunnel_frr_total_count",
                                    "tunnel_total_convergence_complete_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__setattr__(name, value)


                class TablePathOut(Entity):
                    """
                    Table path\-out entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut, self).__init__()

                        self.yang_name = "table-path-out"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-path-out" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableResvIn(Entity):
                    """
                    Table resv\-in entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn, self).__init__()

                        self.yang_name = "table-resv-in"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-resv-in" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableLabelRewrite(Entity):
                    """
                    Table label rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite, self).__init__()

                        self.yang_name = "table-label-rewrite"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-label-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TablePcalc(Entity):
                    """
                    Table PCALC entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc, self).__init__()

                        self.yang_name = "table-pcalc"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-pcalc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableTunnelRewrite(Entity):
                    """
                    Table Tunnel rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite, self).__init__()

                        self.yang_name = "table-tunnel-rewrite"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-tunnel-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableFrrTrigger(Entity):
                    """
                    Table FRR trigger entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger, self).__init__()

                        self.yang_name = "table-frr-trigger"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-frr-trigger" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.tunnel_converged_count.is_set or
                        self.tunnel_frr_active_count.is_set or
                        self.tunnel_frr_total_count.is_set or
                        self.tunnel_total_convergence_complete_time.is_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_data()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_data()) or
                        (self.table_path_out is not None and self.table_path_out.has_data()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_data()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_data()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_converged_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_active_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_total_count.yfilter != YFilter.not_set or
                        self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_operation()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_operation()) or
                        (self.table_path_out is not None and self.table_path_out.has_operation()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_operation()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_operation()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "current-tunnel-convergence-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_converged_count.is_set or self.tunnel_converged_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_converged_count.get_name_leafdata())
                    if (self.tunnel_frr_active_count.is_set or self.tunnel_frr_active_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_active_count.get_name_leafdata())
                    if (self.tunnel_frr_total_count.is_set or self.tunnel_frr_total_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_total_count.get_name_leafdata())
                    if (self.tunnel_total_convergence_complete_time.is_set or self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_total_convergence_complete_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "table-frr-trigger"):
                        if (self.table_frr_trigger is None):
                            self.table_frr_trigger = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger()
                            self.table_frr_trigger.parent = self
                            self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                        return self.table_frr_trigger

                    if (child_yang_name == "table-label-rewrite"):
                        if (self.table_label_rewrite is None):
                            self.table_label_rewrite = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite()
                            self.table_label_rewrite.parent = self
                            self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                        return self.table_label_rewrite

                    if (child_yang_name == "table-path-out"):
                        if (self.table_path_out is None):
                            self.table_path_out = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut()
                            self.table_path_out.parent = self
                            self._children_name_map["table_path_out"] = "table-path-out"
                        return self.table_path_out

                    if (child_yang_name == "table-pcalc"):
                        if (self.table_pcalc is None):
                            self.table_pcalc = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc()
                            self.table_pcalc.parent = self
                            self._children_name_map["table_pcalc"] = "table-pcalc"
                        return self.table_pcalc

                    if (child_yang_name == "table-resv-in"):
                        if (self.table_resv_in is None):
                            self.table_resv_in = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn()
                            self.table_resv_in.parent = self
                            self._children_name_map["table_resv_in"] = "table-resv-in"
                        return self.table_resv_in

                    if (child_yang_name == "table-tunnel-rewrite"):
                        if (self.table_tunnel_rewrite is None):
                            self.table_tunnel_rewrite = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite()
                            self.table_tunnel_rewrite.parent = self
                            self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                        return self.table_tunnel_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "table-frr-trigger" or name == "table-label-rewrite" or name == "table-path-out" or name == "table-pcalc" or name == "table-resv-in" or name == "table-tunnel-rewrite" or name == "tunnel-converged-count" or name == "tunnel-frr-active-count" or name == "tunnel-frr-total-count" or name == "tunnel-total-convergence-complete-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-converged-count"):
                        self.tunnel_converged_count = value
                        self.tunnel_converged_count.value_namespace = name_space
                        self.tunnel_converged_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-active-count"):
                        self.tunnel_frr_active_count = value
                        self.tunnel_frr_active_count.value_namespace = name_space
                        self.tunnel_frr_active_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-total-count"):
                        self.tunnel_frr_total_count = value
                        self.tunnel_frr_total_count.value_namespace = name_space
                        self.tunnel_frr_total_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-total-convergence-complete-time"):
                        self.tunnel_total_convergence_complete_time = value
                        self.tunnel_total_convergence_complete_time.value_namespace = name_space
                        self.tunnel_total_convergence_complete_time.value_namespace_prefix = name_space_prefix


            class LastTunnelConvergenceSummary(Entity):
                """
                Last Tunnel convergemce summary information
                
                .. attribute:: table_frr_trigger
                
                	Table FRR trigger entry
                	**type**\:   :py:class:`TableFrrTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger>`
                
                .. attribute:: table_label_rewrite
                
                	Table label rewrite entry
                	**type**\:   :py:class:`TableLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite>`
                
                .. attribute:: table_path_out
                
                	Table path\-out entry
                	**type**\:   :py:class:`TablePathOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut>`
                
                .. attribute:: table_pcalc
                
                	Table PCALC entry
                	**type**\:   :py:class:`TablePcalc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc>`
                
                .. attribute:: table_resv_in
                
                	Table resv\-in entry
                	**type**\:   :py:class:`TableResvIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn>`
                
                .. attribute:: table_tunnel_rewrite
                
                	Table Tunnel rewrite entry
                	**type**\:   :py:class:`TableTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite>`
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "last-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"

                    self.tunnel_converged_count = YLeaf(YType.uint32, "tunnel-converged-count")

                    self.tunnel_frr_active_count = YLeaf(YType.uint32, "tunnel-frr-active-count")

                    self.tunnel_frr_total_count = YLeaf(YType.uint32, "tunnel-frr-total-count")

                    self.tunnel_total_convergence_complete_time = YLeaf(YType.uint64, "tunnel-total-convergence-complete-time")

                    self.table_frr_trigger = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger()
                    self.table_frr_trigger.parent = self
                    self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                    self._children_yang_names.add("table-frr-trigger")

                    self.table_label_rewrite = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite()
                    self.table_label_rewrite.parent = self
                    self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                    self._children_yang_names.add("table-label-rewrite")

                    self.table_path_out = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut()
                    self.table_path_out.parent = self
                    self._children_name_map["table_path_out"] = "table-path-out"
                    self._children_yang_names.add("table-path-out")

                    self.table_pcalc = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc()
                    self.table_pcalc.parent = self
                    self._children_name_map["table_pcalc"] = "table-pcalc"
                    self._children_yang_names.add("table-pcalc")

                    self.table_resv_in = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn()
                    self.table_resv_in.parent = self
                    self._children_name_map["table_resv_in"] = "table-resv-in"
                    self._children_yang_names.add("table-resv-in")

                    self.table_tunnel_rewrite = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite()
                    self.table_tunnel_rewrite.parent = self
                    self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                    self._children_yang_names.add("table-tunnel-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_converged_count",
                                    "tunnel_frr_active_count",
                                    "tunnel_frr_total_count",
                                    "tunnel_total_convergence_complete_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary, self).__setattr__(name, value)


                class TablePathOut(Entity):
                    """
                    Table path\-out entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut, self).__init__()

                        self.yang_name = "table-path-out"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-path-out" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableResvIn(Entity):
                    """
                    Table resv\-in entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn, self).__init__()

                        self.yang_name = "table-resv-in"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-resv-in" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableLabelRewrite(Entity):
                    """
                    Table label rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite, self).__init__()

                        self.yang_name = "table-label-rewrite"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-label-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TablePcalc(Entity):
                    """
                    Table PCALC entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc, self).__init__()

                        self.yang_name = "table-pcalc"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-pcalc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableTunnelRewrite(Entity):
                    """
                    Table Tunnel rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite, self).__init__()

                        self.yang_name = "table-tunnel-rewrite"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-tunnel-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableFrrTrigger(Entity):
                    """
                    Table FRR trigger entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger, self).__init__()

                        self.yang_name = "table-frr-trigger"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-frr-trigger" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.tunnel_converged_count.is_set or
                        self.tunnel_frr_active_count.is_set or
                        self.tunnel_frr_total_count.is_set or
                        self.tunnel_total_convergence_complete_time.is_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_data()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_data()) or
                        (self.table_path_out is not None and self.table_path_out.has_data()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_data()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_data()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_converged_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_active_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_total_count.yfilter != YFilter.not_set or
                        self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_operation()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_operation()) or
                        (self.table_path_out is not None and self.table_path_out.has_operation()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_operation()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_operation()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-tunnel-convergence-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_converged_count.is_set or self.tunnel_converged_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_converged_count.get_name_leafdata())
                    if (self.tunnel_frr_active_count.is_set or self.tunnel_frr_active_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_active_count.get_name_leafdata())
                    if (self.tunnel_frr_total_count.is_set or self.tunnel_frr_total_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_total_count.get_name_leafdata())
                    if (self.tunnel_total_convergence_complete_time.is_set or self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_total_convergence_complete_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "table-frr-trigger"):
                        if (self.table_frr_trigger is None):
                            self.table_frr_trigger = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger()
                            self.table_frr_trigger.parent = self
                            self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                        return self.table_frr_trigger

                    if (child_yang_name == "table-label-rewrite"):
                        if (self.table_label_rewrite is None):
                            self.table_label_rewrite = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite()
                            self.table_label_rewrite.parent = self
                            self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                        return self.table_label_rewrite

                    if (child_yang_name == "table-path-out"):
                        if (self.table_path_out is None):
                            self.table_path_out = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut()
                            self.table_path_out.parent = self
                            self._children_name_map["table_path_out"] = "table-path-out"
                        return self.table_path_out

                    if (child_yang_name == "table-pcalc"):
                        if (self.table_pcalc is None):
                            self.table_pcalc = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc()
                            self.table_pcalc.parent = self
                            self._children_name_map["table_pcalc"] = "table-pcalc"
                        return self.table_pcalc

                    if (child_yang_name == "table-resv-in"):
                        if (self.table_resv_in is None):
                            self.table_resv_in = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn()
                            self.table_resv_in.parent = self
                            self._children_name_map["table_resv_in"] = "table-resv-in"
                        return self.table_resv_in

                    if (child_yang_name == "table-tunnel-rewrite"):
                        if (self.table_tunnel_rewrite is None):
                            self.table_tunnel_rewrite = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite()
                            self.table_tunnel_rewrite.parent = self
                            self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                        return self.table_tunnel_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "table-frr-trigger" or name == "table-label-rewrite" or name == "table-path-out" or name == "table-pcalc" or name == "table-resv-in" or name == "table-tunnel-rewrite" or name == "tunnel-converged-count" or name == "tunnel-frr-active-count" or name == "tunnel-frr-total-count" or name == "tunnel-total-convergence-complete-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-converged-count"):
                        self.tunnel_converged_count = value
                        self.tunnel_converged_count.value_namespace = name_space
                        self.tunnel_converged_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-active-count"):
                        self.tunnel_frr_active_count = value
                        self.tunnel_frr_active_count.value_namespace = name_space
                        self.tunnel_frr_active_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-total-count"):
                        self.tunnel_frr_total_count = value
                        self.tunnel_frr_total_count.value_namespace = name_space
                        self.tunnel_frr_total_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-total-convergence-complete-time"):
                        self.tunnel_total_convergence_complete_time = value
                        self.tunnel_total_convergence_complete_time.value_namespace = name_space
                        self.tunnel_total_convergence_complete_time.value_namespace_prefix = name_space_prefix


            class AutoTunServerSummary(Entity):
                """
                Auto\-tunnel server tunnel summary
                
                .. attribute:: clients_summary
                
                	List of auto\-tunnel server clients
                	**type**\: list of    :py:class:`ClientsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary>`
                
                .. attribute:: total_auto_p2mp_tunnels
                
                	Total number of P2MP auto\-tunnels
                	**type**\:   :py:class:`TotalAutoP2MpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels>`
                
                .. attribute:: total_auto_p2p_tunnels
                
                	Total number of P2P auto\-tunnels
                	**type**\:   :py:class:`TotalAutoP2PTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary, self).__init__()

                    self.yang_name = "auto-tun-server-summary"
                    self.yang_parent_name = "summary"

                    self.total_auto_p2mp_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels()
                    self.total_auto_p2mp_tunnels.parent = self
                    self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"
                    self._children_yang_names.add("total-auto-p2mp-tunnels")

                    self.total_auto_p2p_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels()
                    self.total_auto_p2p_tunnels.parent = self
                    self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"
                    self._children_yang_names.add("total-auto-p2p-tunnels")

                    self.clients_summary = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary, self).__setattr__(name, value)


                class TotalAutoP2MpTunnels(Entity):
                    """
                    Total number of P2MP auto\-tunnels
                    
                    .. attribute:: auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_p2mp_tunnel
                    
                    	Total number of client P2MP auto\-tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__init__()

                        self.yang_name = "total-auto-p2mp-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.auto_p2mp_destinations = YLeaf(YType.uint32, "auto-p2mp-destinations")

                        self.auto_p2mp_tunnel = YLeaf(YType.uint32, "auto-p2mp-tunnel")

                        self.down_auto_p2mp_destinations = YLeaf(YType.uint32, "down-auto-p2mp-destinations")

                        self.down_auto_p2mp_tunnels = YLeaf(YType.uint32, "down-auto-p2mp-tunnels")

                        self.frr_auto_p2mp_tunnels = YLeaf(YType.uint32, "frr-auto-p2mp-tunnels")

                        self.up_auto_p2mp_destinations = YLeaf(YType.uint32, "up-auto-p2mp-destinations")

                        self.up_auto_p2mp_tunnels = YLeaf(YType.uint32, "up-auto-p2mp-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_p2mp_destinations",
                                        "auto_p2mp_tunnel",
                                        "down_auto_p2mp_destinations",
                                        "down_auto_p2mp_tunnels",
                                        "frr_auto_p2mp_tunnels",
                                        "up_auto_p2mp_destinations",
                                        "up_auto_p2mp_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_p2mp_destinations.is_set or
                            self.auto_p2mp_tunnel.is_set or
                            self.down_auto_p2mp_destinations.is_set or
                            self.down_auto_p2mp_tunnels.is_set or
                            self.frr_auto_p2mp_tunnels.is_set or
                            self.up_auto_p2mp_destinations.is_set or
                            self.up_auto_p2mp_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.auto_p2mp_tunnel.yfilter != YFilter.not_set or
                            self.down_auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-auto-p2mp-tunnels" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_p2mp_destinations.is_set or self.auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2mp_destinations.get_name_leafdata())
                        if (self.auto_p2mp_tunnel.is_set or self.auto_p2mp_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2mp_tunnel.get_name_leafdata())
                        if (self.down_auto_p2mp_destinations.is_set or self.down_auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2mp_destinations.get_name_leafdata())
                        if (self.down_auto_p2mp_tunnels.is_set or self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2mp_tunnels.get_name_leafdata())
                        if (self.frr_auto_p2mp_tunnels.is_set or self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_p2mp_tunnels.get_name_leafdata())
                        if (self.up_auto_p2mp_destinations.is_set or self.up_auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2mp_destinations.get_name_leafdata())
                        if (self.up_auto_p2mp_tunnels.is_set or self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2mp_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-p2mp-destinations" or name == "auto-p2mp-tunnel" or name == "down-auto-p2mp-destinations" or name == "down-auto-p2mp-tunnels" or name == "frr-auto-p2mp-tunnels" or name == "up-auto-p2mp-destinations" or name == "up-auto-p2mp-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-p2mp-destinations"):
                            self.auto_p2mp_destinations = value
                            self.auto_p2mp_destinations.value_namespace = name_space
                            self.auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-p2mp-tunnel"):
                            self.auto_p2mp_tunnel = value
                            self.auto_p2mp_tunnel.value_namespace = name_space
                            self.auto_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2mp-destinations"):
                            self.down_auto_p2mp_destinations = value
                            self.down_auto_p2mp_destinations.value_namespace = name_space
                            self.down_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2mp-tunnels"):
                            self.down_auto_p2mp_tunnels = value
                            self.down_auto_p2mp_tunnels.value_namespace = name_space
                            self.down_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-p2mp-tunnels"):
                            self.frr_auto_p2mp_tunnels = value
                            self.frr_auto_p2mp_tunnels.value_namespace = name_space
                            self.frr_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2mp-destinations"):
                            self.up_auto_p2mp_destinations = value
                            self.up_auto_p2mp_destinations.value_namespace = name_space
                            self.up_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2mp-tunnels"):
                            self.up_auto_p2mp_tunnels = value
                            self.up_auto_p2mp_tunnels.value_namespace = name_space
                            self.up_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix


                class TotalAutoP2PTunnels(Entity):
                    """
                    Total number of P2P auto\-tunnels
                    
                    .. attribute:: auto_p2p_tunnel
                    
                    	Total number of client P2P auto\-tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__init__()

                        self.yang_name = "total-auto-p2p-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.auto_p2p_tunnel = YLeaf(YType.uint32, "auto-p2p-tunnel")

                        self.down_auto_p2p_tunnels = YLeaf(YType.uint32, "down-auto-p2p-tunnels")

                        self.up_auto_p2p_tunnels = YLeaf(YType.uint32, "up-auto-p2p-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_p2p_tunnel",
                                        "down_auto_p2p_tunnels",
                                        "up_auto_p2p_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_p2p_tunnel.is_set or
                            self.down_auto_p2p_tunnels.is_set or
                            self.up_auto_p2p_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_p2p_tunnel.yfilter != YFilter.not_set or
                            self.down_auto_p2p_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_p2p_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-auto-p2p-tunnels" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_p2p_tunnel.is_set or self.auto_p2p_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2p_tunnel.get_name_leafdata())
                        if (self.down_auto_p2p_tunnels.is_set or self.down_auto_p2p_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2p_tunnels.get_name_leafdata())
                        if (self.up_auto_p2p_tunnels.is_set or self.up_auto_p2p_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2p_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-p2p-tunnel" or name == "down-auto-p2p-tunnels" or name == "up-auto-p2p-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-p2p-tunnel"):
                            self.auto_p2p_tunnel = value
                            self.auto_p2p_tunnel.value_namespace = name_space
                            self.auto_p2p_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2p-tunnels"):
                            self.down_auto_p2p_tunnels = value
                            self.down_auto_p2p_tunnels.value_namespace = name_space
                            self.down_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2p-tunnels"):
                            self.up_auto_p2p_tunnels = value
                            self.up_auto_p2p_tunnels.value_namespace = name_space
                            self.up_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix


                class ClientsSummary(Entity):
                    """
                    List of auto\-tunnel server clients
                    
                    .. attribute:: client_id
                    
                    	Client ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: client_instance_name
                    
                    	Client Instance name
                    	**type**\:  str
                    
                    .. attribute:: p2mp_info
                    
                    	P2MP info for a client
                    	**type**\:   :py:class:`P2MpInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo>`
                    
                    .. attribute:: p2p_info
                    
                    	P2P info for a client
                    	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo>`
                    
                    .. attribute:: protocol_type
                    
                    	Client's protocol type
                    	**type**\:   :py:class:`TeServTunClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeServTunClient>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__init__()

                        self.yang_name = "clients-summary"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.client_id = YLeaf(YType.uint32, "client-id")

                        self.client_instance_name = YLeaf(YType.str, "client-instance-name")

                        self.protocol_type = YLeaf(YType.enumeration, "protocol-type")

                        self.p2mp_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo()
                        self.p2mp_info.parent = self
                        self._children_name_map["p2mp_info"] = "p2mp-info"
                        self._children_yang_names.add("p2mp-info")

                        self.p2p_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo()
                        self.p2p_info.parent = self
                        self._children_name_map["p2p_info"] = "p2p-info"
                        self._children_yang_names.add("p2p-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("client_id",
                                        "client_instance_name",
                                        "protocol_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__setattr__(name, value)


                    class P2MpInfo(Entity):
                        """
                        P2MP info for a client
                        
                        .. attribute:: auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: auto_p2mp_tunnel
                        
                        	Total number of client P2MP auto\-tunnels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: frr_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are FRR enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__init__()

                            self.yang_name = "p2mp-info"
                            self.yang_parent_name = "clients-summary"

                            self.auto_p2mp_destinations = YLeaf(YType.uint32, "auto-p2mp-destinations")

                            self.auto_p2mp_tunnel = YLeaf(YType.uint32, "auto-p2mp-tunnel")

                            self.down_auto_p2mp_destinations = YLeaf(YType.uint32, "down-auto-p2mp-destinations")

                            self.down_auto_p2mp_tunnels = YLeaf(YType.uint32, "down-auto-p2mp-tunnels")

                            self.frr_auto_p2mp_tunnels = YLeaf(YType.uint32, "frr-auto-p2mp-tunnels")

                            self.up_auto_p2mp_destinations = YLeaf(YType.uint32, "up-auto-p2mp-destinations")

                            self.up_auto_p2mp_tunnels = YLeaf(YType.uint32, "up-auto-p2mp-tunnels")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("auto_p2mp_destinations",
                                            "auto_p2mp_tunnel",
                                            "down_auto_p2mp_destinations",
                                            "down_auto_p2mp_tunnels",
                                            "frr_auto_p2mp_tunnels",
                                            "up_auto_p2mp_destinations",
                                            "up_auto_p2mp_tunnels") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.auto_p2mp_destinations.is_set or
                                self.auto_p2mp_tunnel.is_set or
                                self.down_auto_p2mp_destinations.is_set or
                                self.down_auto_p2mp_tunnels.is_set or
                                self.frr_auto_p2mp_tunnels.is_set or
                                self.up_auto_p2mp_destinations.is_set or
                                self.up_auto_p2mp_tunnels.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.auto_p2mp_tunnel.yfilter != YFilter.not_set or
                                self.down_auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                                self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                                self.up_auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "p2mp-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.auto_p2mp_destinations.is_set or self.auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2mp_destinations.get_name_leafdata())
                            if (self.auto_p2mp_tunnel.is_set or self.auto_p2mp_tunnel.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2mp_tunnel.get_name_leafdata())
                            if (self.down_auto_p2mp_destinations.is_set or self.down_auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2mp_destinations.get_name_leafdata())
                            if (self.down_auto_p2mp_tunnels.is_set or self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2mp_tunnels.get_name_leafdata())
                            if (self.frr_auto_p2mp_tunnels.is_set or self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_auto_p2mp_tunnels.get_name_leafdata())
                            if (self.up_auto_p2mp_destinations.is_set or self.up_auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2mp_destinations.get_name_leafdata())
                            if (self.up_auto_p2mp_tunnels.is_set or self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2mp_tunnels.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "auto-p2mp-destinations" or name == "auto-p2mp-tunnel" or name == "down-auto-p2mp-destinations" or name == "down-auto-p2mp-tunnels" or name == "frr-auto-p2mp-tunnels" or name == "up-auto-p2mp-destinations" or name == "up-auto-p2mp-tunnels"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "auto-p2mp-destinations"):
                                self.auto_p2mp_destinations = value
                                self.auto_p2mp_destinations.value_namespace = name_space
                                self.auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "auto-p2mp-tunnel"):
                                self.auto_p2mp_tunnel = value
                                self.auto_p2mp_tunnel.value_namespace = name_space
                                self.auto_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2mp-destinations"):
                                self.down_auto_p2mp_destinations = value
                                self.down_auto_p2mp_destinations.value_namespace = name_space
                                self.down_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2mp-tunnels"):
                                self.down_auto_p2mp_tunnels = value
                                self.down_auto_p2mp_tunnels.value_namespace = name_space
                                self.down_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-auto-p2mp-tunnels"):
                                self.frr_auto_p2mp_tunnels = value
                                self.frr_auto_p2mp_tunnels.value_namespace = name_space
                                self.frr_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2mp-destinations"):
                                self.up_auto_p2mp_destinations = value
                                self.up_auto_p2mp_destinations.value_namespace = name_space
                                self.up_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2mp-tunnels"):
                                self.up_auto_p2mp_tunnels = value
                                self.up_auto_p2mp_tunnels.value_namespace = name_space
                                self.up_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix


                    class P2PInfo(Entity):
                        """
                        P2P info for a client
                        
                        .. attribute:: auto_p2p_tunnel
                        
                        	Total number of client P2P auto\-tunnels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__init__()

                            self.yang_name = "p2p-info"
                            self.yang_parent_name = "clients-summary"

                            self.auto_p2p_tunnel = YLeaf(YType.uint32, "auto-p2p-tunnel")

                            self.down_auto_p2p_tunnels = YLeaf(YType.uint32, "down-auto-p2p-tunnels")

                            self.up_auto_p2p_tunnels = YLeaf(YType.uint32, "up-auto-p2p-tunnels")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("auto_p2p_tunnel",
                                            "down_auto_p2p_tunnels",
                                            "up_auto_p2p_tunnels") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.auto_p2p_tunnel.is_set or
                                self.down_auto_p2p_tunnels.is_set or
                                self.up_auto_p2p_tunnels.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.auto_p2p_tunnel.yfilter != YFilter.not_set or
                                self.down_auto_p2p_tunnels.yfilter != YFilter.not_set or
                                self.up_auto_p2p_tunnels.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "p2p-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.auto_p2p_tunnel.is_set or self.auto_p2p_tunnel.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2p_tunnel.get_name_leafdata())
                            if (self.down_auto_p2p_tunnels.is_set or self.down_auto_p2p_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2p_tunnels.get_name_leafdata())
                            if (self.up_auto_p2p_tunnels.is_set or self.up_auto_p2p_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2p_tunnels.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "auto-p2p-tunnel" or name == "down-auto-p2p-tunnels" or name == "up-auto-p2p-tunnels"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "auto-p2p-tunnel"):
                                self.auto_p2p_tunnel = value
                                self.auto_p2p_tunnel.value_namespace = name_space
                                self.auto_p2p_tunnel.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2p-tunnels"):
                                self.down_auto_p2p_tunnels = value
                                self.down_auto_p2p_tunnels.value_namespace = name_space
                                self.down_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2p-tunnels"):
                                self.up_auto_p2p_tunnels = value
                                self.up_auto_p2p_tunnels.value_namespace = name_space
                                self.up_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.client_id.is_set or
                            self.client_instance_name.is_set or
                            self.protocol_type.is_set or
                            (self.p2mp_info is not None and self.p2mp_info.has_data()) or
                            (self.p2p_info is not None and self.p2p_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.client_id.yfilter != YFilter.not_set or
                            self.client_instance_name.yfilter != YFilter.not_set or
                            self.protocol_type.yfilter != YFilter.not_set or
                            (self.p2mp_info is not None and self.p2mp_info.has_operation()) or
                            (self.p2p_info is not None and self.p2p_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "clients-summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.client_id.is_set or self.client_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.client_id.get_name_leafdata())
                        if (self.client_instance_name.is_set or self.client_instance_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.client_instance_name.get_name_leafdata())
                        if (self.protocol_type.is_set or self.protocol_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protocol_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "p2mp-info"):
                            if (self.p2mp_info is None):
                                self.p2mp_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo()
                                self.p2mp_info.parent = self
                                self._children_name_map["p2mp_info"] = "p2mp-info"
                            return self.p2mp_info

                        if (child_yang_name == "p2p-info"):
                            if (self.p2p_info is None):
                                self.p2p_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo()
                                self.p2p_info.parent = self
                                self._children_name_map["p2p_info"] = "p2p-info"
                            return self.p2p_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "p2mp-info" or name == "p2p-info" or name == "client-id" or name == "client-instance-name" or name == "protocol-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "client-id"):
                            self.client_id = value
                            self.client_id.value_namespace = name_space
                            self.client_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "client-instance-name"):
                            self.client_instance_name = value
                            self.client_instance_name.value_namespace = name_space
                            self.client_instance_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "protocol-type"):
                            self.protocol_type = value
                            self.protocol_type.value_namespace = name_space
                            self.protocol_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.clients_summary:
                        if (c.has_data()):
                            return True
                    return (
                        (self.total_auto_p2mp_tunnels is not None and self.total_auto_p2mp_tunnels.has_data()) or
                        (self.total_auto_p2p_tunnels is not None and self.total_auto_p2p_tunnels.has_data()))

                def has_operation(self):
                    for c in self.clients_summary:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.total_auto_p2mp_tunnels is not None and self.total_auto_p2mp_tunnels.has_operation()) or
                        (self.total_auto_p2p_tunnels is not None and self.total_auto_p2p_tunnels.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-tun-server-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "clients-summary"):
                        for c in self.clients_summary:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.clients_summary.append(c)
                        return c

                    if (child_yang_name == "total-auto-p2mp-tunnels"):
                        if (self.total_auto_p2mp_tunnels is None):
                            self.total_auto_p2mp_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels()
                            self.total_auto_p2mp_tunnels.parent = self
                            self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"
                        return self.total_auto_p2mp_tunnels

                    if (child_yang_name == "total-auto-p2p-tunnels"):
                        if (self.total_auto_p2p_tunnels is None):
                            self.total_auto_p2p_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels()
                            self.total_auto_p2p_tunnels.parent = self
                            self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"
                        return self.total_auto_p2p_tunnels

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "clients-summary" or name == "total-auto-p2mp-tunnels" or name == "total-auto-p2p-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.activated_heads.is_set or
                    self.auto_bandwidth_collection_period.is_set or
                    self.auto_bandwidth_tunnels.is_set or
                    self.backup_tunnels.is_set or
                    self.backups_assigned.is_set or
                    self.bidir_head_ls_ps_associated.is_set or
                    self.bidir_head_ls_ps_proceeding.is_set or
                    self.bidir_head_ls_ps_standby.is_set or
                    self.bidir_head_ls_ps_up.is_set or
                    self.bidir_head_tunnels.is_set or
                    self.bidir_head_tunnels_associated.is_set or
                    self.bidir_head_tunnels_corouted.is_set or
                    self.bidir_head_tunnels_up.is_set or
                    self.bidir_mid_ls_ps_associated.is_set or
                    self.bidir_mid_ls_ps_proceeding.is_set or
                    self.bidir_mid_ls_ps_standby.is_set or
                    self.bidir_mid_tunnels.is_set or
                    self.bidir_mid_tunnels_up.is_set or
                    self.bidir_tail_ls_ps.is_set or
                    self.bidir_tail_ls_ps_associated.is_set or
                    self.bidir_tail_ls_ps_corouted.is_set or
                    self.bidir_tail_ls_ps_proceeding.is_set or
                    self.bidir_tail_ls_ps_standby.is_set or
                    self.bidir_tail_ls_ps_up.is_set or
                    self.bw_protected_p2mp_s2_ls.is_set or
                    self.bw_protected_p2p_s2_ls.is_set or
                    self.bw_protected_p2p_tunnels.is_set or
                    self.bw_protected_tunnels.is_set or
                    self.deactivated_heads.is_set or
                    self.dynamic_up_p2p_head_tunnels.is_set or
                    self.frr_config_p2mp_head_tunnels.is_set or
                    self.frr_config_p2p_head_tunnels.is_set or
                    self.frr_head_tunnels.is_set or
                    self.frr_mid_point_tunnels.is_set or
                    self.frr_p2mp_head_s2_ls.is_set or
                    self.frr_p2mp_mid_point_s2_ls.is_set or
                    self.frr_p2p_head_s2_ls.is_set or
                    self.frr_p2p_head_tunnels.is_set or
                    self.frr_p2p_mid_point_s2_ls.is_set or
                    self.frr_p2p_mid_point_tunnels.is_set or
                    self.frr_protected_interfaces.is_set or
                    self.is_forwarding_enabled.is_set or
                    self.is_periodic_reoptimization_on.is_set or
                    self.is_promotion_on.is_set or
                    self.is_rsvp_process_enabled.is_set or
                    self.link_and_node_diverse_paths.is_set or
                    self.link_diverse_paths.is_set or
                    self.link_protected_p2mp_s2_ls.is_set or
                    self.link_protected_p2p_s2_ls.is_set or
                    self.link_protected_p2p_tunnels.is_set or
                    self.link_protected_tunnels.is_set or
                    self.next_check_time.is_set or
                    self.next_promotion_timer.is_set or
                    self.next_reoptimization_timer.is_set or
                    self.next_verify_timer.is_set or
                    self.node_diverse_paths.is_set or
                    self.node_protected_p2p_tunnels.is_set or
                    self.node_protected_tunnels.is_set or
                    self.p2mp_head_destinations.is_set or
                    self.p2mp_head_tunnels.is_set or
                    self.p2mp_mid_point_s2_ls.is_set or
                    self.p2mp_tail_s2_ls.is_set or
                    self.p2p_head_destinations.is_set or
                    self.p2p_head_destinations_up.is_set or
                    self.p2p_head_tunnels.is_set or
                    self.p2p_mid_point_s2_ls.is_set or
                    self.p2p_tail_s2_ls.is_set or
                    self.p2p_tail_tunnels.is_set or
                    self.path_protect_configured_tunnels.is_set or
                    self.path_protect_configured_tunnels_standby_up.is_set or
                    self.path_protect_configured_tunnels_up.is_set or
                    self.pcalc_tie_breaker_type.is_set or
                    self.pcalc_tiebreaker.is_set or
                    self.proceeding_p2mp_head_s2_ls.is_set or
                    self.proceeding_p2mp_mid_point_s2_ls.is_set or
                    self.proceeding_p2p_head_s2_ls.is_set or
                    self.proceeding_p2p_mid_point_s2_ls.is_set or
                    self.promotion_period.is_set or
                    self.protected_head_tunnels.is_set or
                    self.protected_mid_point_tunnels.is_set or
                    self.protected_p2mp_head_s2_ls.is_set or
                    self.protected_p2mp_mid_point_s2_ls.is_set or
                    self.protected_p2p_head_s2_ls.is_set or
                    self.protected_p2p_head_tunnels.is_set or
                    self.protected_p2p_mid_point_s2_ls.is_set or
                    self.protected_p2p_mid_point_tunnels.is_set or
                    self.recovered_heads.is_set or
                    self.recovering_p2p_head_s2_ls.is_set or
                    self.reoptimization_period.is_set or
                    self.rerouted_head_tunnels.is_set or
                    self.rerouted_interfaces.is_set or
                    self.rerouted_mid_point_tunnels.is_set or
                    self.rerouted_p2mp_head_s2_ls.is_set or
                    self.rerouted_p2mp_mid_point_s2_ls.is_set or
                    self.rerouted_p2p_head_s2_ls.is_set or
                    self.rerouted_p2p_head_tunnels.is_set or
                    self.rerouted_p2p_mid_point_s2_ls.is_set or
                    self.rerouted_p2p_mid_point_tunnels.is_set or
                    self.te_process_status.is_set or
                    self.tiebreaker_qualifier.is_set or
                    self.tunnel_check_period.is_set or
                    self.tunnel_verify_period.is_set or
                    self.up_p2mp_head_destinations.is_set or
                    self.up_p2mp_head_s2_ls.is_set or
                    self.up_p2mp_head_tunnels.is_set or
                    self.up_p2mp_mid_point_s2_ls.is_set or
                    self.up_p2mp_tail_s2_ls.is_set or
                    self.up_p2p_head_s2_ls.is_set or
                    self.up_p2p_head_tunnels.is_set or
                    self.up_p2p_mid_point_s2_ls.is_set or
                    self.up_p2p_tail_s2_ls.is_set or
                    self.user_defined_paths.is_set or
                    (self.auto_mesh_one_hop_summary is not None and self.auto_mesh_one_hop_summary.has_data()) or
                    (self.auto_mesh_summary is not None and self.auto_mesh_summary.has_data()) or
                    (self.auto_tun_server_summary is not None and self.auto_tun_server_summary.has_data()) or
                    (self.autobackup_summary is not None and self.autobackup_summary.has_data()) or
                    (self.current_tunnel_convergence_summary is not None and self.current_tunnel_convergence_summary.has_data()) or
                    (self.gmpls_nni_summary is not None and self.gmpls_nni_summary.has_data()) or
                    (self.gmpls_uni_summary is not None and self.gmpls_uni_summary.has_data()) or
                    (self.last_tunnel_convergence_summary is not None and self.last_tunnel_convergence_summary.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.activated_heads.yfilter != YFilter.not_set or
                    self.auto_bandwidth_collection_period.yfilter != YFilter.not_set or
                    self.auto_bandwidth_tunnels.yfilter != YFilter.not_set or
                    self.backup_tunnels.yfilter != YFilter.not_set or
                    self.backups_assigned.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_up.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_associated.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_corouted.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_up.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_mid_tunnels.yfilter != YFilter.not_set or
                    self.bidir_mid_tunnels_up.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_corouted.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_up.yfilter != YFilter.not_set or
                    self.bw_protected_p2mp_s2_ls.yfilter != YFilter.not_set or
                    self.bw_protected_p2p_s2_ls.yfilter != YFilter.not_set or
                    self.bw_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.bw_protected_tunnels.yfilter != YFilter.not_set or
                    self.deactivated_heads.yfilter != YFilter.not_set or
                    self.dynamic_up_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_config_p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_config_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.frr_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.frr_protected_interfaces.yfilter != YFilter.not_set or
                    self.is_forwarding_enabled.yfilter != YFilter.not_set or
                    self.is_periodic_reoptimization_on.yfilter != YFilter.not_set or
                    self.is_promotion_on.yfilter != YFilter.not_set or
                    self.is_rsvp_process_enabled.yfilter != YFilter.not_set or
                    self.link_and_node_diverse_paths.yfilter != YFilter.not_set or
                    self.link_diverse_paths.yfilter != YFilter.not_set or
                    self.link_protected_p2mp_s2_ls.yfilter != YFilter.not_set or
                    self.link_protected_p2p_s2_ls.yfilter != YFilter.not_set or
                    self.link_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.link_protected_tunnels.yfilter != YFilter.not_set or
                    self.next_check_time.yfilter != YFilter.not_set or
                    self.next_promotion_timer.yfilter != YFilter.not_set or
                    self.next_reoptimization_timer.yfilter != YFilter.not_set or
                    self.next_verify_timer.yfilter != YFilter.not_set or
                    self.node_diverse_paths.yfilter != YFilter.not_set or
                    self.node_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.node_protected_tunnels.yfilter != YFilter.not_set or
                    self.p2mp_head_destinations.yfilter != YFilter.not_set or
                    self.p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.p2mp_tail_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_head_destinations.yfilter != YFilter.not_set or
                    self.p2p_head_destinations_up.yfilter != YFilter.not_set or
                    self.p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_tail_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_tail_tunnels.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels_standby_up.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels_up.yfilter != YFilter.not_set or
                    self.pcalc_tie_breaker_type.yfilter != YFilter.not_set or
                    self.pcalc_tiebreaker.yfilter != YFilter.not_set or
                    self.proceeding_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.promotion_period.yfilter != YFilter.not_set or
                    self.protected_head_tunnels.yfilter != YFilter.not_set or
                    self.protected_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.protected_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.protected_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.recovered_heads.yfilter != YFilter.not_set or
                    self.recovering_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.reoptimization_period.yfilter != YFilter.not_set or
                    self.rerouted_head_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_interfaces.yfilter != YFilter.not_set or
                    self.rerouted_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.te_process_status.yfilter != YFilter.not_set or
                    self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                    self.tunnel_check_period.yfilter != YFilter.not_set or
                    self.tunnel_verify_period.yfilter != YFilter.not_set or
                    self.up_p2mp_head_destinations.yfilter != YFilter.not_set or
                    self.up_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.up_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2mp_tail_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.up_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_tail_s2_ls.yfilter != YFilter.not_set or
                    self.user_defined_paths.yfilter != YFilter.not_set or
                    (self.auto_mesh_one_hop_summary is not None and self.auto_mesh_one_hop_summary.has_operation()) or
                    (self.auto_mesh_summary is not None and self.auto_mesh_summary.has_operation()) or
                    (self.auto_tun_server_summary is not None and self.auto_tun_server_summary.has_operation()) or
                    (self.autobackup_summary is not None and self.autobackup_summary.has_operation()) or
                    (self.current_tunnel_convergence_summary is not None and self.current_tunnel_convergence_summary.has_operation()) or
                    (self.gmpls_nni_summary is not None and self.gmpls_nni_summary.has_operation()) or
                    (self.gmpls_uni_summary is not None and self.gmpls_uni_summary.has_operation()) or
                    (self.last_tunnel_convergence_summary is not None and self.last_tunnel_convergence_summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.activated_heads.is_set or self.activated_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.activated_heads.get_name_leafdata())
                if (self.auto_bandwidth_collection_period.is_set or self.auto_bandwidth_collection_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.auto_bandwidth_collection_period.get_name_leafdata())
                if (self.auto_bandwidth_tunnels.is_set or self.auto_bandwidth_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.auto_bandwidth_tunnels.get_name_leafdata())
                if (self.backup_tunnels.is_set or self.backup_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.backup_tunnels.get_name_leafdata())
                if (self.backups_assigned.is_set or self.backups_assigned.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.backups_assigned.get_name_leafdata())
                if (self.bidir_head_ls_ps_associated.is_set or self.bidir_head_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_associated.get_name_leafdata())
                if (self.bidir_head_ls_ps_proceeding.is_set or self.bidir_head_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_head_ls_ps_standby.is_set or self.bidir_head_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_standby.get_name_leafdata())
                if (self.bidir_head_ls_ps_up.is_set or self.bidir_head_ls_ps_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_up.get_name_leafdata())
                if (self.bidir_head_tunnels.is_set or self.bidir_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels.get_name_leafdata())
                if (self.bidir_head_tunnels_associated.is_set or self.bidir_head_tunnels_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_associated.get_name_leafdata())
                if (self.bidir_head_tunnels_corouted.is_set or self.bidir_head_tunnels_corouted.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_corouted.get_name_leafdata())
                if (self.bidir_head_tunnels_up.is_set or self.bidir_head_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_up.get_name_leafdata())
                if (self.bidir_mid_ls_ps_associated.is_set or self.bidir_mid_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_associated.get_name_leafdata())
                if (self.bidir_mid_ls_ps_proceeding.is_set or self.bidir_mid_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_mid_ls_ps_standby.is_set or self.bidir_mid_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_standby.get_name_leafdata())
                if (self.bidir_mid_tunnels.is_set or self.bidir_mid_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_tunnels.get_name_leafdata())
                if (self.bidir_mid_tunnels_up.is_set or self.bidir_mid_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_tunnels_up.get_name_leafdata())
                if (self.bidir_tail_ls_ps.is_set or self.bidir_tail_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps.get_name_leafdata())
                if (self.bidir_tail_ls_ps_associated.is_set or self.bidir_tail_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_associated.get_name_leafdata())
                if (self.bidir_tail_ls_ps_corouted.is_set or self.bidir_tail_ls_ps_corouted.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_corouted.get_name_leafdata())
                if (self.bidir_tail_ls_ps_proceeding.is_set or self.bidir_tail_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_tail_ls_ps_standby.is_set or self.bidir_tail_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_standby.get_name_leafdata())
                if (self.bidir_tail_ls_ps_up.is_set or self.bidir_tail_ls_ps_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_up.get_name_leafdata())
                if (self.bw_protected_p2mp_s2_ls.is_set or self.bw_protected_p2mp_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2mp_s2_ls.get_name_leafdata())
                if (self.bw_protected_p2p_s2_ls.is_set or self.bw_protected_p2p_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2p_s2_ls.get_name_leafdata())
                if (self.bw_protected_p2p_tunnels.is_set or self.bw_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2p_tunnels.get_name_leafdata())
                if (self.bw_protected_tunnels.is_set or self.bw_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_tunnels.get_name_leafdata())
                if (self.deactivated_heads.is_set or self.deactivated_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.deactivated_heads.get_name_leafdata())
                if (self.dynamic_up_p2p_head_tunnels.is_set or self.dynamic_up_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.dynamic_up_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_config_p2mp_head_tunnels.is_set or self.frr_config_p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_config_p2mp_head_tunnels.get_name_leafdata())
                if (self.frr_config_p2p_head_tunnels.is_set or self.frr_config_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_config_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_head_tunnels.is_set or self.frr_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_head_tunnels.get_name_leafdata())
                if (self.frr_mid_point_tunnels.is_set or self.frr_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_mid_point_tunnels.get_name_leafdata())
                if (self.frr_p2mp_head_s2_ls.is_set or self.frr_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2mp_head_s2_ls.get_name_leafdata())
                if (self.frr_p2mp_mid_point_s2_ls.is_set or self.frr_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.frr_p2p_head_s2_ls.is_set or self.frr_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_head_s2_ls.get_name_leafdata())
                if (self.frr_p2p_head_tunnels.is_set or self.frr_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_p2p_mid_point_s2_ls.is_set or self.frr_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.frr_p2p_mid_point_tunnels.is_set or self.frr_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.frr_protected_interfaces.is_set or self.frr_protected_interfaces.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_protected_interfaces.get_name_leafdata())
                if (self.is_forwarding_enabled.is_set or self.is_forwarding_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_forwarding_enabled.get_name_leafdata())
                if (self.is_periodic_reoptimization_on.is_set or self.is_periodic_reoptimization_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_periodic_reoptimization_on.get_name_leafdata())
                if (self.is_promotion_on.is_set or self.is_promotion_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_promotion_on.get_name_leafdata())
                if (self.is_rsvp_process_enabled.is_set or self.is_rsvp_process_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_rsvp_process_enabled.get_name_leafdata())
                if (self.link_and_node_diverse_paths.is_set or self.link_and_node_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_and_node_diverse_paths.get_name_leafdata())
                if (self.link_diverse_paths.is_set or self.link_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_diverse_paths.get_name_leafdata())
                if (self.link_protected_p2mp_s2_ls.is_set or self.link_protected_p2mp_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2mp_s2_ls.get_name_leafdata())
                if (self.link_protected_p2p_s2_ls.is_set or self.link_protected_p2p_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2p_s2_ls.get_name_leafdata())
                if (self.link_protected_p2p_tunnels.is_set or self.link_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2p_tunnels.get_name_leafdata())
                if (self.link_protected_tunnels.is_set or self.link_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_tunnels.get_name_leafdata())
                if (self.next_check_time.is_set or self.next_check_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_check_time.get_name_leafdata())
                if (self.next_promotion_timer.is_set or self.next_promotion_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_promotion_timer.get_name_leafdata())
                if (self.next_reoptimization_timer.is_set or self.next_reoptimization_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_reoptimization_timer.get_name_leafdata())
                if (self.next_verify_timer.is_set or self.next_verify_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_verify_timer.get_name_leafdata())
                if (self.node_diverse_paths.is_set or self.node_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_diverse_paths.get_name_leafdata())
                if (self.node_protected_p2p_tunnels.is_set or self.node_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_protected_p2p_tunnels.get_name_leafdata())
                if (self.node_protected_tunnels.is_set or self.node_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_protected_tunnels.get_name_leafdata())
                if (self.p2mp_head_destinations.is_set or self.p2mp_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_head_destinations.get_name_leafdata())
                if (self.p2mp_head_tunnels.is_set or self.p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_head_tunnels.get_name_leafdata())
                if (self.p2mp_mid_point_s2_ls.is_set or self.p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.p2mp_tail_s2_ls.is_set or self.p2mp_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_tail_s2_ls.get_name_leafdata())
                if (self.p2p_head_destinations.is_set or self.p2p_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_destinations.get_name_leafdata())
                if (self.p2p_head_destinations_up.is_set or self.p2p_head_destinations_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_destinations_up.get_name_leafdata())
                if (self.p2p_head_tunnels.is_set or self.p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_tunnels.get_name_leafdata())
                if (self.p2p_mid_point_s2_ls.is_set or self.p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.p2p_tail_s2_ls.is_set or self.p2p_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_tail_s2_ls.get_name_leafdata())
                if (self.p2p_tail_tunnels.is_set or self.p2p_tail_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_tail_tunnels.get_name_leafdata())
                if (self.path_protect_configured_tunnels.is_set or self.path_protect_configured_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels.get_name_leafdata())
                if (self.path_protect_configured_tunnels_standby_up.is_set or self.path_protect_configured_tunnels_standby_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels_standby_up.get_name_leafdata())
                if (self.path_protect_configured_tunnels_up.is_set or self.path_protect_configured_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels_up.get_name_leafdata())
                if (self.pcalc_tie_breaker_type.is_set or self.pcalc_tie_breaker_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcalc_tie_breaker_type.get_name_leafdata())
                if (self.pcalc_tiebreaker.is_set or self.pcalc_tiebreaker.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcalc_tiebreaker.get_name_leafdata())
                if (self.proceeding_p2mp_head_s2_ls.is_set or self.proceeding_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2mp_head_s2_ls.get_name_leafdata())
                if (self.proceeding_p2mp_mid_point_s2_ls.is_set or self.proceeding_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.proceeding_p2p_head_s2_ls.is_set or self.proceeding_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2p_head_s2_ls.get_name_leafdata())
                if (self.proceeding_p2p_mid_point_s2_ls.is_set or self.proceeding_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.promotion_period.is_set or self.promotion_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.promotion_period.get_name_leafdata())
                if (self.protected_head_tunnels.is_set or self.protected_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_head_tunnels.get_name_leafdata())
                if (self.protected_mid_point_tunnels.is_set or self.protected_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_mid_point_tunnels.get_name_leafdata())
                if (self.protected_p2mp_head_s2_ls.is_set or self.protected_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2mp_head_s2_ls.get_name_leafdata())
                if (self.protected_p2mp_mid_point_s2_ls.is_set or self.protected_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.protected_p2p_head_s2_ls.is_set or self.protected_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_head_s2_ls.get_name_leafdata())
                if (self.protected_p2p_head_tunnels.is_set or self.protected_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_head_tunnels.get_name_leafdata())
                if (self.protected_p2p_mid_point_s2_ls.is_set or self.protected_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.protected_p2p_mid_point_tunnels.is_set or self.protected_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.recovered_heads.is_set or self.recovered_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovered_heads.get_name_leafdata())
                if (self.recovering_p2p_head_s2_ls.is_set or self.recovering_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovering_p2p_head_s2_ls.get_name_leafdata())
                if (self.reoptimization_period.is_set or self.reoptimization_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reoptimization_period.get_name_leafdata())
                if (self.rerouted_head_tunnels.is_set or self.rerouted_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_head_tunnels.get_name_leafdata())
                if (self.rerouted_interfaces.is_set or self.rerouted_interfaces.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_interfaces.get_name_leafdata())
                if (self.rerouted_mid_point_tunnels.is_set or self.rerouted_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_mid_point_tunnels.get_name_leafdata())
                if (self.rerouted_p2mp_head_s2_ls.is_set or self.rerouted_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2mp_head_s2_ls.get_name_leafdata())
                if (self.rerouted_p2mp_mid_point_s2_ls.is_set or self.rerouted_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_head_s2_ls.is_set or self.rerouted_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_head_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_head_tunnels.is_set or self.rerouted_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_head_tunnels.get_name_leafdata())
                if (self.rerouted_p2p_mid_point_s2_ls.is_set or self.rerouted_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_mid_point_tunnels.is_set or self.rerouted_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.te_process_status.is_set or self.te_process_status.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.te_process_status.get_name_leafdata())
                if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                if (self.tunnel_check_period.is_set or self.tunnel_check_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_check_period.get_name_leafdata())
                if (self.tunnel_verify_period.is_set or self.tunnel_verify_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_verify_period.get_name_leafdata())
                if (self.up_p2mp_head_destinations.is_set or self.up_p2mp_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_destinations.get_name_leafdata())
                if (self.up_p2mp_head_s2_ls.is_set or self.up_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_s2_ls.get_name_leafdata())
                if (self.up_p2mp_head_tunnels.is_set or self.up_p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_tunnels.get_name_leafdata())
                if (self.up_p2mp_mid_point_s2_ls.is_set or self.up_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.up_p2mp_tail_s2_ls.is_set or self.up_p2mp_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_tail_s2_ls.get_name_leafdata())
                if (self.up_p2p_head_s2_ls.is_set or self.up_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_head_s2_ls.get_name_leafdata())
                if (self.up_p2p_head_tunnels.is_set or self.up_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_head_tunnels.get_name_leafdata())
                if (self.up_p2p_mid_point_s2_ls.is_set or self.up_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.up_p2p_tail_s2_ls.is_set or self.up_p2p_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_tail_s2_ls.get_name_leafdata())
                if (self.user_defined_paths.is_set or self.user_defined_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.user_defined_paths.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "auto-mesh-one-hop-summary"):
                    if (self.auto_mesh_one_hop_summary is None):
                        self.auto_mesh_one_hop_summary = MplsTe.Tunnels.Summary.AutoMeshOneHopSummary()
                        self.auto_mesh_one_hop_summary.parent = self
                        self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"
                    return self.auto_mesh_one_hop_summary

                if (child_yang_name == "auto-mesh-summary"):
                    if (self.auto_mesh_summary is None):
                        self.auto_mesh_summary = MplsTe.Tunnels.Summary.AutoMeshSummary()
                        self.auto_mesh_summary.parent = self
                        self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"
                    return self.auto_mesh_summary

                if (child_yang_name == "auto-tun-server-summary"):
                    if (self.auto_tun_server_summary is None):
                        self.auto_tun_server_summary = MplsTe.Tunnels.Summary.AutoTunServerSummary()
                        self.auto_tun_server_summary.parent = self
                        self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                    return self.auto_tun_server_summary

                if (child_yang_name == "autobackup-summary"):
                    if (self.autobackup_summary is None):
                        self.autobackup_summary = MplsTe.Tunnels.Summary.AutobackupSummary()
                        self.autobackup_summary.parent = self
                        self._children_name_map["autobackup_summary"] = "autobackup-summary"
                    return self.autobackup_summary

                if (child_yang_name == "current-tunnel-convergence-summary"):
                    if (self.current_tunnel_convergence_summary is None):
                        self.current_tunnel_convergence_summary = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                        self.current_tunnel_convergence_summary.parent = self
                        self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"
                    return self.current_tunnel_convergence_summary

                if (child_yang_name == "gmpls-nni-summary"):
                    if (self.gmpls_nni_summary is None):
                        self.gmpls_nni_summary = MplsTe.Tunnels.Summary.GmplsNniSummary()
                        self.gmpls_nni_summary.parent = self
                        self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"
                    return self.gmpls_nni_summary

                if (child_yang_name == "gmpls-uni-summary"):
                    if (self.gmpls_uni_summary is None):
                        self.gmpls_uni_summary = MplsTe.Tunnels.Summary.GmplsUniSummary()
                        self.gmpls_uni_summary.parent = self
                        self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"
                    return self.gmpls_uni_summary

                if (child_yang_name == "last-tunnel-convergence-summary"):
                    if (self.last_tunnel_convergence_summary is None):
                        self.last_tunnel_convergence_summary = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary()
                        self.last_tunnel_convergence_summary.parent = self
                        self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"
                    return self.last_tunnel_convergence_summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "auto-mesh-one-hop-summary" or name == "auto-mesh-summary" or name == "auto-tun-server-summary" or name == "autobackup-summary" or name == "current-tunnel-convergence-summary" or name == "gmpls-nni-summary" or name == "gmpls-uni-summary" or name == "last-tunnel-convergence-summary" or name == "activated-heads" or name == "auto-bandwidth-collection-period" or name == "auto-bandwidth-tunnels" or name == "backup-tunnels" or name == "backups-assigned" or name == "bidir-head-ls-ps-associated" or name == "bidir-head-ls-ps-proceeding" or name == "bidir-head-ls-ps-standby" or name == "bidir-head-ls-ps-up" or name == "bidir-head-tunnels" or name == "bidir-head-tunnels-associated" or name == "bidir-head-tunnels-corouted" or name == "bidir-head-tunnels-up" or name == "bidir-mid-ls-ps-associated" or name == "bidir-mid-ls-ps-proceeding" or name == "bidir-mid-ls-ps-standby" or name == "bidir-mid-tunnels" or name == "bidir-mid-tunnels-up" or name == "bidir-tail-ls-ps" or name == "bidir-tail-ls-ps-associated" or name == "bidir-tail-ls-ps-corouted" or name == "bidir-tail-ls-ps-proceeding" or name == "bidir-tail-ls-ps-standby" or name == "bidir-tail-ls-ps-up" or name == "bw-protected-p2mp-s2-ls" or name == "bw-protected-p2p-s2-ls" or name == "bw-protected-p2p-tunnels" or name == "bw-protected-tunnels" or name == "deactivated-heads" or name == "dynamic-up-p2p-head-tunnels" or name == "frr-config-p2mp-head-tunnels" or name == "frr-config-p2p-head-tunnels" or name == "frr-head-tunnels" or name == "frr-mid-point-tunnels" or name == "frr-p2mp-head-s2-ls" or name == "frr-p2mp-mid-point-s2-ls" or name == "frr-p2p-head-s2-ls" or name == "frr-p2p-head-tunnels" or name == "frr-p2p-mid-point-s2-ls" or name == "frr-p2p-mid-point-tunnels" or name == "frr-protected-interfaces" or name == "is-forwarding-enabled" or name == "is-periodic-reoptimization-on" or name == "is-promotion-on" or name == "is-rsvp-process-enabled" or name == "link-and-node-diverse-paths" or name == "link-diverse-paths" or name == "link-protected-p2mp-s2-ls" or name == "link-protected-p2p-s2-ls" or name == "link-protected-p2p-tunnels" or name == "link-protected-tunnels" or name == "next-check-time" or name == "next-promotion-timer" or name == "next-reoptimization-timer" or name == "next-verify-timer" or name == "node-diverse-paths" or name == "node-protected-p2p-tunnels" or name == "node-protected-tunnels" or name == "p2mp-head-destinations" or name == "p2mp-head-tunnels" or name == "p2mp-mid-point-s2-ls" or name == "p2mp-tail-s2-ls" or name == "p2p-head-destinations" or name == "p2p-head-destinations-up" or name == "p2p-head-tunnels" or name == "p2p-mid-point-s2-ls" or name == "p2p-tail-s2-ls" or name == "p2p-tail-tunnels" or name == "path-protect-configured-tunnels" or name == "path-protect-configured-tunnels-standby-up" or name == "path-protect-configured-tunnels-up" or name == "pcalc-tie-breaker-type" or name == "pcalc-tiebreaker" or name == "proceeding-p2mp-head-s2-ls" or name == "proceeding-p2mp-mid-point-s2-ls" or name == "proceeding-p2p-head-s2-ls" or name == "proceeding-p2p-mid-point-s2-ls" or name == "promotion-period" or name == "protected-head-tunnels" or name == "protected-mid-point-tunnels" or name == "protected-p2mp-head-s2-ls" or name == "protected-p2mp-mid-point-s2-ls" or name == "protected-p2p-head-s2-ls" or name == "protected-p2p-head-tunnels" or name == "protected-p2p-mid-point-s2-ls" or name == "protected-p2p-mid-point-tunnels" or name == "recovered-heads" or name == "recovering-p2p-head-s2-ls" or name == "reoptimization-period" or name == "rerouted-head-tunnels" or name == "rerouted-interfaces" or name == "rerouted-mid-point-tunnels" or name == "rerouted-p2mp-head-s2-ls" or name == "rerouted-p2mp-mid-point-s2-ls" or name == "rerouted-p2p-head-s2-ls" or name == "rerouted-p2p-head-tunnels" or name == "rerouted-p2p-mid-point-s2-ls" or name == "rerouted-p2p-mid-point-tunnels" or name == "te-process-status" or name == "tiebreaker-qualifier" or name == "tunnel-check-period" or name == "tunnel-verify-period" or name == "up-p2mp-head-destinations" or name == "up-p2mp-head-s2-ls" or name == "up-p2mp-head-tunnels" or name == "up-p2mp-mid-point-s2-ls" or name == "up-p2mp-tail-s2-ls" or name == "up-p2p-head-s2-ls" or name == "up-p2p-head-tunnels" or name == "up-p2p-mid-point-s2-ls" or name == "up-p2p-tail-s2-ls" or name == "user-defined-paths"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "activated-heads"):
                    self.activated_heads = value
                    self.activated_heads.value_namespace = name_space
                    self.activated_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "auto-bandwidth-collection-period"):
                    self.auto_bandwidth_collection_period = value
                    self.auto_bandwidth_collection_period.value_namespace = name_space
                    self.auto_bandwidth_collection_period.value_namespace_prefix = name_space_prefix
                if(value_path == "auto-bandwidth-tunnels"):
                    self.auto_bandwidth_tunnels = value
                    self.auto_bandwidth_tunnels.value_namespace = name_space
                    self.auto_bandwidth_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "backup-tunnels"):
                    self.backup_tunnels = value
                    self.backup_tunnels.value_namespace = name_space
                    self.backup_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "backups-assigned"):
                    self.backups_assigned = value
                    self.backups_assigned.value_namespace = name_space
                    self.backups_assigned.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-associated"):
                    self.bidir_head_ls_ps_associated = value
                    self.bidir_head_ls_ps_associated.value_namespace = name_space
                    self.bidir_head_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-proceeding"):
                    self.bidir_head_ls_ps_proceeding = value
                    self.bidir_head_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_head_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-standby"):
                    self.bidir_head_ls_ps_standby = value
                    self.bidir_head_ls_ps_standby.value_namespace = name_space
                    self.bidir_head_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-up"):
                    self.bidir_head_ls_ps_up = value
                    self.bidir_head_ls_ps_up.value_namespace = name_space
                    self.bidir_head_ls_ps_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels"):
                    self.bidir_head_tunnels = value
                    self.bidir_head_tunnels.value_namespace = name_space
                    self.bidir_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-associated"):
                    self.bidir_head_tunnels_associated = value
                    self.bidir_head_tunnels_associated.value_namespace = name_space
                    self.bidir_head_tunnels_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-corouted"):
                    self.bidir_head_tunnels_corouted = value
                    self.bidir_head_tunnels_corouted.value_namespace = name_space
                    self.bidir_head_tunnels_corouted.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-up"):
                    self.bidir_head_tunnels_up = value
                    self.bidir_head_tunnels_up.value_namespace = name_space
                    self.bidir_head_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-associated"):
                    self.bidir_mid_ls_ps_associated = value
                    self.bidir_mid_ls_ps_associated.value_namespace = name_space
                    self.bidir_mid_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-proceeding"):
                    self.bidir_mid_ls_ps_proceeding = value
                    self.bidir_mid_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_mid_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-standby"):
                    self.bidir_mid_ls_ps_standby = value
                    self.bidir_mid_ls_ps_standby.value_namespace = name_space
                    self.bidir_mid_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-tunnels"):
                    self.bidir_mid_tunnels = value
                    self.bidir_mid_tunnels.value_namespace = name_space
                    self.bidir_mid_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-tunnels-up"):
                    self.bidir_mid_tunnels_up = value
                    self.bidir_mid_tunnels_up.value_namespace = name_space
                    self.bidir_mid_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps"):
                    self.bidir_tail_ls_ps = value
                    self.bidir_tail_ls_ps.value_namespace = name_space
                    self.bidir_tail_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-associated"):
                    self.bidir_tail_ls_ps_associated = value
                    self.bidir_tail_ls_ps_associated.value_namespace = name_space
                    self.bidir_tail_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-corouted"):
                    self.bidir_tail_ls_ps_corouted = value
                    self.bidir_tail_ls_ps_corouted.value_namespace = name_space
                    self.bidir_tail_ls_ps_corouted.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-proceeding"):
                    self.bidir_tail_ls_ps_proceeding = value
                    self.bidir_tail_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_tail_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-standby"):
                    self.bidir_tail_ls_ps_standby = value
                    self.bidir_tail_ls_ps_standby.value_namespace = name_space
                    self.bidir_tail_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-up"):
                    self.bidir_tail_ls_ps_up = value
                    self.bidir_tail_ls_ps_up.value_namespace = name_space
                    self.bidir_tail_ls_ps_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2mp-s2-ls"):
                    self.bw_protected_p2mp_s2_ls = value
                    self.bw_protected_p2mp_s2_ls.value_namespace = name_space
                    self.bw_protected_p2mp_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2p-s2-ls"):
                    self.bw_protected_p2p_s2_ls = value
                    self.bw_protected_p2p_s2_ls.value_namespace = name_space
                    self.bw_protected_p2p_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2p-tunnels"):
                    self.bw_protected_p2p_tunnels = value
                    self.bw_protected_p2p_tunnels.value_namespace = name_space
                    self.bw_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-tunnels"):
                    self.bw_protected_tunnels = value
                    self.bw_protected_tunnels.value_namespace = name_space
                    self.bw_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "deactivated-heads"):
                    self.deactivated_heads = value
                    self.deactivated_heads.value_namespace = name_space
                    self.deactivated_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "dynamic-up-p2p-head-tunnels"):
                    self.dynamic_up_p2p_head_tunnels = value
                    self.dynamic_up_p2p_head_tunnels.value_namespace = name_space
                    self.dynamic_up_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-config-p2mp-head-tunnels"):
                    self.frr_config_p2mp_head_tunnels = value
                    self.frr_config_p2mp_head_tunnels.value_namespace = name_space
                    self.frr_config_p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-config-p2p-head-tunnels"):
                    self.frr_config_p2p_head_tunnels = value
                    self.frr_config_p2p_head_tunnels.value_namespace = name_space
                    self.frr_config_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-head-tunnels"):
                    self.frr_head_tunnels = value
                    self.frr_head_tunnels.value_namespace = name_space
                    self.frr_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-mid-point-tunnels"):
                    self.frr_mid_point_tunnels = value
                    self.frr_mid_point_tunnels.value_namespace = name_space
                    self.frr_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2mp-head-s2-ls"):
                    self.frr_p2mp_head_s2_ls = value
                    self.frr_p2mp_head_s2_ls.value_namespace = name_space
                    self.frr_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2mp-mid-point-s2-ls"):
                    self.frr_p2mp_mid_point_s2_ls = value
                    self.frr_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.frr_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-head-s2-ls"):
                    self.frr_p2p_head_s2_ls = value
                    self.frr_p2p_head_s2_ls.value_namespace = name_space
                    self.frr_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-head-tunnels"):
                    self.frr_p2p_head_tunnels = value
                    self.frr_p2p_head_tunnels.value_namespace = name_space
                    self.frr_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-mid-point-s2-ls"):
                    self.frr_p2p_mid_point_s2_ls = value
                    self.frr_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.frr_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-mid-point-tunnels"):
                    self.frr_p2p_mid_point_tunnels = value
                    self.frr_p2p_mid_point_tunnels.value_namespace = name_space
                    self.frr_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-protected-interfaces"):
                    self.frr_protected_interfaces = value
                    self.frr_protected_interfaces.value_namespace = name_space
                    self.frr_protected_interfaces.value_namespace_prefix = name_space_prefix
                if(value_path == "is-forwarding-enabled"):
                    self.is_forwarding_enabled = value
                    self.is_forwarding_enabled.value_namespace = name_space
                    self.is_forwarding_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "is-periodic-reoptimization-on"):
                    self.is_periodic_reoptimization_on = value
                    self.is_periodic_reoptimization_on.value_namespace = name_space
                    self.is_periodic_reoptimization_on.value_namespace_prefix = name_space_prefix
                if(value_path == "is-promotion-on"):
                    self.is_promotion_on = value
                    self.is_promotion_on.value_namespace = name_space
                    self.is_promotion_on.value_namespace_prefix = name_space_prefix
                if(value_path == "is-rsvp-process-enabled"):
                    self.is_rsvp_process_enabled = value
                    self.is_rsvp_process_enabled.value_namespace = name_space
                    self.is_rsvp_process_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "link-and-node-diverse-paths"):
                    self.link_and_node_diverse_paths = value
                    self.link_and_node_diverse_paths.value_namespace = name_space
                    self.link_and_node_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "link-diverse-paths"):
                    self.link_diverse_paths = value
                    self.link_diverse_paths.value_namespace = name_space
                    self.link_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2mp-s2-ls"):
                    self.link_protected_p2mp_s2_ls = value
                    self.link_protected_p2mp_s2_ls.value_namespace = name_space
                    self.link_protected_p2mp_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2p-s2-ls"):
                    self.link_protected_p2p_s2_ls = value
                    self.link_protected_p2p_s2_ls.value_namespace = name_space
                    self.link_protected_p2p_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2p-tunnels"):
                    self.link_protected_p2p_tunnels = value
                    self.link_protected_p2p_tunnels.value_namespace = name_space
                    self.link_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-tunnels"):
                    self.link_protected_tunnels = value
                    self.link_protected_tunnels.value_namespace = name_space
                    self.link_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "next-check-time"):
                    self.next_check_time = value
                    self.next_check_time.value_namespace = name_space
                    self.next_check_time.value_namespace_prefix = name_space_prefix
                if(value_path == "next-promotion-timer"):
                    self.next_promotion_timer = value
                    self.next_promotion_timer.value_namespace = name_space
                    self.next_promotion_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "next-reoptimization-timer"):
                    self.next_reoptimization_timer = value
                    self.next_reoptimization_timer.value_namespace = name_space
                    self.next_reoptimization_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "next-verify-timer"):
                    self.next_verify_timer = value
                    self.next_verify_timer.value_namespace = name_space
                    self.next_verify_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "node-diverse-paths"):
                    self.node_diverse_paths = value
                    self.node_diverse_paths.value_namespace = name_space
                    self.node_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "node-protected-p2p-tunnels"):
                    self.node_protected_p2p_tunnels = value
                    self.node_protected_p2p_tunnels.value_namespace = name_space
                    self.node_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "node-protected-tunnels"):
                    self.node_protected_tunnels = value
                    self.node_protected_tunnels.value_namespace = name_space
                    self.node_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-head-destinations"):
                    self.p2mp_head_destinations = value
                    self.p2mp_head_destinations.value_namespace = name_space
                    self.p2mp_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-head-tunnels"):
                    self.p2mp_head_tunnels = value
                    self.p2mp_head_tunnels.value_namespace = name_space
                    self.p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-mid-point-s2-ls"):
                    self.p2mp_mid_point_s2_ls = value
                    self.p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-tail-s2-ls"):
                    self.p2mp_tail_s2_ls = value
                    self.p2mp_tail_s2_ls.value_namespace = name_space
                    self.p2mp_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-destinations"):
                    self.p2p_head_destinations = value
                    self.p2p_head_destinations.value_namespace = name_space
                    self.p2p_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-destinations-up"):
                    self.p2p_head_destinations_up = value
                    self.p2p_head_destinations_up.value_namespace = name_space
                    self.p2p_head_destinations_up.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-tunnels"):
                    self.p2p_head_tunnels = value
                    self.p2p_head_tunnels.value_namespace = name_space
                    self.p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-mid-point-s2-ls"):
                    self.p2p_mid_point_s2_ls = value
                    self.p2p_mid_point_s2_ls.value_namespace = name_space
                    self.p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-tail-s2-ls"):
                    self.p2p_tail_s2_ls = value
                    self.p2p_tail_s2_ls.value_namespace = name_space
                    self.p2p_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-tail-tunnels"):
                    self.p2p_tail_tunnels = value
                    self.p2p_tail_tunnels.value_namespace = name_space
                    self.p2p_tail_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels"):
                    self.path_protect_configured_tunnels = value
                    self.path_protect_configured_tunnels.value_namespace = name_space
                    self.path_protect_configured_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels-standby-up"):
                    self.path_protect_configured_tunnels_standby_up = value
                    self.path_protect_configured_tunnels_standby_up.value_namespace = name_space
                    self.path_protect_configured_tunnels_standby_up.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels-up"):
                    self.path_protect_configured_tunnels_up = value
                    self.path_protect_configured_tunnels_up.value_namespace = name_space
                    self.path_protect_configured_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "pcalc-tie-breaker-type"):
                    self.pcalc_tie_breaker_type = value
                    self.pcalc_tie_breaker_type.value_namespace = name_space
                    self.pcalc_tie_breaker_type.value_namespace_prefix = name_space_prefix
                if(value_path == "pcalc-tiebreaker"):
                    self.pcalc_tiebreaker = value
                    self.pcalc_tiebreaker.value_namespace = name_space
                    self.pcalc_tiebreaker.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2mp-head-s2-ls"):
                    self.proceeding_p2mp_head_s2_ls = value
                    self.proceeding_p2mp_head_s2_ls.value_namespace = name_space
                    self.proceeding_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2mp-mid-point-s2-ls"):
                    self.proceeding_p2mp_mid_point_s2_ls = value
                    self.proceeding_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.proceeding_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2p-head-s2-ls"):
                    self.proceeding_p2p_head_s2_ls = value
                    self.proceeding_p2p_head_s2_ls.value_namespace = name_space
                    self.proceeding_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2p-mid-point-s2-ls"):
                    self.proceeding_p2p_mid_point_s2_ls = value
                    self.proceeding_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.proceeding_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "promotion-period"):
                    self.promotion_period = value
                    self.promotion_period.value_namespace = name_space
                    self.promotion_period.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-head-tunnels"):
                    self.protected_head_tunnels = value
                    self.protected_head_tunnels.value_namespace = name_space
                    self.protected_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-mid-point-tunnels"):
                    self.protected_mid_point_tunnels = value
                    self.protected_mid_point_tunnels.value_namespace = name_space
                    self.protected_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2mp-head-s2-ls"):
                    self.protected_p2mp_head_s2_ls = value
                    self.protected_p2mp_head_s2_ls.value_namespace = name_space
                    self.protected_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2mp-mid-point-s2-ls"):
                    self.protected_p2mp_mid_point_s2_ls = value
                    self.protected_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.protected_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-head-s2-ls"):
                    self.protected_p2p_head_s2_ls = value
                    self.protected_p2p_head_s2_ls.value_namespace = name_space
                    self.protected_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-head-tunnels"):
                    self.protected_p2p_head_tunnels = value
                    self.protected_p2p_head_tunnels.value_namespace = name_space
                    self.protected_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-mid-point-s2-ls"):
                    self.protected_p2p_mid_point_s2_ls = value
                    self.protected_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.protected_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-mid-point-tunnels"):
                    self.protected_p2p_mid_point_tunnels = value
                    self.protected_p2p_mid_point_tunnels.value_namespace = name_space
                    self.protected_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "recovered-heads"):
                    self.recovered_heads = value
                    self.recovered_heads.value_namespace = name_space
                    self.recovered_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "recovering-p2p-head-s2-ls"):
                    self.recovering_p2p_head_s2_ls = value
                    self.recovering_p2p_head_s2_ls.value_namespace = name_space
                    self.recovering_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "reoptimization-period"):
                    self.reoptimization_period = value
                    self.reoptimization_period.value_namespace = name_space
                    self.reoptimization_period.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-head-tunnels"):
                    self.rerouted_head_tunnels = value
                    self.rerouted_head_tunnels.value_namespace = name_space
                    self.rerouted_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-interfaces"):
                    self.rerouted_interfaces = value
                    self.rerouted_interfaces.value_namespace = name_space
                    self.rerouted_interfaces.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-mid-point-tunnels"):
                    self.rerouted_mid_point_tunnels = value
                    self.rerouted_mid_point_tunnels.value_namespace = name_space
                    self.rerouted_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2mp-head-s2-ls"):
                    self.rerouted_p2mp_head_s2_ls = value
                    self.rerouted_p2mp_head_s2_ls.value_namespace = name_space
                    self.rerouted_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2mp-mid-point-s2-ls"):
                    self.rerouted_p2mp_mid_point_s2_ls = value
                    self.rerouted_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.rerouted_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-head-s2-ls"):
                    self.rerouted_p2p_head_s2_ls = value
                    self.rerouted_p2p_head_s2_ls.value_namespace = name_space
                    self.rerouted_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-head-tunnels"):
                    self.rerouted_p2p_head_tunnels = value
                    self.rerouted_p2p_head_tunnels.value_namespace = name_space
                    self.rerouted_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-mid-point-s2-ls"):
                    self.rerouted_p2p_mid_point_s2_ls = value
                    self.rerouted_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.rerouted_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-mid-point-tunnels"):
                    self.rerouted_p2p_mid_point_tunnels = value
                    self.rerouted_p2p_mid_point_tunnels.value_namespace = name_space
                    self.rerouted_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "te-process-status"):
                    self.te_process_status = value
                    self.te_process_status.value_namespace = name_space
                    self.te_process_status.value_namespace_prefix = name_space_prefix
                if(value_path == "tiebreaker-qualifier"):
                    self.tiebreaker_qualifier = value
                    self.tiebreaker_qualifier.value_namespace = name_space
                    self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-check-period"):
                    self.tunnel_check_period = value
                    self.tunnel_check_period.value_namespace = name_space
                    self.tunnel_check_period.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-verify-period"):
                    self.tunnel_verify_period = value
                    self.tunnel_verify_period.value_namespace = name_space
                    self.tunnel_verify_period.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-destinations"):
                    self.up_p2mp_head_destinations = value
                    self.up_p2mp_head_destinations.value_namespace = name_space
                    self.up_p2mp_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-s2-ls"):
                    self.up_p2mp_head_s2_ls = value
                    self.up_p2mp_head_s2_ls.value_namespace = name_space
                    self.up_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-tunnels"):
                    self.up_p2mp_head_tunnels = value
                    self.up_p2mp_head_tunnels.value_namespace = name_space
                    self.up_p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-mid-point-s2-ls"):
                    self.up_p2mp_mid_point_s2_ls = value
                    self.up_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.up_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-tail-s2-ls"):
                    self.up_p2mp_tail_s2_ls = value
                    self.up_p2mp_tail_s2_ls.value_namespace = name_space
                    self.up_p2mp_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-head-s2-ls"):
                    self.up_p2p_head_s2_ls = value
                    self.up_p2p_head_s2_ls.value_namespace = name_space
                    self.up_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-head-tunnels"):
                    self.up_p2p_head_tunnels = value
                    self.up_p2p_head_tunnels.value_namespace = name_space
                    self.up_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-mid-point-s2-ls"):
                    self.up_p2p_mid_point_s2_ls = value
                    self.up_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.up_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-tail-s2-ls"):
                    self.up_p2p_tail_s2_ls = value
                    self.up_p2p_tail_s2_ls.value_namespace = name_space
                    self.up_p2p_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "user-defined-paths"):
                    self.user_defined_paths = value
                    self.user_defined_paths.value_namespace = name_space
                    self.user_defined_paths.value_namespace_prefix = name_space_prefix


        class TunnelPathProtections(Entity):
            """
            Path protection
            
            .. attribute:: tunnel_path_protection
            
            	Path Protection
            	**type**\: list of    :py:class:`TunnelPathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Tunnels.TunnelPathProtections, self).__init__()

                self.yang_name = "tunnel-path-protections"
                self.yang_parent_name = "tunnels"

                self.tunnel_path_protection = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Tunnels.TunnelPathProtections, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Tunnels.TunnelPathProtections, self).__setattr__(name, value)


            class TunnelPathProtection(Entity):
                """
                Path Protection
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: current_lsp
                
                	 Current LSP info
                	**type**\:   :py:class:`CurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp>`
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection>`
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: standby_lsp
                
                	 Standby LSP info
                	**type**\:   :py:class:`StandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp>`
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__init__()

                    self.yang_name = "tunnel-path-protection"
                    self.yang_parent_name = "tunnel-path-protections"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.is_tunnel_up = YLeaf(YType.boolean, "is-tunnel-up")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.current_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                    self.current_lsp.parent = self
                    self._children_name_map["current_lsp"] = "current-lsp"
                    self._children_yang_names.add("current-lsp")

                    self.path_protection = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.standby_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                    self.standby_lsp.parent = self
                    self._children_name_map["standby_lsp"] = "standby-lsp"
                    self._children_yang_names.add("standby-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "is_tunnel_up",
                                    "source_address",
                                    "tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__setattr__(name, value)


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/path-protection/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class CurrentLsp(Entity):
                    """
                     Current LSP info
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of    :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__init__()

                        self.yang_name = "current-lsp"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.lsp_hop = YList(self)
                        self.srlsp_outgoing_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("lsp_local_label",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__setattr__(name, value)


                    class SrlspOutgoingInfo(Entity):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\:  str
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "current-lsp"

                            self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                            self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_output_interface",
                                            "lsp_output_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_output_interface.is_set or
                                self.lsp_output_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_output_interface.yfilter != YFilter.not_set or
                                self.lsp_output_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlsp-outgoing-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                            if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-output-interface" or name == "lsp-output-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-output-interface"):
                                self.lsp_output_interface = value
                                self.lsp_output_interface.value_namespace = name_space
                                self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-output-label"):
                                self.lsp_output_label = value
                                self.lsp_output_label.value_namespace = name_space
                                self.lsp_output_label.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "current-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.lsp_local_label.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set)

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "srlsp-outgoing-info"):
                            for c in self.srlsp_outgoing_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlsp_outgoing_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-hop" or name == "srlsp-outgoing-info" or name == "lsp-local-label" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix


                class StandbyLsp(Entity):
                    """
                     Standby LSP info
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of    :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__init__()

                        self.yang_name = "standby-lsp"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.lsp_hop = YList(self)
                        self.srlsp_outgoing_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("lsp_local_label",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__setattr__(name, value)


                    class SrlspOutgoingInfo(Entity):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\:  str
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "standby-lsp"

                            self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                            self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_output_interface",
                                            "lsp_output_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_output_interface.is_set or
                                self.lsp_output_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_output_interface.yfilter != YFilter.not_set or
                                self.lsp_output_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlsp-outgoing-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                            if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-output-interface" or name == "lsp-output-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-output-interface"):
                                self.lsp_output_interface = value
                                self.lsp_output_interface.value_namespace = name_space
                                self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-output-label"):
                                self.lsp_output_label = value
                                self.lsp_output_label.value_namespace = name_space
                                self.lsp_output_label.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "standby-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.lsp_local_label.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set)

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "srlsp-outgoing-info"):
                            for c in self.srlsp_outgoing_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlsp_outgoing_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-hop" or name == "srlsp-outgoing-info" or name == "lsp-local-label" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.is_tunnel_up.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_name.is_set or
                        (self.current_lsp is not None and self.current_lsp.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.standby_lsp is not None and self.standby_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.is_tunnel_up.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.current_lsp is not None and self.current_lsp.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.standby_lsp is not None and self.standby_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-path-protection" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.is_tunnel_up.is_set or self.is_tunnel_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_tunnel_up.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "current-lsp"):
                        if (self.current_lsp is None):
                            self.current_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                            self.current_lsp.parent = self
                            self._children_name_map["current_lsp"] = "current-lsp"
                        return self.current_lsp

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "standby-lsp"):
                        if (self.standby_lsp is None):
                            self.standby_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                            self.standby_lsp.parent = self
                            self._children_name_map["standby_lsp"] = "standby-lsp"
                        return self.standby_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "current-lsp" or name == "path-protection" or name == "standby-lsp" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "is-tunnel-up" or name == "source-address" or name == "tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-tunnel-up"):
                        self.is_tunnel_up = value
                        self.is_tunnel_up.value_namespace = name_space
                        self.is_tunnel_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_path_protection:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_path_protection:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-path-protections" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-path-protection"):
                    for c in self.tunnel_path_protection:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_path_protection.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-path-protection"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.summary is not None and self.summary.has_data()) or
                (self.tunnel_auto_bandwidths is not None and self.tunnel_auto_bandwidths.has_data()) or
                (self.tunnel_flex_lsps is not None and self.tunnel_flex_lsps.has_data()) or
                (self.tunnel_path_protections is not None and self.tunnel_path_protections.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()) or
                (self.tunnel_auto_bandwidths is not None and self.tunnel_auto_bandwidths.has_operation()) or
                (self.tunnel_flex_lsps is not None and self.tunnel_flex_lsps.has_operation()) or
                (self.tunnel_path_protections is not None and self.tunnel_path_protections.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTe.Tunnels.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            if (child_yang_name == "tunnel-auto-bandwidths"):
                if (self.tunnel_auto_bandwidths is None):
                    self.tunnel_auto_bandwidths = MplsTe.Tunnels.TunnelAutoBandwidths()
                    self.tunnel_auto_bandwidths.parent = self
                    self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"
                return self.tunnel_auto_bandwidths

            if (child_yang_name == "tunnel-flex-lsps"):
                if (self.tunnel_flex_lsps is None):
                    self.tunnel_flex_lsps = MplsTe.Tunnels.TunnelFlexLsps()
                    self.tunnel_flex_lsps.parent = self
                    self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"
                return self.tunnel_flex_lsps

            if (child_yang_name == "tunnel-path-protections"):
                if (self.tunnel_path_protections is None):
                    self.tunnel_path_protections = MplsTe.Tunnels.TunnelPathProtections()
                    self.tunnel_path_protections.parent = self
                    self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
                return self.tunnel_path_protections

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary" or name == "tunnel-auto-bandwidths" or name == "tunnel-flex-lsps" or name == "tunnel-path-protections"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class MaximumTunnels(Entity):
        """
        MPLS Traffic Engineering Tunnels
        
        .. attribute:: absolute_maximum
        
        	Absolute Maximum
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_auto_mesh
        
        	Current Autotunnel Mesh count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_autobackups
        
        	Current Autotunnel Backup count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_destination_count
        
        	Current Destination Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_gmpls_uni
        
        	Current GMPLS\-UNI tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_auto_mesh
        
        	Current Maximum Autotunnel Mesh Allowed
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_autobackups
        
        	Current Maximum Autotunnel Backups Allowed
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_destinations
        
        	Current Maximum Destinations
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_gmpls_unitunnels
        
        	Current Maximum GMPLS\-UNI Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_p2mp_destnation_per_tunnel
        
        	Current Maximum P2MP Destinations Per Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_p2mp_tunnels
        
        	Current Maximum P2MP Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_tunnels
        
        	Current Maximum Tunnels
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_p2mp_destnation_per_tunnel_count
        
        	Current P2MP Destination per tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_p2mp_tunnel_count
        
        	Current P2MP tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_tunnel_count
        
        	Current tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: is_auto_mesh_range_configured
        
        	TRUE if the automesh range is configured
        	**type**\:  bool
        
        .. attribute:: is_autobackup_range_configured
        
        	TRUE if the autobackup range is configured
        	**type**\:  bool
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.MaximumTunnels, self).__init__()

            self.yang_name = "maximum-tunnels"
            self.yang_parent_name = "mpls-te"

            self.absolute_maximum = YLeaf(YType.uint32, "absolute-maximum")

            self.current_auto_mesh = YLeaf(YType.uint32, "current-auto-mesh")

            self.current_autobackups = YLeaf(YType.uint32, "current-autobackups")

            self.current_destination_count = YLeaf(YType.uint32, "current-destination-count")

            self.current_gmpls_uni = YLeaf(YType.uint32, "current-gmpls-uni")

            self.current_maximum_auto_mesh = YLeaf(YType.uint32, "current-maximum-auto-mesh")

            self.current_maximum_autobackups = YLeaf(YType.uint32, "current-maximum-autobackups")

            self.current_maximum_destinations = YLeaf(YType.uint32, "current-maximum-destinations")

            self.current_maximum_gmpls_unitunnels = YLeaf(YType.uint32, "current-maximum-gmpls-unitunnels")

            self.current_maximum_p2mp_destnation_per_tunnel = YLeaf(YType.uint32, "current-maximum-p2mp-destnation-per-tunnel")

            self.current_maximum_p2mp_tunnels = YLeaf(YType.uint32, "current-maximum-p2mp-tunnels")

            self.current_maximum_tunnels = YLeaf(YType.uint32, "current-maximum-tunnels")

            self.current_p2mp_destnation_per_tunnel_count = YLeaf(YType.uint32, "current-p2mp-destnation-per-tunnel-count")

            self.current_p2mp_tunnel_count = YLeaf(YType.uint32, "current-p2mp-tunnel-count")

            self.current_tunnel_count = YLeaf(YType.uint32, "current-tunnel-count")

            self.is_auto_mesh_range_configured = YLeaf(YType.boolean, "is-auto-mesh-range-configured")

            self.is_autobackup_range_configured = YLeaf(YType.boolean, "is-autobackup-range-configured")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("absolute_maximum",
                            "current_auto_mesh",
                            "current_autobackups",
                            "current_destination_count",
                            "current_gmpls_uni",
                            "current_maximum_auto_mesh",
                            "current_maximum_autobackups",
                            "current_maximum_destinations",
                            "current_maximum_gmpls_unitunnels",
                            "current_maximum_p2mp_destnation_per_tunnel",
                            "current_maximum_p2mp_tunnels",
                            "current_maximum_tunnels",
                            "current_p2mp_destnation_per_tunnel_count",
                            "current_p2mp_tunnel_count",
                            "current_tunnel_count",
                            "is_auto_mesh_range_configured",
                            "is_autobackup_range_configured") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.MaximumTunnels, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.MaximumTunnels, self).__setattr__(name, value)

        def has_data(self):
            return (
                self.absolute_maximum.is_set or
                self.current_auto_mesh.is_set or
                self.current_autobackups.is_set or
                self.current_destination_count.is_set or
                self.current_gmpls_uni.is_set or
                self.current_maximum_auto_mesh.is_set or
                self.current_maximum_autobackups.is_set or
                self.current_maximum_destinations.is_set or
                self.current_maximum_gmpls_unitunnels.is_set or
                self.current_maximum_p2mp_destnation_per_tunnel.is_set or
                self.current_maximum_p2mp_tunnels.is_set or
                self.current_maximum_tunnels.is_set or
                self.current_p2mp_destnation_per_tunnel_count.is_set or
                self.current_p2mp_tunnel_count.is_set or
                self.current_tunnel_count.is_set or
                self.is_auto_mesh_range_configured.is_set or
                self.is_autobackup_range_configured.is_set)

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.absolute_maximum.yfilter != YFilter.not_set or
                self.current_auto_mesh.yfilter != YFilter.not_set or
                self.current_autobackups.yfilter != YFilter.not_set or
                self.current_destination_count.yfilter != YFilter.not_set or
                self.current_gmpls_uni.yfilter != YFilter.not_set or
                self.current_maximum_auto_mesh.yfilter != YFilter.not_set or
                self.current_maximum_autobackups.yfilter != YFilter.not_set or
                self.current_maximum_destinations.yfilter != YFilter.not_set or
                self.current_maximum_gmpls_unitunnels.yfilter != YFilter.not_set or
                self.current_maximum_p2mp_destnation_per_tunnel.yfilter != YFilter.not_set or
                self.current_maximum_p2mp_tunnels.yfilter != YFilter.not_set or
                self.current_maximum_tunnels.yfilter != YFilter.not_set or
                self.current_p2mp_destnation_per_tunnel_count.yfilter != YFilter.not_set or
                self.current_p2mp_tunnel_count.yfilter != YFilter.not_set or
                self.current_tunnel_count.yfilter != YFilter.not_set or
                self.is_auto_mesh_range_configured.yfilter != YFilter.not_set or
                self.is_autobackup_range_configured.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "maximum-tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.absolute_maximum.is_set or self.absolute_maximum.yfilter != YFilter.not_set):
                leaf_name_data.append(self.absolute_maximum.get_name_leafdata())
            if (self.current_auto_mesh.is_set or self.current_auto_mesh.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_auto_mesh.get_name_leafdata())
            if (self.current_autobackups.is_set or self.current_autobackups.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_autobackups.get_name_leafdata())
            if (self.current_destination_count.is_set or self.current_destination_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_destination_count.get_name_leafdata())
            if (self.current_gmpls_uni.is_set or self.current_gmpls_uni.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_gmpls_uni.get_name_leafdata())
            if (self.current_maximum_auto_mesh.is_set or self.current_maximum_auto_mesh.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_auto_mesh.get_name_leafdata())
            if (self.current_maximum_autobackups.is_set or self.current_maximum_autobackups.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_autobackups.get_name_leafdata())
            if (self.current_maximum_destinations.is_set or self.current_maximum_destinations.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_destinations.get_name_leafdata())
            if (self.current_maximum_gmpls_unitunnels.is_set or self.current_maximum_gmpls_unitunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_gmpls_unitunnels.get_name_leafdata())
            if (self.current_maximum_p2mp_destnation_per_tunnel.is_set or self.current_maximum_p2mp_destnation_per_tunnel.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_p2mp_destnation_per_tunnel.get_name_leafdata())
            if (self.current_maximum_p2mp_tunnels.is_set or self.current_maximum_p2mp_tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_p2mp_tunnels.get_name_leafdata())
            if (self.current_maximum_tunnels.is_set or self.current_maximum_tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_tunnels.get_name_leafdata())
            if (self.current_p2mp_destnation_per_tunnel_count.is_set or self.current_p2mp_destnation_per_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_p2mp_destnation_per_tunnel_count.get_name_leafdata())
            if (self.current_p2mp_tunnel_count.is_set or self.current_p2mp_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_p2mp_tunnel_count.get_name_leafdata())
            if (self.current_tunnel_count.is_set or self.current_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_tunnel_count.get_name_leafdata())
            if (self.is_auto_mesh_range_configured.is_set or self.is_auto_mesh_range_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_auto_mesh_range_configured.get_name_leafdata())
            if (self.is_autobackup_range_configured.is_set or self.is_autobackup_range_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_autobackup_range_configured.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "absolute-maximum" or name == "current-auto-mesh" or name == "current-autobackups" or name == "current-destination-count" or name == "current-gmpls-uni" or name == "current-maximum-auto-mesh" or name == "current-maximum-autobackups" or name == "current-maximum-destinations" or name == "current-maximum-gmpls-unitunnels" or name == "current-maximum-p2mp-destnation-per-tunnel" or name == "current-maximum-p2mp-tunnels" or name == "current-maximum-tunnels" or name == "current-p2mp-destnation-per-tunnel-count" or name == "current-p2mp-tunnel-count" or name == "current-tunnel-count" or name == "is-auto-mesh-range-configured" or name == "is-autobackup-range-configured"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "absolute-maximum"):
                self.absolute_maximum = value
                self.absolute_maximum.value_namespace = name_space
                self.absolute_maximum.value_namespace_prefix = name_space_prefix
            if(value_path == "current-auto-mesh"):
                self.current_auto_mesh = value
                self.current_auto_mesh.value_namespace = name_space
                self.current_auto_mesh.value_namespace_prefix = name_space_prefix
            if(value_path == "current-autobackups"):
                self.current_autobackups = value
                self.current_autobackups.value_namespace = name_space
                self.current_autobackups.value_namespace_prefix = name_space_prefix
            if(value_path == "current-destination-count"):
                self.current_destination_count = value
                self.current_destination_count.value_namespace = name_space
                self.current_destination_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-gmpls-uni"):
                self.current_gmpls_uni = value
                self.current_gmpls_uni.value_namespace = name_space
                self.current_gmpls_uni.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-auto-mesh"):
                self.current_maximum_auto_mesh = value
                self.current_maximum_auto_mesh.value_namespace = name_space
                self.current_maximum_auto_mesh.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-autobackups"):
                self.current_maximum_autobackups = value
                self.current_maximum_autobackups.value_namespace = name_space
                self.current_maximum_autobackups.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-destinations"):
                self.current_maximum_destinations = value
                self.current_maximum_destinations.value_namespace = name_space
                self.current_maximum_destinations.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-gmpls-unitunnels"):
                self.current_maximum_gmpls_unitunnels = value
                self.current_maximum_gmpls_unitunnels.value_namespace = name_space
                self.current_maximum_gmpls_unitunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-p2mp-destnation-per-tunnel"):
                self.current_maximum_p2mp_destnation_per_tunnel = value
                self.current_maximum_p2mp_destnation_per_tunnel.value_namespace = name_space
                self.current_maximum_p2mp_destnation_per_tunnel.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-p2mp-tunnels"):
                self.current_maximum_p2mp_tunnels = value
                self.current_maximum_p2mp_tunnels.value_namespace = name_space
                self.current_maximum_p2mp_tunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-tunnels"):
                self.current_maximum_tunnels = value
                self.current_maximum_tunnels.value_namespace = name_space
                self.current_maximum_tunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-p2mp-destnation-per-tunnel-count"):
                self.current_p2mp_destnation_per_tunnel_count = value
                self.current_p2mp_destnation_per_tunnel_count.value_namespace = name_space
                self.current_p2mp_destnation_per_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-p2mp-tunnel-count"):
                self.current_p2mp_tunnel_count = value
                self.current_p2mp_tunnel_count.value_namespace = name_space
                self.current_p2mp_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-tunnel-count"):
                self.current_tunnel_count = value
                self.current_tunnel_count.value_namespace = name_space
                self.current_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "is-auto-mesh-range-configured"):
                self.is_auto_mesh_range_configured = value
                self.is_auto_mesh_range_configured.value_namespace = name_space
                self.is_auto_mesh_range_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "is-autobackup-range-configured"):
                self.is_autobackup_range_configured = value
                self.is_autobackup_range_configured.value_namespace = name_space
                self.is_autobackup_range_configured.value_namespace_prefix = name_space_prefix


    class PathProtection(Entity):
        """
        MPLS TE path protection info
        
        .. attribute:: switchover_log
        
        	MPLS TE path protection info
        	**type**\:   :py:class:`SwitchoverLog <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection.SwitchoverLog>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.PathProtection, self).__init__()

            self.yang_name = "path-protection"
            self.yang_parent_name = "mpls-te"

            self.switchover_log = MplsTe.PathProtection.SwitchoverLog()
            self.switchover_log.parent = self
            self._children_name_map["switchover_log"] = "switchover-log"
            self._children_yang_names.add("switchover-log")


        class SwitchoverLog(Entity):
            """
            MPLS TE path protection info
            
            .. attribute:: average_switchover_millisec
            
            	The average delay for a switchover in milliseconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: millisecond
            
            .. attribute:: maximum_switchover_millisec
            
            	The maximum delay for a switchover in milliseconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: millisecond
            
            .. attribute:: path_protection_switchover_entry
            
            	The array of path protection switchover entries
            	**type**\: list of    :py:class:`PathProtectionSwitchoverEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry>`
            
            .. attribute:: path_protection_switchovers
            
            	Total number of path protection switchover events. This could be more than the entries in the array
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.PathProtection.SwitchoverLog, self).__init__()

                self.yang_name = "switchover-log"
                self.yang_parent_name = "path-protection"

                self.average_switchover_millisec = YLeaf(YType.uint32, "average-switchover-millisec")

                self.maximum_switchover_millisec = YLeaf(YType.uint32, "maximum-switchover-millisec")

                self.path_protection_switchovers = YLeaf(YType.uint32, "path-protection-switchovers")

                self.path_protection_switchover_entry = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("average_switchover_millisec",
                                "maximum_switchover_millisec",
                                "path_protection_switchovers") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.PathProtection.SwitchoverLog, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.PathProtection.SwitchoverLog, self).__setattr__(name, value)


            class PathProtectionSwitchoverEntry(Entity):
                """
                The array of path protection switchover entries
                
                .. attribute:: date_of_error_detection
                
                	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: date_of_error_detection_millisec
                
                	The milliseconds offset of the date when the error that caused  the switchover was detected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: millisecond
                
                .. attribute:: from_lsp_id
                
                	The LSP ID from which the traffic was switched over
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: path_protection_switchover_event_index
                
                	The index number of the path protection switch over event
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: path_protection_switchover_reason
                
                	The reason that caused the path protection switchover
                	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                
                .. attribute:: path_protection_tunnel_id
                
                	The ID of the tunnel that experienced switchover
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: switchover_duration_millisec
                
                	The time in milliseconds between the detection of the error and switching the traffic
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: millisecond
                
                .. attribute:: to_lsp_id
                
                	The LSP ID to which the traffic was switched over
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__init__()

                    self.yang_name = "path-protection-switchover-entry"
                    self.yang_parent_name = "switchover-log"

                    self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                    self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                    self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                    self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                    self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                    self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                    self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                    self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("date_of_error_detection",
                                    "date_of_error_detection_millisec",
                                    "from_lsp_id",
                                    "path_protection_switchover_event_index",
                                    "path_protection_switchover_reason",
                                    "path_protection_tunnel_id",
                                    "switchover_duration_millisec",
                                    "to_lsp_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.date_of_error_detection.is_set or
                        self.date_of_error_detection_millisec.is_set or
                        self.from_lsp_id.is_set or
                        self.path_protection_switchover_event_index.is_set or
                        self.path_protection_switchover_reason.is_set or
                        self.path_protection_tunnel_id.is_set or
                        self.switchover_duration_millisec.is_set or
                        self.to_lsp_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.date_of_error_detection.yfilter != YFilter.not_set or
                        self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                        self.from_lsp_id.yfilter != YFilter.not_set or
                        self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                        self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                        self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                        self.switchover_duration_millisec.yfilter != YFilter.not_set or
                        self.to_lsp_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-protection-switchover-entry" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/path-protection/switchover-log/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                    if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                    if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                    if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                    if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                    if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                    if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                    if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "date-of-error-detection"):
                        self.date_of_error_detection = value
                        self.date_of_error_detection.value_namespace = name_space
                        self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                    if(value_path == "date-of-error-detection-millisec"):
                        self.date_of_error_detection_millisec = value
                        self.date_of_error_detection_millisec.value_namespace = name_space
                        self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                    if(value_path == "from-lsp-id"):
                        self.from_lsp_id = value
                        self.from_lsp_id.value_namespace = name_space
                        self.from_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-switchover-event-index"):
                        self.path_protection_switchover_event_index = value
                        self.path_protection_switchover_event_index.value_namespace = name_space
                        self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-switchover-reason"):
                        self.path_protection_switchover_reason = value
                        self.path_protection_switchover_reason.value_namespace = name_space
                        self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-tunnel-id"):
                        self.path_protection_tunnel_id = value
                        self.path_protection_tunnel_id.value_namespace = name_space
                        self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "switchover-duration-millisec"):
                        self.switchover_duration_millisec = value
                        self.switchover_duration_millisec.value_namespace = name_space
                        self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                    if(value_path == "to-lsp-id"):
                        self.to_lsp_id = value
                        self.to_lsp_id.value_namespace = name_space
                        self.to_lsp_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.path_protection_switchover_entry:
                    if (c.has_data()):
                        return True
                return (
                    self.average_switchover_millisec.is_set or
                    self.maximum_switchover_millisec.is_set or
                    self.path_protection_switchovers.is_set)

            def has_operation(self):
                for c in self.path_protection_switchover_entry:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.average_switchover_millisec.yfilter != YFilter.not_set or
                    self.maximum_switchover_millisec.yfilter != YFilter.not_set or
                    self.path_protection_switchovers.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "switchover-log" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/path-protection/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.average_switchover_millisec.is_set or self.average_switchover_millisec.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.average_switchover_millisec.get_name_leafdata())
                if (self.maximum_switchover_millisec.is_set or self.maximum_switchover_millisec.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.maximum_switchover_millisec.get_name_leafdata())
                if (self.path_protection_switchovers.is_set or self.path_protection_switchovers.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protection_switchovers.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-protection-switchover-entry"):
                    for c in self.path_protection_switchover_entry:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.path_protection_switchover_entry.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-protection-switchover-entry" or name == "average-switchover-millisec" or name == "maximum-switchover-millisec" or name == "path-protection-switchovers"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "average-switchover-millisec"):
                    self.average_switchover_millisec = value
                    self.average_switchover_millisec.value_namespace = name_space
                    self.average_switchover_millisec.value_namespace_prefix = name_space_prefix
                if(value_path == "maximum-switchover-millisec"):
                    self.maximum_switchover_millisec = value
                    self.maximum_switchover_millisec.value_namespace = name_space
                    self.maximum_switchover_millisec.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protection-switchovers"):
                    self.path_protection_switchovers = value
                    self.path_protection_switchovers.value_namespace = name_space
                    self.path_protection_switchovers.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.switchover_log is not None and self.switchover_log.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.switchover_log is not None and self.switchover_log.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "path-protection" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "switchover-log"):
                if (self.switchover_log is None):
                    self.switchover_log = MplsTe.PathProtection.SwitchoverLog()
                    self.switchover_log.parent = self
                    self._children_name_map["switchover_log"] = "switchover-log"
                return self.switchover_log

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "switchover-log"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FibNextHopLabelRoutes(Entity):
        """
        MPLS TE FIB nexthop label route database
        
        .. attribute:: fib_next_hop_label_route
        
        	MPLS TE FIB nexthop label route
        	**type**\: list of    :py:class:`FibNextHopLabelRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.FibNextHopLabelRoutes, self).__init__()

            self.yang_name = "fib-next-hop-label-routes"
            self.yang_parent_name = "mpls-te"

            self.fib_next_hop_label_route = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.FibNextHopLabelRoutes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.FibNextHopLabelRoutes, self).__setattr__(name, value)


        class FibNextHopLabelRoute(Entity):
            """
            MPLS TE FIB nexthop label route
            
            .. attribute:: label  <key>
            
            	MPLS Label
            	**type**\:  int
            
            	**range:** 0..1048575
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\:  bool
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\:  bool
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\:  bool
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of    :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath>`
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: route_version
            
            	Route version
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__init__()

                self.yang_name = "fib-next-hop-label-route"
                self.yang_parent_name = "fib-next-hop-label-routes"

                self.label = YLeaf(YType.uint32, "label")

                self.create_time = YLeaf(YType.uint32, "create-time")

                self.expire_time = YLeaf(YType.uint32, "expire-time")

                self.is_notified = YLeaf(YType.boolean, "is-notified")

                self.is_registered = YLeaf(YType.boolean, "is-registered")

                self.is_stale = YLeaf(YType.boolean, "is-stale")

                self.last_update_time = YLeaf(YType.uint32, "last-update-time")

                self.last_used_time = YLeaf(YType.uint32, "last-used-time")

                self.prefix_addr = YLeaf(YType.str, "prefix-addr")

                self.route_version = YLeaf(YType.uint64, "route-version")

                self.target_address = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"
                self._children_yang_names.add("target-address")

                self.next_hop_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("label",
                                "create_time",
                                "expire_time",
                                "is_notified",
                                "is_registered",
                                "is_stale",
                                "last_update_time",
                                "last_used_time",
                                "prefix_addr",
                                "route_version") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__setattr__(name, value)


            class TargetAddress(Entity):
                """
                Next Hop Target Address
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: type
                
                	type
                	**type**\:   :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-label-route"

                    self.ip_address = YLeaf(YType.str, "ip-address")

                    self.label = YLeaf(YType.uint32, "label")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ip_address",
                                    "label",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.ip_address.is_set or
                        self.label.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ip_address.yfilter != YFilter.not_set or
                        self.label.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "target-address" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ip_address.is_set or self.ip_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ip_address.get_name_leafdata())
                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ip-address" or name == "label" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ip-address"):
                        self.ip_address = value
                        self.ip_address.value_namespace = name_space
                        self.ip_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "label"):
                        self.label = value
                        self.label.value_namespace = name_space
                        self.label.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix


            class NextHopPath(Entity):
                """
                Next Hop Paths
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of    :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack>`
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-label-route"

                    self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                    self.interface = YLeaf(YType.str, "interface")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.path_id = YLeaf(YType.uint32, "path-id")

                    self.pure_backup = YLeaf(YType.boolean, "pure-backup")

                    self.label_stack = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("backup_path_id",
                                    "interface",
                                    "next_hop_address",
                                    "path_id",
                                    "pure_backup") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__setattr__(name, value)


                class LabelStack(Entity):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "label-stack" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.label_stack:
                        if (c.has_data()):
                            return True
                    return (
                        self.backup_path_id.is_set or
                        self.interface.is_set or
                        self.next_hop_address.is_set or
                        self.path_id.is_set or
                        self.pure_backup.is_set)

                def has_operation(self):
                    for c in self.label_stack:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.backup_path_id.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.path_id.yfilter != YFilter.not_set or
                        self.pure_backup.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "next-hop-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_id.get_name_leafdata())
                    if (self.pure_backup.is_set or self.pure_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pure_backup.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "label-stack"):
                        for c in self.label_stack:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.label_stack.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "label-stack" or name == "backup-path-id" or name == "interface" or name == "next-hop-address" or name == "path-id" or name == "pure-backup"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "backup-path-id"):
                        self.backup_path_id = value
                        self.backup_path_id.value_namespace = name_space
                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-id"):
                        self.path_id = value
                        self.path_id.value_namespace = name_space
                        self.path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "pure-backup"):
                        self.pure_backup = value
                        self.pure_backup.value_namespace = name_space
                        self.pure_backup.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.next_hop_path:
                    if (c.has_data()):
                        return True
                return (
                    self.label.is_set or
                    self.create_time.is_set or
                    self.expire_time.is_set or
                    self.is_notified.is_set or
                    self.is_registered.is_set or
                    self.is_stale.is_set or
                    self.last_update_time.is_set or
                    self.last_used_time.is_set or
                    self.prefix_addr.is_set or
                    self.route_version.is_set or
                    (self.target_address is not None and self.target_address.has_data()))

            def has_operation(self):
                for c in self.next_hop_path:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.label.yfilter != YFilter.not_set or
                    self.create_time.yfilter != YFilter.not_set or
                    self.expire_time.yfilter != YFilter.not_set or
                    self.is_notified.yfilter != YFilter.not_set or
                    self.is_registered.yfilter != YFilter.not_set or
                    self.is_stale.yfilter != YFilter.not_set or
                    self.last_update_time.yfilter != YFilter.not_set or
                    self.last_used_time.yfilter != YFilter.not_set or
                    self.prefix_addr.yfilter != YFilter.not_set or
                    self.route_version.yfilter != YFilter.not_set or
                    (self.target_address is not None and self.target_address.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "fib-next-hop-label-route" + "[label='" + self.label.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/fib-next-hop-label-routes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.label.get_name_leafdata())
                if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create_time.get_name_leafdata())
                if (self.expire_time.is_set or self.expire_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expire_time.get_name_leafdata())
                if (self.is_notified.is_set or self.is_notified.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_notified.get_name_leafdata())
                if (self.is_registered.is_set or self.is_registered.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_registered.get_name_leafdata())
                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                if (self.last_update_time.is_set or self.last_update_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_update_time.get_name_leafdata())
                if (self.last_used_time.is_set or self.last_used_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_used_time.get_name_leafdata())
                if (self.prefix_addr.is_set or self.prefix_addr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_addr.get_name_leafdata())
                if (self.route_version.is_set or self.route_version.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.route_version.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "next-hop-path"):
                    for c in self.next_hop_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.next_hop_path.append(c)
                    return c

                if (child_yang_name == "target-address"):
                    if (self.target_address is None):
                        self.target_address = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                        self.target_address.parent = self
                        self._children_name_map["target_address"] = "target-address"
                    return self.target_address

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "next-hop-path" or name == "target-address" or name == "label" or name == "create-time" or name == "expire-time" or name == "is-notified" or name == "is-registered" or name == "is-stale" or name == "last-update-time" or name == "last-used-time" or name == "prefix-addr" or name == "route-version"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "label"):
                    self.label = value
                    self.label.value_namespace = name_space
                    self.label.value_namespace_prefix = name_space_prefix
                if(value_path == "create-time"):
                    self.create_time = value
                    self.create_time.value_namespace = name_space
                    self.create_time.value_namespace_prefix = name_space_prefix
                if(value_path == "expire-time"):
                    self.expire_time = value
                    self.expire_time.value_namespace = name_space
                    self.expire_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-notified"):
                    self.is_notified = value
                    self.is_notified.value_namespace = name_space
                    self.is_notified.value_namespace_prefix = name_space_prefix
                if(value_path == "is-registered"):
                    self.is_registered = value
                    self.is_registered.value_namespace = name_space
                    self.is_registered.value_namespace_prefix = name_space_prefix
                if(value_path == "is-stale"):
                    self.is_stale = value
                    self.is_stale.value_namespace = name_space
                    self.is_stale.value_namespace_prefix = name_space_prefix
                if(value_path == "last-update-time"):
                    self.last_update_time = value
                    self.last_update_time.value_namespace = name_space
                    self.last_update_time.value_namespace_prefix = name_space_prefix
                if(value_path == "last-used-time"):
                    self.last_used_time = value
                    self.last_used_time.value_namespace = name_space
                    self.last_used_time.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-addr"):
                    self.prefix_addr = value
                    self.prefix_addr.value_namespace = name_space
                    self.prefix_addr.value_namespace_prefix = name_space_prefix
                if(value_path == "route-version"):
                    self.route_version = value
                    self.route_version.value_namespace = name_space
                    self.route_version.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.fib_next_hop_label_route:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.fib_next_hop_label_route:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "fib-next-hop-label-routes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "fib-next-hop-label-route"):
                for c in self.fib_next_hop_label_route:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.fib_next_hop_label_route.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "fib-next-hop-label-route"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class P2Mp(Entity):
        """
        P2MP Information
        
        .. attribute:: collaborator_timers
        
        	TE Collaborator timer status
        	**type**\:   :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.CollaboratorTimers>`
        
        .. attribute:: forwarding_output_label_rewrites
        
        	forwarding\-adjacency P2MP Information
        	**type**\:   :py:class:`ForwardingOutputLabelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites>`
        
        .. attribute:: tunnel_rewrites
        
        	forwarding\-adjacency P2MP Tunnel RW
        	**type**\:   :py:class:`TunnelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.P2Mp, self).__init__()

            self.yang_name = "p2mp"
            self.yang_parent_name = "mpls-te"

            self.collaborator_timers = MplsTe.P2Mp.CollaboratorTimers()
            self.collaborator_timers.parent = self
            self._children_name_map["collaborator_timers"] = "collaborator-timers"
            self._children_yang_names.add("collaborator-timers")

            self.forwarding_output_label_rewrites = MplsTe.P2Mp.ForwardingOutputLabelRewrites()
            self.forwarding_output_label_rewrites.parent = self
            self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
            self._children_yang_names.add("forwarding-output-label-rewrites")

            self.tunnel_rewrites = MplsTe.P2Mp.TunnelRewrites()
            self.tunnel_rewrites.parent = self
            self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"
            self._children_yang_names.add("tunnel-rewrites")


        class TunnelRewrites(Entity):
            """
            forwarding\-adjacency P2MP Tunnel RW
            
            .. attribute:: tunnel_rewrite
            
            	Display only P2MP Information
            	**type**\: list of    :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2Mp.TunnelRewrites, self).__init__()

                self.yang_name = "tunnel-rewrites"
                self.yang_parent_name = "p2mp"

                self.tunnel_rewrite = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2Mp.TunnelRewrites, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2Mp.TunnelRewrites, self).__setattr__(name, value)


            class TunnelRewrite(Entity):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: failed_rewrite
                
                	Failed rewrite details
                	**type**\:   :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite>`
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\:  bool
                
                .. attribute:: pending_rewrite
                
                	Pending rewrite details
                	**type**\:   :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite>`
                
                .. attribute:: successful_rewrite
                
                	Successful rewrite details
                	**type**\:   :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite>`
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface name
                	**type**\:  str
                
                .. attribute:: tunnel_signal_name
                
                	Tunnel signaled\-name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite, self).__init__()

                    self.yang_name = "tunnel-rewrite"
                    self.yang_parent_name = "tunnel-rewrites"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                    self.tunnel_signal_name = YLeaf(YType.str, "tunnel-signal-name")

                    self.failed_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                    self.failed_rewrite.parent = self
                    self._children_name_map["failed_rewrite"] = "failed-rewrite"
                    self._children_yang_names.add("failed-rewrite")

                    self.pending_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                    self.pending_rewrite.parent = self
                    self._children_name_map["pending_rewrite"] = "pending-rewrite"
                    self._children_yang_names.add("pending-rewrite")

                    self.successful_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                    self.successful_rewrite.parent = self
                    self._children_name_map["successful_rewrite"] = "successful-rewrite"
                    self._children_yang_names.add("successful-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "ctype",
                                    "is_segment_routing",
                                    "tunnel_interface",
                                    "tunnel_signal_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite, self).__setattr__(name, value)


                class SuccessfulRewrite(Entity):
                    """
                    Successful rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__init__()

                        self.yang_name = "successful-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "successful-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "successful-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix


                class FailedRewrite(Entity):
                    """
                    Failed rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__init__()

                        self.yang_name = "failed-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "failed-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "failed-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix


                class PendingRewrite(Entity):
                    """
                    Pending rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__init__()

                        self.yang_name = "pending-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "pending-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pending-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.ctype.is_set or
                        self.is_segment_routing.is_set or
                        self.tunnel_interface.is_set or
                        self.tunnel_signal_name.is_set or
                        (self.failed_rewrite is not None and self.failed_rewrite.has_data()) or
                        (self.pending_rewrite is not None and self.pending_rewrite.has_data()) or
                        (self.successful_rewrite is not None and self.successful_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.is_segment_routing.yfilter != YFilter.not_set or
                        self.tunnel_interface.yfilter != YFilter.not_set or
                        self.tunnel_signal_name.yfilter != YFilter.not_set or
                        (self.failed_rewrite is not None and self.failed_rewrite.has_operation()) or
                        (self.pending_rewrite is not None and self.pending_rewrite.has_operation()) or
                        (self.successful_rewrite is not None and self.successful_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-rewrite" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[ctype='" + self.ctype.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/tunnel-rewrites/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                    if (self.tunnel_signal_name.is_set or self.tunnel_signal_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_signal_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "failed-rewrite"):
                        if (self.failed_rewrite is None):
                            self.failed_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                            self.failed_rewrite.parent = self
                            self._children_name_map["failed_rewrite"] = "failed-rewrite"
                        return self.failed_rewrite

                    if (child_yang_name == "pending-rewrite"):
                        if (self.pending_rewrite is None):
                            self.pending_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                            self.pending_rewrite.parent = self
                            self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        return self.pending_rewrite

                    if (child_yang_name == "successful-rewrite"):
                        if (self.successful_rewrite is None):
                            self.successful_rewrite = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                            self.successful_rewrite.parent = self
                            self._children_name_map["successful_rewrite"] = "successful-rewrite"
                        return self.successful_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "failed-rewrite" or name == "pending-rewrite" or name == "successful-rewrite" or name == "tunnel-id" or name == "lsp-id" or name == "ctype" or name == "is-segment-routing" or name == "tunnel-interface" or name == "tunnel-signal-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing"):
                        self.is_segment_routing = value
                        self.is_segment_routing.value_namespace = name_space
                        self.is_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface"):
                        self.tunnel_interface = value
                        self.tunnel_interface.value_namespace = name_space
                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-signal-name"):
                        self.tunnel_signal_name = value
                        self.tunnel_signal_name.value_namespace = name_space
                        self.tunnel_signal_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_rewrite:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_rewrite:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-rewrites" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-rewrite"):
                    for c in self.tunnel_rewrite:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2Mp.TunnelRewrites.TunnelRewrite()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_rewrite.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-rewrite"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class CollaboratorTimers(Entity):
            """
            TE Collaborator timer status
            
            .. attribute:: p2mp_timer
            
            	Description of all P2MP timers
            	**type**\: list of    :py:class:`P2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.CollaboratorTimers.P2MpTimer>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2Mp.CollaboratorTimers, self).__init__()

                self.yang_name = "collaborator-timers"
                self.yang_parent_name = "p2mp"

                self.p2mp_timer = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2Mp.CollaboratorTimers, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2Mp.CollaboratorTimers, self).__setattr__(name, value)


            class P2MpTimer(Entity):
                """
                Description of all P2MP timers
                
                .. attribute:: duration
                
                	The expiry delay in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: expiry_time
                
                	Date when the timer last expired in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: is_running
                
                	True if the timer is running
                	**type**\:  bool
                
                .. attribute:: start_time
                
                	Date when timer was last started in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: stop_time
                
                	Date when the timer was last stopped in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: timer_name
                
                	Timer Name
                	**type**\:  str
                
                .. attribute:: timer_type
                
                	Timer Type
                	**type**\:   :py:class:`MplsTeP2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2MpTimer>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2Mp.CollaboratorTimers.P2MpTimer, self).__init__()

                    self.yang_name = "p2mp-timer"
                    self.yang_parent_name = "collaborator-timers"

                    self.duration = YLeaf(YType.uint32, "duration")

                    self.expiry_time = YLeaf(YType.uint32, "expiry-time")

                    self.is_running = YLeaf(YType.boolean, "is-running")

                    self.start_time = YLeaf(YType.uint32, "start-time")

                    self.stop_time = YLeaf(YType.uint32, "stop-time")

                    self.timer_name = YLeaf(YType.str, "timer-name")

                    self.timer_type = YLeaf(YType.enumeration, "timer-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("duration",
                                    "expiry_time",
                                    "is_running",
                                    "start_time",
                                    "stop_time",
                                    "timer_name",
                                    "timer_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2Mp.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2Mp.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.duration.is_set or
                        self.expiry_time.is_set or
                        self.is_running.is_set or
                        self.start_time.is_set or
                        self.stop_time.is_set or
                        self.timer_name.is_set or
                        self.timer_type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.duration.yfilter != YFilter.not_set or
                        self.expiry_time.yfilter != YFilter.not_set or
                        self.is_running.yfilter != YFilter.not_set or
                        self.start_time.yfilter != YFilter.not_set or
                        self.stop_time.yfilter != YFilter.not_set or
                        self.timer_name.yfilter != YFilter.not_set or
                        self.timer_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "p2mp-timer" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/collaborator-timers/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.duration.get_name_leafdata())
                    if (self.expiry_time.is_set or self.expiry_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.expiry_time.get_name_leafdata())
                    if (self.is_running.is_set or self.is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_running.get_name_leafdata())
                    if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.start_time.get_name_leafdata())
                    if (self.stop_time.is_set or self.stop_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.stop_time.get_name_leafdata())
                    if (self.timer_name.is_set or self.timer_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_name.get_name_leafdata())
                    if (self.timer_type.is_set or self.timer_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "duration" or name == "expiry-time" or name == "is-running" or name == "start-time" or name == "stop-time" or name == "timer-name" or name == "timer-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "duration"):
                        self.duration = value
                        self.duration.value_namespace = name_space
                        self.duration.value_namespace_prefix = name_space_prefix
                    if(value_path == "expiry-time"):
                        self.expiry_time = value
                        self.expiry_time.value_namespace = name_space
                        self.expiry_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-running"):
                        self.is_running = value
                        self.is_running.value_namespace = name_space
                        self.is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "start-time"):
                        self.start_time = value
                        self.start_time.value_namespace = name_space
                        self.start_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "stop-time"):
                        self.stop_time = value
                        self.stop_time.value_namespace = name_space
                        self.stop_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-name"):
                        self.timer_name = value
                        self.timer_name.value_namespace = name_space
                        self.timer_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-type"):
                        self.timer_type = value
                        self.timer_type.value_namespace = name_space
                        self.timer_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.p2mp_timer:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.p2mp_timer:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "collaborator-timers" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "p2mp-timer"):
                    for c in self.p2mp_timer:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2Mp.CollaboratorTimers.P2MpTimer()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.p2mp_timer.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "p2mp-timer"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ForwardingOutputLabelRewrites(Entity):
            """
            forwarding\-adjacency P2MP Information
            
            .. attribute:: forwarding_output_label_rewrite
            
            	Display only P2MP Information
            	**type**\: list of    :py:class:`ForwardingOutputLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites, self).__init__()

                self.yang_name = "forwarding-output-label-rewrites"
                self.yang_parent_name = "p2mp"

                self.forwarding_output_label_rewrite = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites, self).__setattr__(name, value)


            class ForwardingOutputLabelRewrite(Entity):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	extended tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: next_hop_address  <key>
                
                	Next Hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: previous_hop_address  <key>
                
                	Prev Hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: backup_tunnel_name
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\:  bool
                
                .. attribute:: original_input_interface
                
                	Input interface of the S2Ls
                	**type**\:  str
                
                .. attribute:: output_interface_name
                
                	The output interface of the S2Ls
                	**type**\:  str
                
                .. attribute:: s2l
                
                	Unique identifiers for the S2L sharing the rewrite
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L>`
                
                .. attribute:: s2l_output_rewrite
                
                	Output rewrite shared between S2Ls
                	**type**\:   :py:class:`S2LOutputRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite>`
                
                .. attribute:: s2lsr_path
                
                	Segment\-Routing Paths
                	**type**\: list of    :py:class:`S2LsrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__init__()

                    self.yang_name = "forwarding-output-label-rewrite"
                    self.yang_parent_name = "forwarding-output-label-rewrites"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                    self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                    self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.s2l_output_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite()
                    self.s2l_output_rewrite.parent = self
                    self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"
                    self._children_yang_names.add("s2l-output-rewrite")

                    self.s2l = YList(self)
                    self.s2lsr_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "p2mp_id",
                                    "destination_address",
                                    "next_hop_address",
                                    "previous_hop_address",
                                    "ctype",
                                    "backup_tunnel_name",
                                    "is_segment_routing",
                                    "original_input_interface",
                                    "output_interface_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__setattr__(name, value)


                class S2LOutputRewrite(Entity):
                    """
                    Output rewrite shared between S2Ls
                    
                    .. attribute:: failed_rewrite
                    
                    	Failed rewrite details
                    	**type**\:   :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite>`
                    
                    .. attribute:: pending_rewrite
                    
                    	Pending rewrite details
                    	**type**\:   :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite>`
                    
                    .. attribute:: subfamily
                    
                    	Subfamily identifiers
                    	**type**\:   :py:class:`Subfamily <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily>`
                    
                    .. attribute:: successful_rewrite
                    
                    	Successful rewrite details
                    	**type**\:   :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite, self).__init__()

                        self.yang_name = "s2l-output-rewrite"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.failed_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite()
                        self.failed_rewrite.parent = self
                        self._children_name_map["failed_rewrite"] = "failed-rewrite"
                        self._children_yang_names.add("failed-rewrite")

                        self.pending_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite()
                        self.pending_rewrite.parent = self
                        self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        self._children_yang_names.add("pending-rewrite")

                        self.subfamily = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily()
                        self.subfamily.parent = self
                        self._children_name_map["subfamily"] = "subfamily"
                        self._children_yang_names.add("subfamily")

                        self.successful_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite()
                        self.successful_rewrite.parent = self
                        self._children_name_map["successful_rewrite"] = "successful-rewrite"
                        self._children_yang_names.add("successful-rewrite")


                    class Subfamily(Entity):
                        """
                        Subfamily identifiers
                        
                        .. attribute:: lsp_fec
                        
                        	LSP FEC
                        	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__init__()

                            self.yang_name = "subfamily"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.lsp_fec = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                            self._children_yang_names.add("lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("next_hop_address",
                                            "previous_hop_address") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__setattr__(name, value)


                        class LspFec(Entity):
                            """
                            LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__init__()

                                self.yang_name = "lsp-fec"
                                self.yang_parent_name = "subfamily"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.next_hop_address.is_set or
                                self.previous_hop_address.is_set or
                                (self.lsp_fec is not None and self.lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subfamily" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "lsp-fec"):
                                if (self.lsp_fec is None):
                                    self.lsp_fec = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec()
                                    self.lsp_fec.parent = self
                                    self._children_name_map["lsp_fec"] = "lsp-fec"
                                return self.lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-fec" or name == "next-hop-address" or name == "previous-hop-address"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix


                    class SuccessfulRewrite(Entity):
                        """
                        Successful rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__init__()

                            self.yang_name = "successful-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "successful-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "successful-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "successful-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix


                    class FailedRewrite(Entity):
                        """
                        Failed rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__init__()

                            self.yang_name = "failed-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "failed-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "failed-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "failed-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix


                    class PendingRewrite(Entity):
                        """
                        Pending rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__init__()

                            self.yang_name = "pending-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "pending-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "pending-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pending-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.failed_rewrite is not None and self.failed_rewrite.has_data()) or
                            (self.pending_rewrite is not None and self.pending_rewrite.has_data()) or
                            (self.subfamily is not None and self.subfamily.has_data()) or
                            (self.successful_rewrite is not None and self.successful_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.failed_rewrite is not None and self.failed_rewrite.has_operation()) or
                            (self.pending_rewrite is not None and self.pending_rewrite.has_operation()) or
                            (self.subfamily is not None and self.subfamily.has_operation()) or
                            (self.successful_rewrite is not None and self.successful_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-output-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "failed-rewrite"):
                            if (self.failed_rewrite is None):
                                self.failed_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite()
                                self.failed_rewrite.parent = self
                                self._children_name_map["failed_rewrite"] = "failed-rewrite"
                            return self.failed_rewrite

                        if (child_yang_name == "pending-rewrite"):
                            if (self.pending_rewrite is None):
                                self.pending_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite()
                                self.pending_rewrite.parent = self
                                self._children_name_map["pending_rewrite"] = "pending-rewrite"
                            return self.pending_rewrite

                        if (child_yang_name == "subfamily"):
                            if (self.subfamily is None):
                                self.subfamily = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily()
                                self.subfamily.parent = self
                                self._children_name_map["subfamily"] = "subfamily"
                            return self.subfamily

                        if (child_yang_name == "successful-rewrite"):
                            if (self.successful_rewrite is None):
                                self.successful_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite()
                                self.successful_rewrite.parent = self
                                self._children_name_map["successful_rewrite"] = "successful-rewrite"
                            return self.successful_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "failed-rewrite" or name == "pending-rewrite" or name == "subfamily" or name == "successful-rewrite"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class S2L(Entity):
                    """
                    Unique identifiers for the S2L sharing the
                    rewrite
                    
                    .. attribute:: destination_address
                    
                    	Destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sub_group_id
                    
                    	S2L Sub\-Group ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_original_id
                    
                    	S2L Sub\-Group Originator ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_original_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_original_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_original_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "destination-address" or name == "sub-group-id" or name == "sub-group-original-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-original-id"):
                            self.sub_group_original_id = value
                            self.sub_group_original_id.value_namespace = name_space
                            self.sub_group_original_id.value_namespace_prefix = name_space_prefix


                class S2LsrPath(Entity):
                    """
                    Segment\-Routing Paths
                    
                    .. attribute:: backup_path_id
                    
                    	Backup Path Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup
                    
                    	True if path is backup
                    	**type**\:  bool
                    
                    .. attribute:: is_primary
                    
                    	True if path is primary
                    	**type**\:  bool
                    
                    .. attribute:: next_hop
                    
                    	Next hop
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing Interface Name
                    	**type**\:  str
                    
                    .. attribute:: outgoing_labels_stack
                    
                    	Outgoing Labels Stack
                    	**type**\: list of    :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack>`
                    
                    .. attribute:: path_id
                    
                    	Path Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__init__()

                        self.yang_name = "s2lsr-path"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                        self.is_backup = YLeaf(YType.boolean, "is-backup")

                        self.is_primary = YLeaf(YType.boolean, "is-primary")

                        self.next_hop = YLeaf(YType.str, "next-hop")

                        self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                        self.path_id = YLeaf(YType.uint32, "path-id")

                        self.outgoing_labels_stack = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("backup_path_id",
                                        "is_backup",
                                        "is_primary",
                                        "next_hop",
                                        "outgoing_interface",
                                        "path_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__setattr__(name, value)


                    class OutgoingLabelsStack(Entity):
                        """
                        Outgoing Labels Stack
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__init__()

                            self.yang_name = "outgoing-labels-stack"
                            self.yang_parent_name = "s2lsr-path"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "outgoing-labels-stack" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.outgoing_labels_stack:
                            if (c.has_data()):
                                return True
                        return (
                            self.backup_path_id.is_set or
                            self.is_backup.is_set or
                            self.is_primary.is_set or
                            self.next_hop.is_set or
                            self.outgoing_interface.is_set or
                            self.path_id.is_set)

                    def has_operation(self):
                        for c in self.outgoing_labels_stack:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.backup_path_id.yfilter != YFilter.not_set or
                            self.is_backup.yfilter != YFilter.not_set or
                            self.is_primary.yfilter != YFilter.not_set or
                            self.next_hop.yfilter != YFilter.not_set or
                            self.outgoing_interface.yfilter != YFilter.not_set or
                            self.path_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2lsr-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                        if (self.is_backup.is_set or self.is_backup.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup.get_name_leafdata())
                        if (self.is_primary.is_set or self.is_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_primary.get_name_leafdata())
                        if (self.next_hop.is_set or self.next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop.get_name_leafdata())
                        if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_interface.get_name_leafdata())
                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "outgoing-labels-stack"):
                            for c in self.outgoing_labels_stack:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.outgoing_labels_stack.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "outgoing-labels-stack" or name == "backup-path-id" or name == "is-backup" or name == "is-primary" or name == "next-hop" or name == "outgoing-interface" or name == "path-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "backup-path-id"):
                            self.backup_path_id = value
                            self.backup_path_id.value_namespace = name_space
                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup"):
                            self.is_backup = value
                            self.is_backup.value_namespace = name_space
                            self.is_backup.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-primary"):
                            self.is_primary = value
                            self.is_primary.value_namespace = name_space
                            self.is_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop"):
                            self.next_hop = value
                            self.next_hop.value_namespace = name_space
                            self.next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-interface"):
                            self.outgoing_interface = value
                            self.outgoing_interface.value_namespace = name_space
                            self.outgoing_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-id"):
                            self.path_id = value
                            self.path_id.value_namespace = name_space
                            self.path_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    for c in self.s2lsr_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.p2mp_id.is_set or
                        self.destination_address.is_set or
                        self.next_hop_address.is_set or
                        self.previous_hop_address.is_set or
                        self.ctype.is_set or
                        self.backup_tunnel_name.is_set or
                        self.is_segment_routing.is_set or
                        self.original_input_interface.is_set or
                        self.output_interface_name.is_set or
                        (self.s2l_output_rewrite is not None and self.s2l_output_rewrite.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    for c in self.s2lsr_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.previous_hop_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.backup_tunnel_name.yfilter != YFilter.not_set or
                        self.is_segment_routing.yfilter != YFilter.not_set or
                        self.original_input_interface.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        (self.s2l_output_rewrite is not None and self.s2l_output_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forwarding-output-label-rewrite" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[next-hop-address='" + self.next_hop_address.get() + "']" + "[previous-hop-address='" + self.previous_hop_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/forwarding-output-label-rewrites/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                    if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                    if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    if (child_yang_name == "s2l-output-rewrite"):
                        if (self.s2l_output_rewrite is None):
                            self.s2l_output_rewrite = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite()
                            self.s2l_output_rewrite.parent = self
                            self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"
                        return self.s2l_output_rewrite

                    if (child_yang_name == "s2lsr-path"):
                        for c in self.s2lsr_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2lsr_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l" or name == "s2l-output-rewrite" or name == "s2lsr-path" or name == "tunnel-id" or name == "lsp-id" or name == "extended-tunnel-id" or name == "source-address" or name == "p2mp-id" or name == "destination-address" or name == "next-hop-address" or name == "previous-hop-address" or name == "ctype" or name == "backup-tunnel-name" or name == "is-segment-routing" or name == "original-input-interface" or name == "output-interface-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "previous-hop-address"):
                        self.previous_hop_address = value
                        self.previous_hop_address.value_namespace = name_space
                        self.previous_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name"):
                        self.backup_tunnel_name = value
                        self.backup_tunnel_name.value_namespace = name_space
                        self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing"):
                        self.is_segment_routing = value
                        self.is_segment_routing.value_namespace = name_space
                        self.is_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "original-input-interface"):
                        self.original_input_interface = value
                        self.original_input_interface.value_namespace = name_space
                        self.original_input_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.forwarding_output_label_rewrite:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.forwarding_output_label_rewrite:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "forwarding-output-label-rewrites" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "forwarding-output-label-rewrite"):
                    for c in self.forwarding_output_label_rewrite:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.forwarding_output_label_rewrite.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "forwarding-output-label-rewrite"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.collaborator_timers is not None and self.collaborator_timers.has_data()) or
                (self.forwarding_output_label_rewrites is not None and self.forwarding_output_label_rewrites.has_data()) or
                (self.tunnel_rewrites is not None and self.tunnel_rewrites.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.collaborator_timers is not None and self.collaborator_timers.has_operation()) or
                (self.forwarding_output_label_rewrites is not None and self.forwarding_output_label_rewrites.has_operation()) or
                (self.tunnel_rewrites is not None and self.tunnel_rewrites.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "p2mp" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "collaborator-timers"):
                if (self.collaborator_timers is None):
                    self.collaborator_timers = MplsTe.P2Mp.CollaboratorTimers()
                    self.collaborator_timers.parent = self
                    self._children_name_map["collaborator_timers"] = "collaborator-timers"
                return self.collaborator_timers

            if (child_yang_name == "forwarding-output-label-rewrites"):
                if (self.forwarding_output_label_rewrites is None):
                    self.forwarding_output_label_rewrites = MplsTe.P2Mp.ForwardingOutputLabelRewrites()
                    self.forwarding_output_label_rewrites.parent = self
                    self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
                return self.forwarding_output_label_rewrites

            if (child_yang_name == "tunnel-rewrites"):
                if (self.tunnel_rewrites is None):
                    self.tunnel_rewrites = MplsTe.P2Mp.TunnelRewrites()
                    self.tunnel_rewrites.parent = self
                    self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"
                return self.tunnel_rewrites

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "collaborator-timers" or name == "forwarding-output-label-rewrites" or name == "tunnel-rewrites"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class OpenConfig(Entity):
        """
        OpenConfig MPLS TE operational data
        
        .. attribute:: lsp_counters
        
        	Table of LSP Counters
        	**type**\:   :py:class:`LspCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.OpenConfig.LspCounters>`
        
        .. attribute:: lsp_states
        
        	Table of LSP State Info
        	**type**\:   :py:class:`LspStates <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.OpenConfig.LspStates>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.OpenConfig, self).__init__()

            self.yang_name = "open-config"
            self.yang_parent_name = "mpls-te"

            self.lsp_counters = MplsTe.OpenConfig.LspCounters()
            self.lsp_counters.parent = self
            self._children_name_map["lsp_counters"] = "lsp-counters"
            self._children_yang_names.add("lsp-counters")

            self.lsp_states = MplsTe.OpenConfig.LspStates()
            self.lsp_states.parent = self
            self._children_name_map["lsp_states"] = "lsp-states"
            self._children_yang_names.add("lsp-states")


        class LspStates(Entity):
            """
            Table of LSP State Info
            
            .. attribute:: lsp_state
            
            	MPLS TE LSP State Info
            	**type**\: list of    :py:class:`LspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.OpenConfig.LspStates.LspState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.OpenConfig.LspStates, self).__init__()

                self.yang_name = "lsp-states"
                self.yang_parent_name = "open-config"

                self.lsp_state = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.OpenConfig.LspStates, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.OpenConfig.LspStates, self).__setattr__(name, value)


            class LspState(Entity):
                """
                MPLS TE LSP State Info
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: tunnel_type  <key>
                
                	Tunnel Type
                	**type**\:   :py:class:`OcMplsTeTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeTunnel>`
                
                .. attribute:: admin_status
                
                	Admin Status
                	**type**\:   :py:class:`LspAdminStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspAdminStatus>`
                
                .. attribute:: description
                
                	Description
                	**type**\:  str
                
                .. attribute:: hold_priority
                
                	Hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: local_id
                
                	Local ID \- TBD
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: metric
                
                	Metric type
                	**type**\:   :py:class:`OcMplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeMetric>`
                
                .. attribute:: name
                
                	LSP Name
                	**type**\:  str
                
                .. attribute:: oper_status
                
                	Operational Status
                	**type**\:   :py:class:`LspOperStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOperStatus>`
                
                .. attribute:: protection_style_requested
                
                	Protection Style Requested
                	**type**\:   :py:class:`MplsProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsProtection>`
                
                .. attribute:: reoptimize_timer
                
                	frequency of reoptimization
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: role
                
                	Role
                	**type**\:   :py:class:`MplsTeLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspRole>`
                
                .. attribute:: setup_priority
                
                	Setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: signaling_protocol
                
                	Signaling Protocol
                	**type**\:   :py:class:`MplsTeProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeProtocol>`
                
                .. attribute:: soft_preemption
                
                	Soft Preemption
                	**type**\:  bool
                
                .. attribute:: source
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: type
                
                	LSP Type
                	**type**\:   :py:class:`OcMplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.OpenConfig.LspStates.LspState, self).__init__()

                    self.yang_name = "lsp-state"
                    self.yang_parent_name = "lsp-states"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_type = YLeaf(YType.enumeration, "tunnel-type")

                    self.admin_status = YLeaf(YType.enumeration, "admin-status")

                    self.description = YLeaf(YType.str, "description")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.local_id = YLeaf(YType.uint32, "local-id")

                    self.metric = YLeaf(YType.enumeration, "metric")

                    self.name = YLeaf(YType.str, "name")

                    self.oper_status = YLeaf(YType.enumeration, "oper-status")

                    self.protection_style_requested = YLeaf(YType.enumeration, "protection-style-requested")

                    self.reoptimize_timer = YLeaf(YType.uint16, "reoptimize-timer")

                    self.role = YLeaf(YType.enumeration, "role")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.signaling_protocol = YLeaf(YType.enumeration, "signaling-protocol")

                    self.soft_preemption = YLeaf(YType.boolean, "soft-preemption")

                    self.source = YLeaf(YType.str, "source")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "tunnel_type",
                                    "admin_status",
                                    "description",
                                    "hold_priority",
                                    "local_id",
                                    "metric",
                                    "name",
                                    "oper_status",
                                    "protection_style_requested",
                                    "reoptimize_timer",
                                    "role",
                                    "setup_priority",
                                    "signaling_protocol",
                                    "soft_preemption",
                                    "source",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.OpenConfig.LspStates.LspState, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.OpenConfig.LspStates.LspState, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.tunnel_type.is_set or
                        self.admin_status.is_set or
                        self.description.is_set or
                        self.hold_priority.is_set or
                        self.local_id.is_set or
                        self.metric.is_set or
                        self.name.is_set or
                        self.oper_status.is_set or
                        self.protection_style_requested.is_set or
                        self.reoptimize_timer.is_set or
                        self.role.is_set or
                        self.setup_priority.is_set or
                        self.signaling_protocol.is_set or
                        self.soft_preemption.is_set or
                        self.source.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_type.yfilter != YFilter.not_set or
                        self.admin_status.yfilter != YFilter.not_set or
                        self.description.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.local_id.yfilter != YFilter.not_set or
                        self.metric.yfilter != YFilter.not_set or
                        self.name.yfilter != YFilter.not_set or
                        self.oper_status.yfilter != YFilter.not_set or
                        self.protection_style_requested.yfilter != YFilter.not_set or
                        self.reoptimize_timer.yfilter != YFilter.not_set or
                        self.role.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.signaling_protocol.yfilter != YFilter.not_set or
                        self.soft_preemption.yfilter != YFilter.not_set or
                        self.source.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-state" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[tunnel-type='" + self.tunnel_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/open-config/lsp-states/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_type.is_set or self.tunnel_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_type.get_name_leafdata())
                    if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_status.get_name_leafdata())
                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.description.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_id.get_name_leafdata())
                    if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric.get_name_leafdata())
                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.name.get_name_leafdata())
                    if (self.oper_status.is_set or self.oper_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.oper_status.get_name_leafdata())
                    if (self.protection_style_requested.is_set or self.protection_style_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protection_style_requested.get_name_leafdata())
                    if (self.reoptimize_timer.is_set or self.reoptimize_timer.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_timer.get_name_leafdata())
                    if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.signaling_protocol.is_set or self.signaling_protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaling_protocol.get_name_leafdata())
                    if (self.soft_preemption.is_set or self.soft_preemption.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption.get_name_leafdata())
                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "tunnel-type" or name == "admin-status" or name == "description" or name == "hold-priority" or name == "local-id" or name == "metric" or name == "name" or name == "oper-status" or name == "protection-style-requested" or name == "reoptimize-timer" or name == "role" or name == "setup-priority" or name == "signaling-protocol" or name == "soft-preemption" or name == "source" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-type"):
                        self.tunnel_type = value
                        self.tunnel_type.value_namespace = name_space
                        self.tunnel_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-status"):
                        self.admin_status = value
                        self.admin_status.value_namespace = name_space
                        self.admin_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "description"):
                        self.description = value
                        self.description.value_namespace = name_space
                        self.description.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-id"):
                        self.local_id = value
                        self.local_id.value_namespace = name_space
                        self.local_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric"):
                        self.metric = value
                        self.metric.value_namespace = name_space
                        self.metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "name"):
                        self.name = value
                        self.name.value_namespace = name_space
                        self.name.value_namespace_prefix = name_space_prefix
                    if(value_path == "oper-status"):
                        self.oper_status = value
                        self.oper_status.value_namespace = name_space
                        self.oper_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "protection-style-requested"):
                        self.protection_style_requested = value
                        self.protection_style_requested.value_namespace = name_space
                        self.protection_style_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-timer"):
                        self.reoptimize_timer = value
                        self.reoptimize_timer.value_namespace = name_space
                        self.reoptimize_timer.value_namespace_prefix = name_space_prefix
                    if(value_path == "role"):
                        self.role = value
                        self.role.value_namespace = name_space
                        self.role.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaling-protocol"):
                        self.signaling_protocol = value
                        self.signaling_protocol.value_namespace = name_space
                        self.signaling_protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption"):
                        self.soft_preemption = value
                        self.soft_preemption.value_namespace = name_space
                        self.soft_preemption.value_namespace_prefix = name_space_prefix
                    if(value_path == "source"):
                        self.source = value
                        self.source.value_namespace = name_space
                        self.source.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_state:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.lsp_state:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp-states" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/open-config/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-state"):
                    for c in self.lsp_state:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.OpenConfig.LspStates.LspState()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_state.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LspCounters(Entity):
            """
            Table of LSP Counters
            
            .. attribute:: lsp_counter
            
            	MPLS TE LSP Counters
            	**type**\: list of    :py:class:`LspCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.OpenConfig.LspCounters.LspCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.OpenConfig.LspCounters, self).__init__()

                self.yang_name = "lsp-counters"
                self.yang_parent_name = "open-config"

                self.lsp_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.OpenConfig.LspCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.OpenConfig.LspCounters, self).__setattr__(name, value)


            class LspCounter(Entity):
                """
                MPLS TE LSP Counters
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: tunnel_type  <key>
                
                	Tunnel Type
                	**type**\:   :py:class:`OcMplsTeTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeTunnel>`
                
                .. attribute:: bytes
                
                	Number of bytes forwarded over the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: current_path_time
                
                	Timestamp of LSP switched onto current path
                	**type**\:  str
                
                .. attribute:: name
                
                	LSP Name
                	**type**\:  str
                
                .. attribute:: next_reoptimization_time
                
                	Timestamp of next scheduled reoptmiziation
                	**type**\:  str
                
                .. attribute:: online_time
                
                	Timestamp of LSP oper state up
                	**type**\:  str
                
                .. attribute:: packets
                
                	Number of packets forwarded over the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: path_changes
                
                	Number of path changes for the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: state_changes
                
                	Number of state changes for the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: type
                
                	LSP Type
                	**type**\:   :py:class:`OcMplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.OpenConfig.LspCounters.LspCounter, self).__init__()

                    self.yang_name = "lsp-counter"
                    self.yang_parent_name = "lsp-counters"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_type = YLeaf(YType.enumeration, "tunnel-type")

                    self.bytes = YLeaf(YType.uint64, "bytes")

                    self.current_path_time = YLeaf(YType.str, "current-path-time")

                    self.name = YLeaf(YType.str, "name")

                    self.next_reoptimization_time = YLeaf(YType.str, "next-reoptimization-time")

                    self.online_time = YLeaf(YType.str, "online-time")

                    self.packets = YLeaf(YType.uint64, "packets")

                    self.path_changes = YLeaf(YType.uint64, "path-changes")

                    self.state_changes = YLeaf(YType.uint64, "state-changes")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "tunnel_type",
                                    "bytes",
                                    "current_path_time",
                                    "name",
                                    "next_reoptimization_time",
                                    "online_time",
                                    "packets",
                                    "path_changes",
                                    "state_changes",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.OpenConfig.LspCounters.LspCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.OpenConfig.LspCounters.LspCounter, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.tunnel_type.is_set or
                        self.bytes.is_set or
                        self.current_path_time.is_set or
                        self.name.is_set or
                        self.next_reoptimization_time.is_set or
                        self.online_time.is_set or
                        self.packets.is_set or
                        self.path_changes.is_set or
                        self.state_changes.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_type.yfilter != YFilter.not_set or
                        self.bytes.yfilter != YFilter.not_set or
                        self.current_path_time.yfilter != YFilter.not_set or
                        self.name.yfilter != YFilter.not_set or
                        self.next_reoptimization_time.yfilter != YFilter.not_set or
                        self.online_time.yfilter != YFilter.not_set or
                        self.packets.yfilter != YFilter.not_set or
                        self.path_changes.yfilter != YFilter.not_set or
                        self.state_changes.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-counter" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[tunnel-type='" + self.tunnel_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/open-config/lsp-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_type.is_set or self.tunnel_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_type.get_name_leafdata())
                    if (self.bytes.is_set or self.bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bytes.get_name_leafdata())
                    if (self.current_path_time.is_set or self.current_path_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.current_path_time.get_name_leafdata())
                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.name.get_name_leafdata())
                    if (self.next_reoptimization_time.is_set or self.next_reoptimization_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_reoptimization_time.get_name_leafdata())
                    if (self.online_time.is_set or self.online_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.online_time.get_name_leafdata())
                    if (self.packets.is_set or self.packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.packets.get_name_leafdata())
                    if (self.path_changes.is_set or self.path_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_changes.get_name_leafdata())
                    if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.state_changes.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "tunnel-type" or name == "bytes" or name == "current-path-time" or name == "name" or name == "next-reoptimization-time" or name == "online-time" or name == "packets" or name == "path-changes" or name == "state-changes" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-type"):
                        self.tunnel_type = value
                        self.tunnel_type.value_namespace = name_space
                        self.tunnel_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bytes"):
                        self.bytes = value
                        self.bytes.value_namespace = name_space
                        self.bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "current-path-time"):
                        self.current_path_time = value
                        self.current_path_time.value_namespace = name_space
                        self.current_path_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "name"):
                        self.name = value
                        self.name.value_namespace = name_space
                        self.name.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-reoptimization-time"):
                        self.next_reoptimization_time = value
                        self.next_reoptimization_time.value_namespace = name_space
                        self.next_reoptimization_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "online-time"):
                        self.online_time = value
                        self.online_time.value_namespace = name_space
                        self.online_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "packets"):
                        self.packets = value
                        self.packets.value_namespace = name_space
                        self.packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-changes"):
                        self.path_changes = value
                        self.path_changes.value_namespace = name_space
                        self.path_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "state-changes"):
                        self.state_changes = value
                        self.state_changes.value_namespace = name_space
                        self.state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.lsp_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/open-config/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-counter"):
                    for c in self.lsp_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.OpenConfig.LspCounters.LspCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.lsp_counters is not None and self.lsp_counters.has_data()) or
                (self.lsp_states is not None and self.lsp_states.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.lsp_counters is not None and self.lsp_counters.has_operation()) or
                (self.lsp_states is not None and self.lsp_states.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "open-config" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "lsp-counters"):
                if (self.lsp_counters is None):
                    self.lsp_counters = MplsTe.OpenConfig.LspCounters()
                    self.lsp_counters.parent = self
                    self._children_name_map["lsp_counters"] = "lsp-counters"
                return self.lsp_counters

            if (child_yang_name == "lsp-states"):
                if (self.lsp_states is None):
                    self.lsp_states = MplsTe.OpenConfig.LspStates()
                    self.lsp_states.parent = self
                    self._children_name_map["lsp_states"] = "lsp-states"
                return self.lsp_states

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "lsp-counters" or name == "lsp-states"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LspOutOfResources(Entity):
        """
        LSP OOR information
        
        .. attribute:: summary
        
        	LSP OOR Summary information
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.LspOutOfResources, self).__init__()

            self.yang_name = "lsp-out-of-resources"
            self.yang_parent_name = "mpls-te"

            self.summary = MplsTe.LspOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            LSP OOR Summary information
            
            .. attribute:: lsp_oor_green_recovery_time
            
            	Time Remaining in Green Recovery State (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: lsp_oor_state
            
            	The current LSP OOR state
            	**type**\:   :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
            
            .. attribute:: lsp_oor_state_xr
            
            	Array of LSP OOR info per state
            	**type**\: list of    :py:class:`LspOorStateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary.LspOorStateXr>`
            
            .. attribute:: lsp_oor_timestamp
            
            	Timestamp when the OOR state last changed
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: transit_lsp_total_count
            
            	Number of all transit LSPs on the router
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: transit_lsp_unprotected_count
            
            	Number of unprotected transit LSPs on the router
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.LspOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "lsp-out-of-resources"

                self.lsp_oor_green_recovery_time = YLeaf(YType.uint32, "lsp-oor-green-recovery-time")

                self.lsp_oor_state = YLeaf(YType.enumeration, "lsp-oor-state")

                self.lsp_oor_timestamp = YLeaf(YType.uint32, "lsp-oor-timestamp")

                self.transit_lsp_total_count = YLeaf(YType.uint32, "transit-lsp-total-count")

                self.transit_lsp_unprotected_count = YLeaf(YType.uint32, "transit-lsp-unprotected-count")

                self.lsp_oor_state_xr = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("lsp_oor_green_recovery_time",
                                "lsp_oor_state",
                                "lsp_oor_timestamp",
                                "transit_lsp_total_count",
                                "transit_lsp_unprotected_count") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.LspOutOfResources.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.LspOutOfResources.Summary, self).__setattr__(name, value)


            class LspOorStateXr(Entity):
                """
                Array of LSP OOR info per state
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the LSP OOR state
                	**type**\:  bool
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: percentage
                
                .. attribute:: lsp_oor_state
                
                	The LSP\-OOR state that this information belongs to
                	**type**\:   :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: statistics
                
                	LSP OOR Statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics>`
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: threshold_transit_all
                
                	The number of transit LSPs that triggers OOR state transition
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: threshold_transit_unprotected
                
                	The number of unprotected transit LSPs that triggers OOR state transition
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green LSP OOR state is entered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: minute
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.LspOutOfResources.Summary.LspOorStateXr, self).__init__()

                    self.yang_name = "lsp-oor-state-xr"
                    self.yang_parent_name = "summary"

                    self.accept_reopt = YLeaf(YType.boolean, "accept-reopt")

                    self.available_bw_percentage = YLeaf(YType.uint32, "available-bw-percentage")

                    self.lsp_oor_state = YLeaf(YType.enumeration, "lsp-oor-state")

                    self.minimum_lsp_bandwidth = YLeaf(YType.uint32, "minimum-lsp-bandwidth")

                    self.te_metric_penalty = YLeaf(YType.uint32, "te-metric-penalty")

                    self.threshold_transit_all = YLeaf(YType.uint32, "threshold-transit-all")

                    self.threshold_transit_unprotected = YLeaf(YType.uint32, "threshold-transit-unprotected")

                    self.transition_duration = YLeaf(YType.uint32, "transition-duration")

                    self.statistics = MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accept_reopt",
                                    "available_bw_percentage",
                                    "lsp_oor_state",
                                    "minimum_lsp_bandwidth",
                                    "te_metric_penalty",
                                    "threshold_transit_all",
                                    "threshold_transit_unprotected",
                                    "transition_duration") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.LspOutOfResources.Summary.LspOorStateXr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.LspOutOfResources.Summary.LspOorStateXr, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP OOR Statistics
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "lsp-oor-state-xr"

                        self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                        self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                        self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                        self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                        self.transitions = YLeaf(YType.uint32, "transitions")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("accepted_ls_ps_number",
                                        "accepted_reopt_ls_ps_number",
                                        "rejected_ls_ps_number",
                                        "rejected_reopt_ls_ps_number",
                                        "transitions") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.accepted_ls_ps_number.is_set or
                            self.accepted_reopt_ls_ps_number.is_set or
                            self.rejected_ls_ps_number.is_set or
                            self.rejected_reopt_ls_ps_number.is_set or
                            self.transitions.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                            self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.transitions.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/summary/lsp-oor-state-xr/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                        if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                        if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                        if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                        if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.transitions.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "accepted-ls-ps-number"):
                            self.accepted_ls_ps_number = value
                            self.accepted_ls_ps_number.value_namespace = name_space
                            self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "accepted-reopt-ls-ps-number"):
                            self.accepted_reopt_ls_ps_number = value
                            self.accepted_reopt_ls_ps_number.value_namespace = name_space
                            self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-ls-ps-number"):
                            self.rejected_ls_ps_number = value
                            self.rejected_ls_ps_number.value_namespace = name_space
                            self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-reopt-ls-ps-number"):
                            self.rejected_reopt_ls_ps_number = value
                            self.rejected_reopt_ls_ps_number.value_namespace = name_space
                            self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "transitions"):
                            self.transitions = value
                            self.transitions.value_namespace = name_space
                            self.transitions.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.accept_reopt.is_set or
                        self.available_bw_percentage.is_set or
                        self.lsp_oor_state.is_set or
                        self.minimum_lsp_bandwidth.is_set or
                        self.te_metric_penalty.is_set or
                        self.threshold_transit_all.is_set or
                        self.threshold_transit_unprotected.is_set or
                        self.transition_duration.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accept_reopt.yfilter != YFilter.not_set or
                        self.available_bw_percentage.yfilter != YFilter.not_set or
                        self.lsp_oor_state.yfilter != YFilter.not_set or
                        self.minimum_lsp_bandwidth.yfilter != YFilter.not_set or
                        self.te_metric_penalty.yfilter != YFilter.not_set or
                        self.threshold_transit_all.yfilter != YFilter.not_set or
                        self.threshold_transit_unprotected.yfilter != YFilter.not_set or
                        self.transition_duration.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-oor-state-xr" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accept_reopt.is_set or self.accept_reopt.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accept_reopt.get_name_leafdata())
                    if (self.available_bw_percentage.is_set or self.available_bw_percentage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bw_percentage.get_name_leafdata())
                    if (self.lsp_oor_state.is_set or self.lsp_oor_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_oor_state.get_name_leafdata())
                    if (self.minimum_lsp_bandwidth.is_set or self.minimum_lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.minimum_lsp_bandwidth.get_name_leafdata())
                    if (self.te_metric_penalty.is_set or self.te_metric_penalty.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric_penalty.get_name_leafdata())
                    if (self.threshold_transit_all.is_set or self.threshold_transit_all.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.threshold_transit_all.get_name_leafdata())
                    if (self.threshold_transit_unprotected.is_set or self.threshold_transit_unprotected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.threshold_transit_unprotected.get_name_leafdata())
                    if (self.transition_duration.is_set or self.transition_duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transition_duration.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "statistics" or name == "accept-reopt" or name == "available-bw-percentage" or name == "lsp-oor-state" or name == "minimum-lsp-bandwidth" or name == "te-metric-penalty" or name == "threshold-transit-all" or name == "threshold-transit-unprotected" or name == "transition-duration"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accept-reopt"):
                        self.accept_reopt = value
                        self.accept_reopt.value_namespace = name_space
                        self.accept_reopt.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bw-percentage"):
                        self.available_bw_percentage = value
                        self.available_bw_percentage.value_namespace = name_space
                        self.available_bw_percentage.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-oor-state"):
                        self.lsp_oor_state = value
                        self.lsp_oor_state.value_namespace = name_space
                        self.lsp_oor_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "minimum-lsp-bandwidth"):
                        self.minimum_lsp_bandwidth = value
                        self.minimum_lsp_bandwidth.value_namespace = name_space
                        self.minimum_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric-penalty"):
                        self.te_metric_penalty = value
                        self.te_metric_penalty.value_namespace = name_space
                        self.te_metric_penalty.value_namespace_prefix = name_space_prefix
                    if(value_path == "threshold-transit-all"):
                        self.threshold_transit_all = value
                        self.threshold_transit_all.value_namespace = name_space
                        self.threshold_transit_all.value_namespace_prefix = name_space_prefix
                    if(value_path == "threshold-transit-unprotected"):
                        self.threshold_transit_unprotected = value
                        self.threshold_transit_unprotected.value_namespace = name_space
                        self.threshold_transit_unprotected.value_namespace_prefix = name_space_prefix
                    if(value_path == "transition-duration"):
                        self.transition_duration = value
                        self.transition_duration.value_namespace = name_space
                        self.transition_duration.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_oor_state_xr:
                    if (c.has_data()):
                        return True
                return (
                    self.lsp_oor_green_recovery_time.is_set or
                    self.lsp_oor_state.is_set or
                    self.lsp_oor_timestamp.is_set or
                    self.transit_lsp_total_count.is_set or
                    self.transit_lsp_unprotected_count.is_set)

            def has_operation(self):
                for c in self.lsp_oor_state_xr:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.lsp_oor_green_recovery_time.yfilter != YFilter.not_set or
                    self.lsp_oor_state.yfilter != YFilter.not_set or
                    self.lsp_oor_timestamp.yfilter != YFilter.not_set or
                    self.transit_lsp_total_count.yfilter != YFilter.not_set or
                    self.transit_lsp_unprotected_count.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.lsp_oor_green_recovery_time.is_set or self.lsp_oor_green_recovery_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_green_recovery_time.get_name_leafdata())
                if (self.lsp_oor_state.is_set or self.lsp_oor_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_state.get_name_leafdata())
                if (self.lsp_oor_timestamp.is_set or self.lsp_oor_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_timestamp.get_name_leafdata())
                if (self.transit_lsp_total_count.is_set or self.transit_lsp_total_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.transit_lsp_total_count.get_name_leafdata())
                if (self.transit_lsp_unprotected_count.is_set or self.transit_lsp_unprotected_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.transit_lsp_unprotected_count.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-oor-state-xr"):
                    for c in self.lsp_oor_state_xr:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.LspOutOfResources.Summary.LspOorStateXr()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_oor_state_xr.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-oor-state-xr" or name == "lsp-oor-green-recovery-time" or name == "lsp-oor-state" or name == "lsp-oor-timestamp" or name == "transit-lsp-total-count" or name == "transit-lsp-unprotected-count"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "lsp-oor-green-recovery-time"):
                    self.lsp_oor_green_recovery_time = value
                    self.lsp_oor_green_recovery_time.value_namespace = name_space
                    self.lsp_oor_green_recovery_time.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-oor-state"):
                    self.lsp_oor_state = value
                    self.lsp_oor_state.value_namespace = name_space
                    self.lsp_oor_state.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-oor-timestamp"):
                    self.lsp_oor_timestamp = value
                    self.lsp_oor_timestamp.value_namespace = name_space
                    self.lsp_oor_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "transit-lsp-total-count"):
                    self.transit_lsp_total_count = value
                    self.transit_lsp_total_count.value_namespace = name_space
                    self.transit_lsp_total_count.value_namespace_prefix = name_space_prefix
                if(value_path == "transit-lsp-unprotected-count"):
                    self.transit_lsp_unprotected_count = value
                    self.transit_lsp_unprotected_count.value_namespace = name_space
                    self.transit_lsp_unprotected_count.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.summary is not None and self.summary.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "lsp-out-of-resources" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTe.LspOutOfResources.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Bfd(Entity):
        """
        MPLS TE BFD Oper Info
        
        .. attribute:: counters
        
        	MPLS TE BFD Counters
        	**type**\:   :py:class:`Counters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters>`
        
        .. attribute:: head_infos
        
        	MPLS TE Head BFD Over LSP Table
        	**type**\:   :py:class:`HeadInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos>`
        
        .. attribute:: links
        
        	MPLS TE BFD Info
        	**type**\:   :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links>`
        
        .. attribute:: summary
        
        	MPLS TE BFD Summary
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Summary>`
        
        .. attribute:: tail_infos
        
        	MPLS TE Tail BFD Over LSP Table
        	**type**\:   :py:class:`TailInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.Bfd, self).__init__()

            self.yang_name = "bfd"
            self.yang_parent_name = "mpls-te"

            self.counters = MplsTe.Bfd.Counters()
            self.counters.parent = self
            self._children_name_map["counters"] = "counters"
            self._children_yang_names.add("counters")

            self.head_infos = MplsTe.Bfd.HeadInfos()
            self.head_infos.parent = self
            self._children_name_map["head_infos"] = "head-infos"
            self._children_yang_names.add("head-infos")

            self.links = MplsTe.Bfd.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._children_yang_names.add("links")

            self.summary = MplsTe.Bfd.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")

            self.tail_infos = MplsTe.Bfd.TailInfos()
            self.tail_infos.parent = self
            self._children_name_map["tail_infos"] = "tail-infos"
            self._children_yang_names.add("tail-infos")


        class HeadInfos(Entity):
            """
            MPLS TE Head BFD Over LSP Table
            
            .. attribute:: head_info
            
            	MPLS TE Head End BFD Over LSP Info
            	**type**\: list of    :py:class:`HeadInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Bfd.HeadInfos, self).__init__()

                self.yang_name = "head-infos"
                self.yang_parent_name = "bfd"

                self.head_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Bfd.HeadInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Bfd.HeadInfos, self).__setattr__(name, value)


            class HeadInfo(Entity):
                """
                MPLS TE Head End BFD Over LSP Info
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: current_lspbfd_info
                
                	Current LSP BFD Info
                	**type**\:   :py:class:`CurrentLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo>`
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lspbfd_type
                
                	LSP BFD type
                	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                
                .. attribute:: reoptimized_lspbfd_info
                
                	Reoptimized LSP BFD Info
                	**type**\:   :py:class:`ReoptimizedLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo>`
                
                .. attribute:: standby_lspbfd_info
                
                	Standby LSP BFD Info
                	**type**\:   :py:class:`StandbyLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo>`
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.HeadInfos.HeadInfo, self).__init__()

                    self.yang_name = "head-info"
                    self.yang_parent_name = "head-infos"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                    self.tunnel_name_xr = YLeaf(YType.str, "tunnel-name-xr")

                    self.current_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                    self.current_lspbfd_info.parent = self
                    self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"
                    self._children_yang_names.add("current-lspbfd-info")

                    self.reoptimized_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                    self.reoptimized_lspbfd_info.parent = self
                    self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                    self._children_yang_names.add("reoptimized-lspbfd-info")

                    self.standby_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                    self.standby_lspbfd_info.parent = self
                    self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"
                    self._children_yang_names.add("standby-lspbfd-info")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "destination_address",
                                    "lspbfd_type",
                                    "tunnel_name_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.HeadInfos.HeadInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.HeadInfos.HeadInfo, self).__setattr__(name, value)


                class CurrentLspbfdInfo(Entity):
                    """
                    Current LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__init__()

                        self.yang_name = "current-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "current-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix


                class StandbyLspbfdInfo(Entity):
                    """
                    Standby LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__init__()

                        self.yang_name = "standby-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "standby-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix


                class ReoptimizedLspbfdInfo(Entity):
                    """
                    Reoptimized LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__init__()

                        self.yang_name = "reoptimized-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.destination_address.is_set or
                        self.lspbfd_type.is_set or
                        self.tunnel_name_xr.is_set or
                        (self.current_lspbfd_info is not None and self.current_lspbfd_info.has_data()) or
                        (self.reoptimized_lspbfd_info is not None and self.reoptimized_lspbfd_info.has_data()) or
                        (self.standby_lspbfd_info is not None and self.standby_lspbfd_info.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.lspbfd_type.yfilter != YFilter.not_set or
                        self.tunnel_name_xr.yfilter != YFilter.not_set or
                        (self.current_lspbfd_info is not None and self.current_lspbfd_info.has_operation()) or
                        (self.reoptimized_lspbfd_info is not None and self.reoptimized_lspbfd_info.has_operation()) or
                        (self.standby_lspbfd_info is not None and self.standby_lspbfd_info.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "head-info" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/head-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lspbfd_type.get_name_leafdata())
                    if (self.tunnel_name_xr.is_set or self.tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "current-lspbfd-info"):
                        if (self.current_lspbfd_info is None):
                            self.current_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                            self.current_lspbfd_info.parent = self
                            self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"
                        return self.current_lspbfd_info

                    if (child_yang_name == "reoptimized-lspbfd-info"):
                        if (self.reoptimized_lspbfd_info is None):
                            self.reoptimized_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                            self.reoptimized_lspbfd_info.parent = self
                            self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                        return self.reoptimized_lspbfd_info

                    if (child_yang_name == "standby-lspbfd-info"):
                        if (self.standby_lspbfd_info is None):
                            self.standby_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                            self.standby_lspbfd_info.parent = self
                            self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"
                        return self.standby_lspbfd_info

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "current-lspbfd-info" or name == "reoptimized-lspbfd-info" or name == "standby-lspbfd-info" or name == "tunnel-name" or name == "destination-address" or name == "lspbfd-type" or name == "tunnel-name-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "lspbfd-type"):
                        self.lspbfd_type = value
                        self.lspbfd_type.value_namespace = name_space
                        self.lspbfd_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name-xr"):
                        self.tunnel_name_xr = value
                        self.tunnel_name_xr.value_namespace = name_space
                        self.tunnel_name_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.head_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.head_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "head-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "head-info"):
                    for c in self.head_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Bfd.HeadInfos.HeadInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.head_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Links(Entity):
            """
            MPLS TE BFD Info
            
            .. attribute:: link
            
            	MPLS TE BFD Info
            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links.Link>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Bfd.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "bfd"

                self.link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Bfd.Links, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Bfd.Links, self).__setattr__(name, value)


            class Link(Entity):
                """
                MPLS TE BFD Info
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: neighbor
                
                	Neighbors of the specified link id
                	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links.Link.Neighbor>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.neighbor = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.Links.Link, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.Links.Link, self).__setattr__(name, value)


                class Neighbor(Entity):
                    """
                    Neighbors of the specified link id
                    
                    .. attribute:: is_bfd_up
                    
                    	TRUE if the BFD session is Up on this link
                    	**type**\:  bool
                    
                    .. attribute:: neighbor_address
                    
                    	The neighbor's IP address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Bfd.Links.Link.Neighbor, self).__init__()

                        self.yang_name = "neighbor"
                        self.yang_parent_name = "link"

                        self.is_bfd_up = YLeaf(YType.boolean, "is-bfd-up")

                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bfd_up",
                                        "neighbor_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Bfd.Links.Link.Neighbor, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Bfd.Links.Link.Neighbor, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_bfd_up.is_set or
                            self.neighbor_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bfd_up.yfilter != YFilter.not_set or
                            self.neighbor_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bfd_up.is_set or self.is_bfd_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bfd_up.get_name_leafdata())
                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-bfd-up" or name == "neighbor-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bfd-up"):
                            self.is_bfd_up = value
                            self.is_bfd_up.value_namespace = name_space
                            self.is_bfd_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-address"):
                            self.neighbor_address = value
                            self.neighbor_address.value_namespace = name_space
                            self.neighbor_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.neighbor:
                        if (c.has_data()):
                            return True
                    return self.interface_name.is_set

                def has_operation(self):
                    for c in self.neighbor:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "neighbor"):
                        for c in self.neighbor:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.Bfd.Links.Link.Neighbor()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.neighbor.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "neighbor" or name == "interface-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link"):
                    for c in self.link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Bfd.Links.Link()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TailInfos(Entity):
            """
            MPLS TE Tail BFD Over LSP Table
            
            .. attribute:: tail_info
            
            	MPLS TE Tail End BFD Over LSP Info
            	**type**\: list of    :py:class:`TailInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Bfd.TailInfos, self).__init__()

                self.yang_name = "tail-infos"
                self.yang_parent_name = "bfd"

                self.tail_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Bfd.TailInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Bfd.TailInfos, self).__setattr__(name, value)


            class TailInfo(Entity):
                """
                MPLS TE Tail End BFD Over LSP Info
                
                .. attribute:: bfd_session_state
                
                	BFD Session State
                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo.LspFec>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: p2mp_id
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: source_address
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.TailInfos.TailInfo, self).__init__()

                    self.yang_name = "tail-info"
                    self.yang_parent_name = "tail-infos"

                    self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_fec = MplsTe.Bfd.TailInfos.TailInfo.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bfd_session_state",
                                    "ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "p2mp_id",
                                    "signaled_name",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.TailInfos.TailInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.TailInfos.TailInfo, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Bfd.TailInfos.TailInfo.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tail-info"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Bfd.TailInfos.TailInfo.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Bfd.TailInfos.TailInfo.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/tail-info/lsp-fec/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/tail-info/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.bfd_session_state.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.p2mp_id.is_set or
                        self.signaled_name.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bfd_session_state.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tail-info" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTe.Bfd.TailInfos.TailInfo.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "bfd-session-state" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "lsp-id" or name == "p2mp-id" or name == "signaled-name" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bfd-session-state"):
                        self.bfd_session_state = value
                        self.bfd_session_state.value_namespace = name_space
                        self.bfd_session_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tail_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tail_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tail-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tail-info"):
                    for c in self.tail_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.Bfd.TailInfos.TailInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tail_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tail-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Summary(Entity):
            """
            MPLS TE BFD Summary
            
            .. attribute:: head_lsp_count_sbfd_session_created
            
            	Number of head end LSP with SBFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_sbfd_up
            
            	Number of head end LSP with SBFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_session_created
            
            	Number of head end LSP with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_up
            
            	Number of head end LSP with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_bfd_enabled
            
            	Number of link with BFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_session_created
            
            	Number of link with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_session_up
            
            	Number of link with BFD session in state Up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tail_lsp_count_session_created
            
            	Number of tail end LSP with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tail_lsp_count_session_up
            
            	Number of tail end LSP with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_bfd_enabled
            
            	Number of tunnel interface with BFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_sbfd_enabled
            
            	Number of tunnel interface with SBFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_sbfd_session_up
            
            	Number of tunnel with SBFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_session_up
            
            	Number of tunnel with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_total
            
            	Total number of tunnel interface
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Bfd.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "bfd"

                self.head_lsp_count_sbfd_session_created = YLeaf(YType.uint16, "head-lsp-count-sbfd-session-created")

                self.head_lsp_count_sbfd_up = YLeaf(YType.uint16, "head-lsp-count-sbfd-up")

                self.head_lsp_count_session_created = YLeaf(YType.uint16, "head-lsp-count-session-created")

                self.head_lsp_count_up = YLeaf(YType.uint16, "head-lsp-count-up")

                self.link_count_bfd_enabled = YLeaf(YType.uint16, "link-count-bfd-enabled")

                self.link_count_session_created = YLeaf(YType.uint16, "link-count-session-created")

                self.link_count_session_up = YLeaf(YType.uint16, "link-count-session-up")

                self.tail_lsp_count_session_created = YLeaf(YType.uint16, "tail-lsp-count-session-created")

                self.tail_lsp_count_session_up = YLeaf(YType.uint16, "tail-lsp-count-session-up")

                self.tunnel_count_bfd_enabled = YLeaf(YType.uint16, "tunnel-count-bfd-enabled")

                self.tunnel_count_sbfd_enabled = YLeaf(YType.uint16, "tunnel-count-sbfd-enabled")

                self.tunnel_count_sbfd_session_up = YLeaf(YType.uint16, "tunnel-count-sbfd-session-up")

                self.tunnel_count_session_up = YLeaf(YType.uint16, "tunnel-count-session-up")

                self.tunnel_count_total = YLeaf(YType.uint16, "tunnel-count-total")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("head_lsp_count_sbfd_session_created",
                                "head_lsp_count_sbfd_up",
                                "head_lsp_count_session_created",
                                "head_lsp_count_up",
                                "link_count_bfd_enabled",
                                "link_count_session_created",
                                "link_count_session_up",
                                "tail_lsp_count_session_created",
                                "tail_lsp_count_session_up",
                                "tunnel_count_bfd_enabled",
                                "tunnel_count_sbfd_enabled",
                                "tunnel_count_sbfd_session_up",
                                "tunnel_count_session_up",
                                "tunnel_count_total") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Bfd.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Bfd.Summary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.head_lsp_count_sbfd_session_created.is_set or
                    self.head_lsp_count_sbfd_up.is_set or
                    self.head_lsp_count_session_created.is_set or
                    self.head_lsp_count_up.is_set or
                    self.link_count_bfd_enabled.is_set or
                    self.link_count_session_created.is_set or
                    self.link_count_session_up.is_set or
                    self.tail_lsp_count_session_created.is_set or
                    self.tail_lsp_count_session_up.is_set or
                    self.tunnel_count_bfd_enabled.is_set or
                    self.tunnel_count_sbfd_enabled.is_set or
                    self.tunnel_count_sbfd_session_up.is_set or
                    self.tunnel_count_session_up.is_set or
                    self.tunnel_count_total.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.head_lsp_count_sbfd_session_created.yfilter != YFilter.not_set or
                    self.head_lsp_count_sbfd_up.yfilter != YFilter.not_set or
                    self.head_lsp_count_session_created.yfilter != YFilter.not_set or
                    self.head_lsp_count_up.yfilter != YFilter.not_set or
                    self.link_count_bfd_enabled.yfilter != YFilter.not_set or
                    self.link_count_session_created.yfilter != YFilter.not_set or
                    self.link_count_session_up.yfilter != YFilter.not_set or
                    self.tail_lsp_count_session_created.yfilter != YFilter.not_set or
                    self.tail_lsp_count_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_bfd_enabled.yfilter != YFilter.not_set or
                    self.tunnel_count_sbfd_enabled.yfilter != YFilter.not_set or
                    self.tunnel_count_sbfd_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_total.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.head_lsp_count_sbfd_session_created.is_set or self.head_lsp_count_sbfd_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_sbfd_session_created.get_name_leafdata())
                if (self.head_lsp_count_sbfd_up.is_set or self.head_lsp_count_sbfd_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_sbfd_up.get_name_leafdata())
                if (self.head_lsp_count_session_created.is_set or self.head_lsp_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_session_created.get_name_leafdata())
                if (self.head_lsp_count_up.is_set or self.head_lsp_count_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_up.get_name_leafdata())
                if (self.link_count_bfd_enabled.is_set or self.link_count_bfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_bfd_enabled.get_name_leafdata())
                if (self.link_count_session_created.is_set or self.link_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_session_created.get_name_leafdata())
                if (self.link_count_session_up.is_set or self.link_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_session_up.get_name_leafdata())
                if (self.tail_lsp_count_session_created.is_set or self.tail_lsp_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tail_lsp_count_session_created.get_name_leafdata())
                if (self.tail_lsp_count_session_up.is_set or self.tail_lsp_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tail_lsp_count_session_up.get_name_leafdata())
                if (self.tunnel_count_bfd_enabled.is_set or self.tunnel_count_bfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_bfd_enabled.get_name_leafdata())
                if (self.tunnel_count_sbfd_enabled.is_set or self.tunnel_count_sbfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_sbfd_enabled.get_name_leafdata())
                if (self.tunnel_count_sbfd_session_up.is_set or self.tunnel_count_sbfd_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_sbfd_session_up.get_name_leafdata())
                if (self.tunnel_count_session_up.is_set or self.tunnel_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_session_up.get_name_leafdata())
                if (self.tunnel_count_total.is_set or self.tunnel_count_total.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_total.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-lsp-count-sbfd-session-created" or name == "head-lsp-count-sbfd-up" or name == "head-lsp-count-session-created" or name == "head-lsp-count-up" or name == "link-count-bfd-enabled" or name == "link-count-session-created" or name == "link-count-session-up" or name == "tail-lsp-count-session-created" or name == "tail-lsp-count-session-up" or name == "tunnel-count-bfd-enabled" or name == "tunnel-count-sbfd-enabled" or name == "tunnel-count-sbfd-session-up" or name == "tunnel-count-session-up" or name == "tunnel-count-total"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "head-lsp-count-sbfd-session-created"):
                    self.head_lsp_count_sbfd_session_created = value
                    self.head_lsp_count_sbfd_session_created.value_namespace = name_space
                    self.head_lsp_count_sbfd_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-sbfd-up"):
                    self.head_lsp_count_sbfd_up = value
                    self.head_lsp_count_sbfd_up.value_namespace = name_space
                    self.head_lsp_count_sbfd_up.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-session-created"):
                    self.head_lsp_count_session_created = value
                    self.head_lsp_count_session_created.value_namespace = name_space
                    self.head_lsp_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-up"):
                    self.head_lsp_count_up = value
                    self.head_lsp_count_up.value_namespace = name_space
                    self.head_lsp_count_up.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-bfd-enabled"):
                    self.link_count_bfd_enabled = value
                    self.link_count_bfd_enabled.value_namespace = name_space
                    self.link_count_bfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-session-created"):
                    self.link_count_session_created = value
                    self.link_count_session_created.value_namespace = name_space
                    self.link_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-session-up"):
                    self.link_count_session_up = value
                    self.link_count_session_up.value_namespace = name_space
                    self.link_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tail-lsp-count-session-created"):
                    self.tail_lsp_count_session_created = value
                    self.tail_lsp_count_session_created.value_namespace = name_space
                    self.tail_lsp_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "tail-lsp-count-session-up"):
                    self.tail_lsp_count_session_up = value
                    self.tail_lsp_count_session_up.value_namespace = name_space
                    self.tail_lsp_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-bfd-enabled"):
                    self.tunnel_count_bfd_enabled = value
                    self.tunnel_count_bfd_enabled.value_namespace = name_space
                    self.tunnel_count_bfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-sbfd-enabled"):
                    self.tunnel_count_sbfd_enabled = value
                    self.tunnel_count_sbfd_enabled.value_namespace = name_space
                    self.tunnel_count_sbfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-sbfd-session-up"):
                    self.tunnel_count_sbfd_session_up = value
                    self.tunnel_count_sbfd_session_up.value_namespace = name_space
                    self.tunnel_count_sbfd_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-session-up"):
                    self.tunnel_count_session_up = value
                    self.tunnel_count_session_up.value_namespace = name_space
                    self.tunnel_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-total"):
                    self.tunnel_count_total = value
                    self.tunnel_count_total.value_namespace = name_space
                    self.tunnel_count_total.value_namespace_prefix = name_space_prefix


        class Counters(Entity):
            """
            MPLS TE BFD Counters
            
            .. attribute:: bf_do_lm_counters
            
            	BFD over Links Cumulative Counters
            	**type**\:   :py:class:`BfDoLmCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfDoLmCounters>`
            
            .. attribute:: bfd_over_lsp_head_counters
            
            	BFD over Head\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`BfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfdOverLspHeadCounters>`
            
            .. attribute:: bfd_over_lsp_tail_counters
            
            	BFD over Tail\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`BfdOverLspTailCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfdOverLspTailCounters>`
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: sbfd_over_lsp_head_counters
            
            	SBFD over Head\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`SbfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.SbfdOverLspHeadCounters>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Bfd.Counters, self).__init__()

                self.yang_name = "counters"
                self.yang_parent_name = "bfd"

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.bf_do_lm_counters = MplsTe.Bfd.Counters.BfDoLmCounters()
                self.bf_do_lm_counters.parent = self
                self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                self._children_yang_names.add("bf-do-lm-counters")

                self.bfd_over_lsp_head_counters = MplsTe.Bfd.Counters.BfdOverLspHeadCounters()
                self.bfd_over_lsp_head_counters.parent = self
                self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"
                self._children_yang_names.add("bfd-over-lsp-head-counters")

                self.bfd_over_lsp_tail_counters = MplsTe.Bfd.Counters.BfdOverLspTailCounters()
                self.bfd_over_lsp_tail_counters.parent = self
                self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"
                self._children_yang_names.add("bfd-over-lsp-tail-counters")

                self.sbfd_over_lsp_head_counters = MplsTe.Bfd.Counters.SbfdOverLspHeadCounters()
                self.sbfd_over_lsp_head_counters.parent = self
                self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"
                self._children_yang_names.add("sbfd-over-lsp-head-counters")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("last_cleared_timestamp") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Bfd.Counters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Bfd.Counters, self).__setattr__(name, value)


            class BfdOverLspHeadCounters(Entity):
                """
                BFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.Counters.BfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_create_timeout_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.Counters.BfdOverLspHeadCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.Counters.BfdOverLspHeadCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_create_timeout_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_create_timeout_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bfd-over-lsp-head-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-timeout-events"):
                        self.session_create_timeout_events = value
                        self.session_create_timeout_events.value_namespace = name_space
                        self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class SbfdOverLspHeadCounters(Entity):
                """
                SBFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.Counters.SbfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "sbfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_create_timeout_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.Counters.SbfdOverLspHeadCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.Counters.SbfdOverLspHeadCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_create_timeout_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_create_timeout_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sbfd-over-lsp-head-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-timeout-events"):
                        self.session_create_timeout_events = value
                        self.session_create_timeout_events.value_namespace = name_space
                        self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class BfdOverLspTailCounters(Entity):
                """
                BFD over Tail\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.Counters.BfdOverLspTailCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-tail-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.Counters.BfdOverLspTailCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.Counters.BfdOverLspTailCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bfd-over-lsp-tail-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class BfDoLmCounters(Entity):
                """
                BFD over Links Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Bfd.Counters.BfDoLmCounters, self).__init__()

                    self.yang_name = "bf-do-lm-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Bfd.Counters.BfDoLmCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Bfd.Counters.BfDoLmCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bf-do-lm-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.last_cleared_timestamp.is_set or
                    (self.bf_do_lm_counters is not None and self.bf_do_lm_counters.has_data()) or
                    (self.bfd_over_lsp_head_counters is not None and self.bfd_over_lsp_head_counters.has_data()) or
                    (self.bfd_over_lsp_tail_counters is not None and self.bfd_over_lsp_tail_counters.has_data()) or
                    (self.sbfd_over_lsp_head_counters is not None and self.sbfd_over_lsp_head_counters.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    (self.bf_do_lm_counters is not None and self.bf_do_lm_counters.has_operation()) or
                    (self.bfd_over_lsp_head_counters is not None and self.bfd_over_lsp_head_counters.has_operation()) or
                    (self.bfd_over_lsp_tail_counters is not None and self.bfd_over_lsp_tail_counters.has_operation()) or
                    (self.sbfd_over_lsp_head_counters is not None and self.sbfd_over_lsp_head_counters.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bf-do-lm-counters"):
                    if (self.bf_do_lm_counters is None):
                        self.bf_do_lm_counters = MplsTe.Bfd.Counters.BfDoLmCounters()
                        self.bf_do_lm_counters.parent = self
                        self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                    return self.bf_do_lm_counters

                if (child_yang_name == "bfd-over-lsp-head-counters"):
                    if (self.bfd_over_lsp_head_counters is None):
                        self.bfd_over_lsp_head_counters = MplsTe.Bfd.Counters.BfdOverLspHeadCounters()
                        self.bfd_over_lsp_head_counters.parent = self
                        self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"
                    return self.bfd_over_lsp_head_counters

                if (child_yang_name == "bfd-over-lsp-tail-counters"):
                    if (self.bfd_over_lsp_tail_counters is None):
                        self.bfd_over_lsp_tail_counters = MplsTe.Bfd.Counters.BfdOverLspTailCounters()
                        self.bfd_over_lsp_tail_counters.parent = self
                        self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"
                    return self.bfd_over_lsp_tail_counters

                if (child_yang_name == "sbfd-over-lsp-head-counters"):
                    if (self.sbfd_over_lsp_head_counters is None):
                        self.sbfd_over_lsp_head_counters = MplsTe.Bfd.Counters.SbfdOverLspHeadCounters()
                        self.sbfd_over_lsp_head_counters.parent = self
                        self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"
                    return self.sbfd_over_lsp_head_counters

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bf-do-lm-counters" or name == "bfd-over-lsp-head-counters" or name == "bfd-over-lsp-tail-counters" or name == "sbfd-over-lsp-head-counters" or name == "last-cleared-timestamp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.counters is not None and self.counters.has_data()) or
                (self.head_infos is not None and self.head_infos.has_data()) or
                (self.links is not None and self.links.has_data()) or
                (self.summary is not None and self.summary.has_data()) or
                (self.tail_infos is not None and self.tail_infos.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.counters is not None and self.counters.has_operation()) or
                (self.head_infos is not None and self.head_infos.has_operation()) or
                (self.links is not None and self.links.has_operation()) or
                (self.summary is not None and self.summary.has_operation()) or
                (self.tail_infos is not None and self.tail_infos.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bfd" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "counters"):
                if (self.counters is None):
                    self.counters = MplsTe.Bfd.Counters()
                    self.counters.parent = self
                    self._children_name_map["counters"] = "counters"
                return self.counters

            if (child_yang_name == "head-infos"):
                if (self.head_infos is None):
                    self.head_infos = MplsTe.Bfd.HeadInfos()
                    self.head_infos.parent = self
                    self._children_name_map["head_infos"] = "head-infos"
                return self.head_infos

            if (child_yang_name == "links"):
                if (self.links is None):
                    self.links = MplsTe.Bfd.Links()
                    self.links.parent = self
                    self._children_name_map["links"] = "links"
                return self.links

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTe.Bfd.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            if (child_yang_name == "tail-infos"):
                if (self.tail_infos is None):
                    self.tail_infos = MplsTe.Bfd.TailInfos()
                    self.tail_infos.parent = self
                    self._children_name_map["tail_infos"] = "tail-infos"
                return self.tail_infos

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "counters" or name == "head-infos" or name == "links" or name == "summary" or name == "tail-infos"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Nsr(Entity):
        """
        MPLS TE NSR information
        
        .. attribute:: detail
        
        	MPLS TE NSR Status information
        	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail>`
        
        .. attribute:: status
        
        	MPLS TE NSR Status information
        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.Nsr, self).__init__()

            self.yang_name = "nsr"
            self.yang_parent_name = "mpls-te"

            self.detail = MplsTe.Nsr.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._children_yang_names.add("detail")

            self.status = MplsTe.Nsr.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"
            self._children_yang_names.add("status")


        class Status(Entity):
            """
            MPLS TE NSR Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Nsr.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "nsr"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTe.Nsr.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Nsr.Status, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Nsr.Status, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Nsr.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Nsr.Status.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Nsr.Status.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "status" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTe.Nsr.Status.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix


        class Detail(Entity):
            """
            MPLS TE NSR Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.Nsr.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "nsr"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTe.Nsr.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.Nsr.Detail, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.Nsr.Detail, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.Nsr.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.Nsr.Detail.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.Nsr.Detail.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "detail" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTe.Nsr.Detail.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.detail is not None and self.detail.has_data()) or
                (self.status is not None and self.status.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.detail is not None and self.detail.has_operation()) or
                (self.status is not None and self.status.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nsr" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "detail"):
                if (self.detail is None):
                    self.detail = MplsTe.Nsr.Detail()
                    self.detail.parent = self
                    self._children_name_map["detail"] = "detail"
                return self.detail

            if (child_yang_name == "status"):
                if (self.status is None):
                    self.status = MplsTe.Nsr.Status()
                    self.status.parent = self
                    self._children_name_map["status"] = "status"
                return self.status

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "detail" or name == "status"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AutoTunnelServices(Entity):
        """
        MPLS TE Auto Tunnel Services
        
        .. attribute:: sr_policy_entries
        
        	MPLS TE SR Policy Context table 
        	**type**\:   :py:class:`SrPolicyEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AutoTunnelServices, self).__init__()

            self.yang_name = "auto-tunnel-services"
            self.yang_parent_name = "mpls-te"

            self.sr_policy_entries = MplsTe.AutoTunnelServices.SrPolicyEntries()
            self.sr_policy_entries.parent = self
            self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
            self._children_yang_names.add("sr-policy-entries")


        class SrPolicyEntries(Entity):
            """
            MPLS TE SR Policy Context table 
            
            .. attribute:: sr_policy_entry
            
            	MPLS TE SR Policy information
            	**type**\: list of    :py:class:`SrPolicyEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AutoTunnelServices.SrPolicyEntries, self).__init__()

                self.yang_name = "sr-policy-entries"
                self.yang_parent_name = "auto-tunnel-services"

                self.sr_policy_entry = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AutoTunnelServices.SrPolicyEntries, self).__setattr__(name, value)


            class SrPolicyEntry(Entity):
                """
                MPLS TE SR Policy information
                
                .. attribute:: client_id  <key>
                
                	Client ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: color  <key>
                
                	Color
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: end_point  <key>
                
                	End Point
                	**type**\: one of the below types:
                
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                
                ----
                	**type**\:  str
                
                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                
                
                ----
                .. attribute:: distinguisher  <key>
                
                	SR Policy Distinguisher Value
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: allocated_binding_sid
                
                	Allocated Binding SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_sid_context_id
                
                	Binding SID Context ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_sid_request_pending
                
                	Binding SID Request Pending
                	**type**\:  bool
                
                .. attribute:: client_id_xr
                
                	Client ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: client_name
                
                	Client Name
                	**type**\:  str
                
                .. attribute:: color_xr
                
                	Color
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: creation_time
                
                	SR policy structure creation timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                .. attribute:: distinguisher_xr
                
                	SR Policy Distinguisher value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: end_point_xr
                
                	End Point
                	**type**\:   :py:class:`EndPointXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr>`
                
                .. attribute:: explicit_path
                
                	Explicit Paths
                	**type**\: list of    :py:class:`ExplicitPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath>`
                
                .. attribute:: ipv6_caps
                
                	IPv6 Capsulation
                	**type**\:  bool
                
                .. attribute:: is_stale
                
                	Is Stale
                	**type**\:  bool
                
                .. attribute:: is_synced
                
                	Is Synced
                	**type**\:  bool
                
                .. attribute:: notify_state_is_active
                
                	Notify State Is Active
                	**type**\:  bool
                
                .. attribute:: notify_time
                
                	Notify Time
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: policy_active
                
                	Policy Active
                	**type**\:  bool
                
                .. attribute:: requested_binding_sid
                
                	Requested Binding SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rewrite_done
                
                	Rewrite Done
                	**type**\:  bool
                
                .. attribute:: rewrite_request_pending
                
                	Rewrite Requeste Pending
                	**type**\:  bool
                
                .. attribute:: sr_policy_id
                
                	SR Policy ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__init__()

                    self.yang_name = "sr-policy-entry"
                    self.yang_parent_name = "sr-policy-entries"

                    self.client_id = YLeaf(YType.int32, "client-id")

                    self.color = YLeaf(YType.int32, "color")

                    self.end_point = YLeaf(YType.str, "end-point")

                    self.distinguisher = YLeaf(YType.int32, "distinguisher")

                    self.allocated_binding_sid = YLeaf(YType.uint32, "allocated-binding-sid")

                    self.binding_sid_context_id = YLeaf(YType.uint32, "binding-sid-context-id")

                    self.binding_sid_request_pending = YLeaf(YType.boolean, "binding-sid-request-pending")

                    self.client_id_xr = YLeaf(YType.uint32, "client-id-xr")

                    self.client_name = YLeaf(YType.str, "client-name")

                    self.color_xr = YLeaf(YType.uint32, "color-xr")

                    self.creation_time = YLeaf(YType.uint64, "creation-time")

                    self.distinguisher_xr = YLeaf(YType.uint32, "distinguisher-xr")

                    self.ipv6_caps = YLeaf(YType.boolean, "ipv6-caps")

                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                    self.is_synced = YLeaf(YType.boolean, "is-synced")

                    self.notify_state_is_active = YLeaf(YType.boolean, "notify-state-is-active")

                    self.notify_time = YLeaf(YType.uint32, "notify-time")

                    self.policy_active = YLeaf(YType.boolean, "policy-active")

                    self.requested_binding_sid = YLeaf(YType.uint32, "requested-binding-sid")

                    self.rewrite_done = YLeaf(YType.boolean, "rewrite-done")

                    self.rewrite_request_pending = YLeaf(YType.boolean, "rewrite-request-pending")

                    self.sr_policy_id = YLeaf(YType.uint32, "sr-policy-id")

                    self.end_point_xr = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                    self.end_point_xr.parent = self
                    self._children_name_map["end_point_xr"] = "end-point-xr"
                    self._children_yang_names.add("end-point-xr")

                    self.explicit_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("client_id",
                                    "color",
                                    "end_point",
                                    "distinguisher",
                                    "allocated_binding_sid",
                                    "binding_sid_context_id",
                                    "binding_sid_request_pending",
                                    "client_id_xr",
                                    "client_name",
                                    "color_xr",
                                    "creation_time",
                                    "distinguisher_xr",
                                    "ipv6_caps",
                                    "is_stale",
                                    "is_synced",
                                    "notify_state_is_active",
                                    "notify_time",
                                    "policy_active",
                                    "requested_binding_sid",
                                    "rewrite_done",
                                    "rewrite_request_pending",
                                    "sr_policy_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__setattr__(name, value)


                class EndPointXr(Entity):
                    """
                    End Point
                    
                    .. attribute:: address_family_type
                    
                    	AddressFamilyType
                    	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv6_address
                    
                    	IPv6 Address
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__init__()

                        self.yang_name = "end-point-xr"
                        self.yang_parent_name = "sr-policy-entry"

                        self.address_family_type = YLeaf(YType.enumeration, "address-family-type")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv6_address = YLeaf(YType.str, "ipv6-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_family_type",
                                        "ipv4_address",
                                        "ipv6_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_family_type.is_set or
                            self.ipv4_address.is_set or
                            self.ipv6_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_family_type.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv6_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "end-point-xr" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_family_type.is_set or self.address_family_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_family_type.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv6_address.is_set or self.ipv6_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv6_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family-type" or name == "ipv4-address" or name == "ipv6-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-family-type"):
                            self.address_family_type = value
                            self.address_family_type.value_namespace = name_space
                            self.address_family_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv6-address"):
                            self.ipv6_address = value
                            self.ipv6_address.value_namespace = name_space
                            self.ipv6_address.value_namespace_prefix = name_space_prefix


                class ExplicitPath(Entity):
                    """
                    Explicit Paths
                    
                    .. attribute:: context_id
                    
                    	Explicit Path Context ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hops
                    
                    	Path Hops
                    	**type**\: list of    :py:class:`Hops <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops>`
                    
                    .. attribute:: is_stale
                    
                    	Is Stale
                    	**type**\:  bool
                    
                    .. attribute:: is_synced
                    
                    	Is Synced
                    	**type**\:  bool
                    
                    .. attribute:: path_weight
                    
                    	Path Weight
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: programmed_in_fib
                    
                    	Programmed in FIB
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_info
                    
                    	Auto tunnel info
                    	**type**\:   :py:class:`TunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__init__()

                        self.yang_name = "explicit-path"
                        self.yang_parent_name = "sr-policy-entry"

                        self.context_id = YLeaf(YType.uint32, "context-id")

                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                        self.is_synced = YLeaf(YType.boolean, "is-synced")

                        self.path_weight = YLeaf(YType.uint32, "path-weight")

                        self.programmed_in_fib = YLeaf(YType.boolean, "programmed-in-fib")

                        self.tunnel_info = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                        self.tunnel_info.parent = self
                        self._children_name_map["tunnel_info"] = "tunnel-info"
                        self._children_yang_names.add("tunnel-info")

                        self.hops = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("context_id",
                                        "is_stale",
                                        "is_synced",
                                        "path_weight",
                                        "programmed_in_fib") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__setattr__(name, value)


                    class TunnelInfo(Entity):
                        """
                        Auto tunnel info
                        
                        .. attribute:: ipv6_caps
                        
                        	IPv6 Capsulation
                        	**type**\:  bool
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_up
                        
                        	Tunnel Up
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__init__()

                            self.yang_name = "tunnel-info"
                            self.yang_parent_name = "explicit-path"

                            self.ipv6_caps = YLeaf(YType.boolean, "ipv6-caps")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            self.tunnel_up = YLeaf(YType.boolean, "tunnel-up")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ipv6_caps",
                                            "tunnel_id",
                                            "tunnel_up") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.ipv6_caps.is_set or
                                self.tunnel_id.is_set or
                                self.tunnel_up.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ipv6_caps.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set or
                                self.tunnel_up.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ipv6_caps.is_set or self.ipv6_caps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv6_caps.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                            if (self.tunnel_up.is_set or self.tunnel_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_up.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv6-caps" or name == "tunnel-id" or name == "tunnel-up"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ipv6-caps"):
                                self.ipv6_caps = value
                                self.ipv6_caps.value_namespace = name_space
                                self.ipv6_caps.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-up"):
                                self.tunnel_up = value
                                self.tunnel_up.value_namespace = name_space
                                self.tunnel_up.value_namespace_prefix = name_space_prefix


                    class Hops(Entity):
                        """
                        Path Hops
                        
                        .. attribute:: hop_type
                        
                        	Hop Type
                        	**type**\:   :py:class:`TeAutoTunExpPathHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutoTunExpPathHop>`
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 Address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__init__()

                            self.yang_name = "hops"
                            self.yang_parent_name = "explicit-path"

                            self.hop_type = YLeaf(YType.enumeration, "hop-type")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("hop_type",
                                            "ipv4_address",
                                            "mpls_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.hop_type.is_set or
                                self.ipv4_address.is_set or
                                self.mpls_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.hop_type.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "hops" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.hop_type.is_set or self.hop_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_type.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "hop-type" or name == "ipv4-address" or name == "mpls-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "hop-type"):
                                self.hop_type = value
                                self.hop_type.value_namespace = name_space
                                self.hop_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.hops:
                            if (c.has_data()):
                                return True
                        return (
                            self.context_id.is_set or
                            self.is_stale.is_set or
                            self.is_synced.is_set or
                            self.path_weight.is_set or
                            self.programmed_in_fib.is_set or
                            (self.tunnel_info is not None and self.tunnel_info.has_data()))

                    def has_operation(self):
                        for c in self.hops:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.context_id.yfilter != YFilter.not_set or
                            self.is_stale.yfilter != YFilter.not_set or
                            self.is_synced.yfilter != YFilter.not_set or
                            self.path_weight.yfilter != YFilter.not_set or
                            self.programmed_in_fib.yfilter != YFilter.not_set or
                            (self.tunnel_info is not None and self.tunnel_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "explicit-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.context_id.is_set or self.context_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.context_id.get_name_leafdata())
                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                        if (self.is_synced.is_set or self.is_synced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_synced.get_name_leafdata())
                        if (self.path_weight.is_set or self.path_weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_weight.get_name_leafdata())
                        if (self.programmed_in_fib.is_set or self.programmed_in_fib.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.programmed_in_fib.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "hops"):
                            for c in self.hops:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.hops.append(c)
                            return c

                        if (child_yang_name == "tunnel-info"):
                            if (self.tunnel_info is None):
                                self.tunnel_info = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                                self.tunnel_info.parent = self
                                self._children_name_map["tunnel_info"] = "tunnel-info"
                            return self.tunnel_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "hops" or name == "tunnel-info" or name == "context-id" or name == "is-stale" or name == "is-synced" or name == "path-weight" or name == "programmed-in-fib"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "context-id"):
                            self.context_id = value
                            self.context_id.value_namespace = name_space
                            self.context_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-stale"):
                            self.is_stale = value
                            self.is_stale.value_namespace = name_space
                            self.is_stale.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-synced"):
                            self.is_synced = value
                            self.is_synced.value_namespace = name_space
                            self.is_synced.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-weight"):
                            self.path_weight = value
                            self.path_weight.value_namespace = name_space
                            self.path_weight.value_namespace_prefix = name_space_prefix
                        if(value_path == "programmed-in-fib"):
                            self.programmed_in_fib = value
                            self.programmed_in_fib.value_namespace = name_space
                            self.programmed_in_fib.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.explicit_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.client_id.is_set or
                        self.color.is_set or
                        self.end_point.is_set or
                        self.distinguisher.is_set or
                        self.allocated_binding_sid.is_set or
                        self.binding_sid_context_id.is_set or
                        self.binding_sid_request_pending.is_set or
                        self.client_id_xr.is_set or
                        self.client_name.is_set or
                        self.color_xr.is_set or
                        self.creation_time.is_set or
                        self.distinguisher_xr.is_set or
                        self.ipv6_caps.is_set or
                        self.is_stale.is_set or
                        self.is_synced.is_set or
                        self.notify_state_is_active.is_set or
                        self.notify_time.is_set or
                        self.policy_active.is_set or
                        self.requested_binding_sid.is_set or
                        self.rewrite_done.is_set or
                        self.rewrite_request_pending.is_set or
                        self.sr_policy_id.is_set or
                        (self.end_point_xr is not None and self.end_point_xr.has_data()))

                def has_operation(self):
                    for c in self.explicit_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.client_id.yfilter != YFilter.not_set or
                        self.color.yfilter != YFilter.not_set or
                        self.end_point.yfilter != YFilter.not_set or
                        self.distinguisher.yfilter != YFilter.not_set or
                        self.allocated_binding_sid.yfilter != YFilter.not_set or
                        self.binding_sid_context_id.yfilter != YFilter.not_set or
                        self.binding_sid_request_pending.yfilter != YFilter.not_set or
                        self.client_id_xr.yfilter != YFilter.not_set or
                        self.client_name.yfilter != YFilter.not_set or
                        self.color_xr.yfilter != YFilter.not_set or
                        self.creation_time.yfilter != YFilter.not_set or
                        self.distinguisher_xr.yfilter != YFilter.not_set or
                        self.ipv6_caps.yfilter != YFilter.not_set or
                        self.is_stale.yfilter != YFilter.not_set or
                        self.is_synced.yfilter != YFilter.not_set or
                        self.notify_state_is_active.yfilter != YFilter.not_set or
                        self.notify_time.yfilter != YFilter.not_set or
                        self.policy_active.yfilter != YFilter.not_set or
                        self.requested_binding_sid.yfilter != YFilter.not_set or
                        self.rewrite_done.yfilter != YFilter.not_set or
                        self.rewrite_request_pending.yfilter != YFilter.not_set or
                        self.sr_policy_id.yfilter != YFilter.not_set or
                        (self.end_point_xr is not None and self.end_point_xr.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sr-policy-entry" + "[client-id='" + self.client_id.get() + "']" + "[color='" + self.color.get() + "']" + "[end-point='" + self.end_point.get() + "']" + "[distinguisher='" + self.distinguisher.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel-services/sr-policy-entries/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.client_id.is_set or self.client_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_id.get_name_leafdata())
                    if (self.color.is_set or self.color.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.color.get_name_leafdata())
                    if (self.end_point.is_set or self.end_point.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.end_point.get_name_leafdata())
                    if (self.distinguisher.is_set or self.distinguisher.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.distinguisher.get_name_leafdata())
                    if (self.allocated_binding_sid.is_set or self.allocated_binding_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.allocated_binding_sid.get_name_leafdata())
                    if (self.binding_sid_context_id.is_set or self.binding_sid_context_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_sid_context_id.get_name_leafdata())
                    if (self.binding_sid_request_pending.is_set or self.binding_sid_request_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_sid_request_pending.get_name_leafdata())
                    if (self.client_id_xr.is_set or self.client_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_id_xr.get_name_leafdata())
                    if (self.client_name.is_set or self.client_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_name.get_name_leafdata())
                    if (self.color_xr.is_set or self.color_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.color_xr.get_name_leafdata())
                    if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.creation_time.get_name_leafdata())
                    if (self.distinguisher_xr.is_set or self.distinguisher_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.distinguisher_xr.get_name_leafdata())
                    if (self.ipv6_caps.is_set or self.ipv6_caps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ipv6_caps.get_name_leafdata())
                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                    if (self.is_synced.is_set or self.is_synced.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_synced.get_name_leafdata())
                    if (self.notify_state_is_active.is_set or self.notify_state_is_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.notify_state_is_active.get_name_leafdata())
                    if (self.notify_time.is_set or self.notify_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.notify_time.get_name_leafdata())
                    if (self.policy_active.is_set or self.policy_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.policy_active.get_name_leafdata())
                    if (self.requested_binding_sid.is_set or self.requested_binding_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_binding_sid.get_name_leafdata())
                    if (self.rewrite_done.is_set or self.rewrite_done.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_done.get_name_leafdata())
                    if (self.rewrite_request_pending.is_set or self.rewrite_request_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_request_pending.get_name_leafdata())
                    if (self.sr_policy_id.is_set or self.sr_policy_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sr_policy_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "end-point-xr"):
                        if (self.end_point_xr is None):
                            self.end_point_xr = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                            self.end_point_xr.parent = self
                            self._children_name_map["end_point_xr"] = "end-point-xr"
                        return self.end_point_xr

                    if (child_yang_name == "explicit-path"):
                        for c in self.explicit_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.explicit_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "end-point-xr" or name == "explicit-path" or name == "client-id" or name == "color" or name == "end-point" or name == "distinguisher" or name == "allocated-binding-sid" or name == "binding-sid-context-id" or name == "binding-sid-request-pending" or name == "client-id-xr" or name == "client-name" or name == "color-xr" or name == "creation-time" or name == "distinguisher-xr" or name == "ipv6-caps" or name == "is-stale" or name == "is-synced" or name == "notify-state-is-active" or name == "notify-time" or name == "policy-active" or name == "requested-binding-sid" or name == "rewrite-done" or name == "rewrite-request-pending" or name == "sr-policy-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "client-id"):
                        self.client_id = value
                        self.client_id.value_namespace = name_space
                        self.client_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "color"):
                        self.color = value
                        self.color.value_namespace = name_space
                        self.color.value_namespace_prefix = name_space_prefix
                    if(value_path == "end-point"):
                        self.end_point = value
                        self.end_point.value_namespace = name_space
                        self.end_point.value_namespace_prefix = name_space_prefix
                    if(value_path == "distinguisher"):
                        self.distinguisher = value
                        self.distinguisher.value_namespace = name_space
                        self.distinguisher.value_namespace_prefix = name_space_prefix
                    if(value_path == "allocated-binding-sid"):
                        self.allocated_binding_sid = value
                        self.allocated_binding_sid.value_namespace = name_space
                        self.allocated_binding_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-sid-context-id"):
                        self.binding_sid_context_id = value
                        self.binding_sid_context_id.value_namespace = name_space
                        self.binding_sid_context_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-sid-request-pending"):
                        self.binding_sid_request_pending = value
                        self.binding_sid_request_pending.value_namespace = name_space
                        self.binding_sid_request_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "client-id-xr"):
                        self.client_id_xr = value
                        self.client_id_xr.value_namespace = name_space
                        self.client_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "client-name"):
                        self.client_name = value
                        self.client_name.value_namespace = name_space
                        self.client_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "color-xr"):
                        self.color_xr = value
                        self.color_xr.value_namespace = name_space
                        self.color_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "creation-time"):
                        self.creation_time = value
                        self.creation_time.value_namespace = name_space
                        self.creation_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "distinguisher-xr"):
                        self.distinguisher_xr = value
                        self.distinguisher_xr.value_namespace = name_space
                        self.distinguisher_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "ipv6-caps"):
                        self.ipv6_caps = value
                        self.ipv6_caps.value_namespace = name_space
                        self.ipv6_caps.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-stale"):
                        self.is_stale = value
                        self.is_stale.value_namespace = name_space
                        self.is_stale.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-synced"):
                        self.is_synced = value
                        self.is_synced.value_namespace = name_space
                        self.is_synced.value_namespace_prefix = name_space_prefix
                    if(value_path == "notify-state-is-active"):
                        self.notify_state_is_active = value
                        self.notify_state_is_active.value_namespace = name_space
                        self.notify_state_is_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "notify-time"):
                        self.notify_time = value
                        self.notify_time.value_namespace = name_space
                        self.notify_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "policy-active"):
                        self.policy_active = value
                        self.policy_active.value_namespace = name_space
                        self.policy_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-binding-sid"):
                        self.requested_binding_sid = value
                        self.requested_binding_sid.value_namespace = name_space
                        self.requested_binding_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-done"):
                        self.rewrite_done = value
                        self.rewrite_done.value_namespace = name_space
                        self.rewrite_done.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-request-pending"):
                        self.rewrite_request_pending = value
                        self.rewrite_request_pending.value_namespace = name_space
                        self.rewrite_request_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "sr-policy-id"):
                        self.sr_policy_id = value
                        self.sr_policy_id.value_namespace = name_space
                        self.sr_policy_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.sr_policy_entry:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.sr_policy_entry:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "sr-policy-entries" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel-services/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sr-policy-entry"):
                    for c in self.sr_policy_entry:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.sr_policy_entry.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sr-policy-entry"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.sr_policy_entries is not None and self.sr_policy_entries.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.sr_policy_entries is not None and self.sr_policy_entries.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "auto-tunnel-services" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "sr-policy-entries"):
                if (self.sr_policy_entries is None):
                    self.sr_policy_entries = MplsTe.AutoTunnelServices.SrPolicyEntries()
                    self.sr_policy_entries.parent = self
                    self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
                return self.sr_policy_entries

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "sr-policy-entries"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AffinityMap(Entity):
        """
        Affinity name to value mapping
        
        .. attribute:: affinity_map_array
        
        	Affinity map array
        	**type**\: list of    :py:class:`AffinityMapArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap.AffinityMapArray>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.AffinityMap, self).__init__()

            self.yang_name = "affinity-map"
            self.yang_parent_name = "mpls-te"

            self.affinity_map_array = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.AffinityMap, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.AffinityMap, self).__setattr__(name, value)


        class AffinityMapArray(Entity):
            """
            Affinity map array
            
            .. attribute:: affinity_bit_position
            
            	Affinity bit position
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: affinity_extended_value
            
            	EAG value
            	**type**\: list of    :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue>`
            
            .. attribute:: affinity_name
            
            	Affinity name
            	**type**\:  str
            
            .. attribute:: affinity_table_id
            
            	Affinity table id
            	**type**\:   :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
            
            .. attribute:: affinity_value
            
            	Affinity value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.AffinityMap.AffinityMapArray, self).__init__()

                self.yang_name = "affinity-map-array"
                self.yang_parent_name = "affinity-map"

                self.affinity_bit_position = YLeaf(YType.uint8, "affinity-bit-position")

                self.affinity_name = YLeaf(YType.str, "affinity-name")

                self.affinity_table_id = YLeaf(YType.enumeration, "affinity-table-id")

                self.affinity_value = YLeaf(YType.uint32, "affinity-value")

                self.affinity_extended_value = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("affinity_bit_position",
                                "affinity_name",
                                "affinity_table_id",
                                "affinity_value") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.AffinityMap.AffinityMapArray, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.AffinityMap.AffinityMapArray, self).__setattr__(name, value)


            class AffinityExtendedValue(Entity):
                """
                EAG value
                
                .. attribute:: entry
                
                	
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__init__()

                    self.yang_name = "affinity-extended-value"
                    self.yang_parent_name = "affinity-map-array"

                    self.entry = YLeaf(YType.uint32, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "affinity-extended-value" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/affinity-map/affinity-map-array/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.affinity_extended_value:
                    if (c.has_data()):
                        return True
                return (
                    self.affinity_bit_position.is_set or
                    self.affinity_name.is_set or
                    self.affinity_table_id.is_set or
                    self.affinity_value.is_set)

            def has_operation(self):
                for c in self.affinity_extended_value:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.affinity_bit_position.yfilter != YFilter.not_set or
                    self.affinity_name.yfilter != YFilter.not_set or
                    self.affinity_table_id.yfilter != YFilter.not_set or
                    self.affinity_value.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "affinity-map-array" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/affinity-map/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.affinity_bit_position.is_set or self.affinity_bit_position.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_bit_position.get_name_leafdata())
                if (self.affinity_name.is_set or self.affinity_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_name.get_name_leafdata())
                if (self.affinity_table_id.is_set or self.affinity_table_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_table_id.get_name_leafdata())
                if (self.affinity_value.is_set or self.affinity_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_value.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "affinity-extended-value"):
                    for c in self.affinity_extended_value:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.affinity_extended_value.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "affinity-extended-value" or name == "affinity-bit-position" or name == "affinity-name" or name == "affinity-table-id" or name == "affinity-value"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "affinity-bit-position"):
                    self.affinity_bit_position = value
                    self.affinity_bit_position.value_namespace = name_space
                    self.affinity_bit_position.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-name"):
                    self.affinity_name = value
                    self.affinity_name.value_namespace = name_space
                    self.affinity_name.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-table-id"):
                    self.affinity_table_id = value
                    self.affinity_table_id.value_namespace = name_space
                    self.affinity_table_id.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-value"):
                    self.affinity_value = value
                    self.affinity_value.value_namespace = name_space
                    self.affinity_value.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.affinity_map_array:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.affinity_map_array:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "affinity-map" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "affinity-map-array"):
                for c in self.affinity_map_array:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.AffinityMap.AffinityMapArray()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.affinity_map_array.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "affinity-map-array"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TopologyBriefs(Entity):
        """
        MPLS\-TE topology brief table
        
        .. attribute:: topology_brief
        
        	A node in MPLS\-TE topoogy brief table
        	**type**\: list of    :py:class:`TopologyBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTe.TopologyBriefs, self).__init__()

            self.yang_name = "topology-briefs"
            self.yang_parent_name = "mpls-te"

            self.topology_brief = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTe.TopologyBriefs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTe.TopologyBriefs, self).__setattr__(name, value)


        class TopologyBrief(Entity):
            """
            A node in MPLS\-TE topoogy brief table
            
            .. attribute:: protocol  <key>
            
            	IGP protocol type
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: igp_id  <key>
            
            	IGP instance
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area  <key>
            
            	IGP area
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: topology_node_type  <key>
            
            	Node type
            	**type**\:   :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            .. attribute:: igp_node_id  <key>
            
            	IGP Node ID
            	**type**\:  str
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of    :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink>`
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\:  bool
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:   :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg>`
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTe.TopologyBriefs.TopologyBrief, self).__init__()

                self.yang_name = "topology-brief"
                self.yang_parent_name = "topology-briefs"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.igp_id = YLeaf(YType.str, "igp-id")

                self.area = YLeaf(YType.int32, "area")

                self.topology_node_type = YLeaf(YType.enumeration, "topology-node-type")

                self.igp_node_id = YLeaf(YType.str, "igp-node-id")

                self.topology_node_overloaded = YLeaf(YType.boolean, "topology-node-overloaded")

                self.topology_node_te_router_id = YLeaf(YType.str, "topology-node-te-router-id")

                self.topology_node_sid_and_srbg = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                self._children_yang_names.add("topology-node-sid-and-srbg")

                self.topology_node_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "igp_id",
                                "area",
                                "topology_node_type",
                                "igp_node_id",
                                "topology_node_overloaded",
                                "topology_node_te_router_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTe.TopologyBriefs.TopologyBrief, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTe.TopologyBriefs.TopologyBrief, self).__setattr__(name, value)


            class TopologyNodeSidAndSrbg(Entity):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-brief"

                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                    self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                    self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                    self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("segment_id",
                                    "segment_id_local_absolute_value",
                                    "srgb_size",
                                    "srgb_start") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.segment_id.is_set or
                        self.segment_id_local_absolute_value.is_set or
                        self.srgb_size.is_set or
                        self.srgb_start.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.segment_id.yfilter != YFilter.not_set or
                        self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                        self.srgb_size.yfilter != YFilter.not_set or
                        self.srgb_start.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-sid-and-srbg" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                    if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                    if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_size.get_name_leafdata())
                    if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_start.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "segment-id"):
                        self.segment_id = value
                        self.segment_id.value_namespace = name_space
                        self.segment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "segment-id-local-absolute-value"):
                        self.segment_id_local_absolute_value = value
                        self.segment_id_local_absolute_value.value_namespace = name_space
                        self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-size"):
                        self.srgb_size = value
                        self.srgb_size.value_namespace = name_space
                        self.srgb_size.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-start"):
                        self.srgb_start = value
                        self.srgb_start.value_namespace = name_space
                        self.srgb_start.value_namespace_prefix = name_space_prefix


            class TopologyNodeLink(Entity):
                """
                This node's link information
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of    :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid>`
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities>`
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup>`
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:   :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth>`
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:   :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of    :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\:  str
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-brief"

                    self.topology_link_affinity_bits = YLeaf(YType.uint32, "topology-link-affinity-bits")

                    self.topology_link_bandwidth_model = YLeaf(YType.enumeration, "topology-link-bandwidth-model")

                    self.topology_link_encoding = YLeaf(YType.uint8, "topology-link-encoding")

                    self.topology_link_fragment_id = YLeaf(YType.uint32, "topology-link-fragment-id")

                    self.topology_link_igp_metric = YLeaf(YType.uint32, "topology-link-igp-metric")

                    self.topology_link_interface_address = YLeaf(YType.str, "topology-link-interface-address")

                    self.topology_link_interface_id = YLeaf(YType.uint32, "topology-link-interface-id")

                    self.topology_link_neighbor_address = YLeaf(YType.str, "topology-link-neighbor-address")

                    self.topology_link_neighbor_generation = YLeaf(YType.uint32, "topology-link-neighbor-generation")

                    self.topology_link_neighbor_id = YLeaf(YType.uint32, "topology-link-neighbor-id")

                    self.topology_link_neighbor_node_id = YLeaf(YType.uint32, "topology-link-neighbor-node-id")

                    self.topology_link_neighbor_system_id = YLeaf(YType.str, "topology-link-neighbor-system-id")

                    self.topology_link_switching_capability = YLeaf(YType.uint8, "topology-link-switching-capability")

                    self.topology_link_te_metric = YLeaf(YType.uint32, "topology-link-te-metric")

                    self.topology_link_type = YLeaf(YType.enumeration, "topology-link-type")

                    self.topology_link_uni_delay = YLeaf(YType.uint32, "topology-link-uni-delay")

                    self.odu_link_capabilities = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.topology_link_bandwidth = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                    self._children_yang_names.add("topology-link-bandwidth")

                    self.adjacency_sid = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.topology_link_extended_affinity_bit = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("topology_link_affinity_bits",
                                    "topology_link_bandwidth_model",
                                    "topology_link_encoding",
                                    "topology_link_fragment_id",
                                    "topology_link_igp_metric",
                                    "topology_link_interface_address",
                                    "topology_link_interface_id",
                                    "topology_link_neighbor_address",
                                    "topology_link_neighbor_generation",
                                    "topology_link_neighbor_id",
                                    "topology_link_neighbor_node_id",
                                    "topology_link_neighbor_system_id",
                                    "topology_link_switching_capability",
                                    "topology_link_te_metric",
                                    "topology_link_type",
                                    "topology_link_uni_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__setattr__(name, value)


                class TopologyLinkBandwidth(Entity):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"

                        self.bandwidth_migration_mode = YLeaf(YType.enumeration, "bandwidth-migration-mode")

                        self.topology_link_bandwidth_prestandard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                        self._children_yang_names.add("topology-link-bandwidth-prestandard")

                        self.topology_link_bandwidth_standard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._children_yang_names.add("topology-link-bandwidth-standard")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_migration_mode") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)


                    class TopologyLinkBandwidthPrestandard(Entity):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topology_link_prestandard_bandwidth_physical = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-physical")

                            self.topology_link_prestandard_bandwidth_reservation_global = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-global")

                            self.topology_link_prestandard_bandwidth_reservation_subpool = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-subpool")

                            self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._children_yang_names.add("topology-link-prestandard-bandwidth-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topology_link_prestandard_bandwidth_physical",
                                            "topology_link_prestandard_bandwidth_reservation_global",
                                            "topology_link_prestandard_bandwidth_reservation_subpool") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)


                        class TopologyLinkPrestandardBandwidthDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(Entity):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(Entity):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(Entity):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-subpool" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topology-link-prestandard-bandwidth-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topology-link-prestandard-bandwidth-allocated"):
                                    for c in self.topology_link_prestandard_bandwidth_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_allocated.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-global"):
                                    for c in self.topology_link_prestandard_bandwidth_available_global:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_global.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_subpool.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topology-link-prestandard-bandwidth-allocated" or name == "topology-link-prestandard-bandwidth-available-global" or name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topology_link_prestandard_bandwidth_physical.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-prestandard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topology_link_prestandard_bandwidth_physical.is_set or self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_physical.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_global.is_set or self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_global.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_subpool.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topology-link-prestandard-bandwidth-detail"):
                                if (self.topology_link_prestandard_bandwidth_detail is None):
                                    self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                                    self.topology_link_prestandard_bandwidth_detail.parent = self
                                    self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                                return self.topology_link_prestandard_bandwidth_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topology-link-prestandard-bandwidth-detail" or name == "topology-link-prestandard-bandwidth-physical" or name == "topology-link-prestandard-bandwidth-reservation-global" or name == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topology-link-prestandard-bandwidth-physical"):
                                self.topology_link_prestandard_bandwidth_physical = value
                                self.topology_link_prestandard_bandwidth_physical.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-global"):
                                self.topology_link_prestandard_bandwidth_reservation_global = value
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                self.topology_link_prestandard_bandwidth_reservation_subpool = value
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace_prefix = name_space_prefix


                    class TopologyLinkBandwidthStandard(Entity):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topo_link_std_bw_physical = YLeaf(YType.uint32, "topo-link-std-bw-physical")

                            self.topo_link_std_bw_res_max = YLeaf(YType.uint32, "topo-link-std-bw-res-max")

                            self.topo_link_std_bw_res_pool0 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool0")

                            self.topo_link_std_bw_res_pool1 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool1")

                            self.topo_link_std_bw_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._children_yang_names.add("topo-link-std-bw-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topo_link_std_bw_physical",
                                            "topo_link_std_bw_res_max",
                                            "topo_link_std_bw_res_pool0",
                                            "topo_link_std_bw_res_pool1") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)


                        class TopoLinkStdBwDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)


                            class TopoLinkStdBwAllocated(Entity):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopoLinkStdBwAvailable(Entity):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-available" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topo-link-std-bw-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topo-link-std-bw-allocated"):
                                    for c in self.topo_link_std_bw_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_allocated.append(c)
                                    return c

                                if (child_yang_name == "topo-link-std-bw-available"):
                                    for c in self.topo_link_std_bw_available:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_available.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topo-link-std-bw-allocated" or name == "topo-link-std-bw-available"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topo_link_std_bw_physical.is_set or
                                self.topo_link_std_bw_res_max.is_set or
                                self.topo_link_std_bw_res_pool0.is_set or
                                self.topo_link_std_bw_res_pool1.is_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_physical.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_max.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-standard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topo_link_std_bw_physical.is_set or self.topo_link_std_bw_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_physical.get_name_leafdata())
                            if (self.topo_link_std_bw_res_max.is_set or self.topo_link_std_bw_res_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_max.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool0.is_set or self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool0.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool1.is_set or self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool1.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topo-link-std-bw-detail"):
                                if (self.topo_link_std_bw_detail is None):
                                    self.topo_link_std_bw_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                                    self.topo_link_std_bw_detail.parent = self
                                    self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                                return self.topo_link_std_bw_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topo-link-std-bw-detail" or name == "topo-link-std-bw-physical" or name == "topo-link-std-bw-res-max" or name == "topo-link-std-bw-res-pool0" or name == "topo-link-std-bw-res-pool1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topo-link-std-bw-physical"):
                                self.topo_link_std_bw_physical = value
                                self.topo_link_std_bw_physical.value_namespace = name_space
                                self.topo_link_std_bw_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-max"):
                                self.topo_link_std_bw_res_max = value
                                self.topo_link_std_bw_res_max.value_namespace = name_space
                                self.topo_link_std_bw_res_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool0"):
                                self.topo_link_std_bw_res_pool0 = value
                                self.topo_link_std_bw_res_pool0.value_namespace = name_space
                                self.topo_link_std_bw_res_pool0.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool1"):
                                self.topo_link_std_bw_res_pool1 = value
                                self.topo_link_std_bw_res_pool1.value_namespace = name_space
                                self.topo_link_std_bw_res_pool1.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.bandwidth_migration_mode.is_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_data()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_migration_mode.yfilter != YFilter.not_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_operation()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_migration_mode.is_set or self.bandwidth_migration_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_migration_mode.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "topology-link-bandwidth-prestandard"):
                            if (self.topology_link_bandwidth_prestandard is None):
                                self.topology_link_bandwidth_prestandard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                                self.topology_link_bandwidth_prestandard.parent = self
                                self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                            return self.topology_link_bandwidth_prestandard

                        if (child_yang_name == "topology-link-bandwidth-standard"):
                            if (self.topology_link_bandwidth_standard is None):
                                self.topology_link_bandwidth_standard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                                self.topology_link_bandwidth_standard.parent = self
                                self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                            return self.topology_link_bandwidth_standard

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "topology-link-bandwidth-prestandard" or name == "topology-link-bandwidth-standard" or name == "bandwidth-migration-mode"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-migration-mode"):
                            self.bandwidth_migration_mode = value
                            self.bandwidth_migration_mode.value_namespace = name_space
                            self.bandwidth_migration_mode.value_namespace_prefix = name_space_prefix


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TopologyLinkExtendedAffinityBit(Entity):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-extended-affinity-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class AdjacencySid(Entity):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\:  bool
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\:  bool
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\:  bool
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\:  bool
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\:  bool
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\:  str
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"

                        self.adjacency_sid = YLeaf(YType.uint32, "adjacency-sid")

                        self.flag_b = YLeaf(YType.boolean, "flag-b")

                        self.flag_f = YLeaf(YType.boolean, "flag-f")

                        self.flag_l = YLeaf(YType.boolean, "flag-l")

                        self.flag_s = YLeaf(YType.boolean, "flag-s")

                        self.flag_v = YLeaf(YType.boolean, "flag-v")

                        self.link_type = YLeaf(YType.enumeration, "link-type")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.nbr_node_igpid = YLeaf(YType.str, "nbr-node-igpid")

                        self.nbr_node_te_router_id = YLeaf(YType.str, "nbr-node-te-router-id")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("adjacency_sid",
                                        "flag_b",
                                        "flag_f",
                                        "flag_l",
                                        "flag_s",
                                        "flag_v",
                                        "link_type",
                                        "local_addr",
                                        "nbr_node_igpid",
                                        "nbr_node_te_router_id",
                                        "remote_addr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.adjacency_sid.is_set or
                            self.flag_b.is_set or
                            self.flag_f.is_set or
                            self.flag_l.is_set or
                            self.flag_s.is_set or
                            self.flag_v.is_set or
                            self.link_type.is_set or
                            self.local_addr.is_set or
                            self.nbr_node_igpid.is_set or
                            self.nbr_node_te_router_id.is_set or
                            self.remote_addr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.adjacency_sid.yfilter != YFilter.not_set or
                            self.flag_b.yfilter != YFilter.not_set or
                            self.flag_f.yfilter != YFilter.not_set or
                            self.flag_l.yfilter != YFilter.not_set or
                            self.flag_s.yfilter != YFilter.not_set or
                            self.flag_v.yfilter != YFilter.not_set or
                            self.link_type.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.nbr_node_igpid.yfilter != YFilter.not_set or
                            self.nbr_node_te_router_id.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "adjacency-sid" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.adjacency_sid.is_set or self.adjacency_sid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.adjacency_sid.get_name_leafdata())
                        if (self.flag_b.is_set or self.flag_b.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_b.get_name_leafdata())
                        if (self.flag_f.is_set or self.flag_f.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_f.get_name_leafdata())
                        if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_l.get_name_leafdata())
                        if (self.flag_s.is_set or self.flag_s.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_s.get_name_leafdata())
                        if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_v.get_name_leafdata())
                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_type.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.nbr_node_igpid.is_set or self.nbr_node_igpid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_igpid.get_name_leafdata())
                        if (self.nbr_node_te_router_id.is_set or self.nbr_node_te_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_te_router_id.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "adjacency-sid" or name == "flag-b" or name == "flag-f" or name == "flag-l" or name == "flag-s" or name == "flag-v" or name == "link-type" or name == "local-addr" or name == "nbr-node-igpid" or name == "nbr-node-te-router-id" or name == "remote-addr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "adjacency-sid"):
                            self.adjacency_sid = value
                            self.adjacency_sid.value_namespace = name_space
                            self.adjacency_sid.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-b"):
                            self.flag_b = value
                            self.flag_b.value_namespace = name_space
                            self.flag_b.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-f"):
                            self.flag_f = value
                            self.flag_f.value_namespace = name_space
                            self.flag_f.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-l"):
                            self.flag_l = value
                            self.flag_l.value_namespace = name_space
                            self.flag_l.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-s"):
                            self.flag_s = value
                            self.flag_s.value_namespace = name_space
                            self.flag_s.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-v"):
                            self.flag_v = value
                            self.flag_v.value_namespace = name_space
                            self.flag_v.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-type"):
                            self.link_type = value
                            self.link_type.value_namespace = name_space
                            self.link_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-igpid"):
                            self.nbr_node_igpid = value
                            self.nbr_node_igpid.value_namespace = name_space
                            self.nbr_node_igpid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-te-router-id"):
                            self.nbr_node_te_router_id = value
                            self.nbr_node_te_router_id.value_namespace = name_space
                            self.nbr_node_te_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.adjacency_sid:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_data()):
                            return True
                    return (
                        self.topology_link_affinity_bits.is_set or
                        self.topology_link_bandwidth_model.is_set or
                        self.topology_link_encoding.is_set or
                        self.topology_link_fragment_id.is_set or
                        self.topology_link_igp_metric.is_set or
                        self.topology_link_interface_address.is_set or
                        self.topology_link_interface_id.is_set or
                        self.topology_link_neighbor_address.is_set or
                        self.topology_link_neighbor_generation.is_set or
                        self.topology_link_neighbor_id.is_set or
                        self.topology_link_neighbor_node_id.is_set or
                        self.topology_link_neighbor_system_id.is_set or
                        self.topology_link_switching_capability.is_set or
                        self.topology_link_te_metric.is_set or
                        self.topology_link_type.is_set or
                        self.topology_link_uni_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.adjacency_sid:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.topology_link_affinity_bits.yfilter != YFilter.not_set or
                        self.topology_link_bandwidth_model.yfilter != YFilter.not_set or
                        self.topology_link_encoding.yfilter != YFilter.not_set or
                        self.topology_link_fragment_id.yfilter != YFilter.not_set or
                        self.topology_link_igp_metric.yfilter != YFilter.not_set or
                        self.topology_link_interface_address.yfilter != YFilter.not_set or
                        self.topology_link_interface_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_address.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_generation.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_node_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_system_id.yfilter != YFilter.not_set or
                        self.topology_link_switching_capability.yfilter != YFilter.not_set or
                        self.topology_link_te_metric.yfilter != YFilter.not_set or
                        self.topology_link_type.yfilter != YFilter.not_set or
                        self.topology_link_uni_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.topology_link_affinity_bits.is_set or self.topology_link_affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_affinity_bits.get_name_leafdata())
                    if (self.topology_link_bandwidth_model.is_set or self.topology_link_bandwidth_model.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_bandwidth_model.get_name_leafdata())
                    if (self.topology_link_encoding.is_set or self.topology_link_encoding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_encoding.get_name_leafdata())
                    if (self.topology_link_fragment_id.is_set or self.topology_link_fragment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_fragment_id.get_name_leafdata())
                    if (self.topology_link_igp_metric.is_set or self.topology_link_igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_igp_metric.get_name_leafdata())
                    if (self.topology_link_interface_address.is_set or self.topology_link_interface_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_address.get_name_leafdata())
                    if (self.topology_link_interface_id.is_set or self.topology_link_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_id.get_name_leafdata())
                    if (self.topology_link_neighbor_address.is_set or self.topology_link_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_address.get_name_leafdata())
                    if (self.topology_link_neighbor_generation.is_set or self.topology_link_neighbor_generation.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_generation.get_name_leafdata())
                    if (self.topology_link_neighbor_id.is_set or self.topology_link_neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_id.get_name_leafdata())
                    if (self.topology_link_neighbor_node_id.is_set or self.topology_link_neighbor_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_node_id.get_name_leafdata())
                    if (self.topology_link_neighbor_system_id.is_set or self.topology_link_neighbor_system_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_system_id.get_name_leafdata())
                    if (self.topology_link_switching_capability.is_set or self.topology_link_switching_capability.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_switching_capability.get_name_leafdata())
                    if (self.topology_link_te_metric.is_set or self.topology_link_te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_te_metric.get_name_leafdata())
                    if (self.topology_link_type.is_set or self.topology_link_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_type.get_name_leafdata())
                    if (self.topology_link_uni_delay.is_set or self.topology_link_uni_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_uni_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "adjacency-sid"):
                        for c in self.adjacency_sid:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.adjacency_sid.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "topology-link-bandwidth"):
                        if (self.topology_link_bandwidth is None):
                            self.topology_link_bandwidth = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                            self.topology_link_bandwidth.parent = self
                            self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                        return self.topology_link_bandwidth

                    if (child_yang_name == "topology-link-extended-affinity-bit"):
                        for c in self.topology_link_extended_affinity_bit:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.topology_link_extended_affinity_bit.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "adjacency-sid" or name == "odu-link-capabilities" or name == "shared-risk-link-group" or name == "topology-link-bandwidth" or name == "topology-link-extended-affinity-bit" or name == "topology-link-affinity-bits" or name == "topology-link-bandwidth-model" or name == "topology-link-encoding" or name == "topology-link-fragment-id" or name == "topology-link-igp-metric" or name == "topology-link-interface-address" or name == "topology-link-interface-id" or name == "topology-link-neighbor-address" or name == "topology-link-neighbor-generation" or name == "topology-link-neighbor-id" or name == "topology-link-neighbor-node-id" or name == "topology-link-neighbor-system-id" or name == "topology-link-switching-capability" or name == "topology-link-te-metric" or name == "topology-link-type" or name == "topology-link-uni-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "topology-link-affinity-bits"):
                        self.topology_link_affinity_bits = value
                        self.topology_link_affinity_bits.value_namespace = name_space
                        self.topology_link_affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-bandwidth-model"):
                        self.topology_link_bandwidth_model = value
                        self.topology_link_bandwidth_model.value_namespace = name_space
                        self.topology_link_bandwidth_model.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-encoding"):
                        self.topology_link_encoding = value
                        self.topology_link_encoding.value_namespace = name_space
                        self.topology_link_encoding.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-fragment-id"):
                        self.topology_link_fragment_id = value
                        self.topology_link_fragment_id.value_namespace = name_space
                        self.topology_link_fragment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-igp-metric"):
                        self.topology_link_igp_metric = value
                        self.topology_link_igp_metric.value_namespace = name_space
                        self.topology_link_igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-address"):
                        self.topology_link_interface_address = value
                        self.topology_link_interface_address.value_namespace = name_space
                        self.topology_link_interface_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-id"):
                        self.topology_link_interface_id = value
                        self.topology_link_interface_id.value_namespace = name_space
                        self.topology_link_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-address"):
                        self.topology_link_neighbor_address = value
                        self.topology_link_neighbor_address.value_namespace = name_space
                        self.topology_link_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-generation"):
                        self.topology_link_neighbor_generation = value
                        self.topology_link_neighbor_generation.value_namespace = name_space
                        self.topology_link_neighbor_generation.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-id"):
                        self.topology_link_neighbor_id = value
                        self.topology_link_neighbor_id.value_namespace = name_space
                        self.topology_link_neighbor_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-node-id"):
                        self.topology_link_neighbor_node_id = value
                        self.topology_link_neighbor_node_id.value_namespace = name_space
                        self.topology_link_neighbor_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-system-id"):
                        self.topology_link_neighbor_system_id = value
                        self.topology_link_neighbor_system_id.value_namespace = name_space
                        self.topology_link_neighbor_system_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-switching-capability"):
                        self.topology_link_switching_capability = value
                        self.topology_link_switching_capability.value_namespace = name_space
                        self.topology_link_switching_capability.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-te-metric"):
                        self.topology_link_te_metric = value
                        self.topology_link_te_metric.value_namespace = name_space
                        self.topology_link_te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-type"):
                        self.topology_link_type = value
                        self.topology_link_type.value_namespace = name_space
                        self.topology_link_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-uni-delay"):
                        self.topology_link_uni_delay = value
                        self.topology_link_uni_delay.value_namespace = name_space
                        self.topology_link_uni_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.topology_node_link:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.igp_id.is_set or
                    self.area.is_set or
                    self.topology_node_type.is_set or
                    self.igp_node_id.is_set or
                    self.topology_node_overloaded.is_set or
                    self.topology_node_te_router_id.is_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_data()))

            def has_operation(self):
                for c in self.topology_node_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.igp_id.yfilter != YFilter.not_set or
                    self.area.yfilter != YFilter.not_set or
                    self.topology_node_type.yfilter != YFilter.not_set or
                    self.igp_node_id.yfilter != YFilter.not_set or
                    self.topology_node_overloaded.yfilter != YFilter.not_set or
                    self.topology_node_te_router_id.yfilter != YFilter.not_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "topology-brief" + "[protocol='" + self.protocol.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + "[area='" + self.area.get() + "']" + "[topology-node-type='" + self.topology_node_type.get() + "']" + "[igp-node-id='" + self.igp_node_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology-briefs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_id.get_name_leafdata())
                if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area.get_name_leafdata())
                if (self.topology_node_type.is_set or self.topology_node_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_type.get_name_leafdata())
                if (self.igp_node_id.is_set or self.igp_node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_node_id.get_name_leafdata())
                if (self.topology_node_overloaded.is_set or self.topology_node_overloaded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_overloaded.get_name_leafdata())
                if (self.topology_node_te_router_id.is_set or self.topology_node_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_te_router_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "topology-node-link"):
                    for c in self.topology_node_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.topology_node_link.append(c)
                    return c

                if (child_yang_name == "topology-node-sid-and-srbg"):
                    if (self.topology_node_sid_and_srbg is None):
                        self.topology_node_sid_and_srbg = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                        self.topology_node_sid_and_srbg.parent = self
                        self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                    return self.topology_node_sid_and_srbg

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "topology-node-link" or name == "topology-node-sid-and-srbg" or name == "protocol" or name == "igp-id" or name == "area" or name == "topology-node-type" or name == "igp-node-id" or name == "topology-node-overloaded" or name == "topology-node-te-router-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-id"):
                    self.igp_id = value
                    self.igp_id.value_namespace = name_space
                    self.igp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "area"):
                    self.area = value
                    self.area.value_namespace = name_space
                    self.area.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-type"):
                    self.topology_node_type = value
                    self.topology_node_type.value_namespace = name_space
                    self.topology_node_type.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-node-id"):
                    self.igp_node_id = value
                    self.igp_node_id.value_namespace = name_space
                    self.igp_node_id.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-overloaded"):
                    self.topology_node_overloaded = value
                    self.topology_node_overloaded.value_namespace = name_space
                    self.topology_node_overloaded.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-te-router-id"):
                    self.topology_node_te_router_id = value
                    self.topology_node_te_router_id.value_namespace = name_space
                    self.topology_node_te_router_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.topology_brief:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.topology_brief:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology-briefs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "topology-brief"):
                for c in self.topology_brief:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTe.TopologyBriefs.TopologyBrief()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.topology_brief.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "topology-brief"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.affinity_map is not None and self.affinity_map.has_data()) or
            (self.announce_tunnels_info is not None and self.announce_tunnels_info.has_data()) or
            (self.attribute_sets is not None and self.attribute_sets.has_data()) or
            (self.auto_route_destination_entries is not None and self.auto_route_destination_entries.has_data()) or
            (self.auto_tunnel is not None and self.auto_tunnel.has_data()) or
            (self.auto_tunnel_services is not None and self.auto_tunnel_services.has_data()) or
            (self.bfd is not None and self.bfd.has_data()) or
            (self.collaborator_timers is not None and self.collaborator_timers.has_data()) or
            (self.diff_serv_te_classes is not None and self.diff_serv_te_classes.has_data()) or
            (self.fast_reroute is not None and self.fast_reroute.has_data()) or
            (self.fib_next_hop_label_routes is not None and self.fib_next_hop_label_routes.has_data()) or
            (self.fib_next_hop_routes is not None and self.fib_next_hop_routes.has_data()) or
            (self.forwarding_adjacency_destinations is not None and self.forwarding_adjacency_destinations.has_data()) or
            (self.hardware_out_of_resources is not None and self.hardware_out_of_resources.has_data()) or
            (self.igp_area_briefs is not None and self.igp_area_briefs.has_data()) or
            (self.igp_areas is not None and self.igp_areas.has_data()) or
            (self.issu is not None and self.issu.has_data()) or
            (self.lsp_out_of_resources is not None and self.lsp_out_of_resources.has_data()) or
            (self.maximum_tunnels is not None and self.maximum_tunnels.has_data()) or
            (self.next_hop_routes is not None and self.next_hop_routes.has_data()) or
            (self.nsr is not None and self.nsr.has_data()) or
            (self.open_config is not None and self.open_config.has_data()) or
            (self.p2mp is not None and self.p2mp.has_data()) or
            (self.p2p_p2mp_tunnel is not None and self.p2p_p2mp_tunnel.has_data()) or
            (self.path_protection is not None and self.path_protection.has_data()) or
            (self.segment_routing is not None and self.segment_routing.has_data()) or
            (self.signalling_counters is not None and self.signalling_counters.has_data()) or
            (self.soft_preemption is not None and self.soft_preemption.has_data()) or
            (self.te_mib is not None and self.te_mib.has_data()) or
            (self.topology is not None and self.topology.has_data()) or
            (self.topology_briefs is not None and self.topology_briefs.has_data()) or
            (self.topology_nodes is not None and self.topology_nodes.has_data()) or
            (self.tunnels is not None and self.tunnels.has_data()) or
            (self.wrap_protection is not None and self.wrap_protection.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.affinity_map is not None and self.affinity_map.has_operation()) or
            (self.announce_tunnels_info is not None and self.announce_tunnels_info.has_operation()) or
            (self.attribute_sets is not None and self.attribute_sets.has_operation()) or
            (self.auto_route_destination_entries is not None and self.auto_route_destination_entries.has_operation()) or
            (self.auto_tunnel is not None and self.auto_tunnel.has_operation()) or
            (self.auto_tunnel_services is not None and self.auto_tunnel_services.has_operation()) or
            (self.bfd is not None and self.bfd.has_operation()) or
            (self.collaborator_timers is not None and self.collaborator_timers.has_operation()) or
            (self.diff_serv_te_classes is not None and self.diff_serv_te_classes.has_operation()) or
            (self.fast_reroute is not None and self.fast_reroute.has_operation()) or
            (self.fib_next_hop_label_routes is not None and self.fib_next_hop_label_routes.has_operation()) or
            (self.fib_next_hop_routes is not None and self.fib_next_hop_routes.has_operation()) or
            (self.forwarding_adjacency_destinations is not None and self.forwarding_adjacency_destinations.has_operation()) or
            (self.hardware_out_of_resources is not None and self.hardware_out_of_resources.has_operation()) or
            (self.igp_area_briefs is not None and self.igp_area_briefs.has_operation()) or
            (self.igp_areas is not None and self.igp_areas.has_operation()) or
            (self.issu is not None and self.issu.has_operation()) or
            (self.lsp_out_of_resources is not None and self.lsp_out_of_resources.has_operation()) or
            (self.maximum_tunnels is not None and self.maximum_tunnels.has_operation()) or
            (self.next_hop_routes is not None and self.next_hop_routes.has_operation()) or
            (self.nsr is not None and self.nsr.has_operation()) or
            (self.open_config is not None and self.open_config.has_operation()) or
            (self.p2mp is not None and self.p2mp.has_operation()) or
            (self.p2p_p2mp_tunnel is not None and self.p2p_p2mp_tunnel.has_operation()) or
            (self.path_protection is not None and self.path_protection.has_operation()) or
            (self.segment_routing is not None and self.segment_routing.has_operation()) or
            (self.signalling_counters is not None and self.signalling_counters.has_operation()) or
            (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
            (self.te_mib is not None and self.te_mib.has_operation()) or
            (self.topology is not None and self.topology.has_operation()) or
            (self.topology_briefs is not None and self.topology_briefs.has_operation()) or
            (self.topology_nodes is not None and self.topology_nodes.has_operation()) or
            (self.tunnels is not None and self.tunnels.has_operation()) or
            (self.wrap_protection is not None and self.wrap_protection.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "affinity-map"):
            if (self.affinity_map is None):
                self.affinity_map = MplsTe.AffinityMap()
                self.affinity_map.parent = self
                self._children_name_map["affinity_map"] = "affinity-map"
            return self.affinity_map

        if (child_yang_name == "announce-tunnels-info"):
            if (self.announce_tunnels_info is None):
                self.announce_tunnels_info = MplsTe.AnnounceTunnelsInfo()
                self.announce_tunnels_info.parent = self
                self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"
            return self.announce_tunnels_info

        if (child_yang_name == "attribute-sets"):
            if (self.attribute_sets is None):
                self.attribute_sets = MplsTe.AttributeSets()
                self.attribute_sets.parent = self
                self._children_name_map["attribute_sets"] = "attribute-sets"
            return self.attribute_sets

        if (child_yang_name == "auto-route-destination-entries"):
            if (self.auto_route_destination_entries is None):
                self.auto_route_destination_entries = MplsTe.AutoRouteDestinationEntries()
                self.auto_route_destination_entries.parent = self
                self._children_name_map["auto_route_destination_entries"] = "auto-route-destination-entries"
            return self.auto_route_destination_entries

        if (child_yang_name == "auto-tunnel"):
            if (self.auto_tunnel is None):
                self.auto_tunnel = MplsTe.AutoTunnel()
                self.auto_tunnel.parent = self
                self._children_name_map["auto_tunnel"] = "auto-tunnel"
            return self.auto_tunnel

        if (child_yang_name == "auto-tunnel-services"):
            if (self.auto_tunnel_services is None):
                self.auto_tunnel_services = MplsTe.AutoTunnelServices()
                self.auto_tunnel_services.parent = self
                self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"
            return self.auto_tunnel_services

        if (child_yang_name == "bfd"):
            if (self.bfd is None):
                self.bfd = MplsTe.Bfd()
                self.bfd.parent = self
                self._children_name_map["bfd"] = "bfd"
            return self.bfd

        if (child_yang_name == "collaborator-timers"):
            if (self.collaborator_timers is None):
                self.collaborator_timers = MplsTe.CollaboratorTimers()
                self.collaborator_timers.parent = self
                self._children_name_map["collaborator_timers"] = "collaborator-timers"
            return self.collaborator_timers

        if (child_yang_name == "diff-serv-te-classes"):
            if (self.diff_serv_te_classes is None):
                self.diff_serv_te_classes = MplsTe.DiffServTeClasses()
                self.diff_serv_te_classes.parent = self
                self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"
            return self.diff_serv_te_classes

        if (child_yang_name == "fast-reroute"):
            if (self.fast_reroute is None):
                self.fast_reroute = MplsTe.FastReroute()
                self.fast_reroute.parent = self
                self._children_name_map["fast_reroute"] = "fast-reroute"
            return self.fast_reroute

        if (child_yang_name == "fib-next-hop-label-routes"):
            if (self.fib_next_hop_label_routes is None):
                self.fib_next_hop_label_routes = MplsTe.FibNextHopLabelRoutes()
                self.fib_next_hop_label_routes.parent = self
                self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"
            return self.fib_next_hop_label_routes

        if (child_yang_name == "fib-next-hop-routes"):
            if (self.fib_next_hop_routes is None):
                self.fib_next_hop_routes = MplsTe.FibNextHopRoutes()
                self.fib_next_hop_routes.parent = self
                self._children_name_map["fib_next_hop_routes"] = "fib-next-hop-routes"
            return self.fib_next_hop_routes

        if (child_yang_name == "forwarding-adjacency-destinations"):
            if (self.forwarding_adjacency_destinations is None):
                self.forwarding_adjacency_destinations = MplsTe.ForwardingAdjacencyDestinations()
                self.forwarding_adjacency_destinations.parent = self
                self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"
            return self.forwarding_adjacency_destinations

        if (child_yang_name == "hardware-out-of-resources"):
            if (self.hardware_out_of_resources is None):
                self.hardware_out_of_resources = MplsTe.HardwareOutOfResources()
                self.hardware_out_of_resources.parent = self
                self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"
            return self.hardware_out_of_resources

        if (child_yang_name == "igp-area-briefs"):
            if (self.igp_area_briefs is None):
                self.igp_area_briefs = MplsTe.IgpAreaBriefs()
                self.igp_area_briefs.parent = self
                self._children_name_map["igp_area_briefs"] = "igp-area-briefs"
            return self.igp_area_briefs

        if (child_yang_name == "igp-areas"):
            if (self.igp_areas is None):
                self.igp_areas = MplsTe.IgpAreas()
                self.igp_areas.parent = self
                self._children_name_map["igp_areas"] = "igp-areas"
            return self.igp_areas

        if (child_yang_name == "issu"):
            if (self.issu is None):
                self.issu = MplsTe.Issu()
                self.issu.parent = self
                self._children_name_map["issu"] = "issu"
            return self.issu

        if (child_yang_name == "lsp-out-of-resources"):
            if (self.lsp_out_of_resources is None):
                self.lsp_out_of_resources = MplsTe.LspOutOfResources()
                self.lsp_out_of_resources.parent = self
                self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"
            return self.lsp_out_of_resources

        if (child_yang_name == "maximum-tunnels"):
            if (self.maximum_tunnels is None):
                self.maximum_tunnels = MplsTe.MaximumTunnels()
                self.maximum_tunnels.parent = self
                self._children_name_map["maximum_tunnels"] = "maximum-tunnels"
            return self.maximum_tunnels

        if (child_yang_name == "next-hop-routes"):
            if (self.next_hop_routes is None):
                self.next_hop_routes = MplsTe.NextHopRoutes()
                self.next_hop_routes.parent = self
                self._children_name_map["next_hop_routes"] = "next-hop-routes"
            return self.next_hop_routes

        if (child_yang_name == "nsr"):
            if (self.nsr is None):
                self.nsr = MplsTe.Nsr()
                self.nsr.parent = self
                self._children_name_map["nsr"] = "nsr"
            return self.nsr

        if (child_yang_name == "open-config"):
            if (self.open_config is None):
                self.open_config = MplsTe.OpenConfig()
                self.open_config.parent = self
                self._children_name_map["open_config"] = "open-config"
            return self.open_config

        if (child_yang_name == "p2mp"):
            if (self.p2mp is None):
                self.p2mp = MplsTe.P2Mp()
                self.p2mp.parent = self
                self._children_name_map["p2mp"] = "p2mp"
            return self.p2mp

        if (child_yang_name == "p2p-p2mp-tunnel"):
            if (self.p2p_p2mp_tunnel is None):
                self.p2p_p2mp_tunnel = MplsTe.P2PP2MpTunnel()
                self.p2p_p2mp_tunnel.parent = self
                self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"
            return self.p2p_p2mp_tunnel

        if (child_yang_name == "path-protection"):
            if (self.path_protection is None):
                self.path_protection = MplsTe.PathProtection()
                self.path_protection.parent = self
                self._children_name_map["path_protection"] = "path-protection"
            return self.path_protection

        if (child_yang_name == "segment-routing"):
            if (self.segment_routing is None):
                self.segment_routing = MplsTe.SegmentRouting()
                self.segment_routing.parent = self
                self._children_name_map["segment_routing"] = "segment-routing"
            return self.segment_routing

        if (child_yang_name == "signalling-counters"):
            if (self.signalling_counters is None):
                self.signalling_counters = MplsTe.SignallingCounters()
                self.signalling_counters.parent = self
                self._children_name_map["signalling_counters"] = "signalling-counters"
            return self.signalling_counters

        if (child_yang_name == "soft-preemption"):
            if (self.soft_preemption is None):
                self.soft_preemption = MplsTe.SoftPreemption()
                self.soft_preemption.parent = self
                self._children_name_map["soft_preemption"] = "soft-preemption"
            return self.soft_preemption

        if (child_yang_name == "te-mib"):
            if (self.te_mib is None):
                self.te_mib = MplsTe.TeMib()
                self.te_mib.parent = self
                self._children_name_map["te_mib"] = "te-mib"
            return self.te_mib

        if (child_yang_name == "topology"):
            if (self.topology is None):
                self.topology = MplsTe.Topology()
                self.topology.parent = self
                self._children_name_map["topology"] = "topology"
            return self.topology

        if (child_yang_name == "topology-briefs"):
            if (self.topology_briefs is None):
                self.topology_briefs = MplsTe.TopologyBriefs()
                self.topology_briefs.parent = self
                self._children_name_map["topology_briefs"] = "topology-briefs"
            return self.topology_briefs

        if (child_yang_name == "topology-nodes"):
            if (self.topology_nodes is None):
                self.topology_nodes = MplsTe.TopologyNodes()
                self.topology_nodes.parent = self
                self._children_name_map["topology_nodes"] = "topology-nodes"
            return self.topology_nodes

        if (child_yang_name == "tunnels"):
            if (self.tunnels is None):
                self.tunnels = MplsTe.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
            return self.tunnels

        if (child_yang_name == "wrap-protection"):
            if (self.wrap_protection is None):
                self.wrap_protection = MplsTe.WrapProtection()
                self.wrap_protection.parent = self
                self._children_name_map["wrap_protection"] = "wrap-protection"
            return self.wrap_protection

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "affinity-map" or name == "announce-tunnels-info" or name == "attribute-sets" or name == "auto-route-destination-entries" or name == "auto-tunnel" or name == "auto-tunnel-services" or name == "bfd" or name == "collaborator-timers" or name == "diff-serv-te-classes" or name == "fast-reroute" or name == "fib-next-hop-label-routes" or name == "fib-next-hop-routes" or name == "forwarding-adjacency-destinations" or name == "hardware-out-of-resources" or name == "igp-area-briefs" or name == "igp-areas" or name == "issu" or name == "lsp-out-of-resources" or name == "maximum-tunnels" or name == "next-hop-routes" or name == "nsr" or name == "open-config" or name == "p2mp" or name == "p2p-p2mp-tunnel" or name == "path-protection" or name == "segment-routing" or name == "signalling-counters" or name == "soft-preemption" or name == "te-mib" or name == "topology" or name == "topology-briefs" or name == "topology-nodes" or name == "tunnels" or name == "wrap-protection"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsTe()
        return self._top_entity

class MplsLcacStandby(Entity):
    """
    mpls lcac standby
    
    .. attribute:: admission_control
    
    	The admission control information in MPLS\-LCAC
    	**type**\:   :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl>`
    
    .. attribute:: advertisements
    
    	The advertisement information in MPLS\-LCAC
    	**type**\:   :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements>`
    
    .. attribute:: bandwidth_account
    
    	The bandwidth accounting information in MPLS\-LCAC
    	**type**\:   :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount>`
    
    .. attribute:: bandwidth_allocation
    
    	The bandwidth allocation information in MPLS\-LCAC
    	**type**\:   :py:class:`BandwidthAllocation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation>`
    
    .. attribute:: bfd_neighbors
    
    	BFD Neighbors
    	**type**\:   :py:class:`BfdNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors>`
    
    .. attribute:: gmpls
    
    	GMPLS data
    	**type**\:   :py:class:`Gmpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls>`
    
    .. attribute:: link_information
    
    	The interface information in MPLS\-LCAC
    	**type**\:   :py:class:`LinkInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation>`
    
    .. attribute:: link_summary
    
    	The global summary for all the interfaces
    	**type**\:   :py:class:`LinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary>`
    
    .. attribute:: neighbors
    
    	The neighbor information for the local router
    	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors>`
    
    .. attribute:: preemption_events
    
    	Preemption event log in MPLS\-LCAC
    	**type**\:   :py:class:`PreemptionEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents>`
    
    .. attribute:: soft_preemption_global_info
    
    	The global soft\-preemption information
    	**type**\:   :py:class:`SoftPreemptionGlobalInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptionGlobalInfo>`
    
    .. attribute:: soft_preemptions
    
    	The soft preemption information for the TE\-links
    	**type**\:   :py:class:`SoftPreemptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions>`
    
    .. attribute:: statistics
    
    	The interface statistics information in MPLS\-LCAC
    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsLcacStandby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lcac-standby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.admission_control = MplsLcacStandby.AdmissionControl()
        self.admission_control.parent = self
        self._children_name_map["admission_control"] = "admission-control"
        self._children_yang_names.add("admission-control")

        self.advertisements = MplsLcacStandby.Advertisements()
        self.advertisements.parent = self
        self._children_name_map["advertisements"] = "advertisements"
        self._children_yang_names.add("advertisements")

        self.bandwidth_account = MplsLcacStandby.BandwidthAccount()
        self.bandwidth_account.parent = self
        self._children_name_map["bandwidth_account"] = "bandwidth-account"
        self._children_yang_names.add("bandwidth-account")

        self.bandwidth_allocation = MplsLcacStandby.BandwidthAllocation()
        self.bandwidth_allocation.parent = self
        self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"
        self._children_yang_names.add("bandwidth-allocation")

        self.bfd_neighbors = MplsLcacStandby.BfdNeighbors()
        self.bfd_neighbors.parent = self
        self._children_name_map["bfd_neighbors"] = "bfd-neighbors"
        self._children_yang_names.add("bfd-neighbors")

        self.gmpls = MplsLcacStandby.Gmpls()
        self.gmpls.parent = self
        self._children_name_map["gmpls"] = "gmpls"
        self._children_yang_names.add("gmpls")

        self.link_information = MplsLcacStandby.LinkInformation()
        self.link_information.parent = self
        self._children_name_map["link_information"] = "link-information"
        self._children_yang_names.add("link-information")

        self.link_summary = MplsLcacStandby.LinkSummary()
        self.link_summary.parent = self
        self._children_name_map["link_summary"] = "link-summary"
        self._children_yang_names.add("link-summary")

        self.neighbors = MplsLcacStandby.Neighbors()
        self.neighbors.parent = self
        self._children_name_map["neighbors"] = "neighbors"
        self._children_yang_names.add("neighbors")

        self.preemption_events = MplsLcacStandby.PreemptionEvents()
        self.preemption_events.parent = self
        self._children_name_map["preemption_events"] = "preemption-events"
        self._children_yang_names.add("preemption-events")

        self.soft_preemption_global_info = MplsLcacStandby.SoftPreemptionGlobalInfo()
        self.soft_preemption_global_info.parent = self
        self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"
        self._children_yang_names.add("soft-preemption-global-info")

        self.soft_preemptions = MplsLcacStandby.SoftPreemptions()
        self.soft_preemptions.parent = self
        self._children_name_map["soft_preemptions"] = "soft-preemptions"
        self._children_yang_names.add("soft-preemptions")

        self.statistics = MplsLcacStandby.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"
        self._children_yang_names.add("statistics")


    class Neighbors(Entity):
        """
        The neighbor information for the local router
        
        .. attribute:: neighbor
        
        	The neighbors connected to a particular interface
        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors.Neighbor>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.Neighbors, self).__init__()

            self.yang_name = "neighbors"
            self.yang_parent_name = "mpls-lcac-standby"

            self.neighbor = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.Neighbors, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.Neighbors, self).__setattr__(name, value)


        class Neighbor(Entity):
            """
            The neighbors connected to a particular
            interface
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors.Neighbor.Neighbor>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Neighbors.Neighbor, self).__init__()

                self.yang_name = "neighbor"
                self.yang_parent_name = "neighbors"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.neighbor = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.Neighbors.Neighbor, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.Neighbors.Neighbor, self).__setattr__(name, value)


            class Neighbor(Entity):
                """
                Neighbors of the specified link id
                
                .. attribute:: area_id
                
                	The area id
                	**type**\:  str
                
                .. attribute:: interface_name
                
                	The interface on which this neighbor is discovered
                	**type**\:  str
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: neighbor_id
                
                	The neighbor's id
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Neighbors.Neighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "neighbor"

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                    self.neighbor_id = YLeaf(YType.str, "neighbor-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_id",
                                    "interface_name",
                                    "neighbor_address",
                                    "neighbor_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Neighbors.Neighbor.Neighbor, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Neighbors.Neighbor.Neighbor, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.area_id.is_set or
                        self.interface_name.is_set or
                        self.neighbor_address.is_set or
                        self.neighbor_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.neighbor_address.yfilter != YFilter.not_set or
                        self.neighbor_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "neighbor" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                    if (self.neighbor_id.is_set or self.neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "area-id" or name == "interface-name" or name == "neighbor-address" or name == "neighbor-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-address"):
                        self.neighbor_address = value
                        self.neighbor_address.value_namespace = name_space
                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-id"):
                        self.neighbor_id = value
                        self.neighbor_id.value_namespace = name_space
                        self.neighbor_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.neighbor:
                    if (c.has_data()):
                        return True
                return self.interface_name.is_set

            def has_operation(self):
                for c in self.neighbor:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "neighbor" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/neighbors/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "neighbor"):
                    for c in self.neighbor:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.Neighbors.Neighbor.Neighbor()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.neighbor.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "neighbor" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.neighbor:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.neighbor:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "neighbors" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "neighbor"):
                for c in self.neighbor:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.Neighbors.Neighbor()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.neighbor.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "neighbor"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class PreemptionEvents(Entity):
        """
        Preemption event log in MPLS\-LCAC
        
        .. attribute:: preemption_event
        
        	Preemption event
        	**type**\: list of    :py:class:`PreemptionEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents.PreemptionEvent>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.PreemptionEvents, self).__init__()

            self.yang_name = "preemption-events"
            self.yang_parent_name = "mpls-lcac-standby"

            self.preemption_event = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.PreemptionEvents, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.PreemptionEvents, self).__setattr__(name, value)


        class PreemptionEvent(Entity):
            """
            Preemption event
            
            .. attribute:: event_index  <key>
            
            	Event index
            	**type**\:  int
            
            	**range:** 0..1999
            
            .. attribute:: bandwidth_overshoot0
            
            	BW Overshoot for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: bandwidth_overshoot1
            
            	BW Overshoot for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: bandwidth_type
            
            	The path's bandwidth type; 0\:CT0, 1\:CT1, so on
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: destination_address
            
            	Destination
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: event_time
            
            	Event time; seconds elapsed since January 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: hard_preempted_bandwidth_bc0
            
            	Amount of hard preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: hard_preempted_bandwidth_bc1
            
            	Amount of hard preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: hard_preempted_ls_ps
            
            	Number of LSPs hardly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: hard_preempted_tunnels
            
            	Number of Tunnels hardly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: hold_priority
            
            	The path's hold priority
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: interface_name
            
            	Interface name
            	**type**\:  str
            
            .. attribute:: ls_ps
            
            	Number of LSPs (not all may be present in the list)
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: lsp
            
            	List of preempted LSPs
            	**type**\: list of    :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp>`
            
            .. attribute:: lsp_id
            
            	LSP ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: new_bandwidth_bc0
            
            	New BW for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: new_bandwidth_bc1
            
            	New BW for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: old_bandwidth_bc0
            
            	Old BW for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: old_bandwidth_bc1
            
            	Old BW for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: requested_bandwidth
            
            	The path's requested bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: setup_priority
            
            	The path's setup priority
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc0
            
            	Amount of softly preempted FRR RW class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc1
            
            	Amount of softly preempted FRR RW class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: soft_preempted_ls_ps
            
            	Number of LSPs softly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_ls_ps_fr_rrewrite
            
            	Number of LSPs softly preempted with traffic switched to backup
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_tunnels
            
            	Number of Tunnels softly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_tunnels_fr_rrewrite
            
            	Number of Tunnels softly preempted with traffic switched to backup
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: softly_preempted_bandwidth_bc0
            
            	Amount of softly preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: softly_preempted_bandwidth_bc1
            
            	Amount of softly preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: source_address
            
            	Source
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: total_preempted_bandwidth_bc0
            
            	Total amount of preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_preempted_bandwidth_bc1
            
            	Total amount of preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: tunnel_id
            
            	Tunnel ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnels
            
            	Number of Tunnels
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.PreemptionEvents.PreemptionEvent, self).__init__()

                self.yang_name = "preemption-event"
                self.yang_parent_name = "preemption-events"

                self.event_index = YLeaf(YType.uint32, "event-index")

                self.bandwidth_overshoot0 = YLeaf(YType.uint64, "bandwidth-overshoot0")

                self.bandwidth_overshoot1 = YLeaf(YType.uint64, "bandwidth-overshoot1")

                self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.event_time = YLeaf(YType.uint32, "event-time")

                self.hard_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "hard-preempted-bandwidth-bc0")

                self.hard_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "hard-preempted-bandwidth-bc1")

                self.hard_preempted_ls_ps = YLeaf(YType.uint16, "hard-preempted-ls-ps")

                self.hard_preempted_tunnels = YLeaf(YType.uint16, "hard-preempted-tunnels")

                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.ls_ps = YLeaf(YType.uint16, "ls-ps")

                self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                self.new_bandwidth_bc0 = YLeaf(YType.uint64, "new-bandwidth-bc0")

                self.new_bandwidth_bc1 = YLeaf(YType.uint64, "new-bandwidth-bc1")

                self.old_bandwidth_bc0 = YLeaf(YType.uint64, "old-bandwidth-bc0")

                self.old_bandwidth_bc1 = YLeaf(YType.uint64, "old-bandwidth-bc1")

                self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                self.soft_preempted_fr_rrewrite_bandwidth_bc0 = YLeaf(YType.uint64, "soft-preempted-fr-rrewrite-bandwidth-bc0")

                self.soft_preempted_fr_rrewrite_bandwidth_bc1 = YLeaf(YType.uint64, "soft-preempted-fr-rrewrite-bandwidth-bc1")

                self.soft_preempted_ls_ps = YLeaf(YType.uint16, "soft-preempted-ls-ps")

                self.soft_preempted_ls_ps_fr_rrewrite = YLeaf(YType.uint16, "soft-preempted-ls-ps-fr-rrewrite")

                self.soft_preempted_tunnels = YLeaf(YType.uint16, "soft-preempted-tunnels")

                self.soft_preempted_tunnels_fr_rrewrite = YLeaf(YType.uint16, "soft-preempted-tunnels-fr-rrewrite")

                self.softly_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "softly-preempted-bandwidth-bc0")

                self.softly_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "softly-preempted-bandwidth-bc1")

                self.source_address = YLeaf(YType.str, "source-address")

                self.total_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "total-preempted-bandwidth-bc0")

                self.total_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "total-preempted-bandwidth-bc1")

                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                self.tunnels = YLeaf(YType.uint16, "tunnels")

                self.lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("event_index",
                                "bandwidth_overshoot0",
                                "bandwidth_overshoot1",
                                "bandwidth_type",
                                "destination_address",
                                "event_time",
                                "hard_preempted_bandwidth_bc0",
                                "hard_preempted_bandwidth_bc1",
                                "hard_preempted_ls_ps",
                                "hard_preempted_tunnels",
                                "hold_priority",
                                "interface_name",
                                "ls_ps",
                                "lsp_id",
                                "new_bandwidth_bc0",
                                "new_bandwidth_bc1",
                                "old_bandwidth_bc0",
                                "old_bandwidth_bc1",
                                "requested_bandwidth",
                                "setup_priority",
                                "soft_preempted_fr_rrewrite_bandwidth_bc0",
                                "soft_preempted_fr_rrewrite_bandwidth_bc1",
                                "soft_preempted_ls_ps",
                                "soft_preempted_ls_ps_fr_rrewrite",
                                "soft_preempted_tunnels",
                                "soft_preempted_tunnels_fr_rrewrite",
                                "softly_preempted_bandwidth_bc0",
                                "softly_preempted_bandwidth_bc1",
                                "source_address",
                                "total_preempted_bandwidth_bc0",
                                "total_preempted_bandwidth_bc1",
                                "tunnel_id",
                                "tunnels") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.PreemptionEvents.PreemptionEvent, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.PreemptionEvents.PreemptionEvent, self).__setattr__(name, value)


            class Lsp(Entity):
                """
                List of preempted LSPs
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\:  bool
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\:  int
                
                	**range:** 0..65535
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp, self).__init__()

                    self.yang_name = "lsp"
                    self.yang_parent_name = "preemption-event"

                    self.bandwidth_preempted = YLeaf(YType.boolean, "bandwidth-preempted")

                    self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.soft_preempted = YLeaf(YType.boolean, "soft-preempted")

                    self.soft_preempted_fr_rrewrite = YLeaf(YType.boolean, "soft-preempted-fr-rrewrite")

                    self.soft_preemption_timeout = YLeaf(YType.uint16, "soft-preemption-timeout")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bandwidth_preempted",
                                    "bandwidth_type",
                                    "destination_address",
                                    "hold_priority",
                                    "lsp_id",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "soft_preempted",
                                    "soft_preempted_fr_rrewrite",
                                    "soft_preemption_timeout",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.bandwidth_preempted.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address.is_set or
                        self.hold_priority.is_set or
                        self.lsp_id.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.soft_preempted.is_set or
                        self.soft_preempted_fr_rrewrite.is_set or
                        self.soft_preemption_timeout.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bandwidth_preempted.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.soft_preempted.yfilter != YFilter.not_set or
                        self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set or
                        self.soft_preemption_timeout.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bandwidth_preempted.is_set or self.bandwidth_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_preempted.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.soft_preempted.is_set or self.soft_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted.get_name_leafdata())
                    if (self.soft_preempted_fr_rrewrite.is_set or self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_fr_rrewrite.get_name_leafdata())
                    if (self.soft_preemption_timeout.is_set or self.soft_preemption_timeout.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption_timeout.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bandwidth-preempted" or name == "bandwidth-type" or name == "destination-address" or name == "hold-priority" or name == "lsp-id" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted" or name == "soft-preempted-fr-rrewrite" or name == "soft-preemption-timeout" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bandwidth-preempted"):
                        self.bandwidth_preempted = value
                        self.bandwidth_preempted.value_namespace = name_space
                        self.bandwidth_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted"):
                        self.soft_preempted = value
                        self.soft_preempted.value_namespace = name_space
                        self.soft_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-fr-rrewrite"):
                        self.soft_preempted_fr_rrewrite = value
                        self.soft_preempted_fr_rrewrite.value_namespace = name_space
                        self.soft_preempted_fr_rrewrite.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption-timeout"):
                        self.soft_preemption_timeout = value
                        self.soft_preemption_timeout.value_namespace = name_space
                        self.soft_preemption_timeout.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp:
                    if (c.has_data()):
                        return True
                return (
                    self.event_index.is_set or
                    self.bandwidth_overshoot0.is_set or
                    self.bandwidth_overshoot1.is_set or
                    self.bandwidth_type.is_set or
                    self.destination_address.is_set or
                    self.event_time.is_set or
                    self.hard_preempted_bandwidth_bc0.is_set or
                    self.hard_preempted_bandwidth_bc1.is_set or
                    self.hard_preempted_ls_ps.is_set or
                    self.hard_preempted_tunnels.is_set or
                    self.hold_priority.is_set or
                    self.interface_name.is_set or
                    self.ls_ps.is_set or
                    self.lsp_id.is_set or
                    self.new_bandwidth_bc0.is_set or
                    self.new_bandwidth_bc1.is_set or
                    self.old_bandwidth_bc0.is_set or
                    self.old_bandwidth_bc1.is_set or
                    self.requested_bandwidth.is_set or
                    self.setup_priority.is_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.is_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.is_set or
                    self.soft_preempted_ls_ps.is_set or
                    self.soft_preempted_ls_ps_fr_rrewrite.is_set or
                    self.soft_preempted_tunnels.is_set or
                    self.soft_preempted_tunnels_fr_rrewrite.is_set or
                    self.softly_preempted_bandwidth_bc0.is_set or
                    self.softly_preempted_bandwidth_bc1.is_set or
                    self.source_address.is_set or
                    self.total_preempted_bandwidth_bc0.is_set or
                    self.total_preempted_bandwidth_bc1.is_set or
                    self.tunnel_id.is_set or
                    self.tunnels.is_set)

            def has_operation(self):
                for c in self.lsp:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.event_index.yfilter != YFilter.not_set or
                    self.bandwidth_overshoot0.yfilter != YFilter.not_set or
                    self.bandwidth_overshoot1.yfilter != YFilter.not_set or
                    self.bandwidth_type.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.event_time.yfilter != YFilter.not_set or
                    self.hard_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.hard_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.hard_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.hard_preempted_tunnels.yfilter != YFilter.not_set or
                    self.hold_priority.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    self.ls_ps.yfilter != YFilter.not_set or
                    self.lsp_id.yfilter != YFilter.not_set or
                    self.new_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.new_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.old_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.old_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.requested_bandwidth.yfilter != YFilter.not_set or
                    self.setup_priority.yfilter != YFilter.not_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps_fr_rrewrite.yfilter != YFilter.not_set or
                    self.soft_preempted_tunnels.yfilter != YFilter.not_set or
                    self.soft_preempted_tunnels_fr_rrewrite.yfilter != YFilter.not_set or
                    self.softly_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.softly_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.total_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.total_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.tunnel_id.yfilter != YFilter.not_set or
                    self.tunnels.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "preemption-event" + "[event-index='" + self.event_index.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/preemption-events/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.event_index.is_set or self.event_index.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.event_index.get_name_leafdata())
                if (self.bandwidth_overshoot0.is_set or self.bandwidth_overshoot0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_overshoot0.get_name_leafdata())
                if (self.bandwidth_overshoot1.is_set or self.bandwidth_overshoot1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_overshoot1.get_name_leafdata())
                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.event_time.is_set or self.event_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.event_time.get_name_leafdata())
                if (self.hard_preempted_bandwidth_bc0.is_set or self.hard_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.hard_preempted_bandwidth_bc1.is_set or self.hard_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.hard_preempted_ls_ps.is_set or self.hard_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_ls_ps.get_name_leafdata())
                if (self.hard_preempted_tunnels.is_set or self.hard_preempted_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_tunnels.get_name_leafdata())
                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ls_ps.get_name_leafdata())
                if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_id.get_name_leafdata())
                if (self.new_bandwidth_bc0.is_set or self.new_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.new_bandwidth_bc0.get_name_leafdata())
                if (self.new_bandwidth_bc1.is_set or self.new_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.new_bandwidth_bc1.get_name_leafdata())
                if (self.old_bandwidth_bc0.is_set or self.old_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.old_bandwidth_bc0.get_name_leafdata())
                if (self.old_bandwidth_bc1.is_set or self.old_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.old_bandwidth_bc1.get_name_leafdata())
                if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                if (self.soft_preempted_fr_rrewrite_bandwidth_bc0.is_set or self.soft_preempted_fr_rrewrite_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_fr_rrewrite_bandwidth_bc0.get_name_leafdata())
                if (self.soft_preempted_fr_rrewrite_bandwidth_bc1.is_set or self.soft_preempted_fr_rrewrite_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_fr_rrewrite_bandwidth_bc1.get_name_leafdata())
                if (self.soft_preempted_ls_ps.is_set or self.soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preempted_ls_ps_fr_rrewrite.is_set or self.soft_preempted_ls_ps_fr_rrewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps_fr_rrewrite.get_name_leafdata())
                if (self.soft_preempted_tunnels.is_set or self.soft_preempted_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_tunnels.get_name_leafdata())
                if (self.soft_preempted_tunnels_fr_rrewrite.is_set or self.soft_preempted_tunnels_fr_rrewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_tunnels_fr_rrewrite.get_name_leafdata())
                if (self.softly_preempted_bandwidth_bc0.is_set or self.softly_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.softly_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.softly_preempted_bandwidth_bc1.is_set or self.softly_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.softly_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.total_preempted_bandwidth_bc0.is_set or self.total_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.total_preempted_bandwidth_bc1.is_set or self.total_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                if (self.tunnels.is_set or self.tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnels.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp"):
                    for c in self.lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp" or name == "event-index" or name == "bandwidth-overshoot0" or name == "bandwidth-overshoot1" or name == "bandwidth-type" or name == "destination-address" or name == "event-time" or name == "hard-preempted-bandwidth-bc0" or name == "hard-preempted-bandwidth-bc1" or name == "hard-preempted-ls-ps" or name == "hard-preempted-tunnels" or name == "hold-priority" or name == "interface-name" or name == "ls-ps" or name == "lsp-id" or name == "new-bandwidth-bc0" or name == "new-bandwidth-bc1" or name == "old-bandwidth-bc0" or name == "old-bandwidth-bc1" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted-fr-rrewrite-bandwidth-bc0" or name == "soft-preempted-fr-rrewrite-bandwidth-bc1" or name == "soft-preempted-ls-ps" or name == "soft-preempted-ls-ps-fr-rrewrite" or name == "soft-preempted-tunnels" or name == "soft-preempted-tunnels-fr-rrewrite" or name == "softly-preempted-bandwidth-bc0" or name == "softly-preempted-bandwidth-bc1" or name == "source-address" or name == "total-preempted-bandwidth-bc0" or name == "total-preempted-bandwidth-bc1" or name == "tunnel-id" or name == "tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "event-index"):
                    self.event_index = value
                    self.event_index.value_namespace = name_space
                    self.event_index.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-overshoot0"):
                    self.bandwidth_overshoot0 = value
                    self.bandwidth_overshoot0.value_namespace = name_space
                    self.bandwidth_overshoot0.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-overshoot1"):
                    self.bandwidth_overshoot1 = value
                    self.bandwidth_overshoot1.value_namespace = name_space
                    self.bandwidth_overshoot1.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-type"):
                    self.bandwidth_type = value
                    self.bandwidth_type.value_namespace = name_space
                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "event-time"):
                    self.event_time = value
                    self.event_time.value_namespace = name_space
                    self.event_time.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-bandwidth-bc0"):
                    self.hard_preempted_bandwidth_bc0 = value
                    self.hard_preempted_bandwidth_bc0.value_namespace = name_space
                    self.hard_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-bandwidth-bc1"):
                    self.hard_preempted_bandwidth_bc1 = value
                    self.hard_preempted_bandwidth_bc1.value_namespace = name_space
                    self.hard_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-ls-ps"):
                    self.hard_preempted_ls_ps = value
                    self.hard_preempted_ls_ps.value_namespace = name_space
                    self.hard_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-tunnels"):
                    self.hard_preempted_tunnels = value
                    self.hard_preempted_tunnels.value_namespace = name_space
                    self.hard_preempted_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "hold-priority"):
                    self.hold_priority = value
                    self.hold_priority.value_namespace = name_space
                    self.hold_priority.value_namespace_prefix = name_space_prefix
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix
                if(value_path == "ls-ps"):
                    self.ls_ps = value
                    self.ls_ps.value_namespace = name_space
                    self.ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-id"):
                    self.lsp_id = value
                    self.lsp_id.value_namespace = name_space
                    self.lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "new-bandwidth-bc0"):
                    self.new_bandwidth_bc0 = value
                    self.new_bandwidth_bc0.value_namespace = name_space
                    self.new_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "new-bandwidth-bc1"):
                    self.new_bandwidth_bc1 = value
                    self.new_bandwidth_bc1.value_namespace = name_space
                    self.new_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "old-bandwidth-bc0"):
                    self.old_bandwidth_bc0 = value
                    self.old_bandwidth_bc0.value_namespace = name_space
                    self.old_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "old-bandwidth-bc1"):
                    self.old_bandwidth_bc1 = value
                    self.old_bandwidth_bc1.value_namespace = name_space
                    self.old_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "requested-bandwidth"):
                    self.requested_bandwidth = value
                    self.requested_bandwidth.value_namespace = name_space
                    self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                if(value_path == "setup-priority"):
                    self.setup_priority = value
                    self.setup_priority.value_namespace = name_space
                    self.setup_priority.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-fr-rrewrite-bandwidth-bc0"):
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0 = value
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.value_namespace = name_space
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-fr-rrewrite-bandwidth-bc1"):
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1 = value
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.value_namespace = name_space
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps"):
                    self.soft_preempted_ls_ps = value
                    self.soft_preempted_ls_ps.value_namespace = name_space
                    self.soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps-fr-rrewrite"):
                    self.soft_preempted_ls_ps_fr_rrewrite = value
                    self.soft_preempted_ls_ps_fr_rrewrite.value_namespace = name_space
                    self.soft_preempted_ls_ps_fr_rrewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-tunnels"):
                    self.soft_preempted_tunnels = value
                    self.soft_preempted_tunnels.value_namespace = name_space
                    self.soft_preempted_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-tunnels-fr-rrewrite"):
                    self.soft_preempted_tunnels_fr_rrewrite = value
                    self.soft_preempted_tunnels_fr_rrewrite.value_namespace = name_space
                    self.soft_preempted_tunnels_fr_rrewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "softly-preempted-bandwidth-bc0"):
                    self.softly_preempted_bandwidth_bc0 = value
                    self.softly_preempted_bandwidth_bc0.value_namespace = name_space
                    self.softly_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "softly-preempted-bandwidth-bc1"):
                    self.softly_preempted_bandwidth_bc1 = value
                    self.softly_preempted_bandwidth_bc1.value_namespace = name_space
                    self.softly_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "total-preempted-bandwidth-bc0"):
                    self.total_preempted_bandwidth_bc0 = value
                    self.total_preempted_bandwidth_bc0.value_namespace = name_space
                    self.total_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "total-preempted-bandwidth-bc1"):
                    self.total_preempted_bandwidth_bc1 = value
                    self.total_preempted_bandwidth_bc1.value_namespace = name_space
                    self.total_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-id"):
                    self.tunnel_id = value
                    self.tunnel_id.value_namespace = name_space
                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnels"):
                    self.tunnels = value
                    self.tunnels.value_namespace = name_space
                    self.tunnels.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.preemption_event:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.preemption_event:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "preemption-events" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "preemption-event"):
                for c in self.preemption_event:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.PreemptionEvents.PreemptionEvent()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.preemption_event.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "preemption-event"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Advertisements(Entity):
        """
        The advertisement information in MPLS\-LCAC
        
        .. attribute:: advertized_areas
        
        	Advertising info for all the IGP areas
        	**type**\: list of    :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas>`
        
        .. attribute:: ds_te_mode
        
        	DS\-TE Mode
        	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
        
        .. attribute:: flooding_status_message
        
        	Flooding status\: ready or reason
        	**type**\:  str
        
        .. attribute:: last_flooding_time
        
        	Time elapsed since last flooding in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        .. attribute:: last_flooding_trigger
        
        	Trigger for last flooding
        	**type**\:   :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
        
        .. attribute:: next_flooding_time
        
        	Time remained for next flooding in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.Advertisements, self).__init__()

            self.yang_name = "advertisements"
            self.yang_parent_name = "mpls-lcac-standby"

            self.ds_te_mode = YLeaf(YType.enumeration, "ds-te-mode")

            self.flooding_status_message = YLeaf(YType.str, "flooding-status-message")

            self.last_flooding_time = YLeaf(YType.uint32, "last-flooding-time")

            self.last_flooding_trigger = YLeaf(YType.enumeration, "last-flooding-trigger")

            self.next_flooding_time = YLeaf(YType.uint32, "next-flooding-time")

            self.advertized_areas = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("ds_te_mode",
                            "flooding_status_message",
                            "last_flooding_time",
                            "last_flooding_trigger",
                            "next_flooding_time") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.Advertisements, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.Advertisements, self).__setattr__(name, value)


        class AdvertizedAreas(Entity):
            """
            Advertising info for all the IGP areas
            
            .. attribute:: flooded_link
            
            	The array of flooded links in this area
            	**type**\: list of    :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink>`
            
            .. attribute:: igp_area_id
            
            	The area id
            	**type**\:  str
            
            .. attribute:: protocol
            
            	The IGP protocol running over this area
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: router_id
            
            	The node's router ID
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: system_id
            
            	The node's system id
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Advertisements.AdvertizedAreas, self).__init__()

                self.yang_name = "advertized-areas"
                self.yang_parent_name = "advertisements"

                self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.router_id = YLeaf(YType.str, "router-id")

                self.system_id = YLeaf(YType.str, "system-id")

                self.flooded_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("igp_area_id",
                                "protocol",
                                "router_id",
                                "system_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas, self).__setattr__(name, value)


            class FloodedLink(Entity):
                """
                The array of flooded links in this area
                
                .. attribute:: affinity_attribute_flags
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_units
                
                	The link's bandwidth units
                	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                .. attribute:: bcm_id
                
                	Bandwidth Constraints Model ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: designated_router_igp_id
                
                	IGP id of the designated router
                	**type**\:  str
                
                .. attribute:: extended_affinity_attribute_flag
                
                	The link's extended affinity bits
                	**type**\: list of    :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                
                .. attribute:: igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_neighbor_address
                
                	The neighbor's ip address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: incoming_interface_id
                
                	The link's incoming interface's id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface_name
                
                	The link's interface name
                	**type**\:  str
                
                .. attribute:: is_designated_router
                
                	TRUE if the link belongs to a desig. router
                	**type**\:  bool
                
                .. attribute:: is_receiving_reservable_bandwidth_enabled
                
                	TRUE if receiving reservable BW is enabled
                	**type**\:  bool
                
                .. attribute:: is_transmitting_reservable_bandwidth_enabled
                
                	TRUE if transmitting reservable BW is enabled
                	**type**\:  bool
                
                .. attribute:: link_address
                
                	The link's IPv4 address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: link_id
                
                	The link's id
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: link_maximum_reservable_bandwidth
                
                	The link's maximum reservable BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: neighbor_igp_id
                
                	The neighbor's IGP id
                	**type**\:  str
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                
                .. attribute:: outgoing_interface_id
                
                	The link's outgoing interface's id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: physical_bandwidth
                
                	The link's physical BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: receiving_direction
                
                	Upstream or Downstream
                	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                .. attribute:: receiving_reservable_bandwidth
                
                	Receiving reservable BW at each priority level(priority 0 to priority 7)
                	**type**\: list of    :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                
                .. attribute:: reservable_pool0_bandwidth
                
                	The link's reservable pool0 BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: reservable_pool1_bandwidth
                
                	The link's reservable pool1 BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                
                .. attribute:: subnet_type
                
                	The link's subnet type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transmitting_direction
                
                	Upstream or Downstream
                	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                .. attribute:: transmitting_reservable_bandwidth
                
                	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                	**type**\: list of    :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                
                .. attribute:: uni_link_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                    self.yang_name = "flooded-link"
                    self.yang_parent_name = "advertized-areas"

                    self.affinity_attribute_flags = YLeaf(YType.uint32, "affinity-attribute-flags")

                    self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                    self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                    self.designated_router_igp_id = YLeaf(YType.str, "designated-router-igp-id")

                    self.igp_metric = YLeaf(YType.uint32, "igp-metric")

                    self.igp_neighbor_address = YLeaf(YType.str, "igp-neighbor-address")

                    self.incoming_interface_id = YLeaf(YType.uint32, "incoming-interface-id")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                    self.is_receiving_reservable_bandwidth_enabled = YLeaf(YType.boolean, "is-receiving-reservable-bandwidth-enabled")

                    self.is_transmitting_reservable_bandwidth_enabled = YLeaf(YType.boolean, "is-transmitting-reservable-bandwidth-enabled")

                    self.link_address = YLeaf(YType.str, "link-address")

                    self.link_id = YLeaf(YType.uint16, "link-id")

                    self.link_maximum_reservable_bandwidth = YLeaf(YType.uint32, "link-maximum-reservable-bandwidth")

                    self.neighbor_igp_id = YLeaf(YType.str, "neighbor-igp-id")

                    self.outgoing_interface_id = YLeaf(YType.uint32, "outgoing-interface-id")

                    self.physical_bandwidth = YLeaf(YType.uint32, "physical-bandwidth")

                    self.receiving_direction = YLeaf(YType.enumeration, "receiving-direction")

                    self.reservable_pool0_bandwidth = YLeaf(YType.uint32, "reservable-pool0-bandwidth")

                    self.reservable_pool1_bandwidth = YLeaf(YType.uint32, "reservable-pool1-bandwidth")

                    self.subnet_type = YLeaf(YType.enumeration, "subnet-type")

                    self.te_metric = YLeaf(YType.uint32, "te-metric")

                    self.transmitting_direction = YLeaf(YType.enumeration, "transmitting-direction")

                    self.uni_link_delay = YLeaf(YType.uint32, "uni-link-delay")

                    self.odu_link_capabilities = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.extended_affinity_attribute_flag = YList(self)
                    self.receiving_reservable_bandwidth = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.transmitting_reservable_bandwidth = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("affinity_attribute_flags",
                                    "bandwidth_units",
                                    "bcm_id",
                                    "designated_router_igp_id",
                                    "igp_metric",
                                    "igp_neighbor_address",
                                    "incoming_interface_id",
                                    "interface_name",
                                    "is_designated_router",
                                    "is_receiving_reservable_bandwidth_enabled",
                                    "is_transmitting_reservable_bandwidth_enabled",
                                    "link_address",
                                    "link_id",
                                    "link_maximum_reservable_bandwidth",
                                    "neighbor_igp_id",
                                    "outgoing_interface_id",
                                    "physical_bandwidth",
                                    "receiving_direction",
                                    "reservable_pool0_bandwidth",
                                    "reservable_pool1_bandwidth",
                                    "subnet_type",
                                    "te_metric",
                                    "transmitting_direction",
                                    "uni_link_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink, self).__setattr__(name, value)


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "flooded-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ExtendedAffinityAttributeFlag(Entity):
                    """
                    The link's extended affinity bits
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                        self.yang_name = "extended-affinity-attribute-flag"
                        self.yang_parent_name = "flooded-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "extended-affinity-attribute-flag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "flooded-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class ReceivingReservableBandwidth(Entity):
                    """
                    Receiving reservable BW at each priority
                    level(priority 0 to priority 7)
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                        self.yang_name = "receiving-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"

                        self.pool0_bandwidth = YLeaf(YType.uint32, "pool0-bandwidth")

                        self.pool1_bandwidth = YLeaf(YType.uint32, "pool1-bandwidth")

                        self.priority = YLeaf(YType.uint8, "priority")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("pool0_bandwidth",
                                        "pool1_bandwidth",
                                        "priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.pool0_bandwidth.is_set or
                            self.pool1_bandwidth.is_set or
                            self.priority.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.pool0_bandwidth.yfilter != YFilter.not_set or
                            self.pool1_bandwidth.yfilter != YFilter.not_set or
                            self.priority.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "receiving-reservable-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.pool0_bandwidth.is_set or self.pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool0_bandwidth.get_name_leafdata())
                        if (self.pool1_bandwidth.is_set or self.pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool1_bandwidth.get_name_leafdata())
                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "pool0-bandwidth" or name == "pool1-bandwidth" or name == "priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "pool0-bandwidth"):
                            self.pool0_bandwidth = value
                            self.pool0_bandwidth.value_namespace = name_space
                            self.pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "pool1-bandwidth"):
                            self.pool1_bandwidth = value
                            self.pool1_bandwidth.value_namespace = name_space
                            self.pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority"):
                            self.priority = value
                            self.priority.value_namespace = name_space
                            self.priority.value_namespace_prefix = name_space_prefix


                class TransmittingReservableBandwidth(Entity):
                    """
                    Transmitting reservable BW at each priority
                    level (priority 0 to priority 7)
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                        self.yang_name = "transmitting-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"

                        self.pool0_bandwidth = YLeaf(YType.uint32, "pool0-bandwidth")

                        self.pool1_bandwidth = YLeaf(YType.uint32, "pool1-bandwidth")

                        self.priority = YLeaf(YType.uint8, "priority")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("pool0_bandwidth",
                                        "pool1_bandwidth",
                                        "priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.pool0_bandwidth.is_set or
                            self.pool1_bandwidth.is_set or
                            self.priority.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.pool0_bandwidth.yfilter != YFilter.not_set or
                            self.pool1_bandwidth.yfilter != YFilter.not_set or
                            self.priority.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transmitting-reservable-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.pool0_bandwidth.is_set or self.pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool0_bandwidth.get_name_leafdata())
                        if (self.pool1_bandwidth.is_set or self.pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool1_bandwidth.get_name_leafdata())
                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "pool0-bandwidth" or name == "pool1-bandwidth" or name == "priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "pool0-bandwidth"):
                            self.pool0_bandwidth = value
                            self.pool0_bandwidth.value_namespace = name_space
                            self.pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "pool1-bandwidth"):
                            self.pool1_bandwidth = value
                            self.pool1_bandwidth.value_namespace = name_space
                            self.pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority"):
                            self.priority = value
                            self.priority.value_namespace = name_space
                            self.priority.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.extended_affinity_attribute_flag:
                        if (c.has_data()):
                            return True
                    for c in self.receiving_reservable_bandwidth:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.transmitting_reservable_bandwidth:
                        if (c.has_data()):
                            return True
                    return (
                        self.affinity_attribute_flags.is_set or
                        self.bandwidth_units.is_set or
                        self.bcm_id.is_set or
                        self.designated_router_igp_id.is_set or
                        self.igp_metric.is_set or
                        self.igp_neighbor_address.is_set or
                        self.incoming_interface_id.is_set or
                        self.interface_name.is_set or
                        self.is_designated_router.is_set or
                        self.is_receiving_reservable_bandwidth_enabled.is_set or
                        self.is_transmitting_reservable_bandwidth_enabled.is_set or
                        self.link_address.is_set or
                        self.link_id.is_set or
                        self.link_maximum_reservable_bandwidth.is_set or
                        self.neighbor_igp_id.is_set or
                        self.outgoing_interface_id.is_set or
                        self.physical_bandwidth.is_set or
                        self.receiving_direction.is_set or
                        self.reservable_pool0_bandwidth.is_set or
                        self.reservable_pool1_bandwidth.is_set or
                        self.subnet_type.is_set or
                        self.te_metric.is_set or
                        self.transmitting_direction.is_set or
                        self.uni_link_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()))

                def has_operation(self):
                    for c in self.extended_affinity_attribute_flag:
                        if (c.has_operation()):
                            return True
                    for c in self.receiving_reservable_bandwidth:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.transmitting_reservable_bandwidth:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.affinity_attribute_flags.yfilter != YFilter.not_set or
                        self.bandwidth_units.yfilter != YFilter.not_set or
                        self.bcm_id.yfilter != YFilter.not_set or
                        self.designated_router_igp_id.yfilter != YFilter.not_set or
                        self.igp_metric.yfilter != YFilter.not_set or
                        self.igp_neighbor_address.yfilter != YFilter.not_set or
                        self.incoming_interface_id.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.is_designated_router.yfilter != YFilter.not_set or
                        self.is_receiving_reservable_bandwidth_enabled.yfilter != YFilter.not_set or
                        self.is_transmitting_reservable_bandwidth_enabled.yfilter != YFilter.not_set or
                        self.link_address.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        self.link_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                        self.neighbor_igp_id.yfilter != YFilter.not_set or
                        self.outgoing_interface_id.yfilter != YFilter.not_set or
                        self.physical_bandwidth.yfilter != YFilter.not_set or
                        self.receiving_direction.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                        self.subnet_type.yfilter != YFilter.not_set or
                        self.te_metric.yfilter != YFilter.not_set or
                        self.transmitting_direction.yfilter != YFilter.not_set or
                        self.uni_link_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "flooded-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.affinity_attribute_flags.is_set or self.affinity_attribute_flags.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_attribute_flags.get_name_leafdata())
                    if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                    if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcm_id.get_name_leafdata())
                    if (self.designated_router_igp_id.is_set or self.designated_router_igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.designated_router_igp_id.get_name_leafdata())
                    if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_metric.get_name_leafdata())
                    if (self.igp_neighbor_address.is_set or self.igp_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_neighbor_address.get_name_leafdata())
                    if (self.incoming_interface_id.is_set or self.incoming_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.incoming_interface_id.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                    if (self.is_receiving_reservable_bandwidth_enabled.is_set or self.is_receiving_reservable_bandwidth_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_receiving_reservable_bandwidth_enabled.get_name_leafdata())
                    if (self.is_transmitting_reservable_bandwidth_enabled.is_set or self.is_transmitting_reservable_bandwidth_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_transmitting_reservable_bandwidth_enabled.get_name_leafdata())
                    if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_address.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())
                    if (self.link_maximum_reservable_bandwidth.is_set or self.link_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_maximum_reservable_bandwidth.get_name_leafdata())
                    if (self.neighbor_igp_id.is_set or self.neighbor_igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_igp_id.get_name_leafdata())
                    if (self.outgoing_interface_id.is_set or self.outgoing_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outgoing_interface_id.get_name_leafdata())
                    if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                    if (self.receiving_direction.is_set or self.receiving_direction.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.receiving_direction.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth.is_set or self.reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth.is_set or self.reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth.get_name_leafdata())
                    if (self.subnet_type.is_set or self.subnet_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.subnet_type.get_name_leafdata())
                    if (self.te_metric.is_set or self.te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric.get_name_leafdata())
                    if (self.transmitting_direction.is_set or self.transmitting_direction.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transmitting_direction.get_name_leafdata())
                    if (self.uni_link_delay.is_set or self.uni_link_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uni_link_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "extended-affinity-attribute-flag"):
                        for c in self.extended_affinity_attribute_flag:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.extended_affinity_attribute_flag.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "receiving-reservable-bandwidth"):
                        for c in self.receiving_reservable_bandwidth:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.receiving_reservable_bandwidth.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "transmitting-reservable-bandwidth"):
                        for c in self.transmitting_reservable_bandwidth:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.transmitting_reservable_bandwidth.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "extended-affinity-attribute-flag" or name == "odu-link-capabilities" or name == "receiving-reservable-bandwidth" or name == "shared-risk-link-group" or name == "transmitting-reservable-bandwidth" or name == "affinity-attribute-flags" or name == "bandwidth-units" or name == "bcm-id" or name == "designated-router-igp-id" or name == "igp-metric" or name == "igp-neighbor-address" or name == "incoming-interface-id" or name == "interface-name" or name == "is-designated-router" or name == "is-receiving-reservable-bandwidth-enabled" or name == "is-transmitting-reservable-bandwidth-enabled" or name == "link-address" or name == "link-id" or name == "link-maximum-reservable-bandwidth" or name == "neighbor-igp-id" or name == "outgoing-interface-id" or name == "physical-bandwidth" or name == "receiving-direction" or name == "reservable-pool0-bandwidth" or name == "reservable-pool1-bandwidth" or name == "subnet-type" or name == "te-metric" or name == "transmitting-direction" or name == "uni-link-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "affinity-attribute-flags"):
                        self.affinity_attribute_flags = value
                        self.affinity_attribute_flags.value_namespace = name_space
                        self.affinity_attribute_flags.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-units"):
                        self.bandwidth_units = value
                        self.bandwidth_units.value_namespace = name_space
                        self.bandwidth_units.value_namespace_prefix = name_space_prefix
                    if(value_path == "bcm-id"):
                        self.bcm_id = value
                        self.bcm_id.value_namespace = name_space
                        self.bcm_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "designated-router-igp-id"):
                        self.designated_router_igp_id = value
                        self.designated_router_igp_id.value_namespace = name_space
                        self.designated_router_igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-metric"):
                        self.igp_metric = value
                        self.igp_metric.value_namespace = name_space
                        self.igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-neighbor-address"):
                        self.igp_neighbor_address = value
                        self.igp_neighbor_address.value_namespace = name_space
                        self.igp_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "incoming-interface-id"):
                        self.incoming_interface_id = value
                        self.incoming_interface_id.value_namespace = name_space
                        self.incoming_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-designated-router"):
                        self.is_designated_router = value
                        self.is_designated_router.value_namespace = name_space
                        self.is_designated_router.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-receiving-reservable-bandwidth-enabled"):
                        self.is_receiving_reservable_bandwidth_enabled = value
                        self.is_receiving_reservable_bandwidth_enabled.value_namespace = name_space
                        self.is_receiving_reservable_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-transmitting-reservable-bandwidth-enabled"):
                        self.is_transmitting_reservable_bandwidth_enabled = value
                        self.is_transmitting_reservable_bandwidth_enabled.value_namespace = name_space
                        self.is_transmitting_reservable_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-address"):
                        self.link_address = value
                        self.link_address.value_namespace = name_space
                        self.link_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-maximum-reservable-bandwidth"):
                        self.link_maximum_reservable_bandwidth = value
                        self.link_maximum_reservable_bandwidth.value_namespace = name_space
                        self.link_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-igp-id"):
                        self.neighbor_igp_id = value
                        self.neighbor_igp_id.value_namespace = name_space
                        self.neighbor_igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "outgoing-interface-id"):
                        self.outgoing_interface_id = value
                        self.outgoing_interface_id.value_namespace = name_space
                        self.outgoing_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "physical-bandwidth"):
                        self.physical_bandwidth = value
                        self.physical_bandwidth.value_namespace = name_space
                        self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "receiving-direction"):
                        self.receiving_direction = value
                        self.receiving_direction.value_namespace = name_space
                        self.receiving_direction.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth"):
                        self.reservable_pool0_bandwidth = value
                        self.reservable_pool0_bandwidth.value_namespace = name_space
                        self.reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth"):
                        self.reservable_pool1_bandwidth = value
                        self.reservable_pool1_bandwidth.value_namespace = name_space
                        self.reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "subnet-type"):
                        self.subnet_type = value
                        self.subnet_type.value_namespace = name_space
                        self.subnet_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric"):
                        self.te_metric = value
                        self.te_metric.value_namespace = name_space
                        self.te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "transmitting-direction"):
                        self.transmitting_direction = value
                        self.transmitting_direction.value_namespace = name_space
                        self.transmitting_direction.value_namespace_prefix = name_space_prefix
                    if(value_path == "uni-link-delay"):
                        self.uni_link_delay = value
                        self.uni_link_delay.value_namespace = name_space
                        self.uni_link_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.flooded_link:
                    if (c.has_data()):
                        return True
                return (
                    self.igp_area_id.is_set or
                    self.protocol.is_set or
                    self.router_id.is_set or
                    self.system_id.is_set)

            def has_operation(self):
                for c in self.flooded_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.igp_area_id.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.router_id.yfilter != YFilter.not_set or
                    self.system_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "advertized-areas" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_area_id.get_name_leafdata())
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.router_id.get_name_leafdata())
                if (self.system_id.is_set or self.system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.system_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "flooded-link"):
                    for c in self.flooded_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.flooded_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "flooded-link" or name == "igp-area-id" or name == "protocol" or name == "router-id" or name == "system-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "igp-area-id"):
                    self.igp_area_id = value
                    self.igp_area_id.value_namespace = name_space
                    self.igp_area_id.value_namespace_prefix = name_space_prefix
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "router-id"):
                    self.router_id = value
                    self.router_id.value_namespace = name_space
                    self.router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "system-id"):
                    self.system_id = value
                    self.system_id.value_namespace = name_space
                    self.system_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.advertized_areas:
                if (c.has_data()):
                    return True
            return (
                self.ds_te_mode.is_set or
                self.flooding_status_message.is_set or
                self.last_flooding_time.is_set or
                self.last_flooding_trigger.is_set or
                self.next_flooding_time.is_set)

        def has_operation(self):
            for c in self.advertized_areas:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.ds_te_mode.yfilter != YFilter.not_set or
                self.flooding_status_message.yfilter != YFilter.not_set or
                self.last_flooding_time.yfilter != YFilter.not_set or
                self.last_flooding_trigger.yfilter != YFilter.not_set or
                self.next_flooding_time.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "advertisements" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.ds_te_mode.is_set or self.ds_te_mode.yfilter != YFilter.not_set):
                leaf_name_data.append(self.ds_te_mode.get_name_leafdata())
            if (self.flooding_status_message.is_set or self.flooding_status_message.yfilter != YFilter.not_set):
                leaf_name_data.append(self.flooding_status_message.get_name_leafdata())
            if (self.last_flooding_time.is_set or self.last_flooding_time.yfilter != YFilter.not_set):
                leaf_name_data.append(self.last_flooding_time.get_name_leafdata())
            if (self.last_flooding_trigger.is_set or self.last_flooding_trigger.yfilter != YFilter.not_set):
                leaf_name_data.append(self.last_flooding_trigger.get_name_leafdata())
            if (self.next_flooding_time.is_set or self.next_flooding_time.yfilter != YFilter.not_set):
                leaf_name_data.append(self.next_flooding_time.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "advertized-areas"):
                for c in self.advertized_areas:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.Advertisements.AdvertizedAreas()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.advertized_areas.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "advertized-areas" or name == "ds-te-mode" or name == "flooding-status-message" or name == "last-flooding-time" or name == "last-flooding-trigger" or name == "next-flooding-time"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "ds-te-mode"):
                self.ds_te_mode = value
                self.ds_te_mode.value_namespace = name_space
                self.ds_te_mode.value_namespace_prefix = name_space_prefix
            if(value_path == "flooding-status-message"):
                self.flooding_status_message = value
                self.flooding_status_message.value_namespace = name_space
                self.flooding_status_message.value_namespace_prefix = name_space_prefix
            if(value_path == "last-flooding-time"):
                self.last_flooding_time = value
                self.last_flooding_time.value_namespace = name_space
                self.last_flooding_time.value_namespace_prefix = name_space_prefix
            if(value_path == "last-flooding-trigger"):
                self.last_flooding_trigger = value
                self.last_flooding_trigger.value_namespace = name_space
                self.last_flooding_trigger.value_namespace_prefix = name_space_prefix
            if(value_path == "next-flooding-time"):
                self.next_flooding_time = value
                self.next_flooding_time.value_namespace = name_space
                self.next_flooding_time.value_namespace_prefix = name_space_prefix


    class Statistics(Entity):
        """
        The interface statistics information in
        MPLS\-LCAC
        
        .. attribute:: statstics_links
        
        	The table of statistics interfaces in MPLS\-LCAC
        	**type**\:   :py:class:`StatsticsLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks>`
        
        .. attribute:: summary
        
        	The statistics summary for all interfaces
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-lcac-standby"

            self.statstics_links = MplsLcacStandby.Statistics.StatsticsLinks()
            self.statstics_links.parent = self
            self._children_name_map["statstics_links"] = "statstics-links"
            self._children_yang_names.add("statstics-links")

            self.summary = MplsLcacStandby.Statistics.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            The statistics summary for all interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: path_statistics
            
            	Deprecated
            	**type**\:   :py:class:`PathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.PathStatistics>`
            
            .. attribute:: path_statistics32_bit
            
            	Path counters (32\-bit)
            	**type**\:   :py:class:`PathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.PathStatistics32Bit>`
            
            .. attribute:: reservation_statistics
            
            	Deprecated
            	**type**\:   :py:class:`ReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.ReservationStatistics>`
            
            .. attribute:: reservation_statistics32_bit
            
            	Reservation counters (32\-bit)
            	**type**\:   :py:class:`ReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Statistics.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "statistics"

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.path_statistics = MplsLcacStandby.Statistics.Summary.PathStatistics()
                self.path_statistics.parent = self
                self._children_name_map["path_statistics"] = "path-statistics"
                self._children_yang_names.add("path-statistics")

                self.path_statistics32_bit = MplsLcacStandby.Statistics.Summary.PathStatistics32Bit()
                self.path_statistics32_bit.parent = self
                self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"
                self._children_yang_names.add("path-statistics32-bit")

                self.reservation_statistics = MplsLcacStandby.Statistics.Summary.ReservationStatistics()
                self.reservation_statistics.parent = self
                self._children_name_map["reservation_statistics"] = "reservation-statistics"
                self._children_yang_names.add("reservation-statistics")

                self.reservation_statistics32_bit = MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit()
                self.reservation_statistics32_bit.parent = self
                self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                self._children_yang_names.add("reservation-statistics32-bit")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_role_standby") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.Statistics.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.Statistics.Summary, self).__setattr__(name, value)


            class PathStatistics(Entity):
                """
                Deprecated
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Statistics.Summary.PathStatistics, self).__init__()

                    self.yang_name = "path-statistics"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Statistics.Summary.PathStatistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Statistics.Summary.PathStatistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class ReservationStatistics(Entity):
                """
                Deprecated
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Statistics.Summary.ReservationStatistics, self).__init__()

                    self.yang_name = "reservation-statistics"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Statistics.Summary.ReservationStatistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Statistics.Summary.ReservationStatistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "reservation-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class PathStatistics32Bit(Entity):
                """
                Path counters (32\-bit)
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Statistics.Summary.PathStatistics32Bit, self).__init__()

                    self.yang_name = "path-statistics32-bit"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Statistics.Summary.PathStatistics32Bit, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Statistics.Summary.PathStatistics32Bit, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-statistics32-bit" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class ReservationStatistics32Bit(Entity):
                """
                Reservation counters (32\-bit)
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit, self).__init__()

                    self.yang_name = "reservation-statistics32-bit"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "reservation-statistics32-bit" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.is_role_standby.is_set or
                    (self.path_statistics is not None and self.path_statistics.has_data()) or
                    (self.path_statistics32_bit is not None and self.path_statistics32_bit.has_data()) or
                    (self.reservation_statistics is not None and self.reservation_statistics.has_data()) or
                    (self.reservation_statistics32_bit is not None and self.reservation_statistics32_bit.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    (self.path_statistics is not None and self.path_statistics.has_operation()) or
                    (self.path_statistics32_bit is not None and self.path_statistics32_bit.has_operation()) or
                    (self.reservation_statistics is not None and self.reservation_statistics.has_operation()) or
                    (self.reservation_statistics32_bit is not None and self.reservation_statistics32_bit.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-statistics"):
                    if (self.path_statistics is None):
                        self.path_statistics = MplsLcacStandby.Statistics.Summary.PathStatistics()
                        self.path_statistics.parent = self
                        self._children_name_map["path_statistics"] = "path-statistics"
                    return self.path_statistics

                if (child_yang_name == "path-statistics32-bit"):
                    if (self.path_statistics32_bit is None):
                        self.path_statistics32_bit = MplsLcacStandby.Statistics.Summary.PathStatistics32Bit()
                        self.path_statistics32_bit.parent = self
                        self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"
                    return self.path_statistics32_bit

                if (child_yang_name == "reservation-statistics"):
                    if (self.reservation_statistics is None):
                        self.reservation_statistics = MplsLcacStandby.Statistics.Summary.ReservationStatistics()
                        self.reservation_statistics.parent = self
                        self._children_name_map["reservation_statistics"] = "reservation-statistics"
                    return self.reservation_statistics

                if (child_yang_name == "reservation-statistics32-bit"):
                    if (self.reservation_statistics32_bit is None):
                        self.reservation_statistics32_bit = MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit()
                        self.reservation_statistics32_bit.parent = self
                        self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                    return self.reservation_statistics32_bit

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-statistics" or name == "path-statistics32-bit" or name == "reservation-statistics" or name == "reservation-statistics32-bit" or name == "is-role-standby"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix


        class StatsticsLinks(Entity):
            """
            The table of statistics interfaces in MPLS\-LCAC
            
            .. attribute:: statstics_link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of    :py:class:`StatsticsLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Statistics.StatsticsLinks, self).__init__()

                self.yang_name = "statstics-links"
                self.yang_parent_name = "statistics"

                self.statstics_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.Statistics.StatsticsLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.Statistics.StatsticsLinks, self).__setattr__(name, value)


            class StatsticsLink(Entity):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: incoming_path_statistics
                
                	Deprecated
                	**type**\:   :py:class:`IncomingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics>`
                
                .. attribute:: incoming_path_statistics32_bit
                
                	Incoming PATH counters
                	**type**\:   :py:class:`IncomingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit>`
                
                .. attribute:: incoming_reservation_statistics
                
                	Deprecated
                	**type**\:   :py:class:`IncomingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics>`
                
                .. attribute:: incoming_reservation_statistics32_bit
                
                	Incoming RESV counters
                	**type**\:   :py:class:`IncomingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit>`
                
                .. attribute:: interface_name_xr
                
                	Link name
                	**type**\:  str
                
                .. attribute:: link_address
                
                	Link's ip address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: outgoing_path_statistics
                
                	Deprecated
                	**type**\:   :py:class:`OutgoingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics>`
                
                .. attribute:: outgoing_path_statistics32_bit
                
                	Outgoing PATH counters
                	**type**\:   :py:class:`OutgoingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit>`
                
                .. attribute:: outgoing_reservation_statistics
                
                	Deprecated
                	**type**\:   :py:class:`OutgoingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics>`
                
                .. attribute:: outgoing_reservation_statistics32_bit
                
                	Outgoing RESV counters
                	**type**\:   :py:class:`OutgoingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink, self).__init__()

                    self.yang_name = "statstics-link"
                    self.yang_parent_name = "statstics-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                    self.link_address = YLeaf(YType.str, "link-address")

                    self.incoming_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                    self.incoming_path_statistics.parent = self
                    self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"
                    self._children_yang_names.add("incoming-path-statistics")

                    self.incoming_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                    self.incoming_path_statistics32_bit.parent = self
                    self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"
                    self._children_yang_names.add("incoming-path-statistics32-bit")

                    self.incoming_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                    self.incoming_reservation_statistics.parent = self
                    self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"
                    self._children_yang_names.add("incoming-reservation-statistics")

                    self.incoming_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                    self.incoming_reservation_statistics32_bit.parent = self
                    self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"
                    self._children_yang_names.add("incoming-reservation-statistics32-bit")

                    self.outgoing_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                    self.outgoing_path_statistics.parent = self
                    self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"
                    self._children_yang_names.add("outgoing-path-statistics")

                    self.outgoing_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                    self.outgoing_path_statistics32_bit.parent = self
                    self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"
                    self._children_yang_names.add("outgoing-path-statistics32-bit")

                    self.outgoing_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                    self.outgoing_reservation_statistics.parent = self
                    self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"
                    self._children_yang_names.add("outgoing-reservation-statistics")

                    self.outgoing_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                    self.outgoing_reservation_statistics32_bit.parent = self
                    self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                    self._children_yang_names.add("outgoing-reservation-statistics32-bit")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "interface_name_xr",
                                    "link_address") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink, self).__setattr__(name, value)


                class IncomingPathStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__init__()

                        self.yang_name = "incoming-path-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-path-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingReservationStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__init__()

                        self.yang_name = "incoming-reservation-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-reservation-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingPathStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__init__()

                        self.yang_name = "outgoing-path-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-path-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingReservationStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-reservation-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingPathStatistics32Bit(Entity):
                    """
                    Incoming PATH counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-path-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingReservationStatistics32Bit(Entity):
                    """
                    Incoming RESV counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-reservation-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingPathStatistics32Bit(Entity):
                    """
                    Outgoing PATH counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-path-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingReservationStatistics32Bit(Entity):
                    """
                    Outgoing RESV counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-reservation-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.interface_name_xr.is_set or
                        self.link_address.is_set or
                        (self.incoming_path_statistics is not None and self.incoming_path_statistics.has_data()) or
                        (self.incoming_path_statistics32_bit is not None and self.incoming_path_statistics32_bit.has_data()) or
                        (self.incoming_reservation_statistics is not None and self.incoming_reservation_statistics.has_data()) or
                        (self.incoming_reservation_statistics32_bit is not None and self.incoming_reservation_statistics32_bit.has_data()) or
                        (self.outgoing_path_statistics is not None and self.outgoing_path_statistics.has_data()) or
                        (self.outgoing_path_statistics32_bit is not None and self.outgoing_path_statistics32_bit.has_data()) or
                        (self.outgoing_reservation_statistics is not None and self.outgoing_reservation_statistics.has_data()) or
                        (self.outgoing_reservation_statistics32_bit is not None and self.outgoing_reservation_statistics32_bit.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.interface_name_xr.yfilter != YFilter.not_set or
                        self.link_address.yfilter != YFilter.not_set or
                        (self.incoming_path_statistics is not None and self.incoming_path_statistics.has_operation()) or
                        (self.incoming_path_statistics32_bit is not None and self.incoming_path_statistics32_bit.has_operation()) or
                        (self.incoming_reservation_statistics is not None and self.incoming_reservation_statistics.has_operation()) or
                        (self.incoming_reservation_statistics32_bit is not None and self.incoming_reservation_statistics32_bit.has_operation()) or
                        (self.outgoing_path_statistics is not None and self.outgoing_path_statistics.has_operation()) or
                        (self.outgoing_path_statistics32_bit is not None and self.outgoing_path_statistics32_bit.has_operation()) or
                        (self.outgoing_reservation_statistics is not None and self.outgoing_reservation_statistics.has_operation()) or
                        (self.outgoing_reservation_statistics32_bit is not None and self.outgoing_reservation_statistics32_bit.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statstics-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/statstics-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                    if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "incoming-path-statistics"):
                        if (self.incoming_path_statistics is None):
                            self.incoming_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                            self.incoming_path_statistics.parent = self
                            self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"
                        return self.incoming_path_statistics

                    if (child_yang_name == "incoming-path-statistics32-bit"):
                        if (self.incoming_path_statistics32_bit is None):
                            self.incoming_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                            self.incoming_path_statistics32_bit.parent = self
                            self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"
                        return self.incoming_path_statistics32_bit

                    if (child_yang_name == "incoming-reservation-statistics"):
                        if (self.incoming_reservation_statistics is None):
                            self.incoming_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                            self.incoming_reservation_statistics.parent = self
                            self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"
                        return self.incoming_reservation_statistics

                    if (child_yang_name == "incoming-reservation-statistics32-bit"):
                        if (self.incoming_reservation_statistics32_bit is None):
                            self.incoming_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                            self.incoming_reservation_statistics32_bit.parent = self
                            self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"
                        return self.incoming_reservation_statistics32_bit

                    if (child_yang_name == "outgoing-path-statistics"):
                        if (self.outgoing_path_statistics is None):
                            self.outgoing_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                            self.outgoing_path_statistics.parent = self
                            self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"
                        return self.outgoing_path_statistics

                    if (child_yang_name == "outgoing-path-statistics32-bit"):
                        if (self.outgoing_path_statistics32_bit is None):
                            self.outgoing_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                            self.outgoing_path_statistics32_bit.parent = self
                            self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"
                        return self.outgoing_path_statistics32_bit

                    if (child_yang_name == "outgoing-reservation-statistics"):
                        if (self.outgoing_reservation_statistics is None):
                            self.outgoing_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                            self.outgoing_reservation_statistics.parent = self
                            self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"
                        return self.outgoing_reservation_statistics

                    if (child_yang_name == "outgoing-reservation-statistics32-bit"):
                        if (self.outgoing_reservation_statistics32_bit is None):
                            self.outgoing_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                            self.outgoing_reservation_statistics32_bit.parent = self
                            self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                        return self.outgoing_reservation_statistics32_bit

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "incoming-path-statistics" or name == "incoming-path-statistics32-bit" or name == "incoming-reservation-statistics" or name == "incoming-reservation-statistics32-bit" or name == "outgoing-path-statistics" or name == "outgoing-path-statistics32-bit" or name == "outgoing-reservation-statistics" or name == "outgoing-reservation-statistics32-bit" or name == "interface-name" or name == "interface-name-xr" or name == "link-address"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name-xr"):
                        self.interface_name_xr = value
                        self.interface_name_xr.value_namespace = name_space
                        self.interface_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-address"):
                        self.link_address = value
                        self.link_address.value_namespace = name_space
                        self.link_address.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.statstics_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.statstics_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "statstics-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "statstics-link"):
                    for c in self.statstics_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.statstics_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "statstics-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.statstics_links is not None and self.statstics_links.has_data()) or
                (self.summary is not None and self.summary.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.statstics_links is not None and self.statstics_links.has_operation()) or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "statistics" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "statstics-links"):
                if (self.statstics_links is None):
                    self.statstics_links = MplsLcacStandby.Statistics.StatsticsLinks()
                    self.statstics_links.parent = self
                    self._children_name_map["statstics_links"] = "statstics-links"
                return self.statstics_links

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsLcacStandby.Statistics.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "statstics-links" or name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BandwidthAllocation(Entity):
        """
        The bandwidth allocation information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_allocation_links
        
        	Per\-link bandwidth allocation information in MPLS\-LCAC
        	**type**\:   :py:class:`BandwidthAllocationLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks>`
        
        .. attribute:: global_
        
        	Global bandwidth allocation information for all interfaces
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.Global_>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.BandwidthAllocation, self).__init__()

            self.yang_name = "bandwidth-allocation"
            self.yang_parent_name = "mpls-lcac-standby"

            self.bandwidth_allocation_links = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks()
            self.bandwidth_allocation_links.parent = self
            self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
            self._children_yang_names.add("bandwidth-allocation-links")

            self.global_ = MplsLcacStandby.BandwidthAllocation.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")


        class Global_(Entity):
            """
            Global bandwidth allocation information for all
            interfaces
            
            .. attribute:: bandwidth_hold_time
            
            	How long to hold the bandwidth (seconds)
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: links
            
            	Number of links
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.BandwidthAllocation.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "bandwidth-allocation"

                self.bandwidth_hold_time = YLeaf(YType.uint16, "bandwidth-hold-time")

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.links = YLeaf(YType.uint16, "links")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("bandwidth_hold_time",
                                "is_role_standby",
                                "links") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.BandwidthAllocation.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.BandwidthAllocation.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.bandwidth_hold_time.is_set or
                    self.is_role_standby.is_set or
                    self.links.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.bandwidth_hold_time.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.links.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.bandwidth_hold_time.is_set or self.bandwidth_hold_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_hold_time.get_name_leafdata())
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-hold-time" or name == "is-role-standby" or name == "links"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "bandwidth-hold-time"):
                    self.bandwidth_hold_time = value
                    self.bandwidth_hold_time.value_namespace = name_space
                    self.bandwidth_hold_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "links"):
                    self.links = value
                    self.links.value_namespace = name_space
                    self.links.value_namespace_prefix = name_space_prefix


        class BandwidthAllocationLinks(Entity):
            """
            Per\-link bandwidth allocation information in
            MPLS\-LCAC
            
            .. attribute:: bandwidth_allocation_link
            
            	The bandwidth allocation for a given interface
            	**type**\: list of    :py:class:`BandwidthAllocationLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks, self).__init__()

                self.yang_name = "bandwidth-allocation-links"
                self.yang_parent_name = "bandwidth-allocation"

                self.bandwidth_allocation_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks, self).__setattr__(name, value)


            class BandwidthAllocationLink(Entity):
                """
                The bandwidth allocation for a given interface
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: bandwidth_descriptors
                
                	Number of BW descriptor for the given pool
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: bandwidth_pool
                
                	type of the BW pool
                	**type**\:   :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                .. attribute:: downstream_bandwidth
                
                	BW info in the dnstream direction
                	**type**\:   :py:class:`DownstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth>`
                
                .. attribute:: flooding_down_threshold
                
                	Flooding down\-thresholds
                	**type**\: list of    :py:class:`FloodingDownThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold>`
                
                .. attribute:: flooding_down_thresholds_are_default
                
                	TRUE if the down\-threshold are default
                	**type**\:  bool
                
                .. attribute:: flooding_down_thresholds_are_global
                
                	TRUE if the down\-threshold are global
                	**type**\:  bool
                
                .. attribute:: flooding_up_threshold
                
                	Flooding up\-thresholds
                	**type**\: list of    :py:class:`FloodingUpThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold>`
                
                .. attribute:: flooding_up_thresholds_are_default
                
                	TRUE if the up\-threshold are default
                	**type**\:  bool
                
                .. attribute:: flooding_up_thresholds_are_global
                
                	TRUE if the up\-threshold are global
                	**type**\:  bool
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:   :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon>`
                
                .. attribute:: total_bandwidth_descriptors
                
                	Number of total BW descriptors
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: upstream_bandwidth
                
                	BW info in the upstream direction
                	**type**\:   :py:class:`UpstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__init__()

                    self.yang_name = "bandwidth-allocation-link"
                    self.yang_parent_name = "bandwidth-allocation-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.bandwidth_descriptors = YLeaf(YType.uint16, "bandwidth-descriptors")

                    self.bandwidth_pool = YLeaf(YType.enumeration, "bandwidth-pool")

                    self.flooding_down_thresholds_are_default = YLeaf(YType.boolean, "flooding-down-thresholds-are-default")

                    self.flooding_down_thresholds_are_global = YLeaf(YType.boolean, "flooding-down-thresholds-are-global")

                    self.flooding_up_thresholds_are_default = YLeaf(YType.boolean, "flooding-up-thresholds-are-default")

                    self.flooding_up_thresholds_are_global = YLeaf(YType.boolean, "flooding-up-thresholds-are-global")

                    self.total_bandwidth_descriptors = YLeaf(YType.uint16, "total-bandwidth-descriptors")

                    self.downstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                    self.downstream_bandwidth.parent = self
                    self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"
                    self._children_yang_names.add("downstream-bandwidth")

                    self.link_common = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"
                    self._children_yang_names.add("link-common")

                    self.upstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                    self.upstream_bandwidth.parent = self
                    self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"
                    self._children_yang_names.add("upstream-bandwidth")

                    self.flooding_down_threshold = YList(self)
                    self.flooding_up_threshold = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "bandwidth_descriptors",
                                    "bandwidth_pool",
                                    "flooding_down_thresholds_are_default",
                                    "flooding_down_thresholds_are_global",
                                    "flooding_up_thresholds_are_default",
                                    "flooding_up_thresholds_are_global",
                                    "total_bandwidth_descriptors") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__setattr__(name, value)


                class LinkCommon(Entity):
                    """
                    The link's common info
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of    :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas>`
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\:  bool
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of    :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\:  bool
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\:  bool
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:   :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags>`
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\:  str
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:   :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup>`
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                        self.capability = YLeaf(YType.uint32, "capability")

                        self.has_protection = YLeaf(YType.boolean, "has-protection")

                        self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                        self.inbound_admission_method = YLeaf(YType.enumeration, "inbound-admission-method")

                        self.incoming_reservable_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-bandwidth-percentage")

                        self.incoming_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool0-bandwidth-percentage")

                        self.incoming_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool1-bandwidth-percentage")

                        self.is_resource_provider_installed = YLeaf(YType.boolean, "is-resource-provider-installed")

                        self.is_unnumbered = YLeaf(YType.boolean, "is-unnumbered")

                        self.last_flooded_effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "last-flooded-effective-maximum-reservable-bandwidth")

                        self.link_address = YLeaf(YType.str, "link-address")

                        self.link_id = YLeaf(YType.str, "link-id")

                        self.maximum_reservable_bandwidth = YLeaf(YType.uint64, "maximum-reservable-bandwidth")

                        self.maximum_reservable_pool0_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool0-bandwidth")

                        self.maximum_reservable_pool1_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool1-bandwidth")

                        self.outbound_admission_method = YLeaf(YType.enumeration, "outbound-admission-method")

                        self.outgoing_reservable_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-bandwidth-percentage")

                        self.outgoing_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool0-bandwidth-percentage")

                        self.outgoing_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool1-bandwidth-percentage")

                        self.physical_bandwidth = YLeaf(YType.uint64, "physical-bandwidth")

                        self.resource_provider = YLeaf(YType.enumeration, "resource-provider")

                        self.working_priority = YLeaf(YType.uint32, "working-priority")

                        self.link_flags = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"
                        self._children_yang_names.add("link-flags")

                        self.flooded_areas = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_units",
                                        "bcm_id",
                                        "capability",
                                        "has_protection",
                                        "igp_neighbors",
                                        "inbound_admission_method",
                                        "incoming_reservable_bandwidth_percentage",
                                        "incoming_reservable_pool0_bandwidth_percentage",
                                        "incoming_reservable_pool1_bandwidth_percentage",
                                        "is_resource_provider_installed",
                                        "is_unnumbered",
                                        "last_flooded_effective_maximum_reservable_bandwidth",
                                        "link_address",
                                        "link_id",
                                        "maximum_reservable_bandwidth",
                                        "maximum_reservable_pool0_bandwidth",
                                        "maximum_reservable_pool1_bandwidth",
                                        "outbound_admission_method",
                                        "outgoing_reservable_bandwidth_percentage",
                                        "outgoing_reservable_pool0_bandwidth_percentage",
                                        "outgoing_reservable_pool1_bandwidth_percentage",
                                        "physical_bandwidth",
                                        "resource_provider",
                                        "working_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__setattr__(name, value)


                    class LinkFlags(Entity):
                        """
                        The link's flags
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\:  bool
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\:  bool
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:   :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"

                            self.is_admin_up = YLeaf(YType.boolean, "is-admin-up")

                            self.is_mpls_te_on = YLeaf(YType.boolean, "is-mpls-te-on")

                            self.signaling_agent = YLeaf(YType.enumeration, "signaling-agent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_admin_up",
                                            "is_mpls_te_on",
                                            "signaling_agent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_admin_up.is_set or
                                self.is_mpls_te_on.is_set or
                                self.signaling_agent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_admin_up.yfilter != YFilter.not_set or
                                self.is_mpls_te_on.yfilter != YFilter.not_set or
                                self.signaling_agent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "link-flags" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_admin_up.is_set or self.is_admin_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_admin_up.get_name_leafdata())
                            if (self.is_mpls_te_on.is_set or self.is_mpls_te_on.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mpls_te_on.get_name_leafdata())
                            if (self.signaling_agent.is_set or self.signaling_agent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaling_agent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-admin-up" or name == "is-mpls-te-on" or name == "signaling-agent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-admin-up"):
                                self.is_admin_up = value
                                self.is_admin_up.value_namespace = name_space
                                self.is_admin_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-mpls-te-on"):
                                self.is_mpls_te_on = value
                                self.is_mpls_te_on.value_namespace = name_space
                                self.is_mpls_te_on.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaling-agent"):
                                self.signaling_agent = value
                                self.signaling_agent.value_namespace = name_space
                                self.signaling_agent.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class InterfaceSwitchingCapabilityDescriptor(Entity):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"

                            self.encoding = YLeaf(YType.uint8, "encoding")

                            self.key = YLeaf(YType.uint8, "key")

                            self.switching_capability = YLeaf(YType.uint8, "switching-capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("encoding",
                                            "key",
                                            "switching_capability") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.encoding.is_set or
                                self.key.is_set or
                                self.switching_capability.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.encoding.yfilter != YFilter.not_set or
                                self.key.yfilter != YFilter.not_set or
                                self.switching_capability.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-switching-capability-descriptor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.encoding.is_set or self.encoding.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.encoding.get_name_leafdata())
                            if (self.key.is_set or self.key.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.key.get_name_leafdata())
                            if (self.switching_capability.is_set or self.switching_capability.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switching_capability.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "encoding" or name == "key" or name == "switching-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "encoding"):
                                self.encoding = value
                                self.encoding.value_namespace = name_space
                                self.encoding.value_namespace_prefix = name_space_prefix
                            if(value_path == "key"):
                                self.key = value
                                self.key.value_namespace = name_space
                                self.key.value_namespace_prefix = name_space_prefix
                            if(value_path == "switching-capability"):
                                self.switching_capability = value
                                self.switching_capability.value_namespace = name_space
                                self.switching_capability.value_namespace_prefix = name_space_prefix


                    class FloodedAreas(Entity):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"

                            self.flooded_area = YLeaf(YType.str, "flooded-area")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("flooded_area") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__setattr__(name, value)

                        def has_data(self):
                            return self.flooded_area.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.flooded_area.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flooded-areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.flooded_area.is_set or self.flooded_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flooded_area.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flooded-area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "flooded-area"):
                                self.flooded_area = value
                                self.flooded_area.value_namespace = name_space
                                self.flooded_area.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.flooded_areas:
                            if (c.has_data()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_units.is_set or
                            self.bcm_id.is_set or
                            self.capability.is_set or
                            self.has_protection.is_set or
                            self.igp_neighbors.is_set or
                            self.inbound_admission_method.is_set or
                            self.incoming_reservable_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.is_set or
                            self.is_resource_provider_installed.is_set or
                            self.is_unnumbered.is_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.is_set or
                            self.link_address.is_set or
                            self.link_id.is_set or
                            self.maximum_reservable_bandwidth.is_set or
                            self.maximum_reservable_pool0_bandwidth.is_set or
                            self.maximum_reservable_pool1_bandwidth.is_set or
                            self.outbound_admission_method.is_set or
                            self.outgoing_reservable_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.is_set or
                            self.physical_bandwidth.is_set or
                            self.resource_provider.is_set or
                            self.working_priority.is_set or
                            (self.link_flags is not None and self.link_flags.has_data()))

                    def has_operation(self):
                        for c in self.flooded_areas:
                            if (c.has_operation()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.bcm_id.yfilter != YFilter.not_set or
                            self.capability.yfilter != YFilter.not_set or
                            self.has_protection.yfilter != YFilter.not_set or
                            self.igp_neighbors.yfilter != YFilter.not_set or
                            self.inbound_admission_method.yfilter != YFilter.not_set or
                            self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.is_resource_provider_installed.yfilter != YFilter.not_set or
                            self.is_unnumbered.yfilter != YFilter.not_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.link_address.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                            self.outbound_admission_method.yfilter != YFilter.not_set or
                            self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.physical_bandwidth.yfilter != YFilter.not_set or
                            self.resource_provider.yfilter != YFilter.not_set or
                            self.working_priority.yfilter != YFilter.not_set or
                            (self.link_flags is not None and self.link_flags.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcm_id.get_name_leafdata())
                        if (self.capability.is_set or self.capability.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.capability.get_name_leafdata())
                        if (self.has_protection.is_set or self.has_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_protection.get_name_leafdata())
                        if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                        if (self.inbound_admission_method.is_set or self.inbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inbound_admission_method.get_name_leafdata())
                        if (self.incoming_reservable_bandwidth_percentage.is_set or self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool0_bandwidth_percentage.is_set or self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool1_bandwidth_percentage.is_set or self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.is_resource_provider_installed.is_set or self.is_resource_provider_installed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_resource_provider_installed.get_name_leafdata())
                        if (self.is_unnumbered.is_set or self.is_unnumbered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unnumbered.get_name_leafdata())
                        if (self.last_flooded_effective_maximum_reservable_bandwidth.is_set or self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_flooded_effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_address.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.maximum_reservable_bandwidth.is_set or self.maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool0_bandwidth.is_set or self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool0_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool1_bandwidth.is_set or self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool1_bandwidth.get_name_leafdata())
                        if (self.outbound_admission_method.is_set or self.outbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_admission_method.get_name_leafdata())
                        if (self.outgoing_reservable_bandwidth_percentage.is_set or self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool0_bandwidth_percentage.is_set or self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool1_bandwidth_percentage.is_set or self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                        if (self.resource_provider.is_set or self.resource_provider.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_provider.get_name_leafdata())
                        if (self.working_priority.is_set or self.working_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.working_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "flooded-areas"):
                            for c in self.flooded_areas:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.flooded_areas.append(c)
                            return c

                        if (child_yang_name == "interface-switching-capability-descriptor"):
                            for c in self.interface_switching_capability_descriptor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface_switching_capability_descriptor.append(c)
                            return c

                        if (child_yang_name == "link-flags"):
                            if (self.link_flags is None):
                                self.link_flags = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                                self.link_flags.parent = self
                                self._children_name_map["link_flags"] = "link-flags"
                            return self.link_flags

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "flooded-areas" or name == "interface-switching-capability-descriptor" or name == "link-flags" or name == "shared-risk-link-group" or name == "bandwidth-units" or name == "bcm-id" or name == "capability" or name == "has-protection" or name == "igp-neighbors" or name == "inbound-admission-method" or name == "incoming-reservable-bandwidth-percentage" or name == "incoming-reservable-pool0-bandwidth-percentage" or name == "incoming-reservable-pool1-bandwidth-percentage" or name == "is-resource-provider-installed" or name == "is-unnumbered" or name == "last-flooded-effective-maximum-reservable-bandwidth" or name == "link-address" or name == "link-id" or name == "maximum-reservable-bandwidth" or name == "maximum-reservable-pool0-bandwidth" or name == "maximum-reservable-pool1-bandwidth" or name == "outbound-admission-method" or name == "outgoing-reservable-bandwidth-percentage" or name == "outgoing-reservable-pool0-bandwidth-percentage" or name == "outgoing-reservable-pool1-bandwidth-percentage" or name == "physical-bandwidth" or name == "resource-provider" or name == "working-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcm-id"):
                            self.bcm_id = value
                            self.bcm_id.value_namespace = name_space
                            self.bcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "capability"):
                            self.capability = value
                            self.capability.value_namespace = name_space
                            self.capability.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-protection"):
                            self.has_protection = value
                            self.has_protection.value_namespace = name_space
                            self.has_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-neighbors"):
                            self.igp_neighbors = value
                            self.igp_neighbors.value_namespace = name_space
                            self.igp_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "inbound-admission-method"):
                            self.inbound_admission_method = value
                            self.inbound_admission_method.value_namespace = name_space
                            self.inbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-bandwidth-percentage"):
                            self.incoming_reservable_bandwidth_percentage = value
                            self.incoming_reservable_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool0-bandwidth-percentage"):
                            self.incoming_reservable_pool0_bandwidth_percentage = value
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool1-bandwidth-percentage"):
                            self.incoming_reservable_pool1_bandwidth_percentage = value
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-resource-provider-installed"):
                            self.is_resource_provider_installed = value
                            self.is_resource_provider_installed.value_namespace = name_space
                            self.is_resource_provider_installed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unnumbered"):
                            self.is_unnumbered = value
                            self.is_unnumbered.value_namespace = name_space
                            self.is_unnumbered.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-flooded-effective-maximum-reservable-bandwidth"):
                            self.last_flooded_effective_maximum_reservable_bandwidth = value
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-address"):
                            self.link_address = value
                            self.link_address.value_namespace = name_space
                            self.link_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-bandwidth"):
                            self.maximum_reservable_bandwidth = value
                            self.maximum_reservable_bandwidth.value_namespace = name_space
                            self.maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool0-bandwidth"):
                            self.maximum_reservable_pool0_bandwidth = value
                            self.maximum_reservable_pool0_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool1-bandwidth"):
                            self.maximum_reservable_pool1_bandwidth = value
                            self.maximum_reservable_pool1_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-admission-method"):
                            self.outbound_admission_method = value
                            self.outbound_admission_method.value_namespace = name_space
                            self.outbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-bandwidth-percentage"):
                            self.outgoing_reservable_bandwidth_percentage = value
                            self.outgoing_reservable_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool0-bandwidth-percentage"):
                            self.outgoing_reservable_pool0_bandwidth_percentage = value
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool1-bandwidth-percentage"):
                            self.outgoing_reservable_pool1_bandwidth_percentage = value
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-bandwidth"):
                            self.physical_bandwidth = value
                            self.physical_bandwidth.value_namespace = name_space
                            self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-provider"):
                            self.resource_provider = value
                            self.resource_provider.value_namespace = name_space
                            self.resource_provider.value_namespace_prefix = name_space_prefix
                        if(value_path == "working-priority"):
                            self.working_priority = value
                            self.working_priority.value_namespace = name_space
                            self.working_priority.value_namespace_prefix = name_space_prefix


                class UpstreamBandwidth(Entity):
                    """
                    BW info in the upstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0>`
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1>`
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__init__()

                        self.yang_name = "upstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_direction = YLeaf(YType.enumeration, "bandwidth-direction")

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.is_admission_method_allocated_bandwidth = YLeaf(YType.boolean, "is-admission-method-allocated-bandwidth")

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_direction",
                                        "bandwidth_units",
                                        "is_admission_method_allocated_bandwidth") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__setattr__(name, value)


                    class BandwidthPool0(Entity):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "upstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool0" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix


                    class BandwidthPool1(Entity):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "upstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool1" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_data()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_direction.is_set or
                            self.bandwidth_units.is_set or
                            self.is_admission_method_allocated_bandwidth.is_set)

                    def has_operation(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_operation()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_direction.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "upstream-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_direction.is_set or self.bandwidth_direction.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_direction.get_name_leafdata())
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.is_admission_method_allocated_bandwidth.is_set or self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_admission_method_allocated_bandwidth.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-pool0"):
                            for c in self.bandwidth_pool0:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool0.append(c)
                            return c

                        if (child_yang_name == "bandwidth-pool1"):
                            for c in self.bandwidth_pool1:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool1.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-pool0" or name == "bandwidth-pool1" or name == "bandwidth-direction" or name == "bandwidth-units" or name == "is-admission-method-allocated-bandwidth"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-direction"):
                            self.bandwidth_direction = value
                            self.bandwidth_direction.value_namespace = name_space
                            self.bandwidth_direction.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-admission-method-allocated-bandwidth"):
                            self.is_admission_method_allocated_bandwidth = value
                            self.is_admission_method_allocated_bandwidth.value_namespace = name_space
                            self.is_admission_method_allocated_bandwidth.value_namespace_prefix = name_space_prefix


                class DownstreamBandwidth(Entity):
                    """
                    BW info in the dnstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0>`
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1>`
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__init__()

                        self.yang_name = "downstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_direction = YLeaf(YType.enumeration, "bandwidth-direction")

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.is_admission_method_allocated_bandwidth = YLeaf(YType.boolean, "is-admission-method-allocated-bandwidth")

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_direction",
                                        "bandwidth_units",
                                        "is_admission_method_allocated_bandwidth") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__setattr__(name, value)


                    class BandwidthPool0(Entity):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "downstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool0" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix


                    class BandwidthPool1(Entity):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "downstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool1" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_data()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_direction.is_set or
                            self.bandwidth_units.is_set or
                            self.is_admission_method_allocated_bandwidth.is_set)

                    def has_operation(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_operation()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_direction.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "downstream-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_direction.is_set or self.bandwidth_direction.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_direction.get_name_leafdata())
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.is_admission_method_allocated_bandwidth.is_set or self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_admission_method_allocated_bandwidth.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-pool0"):
                            for c in self.bandwidth_pool0:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool0.append(c)
                            return c

                        if (child_yang_name == "bandwidth-pool1"):
                            for c in self.bandwidth_pool1:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool1.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-pool0" or name == "bandwidth-pool1" or name == "bandwidth-direction" or name == "bandwidth-units" or name == "is-admission-method-allocated-bandwidth"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-direction"):
                            self.bandwidth_direction = value
                            self.bandwidth_direction.value_namespace = name_space
                            self.bandwidth_direction.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-admission-method-allocated-bandwidth"):
                            self.is_admission_method_allocated_bandwidth = value
                            self.is_admission_method_allocated_bandwidth.value_namespace = name_space
                            self.is_admission_method_allocated_bandwidth.value_namespace_prefix = name_space_prefix


                class FloodingUpThreshold(Entity):
                    """
                    Flooding up\-thresholds
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__init__()

                        self.yang_name = "flooding-up-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.entry = YLeaf(YType.uint8, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flooding-up-threshold" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class FloodingDownThreshold(Entity):
                    """
                    Flooding down\-thresholds
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__init__()

                        self.yang_name = "flooding-down-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.entry = YLeaf(YType.uint8, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flooding-down-threshold" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.flooding_down_threshold:
                        if (c.has_data()):
                            return True
                    for c in self.flooding_up_threshold:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.bandwidth_descriptors.is_set or
                        self.bandwidth_pool.is_set or
                        self.flooding_down_thresholds_are_default.is_set or
                        self.flooding_down_thresholds_are_global.is_set or
                        self.flooding_up_thresholds_are_default.is_set or
                        self.flooding_up_thresholds_are_global.is_set or
                        self.total_bandwidth_descriptors.is_set or
                        (self.downstream_bandwidth is not None and self.downstream_bandwidth.has_data()) or
                        (self.link_common is not None and self.link_common.has_data()) or
                        (self.upstream_bandwidth is not None and self.upstream_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.flooding_down_threshold:
                        if (c.has_operation()):
                            return True
                    for c in self.flooding_up_threshold:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.bandwidth_descriptors.yfilter != YFilter.not_set or
                        self.bandwidth_pool.yfilter != YFilter.not_set or
                        self.flooding_down_thresholds_are_default.yfilter != YFilter.not_set or
                        self.flooding_down_thresholds_are_global.yfilter != YFilter.not_set or
                        self.flooding_up_thresholds_are_default.yfilter != YFilter.not_set or
                        self.flooding_up_thresholds_are_global.yfilter != YFilter.not_set or
                        self.total_bandwidth_descriptors.yfilter != YFilter.not_set or
                        (self.downstream_bandwidth is not None and self.downstream_bandwidth.has_operation()) or
                        (self.link_common is not None and self.link_common.has_operation()) or
                        (self.upstream_bandwidth is not None and self.upstream_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bandwidth-allocation-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/bandwidth-allocation-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.bandwidth_descriptors.is_set or self.bandwidth_descriptors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_descriptors.get_name_leafdata())
                    if (self.bandwidth_pool.is_set or self.bandwidth_pool.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool.get_name_leafdata())
                    if (self.flooding_down_thresholds_are_default.is_set or self.flooding_down_thresholds_are_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_down_thresholds_are_default.get_name_leafdata())
                    if (self.flooding_down_thresholds_are_global.is_set or self.flooding_down_thresholds_are_global.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_down_thresholds_are_global.get_name_leafdata())
                    if (self.flooding_up_thresholds_are_default.is_set or self.flooding_up_thresholds_are_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_up_thresholds_are_default.get_name_leafdata())
                    if (self.flooding_up_thresholds_are_global.is_set or self.flooding_up_thresholds_are_global.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_up_thresholds_are_global.get_name_leafdata())
                    if (self.total_bandwidth_descriptors.is_set or self.total_bandwidth_descriptors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_bandwidth_descriptors.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "downstream-bandwidth"):
                        if (self.downstream_bandwidth is None):
                            self.downstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                            self.downstream_bandwidth.parent = self
                            self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"
                        return self.downstream_bandwidth

                    if (child_yang_name == "flooding-down-threshold"):
                        for c in self.flooding_down_threshold:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.flooding_down_threshold.append(c)
                        return c

                    if (child_yang_name == "flooding-up-threshold"):
                        for c in self.flooding_up_threshold:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.flooding_up_threshold.append(c)
                        return c

                    if (child_yang_name == "link-common"):
                        if (self.link_common is None):
                            self.link_common = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                            self.link_common.parent = self
                            self._children_name_map["link_common"] = "link-common"
                        return self.link_common

                    if (child_yang_name == "upstream-bandwidth"):
                        if (self.upstream_bandwidth is None):
                            self.upstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                            self.upstream_bandwidth.parent = self
                            self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"
                        return self.upstream_bandwidth

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "downstream-bandwidth" or name == "flooding-down-threshold" or name == "flooding-up-threshold" or name == "link-common" or name == "upstream-bandwidth" or name == "interface-name" or name == "bandwidth-descriptors" or name == "bandwidth-pool" or name == "flooding-down-thresholds-are-default" or name == "flooding-down-thresholds-are-global" or name == "flooding-up-thresholds-are-default" or name == "flooding-up-thresholds-are-global" or name == "total-bandwidth-descriptors"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-descriptors"):
                        self.bandwidth_descriptors = value
                        self.bandwidth_descriptors.value_namespace = name_space
                        self.bandwidth_descriptors.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool"):
                        self.bandwidth_pool = value
                        self.bandwidth_pool.value_namespace = name_space
                        self.bandwidth_pool.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-down-thresholds-are-default"):
                        self.flooding_down_thresholds_are_default = value
                        self.flooding_down_thresholds_are_default.value_namespace = name_space
                        self.flooding_down_thresholds_are_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-down-thresholds-are-global"):
                        self.flooding_down_thresholds_are_global = value
                        self.flooding_down_thresholds_are_global.value_namespace = name_space
                        self.flooding_down_thresholds_are_global.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-up-thresholds-are-default"):
                        self.flooding_up_thresholds_are_default = value
                        self.flooding_up_thresholds_are_default.value_namespace = name_space
                        self.flooding_up_thresholds_are_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-up-thresholds-are-global"):
                        self.flooding_up_thresholds_are_global = value
                        self.flooding_up_thresholds_are_global.value_namespace = name_space
                        self.flooding_up_thresholds_are_global.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-bandwidth-descriptors"):
                        self.total_bandwidth_descriptors = value
                        self.total_bandwidth_descriptors.value_namespace = name_space
                        self.total_bandwidth_descriptors.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.bandwidth_allocation_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.bandwidth_allocation_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-allocation-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bandwidth-allocation-link"):
                    for c in self.bandwidth_allocation_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.bandwidth_allocation_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-allocation-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.bandwidth_allocation_links is not None and self.bandwidth_allocation_links.has_data()) or
                (self.global_ is not None and self.global_.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.bandwidth_allocation_links is not None and self.bandwidth_allocation_links.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bandwidth-allocation" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bandwidth-allocation-links"):
                if (self.bandwidth_allocation_links is None):
                    self.bandwidth_allocation_links = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks()
                    self.bandwidth_allocation_links.parent = self
                    self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
                return self.bandwidth_allocation_links

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcacStandby.BandwidthAllocation.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bandwidth-allocation-links" or name == "global"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Gmpls(Entity):
        """
        GMPLS data
        
        .. attribute:: nni
        
        	GMPLS NNI data
        	**type**\:   :py:class:`Nni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni>`
        
        .. attribute:: uni
        
        	GMPLS UNI data
        	**type**\:   :py:class:`Uni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.Gmpls, self).__init__()

            self.yang_name = "gmpls"
            self.yang_parent_name = "mpls-lcac-standby"

            self.nni = MplsLcacStandby.Gmpls.Nni()
            self.nni.parent = self
            self._children_name_map["nni"] = "nni"
            self._children_yang_names.add("nni")

            self.uni = MplsLcacStandby.Gmpls.Uni()
            self.uni.parent = self
            self._children_name_map["uni"] = "uni"
            self._children_yang_names.add("uni")


        class Nni(Entity):
            """
            GMPLS NNI data
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Gmpls.Nni, self).__init__()

                self.yang_name = "nni"
                self.yang_parent_name = "gmpls"

            def has_data(self):
                return False

            def has_operation(self):
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nni" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Uni(Entity):
            """
            GMPLS UNI data
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.Gmpls.Uni, self).__init__()

                self.yang_name = "uni"
                self.yang_parent_name = "gmpls"

            def has_data(self):
                return False

            def has_operation(self):
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "uni" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.nni is not None and self.nni.has_data()) or
                (self.uni is not None and self.uni.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.nni is not None and self.nni.has_operation()) or
                (self.uni is not None and self.uni.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "gmpls" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "nni"):
                if (self.nni is None):
                    self.nni = MplsLcacStandby.Gmpls.Nni()
                    self.nni.parent = self
                    self._children_name_map["nni"] = "nni"
                return self.nni

            if (child_yang_name == "uni"):
                if (self.uni is None):
                    self.uni = MplsLcacStandby.Gmpls.Uni()
                    self.uni.parent = self
                    self._children_name_map["uni"] = "uni"
                return self.uni

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "nni" or name == "uni"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BfdNeighbors(Entity):
        """
        BFD Neighbors
        
        .. attribute:: bfd_neighbor
        
        	A BFD Neighbor
        	**type**\: list of    :py:class:`BfdNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors.BfdNeighbor>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.BfdNeighbors, self).__init__()

            self.yang_name = "bfd-neighbors"
            self.yang_parent_name = "mpls-lcac-standby"

            self.bfd_neighbor = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.BfdNeighbors, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.BfdNeighbors, self).__setattr__(name, value)


        class BfdNeighbor(Entity):
            """
            A BFD Neighbor
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.BfdNeighbors.BfdNeighbor, self).__init__()

                self.yang_name = "bfd-neighbor"
                self.yang_parent_name = "bfd-neighbors"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.neighbor = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.BfdNeighbors.BfdNeighbor, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.BfdNeighbors.BfdNeighbor, self).__setattr__(name, value)


            class Neighbor(Entity):
                """
                Neighbors of the specified link id
                
                .. attribute:: is_bfd_up
                
                	TRUE if the BFD session is Up on this link
                	**type**\:  bool
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "bfd-neighbor"

                    self.is_bfd_up = YLeaf(YType.boolean, "is-bfd-up")

                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_bfd_up",
                                    "neighbor_address") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.is_bfd_up.is_set or
                        self.neighbor_address.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_bfd_up.yfilter != YFilter.not_set or
                        self.neighbor_address.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "neighbor" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_bfd_up.is_set or self.is_bfd_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bfd_up.get_name_leafdata())
                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "is-bfd-up" or name == "neighbor-address"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-bfd-up"):
                        self.is_bfd_up = value
                        self.is_bfd_up.value_namespace = name_space
                        self.is_bfd_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-address"):
                        self.neighbor_address = value
                        self.neighbor_address.value_namespace = name_space
                        self.neighbor_address.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.neighbor:
                    if (c.has_data()):
                        return True
                return self.interface_name.is_set

            def has_operation(self):
                for c in self.neighbor:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bfd-neighbor" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bfd-neighbors/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "neighbor"):
                    for c in self.neighbor:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.neighbor.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "neighbor" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.bfd_neighbor:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.bfd_neighbor:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bfd-neighbors" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bfd-neighbor"):
                for c in self.bfd_neighbor:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.BfdNeighbors.BfdNeighbor()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.bfd_neighbor.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bfd-neighbor"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BandwidthAccount(Entity):
        """
        The bandwidth accounting information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_account_links
        
        	The interface bandwidth accounting information table
        	**type**\:   :py:class:`BandwidthAccountLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.BandwidthAccount, self).__init__()

            self.yang_name = "bandwidth-account"
            self.yang_parent_name = "mpls-lcac-standby"

            self.bandwidth_account_links = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks()
            self.bandwidth_account_links.parent = self
            self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
            self._children_yang_names.add("bandwidth-account-links")


        class BandwidthAccountLinks(Entity):
            """
            The interface bandwidth accounting information
            table
            
            .. attribute:: bandwidth_account_link
            
            	An interface in bandwidth accounting table
            	**type**\: list of    :py:class:`BandwidthAccountLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks, self).__init__()

                self.yang_name = "bandwidth-account-links"
                self.yang_parent_name = "bandwidth-account"

                self.bandwidth_account_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks, self).__setattr__(name, value)


            class BandwidthAccountLink(Entity):
                """
                An interface in bandwidth accounting table
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: common_info
                
                	Information for bandwidth accounting telemetry
                	**type**\:   :py:class:`CommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo>`
                
                .. attribute:: link_id
                
                	The link's ID
                	**type**\:  str
                
                .. attribute:: rsvp_te_sample_history
                
                	History of bandwidth accounting RSVP\-TE samples
                	**type**\:   :py:class:`RsvpTeSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory>`
                
                .. attribute:: sr_sample_history
                
                	History of bandwidth accounting Segment Routing samples
                	**type**\:   :py:class:`SrSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__init__()

                    self.yang_name = "bandwidth-account-link"
                    self.yang_parent_name = "bandwidth-account-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.link_id = YLeaf(YType.str, "link-id")

                    self.common_info = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                    self.common_info.parent = self
                    self._children_name_map["common_info"] = "common-info"
                    self._children_yang_names.add("common-info")

                    self.rsvp_te_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                    self.rsvp_te_sample_history.parent = self
                    self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"
                    self._children_yang_names.add("rsvp-te-sample-history")

                    self.sr_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                    self.sr_sample_history.parent = self
                    self._children_name_map["sr_sample_history"] = "sr-sample-history"
                    self._children_yang_names.add("sr-sample-history")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "link_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__setattr__(name, value)


                class CommonInfo(Entity):
                    """
                    Information for bandwidth accounting telemetry
                    
                    .. attribute:: application_enforced
                    
                    	TRUE if application is enforced
                    	**type**\:  bool
                    
                    .. attribute:: application_time_remaining_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next application
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: collection_type
                    
                    	The type of traffic collected for bandwidth accounting
                    	**type**\:   :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                    
                    .. attribute:: effective_maximum_reservable_bandwidth
                    
                    	Maximum reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_bandwidth_account_enabled
                    
                    	TRUE if bandwidth accounting is enabled
                    	**type**\:  bool
                    
                    .. attribute:: last_application_timestamp_nanosec
                    
                    	Timestamp for the last application in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_sample_collection_timestamp_nanosec
                    
                    	Timestamp for the last sample collection in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_application_timestamp_nanosec
                    
                    	Timestamp for the next application in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_sample_collection_nanosec
                    
                    	Timestamp for the next sample collection in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: rsvp_te_bandwidth_utilization
                    
                    	RSVP\-TE bandwidth utilization information
                    	**type**\:   :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization>`
                    
                    .. attribute:: sample_time_remaining_timestamp_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next sampling
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: sr_bandwidth_utilization
                    
                    	Segment Routing bandwidth utilization information
                    	**type**\:   :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__init__()

                        self.yang_name = "common-info"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.application_enforced = YLeaf(YType.boolean, "application-enforced")

                        self.application_time_remaining_nanosec = YLeaf(YType.uint64, "application-time-remaining-nanosec")

                        self.collection_type = YLeaf(YType.enumeration, "collection-type")

                        self.effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "effective-maximum-reservable-bandwidth")

                        self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                        self.last_application_timestamp_nanosec = YLeaf(YType.uint64, "last-application-timestamp-nanosec")

                        self.last_sample_collection_timestamp_nanosec = YLeaf(YType.uint64, "last-sample-collection-timestamp-nanosec")

                        self.next_application_timestamp_nanosec = YLeaf(YType.uint64, "next-application-timestamp-nanosec")

                        self.next_sample_collection_nanosec = YLeaf(YType.uint64, "next-sample-collection-nanosec")

                        self.sample_time_remaining_timestamp_nanosec = YLeaf(YType.uint64, "sample-time-remaining-timestamp-nanosec")

                        self.rsvp_te_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                        self.rsvp_te_bandwidth_utilization.parent = self
                        self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                        self._children_yang_names.add("rsvp-te-bandwidth-utilization")

                        self.sr_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                        self.sr_bandwidth_utilization.parent = self
                        self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                        self._children_yang_names.add("sr-bandwidth-utilization")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_enforced",
                                        "application_time_remaining_nanosec",
                                        "collection_type",
                                        "effective_maximum_reservable_bandwidth",
                                        "is_bandwidth_account_enabled",
                                        "last_application_timestamp_nanosec",
                                        "last_sample_collection_timestamp_nanosec",
                                        "next_application_timestamp_nanosec",
                                        "next_sample_collection_nanosec",
                                        "sample_time_remaining_timestamp_nanosec") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__setattr__(name, value)


                    class RsvpTeBandwidthUtilization(Entity):
                        """
                        RSVP\-TE bandwidth utilization information
                        
                        .. attribute:: non_rsvp_te_bandwidth_utilization
                        
                        	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                        
                        	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_enforced_bandwidth_utilization
                        
                        	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_link_bandwidth_utilization
                        
                        	Total bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-utilization"
                            self.yang_parent_name = "common-info"

                            self.non_rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "non-rsvp-te-bandwidth-utilization")

                            self.rsvp_te_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-adjusted-bandwidth-utilization")

                            self.rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-bandwidth-utilization")

                            self.rsvp_te_enforced_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-enforced-bandwidth-utilization")

                            self.total_link_bandwidth_utilization = YLeaf(YType.uint64, "total-link-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_bandwidth_utilization",
                                            "rsvp_te_adjusted_bandwidth_utilization",
                                            "rsvp_te_bandwidth_utilization",
                                            "rsvp_te_enforced_bandwidth_utilization",
                                            "total_link_bandwidth_utilization") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_bandwidth_utilization.is_set or
                                self.rsvp_te_adjusted_bandwidth_utilization.is_set or
                                self.rsvp_te_bandwidth_utilization.is_set or
                                self.rsvp_te_enforced_bandwidth_utilization.is_set or
                                self.total_link_bandwidth_utilization.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.total_link_bandwidth_utilization.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-bandwidth-utilization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_bandwidth_utilization.is_set or self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_adjusted_bandwidth_utilization.is_set or self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_adjusted_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_bandwidth_utilization.is_set or self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_enforced_bandwidth_utilization.is_set or self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_enforced_bandwidth_utilization.get_name_leafdata())
                            if (self.total_link_bandwidth_utilization.is_set or self.total_link_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_link_bandwidth_utilization.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-bandwidth-utilization" or name == "rsvp-te-adjusted-bandwidth-utilization" or name == "rsvp-te-bandwidth-utilization" or name == "rsvp-te-enforced-bandwidth-utilization" or name == "total-link-bandwidth-utilization"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-bandwidth-utilization"):
                                self.non_rsvp_te_bandwidth_utilization = value
                                self.non_rsvp_te_bandwidth_utilization.value_namespace = name_space
                                self.non_rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-adjusted-bandwidth-utilization"):
                                self.rsvp_te_adjusted_bandwidth_utilization = value
                                self.rsvp_te_adjusted_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-bandwidth-utilization"):
                                self.rsvp_te_bandwidth_utilization = value
                                self.rsvp_te_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-enforced-bandwidth-utilization"):
                                self.rsvp_te_enforced_bandwidth_utilization = value
                                self.rsvp_te_enforced_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-link-bandwidth-utilization"):
                                self.total_link_bandwidth_utilization = value
                                self.total_link_bandwidth_utilization.value_namespace = name_space
                                self.total_link_bandwidth_utilization.value_namespace_prefix = name_space_prefix


                    class SrBandwidthUtilization(Entity):
                        """
                        Segment Routing bandwidth utilization
                        information
                        
                        .. attribute:: sr_adjusted_bandwidth_utilization
                        
                        	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_enforced_bandwidth_utilization
                        
                        	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__init__()

                            self.yang_name = "sr-bandwidth-utilization"
                            self.yang_parent_name = "common-info"

                            self.sr_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "sr-adjusted-bandwidth-utilization")

                            self.sr_bandwidth_utilization = YLeaf(YType.uint64, "sr-bandwidth-utilization")

                            self.sr_enforced_bandwidth_utilization = YLeaf(YType.uint64, "sr-enforced-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_adjusted_bandwidth_utilization",
                                            "sr_bandwidth_utilization",
                                            "sr_enforced_bandwidth_utilization") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_adjusted_bandwidth_utilization.is_set or
                                self.sr_bandwidth_utilization.is_set or
                                self.sr_enforced_bandwidth_utilization.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.sr_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-bandwidth-utilization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_adjusted_bandwidth_utilization.is_set or self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_adjusted_bandwidth_utilization.get_name_leafdata())
                            if (self.sr_bandwidth_utilization.is_set or self.sr_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_bandwidth_utilization.get_name_leafdata())
                            if (self.sr_enforced_bandwidth_utilization.is_set or self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_enforced_bandwidth_utilization.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-adjusted-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "sr-enforced-bandwidth-utilization"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-adjusted-bandwidth-utilization"):
                                self.sr_adjusted_bandwidth_utilization = value
                                self.sr_adjusted_bandwidth_utilization.value_namespace = name_space
                                self.sr_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-bandwidth-utilization"):
                                self.sr_bandwidth_utilization = value
                                self.sr_bandwidth_utilization.value_namespace = name_space
                                self.sr_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-enforced-bandwidth-utilization"):
                                self.sr_enforced_bandwidth_utilization = value
                                self.sr_enforced_bandwidth_utilization.value_namespace = name_space
                                self.sr_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.application_enforced.is_set or
                            self.application_time_remaining_nanosec.is_set or
                            self.collection_type.is_set or
                            self.effective_maximum_reservable_bandwidth.is_set or
                            self.is_bandwidth_account_enabled.is_set or
                            self.last_application_timestamp_nanosec.is_set or
                            self.last_sample_collection_timestamp_nanosec.is_set or
                            self.next_application_timestamp_nanosec.is_set or
                            self.next_sample_collection_nanosec.is_set or
                            self.sample_time_remaining_timestamp_nanosec.is_set or
                            (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_data()) or
                            (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_enforced.yfilter != YFilter.not_set or
                            self.application_time_remaining_nanosec.yfilter != YFilter.not_set or
                            self.collection_type.yfilter != YFilter.not_set or
                            self.effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                            self.last_application_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.last_sample_collection_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.next_application_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.next_sample_collection_nanosec.yfilter != YFilter.not_set or
                            self.sample_time_remaining_timestamp_nanosec.yfilter != YFilter.not_set or
                            (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_operation()) or
                            (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "common-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_enforced.is_set or self.application_enforced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_enforced.get_name_leafdata())
                        if (self.application_time_remaining_nanosec.is_set or self.application_time_remaining_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_time_remaining_nanosec.get_name_leafdata())
                        if (self.collection_type.is_set or self.collection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.collection_type.get_name_leafdata())
                        if (self.effective_maximum_reservable_bandwidth.is_set or self.effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                        if (self.last_application_timestamp_nanosec.is_set or self.last_application_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_application_timestamp_nanosec.get_name_leafdata())
                        if (self.last_sample_collection_timestamp_nanosec.is_set or self.last_sample_collection_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_sample_collection_timestamp_nanosec.get_name_leafdata())
                        if (self.next_application_timestamp_nanosec.is_set or self.next_application_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_application_timestamp_nanosec.get_name_leafdata())
                        if (self.next_sample_collection_nanosec.is_set or self.next_sample_collection_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_sample_collection_nanosec.get_name_leafdata())
                        if (self.sample_time_remaining_timestamp_nanosec.is_set or self.sample_time_remaining_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sample_time_remaining_timestamp_nanosec.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rsvp-te-bandwidth-utilization"):
                            if (self.rsvp_te_bandwidth_utilization is None):
                                self.rsvp_te_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                                self.rsvp_te_bandwidth_utilization.parent = self
                                self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                            return self.rsvp_te_bandwidth_utilization

                        if (child_yang_name == "sr-bandwidth-utilization"):
                            if (self.sr_bandwidth_utilization is None):
                                self.sr_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                                self.sr_bandwidth_utilization.parent = self
                                self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            return self.sr_bandwidth_utilization

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rsvp-te-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "application-enforced" or name == "application-time-remaining-nanosec" or name == "collection-type" or name == "effective-maximum-reservable-bandwidth" or name == "is-bandwidth-account-enabled" or name == "last-application-timestamp-nanosec" or name == "last-sample-collection-timestamp-nanosec" or name == "next-application-timestamp-nanosec" or name == "next-sample-collection-nanosec" or name == "sample-time-remaining-timestamp-nanosec"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-enforced"):
                            self.application_enforced = value
                            self.application_enforced.value_namespace = name_space
                            self.application_enforced.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-time-remaining-nanosec"):
                            self.application_time_remaining_nanosec = value
                            self.application_time_remaining_nanosec.value_namespace = name_space
                            self.application_time_remaining_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "collection-type"):
                            self.collection_type = value
                            self.collection_type.value_namespace = name_space
                            self.collection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "effective-maximum-reservable-bandwidth"):
                            self.effective_maximum_reservable_bandwidth = value
                            self.effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-account-enabled"):
                            self.is_bandwidth_account_enabled = value
                            self.is_bandwidth_account_enabled.value_namespace = name_space
                            self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-application-timestamp-nanosec"):
                            self.last_application_timestamp_nanosec = value
                            self.last_application_timestamp_nanosec.value_namespace = name_space
                            self.last_application_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-sample-collection-timestamp-nanosec"):
                            self.last_sample_collection_timestamp_nanosec = value
                            self.last_sample_collection_timestamp_nanosec.value_namespace = name_space
                            self.last_sample_collection_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-application-timestamp-nanosec"):
                            self.next_application_timestamp_nanosec = value
                            self.next_application_timestamp_nanosec.value_namespace = name_space
                            self.next_application_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-sample-collection-nanosec"):
                            self.next_sample_collection_nanosec = value
                            self.next_sample_collection_nanosec.value_namespace = name_space
                            self.next_sample_collection_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "sample-time-remaining-timestamp-nanosec"):
                            self.sample_time_remaining_timestamp_nanosec = value
                            self.sample_time_remaining_timestamp_nanosec.value_namespace = name_space
                            self.sample_time_remaining_timestamp_nanosec.value_namespace_prefix = name_space_prefix


                class RsvpTeSampleHistory(Entity):
                    """
                    History of bandwidth accounting RSVP\-TE samples
                    
                    .. attribute:: rsvp_te_active_interval_sample
                    
                    	RSVP\-TE samples in the current application interval
                    	**type**\: list of    :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample>`
                    
                    .. attribute:: rsvp_te_previous_interval_sample
                    
                    	RSVP\-TE samples in the previous application interval
                    	**type**\: list of    :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__init__()

                        self.yang_name = "rsvp-te-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.rsvp_te_active_interval_sample = YList(self)
                        self.rsvp_te_previous_interval_sample = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__setattr__(name, value)


                    class RsvpTeActiveIntervalSample(Entity):
                        """
                        RSVP\-TE samples in the current application
                        interval
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-active-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"

                            self.non_rsvp_te_packet_rate = YLeaf(YType.uint64, "non-rsvp-te-packet-rate")

                            self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                            self.rsvp_te_packet_rate = YLeaf(YType.uint64, "rsvp-te-packet-rate")

                            self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                            self.total_packet_rate = YLeaf(YType.uint64, "total-packet-rate")

                            self.total_rate = YLeaf(YType.uint64, "total-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_packet_rate",
                                            "non_rsvp_te_rate",
                                            "rsvp_te_packet_rate",
                                            "rsvp_te_rate",
                                            "timestamp_nanosec",
                                            "total_packet_rate",
                                            "total_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_packet_rate.is_set or
                                self.non_rsvp_te_rate.is_set or
                                self.rsvp_te_packet_rate.is_set or
                                self.rsvp_te_rate.is_set or
                                self.timestamp_nanosec.is_set or
                                self.total_packet_rate.is_set or
                                self.total_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set or
                                self.total_packet_rate.yfilter != YFilter.not_set or
                                self.total_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-active-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_packet_rate.is_set or self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_packet_rate.get_name_leafdata())
                            if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                            if (self.rsvp_te_packet_rate.is_set or self.rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_packet_rate.get_name_leafdata())
                            if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())
                            if (self.total_packet_rate.is_set or self.total_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_packet_rate.get_name_leafdata())
                            if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-packet-rate" or name == "non-rsvp-te-rate" or name == "rsvp-te-packet-rate" or name == "rsvp-te-rate" or name == "timestamp-nanosec" or name == "total-packet-rate" or name == "total-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-packet-rate"):
                                self.non_rsvp_te_packet_rate = value
                                self.non_rsvp_te_packet_rate.value_namespace = name_space
                                self.non_rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "non-rsvp-te-rate"):
                                self.non_rsvp_te_rate = value
                                self.non_rsvp_te_rate.value_namespace = name_space
                                self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-packet-rate"):
                                self.rsvp_te_packet_rate = value
                                self.rsvp_te_packet_rate.value_namespace = name_space
                                self.rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-rate"):
                                self.rsvp_te_rate = value
                                self.rsvp_te_rate.value_namespace = name_space
                                self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-packet-rate"):
                                self.total_packet_rate = value
                                self.total_packet_rate.value_namespace = name_space
                                self.total_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-rate"):
                                self.total_rate = value
                                self.total_rate.value_namespace = name_space
                                self.total_rate.value_namespace_prefix = name_space_prefix


                    class RsvpTePreviousIntervalSample(Entity):
                        """
                        RSVP\-TE samples in the previous application
                        interval
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-previous-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"

                            self.non_rsvp_te_packet_rate = YLeaf(YType.uint64, "non-rsvp-te-packet-rate")

                            self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                            self.rsvp_te_packet_rate = YLeaf(YType.uint64, "rsvp-te-packet-rate")

                            self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                            self.total_packet_rate = YLeaf(YType.uint64, "total-packet-rate")

                            self.total_rate = YLeaf(YType.uint64, "total-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_packet_rate",
                                            "non_rsvp_te_rate",
                                            "rsvp_te_packet_rate",
                                            "rsvp_te_rate",
                                            "timestamp_nanosec",
                                            "total_packet_rate",
                                            "total_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_packet_rate.is_set or
                                self.non_rsvp_te_rate.is_set or
                                self.rsvp_te_packet_rate.is_set or
                                self.rsvp_te_rate.is_set or
                                self.timestamp_nanosec.is_set or
                                self.total_packet_rate.is_set or
                                self.total_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set or
                                self.total_packet_rate.yfilter != YFilter.not_set or
                                self.total_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-previous-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_packet_rate.is_set or self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_packet_rate.get_name_leafdata())
                            if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                            if (self.rsvp_te_packet_rate.is_set or self.rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_packet_rate.get_name_leafdata())
                            if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())
                            if (self.total_packet_rate.is_set or self.total_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_packet_rate.get_name_leafdata())
                            if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-packet-rate" or name == "non-rsvp-te-rate" or name == "rsvp-te-packet-rate" or name == "rsvp-te-rate" or name == "timestamp-nanosec" or name == "total-packet-rate" or name == "total-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-packet-rate"):
                                self.non_rsvp_te_packet_rate = value
                                self.non_rsvp_te_packet_rate.value_namespace = name_space
                                self.non_rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "non-rsvp-te-rate"):
                                self.non_rsvp_te_rate = value
                                self.non_rsvp_te_rate.value_namespace = name_space
                                self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-packet-rate"):
                                self.rsvp_te_packet_rate = value
                                self.rsvp_te_packet_rate.value_namespace = name_space
                                self.rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-rate"):
                                self.rsvp_te_rate = value
                                self.rsvp_te_rate.value_namespace = name_space
                                self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-packet-rate"):
                                self.total_packet_rate = value
                                self.total_packet_rate.value_namespace = name_space
                                self.total_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-rate"):
                                self.total_rate = value
                                self.total_rate.value_namespace = name_space
                                self.total_rate.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.rsvp_te_active_interval_sample:
                            if (c.has_data()):
                                return True
                        for c in self.rsvp_te_previous_interval_sample:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.rsvp_te_active_interval_sample:
                            if (c.has_operation()):
                                return True
                        for c in self.rsvp_te_previous_interval_sample:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rsvp-te-sample-history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rsvp-te-active-interval-sample"):
                            for c in self.rsvp_te_active_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.rsvp_te_active_interval_sample.append(c)
                            return c

                        if (child_yang_name == "rsvp-te-previous-interval-sample"):
                            for c in self.rsvp_te_previous_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.rsvp_te_previous_interval_sample.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rsvp-te-active-interval-sample" or name == "rsvp-te-previous-interval-sample"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class SrSampleHistory(Entity):
                    """
                    History of bandwidth accounting Segment Routing
                    samples
                    
                    .. attribute:: sr_active_interval_sample
                    
                    	Segment Routing samples in the current application interval
                    	**type**\: list of    :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample>`
                    
                    .. attribute:: sr_previous_interval_sample
                    
                    	Segment Routing samples in the previous application interval
                    	**type**\: list of    :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__init__()

                        self.yang_name = "sr-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.sr_active_interval_sample = YList(self)
                        self.sr_previous_interval_sample = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__setattr__(name, value)


                    class SrActiveIntervalSample(Entity):
                        """
                        Segment Routing samples in the current
                        application interval
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__init__()

                            self.yang_name = "sr-active-interval-sample"
                            self.yang_parent_name = "sr-sample-history"

                            self.sr_packet_rate = YLeaf(YType.uint64, "sr-packet-rate")

                            self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_packet_rate",
                                            "sr_rate",
                                            "timestamp_nanosec") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_packet_rate.is_set or
                                self.sr_rate.is_set or
                                self.timestamp_nanosec.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_packet_rate.yfilter != YFilter.not_set or
                                self.sr_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-active-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_packet_rate.is_set or self.sr_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_packet_rate.get_name_leafdata())
                            if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-packet-rate" or name == "sr-rate" or name == "timestamp-nanosec"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-packet-rate"):
                                self.sr_packet_rate = value
                                self.sr_packet_rate.value_namespace = name_space
                                self.sr_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-rate"):
                                self.sr_rate = value
                                self.sr_rate.value_namespace = name_space
                                self.sr_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix


                    class SrPreviousIntervalSample(Entity):
                        """
                        Segment Routing samples in the previous
                        application interval
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__init__()

                            self.yang_name = "sr-previous-interval-sample"
                            self.yang_parent_name = "sr-sample-history"

                            self.sr_packet_rate = YLeaf(YType.uint64, "sr-packet-rate")

                            self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_packet_rate",
                                            "sr_rate",
                                            "timestamp_nanosec") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_packet_rate.is_set or
                                self.sr_rate.is_set or
                                self.timestamp_nanosec.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_packet_rate.yfilter != YFilter.not_set or
                                self.sr_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-previous-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_packet_rate.is_set or self.sr_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_packet_rate.get_name_leafdata())
                            if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-packet-rate" or name == "sr-rate" or name == "timestamp-nanosec"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-packet-rate"):
                                self.sr_packet_rate = value
                                self.sr_packet_rate.value_namespace = name_space
                                self.sr_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-rate"):
                                self.sr_rate = value
                                self.sr_rate.value_namespace = name_space
                                self.sr_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.sr_active_interval_sample:
                            if (c.has_data()):
                                return True
                        for c in self.sr_previous_interval_sample:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.sr_active_interval_sample:
                            if (c.has_operation()):
                                return True
                        for c in self.sr_previous_interval_sample:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-sample-history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "sr-active-interval-sample"):
                            for c in self.sr_active_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.sr_active_interval_sample.append(c)
                            return c

                        if (child_yang_name == "sr-previous-interval-sample"):
                            for c in self.sr_previous_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.sr_previous_interval_sample.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "sr-active-interval-sample" or name == "sr-previous-interval-sample"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.link_id.is_set or
                        (self.common_info is not None and self.common_info.has_data()) or
                        (self.rsvp_te_sample_history is not None and self.rsvp_te_sample_history.has_data()) or
                        (self.sr_sample_history is not None and self.sr_sample_history.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        (self.common_info is not None and self.common_info.has_operation()) or
                        (self.rsvp_te_sample_history is not None and self.rsvp_te_sample_history.has_operation()) or
                        (self.sr_sample_history is not None and self.sr_sample_history.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bandwidth-account-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-account/bandwidth-account-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "common-info"):
                        if (self.common_info is None):
                            self.common_info = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                            self.common_info.parent = self
                            self._children_name_map["common_info"] = "common-info"
                        return self.common_info

                    if (child_yang_name == "rsvp-te-sample-history"):
                        if (self.rsvp_te_sample_history is None):
                            self.rsvp_te_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                            self.rsvp_te_sample_history.parent = self
                            self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"
                        return self.rsvp_te_sample_history

                    if (child_yang_name == "sr-sample-history"):
                        if (self.sr_sample_history is None):
                            self.sr_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                            self.sr_sample_history.parent = self
                            self._children_name_map["sr_sample_history"] = "sr-sample-history"
                        return self.sr_sample_history

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "common-info" or name == "rsvp-te-sample-history" or name == "sr-sample-history" or name == "interface-name" or name == "link-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.bandwidth_account_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.bandwidth_account_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-account-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-account/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bandwidth-account-link"):
                    for c in self.bandwidth_account_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.bandwidth_account_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-account-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.bandwidth_account_links is not None and self.bandwidth_account_links.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.bandwidth_account_links is not None and self.bandwidth_account_links.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bandwidth-account" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bandwidth-account-links"):
                if (self.bandwidth_account_links is None):
                    self.bandwidth_account_links = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks()
                    self.bandwidth_account_links.parent = self
                    self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
                return self.bandwidth_account_links

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bandwidth-account-links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LinkSummary(Entity):
        """
        The global summary for all the interfaces
        
        .. attribute:: areas_summary
        
        	Summary info for the areas
        	**type**\: list of    :py:class:`AreasSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary.AreasSummary>`
        
        .. attribute:: bandwidth_account_summary
        
        	Bandwidth account summary
        	**type**\:   :py:class:`BandwidthAccountSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary.BandwidthAccountSummary>`
        
        .. attribute:: is_flooding_enabled
        
        	TRUE if flooding is enabled
        	**type**\:  bool
        
        .. attribute:: is_role_standby
        
        	TRUE if Role is Standby, Active otherwise
        	**type**\:  bool
        
        .. attribute:: links
        
        	Total number of links
        	**type**\:  int
        
        	**range:** 0..65535
        
        .. attribute:: maximum_links
        
        	Maximum number of links supported
        	**type**\:  int
        
        	**range:** 0..65535
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.LinkSummary, self).__init__()

            self.yang_name = "link-summary"
            self.yang_parent_name = "mpls-lcac-standby"

            self.is_flooding_enabled = YLeaf(YType.boolean, "is-flooding-enabled")

            self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

            self.links = YLeaf(YType.uint16, "links")

            self.maximum_links = YLeaf(YType.uint16, "maximum-links")

            self.bandwidth_account_summary = MplsLcacStandby.LinkSummary.BandwidthAccountSummary()
            self.bandwidth_account_summary.parent = self
            self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"
            self._children_yang_names.add("bandwidth-account-summary")

            self.areas_summary = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("is_flooding_enabled",
                            "is_role_standby",
                            "links",
                            "maximum_links") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.LinkSummary, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.LinkSummary, self).__setattr__(name, value)


        class BandwidthAccountSummary(Entity):
            """
            Bandwidth account summary
            
            .. attribute:: application_interval
            
            	Application interval for bandwidth accounting stats
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: application_time_remaining
            
            	This value indicates the number of seconds until the next application
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: is_bandwidth_account_enabled
            
            	TRUE if bandwidth accounting is enabled
            	**type**\:  bool
            
            .. attribute:: sample_interval
            
            	Sample interval for bandwidth accounting stats
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: sample_time_remaining
            
            	This value indicates the number of seconds until the next sample collection
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.LinkSummary.BandwidthAccountSummary, self).__init__()

                self.yang_name = "bandwidth-account-summary"
                self.yang_parent_name = "link-summary"

                self.application_interval = YLeaf(YType.uint32, "application-interval")

                self.application_time_remaining = YLeaf(YType.uint32, "application-time-remaining")

                self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                self.sample_interval = YLeaf(YType.uint32, "sample-interval")

                self.sample_time_remaining = YLeaf(YType.uint32, "sample-time-remaining")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("application_interval",
                                "application_time_remaining",
                                "is_bandwidth_account_enabled",
                                "sample_interval",
                                "sample_time_remaining") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.LinkSummary.BandwidthAccountSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.LinkSummary.BandwidthAccountSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.application_interval.is_set or
                    self.application_time_remaining.is_set or
                    self.is_bandwidth_account_enabled.is_set or
                    self.sample_interval.is_set or
                    self.sample_time_remaining.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.application_interval.yfilter != YFilter.not_set or
                    self.application_time_remaining.yfilter != YFilter.not_set or
                    self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                    self.sample_interval.yfilter != YFilter.not_set or
                    self.sample_time_remaining.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-account-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.application_interval.is_set or self.application_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_interval.get_name_leafdata())
                if (self.application_time_remaining.is_set or self.application_time_remaining.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_time_remaining.get_name_leafdata())
                if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                if (self.sample_interval.is_set or self.sample_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sample_interval.get_name_leafdata())
                if (self.sample_time_remaining.is_set or self.sample_time_remaining.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sample_time_remaining.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-interval" or name == "application-time-remaining" or name == "is-bandwidth-account-enabled" or name == "sample-interval" or name == "sample-time-remaining"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "application-interval"):
                    self.application_interval = value
                    self.application_interval.value_namespace = name_space
                    self.application_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "application-time-remaining"):
                    self.application_time_remaining = value
                    self.application_time_remaining.value_namespace = name_space
                    self.application_time_remaining.value_namespace_prefix = name_space_prefix
                if(value_path == "is-bandwidth-account-enabled"):
                    self.is_bandwidth_account_enabled = value
                    self.is_bandwidth_account_enabled.value_namespace = name_space
                    self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "sample-interval"):
                    self.sample_interval = value
                    self.sample_interval.value_namespace = name_space
                    self.sample_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "sample-time-remaining"):
                    self.sample_time_remaining = value
                    self.sample_time_remaining.value_namespace = name_space
                    self.sample_time_remaining.value_namespace_prefix = name_space_prefix


        class AreasSummary(Entity):
            """
            Summary info for the areas
            
            .. attribute:: area_id
            
            	Area id
            	**type**\:  str
            
            .. attribute:: igp_neighbors
            
            	Number of IGP neighbors
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: is_flooded
            
            	TRUE if flooding occurred in this area
            	**type**\:  bool
            
            .. attribute:: is_periodic_flooding_on
            
            	TRUE if periodic flooding is on
            	**type**\:  bool
            
            .. attribute:: links_flooded
            
            	Number of flooded links
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: local_node_router_id
            
            	Local router id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: periodic_flooding_interval
            
            	Flooding period in seconds
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: protocol
            
            	Protocol running over the area
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: system_id
            
            	IGP id of local node
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.LinkSummary.AreasSummary, self).__init__()

                self.yang_name = "areas-summary"
                self.yang_parent_name = "link-summary"

                self.area_id = YLeaf(YType.str, "area-id")

                self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                self.is_flooded = YLeaf(YType.boolean, "is-flooded")

                self.is_periodic_flooding_on = YLeaf(YType.boolean, "is-periodic-flooding-on")

                self.links_flooded = YLeaf(YType.uint16, "links-flooded")

                self.local_node_router_id = YLeaf(YType.str, "local-node-router-id")

                self.periodic_flooding_interval = YLeaf(YType.uint16, "periodic-flooding-interval")

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.system_id = YLeaf(YType.str, "system-id")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("area_id",
                                "igp_neighbors",
                                "is_flooded",
                                "is_periodic_flooding_on",
                                "links_flooded",
                                "local_node_router_id",
                                "periodic_flooding_interval",
                                "protocol",
                                "system_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.LinkSummary.AreasSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.LinkSummary.AreasSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.area_id.is_set or
                    self.igp_neighbors.is_set or
                    self.is_flooded.is_set or
                    self.is_periodic_flooding_on.is_set or
                    self.links_flooded.is_set or
                    self.local_node_router_id.is_set or
                    self.periodic_flooding_interval.is_set or
                    self.protocol.is_set or
                    self.system_id.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.area_id.yfilter != YFilter.not_set or
                    self.igp_neighbors.yfilter != YFilter.not_set or
                    self.is_flooded.yfilter != YFilter.not_set or
                    self.is_periodic_flooding_on.yfilter != YFilter.not_set or
                    self.links_flooded.yfilter != YFilter.not_set or
                    self.local_node_router_id.yfilter != YFilter.not_set or
                    self.periodic_flooding_interval.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.system_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "areas-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area_id.get_name_leafdata())
                if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                if (self.is_flooded.is_set or self.is_flooded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_flooded.get_name_leafdata())
                if (self.is_periodic_flooding_on.is_set or self.is_periodic_flooding_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_periodic_flooding_on.get_name_leafdata())
                if (self.links_flooded.is_set or self.links_flooded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links_flooded.get_name_leafdata())
                if (self.local_node_router_id.is_set or self.local_node_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_node_router_id.get_name_leafdata())
                if (self.periodic_flooding_interval.is_set or self.periodic_flooding_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.periodic_flooding_interval.get_name_leafdata())
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.system_id.is_set or self.system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.system_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area-id" or name == "igp-neighbors" or name == "is-flooded" or name == "is-periodic-flooding-on" or name == "links-flooded" or name == "local-node-router-id" or name == "periodic-flooding-interval" or name == "protocol" or name == "system-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "area-id"):
                    self.area_id = value
                    self.area_id.value_namespace = name_space
                    self.area_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-neighbors"):
                    self.igp_neighbors = value
                    self.igp_neighbors.value_namespace = name_space
                    self.igp_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "is-flooded"):
                    self.is_flooded = value
                    self.is_flooded.value_namespace = name_space
                    self.is_flooded.value_namespace_prefix = name_space_prefix
                if(value_path == "is-periodic-flooding-on"):
                    self.is_periodic_flooding_on = value
                    self.is_periodic_flooding_on.value_namespace = name_space
                    self.is_periodic_flooding_on.value_namespace_prefix = name_space_prefix
                if(value_path == "links-flooded"):
                    self.links_flooded = value
                    self.links_flooded.value_namespace = name_space
                    self.links_flooded.value_namespace_prefix = name_space_prefix
                if(value_path == "local-node-router-id"):
                    self.local_node_router_id = value
                    self.local_node_router_id.value_namespace = name_space
                    self.local_node_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "periodic-flooding-interval"):
                    self.periodic_flooding_interval = value
                    self.periodic_flooding_interval.value_namespace = name_space
                    self.periodic_flooding_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "system-id"):
                    self.system_id = value
                    self.system_id.value_namespace = name_space
                    self.system_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.areas_summary:
                if (c.has_data()):
                    return True
            return (
                self.is_flooding_enabled.is_set or
                self.is_role_standby.is_set or
                self.links.is_set or
                self.maximum_links.is_set or
                (self.bandwidth_account_summary is not None and self.bandwidth_account_summary.has_data()))

        def has_operation(self):
            for c in self.areas_summary:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.is_flooding_enabled.yfilter != YFilter.not_set or
                self.is_role_standby.yfilter != YFilter.not_set or
                self.links.yfilter != YFilter.not_set or
                self.maximum_links.yfilter != YFilter.not_set or
                (self.bandwidth_account_summary is not None and self.bandwidth_account_summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "link-summary" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.is_flooding_enabled.is_set or self.is_flooding_enabled.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_flooding_enabled.get_name_leafdata())
            if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_role_standby.get_name_leafdata())
            if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                leaf_name_data.append(self.links.get_name_leafdata())
            if (self.maximum_links.is_set or self.maximum_links.yfilter != YFilter.not_set):
                leaf_name_data.append(self.maximum_links.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "areas-summary"):
                for c in self.areas_summary:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.LinkSummary.AreasSummary()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.areas_summary.append(c)
                return c

            if (child_yang_name == "bandwidth-account-summary"):
                if (self.bandwidth_account_summary is None):
                    self.bandwidth_account_summary = MplsLcacStandby.LinkSummary.BandwidthAccountSummary()
                    self.bandwidth_account_summary.parent = self
                    self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"
                return self.bandwidth_account_summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "areas-summary" or name == "bandwidth-account-summary" or name == "is-flooding-enabled" or name == "is-role-standby" or name == "links" or name == "maximum-links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "is-flooding-enabled"):
                self.is_flooding_enabled = value
                self.is_flooding_enabled.value_namespace = name_space
                self.is_flooding_enabled.value_namespace_prefix = name_space_prefix
            if(value_path == "is-role-standby"):
                self.is_role_standby = value
                self.is_role_standby.value_namespace = name_space
                self.is_role_standby.value_namespace_prefix = name_space_prefix
            if(value_path == "links"):
                self.links = value
                self.links.value_namespace = name_space
                self.links.value_namespace_prefix = name_space_prefix
            if(value_path == "maximum-links"):
                self.maximum_links = value
                self.maximum_links.value_namespace = name_space
                self.maximum_links.value_namespace_prefix = name_space_prefix


    class LinkInformation(Entity):
        """
        The interface information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global information for all the interfaces
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Global_>`
        
        .. attribute:: links
        
        	The table of interfaces in MPLS\-LCAC
        	**type**\:   :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.LinkInformation, self).__init__()

            self.yang_name = "link-information"
            self.yang_parent_name = "mpls-lcac-standby"

            self.global_ = MplsLcacStandby.LinkInformation.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.links = MplsLcacStandby.LinkInformation.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._children_yang_names.add("links")


        class Global_(Entity):
            """
            The global information for all the interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: links
            
            	The number of links
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.LinkInformation.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "link-information"

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.links = YLeaf(YType.uint16, "links")

                self.maximum_links = YLeaf(YType.uint16, "maximum-links")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_role_standby",
                                "links",
                                "maximum_links") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.LinkInformation.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.LinkInformation.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.is_role_standby.is_set or
                    self.links.is_set or
                    self.maximum_links.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.links.yfilter != YFilter.not_set or
                    self.maximum_links.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links.get_name_leafdata())
                if (self.maximum_links.is_set or self.maximum_links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.maximum_links.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "is-role-standby" or name == "links" or name == "maximum-links"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "links"):
                    self.links = value
                    self.links.value_namespace = name_space
                    self.links.value_namespace_prefix = name_space_prefix
                if(value_path == "maximum-links"):
                    self.maximum_links = value
                    self.maximum_links.value_namespace = name_space
                    self.maximum_links.value_namespace_prefix = name_space_prefix


        class Links(Entity):
            """
            The table of interfaces in MPLS\-LCAC
            
            .. attribute:: link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.LinkInformation.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "link-information"

                self.link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.LinkInformation.Links, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.LinkInformation.Links, self).__setattr__(name, value)


            class Link(Entity):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: affinity_map
                
                	Affinity map array
                	**type**\: list of    :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.AffinityMap>`
                
                .. attribute:: areas
                
                	Per\-area data
                	**type**\: list of    :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.Areas>`
                
                .. attribute:: bandwidth_account
                
                	Bandwidth Account info
                	**type**\:   :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount>`
                
                .. attribute:: hw_oor
                
                	The link's NPU OOR info. This field is NULL for platforms that do not support HW\-OOR notifications
                	**type**\:   :py:class:`HwOor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.HwOor>`
                
                .. attribute:: is_attribute_incomplete
                
                	TRUE if one or more affinity definition(s) is/are unknown
                	**type**\:  bool
                
                .. attribute:: is_name_based_attribute
                
                	TRUE, if name based attribute style is in effect
                	**type**\:  bool
                
                .. attribute:: is_te_metric_valid
                
                	Flag to indicate whether the link's TE metric is a valid value
                	**type**\:  bool
                
                .. attribute:: link_attributes
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:   :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon>`
                
                .. attribute:: link_extended_attribute
                
                	The link's extended attribute bit map
                	**type**\: list of    :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute>`
                
                .. attribute:: link_forwad_ref_value
                
                	Reference bits for undefined affinity names
                	**type**\: list of    :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue>`
                
                .. attribute:: lockout
                
                	Flex LSP Lockout info
                	**type**\: list of    :py:class:`Lockout <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.Lockout>`
                
                .. attribute:: maximum_reservation_bandwidth_mam
                
                	The link's maximum reservable BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: maximum_reservation_bandwidth_rdm
                
                	The link's maximum reservable BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reason_not_flooded
                
                	Reason why link is not flooded (area\-independent)
                	**type**\:  str
                
                .. attribute:: reservable_pool0_bandwidth_mam
                
                	The link's reservable pool0 BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool0_bandwidth_rdm
                
                	The link's reservable pool0 BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool1_bandwidth_mam
                
                	The link's reservable pool1 BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool1_bandwidth_rdm
                
                	The link's reservable pool1 BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.LinkInformation.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.is_attribute_incomplete = YLeaf(YType.boolean, "is-attribute-incomplete")

                    self.is_name_based_attribute = YLeaf(YType.boolean, "is-name-based-attribute")

                    self.is_te_metric_valid = YLeaf(YType.boolean, "is-te-metric-valid")

                    self.link_attributes = YLeaf(YType.uint32, "link-attributes")

                    self.maximum_reservation_bandwidth_mam = YLeaf(YType.uint64, "maximum-reservation-bandwidth-mam")

                    self.maximum_reservation_bandwidth_rdm = YLeaf(YType.uint64, "maximum-reservation-bandwidth-rdm")

                    self.reason_not_flooded = YLeaf(YType.str, "reason-not-flooded")

                    self.reservable_pool0_bandwidth_mam = YLeaf(YType.uint64, "reservable-pool0-bandwidth-mam")

                    self.reservable_pool0_bandwidth_rdm = YLeaf(YType.uint64, "reservable-pool0-bandwidth-rdm")

                    self.reservable_pool1_bandwidth_mam = YLeaf(YType.uint64, "reservable-pool1-bandwidth-mam")

                    self.reservable_pool1_bandwidth_rdm = YLeaf(YType.uint64, "reservable-pool1-bandwidth-rdm")

                    self.te_metric = YLeaf(YType.uint32, "te-metric")

                    self.bandwidth_account = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount()
                    self.bandwidth_account.parent = self
                    self._children_name_map["bandwidth_account"] = "bandwidth-account"
                    self._children_yang_names.add("bandwidth-account")

                    self.hw_oor = MplsLcacStandby.LinkInformation.Links.Link.HwOor()
                    self.hw_oor.parent = self
                    self._children_name_map["hw_oor"] = "hw-oor"
                    self._children_yang_names.add("hw-oor")

                    self.link_common = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"
                    self._children_yang_names.add("link-common")

                    self.affinity_map = YList(self)
                    self.areas = YList(self)
                    self.link_extended_attribute = YList(self)
                    self.link_forwad_ref_value = YList(self)
                    self.lockout = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "is_attribute_incomplete",
                                    "is_name_based_attribute",
                                    "is_te_metric_valid",
                                    "link_attributes",
                                    "maximum_reservation_bandwidth_mam",
                                    "maximum_reservation_bandwidth_rdm",
                                    "reason_not_flooded",
                                    "reservable_pool0_bandwidth_mam",
                                    "reservable_pool0_bandwidth_rdm",
                                    "reservable_pool1_bandwidth_mam",
                                    "reservable_pool1_bandwidth_rdm",
                                    "te_metric") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.LinkInformation.Links.Link, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.LinkInformation.Links.Link, self).__setattr__(name, value)


                class LinkCommon(Entity):
                    """
                    The link's common info
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of    :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas>`
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\:  bool
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of    :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\:  bool
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\:  bool
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:   :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags>`
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\:  str
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:   :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup>`
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "link"

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                        self.capability = YLeaf(YType.uint32, "capability")

                        self.has_protection = YLeaf(YType.boolean, "has-protection")

                        self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                        self.inbound_admission_method = YLeaf(YType.enumeration, "inbound-admission-method")

                        self.incoming_reservable_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-bandwidth-percentage")

                        self.incoming_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool0-bandwidth-percentage")

                        self.incoming_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool1-bandwidth-percentage")

                        self.is_resource_provider_installed = YLeaf(YType.boolean, "is-resource-provider-installed")

                        self.is_unnumbered = YLeaf(YType.boolean, "is-unnumbered")

                        self.last_flooded_effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "last-flooded-effective-maximum-reservable-bandwidth")

                        self.link_address = YLeaf(YType.str, "link-address")

                        self.link_id = YLeaf(YType.str, "link-id")

                        self.maximum_reservable_bandwidth = YLeaf(YType.uint64, "maximum-reservable-bandwidth")

                        self.maximum_reservable_pool0_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool0-bandwidth")

                        self.maximum_reservable_pool1_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool1-bandwidth")

                        self.outbound_admission_method = YLeaf(YType.enumeration, "outbound-admission-method")

                        self.outgoing_reservable_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-bandwidth-percentage")

                        self.outgoing_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool0-bandwidth-percentage")

                        self.outgoing_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool1-bandwidth-percentage")

                        self.physical_bandwidth = YLeaf(YType.uint64, "physical-bandwidth")

                        self.resource_provider = YLeaf(YType.enumeration, "resource-provider")

                        self.working_priority = YLeaf(YType.uint32, "working-priority")

                        self.link_flags = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"
                        self._children_yang_names.add("link-flags")

                        self.flooded_areas = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_units",
                                        "bcm_id",
                                        "capability",
                                        "has_protection",
                                        "igp_neighbors",
                                        "inbound_admission_method",
                                        "incoming_reservable_bandwidth_percentage",
                                        "incoming_reservable_pool0_bandwidth_percentage",
                                        "incoming_reservable_pool1_bandwidth_percentage",
                                        "is_resource_provider_installed",
                                        "is_unnumbered",
                                        "last_flooded_effective_maximum_reservable_bandwidth",
                                        "link_address",
                                        "link_id",
                                        "maximum_reservable_bandwidth",
                                        "maximum_reservable_pool0_bandwidth",
                                        "maximum_reservable_pool1_bandwidth",
                                        "outbound_admission_method",
                                        "outgoing_reservable_bandwidth_percentage",
                                        "outgoing_reservable_pool0_bandwidth_percentage",
                                        "outgoing_reservable_pool1_bandwidth_percentage",
                                        "physical_bandwidth",
                                        "resource_provider",
                                        "working_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon, self).__setattr__(name, value)


                    class LinkFlags(Entity):
                        """
                        The link's flags
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\:  bool
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\:  bool
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:   :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"

                            self.is_admin_up = YLeaf(YType.boolean, "is-admin-up")

                            self.is_mpls_te_on = YLeaf(YType.boolean, "is-mpls-te-on")

                            self.signaling_agent = YLeaf(YType.enumeration, "signaling-agent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_admin_up",
                                            "is_mpls_te_on",
                                            "signaling_agent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_admin_up.is_set or
                                self.is_mpls_te_on.is_set or
                                self.signaling_agent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_admin_up.yfilter != YFilter.not_set or
                                self.is_mpls_te_on.yfilter != YFilter.not_set or
                                self.signaling_agent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "link-flags" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_admin_up.is_set or self.is_admin_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_admin_up.get_name_leafdata())
                            if (self.is_mpls_te_on.is_set or self.is_mpls_te_on.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mpls_te_on.get_name_leafdata())
                            if (self.signaling_agent.is_set or self.signaling_agent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaling_agent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-admin-up" or name == "is-mpls-te-on" or name == "signaling-agent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-admin-up"):
                                self.is_admin_up = value
                                self.is_admin_up.value_namespace = name_space
                                self.is_admin_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-mpls-te-on"):
                                self.is_mpls_te_on = value
                                self.is_mpls_te_on.value_namespace = name_space
                                self.is_mpls_te_on.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaling-agent"):
                                self.signaling_agent = value
                                self.signaling_agent.value_namespace = name_space
                                self.signaling_agent.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class InterfaceSwitchingCapabilityDescriptor(Entity):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"

                            self.encoding = YLeaf(YType.uint8, "encoding")

                            self.key = YLeaf(YType.uint8, "key")

                            self.switching_capability = YLeaf(YType.uint8, "switching-capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("encoding",
                                            "key",
                                            "switching_capability") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.encoding.is_set or
                                self.key.is_set or
                                self.switching_capability.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.encoding.yfilter != YFilter.not_set or
                                self.key.yfilter != YFilter.not_set or
                                self.switching_capability.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-switching-capability-descriptor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.encoding.is_set or self.encoding.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.encoding.get_name_leafdata())
                            if (self.key.is_set or self.key.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.key.get_name_leafdata())
                            if (self.switching_capability.is_set or self.switching_capability.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switching_capability.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "encoding" or name == "key" or name == "switching-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "encoding"):
                                self.encoding = value
                                self.encoding.value_namespace = name_space
                                self.encoding.value_namespace_prefix = name_space_prefix
                            if(value_path == "key"):
                                self.key = value
                                self.key.value_namespace = name_space
                                self.key.value_namespace_prefix = name_space_prefix
                            if(value_path == "switching-capability"):
                                self.switching_capability = value
                                self.switching_capability.value_namespace = name_space
                                self.switching_capability.value_namespace_prefix = name_space_prefix


                    class FloodedAreas(Entity):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"

                            self.flooded_area = YLeaf(YType.str, "flooded-area")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("flooded_area") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__setattr__(name, value)

                        def has_data(self):
                            return self.flooded_area.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.flooded_area.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flooded-areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.flooded_area.is_set or self.flooded_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flooded_area.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flooded-area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "flooded-area"):
                                self.flooded_area = value
                                self.flooded_area.value_namespace = name_space
                                self.flooded_area.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.flooded_areas:
                            if (c.has_data()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_units.is_set or
                            self.bcm_id.is_set or
                            self.capability.is_set or
                            self.has_protection.is_set or
                            self.igp_neighbors.is_set or
                            self.inbound_admission_method.is_set or
                            self.incoming_reservable_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.is_set or
                            self.is_resource_provider_installed.is_set or
                            self.is_unnumbered.is_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.is_set or
                            self.link_address.is_set or
                            self.link_id.is_set or
                            self.maximum_reservable_bandwidth.is_set or
                            self.maximum_reservable_pool0_bandwidth.is_set or
                            self.maximum_reservable_pool1_bandwidth.is_set or
                            self.outbound_admission_method.is_set or
                            self.outgoing_reservable_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.is_set or
                            self.physical_bandwidth.is_set or
                            self.resource_provider.is_set or
                            self.working_priority.is_set or
                            (self.link_flags is not None and self.link_flags.has_data()))

                    def has_operation(self):
                        for c in self.flooded_areas:
                            if (c.has_operation()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.bcm_id.yfilter != YFilter.not_set or
                            self.capability.yfilter != YFilter.not_set or
                            self.has_protection.yfilter != YFilter.not_set or
                            self.igp_neighbors.yfilter != YFilter.not_set or
                            self.inbound_admission_method.yfilter != YFilter.not_set or
                            self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.is_resource_provider_installed.yfilter != YFilter.not_set or
                            self.is_unnumbered.yfilter != YFilter.not_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.link_address.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                            self.outbound_admission_method.yfilter != YFilter.not_set or
                            self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.physical_bandwidth.yfilter != YFilter.not_set or
                            self.resource_provider.yfilter != YFilter.not_set or
                            self.working_priority.yfilter != YFilter.not_set or
                            (self.link_flags is not None and self.link_flags.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcm_id.get_name_leafdata())
                        if (self.capability.is_set or self.capability.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.capability.get_name_leafdata())
                        if (self.has_protection.is_set or self.has_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_protection.get_name_leafdata())
                        if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                        if (self.inbound_admission_method.is_set or self.inbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inbound_admission_method.get_name_leafdata())
                        if (self.incoming_reservable_bandwidth_percentage.is_set or self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool0_bandwidth_percentage.is_set or self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool1_bandwidth_percentage.is_set or self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.is_resource_provider_installed.is_set or self.is_resource_provider_installed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_resource_provider_installed.get_name_leafdata())
                        if (self.is_unnumbered.is_set or self.is_unnumbered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unnumbered.get_name_leafdata())
                        if (self.last_flooded_effective_maximum_reservable_bandwidth.is_set or self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_flooded_effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_address.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.maximum_reservable_bandwidth.is_set or self.maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool0_bandwidth.is_set or self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool0_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool1_bandwidth.is_set or self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool1_bandwidth.get_name_leafdata())
                        if (self.outbound_admission_method.is_set or self.outbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_admission_method.get_name_leafdata())
                        if (self.outgoing_reservable_bandwidth_percentage.is_set or self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool0_bandwidth_percentage.is_set or self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool1_bandwidth_percentage.is_set or self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                        if (self.resource_provider.is_set or self.resource_provider.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_provider.get_name_leafdata())
                        if (self.working_priority.is_set or self.working_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.working_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "flooded-areas"):
                            for c in self.flooded_areas:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.flooded_areas.append(c)
                            return c

                        if (child_yang_name == "interface-switching-capability-descriptor"):
                            for c in self.interface_switching_capability_descriptor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface_switching_capability_descriptor.append(c)
                            return c

                        if (child_yang_name == "link-flags"):
                            if (self.link_flags is None):
                                self.link_flags = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                                self.link_flags.parent = self
                                self._children_name_map["link_flags"] = "link-flags"
                            return self.link_flags

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "flooded-areas" or name == "interface-switching-capability-descriptor" or name == "link-flags" or name == "shared-risk-link-group" or name == "bandwidth-units" or name == "bcm-id" or name == "capability" or name == "has-protection" or name == "igp-neighbors" or name == "inbound-admission-method" or name == "incoming-reservable-bandwidth-percentage" or name == "incoming-reservable-pool0-bandwidth-percentage" or name == "incoming-reservable-pool1-bandwidth-percentage" or name == "is-resource-provider-installed" or name == "is-unnumbered" or name == "last-flooded-effective-maximum-reservable-bandwidth" or name == "link-address" or name == "link-id" or name == "maximum-reservable-bandwidth" or name == "maximum-reservable-pool0-bandwidth" or name == "maximum-reservable-pool1-bandwidth" or name == "outbound-admission-method" or name == "outgoing-reservable-bandwidth-percentage" or name == "outgoing-reservable-pool0-bandwidth-percentage" or name == "outgoing-reservable-pool1-bandwidth-percentage" or name == "physical-bandwidth" or name == "resource-provider" or name == "working-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcm-id"):
                            self.bcm_id = value
                            self.bcm_id.value_namespace = name_space
                            self.bcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "capability"):
                            self.capability = value
                            self.capability.value_namespace = name_space
                            self.capability.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-protection"):
                            self.has_protection = value
                            self.has_protection.value_namespace = name_space
                            self.has_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-neighbors"):
                            self.igp_neighbors = value
                            self.igp_neighbors.value_namespace = name_space
                            self.igp_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "inbound-admission-method"):
                            self.inbound_admission_method = value
                            self.inbound_admission_method.value_namespace = name_space
                            self.inbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-bandwidth-percentage"):
                            self.incoming_reservable_bandwidth_percentage = value
                            self.incoming_reservable_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool0-bandwidth-percentage"):
                            self.incoming_reservable_pool0_bandwidth_percentage = value
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool1-bandwidth-percentage"):
                            self.incoming_reservable_pool1_bandwidth_percentage = value
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-resource-provider-installed"):
                            self.is_resource_provider_installed = value
                            self.is_resource_provider_installed.value_namespace = name_space
                            self.is_resource_provider_installed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unnumbered"):
                            self.is_unnumbered = value
                            self.is_unnumbered.value_namespace = name_space
                            self.is_unnumbered.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-flooded-effective-maximum-reservable-bandwidth"):
                            self.last_flooded_effective_maximum_reservable_bandwidth = value
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-address"):
                            self.link_address = value
                            self.link_address.value_namespace = name_space
                            self.link_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-bandwidth"):
                            self.maximum_reservable_bandwidth = value
                            self.maximum_reservable_bandwidth.value_namespace = name_space
                            self.maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool0-bandwidth"):
                            self.maximum_reservable_pool0_bandwidth = value
                            self.maximum_reservable_pool0_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool1-bandwidth"):
                            self.maximum_reservable_pool1_bandwidth = value
                            self.maximum_reservable_pool1_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-admission-method"):
                            self.outbound_admission_method = value
                            self.outbound_admission_method.value_namespace = name_space
                            self.outbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-bandwidth-percentage"):
                            self.outgoing_reservable_bandwidth_percentage = value
                            self.outgoing_reservable_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool0-bandwidth-percentage"):
                            self.outgoing_reservable_pool0_bandwidth_percentage = value
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool1-bandwidth-percentage"):
                            self.outgoing_reservable_pool1_bandwidth_percentage = value
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-bandwidth"):
                            self.physical_bandwidth = value
                            self.physical_bandwidth.value_namespace = name_space
                            self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-provider"):
                            self.resource_provider = value
                            self.resource_provider.value_namespace = name_space
                            self.resource_provider.value_namespace_prefix = name_space_prefix
                        if(value_path == "working-priority"):
                            self.working_priority = value
                            self.working_priority.value_namespace = name_space
                            self.working_priority.value_namespace_prefix = name_space_prefix


                class BandwidthAccount(Entity):
                    """
                    Bandwidth Account info
                    
                    .. attribute:: bandwidth_account_common_info
                    
                    	Common info for bandwidth accounting
                    	**type**\:   :py:class:`BandwidthAccountCommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo>`
                    
                    .. attribute:: rsvp_te_bandwidth_sample_history
                    
                    	RSVP\-TE Bandwidth samples history
                    	**type**\:   :py:class:`RsvpTeBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory>`
                    
                    .. attribute:: sr_bandwidth_sample_history
                    
                    	Segment Routing Bandwidth samples history
                    	**type**\:   :py:class:`SrBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount, self).__init__()

                        self.yang_name = "bandwidth-account"
                        self.yang_parent_name = "link"

                        self.bandwidth_account_common_info = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                        self.bandwidth_account_common_info.parent = self
                        self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"
                        self._children_yang_names.add("bandwidth-account-common-info")

                        self.rsvp_te_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                        self.rsvp_te_bandwidth_sample_history.parent = self
                        self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"
                        self._children_yang_names.add("rsvp-te-bandwidth-sample-history")

                        self.sr_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                        self.sr_bandwidth_sample_history.parent = self
                        self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                        self._children_yang_names.add("sr-bandwidth-sample-history")


                    class BandwidthAccountCommonInfo(Entity):
                        """
                        Common info for bandwidth accounting
                        
                        .. attribute:: adjustment_factor
                        
                        	This value indicates the adjustment factor applied to measured non RSVP\-TE bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_enforced
                        
                        	TRUE if bandwidth accounting application is enforced
                        	**type**\:  bool
                        
                        .. attribute:: application_interval
                        
                        	Application interval in seconds for bandwidth accounting stats
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: application_time_remaining
                        
                        	This value indicates the number of seconds until the next application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: collection_type
                        
                        	The type of traffic collected for bandwidth accounting
                        	**type**\:   :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                        
                        .. attribute:: down_threshold_max_reservable_bandwidth
                        
                        	The down threshold for flooding the maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: is_bandwidth_account_enabled
                        
                        	TRUE if bandwidth accounting is enabled
                        	**type**\:  bool
                        
                        .. attribute:: last_application_timestamp
                        
                        	Timestamp for the last application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_sample_collection_timestamp
                        
                        	Timestamp for the last sample collection
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_reservable_bandwidth_threshold_are_default
                        
                        	TRUE if the maximum reservable bandwidth flooding thresholds are default
                        	**type**\:  bool
                        
                        .. attribute:: next_application
                        
                        	Timestamp for the next application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: next_sample_collection
                        
                        	Timestamp for the next sample collection
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE Bandwidth utilization information
                        	**type**\:   :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization>`
                        
                        .. attribute:: sample_interval
                        
                        	Sampling interval in seconds for bandwidth accounting stats
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: sample_time_remaining
                        
                        	This value indicates the number of seconds until the next sampling
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing Bandwidth utilization information
                        	**type**\:   :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization>`
                        
                        .. attribute:: up_threshold_max_reservable_bandwidth
                        
                        	The up threshold for flooding the maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__init__()

                            self.yang_name = "bandwidth-account-common-info"
                            self.yang_parent_name = "bandwidth-account"

                            self.adjustment_factor = YLeaf(YType.uint32, "adjustment-factor")

                            self.application_enforced = YLeaf(YType.boolean, "application-enforced")

                            self.application_interval = YLeaf(YType.uint32, "application-interval")

                            self.application_time_remaining = YLeaf(YType.uint32, "application-time-remaining")

                            self.collection_type = YLeaf(YType.enumeration, "collection-type")

                            self.down_threshold_max_reservable_bandwidth = YLeaf(YType.uint8, "down-threshold-max-reservable-bandwidth")

                            self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                            self.last_application_timestamp = YLeaf(YType.uint32, "last-application-timestamp")

                            self.last_sample_collection_timestamp = YLeaf(YType.uint32, "last-sample-collection-timestamp")

                            self.max_reservable_bandwidth_threshold_are_default = YLeaf(YType.boolean, "max-reservable-bandwidth-threshold-are-default")

                            self.next_application = YLeaf(YType.uint32, "next-application")

                            self.next_sample_collection = YLeaf(YType.uint32, "next-sample-collection")

                            self.sample_interval = YLeaf(YType.uint32, "sample-interval")

                            self.sample_time_remaining = YLeaf(YType.uint32, "sample-time-remaining")

                            self.up_threshold_max_reservable_bandwidth = YLeaf(YType.uint8, "up-threshold-max-reservable-bandwidth")

                            self.rsvp_te_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                            self.rsvp_te_bandwidth_utilization.parent = self
                            self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                            self._children_yang_names.add("rsvp-te-bandwidth-utilization")

                            self.sr_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                            self.sr_bandwidth_utilization.parent = self
                            self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            self._children_yang_names.add("sr-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_factor",
                                            "application_enforced",
                                            "application_interval",
                                            "application_time_remaining",
                                            "collection_type",
                                            "down_threshold_max_reservable_bandwidth",
                                            "is_bandwidth_account_enabled",
                                            "last_application_timestamp",
                                            "last_sample_collection_timestamp",
                                            "max_reservable_bandwidth_threshold_are_default",
                                            "next_application",
                                            "next_sample_collection",
                                            "sample_interval",
                                            "sample_time_remaining",
                                            "up_threshold_max_reservable_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__setattr__(name, value)


                        class RsvpTeBandwidthUtilization(Entity):
                            """
                            RSVP\-TE Bandwidth utilization information
                            
                            .. attribute:: non_rsvp_te_bandwidth_utilization
                            
                            	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                            
                            	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_bandwidth_utilization
                            
                            	RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_enforced_bandwidth_utilization
                            
                            	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: total_link_bandwidth_utilization
                            
                            	Total bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                                self.yang_name = "rsvp-te-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"

                                self.non_rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "non-rsvp-te-bandwidth-utilization")

                                self.rsvp_te_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-adjusted-bandwidth-utilization")

                                self.rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-bandwidth-utilization")

                                self.rsvp_te_enforced_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-enforced-bandwidth-utilization")

                                self.total_link_bandwidth_utilization = YLeaf(YType.uint64, "total-link-bandwidth-utilization")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_bandwidth_utilization",
                                                "rsvp_te_adjusted_bandwidth_utilization",
                                                "rsvp_te_bandwidth_utilization",
                                                "rsvp_te_enforced_bandwidth_utilization",
                                                "total_link_bandwidth_utilization") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_bandwidth_utilization.is_set or
                                    self.rsvp_te_adjusted_bandwidth_utilization.is_set or
                                    self.rsvp_te_bandwidth_utilization.is_set or
                                    self.rsvp_te_enforced_bandwidth_utilization.is_set or
                                    self.total_link_bandwidth_utilization.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.total_link_bandwidth_utilization.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-bandwidth-utilization" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_bandwidth_utilization.is_set or self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_adjusted_bandwidth_utilization.is_set or self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_adjusted_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_bandwidth_utilization.is_set or self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_enforced_bandwidth_utilization.is_set or self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_enforced_bandwidth_utilization.get_name_leafdata())
                                if (self.total_link_bandwidth_utilization.is_set or self.total_link_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_link_bandwidth_utilization.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-bandwidth-utilization" or name == "rsvp-te-adjusted-bandwidth-utilization" or name == "rsvp-te-bandwidth-utilization" or name == "rsvp-te-enforced-bandwidth-utilization" or name == "total-link-bandwidth-utilization"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-bandwidth-utilization"):
                                    self.non_rsvp_te_bandwidth_utilization = value
                                    self.non_rsvp_te_bandwidth_utilization.value_namespace = name_space
                                    self.non_rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-adjusted-bandwidth-utilization"):
                                    self.rsvp_te_adjusted_bandwidth_utilization = value
                                    self.rsvp_te_adjusted_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-bandwidth-utilization"):
                                    self.rsvp_te_bandwidth_utilization = value
                                    self.rsvp_te_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-enforced-bandwidth-utilization"):
                                    self.rsvp_te_enforced_bandwidth_utilization = value
                                    self.rsvp_te_enforced_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-link-bandwidth-utilization"):
                                    self.total_link_bandwidth_utilization = value
                                    self.total_link_bandwidth_utilization.value_namespace = name_space
                                    self.total_link_bandwidth_utilization.value_namespace_prefix = name_space_prefix


                        class SrBandwidthUtilization(Entity):
                            """
                            Segment Routing Bandwidth utilization
                            information
                            
                            .. attribute:: sr_adjusted_bandwidth_utilization
                            
                            	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_bandwidth_utilization
                            
                            	Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_enforced_bandwidth_utilization
                            
                            	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__init__()

                                self.yang_name = "sr-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"

                                self.sr_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "sr-adjusted-bandwidth-utilization")

                                self.sr_bandwidth_utilization = YLeaf(YType.uint64, "sr-bandwidth-utilization")

                                self.sr_enforced_bandwidth_utilization = YLeaf(YType.uint64, "sr-enforced-bandwidth-utilization")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_adjusted_bandwidth_utilization",
                                                "sr_bandwidth_utilization",
                                                "sr_enforced_bandwidth_utilization") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_adjusted_bandwidth_utilization.is_set or
                                    self.sr_bandwidth_utilization.is_set or
                                    self.sr_enforced_bandwidth_utilization.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.sr_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-bandwidth-utilization" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_adjusted_bandwidth_utilization.is_set or self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_adjusted_bandwidth_utilization.get_name_leafdata())
                                if (self.sr_bandwidth_utilization.is_set or self.sr_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_bandwidth_utilization.get_name_leafdata())
                                if (self.sr_enforced_bandwidth_utilization.is_set or self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_enforced_bandwidth_utilization.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-adjusted-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "sr-enforced-bandwidth-utilization"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-adjusted-bandwidth-utilization"):
                                    self.sr_adjusted_bandwidth_utilization = value
                                    self.sr_adjusted_bandwidth_utilization.value_namespace = name_space
                                    self.sr_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-bandwidth-utilization"):
                                    self.sr_bandwidth_utilization = value
                                    self.sr_bandwidth_utilization.value_namespace = name_space
                                    self.sr_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-enforced-bandwidth-utilization"):
                                    self.sr_enforced_bandwidth_utilization = value
                                    self.sr_enforced_bandwidth_utilization.value_namespace = name_space
                                    self.sr_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.adjustment_factor.is_set or
                                self.application_enforced.is_set or
                                self.application_interval.is_set or
                                self.application_time_remaining.is_set or
                                self.collection_type.is_set or
                                self.down_threshold_max_reservable_bandwidth.is_set or
                                self.is_bandwidth_account_enabled.is_set or
                                self.last_application_timestamp.is_set or
                                self.last_sample_collection_timestamp.is_set or
                                self.max_reservable_bandwidth_threshold_are_default.is_set or
                                self.next_application.is_set or
                                self.next_sample_collection.is_set or
                                self.sample_interval.is_set or
                                self.sample_time_remaining.is_set or
                                self.up_threshold_max_reservable_bandwidth.is_set or
                                (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_data()) or
                                (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_factor.yfilter != YFilter.not_set or
                                self.application_enforced.yfilter != YFilter.not_set or
                                self.application_interval.yfilter != YFilter.not_set or
                                self.application_time_remaining.yfilter != YFilter.not_set or
                                self.collection_type.yfilter != YFilter.not_set or
                                self.down_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set or
                                self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                                self.last_application_timestamp.yfilter != YFilter.not_set or
                                self.last_sample_collection_timestamp.yfilter != YFilter.not_set or
                                self.max_reservable_bandwidth_threshold_are_default.yfilter != YFilter.not_set or
                                self.next_application.yfilter != YFilter.not_set or
                                self.next_sample_collection.yfilter != YFilter.not_set or
                                self.sample_interval.yfilter != YFilter.not_set or
                                self.sample_time_remaining.yfilter != YFilter.not_set or
                                self.up_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set or
                                (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_operation()) or
                                (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-account-common-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_factor.is_set or self.adjustment_factor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_factor.get_name_leafdata())
                            if (self.application_enforced.is_set or self.application_enforced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_enforced.get_name_leafdata())
                            if (self.application_interval.is_set or self.application_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_interval.get_name_leafdata())
                            if (self.application_time_remaining.is_set or self.application_time_remaining.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_time_remaining.get_name_leafdata())
                            if (self.collection_type.is_set or self.collection_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_type.get_name_leafdata())
                            if (self.down_threshold_max_reservable_bandwidth.is_set or self.down_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_threshold_max_reservable_bandwidth.get_name_leafdata())
                            if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                            if (self.last_application_timestamp.is_set or self.last_application_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_timestamp.get_name_leafdata())
                            if (self.last_sample_collection_timestamp.is_set or self.last_sample_collection_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_sample_collection_timestamp.get_name_leafdata())
                            if (self.max_reservable_bandwidth_threshold_are_default.is_set or self.max_reservable_bandwidth_threshold_are_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_reservable_bandwidth_threshold_are_default.get_name_leafdata())
                            if (self.next_application.is_set or self.next_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_application.get_name_leafdata())
                            if (self.next_sample_collection.is_set or self.next_sample_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_sample_collection.get_name_leafdata())
                            if (self.sample_interval.is_set or self.sample_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sample_interval.get_name_leafdata())
                            if (self.sample_time_remaining.is_set or self.sample_time_remaining.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sample_time_remaining.get_name_leafdata())
                            if (self.up_threshold_max_reservable_bandwidth.is_set or self.up_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_threshold_max_reservable_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rsvp-te-bandwidth-utilization"):
                                if (self.rsvp_te_bandwidth_utilization is None):
                                    self.rsvp_te_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                                    self.rsvp_te_bandwidth_utilization.parent = self
                                    self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                                return self.rsvp_te_bandwidth_utilization

                            if (child_yang_name == "sr-bandwidth-utilization"):
                                if (self.sr_bandwidth_utilization is None):
                                    self.sr_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                                    self.sr_bandwidth_utilization.parent = self
                                    self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                                return self.sr_bandwidth_utilization

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rsvp-te-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "adjustment-factor" or name == "application-enforced" or name == "application-interval" or name == "application-time-remaining" or name == "collection-type" or name == "down-threshold-max-reservable-bandwidth" or name == "is-bandwidth-account-enabled" or name == "last-application-timestamp" or name == "last-sample-collection-timestamp" or name == "max-reservable-bandwidth-threshold-are-default" or name == "next-application" or name == "next-sample-collection" or name == "sample-interval" or name == "sample-time-remaining" or name == "up-threshold-max-reservable-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-factor"):
                                self.adjustment_factor = value
                                self.adjustment_factor.value_namespace = name_space
                                self.adjustment_factor.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-enforced"):
                                self.application_enforced = value
                                self.application_enforced.value_namespace = name_space
                                self.application_enforced.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-interval"):
                                self.application_interval = value
                                self.application_interval.value_namespace = name_space
                                self.application_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-time-remaining"):
                                self.application_time_remaining = value
                                self.application_time_remaining.value_namespace = name_space
                                self.application_time_remaining.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-type"):
                                self.collection_type = value
                                self.collection_type.value_namespace = name_space
                                self.collection_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-threshold-max-reservable-bandwidth"):
                                self.down_threshold_max_reservable_bandwidth = value
                                self.down_threshold_max_reservable_bandwidth.value_namespace = name_space
                                self.down_threshold_max_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-account-enabled"):
                                self.is_bandwidth_account_enabled = value
                                self.is_bandwidth_account_enabled.value_namespace = name_space
                                self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-timestamp"):
                                self.last_application_timestamp = value
                                self.last_application_timestamp.value_namespace = name_space
                                self.last_application_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-sample-collection-timestamp"):
                                self.last_sample_collection_timestamp = value
                                self.last_sample_collection_timestamp.value_namespace = name_space
                                self.last_sample_collection_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-reservable-bandwidth-threshold-are-default"):
                                self.max_reservable_bandwidth_threshold_are_default = value
                                self.max_reservable_bandwidth_threshold_are_default.value_namespace = name_space
                                self.max_reservable_bandwidth_threshold_are_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-application"):
                                self.next_application = value
                                self.next_application.value_namespace = name_space
                                self.next_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-sample-collection"):
                                self.next_sample_collection = value
                                self.next_sample_collection.value_namespace = name_space
                                self.next_sample_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "sample-interval"):
                                self.sample_interval = value
                                self.sample_interval.value_namespace = name_space
                                self.sample_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "sample-time-remaining"):
                                self.sample_time_remaining = value
                                self.sample_time_remaining.value_namespace = name_space
                                self.sample_time_remaining.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-threshold-max-reservable-bandwidth"):
                                self.up_threshold_max_reservable_bandwidth = value
                                self.up_threshold_max_reservable_bandwidth.value_namespace = name_space
                                self.up_threshold_max_reservable_bandwidth.value_namespace_prefix = name_space_prefix


                    class RsvpTeBandwidthSampleHistory(Entity):
                        """
                        RSVP\-TE Bandwidth samples history
                        
                        .. attribute:: rsvp_te_active_interval_sample
                        
                        	RSVP\-TE samples in the current application interval
                        	**type**\: list of    :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample>`
                        
                        .. attribute:: rsvp_te_previous_interval_sample
                        
                        	RSVP\-TE samples in the previous application interval
                        	**type**\: list of    :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"

                            self.rsvp_te_active_interval_sample = YList(self)
                            self.rsvp_te_previous_interval_sample = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__setattr__(name, value)


                        class RsvpTeActiveIntervalSample(Entity):
                            """
                            RSVP\-TE samples in the current application
                            interval
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-active-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"

                                self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                                self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                                self.total_rate = YLeaf(YType.uint64, "total-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_rate",
                                                "rsvp_te_rate",
                                                "timestamp",
                                                "total_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_rate.is_set or
                                    self.rsvp_te_rate.is_set or
                                    self.timestamp.is_set or
                                    self.total_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set or
                                    self.total_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-active-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                                if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())
                                if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-rate" or name == "rsvp-te-rate" or name == "timestamp" or name == "total-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-rate"):
                                    self.non_rsvp_te_rate = value
                                    self.non_rsvp_te_rate.value_namespace = name_space
                                    self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-rate"):
                                    self.rsvp_te_rate = value
                                    self.rsvp_te_rate.value_namespace = name_space
                                    self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-rate"):
                                    self.total_rate = value
                                    self.total_rate.value_namespace = name_space
                                    self.total_rate.value_namespace_prefix = name_space_prefix


                        class RsvpTePreviousIntervalSample(Entity):
                            """
                            RSVP\-TE samples in the previous application
                            interval
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-previous-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"

                                self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                                self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                                self.total_rate = YLeaf(YType.uint64, "total-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_rate",
                                                "rsvp_te_rate",
                                                "timestamp",
                                                "total_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_rate.is_set or
                                    self.rsvp_te_rate.is_set or
                                    self.timestamp.is_set or
                                    self.total_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set or
                                    self.total_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-previous-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                                if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())
                                if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-rate" or name == "rsvp-te-rate" or name == "timestamp" or name == "total-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-rate"):
                                    self.non_rsvp_te_rate = value
                                    self.non_rsvp_te_rate.value_namespace = name_space
                                    self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-rate"):
                                    self.rsvp_te_rate = value
                                    self.rsvp_te_rate.value_namespace = name_space
                                    self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-rate"):
                                    self.total_rate = value
                                    self.total_rate.value_namespace = name_space
                                    self.total_rate.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.rsvp_te_active_interval_sample:
                                if (c.has_data()):
                                    return True
                            for c in self.rsvp_te_previous_interval_sample:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.rsvp_te_active_interval_sample:
                                if (c.has_operation()):
                                    return True
                            for c in self.rsvp_te_previous_interval_sample:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-bandwidth-sample-history" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rsvp-te-active-interval-sample"):
                                for c in self.rsvp_te_active_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.rsvp_te_active_interval_sample.append(c)
                                return c

                            if (child_yang_name == "rsvp-te-previous-interval-sample"):
                                for c in self.rsvp_te_previous_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.rsvp_te_previous_interval_sample.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rsvp-te-active-interval-sample" or name == "rsvp-te-previous-interval-sample"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class SrBandwidthSampleHistory(Entity):
                        """
                        Segment Routing Bandwidth samples history
                        
                        .. attribute:: sr_active_interval_sample
                        
                        	Segment Routing samples in the current application interval
                        	**type**\: list of    :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample>`
                        
                        .. attribute:: sr_previous_interval_sample
                        
                        	Segment Routing samples in the previous application interval
                        	**type**\: list of    :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__init__()

                            self.yang_name = "sr-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"

                            self.sr_active_interval_sample = YList(self)
                            self.sr_previous_interval_sample = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__setattr__(name, value)


                        class SrActiveIntervalSample(Entity):
                            """
                            Segment Routing samples in the current
                            application interval
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__init__()

                                self.yang_name = "sr-active-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"

                                self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_rate",
                                                "timestamp") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_rate.is_set or
                                    self.timestamp.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-active-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-rate" or name == "timestamp"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-rate"):
                                    self.sr_rate = value
                                    self.sr_rate.value_namespace = name_space
                                    self.sr_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix


                        class SrPreviousIntervalSample(Entity):
                            """
                            Segment Routing samples in the previous
                            application interval
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__init__()

                                self.yang_name = "sr-previous-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"

                                self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_rate",
                                                "timestamp") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_rate.is_set or
                                    self.timestamp.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-previous-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-rate" or name == "timestamp"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-rate"):
                                    self.sr_rate = value
                                    self.sr_rate.value_namespace = name_space
                                    self.sr_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.sr_active_interval_sample:
                                if (c.has_data()):
                                    return True
                            for c in self.sr_previous_interval_sample:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.sr_active_interval_sample:
                                if (c.has_operation()):
                                    return True
                            for c in self.sr_previous_interval_sample:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-bandwidth-sample-history" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sr-active-interval-sample"):
                                for c in self.sr_active_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sr_active_interval_sample.append(c)
                                return c

                            if (child_yang_name == "sr-previous-interval-sample"):
                                for c in self.sr_previous_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sr_previous_interval_sample.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-active-interval-sample" or name == "sr-previous-interval-sample"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.bandwidth_account_common_info is not None and self.bandwidth_account_common_info.has_data()) or
                            (self.rsvp_te_bandwidth_sample_history is not None and self.rsvp_te_bandwidth_sample_history.has_data()) or
                            (self.sr_bandwidth_sample_history is not None and self.sr_bandwidth_sample_history.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.bandwidth_account_common_info is not None and self.bandwidth_account_common_info.has_operation()) or
                            (self.rsvp_te_bandwidth_sample_history is not None and self.rsvp_te_bandwidth_sample_history.has_operation()) or
                            (self.sr_bandwidth_sample_history is not None and self.sr_bandwidth_sample_history.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bandwidth-account" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-account-common-info"):
                            if (self.bandwidth_account_common_info is None):
                                self.bandwidth_account_common_info = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                                self.bandwidth_account_common_info.parent = self
                                self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"
                            return self.bandwidth_account_common_info

                        if (child_yang_name == "rsvp-te-bandwidth-sample-history"):
                            if (self.rsvp_te_bandwidth_sample_history is None):
                                self.rsvp_te_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                                self.rsvp_te_bandwidth_sample_history.parent = self
                                self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"
                            return self.rsvp_te_bandwidth_sample_history

                        if (child_yang_name == "sr-bandwidth-sample-history"):
                            if (self.sr_bandwidth_sample_history is None):
                                self.sr_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                                self.sr_bandwidth_sample_history.parent = self
                                self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                            return self.sr_bandwidth_sample_history

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-account-common-info" or name == "rsvp-te-bandwidth-sample-history" or name == "sr-bandwidth-sample-history"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class HwOor(Entity):
                    """
                    The link's NPU OOR info. This field is NULL for
                    platforms that do not support HW\-OOR
                    notifications
                    
                    .. attribute:: hw_o_or_green_recovery_time
                    
                    	Time Remaining in Green Recovery State (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: hw_o_or_link_statistic
                    
                    	HW OOR statistics for the link
                    	**type**\: list of    :py:class:`HwOOrLinkStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic>`
                    
                    .. attribute:: hw_oor_state
                    
                    	The NPU (Network Processor Unit) HW resource state
                    	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    .. attribute:: hw_oor_timestamp
                    
                    	Timestamp when the OOR state last changed
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.HwOor, self).__init__()

                        self.yang_name = "hw-oor"
                        self.yang_parent_name = "link"

                        self.hw_o_or_green_recovery_time = YLeaf(YType.uint32, "hw-o-or-green-recovery-time")

                        self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                        self.hw_oor_timestamp = YLeaf(YType.uint32, "hw-oor-timestamp")

                        self.hw_o_or_link_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hw_o_or_green_recovery_time",
                                        "hw_oor_state",
                                        "hw_oor_timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.HwOor, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.HwOor, self).__setattr__(name, value)


                    class HwOOrLinkStatistic(Entity):
                        """
                        HW OOR statistics for the link
                        
                        .. attribute:: accepted_ls_ps_number
                        
                        	Number of LSPs that were accepted in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: accepted_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were accepted in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hw_oor_state
                        
                        	The HW\-OOR state that these statistics belong to
                        	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                        
                        .. attribute:: node_protection_disable_number
                        
                        	Number of times this OOR state disabled node protection assignment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rejected_ls_ps_number
                        
                        	Number of LSPs that were rejected in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rejected_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were rejected in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: transitions
                        
                        	Number of transitions to this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__init__()

                            self.yang_name = "hw-o-or-link-statistic"
                            self.yang_parent_name = "hw-oor"

                            self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                            self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                            self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                            self.node_protection_disable_number = YLeaf(YType.uint32, "node-protection-disable-number")

                            self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                            self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                            self.transitions = YLeaf(YType.uint32, "transitions")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("accepted_ls_ps_number",
                                            "accepted_reopt_ls_ps_number",
                                            "hw_oor_state",
                                            "node_protection_disable_number",
                                            "rejected_ls_ps_number",
                                            "rejected_reopt_ls_ps_number",
                                            "transitions") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.accepted_ls_ps_number.is_set or
                                self.accepted_reopt_ls_ps_number.is_set or
                                self.hw_oor_state.is_set or
                                self.node_protection_disable_number.is_set or
                                self.rejected_ls_ps_number.is_set or
                                self.rejected_reopt_ls_ps_number.is_set or
                                self.transitions.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                                self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                                self.hw_oor_state.yfilter != YFilter.not_set or
                                self.node_protection_disable_number.yfilter != YFilter.not_set or
                                self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                                self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                                self.transitions.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "hw-o-or-link-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                            if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                            if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                            if (self.node_protection_disable_number.is_set or self.node_protection_disable_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_protection_disable_number.get_name_leafdata())
                            if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                            if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                            if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.transitions.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "hw-oor-state" or name == "node-protection-disable-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "accepted-ls-ps-number"):
                                self.accepted_ls_ps_number = value
                                self.accepted_ls_ps_number.value_namespace = name_space
                                self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "accepted-reopt-ls-ps-number"):
                                self.accepted_reopt_ls_ps_number = value
                                self.accepted_reopt_ls_ps_number.value_namespace = name_space
                                self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "hw-oor-state"):
                                self.hw_oor_state = value
                                self.hw_oor_state.value_namespace = name_space
                                self.hw_oor_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-protection-disable-number"):
                                self.node_protection_disable_number = value
                                self.node_protection_disable_number.value_namespace = name_space
                                self.node_protection_disable_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "rejected-ls-ps-number"):
                                self.rejected_ls_ps_number = value
                                self.rejected_ls_ps_number.value_namespace = name_space
                                self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "rejected-reopt-ls-ps-number"):
                                self.rejected_reopt_ls_ps_number = value
                                self.rejected_reopt_ls_ps_number.value_namespace = name_space
                                self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "transitions"):
                                self.transitions = value
                                self.transitions.value_namespace = name_space
                                self.transitions.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.hw_o_or_link_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.hw_o_or_green_recovery_time.is_set or
                            self.hw_oor_state.is_set or
                            self.hw_oor_timestamp.is_set)

                    def has_operation(self):
                        for c in self.hw_o_or_link_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hw_o_or_green_recovery_time.yfilter != YFilter.not_set or
                            self.hw_oor_state.yfilter != YFilter.not_set or
                            self.hw_oor_timestamp.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hw-oor" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hw_o_or_green_recovery_time.is_set or self.hw_o_or_green_recovery_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_o_or_green_recovery_time.get_name_leafdata())
                        if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                        if (self.hw_oor_timestamp.is_set or self.hw_oor_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "hw-o-or-link-statistic"):
                            for c in self.hw_o_or_link_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.hw_o_or_link_statistic.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "hw-o-or-link-statistic" or name == "hw-o-or-green-recovery-time" or name == "hw-oor-state" or name == "hw-oor-timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hw-o-or-green-recovery-time"):
                            self.hw_o_or_green_recovery_time = value
                            self.hw_o_or_green_recovery_time.value_namespace = name_space
                            self.hw_o_or_green_recovery_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-state"):
                            self.hw_oor_state = value
                            self.hw_oor_state.value_namespace = name_space
                            self.hw_oor_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-timestamp"):
                            self.hw_oor_timestamp = value
                            self.hw_oor_timestamp.value_namespace = name_space
                            self.hw_oor_timestamp.value_namespace_prefix = name_space_prefix


                class LinkExtendedAttribute(Entity):
                    """
                    The link's extended attribute bit map
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute, self).__init__()

                        self.yang_name = "link-extended-attribute"
                        self.yang_parent_name = "link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-extended-attribute" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class LinkForwadRefValue(Entity):
                    """
                    Reference bits for undefined affinity names
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue, self).__init__()

                        self.yang_name = "link-forwad-ref-value"
                        self.yang_parent_name = "link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-forwad-ref-value" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class AffinityMap(Entity):
                    """
                    Affinity map array
                    
                    .. attribute:: affinity_bit_position
                    
                    	Affinity bit position
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: affinity_extended_value
                    
                    	EAG value
                    	**type**\: list of    :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue>`
                    
                    .. attribute:: affinity_name
                    
                    	Affinity name
                    	**type**\:  str
                    
                    .. attribute:: affinity_table_id
                    
                    	Affinity table id
                    	**type**\:   :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                    
                    .. attribute:: affinity_value
                    
                    	Affinity value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap, self).__init__()

                        self.yang_name = "affinity-map"
                        self.yang_parent_name = "link"

                        self.affinity_bit_position = YLeaf(YType.uint8, "affinity-bit-position")

                        self.affinity_name = YLeaf(YType.str, "affinity-name")

                        self.affinity_table_id = YLeaf(YType.enumeration, "affinity-table-id")

                        self.affinity_value = YLeaf(YType.uint32, "affinity-value")

                        self.affinity_extended_value = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bit_position",
                                        "affinity_name",
                                        "affinity_table_id",
                                        "affinity_value") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap, self).__setattr__(name, value)


                    class AffinityExtendedValue(Entity):
                        """
                        EAG value
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__init__()

                            self.yang_name = "affinity-extended-value"
                            self.yang_parent_name = "affinity-map"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity-extended-value" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.affinity_extended_value:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bit_position.is_set or
                            self.affinity_name.is_set or
                            self.affinity_table_id.is_set or
                            self.affinity_value.is_set)

                    def has_operation(self):
                        for c in self.affinity_extended_value:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bit_position.yfilter != YFilter.not_set or
                            self.affinity_name.yfilter != YFilter.not_set or
                            self.affinity_table_id.yfilter != YFilter.not_set or
                            self.affinity_value.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity-map" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bit_position.is_set or self.affinity_bit_position.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bit_position.get_name_leafdata())
                        if (self.affinity_name.is_set or self.affinity_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_name.get_name_leafdata())
                        if (self.affinity_table_id.is_set or self.affinity_table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_table_id.get_name_leafdata())
                        if (self.affinity_value.is_set or self.affinity_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_value.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity-extended-value"):
                            for c in self.affinity_extended_value:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.affinity_extended_value.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity-extended-value" or name == "affinity-bit-position" or name == "affinity-name" or name == "affinity-table-id" or name == "affinity-value"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bit-position"):
                            self.affinity_bit_position = value
                            self.affinity_bit_position.value_namespace = name_space
                            self.affinity_bit_position.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-name"):
                            self.affinity_name = value
                            self.affinity_name.value_namespace = name_space
                            self.affinity_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-table-id"):
                            self.affinity_table_id = value
                            self.affinity_table_id.value_namespace = name_space
                            self.affinity_table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-value"):
                            self.affinity_value = value
                            self.affinity_value.value_namespace = name_space
                            self.affinity_value.value_namespace_prefix = name_space_prefix


                class Areas(Entity):
                    """
                    Per\-area data
                    
                    .. attribute:: area_id
                    
                    	Area id
                    	**type**\:  str
                    
                    .. attribute:: igp_metric
                    
                    	The link's IGP metric
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_neighbor_up
                    
                    	TRUE if the neighbor is up
                    	**type**\:  bool
                    
                    .. attribute:: neighbor_address
                    
                    	The interface's neighbor's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: neighbor_id
                    
                    	The interface neighbor id
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.Areas, self).__init__()

                        self.yang_name = "areas"
                        self.yang_parent_name = "link"

                        self.area_id = YLeaf(YType.str, "area-id")

                        self.igp_metric = YLeaf(YType.uint32, "igp-metric")

                        self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                        self.neighbor_id = YLeaf(YType.str, "neighbor-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("area_id",
                                        "igp_metric",
                                        "is_neighbor_up",
                                        "neighbor_address",
                                        "neighbor_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.Areas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.Areas, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.area_id.is_set or
                            self.igp_metric.is_set or
                            self.is_neighbor_up.is_set or
                            self.neighbor_address.is_set or
                            self.neighbor_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.area_id.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_neighbor_up.yfilter != YFilter.not_set or
                            self.neighbor_address.yfilter != YFilter.not_set or
                            self.neighbor_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_id.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                        if (self.neighbor_id.is_set or self.neighbor_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-id" or name == "igp-metric" or name == "is-neighbor-up" or name == "neighbor-address" or name == "neighbor-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "area-id"):
                            self.area_id = value
                            self.area_id.value_namespace = name_space
                            self.area_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-neighbor-up"):
                            self.is_neighbor_up = value
                            self.is_neighbor_up.value_namespace = name_space
                            self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-address"):
                            self.neighbor_address = value
                            self.neighbor_address.value_namespace = name_space
                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-id"):
                            self.neighbor_id = value
                            self.neighbor_id.value_namespace = name_space
                            self.neighbor_id.value_namespace_prefix = name_space_prefix


                class Lockout(Entity):
                    """
                    Flex LSP Lockout info
                    
                    .. attribute:: is_lockout
                    
                    	True if link is locked out
                    	**type**\:  bool
                    
                    .. attribute:: lockout_off_timestamp
                    
                    	Timestamp when the lockout is cleared
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lockout_on_timestamp
                    
                    	Timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcacStandby.LinkInformation.Links.Link.Lockout, self).__init__()

                        self.yang_name = "lockout"
                        self.yang_parent_name = "link"

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_off_timestamp = YLeaf(YType.uint32, "lockout-off-timestamp")

                        self.lockout_on_timestamp = YLeaf(YType.uint32, "lockout-on-timestamp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_lockout",
                                        "lockout_off_timestamp",
                                        "lockout_on_timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcacStandby.LinkInformation.Links.Link.Lockout, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcacStandby.LinkInformation.Links.Link.Lockout, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_lockout.is_set or
                            self.lockout_off_timestamp.is_set or
                            self.lockout_on_timestamp.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_off_timestamp.yfilter != YFilter.not_set or
                            self.lockout_on_timestamp.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lockout" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_off_timestamp.is_set or self.lockout_off_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_off_timestamp.get_name_leafdata())
                        if (self.lockout_on_timestamp.is_set or self.lockout_on_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_on_timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-lockout" or name == "lockout-off-timestamp" or name == "lockout-on-timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-off-timestamp"):
                            self.lockout_off_timestamp = value
                            self.lockout_off_timestamp.value_namespace = name_space
                            self.lockout_off_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-on-timestamp"):
                            self.lockout_on_timestamp = value
                            self.lockout_on_timestamp.value_namespace = name_space
                            self.lockout_on_timestamp.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.affinity_map:
                        if (c.has_data()):
                            return True
                    for c in self.areas:
                        if (c.has_data()):
                            return True
                    for c in self.link_extended_attribute:
                        if (c.has_data()):
                            return True
                    for c in self.link_forwad_ref_value:
                        if (c.has_data()):
                            return True
                    for c in self.lockout:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.is_attribute_incomplete.is_set or
                        self.is_name_based_attribute.is_set or
                        self.is_te_metric_valid.is_set or
                        self.link_attributes.is_set or
                        self.maximum_reservation_bandwidth_mam.is_set or
                        self.maximum_reservation_bandwidth_rdm.is_set or
                        self.reason_not_flooded.is_set or
                        self.reservable_pool0_bandwidth_mam.is_set or
                        self.reservable_pool0_bandwidth_rdm.is_set or
                        self.reservable_pool1_bandwidth_mam.is_set or
                        self.reservable_pool1_bandwidth_rdm.is_set or
                        self.te_metric.is_set or
                        (self.bandwidth_account is not None and self.bandwidth_account.has_data()) or
                        (self.hw_oor is not None and self.hw_oor.has_data()) or
                        (self.link_common is not None and self.link_common.has_data()))

                def has_operation(self):
                    for c in self.affinity_map:
                        if (c.has_operation()):
                            return True
                    for c in self.areas:
                        if (c.has_operation()):
                            return True
                    for c in self.link_extended_attribute:
                        if (c.has_operation()):
                            return True
                    for c in self.link_forwad_ref_value:
                        if (c.has_operation()):
                            return True
                    for c in self.lockout:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.is_attribute_incomplete.yfilter != YFilter.not_set or
                        self.is_name_based_attribute.yfilter != YFilter.not_set or
                        self.is_te_metric_valid.yfilter != YFilter.not_set or
                        self.link_attributes.yfilter != YFilter.not_set or
                        self.maximum_reservation_bandwidth_mam.yfilter != YFilter.not_set or
                        self.maximum_reservation_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.reason_not_flooded.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth_mam.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth_mam.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.te_metric.yfilter != YFilter.not_set or
                        (self.bandwidth_account is not None and self.bandwidth_account.has_operation()) or
                        (self.hw_oor is not None and self.hw_oor.has_operation()) or
                        (self.link_common is not None and self.link_common.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.is_attribute_incomplete.is_set or self.is_attribute_incomplete.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_incomplete.get_name_leafdata())
                    if (self.is_name_based_attribute.is_set or self.is_name_based_attribute.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_name_based_attribute.get_name_leafdata())
                    if (self.is_te_metric_valid.is_set or self.is_te_metric_valid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_te_metric_valid.get_name_leafdata())
                    if (self.link_attributes.is_set or self.link_attributes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_attributes.get_name_leafdata())
                    if (self.maximum_reservation_bandwidth_mam.is_set or self.maximum_reservation_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.maximum_reservation_bandwidth_mam.get_name_leafdata())
                    if (self.maximum_reservation_bandwidth_rdm.is_set or self.maximum_reservation_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.maximum_reservation_bandwidth_rdm.get_name_leafdata())
                    if (self.reason_not_flooded.is_set or self.reason_not_flooded.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reason_not_flooded.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth_mam.is_set or self.reservable_pool0_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth_mam.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth_rdm.is_set or self.reservable_pool0_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth_rdm.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth_mam.is_set or self.reservable_pool1_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth_mam.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth_rdm.is_set or self.reservable_pool1_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth_rdm.get_name_leafdata())
                    if (self.te_metric.is_set or self.te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity-map"):
                        for c in self.affinity_map:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.LinkInformation.Links.Link.AffinityMap()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.affinity_map.append(c)
                        return c

                    if (child_yang_name == "areas"):
                        for c in self.areas:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.LinkInformation.Links.Link.Areas()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.areas.append(c)
                        return c

                    if (child_yang_name == "bandwidth-account"):
                        if (self.bandwidth_account is None):
                            self.bandwidth_account = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount()
                            self.bandwidth_account.parent = self
                            self._children_name_map["bandwidth_account"] = "bandwidth-account"
                        return self.bandwidth_account

                    if (child_yang_name == "hw-oor"):
                        if (self.hw_oor is None):
                            self.hw_oor = MplsLcacStandby.LinkInformation.Links.Link.HwOor()
                            self.hw_oor.parent = self
                            self._children_name_map["hw_oor"] = "hw-oor"
                        return self.hw_oor

                    if (child_yang_name == "link-common"):
                        if (self.link_common is None):
                            self.link_common = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon()
                            self.link_common.parent = self
                            self._children_name_map["link_common"] = "link-common"
                        return self.link_common

                    if (child_yang_name == "link-extended-attribute"):
                        for c in self.link_extended_attribute:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.link_extended_attribute.append(c)
                        return c

                    if (child_yang_name == "link-forwad-ref-value"):
                        for c in self.link_forwad_ref_value:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.link_forwad_ref_value.append(c)
                        return c

                    if (child_yang_name == "lockout"):
                        for c in self.lockout:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcacStandby.LinkInformation.Links.Link.Lockout()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.lockout.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity-map" or name == "areas" or name == "bandwidth-account" or name == "hw-oor" or name == "link-common" or name == "link-extended-attribute" or name == "link-forwad-ref-value" or name == "lockout" or name == "interface-name" or name == "is-attribute-incomplete" or name == "is-name-based-attribute" or name == "is-te-metric-valid" or name == "link-attributes" or name == "maximum-reservation-bandwidth-mam" or name == "maximum-reservation-bandwidth-rdm" or name == "reason-not-flooded" or name == "reservable-pool0-bandwidth-mam" or name == "reservable-pool0-bandwidth-rdm" or name == "reservable-pool1-bandwidth-mam" or name == "reservable-pool1-bandwidth-rdm" or name == "te-metric"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-incomplete"):
                        self.is_attribute_incomplete = value
                        self.is_attribute_incomplete.value_namespace = name_space
                        self.is_attribute_incomplete.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-name-based-attribute"):
                        self.is_name_based_attribute = value
                        self.is_name_based_attribute.value_namespace = name_space
                        self.is_name_based_attribute.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-te-metric-valid"):
                        self.is_te_metric_valid = value
                        self.is_te_metric_valid.value_namespace = name_space
                        self.is_te_metric_valid.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-attributes"):
                        self.link_attributes = value
                        self.link_attributes.value_namespace = name_space
                        self.link_attributes.value_namespace_prefix = name_space_prefix
                    if(value_path == "maximum-reservation-bandwidth-mam"):
                        self.maximum_reservation_bandwidth_mam = value
                        self.maximum_reservation_bandwidth_mam.value_namespace = name_space
                        self.maximum_reservation_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "maximum-reservation-bandwidth-rdm"):
                        self.maximum_reservation_bandwidth_rdm = value
                        self.maximum_reservation_bandwidth_rdm.value_namespace = name_space
                        self.maximum_reservation_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "reason-not-flooded"):
                        self.reason_not_flooded = value
                        self.reason_not_flooded.value_namespace = name_space
                        self.reason_not_flooded.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth-mam"):
                        self.reservable_pool0_bandwidth_mam = value
                        self.reservable_pool0_bandwidth_mam.value_namespace = name_space
                        self.reservable_pool0_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth-rdm"):
                        self.reservable_pool0_bandwidth_rdm = value
                        self.reservable_pool0_bandwidth_rdm.value_namespace = name_space
                        self.reservable_pool0_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth-mam"):
                        self.reservable_pool1_bandwidth_mam = value
                        self.reservable_pool1_bandwidth_mam.value_namespace = name_space
                        self.reservable_pool1_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth-rdm"):
                        self.reservable_pool1_bandwidth_rdm = value
                        self.reservable_pool1_bandwidth_rdm.value_namespace = name_space
                        self.reservable_pool1_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric"):
                        self.te_metric = value
                        self.te_metric.value_namespace = name_space
                        self.te_metric.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link"):
                    for c in self.link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.LinkInformation.Links.Link()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.global_ is not None and self.global_.has_data()) or
                (self.links is not None and self.links.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.links is not None and self.links.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "link-information" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcacStandby.LinkInformation.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "links"):
                if (self.links is None):
                    self.links = MplsLcacStandby.LinkInformation.Links()
                    self.links.parent = self
                    self._children_name_map["links"] = "links"
                return self.links

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "global" or name == "links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AdmissionControl(Entity):
        """
        The admission control information in MPLS\-LCAC
        
        .. attribute:: admitted_tunnels
        
        	The table of admitted tunnels information in MPLS\-LCAC
        	**type**\:   :py:class:`AdmittedTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.AdmittedTunnels>`
        
        .. attribute:: global_
        
        	The global admission control information
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.Global_>`
        
        .. attribute:: link_interfaces
        
        	The global admission control information on Interfaces
        	**type**\:   :py:class:`LinkInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.LinkInterfaces>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.AdmissionControl, self).__init__()

            self.yang_name = "admission-control"
            self.yang_parent_name = "mpls-lcac-standby"

            self.admitted_tunnels = MplsLcacStandby.AdmissionControl.AdmittedTunnels()
            self.admitted_tunnels.parent = self
            self._children_name_map["admitted_tunnels"] = "admitted-tunnels"
            self._children_yang_names.add("admitted-tunnels")

            self.global_ = MplsLcacStandby.AdmissionControl.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.link_interfaces = MplsLcacStandby.AdmissionControl.LinkInterfaces()
            self.link_interfaces.parent = self
            self._children_name_map["link_interfaces"] = "link-interfaces"
            self._children_yang_names.add("link-interfaces")


        class Global_(Entity):
            """
            The global admission control information
            
            .. attribute:: bandwidth_units
            
            	Bandwidth units
            	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: selected_tunnels
            
            	Number of tunnels selected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_p2mp_tunnels
            
            	Total p2mp tunnels admitted
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_tunnels
            
            	Total p2p tunnels admitted
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.AdmissionControl.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "admission-control"

                self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.selected_tunnels = YLeaf(YType.uint32, "selected-tunnels")

                self.total_p2mp_tunnels = YLeaf(YType.uint32, "total-p2mp-tunnels")

                self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("bandwidth_units",
                                "is_role_standby",
                                "selected_tunnels",
                                "total_p2mp_tunnels",
                                "total_tunnels") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.AdmissionControl.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.AdmissionControl.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.bandwidth_units.is_set or
                    self.is_role_standby.is_set or
                    self.selected_tunnels.is_set or
                    self.total_p2mp_tunnels.is_set or
                    self.total_tunnels.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.bandwidth_units.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.selected_tunnels.yfilter != YFilter.not_set or
                    self.total_p2mp_tunnels.yfilter != YFilter.not_set or
                    self.total_tunnels.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.selected_tunnels.is_set or self.selected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.selected_tunnels.get_name_leafdata())
                if (self.total_p2mp_tunnels.is_set or self.total_p2mp_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_p2mp_tunnels.get_name_leafdata())
                if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-units" or name == "is-role-standby" or name == "selected-tunnels" or name == "total-p2mp-tunnels" or name == "total-tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "bandwidth-units"):
                    self.bandwidth_units = value
                    self.bandwidth_units.value_namespace = name_space
                    self.bandwidth_units.value_namespace_prefix = name_space_prefix
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "selected-tunnels"):
                    self.selected_tunnels = value
                    self.selected_tunnels.value_namespace = name_space
                    self.selected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "total-p2mp-tunnels"):
                    self.total_p2mp_tunnels = value
                    self.total_p2mp_tunnels.value_namespace = name_space
                    self.total_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "total-tunnels"):
                    self.total_tunnels = value
                    self.total_tunnels.value_namespace = name_space
                    self.total_tunnels.value_namespace_prefix = name_space_prefix


        class AdmittedTunnels(Entity):
            """
            The table of admitted tunnels information in
            MPLS\-LCAC
            
            .. attribute:: admitted_tunnel
            
            	The information for a specific admitted tunnel
            	**type**\: list of    :py:class:`AdmittedTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.AdmissionControl.AdmittedTunnels, self).__init__()

                self.yang_name = "admitted-tunnels"
                self.yang_parent_name = "admission-control"

                self.admitted_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.AdmissionControl.AdmittedTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.AdmissionControl.AdmittedTunnels, self).__setattr__(name, value)


            class AdmittedTunnel(Entity):
                """
                The information for a specific admitted tunnel
                
                .. attribute:: source_address  <key>
                
                	The source IP address of the tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_port  <key>
                
                	The tunnel number at the head
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_port  <key>
                
                	The signaling instance number of the tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address  <key>
                
                	The destination IP address of the tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended tunnel id
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: next_hop_address  <key>
                
                	The Next hop IP
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	C type
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP id
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: backup_interface
                
                	The backup Interface
                	**type**\:  str
                
                .. attribute:: bandwidth
                
                	The bandwidth used by this tunnel
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: bandwidth_pool
                
                	The bandwidth pool
                	**type**\:   :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                .. attribute:: bandwidth_state
                
                	The bandwidth state
                	**type**\:   :py:class:`BandwidthStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthStateEnum>`
                
                .. attribute:: down_link_name
                
                	The downlink's name for this tunnel
                	**type**\:  str
                
                .. attribute:: hold_priority
                
                	The tunnel's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: is_rerouted
                
                	TRUE if the tunnel is currently rerouted
                	**type**\:  bool
                
                .. attribute:: local_label
                
                	The local label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: outgoing_label
                
                	The outgoing label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_priority
                
                	The tunnel's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: tunnel_name
                
                	The admitted tunnel's name
                	**type**\:  str
                
                .. attribute:: tunnel_state
                
                	The tunnel's state
                	**type**\:   :py:class:`TunnelStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelStateEnum>`
                
                .. attribute:: up_link_name
                
                	The uplink's name for this tunnel
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__init__()

                    self.yang_name = "admitted-tunnel"
                    self.yang_parent_name = "admitted-tunnels"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_port = YLeaf(YType.int32, "destination-port")

                    self.source_port = YLeaf(YType.int32, "source-port")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                    self.bandwidth = YLeaf(YType.uint64, "bandwidth")

                    self.bandwidth_pool = YLeaf(YType.enumeration, "bandwidth-pool")

                    self.bandwidth_state = YLeaf(YType.enumeration, "bandwidth-state")

                    self.down_link_name = YLeaf(YType.str, "down-link-name")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.is_rerouted = YLeaf(YType.boolean, "is-rerouted")

                    self.local_label = YLeaf(YType.uint32, "local-label")

                    self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    self.up_link_name = YLeaf(YType.str, "up-link-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_port",
                                    "source_port",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "next_hop_address",
                                    "ctype",
                                    "p2mp_id",
                                    "backup_interface",
                                    "bandwidth",
                                    "bandwidth_pool",
                                    "bandwidth_state",
                                    "down_link_name",
                                    "hold_priority",
                                    "is_rerouted",
                                    "local_label",
                                    "outgoing_label",
                                    "setup_priority",
                                    "tunnel_name",
                                    "tunnel_state",
                                    "up_link_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_port.is_set or
                        self.source_port.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.next_hop_address.is_set or
                        self.ctype.is_set or
                        self.p2mp_id.is_set or
                        self.backup_interface.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_pool.is_set or
                        self.bandwidth_state.is_set or
                        self.down_link_name.is_set or
                        self.hold_priority.is_set or
                        self.is_rerouted.is_set or
                        self.local_label.is_set or
                        self.outgoing_label.is_set or
                        self.setup_priority.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_state.is_set or
                        self.up_link_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_port.yfilter != YFilter.not_set or
                        self.source_port.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.backup_interface.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_pool.yfilter != YFilter.not_set or
                        self.bandwidth_state.yfilter != YFilter.not_set or
                        self.down_link_name.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.is_rerouted.yfilter != YFilter.not_set or
                        self.local_label.yfilter != YFilter.not_set or
                        self.outgoing_label.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_state.yfilter != YFilter.not_set or
                        self.up_link_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "admitted-tunnel" + "[source-address='" + self.source_address.get() + "']" + "[destination-port='" + self.destination_port.get() + "']" + "[source-port='" + self.source_port.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[next-hop-address='" + self.next_hop_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/admitted-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_port.is_set or self.destination_port.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_port.get_name_leafdata())
                    if (self.source_port.is_set or self.source_port.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_port.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_pool.is_set or self.bandwidth_pool.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool.get_name_leafdata())
                    if (self.bandwidth_state.is_set or self.bandwidth_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_state.get_name_leafdata())
                    if (self.down_link_name.is_set or self.down_link_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_link_name.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.is_rerouted.is_set or self.is_rerouted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_rerouted.get_name_leafdata())
                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_label.get_name_leafdata())
                    if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_state.get_name_leafdata())
                    if (self.up_link_name.is_set or self.up_link_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_link_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-port" or name == "source-port" or name == "destination-address" or name == "extended-tunnel-id" or name == "next-hop-address" or name == "ctype" or name == "p2mp-id" or name == "backup-interface" or name == "bandwidth" or name == "bandwidth-pool" or name == "bandwidth-state" or name == "down-link-name" or name == "hold-priority" or name == "is-rerouted" or name == "local-label" or name == "outgoing-label" or name == "setup-priority" or name == "tunnel-name" or name == "tunnel-state" or name == "up-link-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-port"):
                        self.destination_port = value
                        self.destination_port.value_namespace = name_space
                        self.destination_port.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-port"):
                        self.source_port = value
                        self.source_port.value_namespace = name_space
                        self.source_port.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-interface"):
                        self.backup_interface = value
                        self.backup_interface.value_namespace = name_space
                        self.backup_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool"):
                        self.bandwidth_pool = value
                        self.bandwidth_pool.value_namespace = name_space
                        self.bandwidth_pool.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-state"):
                        self.bandwidth_state = value
                        self.bandwidth_state.value_namespace = name_space
                        self.bandwidth_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-link-name"):
                        self.down_link_name = value
                        self.down_link_name.value_namespace = name_space
                        self.down_link_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-rerouted"):
                        self.is_rerouted = value
                        self.is_rerouted.value_namespace = name_space
                        self.is_rerouted.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-label"):
                        self.local_label = value
                        self.local_label.value_namespace = name_space
                        self.local_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "outgoing-label"):
                        self.outgoing_label = value
                        self.outgoing_label.value_namespace = name_space
                        self.outgoing_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-state"):
                        self.tunnel_state = value
                        self.tunnel_state.value_namespace = name_space
                        self.tunnel_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-link-name"):
                        self.up_link_name = value
                        self.up_link_name.value_namespace = name_space
                        self.up_link_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.admitted_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.admitted_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "admitted-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "admitted-tunnel"):
                    for c in self.admitted_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.admitted_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "admitted-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LinkInterfaces(Entity):
            """
            The global admission control information on
            Interfaces
            
            .. attribute:: link_interface
            
            	The global admission control information on an interface
            	**type**\: list of    :py:class:`LinkInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.AdmissionControl.LinkInterfaces, self).__init__()

                self.yang_name = "link-interfaces"
                self.yang_parent_name = "admission-control"

                self.link_interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.AdmissionControl.LinkInterfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.AdmissionControl.LinkInterfaces, self).__setattr__(name, value)


            class LinkInterface(Entity):
                """
                The global admission control information on an
                interface
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: bandwidth_units
                
                	Bandwidth units
                	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                .. attribute:: is_role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: selected_tunnels
                
                	Number of tunnels selected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_p2mp_tunnels
                
                	Total p2mp tunnels admitted
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_tunnels
                
                	Total p2p tunnels admitted
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface, self).__init__()

                    self.yang_name = "link-interface"
                    self.yang_parent_name = "link-interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                    self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                    self.selected_tunnels = YLeaf(YType.uint32, "selected-tunnels")

                    self.total_p2mp_tunnels = YLeaf(YType.uint32, "total-p2mp-tunnels")

                    self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "bandwidth_units",
                                    "is_role_standby",
                                    "selected_tunnels",
                                    "total_p2mp_tunnels",
                                    "total_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.bandwidth_units.is_set or
                        self.is_role_standby.is_set or
                        self.selected_tunnels.is_set or
                        self.total_p2mp_tunnels.is_set or
                        self.total_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.bandwidth_units.yfilter != YFilter.not_set or
                        self.is_role_standby.yfilter != YFilter.not_set or
                        self.selected_tunnels.yfilter != YFilter.not_set or
                        self.total_p2mp_tunnels.yfilter != YFilter.not_set or
                        self.total_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/link-interfaces/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                    if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                    if (self.selected_tunnels.is_set or self.selected_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.selected_tunnels.get_name_leafdata())
                    if (self.total_p2mp_tunnels.is_set or self.total_p2mp_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_p2mp_tunnels.get_name_leafdata())
                    if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-name" or name == "bandwidth-units" or name == "is-role-standby" or name == "selected-tunnels" or name == "total-p2mp-tunnels" or name == "total-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-units"):
                        self.bandwidth_units = value
                        self.bandwidth_units.value_namespace = name_space
                        self.bandwidth_units.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-role-standby"):
                        self.is_role_standby = value
                        self.is_role_standby.value_namespace = name_space
                        self.is_role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "selected-tunnels"):
                        self.selected_tunnels = value
                        self.selected_tunnels.value_namespace = name_space
                        self.selected_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-p2mp-tunnels"):
                        self.total_p2mp_tunnels = value
                        self.total_p2mp_tunnels.value_namespace = name_space
                        self.total_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-tunnels"):
                        self.total_tunnels = value
                        self.total_tunnels.value_namespace = name_space
                        self.total_tunnels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link_interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link_interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "link-interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link-interface"):
                    for c in self.link_interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link_interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link-interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.admitted_tunnels is not None and self.admitted_tunnels.has_data()) or
                (self.global_ is not None and self.global_.has_data()) or
                (self.link_interfaces is not None and self.link_interfaces.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.admitted_tunnels is not None and self.admitted_tunnels.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.link_interfaces is not None and self.link_interfaces.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "admission-control" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "admitted-tunnels"):
                if (self.admitted_tunnels is None):
                    self.admitted_tunnels = MplsLcacStandby.AdmissionControl.AdmittedTunnels()
                    self.admitted_tunnels.parent = self
                    self._children_name_map["admitted_tunnels"] = "admitted-tunnels"
                return self.admitted_tunnels

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcacStandby.AdmissionControl.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "link-interfaces"):
                if (self.link_interfaces is None):
                    self.link_interfaces = MplsLcacStandby.AdmissionControl.LinkInterfaces()
                    self.link_interfaces.parent = self
                    self._children_name_map["link_interfaces"] = "link-interfaces"
                return self.link_interfaces

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "admitted-tunnels" or name == "global" or name == "link-interfaces"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SoftPreemptionGlobalInfo(Entity):
        """
        The global soft\-preemption information
        
        .. attribute:: is_configured
        
        	Is global soft\-preemption configured
        	**type**\:  bool
        
        .. attribute:: is_timeout_interval_configured
        
        	Is global soft\-preemption timeout interval configured
        	**type**\:  bool
        
        .. attribute:: timeout_interval
        
        	Global soft\-preemption timeout interval
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.SoftPreemptionGlobalInfo, self).__init__()

            self.yang_name = "soft-preemption-global-info"
            self.yang_parent_name = "mpls-lcac-standby"

            self.is_configured = YLeaf(YType.boolean, "is-configured")

            self.is_timeout_interval_configured = YLeaf(YType.boolean, "is-timeout-interval-configured")

            self.timeout_interval = YLeaf(YType.uint32, "timeout-interval")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("is_configured",
                            "is_timeout_interval_configured",
                            "timeout_interval") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.SoftPreemptionGlobalInfo, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.SoftPreemptionGlobalInfo, self).__setattr__(name, value)

        def has_data(self):
            return (
                self.is_configured.is_set or
                self.is_timeout_interval_configured.is_set or
                self.timeout_interval.is_set)

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.is_configured.yfilter != YFilter.not_set or
                self.is_timeout_interval_configured.yfilter != YFilter.not_set or
                self.timeout_interval.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemption-global-info" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_configured.get_name_leafdata())
            if (self.is_timeout_interval_configured.is_set or self.is_timeout_interval_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_timeout_interval_configured.get_name_leafdata())
            if (self.timeout_interval.is_set or self.timeout_interval.yfilter != YFilter.not_set):
                leaf_name_data.append(self.timeout_interval.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "is-configured" or name == "is-timeout-interval-configured" or name == "timeout-interval"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "is-configured"):
                self.is_configured = value
                self.is_configured.value_namespace = name_space
                self.is_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "is-timeout-interval-configured"):
                self.is_timeout_interval_configured = value
                self.is_timeout_interval_configured.value_namespace = name_space
                self.is_timeout_interval_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "timeout-interval"):
                self.timeout_interval = value
                self.timeout_interval.value_namespace = name_space
                self.timeout_interval.value_namespace_prefix = name_space_prefix


    class SoftPreemptions(Entity):
        """
        The soft preemption information for the TE\-links
        
        .. attribute:: soft_preemption
        
        	The soft preemption info for a TE\-link
        	**type**\: list of    :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions.SoftPreemption>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcacStandby.SoftPreemptions, self).__init__()

            self.yang_name = "soft-preemptions"
            self.yang_parent_name = "mpls-lcac-standby"

            self.soft_preemption = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcacStandby.SoftPreemptions, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcacStandby.SoftPreemptions, self).__setattr__(name, value)


        class SoftPreemption(Entity):
            """
            The soft preemption info for a TE\-link
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: current_over_subscribed_bandwidth_bc0
            
            	The BC0 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC0 BW on the link and the sum of the currently reserved BC0 bandwidth and the currently soft preempted BC0 BW
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_over_subscribed_bandwidth_bc1
            
            	The BC1 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC1 BW on the link and the sum of the currently reserved BC1 bandwidth and the currently soft preempted BC1 BW
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preempted_bandwidth_bc0
            
            	The current BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preempted_bandwidth_bc1
            
            	The current BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preemption_lsp
            
            	List of the soft preempted LSPs that are not yet cleaned up
            	**type**\: list of    :py:class:`CurrentSoftPreemptionLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp>`
            
            .. attribute:: link_address
            
            	The link's IPv4 address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: release_soft_preempted_bandwidth_bc0
            
            	The total released BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: release_soft_preempted_bandwidth_bc1
            
            	The total released BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_soft_preempted_bandwidth_bc0
            
            	The total BC0 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_soft_preempted_bandwidth_bc1
            
            	The total BC1 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcacStandby.SoftPreemptions.SoftPreemption, self).__init__()

                self.yang_name = "soft-preemption"
                self.yang_parent_name = "soft-preemptions"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.current_over_subscribed_bandwidth_bc0 = YLeaf(YType.uint64, "current-over-subscribed-bandwidth-bc0")

                self.current_over_subscribed_bandwidth_bc1 = YLeaf(YType.uint64, "current-over-subscribed-bandwidth-bc1")

                self.current_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "current-soft-preempted-bandwidth-bc0")

                self.current_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "current-soft-preempted-bandwidth-bc1")

                self.link_address = YLeaf(YType.str, "link-address")

                self.release_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "release-soft-preempted-bandwidth-bc0")

                self.release_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "release-soft-preempted-bandwidth-bc1")

                self.total_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "total-soft-preempted-bandwidth-bc0")

                self.total_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "total-soft-preempted-bandwidth-bc1")

                self.current_soft_preemption_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name",
                                "current_over_subscribed_bandwidth_bc0",
                                "current_over_subscribed_bandwidth_bc1",
                                "current_soft_preempted_bandwidth_bc0",
                                "current_soft_preempted_bandwidth_bc1",
                                "link_address",
                                "release_soft_preempted_bandwidth_bc0",
                                "release_soft_preempted_bandwidth_bc1",
                                "total_soft_preempted_bandwidth_bc0",
                                "total_soft_preempted_bandwidth_bc1") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcacStandby.SoftPreemptions.SoftPreemption, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcacStandby.SoftPreemptions.SoftPreemption, self).__setattr__(name, value)


            class CurrentSoftPreemptionLsp(Entity):
                """
                List of the soft preempted LSPs that are not yet
                cleaned up
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\:  bool
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\:  int
                
                	**range:** 0..65535
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__init__()

                    self.yang_name = "current-soft-preemption-lsp"
                    self.yang_parent_name = "soft-preemption"

                    self.bandwidth_preempted = YLeaf(YType.boolean, "bandwidth-preempted")

                    self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.soft_preempted = YLeaf(YType.boolean, "soft-preempted")

                    self.soft_preempted_fr_rrewrite = YLeaf(YType.boolean, "soft-preempted-fr-rrewrite")

                    self.soft_preemption_timeout = YLeaf(YType.uint16, "soft-preemption-timeout")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bandwidth_preempted",
                                    "bandwidth_type",
                                    "destination_address",
                                    "hold_priority",
                                    "lsp_id",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "soft_preempted",
                                    "soft_preempted_fr_rrewrite",
                                    "soft_preemption_timeout",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.bandwidth_preempted.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address.is_set or
                        self.hold_priority.is_set or
                        self.lsp_id.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.soft_preempted.is_set or
                        self.soft_preempted_fr_rrewrite.is_set or
                        self.soft_preemption_timeout.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bandwidth_preempted.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.soft_preempted.yfilter != YFilter.not_set or
                        self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set or
                        self.soft_preemption_timeout.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "current-soft-preemption-lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bandwidth_preempted.is_set or self.bandwidth_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_preempted.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.soft_preempted.is_set or self.soft_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted.get_name_leafdata())
                    if (self.soft_preempted_fr_rrewrite.is_set or self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_fr_rrewrite.get_name_leafdata())
                    if (self.soft_preemption_timeout.is_set or self.soft_preemption_timeout.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption_timeout.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bandwidth-preempted" or name == "bandwidth-type" or name == "destination-address" or name == "hold-priority" or name == "lsp-id" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted" or name == "soft-preempted-fr-rrewrite" or name == "soft-preemption-timeout" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bandwidth-preempted"):
                        self.bandwidth_preempted = value
                        self.bandwidth_preempted.value_namespace = name_space
                        self.bandwidth_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted"):
                        self.soft_preempted = value
                        self.soft_preempted.value_namespace = name_space
                        self.soft_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-fr-rrewrite"):
                        self.soft_preempted_fr_rrewrite = value
                        self.soft_preempted_fr_rrewrite.value_namespace = name_space
                        self.soft_preempted_fr_rrewrite.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption-timeout"):
                        self.soft_preemption_timeout = value
                        self.soft_preemption_timeout.value_namespace = name_space
                        self.soft_preemption_timeout.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.current_soft_preemption_lsp:
                    if (c.has_data()):
                        return True
                return (
                    self.interface_name.is_set or
                    self.current_over_subscribed_bandwidth_bc0.is_set or
                    self.current_over_subscribed_bandwidth_bc1.is_set or
                    self.current_soft_preempted_bandwidth_bc0.is_set or
                    self.current_soft_preempted_bandwidth_bc1.is_set or
                    self.link_address.is_set or
                    self.release_soft_preempted_bandwidth_bc0.is_set or
                    self.release_soft_preempted_bandwidth_bc1.is_set or
                    self.total_soft_preempted_bandwidth_bc0.is_set or
                    self.total_soft_preempted_bandwidth_bc1.is_set)

            def has_operation(self):
                for c in self.current_soft_preemption_lsp:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    self.current_over_subscribed_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.current_over_subscribed_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.current_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.current_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.link_address.yfilter != YFilter.not_set or
                    self.release_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.release_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.total_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.total_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "soft-preemption" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/soft-preemptions/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                if (self.current_over_subscribed_bandwidth_bc0.is_set or self.current_over_subscribed_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_over_subscribed_bandwidth_bc0.get_name_leafdata())
                if (self.current_over_subscribed_bandwidth_bc1.is_set or self.current_over_subscribed_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_over_subscribed_bandwidth_bc1.get_name_leafdata())
                if (self.current_soft_preempted_bandwidth_bc0.is_set or self.current_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.current_soft_preempted_bandwidth_bc1.is_set or self.current_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_soft_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_address.get_name_leafdata())
                if (self.release_soft_preempted_bandwidth_bc0.is_set or self.release_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.release_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.release_soft_preempted_bandwidth_bc1.is_set or self.release_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.release_soft_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.total_soft_preempted_bandwidth_bc0.is_set or self.total_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.total_soft_preempted_bandwidth_bc1.is_set or self.total_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_soft_preempted_bandwidth_bc1.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "current-soft-preemption-lsp"):
                    for c in self.current_soft_preemption_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.current_soft_preemption_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "current-soft-preemption-lsp" or name == "interface-name" or name == "current-over-subscribed-bandwidth-bc0" or name == "current-over-subscribed-bandwidth-bc1" or name == "current-soft-preempted-bandwidth-bc0" or name == "current-soft-preempted-bandwidth-bc1" or name == "link-address" or name == "release-soft-preempted-bandwidth-bc0" or name == "release-soft-preempted-bandwidth-bc1" or name == "total-soft-preempted-bandwidth-bc0" or name == "total-soft-preempted-bandwidth-bc1"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix
                if(value_path == "current-over-subscribed-bandwidth-bc0"):
                    self.current_over_subscribed_bandwidth_bc0 = value
                    self.current_over_subscribed_bandwidth_bc0.value_namespace = name_space
                    self.current_over_subscribed_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "current-over-subscribed-bandwidth-bc1"):
                    self.current_over_subscribed_bandwidth_bc1 = value
                    self.current_over_subscribed_bandwidth_bc1.value_namespace = name_space
                    self.current_over_subscribed_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "current-soft-preempted-bandwidth-bc0"):
                    self.current_soft_preempted_bandwidth_bc0 = value
                    self.current_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.current_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "current-soft-preempted-bandwidth-bc1"):
                    self.current_soft_preempted_bandwidth_bc1 = value
                    self.current_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.current_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "link-address"):
                    self.link_address = value
                    self.link_address.value_namespace = name_space
                    self.link_address.value_namespace_prefix = name_space_prefix
                if(value_path == "release-soft-preempted-bandwidth-bc0"):
                    self.release_soft_preempted_bandwidth_bc0 = value
                    self.release_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.release_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "release-soft-preempted-bandwidth-bc1"):
                    self.release_soft_preempted_bandwidth_bc1 = value
                    self.release_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.release_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "total-soft-preempted-bandwidth-bc0"):
                    self.total_soft_preempted_bandwidth_bc0 = value
                    self.total_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.total_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "total-soft-preempted-bandwidth-bc1"):
                    self.total_soft_preempted_bandwidth_bc1 = value
                    self.total_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.total_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.soft_preemption:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.soft_preemption:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemptions" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "soft-preemption"):
                for c in self.soft_preemption:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcacStandby.SoftPreemptions.SoftPreemption()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.soft_preemption.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "soft-preemption"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.admission_control is not None and self.admission_control.has_data()) or
            (self.advertisements is not None and self.advertisements.has_data()) or
            (self.bandwidth_account is not None and self.bandwidth_account.has_data()) or
            (self.bandwidth_allocation is not None and self.bandwidth_allocation.has_data()) or
            (self.bfd_neighbors is not None and self.bfd_neighbors.has_data()) or
            (self.gmpls is not None and self.gmpls.has_data()) or
            (self.link_information is not None and self.link_information.has_data()) or
            (self.link_summary is not None and self.link_summary.has_data()) or
            (self.neighbors is not None and self.neighbors.has_data()) or
            (self.preemption_events is not None and self.preemption_events.has_data()) or
            (self.soft_preemption_global_info is not None and self.soft_preemption_global_info.has_data()) or
            (self.soft_preemptions is not None and self.soft_preemptions.has_data()) or
            (self.statistics is not None and self.statistics.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.admission_control is not None and self.admission_control.has_operation()) or
            (self.advertisements is not None and self.advertisements.has_operation()) or
            (self.bandwidth_account is not None and self.bandwidth_account.has_operation()) or
            (self.bandwidth_allocation is not None and self.bandwidth_allocation.has_operation()) or
            (self.bfd_neighbors is not None and self.bfd_neighbors.has_operation()) or
            (self.gmpls is not None and self.gmpls.has_operation()) or
            (self.link_information is not None and self.link_information.has_operation()) or
            (self.link_summary is not None and self.link_summary.has_operation()) or
            (self.neighbors is not None and self.neighbors.has_operation()) or
            (self.preemption_events is not None and self.preemption_events.has_operation()) or
            (self.soft_preemption_global_info is not None and self.soft_preemption_global_info.has_operation()) or
            (self.soft_preemptions is not None and self.soft_preemptions.has_operation()) or
            (self.statistics is not None and self.statistics.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "admission-control"):
            if (self.admission_control is None):
                self.admission_control = MplsLcacStandby.AdmissionControl()
                self.admission_control.parent = self
                self._children_name_map["admission_control"] = "admission-control"
            return self.admission_control

        if (child_yang_name == "advertisements"):
            if (self.advertisements is None):
                self.advertisements = MplsLcacStandby.Advertisements()
                self.advertisements.parent = self
                self._children_name_map["advertisements"] = "advertisements"
            return self.advertisements

        if (child_yang_name == "bandwidth-account"):
            if (self.bandwidth_account is None):
                self.bandwidth_account = MplsLcacStandby.BandwidthAccount()
                self.bandwidth_account.parent = self
                self._children_name_map["bandwidth_account"] = "bandwidth-account"
            return self.bandwidth_account

        if (child_yang_name == "bandwidth-allocation"):
            if (self.bandwidth_allocation is None):
                self.bandwidth_allocation = MplsLcacStandby.BandwidthAllocation()
                self.bandwidth_allocation.parent = self
                self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"
            return self.bandwidth_allocation

        if (child_yang_name == "bfd-neighbors"):
            if (self.bfd_neighbors is None):
                self.bfd_neighbors = MplsLcacStandby.BfdNeighbors()
                self.bfd_neighbors.parent = self
                self._children_name_map["bfd_neighbors"] = "bfd-neighbors"
            return self.bfd_neighbors

        if (child_yang_name == "gmpls"):
            if (self.gmpls is None):
                self.gmpls = MplsLcacStandby.Gmpls()
                self.gmpls.parent = self
                self._children_name_map["gmpls"] = "gmpls"
            return self.gmpls

        if (child_yang_name == "link-information"):
            if (self.link_information is None):
                self.link_information = MplsLcacStandby.LinkInformation()
                self.link_information.parent = self
                self._children_name_map["link_information"] = "link-information"
            return self.link_information

        if (child_yang_name == "link-summary"):
            if (self.link_summary is None):
                self.link_summary = MplsLcacStandby.LinkSummary()
                self.link_summary.parent = self
                self._children_name_map["link_summary"] = "link-summary"
            return self.link_summary

        if (child_yang_name == "neighbors"):
            if (self.neighbors is None):
                self.neighbors = MplsLcacStandby.Neighbors()
                self.neighbors.parent = self
                self._children_name_map["neighbors"] = "neighbors"
            return self.neighbors

        if (child_yang_name == "preemption-events"):
            if (self.preemption_events is None):
                self.preemption_events = MplsLcacStandby.PreemptionEvents()
                self.preemption_events.parent = self
                self._children_name_map["preemption_events"] = "preemption-events"
            return self.preemption_events

        if (child_yang_name == "soft-preemption-global-info"):
            if (self.soft_preemption_global_info is None):
                self.soft_preemption_global_info = MplsLcacStandby.SoftPreemptionGlobalInfo()
                self.soft_preemption_global_info.parent = self
                self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"
            return self.soft_preemption_global_info

        if (child_yang_name == "soft-preemptions"):
            if (self.soft_preemptions is None):
                self.soft_preemptions = MplsLcacStandby.SoftPreemptions()
                self.soft_preemptions.parent = self
                self._children_name_map["soft_preemptions"] = "soft-preemptions"
            return self.soft_preemptions

        if (child_yang_name == "statistics"):
            if (self.statistics is None):
                self.statistics = MplsLcacStandby.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
            return self.statistics

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "admission-control" or name == "advertisements" or name == "bandwidth-account" or name == "bandwidth-allocation" or name == "bfd-neighbors" or name == "gmpls" or name == "link-information" or name == "link-summary" or name == "neighbors" or name == "preemption-events" or name == "soft-preemption-global-info" or name == "soft-preemptions" or name == "statistics"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsLcacStandby()
        return self._top_entity

class MplsLcac(Entity):
    """
    mpls lcac
    
    .. attribute:: admission_control
    
    	The admission control information in MPLS\-LCAC
    	**type**\:   :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl>`
    
    .. attribute:: advertisements
    
    	The advertisement information in MPLS\-LCAC
    	**type**\:   :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements>`
    
    .. attribute:: bandwidth_account
    
    	The bandwidth accounting information in MPLS\-LCAC
    	**type**\:   :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount>`
    
    .. attribute:: bandwidth_allocation
    
    	The bandwidth allocation information in MPLS\-LCAC
    	**type**\:   :py:class:`BandwidthAllocation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation>`
    
    .. attribute:: bfd_neighbors
    
    	BFD Neighbors
    	**type**\:   :py:class:`BfdNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors>`
    
    .. attribute:: gmpls
    
    	GMPLS data
    	**type**\:   :py:class:`Gmpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls>`
    
    .. attribute:: link_information
    
    	The interface information in MPLS\-LCAC
    	**type**\:   :py:class:`LinkInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation>`
    
    .. attribute:: link_summary
    
    	The global summary for all the interfaces
    	**type**\:   :py:class:`LinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary>`
    
    .. attribute:: neighbors
    
    	The neighbor information for the local router
    	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors>`
    
    .. attribute:: preemption_events
    
    	Preemption event log in MPLS\-LCAC
    	**type**\:   :py:class:`PreemptionEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents>`
    
    .. attribute:: soft_preemption_global_info
    
    	The global soft\-preemption information
    	**type**\:   :py:class:`SoftPreemptionGlobalInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptionGlobalInfo>`
    
    .. attribute:: soft_preemptions
    
    	The soft preemption information for the TE\-links
    	**type**\:   :py:class:`SoftPreemptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions>`
    
    .. attribute:: statistics
    
    	The interface statistics information in MPLS\-LCAC
    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsLcac, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lcac"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.admission_control = MplsLcac.AdmissionControl()
        self.admission_control.parent = self
        self._children_name_map["admission_control"] = "admission-control"
        self._children_yang_names.add("admission-control")

        self.advertisements = MplsLcac.Advertisements()
        self.advertisements.parent = self
        self._children_name_map["advertisements"] = "advertisements"
        self._children_yang_names.add("advertisements")

        self.bandwidth_account = MplsLcac.BandwidthAccount()
        self.bandwidth_account.parent = self
        self._children_name_map["bandwidth_account"] = "bandwidth-account"
        self._children_yang_names.add("bandwidth-account")

        self.bandwidth_allocation = MplsLcac.BandwidthAllocation()
        self.bandwidth_allocation.parent = self
        self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"
        self._children_yang_names.add("bandwidth-allocation")

        self.bfd_neighbors = MplsLcac.BfdNeighbors()
        self.bfd_neighbors.parent = self
        self._children_name_map["bfd_neighbors"] = "bfd-neighbors"
        self._children_yang_names.add("bfd-neighbors")

        self.gmpls = MplsLcac.Gmpls()
        self.gmpls.parent = self
        self._children_name_map["gmpls"] = "gmpls"
        self._children_yang_names.add("gmpls")

        self.link_information = MplsLcac.LinkInformation()
        self.link_information.parent = self
        self._children_name_map["link_information"] = "link-information"
        self._children_yang_names.add("link-information")

        self.link_summary = MplsLcac.LinkSummary()
        self.link_summary.parent = self
        self._children_name_map["link_summary"] = "link-summary"
        self._children_yang_names.add("link-summary")

        self.neighbors = MplsLcac.Neighbors()
        self.neighbors.parent = self
        self._children_name_map["neighbors"] = "neighbors"
        self._children_yang_names.add("neighbors")

        self.preemption_events = MplsLcac.PreemptionEvents()
        self.preemption_events.parent = self
        self._children_name_map["preemption_events"] = "preemption-events"
        self._children_yang_names.add("preemption-events")

        self.soft_preemption_global_info = MplsLcac.SoftPreemptionGlobalInfo()
        self.soft_preemption_global_info.parent = self
        self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"
        self._children_yang_names.add("soft-preemption-global-info")

        self.soft_preemptions = MplsLcac.SoftPreemptions()
        self.soft_preemptions.parent = self
        self._children_name_map["soft_preemptions"] = "soft-preemptions"
        self._children_yang_names.add("soft-preemptions")

        self.statistics = MplsLcac.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"
        self._children_yang_names.add("statistics")


    class Neighbors(Entity):
        """
        The neighbor information for the local router
        
        .. attribute:: neighbor
        
        	The neighbors connected to a particular interface
        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors.Neighbor>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.Neighbors, self).__init__()

            self.yang_name = "neighbors"
            self.yang_parent_name = "mpls-lcac"

            self.neighbor = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.Neighbors, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.Neighbors, self).__setattr__(name, value)


        class Neighbor(Entity):
            """
            The neighbors connected to a particular
            interface
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors.Neighbor.Neighbor>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Neighbors.Neighbor, self).__init__()

                self.yang_name = "neighbor"
                self.yang_parent_name = "neighbors"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.neighbor = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.Neighbors.Neighbor, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.Neighbors.Neighbor, self).__setattr__(name, value)


            class Neighbor(Entity):
                """
                Neighbors of the specified link id
                
                .. attribute:: area_id
                
                	The area id
                	**type**\:  str
                
                .. attribute:: interface_name
                
                	The interface on which this neighbor is discovered
                	**type**\:  str
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: neighbor_id
                
                	The neighbor's id
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Neighbors.Neighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "neighbor"

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                    self.neighbor_id = YLeaf(YType.str, "neighbor-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_id",
                                    "interface_name",
                                    "neighbor_address",
                                    "neighbor_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Neighbors.Neighbor.Neighbor, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Neighbors.Neighbor.Neighbor, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.area_id.is_set or
                        self.interface_name.is_set or
                        self.neighbor_address.is_set or
                        self.neighbor_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.neighbor_address.yfilter != YFilter.not_set or
                        self.neighbor_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "neighbor" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                    if (self.neighbor_id.is_set or self.neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "area-id" or name == "interface-name" or name == "neighbor-address" or name == "neighbor-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-address"):
                        self.neighbor_address = value
                        self.neighbor_address.value_namespace = name_space
                        self.neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-id"):
                        self.neighbor_id = value
                        self.neighbor_id.value_namespace = name_space
                        self.neighbor_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.neighbor:
                    if (c.has_data()):
                        return True
                return self.interface_name.is_set

            def has_operation(self):
                for c in self.neighbor:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "neighbor" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/neighbors/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "neighbor"):
                    for c in self.neighbor:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.Neighbors.Neighbor.Neighbor()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.neighbor.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "neighbor" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.neighbor:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.neighbor:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "neighbors" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "neighbor"):
                for c in self.neighbor:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.Neighbors.Neighbor()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.neighbor.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "neighbor"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class PreemptionEvents(Entity):
        """
        Preemption event log in MPLS\-LCAC
        
        .. attribute:: preemption_event
        
        	Preemption event
        	**type**\: list of    :py:class:`PreemptionEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents.PreemptionEvent>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.PreemptionEvents, self).__init__()

            self.yang_name = "preemption-events"
            self.yang_parent_name = "mpls-lcac"

            self.preemption_event = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.PreemptionEvents, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.PreemptionEvents, self).__setattr__(name, value)


        class PreemptionEvent(Entity):
            """
            Preemption event
            
            .. attribute:: event_index  <key>
            
            	Event index
            	**type**\:  int
            
            	**range:** 0..1999
            
            .. attribute:: bandwidth_overshoot0
            
            	BW Overshoot for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: bandwidth_overshoot1
            
            	BW Overshoot for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: bandwidth_type
            
            	The path's bandwidth type; 0\:CT0, 1\:CT1, so on
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: destination_address
            
            	Destination
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: event_time
            
            	Event time; seconds elapsed since January 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: hard_preempted_bandwidth_bc0
            
            	Amount of hard preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: hard_preempted_bandwidth_bc1
            
            	Amount of hard preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: hard_preempted_ls_ps
            
            	Number of LSPs hardly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: hard_preempted_tunnels
            
            	Number of Tunnels hardly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: hold_priority
            
            	The path's hold priority
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: interface_name
            
            	Interface name
            	**type**\:  str
            
            .. attribute:: ls_ps
            
            	Number of LSPs (not all may be present in the list)
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: lsp
            
            	List of preempted LSPs
            	**type**\: list of    :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents.PreemptionEvent.Lsp>`
            
            .. attribute:: lsp_id
            
            	LSP ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: new_bandwidth_bc0
            
            	New BW for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: new_bandwidth_bc1
            
            	New BW for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: old_bandwidth_bc0
            
            	Old BW for BC0
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: old_bandwidth_bc1
            
            	Old BW for BC1
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: requested_bandwidth
            
            	The path's requested bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: setup_priority
            
            	The path's setup priority
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc0
            
            	Amount of softly preempted FRR RW class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc1
            
            	Amount of softly preempted FRR RW class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: soft_preempted_ls_ps
            
            	Number of LSPs softly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_ls_ps_fr_rrewrite
            
            	Number of LSPs softly preempted with traffic switched to backup
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_tunnels
            
            	Number of Tunnels softly preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: soft_preempted_tunnels_fr_rrewrite
            
            	Number of Tunnels softly preempted with traffic switched to backup
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: softly_preempted_bandwidth_bc0
            
            	Amount of softly preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: softly_preempted_bandwidth_bc1
            
            	Amount of softly preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: source_address
            
            	Source
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: total_preempted_bandwidth_bc0
            
            	Total amount of preempted class 0 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_preempted_bandwidth_bc1
            
            	Total amount of preempted class 1 bandwidth
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: tunnel_id
            
            	Tunnel ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnels
            
            	Number of Tunnels
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.PreemptionEvents.PreemptionEvent, self).__init__()

                self.yang_name = "preemption-event"
                self.yang_parent_name = "preemption-events"

                self.event_index = YLeaf(YType.uint32, "event-index")

                self.bandwidth_overshoot0 = YLeaf(YType.uint64, "bandwidth-overshoot0")

                self.bandwidth_overshoot1 = YLeaf(YType.uint64, "bandwidth-overshoot1")

                self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.event_time = YLeaf(YType.uint32, "event-time")

                self.hard_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "hard-preempted-bandwidth-bc0")

                self.hard_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "hard-preempted-bandwidth-bc1")

                self.hard_preempted_ls_ps = YLeaf(YType.uint16, "hard-preempted-ls-ps")

                self.hard_preempted_tunnels = YLeaf(YType.uint16, "hard-preempted-tunnels")

                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.ls_ps = YLeaf(YType.uint16, "ls-ps")

                self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                self.new_bandwidth_bc0 = YLeaf(YType.uint64, "new-bandwidth-bc0")

                self.new_bandwidth_bc1 = YLeaf(YType.uint64, "new-bandwidth-bc1")

                self.old_bandwidth_bc0 = YLeaf(YType.uint64, "old-bandwidth-bc0")

                self.old_bandwidth_bc1 = YLeaf(YType.uint64, "old-bandwidth-bc1")

                self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                self.soft_preempted_fr_rrewrite_bandwidth_bc0 = YLeaf(YType.uint64, "soft-preempted-fr-rrewrite-bandwidth-bc0")

                self.soft_preempted_fr_rrewrite_bandwidth_bc1 = YLeaf(YType.uint64, "soft-preempted-fr-rrewrite-bandwidth-bc1")

                self.soft_preempted_ls_ps = YLeaf(YType.uint16, "soft-preempted-ls-ps")

                self.soft_preempted_ls_ps_fr_rrewrite = YLeaf(YType.uint16, "soft-preempted-ls-ps-fr-rrewrite")

                self.soft_preempted_tunnels = YLeaf(YType.uint16, "soft-preempted-tunnels")

                self.soft_preempted_tunnels_fr_rrewrite = YLeaf(YType.uint16, "soft-preempted-tunnels-fr-rrewrite")

                self.softly_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "softly-preempted-bandwidth-bc0")

                self.softly_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "softly-preempted-bandwidth-bc1")

                self.source_address = YLeaf(YType.str, "source-address")

                self.total_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "total-preempted-bandwidth-bc0")

                self.total_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "total-preempted-bandwidth-bc1")

                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                self.tunnels = YLeaf(YType.uint16, "tunnels")

                self.lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("event_index",
                                "bandwidth_overshoot0",
                                "bandwidth_overshoot1",
                                "bandwidth_type",
                                "destination_address",
                                "event_time",
                                "hard_preempted_bandwidth_bc0",
                                "hard_preempted_bandwidth_bc1",
                                "hard_preempted_ls_ps",
                                "hard_preempted_tunnels",
                                "hold_priority",
                                "interface_name",
                                "ls_ps",
                                "lsp_id",
                                "new_bandwidth_bc0",
                                "new_bandwidth_bc1",
                                "old_bandwidth_bc0",
                                "old_bandwidth_bc1",
                                "requested_bandwidth",
                                "setup_priority",
                                "soft_preempted_fr_rrewrite_bandwidth_bc0",
                                "soft_preempted_fr_rrewrite_bandwidth_bc1",
                                "soft_preempted_ls_ps",
                                "soft_preempted_ls_ps_fr_rrewrite",
                                "soft_preempted_tunnels",
                                "soft_preempted_tunnels_fr_rrewrite",
                                "softly_preempted_bandwidth_bc0",
                                "softly_preempted_bandwidth_bc1",
                                "source_address",
                                "total_preempted_bandwidth_bc0",
                                "total_preempted_bandwidth_bc1",
                                "tunnel_id",
                                "tunnels") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.PreemptionEvents.PreemptionEvent, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.PreemptionEvents.PreemptionEvent, self).__setattr__(name, value)


            class Lsp(Entity):
                """
                List of preempted LSPs
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\:  bool
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\:  int
                
                	**range:** 0..65535
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.PreemptionEvents.PreemptionEvent.Lsp, self).__init__()

                    self.yang_name = "lsp"
                    self.yang_parent_name = "preemption-event"

                    self.bandwidth_preempted = YLeaf(YType.boolean, "bandwidth-preempted")

                    self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.soft_preempted = YLeaf(YType.boolean, "soft-preempted")

                    self.soft_preempted_fr_rrewrite = YLeaf(YType.boolean, "soft-preempted-fr-rrewrite")

                    self.soft_preemption_timeout = YLeaf(YType.uint16, "soft-preemption-timeout")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bandwidth_preempted",
                                    "bandwidth_type",
                                    "destination_address",
                                    "hold_priority",
                                    "lsp_id",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "soft_preempted",
                                    "soft_preempted_fr_rrewrite",
                                    "soft_preemption_timeout",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.PreemptionEvents.PreemptionEvent.Lsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.PreemptionEvents.PreemptionEvent.Lsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.bandwidth_preempted.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address.is_set or
                        self.hold_priority.is_set or
                        self.lsp_id.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.soft_preempted.is_set or
                        self.soft_preempted_fr_rrewrite.is_set or
                        self.soft_preemption_timeout.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bandwidth_preempted.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.soft_preempted.yfilter != YFilter.not_set or
                        self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set or
                        self.soft_preemption_timeout.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bandwidth_preempted.is_set or self.bandwidth_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_preempted.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.soft_preempted.is_set or self.soft_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted.get_name_leafdata())
                    if (self.soft_preempted_fr_rrewrite.is_set or self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_fr_rrewrite.get_name_leafdata())
                    if (self.soft_preemption_timeout.is_set or self.soft_preemption_timeout.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption_timeout.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bandwidth-preempted" or name == "bandwidth-type" or name == "destination-address" or name == "hold-priority" or name == "lsp-id" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted" or name == "soft-preempted-fr-rrewrite" or name == "soft-preemption-timeout" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bandwidth-preempted"):
                        self.bandwidth_preempted = value
                        self.bandwidth_preempted.value_namespace = name_space
                        self.bandwidth_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted"):
                        self.soft_preempted = value
                        self.soft_preempted.value_namespace = name_space
                        self.soft_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-fr-rrewrite"):
                        self.soft_preempted_fr_rrewrite = value
                        self.soft_preempted_fr_rrewrite.value_namespace = name_space
                        self.soft_preempted_fr_rrewrite.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption-timeout"):
                        self.soft_preemption_timeout = value
                        self.soft_preemption_timeout.value_namespace = name_space
                        self.soft_preemption_timeout.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp:
                    if (c.has_data()):
                        return True
                return (
                    self.event_index.is_set or
                    self.bandwidth_overshoot0.is_set or
                    self.bandwidth_overshoot1.is_set or
                    self.bandwidth_type.is_set or
                    self.destination_address.is_set or
                    self.event_time.is_set or
                    self.hard_preempted_bandwidth_bc0.is_set or
                    self.hard_preempted_bandwidth_bc1.is_set or
                    self.hard_preempted_ls_ps.is_set or
                    self.hard_preempted_tunnels.is_set or
                    self.hold_priority.is_set or
                    self.interface_name.is_set or
                    self.ls_ps.is_set or
                    self.lsp_id.is_set or
                    self.new_bandwidth_bc0.is_set or
                    self.new_bandwidth_bc1.is_set or
                    self.old_bandwidth_bc0.is_set or
                    self.old_bandwidth_bc1.is_set or
                    self.requested_bandwidth.is_set or
                    self.setup_priority.is_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.is_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.is_set or
                    self.soft_preempted_ls_ps.is_set or
                    self.soft_preempted_ls_ps_fr_rrewrite.is_set or
                    self.soft_preempted_tunnels.is_set or
                    self.soft_preempted_tunnels_fr_rrewrite.is_set or
                    self.softly_preempted_bandwidth_bc0.is_set or
                    self.softly_preempted_bandwidth_bc1.is_set or
                    self.source_address.is_set or
                    self.total_preempted_bandwidth_bc0.is_set or
                    self.total_preempted_bandwidth_bc1.is_set or
                    self.tunnel_id.is_set or
                    self.tunnels.is_set)

            def has_operation(self):
                for c in self.lsp:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.event_index.yfilter != YFilter.not_set or
                    self.bandwidth_overshoot0.yfilter != YFilter.not_set or
                    self.bandwidth_overshoot1.yfilter != YFilter.not_set or
                    self.bandwidth_type.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.event_time.yfilter != YFilter.not_set or
                    self.hard_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.hard_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.hard_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.hard_preempted_tunnels.yfilter != YFilter.not_set or
                    self.hold_priority.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    self.ls_ps.yfilter != YFilter.not_set or
                    self.lsp_id.yfilter != YFilter.not_set or
                    self.new_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.new_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.old_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.old_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.requested_bandwidth.yfilter != YFilter.not_set or
                    self.setup_priority.yfilter != YFilter.not_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps_fr_rrewrite.yfilter != YFilter.not_set or
                    self.soft_preempted_tunnels.yfilter != YFilter.not_set or
                    self.soft_preempted_tunnels_fr_rrewrite.yfilter != YFilter.not_set or
                    self.softly_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.softly_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.total_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.total_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.tunnel_id.yfilter != YFilter.not_set or
                    self.tunnels.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "preemption-event" + "[event-index='" + self.event_index.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/preemption-events/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.event_index.is_set or self.event_index.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.event_index.get_name_leafdata())
                if (self.bandwidth_overshoot0.is_set or self.bandwidth_overshoot0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_overshoot0.get_name_leafdata())
                if (self.bandwidth_overshoot1.is_set or self.bandwidth_overshoot1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_overshoot1.get_name_leafdata())
                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.event_time.is_set or self.event_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.event_time.get_name_leafdata())
                if (self.hard_preempted_bandwidth_bc0.is_set or self.hard_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.hard_preempted_bandwidth_bc1.is_set or self.hard_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.hard_preempted_ls_ps.is_set or self.hard_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_ls_ps.get_name_leafdata())
                if (self.hard_preempted_tunnels.is_set or self.hard_preempted_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hard_preempted_tunnels.get_name_leafdata())
                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ls_ps.get_name_leafdata())
                if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_id.get_name_leafdata())
                if (self.new_bandwidth_bc0.is_set or self.new_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.new_bandwidth_bc0.get_name_leafdata())
                if (self.new_bandwidth_bc1.is_set or self.new_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.new_bandwidth_bc1.get_name_leafdata())
                if (self.old_bandwidth_bc0.is_set or self.old_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.old_bandwidth_bc0.get_name_leafdata())
                if (self.old_bandwidth_bc1.is_set or self.old_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.old_bandwidth_bc1.get_name_leafdata())
                if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                if (self.soft_preempted_fr_rrewrite_bandwidth_bc0.is_set or self.soft_preempted_fr_rrewrite_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_fr_rrewrite_bandwidth_bc0.get_name_leafdata())
                if (self.soft_preempted_fr_rrewrite_bandwidth_bc1.is_set or self.soft_preempted_fr_rrewrite_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_fr_rrewrite_bandwidth_bc1.get_name_leafdata())
                if (self.soft_preempted_ls_ps.is_set or self.soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preempted_ls_ps_fr_rrewrite.is_set or self.soft_preempted_ls_ps_fr_rrewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps_fr_rrewrite.get_name_leafdata())
                if (self.soft_preempted_tunnels.is_set or self.soft_preempted_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_tunnels.get_name_leafdata())
                if (self.soft_preempted_tunnels_fr_rrewrite.is_set or self.soft_preempted_tunnels_fr_rrewrite.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_tunnels_fr_rrewrite.get_name_leafdata())
                if (self.softly_preempted_bandwidth_bc0.is_set or self.softly_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.softly_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.softly_preempted_bandwidth_bc1.is_set or self.softly_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.softly_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.total_preempted_bandwidth_bc0.is_set or self.total_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.total_preempted_bandwidth_bc1.is_set or self.total_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                if (self.tunnels.is_set or self.tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnels.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp"):
                    for c in self.lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.PreemptionEvents.PreemptionEvent.Lsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp" or name == "event-index" or name == "bandwidth-overshoot0" or name == "bandwidth-overshoot1" or name == "bandwidth-type" or name == "destination-address" or name == "event-time" or name == "hard-preempted-bandwidth-bc0" or name == "hard-preempted-bandwidth-bc1" or name == "hard-preempted-ls-ps" or name == "hard-preempted-tunnels" or name == "hold-priority" or name == "interface-name" or name == "ls-ps" or name == "lsp-id" or name == "new-bandwidth-bc0" or name == "new-bandwidth-bc1" or name == "old-bandwidth-bc0" or name == "old-bandwidth-bc1" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted-fr-rrewrite-bandwidth-bc0" or name == "soft-preempted-fr-rrewrite-bandwidth-bc1" or name == "soft-preempted-ls-ps" or name == "soft-preempted-ls-ps-fr-rrewrite" or name == "soft-preempted-tunnels" or name == "soft-preempted-tunnels-fr-rrewrite" or name == "softly-preempted-bandwidth-bc0" or name == "softly-preempted-bandwidth-bc1" or name == "source-address" or name == "total-preempted-bandwidth-bc0" or name == "total-preempted-bandwidth-bc1" or name == "tunnel-id" or name == "tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "event-index"):
                    self.event_index = value
                    self.event_index.value_namespace = name_space
                    self.event_index.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-overshoot0"):
                    self.bandwidth_overshoot0 = value
                    self.bandwidth_overshoot0.value_namespace = name_space
                    self.bandwidth_overshoot0.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-overshoot1"):
                    self.bandwidth_overshoot1 = value
                    self.bandwidth_overshoot1.value_namespace = name_space
                    self.bandwidth_overshoot1.value_namespace_prefix = name_space_prefix
                if(value_path == "bandwidth-type"):
                    self.bandwidth_type = value
                    self.bandwidth_type.value_namespace = name_space
                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "event-time"):
                    self.event_time = value
                    self.event_time.value_namespace = name_space
                    self.event_time.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-bandwidth-bc0"):
                    self.hard_preempted_bandwidth_bc0 = value
                    self.hard_preempted_bandwidth_bc0.value_namespace = name_space
                    self.hard_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-bandwidth-bc1"):
                    self.hard_preempted_bandwidth_bc1 = value
                    self.hard_preempted_bandwidth_bc1.value_namespace = name_space
                    self.hard_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-ls-ps"):
                    self.hard_preempted_ls_ps = value
                    self.hard_preempted_ls_ps.value_namespace = name_space
                    self.hard_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "hard-preempted-tunnels"):
                    self.hard_preempted_tunnels = value
                    self.hard_preempted_tunnels.value_namespace = name_space
                    self.hard_preempted_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "hold-priority"):
                    self.hold_priority = value
                    self.hold_priority.value_namespace = name_space
                    self.hold_priority.value_namespace_prefix = name_space_prefix
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix
                if(value_path == "ls-ps"):
                    self.ls_ps = value
                    self.ls_ps.value_namespace = name_space
                    self.ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-id"):
                    self.lsp_id = value
                    self.lsp_id.value_namespace = name_space
                    self.lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "new-bandwidth-bc0"):
                    self.new_bandwidth_bc0 = value
                    self.new_bandwidth_bc0.value_namespace = name_space
                    self.new_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "new-bandwidth-bc1"):
                    self.new_bandwidth_bc1 = value
                    self.new_bandwidth_bc1.value_namespace = name_space
                    self.new_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "old-bandwidth-bc0"):
                    self.old_bandwidth_bc0 = value
                    self.old_bandwidth_bc0.value_namespace = name_space
                    self.old_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "old-bandwidth-bc1"):
                    self.old_bandwidth_bc1 = value
                    self.old_bandwidth_bc1.value_namespace = name_space
                    self.old_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "requested-bandwidth"):
                    self.requested_bandwidth = value
                    self.requested_bandwidth.value_namespace = name_space
                    self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                if(value_path == "setup-priority"):
                    self.setup_priority = value
                    self.setup_priority.value_namespace = name_space
                    self.setup_priority.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-fr-rrewrite-bandwidth-bc0"):
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0 = value
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.value_namespace = name_space
                    self.soft_preempted_fr_rrewrite_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-fr-rrewrite-bandwidth-bc1"):
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1 = value
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.value_namespace = name_space
                    self.soft_preempted_fr_rrewrite_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps"):
                    self.soft_preempted_ls_ps = value
                    self.soft_preempted_ls_ps.value_namespace = name_space
                    self.soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps-fr-rrewrite"):
                    self.soft_preempted_ls_ps_fr_rrewrite = value
                    self.soft_preempted_ls_ps_fr_rrewrite.value_namespace = name_space
                    self.soft_preempted_ls_ps_fr_rrewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-tunnels"):
                    self.soft_preempted_tunnels = value
                    self.soft_preempted_tunnels.value_namespace = name_space
                    self.soft_preempted_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-tunnels-fr-rrewrite"):
                    self.soft_preempted_tunnels_fr_rrewrite = value
                    self.soft_preempted_tunnels_fr_rrewrite.value_namespace = name_space
                    self.soft_preempted_tunnels_fr_rrewrite.value_namespace_prefix = name_space_prefix
                if(value_path == "softly-preempted-bandwidth-bc0"):
                    self.softly_preempted_bandwidth_bc0 = value
                    self.softly_preempted_bandwidth_bc0.value_namespace = name_space
                    self.softly_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "softly-preempted-bandwidth-bc1"):
                    self.softly_preempted_bandwidth_bc1 = value
                    self.softly_preempted_bandwidth_bc1.value_namespace = name_space
                    self.softly_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "total-preempted-bandwidth-bc0"):
                    self.total_preempted_bandwidth_bc0 = value
                    self.total_preempted_bandwidth_bc0.value_namespace = name_space
                    self.total_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "total-preempted-bandwidth-bc1"):
                    self.total_preempted_bandwidth_bc1 = value
                    self.total_preempted_bandwidth_bc1.value_namespace = name_space
                    self.total_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-id"):
                    self.tunnel_id = value
                    self.tunnel_id.value_namespace = name_space
                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnels"):
                    self.tunnels = value
                    self.tunnels.value_namespace = name_space
                    self.tunnels.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.preemption_event:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.preemption_event:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "preemption-events" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "preemption-event"):
                for c in self.preemption_event:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.PreemptionEvents.PreemptionEvent()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.preemption_event.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "preemption-event"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Advertisements(Entity):
        """
        The advertisement information in MPLS\-LCAC
        
        .. attribute:: advertized_areas
        
        	Advertising info for all the IGP areas
        	**type**\: list of    :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas>`
        
        .. attribute:: ds_te_mode
        
        	DS\-TE Mode
        	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
        
        .. attribute:: flooding_status_message
        
        	Flooding status\: ready or reason
        	**type**\:  str
        
        .. attribute:: last_flooding_time
        
        	Time elapsed since last flooding in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        .. attribute:: last_flooding_trigger
        
        	Trigger for last flooding
        	**type**\:   :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
        
        .. attribute:: next_flooding_time
        
        	Time remained for next flooding in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.Advertisements, self).__init__()

            self.yang_name = "advertisements"
            self.yang_parent_name = "mpls-lcac"

            self.ds_te_mode = YLeaf(YType.enumeration, "ds-te-mode")

            self.flooding_status_message = YLeaf(YType.str, "flooding-status-message")

            self.last_flooding_time = YLeaf(YType.uint32, "last-flooding-time")

            self.last_flooding_trigger = YLeaf(YType.enumeration, "last-flooding-trigger")

            self.next_flooding_time = YLeaf(YType.uint32, "next-flooding-time")

            self.advertized_areas = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("ds_te_mode",
                            "flooding_status_message",
                            "last_flooding_time",
                            "last_flooding_trigger",
                            "next_flooding_time") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.Advertisements, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.Advertisements, self).__setattr__(name, value)


        class AdvertizedAreas(Entity):
            """
            Advertising info for all the IGP areas
            
            .. attribute:: flooded_link
            
            	The array of flooded links in this area
            	**type**\: list of    :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink>`
            
            .. attribute:: igp_area_id
            
            	The area id
            	**type**\:  str
            
            .. attribute:: protocol
            
            	The IGP protocol running over this area
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: router_id
            
            	The node's router ID
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: system_id
            
            	The node's system id
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Advertisements.AdvertizedAreas, self).__init__()

                self.yang_name = "advertized-areas"
                self.yang_parent_name = "advertisements"

                self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.router_id = YLeaf(YType.str, "router-id")

                self.system_id = YLeaf(YType.str, "system-id")

                self.flooded_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("igp_area_id",
                                "protocol",
                                "router_id",
                                "system_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.Advertisements.AdvertizedAreas, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.Advertisements.AdvertizedAreas, self).__setattr__(name, value)


            class FloodedLink(Entity):
                """
                The array of flooded links in this area
                
                .. attribute:: affinity_attribute_flags
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_units
                
                	The link's bandwidth units
                	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                .. attribute:: bcm_id
                
                	Bandwidth Constraints Model ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: designated_router_igp_id
                
                	IGP id of the designated router
                	**type**\:  str
                
                .. attribute:: extended_affinity_attribute_flag
                
                	The link's extended affinity bits
                	**type**\: list of    :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                
                .. attribute:: igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_neighbor_address
                
                	The neighbor's ip address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: incoming_interface_id
                
                	The link's incoming interface's id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface_name
                
                	The link's interface name
                	**type**\:  str
                
                .. attribute:: is_designated_router
                
                	TRUE if the link belongs to a desig. router
                	**type**\:  bool
                
                .. attribute:: is_receiving_reservable_bandwidth_enabled
                
                	TRUE if receiving reservable BW is enabled
                	**type**\:  bool
                
                .. attribute:: is_transmitting_reservable_bandwidth_enabled
                
                	TRUE if transmitting reservable BW is enabled
                	**type**\:  bool
                
                .. attribute:: link_address
                
                	The link's IPv4 address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: link_id
                
                	The link's id
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: link_maximum_reservable_bandwidth
                
                	The link's maximum reservable BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: neighbor_igp_id
                
                	The neighbor's IGP id
                	**type**\:  str
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                
                .. attribute:: outgoing_interface_id
                
                	The link's outgoing interface's id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: physical_bandwidth
                
                	The link's physical BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: receiving_direction
                
                	Upstream or Downstream
                	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                .. attribute:: receiving_reservable_bandwidth
                
                	Receiving reservable BW at each priority level(priority 0 to priority 7)
                	**type**\: list of    :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                
                .. attribute:: reservable_pool0_bandwidth
                
                	The link's reservable pool0 BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: reservable_pool1_bandwidth
                
                	The link's reservable pool1 BW
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                
                .. attribute:: subnet_type
                
                	The link's subnet type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transmitting_direction
                
                	Upstream or Downstream
                	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                .. attribute:: transmitting_reservable_bandwidth
                
                	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                	**type**\: list of    :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                
                .. attribute:: uni_link_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                    self.yang_name = "flooded-link"
                    self.yang_parent_name = "advertized-areas"

                    self.affinity_attribute_flags = YLeaf(YType.uint32, "affinity-attribute-flags")

                    self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                    self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                    self.designated_router_igp_id = YLeaf(YType.str, "designated-router-igp-id")

                    self.igp_metric = YLeaf(YType.uint32, "igp-metric")

                    self.igp_neighbor_address = YLeaf(YType.str, "igp-neighbor-address")

                    self.incoming_interface_id = YLeaf(YType.uint32, "incoming-interface-id")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.is_designated_router = YLeaf(YType.boolean, "is-designated-router")

                    self.is_receiving_reservable_bandwidth_enabled = YLeaf(YType.boolean, "is-receiving-reservable-bandwidth-enabled")

                    self.is_transmitting_reservable_bandwidth_enabled = YLeaf(YType.boolean, "is-transmitting-reservable-bandwidth-enabled")

                    self.link_address = YLeaf(YType.str, "link-address")

                    self.link_id = YLeaf(YType.uint16, "link-id")

                    self.link_maximum_reservable_bandwidth = YLeaf(YType.uint32, "link-maximum-reservable-bandwidth")

                    self.neighbor_igp_id = YLeaf(YType.str, "neighbor-igp-id")

                    self.outgoing_interface_id = YLeaf(YType.uint32, "outgoing-interface-id")

                    self.physical_bandwidth = YLeaf(YType.uint32, "physical-bandwidth")

                    self.receiving_direction = YLeaf(YType.enumeration, "receiving-direction")

                    self.reservable_pool0_bandwidth = YLeaf(YType.uint32, "reservable-pool0-bandwidth")

                    self.reservable_pool1_bandwidth = YLeaf(YType.uint32, "reservable-pool1-bandwidth")

                    self.subnet_type = YLeaf(YType.enumeration, "subnet-type")

                    self.te_metric = YLeaf(YType.uint32, "te-metric")

                    self.transmitting_direction = YLeaf(YType.enumeration, "transmitting-direction")

                    self.uni_link_delay = YLeaf(YType.uint32, "uni-link-delay")

                    self.odu_link_capabilities = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.extended_affinity_attribute_flag = YList(self)
                    self.receiving_reservable_bandwidth = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.transmitting_reservable_bandwidth = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("affinity_attribute_flags",
                                    "bandwidth_units",
                                    "bcm_id",
                                    "designated_router_igp_id",
                                    "igp_metric",
                                    "igp_neighbor_address",
                                    "incoming_interface_id",
                                    "interface_name",
                                    "is_designated_router",
                                    "is_receiving_reservable_bandwidth_enabled",
                                    "is_transmitting_reservable_bandwidth_enabled",
                                    "link_address",
                                    "link_id",
                                    "link_maximum_reservable_bandwidth",
                                    "neighbor_igp_id",
                                    "outgoing_interface_id",
                                    "physical_bandwidth",
                                    "receiving_direction",
                                    "reservable_pool0_bandwidth",
                                    "reservable_pool1_bandwidth",
                                    "subnet_type",
                                    "te_metric",
                                    "transmitting_direction",
                                    "uni_link_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink, self).__setattr__(name, value)


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "flooded-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class ExtendedAffinityAttributeFlag(Entity):
                    """
                    The link's extended affinity bits
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                        self.yang_name = "extended-affinity-attribute-flag"
                        self.yang_parent_name = "flooded-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "extended-affinity-attribute-flag" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "flooded-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class ReceivingReservableBandwidth(Entity):
                    """
                    Receiving reservable BW at each priority
                    level(priority 0 to priority 7)
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                        self.yang_name = "receiving-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"

                        self.pool0_bandwidth = YLeaf(YType.uint32, "pool0-bandwidth")

                        self.pool1_bandwidth = YLeaf(YType.uint32, "pool1-bandwidth")

                        self.priority = YLeaf(YType.uint8, "priority")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("pool0_bandwidth",
                                        "pool1_bandwidth",
                                        "priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.pool0_bandwidth.is_set or
                            self.pool1_bandwidth.is_set or
                            self.priority.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.pool0_bandwidth.yfilter != YFilter.not_set or
                            self.pool1_bandwidth.yfilter != YFilter.not_set or
                            self.priority.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "receiving-reservable-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.pool0_bandwidth.is_set or self.pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool0_bandwidth.get_name_leafdata())
                        if (self.pool1_bandwidth.is_set or self.pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool1_bandwidth.get_name_leafdata())
                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "pool0-bandwidth" or name == "pool1-bandwidth" or name == "priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "pool0-bandwidth"):
                            self.pool0_bandwidth = value
                            self.pool0_bandwidth.value_namespace = name_space
                            self.pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "pool1-bandwidth"):
                            self.pool1_bandwidth = value
                            self.pool1_bandwidth.value_namespace = name_space
                            self.pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority"):
                            self.priority = value
                            self.priority.value_namespace = name_space
                            self.priority.value_namespace_prefix = name_space_prefix


                class TransmittingReservableBandwidth(Entity):
                    """
                    Transmitting reservable BW at each priority
                    level (priority 0 to priority 7)
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                        self.yang_name = "transmitting-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"

                        self.pool0_bandwidth = YLeaf(YType.uint32, "pool0-bandwidth")

                        self.pool1_bandwidth = YLeaf(YType.uint32, "pool1-bandwidth")

                        self.priority = YLeaf(YType.uint8, "priority")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("pool0_bandwidth",
                                        "pool1_bandwidth",
                                        "priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.pool0_bandwidth.is_set or
                            self.pool1_bandwidth.is_set or
                            self.priority.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.pool0_bandwidth.yfilter != YFilter.not_set or
                            self.pool1_bandwidth.yfilter != YFilter.not_set or
                            self.priority.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transmitting-reservable-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.pool0_bandwidth.is_set or self.pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool0_bandwidth.get_name_leafdata())
                        if (self.pool1_bandwidth.is_set or self.pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pool1_bandwidth.get_name_leafdata())
                        if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "pool0-bandwidth" or name == "pool1-bandwidth" or name == "priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "pool0-bandwidth"):
                            self.pool0_bandwidth = value
                            self.pool0_bandwidth.value_namespace = name_space
                            self.pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "pool1-bandwidth"):
                            self.pool1_bandwidth = value
                            self.pool1_bandwidth.value_namespace = name_space
                            self.pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "priority"):
                            self.priority = value
                            self.priority.value_namespace = name_space
                            self.priority.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.extended_affinity_attribute_flag:
                        if (c.has_data()):
                            return True
                    for c in self.receiving_reservable_bandwidth:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.transmitting_reservable_bandwidth:
                        if (c.has_data()):
                            return True
                    return (
                        self.affinity_attribute_flags.is_set or
                        self.bandwidth_units.is_set or
                        self.bcm_id.is_set or
                        self.designated_router_igp_id.is_set or
                        self.igp_metric.is_set or
                        self.igp_neighbor_address.is_set or
                        self.incoming_interface_id.is_set or
                        self.interface_name.is_set or
                        self.is_designated_router.is_set or
                        self.is_receiving_reservable_bandwidth_enabled.is_set or
                        self.is_transmitting_reservable_bandwidth_enabled.is_set or
                        self.link_address.is_set or
                        self.link_id.is_set or
                        self.link_maximum_reservable_bandwidth.is_set or
                        self.neighbor_igp_id.is_set or
                        self.outgoing_interface_id.is_set or
                        self.physical_bandwidth.is_set or
                        self.receiving_direction.is_set or
                        self.reservable_pool0_bandwidth.is_set or
                        self.reservable_pool1_bandwidth.is_set or
                        self.subnet_type.is_set or
                        self.te_metric.is_set or
                        self.transmitting_direction.is_set or
                        self.uni_link_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()))

                def has_operation(self):
                    for c in self.extended_affinity_attribute_flag:
                        if (c.has_operation()):
                            return True
                    for c in self.receiving_reservable_bandwidth:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.transmitting_reservable_bandwidth:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.affinity_attribute_flags.yfilter != YFilter.not_set or
                        self.bandwidth_units.yfilter != YFilter.not_set or
                        self.bcm_id.yfilter != YFilter.not_set or
                        self.designated_router_igp_id.yfilter != YFilter.not_set or
                        self.igp_metric.yfilter != YFilter.not_set or
                        self.igp_neighbor_address.yfilter != YFilter.not_set or
                        self.incoming_interface_id.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.is_designated_router.yfilter != YFilter.not_set or
                        self.is_receiving_reservable_bandwidth_enabled.yfilter != YFilter.not_set or
                        self.is_transmitting_reservable_bandwidth_enabled.yfilter != YFilter.not_set or
                        self.link_address.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        self.link_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                        self.neighbor_igp_id.yfilter != YFilter.not_set or
                        self.outgoing_interface_id.yfilter != YFilter.not_set or
                        self.physical_bandwidth.yfilter != YFilter.not_set or
                        self.receiving_direction.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                        self.subnet_type.yfilter != YFilter.not_set or
                        self.te_metric.yfilter != YFilter.not_set or
                        self.transmitting_direction.yfilter != YFilter.not_set or
                        self.uni_link_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "flooded-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.affinity_attribute_flags.is_set or self.affinity_attribute_flags.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_attribute_flags.get_name_leafdata())
                    if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                    if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bcm_id.get_name_leafdata())
                    if (self.designated_router_igp_id.is_set or self.designated_router_igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.designated_router_igp_id.get_name_leafdata())
                    if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_metric.get_name_leafdata())
                    if (self.igp_neighbor_address.is_set or self.igp_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_neighbor_address.get_name_leafdata())
                    if (self.incoming_interface_id.is_set or self.incoming_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.incoming_interface_id.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.is_designated_router.is_set or self.is_designated_router.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_designated_router.get_name_leafdata())
                    if (self.is_receiving_reservable_bandwidth_enabled.is_set or self.is_receiving_reservable_bandwidth_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_receiving_reservable_bandwidth_enabled.get_name_leafdata())
                    if (self.is_transmitting_reservable_bandwidth_enabled.is_set or self.is_transmitting_reservable_bandwidth_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_transmitting_reservable_bandwidth_enabled.get_name_leafdata())
                    if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_address.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())
                    if (self.link_maximum_reservable_bandwidth.is_set or self.link_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_maximum_reservable_bandwidth.get_name_leafdata())
                    if (self.neighbor_igp_id.is_set or self.neighbor_igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_igp_id.get_name_leafdata())
                    if (self.outgoing_interface_id.is_set or self.outgoing_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outgoing_interface_id.get_name_leafdata())
                    if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                    if (self.receiving_direction.is_set or self.receiving_direction.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.receiving_direction.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth.is_set or self.reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth.is_set or self.reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth.get_name_leafdata())
                    if (self.subnet_type.is_set or self.subnet_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.subnet_type.get_name_leafdata())
                    if (self.te_metric.is_set or self.te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric.get_name_leafdata())
                    if (self.transmitting_direction.is_set or self.transmitting_direction.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transmitting_direction.get_name_leafdata())
                    if (self.uni_link_delay.is_set or self.uni_link_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uni_link_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "extended-affinity-attribute-flag"):
                        for c in self.extended_affinity_attribute_flag:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.extended_affinity_attribute_flag.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "receiving-reservable-bandwidth"):
                        for c in self.receiving_reservable_bandwidth:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.receiving_reservable_bandwidth.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "transmitting-reservable-bandwidth"):
                        for c in self.transmitting_reservable_bandwidth:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.transmitting_reservable_bandwidth.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "extended-affinity-attribute-flag" or name == "odu-link-capabilities" or name == "receiving-reservable-bandwidth" or name == "shared-risk-link-group" or name == "transmitting-reservable-bandwidth" or name == "affinity-attribute-flags" or name == "bandwidth-units" or name == "bcm-id" or name == "designated-router-igp-id" or name == "igp-metric" or name == "igp-neighbor-address" or name == "incoming-interface-id" or name == "interface-name" or name == "is-designated-router" or name == "is-receiving-reservable-bandwidth-enabled" or name == "is-transmitting-reservable-bandwidth-enabled" or name == "link-address" or name == "link-id" or name == "link-maximum-reservable-bandwidth" or name == "neighbor-igp-id" or name == "outgoing-interface-id" or name == "physical-bandwidth" or name == "receiving-direction" or name == "reservable-pool0-bandwidth" or name == "reservable-pool1-bandwidth" or name == "subnet-type" or name == "te-metric" or name == "transmitting-direction" or name == "uni-link-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "affinity-attribute-flags"):
                        self.affinity_attribute_flags = value
                        self.affinity_attribute_flags.value_namespace = name_space
                        self.affinity_attribute_flags.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-units"):
                        self.bandwidth_units = value
                        self.bandwidth_units.value_namespace = name_space
                        self.bandwidth_units.value_namespace_prefix = name_space_prefix
                    if(value_path == "bcm-id"):
                        self.bcm_id = value
                        self.bcm_id.value_namespace = name_space
                        self.bcm_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "designated-router-igp-id"):
                        self.designated_router_igp_id = value
                        self.designated_router_igp_id.value_namespace = name_space
                        self.designated_router_igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-metric"):
                        self.igp_metric = value
                        self.igp_metric.value_namespace = name_space
                        self.igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-neighbor-address"):
                        self.igp_neighbor_address = value
                        self.igp_neighbor_address.value_namespace = name_space
                        self.igp_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "incoming-interface-id"):
                        self.incoming_interface_id = value
                        self.incoming_interface_id.value_namespace = name_space
                        self.incoming_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-designated-router"):
                        self.is_designated_router = value
                        self.is_designated_router.value_namespace = name_space
                        self.is_designated_router.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-receiving-reservable-bandwidth-enabled"):
                        self.is_receiving_reservable_bandwidth_enabled = value
                        self.is_receiving_reservable_bandwidth_enabled.value_namespace = name_space
                        self.is_receiving_reservable_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-transmitting-reservable-bandwidth-enabled"):
                        self.is_transmitting_reservable_bandwidth_enabled = value
                        self.is_transmitting_reservable_bandwidth_enabled.value_namespace = name_space
                        self.is_transmitting_reservable_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-address"):
                        self.link_address = value
                        self.link_address.value_namespace = name_space
                        self.link_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-maximum-reservable-bandwidth"):
                        self.link_maximum_reservable_bandwidth = value
                        self.link_maximum_reservable_bandwidth.value_namespace = name_space
                        self.link_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-igp-id"):
                        self.neighbor_igp_id = value
                        self.neighbor_igp_id.value_namespace = name_space
                        self.neighbor_igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "outgoing-interface-id"):
                        self.outgoing_interface_id = value
                        self.outgoing_interface_id.value_namespace = name_space
                        self.outgoing_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "physical-bandwidth"):
                        self.physical_bandwidth = value
                        self.physical_bandwidth.value_namespace = name_space
                        self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "receiving-direction"):
                        self.receiving_direction = value
                        self.receiving_direction.value_namespace = name_space
                        self.receiving_direction.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth"):
                        self.reservable_pool0_bandwidth = value
                        self.reservable_pool0_bandwidth.value_namespace = name_space
                        self.reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth"):
                        self.reservable_pool1_bandwidth = value
                        self.reservable_pool1_bandwidth.value_namespace = name_space
                        self.reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "subnet-type"):
                        self.subnet_type = value
                        self.subnet_type.value_namespace = name_space
                        self.subnet_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric"):
                        self.te_metric = value
                        self.te_metric.value_namespace = name_space
                        self.te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "transmitting-direction"):
                        self.transmitting_direction = value
                        self.transmitting_direction.value_namespace = name_space
                        self.transmitting_direction.value_namespace_prefix = name_space_prefix
                    if(value_path == "uni-link-delay"):
                        self.uni_link_delay = value
                        self.uni_link_delay.value_namespace = name_space
                        self.uni_link_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.flooded_link:
                    if (c.has_data()):
                        return True
                return (
                    self.igp_area_id.is_set or
                    self.protocol.is_set or
                    self.router_id.is_set or
                    self.system_id.is_set)

            def has_operation(self):
                for c in self.flooded_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.igp_area_id.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.router_id.yfilter != YFilter.not_set or
                    self.system_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "advertized-areas" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_area_id.get_name_leafdata())
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.router_id.get_name_leafdata())
                if (self.system_id.is_set or self.system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.system_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "flooded-link"):
                    for c in self.flooded_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.flooded_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "flooded-link" or name == "igp-area-id" or name == "protocol" or name == "router-id" or name == "system-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "igp-area-id"):
                    self.igp_area_id = value
                    self.igp_area_id.value_namespace = name_space
                    self.igp_area_id.value_namespace_prefix = name_space_prefix
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "router-id"):
                    self.router_id = value
                    self.router_id.value_namespace = name_space
                    self.router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "system-id"):
                    self.system_id = value
                    self.system_id.value_namespace = name_space
                    self.system_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.advertized_areas:
                if (c.has_data()):
                    return True
            return (
                self.ds_te_mode.is_set or
                self.flooding_status_message.is_set or
                self.last_flooding_time.is_set or
                self.last_flooding_trigger.is_set or
                self.next_flooding_time.is_set)

        def has_operation(self):
            for c in self.advertized_areas:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.ds_te_mode.yfilter != YFilter.not_set or
                self.flooding_status_message.yfilter != YFilter.not_set or
                self.last_flooding_time.yfilter != YFilter.not_set or
                self.last_flooding_trigger.yfilter != YFilter.not_set or
                self.next_flooding_time.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "advertisements" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.ds_te_mode.is_set or self.ds_te_mode.yfilter != YFilter.not_set):
                leaf_name_data.append(self.ds_te_mode.get_name_leafdata())
            if (self.flooding_status_message.is_set or self.flooding_status_message.yfilter != YFilter.not_set):
                leaf_name_data.append(self.flooding_status_message.get_name_leafdata())
            if (self.last_flooding_time.is_set or self.last_flooding_time.yfilter != YFilter.not_set):
                leaf_name_data.append(self.last_flooding_time.get_name_leafdata())
            if (self.last_flooding_trigger.is_set or self.last_flooding_trigger.yfilter != YFilter.not_set):
                leaf_name_data.append(self.last_flooding_trigger.get_name_leafdata())
            if (self.next_flooding_time.is_set or self.next_flooding_time.yfilter != YFilter.not_set):
                leaf_name_data.append(self.next_flooding_time.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "advertized-areas"):
                for c in self.advertized_areas:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.Advertisements.AdvertizedAreas()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.advertized_areas.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "advertized-areas" or name == "ds-te-mode" or name == "flooding-status-message" or name == "last-flooding-time" or name == "last-flooding-trigger" or name == "next-flooding-time"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "ds-te-mode"):
                self.ds_te_mode = value
                self.ds_te_mode.value_namespace = name_space
                self.ds_te_mode.value_namespace_prefix = name_space_prefix
            if(value_path == "flooding-status-message"):
                self.flooding_status_message = value
                self.flooding_status_message.value_namespace = name_space
                self.flooding_status_message.value_namespace_prefix = name_space_prefix
            if(value_path == "last-flooding-time"):
                self.last_flooding_time = value
                self.last_flooding_time.value_namespace = name_space
                self.last_flooding_time.value_namespace_prefix = name_space_prefix
            if(value_path == "last-flooding-trigger"):
                self.last_flooding_trigger = value
                self.last_flooding_trigger.value_namespace = name_space
                self.last_flooding_trigger.value_namespace_prefix = name_space_prefix
            if(value_path == "next-flooding-time"):
                self.next_flooding_time = value
                self.next_flooding_time.value_namespace = name_space
                self.next_flooding_time.value_namespace_prefix = name_space_prefix


    class Statistics(Entity):
        """
        The interface statistics information in
        MPLS\-LCAC
        
        .. attribute:: statstics_links
        
        	The table of statistics interfaces in MPLS\-LCAC
        	**type**\:   :py:class:`StatsticsLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks>`
        
        .. attribute:: summary
        
        	The statistics summary for all interfaces
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-lcac"

            self.statstics_links = MplsLcac.Statistics.StatsticsLinks()
            self.statstics_links.parent = self
            self._children_name_map["statstics_links"] = "statstics-links"
            self._children_yang_names.add("statstics-links")

            self.summary = MplsLcac.Statistics.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            The statistics summary for all interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: path_statistics
            
            	Deprecated
            	**type**\:   :py:class:`PathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.PathStatistics>`
            
            .. attribute:: path_statistics32_bit
            
            	Path counters (32\-bit)
            	**type**\:   :py:class:`PathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.PathStatistics32Bit>`
            
            .. attribute:: reservation_statistics
            
            	Deprecated
            	**type**\:   :py:class:`ReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.ReservationStatistics>`
            
            .. attribute:: reservation_statistics32_bit
            
            	Reservation counters (32\-bit)
            	**type**\:   :py:class:`ReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.ReservationStatistics32Bit>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Statistics.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "statistics"

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.path_statistics = MplsLcac.Statistics.Summary.PathStatistics()
                self.path_statistics.parent = self
                self._children_name_map["path_statistics"] = "path-statistics"
                self._children_yang_names.add("path-statistics")

                self.path_statistics32_bit = MplsLcac.Statistics.Summary.PathStatistics32Bit()
                self.path_statistics32_bit.parent = self
                self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"
                self._children_yang_names.add("path-statistics32-bit")

                self.reservation_statistics = MplsLcac.Statistics.Summary.ReservationStatistics()
                self.reservation_statistics.parent = self
                self._children_name_map["reservation_statistics"] = "reservation-statistics"
                self._children_yang_names.add("reservation-statistics")

                self.reservation_statistics32_bit = MplsLcac.Statistics.Summary.ReservationStatistics32Bit()
                self.reservation_statistics32_bit.parent = self
                self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                self._children_yang_names.add("reservation-statistics32-bit")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_role_standby") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.Statistics.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.Statistics.Summary, self).__setattr__(name, value)


            class PathStatistics(Entity):
                """
                Deprecated
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Statistics.Summary.PathStatistics, self).__init__()

                    self.yang_name = "path-statistics"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Statistics.Summary.PathStatistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Statistics.Summary.PathStatistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class ReservationStatistics(Entity):
                """
                Deprecated
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Statistics.Summary.ReservationStatistics, self).__init__()

                    self.yang_name = "reservation-statistics"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Statistics.Summary.ReservationStatistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Statistics.Summary.ReservationStatistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "reservation-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class PathStatistics32Bit(Entity):
                """
                Path counters (32\-bit)
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Statistics.Summary.PathStatistics32Bit, self).__init__()

                    self.yang_name = "path-statistics32-bit"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Statistics.Summary.PathStatistics32Bit, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Statistics.Summary.PathStatistics32Bit, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-statistics32-bit" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix


            class ReservationStatistics32Bit(Entity):
                """
                Reservation counters (32\-bit)
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Statistics.Summary.ReservationStatistics32Bit, self).__init__()

                    self.yang_name = "reservation-statistics32-bit"
                    self.yang_parent_name = "summary"

                    self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                    self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                    self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                    self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                    self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                    self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                    self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("setup_admits",
                                    "setup_errors",
                                    "setup_rejects",
                                    "setup_requests",
                                    "tear_errors",
                                    "tear_preempts",
                                    "tear_requests") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Statistics.Summary.ReservationStatistics32Bit, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Statistics.Summary.ReservationStatistics32Bit, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.setup_admits.is_set or
                        self.setup_errors.is_set or
                        self.setup_rejects.is_set or
                        self.setup_requests.is_set or
                        self.tear_errors.is_set or
                        self.tear_preempts.is_set or
                        self.tear_requests.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.setup_admits.yfilter != YFilter.not_set or
                        self.setup_errors.yfilter != YFilter.not_set or
                        self.setup_rejects.yfilter != YFilter.not_set or
                        self.setup_requests.yfilter != YFilter.not_set or
                        self.tear_errors.yfilter != YFilter.not_set or
                        self.tear_preempts.yfilter != YFilter.not_set or
                        self.tear_requests.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "reservation-statistics32-bit" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_admits.get_name_leafdata())
                    if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_errors.get_name_leafdata())
                    if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                    if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_requests.get_name_leafdata())
                    if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_errors.get_name_leafdata())
                    if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                    if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tear_requests.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "setup-admits"):
                        self.setup_admits = value
                        self.setup_admits.value_namespace = name_space
                        self.setup_admits.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-errors"):
                        self.setup_errors = value
                        self.setup_errors.value_namespace = name_space
                        self.setup_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-rejects"):
                        self.setup_rejects = value
                        self.setup_rejects.value_namespace = name_space
                        self.setup_rejects.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-requests"):
                        self.setup_requests = value
                        self.setup_requests.value_namespace = name_space
                        self.setup_requests.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-errors"):
                        self.tear_errors = value
                        self.tear_errors.value_namespace = name_space
                        self.tear_errors.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-preempts"):
                        self.tear_preempts = value
                        self.tear_preempts.value_namespace = name_space
                        self.tear_preempts.value_namespace_prefix = name_space_prefix
                    if(value_path == "tear-requests"):
                        self.tear_requests = value
                        self.tear_requests.value_namespace = name_space
                        self.tear_requests.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.is_role_standby.is_set or
                    (self.path_statistics is not None and self.path_statistics.has_data()) or
                    (self.path_statistics32_bit is not None and self.path_statistics32_bit.has_data()) or
                    (self.reservation_statistics is not None and self.reservation_statistics.has_data()) or
                    (self.reservation_statistics32_bit is not None and self.reservation_statistics32_bit.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    (self.path_statistics is not None and self.path_statistics.has_operation()) or
                    (self.path_statistics32_bit is not None and self.path_statistics32_bit.has_operation()) or
                    (self.reservation_statistics is not None and self.reservation_statistics.has_operation()) or
                    (self.reservation_statistics32_bit is not None and self.reservation_statistics32_bit.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-statistics"):
                    if (self.path_statistics is None):
                        self.path_statistics = MplsLcac.Statistics.Summary.PathStatistics()
                        self.path_statistics.parent = self
                        self._children_name_map["path_statistics"] = "path-statistics"
                    return self.path_statistics

                if (child_yang_name == "path-statistics32-bit"):
                    if (self.path_statistics32_bit is None):
                        self.path_statistics32_bit = MplsLcac.Statistics.Summary.PathStatistics32Bit()
                        self.path_statistics32_bit.parent = self
                        self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"
                    return self.path_statistics32_bit

                if (child_yang_name == "reservation-statistics"):
                    if (self.reservation_statistics is None):
                        self.reservation_statistics = MplsLcac.Statistics.Summary.ReservationStatistics()
                        self.reservation_statistics.parent = self
                        self._children_name_map["reservation_statistics"] = "reservation-statistics"
                    return self.reservation_statistics

                if (child_yang_name == "reservation-statistics32-bit"):
                    if (self.reservation_statistics32_bit is None):
                        self.reservation_statistics32_bit = MplsLcac.Statistics.Summary.ReservationStatistics32Bit()
                        self.reservation_statistics32_bit.parent = self
                        self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                    return self.reservation_statistics32_bit

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-statistics" or name == "path-statistics32-bit" or name == "reservation-statistics" or name == "reservation-statistics32-bit" or name == "is-role-standby"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix


        class StatsticsLinks(Entity):
            """
            The table of statistics interfaces in MPLS\-LCAC
            
            .. attribute:: statstics_link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of    :py:class:`StatsticsLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Statistics.StatsticsLinks, self).__init__()

                self.yang_name = "statstics-links"
                self.yang_parent_name = "statistics"

                self.statstics_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.Statistics.StatsticsLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.Statistics.StatsticsLinks, self).__setattr__(name, value)


            class StatsticsLink(Entity):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: incoming_path_statistics
                
                	Deprecated
                	**type**\:   :py:class:`IncomingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics>`
                
                .. attribute:: incoming_path_statistics32_bit
                
                	Incoming PATH counters
                	**type**\:   :py:class:`IncomingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit>`
                
                .. attribute:: incoming_reservation_statistics
                
                	Deprecated
                	**type**\:   :py:class:`IncomingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics>`
                
                .. attribute:: incoming_reservation_statistics32_bit
                
                	Incoming RESV counters
                	**type**\:   :py:class:`IncomingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit>`
                
                .. attribute:: interface_name_xr
                
                	Link name
                	**type**\:  str
                
                .. attribute:: link_address
                
                	Link's ip address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: outgoing_path_statistics
                
                	Deprecated
                	**type**\:   :py:class:`OutgoingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics>`
                
                .. attribute:: outgoing_path_statistics32_bit
                
                	Outgoing PATH counters
                	**type**\:   :py:class:`OutgoingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit>`
                
                .. attribute:: outgoing_reservation_statistics
                
                	Deprecated
                	**type**\:   :py:class:`OutgoingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics>`
                
                .. attribute:: outgoing_reservation_statistics32_bit
                
                	Outgoing RESV counters
                	**type**\:   :py:class:`OutgoingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink, self).__init__()

                    self.yang_name = "statstics-link"
                    self.yang_parent_name = "statstics-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                    self.link_address = YLeaf(YType.str, "link-address")

                    self.incoming_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                    self.incoming_path_statistics.parent = self
                    self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"
                    self._children_yang_names.add("incoming-path-statistics")

                    self.incoming_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                    self.incoming_path_statistics32_bit.parent = self
                    self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"
                    self._children_yang_names.add("incoming-path-statistics32-bit")

                    self.incoming_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                    self.incoming_reservation_statistics.parent = self
                    self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"
                    self._children_yang_names.add("incoming-reservation-statistics")

                    self.incoming_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                    self.incoming_reservation_statistics32_bit.parent = self
                    self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"
                    self._children_yang_names.add("incoming-reservation-statistics32-bit")

                    self.outgoing_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                    self.outgoing_path_statistics.parent = self
                    self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"
                    self._children_yang_names.add("outgoing-path-statistics")

                    self.outgoing_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                    self.outgoing_path_statistics32_bit.parent = self
                    self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"
                    self._children_yang_names.add("outgoing-path-statistics32-bit")

                    self.outgoing_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                    self.outgoing_reservation_statistics.parent = self
                    self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"
                    self._children_yang_names.add("outgoing-reservation-statistics")

                    self.outgoing_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                    self.outgoing_reservation_statistics32_bit.parent = self
                    self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                    self._children_yang_names.add("outgoing-reservation-statistics32-bit")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "interface_name_xr",
                                    "link_address") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink, self).__setattr__(name, value)


                class IncomingPathStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__init__()

                        self.yang_name = "incoming-path-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-path-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingReservationStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__init__()

                        self.yang_name = "incoming-reservation-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-reservation-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingPathStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__init__()

                        self.yang_name = "outgoing-path-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-path-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingReservationStatistics(Entity):
                    """
                    Deprecated
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint16, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint16, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint16, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint16, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint16, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint16, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint16, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-reservation-statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingPathStatistics32Bit(Entity):
                    """
                    Incoming PATH counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-path-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class IncomingReservationStatistics32Bit(Entity):
                    """
                    Incoming RESV counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "incoming-reservation-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingPathStatistics32Bit(Entity):
                    """
                    Outgoing PATH counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-path-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix


                class OutgoingReservationStatistics32Bit(Entity):
                    """
                    Outgoing RESV counters
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"

                        self.setup_admits = YLeaf(YType.uint32, "setup-admits")

                        self.setup_errors = YLeaf(YType.uint32, "setup-errors")

                        self.setup_rejects = YLeaf(YType.uint32, "setup-rejects")

                        self.setup_requests = YLeaf(YType.uint32, "setup-requests")

                        self.tear_errors = YLeaf(YType.uint32, "tear-errors")

                        self.tear_preempts = YLeaf(YType.uint32, "tear-preempts")

                        self.tear_requests = YLeaf(YType.uint32, "tear-requests")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("setup_admits",
                                        "setup_errors",
                                        "setup_rejects",
                                        "setup_requests",
                                        "tear_errors",
                                        "tear_preempts",
                                        "tear_requests") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.setup_admits.is_set or
                            self.setup_errors.is_set or
                            self.setup_rejects.is_set or
                            self.setup_requests.is_set or
                            self.tear_errors.is_set or
                            self.tear_preempts.is_set or
                            self.tear_requests.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.setup_admits.yfilter != YFilter.not_set or
                            self.setup_errors.yfilter != YFilter.not_set or
                            self.setup_rejects.yfilter != YFilter.not_set or
                            self.setup_requests.yfilter != YFilter.not_set or
                            self.tear_errors.yfilter != YFilter.not_set or
                            self.tear_preempts.yfilter != YFilter.not_set or
                            self.tear_requests.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "outgoing-reservation-statistics32-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.setup_admits.is_set or self.setup_admits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_admits.get_name_leafdata())
                        if (self.setup_errors.is_set or self.setup_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_errors.get_name_leafdata())
                        if (self.setup_rejects.is_set or self.setup_rejects.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_rejects.get_name_leafdata())
                        if (self.setup_requests.is_set or self.setup_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_requests.get_name_leafdata())
                        if (self.tear_errors.is_set or self.tear_errors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_errors.get_name_leafdata())
                        if (self.tear_preempts.is_set or self.tear_preempts.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_preempts.get_name_leafdata())
                        if (self.tear_requests.is_set or self.tear_requests.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tear_requests.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "setup-admits" or name == "setup-errors" or name == "setup-rejects" or name == "setup-requests" or name == "tear-errors" or name == "tear-preempts" or name == "tear-requests"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "setup-admits"):
                            self.setup_admits = value
                            self.setup_admits.value_namespace = name_space
                            self.setup_admits.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-errors"):
                            self.setup_errors = value
                            self.setup_errors.value_namespace = name_space
                            self.setup_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-rejects"):
                            self.setup_rejects = value
                            self.setup_rejects.value_namespace = name_space
                            self.setup_rejects.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-requests"):
                            self.setup_requests = value
                            self.setup_requests.value_namespace = name_space
                            self.setup_requests.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-errors"):
                            self.tear_errors = value
                            self.tear_errors.value_namespace = name_space
                            self.tear_errors.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-preempts"):
                            self.tear_preempts = value
                            self.tear_preempts.value_namespace = name_space
                            self.tear_preempts.value_namespace_prefix = name_space_prefix
                        if(value_path == "tear-requests"):
                            self.tear_requests = value
                            self.tear_requests.value_namespace = name_space
                            self.tear_requests.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.interface_name_xr.is_set or
                        self.link_address.is_set or
                        (self.incoming_path_statistics is not None and self.incoming_path_statistics.has_data()) or
                        (self.incoming_path_statistics32_bit is not None and self.incoming_path_statistics32_bit.has_data()) or
                        (self.incoming_reservation_statistics is not None and self.incoming_reservation_statistics.has_data()) or
                        (self.incoming_reservation_statistics32_bit is not None and self.incoming_reservation_statistics32_bit.has_data()) or
                        (self.outgoing_path_statistics is not None and self.outgoing_path_statistics.has_data()) or
                        (self.outgoing_path_statistics32_bit is not None and self.outgoing_path_statistics32_bit.has_data()) or
                        (self.outgoing_reservation_statistics is not None and self.outgoing_reservation_statistics.has_data()) or
                        (self.outgoing_reservation_statistics32_bit is not None and self.outgoing_reservation_statistics32_bit.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.interface_name_xr.yfilter != YFilter.not_set or
                        self.link_address.yfilter != YFilter.not_set or
                        (self.incoming_path_statistics is not None and self.incoming_path_statistics.has_operation()) or
                        (self.incoming_path_statistics32_bit is not None and self.incoming_path_statistics32_bit.has_operation()) or
                        (self.incoming_reservation_statistics is not None and self.incoming_reservation_statistics.has_operation()) or
                        (self.incoming_reservation_statistics32_bit is not None and self.incoming_reservation_statistics32_bit.has_operation()) or
                        (self.outgoing_path_statistics is not None and self.outgoing_path_statistics.has_operation()) or
                        (self.outgoing_path_statistics32_bit is not None and self.outgoing_path_statistics32_bit.has_operation()) or
                        (self.outgoing_reservation_statistics is not None and self.outgoing_reservation_statistics.has_operation()) or
                        (self.outgoing_reservation_statistics32_bit is not None and self.outgoing_reservation_statistics32_bit.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statstics-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/statstics-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                    if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "incoming-path-statistics"):
                        if (self.incoming_path_statistics is None):
                            self.incoming_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                            self.incoming_path_statistics.parent = self
                            self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"
                        return self.incoming_path_statistics

                    if (child_yang_name == "incoming-path-statistics32-bit"):
                        if (self.incoming_path_statistics32_bit is None):
                            self.incoming_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                            self.incoming_path_statistics32_bit.parent = self
                            self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"
                        return self.incoming_path_statistics32_bit

                    if (child_yang_name == "incoming-reservation-statistics"):
                        if (self.incoming_reservation_statistics is None):
                            self.incoming_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                            self.incoming_reservation_statistics.parent = self
                            self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"
                        return self.incoming_reservation_statistics

                    if (child_yang_name == "incoming-reservation-statistics32-bit"):
                        if (self.incoming_reservation_statistics32_bit is None):
                            self.incoming_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                            self.incoming_reservation_statistics32_bit.parent = self
                            self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"
                        return self.incoming_reservation_statistics32_bit

                    if (child_yang_name == "outgoing-path-statistics"):
                        if (self.outgoing_path_statistics is None):
                            self.outgoing_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                            self.outgoing_path_statistics.parent = self
                            self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"
                        return self.outgoing_path_statistics

                    if (child_yang_name == "outgoing-path-statistics32-bit"):
                        if (self.outgoing_path_statistics32_bit is None):
                            self.outgoing_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                            self.outgoing_path_statistics32_bit.parent = self
                            self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"
                        return self.outgoing_path_statistics32_bit

                    if (child_yang_name == "outgoing-reservation-statistics"):
                        if (self.outgoing_reservation_statistics is None):
                            self.outgoing_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                            self.outgoing_reservation_statistics.parent = self
                            self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"
                        return self.outgoing_reservation_statistics

                    if (child_yang_name == "outgoing-reservation-statistics32-bit"):
                        if (self.outgoing_reservation_statistics32_bit is None):
                            self.outgoing_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                            self.outgoing_reservation_statistics32_bit.parent = self
                            self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                        return self.outgoing_reservation_statistics32_bit

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "incoming-path-statistics" or name == "incoming-path-statistics32-bit" or name == "incoming-reservation-statistics" or name == "incoming-reservation-statistics32-bit" or name == "outgoing-path-statistics" or name == "outgoing-path-statistics32-bit" or name == "outgoing-reservation-statistics" or name == "outgoing-reservation-statistics32-bit" or name == "interface-name" or name == "interface-name-xr" or name == "link-address"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name-xr"):
                        self.interface_name_xr = value
                        self.interface_name_xr.value_namespace = name_space
                        self.interface_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-address"):
                        self.link_address = value
                        self.link_address.value_namespace = name_space
                        self.link_address.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.statstics_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.statstics_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "statstics-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "statstics-link"):
                    for c in self.statstics_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.Statistics.StatsticsLinks.StatsticsLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.statstics_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "statstics-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.statstics_links is not None and self.statstics_links.has_data()) or
                (self.summary is not None and self.summary.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.statstics_links is not None and self.statstics_links.has_operation()) or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "statistics" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "statstics-links"):
                if (self.statstics_links is None):
                    self.statstics_links = MplsLcac.Statistics.StatsticsLinks()
                    self.statstics_links.parent = self
                    self._children_name_map["statstics_links"] = "statstics-links"
                return self.statstics_links

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsLcac.Statistics.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "statstics-links" or name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BandwidthAllocation(Entity):
        """
        The bandwidth allocation information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_allocation_links
        
        	Per\-link bandwidth allocation information in MPLS\-LCAC
        	**type**\:   :py:class:`BandwidthAllocationLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks>`
        
        .. attribute:: global_
        
        	Global bandwidth allocation information for all interfaces
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.Global_>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.BandwidthAllocation, self).__init__()

            self.yang_name = "bandwidth-allocation"
            self.yang_parent_name = "mpls-lcac"

            self.bandwidth_allocation_links = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks()
            self.bandwidth_allocation_links.parent = self
            self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
            self._children_yang_names.add("bandwidth-allocation-links")

            self.global_ = MplsLcac.BandwidthAllocation.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")


        class Global_(Entity):
            """
            Global bandwidth allocation information for all
            interfaces
            
            .. attribute:: bandwidth_hold_time
            
            	How long to hold the bandwidth (seconds)
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: links
            
            	Number of links
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.BandwidthAllocation.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "bandwidth-allocation"

                self.bandwidth_hold_time = YLeaf(YType.uint16, "bandwidth-hold-time")

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.links = YLeaf(YType.uint16, "links")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("bandwidth_hold_time",
                                "is_role_standby",
                                "links") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.BandwidthAllocation.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.BandwidthAllocation.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.bandwidth_hold_time.is_set or
                    self.is_role_standby.is_set or
                    self.links.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.bandwidth_hold_time.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.links.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.bandwidth_hold_time.is_set or self.bandwidth_hold_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_hold_time.get_name_leafdata())
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-hold-time" or name == "is-role-standby" or name == "links"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "bandwidth-hold-time"):
                    self.bandwidth_hold_time = value
                    self.bandwidth_hold_time.value_namespace = name_space
                    self.bandwidth_hold_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "links"):
                    self.links = value
                    self.links.value_namespace = name_space
                    self.links.value_namespace_prefix = name_space_prefix


        class BandwidthAllocationLinks(Entity):
            """
            Per\-link bandwidth allocation information in
            MPLS\-LCAC
            
            .. attribute:: bandwidth_allocation_link
            
            	The bandwidth allocation for a given interface
            	**type**\: list of    :py:class:`BandwidthAllocationLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks, self).__init__()

                self.yang_name = "bandwidth-allocation-links"
                self.yang_parent_name = "bandwidth-allocation"

                self.bandwidth_allocation_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks, self).__setattr__(name, value)


            class BandwidthAllocationLink(Entity):
                """
                The bandwidth allocation for a given interface
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: bandwidth_descriptors
                
                	Number of BW descriptor for the given pool
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: bandwidth_pool
                
                	type of the BW pool
                	**type**\:   :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                .. attribute:: downstream_bandwidth
                
                	BW info in the dnstream direction
                	**type**\:   :py:class:`DownstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth>`
                
                .. attribute:: flooding_down_threshold
                
                	Flooding down\-thresholds
                	**type**\: list of    :py:class:`FloodingDownThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold>`
                
                .. attribute:: flooding_down_thresholds_are_default
                
                	TRUE if the down\-threshold are default
                	**type**\:  bool
                
                .. attribute:: flooding_down_thresholds_are_global
                
                	TRUE if the down\-threshold are global
                	**type**\:  bool
                
                .. attribute:: flooding_up_threshold
                
                	Flooding up\-thresholds
                	**type**\: list of    :py:class:`FloodingUpThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold>`
                
                .. attribute:: flooding_up_thresholds_are_default
                
                	TRUE if the up\-threshold are default
                	**type**\:  bool
                
                .. attribute:: flooding_up_thresholds_are_global
                
                	TRUE if the up\-threshold are global
                	**type**\:  bool
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:   :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon>`
                
                .. attribute:: total_bandwidth_descriptors
                
                	Number of total BW descriptors
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: upstream_bandwidth
                
                	BW info in the upstream direction
                	**type**\:   :py:class:`UpstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__init__()

                    self.yang_name = "bandwidth-allocation-link"
                    self.yang_parent_name = "bandwidth-allocation-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.bandwidth_descriptors = YLeaf(YType.uint16, "bandwidth-descriptors")

                    self.bandwidth_pool = YLeaf(YType.enumeration, "bandwidth-pool")

                    self.flooding_down_thresholds_are_default = YLeaf(YType.boolean, "flooding-down-thresholds-are-default")

                    self.flooding_down_thresholds_are_global = YLeaf(YType.boolean, "flooding-down-thresholds-are-global")

                    self.flooding_up_thresholds_are_default = YLeaf(YType.boolean, "flooding-up-thresholds-are-default")

                    self.flooding_up_thresholds_are_global = YLeaf(YType.boolean, "flooding-up-thresholds-are-global")

                    self.total_bandwidth_descriptors = YLeaf(YType.uint16, "total-bandwidth-descriptors")

                    self.downstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                    self.downstream_bandwidth.parent = self
                    self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"
                    self._children_yang_names.add("downstream-bandwidth")

                    self.link_common = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"
                    self._children_yang_names.add("link-common")

                    self.upstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                    self.upstream_bandwidth.parent = self
                    self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"
                    self._children_yang_names.add("upstream-bandwidth")

                    self.flooding_down_threshold = YList(self)
                    self.flooding_up_threshold = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "bandwidth_descriptors",
                                    "bandwidth_pool",
                                    "flooding_down_thresholds_are_default",
                                    "flooding_down_thresholds_are_global",
                                    "flooding_up_thresholds_are_default",
                                    "flooding_up_thresholds_are_global",
                                    "total_bandwidth_descriptors") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__setattr__(name, value)


                class LinkCommon(Entity):
                    """
                    The link's common info
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of    :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas>`
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\:  bool
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of    :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\:  bool
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\:  bool
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:   :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags>`
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\:  str
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:   :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup>`
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                        self.capability = YLeaf(YType.uint32, "capability")

                        self.has_protection = YLeaf(YType.boolean, "has-protection")

                        self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                        self.inbound_admission_method = YLeaf(YType.enumeration, "inbound-admission-method")

                        self.incoming_reservable_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-bandwidth-percentage")

                        self.incoming_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool0-bandwidth-percentage")

                        self.incoming_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool1-bandwidth-percentage")

                        self.is_resource_provider_installed = YLeaf(YType.boolean, "is-resource-provider-installed")

                        self.is_unnumbered = YLeaf(YType.boolean, "is-unnumbered")

                        self.last_flooded_effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "last-flooded-effective-maximum-reservable-bandwidth")

                        self.link_address = YLeaf(YType.str, "link-address")

                        self.link_id = YLeaf(YType.str, "link-id")

                        self.maximum_reservable_bandwidth = YLeaf(YType.uint64, "maximum-reservable-bandwidth")

                        self.maximum_reservable_pool0_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool0-bandwidth")

                        self.maximum_reservable_pool1_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool1-bandwidth")

                        self.outbound_admission_method = YLeaf(YType.enumeration, "outbound-admission-method")

                        self.outgoing_reservable_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-bandwidth-percentage")

                        self.outgoing_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool0-bandwidth-percentage")

                        self.outgoing_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool1-bandwidth-percentage")

                        self.physical_bandwidth = YLeaf(YType.uint64, "physical-bandwidth")

                        self.resource_provider = YLeaf(YType.enumeration, "resource-provider")

                        self.working_priority = YLeaf(YType.uint32, "working-priority")

                        self.link_flags = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"
                        self._children_yang_names.add("link-flags")

                        self.flooded_areas = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_units",
                                        "bcm_id",
                                        "capability",
                                        "has_protection",
                                        "igp_neighbors",
                                        "inbound_admission_method",
                                        "incoming_reservable_bandwidth_percentage",
                                        "incoming_reservable_pool0_bandwidth_percentage",
                                        "incoming_reservable_pool1_bandwidth_percentage",
                                        "is_resource_provider_installed",
                                        "is_unnumbered",
                                        "last_flooded_effective_maximum_reservable_bandwidth",
                                        "link_address",
                                        "link_id",
                                        "maximum_reservable_bandwidth",
                                        "maximum_reservable_pool0_bandwidth",
                                        "maximum_reservable_pool1_bandwidth",
                                        "outbound_admission_method",
                                        "outgoing_reservable_bandwidth_percentage",
                                        "outgoing_reservable_pool0_bandwidth_percentage",
                                        "outgoing_reservable_pool1_bandwidth_percentage",
                                        "physical_bandwidth",
                                        "resource_provider",
                                        "working_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__setattr__(name, value)


                    class LinkFlags(Entity):
                        """
                        The link's flags
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\:  bool
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\:  bool
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:   :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"

                            self.is_admin_up = YLeaf(YType.boolean, "is-admin-up")

                            self.is_mpls_te_on = YLeaf(YType.boolean, "is-mpls-te-on")

                            self.signaling_agent = YLeaf(YType.enumeration, "signaling-agent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_admin_up",
                                            "is_mpls_te_on",
                                            "signaling_agent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_admin_up.is_set or
                                self.is_mpls_te_on.is_set or
                                self.signaling_agent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_admin_up.yfilter != YFilter.not_set or
                                self.is_mpls_te_on.yfilter != YFilter.not_set or
                                self.signaling_agent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "link-flags" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_admin_up.is_set or self.is_admin_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_admin_up.get_name_leafdata())
                            if (self.is_mpls_te_on.is_set or self.is_mpls_te_on.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mpls_te_on.get_name_leafdata())
                            if (self.signaling_agent.is_set or self.signaling_agent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaling_agent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-admin-up" or name == "is-mpls-te-on" or name == "signaling-agent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-admin-up"):
                                self.is_admin_up = value
                                self.is_admin_up.value_namespace = name_space
                                self.is_admin_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-mpls-te-on"):
                                self.is_mpls_te_on = value
                                self.is_mpls_te_on.value_namespace = name_space
                                self.is_mpls_te_on.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaling-agent"):
                                self.signaling_agent = value
                                self.signaling_agent.value_namespace = name_space
                                self.signaling_agent.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class InterfaceSwitchingCapabilityDescriptor(Entity):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"

                            self.encoding = YLeaf(YType.uint8, "encoding")

                            self.key = YLeaf(YType.uint8, "key")

                            self.switching_capability = YLeaf(YType.uint8, "switching-capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("encoding",
                                            "key",
                                            "switching_capability") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.encoding.is_set or
                                self.key.is_set or
                                self.switching_capability.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.encoding.yfilter != YFilter.not_set or
                                self.key.yfilter != YFilter.not_set or
                                self.switching_capability.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-switching-capability-descriptor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.encoding.is_set or self.encoding.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.encoding.get_name_leafdata())
                            if (self.key.is_set or self.key.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.key.get_name_leafdata())
                            if (self.switching_capability.is_set or self.switching_capability.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switching_capability.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "encoding" or name == "key" or name == "switching-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "encoding"):
                                self.encoding = value
                                self.encoding.value_namespace = name_space
                                self.encoding.value_namespace_prefix = name_space_prefix
                            if(value_path == "key"):
                                self.key = value
                                self.key.value_namespace = name_space
                                self.key.value_namespace_prefix = name_space_prefix
                            if(value_path == "switching-capability"):
                                self.switching_capability = value
                                self.switching_capability.value_namespace = name_space
                                self.switching_capability.value_namespace_prefix = name_space_prefix


                    class FloodedAreas(Entity):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"

                            self.flooded_area = YLeaf(YType.str, "flooded-area")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("flooded_area") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__setattr__(name, value)

                        def has_data(self):
                            return self.flooded_area.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.flooded_area.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flooded-areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.flooded_area.is_set or self.flooded_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flooded_area.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flooded-area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "flooded-area"):
                                self.flooded_area = value
                                self.flooded_area.value_namespace = name_space
                                self.flooded_area.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.flooded_areas:
                            if (c.has_data()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_units.is_set or
                            self.bcm_id.is_set or
                            self.capability.is_set or
                            self.has_protection.is_set or
                            self.igp_neighbors.is_set or
                            self.inbound_admission_method.is_set or
                            self.incoming_reservable_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.is_set or
                            self.is_resource_provider_installed.is_set or
                            self.is_unnumbered.is_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.is_set or
                            self.link_address.is_set or
                            self.link_id.is_set or
                            self.maximum_reservable_bandwidth.is_set or
                            self.maximum_reservable_pool0_bandwidth.is_set or
                            self.maximum_reservable_pool1_bandwidth.is_set or
                            self.outbound_admission_method.is_set or
                            self.outgoing_reservable_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.is_set or
                            self.physical_bandwidth.is_set or
                            self.resource_provider.is_set or
                            self.working_priority.is_set or
                            (self.link_flags is not None and self.link_flags.has_data()))

                    def has_operation(self):
                        for c in self.flooded_areas:
                            if (c.has_operation()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.bcm_id.yfilter != YFilter.not_set or
                            self.capability.yfilter != YFilter.not_set or
                            self.has_protection.yfilter != YFilter.not_set or
                            self.igp_neighbors.yfilter != YFilter.not_set or
                            self.inbound_admission_method.yfilter != YFilter.not_set or
                            self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.is_resource_provider_installed.yfilter != YFilter.not_set or
                            self.is_unnumbered.yfilter != YFilter.not_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.link_address.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                            self.outbound_admission_method.yfilter != YFilter.not_set or
                            self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.physical_bandwidth.yfilter != YFilter.not_set or
                            self.resource_provider.yfilter != YFilter.not_set or
                            self.working_priority.yfilter != YFilter.not_set or
                            (self.link_flags is not None and self.link_flags.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcm_id.get_name_leafdata())
                        if (self.capability.is_set or self.capability.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.capability.get_name_leafdata())
                        if (self.has_protection.is_set or self.has_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_protection.get_name_leafdata())
                        if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                        if (self.inbound_admission_method.is_set or self.inbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inbound_admission_method.get_name_leafdata())
                        if (self.incoming_reservable_bandwidth_percentage.is_set or self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool0_bandwidth_percentage.is_set or self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool1_bandwidth_percentage.is_set or self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.is_resource_provider_installed.is_set or self.is_resource_provider_installed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_resource_provider_installed.get_name_leafdata())
                        if (self.is_unnumbered.is_set or self.is_unnumbered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unnumbered.get_name_leafdata())
                        if (self.last_flooded_effective_maximum_reservable_bandwidth.is_set or self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_flooded_effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_address.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.maximum_reservable_bandwidth.is_set or self.maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool0_bandwidth.is_set or self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool0_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool1_bandwidth.is_set or self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool1_bandwidth.get_name_leafdata())
                        if (self.outbound_admission_method.is_set or self.outbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_admission_method.get_name_leafdata())
                        if (self.outgoing_reservable_bandwidth_percentage.is_set or self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool0_bandwidth_percentage.is_set or self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool1_bandwidth_percentage.is_set or self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                        if (self.resource_provider.is_set or self.resource_provider.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_provider.get_name_leafdata())
                        if (self.working_priority.is_set or self.working_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.working_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "flooded-areas"):
                            for c in self.flooded_areas:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.flooded_areas.append(c)
                            return c

                        if (child_yang_name == "interface-switching-capability-descriptor"):
                            for c in self.interface_switching_capability_descriptor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface_switching_capability_descriptor.append(c)
                            return c

                        if (child_yang_name == "link-flags"):
                            if (self.link_flags is None):
                                self.link_flags = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                                self.link_flags.parent = self
                                self._children_name_map["link_flags"] = "link-flags"
                            return self.link_flags

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "flooded-areas" or name == "interface-switching-capability-descriptor" or name == "link-flags" or name == "shared-risk-link-group" or name == "bandwidth-units" or name == "bcm-id" or name == "capability" or name == "has-protection" or name == "igp-neighbors" or name == "inbound-admission-method" or name == "incoming-reservable-bandwidth-percentage" or name == "incoming-reservable-pool0-bandwidth-percentage" or name == "incoming-reservable-pool1-bandwidth-percentage" or name == "is-resource-provider-installed" or name == "is-unnumbered" or name == "last-flooded-effective-maximum-reservable-bandwidth" or name == "link-address" or name == "link-id" or name == "maximum-reservable-bandwidth" or name == "maximum-reservable-pool0-bandwidth" or name == "maximum-reservable-pool1-bandwidth" or name == "outbound-admission-method" or name == "outgoing-reservable-bandwidth-percentage" or name == "outgoing-reservable-pool0-bandwidth-percentage" or name == "outgoing-reservable-pool1-bandwidth-percentage" or name == "physical-bandwidth" or name == "resource-provider" or name == "working-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcm-id"):
                            self.bcm_id = value
                            self.bcm_id.value_namespace = name_space
                            self.bcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "capability"):
                            self.capability = value
                            self.capability.value_namespace = name_space
                            self.capability.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-protection"):
                            self.has_protection = value
                            self.has_protection.value_namespace = name_space
                            self.has_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-neighbors"):
                            self.igp_neighbors = value
                            self.igp_neighbors.value_namespace = name_space
                            self.igp_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "inbound-admission-method"):
                            self.inbound_admission_method = value
                            self.inbound_admission_method.value_namespace = name_space
                            self.inbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-bandwidth-percentage"):
                            self.incoming_reservable_bandwidth_percentage = value
                            self.incoming_reservable_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool0-bandwidth-percentage"):
                            self.incoming_reservable_pool0_bandwidth_percentage = value
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool1-bandwidth-percentage"):
                            self.incoming_reservable_pool1_bandwidth_percentage = value
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-resource-provider-installed"):
                            self.is_resource_provider_installed = value
                            self.is_resource_provider_installed.value_namespace = name_space
                            self.is_resource_provider_installed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unnumbered"):
                            self.is_unnumbered = value
                            self.is_unnumbered.value_namespace = name_space
                            self.is_unnumbered.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-flooded-effective-maximum-reservable-bandwidth"):
                            self.last_flooded_effective_maximum_reservable_bandwidth = value
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-address"):
                            self.link_address = value
                            self.link_address.value_namespace = name_space
                            self.link_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-bandwidth"):
                            self.maximum_reservable_bandwidth = value
                            self.maximum_reservable_bandwidth.value_namespace = name_space
                            self.maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool0-bandwidth"):
                            self.maximum_reservable_pool0_bandwidth = value
                            self.maximum_reservable_pool0_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool1-bandwidth"):
                            self.maximum_reservable_pool1_bandwidth = value
                            self.maximum_reservable_pool1_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-admission-method"):
                            self.outbound_admission_method = value
                            self.outbound_admission_method.value_namespace = name_space
                            self.outbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-bandwidth-percentage"):
                            self.outgoing_reservable_bandwidth_percentage = value
                            self.outgoing_reservable_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool0-bandwidth-percentage"):
                            self.outgoing_reservable_pool0_bandwidth_percentage = value
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool1-bandwidth-percentage"):
                            self.outgoing_reservable_pool1_bandwidth_percentage = value
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-bandwidth"):
                            self.physical_bandwidth = value
                            self.physical_bandwidth.value_namespace = name_space
                            self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-provider"):
                            self.resource_provider = value
                            self.resource_provider.value_namespace = name_space
                            self.resource_provider.value_namespace_prefix = name_space_prefix
                        if(value_path == "working-priority"):
                            self.working_priority = value
                            self.working_priority.value_namespace = name_space
                            self.working_priority.value_namespace_prefix = name_space_prefix


                class UpstreamBandwidth(Entity):
                    """
                    BW info in the upstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0>`
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1>`
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__init__()

                        self.yang_name = "upstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_direction = YLeaf(YType.enumeration, "bandwidth-direction")

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.is_admission_method_allocated_bandwidth = YLeaf(YType.boolean, "is-admission-method-allocated-bandwidth")

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_direction",
                                        "bandwidth_units",
                                        "is_admission_method_allocated_bandwidth") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__setattr__(name, value)


                    class BandwidthPool0(Entity):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "upstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool0" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix


                    class BandwidthPool1(Entity):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "upstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool1" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_data()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_direction.is_set or
                            self.bandwidth_units.is_set or
                            self.is_admission_method_allocated_bandwidth.is_set)

                    def has_operation(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_operation()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_direction.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "upstream-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_direction.is_set or self.bandwidth_direction.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_direction.get_name_leafdata())
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.is_admission_method_allocated_bandwidth.is_set or self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_admission_method_allocated_bandwidth.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-pool0"):
                            for c in self.bandwidth_pool0:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool0.append(c)
                            return c

                        if (child_yang_name == "bandwidth-pool1"):
                            for c in self.bandwidth_pool1:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool1.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-pool0" or name == "bandwidth-pool1" or name == "bandwidth-direction" or name == "bandwidth-units" or name == "is-admission-method-allocated-bandwidth"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-direction"):
                            self.bandwidth_direction = value
                            self.bandwidth_direction.value_namespace = name_space
                            self.bandwidth_direction.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-admission-method-allocated-bandwidth"):
                            self.is_admission_method_allocated_bandwidth = value
                            self.is_admission_method_allocated_bandwidth.value_namespace = name_space
                            self.is_admission_method_allocated_bandwidth.value_namespace_prefix = name_space_prefix


                class DownstreamBandwidth(Entity):
                    """
                    BW info in the dnstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:   :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0>`
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of    :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1>`
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__init__()

                        self.yang_name = "downstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.bandwidth_direction = YLeaf(YType.enumeration, "bandwidth-direction")

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.is_admission_method_allocated_bandwidth = YLeaf(YType.boolean, "is-admission-method-allocated-bandwidth")

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_direction",
                                        "bandwidth_units",
                                        "is_admission_method_allocated_bandwidth") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__setattr__(name, value)


                    class BandwidthPool0(Entity):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "downstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool0" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix


                    class BandwidthPool1(Entity):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "downstream-bandwidth"

                            self.held_amount = YLeaf(YType.uint32, "held-amount")

                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                            self.locked_amount = YLeaf(YType.uint32, "locked-amount")

                            self.total_held_amount = YLeaf(YType.uint32, "total-held-amount")

                            self.total_locked_amount = YLeaf(YType.uint32, "total-locked-amount")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("held_amount",
                                            "hold_priority",
                                            "locked_amount",
                                            "total_held_amount",
                                            "total_locked_amount") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.held_amount.is_set or
                                self.hold_priority.is_set or
                                self.locked_amount.is_set or
                                self.total_held_amount.is_set or
                                self.total_locked_amount.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.held_amount.yfilter != YFilter.not_set or
                                self.hold_priority.yfilter != YFilter.not_set or
                                self.locked_amount.yfilter != YFilter.not_set or
                                self.total_held_amount.yfilter != YFilter.not_set or
                                self.total_locked_amount.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-pool1" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.held_amount.is_set or self.held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.held_amount.get_name_leafdata())
                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                            if (self.locked_amount.is_set or self.locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.locked_amount.get_name_leafdata())
                            if (self.total_held_amount.is_set or self.total_held_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_held_amount.get_name_leafdata())
                            if (self.total_locked_amount.is_set or self.total_locked_amount.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_locked_amount.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "held-amount" or name == "hold-priority" or name == "locked-amount" or name == "total-held-amount" or name == "total-locked-amount"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "held-amount"):
                                self.held_amount = value
                                self.held_amount.value_namespace = name_space
                                self.held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-priority"):
                                self.hold_priority = value
                                self.hold_priority.value_namespace = name_space
                                self.hold_priority.value_namespace_prefix = name_space_prefix
                            if(value_path == "locked-amount"):
                                self.locked_amount = value
                                self.locked_amount.value_namespace = name_space
                                self.locked_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-held-amount"):
                                self.total_held_amount = value
                                self.total_held_amount.value_namespace = name_space
                                self.total_held_amount.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-locked-amount"):
                                self.total_locked_amount = value
                                self.total_locked_amount.value_namespace = name_space
                                self.total_locked_amount.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_data()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_direction.is_set or
                            self.bandwidth_units.is_set or
                            self.is_admission_method_allocated_bandwidth.is_set)

                    def has_operation(self):
                        for c in self.bandwidth_pool0:
                            if (c.has_operation()):
                                return True
                        for c in self.bandwidth_pool1:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_direction.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "downstream-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_direction.is_set or self.bandwidth_direction.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_direction.get_name_leafdata())
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.is_admission_method_allocated_bandwidth.is_set or self.is_admission_method_allocated_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_admission_method_allocated_bandwidth.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-pool0"):
                            for c in self.bandwidth_pool0:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool0.append(c)
                            return c

                        if (child_yang_name == "bandwidth-pool1"):
                            for c in self.bandwidth_pool1:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.bandwidth_pool1.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-pool0" or name == "bandwidth-pool1" or name == "bandwidth-direction" or name == "bandwidth-units" or name == "is-admission-method-allocated-bandwidth"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-direction"):
                            self.bandwidth_direction = value
                            self.bandwidth_direction.value_namespace = name_space
                            self.bandwidth_direction.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-admission-method-allocated-bandwidth"):
                            self.is_admission_method_allocated_bandwidth = value
                            self.is_admission_method_allocated_bandwidth.value_namespace = name_space
                            self.is_admission_method_allocated_bandwidth.value_namespace_prefix = name_space_prefix


                class FloodingUpThreshold(Entity):
                    """
                    Flooding up\-thresholds
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__init__()

                        self.yang_name = "flooding-up-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.entry = YLeaf(YType.uint8, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flooding-up-threshold" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class FloodingDownThreshold(Entity):
                    """
                    Flooding down\-thresholds
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__init__()

                        self.yang_name = "flooding-down-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"

                        self.entry = YLeaf(YType.uint8, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flooding-down-threshold" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.flooding_down_threshold:
                        if (c.has_data()):
                            return True
                    for c in self.flooding_up_threshold:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.bandwidth_descriptors.is_set or
                        self.bandwidth_pool.is_set or
                        self.flooding_down_thresholds_are_default.is_set or
                        self.flooding_down_thresholds_are_global.is_set or
                        self.flooding_up_thresholds_are_default.is_set or
                        self.flooding_up_thresholds_are_global.is_set or
                        self.total_bandwidth_descriptors.is_set or
                        (self.downstream_bandwidth is not None and self.downstream_bandwidth.has_data()) or
                        (self.link_common is not None and self.link_common.has_data()) or
                        (self.upstream_bandwidth is not None and self.upstream_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.flooding_down_threshold:
                        if (c.has_operation()):
                            return True
                    for c in self.flooding_up_threshold:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.bandwidth_descriptors.yfilter != YFilter.not_set or
                        self.bandwidth_pool.yfilter != YFilter.not_set or
                        self.flooding_down_thresholds_are_default.yfilter != YFilter.not_set or
                        self.flooding_down_thresholds_are_global.yfilter != YFilter.not_set or
                        self.flooding_up_thresholds_are_default.yfilter != YFilter.not_set or
                        self.flooding_up_thresholds_are_global.yfilter != YFilter.not_set or
                        self.total_bandwidth_descriptors.yfilter != YFilter.not_set or
                        (self.downstream_bandwidth is not None and self.downstream_bandwidth.has_operation()) or
                        (self.link_common is not None and self.link_common.has_operation()) or
                        (self.upstream_bandwidth is not None and self.upstream_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bandwidth-allocation-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/bandwidth-allocation-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.bandwidth_descriptors.is_set or self.bandwidth_descriptors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_descriptors.get_name_leafdata())
                    if (self.bandwidth_pool.is_set or self.bandwidth_pool.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool.get_name_leafdata())
                    if (self.flooding_down_thresholds_are_default.is_set or self.flooding_down_thresholds_are_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_down_thresholds_are_default.get_name_leafdata())
                    if (self.flooding_down_thresholds_are_global.is_set or self.flooding_down_thresholds_are_global.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_down_thresholds_are_global.get_name_leafdata())
                    if (self.flooding_up_thresholds_are_default.is_set or self.flooding_up_thresholds_are_default.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_up_thresholds_are_default.get_name_leafdata())
                    if (self.flooding_up_thresholds_are_global.is_set or self.flooding_up_thresholds_are_global.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.flooding_up_thresholds_are_global.get_name_leafdata())
                    if (self.total_bandwidth_descriptors.is_set or self.total_bandwidth_descriptors.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_bandwidth_descriptors.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "downstream-bandwidth"):
                        if (self.downstream_bandwidth is None):
                            self.downstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                            self.downstream_bandwidth.parent = self
                            self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"
                        return self.downstream_bandwidth

                    if (child_yang_name == "flooding-down-threshold"):
                        for c in self.flooding_down_threshold:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.flooding_down_threshold.append(c)
                        return c

                    if (child_yang_name == "flooding-up-threshold"):
                        for c in self.flooding_up_threshold:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.flooding_up_threshold.append(c)
                        return c

                    if (child_yang_name == "link-common"):
                        if (self.link_common is None):
                            self.link_common = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                            self.link_common.parent = self
                            self._children_name_map["link_common"] = "link-common"
                        return self.link_common

                    if (child_yang_name == "upstream-bandwidth"):
                        if (self.upstream_bandwidth is None):
                            self.upstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                            self.upstream_bandwidth.parent = self
                            self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"
                        return self.upstream_bandwidth

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "downstream-bandwidth" or name == "flooding-down-threshold" or name == "flooding-up-threshold" or name == "link-common" or name == "upstream-bandwidth" or name == "interface-name" or name == "bandwidth-descriptors" or name == "bandwidth-pool" or name == "flooding-down-thresholds-are-default" or name == "flooding-down-thresholds-are-global" or name == "flooding-up-thresholds-are-default" or name == "flooding-up-thresholds-are-global" or name == "total-bandwidth-descriptors"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-descriptors"):
                        self.bandwidth_descriptors = value
                        self.bandwidth_descriptors.value_namespace = name_space
                        self.bandwidth_descriptors.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool"):
                        self.bandwidth_pool = value
                        self.bandwidth_pool.value_namespace = name_space
                        self.bandwidth_pool.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-down-thresholds-are-default"):
                        self.flooding_down_thresholds_are_default = value
                        self.flooding_down_thresholds_are_default.value_namespace = name_space
                        self.flooding_down_thresholds_are_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-down-thresholds-are-global"):
                        self.flooding_down_thresholds_are_global = value
                        self.flooding_down_thresholds_are_global.value_namespace = name_space
                        self.flooding_down_thresholds_are_global.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-up-thresholds-are-default"):
                        self.flooding_up_thresholds_are_default = value
                        self.flooding_up_thresholds_are_default.value_namespace = name_space
                        self.flooding_up_thresholds_are_default.value_namespace_prefix = name_space_prefix
                    if(value_path == "flooding-up-thresholds-are-global"):
                        self.flooding_up_thresholds_are_global = value
                        self.flooding_up_thresholds_are_global.value_namespace = name_space
                        self.flooding_up_thresholds_are_global.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-bandwidth-descriptors"):
                        self.total_bandwidth_descriptors = value
                        self.total_bandwidth_descriptors.value_namespace = name_space
                        self.total_bandwidth_descriptors.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.bandwidth_allocation_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.bandwidth_allocation_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-allocation-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bandwidth-allocation-link"):
                    for c in self.bandwidth_allocation_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.bandwidth_allocation_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-allocation-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.bandwidth_allocation_links is not None and self.bandwidth_allocation_links.has_data()) or
                (self.global_ is not None and self.global_.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.bandwidth_allocation_links is not None and self.bandwidth_allocation_links.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bandwidth-allocation" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bandwidth-allocation-links"):
                if (self.bandwidth_allocation_links is None):
                    self.bandwidth_allocation_links = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks()
                    self.bandwidth_allocation_links.parent = self
                    self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
                return self.bandwidth_allocation_links

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcac.BandwidthAllocation.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bandwidth-allocation-links" or name == "global"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Gmpls(Entity):
        """
        GMPLS data
        
        .. attribute:: nni
        
        	GMPLS NNI data
        	**type**\:   :py:class:`Nni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni>`
        
        .. attribute:: uni
        
        	GMPLS UNI data
        	**type**\:   :py:class:`Uni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.Gmpls, self).__init__()

            self.yang_name = "gmpls"
            self.yang_parent_name = "mpls-lcac"

            self.nni = MplsLcac.Gmpls.Nni()
            self.nni.parent = self
            self._children_name_map["nni"] = "nni"
            self._children_yang_names.add("nni")

            self.uni = MplsLcac.Gmpls.Uni()
            self.uni.parent = self
            self._children_name_map["uni"] = "uni"
            self._children_yang_names.add("uni")


        class Nni(Entity):
            """
            GMPLS NNI data
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Gmpls.Nni, self).__init__()

                self.yang_name = "nni"
                self.yang_parent_name = "gmpls"

            def has_data(self):
                return False

            def has_operation(self):
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nni" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Uni(Entity):
            """
            GMPLS UNI data
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.Gmpls.Uni, self).__init__()

                self.yang_name = "uni"
                self.yang_parent_name = "gmpls"

            def has_data(self):
                return False

            def has_operation(self):
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "uni" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.nni is not None and self.nni.has_data()) or
                (self.uni is not None and self.uni.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.nni is not None and self.nni.has_operation()) or
                (self.uni is not None and self.uni.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "gmpls" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "nni"):
                if (self.nni is None):
                    self.nni = MplsLcac.Gmpls.Nni()
                    self.nni.parent = self
                    self._children_name_map["nni"] = "nni"
                return self.nni

            if (child_yang_name == "uni"):
                if (self.uni is None):
                    self.uni = MplsLcac.Gmpls.Uni()
                    self.uni.parent = self
                    self._children_name_map["uni"] = "uni"
                return self.uni

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "nni" or name == "uni"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BfdNeighbors(Entity):
        """
        BFD Neighbors
        
        .. attribute:: bfd_neighbor
        
        	A BFD Neighbor
        	**type**\: list of    :py:class:`BfdNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors.BfdNeighbor>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.BfdNeighbors, self).__init__()

            self.yang_name = "bfd-neighbors"
            self.yang_parent_name = "mpls-lcac"

            self.bfd_neighbor = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.BfdNeighbors, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.BfdNeighbors, self).__setattr__(name, value)


        class BfdNeighbor(Entity):
            """
            A BFD Neighbor
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.BfdNeighbors.BfdNeighbor, self).__init__()

                self.yang_name = "bfd-neighbor"
                self.yang_parent_name = "bfd-neighbors"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.neighbor = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.BfdNeighbors.BfdNeighbor, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.BfdNeighbors.BfdNeighbor, self).__setattr__(name, value)


            class Neighbor(Entity):
                """
                Neighbors of the specified link id
                
                .. attribute:: is_bfd_up
                
                	TRUE if the BFD session is Up on this link
                	**type**\:  bool
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "bfd-neighbor"

                    self.is_bfd_up = YLeaf(YType.boolean, "is-bfd-up")

                    self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_bfd_up",
                                    "neighbor_address") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.is_bfd_up.is_set or
                        self.neighbor_address.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_bfd_up.yfilter != YFilter.not_set or
                        self.neighbor_address.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "neighbor" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_bfd_up.is_set or self.is_bfd_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bfd_up.get_name_leafdata())
                    if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.neighbor_address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "is-bfd-up" or name == "neighbor-address"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-bfd-up"):
                        self.is_bfd_up = value
                        self.is_bfd_up.value_namespace = name_space
                        self.is_bfd_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "neighbor-address"):
                        self.neighbor_address = value
                        self.neighbor_address.value_namespace = name_space
                        self.neighbor_address.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.neighbor:
                    if (c.has_data()):
                        return True
                return self.interface_name.is_set

            def has_operation(self):
                for c in self.neighbor:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bfd-neighbor" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bfd-neighbors/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "neighbor"):
                    for c in self.neighbor:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.neighbor.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "neighbor" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.bfd_neighbor:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.bfd_neighbor:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bfd-neighbors" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bfd-neighbor"):
                for c in self.bfd_neighbor:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.BfdNeighbors.BfdNeighbor()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.bfd_neighbor.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bfd-neighbor"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class BandwidthAccount(Entity):
        """
        The bandwidth accounting information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_account_links
        
        	The interface bandwidth accounting information table
        	**type**\:   :py:class:`BandwidthAccountLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.BandwidthAccount, self).__init__()

            self.yang_name = "bandwidth-account"
            self.yang_parent_name = "mpls-lcac"

            self.bandwidth_account_links = MplsLcac.BandwidthAccount.BandwidthAccountLinks()
            self.bandwidth_account_links.parent = self
            self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
            self._children_yang_names.add("bandwidth-account-links")


        class BandwidthAccountLinks(Entity):
            """
            The interface bandwidth accounting information
            table
            
            .. attribute:: bandwidth_account_link
            
            	An interface in bandwidth accounting table
            	**type**\: list of    :py:class:`BandwidthAccountLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks, self).__init__()

                self.yang_name = "bandwidth-account-links"
                self.yang_parent_name = "bandwidth-account"

                self.bandwidth_account_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks, self).__setattr__(name, value)


            class BandwidthAccountLink(Entity):
                """
                An interface in bandwidth accounting table
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: common_info
                
                	Information for bandwidth accounting telemetry
                	**type**\:   :py:class:`CommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo>`
                
                .. attribute:: link_id
                
                	The link's ID
                	**type**\:  str
                
                .. attribute:: rsvp_te_sample_history
                
                	History of bandwidth accounting RSVP\-TE samples
                	**type**\:   :py:class:`RsvpTeSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory>`
                
                .. attribute:: sr_sample_history
                
                	History of bandwidth accounting Segment Routing samples
                	**type**\:   :py:class:`SrSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__init__()

                    self.yang_name = "bandwidth-account-link"
                    self.yang_parent_name = "bandwidth-account-links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.link_id = YLeaf(YType.str, "link-id")

                    self.common_info = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                    self.common_info.parent = self
                    self._children_name_map["common_info"] = "common-info"
                    self._children_yang_names.add("common-info")

                    self.rsvp_te_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                    self.rsvp_te_sample_history.parent = self
                    self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"
                    self._children_yang_names.add("rsvp-te-sample-history")

                    self.sr_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                    self.sr_sample_history.parent = self
                    self._children_name_map["sr_sample_history"] = "sr-sample-history"
                    self._children_yang_names.add("sr-sample-history")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "link_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__setattr__(name, value)


                class CommonInfo(Entity):
                    """
                    Information for bandwidth accounting telemetry
                    
                    .. attribute:: application_enforced
                    
                    	TRUE if application is enforced
                    	**type**\:  bool
                    
                    .. attribute:: application_time_remaining_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next application
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: collection_type
                    
                    	The type of traffic collected for bandwidth accounting
                    	**type**\:   :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                    
                    .. attribute:: effective_maximum_reservable_bandwidth
                    
                    	Maximum reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_bandwidth_account_enabled
                    
                    	TRUE if bandwidth accounting is enabled
                    	**type**\:  bool
                    
                    .. attribute:: last_application_timestamp_nanosec
                    
                    	Timestamp for the last application in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_sample_collection_timestamp_nanosec
                    
                    	Timestamp for the last sample collection in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_application_timestamp_nanosec
                    
                    	Timestamp for the next application in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_sample_collection_nanosec
                    
                    	Timestamp for the next sample collection in nano\-seconds
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: rsvp_te_bandwidth_utilization
                    
                    	RSVP\-TE bandwidth utilization information
                    	**type**\:   :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization>`
                    
                    .. attribute:: sample_time_remaining_timestamp_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next sampling
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: sr_bandwidth_utilization
                    
                    	Segment Routing bandwidth utilization information
                    	**type**\:   :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__init__()

                        self.yang_name = "common-info"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.application_enforced = YLeaf(YType.boolean, "application-enforced")

                        self.application_time_remaining_nanosec = YLeaf(YType.uint64, "application-time-remaining-nanosec")

                        self.collection_type = YLeaf(YType.enumeration, "collection-type")

                        self.effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "effective-maximum-reservable-bandwidth")

                        self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                        self.last_application_timestamp_nanosec = YLeaf(YType.uint64, "last-application-timestamp-nanosec")

                        self.last_sample_collection_timestamp_nanosec = YLeaf(YType.uint64, "last-sample-collection-timestamp-nanosec")

                        self.next_application_timestamp_nanosec = YLeaf(YType.uint64, "next-application-timestamp-nanosec")

                        self.next_sample_collection_nanosec = YLeaf(YType.uint64, "next-sample-collection-nanosec")

                        self.sample_time_remaining_timestamp_nanosec = YLeaf(YType.uint64, "sample-time-remaining-timestamp-nanosec")

                        self.rsvp_te_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                        self.rsvp_te_bandwidth_utilization.parent = self
                        self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                        self._children_yang_names.add("rsvp-te-bandwidth-utilization")

                        self.sr_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                        self.sr_bandwidth_utilization.parent = self
                        self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                        self._children_yang_names.add("sr-bandwidth-utilization")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("application_enforced",
                                        "application_time_remaining_nanosec",
                                        "collection_type",
                                        "effective_maximum_reservable_bandwidth",
                                        "is_bandwidth_account_enabled",
                                        "last_application_timestamp_nanosec",
                                        "last_sample_collection_timestamp_nanosec",
                                        "next_application_timestamp_nanosec",
                                        "next_sample_collection_nanosec",
                                        "sample_time_remaining_timestamp_nanosec") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__setattr__(name, value)


                    class RsvpTeBandwidthUtilization(Entity):
                        """
                        RSVP\-TE bandwidth utilization information
                        
                        .. attribute:: non_rsvp_te_bandwidth_utilization
                        
                        	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                        
                        	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_enforced_bandwidth_utilization
                        
                        	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_link_bandwidth_utilization
                        
                        	Total bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-utilization"
                            self.yang_parent_name = "common-info"

                            self.non_rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "non-rsvp-te-bandwidth-utilization")

                            self.rsvp_te_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-adjusted-bandwidth-utilization")

                            self.rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-bandwidth-utilization")

                            self.rsvp_te_enforced_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-enforced-bandwidth-utilization")

                            self.total_link_bandwidth_utilization = YLeaf(YType.uint64, "total-link-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_bandwidth_utilization",
                                            "rsvp_te_adjusted_bandwidth_utilization",
                                            "rsvp_te_bandwidth_utilization",
                                            "rsvp_te_enforced_bandwidth_utilization",
                                            "total_link_bandwidth_utilization") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_bandwidth_utilization.is_set or
                                self.rsvp_te_adjusted_bandwidth_utilization.is_set or
                                self.rsvp_te_bandwidth_utilization.is_set or
                                self.rsvp_te_enforced_bandwidth_utilization.is_set or
                                self.total_link_bandwidth_utilization.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.total_link_bandwidth_utilization.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-bandwidth-utilization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_bandwidth_utilization.is_set or self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_adjusted_bandwidth_utilization.is_set or self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_adjusted_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_bandwidth_utilization.is_set or self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_bandwidth_utilization.get_name_leafdata())
                            if (self.rsvp_te_enforced_bandwidth_utilization.is_set or self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_enforced_bandwidth_utilization.get_name_leafdata())
                            if (self.total_link_bandwidth_utilization.is_set or self.total_link_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_link_bandwidth_utilization.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-bandwidth-utilization" or name == "rsvp-te-adjusted-bandwidth-utilization" or name == "rsvp-te-bandwidth-utilization" or name == "rsvp-te-enforced-bandwidth-utilization" or name == "total-link-bandwidth-utilization"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-bandwidth-utilization"):
                                self.non_rsvp_te_bandwidth_utilization = value
                                self.non_rsvp_te_bandwidth_utilization.value_namespace = name_space
                                self.non_rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-adjusted-bandwidth-utilization"):
                                self.rsvp_te_adjusted_bandwidth_utilization = value
                                self.rsvp_te_adjusted_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-bandwidth-utilization"):
                                self.rsvp_te_bandwidth_utilization = value
                                self.rsvp_te_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-enforced-bandwidth-utilization"):
                                self.rsvp_te_enforced_bandwidth_utilization = value
                                self.rsvp_te_enforced_bandwidth_utilization.value_namespace = name_space
                                self.rsvp_te_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-link-bandwidth-utilization"):
                                self.total_link_bandwidth_utilization = value
                                self.total_link_bandwidth_utilization.value_namespace = name_space
                                self.total_link_bandwidth_utilization.value_namespace_prefix = name_space_prefix


                    class SrBandwidthUtilization(Entity):
                        """
                        Segment Routing bandwidth utilization
                        information
                        
                        .. attribute:: sr_adjusted_bandwidth_utilization
                        
                        	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_enforced_bandwidth_utilization
                        
                        	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__init__()

                            self.yang_name = "sr-bandwidth-utilization"
                            self.yang_parent_name = "common-info"

                            self.sr_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "sr-adjusted-bandwidth-utilization")

                            self.sr_bandwidth_utilization = YLeaf(YType.uint64, "sr-bandwidth-utilization")

                            self.sr_enforced_bandwidth_utilization = YLeaf(YType.uint64, "sr-enforced-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_adjusted_bandwidth_utilization",
                                            "sr_bandwidth_utilization",
                                            "sr_enforced_bandwidth_utilization") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_adjusted_bandwidth_utilization.is_set or
                                self.sr_bandwidth_utilization.is_set or
                                self.sr_enforced_bandwidth_utilization.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.sr_bandwidth_utilization.yfilter != YFilter.not_set or
                                self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-bandwidth-utilization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_adjusted_bandwidth_utilization.is_set or self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_adjusted_bandwidth_utilization.get_name_leafdata())
                            if (self.sr_bandwidth_utilization.is_set or self.sr_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_bandwidth_utilization.get_name_leafdata())
                            if (self.sr_enforced_bandwidth_utilization.is_set or self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_enforced_bandwidth_utilization.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-adjusted-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "sr-enforced-bandwidth-utilization"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-adjusted-bandwidth-utilization"):
                                self.sr_adjusted_bandwidth_utilization = value
                                self.sr_adjusted_bandwidth_utilization.value_namespace = name_space
                                self.sr_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-bandwidth-utilization"):
                                self.sr_bandwidth_utilization = value
                                self.sr_bandwidth_utilization.value_namespace = name_space
                                self.sr_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-enforced-bandwidth-utilization"):
                                self.sr_enforced_bandwidth_utilization = value
                                self.sr_enforced_bandwidth_utilization.value_namespace = name_space
                                self.sr_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.application_enforced.is_set or
                            self.application_time_remaining_nanosec.is_set or
                            self.collection_type.is_set or
                            self.effective_maximum_reservable_bandwidth.is_set or
                            self.is_bandwidth_account_enabled.is_set or
                            self.last_application_timestamp_nanosec.is_set or
                            self.last_sample_collection_timestamp_nanosec.is_set or
                            self.next_application_timestamp_nanosec.is_set or
                            self.next_sample_collection_nanosec.is_set or
                            self.sample_time_remaining_timestamp_nanosec.is_set or
                            (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_data()) or
                            (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.application_enforced.yfilter != YFilter.not_set or
                            self.application_time_remaining_nanosec.yfilter != YFilter.not_set or
                            self.collection_type.yfilter != YFilter.not_set or
                            self.effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                            self.last_application_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.last_sample_collection_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.next_application_timestamp_nanosec.yfilter != YFilter.not_set or
                            self.next_sample_collection_nanosec.yfilter != YFilter.not_set or
                            self.sample_time_remaining_timestamp_nanosec.yfilter != YFilter.not_set or
                            (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_operation()) or
                            (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "common-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.application_enforced.is_set or self.application_enforced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_enforced.get_name_leafdata())
                        if (self.application_time_remaining_nanosec.is_set or self.application_time_remaining_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.application_time_remaining_nanosec.get_name_leafdata())
                        if (self.collection_type.is_set or self.collection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.collection_type.get_name_leafdata())
                        if (self.effective_maximum_reservable_bandwidth.is_set or self.effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                        if (self.last_application_timestamp_nanosec.is_set or self.last_application_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_application_timestamp_nanosec.get_name_leafdata())
                        if (self.last_sample_collection_timestamp_nanosec.is_set or self.last_sample_collection_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_sample_collection_timestamp_nanosec.get_name_leafdata())
                        if (self.next_application_timestamp_nanosec.is_set or self.next_application_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_application_timestamp_nanosec.get_name_leafdata())
                        if (self.next_sample_collection_nanosec.is_set or self.next_sample_collection_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_sample_collection_nanosec.get_name_leafdata())
                        if (self.sample_time_remaining_timestamp_nanosec.is_set or self.sample_time_remaining_timestamp_nanosec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sample_time_remaining_timestamp_nanosec.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rsvp-te-bandwidth-utilization"):
                            if (self.rsvp_te_bandwidth_utilization is None):
                                self.rsvp_te_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                                self.rsvp_te_bandwidth_utilization.parent = self
                                self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                            return self.rsvp_te_bandwidth_utilization

                        if (child_yang_name == "sr-bandwidth-utilization"):
                            if (self.sr_bandwidth_utilization is None):
                                self.sr_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                                self.sr_bandwidth_utilization.parent = self
                                self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            return self.sr_bandwidth_utilization

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rsvp-te-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "application-enforced" or name == "application-time-remaining-nanosec" or name == "collection-type" or name == "effective-maximum-reservable-bandwidth" or name == "is-bandwidth-account-enabled" or name == "last-application-timestamp-nanosec" or name == "last-sample-collection-timestamp-nanosec" or name == "next-application-timestamp-nanosec" or name == "next-sample-collection-nanosec" or name == "sample-time-remaining-timestamp-nanosec"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "application-enforced"):
                            self.application_enforced = value
                            self.application_enforced.value_namespace = name_space
                            self.application_enforced.value_namespace_prefix = name_space_prefix
                        if(value_path == "application-time-remaining-nanosec"):
                            self.application_time_remaining_nanosec = value
                            self.application_time_remaining_nanosec.value_namespace = name_space
                            self.application_time_remaining_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "collection-type"):
                            self.collection_type = value
                            self.collection_type.value_namespace = name_space
                            self.collection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "effective-maximum-reservable-bandwidth"):
                            self.effective_maximum_reservable_bandwidth = value
                            self.effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-account-enabled"):
                            self.is_bandwidth_account_enabled = value
                            self.is_bandwidth_account_enabled.value_namespace = name_space
                            self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-application-timestamp-nanosec"):
                            self.last_application_timestamp_nanosec = value
                            self.last_application_timestamp_nanosec.value_namespace = name_space
                            self.last_application_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-sample-collection-timestamp-nanosec"):
                            self.last_sample_collection_timestamp_nanosec = value
                            self.last_sample_collection_timestamp_nanosec.value_namespace = name_space
                            self.last_sample_collection_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-application-timestamp-nanosec"):
                            self.next_application_timestamp_nanosec = value
                            self.next_application_timestamp_nanosec.value_namespace = name_space
                            self.next_application_timestamp_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-sample-collection-nanosec"):
                            self.next_sample_collection_nanosec = value
                            self.next_sample_collection_nanosec.value_namespace = name_space
                            self.next_sample_collection_nanosec.value_namespace_prefix = name_space_prefix
                        if(value_path == "sample-time-remaining-timestamp-nanosec"):
                            self.sample_time_remaining_timestamp_nanosec = value
                            self.sample_time_remaining_timestamp_nanosec.value_namespace = name_space
                            self.sample_time_remaining_timestamp_nanosec.value_namespace_prefix = name_space_prefix


                class RsvpTeSampleHistory(Entity):
                    """
                    History of bandwidth accounting RSVP\-TE samples
                    
                    .. attribute:: rsvp_te_active_interval_sample
                    
                    	RSVP\-TE samples in the current application interval
                    	**type**\: list of    :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample>`
                    
                    .. attribute:: rsvp_te_previous_interval_sample
                    
                    	RSVP\-TE samples in the previous application interval
                    	**type**\: list of    :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__init__()

                        self.yang_name = "rsvp-te-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.rsvp_te_active_interval_sample = YList(self)
                        self.rsvp_te_previous_interval_sample = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__setattr__(name, value)


                    class RsvpTeActiveIntervalSample(Entity):
                        """
                        RSVP\-TE samples in the current application
                        interval
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-active-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"

                            self.non_rsvp_te_packet_rate = YLeaf(YType.uint64, "non-rsvp-te-packet-rate")

                            self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                            self.rsvp_te_packet_rate = YLeaf(YType.uint64, "rsvp-te-packet-rate")

                            self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                            self.total_packet_rate = YLeaf(YType.uint64, "total-packet-rate")

                            self.total_rate = YLeaf(YType.uint64, "total-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_packet_rate",
                                            "non_rsvp_te_rate",
                                            "rsvp_te_packet_rate",
                                            "rsvp_te_rate",
                                            "timestamp_nanosec",
                                            "total_packet_rate",
                                            "total_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_packet_rate.is_set or
                                self.non_rsvp_te_rate.is_set or
                                self.rsvp_te_packet_rate.is_set or
                                self.rsvp_te_rate.is_set or
                                self.timestamp_nanosec.is_set or
                                self.total_packet_rate.is_set or
                                self.total_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set or
                                self.total_packet_rate.yfilter != YFilter.not_set or
                                self.total_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-active-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_packet_rate.is_set or self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_packet_rate.get_name_leafdata())
                            if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                            if (self.rsvp_te_packet_rate.is_set or self.rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_packet_rate.get_name_leafdata())
                            if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())
                            if (self.total_packet_rate.is_set or self.total_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_packet_rate.get_name_leafdata())
                            if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-packet-rate" or name == "non-rsvp-te-rate" or name == "rsvp-te-packet-rate" or name == "rsvp-te-rate" or name == "timestamp-nanosec" or name == "total-packet-rate" or name == "total-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-packet-rate"):
                                self.non_rsvp_te_packet_rate = value
                                self.non_rsvp_te_packet_rate.value_namespace = name_space
                                self.non_rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "non-rsvp-te-rate"):
                                self.non_rsvp_te_rate = value
                                self.non_rsvp_te_rate.value_namespace = name_space
                                self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-packet-rate"):
                                self.rsvp_te_packet_rate = value
                                self.rsvp_te_packet_rate.value_namespace = name_space
                                self.rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-rate"):
                                self.rsvp_te_rate = value
                                self.rsvp_te_rate.value_namespace = name_space
                                self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-packet-rate"):
                                self.total_packet_rate = value
                                self.total_packet_rate.value_namespace = name_space
                                self.total_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-rate"):
                                self.total_rate = value
                                self.total_rate.value_namespace = name_space
                                self.total_rate.value_namespace_prefix = name_space_prefix


                    class RsvpTePreviousIntervalSample(Entity):
                        """
                        RSVP\-TE samples in the previous application
                        interval
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-previous-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"

                            self.non_rsvp_te_packet_rate = YLeaf(YType.uint64, "non-rsvp-te-packet-rate")

                            self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                            self.rsvp_te_packet_rate = YLeaf(YType.uint64, "rsvp-te-packet-rate")

                            self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                            self.total_packet_rate = YLeaf(YType.uint64, "total-packet-rate")

                            self.total_rate = YLeaf(YType.uint64, "total-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("non_rsvp_te_packet_rate",
                                            "non_rsvp_te_rate",
                                            "rsvp_te_packet_rate",
                                            "rsvp_te_rate",
                                            "timestamp_nanosec",
                                            "total_packet_rate",
                                            "total_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.non_rsvp_te_packet_rate.is_set or
                                self.non_rsvp_te_rate.is_set or
                                self.rsvp_te_packet_rate.is_set or
                                self.rsvp_te_rate.is_set or
                                self.timestamp_nanosec.is_set or
                                self.total_packet_rate.is_set or
                                self.total_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_packet_rate.yfilter != YFilter.not_set or
                                self.rsvp_te_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set or
                                self.total_packet_rate.yfilter != YFilter.not_set or
                                self.total_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-previous-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.non_rsvp_te_packet_rate.is_set or self.non_rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_packet_rate.get_name_leafdata())
                            if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                            if (self.rsvp_te_packet_rate.is_set or self.rsvp_te_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_packet_rate.get_name_leafdata())
                            if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())
                            if (self.total_packet_rate.is_set or self.total_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_packet_rate.get_name_leafdata())
                            if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "non-rsvp-te-packet-rate" or name == "non-rsvp-te-rate" or name == "rsvp-te-packet-rate" or name == "rsvp-te-rate" or name == "timestamp-nanosec" or name == "total-packet-rate" or name == "total-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "non-rsvp-te-packet-rate"):
                                self.non_rsvp_te_packet_rate = value
                                self.non_rsvp_te_packet_rate.value_namespace = name_space
                                self.non_rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "non-rsvp-te-rate"):
                                self.non_rsvp_te_rate = value
                                self.non_rsvp_te_rate.value_namespace = name_space
                                self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-packet-rate"):
                                self.rsvp_te_packet_rate = value
                                self.rsvp_te_packet_rate.value_namespace = name_space
                                self.rsvp_te_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "rsvp-te-rate"):
                                self.rsvp_te_rate = value
                                self.rsvp_te_rate.value_namespace = name_space
                                self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-packet-rate"):
                                self.total_packet_rate = value
                                self.total_packet_rate.value_namespace = name_space
                                self.total_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-rate"):
                                self.total_rate = value
                                self.total_rate.value_namespace = name_space
                                self.total_rate.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.rsvp_te_active_interval_sample:
                            if (c.has_data()):
                                return True
                        for c in self.rsvp_te_previous_interval_sample:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.rsvp_te_active_interval_sample:
                            if (c.has_operation()):
                                return True
                        for c in self.rsvp_te_previous_interval_sample:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rsvp-te-sample-history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "rsvp-te-active-interval-sample"):
                            for c in self.rsvp_te_active_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.rsvp_te_active_interval_sample.append(c)
                            return c

                        if (child_yang_name == "rsvp-te-previous-interval-sample"):
                            for c in self.rsvp_te_previous_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.rsvp_te_previous_interval_sample.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "rsvp-te-active-interval-sample" or name == "rsvp-te-previous-interval-sample"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class SrSampleHistory(Entity):
                    """
                    History of bandwidth accounting Segment Routing
                    samples
                    
                    .. attribute:: sr_active_interval_sample
                    
                    	Segment Routing samples in the current application interval
                    	**type**\: list of    :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample>`
                    
                    .. attribute:: sr_previous_interval_sample
                    
                    	Segment Routing samples in the previous application interval
                    	**type**\: list of    :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__init__()

                        self.yang_name = "sr-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"

                        self.sr_active_interval_sample = YList(self)
                        self.sr_previous_interval_sample = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__setattr__(name, value)


                    class SrActiveIntervalSample(Entity):
                        """
                        Segment Routing samples in the current
                        application interval
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__init__()

                            self.yang_name = "sr-active-interval-sample"
                            self.yang_parent_name = "sr-sample-history"

                            self.sr_packet_rate = YLeaf(YType.uint64, "sr-packet-rate")

                            self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_packet_rate",
                                            "sr_rate",
                                            "timestamp_nanosec") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_packet_rate.is_set or
                                self.sr_rate.is_set or
                                self.timestamp_nanosec.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_packet_rate.yfilter != YFilter.not_set or
                                self.sr_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-active-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_packet_rate.is_set or self.sr_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_packet_rate.get_name_leafdata())
                            if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-packet-rate" or name == "sr-rate" or name == "timestamp-nanosec"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-packet-rate"):
                                self.sr_packet_rate = value
                                self.sr_packet_rate.value_namespace = name_space
                                self.sr_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-rate"):
                                self.sr_rate = value
                                self.sr_rate.value_namespace = name_space
                                self.sr_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix


                    class SrPreviousIntervalSample(Entity):
                        """
                        Segment Routing samples in the previous
                        application interval
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: packet/s
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__init__()

                            self.yang_name = "sr-previous-interval-sample"
                            self.yang_parent_name = "sr-sample-history"

                            self.sr_packet_rate = YLeaf(YType.uint64, "sr-packet-rate")

                            self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                            self.timestamp_nanosec = YLeaf(YType.uint64, "timestamp-nanosec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("sr_packet_rate",
                                            "sr_rate",
                                            "timestamp_nanosec") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.sr_packet_rate.is_set or
                                self.sr_rate.is_set or
                                self.timestamp_nanosec.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.sr_packet_rate.yfilter != YFilter.not_set or
                                self.sr_rate.yfilter != YFilter.not_set or
                                self.timestamp_nanosec.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-previous-interval-sample" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.sr_packet_rate.is_set or self.sr_packet_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_packet_rate.get_name_leafdata())
                            if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sr_rate.get_name_leafdata())
                            if (self.timestamp_nanosec.is_set or self.timestamp_nanosec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp_nanosec.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-packet-rate" or name == "sr-rate" or name == "timestamp-nanosec"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "sr-packet-rate"):
                                self.sr_packet_rate = value
                                self.sr_packet_rate.value_namespace = name_space
                                self.sr_packet_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "sr-rate"):
                                self.sr_rate = value
                                self.sr_rate.value_namespace = name_space
                                self.sr_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp-nanosec"):
                                self.timestamp_nanosec = value
                                self.timestamp_nanosec.value_namespace = name_space
                                self.timestamp_nanosec.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.sr_active_interval_sample:
                            if (c.has_data()):
                                return True
                        for c in self.sr_previous_interval_sample:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.sr_active_interval_sample:
                            if (c.has_operation()):
                                return True
                        for c in self.sr_previous_interval_sample:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-sample-history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "sr-active-interval-sample"):
                            for c in self.sr_active_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.sr_active_interval_sample.append(c)
                            return c

                        if (child_yang_name == "sr-previous-interval-sample"):
                            for c in self.sr_previous_interval_sample:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.sr_previous_interval_sample.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "sr-active-interval-sample" or name == "sr-previous-interval-sample"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.link_id.is_set or
                        (self.common_info is not None and self.common_info.has_data()) or
                        (self.rsvp_te_sample_history is not None and self.rsvp_te_sample_history.has_data()) or
                        (self.sr_sample_history is not None and self.sr_sample_history.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        (self.common_info is not None and self.common_info.has_operation()) or
                        (self.rsvp_te_sample_history is not None and self.rsvp_te_sample_history.has_operation()) or
                        (self.sr_sample_history is not None and self.sr_sample_history.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bandwidth-account-link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-account/bandwidth-account-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "common-info"):
                        if (self.common_info is None):
                            self.common_info = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                            self.common_info.parent = self
                            self._children_name_map["common_info"] = "common-info"
                        return self.common_info

                    if (child_yang_name == "rsvp-te-sample-history"):
                        if (self.rsvp_te_sample_history is None):
                            self.rsvp_te_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                            self.rsvp_te_sample_history.parent = self
                            self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"
                        return self.rsvp_te_sample_history

                    if (child_yang_name == "sr-sample-history"):
                        if (self.sr_sample_history is None):
                            self.sr_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                            self.sr_sample_history.parent = self
                            self._children_name_map["sr_sample_history"] = "sr-sample-history"
                        return self.sr_sample_history

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "common-info" or name == "rsvp-te-sample-history" or name == "sr-sample-history" or name == "interface-name" or name == "link-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.bandwidth_account_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.bandwidth_account_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-account-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-account/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bandwidth-account-link"):
                    for c in self.bandwidth_account_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.bandwidth_account_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-account-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.bandwidth_account_links is not None and self.bandwidth_account_links.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.bandwidth_account_links is not None and self.bandwidth_account_links.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bandwidth-account" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "bandwidth-account-links"):
                if (self.bandwidth_account_links is None):
                    self.bandwidth_account_links = MplsLcac.BandwidthAccount.BandwidthAccountLinks()
                    self.bandwidth_account_links.parent = self
                    self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
                return self.bandwidth_account_links

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "bandwidth-account-links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LinkSummary(Entity):
        """
        The global summary for all the interfaces
        
        .. attribute:: areas_summary
        
        	Summary info for the areas
        	**type**\: list of    :py:class:`AreasSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary.AreasSummary>`
        
        .. attribute:: bandwidth_account_summary
        
        	Bandwidth account summary
        	**type**\:   :py:class:`BandwidthAccountSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary.BandwidthAccountSummary>`
        
        .. attribute:: is_flooding_enabled
        
        	TRUE if flooding is enabled
        	**type**\:  bool
        
        .. attribute:: is_role_standby
        
        	TRUE if Role is Standby, Active otherwise
        	**type**\:  bool
        
        .. attribute:: links
        
        	Total number of links
        	**type**\:  int
        
        	**range:** 0..65535
        
        .. attribute:: maximum_links
        
        	Maximum number of links supported
        	**type**\:  int
        
        	**range:** 0..65535
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.LinkSummary, self).__init__()

            self.yang_name = "link-summary"
            self.yang_parent_name = "mpls-lcac"

            self.is_flooding_enabled = YLeaf(YType.boolean, "is-flooding-enabled")

            self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

            self.links = YLeaf(YType.uint16, "links")

            self.maximum_links = YLeaf(YType.uint16, "maximum-links")

            self.bandwidth_account_summary = MplsLcac.LinkSummary.BandwidthAccountSummary()
            self.bandwidth_account_summary.parent = self
            self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"
            self._children_yang_names.add("bandwidth-account-summary")

            self.areas_summary = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("is_flooding_enabled",
                            "is_role_standby",
                            "links",
                            "maximum_links") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.LinkSummary, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.LinkSummary, self).__setattr__(name, value)


        class BandwidthAccountSummary(Entity):
            """
            Bandwidth account summary
            
            .. attribute:: application_interval
            
            	Application interval for bandwidth accounting stats
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: application_time_remaining
            
            	This value indicates the number of seconds until the next application
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: is_bandwidth_account_enabled
            
            	TRUE if bandwidth accounting is enabled
            	**type**\:  bool
            
            .. attribute:: sample_interval
            
            	Sample interval for bandwidth accounting stats
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: sample_time_remaining
            
            	This value indicates the number of seconds until the next sample collection
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.LinkSummary.BandwidthAccountSummary, self).__init__()

                self.yang_name = "bandwidth-account-summary"
                self.yang_parent_name = "link-summary"

                self.application_interval = YLeaf(YType.uint32, "application-interval")

                self.application_time_remaining = YLeaf(YType.uint32, "application-time-remaining")

                self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                self.sample_interval = YLeaf(YType.uint32, "sample-interval")

                self.sample_time_remaining = YLeaf(YType.uint32, "sample-time-remaining")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("application_interval",
                                "application_time_remaining",
                                "is_bandwidth_account_enabled",
                                "sample_interval",
                                "sample_time_remaining") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.LinkSummary.BandwidthAccountSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.LinkSummary.BandwidthAccountSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.application_interval.is_set or
                    self.application_time_remaining.is_set or
                    self.is_bandwidth_account_enabled.is_set or
                    self.sample_interval.is_set or
                    self.sample_time_remaining.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.application_interval.yfilter != YFilter.not_set or
                    self.application_time_remaining.yfilter != YFilter.not_set or
                    self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                    self.sample_interval.yfilter != YFilter.not_set or
                    self.sample_time_remaining.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "bandwidth-account-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.application_interval.is_set or self.application_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_interval.get_name_leafdata())
                if (self.application_time_remaining.is_set or self.application_time_remaining.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.application_time_remaining.get_name_leafdata())
                if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                if (self.sample_interval.is_set or self.sample_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sample_interval.get_name_leafdata())
                if (self.sample_time_remaining.is_set or self.sample_time_remaining.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sample_time_remaining.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "application-interval" or name == "application-time-remaining" or name == "is-bandwidth-account-enabled" or name == "sample-interval" or name == "sample-time-remaining"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "application-interval"):
                    self.application_interval = value
                    self.application_interval.value_namespace = name_space
                    self.application_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "application-time-remaining"):
                    self.application_time_remaining = value
                    self.application_time_remaining.value_namespace = name_space
                    self.application_time_remaining.value_namespace_prefix = name_space_prefix
                if(value_path == "is-bandwidth-account-enabled"):
                    self.is_bandwidth_account_enabled = value
                    self.is_bandwidth_account_enabled.value_namespace = name_space
                    self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "sample-interval"):
                    self.sample_interval = value
                    self.sample_interval.value_namespace = name_space
                    self.sample_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "sample-time-remaining"):
                    self.sample_time_remaining = value
                    self.sample_time_remaining.value_namespace = name_space
                    self.sample_time_remaining.value_namespace_prefix = name_space_prefix


        class AreasSummary(Entity):
            """
            Summary info for the areas
            
            .. attribute:: area_id
            
            	Area id
            	**type**\:  str
            
            .. attribute:: igp_neighbors
            
            	Number of IGP neighbors
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: is_flooded
            
            	TRUE if flooding occurred in this area
            	**type**\:  bool
            
            .. attribute:: is_periodic_flooding_on
            
            	TRUE if periodic flooding is on
            	**type**\:  bool
            
            .. attribute:: links_flooded
            
            	Number of flooded links
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: local_node_router_id
            
            	Local router id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: periodic_flooding_interval
            
            	Flooding period in seconds
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: protocol
            
            	Protocol running over the area
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: system_id
            
            	IGP id of local node
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.LinkSummary.AreasSummary, self).__init__()

                self.yang_name = "areas-summary"
                self.yang_parent_name = "link-summary"

                self.area_id = YLeaf(YType.str, "area-id")

                self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                self.is_flooded = YLeaf(YType.boolean, "is-flooded")

                self.is_periodic_flooding_on = YLeaf(YType.boolean, "is-periodic-flooding-on")

                self.links_flooded = YLeaf(YType.uint16, "links-flooded")

                self.local_node_router_id = YLeaf(YType.str, "local-node-router-id")

                self.periodic_flooding_interval = YLeaf(YType.uint16, "periodic-flooding-interval")

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.system_id = YLeaf(YType.str, "system-id")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("area_id",
                                "igp_neighbors",
                                "is_flooded",
                                "is_periodic_flooding_on",
                                "links_flooded",
                                "local_node_router_id",
                                "periodic_flooding_interval",
                                "protocol",
                                "system_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.LinkSummary.AreasSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.LinkSummary.AreasSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.area_id.is_set or
                    self.igp_neighbors.is_set or
                    self.is_flooded.is_set or
                    self.is_periodic_flooding_on.is_set or
                    self.links_flooded.is_set or
                    self.local_node_router_id.is_set or
                    self.periodic_flooding_interval.is_set or
                    self.protocol.is_set or
                    self.system_id.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.area_id.yfilter != YFilter.not_set or
                    self.igp_neighbors.yfilter != YFilter.not_set or
                    self.is_flooded.yfilter != YFilter.not_set or
                    self.is_periodic_flooding_on.yfilter != YFilter.not_set or
                    self.links_flooded.yfilter != YFilter.not_set or
                    self.local_node_router_id.yfilter != YFilter.not_set or
                    self.periodic_flooding_interval.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.system_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "areas-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-summary/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area_id.get_name_leafdata())
                if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                if (self.is_flooded.is_set or self.is_flooded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_flooded.get_name_leafdata())
                if (self.is_periodic_flooding_on.is_set or self.is_periodic_flooding_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_periodic_flooding_on.get_name_leafdata())
                if (self.links_flooded.is_set or self.links_flooded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links_flooded.get_name_leafdata())
                if (self.local_node_router_id.is_set or self.local_node_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_node_router_id.get_name_leafdata())
                if (self.periodic_flooding_interval.is_set or self.periodic_flooding_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.periodic_flooding_interval.get_name_leafdata())
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.system_id.is_set or self.system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.system_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area-id" or name == "igp-neighbors" or name == "is-flooded" or name == "is-periodic-flooding-on" or name == "links-flooded" or name == "local-node-router-id" or name == "periodic-flooding-interval" or name == "protocol" or name == "system-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "area-id"):
                    self.area_id = value
                    self.area_id.value_namespace = name_space
                    self.area_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-neighbors"):
                    self.igp_neighbors = value
                    self.igp_neighbors.value_namespace = name_space
                    self.igp_neighbors.value_namespace_prefix = name_space_prefix
                if(value_path == "is-flooded"):
                    self.is_flooded = value
                    self.is_flooded.value_namespace = name_space
                    self.is_flooded.value_namespace_prefix = name_space_prefix
                if(value_path == "is-periodic-flooding-on"):
                    self.is_periodic_flooding_on = value
                    self.is_periodic_flooding_on.value_namespace = name_space
                    self.is_periodic_flooding_on.value_namespace_prefix = name_space_prefix
                if(value_path == "links-flooded"):
                    self.links_flooded = value
                    self.links_flooded.value_namespace = name_space
                    self.links_flooded.value_namespace_prefix = name_space_prefix
                if(value_path == "local-node-router-id"):
                    self.local_node_router_id = value
                    self.local_node_router_id.value_namespace = name_space
                    self.local_node_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "periodic-flooding-interval"):
                    self.periodic_flooding_interval = value
                    self.periodic_flooding_interval.value_namespace = name_space
                    self.periodic_flooding_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "system-id"):
                    self.system_id = value
                    self.system_id.value_namespace = name_space
                    self.system_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.areas_summary:
                if (c.has_data()):
                    return True
            return (
                self.is_flooding_enabled.is_set or
                self.is_role_standby.is_set or
                self.links.is_set or
                self.maximum_links.is_set or
                (self.bandwidth_account_summary is not None and self.bandwidth_account_summary.has_data()))

        def has_operation(self):
            for c in self.areas_summary:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.is_flooding_enabled.yfilter != YFilter.not_set or
                self.is_role_standby.yfilter != YFilter.not_set or
                self.links.yfilter != YFilter.not_set or
                self.maximum_links.yfilter != YFilter.not_set or
                (self.bandwidth_account_summary is not None and self.bandwidth_account_summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "link-summary" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.is_flooding_enabled.is_set or self.is_flooding_enabled.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_flooding_enabled.get_name_leafdata())
            if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_role_standby.get_name_leafdata())
            if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                leaf_name_data.append(self.links.get_name_leafdata())
            if (self.maximum_links.is_set or self.maximum_links.yfilter != YFilter.not_set):
                leaf_name_data.append(self.maximum_links.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "areas-summary"):
                for c in self.areas_summary:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.LinkSummary.AreasSummary()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.areas_summary.append(c)
                return c

            if (child_yang_name == "bandwidth-account-summary"):
                if (self.bandwidth_account_summary is None):
                    self.bandwidth_account_summary = MplsLcac.LinkSummary.BandwidthAccountSummary()
                    self.bandwidth_account_summary.parent = self
                    self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"
                return self.bandwidth_account_summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "areas-summary" or name == "bandwidth-account-summary" or name == "is-flooding-enabled" or name == "is-role-standby" or name == "links" or name == "maximum-links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "is-flooding-enabled"):
                self.is_flooding_enabled = value
                self.is_flooding_enabled.value_namespace = name_space
                self.is_flooding_enabled.value_namespace_prefix = name_space_prefix
            if(value_path == "is-role-standby"):
                self.is_role_standby = value
                self.is_role_standby.value_namespace = name_space
                self.is_role_standby.value_namespace_prefix = name_space_prefix
            if(value_path == "links"):
                self.links = value
                self.links.value_namespace = name_space
                self.links.value_namespace_prefix = name_space_prefix
            if(value_path == "maximum-links"):
                self.maximum_links = value
                self.maximum_links.value_namespace = name_space
                self.maximum_links.value_namespace_prefix = name_space_prefix


    class LinkInformation(Entity):
        """
        The interface information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global information for all the interfaces
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Global_>`
        
        .. attribute:: links
        
        	The table of interfaces in MPLS\-LCAC
        	**type**\:   :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.LinkInformation, self).__init__()

            self.yang_name = "link-information"
            self.yang_parent_name = "mpls-lcac"

            self.global_ = MplsLcac.LinkInformation.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.links = MplsLcac.LinkInformation.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._children_yang_names.add("links")


        class Global_(Entity):
            """
            The global information for all the interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: links
            
            	The number of links
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.LinkInformation.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "link-information"

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.links = YLeaf(YType.uint16, "links")

                self.maximum_links = YLeaf(YType.uint16, "maximum-links")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_role_standby",
                                "links",
                                "maximum_links") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.LinkInformation.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.LinkInformation.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.is_role_standby.is_set or
                    self.links.is_set or
                    self.maximum_links.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.links.yfilter != YFilter.not_set or
                    self.maximum_links.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links.get_name_leafdata())
                if (self.maximum_links.is_set or self.maximum_links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.maximum_links.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "is-role-standby" or name == "links" or name == "maximum-links"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "links"):
                    self.links = value
                    self.links.value_namespace = name_space
                    self.links.value_namespace_prefix = name_space_prefix
                if(value_path == "maximum-links"):
                    self.maximum_links = value
                    self.maximum_links.value_namespace = name_space
                    self.maximum_links.value_namespace_prefix = name_space_prefix


        class Links(Entity):
            """
            The table of interfaces in MPLS\-LCAC
            
            .. attribute:: link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.LinkInformation.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "link-information"

                self.link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.LinkInformation.Links, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.LinkInformation.Links, self).__setattr__(name, value)


            class Link(Entity):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: affinity_map
                
                	Affinity map array
                	**type**\: list of    :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.AffinityMap>`
                
                .. attribute:: areas
                
                	Per\-area data
                	**type**\: list of    :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.Areas>`
                
                .. attribute:: bandwidth_account
                
                	Bandwidth Account info
                	**type**\:   :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount>`
                
                .. attribute:: hw_oor
                
                	The link's NPU OOR info. This field is NULL for platforms that do not support HW\-OOR notifications
                	**type**\:   :py:class:`HwOor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.HwOor>`
                
                .. attribute:: is_attribute_incomplete
                
                	TRUE if one or more affinity definition(s) is/are unknown
                	**type**\:  bool
                
                .. attribute:: is_name_based_attribute
                
                	TRUE, if name based attribute style is in effect
                	**type**\:  bool
                
                .. attribute:: is_te_metric_valid
                
                	Flag to indicate whether the link's TE metric is a valid value
                	**type**\:  bool
                
                .. attribute:: link_attributes
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:   :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon>`
                
                .. attribute:: link_extended_attribute
                
                	The link's extended attribute bit map
                	**type**\: list of    :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute>`
                
                .. attribute:: link_forwad_ref_value
                
                	Reference bits for undefined affinity names
                	**type**\: list of    :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue>`
                
                .. attribute:: lockout
                
                	Flex LSP Lockout info
                	**type**\: list of    :py:class:`Lockout <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.Lockout>`
                
                .. attribute:: maximum_reservation_bandwidth_mam
                
                	The link's maximum reservable BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: maximum_reservation_bandwidth_rdm
                
                	The link's maximum reservable BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reason_not_flooded
                
                	Reason why link is not flooded (area\-independent)
                	**type**\:  str
                
                .. attribute:: reservable_pool0_bandwidth_mam
                
                	The link's reservable pool0 BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool0_bandwidth_rdm
                
                	The link's reservable pool0 BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool1_bandwidth_mam
                
                	The link's reservable pool1 BW in MAM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reservable_pool1_bandwidth_rdm
                
                	The link's reservable pool1 BW in RDM
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.LinkInformation.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.is_attribute_incomplete = YLeaf(YType.boolean, "is-attribute-incomplete")

                    self.is_name_based_attribute = YLeaf(YType.boolean, "is-name-based-attribute")

                    self.is_te_metric_valid = YLeaf(YType.boolean, "is-te-metric-valid")

                    self.link_attributes = YLeaf(YType.uint32, "link-attributes")

                    self.maximum_reservation_bandwidth_mam = YLeaf(YType.uint64, "maximum-reservation-bandwidth-mam")

                    self.maximum_reservation_bandwidth_rdm = YLeaf(YType.uint64, "maximum-reservation-bandwidth-rdm")

                    self.reason_not_flooded = YLeaf(YType.str, "reason-not-flooded")

                    self.reservable_pool0_bandwidth_mam = YLeaf(YType.uint64, "reservable-pool0-bandwidth-mam")

                    self.reservable_pool0_bandwidth_rdm = YLeaf(YType.uint64, "reservable-pool0-bandwidth-rdm")

                    self.reservable_pool1_bandwidth_mam = YLeaf(YType.uint64, "reservable-pool1-bandwidth-mam")

                    self.reservable_pool1_bandwidth_rdm = YLeaf(YType.uint64, "reservable-pool1-bandwidth-rdm")

                    self.te_metric = YLeaf(YType.uint32, "te-metric")

                    self.bandwidth_account = MplsLcac.LinkInformation.Links.Link.BandwidthAccount()
                    self.bandwidth_account.parent = self
                    self._children_name_map["bandwidth_account"] = "bandwidth-account"
                    self._children_yang_names.add("bandwidth-account")

                    self.hw_oor = MplsLcac.LinkInformation.Links.Link.HwOor()
                    self.hw_oor.parent = self
                    self._children_name_map["hw_oor"] = "hw-oor"
                    self._children_yang_names.add("hw-oor")

                    self.link_common = MplsLcac.LinkInformation.Links.Link.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"
                    self._children_yang_names.add("link-common")

                    self.affinity_map = YList(self)
                    self.areas = YList(self)
                    self.link_extended_attribute = YList(self)
                    self.link_forwad_ref_value = YList(self)
                    self.lockout = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "is_attribute_incomplete",
                                    "is_name_based_attribute",
                                    "is_te_metric_valid",
                                    "link_attributes",
                                    "maximum_reservation_bandwidth_mam",
                                    "maximum_reservation_bandwidth_rdm",
                                    "reason_not_flooded",
                                    "reservable_pool0_bandwidth_mam",
                                    "reservable_pool0_bandwidth_rdm",
                                    "reservable_pool1_bandwidth_mam",
                                    "reservable_pool1_bandwidth_rdm",
                                    "te_metric") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.LinkInformation.Links.Link, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.LinkInformation.Links.Link, self).__setattr__(name, value)


                class LinkCommon(Entity):
                    """
                    The link's common info
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of    :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas>`
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\:  bool
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of    :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\:  bool
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\:  bool
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:   :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags>`
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\:  str
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:   :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:   :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup>`
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "link"

                        self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                        self.bcm_id = YLeaf(YType.uint16, "bcm-id")

                        self.capability = YLeaf(YType.uint32, "capability")

                        self.has_protection = YLeaf(YType.boolean, "has-protection")

                        self.igp_neighbors = YLeaf(YType.uint16, "igp-neighbors")

                        self.inbound_admission_method = YLeaf(YType.enumeration, "inbound-admission-method")

                        self.incoming_reservable_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-bandwidth-percentage")

                        self.incoming_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool0-bandwidth-percentage")

                        self.incoming_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "incoming-reservable-pool1-bandwidth-percentage")

                        self.is_resource_provider_installed = YLeaf(YType.boolean, "is-resource-provider-installed")

                        self.is_unnumbered = YLeaf(YType.boolean, "is-unnumbered")

                        self.last_flooded_effective_maximum_reservable_bandwidth = YLeaf(YType.uint64, "last-flooded-effective-maximum-reservable-bandwidth")

                        self.link_address = YLeaf(YType.str, "link-address")

                        self.link_id = YLeaf(YType.str, "link-id")

                        self.maximum_reservable_bandwidth = YLeaf(YType.uint64, "maximum-reservable-bandwidth")

                        self.maximum_reservable_pool0_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool0-bandwidth")

                        self.maximum_reservable_pool1_bandwidth = YLeaf(YType.uint64, "maximum-reservable-pool1-bandwidth")

                        self.outbound_admission_method = YLeaf(YType.enumeration, "outbound-admission-method")

                        self.outgoing_reservable_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-bandwidth-percentage")

                        self.outgoing_reservable_pool0_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool0-bandwidth-percentage")

                        self.outgoing_reservable_pool1_bandwidth_percentage = YLeaf(YType.uint8, "outgoing-reservable-pool1-bandwidth-percentage")

                        self.physical_bandwidth = YLeaf(YType.uint64, "physical-bandwidth")

                        self.resource_provider = YLeaf(YType.enumeration, "resource-provider")

                        self.working_priority = YLeaf(YType.uint32, "working-priority")

                        self.link_flags = MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"
                        self._children_yang_names.add("link-flags")

                        self.flooded_areas = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_units",
                                        "bcm_id",
                                        "capability",
                                        "has_protection",
                                        "igp_neighbors",
                                        "inbound_admission_method",
                                        "incoming_reservable_bandwidth_percentage",
                                        "incoming_reservable_pool0_bandwidth_percentage",
                                        "incoming_reservable_pool1_bandwidth_percentage",
                                        "is_resource_provider_installed",
                                        "is_unnumbered",
                                        "last_flooded_effective_maximum_reservable_bandwidth",
                                        "link_address",
                                        "link_id",
                                        "maximum_reservable_bandwidth",
                                        "maximum_reservable_pool0_bandwidth",
                                        "maximum_reservable_pool1_bandwidth",
                                        "outbound_admission_method",
                                        "outgoing_reservable_bandwidth_percentage",
                                        "outgoing_reservable_pool0_bandwidth_percentage",
                                        "outgoing_reservable_pool1_bandwidth_percentage",
                                        "physical_bandwidth",
                                        "resource_provider",
                                        "working_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.LinkCommon, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.LinkCommon, self).__setattr__(name, value)


                    class LinkFlags(Entity):
                        """
                        The link's flags
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\:  bool
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\:  bool
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:   :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"

                            self.is_admin_up = YLeaf(YType.boolean, "is-admin-up")

                            self.is_mpls_te_on = YLeaf(YType.boolean, "is-mpls-te-on")

                            self.signaling_agent = YLeaf(YType.enumeration, "signaling-agent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_admin_up",
                                            "is_mpls_te_on",
                                            "signaling_agent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_admin_up.is_set or
                                self.is_mpls_te_on.is_set or
                                self.signaling_agent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_admin_up.yfilter != YFilter.not_set or
                                self.is_mpls_te_on.yfilter != YFilter.not_set or
                                self.signaling_agent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "link-flags" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_admin_up.is_set or self.is_admin_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_admin_up.get_name_leafdata())
                            if (self.is_mpls_te_on.is_set or self.is_mpls_te_on.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mpls_te_on.get_name_leafdata())
                            if (self.signaling_agent.is_set or self.signaling_agent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaling_agent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-admin-up" or name == "is-mpls-te-on" or name == "signaling-agent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-admin-up"):
                                self.is_admin_up = value
                                self.is_admin_up.value_namespace = name_space
                                self.is_admin_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-mpls-te-on"):
                                self.is_mpls_te_on = value
                                self.is_mpls_te_on.value_namespace = name_space
                                self.is_mpls_te_on.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaling-agent"):
                                self.signaling_agent = value
                                self.signaling_agent.value_namespace = name_space
                                self.signaling_agent.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class InterfaceSwitchingCapabilityDescriptor(Entity):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"

                            self.encoding = YLeaf(YType.uint8, "encoding")

                            self.key = YLeaf(YType.uint8, "key")

                            self.switching_capability = YLeaf(YType.uint8, "switching-capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("encoding",
                                            "key",
                                            "switching_capability") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.encoding.is_set or
                                self.key.is_set or
                                self.switching_capability.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.encoding.yfilter != YFilter.not_set or
                                self.key.yfilter != YFilter.not_set or
                                self.switching_capability.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface-switching-capability-descriptor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.encoding.is_set or self.encoding.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.encoding.get_name_leafdata())
                            if (self.key.is_set or self.key.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.key.get_name_leafdata())
                            if (self.switching_capability.is_set or self.switching_capability.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switching_capability.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "encoding" or name == "key" or name == "switching-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "encoding"):
                                self.encoding = value
                                self.encoding.value_namespace = name_space
                                self.encoding.value_namespace_prefix = name_space_prefix
                            if(value_path == "key"):
                                self.key = value
                                self.key.value_namespace = name_space
                                self.key.value_namespace_prefix = name_space_prefix
                            if(value_path == "switching-capability"):
                                self.switching_capability = value
                                self.switching_capability.value_namespace = name_space
                                self.switching_capability.value_namespace_prefix = name_space_prefix


                    class FloodedAreas(Entity):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"

                            self.flooded_area = YLeaf(YType.str, "flooded-area")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("flooded_area") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__setattr__(name, value)

                        def has_data(self):
                            return self.flooded_area.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.flooded_area.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flooded-areas" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.flooded_area.is_set or self.flooded_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.flooded_area.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flooded-area"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "flooded-area"):
                                self.flooded_area = value
                                self.flooded_area.value_namespace = name_space
                                self.flooded_area.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.flooded_areas:
                            if (c.has_data()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_units.is_set or
                            self.bcm_id.is_set or
                            self.capability.is_set or
                            self.has_protection.is_set or
                            self.igp_neighbors.is_set or
                            self.inbound_admission_method.is_set or
                            self.incoming_reservable_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.is_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.is_set or
                            self.is_resource_provider_installed.is_set or
                            self.is_unnumbered.is_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.is_set or
                            self.link_address.is_set or
                            self.link_id.is_set or
                            self.maximum_reservable_bandwidth.is_set or
                            self.maximum_reservable_pool0_bandwidth.is_set or
                            self.maximum_reservable_pool1_bandwidth.is_set or
                            self.outbound_admission_method.is_set or
                            self.outgoing_reservable_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.is_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.is_set or
                            self.physical_bandwidth.is_set or
                            self.resource_provider.is_set or
                            self.working_priority.is_set or
                            (self.link_flags is not None and self.link_flags.has_data()))

                    def has_operation(self):
                        for c in self.flooded_areas:
                            if (c.has_operation()):
                                return True
                        for c in self.interface_switching_capability_descriptor:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_units.yfilter != YFilter.not_set or
                            self.bcm_id.yfilter != YFilter.not_set or
                            self.capability.yfilter != YFilter.not_set or
                            self.has_protection.yfilter != YFilter.not_set or
                            self.igp_neighbors.yfilter != YFilter.not_set or
                            self.inbound_admission_method.yfilter != YFilter.not_set or
                            self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.is_resource_provider_installed.yfilter != YFilter.not_set or
                            self.is_unnumbered.yfilter != YFilter.not_set or
                            self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.link_address.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.maximum_reservable_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set or
                            self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set or
                            self.outbound_admission_method.yfilter != YFilter.not_set or
                            self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set or
                            self.physical_bandwidth.yfilter != YFilter.not_set or
                            self.resource_provider.yfilter != YFilter.not_set or
                            self.working_priority.yfilter != YFilter.not_set or
                            (self.link_flags is not None and self.link_flags.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                        if (self.bcm_id.is_set or self.bcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bcm_id.get_name_leafdata())
                        if (self.capability.is_set or self.capability.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.capability.get_name_leafdata())
                        if (self.has_protection.is_set or self.has_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_protection.get_name_leafdata())
                        if (self.igp_neighbors.is_set or self.igp_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_neighbors.get_name_leafdata())
                        if (self.inbound_admission_method.is_set or self.inbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.inbound_admission_method.get_name_leafdata())
                        if (self.incoming_reservable_bandwidth_percentage.is_set or self.incoming_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool0_bandwidth_percentage.is_set or self.incoming_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.incoming_reservable_pool1_bandwidth_percentage.is_set or self.incoming_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.is_resource_provider_installed.is_set or self.is_resource_provider_installed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_resource_provider_installed.get_name_leafdata())
                        if (self.is_unnumbered.is_set or self.is_unnumbered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unnumbered.get_name_leafdata())
                        if (self.last_flooded_effective_maximum_reservable_bandwidth.is_set or self.last_flooded_effective_maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_flooded_effective_maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_address.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.maximum_reservable_bandwidth.is_set or self.maximum_reservable_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool0_bandwidth.is_set or self.maximum_reservable_pool0_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool0_bandwidth.get_name_leafdata())
                        if (self.maximum_reservable_pool1_bandwidth.is_set or self.maximum_reservable_pool1_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_reservable_pool1_bandwidth.get_name_leafdata())
                        if (self.outbound_admission_method.is_set or self.outbound_admission_method.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_admission_method.get_name_leafdata())
                        if (self.outgoing_reservable_bandwidth_percentage.is_set or self.outgoing_reservable_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool0_bandwidth_percentage.is_set or self.outgoing_reservable_pool0_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool0_bandwidth_percentage.get_name_leafdata())
                        if (self.outgoing_reservable_pool1_bandwidth_percentage.is_set or self.outgoing_reservable_pool1_bandwidth_percentage.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_reservable_pool1_bandwidth_percentage.get_name_leafdata())
                        if (self.physical_bandwidth.is_set or self.physical_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.physical_bandwidth.get_name_leafdata())
                        if (self.resource_provider.is_set or self.resource_provider.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.resource_provider.get_name_leafdata())
                        if (self.working_priority.is_set or self.working_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.working_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "flooded-areas"):
                            for c in self.flooded_areas:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.flooded_areas.append(c)
                            return c

                        if (child_yang_name == "interface-switching-capability-descriptor"):
                            for c in self.interface_switching_capability_descriptor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface_switching_capability_descriptor.append(c)
                            return c

                        if (child_yang_name == "link-flags"):
                            if (self.link_flags is None):
                                self.link_flags = MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                                self.link_flags.parent = self
                                self._children_name_map["link_flags"] = "link-flags"
                            return self.link_flags

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "flooded-areas" or name == "interface-switching-capability-descriptor" or name == "link-flags" or name == "shared-risk-link-group" or name == "bandwidth-units" or name == "bcm-id" or name == "capability" or name == "has-protection" or name == "igp-neighbors" or name == "inbound-admission-method" or name == "incoming-reservable-bandwidth-percentage" or name == "incoming-reservable-pool0-bandwidth-percentage" or name == "incoming-reservable-pool1-bandwidth-percentage" or name == "is-resource-provider-installed" or name == "is-unnumbered" or name == "last-flooded-effective-maximum-reservable-bandwidth" or name == "link-address" or name == "link-id" or name == "maximum-reservable-bandwidth" or name == "maximum-reservable-pool0-bandwidth" or name == "maximum-reservable-pool1-bandwidth" or name == "outbound-admission-method" or name == "outgoing-reservable-bandwidth-percentage" or name == "outgoing-reservable-pool0-bandwidth-percentage" or name == "outgoing-reservable-pool1-bandwidth-percentage" or name == "physical-bandwidth" or name == "resource-provider" or name == "working-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-units"):
                            self.bandwidth_units = value
                            self.bandwidth_units.value_namespace = name_space
                            self.bandwidth_units.value_namespace_prefix = name_space_prefix
                        if(value_path == "bcm-id"):
                            self.bcm_id = value
                            self.bcm_id.value_namespace = name_space
                            self.bcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "capability"):
                            self.capability = value
                            self.capability.value_namespace = name_space
                            self.capability.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-protection"):
                            self.has_protection = value
                            self.has_protection.value_namespace = name_space
                            self.has_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-neighbors"):
                            self.igp_neighbors = value
                            self.igp_neighbors.value_namespace = name_space
                            self.igp_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "inbound-admission-method"):
                            self.inbound_admission_method = value
                            self.inbound_admission_method.value_namespace = name_space
                            self.inbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-bandwidth-percentage"):
                            self.incoming_reservable_bandwidth_percentage = value
                            self.incoming_reservable_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool0-bandwidth-percentage"):
                            self.incoming_reservable_pool0_bandwidth_percentage = value
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-reservable-pool1-bandwidth-percentage"):
                            self.incoming_reservable_pool1_bandwidth_percentage = value
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.incoming_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-resource-provider-installed"):
                            self.is_resource_provider_installed = value
                            self.is_resource_provider_installed.value_namespace = name_space
                            self.is_resource_provider_installed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unnumbered"):
                            self.is_unnumbered = value
                            self.is_unnumbered.value_namespace = name_space
                            self.is_unnumbered.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-flooded-effective-maximum-reservable-bandwidth"):
                            self.last_flooded_effective_maximum_reservable_bandwidth = value
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace = name_space
                            self.last_flooded_effective_maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-address"):
                            self.link_address = value
                            self.link_address.value_namespace = name_space
                            self.link_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-bandwidth"):
                            self.maximum_reservable_bandwidth = value
                            self.maximum_reservable_bandwidth.value_namespace = name_space
                            self.maximum_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool0-bandwidth"):
                            self.maximum_reservable_pool0_bandwidth = value
                            self.maximum_reservable_pool0_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool0_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-reservable-pool1-bandwidth"):
                            self.maximum_reservable_pool1_bandwidth = value
                            self.maximum_reservable_pool1_bandwidth.value_namespace = name_space
                            self.maximum_reservable_pool1_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-admission-method"):
                            self.outbound_admission_method = value
                            self.outbound_admission_method.value_namespace = name_space
                            self.outbound_admission_method.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-bandwidth-percentage"):
                            self.outgoing_reservable_bandwidth_percentage = value
                            self.outgoing_reservable_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool0-bandwidth-percentage"):
                            self.outgoing_reservable_pool0_bandwidth_percentage = value
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool0_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-reservable-pool1-bandwidth-percentage"):
                            self.outgoing_reservable_pool1_bandwidth_percentage = value
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace = name_space
                            self.outgoing_reservable_pool1_bandwidth_percentage.value_namespace_prefix = name_space_prefix
                        if(value_path == "physical-bandwidth"):
                            self.physical_bandwidth = value
                            self.physical_bandwidth.value_namespace = name_space
                            self.physical_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "resource-provider"):
                            self.resource_provider = value
                            self.resource_provider.value_namespace = name_space
                            self.resource_provider.value_namespace_prefix = name_space_prefix
                        if(value_path == "working-priority"):
                            self.working_priority = value
                            self.working_priority.value_namespace = name_space
                            self.working_priority.value_namespace_prefix = name_space_prefix


                class BandwidthAccount(Entity):
                    """
                    Bandwidth Account info
                    
                    .. attribute:: bandwidth_account_common_info
                    
                    	Common info for bandwidth accounting
                    	**type**\:   :py:class:`BandwidthAccountCommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo>`
                    
                    .. attribute:: rsvp_te_bandwidth_sample_history
                    
                    	RSVP\-TE Bandwidth samples history
                    	**type**\:   :py:class:`RsvpTeBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory>`
                    
                    .. attribute:: sr_bandwidth_sample_history
                    
                    	Segment Routing Bandwidth samples history
                    	**type**\:   :py:class:`SrBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount, self).__init__()

                        self.yang_name = "bandwidth-account"
                        self.yang_parent_name = "link"

                        self.bandwidth_account_common_info = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                        self.bandwidth_account_common_info.parent = self
                        self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"
                        self._children_yang_names.add("bandwidth-account-common-info")

                        self.rsvp_te_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                        self.rsvp_te_bandwidth_sample_history.parent = self
                        self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"
                        self._children_yang_names.add("rsvp-te-bandwidth-sample-history")

                        self.sr_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                        self.sr_bandwidth_sample_history.parent = self
                        self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                        self._children_yang_names.add("sr-bandwidth-sample-history")


                    class BandwidthAccountCommonInfo(Entity):
                        """
                        Common info for bandwidth accounting
                        
                        .. attribute:: adjustment_factor
                        
                        	This value indicates the adjustment factor applied to measured non RSVP\-TE bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_enforced
                        
                        	TRUE if bandwidth accounting application is enforced
                        	**type**\:  bool
                        
                        .. attribute:: application_interval
                        
                        	Application interval in seconds for bandwidth accounting stats
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: application_time_remaining
                        
                        	This value indicates the number of seconds until the next application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: collection_type
                        
                        	The type of traffic collected for bandwidth accounting
                        	**type**\:   :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                        
                        .. attribute:: down_threshold_max_reservable_bandwidth
                        
                        	The down threshold for flooding the maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: is_bandwidth_account_enabled
                        
                        	TRUE if bandwidth accounting is enabled
                        	**type**\:  bool
                        
                        .. attribute:: last_application_timestamp
                        
                        	Timestamp for the last application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_sample_collection_timestamp
                        
                        	Timestamp for the last sample collection
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_reservable_bandwidth_threshold_are_default
                        
                        	TRUE if the maximum reservable bandwidth flooding thresholds are default
                        	**type**\:  bool
                        
                        .. attribute:: next_application
                        
                        	Timestamp for the next application
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: next_sample_collection
                        
                        	Timestamp for the next sample collection
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE Bandwidth utilization information
                        	**type**\:   :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization>`
                        
                        .. attribute:: sample_interval
                        
                        	Sampling interval in seconds for bandwidth accounting stats
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: sample_time_remaining
                        
                        	This value indicates the number of seconds until the next sampling
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing Bandwidth utilization information
                        	**type**\:   :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization>`
                        
                        .. attribute:: up_threshold_max_reservable_bandwidth
                        
                        	The up threshold for flooding the maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__init__()

                            self.yang_name = "bandwidth-account-common-info"
                            self.yang_parent_name = "bandwidth-account"

                            self.adjustment_factor = YLeaf(YType.uint32, "adjustment-factor")

                            self.application_enforced = YLeaf(YType.boolean, "application-enforced")

                            self.application_interval = YLeaf(YType.uint32, "application-interval")

                            self.application_time_remaining = YLeaf(YType.uint32, "application-time-remaining")

                            self.collection_type = YLeaf(YType.enumeration, "collection-type")

                            self.down_threshold_max_reservable_bandwidth = YLeaf(YType.uint8, "down-threshold-max-reservable-bandwidth")

                            self.is_bandwidth_account_enabled = YLeaf(YType.boolean, "is-bandwidth-account-enabled")

                            self.last_application_timestamp = YLeaf(YType.uint32, "last-application-timestamp")

                            self.last_sample_collection_timestamp = YLeaf(YType.uint32, "last-sample-collection-timestamp")

                            self.max_reservable_bandwidth_threshold_are_default = YLeaf(YType.boolean, "max-reservable-bandwidth-threshold-are-default")

                            self.next_application = YLeaf(YType.uint32, "next-application")

                            self.next_sample_collection = YLeaf(YType.uint32, "next-sample-collection")

                            self.sample_interval = YLeaf(YType.uint32, "sample-interval")

                            self.sample_time_remaining = YLeaf(YType.uint32, "sample-time-remaining")

                            self.up_threshold_max_reservable_bandwidth = YLeaf(YType.uint8, "up-threshold-max-reservable-bandwidth")

                            self.rsvp_te_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                            self.rsvp_te_bandwidth_utilization.parent = self
                            self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                            self._children_yang_names.add("rsvp-te-bandwidth-utilization")

                            self.sr_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                            self.sr_bandwidth_utilization.parent = self
                            self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            self._children_yang_names.add("sr-bandwidth-utilization")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_factor",
                                            "application_enforced",
                                            "application_interval",
                                            "application_time_remaining",
                                            "collection_type",
                                            "down_threshold_max_reservable_bandwidth",
                                            "is_bandwidth_account_enabled",
                                            "last_application_timestamp",
                                            "last_sample_collection_timestamp",
                                            "max_reservable_bandwidth_threshold_are_default",
                                            "next_application",
                                            "next_sample_collection",
                                            "sample_interval",
                                            "sample_time_remaining",
                                            "up_threshold_max_reservable_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__setattr__(name, value)


                        class RsvpTeBandwidthUtilization(Entity):
                            """
                            RSVP\-TE Bandwidth utilization information
                            
                            .. attribute:: non_rsvp_te_bandwidth_utilization
                            
                            	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                            
                            	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_bandwidth_utilization
                            
                            	RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_enforced_bandwidth_utilization
                            
                            	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: total_link_bandwidth_utilization
                            
                            	Total bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                                self.yang_name = "rsvp-te-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"

                                self.non_rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "non-rsvp-te-bandwidth-utilization")

                                self.rsvp_te_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-adjusted-bandwidth-utilization")

                                self.rsvp_te_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-bandwidth-utilization")

                                self.rsvp_te_enforced_bandwidth_utilization = YLeaf(YType.uint64, "rsvp-te-enforced-bandwidth-utilization")

                                self.total_link_bandwidth_utilization = YLeaf(YType.uint64, "total-link-bandwidth-utilization")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_bandwidth_utilization",
                                                "rsvp_te_adjusted_bandwidth_utilization",
                                                "rsvp_te_bandwidth_utilization",
                                                "rsvp_te_enforced_bandwidth_utilization",
                                                "total_link_bandwidth_utilization") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_bandwidth_utilization.is_set or
                                    self.rsvp_te_adjusted_bandwidth_utilization.is_set or
                                    self.rsvp_te_bandwidth_utilization.is_set or
                                    self.rsvp_te_enforced_bandwidth_utilization.is_set or
                                    self.total_link_bandwidth_utilization.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.total_link_bandwidth_utilization.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-bandwidth-utilization" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_bandwidth_utilization.is_set or self.non_rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_adjusted_bandwidth_utilization.is_set or self.rsvp_te_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_adjusted_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_bandwidth_utilization.is_set or self.rsvp_te_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_bandwidth_utilization.get_name_leafdata())
                                if (self.rsvp_te_enforced_bandwidth_utilization.is_set or self.rsvp_te_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_enforced_bandwidth_utilization.get_name_leafdata())
                                if (self.total_link_bandwidth_utilization.is_set or self.total_link_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_link_bandwidth_utilization.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-bandwidth-utilization" or name == "rsvp-te-adjusted-bandwidth-utilization" or name == "rsvp-te-bandwidth-utilization" or name == "rsvp-te-enforced-bandwidth-utilization" or name == "total-link-bandwidth-utilization"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-bandwidth-utilization"):
                                    self.non_rsvp_te_bandwidth_utilization = value
                                    self.non_rsvp_te_bandwidth_utilization.value_namespace = name_space
                                    self.non_rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-adjusted-bandwidth-utilization"):
                                    self.rsvp_te_adjusted_bandwidth_utilization = value
                                    self.rsvp_te_adjusted_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-bandwidth-utilization"):
                                    self.rsvp_te_bandwidth_utilization = value
                                    self.rsvp_te_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-enforced-bandwidth-utilization"):
                                    self.rsvp_te_enforced_bandwidth_utilization = value
                                    self.rsvp_te_enforced_bandwidth_utilization.value_namespace = name_space
                                    self.rsvp_te_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-link-bandwidth-utilization"):
                                    self.total_link_bandwidth_utilization = value
                                    self.total_link_bandwidth_utilization.value_namespace = name_space
                                    self.total_link_bandwidth_utilization.value_namespace_prefix = name_space_prefix


                        class SrBandwidthUtilization(Entity):
                            """
                            Segment Routing Bandwidth utilization
                            information
                            
                            .. attribute:: sr_adjusted_bandwidth_utilization
                            
                            	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_bandwidth_utilization
                            
                            	Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_enforced_bandwidth_utilization
                            
                            	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__init__()

                                self.yang_name = "sr-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"

                                self.sr_adjusted_bandwidth_utilization = YLeaf(YType.uint64, "sr-adjusted-bandwidth-utilization")

                                self.sr_bandwidth_utilization = YLeaf(YType.uint64, "sr-bandwidth-utilization")

                                self.sr_enforced_bandwidth_utilization = YLeaf(YType.uint64, "sr-enforced-bandwidth-utilization")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_adjusted_bandwidth_utilization",
                                                "sr_bandwidth_utilization",
                                                "sr_enforced_bandwidth_utilization") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_adjusted_bandwidth_utilization.is_set or
                                    self.sr_bandwidth_utilization.is_set or
                                    self.sr_enforced_bandwidth_utilization.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.sr_bandwidth_utilization.yfilter != YFilter.not_set or
                                    self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-bandwidth-utilization" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_adjusted_bandwidth_utilization.is_set or self.sr_adjusted_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_adjusted_bandwidth_utilization.get_name_leafdata())
                                if (self.sr_bandwidth_utilization.is_set or self.sr_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_bandwidth_utilization.get_name_leafdata())
                                if (self.sr_enforced_bandwidth_utilization.is_set or self.sr_enforced_bandwidth_utilization.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_enforced_bandwidth_utilization.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-adjusted-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "sr-enforced-bandwidth-utilization"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-adjusted-bandwidth-utilization"):
                                    self.sr_adjusted_bandwidth_utilization = value
                                    self.sr_adjusted_bandwidth_utilization.value_namespace = name_space
                                    self.sr_adjusted_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-bandwidth-utilization"):
                                    self.sr_bandwidth_utilization = value
                                    self.sr_bandwidth_utilization.value_namespace = name_space
                                    self.sr_bandwidth_utilization.value_namespace_prefix = name_space_prefix
                                if(value_path == "sr-enforced-bandwidth-utilization"):
                                    self.sr_enforced_bandwidth_utilization = value
                                    self.sr_enforced_bandwidth_utilization.value_namespace = name_space
                                    self.sr_enforced_bandwidth_utilization.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.adjustment_factor.is_set or
                                self.application_enforced.is_set or
                                self.application_interval.is_set or
                                self.application_time_remaining.is_set or
                                self.collection_type.is_set or
                                self.down_threshold_max_reservable_bandwidth.is_set or
                                self.is_bandwidth_account_enabled.is_set or
                                self.last_application_timestamp.is_set or
                                self.last_sample_collection_timestamp.is_set or
                                self.max_reservable_bandwidth_threshold_are_default.is_set or
                                self.next_application.is_set or
                                self.next_sample_collection.is_set or
                                self.sample_interval.is_set or
                                self.sample_time_remaining.is_set or
                                self.up_threshold_max_reservable_bandwidth.is_set or
                                (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_data()) or
                                (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_factor.yfilter != YFilter.not_set or
                                self.application_enforced.yfilter != YFilter.not_set or
                                self.application_interval.yfilter != YFilter.not_set or
                                self.application_time_remaining.yfilter != YFilter.not_set or
                                self.collection_type.yfilter != YFilter.not_set or
                                self.down_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set or
                                self.is_bandwidth_account_enabled.yfilter != YFilter.not_set or
                                self.last_application_timestamp.yfilter != YFilter.not_set or
                                self.last_sample_collection_timestamp.yfilter != YFilter.not_set or
                                self.max_reservable_bandwidth_threshold_are_default.yfilter != YFilter.not_set or
                                self.next_application.yfilter != YFilter.not_set or
                                self.next_sample_collection.yfilter != YFilter.not_set or
                                self.sample_interval.yfilter != YFilter.not_set or
                                self.sample_time_remaining.yfilter != YFilter.not_set or
                                self.up_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set or
                                (self.rsvp_te_bandwidth_utilization is not None and self.rsvp_te_bandwidth_utilization.has_operation()) or
                                (self.sr_bandwidth_utilization is not None and self.sr_bandwidth_utilization.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bandwidth-account-common-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_factor.is_set or self.adjustment_factor.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_factor.get_name_leafdata())
                            if (self.application_enforced.is_set or self.application_enforced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_enforced.get_name_leafdata())
                            if (self.application_interval.is_set or self.application_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_interval.get_name_leafdata())
                            if (self.application_time_remaining.is_set or self.application_time_remaining.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_time_remaining.get_name_leafdata())
                            if (self.collection_type.is_set or self.collection_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_type.get_name_leafdata())
                            if (self.down_threshold_max_reservable_bandwidth.is_set or self.down_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_threshold_max_reservable_bandwidth.get_name_leafdata())
                            if (self.is_bandwidth_account_enabled.is_set or self.is_bandwidth_account_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_account_enabled.get_name_leafdata())
                            if (self.last_application_timestamp.is_set or self.last_application_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_timestamp.get_name_leafdata())
                            if (self.last_sample_collection_timestamp.is_set or self.last_sample_collection_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_sample_collection_timestamp.get_name_leafdata())
                            if (self.max_reservable_bandwidth_threshold_are_default.is_set or self.max_reservable_bandwidth_threshold_are_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_reservable_bandwidth_threshold_are_default.get_name_leafdata())
                            if (self.next_application.is_set or self.next_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_application.get_name_leafdata())
                            if (self.next_sample_collection.is_set or self.next_sample_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_sample_collection.get_name_leafdata())
                            if (self.sample_interval.is_set or self.sample_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sample_interval.get_name_leafdata())
                            if (self.sample_time_remaining.is_set or self.sample_time_remaining.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sample_time_remaining.get_name_leafdata())
                            if (self.up_threshold_max_reservable_bandwidth.is_set or self.up_threshold_max_reservable_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_threshold_max_reservable_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rsvp-te-bandwidth-utilization"):
                                if (self.rsvp_te_bandwidth_utilization is None):
                                    self.rsvp_te_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                                    self.rsvp_te_bandwidth_utilization.parent = self
                                    self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"
                                return self.rsvp_te_bandwidth_utilization

                            if (child_yang_name == "sr-bandwidth-utilization"):
                                if (self.sr_bandwidth_utilization is None):
                                    self.sr_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                                    self.sr_bandwidth_utilization.parent = self
                                    self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                                return self.sr_bandwidth_utilization

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rsvp-te-bandwidth-utilization" or name == "sr-bandwidth-utilization" or name == "adjustment-factor" or name == "application-enforced" or name == "application-interval" or name == "application-time-remaining" or name == "collection-type" or name == "down-threshold-max-reservable-bandwidth" or name == "is-bandwidth-account-enabled" or name == "last-application-timestamp" or name == "last-sample-collection-timestamp" or name == "max-reservable-bandwidth-threshold-are-default" or name == "next-application" or name == "next-sample-collection" or name == "sample-interval" or name == "sample-time-remaining" or name == "up-threshold-max-reservable-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-factor"):
                                self.adjustment_factor = value
                                self.adjustment_factor.value_namespace = name_space
                                self.adjustment_factor.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-enforced"):
                                self.application_enforced = value
                                self.application_enforced.value_namespace = name_space
                                self.application_enforced.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-interval"):
                                self.application_interval = value
                                self.application_interval.value_namespace = name_space
                                self.application_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-time-remaining"):
                                self.application_time_remaining = value
                                self.application_time_remaining.value_namespace = name_space
                                self.application_time_remaining.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-type"):
                                self.collection_type = value
                                self.collection_type.value_namespace = name_space
                                self.collection_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-threshold-max-reservable-bandwidth"):
                                self.down_threshold_max_reservable_bandwidth = value
                                self.down_threshold_max_reservable_bandwidth.value_namespace = name_space
                                self.down_threshold_max_reservable_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-account-enabled"):
                                self.is_bandwidth_account_enabled = value
                                self.is_bandwidth_account_enabled.value_namespace = name_space
                                self.is_bandwidth_account_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-timestamp"):
                                self.last_application_timestamp = value
                                self.last_application_timestamp.value_namespace = name_space
                                self.last_application_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-sample-collection-timestamp"):
                                self.last_sample_collection_timestamp = value
                                self.last_sample_collection_timestamp.value_namespace = name_space
                                self.last_sample_collection_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-reservable-bandwidth-threshold-are-default"):
                                self.max_reservable_bandwidth_threshold_are_default = value
                                self.max_reservable_bandwidth_threshold_are_default.value_namespace = name_space
                                self.max_reservable_bandwidth_threshold_are_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-application"):
                                self.next_application = value
                                self.next_application.value_namespace = name_space
                                self.next_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-sample-collection"):
                                self.next_sample_collection = value
                                self.next_sample_collection.value_namespace = name_space
                                self.next_sample_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "sample-interval"):
                                self.sample_interval = value
                                self.sample_interval.value_namespace = name_space
                                self.sample_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "sample-time-remaining"):
                                self.sample_time_remaining = value
                                self.sample_time_remaining.value_namespace = name_space
                                self.sample_time_remaining.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-threshold-max-reservable-bandwidth"):
                                self.up_threshold_max_reservable_bandwidth = value
                                self.up_threshold_max_reservable_bandwidth.value_namespace = name_space
                                self.up_threshold_max_reservable_bandwidth.value_namespace_prefix = name_space_prefix


                    class RsvpTeBandwidthSampleHistory(Entity):
                        """
                        RSVP\-TE Bandwidth samples history
                        
                        .. attribute:: rsvp_te_active_interval_sample
                        
                        	RSVP\-TE samples in the current application interval
                        	**type**\: list of    :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample>`
                        
                        .. attribute:: rsvp_te_previous_interval_sample
                        
                        	RSVP\-TE samples in the previous application interval
                        	**type**\: list of    :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"

                            self.rsvp_te_active_interval_sample = YList(self)
                            self.rsvp_te_previous_interval_sample = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__setattr__(name, value)


                        class RsvpTeActiveIntervalSample(Entity):
                            """
                            RSVP\-TE samples in the current application
                            interval
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-active-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"

                                self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                                self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                                self.total_rate = YLeaf(YType.uint64, "total-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_rate",
                                                "rsvp_te_rate",
                                                "timestamp",
                                                "total_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_rate.is_set or
                                    self.rsvp_te_rate.is_set or
                                    self.timestamp.is_set or
                                    self.total_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set or
                                    self.total_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-active-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                                if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())
                                if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-rate" or name == "rsvp-te-rate" or name == "timestamp" or name == "total-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-rate"):
                                    self.non_rsvp_te_rate = value
                                    self.non_rsvp_te_rate.value_namespace = name_space
                                    self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-rate"):
                                    self.rsvp_te_rate = value
                                    self.rsvp_te_rate.value_namespace = name_space
                                    self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-rate"):
                                    self.total_rate = value
                                    self.total_rate.value_namespace = name_space
                                    self.total_rate.value_namespace_prefix = name_space_prefix


                        class RsvpTePreviousIntervalSample(Entity):
                            """
                            RSVP\-TE samples in the previous application
                            interval
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-previous-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"

                                self.non_rsvp_te_rate = YLeaf(YType.uint64, "non-rsvp-te-rate")

                                self.rsvp_te_rate = YLeaf(YType.uint64, "rsvp-te-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                                self.total_rate = YLeaf(YType.uint64, "total-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_rsvp_te_rate",
                                                "rsvp_te_rate",
                                                "timestamp",
                                                "total_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_rsvp_te_rate.is_set or
                                    self.rsvp_te_rate.is_set or
                                    self.timestamp.is_set or
                                    self.total_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.rsvp_te_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set or
                                    self.total_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "rsvp-te-previous-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_rsvp_te_rate.is_set or self.non_rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_rsvp_te_rate.get_name_leafdata())
                                if (self.rsvp_te_rate.is_set or self.rsvp_te_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rsvp_te_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())
                                if (self.total_rate.is_set or self.total_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-rsvp-te-rate" or name == "rsvp-te-rate" or name == "timestamp" or name == "total-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-rsvp-te-rate"):
                                    self.non_rsvp_te_rate = value
                                    self.non_rsvp_te_rate.value_namespace = name_space
                                    self.non_rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "rsvp-te-rate"):
                                    self.rsvp_te_rate = value
                                    self.rsvp_te_rate.value_namespace = name_space
                                    self.rsvp_te_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-rate"):
                                    self.total_rate = value
                                    self.total_rate.value_namespace = name_space
                                    self.total_rate.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.rsvp_te_active_interval_sample:
                                if (c.has_data()):
                                    return True
                            for c in self.rsvp_te_previous_interval_sample:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.rsvp_te_active_interval_sample:
                                if (c.has_operation()):
                                    return True
                            for c in self.rsvp_te_previous_interval_sample:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "rsvp-te-bandwidth-sample-history" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "rsvp-te-active-interval-sample"):
                                for c in self.rsvp_te_active_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.rsvp_te_active_interval_sample.append(c)
                                return c

                            if (child_yang_name == "rsvp-te-previous-interval-sample"):
                                for c in self.rsvp_te_previous_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.rsvp_te_previous_interval_sample.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "rsvp-te-active-interval-sample" or name == "rsvp-te-previous-interval-sample"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class SrBandwidthSampleHistory(Entity):
                        """
                        Segment Routing Bandwidth samples history
                        
                        .. attribute:: sr_active_interval_sample
                        
                        	Segment Routing samples in the current application interval
                        	**type**\: list of    :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample>`
                        
                        .. attribute:: sr_previous_interval_sample
                        
                        	Segment Routing samples in the previous application interval
                        	**type**\: list of    :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__init__()

                            self.yang_name = "sr-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"

                            self.sr_active_interval_sample = YList(self)
                            self.sr_previous_interval_sample = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__setattr__(name, value)


                        class SrActiveIntervalSample(Entity):
                            """
                            Segment Routing samples in the current
                            application interval
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__init__()

                                self.yang_name = "sr-active-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"

                                self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_rate",
                                                "timestamp") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_rate.is_set or
                                    self.timestamp.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-active-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-rate" or name == "timestamp"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-rate"):
                                    self.sr_rate = value
                                    self.sr_rate.value_namespace = name_space
                                    self.sr_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix


                        class SrPreviousIntervalSample(Entity):
                            """
                            Segment Routing samples in the previous
                            application interval
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__init__()

                                self.yang_name = "sr-previous-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"

                                self.sr_rate = YLeaf(YType.uint64, "sr-rate")

                                self.timestamp = YLeaf(YType.uint32, "timestamp")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("sr_rate",
                                                "timestamp") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.sr_rate.is_set or
                                    self.timestamp.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.sr_rate.yfilter != YFilter.not_set or
                                    self.timestamp.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sr-previous-interval-sample" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.sr_rate.is_set or self.sr_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sr_rate.get_name_leafdata())
                                if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.timestamp.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-rate" or name == "timestamp"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "sr-rate"):
                                    self.sr_rate = value
                                    self.sr_rate.value_namespace = name_space
                                    self.sr_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "timestamp"):
                                    self.timestamp = value
                                    self.timestamp.value_namespace = name_space
                                    self.timestamp.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.sr_active_interval_sample:
                                if (c.has_data()):
                                    return True
                            for c in self.sr_previous_interval_sample:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.sr_active_interval_sample:
                                if (c.has_operation()):
                                    return True
                            for c in self.sr_previous_interval_sample:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "sr-bandwidth-sample-history" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sr-active-interval-sample"):
                                for c in self.sr_active_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sr_active_interval_sample.append(c)
                                return c

                            if (child_yang_name == "sr-previous-interval-sample"):
                                for c in self.sr_previous_interval_sample:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sr_previous_interval_sample.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sr-active-interval-sample" or name == "sr-previous-interval-sample"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.bandwidth_account_common_info is not None and self.bandwidth_account_common_info.has_data()) or
                            (self.rsvp_te_bandwidth_sample_history is not None and self.rsvp_te_bandwidth_sample_history.has_data()) or
                            (self.sr_bandwidth_sample_history is not None and self.sr_bandwidth_sample_history.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.bandwidth_account_common_info is not None and self.bandwidth_account_common_info.has_operation()) or
                            (self.rsvp_te_bandwidth_sample_history is not None and self.rsvp_te_bandwidth_sample_history.has_operation()) or
                            (self.sr_bandwidth_sample_history is not None and self.sr_bandwidth_sample_history.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bandwidth-account" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bandwidth-account-common-info"):
                            if (self.bandwidth_account_common_info is None):
                                self.bandwidth_account_common_info = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                                self.bandwidth_account_common_info.parent = self
                                self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"
                            return self.bandwidth_account_common_info

                        if (child_yang_name == "rsvp-te-bandwidth-sample-history"):
                            if (self.rsvp_te_bandwidth_sample_history is None):
                                self.rsvp_te_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                                self.rsvp_te_bandwidth_sample_history.parent = self
                                self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"
                            return self.rsvp_te_bandwidth_sample_history

                        if (child_yang_name == "sr-bandwidth-sample-history"):
                            if (self.sr_bandwidth_sample_history is None):
                                self.sr_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                                self.sr_bandwidth_sample_history.parent = self
                                self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                            return self.sr_bandwidth_sample_history

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth-account-common-info" or name == "rsvp-te-bandwidth-sample-history" or name == "sr-bandwidth-sample-history"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class HwOor(Entity):
                    """
                    The link's NPU OOR info. This field is NULL for
                    platforms that do not support HW\-OOR
                    notifications
                    
                    .. attribute:: hw_o_or_green_recovery_time
                    
                    	Time Remaining in Green Recovery State (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: hw_o_or_link_statistic
                    
                    	HW OOR statistics for the link
                    	**type**\: list of    :py:class:`HwOOrLinkStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic>`
                    
                    .. attribute:: hw_oor_state
                    
                    	The NPU (Network Processor Unit) HW resource state
                    	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    .. attribute:: hw_oor_timestamp
                    
                    	Timestamp when the OOR state last changed
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.HwOor, self).__init__()

                        self.yang_name = "hw-oor"
                        self.yang_parent_name = "link"

                        self.hw_o_or_green_recovery_time = YLeaf(YType.uint32, "hw-o-or-green-recovery-time")

                        self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                        self.hw_oor_timestamp = YLeaf(YType.uint32, "hw-oor-timestamp")

                        self.hw_o_or_link_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hw_o_or_green_recovery_time",
                                        "hw_oor_state",
                                        "hw_oor_timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.HwOor, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.HwOor, self).__setattr__(name, value)


                    class HwOOrLinkStatistic(Entity):
                        """
                        HW OOR statistics for the link
                        
                        .. attribute:: accepted_ls_ps_number
                        
                        	Number of LSPs that were accepted in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: accepted_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were accepted in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hw_oor_state
                        
                        	The HW\-OOR state that these statistics belong to
                        	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                        
                        .. attribute:: node_protection_disable_number
                        
                        	Number of times this OOR state disabled node protection assignment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rejected_ls_ps_number
                        
                        	Number of LSPs that were rejected in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rejected_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were rejected in this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: transitions
                        
                        	Number of transitions to this state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__init__()

                            self.yang_name = "hw-o-or-link-statistic"
                            self.yang_parent_name = "hw-oor"

                            self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                            self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                            self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                            self.node_protection_disable_number = YLeaf(YType.uint32, "node-protection-disable-number")

                            self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                            self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                            self.transitions = YLeaf(YType.uint32, "transitions")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("accepted_ls_ps_number",
                                            "accepted_reopt_ls_ps_number",
                                            "hw_oor_state",
                                            "node_protection_disable_number",
                                            "rejected_ls_ps_number",
                                            "rejected_reopt_ls_ps_number",
                                            "transitions") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.accepted_ls_ps_number.is_set or
                                self.accepted_reopt_ls_ps_number.is_set or
                                self.hw_oor_state.is_set or
                                self.node_protection_disable_number.is_set or
                                self.rejected_ls_ps_number.is_set or
                                self.rejected_reopt_ls_ps_number.is_set or
                                self.transitions.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                                self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                                self.hw_oor_state.yfilter != YFilter.not_set or
                                self.node_protection_disable_number.yfilter != YFilter.not_set or
                                self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                                self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                                self.transitions.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "hw-o-or-link-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                            if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                            if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                            if (self.node_protection_disable_number.is_set or self.node_protection_disable_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_protection_disable_number.get_name_leafdata())
                            if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                            if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                            if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.transitions.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "hw-oor-state" or name == "node-protection-disable-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "accepted-ls-ps-number"):
                                self.accepted_ls_ps_number = value
                                self.accepted_ls_ps_number.value_namespace = name_space
                                self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "accepted-reopt-ls-ps-number"):
                                self.accepted_reopt_ls_ps_number = value
                                self.accepted_reopt_ls_ps_number.value_namespace = name_space
                                self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "hw-oor-state"):
                                self.hw_oor_state = value
                                self.hw_oor_state.value_namespace = name_space
                                self.hw_oor_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-protection-disable-number"):
                                self.node_protection_disable_number = value
                                self.node_protection_disable_number.value_namespace = name_space
                                self.node_protection_disable_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "rejected-ls-ps-number"):
                                self.rejected_ls_ps_number = value
                                self.rejected_ls_ps_number.value_namespace = name_space
                                self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "rejected-reopt-ls-ps-number"):
                                self.rejected_reopt_ls_ps_number = value
                                self.rejected_reopt_ls_ps_number.value_namespace = name_space
                                self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                            if(value_path == "transitions"):
                                self.transitions = value
                                self.transitions.value_namespace = name_space
                                self.transitions.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.hw_o_or_link_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.hw_o_or_green_recovery_time.is_set or
                            self.hw_oor_state.is_set or
                            self.hw_oor_timestamp.is_set)

                    def has_operation(self):
                        for c in self.hw_o_or_link_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hw_o_or_green_recovery_time.yfilter != YFilter.not_set or
                            self.hw_oor_state.yfilter != YFilter.not_set or
                            self.hw_oor_timestamp.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hw-oor" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hw_o_or_green_recovery_time.is_set or self.hw_o_or_green_recovery_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_o_or_green_recovery_time.get_name_leafdata())
                        if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                        if (self.hw_oor_timestamp.is_set or self.hw_oor_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "hw-o-or-link-statistic"):
                            for c in self.hw_o_or_link_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.hw_o_or_link_statistic.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "hw-o-or-link-statistic" or name == "hw-o-or-green-recovery-time" or name == "hw-oor-state" or name == "hw-oor-timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hw-o-or-green-recovery-time"):
                            self.hw_o_or_green_recovery_time = value
                            self.hw_o_or_green_recovery_time.value_namespace = name_space
                            self.hw_o_or_green_recovery_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-state"):
                            self.hw_oor_state = value
                            self.hw_oor_state.value_namespace = name_space
                            self.hw_oor_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-timestamp"):
                            self.hw_oor_timestamp = value
                            self.hw_oor_timestamp.value_namespace = name_space
                            self.hw_oor_timestamp.value_namespace_prefix = name_space_prefix


                class LinkExtendedAttribute(Entity):
                    """
                    The link's extended attribute bit map
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute, self).__init__()

                        self.yang_name = "link-extended-attribute"
                        self.yang_parent_name = "link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-extended-attribute" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class LinkForwadRefValue(Entity):
                    """
                    Reference bits for undefined affinity names
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue, self).__init__()

                        self.yang_name = "link-forwad-ref-value"
                        self.yang_parent_name = "link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "link-forwad-ref-value" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class AffinityMap(Entity):
                    """
                    Affinity map array
                    
                    .. attribute:: affinity_bit_position
                    
                    	Affinity bit position
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: affinity_extended_value
                    
                    	EAG value
                    	**type**\: list of    :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue>`
                    
                    .. attribute:: affinity_name
                    
                    	Affinity name
                    	**type**\:  str
                    
                    .. attribute:: affinity_table_id
                    
                    	Affinity table id
                    	**type**\:   :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                    
                    .. attribute:: affinity_value
                    
                    	Affinity value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.AffinityMap, self).__init__()

                        self.yang_name = "affinity-map"
                        self.yang_parent_name = "link"

                        self.affinity_bit_position = YLeaf(YType.uint8, "affinity-bit-position")

                        self.affinity_name = YLeaf(YType.str, "affinity-name")

                        self.affinity_table_id = YLeaf(YType.enumeration, "affinity-table-id")

                        self.affinity_value = YLeaf(YType.uint32, "affinity-value")

                        self.affinity_extended_value = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bit_position",
                                        "affinity_name",
                                        "affinity_table_id",
                                        "affinity_value") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.AffinityMap, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.AffinityMap, self).__setattr__(name, value)


                    class AffinityExtendedValue(Entity):
                        """
                        EAG value
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__init__()

                            self.yang_name = "affinity-extended-value"
                            self.yang_parent_name = "affinity-map"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity-extended-value" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.affinity_extended_value:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bit_position.is_set or
                            self.affinity_name.is_set or
                            self.affinity_table_id.is_set or
                            self.affinity_value.is_set)

                    def has_operation(self):
                        for c in self.affinity_extended_value:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bit_position.yfilter != YFilter.not_set or
                            self.affinity_name.yfilter != YFilter.not_set or
                            self.affinity_table_id.yfilter != YFilter.not_set or
                            self.affinity_value.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity-map" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bit_position.is_set or self.affinity_bit_position.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bit_position.get_name_leafdata())
                        if (self.affinity_name.is_set or self.affinity_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_name.get_name_leafdata())
                        if (self.affinity_table_id.is_set or self.affinity_table_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_table_id.get_name_leafdata())
                        if (self.affinity_value.is_set or self.affinity_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_value.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity-extended-value"):
                            for c in self.affinity_extended_value:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.affinity_extended_value.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity-extended-value" or name == "affinity-bit-position" or name == "affinity-name" or name == "affinity-table-id" or name == "affinity-value"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bit-position"):
                            self.affinity_bit_position = value
                            self.affinity_bit_position.value_namespace = name_space
                            self.affinity_bit_position.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-name"):
                            self.affinity_name = value
                            self.affinity_name.value_namespace = name_space
                            self.affinity_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-table-id"):
                            self.affinity_table_id = value
                            self.affinity_table_id.value_namespace = name_space
                            self.affinity_table_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-value"):
                            self.affinity_value = value
                            self.affinity_value.value_namespace = name_space
                            self.affinity_value.value_namespace_prefix = name_space_prefix


                class Areas(Entity):
                    """
                    Per\-area data
                    
                    .. attribute:: area_id
                    
                    	Area id
                    	**type**\:  str
                    
                    .. attribute:: igp_metric
                    
                    	The link's IGP metric
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_neighbor_up
                    
                    	TRUE if the neighbor is up
                    	**type**\:  bool
                    
                    .. attribute:: neighbor_address
                    
                    	The interface's neighbor's ip address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: neighbor_id
                    
                    	The interface neighbor id
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.Areas, self).__init__()

                        self.yang_name = "areas"
                        self.yang_parent_name = "link"

                        self.area_id = YLeaf(YType.str, "area-id")

                        self.igp_metric = YLeaf(YType.uint32, "igp-metric")

                        self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                        self.neighbor_id = YLeaf(YType.str, "neighbor-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("area_id",
                                        "igp_metric",
                                        "is_neighbor_up",
                                        "neighbor_address",
                                        "neighbor_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.Areas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.Areas, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.area_id.is_set or
                            self.igp_metric.is_set or
                            self.is_neighbor_up.is_set or
                            self.neighbor_address.is_set or
                            self.neighbor_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.area_id.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_neighbor_up.yfilter != YFilter.not_set or
                            self.neighbor_address.yfilter != YFilter.not_set or
                            self.neighbor_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_id.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())
                        if (self.neighbor_id.is_set or self.neighbor_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-id" or name == "igp-metric" or name == "is-neighbor-up" or name == "neighbor-address" or name == "neighbor-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "area-id"):
                            self.area_id = value
                            self.area_id.value_namespace = name_space
                            self.area_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-neighbor-up"):
                            self.is_neighbor_up = value
                            self.is_neighbor_up.value_namespace = name_space
                            self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-address"):
                            self.neighbor_address = value
                            self.neighbor_address.value_namespace = name_space
                            self.neighbor_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-id"):
                            self.neighbor_id = value
                            self.neighbor_id.value_namespace = name_space
                            self.neighbor_id.value_namespace_prefix = name_space_prefix


                class Lockout(Entity):
                    """
                    Flex LSP Lockout info
                    
                    .. attribute:: is_lockout
                    
                    	True if link is locked out
                    	**type**\:  bool
                    
                    .. attribute:: lockout_off_timestamp
                    
                    	Timestamp when the lockout is cleared
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lockout_on_timestamp
                    
                    	Timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLcac.LinkInformation.Links.Link.Lockout, self).__init__()

                        self.yang_name = "lockout"
                        self.yang_parent_name = "link"

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_off_timestamp = YLeaf(YType.uint32, "lockout-off-timestamp")

                        self.lockout_on_timestamp = YLeaf(YType.uint32, "lockout-on-timestamp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_lockout",
                                        "lockout_off_timestamp",
                                        "lockout_on_timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLcac.LinkInformation.Links.Link.Lockout, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLcac.LinkInformation.Links.Link.Lockout, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_lockout.is_set or
                            self.lockout_off_timestamp.is_set or
                            self.lockout_on_timestamp.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_off_timestamp.yfilter != YFilter.not_set or
                            self.lockout_on_timestamp.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lockout" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_off_timestamp.is_set or self.lockout_off_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_off_timestamp.get_name_leafdata())
                        if (self.lockout_on_timestamp.is_set or self.lockout_on_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_on_timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-lockout" or name == "lockout-off-timestamp" or name == "lockout-on-timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-off-timestamp"):
                            self.lockout_off_timestamp = value
                            self.lockout_off_timestamp.value_namespace = name_space
                            self.lockout_off_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-on-timestamp"):
                            self.lockout_on_timestamp = value
                            self.lockout_on_timestamp.value_namespace = name_space
                            self.lockout_on_timestamp.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.affinity_map:
                        if (c.has_data()):
                            return True
                    for c in self.areas:
                        if (c.has_data()):
                            return True
                    for c in self.link_extended_attribute:
                        if (c.has_data()):
                            return True
                    for c in self.link_forwad_ref_value:
                        if (c.has_data()):
                            return True
                    for c in self.lockout:
                        if (c.has_data()):
                            return True
                    return (
                        self.interface_name.is_set or
                        self.is_attribute_incomplete.is_set or
                        self.is_name_based_attribute.is_set or
                        self.is_te_metric_valid.is_set or
                        self.link_attributes.is_set or
                        self.maximum_reservation_bandwidth_mam.is_set or
                        self.maximum_reservation_bandwidth_rdm.is_set or
                        self.reason_not_flooded.is_set or
                        self.reservable_pool0_bandwidth_mam.is_set or
                        self.reservable_pool0_bandwidth_rdm.is_set or
                        self.reservable_pool1_bandwidth_mam.is_set or
                        self.reservable_pool1_bandwidth_rdm.is_set or
                        self.te_metric.is_set or
                        (self.bandwidth_account is not None and self.bandwidth_account.has_data()) or
                        (self.hw_oor is not None and self.hw_oor.has_data()) or
                        (self.link_common is not None and self.link_common.has_data()))

                def has_operation(self):
                    for c in self.affinity_map:
                        if (c.has_operation()):
                            return True
                    for c in self.areas:
                        if (c.has_operation()):
                            return True
                    for c in self.link_extended_attribute:
                        if (c.has_operation()):
                            return True
                    for c in self.link_forwad_ref_value:
                        if (c.has_operation()):
                            return True
                    for c in self.lockout:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.is_attribute_incomplete.yfilter != YFilter.not_set or
                        self.is_name_based_attribute.yfilter != YFilter.not_set or
                        self.is_te_metric_valid.yfilter != YFilter.not_set or
                        self.link_attributes.yfilter != YFilter.not_set or
                        self.maximum_reservation_bandwidth_mam.yfilter != YFilter.not_set or
                        self.maximum_reservation_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.reason_not_flooded.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth_mam.yfilter != YFilter.not_set or
                        self.reservable_pool0_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth_mam.yfilter != YFilter.not_set or
                        self.reservable_pool1_bandwidth_rdm.yfilter != YFilter.not_set or
                        self.te_metric.yfilter != YFilter.not_set or
                        (self.bandwidth_account is not None and self.bandwidth_account.has_operation()) or
                        (self.hw_oor is not None and self.hw_oor.has_operation()) or
                        (self.link_common is not None and self.link_common.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.is_attribute_incomplete.is_set or self.is_attribute_incomplete.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_incomplete.get_name_leafdata())
                    if (self.is_name_based_attribute.is_set or self.is_name_based_attribute.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_name_based_attribute.get_name_leafdata())
                    if (self.is_te_metric_valid.is_set or self.is_te_metric_valid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_te_metric_valid.get_name_leafdata())
                    if (self.link_attributes.is_set or self.link_attributes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_attributes.get_name_leafdata())
                    if (self.maximum_reservation_bandwidth_mam.is_set or self.maximum_reservation_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.maximum_reservation_bandwidth_mam.get_name_leafdata())
                    if (self.maximum_reservation_bandwidth_rdm.is_set or self.maximum_reservation_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.maximum_reservation_bandwidth_rdm.get_name_leafdata())
                    if (self.reason_not_flooded.is_set or self.reason_not_flooded.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reason_not_flooded.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth_mam.is_set or self.reservable_pool0_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth_mam.get_name_leafdata())
                    if (self.reservable_pool0_bandwidth_rdm.is_set or self.reservable_pool0_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool0_bandwidth_rdm.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth_mam.is_set or self.reservable_pool1_bandwidth_mam.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth_mam.get_name_leafdata())
                    if (self.reservable_pool1_bandwidth_rdm.is_set or self.reservable_pool1_bandwidth_rdm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reservable_pool1_bandwidth_rdm.get_name_leafdata())
                    if (self.te_metric.is_set or self.te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity-map"):
                        for c in self.affinity_map:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.LinkInformation.Links.Link.AffinityMap()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.affinity_map.append(c)
                        return c

                    if (child_yang_name == "areas"):
                        for c in self.areas:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.LinkInformation.Links.Link.Areas()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.areas.append(c)
                        return c

                    if (child_yang_name == "bandwidth-account"):
                        if (self.bandwidth_account is None):
                            self.bandwidth_account = MplsLcac.LinkInformation.Links.Link.BandwidthAccount()
                            self.bandwidth_account.parent = self
                            self._children_name_map["bandwidth_account"] = "bandwidth-account"
                        return self.bandwidth_account

                    if (child_yang_name == "hw-oor"):
                        if (self.hw_oor is None):
                            self.hw_oor = MplsLcac.LinkInformation.Links.Link.HwOor()
                            self.hw_oor.parent = self
                            self._children_name_map["hw_oor"] = "hw-oor"
                        return self.hw_oor

                    if (child_yang_name == "link-common"):
                        if (self.link_common is None):
                            self.link_common = MplsLcac.LinkInformation.Links.Link.LinkCommon()
                            self.link_common.parent = self
                            self._children_name_map["link_common"] = "link-common"
                        return self.link_common

                    if (child_yang_name == "link-extended-attribute"):
                        for c in self.link_extended_attribute:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.link_extended_attribute.append(c)
                        return c

                    if (child_yang_name == "link-forwad-ref-value"):
                        for c in self.link_forwad_ref_value:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.link_forwad_ref_value.append(c)
                        return c

                    if (child_yang_name == "lockout"):
                        for c in self.lockout:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLcac.LinkInformation.Links.Link.Lockout()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.lockout.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity-map" or name == "areas" or name == "bandwidth-account" or name == "hw-oor" or name == "link-common" or name == "link-extended-attribute" or name == "link-forwad-ref-value" or name == "lockout" or name == "interface-name" or name == "is-attribute-incomplete" or name == "is-name-based-attribute" or name == "is-te-metric-valid" or name == "link-attributes" or name == "maximum-reservation-bandwidth-mam" or name == "maximum-reservation-bandwidth-rdm" or name == "reason-not-flooded" or name == "reservable-pool0-bandwidth-mam" or name == "reservable-pool0-bandwidth-rdm" or name == "reservable-pool1-bandwidth-mam" or name == "reservable-pool1-bandwidth-rdm" or name == "te-metric"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-incomplete"):
                        self.is_attribute_incomplete = value
                        self.is_attribute_incomplete.value_namespace = name_space
                        self.is_attribute_incomplete.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-name-based-attribute"):
                        self.is_name_based_attribute = value
                        self.is_name_based_attribute.value_namespace = name_space
                        self.is_name_based_attribute.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-te-metric-valid"):
                        self.is_te_metric_valid = value
                        self.is_te_metric_valid.value_namespace = name_space
                        self.is_te_metric_valid.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-attributes"):
                        self.link_attributes = value
                        self.link_attributes.value_namespace = name_space
                        self.link_attributes.value_namespace_prefix = name_space_prefix
                    if(value_path == "maximum-reservation-bandwidth-mam"):
                        self.maximum_reservation_bandwidth_mam = value
                        self.maximum_reservation_bandwidth_mam.value_namespace = name_space
                        self.maximum_reservation_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "maximum-reservation-bandwidth-rdm"):
                        self.maximum_reservation_bandwidth_rdm = value
                        self.maximum_reservation_bandwidth_rdm.value_namespace = name_space
                        self.maximum_reservation_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "reason-not-flooded"):
                        self.reason_not_flooded = value
                        self.reason_not_flooded.value_namespace = name_space
                        self.reason_not_flooded.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth-mam"):
                        self.reservable_pool0_bandwidth_mam = value
                        self.reservable_pool0_bandwidth_mam.value_namespace = name_space
                        self.reservable_pool0_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool0-bandwidth-rdm"):
                        self.reservable_pool0_bandwidth_rdm = value
                        self.reservable_pool0_bandwidth_rdm.value_namespace = name_space
                        self.reservable_pool0_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth-mam"):
                        self.reservable_pool1_bandwidth_mam = value
                        self.reservable_pool1_bandwidth_mam.value_namespace = name_space
                        self.reservable_pool1_bandwidth_mam.value_namespace_prefix = name_space_prefix
                    if(value_path == "reservable-pool1-bandwidth-rdm"):
                        self.reservable_pool1_bandwidth_rdm = value
                        self.reservable_pool1_bandwidth_rdm.value_namespace = name_space
                        self.reservable_pool1_bandwidth_rdm.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric"):
                        self.te_metric = value
                        self.te_metric.value_namespace = name_space
                        self.te_metric.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link"):
                    for c in self.link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.LinkInformation.Links.Link()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.global_ is not None and self.global_.has_data()) or
                (self.links is not None and self.links.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.links is not None and self.links.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "link-information" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcac.LinkInformation.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "links"):
                if (self.links is None):
                    self.links = MplsLcac.LinkInformation.Links()
                    self.links.parent = self
                    self._children_name_map["links"] = "links"
                return self.links

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "global" or name == "links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AdmissionControl(Entity):
        """
        The admission control information in MPLS\-LCAC
        
        .. attribute:: admitted_tunnels
        
        	The table of admitted tunnels information in MPLS\-LCAC
        	**type**\:   :py:class:`AdmittedTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.AdmittedTunnels>`
        
        .. attribute:: global_
        
        	The global admission control information
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.Global_>`
        
        .. attribute:: link_interfaces
        
        	The global admission control information on Interfaces
        	**type**\:   :py:class:`LinkInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.LinkInterfaces>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.AdmissionControl, self).__init__()

            self.yang_name = "admission-control"
            self.yang_parent_name = "mpls-lcac"

            self.admitted_tunnels = MplsLcac.AdmissionControl.AdmittedTunnels()
            self.admitted_tunnels.parent = self
            self._children_name_map["admitted_tunnels"] = "admitted-tunnels"
            self._children_yang_names.add("admitted-tunnels")

            self.global_ = MplsLcac.AdmissionControl.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.link_interfaces = MplsLcac.AdmissionControl.LinkInterfaces()
            self.link_interfaces.parent = self
            self._children_name_map["link_interfaces"] = "link-interfaces"
            self._children_yang_names.add("link-interfaces")


        class Global_(Entity):
            """
            The global admission control information
            
            .. attribute:: bandwidth_units
            
            	Bandwidth units
            	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\:  bool
            
            .. attribute:: selected_tunnels
            
            	Number of tunnels selected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_p2mp_tunnels
            
            	Total p2mp tunnels admitted
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_tunnels
            
            	Total p2p tunnels admitted
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.AdmissionControl.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "admission-control"

                self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                self.selected_tunnels = YLeaf(YType.uint32, "selected-tunnels")

                self.total_p2mp_tunnels = YLeaf(YType.uint32, "total-p2mp-tunnels")

                self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("bandwidth_units",
                                "is_role_standby",
                                "selected_tunnels",
                                "total_p2mp_tunnels",
                                "total_tunnels") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.AdmissionControl.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.AdmissionControl.Global_, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.bandwidth_units.is_set or
                    self.is_role_standby.is_set or
                    self.selected_tunnels.is_set or
                    self.total_p2mp_tunnels.is_set or
                    self.total_tunnels.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.bandwidth_units.yfilter != YFilter.not_set or
                    self.is_role_standby.yfilter != YFilter.not_set or
                    self.selected_tunnels.yfilter != YFilter.not_set or
                    self.total_p2mp_tunnels.yfilter != YFilter.not_set or
                    self.total_tunnels.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                if (self.selected_tunnels.is_set or self.selected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.selected_tunnels.get_name_leafdata())
                if (self.total_p2mp_tunnels.is_set or self.total_p2mp_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_p2mp_tunnels.get_name_leafdata())
                if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bandwidth-units" or name == "is-role-standby" or name == "selected-tunnels" or name == "total-p2mp-tunnels" or name == "total-tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "bandwidth-units"):
                    self.bandwidth_units = value
                    self.bandwidth_units.value_namespace = name_space
                    self.bandwidth_units.value_namespace_prefix = name_space_prefix
                if(value_path == "is-role-standby"):
                    self.is_role_standby = value
                    self.is_role_standby.value_namespace = name_space
                    self.is_role_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "selected-tunnels"):
                    self.selected_tunnels = value
                    self.selected_tunnels.value_namespace = name_space
                    self.selected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "total-p2mp-tunnels"):
                    self.total_p2mp_tunnels = value
                    self.total_p2mp_tunnels.value_namespace = name_space
                    self.total_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "total-tunnels"):
                    self.total_tunnels = value
                    self.total_tunnels.value_namespace = name_space
                    self.total_tunnels.value_namespace_prefix = name_space_prefix


        class AdmittedTunnels(Entity):
            """
            The table of admitted tunnels information in
            MPLS\-LCAC
            
            .. attribute:: admitted_tunnel
            
            	The information for a specific admitted tunnel
            	**type**\: list of    :py:class:`AdmittedTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.AdmissionControl.AdmittedTunnels, self).__init__()

                self.yang_name = "admitted-tunnels"
                self.yang_parent_name = "admission-control"

                self.admitted_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.AdmissionControl.AdmittedTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.AdmissionControl.AdmittedTunnels, self).__setattr__(name, value)


            class AdmittedTunnel(Entity):
                """
                The information for a specific admitted tunnel
                
                .. attribute:: source_address  <key>
                
                	The source IP address of the tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_port  <key>
                
                	The tunnel number at the head
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_port  <key>
                
                	The signaling instance number of the tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address  <key>
                
                	The destination IP address of the tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended tunnel id
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: next_hop_address  <key>
                
                	The Next hop IP
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	C type
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP id
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: backup_interface
                
                	The backup Interface
                	**type**\:  str
                
                .. attribute:: bandwidth
                
                	The bandwidth used by this tunnel
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: bandwidth_pool
                
                	The bandwidth pool
                	**type**\:   :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                .. attribute:: bandwidth_state
                
                	The bandwidth state
                	**type**\:   :py:class:`BandwidthStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthStateEnum>`
                
                .. attribute:: down_link_name
                
                	The downlink's name for this tunnel
                	**type**\:  str
                
                .. attribute:: hold_priority
                
                	The tunnel's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: is_rerouted
                
                	TRUE if the tunnel is currently rerouted
                	**type**\:  bool
                
                .. attribute:: local_label
                
                	The local label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: outgoing_label
                
                	The outgoing label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: setup_priority
                
                	The tunnel's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: tunnel_name
                
                	The admitted tunnel's name
                	**type**\:  str
                
                .. attribute:: tunnel_state
                
                	The tunnel's state
                	**type**\:   :py:class:`TunnelStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelStateEnum>`
                
                .. attribute:: up_link_name
                
                	The uplink's name for this tunnel
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__init__()

                    self.yang_name = "admitted-tunnel"
                    self.yang_parent_name = "admitted-tunnels"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_port = YLeaf(YType.int32, "destination-port")

                    self.source_port = YLeaf(YType.int32, "source-port")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.backup_interface = YLeaf(YType.str, "backup-interface")

                    self.bandwidth = YLeaf(YType.uint64, "bandwidth")

                    self.bandwidth_pool = YLeaf(YType.enumeration, "bandwidth-pool")

                    self.bandwidth_state = YLeaf(YType.enumeration, "bandwidth-state")

                    self.down_link_name = YLeaf(YType.str, "down-link-name")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.is_rerouted = YLeaf(YType.boolean, "is-rerouted")

                    self.local_label = YLeaf(YType.uint32, "local-label")

                    self.outgoing_label = YLeaf(YType.uint32, "outgoing-label")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    self.up_link_name = YLeaf(YType.str, "up-link-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_port",
                                    "source_port",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "next_hop_address",
                                    "ctype",
                                    "p2mp_id",
                                    "backup_interface",
                                    "bandwidth",
                                    "bandwidth_pool",
                                    "bandwidth_state",
                                    "down_link_name",
                                    "hold_priority",
                                    "is_rerouted",
                                    "local_label",
                                    "outgoing_label",
                                    "setup_priority",
                                    "tunnel_name",
                                    "tunnel_state",
                                    "up_link_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_port.is_set or
                        self.source_port.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.next_hop_address.is_set or
                        self.ctype.is_set or
                        self.p2mp_id.is_set or
                        self.backup_interface.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_pool.is_set or
                        self.bandwidth_state.is_set or
                        self.down_link_name.is_set or
                        self.hold_priority.is_set or
                        self.is_rerouted.is_set or
                        self.local_label.is_set or
                        self.outgoing_label.is_set or
                        self.setup_priority.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_state.is_set or
                        self.up_link_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_port.yfilter != YFilter.not_set or
                        self.source_port.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.backup_interface.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_pool.yfilter != YFilter.not_set or
                        self.bandwidth_state.yfilter != YFilter.not_set or
                        self.down_link_name.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.is_rerouted.yfilter != YFilter.not_set or
                        self.local_label.yfilter != YFilter.not_set or
                        self.outgoing_label.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_state.yfilter != YFilter.not_set or
                        self.up_link_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "admitted-tunnel" + "[source-address='" + self.source_address.get() + "']" + "[destination-port='" + self.destination_port.get() + "']" + "[source-port='" + self.source_port.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[next-hop-address='" + self.next_hop_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/admitted-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_port.is_set or self.destination_port.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_port.get_name_leafdata())
                    if (self.source_port.is_set or self.source_port.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_port.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.backup_interface.is_set or self.backup_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_interface.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_pool.is_set or self.bandwidth_pool.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool.get_name_leafdata())
                    if (self.bandwidth_state.is_set or self.bandwidth_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_state.get_name_leafdata())
                    if (self.down_link_name.is_set or self.down_link_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_link_name.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.is_rerouted.is_set or self.is_rerouted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_rerouted.get_name_leafdata())
                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_label.get_name_leafdata())
                    if (self.outgoing_label.is_set or self.outgoing_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outgoing_label.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_state.get_name_leafdata())
                    if (self.up_link_name.is_set or self.up_link_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_link_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-port" or name == "source-port" or name == "destination-address" or name == "extended-tunnel-id" or name == "next-hop-address" or name == "ctype" or name == "p2mp-id" or name == "backup-interface" or name == "bandwidth" or name == "bandwidth-pool" or name == "bandwidth-state" or name == "down-link-name" or name == "hold-priority" or name == "is-rerouted" or name == "local-label" or name == "outgoing-label" or name == "setup-priority" or name == "tunnel-name" or name == "tunnel-state" or name == "up-link-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-port"):
                        self.destination_port = value
                        self.destination_port.value_namespace = name_space
                        self.destination_port.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-port"):
                        self.source_port = value
                        self.source_port.value_namespace = name_space
                        self.source_port.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-interface"):
                        self.backup_interface = value
                        self.backup_interface.value_namespace = name_space
                        self.backup_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool"):
                        self.bandwidth_pool = value
                        self.bandwidth_pool.value_namespace = name_space
                        self.bandwidth_pool.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-state"):
                        self.bandwidth_state = value
                        self.bandwidth_state.value_namespace = name_space
                        self.bandwidth_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-link-name"):
                        self.down_link_name = value
                        self.down_link_name.value_namespace = name_space
                        self.down_link_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-rerouted"):
                        self.is_rerouted = value
                        self.is_rerouted.value_namespace = name_space
                        self.is_rerouted.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-label"):
                        self.local_label = value
                        self.local_label.value_namespace = name_space
                        self.local_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "outgoing-label"):
                        self.outgoing_label = value
                        self.outgoing_label.value_namespace = name_space
                        self.outgoing_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-state"):
                        self.tunnel_state = value
                        self.tunnel_state.value_namespace = name_space
                        self.tunnel_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-link-name"):
                        self.up_link_name = value
                        self.up_link_name.value_namespace = name_space
                        self.up_link_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.admitted_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.admitted_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "admitted-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "admitted-tunnel"):
                    for c in self.admitted_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.admitted_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "admitted-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LinkInterfaces(Entity):
            """
            The global admission control information on
            Interfaces
            
            .. attribute:: link_interface
            
            	The global admission control information on an interface
            	**type**\: list of    :py:class:`LinkInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.AdmissionControl.LinkInterfaces, self).__init__()

                self.yang_name = "link-interfaces"
                self.yang_parent_name = "admission-control"

                self.link_interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.AdmissionControl.LinkInterfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.AdmissionControl.LinkInterfaces, self).__setattr__(name, value)


            class LinkInterface(Entity):
                """
                The global admission control information on an
                interface
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: bandwidth_units
                
                	Bandwidth units
                	**type**\:   :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                .. attribute:: is_role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: selected_tunnels
                
                	Number of tunnels selected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_p2mp_tunnels
                
                	Total p2mp tunnels admitted
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_tunnels
                
                	Total p2p tunnels admitted
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface, self).__init__()

                    self.yang_name = "link-interface"
                    self.yang_parent_name = "link-interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.bandwidth_units = YLeaf(YType.enumeration, "bandwidth-units")

                    self.is_role_standby = YLeaf(YType.boolean, "is-role-standby")

                    self.selected_tunnels = YLeaf(YType.uint32, "selected-tunnels")

                    self.total_p2mp_tunnels = YLeaf(YType.uint32, "total-p2mp-tunnels")

                    self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "bandwidth_units",
                                    "is_role_standby",
                                    "selected_tunnels",
                                    "total_p2mp_tunnels",
                                    "total_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.bandwidth_units.is_set or
                        self.is_role_standby.is_set or
                        self.selected_tunnels.is_set or
                        self.total_p2mp_tunnels.is_set or
                        self.total_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.bandwidth_units.yfilter != YFilter.not_set or
                        self.is_role_standby.yfilter != YFilter.not_set or
                        self.selected_tunnels.yfilter != YFilter.not_set or
                        self.total_p2mp_tunnels.yfilter != YFilter.not_set or
                        self.total_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/link-interfaces/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.bandwidth_units.is_set or self.bandwidth_units.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_units.get_name_leafdata())
                    if (self.is_role_standby.is_set or self.is_role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_role_standby.get_name_leafdata())
                    if (self.selected_tunnels.is_set or self.selected_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.selected_tunnels.get_name_leafdata())
                    if (self.total_p2mp_tunnels.is_set or self.total_p2mp_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_p2mp_tunnels.get_name_leafdata())
                    if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-name" or name == "bandwidth-units" or name == "is-role-standby" or name == "selected-tunnels" or name == "total-p2mp-tunnels" or name == "total-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-units"):
                        self.bandwidth_units = value
                        self.bandwidth_units.value_namespace = name_space
                        self.bandwidth_units.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-role-standby"):
                        self.is_role_standby = value
                        self.is_role_standby.value_namespace = name_space
                        self.is_role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "selected-tunnels"):
                        self.selected_tunnels = value
                        self.selected_tunnels.value_namespace = name_space
                        self.selected_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-p2mp-tunnels"):
                        self.total_p2mp_tunnels = value
                        self.total_p2mp_tunnels.value_namespace = name_space
                        self.total_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "total-tunnels"):
                        self.total_tunnels = value
                        self.total_tunnels.value_namespace = name_space
                        self.total_tunnels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link_interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link_interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "link-interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link-interface"):
                    for c in self.link_interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link_interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link-interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.admitted_tunnels is not None and self.admitted_tunnels.has_data()) or
                (self.global_ is not None and self.global_.has_data()) or
                (self.link_interfaces is not None and self.link_interfaces.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.admitted_tunnels is not None and self.admitted_tunnels.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.link_interfaces is not None and self.link_interfaces.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "admission-control" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "admitted-tunnels"):
                if (self.admitted_tunnels is None):
                    self.admitted_tunnels = MplsLcac.AdmissionControl.AdmittedTunnels()
                    self.admitted_tunnels.parent = self
                    self._children_name_map["admitted_tunnels"] = "admitted-tunnels"
                return self.admitted_tunnels

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsLcac.AdmissionControl.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "link-interfaces"):
                if (self.link_interfaces is None):
                    self.link_interfaces = MplsLcac.AdmissionControl.LinkInterfaces()
                    self.link_interfaces.parent = self
                    self._children_name_map["link_interfaces"] = "link-interfaces"
                return self.link_interfaces

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "admitted-tunnels" or name == "global" or name == "link-interfaces"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SoftPreemptionGlobalInfo(Entity):
        """
        The global soft\-preemption information
        
        .. attribute:: is_configured
        
        	Is global soft\-preemption configured
        	**type**\:  bool
        
        .. attribute:: is_timeout_interval_configured
        
        	Is global soft\-preemption timeout interval configured
        	**type**\:  bool
        
        .. attribute:: timeout_interval
        
        	Global soft\-preemption timeout interval
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.SoftPreemptionGlobalInfo, self).__init__()

            self.yang_name = "soft-preemption-global-info"
            self.yang_parent_name = "mpls-lcac"

            self.is_configured = YLeaf(YType.boolean, "is-configured")

            self.is_timeout_interval_configured = YLeaf(YType.boolean, "is-timeout-interval-configured")

            self.timeout_interval = YLeaf(YType.uint32, "timeout-interval")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("is_configured",
                            "is_timeout_interval_configured",
                            "timeout_interval") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.SoftPreemptionGlobalInfo, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.SoftPreemptionGlobalInfo, self).__setattr__(name, value)

        def has_data(self):
            return (
                self.is_configured.is_set or
                self.is_timeout_interval_configured.is_set or
                self.timeout_interval.is_set)

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.is_configured.yfilter != YFilter.not_set or
                self.is_timeout_interval_configured.yfilter != YFilter.not_set or
                self.timeout_interval.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemption-global-info" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_configured.get_name_leafdata())
            if (self.is_timeout_interval_configured.is_set or self.is_timeout_interval_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_timeout_interval_configured.get_name_leafdata())
            if (self.timeout_interval.is_set or self.timeout_interval.yfilter != YFilter.not_set):
                leaf_name_data.append(self.timeout_interval.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "is-configured" or name == "is-timeout-interval-configured" or name == "timeout-interval"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "is-configured"):
                self.is_configured = value
                self.is_configured.value_namespace = name_space
                self.is_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "is-timeout-interval-configured"):
                self.is_timeout_interval_configured = value
                self.is_timeout_interval_configured.value_namespace = name_space
                self.is_timeout_interval_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "timeout-interval"):
                self.timeout_interval = value
                self.timeout_interval.value_namespace = name_space
                self.timeout_interval.value_namespace_prefix = name_space_prefix


    class SoftPreemptions(Entity):
        """
        The soft preemption information for the TE\-links
        
        .. attribute:: soft_preemption
        
        	The soft preemption info for a TE\-link
        	**type**\: list of    :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions.SoftPreemption>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLcac.SoftPreemptions, self).__init__()

            self.yang_name = "soft-preemptions"
            self.yang_parent_name = "mpls-lcac"

            self.soft_preemption = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLcac.SoftPreemptions, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLcac.SoftPreemptions, self).__setattr__(name, value)


        class SoftPreemption(Entity):
            """
            The soft preemption info for a TE\-link
            
            .. attribute:: interface_name  <key>
            
            	Interface name
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: current_over_subscribed_bandwidth_bc0
            
            	The BC0 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC0 BW on the link and the sum of the currently reserved BC0 bandwidth and the currently soft preempted BC0 BW
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_over_subscribed_bandwidth_bc1
            
            	The BC1 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC1 BW on the link and the sum of the currently reserved BC1 bandwidth and the currently soft preempted BC1 BW
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preempted_bandwidth_bc0
            
            	The current BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preempted_bandwidth_bc1
            
            	The current BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: current_soft_preemption_lsp
            
            	List of the soft preempted LSPs that are not yet cleaned up
            	**type**\: list of    :py:class:`CurrentSoftPreemptionLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp>`
            
            .. attribute:: link_address
            
            	The link's IPv4 address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: release_soft_preempted_bandwidth_bc0
            
            	The total released BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: release_soft_preempted_bandwidth_bc1
            
            	The total released BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_soft_preempted_bandwidth_bc0
            
            	The total BC0 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_soft_preempted_bandwidth_bc1
            
            	The total BC1 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLcac.SoftPreemptions.SoftPreemption, self).__init__()

                self.yang_name = "soft-preemption"
                self.yang_parent_name = "soft-preemptions"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.current_over_subscribed_bandwidth_bc0 = YLeaf(YType.uint64, "current-over-subscribed-bandwidth-bc0")

                self.current_over_subscribed_bandwidth_bc1 = YLeaf(YType.uint64, "current-over-subscribed-bandwidth-bc1")

                self.current_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "current-soft-preempted-bandwidth-bc0")

                self.current_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "current-soft-preempted-bandwidth-bc1")

                self.link_address = YLeaf(YType.str, "link-address")

                self.release_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "release-soft-preempted-bandwidth-bc0")

                self.release_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "release-soft-preempted-bandwidth-bc1")

                self.total_soft_preempted_bandwidth_bc0 = YLeaf(YType.uint64, "total-soft-preempted-bandwidth-bc0")

                self.total_soft_preempted_bandwidth_bc1 = YLeaf(YType.uint64, "total-soft-preempted-bandwidth-bc1")

                self.current_soft_preemption_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name",
                                "current_over_subscribed_bandwidth_bc0",
                                "current_over_subscribed_bandwidth_bc1",
                                "current_soft_preempted_bandwidth_bc0",
                                "current_soft_preempted_bandwidth_bc1",
                                "link_address",
                                "release_soft_preempted_bandwidth_bc0",
                                "release_soft_preempted_bandwidth_bc1",
                                "total_soft_preempted_bandwidth_bc0",
                                "total_soft_preempted_bandwidth_bc1") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLcac.SoftPreemptions.SoftPreemption, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLcac.SoftPreemptions.SoftPreemption, self).__setattr__(name, value)


            class CurrentSoftPreemptionLsp(Entity):
                """
                List of the soft preempted LSPs that are not yet
                cleaned up
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\:  bool
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\:  bool
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\:  int
                
                	**range:** 0..65535
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__init__()

                    self.yang_name = "current-soft-preemption-lsp"
                    self.yang_parent_name = "soft-preemption"

                    self.bandwidth_preempted = YLeaf(YType.boolean, "bandwidth-preempted")

                    self.bandwidth_type = YLeaf(YType.uint8, "bandwidth-type")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.soft_preempted = YLeaf(YType.boolean, "soft-preempted")

                    self.soft_preempted_fr_rrewrite = YLeaf(YType.boolean, "soft-preempted-fr-rrewrite")

                    self.soft_preemption_timeout = YLeaf(YType.uint16, "soft-preemption-timeout")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bandwidth_preempted",
                                    "bandwidth_type",
                                    "destination_address",
                                    "hold_priority",
                                    "lsp_id",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "soft_preempted",
                                    "soft_preempted_fr_rrewrite",
                                    "soft_preemption_timeout",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.bandwidth_preempted.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address.is_set or
                        self.hold_priority.is_set or
                        self.lsp_id.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.soft_preempted.is_set or
                        self.soft_preempted_fr_rrewrite.is_set or
                        self.soft_preemption_timeout.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bandwidth_preempted.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.soft_preempted.yfilter != YFilter.not_set or
                        self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set or
                        self.soft_preemption_timeout.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "current-soft-preemption-lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bandwidth_preempted.is_set or self.bandwidth_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_preempted.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.soft_preempted.is_set or self.soft_preempted.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted.get_name_leafdata())
                    if (self.soft_preempted_fr_rrewrite.is_set or self.soft_preempted_fr_rrewrite.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_fr_rrewrite.get_name_leafdata())
                    if (self.soft_preemption_timeout.is_set or self.soft_preemption_timeout.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption_timeout.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bandwidth-preempted" or name == "bandwidth-type" or name == "destination-address" or name == "hold-priority" or name == "lsp-id" or name == "requested-bandwidth" or name == "setup-priority" or name == "soft-preempted" or name == "soft-preempted-fr-rrewrite" or name == "soft-preemption-timeout" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bandwidth-preempted"):
                        self.bandwidth_preempted = value
                        self.bandwidth_preempted.value_namespace = name_space
                        self.bandwidth_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted"):
                        self.soft_preempted = value
                        self.soft_preempted.value_namespace = name_space
                        self.soft_preempted.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-fr-rrewrite"):
                        self.soft_preempted_fr_rrewrite = value
                        self.soft_preempted_fr_rrewrite.value_namespace = name_space
                        self.soft_preempted_fr_rrewrite.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption-timeout"):
                        self.soft_preemption_timeout = value
                        self.soft_preemption_timeout.value_namespace = name_space
                        self.soft_preemption_timeout.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.current_soft_preemption_lsp:
                    if (c.has_data()):
                        return True
                return (
                    self.interface_name.is_set or
                    self.current_over_subscribed_bandwidth_bc0.is_set or
                    self.current_over_subscribed_bandwidth_bc1.is_set or
                    self.current_soft_preempted_bandwidth_bc0.is_set or
                    self.current_soft_preempted_bandwidth_bc1.is_set or
                    self.link_address.is_set or
                    self.release_soft_preempted_bandwidth_bc0.is_set or
                    self.release_soft_preempted_bandwidth_bc1.is_set or
                    self.total_soft_preempted_bandwidth_bc0.is_set or
                    self.total_soft_preempted_bandwidth_bc1.is_set)

            def has_operation(self):
                for c in self.current_soft_preemption_lsp:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    self.current_over_subscribed_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.current_over_subscribed_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.current_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.current_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.link_address.yfilter != YFilter.not_set or
                    self.release_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.release_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set or
                    self.total_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set or
                    self.total_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "soft-preemption" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/soft-preemptions/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                if (self.current_over_subscribed_bandwidth_bc0.is_set or self.current_over_subscribed_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_over_subscribed_bandwidth_bc0.get_name_leafdata())
                if (self.current_over_subscribed_bandwidth_bc1.is_set or self.current_over_subscribed_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_over_subscribed_bandwidth_bc1.get_name_leafdata())
                if (self.current_soft_preempted_bandwidth_bc0.is_set or self.current_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.current_soft_preempted_bandwidth_bc1.is_set or self.current_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.current_soft_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_address.get_name_leafdata())
                if (self.release_soft_preempted_bandwidth_bc0.is_set or self.release_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.release_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.release_soft_preempted_bandwidth_bc1.is_set or self.release_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.release_soft_preempted_bandwidth_bc1.get_name_leafdata())
                if (self.total_soft_preempted_bandwidth_bc0.is_set or self.total_soft_preempted_bandwidth_bc0.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_soft_preempted_bandwidth_bc0.get_name_leafdata())
                if (self.total_soft_preempted_bandwidth_bc1.is_set or self.total_soft_preempted_bandwidth_bc1.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_soft_preempted_bandwidth_bc1.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "current-soft-preemption-lsp"):
                    for c in self.current_soft_preemption_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.current_soft_preemption_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "current-soft-preemption-lsp" or name == "interface-name" or name == "current-over-subscribed-bandwidth-bc0" or name == "current-over-subscribed-bandwidth-bc1" or name == "current-soft-preempted-bandwidth-bc0" or name == "current-soft-preempted-bandwidth-bc1" or name == "link-address" or name == "release-soft-preempted-bandwidth-bc0" or name == "release-soft-preempted-bandwidth-bc1" or name == "total-soft-preempted-bandwidth-bc0" or name == "total-soft-preempted-bandwidth-bc1"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix
                if(value_path == "current-over-subscribed-bandwidth-bc0"):
                    self.current_over_subscribed_bandwidth_bc0 = value
                    self.current_over_subscribed_bandwidth_bc0.value_namespace = name_space
                    self.current_over_subscribed_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "current-over-subscribed-bandwidth-bc1"):
                    self.current_over_subscribed_bandwidth_bc1 = value
                    self.current_over_subscribed_bandwidth_bc1.value_namespace = name_space
                    self.current_over_subscribed_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "current-soft-preempted-bandwidth-bc0"):
                    self.current_soft_preempted_bandwidth_bc0 = value
                    self.current_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.current_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "current-soft-preempted-bandwidth-bc1"):
                    self.current_soft_preempted_bandwidth_bc1 = value
                    self.current_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.current_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "link-address"):
                    self.link_address = value
                    self.link_address.value_namespace = name_space
                    self.link_address.value_namespace_prefix = name_space_prefix
                if(value_path == "release-soft-preempted-bandwidth-bc0"):
                    self.release_soft_preempted_bandwidth_bc0 = value
                    self.release_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.release_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "release-soft-preempted-bandwidth-bc1"):
                    self.release_soft_preempted_bandwidth_bc1 = value
                    self.release_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.release_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix
                if(value_path == "total-soft-preempted-bandwidth-bc0"):
                    self.total_soft_preempted_bandwidth_bc0 = value
                    self.total_soft_preempted_bandwidth_bc0.value_namespace = name_space
                    self.total_soft_preempted_bandwidth_bc0.value_namespace_prefix = name_space_prefix
                if(value_path == "total-soft-preempted-bandwidth-bc1"):
                    self.total_soft_preempted_bandwidth_bc1 = value
                    self.total_soft_preempted_bandwidth_bc1.value_namespace = name_space
                    self.total_soft_preempted_bandwidth_bc1.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.soft_preemption:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.soft_preemption:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemptions" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "soft-preemption"):
                for c in self.soft_preemption:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLcac.SoftPreemptions.SoftPreemption()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.soft_preemption.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "soft-preemption"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.admission_control is not None and self.admission_control.has_data()) or
            (self.advertisements is not None and self.advertisements.has_data()) or
            (self.bandwidth_account is not None and self.bandwidth_account.has_data()) or
            (self.bandwidth_allocation is not None and self.bandwidth_allocation.has_data()) or
            (self.bfd_neighbors is not None and self.bfd_neighbors.has_data()) or
            (self.gmpls is not None and self.gmpls.has_data()) or
            (self.link_information is not None and self.link_information.has_data()) or
            (self.link_summary is not None and self.link_summary.has_data()) or
            (self.neighbors is not None and self.neighbors.has_data()) or
            (self.preemption_events is not None and self.preemption_events.has_data()) or
            (self.soft_preemption_global_info is not None and self.soft_preemption_global_info.has_data()) or
            (self.soft_preemptions is not None and self.soft_preemptions.has_data()) or
            (self.statistics is not None and self.statistics.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.admission_control is not None and self.admission_control.has_operation()) or
            (self.advertisements is not None and self.advertisements.has_operation()) or
            (self.bandwidth_account is not None and self.bandwidth_account.has_operation()) or
            (self.bandwidth_allocation is not None and self.bandwidth_allocation.has_operation()) or
            (self.bfd_neighbors is not None and self.bfd_neighbors.has_operation()) or
            (self.gmpls is not None and self.gmpls.has_operation()) or
            (self.link_information is not None and self.link_information.has_operation()) or
            (self.link_summary is not None and self.link_summary.has_operation()) or
            (self.neighbors is not None and self.neighbors.has_operation()) or
            (self.preemption_events is not None and self.preemption_events.has_operation()) or
            (self.soft_preemption_global_info is not None and self.soft_preemption_global_info.has_operation()) or
            (self.soft_preemptions is not None and self.soft_preemptions.has_operation()) or
            (self.statistics is not None and self.statistics.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-lcac" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "admission-control"):
            if (self.admission_control is None):
                self.admission_control = MplsLcac.AdmissionControl()
                self.admission_control.parent = self
                self._children_name_map["admission_control"] = "admission-control"
            return self.admission_control

        if (child_yang_name == "advertisements"):
            if (self.advertisements is None):
                self.advertisements = MplsLcac.Advertisements()
                self.advertisements.parent = self
                self._children_name_map["advertisements"] = "advertisements"
            return self.advertisements

        if (child_yang_name == "bandwidth-account"):
            if (self.bandwidth_account is None):
                self.bandwidth_account = MplsLcac.BandwidthAccount()
                self.bandwidth_account.parent = self
                self._children_name_map["bandwidth_account"] = "bandwidth-account"
            return self.bandwidth_account

        if (child_yang_name == "bandwidth-allocation"):
            if (self.bandwidth_allocation is None):
                self.bandwidth_allocation = MplsLcac.BandwidthAllocation()
                self.bandwidth_allocation.parent = self
                self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"
            return self.bandwidth_allocation

        if (child_yang_name == "bfd-neighbors"):
            if (self.bfd_neighbors is None):
                self.bfd_neighbors = MplsLcac.BfdNeighbors()
                self.bfd_neighbors.parent = self
                self._children_name_map["bfd_neighbors"] = "bfd-neighbors"
            return self.bfd_neighbors

        if (child_yang_name == "gmpls"):
            if (self.gmpls is None):
                self.gmpls = MplsLcac.Gmpls()
                self.gmpls.parent = self
                self._children_name_map["gmpls"] = "gmpls"
            return self.gmpls

        if (child_yang_name == "link-information"):
            if (self.link_information is None):
                self.link_information = MplsLcac.LinkInformation()
                self.link_information.parent = self
                self._children_name_map["link_information"] = "link-information"
            return self.link_information

        if (child_yang_name == "link-summary"):
            if (self.link_summary is None):
                self.link_summary = MplsLcac.LinkSummary()
                self.link_summary.parent = self
                self._children_name_map["link_summary"] = "link-summary"
            return self.link_summary

        if (child_yang_name == "neighbors"):
            if (self.neighbors is None):
                self.neighbors = MplsLcac.Neighbors()
                self.neighbors.parent = self
                self._children_name_map["neighbors"] = "neighbors"
            return self.neighbors

        if (child_yang_name == "preemption-events"):
            if (self.preemption_events is None):
                self.preemption_events = MplsLcac.PreemptionEvents()
                self.preemption_events.parent = self
                self._children_name_map["preemption_events"] = "preemption-events"
            return self.preemption_events

        if (child_yang_name == "soft-preemption-global-info"):
            if (self.soft_preemption_global_info is None):
                self.soft_preemption_global_info = MplsLcac.SoftPreemptionGlobalInfo()
                self.soft_preemption_global_info.parent = self
                self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"
            return self.soft_preemption_global_info

        if (child_yang_name == "soft-preemptions"):
            if (self.soft_preemptions is None):
                self.soft_preemptions = MplsLcac.SoftPreemptions()
                self.soft_preemptions.parent = self
                self._children_name_map["soft_preemptions"] = "soft-preemptions"
            return self.soft_preemptions

        if (child_yang_name == "statistics"):
            if (self.statistics is None):
                self.statistics = MplsLcac.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
            return self.statistics

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "admission-control" or name == "advertisements" or name == "bandwidth-account" or name == "bandwidth-allocation" or name == "bfd-neighbors" or name == "gmpls" or name == "link-information" or name == "link-summary" or name == "neighbors" or name == "preemption-events" or name == "soft-preemption-global-info" or name == "soft-preemptions" or name == "statistics"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsLcac()
        return self._top_entity

class MplsPce(Entity):
    """
    mpls pce
    
    .. attribute:: lsps
    
    	Table of LSPs
    	**type**\:   :py:class:`Lsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps>`
    
    .. attribute:: peers
    
    	The set of PCE peers
    	**type**\:   :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers>`
    
    .. attribute:: statistics
    
    	PCE stats info
    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics>`
    
    .. attribute:: topology
    
    	The topology information in PCE
    	**type**\:   :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology>`
    
    .. attribute:: tunnels
    
    	Table of PCE tunnels
    	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Tunnels>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsPce, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-pce"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.lsps = MplsPce.Lsps()
        self.lsps.parent = self
        self._children_name_map["lsps"] = "lsps"
        self._children_yang_names.add("lsps")

        self.peers = MplsPce.Peers()
        self.peers.parent = self
        self._children_name_map["peers"] = "peers"
        self._children_yang_names.add("peers")

        self.statistics = MplsPce.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"
        self._children_yang_names.add("statistics")

        self.topology = MplsPce.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"
        self._children_yang_names.add("topology")

        self.tunnels = MplsPce.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._children_yang_names.add("tunnels")


    class Lsps(Entity):
        """
        Table of LSPs
        
        .. attribute:: administrative
        
        	LSP administrative status
        	**type**\:  bool
        
        .. attribute:: autoroute
        
        	Auto Route
        	**type**\:   :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Autoroute>`
        
        .. attribute:: backup_path
        
        	Backup Path
        	**type**\:  list of str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: binding_sid
        
        	Binding SID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: cleanup_timer_exp
        
        	Deprecated
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: create
        
        	LSPO create flag
        	**type**\:  bool
        
        .. attribute:: creator
        
        	Creator Peer of the LSP
        	**type**\:   :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Creator>`
        
        .. attribute:: delegatable
        
        	LSP delegatable
        	**type**\:  bool
        
        .. attribute:: delegated
        
        	Owner Peer of the LSP
        	**type**\:   :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Delegated>`
        
        .. attribute:: delegation_timer_exp
        
        	LSP delegation timer expiration in sec
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: destination_address
        
        	Destination IP Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: forward_class_id
        
        	Forward Class ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: identifiers
        
        	LSP Identifiers
        	**type**\:   :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Identifiers>`
        
        .. attribute:: load_share
        
        	Load share factor
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: lsp
        
        	Information of a LSP from LSPDB
        	**type**\: list of    :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp>`
        
        .. attribute:: lspo_is_used
        
        	LSP Object used flag
        	**type**\:  bool
        
        .. attribute:: operational
        
        	LSP operational status
        	**type**\:   :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
        
        .. attribute:: path_setup_type
        
        	Path setup type
        	**type**\:  int
        
        	**range:** 0..255
        
        .. attribute:: paths
        
        	Array of paths
        	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths>`
        
        .. attribute:: request_queue_size
        
        	Request queue size
        	**type**\:  int
        
        	**range:** 0..255
        
        .. attribute:: session_internal_lsp_id
        
        	Session internal ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: source_address
        
        	Source IP Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: state_timer_exp
        
        	LSP state\-timeout time expiration
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: stateful_request_parameter_id
        
        	SRP ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: symbolic_name_xr
        
        	Symbolic Name
        	**type**\:  str
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPce.Lsps, self).__init__()

            self.yang_name = "lsps"
            self.yang_parent_name = "mpls-pce"

            self.administrative = YLeaf(YType.boolean, "administrative")

            self.backup_path = YLeafList(YType.str, "backup-path")

            self.binding_sid = YLeaf(YType.uint32, "binding-sid")

            self.cleanup_timer_exp = YLeaf(YType.int32, "cleanup-timer-exp")

            self.create = YLeaf(YType.boolean, "create")

            self.delegatable = YLeaf(YType.boolean, "delegatable")

            self.delegation_timer_exp = YLeaf(YType.int32, "delegation-timer-exp")

            self.destination_address = YLeaf(YType.str, "destination-address")

            self.forward_class_id = YLeaf(YType.uint32, "forward-class-id")

            self.load_share = YLeaf(YType.uint32, "load-share")

            self.lspo_is_used = YLeaf(YType.boolean, "lspo-is-used")

            self.operational = YLeaf(YType.enumeration, "operational")

            self.path_setup_type = YLeaf(YType.uint8, "path-setup-type")

            self.request_queue_size = YLeaf(YType.uint8, "request-queue-size")

            self.session_internal_lsp_id = YLeaf(YType.uint32, "session-internal-lsp-id")

            self.source_address = YLeaf(YType.str, "source-address")

            self.state_timer_exp = YLeaf(YType.int32, "state-timer-exp")

            self.stateful_request_parameter_id = YLeaf(YType.uint32, "stateful-request-parameter-id")

            self.symbolic_name_xr = YLeaf(YType.str, "symbolic-name-xr")

            self.autoroute = MplsPce.Lsps.Autoroute()
            self.autoroute.parent = self
            self._children_name_map["autoroute"] = "autoroute"
            self._children_yang_names.add("autoroute")

            self.creator = MplsPce.Lsps.Creator()
            self.creator.parent = self
            self._children_name_map["creator"] = "creator"
            self._children_yang_names.add("creator")

            self.delegated = MplsPce.Lsps.Delegated()
            self.delegated.parent = self
            self._children_name_map["delegated"] = "delegated"
            self._children_yang_names.add("delegated")

            self.identifiers = MplsPce.Lsps.Identifiers()
            self.identifiers.parent = self
            self._children_name_map["identifiers"] = "identifiers"
            self._children_yang_names.add("identifiers")

            self.lsp = YList(self)
            self.paths = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("administrative",
                            "backup_path",
                            "binding_sid",
                            "cleanup_timer_exp",
                            "create",
                            "delegatable",
                            "delegation_timer_exp",
                            "destination_address",
                            "forward_class_id",
                            "load_share",
                            "lspo_is_used",
                            "operational",
                            "path_setup_type",
                            "request_queue_size",
                            "session_internal_lsp_id",
                            "source_address",
                            "state_timer_exp",
                            "stateful_request_parameter_id",
                            "symbolic_name_xr") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPce.Lsps, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPce.Lsps, self).__setattr__(name, value)


        class Lsp(Entity):
            """
            Information of a LSP from LSPDB
            
            .. attribute:: symbolic_name  <key>
            
            	Symbolic name
            	**type**\:  str
            
            	**length:** 1..256
            
            .. attribute:: administrative
            
            	LSP administrative status
            	**type**\:  bool
            
            .. attribute:: autoroute
            
            	Auto Route
            	**type**\:   :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Autoroute>`
            
            .. attribute:: backup_path
            
            	Backup Path
            	**type**\:  list of str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: binding_sid
            
            	Binding SID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: cleanup_timer_exp
            
            	Deprecated
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: create
            
            	LSPO create flag
            	**type**\:  bool
            
            .. attribute:: creator
            
            	Creator Peer of the LSP
            	**type**\:   :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Creator>`
            
            .. attribute:: delegatable
            
            	LSP delegatable
            	**type**\:  bool
            
            .. attribute:: delegated
            
            	Owner Peer of the LSP
            	**type**\:   :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Delegated>`
            
            .. attribute:: delegation_timer_exp
            
            	LSP delegation timer expiration in sec
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: destination_address
            
            	Destination IP Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: forward_class_id
            
            	Forward Class ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: identifiers
            
            	LSP Identifiers
            	**type**\:   :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Identifiers>`
            
            .. attribute:: load_share
            
            	Load share factor
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: lspo_is_used
            
            	LSP Object used flag
            	**type**\:  bool
            
            .. attribute:: operational
            
            	LSP operational status
            	**type**\:   :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
            
            .. attribute:: path_setup_type
            
            	Path setup type
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: paths
            
            	Array of paths
            	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths>`
            
            .. attribute:: request_queue_size
            
            	Request queue size
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: session_internal_lsp_id
            
            	Session internal ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: source_address
            
            	Source IP Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: state_timer_exp
            
            	LSP state\-timeout time expiration
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: stateful_request_parameter_id
            
            	SRP ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: symbolic_name_xr
            
            	Symbolic Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Lsp, self).__init__()

                self.yang_name = "lsp"
                self.yang_parent_name = "lsps"

                self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                self.administrative = YLeaf(YType.boolean, "administrative")

                self.backup_path = YLeafList(YType.str, "backup-path")

                self.binding_sid = YLeaf(YType.uint32, "binding-sid")

                self.cleanup_timer_exp = YLeaf(YType.int32, "cleanup-timer-exp")

                self.create = YLeaf(YType.boolean, "create")

                self.delegatable = YLeaf(YType.boolean, "delegatable")

                self.delegation_timer_exp = YLeaf(YType.int32, "delegation-timer-exp")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.forward_class_id = YLeaf(YType.uint32, "forward-class-id")

                self.load_share = YLeaf(YType.uint32, "load-share")

                self.lspo_is_used = YLeaf(YType.boolean, "lspo-is-used")

                self.operational = YLeaf(YType.enumeration, "operational")

                self.path_setup_type = YLeaf(YType.uint8, "path-setup-type")

                self.request_queue_size = YLeaf(YType.uint8, "request-queue-size")

                self.session_internal_lsp_id = YLeaf(YType.uint32, "session-internal-lsp-id")

                self.source_address = YLeaf(YType.str, "source-address")

                self.state_timer_exp = YLeaf(YType.int32, "state-timer-exp")

                self.stateful_request_parameter_id = YLeaf(YType.uint32, "stateful-request-parameter-id")

                self.symbolic_name_xr = YLeaf(YType.str, "symbolic-name-xr")

                self.autoroute = MplsPce.Lsps.Lsp.Autoroute()
                self.autoroute.parent = self
                self._children_name_map["autoroute"] = "autoroute"
                self._children_yang_names.add("autoroute")

                self.creator = MplsPce.Lsps.Lsp.Creator()
                self.creator.parent = self
                self._children_name_map["creator"] = "creator"
                self._children_yang_names.add("creator")

                self.delegated = MplsPce.Lsps.Lsp.Delegated()
                self.delegated.parent = self
                self._children_name_map["delegated"] = "delegated"
                self._children_yang_names.add("delegated")

                self.identifiers = MplsPce.Lsps.Lsp.Identifiers()
                self.identifiers.parent = self
                self._children_name_map["identifiers"] = "identifiers"
                self._children_yang_names.add("identifiers")

                self.paths = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("symbolic_name",
                                "administrative",
                                "backup_path",
                                "binding_sid",
                                "cleanup_timer_exp",
                                "create",
                                "delegatable",
                                "delegation_timer_exp",
                                "destination_address",
                                "forward_class_id",
                                "load_share",
                                "lspo_is_used",
                                "operational",
                                "path_setup_type",
                                "request_queue_size",
                                "session_internal_lsp_id",
                                "source_address",
                                "state_timer_exp",
                                "stateful_request_parameter_id",
                                "symbolic_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Lsp, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Lsp, self).__setattr__(name, value)


            class Creator(Entity):
                """
                Creator Peer of the LSP
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Lsp.Creator, self).__init__()

                    self.yang_name = "creator"
                    self.yang_parent_name = "lsp"

                    self.address = YLeaf(YType.str, "address")

                    self.node_identifier = YLeaf(YType.str, "node-identifier")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "node_identifier") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Lsp.Creator, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Lsp.Creator, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.address.is_set or
                        self.node_identifier.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.node_identifier.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "creator" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address.get_name_leafdata())
                    if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_identifier.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "address" or name == "node-identifier"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address = value
                        self.address.value_namespace = name_space
                        self.address.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-identifier"):
                        self.node_identifier = value
                        self.node_identifier.value_namespace = name_space
                        self.node_identifier.value_namespace_prefix = name_space_prefix


            class Delegated(Entity):
                """
                Owner Peer of the LSP
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Lsp.Delegated, self).__init__()

                    self.yang_name = "delegated"
                    self.yang_parent_name = "lsp"

                    self.address = YLeaf(YType.str, "address")

                    self.node_identifier = YLeaf(YType.str, "node-identifier")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "node_identifier") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Lsp.Delegated, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Lsp.Delegated, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.address.is_set or
                        self.node_identifier.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.node_identifier.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "delegated" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address.get_name_leafdata())
                    if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_identifier.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "address" or name == "node-identifier"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address = value
                        self.address.value_namespace = name_space
                        self.address.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-identifier"):
                        self.node_identifier = value
                        self.node_identifier.value_namespace = name_space
                        self.node_identifier.value_namespace_prefix = name_space_prefix


            class Identifiers(Entity):
                """
                LSP Identifiers
                
                .. attribute:: ext_tunnel_id
                
                	External Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	LSP Identifier used flag
                	**type**\:  bool
                
                .. attribute:: sender
                
                	Sender Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: te_lsp_id
                
                	TE LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_id
                
                	LSPO Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Lsp.Identifiers, self).__init__()

                    self.yang_name = "identifiers"
                    self.yang_parent_name = "lsp"

                    self.ext_tunnel_id = YLeaf(YType.uint32, "ext-tunnel-id")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.sender = YLeaf(YType.str, "sender")

                    self.te_lsp_id = YLeaf(YType.uint16, "te-lsp-id")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ext_tunnel_id",
                                    "is_used",
                                    "sender",
                                    "te_lsp_id",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Lsp.Identifiers, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Lsp.Identifiers, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.ext_tunnel_id.is_set or
                        self.is_used.is_set or
                        self.sender.is_set or
                        self.te_lsp_id.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ext_tunnel_id.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.sender.yfilter != YFilter.not_set or
                        self.te_lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "identifiers" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ext_tunnel_id.is_set or self.ext_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ext_tunnel_id.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.sender.is_set or self.sender.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sender.get_name_leafdata())
                    if (self.te_lsp_id.is_set or self.te_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ext-tunnel-id" or name == "is-used" or name == "sender" or name == "te-lsp-id" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ext-tunnel-id"):
                        self.ext_tunnel_id = value
                        self.ext_tunnel_id.value_namespace = name_space
                        self.ext_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "sender"):
                        self.sender = value
                        self.sender.value_namespace = name_space
                        self.sender.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-lsp-id"):
                        self.te_lsp_id = value
                        self.te_lsp_id.value_namespace = name_space
                        self.te_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix


            class Autoroute(Entity):
                """
                Auto Route
                
                .. attribute:: announced
                
                	Autoroute announced
                	**type**\:  bool
                
                .. attribute:: destination
                
                	Destinations
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_used
                
                	Autoroute used flag
                	**type**\:  bool
                
                .. attribute:: metric
                
                	Metric Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:   :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Lsp.Autoroute, self).__init__()

                    self.yang_name = "autoroute"
                    self.yang_parent_name = "lsp"

                    self.announced = YLeaf(YType.boolean, "announced")

                    self.destination = YLeafList(YType.str, "destination")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.metric = YLeaf(YType.uint32, "metric")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("announced",
                                    "destination",
                                    "is_used",
                                    "metric",
                                    "metric_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Lsp.Autoroute, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Lsp.Autoroute, self).__setattr__(name, value)

                def has_data(self):
                    for leaf in self.destination.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.announced.is_set or
                        self.is_used.is_set or
                        self.metric.is_set or
                        self.metric_type.is_set)

                def has_operation(self):
                    for leaf in self.destination.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.announced.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.metric.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "autoroute" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.announced.is_set or self.announced.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())

                    leaf_name_data.extend(self.destination.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "announced" or name == "destination" or name == "is-used" or name == "metric" or name == "metric-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "announced"):
                        self.announced = value
                        self.announced.value_namespace = name_space
                        self.announced.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination.append(value)
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric"):
                        self.metric = value
                        self.metric.value_namespace = name_space
                        self.metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix


            class Paths(Entity):
                """
                Array of paths
                
                .. attribute:: applied_bw
                
                	Applied bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bw
                
                	Bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ero
                
                	Explicit Router Object
                	**type**\:   :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Ero>`
                
                .. attribute:: is_applied_bw_used
                
                	Applied bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: is_bw_used
                
                	Bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: is_reopt_bw_used
                
                	Reoptimize bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: lspa
                
                	LSP Attributes Object
                	**type**\:   :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Lspa>`
                
                .. attribute:: metric
                
                	List of Metrics
                	**type**\: list of    :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Metric>`
                
                .. attribute:: reopt_bw
                
                	Reoptimize bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rro
                
                	Reported Route Object
                	**type**\:   :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Rro>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Lsp.Paths, self).__init__()

                    self.yang_name = "paths"
                    self.yang_parent_name = "lsp"

                    self.applied_bw = YLeaf(YType.uint32, "applied-bw")

                    self.bw = YLeaf(YType.uint32, "bw")

                    self.is_applied_bw_used = YLeaf(YType.boolean, "is-applied-bw-used")

                    self.is_bw_used = YLeaf(YType.boolean, "is-bw-used")

                    self.is_reopt_bw_used = YLeaf(YType.boolean, "is-reopt-bw-used")

                    self.reopt_bw = YLeaf(YType.uint32, "reopt-bw")

                    self.ero = MplsPce.Lsps.Lsp.Paths.Ero()
                    self.ero.parent = self
                    self._children_name_map["ero"] = "ero"
                    self._children_yang_names.add("ero")

                    self.lspa = MplsPce.Lsps.Lsp.Paths.Lspa()
                    self.lspa.parent = self
                    self._children_name_map["lspa"] = "lspa"
                    self._children_yang_names.add("lspa")

                    self.rro = MplsPce.Lsps.Lsp.Paths.Rro()
                    self.rro.parent = self
                    self._children_name_map["rro"] = "rro"
                    self._children_yang_names.add("rro")

                    self.metric = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("applied_bw",
                                    "bw",
                                    "is_applied_bw_used",
                                    "is_bw_used",
                                    "is_reopt_bw_used",
                                    "reopt_bw") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Lsp.Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Lsp.Paths, self).__setattr__(name, value)


                class Ero(Entity):
                    """
                    Explicit Router Object
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\:  list of str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\:  bool
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Ero.Subobject>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Lsp.Paths.Ero, self).__init__()

                        self.yang_name = "ero"
                        self.yang_parent_name = "paths"

                        self.address = YLeafList(YType.str, "address")

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.subobject = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address",
                                        "cost",
                                        "is_used") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Lsp.Paths.Ero, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Lsp.Paths.Ero, self).__setattr__(name, value)


                    class Subobject(Entity):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\:  bool
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\:  bool
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\:  bool
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\:  bool
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\:  bool
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\:  bool
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\:  bool
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\:  bool
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsPce.Lsps.Lsp.Paths.Ero.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "ero"

                            self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                            self.global_ = YLeaf(YType.boolean, "global")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                            self.local_address = YLeaf(YType.str, "local-address")

                            self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                            self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                            self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                            self.node_id = YLeaf(YType.str, "node-id")

                            self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                            self.remote_address = YLeaf(YType.str, "remote-address")

                            self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                            self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                            self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                            self.strict = YLeaf(YType.boolean, "strict")

                            self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("complete_mpls_label_entry",
                                            "global_",
                                            "ipv4_address",
                                            "ipv4_prefix_len",
                                            "local_address",
                                            "missing_node_adjcency_id",
                                            "missing_segment_id",
                                            "mpls_label",
                                            "node_adjacency_id_exists",
                                            "node_id",
                                            "only_valid_mpls_label",
                                            "remote_address",
                                            "segment_id_exists",
                                            "segment_id_type",
                                            "segment_id_value",
                                            "strict",
                                            "subobj_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsPce.Lsps.Lsp.Paths.Ero.Subobject, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsPce.Lsps.Lsp.Paths.Ero.Subobject, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.complete_mpls_label_entry.is_set or
                                self.global_.is_set or
                                self.ipv4_address.is_set or
                                self.ipv4_prefix_len.is_set or
                                self.local_address.is_set or
                                self.missing_node_adjcency_id.is_set or
                                self.missing_segment_id.is_set or
                                self.mpls_label.is_set or
                                self.node_adjacency_id_exists.is_set or
                                self.node_id.is_set or
                                self.only_valid_mpls_label.is_set or
                                self.remote_address.is_set or
                                self.segment_id_exists.is_set or
                                self.segment_id_type.is_set or
                                self.segment_id_value.is_set or
                                self.strict.is_set or
                                self.subobj_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                                self.global_.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.ipv4_prefix_len.yfilter != YFilter.not_set or
                                self.local_address.yfilter != YFilter.not_set or
                                self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                                self.missing_segment_id.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set or
                                self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.only_valid_mpls_label.yfilter != YFilter.not_set or
                                self.remote_address.yfilter != YFilter.not_set or
                                self.segment_id_exists.yfilter != YFilter.not_set or
                                self.segment_id_type.yfilter != YFilter.not_set or
                                self.segment_id_value.yfilter != YFilter.not_set or
                                self.strict.yfilter != YFilter.not_set or
                                self.subobj_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subobject" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                            if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_address.get_name_leafdata())
                            if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                            if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())
                            if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                            if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_address.get_name_leafdata())
                            if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                            if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                            if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                            if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.strict.get_name_leafdata())
                            if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.subobj_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "complete-mpls-label-entry"):
                                self.complete_mpls_label_entry = value
                                self.complete_mpls_label_entry.value_namespace = name_space
                                self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                            if(value_path == "global"):
                                self.global_ = value
                                self.global_.value_namespace = name_space
                                self.global_.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-prefix-len"):
                                self.ipv4_prefix_len = value
                                self.ipv4_prefix_len.value_namespace = name_space
                                self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-address"):
                                self.local_address = value
                                self.local_address.value_namespace = name_space
                                self.local_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-node-adjcency-id"):
                                self.missing_node_adjcency_id = value
                                self.missing_node_adjcency_id.value_namespace = name_space
                                self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-segment-id"):
                                self.missing_segment_id = value
                                self.missing_segment_id.value_namespace = name_space
                                self.missing_segment_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-adjacency-id-exists"):
                                self.node_adjacency_id_exists = value
                                self.node_adjacency_id_exists.value_namespace = name_space
                                self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "only-valid-mpls-label"):
                                self.only_valid_mpls_label = value
                                self.only_valid_mpls_label.value_namespace = name_space
                                self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-address"):
                                self.remote_address = value
                                self.remote_address.value_namespace = name_space
                                self.remote_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-exists"):
                                self.segment_id_exists = value
                                self.segment_id_exists.value_namespace = name_space
                                self.segment_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-type"):
                                self.segment_id_type = value
                                self.segment_id_type.value_namespace = name_space
                                self.segment_id_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-value"):
                                self.segment_id_value = value
                                self.segment_id_value.value_namespace = name_space
                                self.segment_id_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "strict"):
                                self.strict = value
                                self.strict.value_namespace = name_space
                                self.strict.value_namespace_prefix = name_space_prefix
                            if(value_path == "subobj-type"):
                                self.subobj_type = value
                                self.subobj_type.value_namespace = name_space
                                self.subobj_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.subobject:
                            if (c.has_data()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        return (
                            self.cost.is_set or
                            self.is_used.is_set)

                    def has_operation(self):
                        for c in self.subobject:
                            if (c.has_operation()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.is_set):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ero" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())

                        leaf_name_data.extend(self.address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "subobject"):
                            for c in self.subobject:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsPce.Lsps.Lsp.Paths.Ero.Subobject()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.subobject.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address"):
                            self.address.append(value)
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix


                class Lspa(Entity):
                    """
                    LSP Attributes Object
                    
                    .. attribute:: exlude_any
                    
                    	Exclude Any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold
                    
                    	Hold
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: include_all
                    
                    	Include All
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: include_any
                    
                    	Include Any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	LSPA used flag
                    	**type**\:  bool
                    
                    .. attribute:: lbit
                    
                    	L flag
                    	**type**\:  bool
                    
                    .. attribute:: setup
                    
                    	Setup
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Lsp.Paths.Lspa, self).__init__()

                        self.yang_name = "lspa"
                        self.yang_parent_name = "paths"

                        self.exlude_any = YLeaf(YType.uint32, "exlude-any")

                        self.hold = YLeaf(YType.uint8, "hold")

                        self.include_all = YLeaf(YType.uint32, "include-all")

                        self.include_any = YLeaf(YType.uint32, "include-any")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.lbit = YLeaf(YType.boolean, "lbit")

                        self.setup = YLeaf(YType.uint8, "setup")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("exlude_any",
                                        "hold",
                                        "include_all",
                                        "include_any",
                                        "is_used",
                                        "lbit",
                                        "setup") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Lsp.Paths.Lspa, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Lsp.Paths.Lspa, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.exlude_any.is_set or
                            self.hold.is_set or
                            self.include_all.is_set or
                            self.include_any.is_set or
                            self.is_used.is_set or
                            self.lbit.is_set or
                            self.setup.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.exlude_any.yfilter != YFilter.not_set or
                            self.hold.yfilter != YFilter.not_set or
                            self.include_all.yfilter != YFilter.not_set or
                            self.include_any.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set or
                            self.lbit.yfilter != YFilter.not_set or
                            self.setup.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lspa" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.exlude_any.is_set or self.exlude_any.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.exlude_any.get_name_leafdata())
                        if (self.hold.is_set or self.hold.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold.get_name_leafdata())
                        if (self.include_all.is_set or self.include_all.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.include_all.get_name_leafdata())
                        if (self.include_any.is_set or self.include_any.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.include_any.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())
                        if (self.lbit.is_set or self.lbit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lbit.get_name_leafdata())
                        if (self.setup.is_set or self.setup.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "exlude-any" or name == "hold" or name == "include-all" or name == "include-any" or name == "is-used" or name == "lbit" or name == "setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "exlude-any"):
                            self.exlude_any = value
                            self.exlude_any.value_namespace = name_space
                            self.exlude_any.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold"):
                            self.hold = value
                            self.hold.value_namespace = name_space
                            self.hold.value_namespace_prefix = name_space_prefix
                        if(value_path == "include-all"):
                            self.include_all = value
                            self.include_all.value_namespace = name_space
                            self.include_all.value_namespace_prefix = name_space_prefix
                        if(value_path == "include-any"):
                            self.include_any = value
                            self.include_any.value_namespace = name_space
                            self.include_any.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix
                        if(value_path == "lbit"):
                            self.lbit = value
                            self.lbit.value_namespace = name_space
                            self.lbit.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup"):
                            self.setup = value
                            self.setup.value_namespace = name_space
                            self.setup.value_namespace_prefix = name_space_prefix


                class Rro(Entity):
                    """
                    Reported Route Object
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\:  list of str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\:  bool
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Rro.Subobject>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Lsp.Paths.Rro, self).__init__()

                        self.yang_name = "rro"
                        self.yang_parent_name = "paths"

                        self.address = YLeafList(YType.str, "address")

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.subobject = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address",
                                        "cost",
                                        "is_used") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Lsp.Paths.Rro, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Lsp.Paths.Rro, self).__setattr__(name, value)


                    class Subobject(Entity):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\:  bool
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\:  bool
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\:  bool
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\:  bool
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\:  bool
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\:  bool
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\:  bool
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\:  bool
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsPce.Lsps.Lsp.Paths.Rro.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "rro"

                            self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                            self.global_ = YLeaf(YType.boolean, "global")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                            self.local_address = YLeaf(YType.str, "local-address")

                            self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                            self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                            self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                            self.node_id = YLeaf(YType.str, "node-id")

                            self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                            self.remote_address = YLeaf(YType.str, "remote-address")

                            self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                            self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                            self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                            self.strict = YLeaf(YType.boolean, "strict")

                            self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("complete_mpls_label_entry",
                                            "global_",
                                            "ipv4_address",
                                            "ipv4_prefix_len",
                                            "local_address",
                                            "missing_node_adjcency_id",
                                            "missing_segment_id",
                                            "mpls_label",
                                            "node_adjacency_id_exists",
                                            "node_id",
                                            "only_valid_mpls_label",
                                            "remote_address",
                                            "segment_id_exists",
                                            "segment_id_type",
                                            "segment_id_value",
                                            "strict",
                                            "subobj_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsPce.Lsps.Lsp.Paths.Rro.Subobject, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsPce.Lsps.Lsp.Paths.Rro.Subobject, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.complete_mpls_label_entry.is_set or
                                self.global_.is_set or
                                self.ipv4_address.is_set or
                                self.ipv4_prefix_len.is_set or
                                self.local_address.is_set or
                                self.missing_node_adjcency_id.is_set or
                                self.missing_segment_id.is_set or
                                self.mpls_label.is_set or
                                self.node_adjacency_id_exists.is_set or
                                self.node_id.is_set or
                                self.only_valid_mpls_label.is_set or
                                self.remote_address.is_set or
                                self.segment_id_exists.is_set or
                                self.segment_id_type.is_set or
                                self.segment_id_value.is_set or
                                self.strict.is_set or
                                self.subobj_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                                self.global_.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.ipv4_prefix_len.yfilter != YFilter.not_set or
                                self.local_address.yfilter != YFilter.not_set or
                                self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                                self.missing_segment_id.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set or
                                self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.only_valid_mpls_label.yfilter != YFilter.not_set or
                                self.remote_address.yfilter != YFilter.not_set or
                                self.segment_id_exists.yfilter != YFilter.not_set or
                                self.segment_id_type.yfilter != YFilter.not_set or
                                self.segment_id_value.yfilter != YFilter.not_set or
                                self.strict.yfilter != YFilter.not_set or
                                self.subobj_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subobject" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                            if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_address.get_name_leafdata())
                            if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                            if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())
                            if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                            if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_address.get_name_leafdata())
                            if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                            if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                            if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                            if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.strict.get_name_leafdata())
                            if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.subobj_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "complete-mpls-label-entry"):
                                self.complete_mpls_label_entry = value
                                self.complete_mpls_label_entry.value_namespace = name_space
                                self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                            if(value_path == "global"):
                                self.global_ = value
                                self.global_.value_namespace = name_space
                                self.global_.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-prefix-len"):
                                self.ipv4_prefix_len = value
                                self.ipv4_prefix_len.value_namespace = name_space
                                self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-address"):
                                self.local_address = value
                                self.local_address.value_namespace = name_space
                                self.local_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-node-adjcency-id"):
                                self.missing_node_adjcency_id = value
                                self.missing_node_adjcency_id.value_namespace = name_space
                                self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-segment-id"):
                                self.missing_segment_id = value
                                self.missing_segment_id.value_namespace = name_space
                                self.missing_segment_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-adjacency-id-exists"):
                                self.node_adjacency_id_exists = value
                                self.node_adjacency_id_exists.value_namespace = name_space
                                self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "only-valid-mpls-label"):
                                self.only_valid_mpls_label = value
                                self.only_valid_mpls_label.value_namespace = name_space
                                self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-address"):
                                self.remote_address = value
                                self.remote_address.value_namespace = name_space
                                self.remote_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-exists"):
                                self.segment_id_exists = value
                                self.segment_id_exists.value_namespace = name_space
                                self.segment_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-type"):
                                self.segment_id_type = value
                                self.segment_id_type.value_namespace = name_space
                                self.segment_id_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-value"):
                                self.segment_id_value = value
                                self.segment_id_value.value_namespace = name_space
                                self.segment_id_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "strict"):
                                self.strict = value
                                self.strict.value_namespace = name_space
                                self.strict.value_namespace_prefix = name_space_prefix
                            if(value_path == "subobj-type"):
                                self.subobj_type = value
                                self.subobj_type.value_namespace = name_space
                                self.subobj_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.subobject:
                            if (c.has_data()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        return (
                            self.cost.is_set or
                            self.is_used.is_set)

                    def has_operation(self):
                        for c in self.subobject:
                            if (c.has_operation()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.is_set):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rro" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())

                        leaf_name_data.extend(self.address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "subobject"):
                            for c in self.subobject:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsPce.Lsps.Lsp.Paths.Rro.Subobject()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.subobject.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address"):
                            self.address.append(value)
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix


                class Metric(Entity):
                    """
                    List of Metrics
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: type
                    
                    	Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Lsp.Paths.Metric, self).__init__()

                        self.yang_name = "metric"
                        self.yang_parent_name = "paths"

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.type = YLeaf(YType.uint8, "type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("cost",
                                        "type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Lsp.Paths.Metric, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Lsp.Paths.Metric, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.cost.is_set or
                            self.type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "metric" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "cost" or name == "type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.metric:
                        if (c.has_data()):
                            return True
                    return (
                        self.applied_bw.is_set or
                        self.bw.is_set or
                        self.is_applied_bw_used.is_set or
                        self.is_bw_used.is_set or
                        self.is_reopt_bw_used.is_set or
                        self.reopt_bw.is_set or
                        (self.ero is not None and self.ero.has_data()) or
                        (self.lspa is not None and self.lspa.has_data()) or
                        (self.rro is not None and self.rro.has_data()))

                def has_operation(self):
                    for c in self.metric:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.applied_bw.yfilter != YFilter.not_set or
                        self.bw.yfilter != YFilter.not_set or
                        self.is_applied_bw_used.yfilter != YFilter.not_set or
                        self.is_bw_used.yfilter != YFilter.not_set or
                        self.is_reopt_bw_used.yfilter != YFilter.not_set or
                        self.reopt_bw.yfilter != YFilter.not_set or
                        (self.ero is not None and self.ero.has_operation()) or
                        (self.lspa is not None and self.lspa.has_operation()) or
                        (self.rro is not None and self.rro.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.applied_bw.is_set or self.applied_bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.applied_bw.get_name_leafdata())
                    if (self.bw.is_set or self.bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bw.get_name_leafdata())
                    if (self.is_applied_bw_used.is_set or self.is_applied_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_applied_bw_used.get_name_leafdata())
                    if (self.is_bw_used.is_set or self.is_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bw_used.get_name_leafdata())
                    if (self.is_reopt_bw_used.is_set or self.is_reopt_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_reopt_bw_used.get_name_leafdata())
                    if (self.reopt_bw.is_set or self.reopt_bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reopt_bw.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ero"):
                        if (self.ero is None):
                            self.ero = MplsPce.Lsps.Lsp.Paths.Ero()
                            self.ero.parent = self
                            self._children_name_map["ero"] = "ero"
                        return self.ero

                    if (child_yang_name == "lspa"):
                        if (self.lspa is None):
                            self.lspa = MplsPce.Lsps.Lsp.Paths.Lspa()
                            self.lspa.parent = self
                            self._children_name_map["lspa"] = "lspa"
                        return self.lspa

                    if (child_yang_name == "metric"):
                        for c in self.metric:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPce.Lsps.Lsp.Paths.Metric()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.metric.append(c)
                        return c

                    if (child_yang_name == "rro"):
                        if (self.rro is None):
                            self.rro = MplsPce.Lsps.Lsp.Paths.Rro()
                            self.rro.parent = self
                            self._children_name_map["rro"] = "rro"
                        return self.rro

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ero" or name == "lspa" or name == "metric" or name == "rro" or name == "applied-bw" or name == "bw" or name == "is-applied-bw-used" or name == "is-bw-used" or name == "is-reopt-bw-used" or name == "reopt-bw"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "applied-bw"):
                        self.applied_bw = value
                        self.applied_bw.value_namespace = name_space
                        self.applied_bw.value_namespace_prefix = name_space_prefix
                    if(value_path == "bw"):
                        self.bw = value
                        self.bw.value_namespace = name_space
                        self.bw.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-applied-bw-used"):
                        self.is_applied_bw_used = value
                        self.is_applied_bw_used.value_namespace = name_space
                        self.is_applied_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bw-used"):
                        self.is_bw_used = value
                        self.is_bw_used.value_namespace = name_space
                        self.is_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-reopt-bw-used"):
                        self.is_reopt_bw_used = value
                        self.is_reopt_bw_used.value_namespace = name_space
                        self.is_reopt_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "reopt-bw"):
                        self.reopt_bw = value
                        self.reopt_bw.value_namespace = name_space
                        self.reopt_bw.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.paths:
                    if (c.has_data()):
                        return True
                for leaf in self.backup_path.getYLeafs():
                    if (leaf.yfilter != YFilter.not_set):
                        return True
                return (
                    self.symbolic_name.is_set or
                    self.administrative.is_set or
                    self.binding_sid.is_set or
                    self.cleanup_timer_exp.is_set or
                    self.create.is_set or
                    self.delegatable.is_set or
                    self.delegation_timer_exp.is_set or
                    self.destination_address.is_set or
                    self.forward_class_id.is_set or
                    self.load_share.is_set or
                    self.lspo_is_used.is_set or
                    self.operational.is_set or
                    self.path_setup_type.is_set or
                    self.request_queue_size.is_set or
                    self.session_internal_lsp_id.is_set or
                    self.source_address.is_set or
                    self.state_timer_exp.is_set or
                    self.stateful_request_parameter_id.is_set or
                    self.symbolic_name_xr.is_set or
                    (self.autoroute is not None and self.autoroute.has_data()) or
                    (self.creator is not None and self.creator.has_data()) or
                    (self.delegated is not None and self.delegated.has_data()) or
                    (self.identifiers is not None and self.identifiers.has_data()))

            def has_operation(self):
                for c in self.paths:
                    if (c.has_operation()):
                        return True
                for leaf in self.backup_path.getYLeafs():
                    if (leaf.is_set):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.symbolic_name.yfilter != YFilter.not_set or
                    self.administrative.yfilter != YFilter.not_set or
                    self.backup_path.yfilter != YFilter.not_set or
                    self.binding_sid.yfilter != YFilter.not_set or
                    self.cleanup_timer_exp.yfilter != YFilter.not_set or
                    self.create.yfilter != YFilter.not_set or
                    self.delegatable.yfilter != YFilter.not_set or
                    self.delegation_timer_exp.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.forward_class_id.yfilter != YFilter.not_set or
                    self.load_share.yfilter != YFilter.not_set or
                    self.lspo_is_used.yfilter != YFilter.not_set or
                    self.operational.yfilter != YFilter.not_set or
                    self.path_setup_type.yfilter != YFilter.not_set or
                    self.request_queue_size.yfilter != YFilter.not_set or
                    self.session_internal_lsp_id.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.state_timer_exp.yfilter != YFilter.not_set or
                    self.stateful_request_parameter_id.yfilter != YFilter.not_set or
                    self.symbolic_name_xr.yfilter != YFilter.not_set or
                    (self.autoroute is not None and self.autoroute.has_operation()) or
                    (self.creator is not None and self.creator.has_operation()) or
                    (self.delegated is not None and self.delegated.has_operation()) or
                    (self.identifiers is not None and self.identifiers.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp" + "[symbolic-name='" + self.symbolic_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.symbolic_name.get_name_leafdata())
                if (self.administrative.is_set or self.administrative.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.administrative.get_name_leafdata())
                if (self.binding_sid.is_set or self.binding_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.binding_sid.get_name_leafdata())
                if (self.cleanup_timer_exp.is_set or self.cleanup_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.cleanup_timer_exp.get_name_leafdata())
                if (self.create.is_set or self.create.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create.get_name_leafdata())
                if (self.delegatable.is_set or self.delegatable.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delegatable.get_name_leafdata())
                if (self.delegation_timer_exp.is_set or self.delegation_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delegation_timer_exp.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.forward_class_id.is_set or self.forward_class_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.forward_class_id.get_name_leafdata())
                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.load_share.get_name_leafdata())
                if (self.lspo_is_used.is_set or self.lspo_is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lspo_is_used.get_name_leafdata())
                if (self.operational.is_set or self.operational.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.operational.get_name_leafdata())
                if (self.path_setup_type.is_set or self.path_setup_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_setup_type.get_name_leafdata())
                if (self.request_queue_size.is_set or self.request_queue_size.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.request_queue_size.get_name_leafdata())
                if (self.session_internal_lsp_id.is_set or self.session_internal_lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.session_internal_lsp_id.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.state_timer_exp.is_set or self.state_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.state_timer_exp.get_name_leafdata())
                if (self.stateful_request_parameter_id.is_set or self.stateful_request_parameter_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stateful_request_parameter_id.get_name_leafdata())
                if (self.symbolic_name_xr.is_set or self.symbolic_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.symbolic_name_xr.get_name_leafdata())

                leaf_name_data.extend(self.backup_path.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "autoroute"):
                    if (self.autoroute is None):
                        self.autoroute = MplsPce.Lsps.Lsp.Autoroute()
                        self.autoroute.parent = self
                        self._children_name_map["autoroute"] = "autoroute"
                    return self.autoroute

                if (child_yang_name == "creator"):
                    if (self.creator is None):
                        self.creator = MplsPce.Lsps.Lsp.Creator()
                        self.creator.parent = self
                        self._children_name_map["creator"] = "creator"
                    return self.creator

                if (child_yang_name == "delegated"):
                    if (self.delegated is None):
                        self.delegated = MplsPce.Lsps.Lsp.Delegated()
                        self.delegated.parent = self
                        self._children_name_map["delegated"] = "delegated"
                    return self.delegated

                if (child_yang_name == "identifiers"):
                    if (self.identifiers is None):
                        self.identifiers = MplsPce.Lsps.Lsp.Identifiers()
                        self.identifiers.parent = self
                        self._children_name_map["identifiers"] = "identifiers"
                    return self.identifiers

                if (child_yang_name == "paths"):
                    for c in self.paths:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPce.Lsps.Lsp.Paths()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.paths.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "autoroute" or name == "creator" or name == "delegated" or name == "identifiers" or name == "paths" or name == "symbolic-name" or name == "administrative" or name == "backup-path" or name == "binding-sid" or name == "cleanup-timer-exp" or name == "create" or name == "delegatable" or name == "delegation-timer-exp" or name == "destination-address" or name == "forward-class-id" or name == "load-share" or name == "lspo-is-used" or name == "operational" or name == "path-setup-type" or name == "request-queue-size" or name == "session-internal-lsp-id" or name == "source-address" or name == "state-timer-exp" or name == "stateful-request-parameter-id" or name == "symbolic-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "symbolic-name"):
                    self.symbolic_name = value
                    self.symbolic_name.value_namespace = name_space
                    self.symbolic_name.value_namespace_prefix = name_space_prefix
                if(value_path == "administrative"):
                    self.administrative = value
                    self.administrative.value_namespace = name_space
                    self.administrative.value_namespace_prefix = name_space_prefix
                if(value_path == "backup-path"):
                    self.backup_path.append(value)
                if(value_path == "binding-sid"):
                    self.binding_sid = value
                    self.binding_sid.value_namespace = name_space
                    self.binding_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "cleanup-timer-exp"):
                    self.cleanup_timer_exp = value
                    self.cleanup_timer_exp.value_namespace = name_space
                    self.cleanup_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "create"):
                    self.create = value
                    self.create.value_namespace = name_space
                    self.create.value_namespace_prefix = name_space_prefix
                if(value_path == "delegatable"):
                    self.delegatable = value
                    self.delegatable.value_namespace = name_space
                    self.delegatable.value_namespace_prefix = name_space_prefix
                if(value_path == "delegation-timer-exp"):
                    self.delegation_timer_exp = value
                    self.delegation_timer_exp.value_namespace = name_space
                    self.delegation_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "forward-class-id"):
                    self.forward_class_id = value
                    self.forward_class_id.value_namespace = name_space
                    self.forward_class_id.value_namespace_prefix = name_space_prefix
                if(value_path == "load-share"):
                    self.load_share = value
                    self.load_share.value_namespace = name_space
                    self.load_share.value_namespace_prefix = name_space_prefix
                if(value_path == "lspo-is-used"):
                    self.lspo_is_used = value
                    self.lspo_is_used.value_namespace = name_space
                    self.lspo_is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "operational"):
                    self.operational = value
                    self.operational.value_namespace = name_space
                    self.operational.value_namespace_prefix = name_space_prefix
                if(value_path == "path-setup-type"):
                    self.path_setup_type = value
                    self.path_setup_type.value_namespace = name_space
                    self.path_setup_type.value_namespace_prefix = name_space_prefix
                if(value_path == "request-queue-size"):
                    self.request_queue_size = value
                    self.request_queue_size.value_namespace = name_space
                    self.request_queue_size.value_namespace_prefix = name_space_prefix
                if(value_path == "session-internal-lsp-id"):
                    self.session_internal_lsp_id = value
                    self.session_internal_lsp_id.value_namespace = name_space
                    self.session_internal_lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "state-timer-exp"):
                    self.state_timer_exp = value
                    self.state_timer_exp.value_namespace = name_space
                    self.state_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "stateful-request-parameter-id"):
                    self.stateful_request_parameter_id = value
                    self.stateful_request_parameter_id.value_namespace = name_space
                    self.stateful_request_parameter_id.value_namespace_prefix = name_space_prefix
                if(value_path == "symbolic-name-xr"):
                    self.symbolic_name_xr = value
                    self.symbolic_name_xr.value_namespace = name_space
                    self.symbolic_name_xr.value_namespace_prefix = name_space_prefix


        class Creator(Entity):
            """
            Creator Peer of the LSP
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Creator, self).__init__()

                self.yang_name = "creator"
                self.yang_parent_name = "lsps"

                self.address = YLeaf(YType.str, "address")

                self.node_identifier = YLeaf(YType.str, "node-identifier")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("address",
                                "node_identifier") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Creator, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Creator, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.address.is_set or
                    self.node_identifier.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.address.yfilter != YFilter.not_set or
                    self.node_identifier.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "creator" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.address.get_name_leafdata())
                if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_identifier.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "address" or name == "node-identifier"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "address"):
                    self.address = value
                    self.address.value_namespace = name_space
                    self.address.value_namespace_prefix = name_space_prefix
                if(value_path == "node-identifier"):
                    self.node_identifier = value
                    self.node_identifier.value_namespace = name_space
                    self.node_identifier.value_namespace_prefix = name_space_prefix


        class Delegated(Entity):
            """
            Owner Peer of the LSP
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Delegated, self).__init__()

                self.yang_name = "delegated"
                self.yang_parent_name = "lsps"

                self.address = YLeaf(YType.str, "address")

                self.node_identifier = YLeaf(YType.str, "node-identifier")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("address",
                                "node_identifier") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Delegated, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Delegated, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.address.is_set or
                    self.node_identifier.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.address.yfilter != YFilter.not_set or
                    self.node_identifier.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "delegated" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.address.get_name_leafdata())
                if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_identifier.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "address" or name == "node-identifier"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "address"):
                    self.address = value
                    self.address.value_namespace = name_space
                    self.address.value_namespace_prefix = name_space_prefix
                if(value_path == "node-identifier"):
                    self.node_identifier = value
                    self.node_identifier.value_namespace = name_space
                    self.node_identifier.value_namespace_prefix = name_space_prefix


        class Identifiers(Entity):
            """
            LSP Identifiers
            
            .. attribute:: ext_tunnel_id
            
            	External Tunnel ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_used
            
            	LSP Identifier used flag
            	**type**\:  bool
            
            .. attribute:: sender
            
            	Sender Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: te_lsp_id
            
            	TE LSP ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_id
            
            	LSPO Tunnel ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Identifiers, self).__init__()

                self.yang_name = "identifiers"
                self.yang_parent_name = "lsps"

                self.ext_tunnel_id = YLeaf(YType.uint32, "ext-tunnel-id")

                self.is_used = YLeaf(YType.boolean, "is-used")

                self.sender = YLeaf(YType.str, "sender")

                self.te_lsp_id = YLeaf(YType.uint16, "te-lsp-id")

                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("ext_tunnel_id",
                                "is_used",
                                "sender",
                                "te_lsp_id",
                                "tunnel_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Identifiers, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Identifiers, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.ext_tunnel_id.is_set or
                    self.is_used.is_set or
                    self.sender.is_set or
                    self.te_lsp_id.is_set or
                    self.tunnel_id.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.ext_tunnel_id.yfilter != YFilter.not_set or
                    self.is_used.yfilter != YFilter.not_set or
                    self.sender.yfilter != YFilter.not_set or
                    self.te_lsp_id.yfilter != YFilter.not_set or
                    self.tunnel_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "identifiers" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.ext_tunnel_id.is_set or self.ext_tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ext_tunnel_id.get_name_leafdata())
                if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_used.get_name_leafdata())
                if (self.sender.is_set or self.sender.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sender.get_name_leafdata())
                if (self.te_lsp_id.is_set or self.te_lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.te_lsp_id.get_name_leafdata())
                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ext-tunnel-id" or name == "is-used" or name == "sender" or name == "te-lsp-id" or name == "tunnel-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "ext-tunnel-id"):
                    self.ext_tunnel_id = value
                    self.ext_tunnel_id.value_namespace = name_space
                    self.ext_tunnel_id.value_namespace_prefix = name_space_prefix
                if(value_path == "is-used"):
                    self.is_used = value
                    self.is_used.value_namespace = name_space
                    self.is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "sender"):
                    self.sender = value
                    self.sender.value_namespace = name_space
                    self.sender.value_namespace_prefix = name_space_prefix
                if(value_path == "te-lsp-id"):
                    self.te_lsp_id = value
                    self.te_lsp_id.value_namespace = name_space
                    self.te_lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-id"):
                    self.tunnel_id = value
                    self.tunnel_id.value_namespace = name_space
                    self.tunnel_id.value_namespace_prefix = name_space_prefix


        class Autoroute(Entity):
            """
            Auto Route
            
            .. attribute:: announced
            
            	Autoroute announced
            	**type**\:  bool
            
            .. attribute:: destination
            
            	Destinations
            	**type**\:  list of str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: is_used
            
            	Autoroute used flag
            	**type**\:  bool
            
            .. attribute:: metric
            
            	Metric Value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: metric_type
            
            	Metric Type
            	**type**\:   :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Autoroute, self).__init__()

                self.yang_name = "autoroute"
                self.yang_parent_name = "lsps"

                self.announced = YLeaf(YType.boolean, "announced")

                self.destination = YLeafList(YType.str, "destination")

                self.is_used = YLeaf(YType.boolean, "is-used")

                self.metric = YLeaf(YType.uint32, "metric")

                self.metric_type = YLeaf(YType.enumeration, "metric-type")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("announced",
                                "destination",
                                "is_used",
                                "metric",
                                "metric_type") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Autoroute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Autoroute, self).__setattr__(name, value)

            def has_data(self):
                for leaf in self.destination.getYLeafs():
                    if (leaf.yfilter != YFilter.not_set):
                        return True
                return (
                    self.announced.is_set or
                    self.is_used.is_set or
                    self.metric.is_set or
                    self.metric_type.is_set)

            def has_operation(self):
                for leaf in self.destination.getYLeafs():
                    if (leaf.is_set):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.announced.yfilter != YFilter.not_set or
                    self.destination.yfilter != YFilter.not_set or
                    self.is_used.yfilter != YFilter.not_set or
                    self.metric.yfilter != YFilter.not_set or
                    self.metric_type.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "autoroute" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.announced.is_set or self.announced.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.announced.get_name_leafdata())
                if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_used.get_name_leafdata())
                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.metric.get_name_leafdata())
                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.metric_type.get_name_leafdata())

                leaf_name_data.extend(self.destination.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announced" or name == "destination" or name == "is-used" or name == "metric" or name == "metric-type"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "announced"):
                    self.announced = value
                    self.announced.value_namespace = name_space
                    self.announced.value_namespace_prefix = name_space_prefix
                if(value_path == "destination"):
                    self.destination.append(value)
                if(value_path == "is-used"):
                    self.is_used = value
                    self.is_used.value_namespace = name_space
                    self.is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "metric"):
                    self.metric = value
                    self.metric.value_namespace = name_space
                    self.metric.value_namespace_prefix = name_space_prefix
                if(value_path == "metric-type"):
                    self.metric_type = value
                    self.metric_type.value_namespace = name_space
                    self.metric_type.value_namespace_prefix = name_space_prefix


        class Paths(Entity):
            """
            Array of paths
            
            .. attribute:: applied_bw
            
            	Applied bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw
            
            	Bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: ero
            
            	Explicit Router Object
            	**type**\:   :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Ero>`
            
            .. attribute:: is_applied_bw_used
            
            	Applied bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: is_bw_used
            
            	Bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: is_reopt_bw_used
            
            	Reoptimize bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: lspa
            
            	LSP Attributes Object
            	**type**\:   :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Lspa>`
            
            .. attribute:: metric
            
            	List of Metrics
            	**type**\: list of    :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Metric>`
            
            .. attribute:: reopt_bw
            
            	Reoptimize bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rro
            
            	Reported Route Object
            	**type**\:   :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Rro>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Lsps.Paths, self).__init__()

                self.yang_name = "paths"
                self.yang_parent_name = "lsps"

                self.applied_bw = YLeaf(YType.uint32, "applied-bw")

                self.bw = YLeaf(YType.uint32, "bw")

                self.is_applied_bw_used = YLeaf(YType.boolean, "is-applied-bw-used")

                self.is_bw_used = YLeaf(YType.boolean, "is-bw-used")

                self.is_reopt_bw_used = YLeaf(YType.boolean, "is-reopt-bw-used")

                self.reopt_bw = YLeaf(YType.uint32, "reopt-bw")

                self.ero = MplsPce.Lsps.Paths.Ero()
                self.ero.parent = self
                self._children_name_map["ero"] = "ero"
                self._children_yang_names.add("ero")

                self.lspa = MplsPce.Lsps.Paths.Lspa()
                self.lspa.parent = self
                self._children_name_map["lspa"] = "lspa"
                self._children_yang_names.add("lspa")

                self.rro = MplsPce.Lsps.Paths.Rro()
                self.rro.parent = self
                self._children_name_map["rro"] = "rro"
                self._children_yang_names.add("rro")

                self.metric = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("applied_bw",
                                "bw",
                                "is_applied_bw_used",
                                "is_bw_used",
                                "is_reopt_bw_used",
                                "reopt_bw") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Lsps.Paths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Lsps.Paths, self).__setattr__(name, value)


            class Ero(Entity):
                """
                Explicit Router Object
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\:  bool
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Ero.Subobject>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Paths.Ero, self).__init__()

                    self.yang_name = "ero"
                    self.yang_parent_name = "paths"

                    self.address = YLeafList(YType.str, "address")

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.subobject = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "cost",
                                    "is_used") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Paths.Ero, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Paths.Ero, self).__setattr__(name, value)


                class Subobject(Entity):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\:  bool
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\:  bool
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\:  bool
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\:  bool
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\:  bool
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\:  bool
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\:  bool
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\:  bool
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Paths.Ero.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "ero"

                        self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                        self.global_ = YLeaf(YType.boolean, "global")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                        self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                        self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                        self.node_id = YLeaf(YType.str, "node-id")

                        self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                        self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                        self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                        self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                        self.strict = YLeaf(YType.boolean, "strict")

                        self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("complete_mpls_label_entry",
                                        "global_",
                                        "ipv4_address",
                                        "ipv4_prefix_len",
                                        "local_address",
                                        "missing_node_adjcency_id",
                                        "missing_segment_id",
                                        "mpls_label",
                                        "node_adjacency_id_exists",
                                        "node_id",
                                        "only_valid_mpls_label",
                                        "remote_address",
                                        "segment_id_exists",
                                        "segment_id_type",
                                        "segment_id_value",
                                        "strict",
                                        "subobj_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Paths.Ero.Subobject, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Paths.Ero.Subobject, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.complete_mpls_label_entry.is_set or
                            self.global_.is_set or
                            self.ipv4_address.is_set or
                            self.ipv4_prefix_len.is_set or
                            self.local_address.is_set or
                            self.missing_node_adjcency_id.is_set or
                            self.missing_segment_id.is_set or
                            self.mpls_label.is_set or
                            self.node_adjacency_id_exists.is_set or
                            self.node_id.is_set or
                            self.only_valid_mpls_label.is_set or
                            self.remote_address.is_set or
                            self.segment_id_exists.is_set or
                            self.segment_id_type.is_set or
                            self.segment_id_value.is_set or
                            self.strict.is_set or
                            self.subobj_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                            self.global_.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv4_prefix_len.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                            self.missing_segment_id.yfilter != YFilter.not_set or
                            self.mpls_label.yfilter != YFilter.not_set or
                            self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set or
                            self.only_valid_mpls_label.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set or
                            self.segment_id_exists.yfilter != YFilter.not_set or
                            self.segment_id_type.yfilter != YFilter.not_set or
                            self.segment_id_value.yfilter != YFilter.not_set or
                            self.strict.yfilter != YFilter.not_set or
                            self.subobj_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "subobject" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/ero/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                        if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                        if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                        if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label.get_name_leafdata())
                        if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())
                        if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())
                        if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                        if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                        if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                        if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict.get_name_leafdata())
                        if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.subobj_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "complete-mpls-label-entry"):
                            self.complete_mpls_label_entry = value
                            self.complete_mpls_label_entry.value_namespace = name_space
                            self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                        if(value_path == "global"):
                            self.global_ = value
                            self.global_.value_namespace = name_space
                            self.global_.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-prefix-len"):
                            self.ipv4_prefix_len = value
                            self.ipv4_prefix_len.value_namespace = name_space
                            self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-node-adjcency-id"):
                            self.missing_node_adjcency_id = value
                            self.missing_node_adjcency_id.value_namespace = name_space
                            self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-segment-id"):
                            self.missing_segment_id = value
                            self.missing_segment_id.value_namespace = name_space
                            self.missing_segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label"):
                            self.mpls_label = value
                            self.mpls_label.value_namespace = name_space
                            self.mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-adjacency-id-exists"):
                            self.node_adjacency_id_exists = value
                            self.node_adjacency_id_exists.value_namespace = name_space
                            self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "only-valid-mpls-label"):
                            self.only_valid_mpls_label = value
                            self.only_valid_mpls_label.value_namespace = name_space
                            self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-exists"):
                            self.segment_id_exists = value
                            self.segment_id_exists.value_namespace = name_space
                            self.segment_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-type"):
                            self.segment_id_type = value
                            self.segment_id_type.value_namespace = name_space
                            self.segment_id_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-value"):
                            self.segment_id_value = value
                            self.segment_id_value.value_namespace = name_space
                            self.segment_id_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict"):
                            self.strict = value
                            self.strict.value_namespace = name_space
                            self.strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "subobj-type"):
                            self.subobj_type = value
                            self.subobj_type.value_namespace = name_space
                            self.subobj_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.subobject:
                        if (c.has_data()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.cost.is_set or
                        self.is_used.is_set)

                def has_operation(self):
                    for c in self.subobject:
                        if (c.has_operation()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ero" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())

                    leaf_name_data.extend(self.address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "subobject"):
                        for c in self.subobject:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPce.Lsps.Paths.Ero.Subobject()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.subobject.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address.append(value)
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix


            class Lspa(Entity):
                """
                LSP Attributes Object
                
                .. attribute:: exlude_any
                
                	Exclude Any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hold
                
                	Hold
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: include_all
                
                	Include All
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: include_any
                
                	Include Any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	LSPA used flag
                	**type**\:  bool
                
                .. attribute:: lbit
                
                	L flag
                	**type**\:  bool
                
                .. attribute:: setup
                
                	Setup
                	**type**\:  int
                
                	**range:** 0..255
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Paths.Lspa, self).__init__()

                    self.yang_name = "lspa"
                    self.yang_parent_name = "paths"

                    self.exlude_any = YLeaf(YType.uint32, "exlude-any")

                    self.hold = YLeaf(YType.uint8, "hold")

                    self.include_all = YLeaf(YType.uint32, "include-all")

                    self.include_any = YLeaf(YType.uint32, "include-any")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.lbit = YLeaf(YType.boolean, "lbit")

                    self.setup = YLeaf(YType.uint8, "setup")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("exlude_any",
                                    "hold",
                                    "include_all",
                                    "include_any",
                                    "is_used",
                                    "lbit",
                                    "setup") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Paths.Lspa, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Paths.Lspa, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.exlude_any.is_set or
                        self.hold.is_set or
                        self.include_all.is_set or
                        self.include_any.is_set or
                        self.is_used.is_set or
                        self.lbit.is_set or
                        self.setup.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.exlude_any.yfilter != YFilter.not_set or
                        self.hold.yfilter != YFilter.not_set or
                        self.include_all.yfilter != YFilter.not_set or
                        self.include_any.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.lbit.yfilter != YFilter.not_set or
                        self.setup.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lspa" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.exlude_any.is_set or self.exlude_any.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exlude_any.get_name_leafdata())
                    if (self.hold.is_set or self.hold.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold.get_name_leafdata())
                    if (self.include_all.is_set or self.include_all.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.include_all.get_name_leafdata())
                    if (self.include_any.is_set or self.include_any.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.include_any.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.lbit.is_set or self.lbit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lbit.get_name_leafdata())
                    if (self.setup.is_set or self.setup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "exlude-any" or name == "hold" or name == "include-all" or name == "include-any" or name == "is-used" or name == "lbit" or name == "setup"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "exlude-any"):
                        self.exlude_any = value
                        self.exlude_any.value_namespace = name_space
                        self.exlude_any.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold"):
                        self.hold = value
                        self.hold.value_namespace = name_space
                        self.hold.value_namespace_prefix = name_space_prefix
                    if(value_path == "include-all"):
                        self.include_all = value
                        self.include_all.value_namespace = name_space
                        self.include_all.value_namespace_prefix = name_space_prefix
                    if(value_path == "include-any"):
                        self.include_any = value
                        self.include_any.value_namespace = name_space
                        self.include_any.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "lbit"):
                        self.lbit = value
                        self.lbit.value_namespace = name_space
                        self.lbit.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup"):
                        self.setup = value
                        self.setup.value_namespace = name_space
                        self.setup.value_namespace_prefix = name_space_prefix


            class Rro(Entity):
                """
                Reported Route Object
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\:  bool
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Rro.Subobject>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Paths.Rro, self).__init__()

                    self.yang_name = "rro"
                    self.yang_parent_name = "paths"

                    self.address = YLeafList(YType.str, "address")

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.subobject = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "cost",
                                    "is_used") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Paths.Rro, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Paths.Rro, self).__setattr__(name, value)


                class Subobject(Entity):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\:  bool
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\:  bool
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\:  bool
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\:  bool
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\:  bool
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\:  bool
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\:  bool
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\:  bool
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPce.Lsps.Paths.Rro.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "rro"

                        self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                        self.global_ = YLeaf(YType.boolean, "global")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                        self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                        self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                        self.node_id = YLeaf(YType.str, "node-id")

                        self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                        self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                        self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                        self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                        self.strict = YLeaf(YType.boolean, "strict")

                        self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("complete_mpls_label_entry",
                                        "global_",
                                        "ipv4_address",
                                        "ipv4_prefix_len",
                                        "local_address",
                                        "missing_node_adjcency_id",
                                        "missing_segment_id",
                                        "mpls_label",
                                        "node_adjacency_id_exists",
                                        "node_id",
                                        "only_valid_mpls_label",
                                        "remote_address",
                                        "segment_id_exists",
                                        "segment_id_type",
                                        "segment_id_value",
                                        "strict",
                                        "subobj_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPce.Lsps.Paths.Rro.Subobject, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPce.Lsps.Paths.Rro.Subobject, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.complete_mpls_label_entry.is_set or
                            self.global_.is_set or
                            self.ipv4_address.is_set or
                            self.ipv4_prefix_len.is_set or
                            self.local_address.is_set or
                            self.missing_node_adjcency_id.is_set or
                            self.missing_segment_id.is_set or
                            self.mpls_label.is_set or
                            self.node_adjacency_id_exists.is_set or
                            self.node_id.is_set or
                            self.only_valid_mpls_label.is_set or
                            self.remote_address.is_set or
                            self.segment_id_exists.is_set or
                            self.segment_id_type.is_set or
                            self.segment_id_value.is_set or
                            self.strict.is_set or
                            self.subobj_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                            self.global_.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv4_prefix_len.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                            self.missing_segment_id.yfilter != YFilter.not_set or
                            self.mpls_label.yfilter != YFilter.not_set or
                            self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set or
                            self.only_valid_mpls_label.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set or
                            self.segment_id_exists.yfilter != YFilter.not_set or
                            self.segment_id_type.yfilter != YFilter.not_set or
                            self.segment_id_value.yfilter != YFilter.not_set or
                            self.strict.yfilter != YFilter.not_set or
                            self.subobj_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "subobject" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/rro/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                        if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                        if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                        if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label.get_name_leafdata())
                        if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())
                        if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())
                        if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                        if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                        if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                        if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict.get_name_leafdata())
                        if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.subobj_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "complete-mpls-label-entry"):
                            self.complete_mpls_label_entry = value
                            self.complete_mpls_label_entry.value_namespace = name_space
                            self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                        if(value_path == "global"):
                            self.global_ = value
                            self.global_.value_namespace = name_space
                            self.global_.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-prefix-len"):
                            self.ipv4_prefix_len = value
                            self.ipv4_prefix_len.value_namespace = name_space
                            self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-node-adjcency-id"):
                            self.missing_node_adjcency_id = value
                            self.missing_node_adjcency_id.value_namespace = name_space
                            self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-segment-id"):
                            self.missing_segment_id = value
                            self.missing_segment_id.value_namespace = name_space
                            self.missing_segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label"):
                            self.mpls_label = value
                            self.mpls_label.value_namespace = name_space
                            self.mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-adjacency-id-exists"):
                            self.node_adjacency_id_exists = value
                            self.node_adjacency_id_exists.value_namespace = name_space
                            self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "only-valid-mpls-label"):
                            self.only_valid_mpls_label = value
                            self.only_valid_mpls_label.value_namespace = name_space
                            self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-exists"):
                            self.segment_id_exists = value
                            self.segment_id_exists.value_namespace = name_space
                            self.segment_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-type"):
                            self.segment_id_type = value
                            self.segment_id_type.value_namespace = name_space
                            self.segment_id_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-value"):
                            self.segment_id_value = value
                            self.segment_id_value.value_namespace = name_space
                            self.segment_id_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict"):
                            self.strict = value
                            self.strict.value_namespace = name_space
                            self.strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "subobj-type"):
                            self.subobj_type = value
                            self.subobj_type.value_namespace = name_space
                            self.subobj_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.subobject:
                        if (c.has_data()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.cost.is_set or
                        self.is_used.is_set)

                def has_operation(self):
                    for c in self.subobject:
                        if (c.has_operation()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rro" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())

                    leaf_name_data.extend(self.address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "subobject"):
                        for c in self.subobject:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPce.Lsps.Paths.Rro.Subobject()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.subobject.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address.append(value)
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix


            class Metric(Entity):
                """
                List of Metrics
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: type
                
                	Type
                	**type**\:  int
                
                	**range:** 0..255
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Lsps.Paths.Metric, self).__init__()

                    self.yang_name = "metric"
                    self.yang_parent_name = "paths"

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.type = YLeaf(YType.uint8, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("cost",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Lsps.Paths.Metric, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Lsps.Paths.Metric, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.cost.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "metric" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "cost" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.metric:
                    if (c.has_data()):
                        return True
                return (
                    self.applied_bw.is_set or
                    self.bw.is_set or
                    self.is_applied_bw_used.is_set or
                    self.is_bw_used.is_set or
                    self.is_reopt_bw_used.is_set or
                    self.reopt_bw.is_set or
                    (self.ero is not None and self.ero.has_data()) or
                    (self.lspa is not None and self.lspa.has_data()) or
                    (self.rro is not None and self.rro.has_data()))

            def has_operation(self):
                for c in self.metric:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.applied_bw.yfilter != YFilter.not_set or
                    self.bw.yfilter != YFilter.not_set or
                    self.is_applied_bw_used.yfilter != YFilter.not_set or
                    self.is_bw_used.yfilter != YFilter.not_set or
                    self.is_reopt_bw_used.yfilter != YFilter.not_set or
                    self.reopt_bw.yfilter != YFilter.not_set or
                    (self.ero is not None and self.ero.has_operation()) or
                    (self.lspa is not None and self.lspa.has_operation()) or
                    (self.rro is not None and self.rro.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.applied_bw.is_set or self.applied_bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.applied_bw.get_name_leafdata())
                if (self.bw.is_set or self.bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw.get_name_leafdata())
                if (self.is_applied_bw_used.is_set or self.is_applied_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_applied_bw_used.get_name_leafdata())
                if (self.is_bw_used.is_set or self.is_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_bw_used.get_name_leafdata())
                if (self.is_reopt_bw_used.is_set or self.is_reopt_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_reopt_bw_used.get_name_leafdata())
                if (self.reopt_bw.is_set or self.reopt_bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reopt_bw.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ero"):
                    if (self.ero is None):
                        self.ero = MplsPce.Lsps.Paths.Ero()
                        self.ero.parent = self
                        self._children_name_map["ero"] = "ero"
                    return self.ero

                if (child_yang_name == "lspa"):
                    if (self.lspa is None):
                        self.lspa = MplsPce.Lsps.Paths.Lspa()
                        self.lspa.parent = self
                        self._children_name_map["lspa"] = "lspa"
                    return self.lspa

                if (child_yang_name == "metric"):
                    for c in self.metric:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPce.Lsps.Paths.Metric()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.metric.append(c)
                    return c

                if (child_yang_name == "rro"):
                    if (self.rro is None):
                        self.rro = MplsPce.Lsps.Paths.Rro()
                        self.rro.parent = self
                        self._children_name_map["rro"] = "rro"
                    return self.rro

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ero" or name == "lspa" or name == "metric" or name == "rro" or name == "applied-bw" or name == "bw" or name == "is-applied-bw-used" or name == "is-bw-used" or name == "is-reopt-bw-used" or name == "reopt-bw"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "applied-bw"):
                    self.applied_bw = value
                    self.applied_bw.value_namespace = name_space
                    self.applied_bw.value_namespace_prefix = name_space_prefix
                if(value_path == "bw"):
                    self.bw = value
                    self.bw.value_namespace = name_space
                    self.bw.value_namespace_prefix = name_space_prefix
                if(value_path == "is-applied-bw-used"):
                    self.is_applied_bw_used = value
                    self.is_applied_bw_used.value_namespace = name_space
                    self.is_applied_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "is-bw-used"):
                    self.is_bw_used = value
                    self.is_bw_used.value_namespace = name_space
                    self.is_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "is-reopt-bw-used"):
                    self.is_reopt_bw_used = value
                    self.is_reopt_bw_used.value_namespace = name_space
                    self.is_reopt_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "reopt-bw"):
                    self.reopt_bw = value
                    self.reopt_bw.value_namespace = name_space
                    self.reopt_bw.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.lsp:
                if (c.has_data()):
                    return True
            for c in self.paths:
                if (c.has_data()):
                    return True
            for leaf in self.backup_path.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            return (
                self.administrative.is_set or
                self.binding_sid.is_set or
                self.cleanup_timer_exp.is_set or
                self.create.is_set or
                self.delegatable.is_set or
                self.delegation_timer_exp.is_set or
                self.destination_address.is_set or
                self.forward_class_id.is_set or
                self.load_share.is_set or
                self.lspo_is_used.is_set or
                self.operational.is_set or
                self.path_setup_type.is_set or
                self.request_queue_size.is_set or
                self.session_internal_lsp_id.is_set or
                self.source_address.is_set or
                self.state_timer_exp.is_set or
                self.stateful_request_parameter_id.is_set or
                self.symbolic_name_xr.is_set or
                (self.autoroute is not None and self.autoroute.has_data()) or
                (self.creator is not None and self.creator.has_data()) or
                (self.delegated is not None and self.delegated.has_data()) or
                (self.identifiers is not None and self.identifiers.has_data()))

        def has_operation(self):
            for c in self.lsp:
                if (c.has_operation()):
                    return True
            for c in self.paths:
                if (c.has_operation()):
                    return True
            for leaf in self.backup_path.getYLeafs():
                if (leaf.is_set):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.administrative.yfilter != YFilter.not_set or
                self.backup_path.yfilter != YFilter.not_set or
                self.binding_sid.yfilter != YFilter.not_set or
                self.cleanup_timer_exp.yfilter != YFilter.not_set or
                self.create.yfilter != YFilter.not_set or
                self.delegatable.yfilter != YFilter.not_set or
                self.delegation_timer_exp.yfilter != YFilter.not_set or
                self.destination_address.yfilter != YFilter.not_set or
                self.forward_class_id.yfilter != YFilter.not_set or
                self.load_share.yfilter != YFilter.not_set or
                self.lspo_is_used.yfilter != YFilter.not_set or
                self.operational.yfilter != YFilter.not_set or
                self.path_setup_type.yfilter != YFilter.not_set or
                self.request_queue_size.yfilter != YFilter.not_set or
                self.session_internal_lsp_id.yfilter != YFilter.not_set or
                self.source_address.yfilter != YFilter.not_set or
                self.state_timer_exp.yfilter != YFilter.not_set or
                self.stateful_request_parameter_id.yfilter != YFilter.not_set or
                self.symbolic_name_xr.yfilter != YFilter.not_set or
                (self.autoroute is not None and self.autoroute.has_operation()) or
                (self.creator is not None and self.creator.has_operation()) or
                (self.delegated is not None and self.delegated.has_operation()) or
                (self.identifiers is not None and self.identifiers.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "lsps" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.administrative.is_set or self.administrative.yfilter != YFilter.not_set):
                leaf_name_data.append(self.administrative.get_name_leafdata())
            if (self.binding_sid.is_set or self.binding_sid.yfilter != YFilter.not_set):
                leaf_name_data.append(self.binding_sid.get_name_leafdata())
            if (self.cleanup_timer_exp.is_set or self.cleanup_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.cleanup_timer_exp.get_name_leafdata())
            if (self.create.is_set or self.create.yfilter != YFilter.not_set):
                leaf_name_data.append(self.create.get_name_leafdata())
            if (self.delegatable.is_set or self.delegatable.yfilter != YFilter.not_set):
                leaf_name_data.append(self.delegatable.get_name_leafdata())
            if (self.delegation_timer_exp.is_set or self.delegation_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.delegation_timer_exp.get_name_leafdata())
            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.destination_address.get_name_leafdata())
            if (self.forward_class_id.is_set or self.forward_class_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.forward_class_id.get_name_leafdata())
            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                leaf_name_data.append(self.load_share.get_name_leafdata())
            if (self.lspo_is_used.is_set or self.lspo_is_used.yfilter != YFilter.not_set):
                leaf_name_data.append(self.lspo_is_used.get_name_leafdata())
            if (self.operational.is_set or self.operational.yfilter != YFilter.not_set):
                leaf_name_data.append(self.operational.get_name_leafdata())
            if (self.path_setup_type.is_set or self.path_setup_type.yfilter != YFilter.not_set):
                leaf_name_data.append(self.path_setup_type.get_name_leafdata())
            if (self.request_queue_size.is_set or self.request_queue_size.yfilter != YFilter.not_set):
                leaf_name_data.append(self.request_queue_size.get_name_leafdata())
            if (self.session_internal_lsp_id.is_set or self.session_internal_lsp_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.session_internal_lsp_id.get_name_leafdata())
            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.source_address.get_name_leafdata())
            if (self.state_timer_exp.is_set or self.state_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.state_timer_exp.get_name_leafdata())
            if (self.stateful_request_parameter_id.is_set or self.stateful_request_parameter_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.stateful_request_parameter_id.get_name_leafdata())
            if (self.symbolic_name_xr.is_set or self.symbolic_name_xr.yfilter != YFilter.not_set):
                leaf_name_data.append(self.symbolic_name_xr.get_name_leafdata())

            leaf_name_data.extend(self.backup_path.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "autoroute"):
                if (self.autoroute is None):
                    self.autoroute = MplsPce.Lsps.Autoroute()
                    self.autoroute.parent = self
                    self._children_name_map["autoroute"] = "autoroute"
                return self.autoroute

            if (child_yang_name == "creator"):
                if (self.creator is None):
                    self.creator = MplsPce.Lsps.Creator()
                    self.creator.parent = self
                    self._children_name_map["creator"] = "creator"
                return self.creator

            if (child_yang_name == "delegated"):
                if (self.delegated is None):
                    self.delegated = MplsPce.Lsps.Delegated()
                    self.delegated.parent = self
                    self._children_name_map["delegated"] = "delegated"
                return self.delegated

            if (child_yang_name == "identifiers"):
                if (self.identifiers is None):
                    self.identifiers = MplsPce.Lsps.Identifiers()
                    self.identifiers.parent = self
                    self._children_name_map["identifiers"] = "identifiers"
                return self.identifiers

            if (child_yang_name == "lsp"):
                for c in self.lsp:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPce.Lsps.Lsp()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.lsp.append(c)
                return c

            if (child_yang_name == "paths"):
                for c in self.paths:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPce.Lsps.Paths()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.paths.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "autoroute" or name == "creator" or name == "delegated" or name == "identifiers" or name == "lsp" or name == "paths" or name == "administrative" or name == "backup-path" or name == "binding-sid" or name == "cleanup-timer-exp" or name == "create" or name == "delegatable" or name == "delegation-timer-exp" or name == "destination-address" or name == "forward-class-id" or name == "load-share" or name == "lspo-is-used" or name == "operational" or name == "path-setup-type" or name == "request-queue-size" or name == "session-internal-lsp-id" or name == "source-address" or name == "state-timer-exp" or name == "stateful-request-parameter-id" or name == "symbolic-name-xr"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "administrative"):
                self.administrative = value
                self.administrative.value_namespace = name_space
                self.administrative.value_namespace_prefix = name_space_prefix
            if(value_path == "backup-path"):
                self.backup_path.append(value)
            if(value_path == "binding-sid"):
                self.binding_sid = value
                self.binding_sid.value_namespace = name_space
                self.binding_sid.value_namespace_prefix = name_space_prefix
            if(value_path == "cleanup-timer-exp"):
                self.cleanup_timer_exp = value
                self.cleanup_timer_exp.value_namespace = name_space
                self.cleanup_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "create"):
                self.create = value
                self.create.value_namespace = name_space
                self.create.value_namespace_prefix = name_space_prefix
            if(value_path == "delegatable"):
                self.delegatable = value
                self.delegatable.value_namespace = name_space
                self.delegatable.value_namespace_prefix = name_space_prefix
            if(value_path == "delegation-timer-exp"):
                self.delegation_timer_exp = value
                self.delegation_timer_exp.value_namespace = name_space
                self.delegation_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "destination-address"):
                self.destination_address = value
                self.destination_address.value_namespace = name_space
                self.destination_address.value_namespace_prefix = name_space_prefix
            if(value_path == "forward-class-id"):
                self.forward_class_id = value
                self.forward_class_id.value_namespace = name_space
                self.forward_class_id.value_namespace_prefix = name_space_prefix
            if(value_path == "load-share"):
                self.load_share = value
                self.load_share.value_namespace = name_space
                self.load_share.value_namespace_prefix = name_space_prefix
            if(value_path == "lspo-is-used"):
                self.lspo_is_used = value
                self.lspo_is_used.value_namespace = name_space
                self.lspo_is_used.value_namespace_prefix = name_space_prefix
            if(value_path == "operational"):
                self.operational = value
                self.operational.value_namespace = name_space
                self.operational.value_namespace_prefix = name_space_prefix
            if(value_path == "path-setup-type"):
                self.path_setup_type = value
                self.path_setup_type.value_namespace = name_space
                self.path_setup_type.value_namespace_prefix = name_space_prefix
            if(value_path == "request-queue-size"):
                self.request_queue_size = value
                self.request_queue_size.value_namespace = name_space
                self.request_queue_size.value_namespace_prefix = name_space_prefix
            if(value_path == "session-internal-lsp-id"):
                self.session_internal_lsp_id = value
                self.session_internal_lsp_id.value_namespace = name_space
                self.session_internal_lsp_id.value_namespace_prefix = name_space_prefix
            if(value_path == "source-address"):
                self.source_address = value
                self.source_address.value_namespace = name_space
                self.source_address.value_namespace_prefix = name_space_prefix
            if(value_path == "state-timer-exp"):
                self.state_timer_exp = value
                self.state_timer_exp.value_namespace = name_space
                self.state_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "stateful-request-parameter-id"):
                self.stateful_request_parameter_id = value
                self.stateful_request_parameter_id.value_namespace = name_space
                self.stateful_request_parameter_id.value_namespace_prefix = name_space_prefix
            if(value_path == "symbolic-name-xr"):
                self.symbolic_name_xr = value
                self.symbolic_name_xr.value_namespace = name_space
                self.symbolic_name_xr.value_namespace_prefix = name_space_prefix


    class Statistics(Entity):
        """
        PCE stats info
        
        .. attribute:: average_in_queue_depth
        
        	Average Input Queue Depth
        	**type**\:  list of int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_file_descriptors
        
        	Number of TCP file descriptors currently in use
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_pceq_length
        
        	Current PCE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_teq_length
        
        	Current TE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: igp_statistics
        
        	IGP Statistics
        	**type**\:   :py:class:`IgpStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics.IgpStatistics>`
        
        .. attribute:: max_file_descriptors
        
        	Maximum number of TCP file descriptors used
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: max_pceq_length
        
        	Max PCE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: max_teq_length
        
        	Max TE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: maximum_in_queue_depth
        
        	Max Input Queue Depth
        	**type**\:  list of int
        
        	**range:** 0..4294967295
        
        .. attribute:: neighbors
        
        	Neighbor Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_pending
        
        	Number of pending req
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_timed_out
        
        	Number of timedout req
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_total
        
        	Total number of PCEReq
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: tunnels
        
        	Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPce.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-pce"

            self.average_in_queue_depth = YLeafList(YType.uint32, "average-in-queue-depth")

            self.current_file_descriptors = YLeaf(YType.uint32, "current-file-descriptors")

            self.current_pceq_length = YLeaf(YType.uint32, "current-pceq-length")

            self.current_teq_length = YLeaf(YType.uint32, "current-teq-length")

            self.max_file_descriptors = YLeaf(YType.uint32, "max-file-descriptors")

            self.max_pceq_length = YLeaf(YType.uint32, "max-pceq-length")

            self.max_teq_length = YLeaf(YType.uint32, "max-teq-length")

            self.maximum_in_queue_depth = YLeafList(YType.uint32, "maximum-in-queue-depth")

            self.neighbors = YLeaf(YType.uint32, "neighbors")

            self.pce_req_pending = YLeaf(YType.uint32, "pce-req-pending")

            self.pce_req_timed_out = YLeaf(YType.uint32, "pce-req-timed-out")

            self.pce_req_total = YLeaf(YType.uint32, "pce-req-total")

            self.tunnels = YLeaf(YType.uint32, "tunnels")

            self.igp_statistics = MplsPce.Statistics.IgpStatistics()
            self.igp_statistics.parent = self
            self._children_name_map["igp_statistics"] = "igp-statistics"
            self._children_yang_names.add("igp-statistics")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("average_in_queue_depth",
                            "current_file_descriptors",
                            "current_pceq_length",
                            "current_teq_length",
                            "max_file_descriptors",
                            "max_pceq_length",
                            "max_teq_length",
                            "maximum_in_queue_depth",
                            "neighbors",
                            "pce_req_pending",
                            "pce_req_timed_out",
                            "pce_req_total",
                            "tunnels") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPce.Statistics, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPce.Statistics, self).__setattr__(name, value)


        class IgpStatistics(Entity):
            """
            IGP Statistics
            
            .. attribute:: abr_lookup_avg
            
            	ABR Lookup Avg
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_complete
            
            	ABR Lookup Complete
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_max
            
            	ABR Lookup Max
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_min
            
            	ABR Lookup Min
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_timeout
            
            	ABR Lookup Timeout
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Statistics.IgpStatistics, self).__init__()

                self.yang_name = "igp-statistics"
                self.yang_parent_name = "statistics"

                self.abr_lookup_avg = YLeaf(YType.uint64, "abr-lookup-avg")

                self.abr_lookup_complete = YLeaf(YType.uint64, "abr-lookup-complete")

                self.abr_lookup_max = YLeaf(YType.uint64, "abr-lookup-max")

                self.abr_lookup_min = YLeaf(YType.uint64, "abr-lookup-min")

                self.abr_lookup_timeout = YLeaf(YType.uint64, "abr-lookup-timeout")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("abr_lookup_avg",
                                "abr_lookup_complete",
                                "abr_lookup_max",
                                "abr_lookup_min",
                                "abr_lookup_timeout") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Statistics.IgpStatistics, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Statistics.IgpStatistics, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.abr_lookup_avg.is_set or
                    self.abr_lookup_complete.is_set or
                    self.abr_lookup_max.is_set or
                    self.abr_lookup_min.is_set or
                    self.abr_lookup_timeout.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.abr_lookup_avg.yfilter != YFilter.not_set or
                    self.abr_lookup_complete.yfilter != YFilter.not_set or
                    self.abr_lookup_max.yfilter != YFilter.not_set or
                    self.abr_lookup_min.yfilter != YFilter.not_set or
                    self.abr_lookup_timeout.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-statistics" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.abr_lookup_avg.is_set or self.abr_lookup_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_avg.get_name_leafdata())
                if (self.abr_lookup_complete.is_set or self.abr_lookup_complete.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_complete.get_name_leafdata())
                if (self.abr_lookup_max.is_set or self.abr_lookup_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_max.get_name_leafdata())
                if (self.abr_lookup_min.is_set or self.abr_lookup_min.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_min.get_name_leafdata())
                if (self.abr_lookup_timeout.is_set or self.abr_lookup_timeout.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_timeout.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "abr-lookup-avg" or name == "abr-lookup-complete" or name == "abr-lookup-max" or name == "abr-lookup-min" or name == "abr-lookup-timeout"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "abr-lookup-avg"):
                    self.abr_lookup_avg = value
                    self.abr_lookup_avg.value_namespace = name_space
                    self.abr_lookup_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-complete"):
                    self.abr_lookup_complete = value
                    self.abr_lookup_complete.value_namespace = name_space
                    self.abr_lookup_complete.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-max"):
                    self.abr_lookup_max = value
                    self.abr_lookup_max.value_namespace = name_space
                    self.abr_lookup_max.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-min"):
                    self.abr_lookup_min = value
                    self.abr_lookup_min.value_namespace = name_space
                    self.abr_lookup_min.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-timeout"):
                    self.abr_lookup_timeout = value
                    self.abr_lookup_timeout.value_namespace = name_space
                    self.abr_lookup_timeout.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for leaf in self.average_in_queue_depth.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            for leaf in self.maximum_in_queue_depth.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            return (
                self.current_file_descriptors.is_set or
                self.current_pceq_length.is_set or
                self.current_teq_length.is_set or
                self.max_file_descriptors.is_set or
                self.max_pceq_length.is_set or
                self.max_teq_length.is_set or
                self.neighbors.is_set or
                self.pce_req_pending.is_set or
                self.pce_req_timed_out.is_set or
                self.pce_req_total.is_set or
                self.tunnels.is_set or
                (self.igp_statistics is not None and self.igp_statistics.has_data()))

        def has_operation(self):
            for leaf in self.average_in_queue_depth.getYLeafs():
                if (leaf.is_set):
                    return True
            for leaf in self.maximum_in_queue_depth.getYLeafs():
                if (leaf.is_set):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.average_in_queue_depth.yfilter != YFilter.not_set or
                self.current_file_descriptors.yfilter != YFilter.not_set or
                self.current_pceq_length.yfilter != YFilter.not_set or
                self.current_teq_length.yfilter != YFilter.not_set or
                self.max_file_descriptors.yfilter != YFilter.not_set or
                self.max_pceq_length.yfilter != YFilter.not_set or
                self.max_teq_length.yfilter != YFilter.not_set or
                self.maximum_in_queue_depth.yfilter != YFilter.not_set or
                self.neighbors.yfilter != YFilter.not_set or
                self.pce_req_pending.yfilter != YFilter.not_set or
                self.pce_req_timed_out.yfilter != YFilter.not_set or
                self.pce_req_total.yfilter != YFilter.not_set or
                self.tunnels.yfilter != YFilter.not_set or
                (self.igp_statistics is not None and self.igp_statistics.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "statistics" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.current_file_descriptors.is_set or self.current_file_descriptors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_file_descriptors.get_name_leafdata())
            if (self.current_pceq_length.is_set or self.current_pceq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_pceq_length.get_name_leafdata())
            if (self.current_teq_length.is_set or self.current_teq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_teq_length.get_name_leafdata())
            if (self.max_file_descriptors.is_set or self.max_file_descriptors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_file_descriptors.get_name_leafdata())
            if (self.max_pceq_length.is_set or self.max_pceq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_pceq_length.get_name_leafdata())
            if (self.max_teq_length.is_set or self.max_teq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_teq_length.get_name_leafdata())
            if (self.neighbors.is_set or self.neighbors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.neighbors.get_name_leafdata())
            if (self.pce_req_pending.is_set or self.pce_req_pending.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_pending.get_name_leafdata())
            if (self.pce_req_timed_out.is_set or self.pce_req_timed_out.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_timed_out.get_name_leafdata())
            if (self.pce_req_total.is_set or self.pce_req_total.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_total.get_name_leafdata())
            if (self.tunnels.is_set or self.tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.tunnels.get_name_leafdata())

            leaf_name_data.extend(self.average_in_queue_depth.get_name_leafdata())

            leaf_name_data.extend(self.maximum_in_queue_depth.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-statistics"):
                if (self.igp_statistics is None):
                    self.igp_statistics = MplsPce.Statistics.IgpStatistics()
                    self.igp_statistics.parent = self
                    self._children_name_map["igp_statistics"] = "igp-statistics"
                return self.igp_statistics

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-statistics" or name == "average-in-queue-depth" or name == "current-file-descriptors" or name == "current-pceq-length" or name == "current-teq-length" or name == "max-file-descriptors" or name == "max-pceq-length" or name == "max-teq-length" or name == "maximum-in-queue-depth" or name == "neighbors" or name == "pce-req-pending" or name == "pce-req-timed-out" or name == "pce-req-total" or name == "tunnels"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "average-in-queue-depth"):
                self.average_in_queue_depth.append(value)
            if(value_path == "current-file-descriptors"):
                self.current_file_descriptors = value
                self.current_file_descriptors.value_namespace = name_space
                self.current_file_descriptors.value_namespace_prefix = name_space_prefix
            if(value_path == "current-pceq-length"):
                self.current_pceq_length = value
                self.current_pceq_length.value_namespace = name_space
                self.current_pceq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "current-teq-length"):
                self.current_teq_length = value
                self.current_teq_length.value_namespace = name_space
                self.current_teq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "max-file-descriptors"):
                self.max_file_descriptors = value
                self.max_file_descriptors.value_namespace = name_space
                self.max_file_descriptors.value_namespace_prefix = name_space_prefix
            if(value_path == "max-pceq-length"):
                self.max_pceq_length = value
                self.max_pceq_length.value_namespace = name_space
                self.max_pceq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "max-teq-length"):
                self.max_teq_length = value
                self.max_teq_length.value_namespace = name_space
                self.max_teq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "maximum-in-queue-depth"):
                self.maximum_in_queue_depth.append(value)
            if(value_path == "neighbors"):
                self.neighbors = value
                self.neighbors.value_namespace = name_space
                self.neighbors.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-pending"):
                self.pce_req_pending = value
                self.pce_req_pending.value_namespace = name_space
                self.pce_req_pending.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-timed-out"):
                self.pce_req_timed_out = value
                self.pce_req_timed_out.value_namespace = name_space
                self.pce_req_timed_out.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-total"):
                self.pce_req_total = value
                self.pce_req_total.value_namespace = name_space
                self.pce_req_total.value_namespace_prefix = name_space_prefix
            if(value_path == "tunnels"):
                self.tunnels = value
                self.tunnels.value_namespace = name_space
                self.tunnels.value_namespace_prefix = name_space_prefix


    class Peers(Entity):
        """
        The set of PCE peers
        
        .. attribute:: peer
        
        	A PCE peer
        	**type**\: list of    :py:class:`Peer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPce.Peers, self).__init__()

            self.yang_name = "peers"
            self.yang_parent_name = "mpls-pce"

            self.peer = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPce.Peers, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPce.Peers, self).__setattr__(name, value)


        class Peer(Entity):
            """
            A PCE peer
            
            .. attribute:: peer_address  <key>
            
            	The peer address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: candidate
            
            	Candidate
            	**type**\:  bool
            
            .. attribute:: capability_db_version
            
            	DB version capability
            	**type**\:  bool
            
            .. attribute:: capability_instantiate
            
            	Instantiation capability
            	**type**\:  bool
            
            .. attribute:: capability_segment_routing
            
            	Segment Routing capability
            	**type**\:  bool
            
            .. attribute:: capability_update
            
            	Update capability
            	**type**\:  bool
            
            .. attribute:: delta_sync_capability
            
            	Delta Synchronization capability
            	**type**\:  bool
            
            .. attribute:: error
            
            	Error (for display only)
            	**type**\:  str
            
            .. attribute:: ig_ps
            
            	IGPs
            	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.IgPs>`
            
            .. attribute:: keepalives
            
            	Keepalive count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: keychain_enabled
            
            	Keychain based Authentication Enabled
            	**type**\:  bool
            
            .. attribute:: last_rx_pce_err
            
            	Last received PCEErr
            	**type**\:   :py:class:`LastRxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.LastRxPceErr>`
            
            .. attribute:: last_tx_pce_err
            
            	Last sent PCEErr
            	**type**\:   :py:class:`LastTxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.LastTxPceErr>`
            
            .. attribute:: local_sid
            
            	Local PCEP session ID
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: max_dead_interval
            
            	Maximum dead interval for the peer
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: md5_enabled
            
            	MD5 Authentication Enabled
            	**type**\:  bool
            
            .. attribute:: min_keepalive_interval
            
            	Minimum keepalive interval for the peer
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: negotated_dead_time
            
            	Negotiated DT
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: negotiated_keepalive
            
            	Negotiated KA
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_err_rx
            
            	PCEErr Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_err_tx
            
            	PCEErr Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_init_rx
            
            	PCEInit Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_init_tx
            
            	PCEInit Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_keepalive_rx
            
            	PCE Keepalive Rx
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: pce_keepalive_tx
            
            	PCE Keepalive Tx
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: pce_open_rx
            
            	PCEOpen Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_open_tx
            
            	PCEOpen Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rep_rx
            
            	PCERep Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rep_tx
            
            	PCERep Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_req_rx
            
            	PCEReq Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_req_tx
            
            	PCEReq Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rpt_rx
            
            	PCERpt Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rpt_tx
            
            	PCERpt Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_state
            
            	PCE State
            	**type**\:   :py:class:`PceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceState>`
            
            .. attribute:: pce_upd_rx
            
            	PCEUpd Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_upd_tx
            
            	PCEUpd Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pcep_up_time
            
            	PCEP Up Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: precedence
            
            	PCE Precedence
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: remote_sid
            
            	Remote PCEP session ID
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: req_reply_avg
            
            	Average reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: req_reply_max
            
            	Maximum reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: req_reply_min
            
            	Mininum reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: request_timeouts
            
            	Request timeout count
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: stateful
            
            	Stateful
            	**type**\:  bool
            
            .. attribute:: statically_configured
            
            	Statically Configured
            	**type**\:  bool
            
            .. attribute:: triggered_sync_capability
            
            	Triggered Synchronization capability
            	**type**\:  bool
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Peers.Peer, self).__init__()

                self.yang_name = "peer"
                self.yang_parent_name = "peers"

                self.peer_address = YLeaf(YType.str, "peer-address")

                self.candidate = YLeaf(YType.boolean, "candidate")

                self.capability_db_version = YLeaf(YType.boolean, "capability-db-version")

                self.capability_instantiate = YLeaf(YType.boolean, "capability-instantiate")

                self.capability_segment_routing = YLeaf(YType.boolean, "capability-segment-routing")

                self.capability_update = YLeaf(YType.boolean, "capability-update")

                self.delta_sync_capability = YLeaf(YType.boolean, "delta-sync-capability")

                self.error = YLeaf(YType.str, "error")

                self.keepalives = YLeaf(YType.uint32, "keepalives")

                self.keychain_enabled = YLeaf(YType.boolean, "keychain-enabled")

                self.local_sid = YLeaf(YType.uint8, "local-sid")

                self.max_dead_interval = YLeaf(YType.uint8, "max-dead-interval")

                self.md5_enabled = YLeaf(YType.boolean, "md5-enabled")

                self.min_keepalive_interval = YLeaf(YType.uint8, "min-keepalive-interval")

                self.negotated_dead_time = YLeaf(YType.uint32, "negotated-dead-time")

                self.negotiated_keepalive = YLeaf(YType.uint32, "negotiated-keepalive")

                self.pce_err_rx = YLeaf(YType.uint32, "pce-err-rx")

                self.pce_err_tx = YLeaf(YType.uint32, "pce-err-tx")

                self.pce_init_rx = YLeaf(YType.uint32, "pce-init-rx")

                self.pce_init_tx = YLeaf(YType.uint32, "pce-init-tx")

                self.pce_keepalive_rx = YLeaf(YType.uint64, "pce-keepalive-rx")

                self.pce_keepalive_tx = YLeaf(YType.uint64, "pce-keepalive-tx")

                self.pce_open_rx = YLeaf(YType.uint32, "pce-open-rx")

                self.pce_open_tx = YLeaf(YType.uint32, "pce-open-tx")

                self.pce_rep_rx = YLeaf(YType.uint32, "pce-rep-rx")

                self.pce_rep_tx = YLeaf(YType.uint32, "pce-rep-tx")

                self.pce_req_rx = YLeaf(YType.uint32, "pce-req-rx")

                self.pce_req_tx = YLeaf(YType.uint32, "pce-req-tx")

                self.pce_rpt_rx = YLeaf(YType.uint32, "pce-rpt-rx")

                self.pce_rpt_tx = YLeaf(YType.uint32, "pce-rpt-tx")

                self.pce_state = YLeaf(YType.enumeration, "pce-state")

                self.pce_upd_rx = YLeaf(YType.uint32, "pce-upd-rx")

                self.pce_upd_tx = YLeaf(YType.uint32, "pce-upd-tx")

                self.pcep_up_time = YLeaf(YType.uint32, "pcep-up-time")

                self.precedence = YLeaf(YType.uint32, "precedence")

                self.remote_sid = YLeaf(YType.uint8, "remote-sid")

                self.req_reply_avg = YLeaf(YType.uint64, "req-reply-avg")

                self.req_reply_max = YLeaf(YType.uint64, "req-reply-max")

                self.req_reply_min = YLeaf(YType.uint64, "req-reply-min")

                self.request_timeouts = YLeaf(YType.uint64, "request-timeouts")

                self.stateful = YLeaf(YType.boolean, "stateful")

                self.statically_configured = YLeaf(YType.boolean, "statically-configured")

                self.triggered_sync_capability = YLeaf(YType.boolean, "triggered-sync-capability")

                self.last_rx_pce_err = MplsPce.Peers.Peer.LastRxPceErr()
                self.last_rx_pce_err.parent = self
                self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"
                self._children_yang_names.add("last-rx-pce-err")

                self.last_tx_pce_err = MplsPce.Peers.Peer.LastTxPceErr()
                self.last_tx_pce_err.parent = self
                self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"
                self._children_yang_names.add("last-tx-pce-err")

                self.ig_ps = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("peer_address",
                                "candidate",
                                "capability_db_version",
                                "capability_instantiate",
                                "capability_segment_routing",
                                "capability_update",
                                "delta_sync_capability",
                                "error",
                                "keepalives",
                                "keychain_enabled",
                                "local_sid",
                                "max_dead_interval",
                                "md5_enabled",
                                "min_keepalive_interval",
                                "negotated_dead_time",
                                "negotiated_keepalive",
                                "pce_err_rx",
                                "pce_err_tx",
                                "pce_init_rx",
                                "pce_init_tx",
                                "pce_keepalive_rx",
                                "pce_keepalive_tx",
                                "pce_open_rx",
                                "pce_open_tx",
                                "pce_rep_rx",
                                "pce_rep_tx",
                                "pce_req_rx",
                                "pce_req_tx",
                                "pce_rpt_rx",
                                "pce_rpt_tx",
                                "pce_state",
                                "pce_upd_rx",
                                "pce_upd_tx",
                                "pcep_up_time",
                                "precedence",
                                "remote_sid",
                                "req_reply_avg",
                                "req_reply_max",
                                "req_reply_min",
                                "request_timeouts",
                                "stateful",
                                "statically_configured",
                                "triggered_sync_capability") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Peers.Peer, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Peers.Peer, self).__setattr__(name, value)


            class LastTxPceErr(Entity):
                """
                Last sent PCEErr
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\:  bool
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\:  bool
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Peers.Peer.LastTxPceErr, self).__init__()

                    self.yang_name = "last-tx-pce-err"
                    self.yang_parent_name = "peer"

                    self.has_open_object = YLeaf(YType.boolean, "has-open-object")

                    self.has_rp_object = YLeaf(YType.boolean, "has-rp-object")

                    self.open_dead_time = YLeaf(YType.uint32, "open-dead-time")

                    self.open_keepalive = YLeaf(YType.uint32, "open-keepalive")

                    self.openversion = YLeaf(YType.uint32, "openversion")

                    self.pce_err_type = YLeaf(YType.uint32, "pce-err-type")

                    self.pce_err_value = YLeaf(YType.uint32, "pce-err-value")

                    self.rp_request_id = YLeaf(YType.uint32, "rp-request-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("has_open_object",
                                    "has_rp_object",
                                    "open_dead_time",
                                    "open_keepalive",
                                    "openversion",
                                    "pce_err_type",
                                    "pce_err_value",
                                    "rp_request_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Peers.Peer.LastTxPceErr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Peers.Peer.LastTxPceErr, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.has_open_object.is_set or
                        self.has_rp_object.is_set or
                        self.open_dead_time.is_set or
                        self.open_keepalive.is_set or
                        self.openversion.is_set or
                        self.pce_err_type.is_set or
                        self.pce_err_value.is_set or
                        self.rp_request_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.has_open_object.yfilter != YFilter.not_set or
                        self.has_rp_object.yfilter != YFilter.not_set or
                        self.open_dead_time.yfilter != YFilter.not_set or
                        self.open_keepalive.yfilter != YFilter.not_set or
                        self.openversion.yfilter != YFilter.not_set or
                        self.pce_err_type.yfilter != YFilter.not_set or
                        self.pce_err_value.yfilter != YFilter.not_set or
                        self.rp_request_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-tx-pce-err" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.has_open_object.is_set or self.has_open_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_open_object.get_name_leafdata())
                    if (self.has_rp_object.is_set or self.has_rp_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_rp_object.get_name_leafdata())
                    if (self.open_dead_time.is_set or self.open_dead_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_dead_time.get_name_leafdata())
                    if (self.open_keepalive.is_set or self.open_keepalive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_keepalive.get_name_leafdata())
                    if (self.openversion.is_set or self.openversion.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.openversion.get_name_leafdata())
                    if (self.pce_err_type.is_set or self.pce_err_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_type.get_name_leafdata())
                    if (self.pce_err_value.is_set or self.pce_err_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_value.get_name_leafdata())
                    if (self.rp_request_id.is_set or self.rp_request_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rp_request_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "has-open-object" or name == "has-rp-object" or name == "open-dead-time" or name == "open-keepalive" or name == "openversion" or name == "pce-err-type" or name == "pce-err-value" or name == "rp-request-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "has-open-object"):
                        self.has_open_object = value
                        self.has_open_object.value_namespace = name_space
                        self.has_open_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-rp-object"):
                        self.has_rp_object = value
                        self.has_rp_object.value_namespace = name_space
                        self.has_rp_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-dead-time"):
                        self.open_dead_time = value
                        self.open_dead_time.value_namespace = name_space
                        self.open_dead_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-keepalive"):
                        self.open_keepalive = value
                        self.open_keepalive.value_namespace = name_space
                        self.open_keepalive.value_namespace_prefix = name_space_prefix
                    if(value_path == "openversion"):
                        self.openversion = value
                        self.openversion.value_namespace = name_space
                        self.openversion.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-type"):
                        self.pce_err_type = value
                        self.pce_err_type.value_namespace = name_space
                        self.pce_err_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-value"):
                        self.pce_err_value = value
                        self.pce_err_value.value_namespace = name_space
                        self.pce_err_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "rp-request-id"):
                        self.rp_request_id = value
                        self.rp_request_id.value_namespace = name_space
                        self.rp_request_id.value_namespace_prefix = name_space_prefix


            class LastRxPceErr(Entity):
                """
                Last received PCEErr
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\:  bool
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\:  bool
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Peers.Peer.LastRxPceErr, self).__init__()

                    self.yang_name = "last-rx-pce-err"
                    self.yang_parent_name = "peer"

                    self.has_open_object = YLeaf(YType.boolean, "has-open-object")

                    self.has_rp_object = YLeaf(YType.boolean, "has-rp-object")

                    self.open_dead_time = YLeaf(YType.uint32, "open-dead-time")

                    self.open_keepalive = YLeaf(YType.uint32, "open-keepalive")

                    self.openversion = YLeaf(YType.uint32, "openversion")

                    self.pce_err_type = YLeaf(YType.uint32, "pce-err-type")

                    self.pce_err_value = YLeaf(YType.uint32, "pce-err-value")

                    self.rp_request_id = YLeaf(YType.uint32, "rp-request-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("has_open_object",
                                    "has_rp_object",
                                    "open_dead_time",
                                    "open_keepalive",
                                    "openversion",
                                    "pce_err_type",
                                    "pce_err_value",
                                    "rp_request_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Peers.Peer.LastRxPceErr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Peers.Peer.LastRxPceErr, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.has_open_object.is_set or
                        self.has_rp_object.is_set or
                        self.open_dead_time.is_set or
                        self.open_keepalive.is_set or
                        self.openversion.is_set or
                        self.pce_err_type.is_set or
                        self.pce_err_value.is_set or
                        self.rp_request_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.has_open_object.yfilter != YFilter.not_set or
                        self.has_rp_object.yfilter != YFilter.not_set or
                        self.open_dead_time.yfilter != YFilter.not_set or
                        self.open_keepalive.yfilter != YFilter.not_set or
                        self.openversion.yfilter != YFilter.not_set or
                        self.pce_err_type.yfilter != YFilter.not_set or
                        self.pce_err_value.yfilter != YFilter.not_set or
                        self.rp_request_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-rx-pce-err" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.has_open_object.is_set or self.has_open_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_open_object.get_name_leafdata())
                    if (self.has_rp_object.is_set or self.has_rp_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_rp_object.get_name_leafdata())
                    if (self.open_dead_time.is_set or self.open_dead_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_dead_time.get_name_leafdata())
                    if (self.open_keepalive.is_set or self.open_keepalive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_keepalive.get_name_leafdata())
                    if (self.openversion.is_set or self.openversion.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.openversion.get_name_leafdata())
                    if (self.pce_err_type.is_set or self.pce_err_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_type.get_name_leafdata())
                    if (self.pce_err_value.is_set or self.pce_err_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_value.get_name_leafdata())
                    if (self.rp_request_id.is_set or self.rp_request_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rp_request_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "has-open-object" or name == "has-rp-object" or name == "open-dead-time" or name == "open-keepalive" or name == "openversion" or name == "pce-err-type" or name == "pce-err-value" or name == "rp-request-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "has-open-object"):
                        self.has_open_object = value
                        self.has_open_object.value_namespace = name_space
                        self.has_open_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-rp-object"):
                        self.has_rp_object = value
                        self.has_rp_object.value_namespace = name_space
                        self.has_rp_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-dead-time"):
                        self.open_dead_time = value
                        self.open_dead_time.value_namespace = name_space
                        self.open_dead_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-keepalive"):
                        self.open_keepalive = value
                        self.open_keepalive.value_namespace = name_space
                        self.open_keepalive.value_namespace_prefix = name_space_prefix
                    if(value_path == "openversion"):
                        self.openversion = value
                        self.openversion.value_namespace = name_space
                        self.openversion.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-type"):
                        self.pce_err_type = value
                        self.pce_err_type.value_namespace = name_space
                        self.pce_err_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-value"):
                        self.pce_err_value = value
                        self.pce_err_value.value_namespace = name_space
                        self.pce_err_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "rp-request-id"):
                        self.rp_request_id = value
                        self.rp_request_id.value_namespace = name_space
                        self.rp_request_id.value_namespace_prefix = name_space_prefix


            class IgPs(Entity):
                """
                IGPs
                
                .. attribute:: igp_instance_id
                
                	Instance ID
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	Type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Peers.Peer.IgPs, self).__init__()

                    self.yang_name = "ig-ps"
                    self.yang_parent_name = "peer"

                    self.igp_instance_id = YLeaf(YType.str, "igp-instance-id")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("igp_instance_id",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Peers.Peer.IgPs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Peers.Peer.IgPs, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.igp_instance_id.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.igp_instance_id.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ig-ps" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.igp_instance_id.is_set or self.igp_instance_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance_id.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "igp-instance-id" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "igp-instance-id"):
                        self.igp_instance_id = value
                        self.igp_instance_id.value_namespace = name_space
                        self.igp_instance_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.ig_ps:
                    if (c.has_data()):
                        return True
                return (
                    self.peer_address.is_set or
                    self.candidate.is_set or
                    self.capability_db_version.is_set or
                    self.capability_instantiate.is_set or
                    self.capability_segment_routing.is_set or
                    self.capability_update.is_set or
                    self.delta_sync_capability.is_set or
                    self.error.is_set or
                    self.keepalives.is_set or
                    self.keychain_enabled.is_set or
                    self.local_sid.is_set or
                    self.max_dead_interval.is_set or
                    self.md5_enabled.is_set or
                    self.min_keepalive_interval.is_set or
                    self.negotated_dead_time.is_set or
                    self.negotiated_keepalive.is_set or
                    self.pce_err_rx.is_set or
                    self.pce_err_tx.is_set or
                    self.pce_init_rx.is_set or
                    self.pce_init_tx.is_set or
                    self.pce_keepalive_rx.is_set or
                    self.pce_keepalive_tx.is_set or
                    self.pce_open_rx.is_set or
                    self.pce_open_tx.is_set or
                    self.pce_rep_rx.is_set or
                    self.pce_rep_tx.is_set or
                    self.pce_req_rx.is_set or
                    self.pce_req_tx.is_set or
                    self.pce_rpt_rx.is_set or
                    self.pce_rpt_tx.is_set or
                    self.pce_state.is_set or
                    self.pce_upd_rx.is_set or
                    self.pce_upd_tx.is_set or
                    self.pcep_up_time.is_set or
                    self.precedence.is_set or
                    self.remote_sid.is_set or
                    self.req_reply_avg.is_set or
                    self.req_reply_max.is_set or
                    self.req_reply_min.is_set or
                    self.request_timeouts.is_set or
                    self.stateful.is_set or
                    self.statically_configured.is_set or
                    self.triggered_sync_capability.is_set or
                    (self.last_rx_pce_err is not None and self.last_rx_pce_err.has_data()) or
                    (self.last_tx_pce_err is not None and self.last_tx_pce_err.has_data()))

            def has_operation(self):
                for c in self.ig_ps:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.peer_address.yfilter != YFilter.not_set or
                    self.candidate.yfilter != YFilter.not_set or
                    self.capability_db_version.yfilter != YFilter.not_set or
                    self.capability_instantiate.yfilter != YFilter.not_set or
                    self.capability_segment_routing.yfilter != YFilter.not_set or
                    self.capability_update.yfilter != YFilter.not_set or
                    self.delta_sync_capability.yfilter != YFilter.not_set or
                    self.error.yfilter != YFilter.not_set or
                    self.keepalives.yfilter != YFilter.not_set or
                    self.keychain_enabled.yfilter != YFilter.not_set or
                    self.local_sid.yfilter != YFilter.not_set or
                    self.max_dead_interval.yfilter != YFilter.not_set or
                    self.md5_enabled.yfilter != YFilter.not_set or
                    self.min_keepalive_interval.yfilter != YFilter.not_set or
                    self.negotated_dead_time.yfilter != YFilter.not_set or
                    self.negotiated_keepalive.yfilter != YFilter.not_set or
                    self.pce_err_rx.yfilter != YFilter.not_set or
                    self.pce_err_tx.yfilter != YFilter.not_set or
                    self.pce_init_rx.yfilter != YFilter.not_set or
                    self.pce_init_tx.yfilter != YFilter.not_set or
                    self.pce_keepalive_rx.yfilter != YFilter.not_set or
                    self.pce_keepalive_tx.yfilter != YFilter.not_set or
                    self.pce_open_rx.yfilter != YFilter.not_set or
                    self.pce_open_tx.yfilter != YFilter.not_set or
                    self.pce_rep_rx.yfilter != YFilter.not_set or
                    self.pce_rep_tx.yfilter != YFilter.not_set or
                    self.pce_req_rx.yfilter != YFilter.not_set or
                    self.pce_req_tx.yfilter != YFilter.not_set or
                    self.pce_rpt_rx.yfilter != YFilter.not_set or
                    self.pce_rpt_tx.yfilter != YFilter.not_set or
                    self.pce_state.yfilter != YFilter.not_set or
                    self.pce_upd_rx.yfilter != YFilter.not_set or
                    self.pce_upd_tx.yfilter != YFilter.not_set or
                    self.pcep_up_time.yfilter != YFilter.not_set or
                    self.precedence.yfilter != YFilter.not_set or
                    self.remote_sid.yfilter != YFilter.not_set or
                    self.req_reply_avg.yfilter != YFilter.not_set or
                    self.req_reply_max.yfilter != YFilter.not_set or
                    self.req_reply_min.yfilter != YFilter.not_set or
                    self.request_timeouts.yfilter != YFilter.not_set or
                    self.stateful.yfilter != YFilter.not_set or
                    self.statically_configured.yfilter != YFilter.not_set or
                    self.triggered_sync_capability.yfilter != YFilter.not_set or
                    (self.last_rx_pce_err is not None and self.last_rx_pce_err.has_operation()) or
                    (self.last_tx_pce_err is not None and self.last_tx_pce_err.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "peer" + "[peer-address='" + self.peer_address.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/peers/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.peer_address.is_set or self.peer_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.peer_address.get_name_leafdata())
                if (self.candidate.is_set or self.candidate.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.candidate.get_name_leafdata())
                if (self.capability_db_version.is_set or self.capability_db_version.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_db_version.get_name_leafdata())
                if (self.capability_instantiate.is_set or self.capability_instantiate.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_instantiate.get_name_leafdata())
                if (self.capability_segment_routing.is_set or self.capability_segment_routing.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_segment_routing.get_name_leafdata())
                if (self.capability_update.is_set or self.capability_update.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_update.get_name_leafdata())
                if (self.delta_sync_capability.is_set or self.delta_sync_capability.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delta_sync_capability.get_name_leafdata())
                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.error.get_name_leafdata())
                if (self.keepalives.is_set or self.keepalives.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.keepalives.get_name_leafdata())
                if (self.keychain_enabled.is_set or self.keychain_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.keychain_enabled.get_name_leafdata())
                if (self.local_sid.is_set or self.local_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_sid.get_name_leafdata())
                if (self.max_dead_interval.is_set or self.max_dead_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.max_dead_interval.get_name_leafdata())
                if (self.md5_enabled.is_set or self.md5_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.md5_enabled.get_name_leafdata())
                if (self.min_keepalive_interval.is_set or self.min_keepalive_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.min_keepalive_interval.get_name_leafdata())
                if (self.negotated_dead_time.is_set or self.negotated_dead_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.negotated_dead_time.get_name_leafdata())
                if (self.negotiated_keepalive.is_set or self.negotiated_keepalive.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.negotiated_keepalive.get_name_leafdata())
                if (self.pce_err_rx.is_set or self.pce_err_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_err_rx.get_name_leafdata())
                if (self.pce_err_tx.is_set or self.pce_err_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_err_tx.get_name_leafdata())
                if (self.pce_init_rx.is_set or self.pce_init_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_init_rx.get_name_leafdata())
                if (self.pce_init_tx.is_set or self.pce_init_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_init_tx.get_name_leafdata())
                if (self.pce_keepalive_rx.is_set or self.pce_keepalive_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_keepalive_rx.get_name_leafdata())
                if (self.pce_keepalive_tx.is_set or self.pce_keepalive_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_keepalive_tx.get_name_leafdata())
                if (self.pce_open_rx.is_set or self.pce_open_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_open_rx.get_name_leafdata())
                if (self.pce_open_tx.is_set or self.pce_open_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_open_tx.get_name_leafdata())
                if (self.pce_rep_rx.is_set or self.pce_rep_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rep_rx.get_name_leafdata())
                if (self.pce_rep_tx.is_set or self.pce_rep_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rep_tx.get_name_leafdata())
                if (self.pce_req_rx.is_set or self.pce_req_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_req_rx.get_name_leafdata())
                if (self.pce_req_tx.is_set or self.pce_req_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_req_tx.get_name_leafdata())
                if (self.pce_rpt_rx.is_set or self.pce_rpt_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rpt_rx.get_name_leafdata())
                if (self.pce_rpt_tx.is_set or self.pce_rpt_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rpt_tx.get_name_leafdata())
                if (self.pce_state.is_set or self.pce_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_state.get_name_leafdata())
                if (self.pce_upd_rx.is_set or self.pce_upd_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_upd_rx.get_name_leafdata())
                if (self.pce_upd_tx.is_set or self.pce_upd_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_upd_tx.get_name_leafdata())
                if (self.pcep_up_time.is_set or self.pcep_up_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcep_up_time.get_name_leafdata())
                if (self.precedence.is_set or self.precedence.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.precedence.get_name_leafdata())
                if (self.remote_sid.is_set or self.remote_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.remote_sid.get_name_leafdata())
                if (self.req_reply_avg.is_set or self.req_reply_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_avg.get_name_leafdata())
                if (self.req_reply_max.is_set or self.req_reply_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_max.get_name_leafdata())
                if (self.req_reply_min.is_set or self.req_reply_min.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_min.get_name_leafdata())
                if (self.request_timeouts.is_set or self.request_timeouts.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.request_timeouts.get_name_leafdata())
                if (self.stateful.is_set or self.stateful.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stateful.get_name_leafdata())
                if (self.statically_configured.is_set or self.statically_configured.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.statically_configured.get_name_leafdata())
                if (self.triggered_sync_capability.is_set or self.triggered_sync_capability.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.triggered_sync_capability.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ig-ps"):
                    for c in self.ig_ps:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPce.Peers.Peer.IgPs()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.ig_ps.append(c)
                    return c

                if (child_yang_name == "last-rx-pce-err"):
                    if (self.last_rx_pce_err is None):
                        self.last_rx_pce_err = MplsPce.Peers.Peer.LastRxPceErr()
                        self.last_rx_pce_err.parent = self
                        self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"
                    return self.last_rx_pce_err

                if (child_yang_name == "last-tx-pce-err"):
                    if (self.last_tx_pce_err is None):
                        self.last_tx_pce_err = MplsPce.Peers.Peer.LastTxPceErr()
                        self.last_tx_pce_err.parent = self
                        self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"
                    return self.last_tx_pce_err

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ig-ps" or name == "last-rx-pce-err" or name == "last-tx-pce-err" or name == "peer-address" or name == "candidate" or name == "capability-db-version" or name == "capability-instantiate" or name == "capability-segment-routing" or name == "capability-update" or name == "delta-sync-capability" or name == "error" or name == "keepalives" or name == "keychain-enabled" or name == "local-sid" or name == "max-dead-interval" or name == "md5-enabled" or name == "min-keepalive-interval" or name == "negotated-dead-time" or name == "negotiated-keepalive" or name == "pce-err-rx" or name == "pce-err-tx" or name == "pce-init-rx" or name == "pce-init-tx" or name == "pce-keepalive-rx" or name == "pce-keepalive-tx" or name == "pce-open-rx" or name == "pce-open-tx" or name == "pce-rep-rx" or name == "pce-rep-tx" or name == "pce-req-rx" or name == "pce-req-tx" or name == "pce-rpt-rx" or name == "pce-rpt-tx" or name == "pce-state" or name == "pce-upd-rx" or name == "pce-upd-tx" or name == "pcep-up-time" or name == "precedence" or name == "remote-sid" or name == "req-reply-avg" or name == "req-reply-max" or name == "req-reply-min" or name == "request-timeouts" or name == "stateful" or name == "statically-configured" or name == "triggered-sync-capability"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "peer-address"):
                    self.peer_address = value
                    self.peer_address.value_namespace = name_space
                    self.peer_address.value_namespace_prefix = name_space_prefix
                if(value_path == "candidate"):
                    self.candidate = value
                    self.candidate.value_namespace = name_space
                    self.candidate.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-db-version"):
                    self.capability_db_version = value
                    self.capability_db_version.value_namespace = name_space
                    self.capability_db_version.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-instantiate"):
                    self.capability_instantiate = value
                    self.capability_instantiate.value_namespace = name_space
                    self.capability_instantiate.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-segment-routing"):
                    self.capability_segment_routing = value
                    self.capability_segment_routing.value_namespace = name_space
                    self.capability_segment_routing.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-update"):
                    self.capability_update = value
                    self.capability_update.value_namespace = name_space
                    self.capability_update.value_namespace_prefix = name_space_prefix
                if(value_path == "delta-sync-capability"):
                    self.delta_sync_capability = value
                    self.delta_sync_capability.value_namespace = name_space
                    self.delta_sync_capability.value_namespace_prefix = name_space_prefix
                if(value_path == "error"):
                    self.error = value
                    self.error.value_namespace = name_space
                    self.error.value_namespace_prefix = name_space_prefix
                if(value_path == "keepalives"):
                    self.keepalives = value
                    self.keepalives.value_namespace = name_space
                    self.keepalives.value_namespace_prefix = name_space_prefix
                if(value_path == "keychain-enabled"):
                    self.keychain_enabled = value
                    self.keychain_enabled.value_namespace = name_space
                    self.keychain_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "local-sid"):
                    self.local_sid = value
                    self.local_sid.value_namespace = name_space
                    self.local_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "max-dead-interval"):
                    self.max_dead_interval = value
                    self.max_dead_interval.value_namespace = name_space
                    self.max_dead_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "md5-enabled"):
                    self.md5_enabled = value
                    self.md5_enabled.value_namespace = name_space
                    self.md5_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "min-keepalive-interval"):
                    self.min_keepalive_interval = value
                    self.min_keepalive_interval.value_namespace = name_space
                    self.min_keepalive_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "negotated-dead-time"):
                    self.negotated_dead_time = value
                    self.negotated_dead_time.value_namespace = name_space
                    self.negotated_dead_time.value_namespace_prefix = name_space_prefix
                if(value_path == "negotiated-keepalive"):
                    self.negotiated_keepalive = value
                    self.negotiated_keepalive.value_namespace = name_space
                    self.negotiated_keepalive.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-err-rx"):
                    self.pce_err_rx = value
                    self.pce_err_rx.value_namespace = name_space
                    self.pce_err_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-err-tx"):
                    self.pce_err_tx = value
                    self.pce_err_tx.value_namespace = name_space
                    self.pce_err_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-init-rx"):
                    self.pce_init_rx = value
                    self.pce_init_rx.value_namespace = name_space
                    self.pce_init_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-init-tx"):
                    self.pce_init_tx = value
                    self.pce_init_tx.value_namespace = name_space
                    self.pce_init_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-keepalive-rx"):
                    self.pce_keepalive_rx = value
                    self.pce_keepalive_rx.value_namespace = name_space
                    self.pce_keepalive_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-keepalive-tx"):
                    self.pce_keepalive_tx = value
                    self.pce_keepalive_tx.value_namespace = name_space
                    self.pce_keepalive_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-open-rx"):
                    self.pce_open_rx = value
                    self.pce_open_rx.value_namespace = name_space
                    self.pce_open_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-open-tx"):
                    self.pce_open_tx = value
                    self.pce_open_tx.value_namespace = name_space
                    self.pce_open_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rep-rx"):
                    self.pce_rep_rx = value
                    self.pce_rep_rx.value_namespace = name_space
                    self.pce_rep_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rep-tx"):
                    self.pce_rep_tx = value
                    self.pce_rep_tx.value_namespace = name_space
                    self.pce_rep_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-req-rx"):
                    self.pce_req_rx = value
                    self.pce_req_rx.value_namespace = name_space
                    self.pce_req_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-req-tx"):
                    self.pce_req_tx = value
                    self.pce_req_tx.value_namespace = name_space
                    self.pce_req_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rpt-rx"):
                    self.pce_rpt_rx = value
                    self.pce_rpt_rx.value_namespace = name_space
                    self.pce_rpt_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rpt-tx"):
                    self.pce_rpt_tx = value
                    self.pce_rpt_tx.value_namespace = name_space
                    self.pce_rpt_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-state"):
                    self.pce_state = value
                    self.pce_state.value_namespace = name_space
                    self.pce_state.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-upd-rx"):
                    self.pce_upd_rx = value
                    self.pce_upd_rx.value_namespace = name_space
                    self.pce_upd_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-upd-tx"):
                    self.pce_upd_tx = value
                    self.pce_upd_tx.value_namespace = name_space
                    self.pce_upd_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pcep-up-time"):
                    self.pcep_up_time = value
                    self.pcep_up_time.value_namespace = name_space
                    self.pcep_up_time.value_namespace_prefix = name_space_prefix
                if(value_path == "precedence"):
                    self.precedence = value
                    self.precedence.value_namespace = name_space
                    self.precedence.value_namespace_prefix = name_space_prefix
                if(value_path == "remote-sid"):
                    self.remote_sid = value
                    self.remote_sid.value_namespace = name_space
                    self.remote_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-avg"):
                    self.req_reply_avg = value
                    self.req_reply_avg.value_namespace = name_space
                    self.req_reply_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-max"):
                    self.req_reply_max = value
                    self.req_reply_max.value_namespace = name_space
                    self.req_reply_max.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-min"):
                    self.req_reply_min = value
                    self.req_reply_min.value_namespace = name_space
                    self.req_reply_min.value_namespace_prefix = name_space_prefix
                if(value_path == "request-timeouts"):
                    self.request_timeouts = value
                    self.request_timeouts.value_namespace = name_space
                    self.request_timeouts.value_namespace_prefix = name_space_prefix
                if(value_path == "stateful"):
                    self.stateful = value
                    self.stateful.value_namespace = name_space
                    self.stateful.value_namespace_prefix = name_space_prefix
                if(value_path == "statically-configured"):
                    self.statically_configured = value
                    self.statically_configured.value_namespace = name_space
                    self.statically_configured.value_namespace_prefix = name_space_prefix
                if(value_path == "triggered-sync-capability"):
                    self.triggered_sync_capability = value
                    self.triggered_sync_capability.value_namespace = name_space
                    self.triggered_sync_capability.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.peer:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.peer:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "peers" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "peer"):
                for c in self.peer:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPce.Peers.Peer()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.peer.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "peer"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Topology(Entity):
        """
        The topology information in PCE
        
        .. attribute:: global_
        
        	The global information of the overall  topology
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology.Global_>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPce.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-pce"

            self.global_ = MplsPce.Topology.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")


        class Global_(Entity):
            """
            The global information of the overall  topology
            
            .. attribute:: nodes
            
            	Node information
            	**type**\: list of    :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology.Global_.Nodes>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Topology.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"

                self.nodes = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Topology.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Topology.Global_, self).__setattr__(name, value)


            class Nodes(Entity):
                """
                Node information
                
                .. attribute:: igp_area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: igp_area_id
                
                	IGP Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_pce_border_node
                
                	PCE border node
                	**type**\:  bool
                
                .. attribute:: node_id
                
                	Node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: pce_cost
                
                	PCE cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: router_id
                
                	Router ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPce.Topology.Global_.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "global"

                    self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                    self.igp_area_id = YLeaf(YType.uint32, "igp-area-id")

                    self.is_pce_border_node = YLeaf(YType.boolean, "is-pce-border-node")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.pce_cost = YLeaf(YType.uint32, "pce-cost")

                    self.router_id = YLeaf(YType.str, "router-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("igp_area_format",
                                    "igp_area_id",
                                    "is_pce_border_node",
                                    "node_id",
                                    "pce_cost",
                                    "router_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPce.Topology.Global_.Nodes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPce.Topology.Global_.Nodes, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.igp_area_format.is_set or
                        self.igp_area_id.is_set or
                        self.is_pce_border_node.is_set or
                        self.node_id.is_set or
                        self.pce_cost.is_set or
                        self.router_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.igp_area_format.yfilter != YFilter.not_set or
                        self.igp_area_id.yfilter != YFilter.not_set or
                        self.is_pce_border_node.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.pce_cost.yfilter != YFilter.not_set or
                        self.router_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nodes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/topology/global/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                    if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area_id.get_name_leafdata())
                    if (self.is_pce_border_node.is_set or self.is_pce_border_node.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_border_node.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.pce_cost.is_set or self.pce_cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_cost.get_name_leafdata())
                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.router_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "igp-area-format" or name == "igp-area-id" or name == "is-pce-border-node" or name == "node-id" or name == "pce-cost" or name == "router-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "igp-area-format"):
                        self.igp_area_format = value
                        self.igp_area_format.value_namespace = name_space
                        self.igp_area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area-id"):
                        self.igp_area_id = value
                        self.igp_area_id.value_namespace = name_space
                        self.igp_area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-border-node"):
                        self.is_pce_border_node = value
                        self.is_pce_border_node.value_namespace = name_space
                        self.is_pce_border_node.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-cost"):
                        self.pce_cost = value
                        self.pce_cost.value_namespace = name_space
                        self.pce_cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "router-id"):
                        self.router_id = value
                        self.router_id.value_namespace = name_space
                        self.router_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.nodes:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.nodes:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nodes"):
                    for c in self.nodes:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPce.Topology.Global_.Nodes()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.nodes.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nodes"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.global_ is not None and self.global_.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.global_ is not None and self.global_.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsPce.Topology.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "global"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Tunnels(Entity):
        """
        Table of PCE tunnels
        
        .. attribute:: admin_weight
        
        	Path metric
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: configured_pce_address
        
        	Configured PCE Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: curr_path_option_index
        
        	Path Option Index of the current path
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: destination_address
        
        	Destination Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: hop_count
        
        	Hop Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: is_curr_path_option_pce
        
        	True if current path option is PCE based
        	**type**\:  bool
        
        .. attribute:: path_state
        
        	Path Request State
        	**type**\:   :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
        
        .. attribute:: sender_pce_address
        
        	Sender PCE Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: source_address
        
        	Source Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: tunnel
        
        	Information of a PCE tunnel
        	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Tunnels.Tunnel>`
        
        .. attribute:: tunnel_state
        
        	Tunnel State
        	**type**\:   :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPce.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-pce"

            self.admin_weight = YLeaf(YType.uint32, "admin-weight")

            self.configured_pce_address = YLeaf(YType.str, "configured-pce-address")

            self.curr_path_option_index = YLeaf(YType.uint32, "curr-path-option-index")

            self.destination_address = YLeaf(YType.str, "destination-address")

            self.hop_count = YLeaf(YType.uint32, "hop-count")

            self.is_curr_path_option_pce = YLeaf(YType.boolean, "is-curr-path-option-pce")

            self.path_state = YLeaf(YType.enumeration, "path-state")

            self.sender_pce_address = YLeaf(YType.str, "sender-pce-address")

            self.source_address = YLeaf(YType.str, "source-address")

            self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

            self.tunnel = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("admin_weight",
                            "configured_pce_address",
                            "curr_path_option_index",
                            "destination_address",
                            "hop_count",
                            "is_curr_path_option_pce",
                            "path_state",
                            "sender_pce_address",
                            "source_address",
                            "tunnel_state") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPce.Tunnels, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPce.Tunnels, self).__setattr__(name, value)


        class Tunnel(Entity):
            """
            Information of a PCE tunnel
            
            .. attribute:: tunnel_name  <key>
            
            	Tunnel Name
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: admin_weight
            
            	Path metric
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: configured_pce_address
            
            	Configured PCE Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: curr_path_option_index
            
            	Path Option Index of the current path
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: destination_address
            
            	Destination Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: hop_count
            
            	Hop Count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_curr_path_option_pce
            
            	True if current path option is PCE based
            	**type**\:  bool
            
            .. attribute:: path_state
            
            	Path Request State
            	**type**\:   :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
            
            .. attribute:: sender_pce_address
            
            	Sender PCE Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: source_address
            
            	Source Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: tunnel_state
            
            	Tunnel State
            	**type**\:   :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPce.Tunnels.Tunnel, self).__init__()

                self.yang_name = "tunnel"
                self.yang_parent_name = "tunnels"

                self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                self.configured_pce_address = YLeaf(YType.str, "configured-pce-address")

                self.curr_path_option_index = YLeaf(YType.uint32, "curr-path-option-index")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.hop_count = YLeaf(YType.uint32, "hop-count")

                self.is_curr_path_option_pce = YLeaf(YType.boolean, "is-curr-path-option-pce")

                self.path_state = YLeaf(YType.enumeration, "path-state")

                self.sender_pce_address = YLeaf(YType.str, "sender-pce-address")

                self.source_address = YLeaf(YType.str, "source-address")

                self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("tunnel_name",
                                "admin_weight",
                                "configured_pce_address",
                                "curr_path_option_index",
                                "destination_address",
                                "hop_count",
                                "is_curr_path_option_pce",
                                "path_state",
                                "sender_pce_address",
                                "source_address",
                                "tunnel_state") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPce.Tunnels.Tunnel, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPce.Tunnels.Tunnel, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.tunnel_name.is_set or
                    self.admin_weight.is_set or
                    self.configured_pce_address.is_set or
                    self.curr_path_option_index.is_set or
                    self.destination_address.is_set or
                    self.hop_count.is_set or
                    self.is_curr_path_option_pce.is_set or
                    self.path_state.is_set or
                    self.sender_pce_address.is_set or
                    self.source_address.is_set or
                    self.tunnel_state.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.tunnel_name.yfilter != YFilter.not_set or
                    self.admin_weight.yfilter != YFilter.not_set or
                    self.configured_pce_address.yfilter != YFilter.not_set or
                    self.curr_path_option_index.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.hop_count.yfilter != YFilter.not_set or
                    self.is_curr_path_option_pce.yfilter != YFilter.not_set or
                    self.path_state.yfilter != YFilter.not_set or
                    self.sender_pce_address.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.tunnel_state.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                if (self.configured_pce_address.is_set or self.configured_pce_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_pce_address.get_name_leafdata())
                if (self.curr_path_option_index.is_set or self.curr_path_option_index.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.curr_path_option_index.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.hop_count.is_set or self.hop_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hop_count.get_name_leafdata())
                if (self.is_curr_path_option_pce.is_set or self.is_curr_path_option_pce.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_curr_path_option_pce.get_name_leafdata())
                if (self.path_state.is_set or self.path_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_state.get_name_leafdata())
                if (self.sender_pce_address.is_set or self.sender_pce_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sender_pce_address.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-name" or name == "admin-weight" or name == "configured-pce-address" or name == "curr-path-option-index" or name == "destination-address" or name == "hop-count" or name == "is-curr-path-option-pce" or name == "path-state" or name == "sender-pce-address" or name == "source-address" or name == "tunnel-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "tunnel-name"):
                    self.tunnel_name = value
                    self.tunnel_name.value_namespace = name_space
                    self.tunnel_name.value_namespace_prefix = name_space_prefix
                if(value_path == "admin-weight"):
                    self.admin_weight = value
                    self.admin_weight.value_namespace = name_space
                    self.admin_weight.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-pce-address"):
                    self.configured_pce_address = value
                    self.configured_pce_address.value_namespace = name_space
                    self.configured_pce_address.value_namespace_prefix = name_space_prefix
                if(value_path == "curr-path-option-index"):
                    self.curr_path_option_index = value
                    self.curr_path_option_index.value_namespace = name_space
                    self.curr_path_option_index.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "hop-count"):
                    self.hop_count = value
                    self.hop_count.value_namespace = name_space
                    self.hop_count.value_namespace_prefix = name_space_prefix
                if(value_path == "is-curr-path-option-pce"):
                    self.is_curr_path_option_pce = value
                    self.is_curr_path_option_pce.value_namespace = name_space
                    self.is_curr_path_option_pce.value_namespace_prefix = name_space_prefix
                if(value_path == "path-state"):
                    self.path_state = value
                    self.path_state.value_namespace = name_space
                    self.path_state.value_namespace_prefix = name_space_prefix
                if(value_path == "sender-pce-address"):
                    self.sender_pce_address = value
                    self.sender_pce_address.value_namespace = name_space
                    self.sender_pce_address.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-state"):
                    self.tunnel_state = value
                    self.tunnel_state.value_namespace = name_space
                    self.tunnel_state.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.tunnel:
                if (c.has_data()):
                    return True
            return (
                self.admin_weight.is_set or
                self.configured_pce_address.is_set or
                self.curr_path_option_index.is_set or
                self.destination_address.is_set or
                self.hop_count.is_set or
                self.is_curr_path_option_pce.is_set or
                self.path_state.is_set or
                self.sender_pce_address.is_set or
                self.source_address.is_set or
                self.tunnel_state.is_set)

        def has_operation(self):
            for c in self.tunnel:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.admin_weight.yfilter != YFilter.not_set or
                self.configured_pce_address.yfilter != YFilter.not_set or
                self.curr_path_option_index.yfilter != YFilter.not_set or
                self.destination_address.yfilter != YFilter.not_set or
                self.hop_count.yfilter != YFilter.not_set or
                self.is_curr_path_option_pce.yfilter != YFilter.not_set or
                self.path_state.yfilter != YFilter.not_set or
                self.sender_pce_address.yfilter != YFilter.not_set or
                self.source_address.yfilter != YFilter.not_set or
                self.tunnel_state.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                leaf_name_data.append(self.admin_weight.get_name_leafdata())
            if (self.configured_pce_address.is_set or self.configured_pce_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.configured_pce_address.get_name_leafdata())
            if (self.curr_path_option_index.is_set or self.curr_path_option_index.yfilter != YFilter.not_set):
                leaf_name_data.append(self.curr_path_option_index.get_name_leafdata())
            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.destination_address.get_name_leafdata())
            if (self.hop_count.is_set or self.hop_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.hop_count.get_name_leafdata())
            if (self.is_curr_path_option_pce.is_set or self.is_curr_path_option_pce.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_curr_path_option_pce.get_name_leafdata())
            if (self.path_state.is_set or self.path_state.yfilter != YFilter.not_set):
                leaf_name_data.append(self.path_state.get_name_leafdata())
            if (self.sender_pce_address.is_set or self.sender_pce_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.sender_pce_address.get_name_leafdata())
            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.source_address.get_name_leafdata())
            if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                leaf_name_data.append(self.tunnel_state.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "tunnel"):
                for c in self.tunnel:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPce.Tunnels.Tunnel()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.tunnel.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "tunnel" or name == "admin-weight" or name == "configured-pce-address" or name == "curr-path-option-index" or name == "destination-address" or name == "hop-count" or name == "is-curr-path-option-pce" or name == "path-state" or name == "sender-pce-address" or name == "source-address" or name == "tunnel-state"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "admin-weight"):
                self.admin_weight = value
                self.admin_weight.value_namespace = name_space
                self.admin_weight.value_namespace_prefix = name_space_prefix
            if(value_path == "configured-pce-address"):
                self.configured_pce_address = value
                self.configured_pce_address.value_namespace = name_space
                self.configured_pce_address.value_namespace_prefix = name_space_prefix
            if(value_path == "curr-path-option-index"):
                self.curr_path_option_index = value
                self.curr_path_option_index.value_namespace = name_space
                self.curr_path_option_index.value_namespace_prefix = name_space_prefix
            if(value_path == "destination-address"):
                self.destination_address = value
                self.destination_address.value_namespace = name_space
                self.destination_address.value_namespace_prefix = name_space_prefix
            if(value_path == "hop-count"):
                self.hop_count = value
                self.hop_count.value_namespace = name_space
                self.hop_count.value_namespace_prefix = name_space_prefix
            if(value_path == "is-curr-path-option-pce"):
                self.is_curr_path_option_pce = value
                self.is_curr_path_option_pce.value_namespace = name_space
                self.is_curr_path_option_pce.value_namespace_prefix = name_space_prefix
            if(value_path == "path-state"):
                self.path_state = value
                self.path_state.value_namespace = name_space
                self.path_state.value_namespace_prefix = name_space_prefix
            if(value_path == "sender-pce-address"):
                self.sender_pce_address = value
                self.sender_pce_address.value_namespace = name_space
                self.sender_pce_address.value_namespace_prefix = name_space_prefix
            if(value_path == "source-address"):
                self.source_address = value
                self.source_address.value_namespace = name_space
                self.source_address.value_namespace_prefix = name_space_prefix
            if(value_path == "tunnel-state"):
                self.tunnel_state = value
                self.tunnel_state.value_namespace = name_space
                self.tunnel_state.value_namespace_prefix = name_space_prefix

    def has_data(self):
        return (
            (self.lsps is not None and self.lsps.has_data()) or
            (self.peers is not None and self.peers.has_data()) or
            (self.statistics is not None and self.statistics.has_data()) or
            (self.topology is not None and self.topology.has_data()) or
            (self.tunnels is not None and self.tunnels.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.lsps is not None and self.lsps.has_operation()) or
            (self.peers is not None and self.peers.has_operation()) or
            (self.statistics is not None and self.statistics.has_operation()) or
            (self.topology is not None and self.topology.has_operation()) or
            (self.tunnels is not None and self.tunnels.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "lsps"):
            if (self.lsps is None):
                self.lsps = MplsPce.Lsps()
                self.lsps.parent = self
                self._children_name_map["lsps"] = "lsps"
            return self.lsps

        if (child_yang_name == "peers"):
            if (self.peers is None):
                self.peers = MplsPce.Peers()
                self.peers.parent = self
                self._children_name_map["peers"] = "peers"
            return self.peers

        if (child_yang_name == "statistics"):
            if (self.statistics is None):
                self.statistics = MplsPce.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
            return self.statistics

        if (child_yang_name == "topology"):
            if (self.topology is None):
                self.topology = MplsPce.Topology()
                self.topology.parent = self
                self._children_name_map["topology"] = "topology"
            return self.topology

        if (child_yang_name == "tunnels"):
            if (self.tunnels is None):
                self.tunnels = MplsPce.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
            return self.tunnels

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "lsps" or name == "peers" or name == "statistics" or name == "topology" or name == "tunnels"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsPce()
        return self._top_entity

class MplsPceStdby(Entity):
    """
    mpls pce stdby
    
    .. attribute:: lsps
    
    	Table of LSPs
    	**type**\:   :py:class:`Lsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps>`
    
    .. attribute:: peers
    
    	The set of PCE peers
    	**type**\:   :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers>`
    
    .. attribute:: statistics
    
    	PCE stats info
    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics>`
    
    .. attribute:: topology
    
    	The topology information in PCE
    	**type**\:   :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology>`
    
    .. attribute:: tunnels
    
    	Table of PCE tunnels
    	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Tunnels>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsPceStdby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-pce-stdby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.lsps = MplsPceStdby.Lsps()
        self.lsps.parent = self
        self._children_name_map["lsps"] = "lsps"
        self._children_yang_names.add("lsps")

        self.peers = MplsPceStdby.Peers()
        self.peers.parent = self
        self._children_name_map["peers"] = "peers"
        self._children_yang_names.add("peers")

        self.statistics = MplsPceStdby.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"
        self._children_yang_names.add("statistics")

        self.topology = MplsPceStdby.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"
        self._children_yang_names.add("topology")

        self.tunnels = MplsPceStdby.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._children_yang_names.add("tunnels")


    class Lsps(Entity):
        """
        Table of LSPs
        
        .. attribute:: administrative
        
        	LSP administrative status
        	**type**\:  bool
        
        .. attribute:: autoroute
        
        	Auto Route
        	**type**\:   :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Autoroute>`
        
        .. attribute:: backup_path
        
        	Backup Path
        	**type**\:  list of str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: binding_sid
        
        	Binding SID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: cleanup_timer_exp
        
        	Deprecated
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: create
        
        	LSPO create flag
        	**type**\:  bool
        
        .. attribute:: creator
        
        	Creator Peer of the LSP
        	**type**\:   :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Creator>`
        
        .. attribute:: delegatable
        
        	LSP delegatable
        	**type**\:  bool
        
        .. attribute:: delegated
        
        	Owner Peer of the LSP
        	**type**\:   :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Delegated>`
        
        .. attribute:: delegation_timer_exp
        
        	LSP delegation timer expiration in sec
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: destination_address
        
        	Destination IP Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: forward_class_id
        
        	Forward Class ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: identifiers
        
        	LSP Identifiers
        	**type**\:   :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Identifiers>`
        
        .. attribute:: load_share
        
        	Load share factor
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: lsp
        
        	Information of a LSP from LSPDB
        	**type**\: list of    :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp>`
        
        .. attribute:: lspo_is_used
        
        	LSP Object used flag
        	**type**\:  bool
        
        .. attribute:: operational
        
        	LSP operational status
        	**type**\:   :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
        
        .. attribute:: path_setup_type
        
        	Path setup type
        	**type**\:  int
        
        	**range:** 0..255
        
        .. attribute:: paths
        
        	Array of paths
        	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths>`
        
        .. attribute:: request_queue_size
        
        	Request queue size
        	**type**\:  int
        
        	**range:** 0..255
        
        .. attribute:: session_internal_lsp_id
        
        	Session internal ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: source_address
        
        	Source IP Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: state_timer_exp
        
        	LSP state\-timeout time expiration
        	**type**\:  int
        
        	**range:** \-2147483648..2147483647
        
        .. attribute:: stateful_request_parameter_id
        
        	SRP ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: symbolic_name_xr
        
        	Symbolic Name
        	**type**\:  str
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPceStdby.Lsps, self).__init__()

            self.yang_name = "lsps"
            self.yang_parent_name = "mpls-pce-stdby"

            self.administrative = YLeaf(YType.boolean, "administrative")

            self.backup_path = YLeafList(YType.str, "backup-path")

            self.binding_sid = YLeaf(YType.uint32, "binding-sid")

            self.cleanup_timer_exp = YLeaf(YType.int32, "cleanup-timer-exp")

            self.create = YLeaf(YType.boolean, "create")

            self.delegatable = YLeaf(YType.boolean, "delegatable")

            self.delegation_timer_exp = YLeaf(YType.int32, "delegation-timer-exp")

            self.destination_address = YLeaf(YType.str, "destination-address")

            self.forward_class_id = YLeaf(YType.uint32, "forward-class-id")

            self.load_share = YLeaf(YType.uint32, "load-share")

            self.lspo_is_used = YLeaf(YType.boolean, "lspo-is-used")

            self.operational = YLeaf(YType.enumeration, "operational")

            self.path_setup_type = YLeaf(YType.uint8, "path-setup-type")

            self.request_queue_size = YLeaf(YType.uint8, "request-queue-size")

            self.session_internal_lsp_id = YLeaf(YType.uint32, "session-internal-lsp-id")

            self.source_address = YLeaf(YType.str, "source-address")

            self.state_timer_exp = YLeaf(YType.int32, "state-timer-exp")

            self.stateful_request_parameter_id = YLeaf(YType.uint32, "stateful-request-parameter-id")

            self.symbolic_name_xr = YLeaf(YType.str, "symbolic-name-xr")

            self.autoroute = MplsPceStdby.Lsps.Autoroute()
            self.autoroute.parent = self
            self._children_name_map["autoroute"] = "autoroute"
            self._children_yang_names.add("autoroute")

            self.creator = MplsPceStdby.Lsps.Creator()
            self.creator.parent = self
            self._children_name_map["creator"] = "creator"
            self._children_yang_names.add("creator")

            self.delegated = MplsPceStdby.Lsps.Delegated()
            self.delegated.parent = self
            self._children_name_map["delegated"] = "delegated"
            self._children_yang_names.add("delegated")

            self.identifiers = MplsPceStdby.Lsps.Identifiers()
            self.identifiers.parent = self
            self._children_name_map["identifiers"] = "identifiers"
            self._children_yang_names.add("identifiers")

            self.lsp = YList(self)
            self.paths = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("administrative",
                            "backup_path",
                            "binding_sid",
                            "cleanup_timer_exp",
                            "create",
                            "delegatable",
                            "delegation_timer_exp",
                            "destination_address",
                            "forward_class_id",
                            "load_share",
                            "lspo_is_used",
                            "operational",
                            "path_setup_type",
                            "request_queue_size",
                            "session_internal_lsp_id",
                            "source_address",
                            "state_timer_exp",
                            "stateful_request_parameter_id",
                            "symbolic_name_xr") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPceStdby.Lsps, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPceStdby.Lsps, self).__setattr__(name, value)


        class Lsp(Entity):
            """
            Information of a LSP from LSPDB
            
            .. attribute:: symbolic_name  <key>
            
            	Symbolic name
            	**type**\:  str
            
            	**length:** 1..256
            
            .. attribute:: administrative
            
            	LSP administrative status
            	**type**\:  bool
            
            .. attribute:: autoroute
            
            	Auto Route
            	**type**\:   :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Autoroute>`
            
            .. attribute:: backup_path
            
            	Backup Path
            	**type**\:  list of str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: binding_sid
            
            	Binding SID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: cleanup_timer_exp
            
            	Deprecated
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: create
            
            	LSPO create flag
            	**type**\:  bool
            
            .. attribute:: creator
            
            	Creator Peer of the LSP
            	**type**\:   :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Creator>`
            
            .. attribute:: delegatable
            
            	LSP delegatable
            	**type**\:  bool
            
            .. attribute:: delegated
            
            	Owner Peer of the LSP
            	**type**\:   :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Delegated>`
            
            .. attribute:: delegation_timer_exp
            
            	LSP delegation timer expiration in sec
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: destination_address
            
            	Destination IP Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: forward_class_id
            
            	Forward Class ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: identifiers
            
            	LSP Identifiers
            	**type**\:   :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Identifiers>`
            
            .. attribute:: load_share
            
            	Load share factor
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: lspo_is_used
            
            	LSP Object used flag
            	**type**\:  bool
            
            .. attribute:: operational
            
            	LSP operational status
            	**type**\:   :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
            
            .. attribute:: path_setup_type
            
            	Path setup type
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: paths
            
            	Array of paths
            	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths>`
            
            .. attribute:: request_queue_size
            
            	Request queue size
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: session_internal_lsp_id
            
            	Session internal ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: source_address
            
            	Source IP Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: state_timer_exp
            
            	LSP state\-timeout time expiration
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: stateful_request_parameter_id
            
            	SRP ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: symbolic_name_xr
            
            	Symbolic Name
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Lsp, self).__init__()

                self.yang_name = "lsp"
                self.yang_parent_name = "lsps"

                self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                self.administrative = YLeaf(YType.boolean, "administrative")

                self.backup_path = YLeafList(YType.str, "backup-path")

                self.binding_sid = YLeaf(YType.uint32, "binding-sid")

                self.cleanup_timer_exp = YLeaf(YType.int32, "cleanup-timer-exp")

                self.create = YLeaf(YType.boolean, "create")

                self.delegatable = YLeaf(YType.boolean, "delegatable")

                self.delegation_timer_exp = YLeaf(YType.int32, "delegation-timer-exp")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.forward_class_id = YLeaf(YType.uint32, "forward-class-id")

                self.load_share = YLeaf(YType.uint32, "load-share")

                self.lspo_is_used = YLeaf(YType.boolean, "lspo-is-used")

                self.operational = YLeaf(YType.enumeration, "operational")

                self.path_setup_type = YLeaf(YType.uint8, "path-setup-type")

                self.request_queue_size = YLeaf(YType.uint8, "request-queue-size")

                self.session_internal_lsp_id = YLeaf(YType.uint32, "session-internal-lsp-id")

                self.source_address = YLeaf(YType.str, "source-address")

                self.state_timer_exp = YLeaf(YType.int32, "state-timer-exp")

                self.stateful_request_parameter_id = YLeaf(YType.uint32, "stateful-request-parameter-id")

                self.symbolic_name_xr = YLeaf(YType.str, "symbolic-name-xr")

                self.autoroute = MplsPceStdby.Lsps.Lsp.Autoroute()
                self.autoroute.parent = self
                self._children_name_map["autoroute"] = "autoroute"
                self._children_yang_names.add("autoroute")

                self.creator = MplsPceStdby.Lsps.Lsp.Creator()
                self.creator.parent = self
                self._children_name_map["creator"] = "creator"
                self._children_yang_names.add("creator")

                self.delegated = MplsPceStdby.Lsps.Lsp.Delegated()
                self.delegated.parent = self
                self._children_name_map["delegated"] = "delegated"
                self._children_yang_names.add("delegated")

                self.identifiers = MplsPceStdby.Lsps.Lsp.Identifiers()
                self.identifiers.parent = self
                self._children_name_map["identifiers"] = "identifiers"
                self._children_yang_names.add("identifiers")

                self.paths = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("symbolic_name",
                                "administrative",
                                "backup_path",
                                "binding_sid",
                                "cleanup_timer_exp",
                                "create",
                                "delegatable",
                                "delegation_timer_exp",
                                "destination_address",
                                "forward_class_id",
                                "load_share",
                                "lspo_is_used",
                                "operational",
                                "path_setup_type",
                                "request_queue_size",
                                "session_internal_lsp_id",
                                "source_address",
                                "state_timer_exp",
                                "stateful_request_parameter_id",
                                "symbolic_name_xr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Lsp, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Lsp, self).__setattr__(name, value)


            class Creator(Entity):
                """
                Creator Peer of the LSP
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Lsp.Creator, self).__init__()

                    self.yang_name = "creator"
                    self.yang_parent_name = "lsp"

                    self.address = YLeaf(YType.str, "address")

                    self.node_identifier = YLeaf(YType.str, "node-identifier")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "node_identifier") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Lsp.Creator, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Lsp.Creator, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.address.is_set or
                        self.node_identifier.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.node_identifier.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "creator" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address.get_name_leafdata())
                    if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_identifier.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "address" or name == "node-identifier"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address = value
                        self.address.value_namespace = name_space
                        self.address.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-identifier"):
                        self.node_identifier = value
                        self.node_identifier.value_namespace = name_space
                        self.node_identifier.value_namespace_prefix = name_space_prefix


            class Delegated(Entity):
                """
                Owner Peer of the LSP
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Lsp.Delegated, self).__init__()

                    self.yang_name = "delegated"
                    self.yang_parent_name = "lsp"

                    self.address = YLeaf(YType.str, "address")

                    self.node_identifier = YLeaf(YType.str, "node-identifier")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "node_identifier") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Lsp.Delegated, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Lsp.Delegated, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.address.is_set or
                        self.node_identifier.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.node_identifier.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "delegated" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address.get_name_leafdata())
                    if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_identifier.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "address" or name == "node-identifier"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address = value
                        self.address.value_namespace = name_space
                        self.address.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-identifier"):
                        self.node_identifier = value
                        self.node_identifier.value_namespace = name_space
                        self.node_identifier.value_namespace_prefix = name_space_prefix


            class Identifiers(Entity):
                """
                LSP Identifiers
                
                .. attribute:: ext_tunnel_id
                
                	External Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	LSP Identifier used flag
                	**type**\:  bool
                
                .. attribute:: sender
                
                	Sender Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: te_lsp_id
                
                	TE LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_id
                
                	LSPO Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Lsp.Identifiers, self).__init__()

                    self.yang_name = "identifiers"
                    self.yang_parent_name = "lsp"

                    self.ext_tunnel_id = YLeaf(YType.uint32, "ext-tunnel-id")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.sender = YLeaf(YType.str, "sender")

                    self.te_lsp_id = YLeaf(YType.uint16, "te-lsp-id")

                    self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ext_tunnel_id",
                                    "is_used",
                                    "sender",
                                    "te_lsp_id",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Lsp.Identifiers, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Lsp.Identifiers, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.ext_tunnel_id.is_set or
                        self.is_used.is_set or
                        self.sender.is_set or
                        self.te_lsp_id.is_set or
                        self.tunnel_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ext_tunnel_id.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.sender.yfilter != YFilter.not_set or
                        self.te_lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "identifiers" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ext_tunnel_id.is_set or self.ext_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ext_tunnel_id.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.sender.is_set or self.sender.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sender.get_name_leafdata())
                    if (self.te_lsp_id.is_set or self.te_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ext-tunnel-id" or name == "is-used" or name == "sender" or name == "te-lsp-id" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ext-tunnel-id"):
                        self.ext_tunnel_id = value
                        self.ext_tunnel_id.value_namespace = name_space
                        self.ext_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "sender"):
                        self.sender = value
                        self.sender.value_namespace = name_space
                        self.sender.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-lsp-id"):
                        self.te_lsp_id = value
                        self.te_lsp_id.value_namespace = name_space
                        self.te_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix


            class Autoroute(Entity):
                """
                Auto Route
                
                .. attribute:: announced
                
                	Autoroute announced
                	**type**\:  bool
                
                .. attribute:: destination
                
                	Destinations
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_used
                
                	Autoroute used flag
                	**type**\:  bool
                
                .. attribute:: metric
                
                	Metric Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:   :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Lsp.Autoroute, self).__init__()

                    self.yang_name = "autoroute"
                    self.yang_parent_name = "lsp"

                    self.announced = YLeaf(YType.boolean, "announced")

                    self.destination = YLeafList(YType.str, "destination")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.metric = YLeaf(YType.uint32, "metric")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("announced",
                                    "destination",
                                    "is_used",
                                    "metric",
                                    "metric_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Lsp.Autoroute, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Lsp.Autoroute, self).__setattr__(name, value)

                def has_data(self):
                    for leaf in self.destination.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.announced.is_set or
                        self.is_used.is_set or
                        self.metric.is_set or
                        self.metric_type.is_set)

                def has_operation(self):
                    for leaf in self.destination.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.announced.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.metric.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "autoroute" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.announced.is_set or self.announced.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())

                    leaf_name_data.extend(self.destination.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "announced" or name == "destination" or name == "is-used" or name == "metric" or name == "metric-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "announced"):
                        self.announced = value
                        self.announced.value_namespace = name_space
                        self.announced.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination.append(value)
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric"):
                        self.metric = value
                        self.metric.value_namespace = name_space
                        self.metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix


            class Paths(Entity):
                """
                Array of paths
                
                .. attribute:: applied_bw
                
                	Applied bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bw
                
                	Bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: ero
                
                	Explicit Router Object
                	**type**\:   :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Ero>`
                
                .. attribute:: is_applied_bw_used
                
                	Applied bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: is_bw_used
                
                	Bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: is_reopt_bw_used
                
                	Reoptimize bandwidth used flag
                	**type**\:  bool
                
                .. attribute:: lspa
                
                	LSP Attributes Object
                	**type**\:   :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Lspa>`
                
                .. attribute:: metric
                
                	List of Metrics
                	**type**\: list of    :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Metric>`
                
                .. attribute:: reopt_bw
                
                	Reoptimize bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rro
                
                	Reported Route Object
                	**type**\:   :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Rro>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Lsp.Paths, self).__init__()

                    self.yang_name = "paths"
                    self.yang_parent_name = "lsp"

                    self.applied_bw = YLeaf(YType.uint32, "applied-bw")

                    self.bw = YLeaf(YType.uint32, "bw")

                    self.is_applied_bw_used = YLeaf(YType.boolean, "is-applied-bw-used")

                    self.is_bw_used = YLeaf(YType.boolean, "is-bw-used")

                    self.is_reopt_bw_used = YLeaf(YType.boolean, "is-reopt-bw-used")

                    self.reopt_bw = YLeaf(YType.uint32, "reopt-bw")

                    self.ero = MplsPceStdby.Lsps.Lsp.Paths.Ero()
                    self.ero.parent = self
                    self._children_name_map["ero"] = "ero"
                    self._children_yang_names.add("ero")

                    self.lspa = MplsPceStdby.Lsps.Lsp.Paths.Lspa()
                    self.lspa.parent = self
                    self._children_name_map["lspa"] = "lspa"
                    self._children_yang_names.add("lspa")

                    self.rro = MplsPceStdby.Lsps.Lsp.Paths.Rro()
                    self.rro.parent = self
                    self._children_name_map["rro"] = "rro"
                    self._children_yang_names.add("rro")

                    self.metric = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("applied_bw",
                                    "bw",
                                    "is_applied_bw_used",
                                    "is_bw_used",
                                    "is_reopt_bw_used",
                                    "reopt_bw") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Lsp.Paths, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Lsp.Paths, self).__setattr__(name, value)


                class Ero(Entity):
                    """
                    Explicit Router Object
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\:  list of str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\:  bool
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Lsp.Paths.Ero, self).__init__()

                        self.yang_name = "ero"
                        self.yang_parent_name = "paths"

                        self.address = YLeafList(YType.str, "address")

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.subobject = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address",
                                        "cost",
                                        "is_used") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Ero, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Lsp.Paths.Ero, self).__setattr__(name, value)


                    class Subobject(Entity):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\:  bool
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\:  bool
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\:  bool
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\:  bool
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\:  bool
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\:  bool
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\:  bool
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\:  bool
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "ero"

                            self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                            self.global_ = YLeaf(YType.boolean, "global")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                            self.local_address = YLeaf(YType.str, "local-address")

                            self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                            self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                            self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                            self.node_id = YLeaf(YType.str, "node-id")

                            self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                            self.remote_address = YLeaf(YType.str, "remote-address")

                            self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                            self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                            self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                            self.strict = YLeaf(YType.boolean, "strict")

                            self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("complete_mpls_label_entry",
                                            "global_",
                                            "ipv4_address",
                                            "ipv4_prefix_len",
                                            "local_address",
                                            "missing_node_adjcency_id",
                                            "missing_segment_id",
                                            "mpls_label",
                                            "node_adjacency_id_exists",
                                            "node_id",
                                            "only_valid_mpls_label",
                                            "remote_address",
                                            "segment_id_exists",
                                            "segment_id_type",
                                            "segment_id_value",
                                            "strict",
                                            "subobj_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.complete_mpls_label_entry.is_set or
                                self.global_.is_set or
                                self.ipv4_address.is_set or
                                self.ipv4_prefix_len.is_set or
                                self.local_address.is_set or
                                self.missing_node_adjcency_id.is_set or
                                self.missing_segment_id.is_set or
                                self.mpls_label.is_set or
                                self.node_adjacency_id_exists.is_set or
                                self.node_id.is_set or
                                self.only_valid_mpls_label.is_set or
                                self.remote_address.is_set or
                                self.segment_id_exists.is_set or
                                self.segment_id_type.is_set or
                                self.segment_id_value.is_set or
                                self.strict.is_set or
                                self.subobj_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                                self.global_.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.ipv4_prefix_len.yfilter != YFilter.not_set or
                                self.local_address.yfilter != YFilter.not_set or
                                self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                                self.missing_segment_id.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set or
                                self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.only_valid_mpls_label.yfilter != YFilter.not_set or
                                self.remote_address.yfilter != YFilter.not_set or
                                self.segment_id_exists.yfilter != YFilter.not_set or
                                self.segment_id_type.yfilter != YFilter.not_set or
                                self.segment_id_value.yfilter != YFilter.not_set or
                                self.strict.yfilter != YFilter.not_set or
                                self.subobj_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subobject" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                            if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_address.get_name_leafdata())
                            if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                            if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())
                            if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                            if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_address.get_name_leafdata())
                            if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                            if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                            if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                            if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.strict.get_name_leafdata())
                            if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.subobj_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "complete-mpls-label-entry"):
                                self.complete_mpls_label_entry = value
                                self.complete_mpls_label_entry.value_namespace = name_space
                                self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                            if(value_path == "global"):
                                self.global_ = value
                                self.global_.value_namespace = name_space
                                self.global_.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-prefix-len"):
                                self.ipv4_prefix_len = value
                                self.ipv4_prefix_len.value_namespace = name_space
                                self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-address"):
                                self.local_address = value
                                self.local_address.value_namespace = name_space
                                self.local_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-node-adjcency-id"):
                                self.missing_node_adjcency_id = value
                                self.missing_node_adjcency_id.value_namespace = name_space
                                self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-segment-id"):
                                self.missing_segment_id = value
                                self.missing_segment_id.value_namespace = name_space
                                self.missing_segment_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-adjacency-id-exists"):
                                self.node_adjacency_id_exists = value
                                self.node_adjacency_id_exists.value_namespace = name_space
                                self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "only-valid-mpls-label"):
                                self.only_valid_mpls_label = value
                                self.only_valid_mpls_label.value_namespace = name_space
                                self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-address"):
                                self.remote_address = value
                                self.remote_address.value_namespace = name_space
                                self.remote_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-exists"):
                                self.segment_id_exists = value
                                self.segment_id_exists.value_namespace = name_space
                                self.segment_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-type"):
                                self.segment_id_type = value
                                self.segment_id_type.value_namespace = name_space
                                self.segment_id_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-value"):
                                self.segment_id_value = value
                                self.segment_id_value.value_namespace = name_space
                                self.segment_id_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "strict"):
                                self.strict = value
                                self.strict.value_namespace = name_space
                                self.strict.value_namespace_prefix = name_space_prefix
                            if(value_path == "subobj-type"):
                                self.subobj_type = value
                                self.subobj_type.value_namespace = name_space
                                self.subobj_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.subobject:
                            if (c.has_data()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        return (
                            self.cost.is_set or
                            self.is_used.is_set)

                    def has_operation(self):
                        for c in self.subobject:
                            if (c.has_operation()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.is_set):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ero" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())

                        leaf_name_data.extend(self.address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "subobject"):
                            for c in self.subobject:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.subobject.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address"):
                            self.address.append(value)
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix


                class Lspa(Entity):
                    """
                    LSP Attributes Object
                    
                    .. attribute:: exlude_any
                    
                    	Exclude Any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold
                    
                    	Hold
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: include_all
                    
                    	Include All
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: include_any
                    
                    	Include Any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	LSPA used flag
                    	**type**\:  bool
                    
                    .. attribute:: lbit
                    
                    	L flag
                    	**type**\:  bool
                    
                    .. attribute:: setup
                    
                    	Setup
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Lsp.Paths.Lspa, self).__init__()

                        self.yang_name = "lspa"
                        self.yang_parent_name = "paths"

                        self.exlude_any = YLeaf(YType.uint32, "exlude-any")

                        self.hold = YLeaf(YType.uint8, "hold")

                        self.include_all = YLeaf(YType.uint32, "include-all")

                        self.include_any = YLeaf(YType.uint32, "include-any")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.lbit = YLeaf(YType.boolean, "lbit")

                        self.setup = YLeaf(YType.uint8, "setup")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("exlude_any",
                                        "hold",
                                        "include_all",
                                        "include_any",
                                        "is_used",
                                        "lbit",
                                        "setup") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Lspa, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Lsp.Paths.Lspa, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.exlude_any.is_set or
                            self.hold.is_set or
                            self.include_all.is_set or
                            self.include_any.is_set or
                            self.is_used.is_set or
                            self.lbit.is_set or
                            self.setup.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.exlude_any.yfilter != YFilter.not_set or
                            self.hold.yfilter != YFilter.not_set or
                            self.include_all.yfilter != YFilter.not_set or
                            self.include_any.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set or
                            self.lbit.yfilter != YFilter.not_set or
                            self.setup.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lspa" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.exlude_any.is_set or self.exlude_any.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.exlude_any.get_name_leafdata())
                        if (self.hold.is_set or self.hold.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold.get_name_leafdata())
                        if (self.include_all.is_set or self.include_all.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.include_all.get_name_leafdata())
                        if (self.include_any.is_set or self.include_any.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.include_any.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())
                        if (self.lbit.is_set or self.lbit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lbit.get_name_leafdata())
                        if (self.setup.is_set or self.setup.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "exlude-any" or name == "hold" or name == "include-all" or name == "include-any" or name == "is-used" or name == "lbit" or name == "setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "exlude-any"):
                            self.exlude_any = value
                            self.exlude_any.value_namespace = name_space
                            self.exlude_any.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold"):
                            self.hold = value
                            self.hold.value_namespace = name_space
                            self.hold.value_namespace_prefix = name_space_prefix
                        if(value_path == "include-all"):
                            self.include_all = value
                            self.include_all.value_namespace = name_space
                            self.include_all.value_namespace_prefix = name_space_prefix
                        if(value_path == "include-any"):
                            self.include_any = value
                            self.include_any.value_namespace = name_space
                            self.include_any.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix
                        if(value_path == "lbit"):
                            self.lbit = value
                            self.lbit.value_namespace = name_space
                            self.lbit.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup"):
                            self.setup = value
                            self.setup.value_namespace = name_space
                            self.setup.value_namespace_prefix = name_space_prefix


                class Rro(Entity):
                    """
                    Reported Route Object
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\:  list of str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\:  bool
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Lsp.Paths.Rro, self).__init__()

                        self.yang_name = "rro"
                        self.yang_parent_name = "paths"

                        self.address = YLeafList(YType.str, "address")

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.is_used = YLeaf(YType.boolean, "is-used")

                        self.subobject = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address",
                                        "cost",
                                        "is_used") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Rro, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Lsp.Paths.Rro, self).__setattr__(name, value)


                    class Subobject(Entity):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\:  bool
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\:  bool
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\:  bool
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\:  bool
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\:  bool
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\:  bool
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\:  bool
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\:  bool
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "rro"

                            self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                            self.global_ = YLeaf(YType.boolean, "global")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                            self.local_address = YLeaf(YType.str, "local-address")

                            self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                            self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                            self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                            self.node_id = YLeaf(YType.str, "node-id")

                            self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                            self.remote_address = YLeaf(YType.str, "remote-address")

                            self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                            self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                            self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                            self.strict = YLeaf(YType.boolean, "strict")

                            self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("complete_mpls_label_entry",
                                            "global_",
                                            "ipv4_address",
                                            "ipv4_prefix_len",
                                            "local_address",
                                            "missing_node_adjcency_id",
                                            "missing_segment_id",
                                            "mpls_label",
                                            "node_adjacency_id_exists",
                                            "node_id",
                                            "only_valid_mpls_label",
                                            "remote_address",
                                            "segment_id_exists",
                                            "segment_id_type",
                                            "segment_id_value",
                                            "strict",
                                            "subobj_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.complete_mpls_label_entry.is_set or
                                self.global_.is_set or
                                self.ipv4_address.is_set or
                                self.ipv4_prefix_len.is_set or
                                self.local_address.is_set or
                                self.missing_node_adjcency_id.is_set or
                                self.missing_segment_id.is_set or
                                self.mpls_label.is_set or
                                self.node_adjacency_id_exists.is_set or
                                self.node_id.is_set or
                                self.only_valid_mpls_label.is_set or
                                self.remote_address.is_set or
                                self.segment_id_exists.is_set or
                                self.segment_id_type.is_set or
                                self.segment_id_value.is_set or
                                self.strict.is_set or
                                self.subobj_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                                self.global_.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.ipv4_prefix_len.yfilter != YFilter.not_set or
                                self.local_address.yfilter != YFilter.not_set or
                                self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                                self.missing_segment_id.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set or
                                self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                                self.node_id.yfilter != YFilter.not_set or
                                self.only_valid_mpls_label.yfilter != YFilter.not_set or
                                self.remote_address.yfilter != YFilter.not_set or
                                self.segment_id_exists.yfilter != YFilter.not_set or
                                self.segment_id_type.yfilter != YFilter.not_set or
                                self.segment_id_value.yfilter != YFilter.not_set or
                                self.strict.yfilter != YFilter.not_set or
                                self.subobj_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subobject" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                            if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_address.get_name_leafdata())
                            if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                            if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())
                            if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_id.get_name_leafdata())
                            if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                            if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_address.get_name_leafdata())
                            if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                            if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                            if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                            if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.strict.get_name_leafdata())
                            if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.subobj_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "complete-mpls-label-entry"):
                                self.complete_mpls_label_entry = value
                                self.complete_mpls_label_entry.value_namespace = name_space
                                self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                            if(value_path == "global"):
                                self.global_ = value
                                self.global_.value_namespace = name_space
                                self.global_.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-prefix-len"):
                                self.ipv4_prefix_len = value
                                self.ipv4_prefix_len.value_namespace = name_space
                                self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-address"):
                                self.local_address = value
                                self.local_address.value_namespace = name_space
                                self.local_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-node-adjcency-id"):
                                self.missing_node_adjcency_id = value
                                self.missing_node_adjcency_id.value_namespace = name_space
                                self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "missing-segment-id"):
                                self.missing_segment_id = value
                                self.missing_segment_id.value_namespace = name_space
                                self.missing_segment_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-adjacency-id-exists"):
                                self.node_adjacency_id_exists = value
                                self.node_adjacency_id_exists.value_namespace = name_space
                                self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-id"):
                                self.node_id = value
                                self.node_id.value_namespace = name_space
                                self.node_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "only-valid-mpls-label"):
                                self.only_valid_mpls_label = value
                                self.only_valid_mpls_label.value_namespace = name_space
                                self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-address"):
                                self.remote_address = value
                                self.remote_address.value_namespace = name_space
                                self.remote_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-exists"):
                                self.segment_id_exists = value
                                self.segment_id_exists.value_namespace = name_space
                                self.segment_id_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-type"):
                                self.segment_id_type = value
                                self.segment_id_type.value_namespace = name_space
                                self.segment_id_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "segment-id-value"):
                                self.segment_id_value = value
                                self.segment_id_value.value_namespace = name_space
                                self.segment_id_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "strict"):
                                self.strict = value
                                self.strict.value_namespace = name_space
                                self.strict.value_namespace_prefix = name_space_prefix
                            if(value_path == "subobj-type"):
                                self.subobj_type = value
                                self.subobj_type.value_namespace = name_space
                                self.subobj_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.subobject:
                            if (c.has_data()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.yfilter != YFilter.not_set):
                                return True
                        return (
                            self.cost.is_set or
                            self.is_used.is_set)

                    def has_operation(self):
                        for c in self.subobject:
                            if (c.has_operation()):
                                return True
                        for leaf in self.address.getYLeafs():
                            if (leaf.is_set):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.is_used.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rro" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_used.get_name_leafdata())

                        leaf_name_data.extend(self.address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "subobject"):
                            for c in self.subobject:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.subobject.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address"):
                            self.address.append(value)
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-used"):
                            self.is_used = value
                            self.is_used.value_namespace = name_space
                            self.is_used.value_namespace_prefix = name_space_prefix


                class Metric(Entity):
                    """
                    List of Metrics
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: type
                    
                    	Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Lsp.Paths.Metric, self).__init__()

                        self.yang_name = "metric"
                        self.yang_parent_name = "paths"

                        self.cost = YLeaf(YType.uint32, "cost")

                        self.type = YLeaf(YType.uint8, "type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("cost",
                                        "type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Lsp.Paths.Metric, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Lsp.Paths.Metric, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.cost.is_set or
                            self.type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.cost.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "metric" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "cost" or name == "type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "cost"):
                            self.cost = value
                            self.cost.value_namespace = name_space
                            self.cost.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.metric:
                        if (c.has_data()):
                            return True
                    return (
                        self.applied_bw.is_set or
                        self.bw.is_set or
                        self.is_applied_bw_used.is_set or
                        self.is_bw_used.is_set or
                        self.is_reopt_bw_used.is_set or
                        self.reopt_bw.is_set or
                        (self.ero is not None and self.ero.has_data()) or
                        (self.lspa is not None and self.lspa.has_data()) or
                        (self.rro is not None and self.rro.has_data()))

                def has_operation(self):
                    for c in self.metric:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.applied_bw.yfilter != YFilter.not_set or
                        self.bw.yfilter != YFilter.not_set or
                        self.is_applied_bw_used.yfilter != YFilter.not_set or
                        self.is_bw_used.yfilter != YFilter.not_set or
                        self.is_reopt_bw_used.yfilter != YFilter.not_set or
                        self.reopt_bw.yfilter != YFilter.not_set or
                        (self.ero is not None and self.ero.has_operation()) or
                        (self.lspa is not None and self.lspa.has_operation()) or
                        (self.rro is not None and self.rro.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "paths" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.applied_bw.is_set or self.applied_bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.applied_bw.get_name_leafdata())
                    if (self.bw.is_set or self.bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bw.get_name_leafdata())
                    if (self.is_applied_bw_used.is_set or self.is_applied_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_applied_bw_used.get_name_leafdata())
                    if (self.is_bw_used.is_set or self.is_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bw_used.get_name_leafdata())
                    if (self.is_reopt_bw_used.is_set or self.is_reopt_bw_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_reopt_bw_used.get_name_leafdata())
                    if (self.reopt_bw.is_set or self.reopt_bw.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reopt_bw.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ero"):
                        if (self.ero is None):
                            self.ero = MplsPceStdby.Lsps.Lsp.Paths.Ero()
                            self.ero.parent = self
                            self._children_name_map["ero"] = "ero"
                        return self.ero

                    if (child_yang_name == "lspa"):
                        if (self.lspa is None):
                            self.lspa = MplsPceStdby.Lsps.Lsp.Paths.Lspa()
                            self.lspa.parent = self
                            self._children_name_map["lspa"] = "lspa"
                        return self.lspa

                    if (child_yang_name == "metric"):
                        for c in self.metric:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPceStdby.Lsps.Lsp.Paths.Metric()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.metric.append(c)
                        return c

                    if (child_yang_name == "rro"):
                        if (self.rro is None):
                            self.rro = MplsPceStdby.Lsps.Lsp.Paths.Rro()
                            self.rro.parent = self
                            self._children_name_map["rro"] = "rro"
                        return self.rro

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ero" or name == "lspa" or name == "metric" or name == "rro" or name == "applied-bw" or name == "bw" or name == "is-applied-bw-used" or name == "is-bw-used" or name == "is-reopt-bw-used" or name == "reopt-bw"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "applied-bw"):
                        self.applied_bw = value
                        self.applied_bw.value_namespace = name_space
                        self.applied_bw.value_namespace_prefix = name_space_prefix
                    if(value_path == "bw"):
                        self.bw = value
                        self.bw.value_namespace = name_space
                        self.bw.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-applied-bw-used"):
                        self.is_applied_bw_used = value
                        self.is_applied_bw_used.value_namespace = name_space
                        self.is_applied_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bw-used"):
                        self.is_bw_used = value
                        self.is_bw_used.value_namespace = name_space
                        self.is_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-reopt-bw-used"):
                        self.is_reopt_bw_used = value
                        self.is_reopt_bw_used.value_namespace = name_space
                        self.is_reopt_bw_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "reopt-bw"):
                        self.reopt_bw = value
                        self.reopt_bw.value_namespace = name_space
                        self.reopt_bw.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.paths:
                    if (c.has_data()):
                        return True
                for leaf in self.backup_path.getYLeafs():
                    if (leaf.yfilter != YFilter.not_set):
                        return True
                return (
                    self.symbolic_name.is_set or
                    self.administrative.is_set or
                    self.binding_sid.is_set or
                    self.cleanup_timer_exp.is_set or
                    self.create.is_set or
                    self.delegatable.is_set or
                    self.delegation_timer_exp.is_set or
                    self.destination_address.is_set or
                    self.forward_class_id.is_set or
                    self.load_share.is_set or
                    self.lspo_is_used.is_set or
                    self.operational.is_set or
                    self.path_setup_type.is_set or
                    self.request_queue_size.is_set or
                    self.session_internal_lsp_id.is_set or
                    self.source_address.is_set or
                    self.state_timer_exp.is_set or
                    self.stateful_request_parameter_id.is_set or
                    self.symbolic_name_xr.is_set or
                    (self.autoroute is not None and self.autoroute.has_data()) or
                    (self.creator is not None and self.creator.has_data()) or
                    (self.delegated is not None and self.delegated.has_data()) or
                    (self.identifiers is not None and self.identifiers.has_data()))

            def has_operation(self):
                for c in self.paths:
                    if (c.has_operation()):
                        return True
                for leaf in self.backup_path.getYLeafs():
                    if (leaf.is_set):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.symbolic_name.yfilter != YFilter.not_set or
                    self.administrative.yfilter != YFilter.not_set or
                    self.backup_path.yfilter != YFilter.not_set or
                    self.binding_sid.yfilter != YFilter.not_set or
                    self.cleanup_timer_exp.yfilter != YFilter.not_set or
                    self.create.yfilter != YFilter.not_set or
                    self.delegatable.yfilter != YFilter.not_set or
                    self.delegation_timer_exp.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.forward_class_id.yfilter != YFilter.not_set or
                    self.load_share.yfilter != YFilter.not_set or
                    self.lspo_is_used.yfilter != YFilter.not_set or
                    self.operational.yfilter != YFilter.not_set or
                    self.path_setup_type.yfilter != YFilter.not_set or
                    self.request_queue_size.yfilter != YFilter.not_set or
                    self.session_internal_lsp_id.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.state_timer_exp.yfilter != YFilter.not_set or
                    self.stateful_request_parameter_id.yfilter != YFilter.not_set or
                    self.symbolic_name_xr.yfilter != YFilter.not_set or
                    (self.autoroute is not None and self.autoroute.has_operation()) or
                    (self.creator is not None and self.creator.has_operation()) or
                    (self.delegated is not None and self.delegated.has_operation()) or
                    (self.identifiers is not None and self.identifiers.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp" + "[symbolic-name='" + self.symbolic_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.symbolic_name.get_name_leafdata())
                if (self.administrative.is_set or self.administrative.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.administrative.get_name_leafdata())
                if (self.binding_sid.is_set or self.binding_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.binding_sid.get_name_leafdata())
                if (self.cleanup_timer_exp.is_set or self.cleanup_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.cleanup_timer_exp.get_name_leafdata())
                if (self.create.is_set or self.create.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create.get_name_leafdata())
                if (self.delegatable.is_set or self.delegatable.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delegatable.get_name_leafdata())
                if (self.delegation_timer_exp.is_set or self.delegation_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delegation_timer_exp.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.forward_class_id.is_set or self.forward_class_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.forward_class_id.get_name_leafdata())
                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.load_share.get_name_leafdata())
                if (self.lspo_is_used.is_set or self.lspo_is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lspo_is_used.get_name_leafdata())
                if (self.operational.is_set or self.operational.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.operational.get_name_leafdata())
                if (self.path_setup_type.is_set or self.path_setup_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_setup_type.get_name_leafdata())
                if (self.request_queue_size.is_set or self.request_queue_size.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.request_queue_size.get_name_leafdata())
                if (self.session_internal_lsp_id.is_set or self.session_internal_lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.session_internal_lsp_id.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.state_timer_exp.is_set or self.state_timer_exp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.state_timer_exp.get_name_leafdata())
                if (self.stateful_request_parameter_id.is_set or self.stateful_request_parameter_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stateful_request_parameter_id.get_name_leafdata())
                if (self.symbolic_name_xr.is_set or self.symbolic_name_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.symbolic_name_xr.get_name_leafdata())

                leaf_name_data.extend(self.backup_path.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "autoroute"):
                    if (self.autoroute is None):
                        self.autoroute = MplsPceStdby.Lsps.Lsp.Autoroute()
                        self.autoroute.parent = self
                        self._children_name_map["autoroute"] = "autoroute"
                    return self.autoroute

                if (child_yang_name == "creator"):
                    if (self.creator is None):
                        self.creator = MplsPceStdby.Lsps.Lsp.Creator()
                        self.creator.parent = self
                        self._children_name_map["creator"] = "creator"
                    return self.creator

                if (child_yang_name == "delegated"):
                    if (self.delegated is None):
                        self.delegated = MplsPceStdby.Lsps.Lsp.Delegated()
                        self.delegated.parent = self
                        self._children_name_map["delegated"] = "delegated"
                    return self.delegated

                if (child_yang_name == "identifiers"):
                    if (self.identifiers is None):
                        self.identifiers = MplsPceStdby.Lsps.Lsp.Identifiers()
                        self.identifiers.parent = self
                        self._children_name_map["identifiers"] = "identifiers"
                    return self.identifiers

                if (child_yang_name == "paths"):
                    for c in self.paths:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPceStdby.Lsps.Lsp.Paths()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.paths.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "autoroute" or name == "creator" or name == "delegated" or name == "identifiers" or name == "paths" or name == "symbolic-name" or name == "administrative" or name == "backup-path" or name == "binding-sid" or name == "cleanup-timer-exp" or name == "create" or name == "delegatable" or name == "delegation-timer-exp" or name == "destination-address" or name == "forward-class-id" or name == "load-share" or name == "lspo-is-used" or name == "operational" or name == "path-setup-type" or name == "request-queue-size" or name == "session-internal-lsp-id" or name == "source-address" or name == "state-timer-exp" or name == "stateful-request-parameter-id" or name == "symbolic-name-xr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "symbolic-name"):
                    self.symbolic_name = value
                    self.symbolic_name.value_namespace = name_space
                    self.symbolic_name.value_namespace_prefix = name_space_prefix
                if(value_path == "administrative"):
                    self.administrative = value
                    self.administrative.value_namespace = name_space
                    self.administrative.value_namespace_prefix = name_space_prefix
                if(value_path == "backup-path"):
                    self.backup_path.append(value)
                if(value_path == "binding-sid"):
                    self.binding_sid = value
                    self.binding_sid.value_namespace = name_space
                    self.binding_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "cleanup-timer-exp"):
                    self.cleanup_timer_exp = value
                    self.cleanup_timer_exp.value_namespace = name_space
                    self.cleanup_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "create"):
                    self.create = value
                    self.create.value_namespace = name_space
                    self.create.value_namespace_prefix = name_space_prefix
                if(value_path == "delegatable"):
                    self.delegatable = value
                    self.delegatable.value_namespace = name_space
                    self.delegatable.value_namespace_prefix = name_space_prefix
                if(value_path == "delegation-timer-exp"):
                    self.delegation_timer_exp = value
                    self.delegation_timer_exp.value_namespace = name_space
                    self.delegation_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "forward-class-id"):
                    self.forward_class_id = value
                    self.forward_class_id.value_namespace = name_space
                    self.forward_class_id.value_namespace_prefix = name_space_prefix
                if(value_path == "load-share"):
                    self.load_share = value
                    self.load_share.value_namespace = name_space
                    self.load_share.value_namespace_prefix = name_space_prefix
                if(value_path == "lspo-is-used"):
                    self.lspo_is_used = value
                    self.lspo_is_used.value_namespace = name_space
                    self.lspo_is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "operational"):
                    self.operational = value
                    self.operational.value_namespace = name_space
                    self.operational.value_namespace_prefix = name_space_prefix
                if(value_path == "path-setup-type"):
                    self.path_setup_type = value
                    self.path_setup_type.value_namespace = name_space
                    self.path_setup_type.value_namespace_prefix = name_space_prefix
                if(value_path == "request-queue-size"):
                    self.request_queue_size = value
                    self.request_queue_size.value_namespace = name_space
                    self.request_queue_size.value_namespace_prefix = name_space_prefix
                if(value_path == "session-internal-lsp-id"):
                    self.session_internal_lsp_id = value
                    self.session_internal_lsp_id.value_namespace = name_space
                    self.session_internal_lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "state-timer-exp"):
                    self.state_timer_exp = value
                    self.state_timer_exp.value_namespace = name_space
                    self.state_timer_exp.value_namespace_prefix = name_space_prefix
                if(value_path == "stateful-request-parameter-id"):
                    self.stateful_request_parameter_id = value
                    self.stateful_request_parameter_id.value_namespace = name_space
                    self.stateful_request_parameter_id.value_namespace_prefix = name_space_prefix
                if(value_path == "symbolic-name-xr"):
                    self.symbolic_name_xr = value
                    self.symbolic_name_xr.value_namespace = name_space
                    self.symbolic_name_xr.value_namespace_prefix = name_space_prefix


        class Creator(Entity):
            """
            Creator Peer of the LSP
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Creator, self).__init__()

                self.yang_name = "creator"
                self.yang_parent_name = "lsps"

                self.address = YLeaf(YType.str, "address")

                self.node_identifier = YLeaf(YType.str, "node-identifier")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("address",
                                "node_identifier") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Creator, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Creator, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.address.is_set or
                    self.node_identifier.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.address.yfilter != YFilter.not_set or
                    self.node_identifier.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "creator" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.address.get_name_leafdata())
                if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_identifier.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "address" or name == "node-identifier"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "address"):
                    self.address = value
                    self.address.value_namespace = name_space
                    self.address.value_namespace_prefix = name_space_prefix
                if(value_path == "node-identifier"):
                    self.node_identifier = value
                    self.node_identifier.value_namespace = name_space
                    self.node_identifier.value_namespace_prefix = name_space_prefix


        class Delegated(Entity):
            """
            Owner Peer of the LSP
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\:  str
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Delegated, self).__init__()

                self.yang_name = "delegated"
                self.yang_parent_name = "lsps"

                self.address = YLeaf(YType.str, "address")

                self.node_identifier = YLeaf(YType.str, "node-identifier")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("address",
                                "node_identifier") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Delegated, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Delegated, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.address.is_set or
                    self.node_identifier.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.address.yfilter != YFilter.not_set or
                    self.node_identifier.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "delegated" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.address.get_name_leafdata())
                if (self.node_identifier.is_set or self.node_identifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_identifier.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "address" or name == "node-identifier"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "address"):
                    self.address = value
                    self.address.value_namespace = name_space
                    self.address.value_namespace_prefix = name_space_prefix
                if(value_path == "node-identifier"):
                    self.node_identifier = value
                    self.node_identifier.value_namespace = name_space
                    self.node_identifier.value_namespace_prefix = name_space_prefix


        class Identifiers(Entity):
            """
            LSP Identifiers
            
            .. attribute:: ext_tunnel_id
            
            	External Tunnel ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_used
            
            	LSP Identifier used flag
            	**type**\:  bool
            
            .. attribute:: sender
            
            	Sender Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: te_lsp_id
            
            	TE LSP ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_id
            
            	LSPO Tunnel ID
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Identifiers, self).__init__()

                self.yang_name = "identifiers"
                self.yang_parent_name = "lsps"

                self.ext_tunnel_id = YLeaf(YType.uint32, "ext-tunnel-id")

                self.is_used = YLeaf(YType.boolean, "is-used")

                self.sender = YLeaf(YType.str, "sender")

                self.te_lsp_id = YLeaf(YType.uint16, "te-lsp-id")

                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("ext_tunnel_id",
                                "is_used",
                                "sender",
                                "te_lsp_id",
                                "tunnel_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Identifiers, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Identifiers, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.ext_tunnel_id.is_set or
                    self.is_used.is_set or
                    self.sender.is_set or
                    self.te_lsp_id.is_set or
                    self.tunnel_id.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.ext_tunnel_id.yfilter != YFilter.not_set or
                    self.is_used.yfilter != YFilter.not_set or
                    self.sender.yfilter != YFilter.not_set or
                    self.te_lsp_id.yfilter != YFilter.not_set or
                    self.tunnel_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "identifiers" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.ext_tunnel_id.is_set or self.ext_tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ext_tunnel_id.get_name_leafdata())
                if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_used.get_name_leafdata())
                if (self.sender.is_set or self.sender.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sender.get_name_leafdata())
                if (self.te_lsp_id.is_set or self.te_lsp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.te_lsp_id.get_name_leafdata())
                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ext-tunnel-id" or name == "is-used" or name == "sender" or name == "te-lsp-id" or name == "tunnel-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "ext-tunnel-id"):
                    self.ext_tunnel_id = value
                    self.ext_tunnel_id.value_namespace = name_space
                    self.ext_tunnel_id.value_namespace_prefix = name_space_prefix
                if(value_path == "is-used"):
                    self.is_used = value
                    self.is_used.value_namespace = name_space
                    self.is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "sender"):
                    self.sender = value
                    self.sender.value_namespace = name_space
                    self.sender.value_namespace_prefix = name_space_prefix
                if(value_path == "te-lsp-id"):
                    self.te_lsp_id = value
                    self.te_lsp_id.value_namespace = name_space
                    self.te_lsp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-id"):
                    self.tunnel_id = value
                    self.tunnel_id.value_namespace = name_space
                    self.tunnel_id.value_namespace_prefix = name_space_prefix


        class Autoroute(Entity):
            """
            Auto Route
            
            .. attribute:: announced
            
            	Autoroute announced
            	**type**\:  bool
            
            .. attribute:: destination
            
            	Destinations
            	**type**\:  list of str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: is_used
            
            	Autoroute used flag
            	**type**\:  bool
            
            .. attribute:: metric
            
            	Metric Value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: metric_type
            
            	Metric Type
            	**type**\:   :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Autoroute, self).__init__()

                self.yang_name = "autoroute"
                self.yang_parent_name = "lsps"

                self.announced = YLeaf(YType.boolean, "announced")

                self.destination = YLeafList(YType.str, "destination")

                self.is_used = YLeaf(YType.boolean, "is-used")

                self.metric = YLeaf(YType.uint32, "metric")

                self.metric_type = YLeaf(YType.enumeration, "metric-type")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("announced",
                                "destination",
                                "is_used",
                                "metric",
                                "metric_type") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Autoroute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Autoroute, self).__setattr__(name, value)

            def has_data(self):
                for leaf in self.destination.getYLeafs():
                    if (leaf.yfilter != YFilter.not_set):
                        return True
                return (
                    self.announced.is_set or
                    self.is_used.is_set or
                    self.metric.is_set or
                    self.metric_type.is_set)

            def has_operation(self):
                for leaf in self.destination.getYLeafs():
                    if (leaf.is_set):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.announced.yfilter != YFilter.not_set or
                    self.destination.yfilter != YFilter.not_set or
                    self.is_used.yfilter != YFilter.not_set or
                    self.metric.yfilter != YFilter.not_set or
                    self.metric_type.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "autoroute" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.announced.is_set or self.announced.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.announced.get_name_leafdata())
                if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_used.get_name_leafdata())
                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.metric.get_name_leafdata())
                if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.metric_type.get_name_leafdata())

                leaf_name_data.extend(self.destination.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announced" or name == "destination" or name == "is-used" or name == "metric" or name == "metric-type"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "announced"):
                    self.announced = value
                    self.announced.value_namespace = name_space
                    self.announced.value_namespace_prefix = name_space_prefix
                if(value_path == "destination"):
                    self.destination.append(value)
                if(value_path == "is-used"):
                    self.is_used = value
                    self.is_used.value_namespace = name_space
                    self.is_used.value_namespace_prefix = name_space_prefix
                if(value_path == "metric"):
                    self.metric = value
                    self.metric.value_namespace = name_space
                    self.metric.value_namespace_prefix = name_space_prefix
                if(value_path == "metric-type"):
                    self.metric_type = value
                    self.metric_type.value_namespace = name_space
                    self.metric_type.value_namespace_prefix = name_space_prefix


        class Paths(Entity):
            """
            Array of paths
            
            .. attribute:: applied_bw
            
            	Applied bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw
            
            	Bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: ero
            
            	Explicit Router Object
            	**type**\:   :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Ero>`
            
            .. attribute:: is_applied_bw_used
            
            	Applied bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: is_bw_used
            
            	Bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: is_reopt_bw_used
            
            	Reoptimize bandwidth used flag
            	**type**\:  bool
            
            .. attribute:: lspa
            
            	LSP Attributes Object
            	**type**\:   :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Lspa>`
            
            .. attribute:: metric
            
            	List of Metrics
            	**type**\: list of    :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Metric>`
            
            .. attribute:: reopt_bw
            
            	Reoptimize bandwidth
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rro
            
            	Reported Route Object
            	**type**\:   :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Rro>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Lsps.Paths, self).__init__()

                self.yang_name = "paths"
                self.yang_parent_name = "lsps"

                self.applied_bw = YLeaf(YType.uint32, "applied-bw")

                self.bw = YLeaf(YType.uint32, "bw")

                self.is_applied_bw_used = YLeaf(YType.boolean, "is-applied-bw-used")

                self.is_bw_used = YLeaf(YType.boolean, "is-bw-used")

                self.is_reopt_bw_used = YLeaf(YType.boolean, "is-reopt-bw-used")

                self.reopt_bw = YLeaf(YType.uint32, "reopt-bw")

                self.ero = MplsPceStdby.Lsps.Paths.Ero()
                self.ero.parent = self
                self._children_name_map["ero"] = "ero"
                self._children_yang_names.add("ero")

                self.lspa = MplsPceStdby.Lsps.Paths.Lspa()
                self.lspa.parent = self
                self._children_name_map["lspa"] = "lspa"
                self._children_yang_names.add("lspa")

                self.rro = MplsPceStdby.Lsps.Paths.Rro()
                self.rro.parent = self
                self._children_name_map["rro"] = "rro"
                self._children_yang_names.add("rro")

                self.metric = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("applied_bw",
                                "bw",
                                "is_applied_bw_used",
                                "is_bw_used",
                                "is_reopt_bw_used",
                                "reopt_bw") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Lsps.Paths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Lsps.Paths, self).__setattr__(name, value)


            class Ero(Entity):
                """
                Explicit Router Object
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\:  bool
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Ero.Subobject>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Paths.Ero, self).__init__()

                    self.yang_name = "ero"
                    self.yang_parent_name = "paths"

                    self.address = YLeafList(YType.str, "address")

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.subobject = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "cost",
                                    "is_used") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Paths.Ero, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Paths.Ero, self).__setattr__(name, value)


                class Subobject(Entity):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\:  bool
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\:  bool
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\:  bool
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\:  bool
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\:  bool
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\:  bool
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\:  bool
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\:  bool
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Paths.Ero.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "ero"

                        self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                        self.global_ = YLeaf(YType.boolean, "global")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                        self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                        self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                        self.node_id = YLeaf(YType.str, "node-id")

                        self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                        self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                        self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                        self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                        self.strict = YLeaf(YType.boolean, "strict")

                        self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("complete_mpls_label_entry",
                                        "global_",
                                        "ipv4_address",
                                        "ipv4_prefix_len",
                                        "local_address",
                                        "missing_node_adjcency_id",
                                        "missing_segment_id",
                                        "mpls_label",
                                        "node_adjacency_id_exists",
                                        "node_id",
                                        "only_valid_mpls_label",
                                        "remote_address",
                                        "segment_id_exists",
                                        "segment_id_type",
                                        "segment_id_value",
                                        "strict",
                                        "subobj_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Paths.Ero.Subobject, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Paths.Ero.Subobject, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.complete_mpls_label_entry.is_set or
                            self.global_.is_set or
                            self.ipv4_address.is_set or
                            self.ipv4_prefix_len.is_set or
                            self.local_address.is_set or
                            self.missing_node_adjcency_id.is_set or
                            self.missing_segment_id.is_set or
                            self.mpls_label.is_set or
                            self.node_adjacency_id_exists.is_set or
                            self.node_id.is_set or
                            self.only_valid_mpls_label.is_set or
                            self.remote_address.is_set or
                            self.segment_id_exists.is_set or
                            self.segment_id_type.is_set or
                            self.segment_id_value.is_set or
                            self.strict.is_set or
                            self.subobj_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                            self.global_.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv4_prefix_len.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                            self.missing_segment_id.yfilter != YFilter.not_set or
                            self.mpls_label.yfilter != YFilter.not_set or
                            self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set or
                            self.only_valid_mpls_label.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set or
                            self.segment_id_exists.yfilter != YFilter.not_set or
                            self.segment_id_type.yfilter != YFilter.not_set or
                            self.segment_id_value.yfilter != YFilter.not_set or
                            self.strict.yfilter != YFilter.not_set or
                            self.subobj_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "subobject" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/ero/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                        if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                        if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                        if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label.get_name_leafdata())
                        if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())
                        if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())
                        if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                        if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                        if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                        if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict.get_name_leafdata())
                        if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.subobj_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "complete-mpls-label-entry"):
                            self.complete_mpls_label_entry = value
                            self.complete_mpls_label_entry.value_namespace = name_space
                            self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                        if(value_path == "global"):
                            self.global_ = value
                            self.global_.value_namespace = name_space
                            self.global_.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-prefix-len"):
                            self.ipv4_prefix_len = value
                            self.ipv4_prefix_len.value_namespace = name_space
                            self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-node-adjcency-id"):
                            self.missing_node_adjcency_id = value
                            self.missing_node_adjcency_id.value_namespace = name_space
                            self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-segment-id"):
                            self.missing_segment_id = value
                            self.missing_segment_id.value_namespace = name_space
                            self.missing_segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label"):
                            self.mpls_label = value
                            self.mpls_label.value_namespace = name_space
                            self.mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-adjacency-id-exists"):
                            self.node_adjacency_id_exists = value
                            self.node_adjacency_id_exists.value_namespace = name_space
                            self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "only-valid-mpls-label"):
                            self.only_valid_mpls_label = value
                            self.only_valid_mpls_label.value_namespace = name_space
                            self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-exists"):
                            self.segment_id_exists = value
                            self.segment_id_exists.value_namespace = name_space
                            self.segment_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-type"):
                            self.segment_id_type = value
                            self.segment_id_type.value_namespace = name_space
                            self.segment_id_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-value"):
                            self.segment_id_value = value
                            self.segment_id_value.value_namespace = name_space
                            self.segment_id_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict"):
                            self.strict = value
                            self.strict.value_namespace = name_space
                            self.strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "subobj-type"):
                            self.subobj_type = value
                            self.subobj_type.value_namespace = name_space
                            self.subobj_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.subobject:
                        if (c.has_data()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.cost.is_set or
                        self.is_used.is_set)

                def has_operation(self):
                    for c in self.subobject:
                        if (c.has_operation()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ero" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())

                    leaf_name_data.extend(self.address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "subobject"):
                        for c in self.subobject:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPceStdby.Lsps.Paths.Ero.Subobject()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.subobject.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address.append(value)
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix


            class Lspa(Entity):
                """
                LSP Attributes Object
                
                .. attribute:: exlude_any
                
                	Exclude Any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hold
                
                	Hold
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: include_all
                
                	Include All
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: include_any
                
                	Include Any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	LSPA used flag
                	**type**\:  bool
                
                .. attribute:: lbit
                
                	L flag
                	**type**\:  bool
                
                .. attribute:: setup
                
                	Setup
                	**type**\:  int
                
                	**range:** 0..255
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Paths.Lspa, self).__init__()

                    self.yang_name = "lspa"
                    self.yang_parent_name = "paths"

                    self.exlude_any = YLeaf(YType.uint32, "exlude-any")

                    self.hold = YLeaf(YType.uint8, "hold")

                    self.include_all = YLeaf(YType.uint32, "include-all")

                    self.include_any = YLeaf(YType.uint32, "include-any")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.lbit = YLeaf(YType.boolean, "lbit")

                    self.setup = YLeaf(YType.uint8, "setup")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("exlude_any",
                                    "hold",
                                    "include_all",
                                    "include_any",
                                    "is_used",
                                    "lbit",
                                    "setup") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Paths.Lspa, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Paths.Lspa, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.exlude_any.is_set or
                        self.hold.is_set or
                        self.include_all.is_set or
                        self.include_any.is_set or
                        self.is_used.is_set or
                        self.lbit.is_set or
                        self.setup.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.exlude_any.yfilter != YFilter.not_set or
                        self.hold.yfilter != YFilter.not_set or
                        self.include_all.yfilter != YFilter.not_set or
                        self.include_any.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set or
                        self.lbit.yfilter != YFilter.not_set or
                        self.setup.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lspa" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.exlude_any.is_set or self.exlude_any.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exlude_any.get_name_leafdata())
                    if (self.hold.is_set or self.hold.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold.get_name_leafdata())
                    if (self.include_all.is_set or self.include_all.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.include_all.get_name_leafdata())
                    if (self.include_any.is_set or self.include_any.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.include_any.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())
                    if (self.lbit.is_set or self.lbit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lbit.get_name_leafdata())
                    if (self.setup.is_set or self.setup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "exlude-any" or name == "hold" or name == "include-all" or name == "include-any" or name == "is-used" or name == "lbit" or name == "setup"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "exlude-any"):
                        self.exlude_any = value
                        self.exlude_any.value_namespace = name_space
                        self.exlude_any.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold"):
                        self.hold = value
                        self.hold.value_namespace = name_space
                        self.hold.value_namespace_prefix = name_space_prefix
                    if(value_path == "include-all"):
                        self.include_all = value
                        self.include_all.value_namespace = name_space
                        self.include_all.value_namespace_prefix = name_space_prefix
                    if(value_path == "include-any"):
                        self.include_any = value
                        self.include_any.value_namespace = name_space
                        self.include_any.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix
                    if(value_path == "lbit"):
                        self.lbit = value
                        self.lbit.value_namespace = name_space
                        self.lbit.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup"):
                        self.setup = value
                        self.setup.value_namespace = name_space
                        self.setup.value_namespace_prefix = name_space_prefix


            class Rro(Entity):
                """
                Reported Route Object
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\:  list of str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\:  bool
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of    :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Rro.Subobject>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Paths.Rro, self).__init__()

                    self.yang_name = "rro"
                    self.yang_parent_name = "paths"

                    self.address = YLeafList(YType.str, "address")

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.is_used = YLeaf(YType.boolean, "is-used")

                    self.subobject = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address",
                                    "cost",
                                    "is_used") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Paths.Rro, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Paths.Rro, self).__setattr__(name, value)


                class Subobject(Entity):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\:  bool
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\:  bool
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\:  bool
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\:  bool
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\:  bool
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\:  bool
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\:  bool
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:   :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\:  bool
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsPceStdby.Lsps.Paths.Rro.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "rro"

                        self.complete_mpls_label_entry = YLeaf(YType.boolean, "complete-mpls-label-entry")

                        self.global_ = YLeaf(YType.boolean, "global")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv4_prefix_len = YLeaf(YType.uint32, "ipv4-prefix-len")

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.missing_node_adjcency_id = YLeaf(YType.boolean, "missing-node-adjcency-id")

                        self.missing_segment_id = YLeaf(YType.boolean, "missing-segment-id")

                        self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        self.node_adjacency_id_exists = YLeaf(YType.boolean, "node-adjacency-id-exists")

                        self.node_id = YLeaf(YType.str, "node-id")

                        self.only_valid_mpls_label = YLeaf(YType.boolean, "only-valid-mpls-label")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                        self.segment_id_exists = YLeaf(YType.boolean, "segment-id-exists")

                        self.segment_id_type = YLeaf(YType.enumeration, "segment-id-type")

                        self.segment_id_value = YLeaf(YType.uint32, "segment-id-value")

                        self.strict = YLeaf(YType.boolean, "strict")

                        self.subobj_type = YLeaf(YType.uint8, "subobj-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("complete_mpls_label_entry",
                                        "global_",
                                        "ipv4_address",
                                        "ipv4_prefix_len",
                                        "local_address",
                                        "missing_node_adjcency_id",
                                        "missing_segment_id",
                                        "mpls_label",
                                        "node_adjacency_id_exists",
                                        "node_id",
                                        "only_valid_mpls_label",
                                        "remote_address",
                                        "segment_id_exists",
                                        "segment_id_type",
                                        "segment_id_value",
                                        "strict",
                                        "subobj_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsPceStdby.Lsps.Paths.Rro.Subobject, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsPceStdby.Lsps.Paths.Rro.Subobject, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.complete_mpls_label_entry.is_set or
                            self.global_.is_set or
                            self.ipv4_address.is_set or
                            self.ipv4_prefix_len.is_set or
                            self.local_address.is_set or
                            self.missing_node_adjcency_id.is_set or
                            self.missing_segment_id.is_set or
                            self.mpls_label.is_set or
                            self.node_adjacency_id_exists.is_set or
                            self.node_id.is_set or
                            self.only_valid_mpls_label.is_set or
                            self.remote_address.is_set or
                            self.segment_id_exists.is_set or
                            self.segment_id_type.is_set or
                            self.segment_id_value.is_set or
                            self.strict.is_set or
                            self.subobj_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.complete_mpls_label_entry.yfilter != YFilter.not_set or
                            self.global_.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv4_prefix_len.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.missing_node_adjcency_id.yfilter != YFilter.not_set or
                            self.missing_segment_id.yfilter != YFilter.not_set or
                            self.mpls_label.yfilter != YFilter.not_set or
                            self.node_adjacency_id_exists.yfilter != YFilter.not_set or
                            self.node_id.yfilter != YFilter.not_set or
                            self.only_valid_mpls_label.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set or
                            self.segment_id_exists.yfilter != YFilter.not_set or
                            self.segment_id_type.yfilter != YFilter.not_set or
                            self.segment_id_value.yfilter != YFilter.not_set or
                            self.strict.yfilter != YFilter.not_set or
                            self.subobj_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "subobject" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/rro/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.complete_mpls_label_entry.is_set or self.complete_mpls_label_entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.complete_mpls_label_entry.get_name_leafdata())
                        if (self.global_.is_set or self.global_.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv4_prefix_len.is_set or self.ipv4_prefix_len.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_prefix_len.get_name_leafdata())
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.missing_node_adjcency_id.is_set or self.missing_node_adjcency_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_node_adjcency_id.get_name_leafdata())
                        if (self.missing_segment_id.is_set or self.missing_segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.missing_segment_id.get_name_leafdata())
                        if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label.get_name_leafdata())
                        if (self.node_adjacency_id_exists.is_set or self.node_adjacency_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_adjacency_id_exists.get_name_leafdata())
                        if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_id.get_name_leafdata())
                        if (self.only_valid_mpls_label.is_set or self.only_valid_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.only_valid_mpls_label.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())
                        if (self.segment_id_exists.is_set or self.segment_id_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_exists.get_name_leafdata())
                        if (self.segment_id_type.is_set or self.segment_id_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_type.get_name_leafdata())
                        if (self.segment_id_value.is_set or self.segment_id_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_value.get_name_leafdata())
                        if (self.strict.is_set or self.strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.strict.get_name_leafdata())
                        if (self.subobj_type.is_set or self.subobj_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.subobj_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "complete-mpls-label-entry" or name == "global" or name == "ipv4-address" or name == "ipv4-prefix-len" or name == "local-address" or name == "missing-node-adjcency-id" or name == "missing-segment-id" or name == "mpls-label" or name == "node-adjacency-id-exists" or name == "node-id" or name == "only-valid-mpls-label" or name == "remote-address" or name == "segment-id-exists" or name == "segment-id-type" or name == "segment-id-value" or name == "strict" or name == "subobj-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "complete-mpls-label-entry"):
                            self.complete_mpls_label_entry = value
                            self.complete_mpls_label_entry.value_namespace = name_space
                            self.complete_mpls_label_entry.value_namespace_prefix = name_space_prefix
                        if(value_path == "global"):
                            self.global_ = value
                            self.global_.value_namespace = name_space
                            self.global_.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-prefix-len"):
                            self.ipv4_prefix_len = value
                            self.ipv4_prefix_len.value_namespace = name_space
                            self.ipv4_prefix_len.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-node-adjcency-id"):
                            self.missing_node_adjcency_id = value
                            self.missing_node_adjcency_id.value_namespace = name_space
                            self.missing_node_adjcency_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "missing-segment-id"):
                            self.missing_segment_id = value
                            self.missing_segment_id.value_namespace = name_space
                            self.missing_segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label"):
                            self.mpls_label = value
                            self.mpls_label.value_namespace = name_space
                            self.mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-adjacency-id-exists"):
                            self.node_adjacency_id_exists = value
                            self.node_adjacency_id_exists.value_namespace = name_space
                            self.node_adjacency_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-id"):
                            self.node_id = value
                            self.node_id.value_namespace = name_space
                            self.node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "only-valid-mpls-label"):
                            self.only_valid_mpls_label = value
                            self.only_valid_mpls_label.value_namespace = name_space
                            self.only_valid_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-exists"):
                            self.segment_id_exists = value
                            self.segment_id_exists.value_namespace = name_space
                            self.segment_id_exists.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-type"):
                            self.segment_id_type = value
                            self.segment_id_type.value_namespace = name_space
                            self.segment_id_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-value"):
                            self.segment_id_value = value
                            self.segment_id_value.value_namespace = name_space
                            self.segment_id_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "strict"):
                            self.strict = value
                            self.strict.value_namespace = name_space
                            self.strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "subobj-type"):
                            self.subobj_type = value
                            self.subobj_type.value_namespace = name_space
                            self.subobj_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.subobject:
                        if (c.has_data()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.yfilter != YFilter.not_set):
                            return True
                    return (
                        self.cost.is_set or
                        self.is_used.is_set)

                def has_operation(self):
                    for c in self.subobject:
                        if (c.has_operation()):
                            return True
                    for leaf in self.address.getYLeafs():
                        if (leaf.is_set):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.is_used.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "rro" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.is_used.is_set or self.is_used.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_used.get_name_leafdata())

                    leaf_name_data.extend(self.address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "subobject"):
                        for c in self.subobject:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsPceStdby.Lsps.Paths.Rro.Subobject()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.subobject.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "subobject" or name == "address" or name == "cost" or name == "is-used"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address"):
                        self.address.append(value)
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-used"):
                        self.is_used = value
                        self.is_used.value_namespace = name_space
                        self.is_used.value_namespace_prefix = name_space_prefix


            class Metric(Entity):
                """
                List of Metrics
                
                .. attribute:: cost
                
                	Cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: type
                
                	Type
                	**type**\:  int
                
                	**range:** 0..255
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Lsps.Paths.Metric, self).__init__()

                    self.yang_name = "metric"
                    self.yang_parent_name = "paths"

                    self.cost = YLeaf(YType.uint32, "cost")

                    self.type = YLeaf(YType.uint8, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("cost",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Lsps.Paths.Metric, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Lsps.Paths.Metric, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.cost.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.cost.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "metric" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.cost.is_set or self.cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "cost" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "cost"):
                        self.cost = value
                        self.cost.value_namespace = name_space
                        self.cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.metric:
                    if (c.has_data()):
                        return True
                return (
                    self.applied_bw.is_set or
                    self.bw.is_set or
                    self.is_applied_bw_used.is_set or
                    self.is_bw_used.is_set or
                    self.is_reopt_bw_used.is_set or
                    self.reopt_bw.is_set or
                    (self.ero is not None and self.ero.has_data()) or
                    (self.lspa is not None and self.lspa.has_data()) or
                    (self.rro is not None and self.rro.has_data()))

            def has_operation(self):
                for c in self.metric:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.applied_bw.yfilter != YFilter.not_set or
                    self.bw.yfilter != YFilter.not_set or
                    self.is_applied_bw_used.yfilter != YFilter.not_set or
                    self.is_bw_used.yfilter != YFilter.not_set or
                    self.is_reopt_bw_used.yfilter != YFilter.not_set or
                    self.reopt_bw.yfilter != YFilter.not_set or
                    (self.ero is not None and self.ero.has_operation()) or
                    (self.lspa is not None and self.lspa.has_operation()) or
                    (self.rro is not None and self.rro.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.applied_bw.is_set or self.applied_bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.applied_bw.get_name_leafdata())
                if (self.bw.is_set or self.bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw.get_name_leafdata())
                if (self.is_applied_bw_used.is_set or self.is_applied_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_applied_bw_used.get_name_leafdata())
                if (self.is_bw_used.is_set or self.is_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_bw_used.get_name_leafdata())
                if (self.is_reopt_bw_used.is_set or self.is_reopt_bw_used.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_reopt_bw_used.get_name_leafdata())
                if (self.reopt_bw.is_set or self.reopt_bw.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reopt_bw.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ero"):
                    if (self.ero is None):
                        self.ero = MplsPceStdby.Lsps.Paths.Ero()
                        self.ero.parent = self
                        self._children_name_map["ero"] = "ero"
                    return self.ero

                if (child_yang_name == "lspa"):
                    if (self.lspa is None):
                        self.lspa = MplsPceStdby.Lsps.Paths.Lspa()
                        self.lspa.parent = self
                        self._children_name_map["lspa"] = "lspa"
                    return self.lspa

                if (child_yang_name == "metric"):
                    for c in self.metric:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPceStdby.Lsps.Paths.Metric()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.metric.append(c)
                    return c

                if (child_yang_name == "rro"):
                    if (self.rro is None):
                        self.rro = MplsPceStdby.Lsps.Paths.Rro()
                        self.rro.parent = self
                        self._children_name_map["rro"] = "rro"
                    return self.rro

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ero" or name == "lspa" or name == "metric" or name == "rro" or name == "applied-bw" or name == "bw" or name == "is-applied-bw-used" or name == "is-bw-used" or name == "is-reopt-bw-used" or name == "reopt-bw"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "applied-bw"):
                    self.applied_bw = value
                    self.applied_bw.value_namespace = name_space
                    self.applied_bw.value_namespace_prefix = name_space_prefix
                if(value_path == "bw"):
                    self.bw = value
                    self.bw.value_namespace = name_space
                    self.bw.value_namespace_prefix = name_space_prefix
                if(value_path == "is-applied-bw-used"):
                    self.is_applied_bw_used = value
                    self.is_applied_bw_used.value_namespace = name_space
                    self.is_applied_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "is-bw-used"):
                    self.is_bw_used = value
                    self.is_bw_used.value_namespace = name_space
                    self.is_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "is-reopt-bw-used"):
                    self.is_reopt_bw_used = value
                    self.is_reopt_bw_used.value_namespace = name_space
                    self.is_reopt_bw_used.value_namespace_prefix = name_space_prefix
                if(value_path == "reopt-bw"):
                    self.reopt_bw = value
                    self.reopt_bw.value_namespace = name_space
                    self.reopt_bw.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.lsp:
                if (c.has_data()):
                    return True
            for c in self.paths:
                if (c.has_data()):
                    return True
            for leaf in self.backup_path.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            return (
                self.administrative.is_set or
                self.binding_sid.is_set or
                self.cleanup_timer_exp.is_set or
                self.create.is_set or
                self.delegatable.is_set or
                self.delegation_timer_exp.is_set or
                self.destination_address.is_set or
                self.forward_class_id.is_set or
                self.load_share.is_set or
                self.lspo_is_used.is_set or
                self.operational.is_set or
                self.path_setup_type.is_set or
                self.request_queue_size.is_set or
                self.session_internal_lsp_id.is_set or
                self.source_address.is_set or
                self.state_timer_exp.is_set or
                self.stateful_request_parameter_id.is_set or
                self.symbolic_name_xr.is_set or
                (self.autoroute is not None and self.autoroute.has_data()) or
                (self.creator is not None and self.creator.has_data()) or
                (self.delegated is not None and self.delegated.has_data()) or
                (self.identifiers is not None and self.identifiers.has_data()))

        def has_operation(self):
            for c in self.lsp:
                if (c.has_operation()):
                    return True
            for c in self.paths:
                if (c.has_operation()):
                    return True
            for leaf in self.backup_path.getYLeafs():
                if (leaf.is_set):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.administrative.yfilter != YFilter.not_set or
                self.backup_path.yfilter != YFilter.not_set or
                self.binding_sid.yfilter != YFilter.not_set or
                self.cleanup_timer_exp.yfilter != YFilter.not_set or
                self.create.yfilter != YFilter.not_set or
                self.delegatable.yfilter != YFilter.not_set or
                self.delegation_timer_exp.yfilter != YFilter.not_set or
                self.destination_address.yfilter != YFilter.not_set or
                self.forward_class_id.yfilter != YFilter.not_set or
                self.load_share.yfilter != YFilter.not_set or
                self.lspo_is_used.yfilter != YFilter.not_set or
                self.operational.yfilter != YFilter.not_set or
                self.path_setup_type.yfilter != YFilter.not_set or
                self.request_queue_size.yfilter != YFilter.not_set or
                self.session_internal_lsp_id.yfilter != YFilter.not_set or
                self.source_address.yfilter != YFilter.not_set or
                self.state_timer_exp.yfilter != YFilter.not_set or
                self.stateful_request_parameter_id.yfilter != YFilter.not_set or
                self.symbolic_name_xr.yfilter != YFilter.not_set or
                (self.autoroute is not None and self.autoroute.has_operation()) or
                (self.creator is not None and self.creator.has_operation()) or
                (self.delegated is not None and self.delegated.has_operation()) or
                (self.identifiers is not None and self.identifiers.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "lsps" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.administrative.is_set or self.administrative.yfilter != YFilter.not_set):
                leaf_name_data.append(self.administrative.get_name_leafdata())
            if (self.binding_sid.is_set or self.binding_sid.yfilter != YFilter.not_set):
                leaf_name_data.append(self.binding_sid.get_name_leafdata())
            if (self.cleanup_timer_exp.is_set or self.cleanup_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.cleanup_timer_exp.get_name_leafdata())
            if (self.create.is_set or self.create.yfilter != YFilter.not_set):
                leaf_name_data.append(self.create.get_name_leafdata())
            if (self.delegatable.is_set or self.delegatable.yfilter != YFilter.not_set):
                leaf_name_data.append(self.delegatable.get_name_leafdata())
            if (self.delegation_timer_exp.is_set or self.delegation_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.delegation_timer_exp.get_name_leafdata())
            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.destination_address.get_name_leafdata())
            if (self.forward_class_id.is_set or self.forward_class_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.forward_class_id.get_name_leafdata())
            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                leaf_name_data.append(self.load_share.get_name_leafdata())
            if (self.lspo_is_used.is_set or self.lspo_is_used.yfilter != YFilter.not_set):
                leaf_name_data.append(self.lspo_is_used.get_name_leafdata())
            if (self.operational.is_set or self.operational.yfilter != YFilter.not_set):
                leaf_name_data.append(self.operational.get_name_leafdata())
            if (self.path_setup_type.is_set or self.path_setup_type.yfilter != YFilter.not_set):
                leaf_name_data.append(self.path_setup_type.get_name_leafdata())
            if (self.request_queue_size.is_set or self.request_queue_size.yfilter != YFilter.not_set):
                leaf_name_data.append(self.request_queue_size.get_name_leafdata())
            if (self.session_internal_lsp_id.is_set or self.session_internal_lsp_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.session_internal_lsp_id.get_name_leafdata())
            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.source_address.get_name_leafdata())
            if (self.state_timer_exp.is_set or self.state_timer_exp.yfilter != YFilter.not_set):
                leaf_name_data.append(self.state_timer_exp.get_name_leafdata())
            if (self.stateful_request_parameter_id.is_set or self.stateful_request_parameter_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.stateful_request_parameter_id.get_name_leafdata())
            if (self.symbolic_name_xr.is_set or self.symbolic_name_xr.yfilter != YFilter.not_set):
                leaf_name_data.append(self.symbolic_name_xr.get_name_leafdata())

            leaf_name_data.extend(self.backup_path.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "autoroute"):
                if (self.autoroute is None):
                    self.autoroute = MplsPceStdby.Lsps.Autoroute()
                    self.autoroute.parent = self
                    self._children_name_map["autoroute"] = "autoroute"
                return self.autoroute

            if (child_yang_name == "creator"):
                if (self.creator is None):
                    self.creator = MplsPceStdby.Lsps.Creator()
                    self.creator.parent = self
                    self._children_name_map["creator"] = "creator"
                return self.creator

            if (child_yang_name == "delegated"):
                if (self.delegated is None):
                    self.delegated = MplsPceStdby.Lsps.Delegated()
                    self.delegated.parent = self
                    self._children_name_map["delegated"] = "delegated"
                return self.delegated

            if (child_yang_name == "identifiers"):
                if (self.identifiers is None):
                    self.identifiers = MplsPceStdby.Lsps.Identifiers()
                    self.identifiers.parent = self
                    self._children_name_map["identifiers"] = "identifiers"
                return self.identifiers

            if (child_yang_name == "lsp"):
                for c in self.lsp:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPceStdby.Lsps.Lsp()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.lsp.append(c)
                return c

            if (child_yang_name == "paths"):
                for c in self.paths:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPceStdby.Lsps.Paths()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.paths.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "autoroute" or name == "creator" or name == "delegated" or name == "identifiers" or name == "lsp" or name == "paths" or name == "administrative" or name == "backup-path" or name == "binding-sid" or name == "cleanup-timer-exp" or name == "create" or name == "delegatable" or name == "delegation-timer-exp" or name == "destination-address" or name == "forward-class-id" or name == "load-share" or name == "lspo-is-used" or name == "operational" or name == "path-setup-type" or name == "request-queue-size" or name == "session-internal-lsp-id" or name == "source-address" or name == "state-timer-exp" or name == "stateful-request-parameter-id" or name == "symbolic-name-xr"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "administrative"):
                self.administrative = value
                self.administrative.value_namespace = name_space
                self.administrative.value_namespace_prefix = name_space_prefix
            if(value_path == "backup-path"):
                self.backup_path.append(value)
            if(value_path == "binding-sid"):
                self.binding_sid = value
                self.binding_sid.value_namespace = name_space
                self.binding_sid.value_namespace_prefix = name_space_prefix
            if(value_path == "cleanup-timer-exp"):
                self.cleanup_timer_exp = value
                self.cleanup_timer_exp.value_namespace = name_space
                self.cleanup_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "create"):
                self.create = value
                self.create.value_namespace = name_space
                self.create.value_namespace_prefix = name_space_prefix
            if(value_path == "delegatable"):
                self.delegatable = value
                self.delegatable.value_namespace = name_space
                self.delegatable.value_namespace_prefix = name_space_prefix
            if(value_path == "delegation-timer-exp"):
                self.delegation_timer_exp = value
                self.delegation_timer_exp.value_namespace = name_space
                self.delegation_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "destination-address"):
                self.destination_address = value
                self.destination_address.value_namespace = name_space
                self.destination_address.value_namespace_prefix = name_space_prefix
            if(value_path == "forward-class-id"):
                self.forward_class_id = value
                self.forward_class_id.value_namespace = name_space
                self.forward_class_id.value_namespace_prefix = name_space_prefix
            if(value_path == "load-share"):
                self.load_share = value
                self.load_share.value_namespace = name_space
                self.load_share.value_namespace_prefix = name_space_prefix
            if(value_path == "lspo-is-used"):
                self.lspo_is_used = value
                self.lspo_is_used.value_namespace = name_space
                self.lspo_is_used.value_namespace_prefix = name_space_prefix
            if(value_path == "operational"):
                self.operational = value
                self.operational.value_namespace = name_space
                self.operational.value_namespace_prefix = name_space_prefix
            if(value_path == "path-setup-type"):
                self.path_setup_type = value
                self.path_setup_type.value_namespace = name_space
                self.path_setup_type.value_namespace_prefix = name_space_prefix
            if(value_path == "request-queue-size"):
                self.request_queue_size = value
                self.request_queue_size.value_namespace = name_space
                self.request_queue_size.value_namespace_prefix = name_space_prefix
            if(value_path == "session-internal-lsp-id"):
                self.session_internal_lsp_id = value
                self.session_internal_lsp_id.value_namespace = name_space
                self.session_internal_lsp_id.value_namespace_prefix = name_space_prefix
            if(value_path == "source-address"):
                self.source_address = value
                self.source_address.value_namespace = name_space
                self.source_address.value_namespace_prefix = name_space_prefix
            if(value_path == "state-timer-exp"):
                self.state_timer_exp = value
                self.state_timer_exp.value_namespace = name_space
                self.state_timer_exp.value_namespace_prefix = name_space_prefix
            if(value_path == "stateful-request-parameter-id"):
                self.stateful_request_parameter_id = value
                self.stateful_request_parameter_id.value_namespace = name_space
                self.stateful_request_parameter_id.value_namespace_prefix = name_space_prefix
            if(value_path == "symbolic-name-xr"):
                self.symbolic_name_xr = value
                self.symbolic_name_xr.value_namespace = name_space
                self.symbolic_name_xr.value_namespace_prefix = name_space_prefix


    class Statistics(Entity):
        """
        PCE stats info
        
        .. attribute:: average_in_queue_depth
        
        	Average Input Queue Depth
        	**type**\:  list of int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_file_descriptors
        
        	Number of TCP file descriptors currently in use
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_pceq_length
        
        	Current PCE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_teq_length
        
        	Current TE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: igp_statistics
        
        	IGP Statistics
        	**type**\:   :py:class:`IgpStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics.IgpStatistics>`
        
        .. attribute:: max_file_descriptors
        
        	Maximum number of TCP file descriptors used
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: max_pceq_length
        
        	Max PCE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: max_teq_length
        
        	Max TE queue length
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: maximum_in_queue_depth
        
        	Max Input Queue Depth
        	**type**\:  list of int
        
        	**range:** 0..4294967295
        
        .. attribute:: neighbors
        
        	Neighbor Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_pending
        
        	Number of pending req
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_timed_out
        
        	Number of timedout req
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: pce_req_total
        
        	Total number of PCEReq
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: tunnels
        
        	Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPceStdby.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-pce-stdby"

            self.average_in_queue_depth = YLeafList(YType.uint32, "average-in-queue-depth")

            self.current_file_descriptors = YLeaf(YType.uint32, "current-file-descriptors")

            self.current_pceq_length = YLeaf(YType.uint32, "current-pceq-length")

            self.current_teq_length = YLeaf(YType.uint32, "current-teq-length")

            self.max_file_descriptors = YLeaf(YType.uint32, "max-file-descriptors")

            self.max_pceq_length = YLeaf(YType.uint32, "max-pceq-length")

            self.max_teq_length = YLeaf(YType.uint32, "max-teq-length")

            self.maximum_in_queue_depth = YLeafList(YType.uint32, "maximum-in-queue-depth")

            self.neighbors = YLeaf(YType.uint32, "neighbors")

            self.pce_req_pending = YLeaf(YType.uint32, "pce-req-pending")

            self.pce_req_timed_out = YLeaf(YType.uint32, "pce-req-timed-out")

            self.pce_req_total = YLeaf(YType.uint32, "pce-req-total")

            self.tunnels = YLeaf(YType.uint32, "tunnels")

            self.igp_statistics = MplsPceStdby.Statistics.IgpStatistics()
            self.igp_statistics.parent = self
            self._children_name_map["igp_statistics"] = "igp-statistics"
            self._children_yang_names.add("igp-statistics")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("average_in_queue_depth",
                            "current_file_descriptors",
                            "current_pceq_length",
                            "current_teq_length",
                            "max_file_descriptors",
                            "max_pceq_length",
                            "max_teq_length",
                            "maximum_in_queue_depth",
                            "neighbors",
                            "pce_req_pending",
                            "pce_req_timed_out",
                            "pce_req_total",
                            "tunnels") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPceStdby.Statistics, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPceStdby.Statistics, self).__setattr__(name, value)


        class IgpStatistics(Entity):
            """
            IGP Statistics
            
            .. attribute:: abr_lookup_avg
            
            	ABR Lookup Avg
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_complete
            
            	ABR Lookup Complete
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_max
            
            	ABR Lookup Max
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_min
            
            	ABR Lookup Min
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: abr_lookup_timeout
            
            	ABR Lookup Timeout
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Statistics.IgpStatistics, self).__init__()

                self.yang_name = "igp-statistics"
                self.yang_parent_name = "statistics"

                self.abr_lookup_avg = YLeaf(YType.uint64, "abr-lookup-avg")

                self.abr_lookup_complete = YLeaf(YType.uint64, "abr-lookup-complete")

                self.abr_lookup_max = YLeaf(YType.uint64, "abr-lookup-max")

                self.abr_lookup_min = YLeaf(YType.uint64, "abr-lookup-min")

                self.abr_lookup_timeout = YLeaf(YType.uint64, "abr-lookup-timeout")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("abr_lookup_avg",
                                "abr_lookup_complete",
                                "abr_lookup_max",
                                "abr_lookup_min",
                                "abr_lookup_timeout") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Statistics.IgpStatistics, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Statistics.IgpStatistics, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.abr_lookup_avg.is_set or
                    self.abr_lookup_complete.is_set or
                    self.abr_lookup_max.is_set or
                    self.abr_lookup_min.is_set or
                    self.abr_lookup_timeout.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.abr_lookup_avg.yfilter != YFilter.not_set or
                    self.abr_lookup_complete.yfilter != YFilter.not_set or
                    self.abr_lookup_max.yfilter != YFilter.not_set or
                    self.abr_lookup_min.yfilter != YFilter.not_set or
                    self.abr_lookup_timeout.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-statistics" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/statistics/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.abr_lookup_avg.is_set or self.abr_lookup_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_avg.get_name_leafdata())
                if (self.abr_lookup_complete.is_set or self.abr_lookup_complete.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_complete.get_name_leafdata())
                if (self.abr_lookup_max.is_set or self.abr_lookup_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_max.get_name_leafdata())
                if (self.abr_lookup_min.is_set or self.abr_lookup_min.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_min.get_name_leafdata())
                if (self.abr_lookup_timeout.is_set or self.abr_lookup_timeout.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.abr_lookup_timeout.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "abr-lookup-avg" or name == "abr-lookup-complete" or name == "abr-lookup-max" or name == "abr-lookup-min" or name == "abr-lookup-timeout"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "abr-lookup-avg"):
                    self.abr_lookup_avg = value
                    self.abr_lookup_avg.value_namespace = name_space
                    self.abr_lookup_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-complete"):
                    self.abr_lookup_complete = value
                    self.abr_lookup_complete.value_namespace = name_space
                    self.abr_lookup_complete.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-max"):
                    self.abr_lookup_max = value
                    self.abr_lookup_max.value_namespace = name_space
                    self.abr_lookup_max.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-min"):
                    self.abr_lookup_min = value
                    self.abr_lookup_min.value_namespace = name_space
                    self.abr_lookup_min.value_namespace_prefix = name_space_prefix
                if(value_path == "abr-lookup-timeout"):
                    self.abr_lookup_timeout = value
                    self.abr_lookup_timeout.value_namespace = name_space
                    self.abr_lookup_timeout.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for leaf in self.average_in_queue_depth.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            for leaf in self.maximum_in_queue_depth.getYLeafs():
                if (leaf.yfilter != YFilter.not_set):
                    return True
            return (
                self.current_file_descriptors.is_set or
                self.current_pceq_length.is_set or
                self.current_teq_length.is_set or
                self.max_file_descriptors.is_set or
                self.max_pceq_length.is_set or
                self.max_teq_length.is_set or
                self.neighbors.is_set or
                self.pce_req_pending.is_set or
                self.pce_req_timed_out.is_set or
                self.pce_req_total.is_set or
                self.tunnels.is_set or
                (self.igp_statistics is not None and self.igp_statistics.has_data()))

        def has_operation(self):
            for leaf in self.average_in_queue_depth.getYLeafs():
                if (leaf.is_set):
                    return True
            for leaf in self.maximum_in_queue_depth.getYLeafs():
                if (leaf.is_set):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.average_in_queue_depth.yfilter != YFilter.not_set or
                self.current_file_descriptors.yfilter != YFilter.not_set or
                self.current_pceq_length.yfilter != YFilter.not_set or
                self.current_teq_length.yfilter != YFilter.not_set or
                self.max_file_descriptors.yfilter != YFilter.not_set or
                self.max_pceq_length.yfilter != YFilter.not_set or
                self.max_teq_length.yfilter != YFilter.not_set or
                self.maximum_in_queue_depth.yfilter != YFilter.not_set or
                self.neighbors.yfilter != YFilter.not_set or
                self.pce_req_pending.yfilter != YFilter.not_set or
                self.pce_req_timed_out.yfilter != YFilter.not_set or
                self.pce_req_total.yfilter != YFilter.not_set or
                self.tunnels.yfilter != YFilter.not_set or
                (self.igp_statistics is not None and self.igp_statistics.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "statistics" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.current_file_descriptors.is_set or self.current_file_descriptors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_file_descriptors.get_name_leafdata())
            if (self.current_pceq_length.is_set or self.current_pceq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_pceq_length.get_name_leafdata())
            if (self.current_teq_length.is_set or self.current_teq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_teq_length.get_name_leafdata())
            if (self.max_file_descriptors.is_set or self.max_file_descriptors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_file_descriptors.get_name_leafdata())
            if (self.max_pceq_length.is_set or self.max_pceq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_pceq_length.get_name_leafdata())
            if (self.max_teq_length.is_set or self.max_teq_length.yfilter != YFilter.not_set):
                leaf_name_data.append(self.max_teq_length.get_name_leafdata())
            if (self.neighbors.is_set or self.neighbors.yfilter != YFilter.not_set):
                leaf_name_data.append(self.neighbors.get_name_leafdata())
            if (self.pce_req_pending.is_set or self.pce_req_pending.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_pending.get_name_leafdata())
            if (self.pce_req_timed_out.is_set or self.pce_req_timed_out.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_timed_out.get_name_leafdata())
            if (self.pce_req_total.is_set or self.pce_req_total.yfilter != YFilter.not_set):
                leaf_name_data.append(self.pce_req_total.get_name_leafdata())
            if (self.tunnels.is_set or self.tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.tunnels.get_name_leafdata())

            leaf_name_data.extend(self.average_in_queue_depth.get_name_leafdata())

            leaf_name_data.extend(self.maximum_in_queue_depth.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-statistics"):
                if (self.igp_statistics is None):
                    self.igp_statistics = MplsPceStdby.Statistics.IgpStatistics()
                    self.igp_statistics.parent = self
                    self._children_name_map["igp_statistics"] = "igp-statistics"
                return self.igp_statistics

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-statistics" or name == "average-in-queue-depth" or name == "current-file-descriptors" or name == "current-pceq-length" or name == "current-teq-length" or name == "max-file-descriptors" or name == "max-pceq-length" or name == "max-teq-length" or name == "maximum-in-queue-depth" or name == "neighbors" or name == "pce-req-pending" or name == "pce-req-timed-out" or name == "pce-req-total" or name == "tunnels"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "average-in-queue-depth"):
                self.average_in_queue_depth.append(value)
            if(value_path == "current-file-descriptors"):
                self.current_file_descriptors = value
                self.current_file_descriptors.value_namespace = name_space
                self.current_file_descriptors.value_namespace_prefix = name_space_prefix
            if(value_path == "current-pceq-length"):
                self.current_pceq_length = value
                self.current_pceq_length.value_namespace = name_space
                self.current_pceq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "current-teq-length"):
                self.current_teq_length = value
                self.current_teq_length.value_namespace = name_space
                self.current_teq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "max-file-descriptors"):
                self.max_file_descriptors = value
                self.max_file_descriptors.value_namespace = name_space
                self.max_file_descriptors.value_namespace_prefix = name_space_prefix
            if(value_path == "max-pceq-length"):
                self.max_pceq_length = value
                self.max_pceq_length.value_namespace = name_space
                self.max_pceq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "max-teq-length"):
                self.max_teq_length = value
                self.max_teq_length.value_namespace = name_space
                self.max_teq_length.value_namespace_prefix = name_space_prefix
            if(value_path == "maximum-in-queue-depth"):
                self.maximum_in_queue_depth.append(value)
            if(value_path == "neighbors"):
                self.neighbors = value
                self.neighbors.value_namespace = name_space
                self.neighbors.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-pending"):
                self.pce_req_pending = value
                self.pce_req_pending.value_namespace = name_space
                self.pce_req_pending.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-timed-out"):
                self.pce_req_timed_out = value
                self.pce_req_timed_out.value_namespace = name_space
                self.pce_req_timed_out.value_namespace_prefix = name_space_prefix
            if(value_path == "pce-req-total"):
                self.pce_req_total = value
                self.pce_req_total.value_namespace = name_space
                self.pce_req_total.value_namespace_prefix = name_space_prefix
            if(value_path == "tunnels"):
                self.tunnels = value
                self.tunnels.value_namespace = name_space
                self.tunnels.value_namespace_prefix = name_space_prefix


    class Peers(Entity):
        """
        The set of PCE peers
        
        .. attribute:: peer
        
        	A PCE peer
        	**type**\: list of    :py:class:`Peer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPceStdby.Peers, self).__init__()

            self.yang_name = "peers"
            self.yang_parent_name = "mpls-pce-stdby"

            self.peer = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPceStdby.Peers, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPceStdby.Peers, self).__setattr__(name, value)


        class Peer(Entity):
            """
            A PCE peer
            
            .. attribute:: peer_address  <key>
            
            	The peer address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: candidate
            
            	Candidate
            	**type**\:  bool
            
            .. attribute:: capability_db_version
            
            	DB version capability
            	**type**\:  bool
            
            .. attribute:: capability_instantiate
            
            	Instantiation capability
            	**type**\:  bool
            
            .. attribute:: capability_segment_routing
            
            	Segment Routing capability
            	**type**\:  bool
            
            .. attribute:: capability_update
            
            	Update capability
            	**type**\:  bool
            
            .. attribute:: delta_sync_capability
            
            	Delta Synchronization capability
            	**type**\:  bool
            
            .. attribute:: error
            
            	Error (for display only)
            	**type**\:  str
            
            .. attribute:: ig_ps
            
            	IGPs
            	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.IgPs>`
            
            .. attribute:: keepalives
            
            	Keepalive count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: keychain_enabled
            
            	Keychain based Authentication Enabled
            	**type**\:  bool
            
            .. attribute:: last_rx_pce_err
            
            	Last received PCEErr
            	**type**\:   :py:class:`LastRxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.LastRxPceErr>`
            
            .. attribute:: last_tx_pce_err
            
            	Last sent PCEErr
            	**type**\:   :py:class:`LastTxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.LastTxPceErr>`
            
            .. attribute:: local_sid
            
            	Local PCEP session ID
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: max_dead_interval
            
            	Maximum dead interval for the peer
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: md5_enabled
            
            	MD5 Authentication Enabled
            	**type**\:  bool
            
            .. attribute:: min_keepalive_interval
            
            	Minimum keepalive interval for the peer
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: negotated_dead_time
            
            	Negotiated DT
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: negotiated_keepalive
            
            	Negotiated KA
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_err_rx
            
            	PCEErr Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_err_tx
            
            	PCEErr Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_init_rx
            
            	PCEInit Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_init_tx
            
            	PCEInit Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_keepalive_rx
            
            	PCE Keepalive Rx
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: pce_keepalive_tx
            
            	PCE Keepalive Tx
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: pce_open_rx
            
            	PCEOpen Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_open_tx
            
            	PCEOpen Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rep_rx
            
            	PCERep Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rep_tx
            
            	PCERep Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_req_rx
            
            	PCEReq Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_req_tx
            
            	PCEReq Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rpt_rx
            
            	PCERpt Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_rpt_tx
            
            	PCERpt Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_state
            
            	PCE State
            	**type**\:   :py:class:`PceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceState>`
            
            .. attribute:: pce_upd_rx
            
            	PCEUpd Rx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pce_upd_tx
            
            	PCEUpd Tx
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: pcep_up_time
            
            	PCEP Up Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: precedence
            
            	PCE Precedence
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: remote_sid
            
            	Remote PCEP session ID
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: req_reply_avg
            
            	Average reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: req_reply_max
            
            	Maximum reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: req_reply_min
            
            	Mininum reply time from peer in ms
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: request_timeouts
            
            	Request timeout count
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: stateful
            
            	Stateful
            	**type**\:  bool
            
            .. attribute:: statically_configured
            
            	Statically Configured
            	**type**\:  bool
            
            .. attribute:: triggered_sync_capability
            
            	Triggered Synchronization capability
            	**type**\:  bool
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Peers.Peer, self).__init__()

                self.yang_name = "peer"
                self.yang_parent_name = "peers"

                self.peer_address = YLeaf(YType.str, "peer-address")

                self.candidate = YLeaf(YType.boolean, "candidate")

                self.capability_db_version = YLeaf(YType.boolean, "capability-db-version")

                self.capability_instantiate = YLeaf(YType.boolean, "capability-instantiate")

                self.capability_segment_routing = YLeaf(YType.boolean, "capability-segment-routing")

                self.capability_update = YLeaf(YType.boolean, "capability-update")

                self.delta_sync_capability = YLeaf(YType.boolean, "delta-sync-capability")

                self.error = YLeaf(YType.str, "error")

                self.keepalives = YLeaf(YType.uint32, "keepalives")

                self.keychain_enabled = YLeaf(YType.boolean, "keychain-enabled")

                self.local_sid = YLeaf(YType.uint8, "local-sid")

                self.max_dead_interval = YLeaf(YType.uint8, "max-dead-interval")

                self.md5_enabled = YLeaf(YType.boolean, "md5-enabled")

                self.min_keepalive_interval = YLeaf(YType.uint8, "min-keepalive-interval")

                self.negotated_dead_time = YLeaf(YType.uint32, "negotated-dead-time")

                self.negotiated_keepalive = YLeaf(YType.uint32, "negotiated-keepalive")

                self.pce_err_rx = YLeaf(YType.uint32, "pce-err-rx")

                self.pce_err_tx = YLeaf(YType.uint32, "pce-err-tx")

                self.pce_init_rx = YLeaf(YType.uint32, "pce-init-rx")

                self.pce_init_tx = YLeaf(YType.uint32, "pce-init-tx")

                self.pce_keepalive_rx = YLeaf(YType.uint64, "pce-keepalive-rx")

                self.pce_keepalive_tx = YLeaf(YType.uint64, "pce-keepalive-tx")

                self.pce_open_rx = YLeaf(YType.uint32, "pce-open-rx")

                self.pce_open_tx = YLeaf(YType.uint32, "pce-open-tx")

                self.pce_rep_rx = YLeaf(YType.uint32, "pce-rep-rx")

                self.pce_rep_tx = YLeaf(YType.uint32, "pce-rep-tx")

                self.pce_req_rx = YLeaf(YType.uint32, "pce-req-rx")

                self.pce_req_tx = YLeaf(YType.uint32, "pce-req-tx")

                self.pce_rpt_rx = YLeaf(YType.uint32, "pce-rpt-rx")

                self.pce_rpt_tx = YLeaf(YType.uint32, "pce-rpt-tx")

                self.pce_state = YLeaf(YType.enumeration, "pce-state")

                self.pce_upd_rx = YLeaf(YType.uint32, "pce-upd-rx")

                self.pce_upd_tx = YLeaf(YType.uint32, "pce-upd-tx")

                self.pcep_up_time = YLeaf(YType.uint32, "pcep-up-time")

                self.precedence = YLeaf(YType.uint32, "precedence")

                self.remote_sid = YLeaf(YType.uint8, "remote-sid")

                self.req_reply_avg = YLeaf(YType.uint64, "req-reply-avg")

                self.req_reply_max = YLeaf(YType.uint64, "req-reply-max")

                self.req_reply_min = YLeaf(YType.uint64, "req-reply-min")

                self.request_timeouts = YLeaf(YType.uint64, "request-timeouts")

                self.stateful = YLeaf(YType.boolean, "stateful")

                self.statically_configured = YLeaf(YType.boolean, "statically-configured")

                self.triggered_sync_capability = YLeaf(YType.boolean, "triggered-sync-capability")

                self.last_rx_pce_err = MplsPceStdby.Peers.Peer.LastRxPceErr()
                self.last_rx_pce_err.parent = self
                self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"
                self._children_yang_names.add("last-rx-pce-err")

                self.last_tx_pce_err = MplsPceStdby.Peers.Peer.LastTxPceErr()
                self.last_tx_pce_err.parent = self
                self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"
                self._children_yang_names.add("last-tx-pce-err")

                self.ig_ps = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("peer_address",
                                "candidate",
                                "capability_db_version",
                                "capability_instantiate",
                                "capability_segment_routing",
                                "capability_update",
                                "delta_sync_capability",
                                "error",
                                "keepalives",
                                "keychain_enabled",
                                "local_sid",
                                "max_dead_interval",
                                "md5_enabled",
                                "min_keepalive_interval",
                                "negotated_dead_time",
                                "negotiated_keepalive",
                                "pce_err_rx",
                                "pce_err_tx",
                                "pce_init_rx",
                                "pce_init_tx",
                                "pce_keepalive_rx",
                                "pce_keepalive_tx",
                                "pce_open_rx",
                                "pce_open_tx",
                                "pce_rep_rx",
                                "pce_rep_tx",
                                "pce_req_rx",
                                "pce_req_tx",
                                "pce_rpt_rx",
                                "pce_rpt_tx",
                                "pce_state",
                                "pce_upd_rx",
                                "pce_upd_tx",
                                "pcep_up_time",
                                "precedence",
                                "remote_sid",
                                "req_reply_avg",
                                "req_reply_max",
                                "req_reply_min",
                                "request_timeouts",
                                "stateful",
                                "statically_configured",
                                "triggered_sync_capability") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Peers.Peer, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Peers.Peer, self).__setattr__(name, value)


            class LastTxPceErr(Entity):
                """
                Last sent PCEErr
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\:  bool
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\:  bool
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Peers.Peer.LastTxPceErr, self).__init__()

                    self.yang_name = "last-tx-pce-err"
                    self.yang_parent_name = "peer"

                    self.has_open_object = YLeaf(YType.boolean, "has-open-object")

                    self.has_rp_object = YLeaf(YType.boolean, "has-rp-object")

                    self.open_dead_time = YLeaf(YType.uint32, "open-dead-time")

                    self.open_keepalive = YLeaf(YType.uint32, "open-keepalive")

                    self.openversion = YLeaf(YType.uint32, "openversion")

                    self.pce_err_type = YLeaf(YType.uint32, "pce-err-type")

                    self.pce_err_value = YLeaf(YType.uint32, "pce-err-value")

                    self.rp_request_id = YLeaf(YType.uint32, "rp-request-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("has_open_object",
                                    "has_rp_object",
                                    "open_dead_time",
                                    "open_keepalive",
                                    "openversion",
                                    "pce_err_type",
                                    "pce_err_value",
                                    "rp_request_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Peers.Peer.LastTxPceErr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Peers.Peer.LastTxPceErr, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.has_open_object.is_set or
                        self.has_rp_object.is_set or
                        self.open_dead_time.is_set or
                        self.open_keepalive.is_set or
                        self.openversion.is_set or
                        self.pce_err_type.is_set or
                        self.pce_err_value.is_set or
                        self.rp_request_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.has_open_object.yfilter != YFilter.not_set or
                        self.has_rp_object.yfilter != YFilter.not_set or
                        self.open_dead_time.yfilter != YFilter.not_set or
                        self.open_keepalive.yfilter != YFilter.not_set or
                        self.openversion.yfilter != YFilter.not_set or
                        self.pce_err_type.yfilter != YFilter.not_set or
                        self.pce_err_value.yfilter != YFilter.not_set or
                        self.rp_request_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-tx-pce-err" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.has_open_object.is_set or self.has_open_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_open_object.get_name_leafdata())
                    if (self.has_rp_object.is_set or self.has_rp_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_rp_object.get_name_leafdata())
                    if (self.open_dead_time.is_set or self.open_dead_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_dead_time.get_name_leafdata())
                    if (self.open_keepalive.is_set or self.open_keepalive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_keepalive.get_name_leafdata())
                    if (self.openversion.is_set or self.openversion.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.openversion.get_name_leafdata())
                    if (self.pce_err_type.is_set or self.pce_err_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_type.get_name_leafdata())
                    if (self.pce_err_value.is_set or self.pce_err_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_value.get_name_leafdata())
                    if (self.rp_request_id.is_set or self.rp_request_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rp_request_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "has-open-object" or name == "has-rp-object" or name == "open-dead-time" or name == "open-keepalive" or name == "openversion" or name == "pce-err-type" or name == "pce-err-value" or name == "rp-request-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "has-open-object"):
                        self.has_open_object = value
                        self.has_open_object.value_namespace = name_space
                        self.has_open_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-rp-object"):
                        self.has_rp_object = value
                        self.has_rp_object.value_namespace = name_space
                        self.has_rp_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-dead-time"):
                        self.open_dead_time = value
                        self.open_dead_time.value_namespace = name_space
                        self.open_dead_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-keepalive"):
                        self.open_keepalive = value
                        self.open_keepalive.value_namespace = name_space
                        self.open_keepalive.value_namespace_prefix = name_space_prefix
                    if(value_path == "openversion"):
                        self.openversion = value
                        self.openversion.value_namespace = name_space
                        self.openversion.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-type"):
                        self.pce_err_type = value
                        self.pce_err_type.value_namespace = name_space
                        self.pce_err_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-value"):
                        self.pce_err_value = value
                        self.pce_err_value.value_namespace = name_space
                        self.pce_err_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "rp-request-id"):
                        self.rp_request_id = value
                        self.rp_request_id.value_namespace = name_space
                        self.rp_request_id.value_namespace_prefix = name_space_prefix


            class LastRxPceErr(Entity):
                """
                Last received PCEErr
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\:  bool
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\:  bool
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Peers.Peer.LastRxPceErr, self).__init__()

                    self.yang_name = "last-rx-pce-err"
                    self.yang_parent_name = "peer"

                    self.has_open_object = YLeaf(YType.boolean, "has-open-object")

                    self.has_rp_object = YLeaf(YType.boolean, "has-rp-object")

                    self.open_dead_time = YLeaf(YType.uint32, "open-dead-time")

                    self.open_keepalive = YLeaf(YType.uint32, "open-keepalive")

                    self.openversion = YLeaf(YType.uint32, "openversion")

                    self.pce_err_type = YLeaf(YType.uint32, "pce-err-type")

                    self.pce_err_value = YLeaf(YType.uint32, "pce-err-value")

                    self.rp_request_id = YLeaf(YType.uint32, "rp-request-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("has_open_object",
                                    "has_rp_object",
                                    "open_dead_time",
                                    "open_keepalive",
                                    "openversion",
                                    "pce_err_type",
                                    "pce_err_value",
                                    "rp_request_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Peers.Peer.LastRxPceErr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Peers.Peer.LastRxPceErr, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.has_open_object.is_set or
                        self.has_rp_object.is_set or
                        self.open_dead_time.is_set or
                        self.open_keepalive.is_set or
                        self.openversion.is_set or
                        self.pce_err_type.is_set or
                        self.pce_err_value.is_set or
                        self.rp_request_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.has_open_object.yfilter != YFilter.not_set or
                        self.has_rp_object.yfilter != YFilter.not_set or
                        self.open_dead_time.yfilter != YFilter.not_set or
                        self.open_keepalive.yfilter != YFilter.not_set or
                        self.openversion.yfilter != YFilter.not_set or
                        self.pce_err_type.yfilter != YFilter.not_set or
                        self.pce_err_value.yfilter != YFilter.not_set or
                        self.rp_request_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-rx-pce-err" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.has_open_object.is_set or self.has_open_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_open_object.get_name_leafdata())
                    if (self.has_rp_object.is_set or self.has_rp_object.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_rp_object.get_name_leafdata())
                    if (self.open_dead_time.is_set or self.open_dead_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_dead_time.get_name_leafdata())
                    if (self.open_keepalive.is_set or self.open_keepalive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.open_keepalive.get_name_leafdata())
                    if (self.openversion.is_set or self.openversion.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.openversion.get_name_leafdata())
                    if (self.pce_err_type.is_set or self.pce_err_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_type.get_name_leafdata())
                    if (self.pce_err_value.is_set or self.pce_err_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_err_value.get_name_leafdata())
                    if (self.rp_request_id.is_set or self.rp_request_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rp_request_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "has-open-object" or name == "has-rp-object" or name == "open-dead-time" or name == "open-keepalive" or name == "openversion" or name == "pce-err-type" or name == "pce-err-value" or name == "rp-request-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "has-open-object"):
                        self.has_open_object = value
                        self.has_open_object.value_namespace = name_space
                        self.has_open_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-rp-object"):
                        self.has_rp_object = value
                        self.has_rp_object.value_namespace = name_space
                        self.has_rp_object.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-dead-time"):
                        self.open_dead_time = value
                        self.open_dead_time.value_namespace = name_space
                        self.open_dead_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "open-keepalive"):
                        self.open_keepalive = value
                        self.open_keepalive.value_namespace = name_space
                        self.open_keepalive.value_namespace_prefix = name_space_prefix
                    if(value_path == "openversion"):
                        self.openversion = value
                        self.openversion.value_namespace = name_space
                        self.openversion.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-type"):
                        self.pce_err_type = value
                        self.pce_err_type.value_namespace = name_space
                        self.pce_err_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-err-value"):
                        self.pce_err_value = value
                        self.pce_err_value.value_namespace = name_space
                        self.pce_err_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "rp-request-id"):
                        self.rp_request_id = value
                        self.rp_request_id.value_namespace = name_space
                        self.rp_request_id.value_namespace_prefix = name_space_prefix


            class IgPs(Entity):
                """
                IGPs
                
                .. attribute:: igp_instance_id
                
                	Instance ID
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	Type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Peers.Peer.IgPs, self).__init__()

                    self.yang_name = "ig-ps"
                    self.yang_parent_name = "peer"

                    self.igp_instance_id = YLeaf(YType.str, "igp-instance-id")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("igp_instance_id",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Peers.Peer.IgPs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Peers.Peer.IgPs, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.igp_instance_id.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.igp_instance_id.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ig-ps" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.igp_instance_id.is_set or self.igp_instance_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance_id.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "igp-instance-id" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "igp-instance-id"):
                        self.igp_instance_id = value
                        self.igp_instance_id.value_namespace = name_space
                        self.igp_instance_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.ig_ps:
                    if (c.has_data()):
                        return True
                return (
                    self.peer_address.is_set or
                    self.candidate.is_set or
                    self.capability_db_version.is_set or
                    self.capability_instantiate.is_set or
                    self.capability_segment_routing.is_set or
                    self.capability_update.is_set or
                    self.delta_sync_capability.is_set or
                    self.error.is_set or
                    self.keepalives.is_set or
                    self.keychain_enabled.is_set or
                    self.local_sid.is_set or
                    self.max_dead_interval.is_set or
                    self.md5_enabled.is_set or
                    self.min_keepalive_interval.is_set or
                    self.negotated_dead_time.is_set or
                    self.negotiated_keepalive.is_set or
                    self.pce_err_rx.is_set or
                    self.pce_err_tx.is_set or
                    self.pce_init_rx.is_set or
                    self.pce_init_tx.is_set or
                    self.pce_keepalive_rx.is_set or
                    self.pce_keepalive_tx.is_set or
                    self.pce_open_rx.is_set or
                    self.pce_open_tx.is_set or
                    self.pce_rep_rx.is_set or
                    self.pce_rep_tx.is_set or
                    self.pce_req_rx.is_set or
                    self.pce_req_tx.is_set or
                    self.pce_rpt_rx.is_set or
                    self.pce_rpt_tx.is_set or
                    self.pce_state.is_set or
                    self.pce_upd_rx.is_set or
                    self.pce_upd_tx.is_set or
                    self.pcep_up_time.is_set or
                    self.precedence.is_set or
                    self.remote_sid.is_set or
                    self.req_reply_avg.is_set or
                    self.req_reply_max.is_set or
                    self.req_reply_min.is_set or
                    self.request_timeouts.is_set or
                    self.stateful.is_set or
                    self.statically_configured.is_set or
                    self.triggered_sync_capability.is_set or
                    (self.last_rx_pce_err is not None and self.last_rx_pce_err.has_data()) or
                    (self.last_tx_pce_err is not None and self.last_tx_pce_err.has_data()))

            def has_operation(self):
                for c in self.ig_ps:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.peer_address.yfilter != YFilter.not_set or
                    self.candidate.yfilter != YFilter.not_set or
                    self.capability_db_version.yfilter != YFilter.not_set or
                    self.capability_instantiate.yfilter != YFilter.not_set or
                    self.capability_segment_routing.yfilter != YFilter.not_set or
                    self.capability_update.yfilter != YFilter.not_set or
                    self.delta_sync_capability.yfilter != YFilter.not_set or
                    self.error.yfilter != YFilter.not_set or
                    self.keepalives.yfilter != YFilter.not_set or
                    self.keychain_enabled.yfilter != YFilter.not_set or
                    self.local_sid.yfilter != YFilter.not_set or
                    self.max_dead_interval.yfilter != YFilter.not_set or
                    self.md5_enabled.yfilter != YFilter.not_set or
                    self.min_keepalive_interval.yfilter != YFilter.not_set or
                    self.negotated_dead_time.yfilter != YFilter.not_set or
                    self.negotiated_keepalive.yfilter != YFilter.not_set or
                    self.pce_err_rx.yfilter != YFilter.not_set or
                    self.pce_err_tx.yfilter != YFilter.not_set or
                    self.pce_init_rx.yfilter != YFilter.not_set or
                    self.pce_init_tx.yfilter != YFilter.not_set or
                    self.pce_keepalive_rx.yfilter != YFilter.not_set or
                    self.pce_keepalive_tx.yfilter != YFilter.not_set or
                    self.pce_open_rx.yfilter != YFilter.not_set or
                    self.pce_open_tx.yfilter != YFilter.not_set or
                    self.pce_rep_rx.yfilter != YFilter.not_set or
                    self.pce_rep_tx.yfilter != YFilter.not_set or
                    self.pce_req_rx.yfilter != YFilter.not_set or
                    self.pce_req_tx.yfilter != YFilter.not_set or
                    self.pce_rpt_rx.yfilter != YFilter.not_set or
                    self.pce_rpt_tx.yfilter != YFilter.not_set or
                    self.pce_state.yfilter != YFilter.not_set or
                    self.pce_upd_rx.yfilter != YFilter.not_set or
                    self.pce_upd_tx.yfilter != YFilter.not_set or
                    self.pcep_up_time.yfilter != YFilter.not_set or
                    self.precedence.yfilter != YFilter.not_set or
                    self.remote_sid.yfilter != YFilter.not_set or
                    self.req_reply_avg.yfilter != YFilter.not_set or
                    self.req_reply_max.yfilter != YFilter.not_set or
                    self.req_reply_min.yfilter != YFilter.not_set or
                    self.request_timeouts.yfilter != YFilter.not_set or
                    self.stateful.yfilter != YFilter.not_set or
                    self.statically_configured.yfilter != YFilter.not_set or
                    self.triggered_sync_capability.yfilter != YFilter.not_set or
                    (self.last_rx_pce_err is not None and self.last_rx_pce_err.has_operation()) or
                    (self.last_tx_pce_err is not None and self.last_tx_pce_err.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "peer" + "[peer-address='" + self.peer_address.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/peers/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.peer_address.is_set or self.peer_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.peer_address.get_name_leafdata())
                if (self.candidate.is_set or self.candidate.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.candidate.get_name_leafdata())
                if (self.capability_db_version.is_set or self.capability_db_version.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_db_version.get_name_leafdata())
                if (self.capability_instantiate.is_set or self.capability_instantiate.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_instantiate.get_name_leafdata())
                if (self.capability_segment_routing.is_set or self.capability_segment_routing.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_segment_routing.get_name_leafdata())
                if (self.capability_update.is_set or self.capability_update.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.capability_update.get_name_leafdata())
                if (self.delta_sync_capability.is_set or self.delta_sync_capability.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.delta_sync_capability.get_name_leafdata())
                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.error.get_name_leafdata())
                if (self.keepalives.is_set or self.keepalives.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.keepalives.get_name_leafdata())
                if (self.keychain_enabled.is_set or self.keychain_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.keychain_enabled.get_name_leafdata())
                if (self.local_sid.is_set or self.local_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_sid.get_name_leafdata())
                if (self.max_dead_interval.is_set or self.max_dead_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.max_dead_interval.get_name_leafdata())
                if (self.md5_enabled.is_set or self.md5_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.md5_enabled.get_name_leafdata())
                if (self.min_keepalive_interval.is_set or self.min_keepalive_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.min_keepalive_interval.get_name_leafdata())
                if (self.negotated_dead_time.is_set or self.negotated_dead_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.negotated_dead_time.get_name_leafdata())
                if (self.negotiated_keepalive.is_set or self.negotiated_keepalive.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.negotiated_keepalive.get_name_leafdata())
                if (self.pce_err_rx.is_set or self.pce_err_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_err_rx.get_name_leafdata())
                if (self.pce_err_tx.is_set or self.pce_err_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_err_tx.get_name_leafdata())
                if (self.pce_init_rx.is_set or self.pce_init_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_init_rx.get_name_leafdata())
                if (self.pce_init_tx.is_set or self.pce_init_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_init_tx.get_name_leafdata())
                if (self.pce_keepalive_rx.is_set or self.pce_keepalive_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_keepalive_rx.get_name_leafdata())
                if (self.pce_keepalive_tx.is_set or self.pce_keepalive_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_keepalive_tx.get_name_leafdata())
                if (self.pce_open_rx.is_set or self.pce_open_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_open_rx.get_name_leafdata())
                if (self.pce_open_tx.is_set or self.pce_open_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_open_tx.get_name_leafdata())
                if (self.pce_rep_rx.is_set or self.pce_rep_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rep_rx.get_name_leafdata())
                if (self.pce_rep_tx.is_set or self.pce_rep_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rep_tx.get_name_leafdata())
                if (self.pce_req_rx.is_set or self.pce_req_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_req_rx.get_name_leafdata())
                if (self.pce_req_tx.is_set or self.pce_req_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_req_tx.get_name_leafdata())
                if (self.pce_rpt_rx.is_set or self.pce_rpt_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rpt_rx.get_name_leafdata())
                if (self.pce_rpt_tx.is_set or self.pce_rpt_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_rpt_tx.get_name_leafdata())
                if (self.pce_state.is_set or self.pce_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_state.get_name_leafdata())
                if (self.pce_upd_rx.is_set or self.pce_upd_rx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_upd_rx.get_name_leafdata())
                if (self.pce_upd_tx.is_set or self.pce_upd_tx.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pce_upd_tx.get_name_leafdata())
                if (self.pcep_up_time.is_set or self.pcep_up_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcep_up_time.get_name_leafdata())
                if (self.precedence.is_set or self.precedence.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.precedence.get_name_leafdata())
                if (self.remote_sid.is_set or self.remote_sid.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.remote_sid.get_name_leafdata())
                if (self.req_reply_avg.is_set or self.req_reply_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_avg.get_name_leafdata())
                if (self.req_reply_max.is_set or self.req_reply_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_max.get_name_leafdata())
                if (self.req_reply_min.is_set or self.req_reply_min.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.req_reply_min.get_name_leafdata())
                if (self.request_timeouts.is_set or self.request_timeouts.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.request_timeouts.get_name_leafdata())
                if (self.stateful.is_set or self.stateful.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stateful.get_name_leafdata())
                if (self.statically_configured.is_set or self.statically_configured.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.statically_configured.get_name_leafdata())
                if (self.triggered_sync_capability.is_set or self.triggered_sync_capability.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.triggered_sync_capability.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ig-ps"):
                    for c in self.ig_ps:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPceStdby.Peers.Peer.IgPs()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.ig_ps.append(c)
                    return c

                if (child_yang_name == "last-rx-pce-err"):
                    if (self.last_rx_pce_err is None):
                        self.last_rx_pce_err = MplsPceStdby.Peers.Peer.LastRxPceErr()
                        self.last_rx_pce_err.parent = self
                        self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"
                    return self.last_rx_pce_err

                if (child_yang_name == "last-tx-pce-err"):
                    if (self.last_tx_pce_err is None):
                        self.last_tx_pce_err = MplsPceStdby.Peers.Peer.LastTxPceErr()
                        self.last_tx_pce_err.parent = self
                        self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"
                    return self.last_tx_pce_err

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ig-ps" or name == "last-rx-pce-err" or name == "last-tx-pce-err" or name == "peer-address" or name == "candidate" or name == "capability-db-version" or name == "capability-instantiate" or name == "capability-segment-routing" or name == "capability-update" or name == "delta-sync-capability" or name == "error" or name == "keepalives" or name == "keychain-enabled" or name == "local-sid" or name == "max-dead-interval" or name == "md5-enabled" or name == "min-keepalive-interval" or name == "negotated-dead-time" or name == "negotiated-keepalive" or name == "pce-err-rx" or name == "pce-err-tx" or name == "pce-init-rx" or name == "pce-init-tx" or name == "pce-keepalive-rx" or name == "pce-keepalive-tx" or name == "pce-open-rx" or name == "pce-open-tx" or name == "pce-rep-rx" or name == "pce-rep-tx" or name == "pce-req-rx" or name == "pce-req-tx" or name == "pce-rpt-rx" or name == "pce-rpt-tx" or name == "pce-state" or name == "pce-upd-rx" or name == "pce-upd-tx" or name == "pcep-up-time" or name == "precedence" or name == "remote-sid" or name == "req-reply-avg" or name == "req-reply-max" or name == "req-reply-min" or name == "request-timeouts" or name == "stateful" or name == "statically-configured" or name == "triggered-sync-capability"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "peer-address"):
                    self.peer_address = value
                    self.peer_address.value_namespace = name_space
                    self.peer_address.value_namespace_prefix = name_space_prefix
                if(value_path == "candidate"):
                    self.candidate = value
                    self.candidate.value_namespace = name_space
                    self.candidate.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-db-version"):
                    self.capability_db_version = value
                    self.capability_db_version.value_namespace = name_space
                    self.capability_db_version.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-instantiate"):
                    self.capability_instantiate = value
                    self.capability_instantiate.value_namespace = name_space
                    self.capability_instantiate.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-segment-routing"):
                    self.capability_segment_routing = value
                    self.capability_segment_routing.value_namespace = name_space
                    self.capability_segment_routing.value_namespace_prefix = name_space_prefix
                if(value_path == "capability-update"):
                    self.capability_update = value
                    self.capability_update.value_namespace = name_space
                    self.capability_update.value_namespace_prefix = name_space_prefix
                if(value_path == "delta-sync-capability"):
                    self.delta_sync_capability = value
                    self.delta_sync_capability.value_namespace = name_space
                    self.delta_sync_capability.value_namespace_prefix = name_space_prefix
                if(value_path == "error"):
                    self.error = value
                    self.error.value_namespace = name_space
                    self.error.value_namespace_prefix = name_space_prefix
                if(value_path == "keepalives"):
                    self.keepalives = value
                    self.keepalives.value_namespace = name_space
                    self.keepalives.value_namespace_prefix = name_space_prefix
                if(value_path == "keychain-enabled"):
                    self.keychain_enabled = value
                    self.keychain_enabled.value_namespace = name_space
                    self.keychain_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "local-sid"):
                    self.local_sid = value
                    self.local_sid.value_namespace = name_space
                    self.local_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "max-dead-interval"):
                    self.max_dead_interval = value
                    self.max_dead_interval.value_namespace = name_space
                    self.max_dead_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "md5-enabled"):
                    self.md5_enabled = value
                    self.md5_enabled.value_namespace = name_space
                    self.md5_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "min-keepalive-interval"):
                    self.min_keepalive_interval = value
                    self.min_keepalive_interval.value_namespace = name_space
                    self.min_keepalive_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "negotated-dead-time"):
                    self.negotated_dead_time = value
                    self.negotated_dead_time.value_namespace = name_space
                    self.negotated_dead_time.value_namespace_prefix = name_space_prefix
                if(value_path == "negotiated-keepalive"):
                    self.negotiated_keepalive = value
                    self.negotiated_keepalive.value_namespace = name_space
                    self.negotiated_keepalive.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-err-rx"):
                    self.pce_err_rx = value
                    self.pce_err_rx.value_namespace = name_space
                    self.pce_err_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-err-tx"):
                    self.pce_err_tx = value
                    self.pce_err_tx.value_namespace = name_space
                    self.pce_err_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-init-rx"):
                    self.pce_init_rx = value
                    self.pce_init_rx.value_namespace = name_space
                    self.pce_init_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-init-tx"):
                    self.pce_init_tx = value
                    self.pce_init_tx.value_namespace = name_space
                    self.pce_init_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-keepalive-rx"):
                    self.pce_keepalive_rx = value
                    self.pce_keepalive_rx.value_namespace = name_space
                    self.pce_keepalive_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-keepalive-tx"):
                    self.pce_keepalive_tx = value
                    self.pce_keepalive_tx.value_namespace = name_space
                    self.pce_keepalive_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-open-rx"):
                    self.pce_open_rx = value
                    self.pce_open_rx.value_namespace = name_space
                    self.pce_open_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-open-tx"):
                    self.pce_open_tx = value
                    self.pce_open_tx.value_namespace = name_space
                    self.pce_open_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rep-rx"):
                    self.pce_rep_rx = value
                    self.pce_rep_rx.value_namespace = name_space
                    self.pce_rep_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rep-tx"):
                    self.pce_rep_tx = value
                    self.pce_rep_tx.value_namespace = name_space
                    self.pce_rep_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-req-rx"):
                    self.pce_req_rx = value
                    self.pce_req_rx.value_namespace = name_space
                    self.pce_req_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-req-tx"):
                    self.pce_req_tx = value
                    self.pce_req_tx.value_namespace = name_space
                    self.pce_req_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rpt-rx"):
                    self.pce_rpt_rx = value
                    self.pce_rpt_rx.value_namespace = name_space
                    self.pce_rpt_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-rpt-tx"):
                    self.pce_rpt_tx = value
                    self.pce_rpt_tx.value_namespace = name_space
                    self.pce_rpt_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-state"):
                    self.pce_state = value
                    self.pce_state.value_namespace = name_space
                    self.pce_state.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-upd-rx"):
                    self.pce_upd_rx = value
                    self.pce_upd_rx.value_namespace = name_space
                    self.pce_upd_rx.value_namespace_prefix = name_space_prefix
                if(value_path == "pce-upd-tx"):
                    self.pce_upd_tx = value
                    self.pce_upd_tx.value_namespace = name_space
                    self.pce_upd_tx.value_namespace_prefix = name_space_prefix
                if(value_path == "pcep-up-time"):
                    self.pcep_up_time = value
                    self.pcep_up_time.value_namespace = name_space
                    self.pcep_up_time.value_namespace_prefix = name_space_prefix
                if(value_path == "precedence"):
                    self.precedence = value
                    self.precedence.value_namespace = name_space
                    self.precedence.value_namespace_prefix = name_space_prefix
                if(value_path == "remote-sid"):
                    self.remote_sid = value
                    self.remote_sid.value_namespace = name_space
                    self.remote_sid.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-avg"):
                    self.req_reply_avg = value
                    self.req_reply_avg.value_namespace = name_space
                    self.req_reply_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-max"):
                    self.req_reply_max = value
                    self.req_reply_max.value_namespace = name_space
                    self.req_reply_max.value_namespace_prefix = name_space_prefix
                if(value_path == "req-reply-min"):
                    self.req_reply_min = value
                    self.req_reply_min.value_namespace = name_space
                    self.req_reply_min.value_namespace_prefix = name_space_prefix
                if(value_path == "request-timeouts"):
                    self.request_timeouts = value
                    self.request_timeouts.value_namespace = name_space
                    self.request_timeouts.value_namespace_prefix = name_space_prefix
                if(value_path == "stateful"):
                    self.stateful = value
                    self.stateful.value_namespace = name_space
                    self.stateful.value_namespace_prefix = name_space_prefix
                if(value_path == "statically-configured"):
                    self.statically_configured = value
                    self.statically_configured.value_namespace = name_space
                    self.statically_configured.value_namespace_prefix = name_space_prefix
                if(value_path == "triggered-sync-capability"):
                    self.triggered_sync_capability = value
                    self.triggered_sync_capability.value_namespace = name_space
                    self.triggered_sync_capability.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.peer:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.peer:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "peers" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "peer"):
                for c in self.peer:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPceStdby.Peers.Peer()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.peer.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "peer"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Topology(Entity):
        """
        The topology information in PCE
        
        .. attribute:: global_
        
        	The global information of the overall  topology
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology.Global_>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPceStdby.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-pce-stdby"

            self.global_ = MplsPceStdby.Topology.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")


        class Global_(Entity):
            """
            The global information of the overall  topology
            
            .. attribute:: nodes
            
            	Node information
            	**type**\: list of    :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology.Global_.Nodes>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Topology.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"

                self.nodes = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Topology.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Topology.Global_, self).__setattr__(name, value)


            class Nodes(Entity):
                """
                Node information
                
                .. attribute:: igp_area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: igp_area_id
                
                	IGP Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_pce_border_node
                
                	PCE border node
                	**type**\:  bool
                
                .. attribute:: node_id
                
                	Node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: pce_cost
                
                	PCE cost
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: router_id
                
                	Router ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsPceStdby.Topology.Global_.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "global"

                    self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                    self.igp_area_id = YLeaf(YType.uint32, "igp-area-id")

                    self.is_pce_border_node = YLeaf(YType.boolean, "is-pce-border-node")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.pce_cost = YLeaf(YType.uint32, "pce-cost")

                    self.router_id = YLeaf(YType.str, "router-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("igp_area_format",
                                    "igp_area_id",
                                    "is_pce_border_node",
                                    "node_id",
                                    "pce_cost",
                                    "router_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsPceStdby.Topology.Global_.Nodes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsPceStdby.Topology.Global_.Nodes, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.igp_area_format.is_set or
                        self.igp_area_id.is_set or
                        self.is_pce_border_node.is_set or
                        self.node_id.is_set or
                        self.pce_cost.is_set or
                        self.router_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.igp_area_format.yfilter != YFilter.not_set or
                        self.igp_area_id.yfilter != YFilter.not_set or
                        self.is_pce_border_node.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.pce_cost.yfilter != YFilter.not_set or
                        self.router_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nodes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/topology/global/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                    if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area_id.get_name_leafdata())
                    if (self.is_pce_border_node.is_set or self.is_pce_border_node.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_border_node.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.pce_cost.is_set or self.pce_cost.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_cost.get_name_leafdata())
                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.router_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "igp-area-format" or name == "igp-area-id" or name == "is-pce-border-node" or name == "node-id" or name == "pce-cost" or name == "router-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "igp-area-format"):
                        self.igp_area_format = value
                        self.igp_area_format.value_namespace = name_space
                        self.igp_area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area-id"):
                        self.igp_area_id = value
                        self.igp_area_id.value_namespace = name_space
                        self.igp_area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-border-node"):
                        self.is_pce_border_node = value
                        self.is_pce_border_node.value_namespace = name_space
                        self.is_pce_border_node.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-cost"):
                        self.pce_cost = value
                        self.pce_cost.value_namespace = name_space
                        self.pce_cost.value_namespace_prefix = name_space_prefix
                    if(value_path == "router-id"):
                        self.router_id = value
                        self.router_id.value_namespace = name_space
                        self.router_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.nodes:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.nodes:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nodes"):
                    for c in self.nodes:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsPceStdby.Topology.Global_.Nodes()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.nodes.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nodes"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.global_ is not None and self.global_.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.global_ is not None and self.global_.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsPceStdby.Topology.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "global"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Tunnels(Entity):
        """
        Table of PCE tunnels
        
        .. attribute:: admin_weight
        
        	Path metric
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: configured_pce_address
        
        	Configured PCE Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: curr_path_option_index
        
        	Path Option Index of the current path
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: destination_address
        
        	Destination Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: hop_count
        
        	Hop Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: is_curr_path_option_pce
        
        	True if current path option is PCE based
        	**type**\:  bool
        
        .. attribute:: path_state
        
        	Path Request State
        	**type**\:   :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
        
        .. attribute:: sender_pce_address
        
        	Sender PCE Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: source_address
        
        	Source Address
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: tunnel
        
        	Information of a PCE tunnel
        	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Tunnels.Tunnel>`
        
        .. attribute:: tunnel_state
        
        	Tunnel State
        	**type**\:   :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsPceStdby.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-pce-stdby"

            self.admin_weight = YLeaf(YType.uint32, "admin-weight")

            self.configured_pce_address = YLeaf(YType.str, "configured-pce-address")

            self.curr_path_option_index = YLeaf(YType.uint32, "curr-path-option-index")

            self.destination_address = YLeaf(YType.str, "destination-address")

            self.hop_count = YLeaf(YType.uint32, "hop-count")

            self.is_curr_path_option_pce = YLeaf(YType.boolean, "is-curr-path-option-pce")

            self.path_state = YLeaf(YType.enumeration, "path-state")

            self.sender_pce_address = YLeaf(YType.str, "sender-pce-address")

            self.source_address = YLeaf(YType.str, "source-address")

            self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

            self.tunnel = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("admin_weight",
                            "configured_pce_address",
                            "curr_path_option_index",
                            "destination_address",
                            "hop_count",
                            "is_curr_path_option_pce",
                            "path_state",
                            "sender_pce_address",
                            "source_address",
                            "tunnel_state") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsPceStdby.Tunnels, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsPceStdby.Tunnels, self).__setattr__(name, value)


        class Tunnel(Entity):
            """
            Information of a PCE tunnel
            
            .. attribute:: tunnel_name  <key>
            
            	Tunnel Name
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: admin_weight
            
            	Path metric
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: configured_pce_address
            
            	Configured PCE Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: curr_path_option_index
            
            	Path Option Index of the current path
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: destination_address
            
            	Destination Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: hop_count
            
            	Hop Count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_curr_path_option_pce
            
            	True if current path option is PCE based
            	**type**\:  bool
            
            .. attribute:: path_state
            
            	Path Request State
            	**type**\:   :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
            
            .. attribute:: sender_pce_address
            
            	Sender PCE Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: source_address
            
            	Source Address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: tunnel_state
            
            	Tunnel State
            	**type**\:   :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsPceStdby.Tunnels.Tunnel, self).__init__()

                self.yang_name = "tunnel"
                self.yang_parent_name = "tunnels"

                self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                self.configured_pce_address = YLeaf(YType.str, "configured-pce-address")

                self.curr_path_option_index = YLeaf(YType.uint32, "curr-path-option-index")

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.hop_count = YLeaf(YType.uint32, "hop-count")

                self.is_curr_path_option_pce = YLeaf(YType.boolean, "is-curr-path-option-pce")

                self.path_state = YLeaf(YType.enumeration, "path-state")

                self.sender_pce_address = YLeaf(YType.str, "sender-pce-address")

                self.source_address = YLeaf(YType.str, "source-address")

                self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("tunnel_name",
                                "admin_weight",
                                "configured_pce_address",
                                "curr_path_option_index",
                                "destination_address",
                                "hop_count",
                                "is_curr_path_option_pce",
                                "path_state",
                                "sender_pce_address",
                                "source_address",
                                "tunnel_state") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsPceStdby.Tunnels.Tunnel, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsPceStdby.Tunnels.Tunnel, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.tunnel_name.is_set or
                    self.admin_weight.is_set or
                    self.configured_pce_address.is_set or
                    self.curr_path_option_index.is_set or
                    self.destination_address.is_set or
                    self.hop_count.is_set or
                    self.is_curr_path_option_pce.is_set or
                    self.path_state.is_set or
                    self.sender_pce_address.is_set or
                    self.source_address.is_set or
                    self.tunnel_state.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.tunnel_name.yfilter != YFilter.not_set or
                    self.admin_weight.yfilter != YFilter.not_set or
                    self.configured_pce_address.yfilter != YFilter.not_set or
                    self.curr_path_option_index.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.hop_count.yfilter != YFilter.not_set or
                    self.is_curr_path_option_pce.yfilter != YFilter.not_set or
                    self.path_state.yfilter != YFilter.not_set or
                    self.sender_pce_address.yfilter != YFilter.not_set or
                    self.source_address.yfilter != YFilter.not_set or
                    self.tunnel_state.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                if (self.configured_pce_address.is_set or self.configured_pce_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_pce_address.get_name_leafdata())
                if (self.curr_path_option_index.is_set or self.curr_path_option_index.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.curr_path_option_index.get_name_leafdata())
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.hop_count.is_set or self.hop_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hop_count.get_name_leafdata())
                if (self.is_curr_path_option_pce.is_set or self.is_curr_path_option_pce.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_curr_path_option_pce.get_name_leafdata())
                if (self.path_state.is_set or self.path_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_state.get_name_leafdata())
                if (self.sender_pce_address.is_set or self.sender_pce_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.sender_pce_address.get_name_leafdata())
                if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.source_address.get_name_leafdata())
                if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-name" or name == "admin-weight" or name == "configured-pce-address" or name == "curr-path-option-index" or name == "destination-address" or name == "hop-count" or name == "is-curr-path-option-pce" or name == "path-state" or name == "sender-pce-address" or name == "source-address" or name == "tunnel-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "tunnel-name"):
                    self.tunnel_name = value
                    self.tunnel_name.value_namespace = name_space
                    self.tunnel_name.value_namespace_prefix = name_space_prefix
                if(value_path == "admin-weight"):
                    self.admin_weight = value
                    self.admin_weight.value_namespace = name_space
                    self.admin_weight.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-pce-address"):
                    self.configured_pce_address = value
                    self.configured_pce_address.value_namespace = name_space
                    self.configured_pce_address.value_namespace_prefix = name_space_prefix
                if(value_path == "curr-path-option-index"):
                    self.curr_path_option_index = value
                    self.curr_path_option_index.value_namespace = name_space
                    self.curr_path_option_index.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "hop-count"):
                    self.hop_count = value
                    self.hop_count.value_namespace = name_space
                    self.hop_count.value_namespace_prefix = name_space_prefix
                if(value_path == "is-curr-path-option-pce"):
                    self.is_curr_path_option_pce = value
                    self.is_curr_path_option_pce.value_namespace = name_space
                    self.is_curr_path_option_pce.value_namespace_prefix = name_space_prefix
                if(value_path == "path-state"):
                    self.path_state = value
                    self.path_state.value_namespace = name_space
                    self.path_state.value_namespace_prefix = name_space_prefix
                if(value_path == "sender-pce-address"):
                    self.sender_pce_address = value
                    self.sender_pce_address.value_namespace = name_space
                    self.sender_pce_address.value_namespace_prefix = name_space_prefix
                if(value_path == "source-address"):
                    self.source_address = value
                    self.source_address.value_namespace = name_space
                    self.source_address.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-state"):
                    self.tunnel_state = value
                    self.tunnel_state.value_namespace = name_space
                    self.tunnel_state.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.tunnel:
                if (c.has_data()):
                    return True
            return (
                self.admin_weight.is_set or
                self.configured_pce_address.is_set or
                self.curr_path_option_index.is_set or
                self.destination_address.is_set or
                self.hop_count.is_set or
                self.is_curr_path_option_pce.is_set or
                self.path_state.is_set or
                self.sender_pce_address.is_set or
                self.source_address.is_set or
                self.tunnel_state.is_set)

        def has_operation(self):
            for c in self.tunnel:
                if (c.has_operation()):
                    return True
            return (
                self.yfilter != YFilter.not_set or
                self.admin_weight.yfilter != YFilter.not_set or
                self.configured_pce_address.yfilter != YFilter.not_set or
                self.curr_path_option_index.yfilter != YFilter.not_set or
                self.destination_address.yfilter != YFilter.not_set or
                self.hop_count.yfilter != YFilter.not_set or
                self.is_curr_path_option_pce.yfilter != YFilter.not_set or
                self.path_state.yfilter != YFilter.not_set or
                self.sender_pce_address.yfilter != YFilter.not_set or
                self.source_address.yfilter != YFilter.not_set or
                self.tunnel_state.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                leaf_name_data.append(self.admin_weight.get_name_leafdata())
            if (self.configured_pce_address.is_set or self.configured_pce_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.configured_pce_address.get_name_leafdata())
            if (self.curr_path_option_index.is_set or self.curr_path_option_index.yfilter != YFilter.not_set):
                leaf_name_data.append(self.curr_path_option_index.get_name_leafdata())
            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.destination_address.get_name_leafdata())
            if (self.hop_count.is_set or self.hop_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.hop_count.get_name_leafdata())
            if (self.is_curr_path_option_pce.is_set or self.is_curr_path_option_pce.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_curr_path_option_pce.get_name_leafdata())
            if (self.path_state.is_set or self.path_state.yfilter != YFilter.not_set):
                leaf_name_data.append(self.path_state.get_name_leafdata())
            if (self.sender_pce_address.is_set or self.sender_pce_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.sender_pce_address.get_name_leafdata())
            if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                leaf_name_data.append(self.source_address.get_name_leafdata())
            if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                leaf_name_data.append(self.tunnel_state.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "tunnel"):
                for c in self.tunnel:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsPceStdby.Tunnels.Tunnel()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.tunnel.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "tunnel" or name == "admin-weight" or name == "configured-pce-address" or name == "curr-path-option-index" or name == "destination-address" or name == "hop-count" or name == "is-curr-path-option-pce" or name == "path-state" or name == "sender-pce-address" or name == "source-address" or name == "tunnel-state"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "admin-weight"):
                self.admin_weight = value
                self.admin_weight.value_namespace = name_space
                self.admin_weight.value_namespace_prefix = name_space_prefix
            if(value_path == "configured-pce-address"):
                self.configured_pce_address = value
                self.configured_pce_address.value_namespace = name_space
                self.configured_pce_address.value_namespace_prefix = name_space_prefix
            if(value_path == "curr-path-option-index"):
                self.curr_path_option_index = value
                self.curr_path_option_index.value_namespace = name_space
                self.curr_path_option_index.value_namespace_prefix = name_space_prefix
            if(value_path == "destination-address"):
                self.destination_address = value
                self.destination_address.value_namespace = name_space
                self.destination_address.value_namespace_prefix = name_space_prefix
            if(value_path == "hop-count"):
                self.hop_count = value
                self.hop_count.value_namespace = name_space
                self.hop_count.value_namespace_prefix = name_space_prefix
            if(value_path == "is-curr-path-option-pce"):
                self.is_curr_path_option_pce = value
                self.is_curr_path_option_pce.value_namespace = name_space
                self.is_curr_path_option_pce.value_namespace_prefix = name_space_prefix
            if(value_path == "path-state"):
                self.path_state = value
                self.path_state.value_namespace = name_space
                self.path_state.value_namespace_prefix = name_space_prefix
            if(value_path == "sender-pce-address"):
                self.sender_pce_address = value
                self.sender_pce_address.value_namespace = name_space
                self.sender_pce_address.value_namespace_prefix = name_space_prefix
            if(value_path == "source-address"):
                self.source_address = value
                self.source_address.value_namespace = name_space
                self.source_address.value_namespace_prefix = name_space_prefix
            if(value_path == "tunnel-state"):
                self.tunnel_state = value
                self.tunnel_state.value_namespace = name_space
                self.tunnel_state.value_namespace_prefix = name_space_prefix

    def has_data(self):
        return (
            (self.lsps is not None and self.lsps.has_data()) or
            (self.peers is not None and self.peers.has_data()) or
            (self.statistics is not None and self.statistics.has_data()) or
            (self.topology is not None and self.topology.has_data()) or
            (self.tunnels is not None and self.tunnels.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.lsps is not None and self.lsps.has_operation()) or
            (self.peers is not None and self.peers.has_operation()) or
            (self.statistics is not None and self.statistics.has_operation()) or
            (self.topology is not None and self.topology.has_operation()) or
            (self.tunnels is not None and self.tunnels.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "lsps"):
            if (self.lsps is None):
                self.lsps = MplsPceStdby.Lsps()
                self.lsps.parent = self
                self._children_name_map["lsps"] = "lsps"
            return self.lsps

        if (child_yang_name == "peers"):
            if (self.peers is None):
                self.peers = MplsPceStdby.Peers()
                self.peers.parent = self
                self._children_name_map["peers"] = "peers"
            return self.peers

        if (child_yang_name == "statistics"):
            if (self.statistics is None):
                self.statistics = MplsPceStdby.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
            return self.statistics

        if (child_yang_name == "topology"):
            if (self.topology is None):
                self.topology = MplsPceStdby.Topology()
                self.topology.parent = self
                self._children_name_map["topology"] = "topology"
            return self.topology

        if (child_yang_name == "tunnels"):
            if (self.tunnels is None):
                self.tunnels = MplsPceStdby.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
            return self.tunnels

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "lsps" or name == "peers" or name == "statistics" or name == "topology" or name == "tunnels"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsPceStdby()
        return self._top_entity

class MplsTp(Entity):
    """
    mpls tp
    
    .. attribute:: tp_global_parameters
    
    	Transport profile global parameters
    	**type**\:   :py:class:`TpGlobalParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpGlobalParameters>`
    
    .. attribute:: tp_links
    
    	Transport profile links
    	**type**\:   :py:class:`TpLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks>`
    
    .. attribute:: tp_midpoints
    
    	Transport profile mid\-point
    	**type**\:   :py:class:`TpMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints>`
    
    .. attribute:: tp_tunnels
    
    	Transport profile tunnels
    	**type**\:   :py:class:`TpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsTp, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-tp"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.tp_global_parameters = MplsTp.TpGlobalParameters()
        self.tp_global_parameters.parent = self
        self._children_name_map["tp_global_parameters"] = "tp-global-parameters"
        self._children_yang_names.add("tp-global-parameters")

        self.tp_links = MplsTp.TpLinks()
        self.tp_links.parent = self
        self._children_name_map["tp_links"] = "tp-links"
        self._children_yang_names.add("tp-links")

        self.tp_midpoints = MplsTp.TpMidpoints()
        self.tp_midpoints.parent = self
        self._children_name_map["tp_midpoints"] = "tp-midpoints"
        self._children_yang_names.add("tp-midpoints")

        self.tp_tunnels = MplsTp.TpTunnels()
        self.tp_tunnels.parent = self
        self._children_name_map["tp_tunnels"] = "tp-tunnels"
        self._children_yang_names.add("tp-tunnels")


    class TpLinks(Entity):
        """
        Transport profile links
        
        .. attribute:: tp_detail_links
        
        	Detailed table of transport profile links
        	**type**\:   :py:class:`TpDetailLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpDetailLinks>`
        
        .. attribute:: tp_link_summary
        
        	Summary of transport profile links
        	**type**\:   :py:class:`TpLinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinkSummary>`
        
        .. attribute:: tp_links
        
        	Table of transport profile links
        	**type**\:   :py:class:`TpLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinks>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTp.TpLinks, self).__init__()

            self.yang_name = "tp-links"
            self.yang_parent_name = "mpls-tp"

            self.tp_detail_links = MplsTp.TpLinks.TpDetailLinks()
            self.tp_detail_links.parent = self
            self._children_name_map["tp_detail_links"] = "tp-detail-links"
            self._children_yang_names.add("tp-detail-links")

            self.tp_link_summary = MplsTp.TpLinks.TpLinkSummary()
            self.tp_link_summary.parent = self
            self._children_name_map["tp_link_summary"] = "tp-link-summary"
            self._children_yang_names.add("tp-link-summary")

            self.tp_links = MplsTp.TpLinks.TpLinks()
            self.tp_links.parent = self
            self._children_name_map["tp_links"] = "tp-links"
            self._children_yang_names.add("tp-links")


        class TpDetailLinks(Entity):
            """
            Detailed table of transport profile links
            
            .. attribute:: tp_detail_link
            
            	Detailed information of transport profile link
            	**type**\: list of    :py:class:`TpDetailLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpDetailLinks.TpDetailLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpLinks.TpDetailLinks, self).__init__()

                self.yang_name = "tp-detail-links"
                self.yang_parent_name = "tp-links"

                self.tp_detail_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpLinks.TpDetailLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpLinks.TpDetailLinks, self).__setattr__(name, value)


            class TpDetailLink(Entity):
                """
                Detailed information of transport profile link
                
                .. attribute:: tp_link_id  <key>
                
                	Numeric transport profile link identifier
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: available_bandwidth
                
                	Available bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: kbit/s
                
                .. attribute:: interface
                
                	Transport profile link interface name
                	**type**\:  str
                
                .. attribute:: link_id
                
                	Transport profile link identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: link_state
                
                	Link State
                	**type**\:   :py:class:`TpLinkState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpLinkState>`
                
                .. attribute:: ls_ps
                
                	Number of TP LSPs on this TP link
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_address
                
                	Transport profile next\-hop in IPv4 address format
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: reserved_bandwidth
                
                	Reserved bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: kbit/s
                
                .. attribute:: unsupported_linecard
                
                	Link is hosted on a linecard that does not support MPLS\-TP
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpLinks.TpDetailLinks.TpDetailLink, self).__init__()

                    self.yang_name = "tp-detail-link"
                    self.yang_parent_name = "tp-detail-links"

                    self.tp_link_id = YLeaf(YType.int32, "tp-link-id")

                    self.available_bandwidth = YLeaf(YType.uint64, "available-bandwidth")

                    self.interface = YLeaf(YType.str, "interface")

                    self.link_id = YLeaf(YType.uint32, "link-id")

                    self.link_state = YLeaf(YType.enumeration, "link-state")

                    self.ls_ps = YLeaf(YType.uint32, "ls-ps")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.reserved_bandwidth = YLeaf(YType.uint64, "reserved-bandwidth")

                    self.unsupported_linecard = YLeaf(YType.boolean, "unsupported-linecard")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_link_id",
                                    "available_bandwidth",
                                    "interface",
                                    "link_id",
                                    "link_state",
                                    "ls_ps",
                                    "next_hop_address",
                                    "reserved_bandwidth",
                                    "unsupported_linecard") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpLinks.TpDetailLinks.TpDetailLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpLinks.TpDetailLinks.TpDetailLink, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tp_link_id.is_set or
                        self.available_bandwidth.is_set or
                        self.interface.is_set or
                        self.link_id.is_set or
                        self.link_state.is_set or
                        self.ls_ps.is_set or
                        self.next_hop_address.is_set or
                        self.reserved_bandwidth.is_set or
                        self.unsupported_linecard.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_link_id.yfilter != YFilter.not_set or
                        self.available_bandwidth.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        self.link_state.yfilter != YFilter.not_set or
                        self.ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.reserved_bandwidth.yfilter != YFilter.not_set or
                        self.unsupported_linecard.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-detail-link" + "[tp-link-id='" + self.tp_link_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/tp-detail-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_link_id.is_set or self.tp_link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_link_id.get_name_leafdata())
                    if (self.available_bandwidth.is_set or self.available_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bandwidth.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())
                    if (self.link_state.is_set or self.link_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_state.get_name_leafdata())
                    if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ls_ps.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.reserved_bandwidth.is_set or self.reserved_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reserved_bandwidth.get_name_leafdata())
                    if (self.unsupported_linecard.is_set or self.unsupported_linecard.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unsupported_linecard.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tp-link-id" or name == "available-bandwidth" or name == "interface" or name == "link-id" or name == "link-state" or name == "ls-ps" or name == "next-hop-address" or name == "reserved-bandwidth" or name == "unsupported-linecard"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-link-id"):
                        self.tp_link_id = value
                        self.tp_link_id.value_namespace = name_space
                        self.tp_link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bandwidth"):
                        self.available_bandwidth = value
                        self.available_bandwidth.value_namespace = name_space
                        self.available_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-state"):
                        self.link_state = value
                        self.link_state.value_namespace = name_space
                        self.link_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "ls-ps"):
                        self.ls_ps = value
                        self.ls_ps.value_namespace = name_space
                        self.ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "reserved-bandwidth"):
                        self.reserved_bandwidth = value
                        self.reserved_bandwidth.value_namespace = name_space
                        self.reserved_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "unsupported-linecard"):
                        self.unsupported_linecard = value
                        self.unsupported_linecard.value_namespace = name_space
                        self.unsupported_linecard.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_detail_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_detail_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-detail-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-detail-link"):
                    for c in self.tp_detail_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpLinks.TpDetailLinks.TpDetailLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_detail_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-detail-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TpLinkSummary(Entity):
            """
            Summary of transport profile links
            
            .. attribute:: links
            
            	Number of transport profile links
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpLinks.TpLinkSummary, self).__init__()

                self.yang_name = "tp-link-summary"
                self.yang_parent_name = "tp-links"

                self.links = YLeaf(YType.uint32, "links")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("links") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpLinks.TpLinkSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpLinks.TpLinkSummary, self).__setattr__(name, value)

            def has_data(self):
                return self.links.is_set

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.links.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-link-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.links.is_set or self.links.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.links.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "links"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "links"):
                    self.links = value
                    self.links.value_namespace = name_space
                    self.links.value_namespace_prefix = name_space_prefix


        class TpLinks(Entity):
            """
            Table of transport profile links
            
            .. attribute:: tp_link
            
            	Brief information of transport profile link
            	**type**\: list of    :py:class:`TpLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinks.TpLink>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpLinks.TpLinks, self).__init__()

                self.yang_name = "tp-links"
                self.yang_parent_name = "tp-links"

                self.tp_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpLinks.TpLinks, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpLinks.TpLinks, self).__setattr__(name, value)


            class TpLink(Entity):
                """
                Brief information of transport profile link
                
                .. attribute:: tp_link_id  <key>
                
                	Numeric transport profile link identifier
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: available_bandwidth
                
                	Available bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: kbit/s
                
                .. attribute:: interface
                
                	Transport profile link interface name
                	**type**\:  str
                
                .. attribute:: link_id
                
                	Transport profile link identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: link_state
                
                	Link state
                	**type**\:   :py:class:`TpLinkState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpLinkState>`
                
                .. attribute:: next_hop_address
                
                	Transport profile next\-hop in IPv4 address format
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpLinks.TpLinks.TpLink, self).__init__()

                    self.yang_name = "tp-link"
                    self.yang_parent_name = "tp-links"

                    self.tp_link_id = YLeaf(YType.int32, "tp-link-id")

                    self.available_bandwidth = YLeaf(YType.uint64, "available-bandwidth")

                    self.interface = YLeaf(YType.str, "interface")

                    self.link_id = YLeaf(YType.uint32, "link-id")

                    self.link_state = YLeaf(YType.enumeration, "link-state")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_link_id",
                                    "available_bandwidth",
                                    "interface",
                                    "link_id",
                                    "link_state",
                                    "next_hop_address") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpLinks.TpLinks.TpLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpLinks.TpLinks.TpLink, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tp_link_id.is_set or
                        self.available_bandwidth.is_set or
                        self.interface.is_set or
                        self.link_id.is_set or
                        self.link_state.is_set or
                        self.next_hop_address.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_link_id.yfilter != YFilter.not_set or
                        self.available_bandwidth.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.link_id.yfilter != YFilter.not_set or
                        self.link_state.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-link" + "[tp-link-id='" + self.tp_link_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/tp-links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_link_id.is_set or self.tp_link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_link_id.get_name_leafdata())
                    if (self.available_bandwidth.is_set or self.available_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bandwidth.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_id.get_name_leafdata())
                    if (self.link_state.is_set or self.link_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.link_state.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tp-link-id" or name == "available-bandwidth" or name == "interface" or name == "link-id" or name == "link-state" or name == "next-hop-address"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-link-id"):
                        self.tp_link_id = value
                        self.tp_link_id.value_namespace = name_space
                        self.tp_link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bandwidth"):
                        self.available_bandwidth = value
                        self.available_bandwidth.value_namespace = name_space
                        self.available_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-id"):
                        self.link_id = value
                        self.link_id.value_namespace = name_space
                        self.link_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "link-state"):
                        self.link_state = value
                        self.link_state.value_namespace = name_space
                        self.link_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-link"):
                    for c in self.tp_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpLinks.TpLinks.TpLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.tp_detail_links is not None and self.tp_detail_links.has_data()) or
                (self.tp_link_summary is not None and self.tp_link_summary.has_data()) or
                (self.tp_links is not None and self.tp_links.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.tp_detail_links is not None and self.tp_detail_links.has_operation()) or
                (self.tp_link_summary is not None and self.tp_link_summary.has_operation()) or
                (self.tp_links is not None and self.tp_links.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tp-links" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "tp-detail-links"):
                if (self.tp_detail_links is None):
                    self.tp_detail_links = MplsTp.TpLinks.TpDetailLinks()
                    self.tp_detail_links.parent = self
                    self._children_name_map["tp_detail_links"] = "tp-detail-links"
                return self.tp_detail_links

            if (child_yang_name == "tp-link-summary"):
                if (self.tp_link_summary is None):
                    self.tp_link_summary = MplsTp.TpLinks.TpLinkSummary()
                    self.tp_link_summary.parent = self
                    self._children_name_map["tp_link_summary"] = "tp-link-summary"
                return self.tp_link_summary

            if (child_yang_name == "tp-links"):
                if (self.tp_links is None):
                    self.tp_links = MplsTp.TpLinks.TpLinks()
                    self.tp_links.parent = self
                    self._children_name_map["tp_links"] = "tp-links"
                return self.tp_links

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "tp-detail-links" or name == "tp-link-summary" or name == "tp-links"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TpTunnels(Entity):
        """
        Transport profile tunnels
        
        .. attribute:: tp_detail_tunnels
        
        	Detailed table of transport profile tunnels
        	**type**\:   :py:class:`TpDetailTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels>`
        
        .. attribute:: tp_tunnel_summary
        
        	Summary of transport profile tunnels
        	**type**\:   :py:class:`TpTunnelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnelSummary>`
        
        .. attribute:: tp_tunnels
        
        	Table of transport profile tunnels
        	**type**\:   :py:class:`TpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTp.TpTunnels, self).__init__()

            self.yang_name = "tp-tunnels"
            self.yang_parent_name = "mpls-tp"

            self.tp_detail_tunnels = MplsTp.TpTunnels.TpDetailTunnels()
            self.tp_detail_tunnels.parent = self
            self._children_name_map["tp_detail_tunnels"] = "tp-detail-tunnels"
            self._children_yang_names.add("tp-detail-tunnels")

            self.tp_tunnel_summary = MplsTp.TpTunnels.TpTunnelSummary()
            self.tp_tunnel_summary.parent = self
            self._children_name_map["tp_tunnel_summary"] = "tp-tunnel-summary"
            self._children_yang_names.add("tp-tunnel-summary")

            self.tp_tunnels = MplsTp.TpTunnels.TpTunnels()
            self.tp_tunnels.parent = self
            self._children_name_map["tp_tunnels"] = "tp-tunnels"
            self._children_yang_names.add("tp-tunnels")


        class TpTunnelSummary(Entity):
            """
            Summary of transport profile tunnels
            
            .. attribute:: active_protect_ls_ps
            
            	Number of protect LSPs that are active
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: active_working_ls_ps
            
            	Number of working LSPs that are active
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: admin_down_tunnels
            
            	Number of tunnels that are administratively down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bfd_session_protect_ls_ps
            
            	Number of protect LSPs with BFD session
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bfd_session_working_ls_ps
            
            	Number of working LSPs with BFD session
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: complete_fec_protect_ls_ps
            
            	Number of protect LSPs with complete FEC
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: complete_fec_working_ls_ps
            
            	Number of working LSPs with complete FEC
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: down_protect_ls_ps
            
            	Number of protect LSPs that are in down state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: down_tunnels
            
            	Number of tunnels that are in down state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: down_working_ls_ps
            
            	Number of Working LSPs that are in down state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: locked_protect_ls_ps
            
            	Number of protect LSPs that are locked out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: locked_working_ls_ps
            
            	Number of working LSPs that are locked out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_protect_ls_ps
            
            	Number of protect LSPs that are in up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_tunnels
            
            	Number of tunnels that are in up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_working_ls_ps
            
            	Number of working LSPs that are in up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpTunnels.TpTunnelSummary, self).__init__()

                self.yang_name = "tp-tunnel-summary"
                self.yang_parent_name = "tp-tunnels"

                self.active_protect_ls_ps = YLeaf(YType.uint32, "active-protect-ls-ps")

                self.active_working_ls_ps = YLeaf(YType.uint32, "active-working-ls-ps")

                self.admin_down_tunnels = YLeaf(YType.uint32, "admin-down-tunnels")

                self.bfd_session_protect_ls_ps = YLeaf(YType.uint32, "bfd-session-protect-ls-ps")

                self.bfd_session_working_ls_ps = YLeaf(YType.uint32, "bfd-session-working-ls-ps")

                self.complete_fec_protect_ls_ps = YLeaf(YType.uint32, "complete-fec-protect-ls-ps")

                self.complete_fec_working_ls_ps = YLeaf(YType.uint32, "complete-fec-working-ls-ps")

                self.down_protect_ls_ps = YLeaf(YType.uint32, "down-protect-ls-ps")

                self.down_tunnels = YLeaf(YType.uint32, "down-tunnels")

                self.down_working_ls_ps = YLeaf(YType.uint32, "down-working-ls-ps")

                self.locked_protect_ls_ps = YLeaf(YType.uint32, "locked-protect-ls-ps")

                self.locked_working_ls_ps = YLeaf(YType.uint32, "locked-working-ls-ps")

                self.up_protect_ls_ps = YLeaf(YType.uint32, "up-protect-ls-ps")

                self.up_tunnels = YLeaf(YType.uint32, "up-tunnels")

                self.up_working_ls_ps = YLeaf(YType.uint32, "up-working-ls-ps")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("active_protect_ls_ps",
                                "active_working_ls_ps",
                                "admin_down_tunnels",
                                "bfd_session_protect_ls_ps",
                                "bfd_session_working_ls_ps",
                                "complete_fec_protect_ls_ps",
                                "complete_fec_working_ls_ps",
                                "down_protect_ls_ps",
                                "down_tunnels",
                                "down_working_ls_ps",
                                "locked_protect_ls_ps",
                                "locked_working_ls_ps",
                                "up_protect_ls_ps",
                                "up_tunnels",
                                "up_working_ls_ps") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpTunnels.TpTunnelSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpTunnels.TpTunnelSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.active_protect_ls_ps.is_set or
                    self.active_working_ls_ps.is_set or
                    self.admin_down_tunnels.is_set or
                    self.bfd_session_protect_ls_ps.is_set or
                    self.bfd_session_working_ls_ps.is_set or
                    self.complete_fec_protect_ls_ps.is_set or
                    self.complete_fec_working_ls_ps.is_set or
                    self.down_protect_ls_ps.is_set or
                    self.down_tunnels.is_set or
                    self.down_working_ls_ps.is_set or
                    self.locked_protect_ls_ps.is_set or
                    self.locked_working_ls_ps.is_set or
                    self.up_protect_ls_ps.is_set or
                    self.up_tunnels.is_set or
                    self.up_working_ls_ps.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.active_protect_ls_ps.yfilter != YFilter.not_set or
                    self.active_working_ls_ps.yfilter != YFilter.not_set or
                    self.admin_down_tunnels.yfilter != YFilter.not_set or
                    self.bfd_session_protect_ls_ps.yfilter != YFilter.not_set or
                    self.bfd_session_working_ls_ps.yfilter != YFilter.not_set or
                    self.complete_fec_protect_ls_ps.yfilter != YFilter.not_set or
                    self.complete_fec_working_ls_ps.yfilter != YFilter.not_set or
                    self.down_protect_ls_ps.yfilter != YFilter.not_set or
                    self.down_tunnels.yfilter != YFilter.not_set or
                    self.down_working_ls_ps.yfilter != YFilter.not_set or
                    self.locked_protect_ls_ps.yfilter != YFilter.not_set or
                    self.locked_working_ls_ps.yfilter != YFilter.not_set or
                    self.up_protect_ls_ps.yfilter != YFilter.not_set or
                    self.up_tunnels.yfilter != YFilter.not_set or
                    self.up_working_ls_ps.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-tunnel-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.active_protect_ls_ps.is_set or self.active_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.active_protect_ls_ps.get_name_leafdata())
                if (self.active_working_ls_ps.is_set or self.active_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.active_working_ls_ps.get_name_leafdata())
                if (self.admin_down_tunnels.is_set or self.admin_down_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.admin_down_tunnels.get_name_leafdata())
                if (self.bfd_session_protect_ls_ps.is_set or self.bfd_session_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bfd_session_protect_ls_ps.get_name_leafdata())
                if (self.bfd_session_working_ls_ps.is_set or self.bfd_session_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bfd_session_working_ls_ps.get_name_leafdata())
                if (self.complete_fec_protect_ls_ps.is_set or self.complete_fec_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.complete_fec_protect_ls_ps.get_name_leafdata())
                if (self.complete_fec_working_ls_ps.is_set or self.complete_fec_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.complete_fec_working_ls_ps.get_name_leafdata())
                if (self.down_protect_ls_ps.is_set or self.down_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.down_protect_ls_ps.get_name_leafdata())
                if (self.down_tunnels.is_set or self.down_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.down_tunnels.get_name_leafdata())
                if (self.down_working_ls_ps.is_set or self.down_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.down_working_ls_ps.get_name_leafdata())
                if (self.locked_protect_ls_ps.is_set or self.locked_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.locked_protect_ls_ps.get_name_leafdata())
                if (self.locked_working_ls_ps.is_set or self.locked_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.locked_working_ls_ps.get_name_leafdata())
                if (self.up_protect_ls_ps.is_set or self.up_protect_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_protect_ls_ps.get_name_leafdata())
                if (self.up_tunnels.is_set or self.up_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_tunnels.get_name_leafdata())
                if (self.up_working_ls_ps.is_set or self.up_working_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_working_ls_ps.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "active-protect-ls-ps" or name == "active-working-ls-ps" or name == "admin-down-tunnels" or name == "bfd-session-protect-ls-ps" or name == "bfd-session-working-ls-ps" or name == "complete-fec-protect-ls-ps" or name == "complete-fec-working-ls-ps" or name == "down-protect-ls-ps" or name == "down-tunnels" or name == "down-working-ls-ps" or name == "locked-protect-ls-ps" or name == "locked-working-ls-ps" or name == "up-protect-ls-ps" or name == "up-tunnels" or name == "up-working-ls-ps"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "active-protect-ls-ps"):
                    self.active_protect_ls_ps = value
                    self.active_protect_ls_ps.value_namespace = name_space
                    self.active_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "active-working-ls-ps"):
                    self.active_working_ls_ps = value
                    self.active_working_ls_ps.value_namespace = name_space
                    self.active_working_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "admin-down-tunnels"):
                    self.admin_down_tunnels = value
                    self.admin_down_tunnels.value_namespace = name_space
                    self.admin_down_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bfd-session-protect-ls-ps"):
                    self.bfd_session_protect_ls_ps = value
                    self.bfd_session_protect_ls_ps.value_namespace = name_space
                    self.bfd_session_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "bfd-session-working-ls-ps"):
                    self.bfd_session_working_ls_ps = value
                    self.bfd_session_working_ls_ps.value_namespace = name_space
                    self.bfd_session_working_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "complete-fec-protect-ls-ps"):
                    self.complete_fec_protect_ls_ps = value
                    self.complete_fec_protect_ls_ps.value_namespace = name_space
                    self.complete_fec_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "complete-fec-working-ls-ps"):
                    self.complete_fec_working_ls_ps = value
                    self.complete_fec_working_ls_ps.value_namespace = name_space
                    self.complete_fec_working_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "down-protect-ls-ps"):
                    self.down_protect_ls_ps = value
                    self.down_protect_ls_ps.value_namespace = name_space
                    self.down_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "down-tunnels"):
                    self.down_tunnels = value
                    self.down_tunnels.value_namespace = name_space
                    self.down_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "down-working-ls-ps"):
                    self.down_working_ls_ps = value
                    self.down_working_ls_ps.value_namespace = name_space
                    self.down_working_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "locked-protect-ls-ps"):
                    self.locked_protect_ls_ps = value
                    self.locked_protect_ls_ps.value_namespace = name_space
                    self.locked_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "locked-working-ls-ps"):
                    self.locked_working_ls_ps = value
                    self.locked_working_ls_ps.value_namespace = name_space
                    self.locked_working_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "up-protect-ls-ps"):
                    self.up_protect_ls_ps = value
                    self.up_protect_ls_ps.value_namespace = name_space
                    self.up_protect_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "up-tunnels"):
                    self.up_tunnels = value
                    self.up_tunnels.value_namespace = name_space
                    self.up_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "up-working-ls-ps"):
                    self.up_working_ls_ps = value
                    self.up_working_ls_ps.value_namespace = name_space
                    self.up_working_ls_ps.value_namespace_prefix = name_space_prefix


        class TpDetailTunnels(Entity):
            """
            Detailed table of transport profile tunnels
            
            .. attribute:: tp_detail_tunnel
            
            	Detailed information of transport profile tunnel
            	**type**\: list of    :py:class:`TpDetailTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpTunnels.TpDetailTunnels, self).__init__()

                self.yang_name = "tp-detail-tunnels"
                self.yang_parent_name = "tp-tunnels"

                self.tp_detail_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpTunnels.TpDetailTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpTunnels.TpDetailTunnels, self).__setattr__(name, value)


            class TpDetailTunnel(Entity):
                """
                Detailed information of transport profile
                tunnel
                
                .. attribute:: tp_tunnel_name  <key>
                
                	Tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: bfd_interval_active
                
                	BFD interval for active LSP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bfd_interval_active_in_micro_sec
                
                	Is BFD interval for active LSP in micro sec
                	**type**\:  bool
                
                .. attribute:: bfd_interval_standby
                
                	BFD interval for standby LSP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bfd_interval_standby_in_micro_sec
                
                	Is BFD interval for standby LSP in micro sec
                	**type**\:  bool
                
                .. attribute:: bfd_multiplier_active
                
                	BFD multiplier for active LSP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bfd_multiplier_standby
                
                	BFD multiplier for standby LSP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: oam_interval
                
                	OAM Interval
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: oam_protection_triggers
                
                	OAM Protection Triggers
                	**type**\:   :py:class:`OamProtectionTriggers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers>`
                
                .. attribute:: protect_lsp
                
                	Protect LSP information
                	**type**\:   :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp>`
                
                .. attribute:: req_bandwidth
                
                	Requested tunnel bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: switch_over_time
                
                	The time at which last switchover was triggered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: switchover_trig
                
                	Switchover trigger
                	**type**\:   :py:class:`MplsTpTunnelSwitchoverTrig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelSwitchoverTrig>`
                
                .. attribute:: tunnel
                
                	Brief tunnel information
                	**type**\:   :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel>`
                
                .. attribute:: tunnel_up_time
                
                	Time in seconds since tunnel went up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: working_lsp
                
                	Working LSP information
                	**type**\:   :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel, self).__init__()

                    self.yang_name = "tp-detail-tunnel"
                    self.yang_parent_name = "tp-detail-tunnels"

                    self.tp_tunnel_name = YLeaf(YType.str, "tp-tunnel-name")

                    self.bfd_interval_active = YLeaf(YType.uint32, "bfd-interval-active")

                    self.bfd_interval_active_in_micro_sec = YLeaf(YType.boolean, "bfd-interval-active-in-micro-sec")

                    self.bfd_interval_standby = YLeaf(YType.uint32, "bfd-interval-standby")

                    self.bfd_interval_standby_in_micro_sec = YLeaf(YType.boolean, "bfd-interval-standby-in-micro-sec")

                    self.bfd_multiplier_active = YLeaf(YType.uint32, "bfd-multiplier-active")

                    self.bfd_multiplier_standby = YLeaf(YType.uint32, "bfd-multiplier-standby")

                    self.oam_interval = YLeaf(YType.uint32, "oam-interval")

                    self.req_bandwidth = YLeaf(YType.uint32, "req-bandwidth")

                    self.switch_over_time = YLeaf(YType.uint32, "switch-over-time")

                    self.switchover_trig = YLeaf(YType.enumeration, "switchover-trig")

                    self.tunnel_up_time = YLeaf(YType.uint32, "tunnel-up-time")

                    self.oam_protection_triggers = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers()
                    self.oam_protection_triggers.parent = self
                    self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
                    self._children_yang_names.add("oam-protection-triggers")

                    self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._children_yang_names.add("protect-lsp")

                    self.tunnel = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel()
                    self.tunnel.parent = self
                    self._children_name_map["tunnel"] = "tunnel"
                    self._children_yang_names.add("tunnel")

                    self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"
                    self._children_yang_names.add("working-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_tunnel_name",
                                    "bfd_interval_active",
                                    "bfd_interval_active_in_micro_sec",
                                    "bfd_interval_standby",
                                    "bfd_interval_standby_in_micro_sec",
                                    "bfd_multiplier_active",
                                    "bfd_multiplier_standby",
                                    "oam_interval",
                                    "req_bandwidth",
                                    "switch_over_time",
                                    "switchover_trig",
                                    "tunnel_up_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel, self).__setattr__(name, value)


                class Tunnel(Entity):
                    """
                    Brief tunnel information
                    
                    .. attribute:: active_lsp
                    
                    	Active LSP
                    	**type**\:   :py:class:`MplsTpTunnelActiveLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelActiveLsp>`
                    
                    .. attribute:: admin_status
                    
                    	Tunnel admin status
                    	**type**\:   :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                    
                    .. attribute:: destination_global_id
                    
                    	Destination global ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_node_id
                    
                    	Destination node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: operation_status
                    
                    	Tunnel operational status
                    	**type**\:   :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                    
                    .. attribute:: protect_lsp
                    
                    	Protect LSP information
                    	**type**\:   :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp>`
                    
                    .. attribute:: remote_tunnel_id
                    
                    	Remote tunnel identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: source_global_id
                    
                    	Source global ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: source_node_id
                    
                    	Source node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_tunnel_id
                    
                    	Source tunnel identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Transport profile tunnel name
                    	**type**\:  str
                    
                    .. attribute:: working_lsp
                    
                    	Working LSP information
                    	**type**\:   :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tp-detail-tunnel"

                        self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                        self.admin_status = YLeaf(YType.enumeration, "admin-status")

                        self.destination_global_id = YLeaf(YType.uint32, "destination-global-id")

                        self.destination_node_id = YLeaf(YType.str, "destination-node-id")

                        self.operation_status = YLeaf(YType.enumeration, "operation-status")

                        self.remote_tunnel_id = YLeaf(YType.uint32, "remote-tunnel-id")

                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                        self.source_tunnel_id = YLeaf(YType.uint32, "source-tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp()
                        self.protect_lsp.parent = self
                        self._children_name_map["protect_lsp"] = "protect-lsp"
                        self._children_yang_names.add("protect-lsp")

                        self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp()
                        self.working_lsp.parent = self
                        self._children_name_map["working_lsp"] = "working-lsp"
                        self._children_yang_names.add("working-lsp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("active_lsp",
                                        "admin_status",
                                        "destination_global_id",
                                        "destination_node_id",
                                        "operation_status",
                                        "remote_tunnel_id",
                                        "source_global_id",
                                        "source_node_id",
                                        "source_tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel, self).__setattr__(name, value)


                    class WorkingLsp(Entity):
                        """
                        Working LSP information
                        
                        .. attribute:: bfd_state
                        
                        	BFD state
                        	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        .. attribute:: lock_out
                        
                        	Lock out
                        	**type**\:  bool
                        
                        .. attribute:: lsp_id
                        
                        	LSP identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_oam_state
                        
                        	Received fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        .. attribute:: state
                        
                        	LSP state
                        	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        .. attribute:: tx_oam_state
                        
                        	Transmitted fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp, self).__init__()

                            self.yang_name = "working-lsp"
                            self.yang_parent_name = "tunnel"

                            self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                            self.lock_out = YLeaf(YType.boolean, "lock-out")

                            self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                            self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                            self.state = YLeaf(YType.enumeration, "state")

                            self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_state",
                                            "lock_out",
                                            "lsp_id",
                                            "rx_oam_state",
                                            "state",
                                            "tx_oam_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_state.is_set or
                                self.lock_out.is_set or
                                self.lsp_id.is_set or
                                self.rx_oam_state.is_set or
                                self.state.is_set or
                                self.tx_oam_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_state.yfilter != YFilter.not_set or
                                self.lock_out.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.rx_oam_state.yfilter != YFilter.not_set or
                                self.state.yfilter != YFilter.not_set or
                                self.tx_oam_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "working-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_state.get_name_leafdata())
                            if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lock_out.get_name_leafdata())
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.state.get_name_leafdata())
                            if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-state"):
                                self.bfd_state = value
                                self.bfd_state.value_namespace = name_space
                                self.bfd_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "lock-out"):
                                self.lock_out = value
                                self.lock_out.value_namespace = name_space
                                self.lock_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-oam-state"):
                                self.rx_oam_state = value
                                self.rx_oam_state.value_namespace = name_space
                                self.rx_oam_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "state"):
                                self.state = value
                                self.state.value_namespace = name_space
                                self.state.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-oam-state"):
                                self.tx_oam_state = value
                                self.tx_oam_state.value_namespace = name_space
                                self.tx_oam_state.value_namespace_prefix = name_space_prefix


                    class ProtectLsp(Entity):
                        """
                        Protect LSP information
                        
                        .. attribute:: bfd_state
                        
                        	BFD state
                        	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        .. attribute:: lock_out
                        
                        	Lock out
                        	**type**\:  bool
                        
                        .. attribute:: lsp_id
                        
                        	LSP identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_oam_state
                        
                        	Received fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        .. attribute:: state
                        
                        	LSP state
                        	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        .. attribute:: tx_oam_state
                        
                        	Transmitted fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp, self).__init__()

                            self.yang_name = "protect-lsp"
                            self.yang_parent_name = "tunnel"

                            self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                            self.lock_out = YLeaf(YType.boolean, "lock-out")

                            self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                            self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                            self.state = YLeaf(YType.enumeration, "state")

                            self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_state",
                                            "lock_out",
                                            "lsp_id",
                                            "rx_oam_state",
                                            "state",
                                            "tx_oam_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_state.is_set or
                                self.lock_out.is_set or
                                self.lsp_id.is_set or
                                self.rx_oam_state.is_set or
                                self.state.is_set or
                                self.tx_oam_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_state.yfilter != YFilter.not_set or
                                self.lock_out.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.rx_oam_state.yfilter != YFilter.not_set or
                                self.state.yfilter != YFilter.not_set or
                                self.tx_oam_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protect-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_state.get_name_leafdata())
                            if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lock_out.get_name_leafdata())
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.state.get_name_leafdata())
                            if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-state"):
                                self.bfd_state = value
                                self.bfd_state.value_namespace = name_space
                                self.bfd_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "lock-out"):
                                self.lock_out = value
                                self.lock_out.value_namespace = name_space
                                self.lock_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-oam-state"):
                                self.rx_oam_state = value
                                self.rx_oam_state.value_namespace = name_space
                                self.rx_oam_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "state"):
                                self.state = value
                                self.state.value_namespace = name_space
                                self.state.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-oam-state"):
                                self.tx_oam_state = value
                                self.tx_oam_state.value_namespace = name_space
                                self.tx_oam_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.active_lsp.is_set or
                            self.admin_status.is_set or
                            self.destination_global_id.is_set or
                            self.destination_node_id.is_set or
                            self.operation_status.is_set or
                            self.remote_tunnel_id.is_set or
                            self.source_global_id.is_set or
                            self.source_node_id.is_set or
                            self.source_tunnel_id.is_set or
                            self.tunnel_name.is_set or
                            (self.protect_lsp is not None and self.protect_lsp.has_data()) or
                            (self.working_lsp is not None and self.working_lsp.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.active_lsp.yfilter != YFilter.not_set or
                            self.admin_status.yfilter != YFilter.not_set or
                            self.destination_global_id.yfilter != YFilter.not_set or
                            self.destination_node_id.yfilter != YFilter.not_set or
                            self.operation_status.yfilter != YFilter.not_set or
                            self.remote_tunnel_id.yfilter != YFilter.not_set or
                            self.source_global_id.yfilter != YFilter.not_set or
                            self.source_node_id.yfilter != YFilter.not_set or
                            self.source_tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            (self.protect_lsp is not None and self.protect_lsp.has_operation()) or
                            (self.working_lsp is not None and self.working_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active_lsp.get_name_leafdata())
                        if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.admin_status.get_name_leafdata())
                        if (self.destination_global_id.is_set or self.destination_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_global_id.get_name_leafdata())
                        if (self.destination_node_id.is_set or self.destination_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_node_id.get_name_leafdata())
                        if (self.operation_status.is_set or self.operation_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operation_status.get_name_leafdata())
                        if (self.remote_tunnel_id.is_set or self.remote_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_tunnel_id.get_name_leafdata())
                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "protect-lsp"):
                            if (self.protect_lsp is None):
                                self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp()
                                self.protect_lsp.parent = self
                                self._children_name_map["protect_lsp"] = "protect-lsp"
                            return self.protect_lsp

                        if (child_yang_name == "working-lsp"):
                            if (self.working_lsp is None):
                                self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp()
                                self.working_lsp.parent = self
                                self._children_name_map["working_lsp"] = "working-lsp"
                            return self.working_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "protect-lsp" or name == "working-lsp" or name == "active-lsp" or name == "admin-status" or name == "destination-global-id" or name == "destination-node-id" or name == "operation-status" or name == "remote-tunnel-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "active-lsp"):
                            self.active_lsp = value
                            self.active_lsp.value_namespace = name_space
                            self.active_lsp.value_namespace_prefix = name_space_prefix
                        if(value_path == "admin-status"):
                            self.admin_status = value
                            self.admin_status.value_namespace = name_space
                            self.admin_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-global-id"):
                            self.destination_global_id = value
                            self.destination_global_id.value_namespace = name_space
                            self.destination_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-node-id"):
                            self.destination_node_id = value
                            self.destination_node_id.value_namespace = name_space
                            self.destination_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "operation-status"):
                            self.operation_status = value
                            self.operation_status.value_namespace = name_space
                            self.operation_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-tunnel-id"):
                            self.remote_tunnel_id = value
                            self.remote_tunnel_id.value_namespace = name_space
                            self.remote_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-global-id"):
                            self.source_global_id = value
                            self.source_global_id.value_namespace = name_space
                            self.source_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-node-id"):
                            self.source_node_id = value
                            self.source_node_id.value_namespace = name_space
                            self.source_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-tunnel-id"):
                            self.source_tunnel_id = value
                            self.source_tunnel_id.value_namespace = name_space
                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class WorkingLsp(Entity):
                    """
                    Working LSP information
                    
                    .. attribute:: brief_information
                    
                    	Brief LSP information
                    	**type**\:   :py:class:`BriefInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation>`
                    
                    .. attribute:: in_label
                    
                    	Incoming label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_id
                    
                    	Transport Profile Link Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: oam_refresh_interval
                    
                    	OAM refresh interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_interface_name
                    
                    	Outgoing interface name
                    	**type**\:  str
                    
                    .. attribute:: out_next_hop
                    
                    	Outgoing next hop in IPv4 address format
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: reserved_bandwidth
                    
                    	Reserved Bandwidth in Kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: tp_out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tp-detail-tunnel"

                        self.in_label = YLeaf(YType.uint32, "in-label")

                        self.link_id = YLeaf(YType.uint32, "link-id")

                        self.oam_refresh_interval = YLeaf(YType.uint32, "oam-refresh-interval")

                        self.out_interface_name = YLeaf(YType.str, "out-interface-name")

                        self.out_next_hop = YLeaf(YType.str, "out-next-hop")

                        self.reserved_bandwidth = YLeaf(YType.uint32, "reserved-bandwidth")

                        self.tp_out_label = YLeaf(YType.uint32, "tp-out-label")

                        self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation()
                        self.brief_information.parent = self
                        self._children_name_map["brief_information"] = "brief-information"
                        self._children_yang_names.add("brief-information")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("in_label",
                                        "link_id",
                                        "oam_refresh_interval",
                                        "out_interface_name",
                                        "out_next_hop",
                                        "reserved_bandwidth",
                                        "tp_out_label") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp, self).__setattr__(name, value)


                    class BriefInformation(Entity):
                        """
                        Brief LSP information
                        
                        .. attribute:: bfd_state
                        
                        	BFD state
                        	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        .. attribute:: lock_out
                        
                        	Lock out
                        	**type**\:  bool
                        
                        .. attribute:: lsp_id
                        
                        	LSP identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_oam_state
                        
                        	Received fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        .. attribute:: state
                        
                        	LSP state
                        	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        .. attribute:: tx_oam_state
                        
                        	Transmitted fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation, self).__init__()

                            self.yang_name = "brief-information"
                            self.yang_parent_name = "working-lsp"

                            self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                            self.lock_out = YLeaf(YType.boolean, "lock-out")

                            self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                            self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                            self.state = YLeaf(YType.enumeration, "state")

                            self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_state",
                                            "lock_out",
                                            "lsp_id",
                                            "rx_oam_state",
                                            "state",
                                            "tx_oam_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_state.is_set or
                                self.lock_out.is_set or
                                self.lsp_id.is_set or
                                self.rx_oam_state.is_set or
                                self.state.is_set or
                                self.tx_oam_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_state.yfilter != YFilter.not_set or
                                self.lock_out.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.rx_oam_state.yfilter != YFilter.not_set or
                                self.state.yfilter != YFilter.not_set or
                                self.tx_oam_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "brief-information" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_state.get_name_leafdata())
                            if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lock_out.get_name_leafdata())
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.state.get_name_leafdata())
                            if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-state"):
                                self.bfd_state = value
                                self.bfd_state.value_namespace = name_space
                                self.bfd_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "lock-out"):
                                self.lock_out = value
                                self.lock_out.value_namespace = name_space
                                self.lock_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-oam-state"):
                                self.rx_oam_state = value
                                self.rx_oam_state.value_namespace = name_space
                                self.rx_oam_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "state"):
                                self.state = value
                                self.state.value_namespace = name_space
                                self.state.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-oam-state"):
                                self.tx_oam_state = value
                                self.tx_oam_state.value_namespace = name_space
                                self.tx_oam_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.in_label.is_set or
                            self.link_id.is_set or
                            self.oam_refresh_interval.is_set or
                            self.out_interface_name.is_set or
                            self.out_next_hop.is_set or
                            self.reserved_bandwidth.is_set or
                            self.tp_out_label.is_set or
                            (self.brief_information is not None and self.brief_information.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.in_label.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.oam_refresh_interval.yfilter != YFilter.not_set or
                            self.out_interface_name.yfilter != YFilter.not_set or
                            self.out_next_hop.yfilter != YFilter.not_set or
                            self.reserved_bandwidth.yfilter != YFilter.not_set or
                            self.tp_out_label.yfilter != YFilter.not_set or
                            (self.brief_information is not None and self.brief_information.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "working-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_label.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.oam_refresh_interval.is_set or self.oam_refresh_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oam_refresh_interval.get_name_leafdata())
                        if (self.out_interface_name.is_set or self.out_interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_interface_name.get_name_leafdata())
                        if (self.out_next_hop.is_set or self.out_next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_next_hop.get_name_leafdata())
                        if (self.reserved_bandwidth.is_set or self.reserved_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reserved_bandwidth.get_name_leafdata())
                        if (self.tp_out_label.is_set or self.tp_out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tp_out_label.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "brief-information"):
                            if (self.brief_information is None):
                                self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation()
                                self.brief_information.parent = self
                                self._children_name_map["brief_information"] = "brief-information"
                            return self.brief_information

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "brief-information" or name == "in-label" or name == "link-id" or name == "oam-refresh-interval" or name == "out-interface-name" or name == "out-next-hop" or name == "reserved-bandwidth" or name == "tp-out-label"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "in-label"):
                            self.in_label = value
                            self.in_label.value_namespace = name_space
                            self.in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "oam-refresh-interval"):
                            self.oam_refresh_interval = value
                            self.oam_refresh_interval.value_namespace = name_space
                            self.oam_refresh_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-interface-name"):
                            self.out_interface_name = value
                            self.out_interface_name.value_namespace = name_space
                            self.out_interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-next-hop"):
                            self.out_next_hop = value
                            self.out_next_hop.value_namespace = name_space
                            self.out_next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "reserved-bandwidth"):
                            self.reserved_bandwidth = value
                            self.reserved_bandwidth.value_namespace = name_space
                            self.reserved_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "tp-out-label"):
                            self.tp_out_label = value
                            self.tp_out_label.value_namespace = name_space
                            self.tp_out_label.value_namespace_prefix = name_space_prefix


                class ProtectLsp(Entity):
                    """
                    Protect LSP information
                    
                    .. attribute:: brief_information
                    
                    	Brief LSP information
                    	**type**\:   :py:class:`BriefInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation>`
                    
                    .. attribute:: in_label
                    
                    	Incoming label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_id
                    
                    	Transport Profile Link Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: oam_refresh_interval
                    
                    	OAM refresh interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_interface_name
                    
                    	Outgoing interface name
                    	**type**\:  str
                    
                    .. attribute:: out_next_hop
                    
                    	Outgoing next hop in IPv4 address format
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: reserved_bandwidth
                    
                    	Reserved Bandwidth in Kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: tp_out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tp-detail-tunnel"

                        self.in_label = YLeaf(YType.uint32, "in-label")

                        self.link_id = YLeaf(YType.uint32, "link-id")

                        self.oam_refresh_interval = YLeaf(YType.uint32, "oam-refresh-interval")

                        self.out_interface_name = YLeaf(YType.str, "out-interface-name")

                        self.out_next_hop = YLeaf(YType.str, "out-next-hop")

                        self.reserved_bandwidth = YLeaf(YType.uint32, "reserved-bandwidth")

                        self.tp_out_label = YLeaf(YType.uint32, "tp-out-label")

                        self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation()
                        self.brief_information.parent = self
                        self._children_name_map["brief_information"] = "brief-information"
                        self._children_yang_names.add("brief-information")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("in_label",
                                        "link_id",
                                        "oam_refresh_interval",
                                        "out_interface_name",
                                        "out_next_hop",
                                        "reserved_bandwidth",
                                        "tp_out_label") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp, self).__setattr__(name, value)


                    class BriefInformation(Entity):
                        """
                        Brief LSP information
                        
                        .. attribute:: bfd_state
                        
                        	BFD state
                        	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        .. attribute:: lock_out
                        
                        	Lock out
                        	**type**\:  bool
                        
                        .. attribute:: lsp_id
                        
                        	LSP identifier
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_oam_state
                        
                        	Received fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        .. attribute:: state
                        
                        	LSP state
                        	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        .. attribute:: tx_oam_state
                        
                        	Transmitted fault OAM state
                        	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation, self).__init__()

                            self.yang_name = "brief-information"
                            self.yang_parent_name = "protect-lsp"

                            self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                            self.lock_out = YLeaf(YType.boolean, "lock-out")

                            self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                            self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                            self.state = YLeaf(YType.enumeration, "state")

                            self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_state",
                                            "lock_out",
                                            "lsp_id",
                                            "rx_oam_state",
                                            "state",
                                            "tx_oam_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_state.is_set or
                                self.lock_out.is_set or
                                self.lsp_id.is_set or
                                self.rx_oam_state.is_set or
                                self.state.is_set or
                                self.tx_oam_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_state.yfilter != YFilter.not_set or
                                self.lock_out.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.rx_oam_state.yfilter != YFilter.not_set or
                                self.state.yfilter != YFilter.not_set or
                                self.tx_oam_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "brief-information" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_state.get_name_leafdata())
                            if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lock_out.get_name_leafdata())
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.state.get_name_leafdata())
                            if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-state"):
                                self.bfd_state = value
                                self.bfd_state.value_namespace = name_space
                                self.bfd_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "lock-out"):
                                self.lock_out = value
                                self.lock_out.value_namespace = name_space
                                self.lock_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-oam-state"):
                                self.rx_oam_state = value
                                self.rx_oam_state.value_namespace = name_space
                                self.rx_oam_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "state"):
                                self.state = value
                                self.state.value_namespace = name_space
                                self.state.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-oam-state"):
                                self.tx_oam_state = value
                                self.tx_oam_state.value_namespace = name_space
                                self.tx_oam_state.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.in_label.is_set or
                            self.link_id.is_set or
                            self.oam_refresh_interval.is_set or
                            self.out_interface_name.is_set or
                            self.out_next_hop.is_set or
                            self.reserved_bandwidth.is_set or
                            self.tp_out_label.is_set or
                            (self.brief_information is not None and self.brief_information.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.in_label.yfilter != YFilter.not_set or
                            self.link_id.yfilter != YFilter.not_set or
                            self.oam_refresh_interval.yfilter != YFilter.not_set or
                            self.out_interface_name.yfilter != YFilter.not_set or
                            self.out_next_hop.yfilter != YFilter.not_set or
                            self.reserved_bandwidth.yfilter != YFilter.not_set or
                            self.tp_out_label.yfilter != YFilter.not_set or
                            (self.brief_information is not None and self.brief_information.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protect-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_label.get_name_leafdata())
                        if (self.link_id.is_set or self.link_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_id.get_name_leafdata())
                        if (self.oam_refresh_interval.is_set or self.oam_refresh_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oam_refresh_interval.get_name_leafdata())
                        if (self.out_interface_name.is_set or self.out_interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_interface_name.get_name_leafdata())
                        if (self.out_next_hop.is_set or self.out_next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_next_hop.get_name_leafdata())
                        if (self.reserved_bandwidth.is_set or self.reserved_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reserved_bandwidth.get_name_leafdata())
                        if (self.tp_out_label.is_set or self.tp_out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tp_out_label.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "brief-information"):
                            if (self.brief_information is None):
                                self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation()
                                self.brief_information.parent = self
                                self._children_name_map["brief_information"] = "brief-information"
                            return self.brief_information

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "brief-information" or name == "in-label" or name == "link-id" or name == "oam-refresh-interval" or name == "out-interface-name" or name == "out-next-hop" or name == "reserved-bandwidth" or name == "tp-out-label"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "in-label"):
                            self.in_label = value
                            self.in_label.value_namespace = name_space
                            self.in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-id"):
                            self.link_id = value
                            self.link_id.value_namespace = name_space
                            self.link_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "oam-refresh-interval"):
                            self.oam_refresh_interval = value
                            self.oam_refresh_interval.value_namespace = name_space
                            self.oam_refresh_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-interface-name"):
                            self.out_interface_name = value
                            self.out_interface_name.value_namespace = name_space
                            self.out_interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-next-hop"):
                            self.out_next_hop = value
                            self.out_next_hop.value_namespace = name_space
                            self.out_next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "reserved-bandwidth"):
                            self.reserved_bandwidth = value
                            self.reserved_bandwidth.value_namespace = name_space
                            self.reserved_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "tp-out-label"):
                            self.tp_out_label = value
                            self.tp_out_label.value_namespace = name_space
                            self.tp_out_label.value_namespace_prefix = name_space_prefix


                class OamProtectionTriggers(Entity):
                    """
                    OAM Protection Triggers
                    
                    .. attribute:: ais
                    
                    	Trigger due to AIS
                    	**type**\:  bool
                    
                    .. attribute:: ldi
                    
                    	Trigger due to LDI
                    	**type**\:  bool
                    
                    .. attribute:: lkr
                    
                    	Trigger due to LKR
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers, self).__init__()

                        self.yang_name = "oam-protection-triggers"
                        self.yang_parent_name = "tp-detail-tunnel"

                        self.ais = YLeaf(YType.boolean, "ais")

                        self.ldi = YLeaf(YType.boolean, "ldi")

                        self.lkr = YLeaf(YType.boolean, "lkr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("ais",
                                        "ldi",
                                        "lkr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.ais.is_set or
                            self.ldi.is_set or
                            self.lkr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.ais.yfilter != YFilter.not_set or
                            self.ldi.yfilter != YFilter.not_set or
                            self.lkr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "oam-protection-triggers" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.ais.is_set or self.ais.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ais.get_name_leafdata())
                        if (self.ldi.is_set or self.ldi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldi.get_name_leafdata())
                        if (self.lkr.is_set or self.lkr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lkr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ais" or name == "ldi" or name == "lkr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "ais"):
                            self.ais = value
                            self.ais.value_namespace = name_space
                            self.ais.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldi"):
                            self.ldi = value
                            self.ldi.value_namespace = name_space
                            self.ldi.value_namespace_prefix = name_space_prefix
                        if(value_path == "lkr"):
                            self.lkr = value
                            self.lkr.value_namespace = name_space
                            self.lkr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tp_tunnel_name.is_set or
                        self.bfd_interval_active.is_set or
                        self.bfd_interval_active_in_micro_sec.is_set or
                        self.bfd_interval_standby.is_set or
                        self.bfd_interval_standby_in_micro_sec.is_set or
                        self.bfd_multiplier_active.is_set or
                        self.bfd_multiplier_standby.is_set or
                        self.oam_interval.is_set or
                        self.req_bandwidth.is_set or
                        self.switch_over_time.is_set or
                        self.switchover_trig.is_set or
                        self.tunnel_up_time.is_set or
                        (self.oam_protection_triggers is not None and self.oam_protection_triggers.has_data()) or
                        (self.protect_lsp is not None and self.protect_lsp.has_data()) or
                        (self.tunnel is not None and self.tunnel.has_data()) or
                        (self.working_lsp is not None and self.working_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_tunnel_name.yfilter != YFilter.not_set or
                        self.bfd_interval_active.yfilter != YFilter.not_set or
                        self.bfd_interval_active_in_micro_sec.yfilter != YFilter.not_set or
                        self.bfd_interval_standby.yfilter != YFilter.not_set or
                        self.bfd_interval_standby_in_micro_sec.yfilter != YFilter.not_set or
                        self.bfd_multiplier_active.yfilter != YFilter.not_set or
                        self.bfd_multiplier_standby.yfilter != YFilter.not_set or
                        self.oam_interval.yfilter != YFilter.not_set or
                        self.req_bandwidth.yfilter != YFilter.not_set or
                        self.switch_over_time.yfilter != YFilter.not_set or
                        self.switchover_trig.yfilter != YFilter.not_set or
                        self.tunnel_up_time.yfilter != YFilter.not_set or
                        (self.oam_protection_triggers is not None and self.oam_protection_triggers.has_operation()) or
                        (self.protect_lsp is not None and self.protect_lsp.has_operation()) or
                        (self.tunnel is not None and self.tunnel.has_operation()) or
                        (self.working_lsp is not None and self.working_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-detail-tunnel" + "[tp-tunnel-name='" + self.tp_tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/tp-detail-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_tunnel_name.is_set or self.tp_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_tunnel_name.get_name_leafdata())
                    if (self.bfd_interval_active.is_set or self.bfd_interval_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_interval_active.get_name_leafdata())
                    if (self.bfd_interval_active_in_micro_sec.is_set or self.bfd_interval_active_in_micro_sec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_interval_active_in_micro_sec.get_name_leafdata())
                    if (self.bfd_interval_standby.is_set or self.bfd_interval_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_interval_standby.get_name_leafdata())
                    if (self.bfd_interval_standby_in_micro_sec.is_set or self.bfd_interval_standby_in_micro_sec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_interval_standby_in_micro_sec.get_name_leafdata())
                    if (self.bfd_multiplier_active.is_set or self.bfd_multiplier_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_multiplier_active.get_name_leafdata())
                    if (self.bfd_multiplier_standby.is_set or self.bfd_multiplier_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_multiplier_standby.get_name_leafdata())
                    if (self.oam_interval.is_set or self.oam_interval.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.oam_interval.get_name_leafdata())
                    if (self.req_bandwidth.is_set or self.req_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.req_bandwidth.get_name_leafdata())
                    if (self.switch_over_time.is_set or self.switch_over_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.switch_over_time.get_name_leafdata())
                    if (self.switchover_trig.is_set or self.switchover_trig.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.switchover_trig.get_name_leafdata())
                    if (self.tunnel_up_time.is_set or self.tunnel_up_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_up_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "oam-protection-triggers"):
                        if (self.oam_protection_triggers is None):
                            self.oam_protection_triggers = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers()
                            self.oam_protection_triggers.parent = self
                            self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
                        return self.oam_protection_triggers

                    if (child_yang_name == "protect-lsp"):
                        if (self.protect_lsp is None):
                            self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp()
                            self.protect_lsp.parent = self
                            self._children_name_map["protect_lsp"] = "protect-lsp"
                        return self.protect_lsp

                    if (child_yang_name == "tunnel"):
                        if (self.tunnel is None):
                            self.tunnel = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel()
                            self.tunnel.parent = self
                            self._children_name_map["tunnel"] = "tunnel"
                        return self.tunnel

                    if (child_yang_name == "working-lsp"):
                        if (self.working_lsp is None):
                            self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp()
                            self.working_lsp.parent = self
                            self._children_name_map["working_lsp"] = "working-lsp"
                        return self.working_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "oam-protection-triggers" or name == "protect-lsp" or name == "tunnel" or name == "working-lsp" or name == "tp-tunnel-name" or name == "bfd-interval-active" or name == "bfd-interval-active-in-micro-sec" or name == "bfd-interval-standby" or name == "bfd-interval-standby-in-micro-sec" or name == "bfd-multiplier-active" or name == "bfd-multiplier-standby" or name == "oam-interval" or name == "req-bandwidth" or name == "switch-over-time" or name == "switchover-trig" or name == "tunnel-up-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-tunnel-name"):
                        self.tp_tunnel_name = value
                        self.tp_tunnel_name.value_namespace = name_space
                        self.tp_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-interval-active"):
                        self.bfd_interval_active = value
                        self.bfd_interval_active.value_namespace = name_space
                        self.bfd_interval_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-interval-active-in-micro-sec"):
                        self.bfd_interval_active_in_micro_sec = value
                        self.bfd_interval_active_in_micro_sec.value_namespace = name_space
                        self.bfd_interval_active_in_micro_sec.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-interval-standby"):
                        self.bfd_interval_standby = value
                        self.bfd_interval_standby.value_namespace = name_space
                        self.bfd_interval_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-interval-standby-in-micro-sec"):
                        self.bfd_interval_standby_in_micro_sec = value
                        self.bfd_interval_standby_in_micro_sec.value_namespace = name_space
                        self.bfd_interval_standby_in_micro_sec.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-multiplier-active"):
                        self.bfd_multiplier_active = value
                        self.bfd_multiplier_active.value_namespace = name_space
                        self.bfd_multiplier_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "bfd-multiplier-standby"):
                        self.bfd_multiplier_standby = value
                        self.bfd_multiplier_standby.value_namespace = name_space
                        self.bfd_multiplier_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "oam-interval"):
                        self.oam_interval = value
                        self.oam_interval.value_namespace = name_space
                        self.oam_interval.value_namespace_prefix = name_space_prefix
                    if(value_path == "req-bandwidth"):
                        self.req_bandwidth = value
                        self.req_bandwidth.value_namespace = name_space
                        self.req_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "switch-over-time"):
                        self.switch_over_time = value
                        self.switch_over_time.value_namespace = name_space
                        self.switch_over_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "switchover-trig"):
                        self.switchover_trig = value
                        self.switchover_trig.value_namespace = name_space
                        self.switchover_trig.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-up-time"):
                        self.tunnel_up_time = value
                        self.tunnel_up_time.value_namespace = name_space
                        self.tunnel_up_time.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_detail_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_detail_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-detail-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-detail-tunnel"):
                    for c in self.tp_detail_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_detail_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-detail-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TpTunnels(Entity):
            """
            Table of transport profile tunnels
            
            .. attribute:: tp_tunnel
            
            	Brief information of transport profile tunnel
            	**type**\: list of    :py:class:`TpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels.TpTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpTunnels.TpTunnels, self).__init__()

                self.yang_name = "tp-tunnels"
                self.yang_parent_name = "tp-tunnels"

                self.tp_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpTunnels.TpTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpTunnels.TpTunnels, self).__setattr__(name, value)


            class TpTunnel(Entity):
                """
                Brief information of transport profile tunnel
                
                .. attribute:: tp_tunnel_name  <key>
                
                	Tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: active_lsp
                
                	Active LSP
                	**type**\:   :py:class:`MplsTpTunnelActiveLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelActiveLsp>`
                
                .. attribute:: admin_status
                
                	Tunnel admin status
                	**type**\:   :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                
                .. attribute:: destination_global_id
                
                	Destination global ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_node_id
                
                	Destination node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: operation_status
                
                	Tunnel operational status
                	**type**\:   :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                
                .. attribute:: protect_lsp
                
                	Protect LSP information
                	**type**\:   :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp>`
                
                .. attribute:: remote_tunnel_id
                
                	Remote tunnel identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: source_global_id
                
                	Source global ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: source_node_id
                
                	Source node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_tunnel_id
                
                	Source tunnel identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Transport profile tunnel name
                	**type**\:  str
                
                .. attribute:: working_lsp
                
                	Working LSP information
                	**type**\:   :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpTunnels.TpTunnels.TpTunnel, self).__init__()

                    self.yang_name = "tp-tunnel"
                    self.yang_parent_name = "tp-tunnels"

                    self.tp_tunnel_name = YLeaf(YType.str, "tp-tunnel-name")

                    self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                    self.admin_status = YLeaf(YType.enumeration, "admin-status")

                    self.destination_global_id = YLeaf(YType.uint32, "destination-global-id")

                    self.destination_node_id = YLeaf(YType.str, "destination-node-id")

                    self.operation_status = YLeaf(YType.enumeration, "operation-status")

                    self.remote_tunnel_id = YLeaf(YType.uint32, "remote-tunnel-id")

                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                    self.source_tunnel_id = YLeaf(YType.uint32, "source-tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.protect_lsp = MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._children_yang_names.add("protect-lsp")

                    self.working_lsp = MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"
                    self._children_yang_names.add("working-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_tunnel_name",
                                    "active_lsp",
                                    "admin_status",
                                    "destination_global_id",
                                    "destination_node_id",
                                    "operation_status",
                                    "remote_tunnel_id",
                                    "source_global_id",
                                    "source_node_id",
                                    "source_tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpTunnels.TpTunnels.TpTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpTunnels.TpTunnels.TpTunnel, self).__setattr__(name, value)


                class WorkingLsp(Entity):
                    """
                    Working LSP information
                    
                    .. attribute:: bfd_state
                    
                    	BFD state
                    	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                    
                    .. attribute:: lock_out
                    
                    	Lock out
                    	**type**\:  bool
                    
                    .. attribute:: lsp_id
                    
                    	LSP identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_oam_state
                    
                    	Received fault OAM state
                    	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    .. attribute:: state
                    
                    	LSP state
                    	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                    
                    .. attribute:: tx_oam_state
                    
                    	Transmitted fault OAM state
                    	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tp-tunnel"

                        self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                        self.lock_out = YLeaf(YType.boolean, "lock-out")

                        self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                        self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_state",
                                        "lock_out",
                                        "lsp_id",
                                        "rx_oam_state",
                                        "state",
                                        "tx_oam_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_state.is_set or
                            self.lock_out.is_set or
                            self.lsp_id.is_set or
                            self.rx_oam_state.is_set or
                            self.state.is_set or
                            self.tx_oam_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_state.yfilter != YFilter.not_set or
                            self.lock_out.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.rx_oam_state.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.tx_oam_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "working-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_state.get_name_leafdata())
                        if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lock_out.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-state"):
                            self.bfd_state = value
                            self.bfd_state.value_namespace = name_space
                            self.bfd_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lock-out"):
                            self.lock_out = value
                            self.lock_out.value_namespace = name_space
                            self.lock_out.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-oam-state"):
                            self.rx_oam_state = value
                            self.rx_oam_state.value_namespace = name_space
                            self.rx_oam_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-oam-state"):
                            self.tx_oam_state = value
                            self.tx_oam_state.value_namespace = name_space
                            self.tx_oam_state.value_namespace_prefix = name_space_prefix


                class ProtectLsp(Entity):
                    """
                    Protect LSP information
                    
                    .. attribute:: bfd_state
                    
                    	BFD state
                    	**type**\:   :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                    
                    .. attribute:: lock_out
                    
                    	Lock out
                    	**type**\:  bool
                    
                    .. attribute:: lsp_id
                    
                    	LSP identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_oam_state
                    
                    	Received fault OAM state
                    	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    .. attribute:: state
                    
                    	LSP state
                    	**type**\:   :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                    
                    .. attribute:: tx_oam_state
                    
                    	Transmitted fault OAM state
                    	**type**\:   :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tp-tunnel"

                        self.bfd_state = YLeaf(YType.enumeration, "bfd-state")

                        self.lock_out = YLeaf(YType.boolean, "lock-out")

                        self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                        self.rx_oam_state = YLeaf(YType.enumeration, "rx-oam-state")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.tx_oam_state = YLeaf(YType.enumeration, "tx-oam-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_state",
                                        "lock_out",
                                        "lsp_id",
                                        "rx_oam_state",
                                        "state",
                                        "tx_oam_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_state.is_set or
                            self.lock_out.is_set or
                            self.lsp_id.is_set or
                            self.rx_oam_state.is_set or
                            self.state.is_set or
                            self.tx_oam_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_state.yfilter != YFilter.not_set or
                            self.lock_out.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.rx_oam_state.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.tx_oam_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protect-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_state.is_set or self.bfd_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_state.get_name_leafdata())
                        if (self.lock_out.is_set or self.lock_out.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lock_out.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.rx_oam_state.is_set or self.rx_oam_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_oam_state.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.tx_oam_state.is_set or self.tx_oam_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_oam_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-state" or name == "lock-out" or name == "lsp-id" or name == "rx-oam-state" or name == "state" or name == "tx-oam-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-state"):
                            self.bfd_state = value
                            self.bfd_state.value_namespace = name_space
                            self.bfd_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lock-out"):
                            self.lock_out = value
                            self.lock_out.value_namespace = name_space
                            self.lock_out.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-oam-state"):
                            self.rx_oam_state = value
                            self.rx_oam_state.value_namespace = name_space
                            self.rx_oam_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-oam-state"):
                            self.tx_oam_state = value
                            self.tx_oam_state.value_namespace = name_space
                            self.tx_oam_state.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tp_tunnel_name.is_set or
                        self.active_lsp.is_set or
                        self.admin_status.is_set or
                        self.destination_global_id.is_set or
                        self.destination_node_id.is_set or
                        self.operation_status.is_set or
                        self.remote_tunnel_id.is_set or
                        self.source_global_id.is_set or
                        self.source_node_id.is_set or
                        self.source_tunnel_id.is_set or
                        self.tunnel_name.is_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_data()) or
                        (self.working_lsp is not None and self.working_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_tunnel_name.yfilter != YFilter.not_set or
                        self.active_lsp.yfilter != YFilter.not_set or
                        self.admin_status.yfilter != YFilter.not_set or
                        self.destination_global_id.yfilter != YFilter.not_set or
                        self.destination_node_id.yfilter != YFilter.not_set or
                        self.operation_status.yfilter != YFilter.not_set or
                        self.remote_tunnel_id.yfilter != YFilter.not_set or
                        self.source_global_id.yfilter != YFilter.not_set or
                        self.source_node_id.yfilter != YFilter.not_set or
                        self.source_tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_operation()) or
                        (self.working_lsp is not None and self.working_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-tunnel" + "[tp-tunnel-name='" + self.tp_tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/tp-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_tunnel_name.is_set or self.tp_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_tunnel_name.get_name_leafdata())
                    if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.active_lsp.get_name_leafdata())
                    if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_status.get_name_leafdata())
                    if (self.destination_global_id.is_set or self.destination_global_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_global_id.get_name_leafdata())
                    if (self.destination_node_id.is_set or self.destination_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_node_id.get_name_leafdata())
                    if (self.operation_status.is_set or self.operation_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operation_status.get_name_leafdata())
                    if (self.remote_tunnel_id.is_set or self.remote_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.remote_tunnel_id.get_name_leafdata())
                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "protect-lsp"):
                        if (self.protect_lsp is None):
                            self.protect_lsp = MplsTp.TpTunnels.TpTunnels.TpTunnel.ProtectLsp()
                            self.protect_lsp.parent = self
                            self._children_name_map["protect_lsp"] = "protect-lsp"
                        return self.protect_lsp

                    if (child_yang_name == "working-lsp"):
                        if (self.working_lsp is None):
                            self.working_lsp = MplsTp.TpTunnels.TpTunnels.TpTunnel.WorkingLsp()
                            self.working_lsp.parent = self
                            self._children_name_map["working_lsp"] = "working-lsp"
                        return self.working_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "protect-lsp" or name == "working-lsp" or name == "tp-tunnel-name" or name == "active-lsp" or name == "admin-status" or name == "destination-global-id" or name == "destination-node-id" or name == "operation-status" or name == "remote-tunnel-id" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-tunnel-name"):
                        self.tp_tunnel_name = value
                        self.tp_tunnel_name.value_namespace = name_space
                        self.tp_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "active-lsp"):
                        self.active_lsp = value
                        self.active_lsp.value_namespace = name_space
                        self.active_lsp.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-status"):
                        self.admin_status = value
                        self.admin_status.value_namespace = name_space
                        self.admin_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-global-id"):
                        self.destination_global_id = value
                        self.destination_global_id.value_namespace = name_space
                        self.destination_global_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-node-id"):
                        self.destination_node_id = value
                        self.destination_node_id.value_namespace = name_space
                        self.destination_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "operation-status"):
                        self.operation_status = value
                        self.operation_status.value_namespace = name_space
                        self.operation_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "remote-tunnel-id"):
                        self.remote_tunnel_id = value
                        self.remote_tunnel_id.value_namespace = name_space
                        self.remote_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-global-id"):
                        self.source_global_id = value
                        self.source_global_id.value_namespace = name_space
                        self.source_global_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-node-id"):
                        self.source_node_id = value
                        self.source_node_id.value_namespace = name_space
                        self.source_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-tunnel-id"):
                        self.source_tunnel_id = value
                        self.source_tunnel_id.value_namespace = name_space
                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-tunnel"):
                    for c in self.tp_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpTunnels.TpTunnels.TpTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.tp_detail_tunnels is not None and self.tp_detail_tunnels.has_data()) or
                (self.tp_tunnel_summary is not None and self.tp_tunnel_summary.has_data()) or
                (self.tp_tunnels is not None and self.tp_tunnels.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.tp_detail_tunnels is not None and self.tp_detail_tunnels.has_operation()) or
                (self.tp_tunnel_summary is not None and self.tp_tunnel_summary.has_operation()) or
                (self.tp_tunnels is not None and self.tp_tunnels.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tp-tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "tp-detail-tunnels"):
                if (self.tp_detail_tunnels is None):
                    self.tp_detail_tunnels = MplsTp.TpTunnels.TpDetailTunnels()
                    self.tp_detail_tunnels.parent = self
                    self._children_name_map["tp_detail_tunnels"] = "tp-detail-tunnels"
                return self.tp_detail_tunnels

            if (child_yang_name == "tp-tunnel-summary"):
                if (self.tp_tunnel_summary is None):
                    self.tp_tunnel_summary = MplsTp.TpTunnels.TpTunnelSummary()
                    self.tp_tunnel_summary.parent = self
                    self._children_name_map["tp_tunnel_summary"] = "tp-tunnel-summary"
                return self.tp_tunnel_summary

            if (child_yang_name == "tp-tunnels"):
                if (self.tp_tunnels is None):
                    self.tp_tunnels = MplsTp.TpTunnels.TpTunnels()
                    self.tp_tunnels.parent = self
                    self._children_name_map["tp_tunnels"] = "tp-tunnels"
                return self.tp_tunnels

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "tp-detail-tunnels" or name == "tp-tunnel-summary" or name == "tp-tunnels"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TpMidpoints(Entity):
        """
        Transport profile mid\-point
        
        .. attribute:: tp_detail_midpoints
        
        	Detailed table of transport profile mid\-points
        	**type**\:   :py:class:`TpDetailMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints>`
        
        .. attribute:: tp_midpoint_summary
        
        	Summary of transport profile mid\-points
        	**type**\:   :py:class:`TpMidpointSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpointSummary>`
        
        .. attribute:: tp_midpoints
        
        	Table of transport profile mid\-points
        	**type**\:   :py:class:`TpMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpoints>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTp.TpMidpoints, self).__init__()

            self.yang_name = "tp-midpoints"
            self.yang_parent_name = "mpls-tp"

            self.tp_detail_midpoints = MplsTp.TpMidpoints.TpDetailMidpoints()
            self.tp_detail_midpoints.parent = self
            self._children_name_map["tp_detail_midpoints"] = "tp-detail-midpoints"
            self._children_yang_names.add("tp-detail-midpoints")

            self.tp_midpoint_summary = MplsTp.TpMidpoints.TpMidpointSummary()
            self.tp_midpoint_summary.parent = self
            self._children_name_map["tp_midpoint_summary"] = "tp-midpoint-summary"
            self._children_yang_names.add("tp-midpoint-summary")

            self.tp_midpoints = MplsTp.TpMidpoints.TpMidpoints()
            self.tp_midpoints.parent = self
            self._children_name_map["tp_midpoints"] = "tp-midpoints"
            self._children_yang_names.add("tp-midpoints")


        class TpDetailMidpoints(Entity):
            """
            Detailed table of transport profile mid\-points
            
            .. attribute:: tp_detail_midpoint
            
            	Detailed information of transport profile mid\-point
            	**type**\: list of    :py:class:`TpDetailMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpMidpoints.TpDetailMidpoints, self).__init__()

                self.yang_name = "tp-detail-midpoints"
                self.yang_parent_name = "tp-midpoints"

                self.tp_detail_midpoint = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpMidpoints.TpDetailMidpoints, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpMidpoints.TpDetailMidpoints, self).__setattr__(name, value)


            class TpDetailMidpoint(Entity):
                """
                Detailed information of transport profile
                mid\-point
                
                .. attribute:: tp_midpoint_name  <key>
                
                	Mid\-point name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: brief_lsp_information
                
                	Brief LSP information
                	**type**\:   :py:class:`BriefLspInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation>`
                
                .. attribute:: forward_lsp
                
                	Forward LSP information
                	**type**\:   :py:class:`ForwardLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp>`
                
                .. attribute:: forward_lsp_reserved_bandwidth
                
                	Forward LSP reserved bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: reverse_lsp
                
                	Reverse LSP information
                	**type**\:   :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp>`
                
                .. attribute:: reverse_lsp_reserved_bandwidth
                
                	Reverse LSP reserved bandwidth in Kbps
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint, self).__init__()

                    self.yang_name = "tp-detail-midpoint"
                    self.yang_parent_name = "tp-detail-midpoints"

                    self.tp_midpoint_name = YLeaf(YType.str, "tp-midpoint-name")

                    self.forward_lsp_reserved_bandwidth = YLeaf(YType.uint32, "forward-lsp-reserved-bandwidth")

                    self.reverse_lsp_reserved_bandwidth = YLeaf(YType.uint32, "reverse-lsp-reserved-bandwidth")

                    self.brief_lsp_information = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation()
                    self.brief_lsp_information.parent = self
                    self._children_name_map["brief_lsp_information"] = "brief-lsp-information"
                    self._children_yang_names.add("brief-lsp-information")

                    self.forward_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp()
                    self.forward_lsp.parent = self
                    self._children_name_map["forward_lsp"] = "forward-lsp"
                    self._children_yang_names.add("forward-lsp")

                    self.reverse_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp()
                    self.reverse_lsp.parent = self
                    self._children_name_map["reverse_lsp"] = "reverse-lsp"
                    self._children_yang_names.add("reverse-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_midpoint_name",
                                    "forward_lsp_reserved_bandwidth",
                                    "reverse_lsp_reserved_bandwidth") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint, self).__setattr__(name, value)


                class BriefLspInformation(Entity):
                    """
                    Brief LSP information
                    
                    .. attribute:: destination_global_id
                    
                    	Destination Global ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_node_id
                    
                    	Destination Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: destination_tunnel_id
                    
                    	Destination Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: forward_lsp_state
                    
                    	Forward LSP State
                    	**type**\:   :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: midpoint_name
                    
                    	Mid Point Name
                    	**type**\:  str
                    
                    .. attribute:: reverse_lsp_state
                    
                    	Reverse LSP State
                    	**type**\:   :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                    
                    .. attribute:: source_global_id
                    
                    	Source Global ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: source_node_id
                    
                    	Source Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_tunnel_id
                    
                    	Source Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation, self).__init__()

                        self.yang_name = "brief-lsp-information"
                        self.yang_parent_name = "tp-detail-midpoint"

                        self.destination_global_id = YLeaf(YType.uint32, "destination-global-id")

                        self.destination_node_id = YLeaf(YType.str, "destination-node-id")

                        self.destination_tunnel_id = YLeaf(YType.uint32, "destination-tunnel-id")

                        self.forward_lsp_state = YLeaf(YType.enumeration, "forward-lsp-state")

                        self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                        self.midpoint_name = YLeaf(YType.str, "midpoint-name")

                        self.reverse_lsp_state = YLeaf(YType.enumeration, "reverse-lsp-state")

                        self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                        self.source_node_id = YLeaf(YType.str, "source-node-id")

                        self.source_tunnel_id = YLeaf(YType.uint32, "source-tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_global_id",
                                        "destination_node_id",
                                        "destination_tunnel_id",
                                        "forward_lsp_state",
                                        "lsp_id",
                                        "midpoint_name",
                                        "reverse_lsp_state",
                                        "source_global_id",
                                        "source_node_id",
                                        "source_tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.destination_global_id.is_set or
                            self.destination_node_id.is_set or
                            self.destination_tunnel_id.is_set or
                            self.forward_lsp_state.is_set or
                            self.lsp_id.is_set or
                            self.midpoint_name.is_set or
                            self.reverse_lsp_state.is_set or
                            self.source_global_id.is_set or
                            self.source_node_id.is_set or
                            self.source_tunnel_id.is_set or
                            self.tunnel_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_global_id.yfilter != YFilter.not_set or
                            self.destination_node_id.yfilter != YFilter.not_set or
                            self.destination_tunnel_id.yfilter != YFilter.not_set or
                            self.forward_lsp_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.midpoint_name.yfilter != YFilter.not_set or
                            self.reverse_lsp_state.yfilter != YFilter.not_set or
                            self.source_global_id.yfilter != YFilter.not_set or
                            self.source_node_id.yfilter != YFilter.not_set or
                            self.source_tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "brief-lsp-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_global_id.is_set or self.destination_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_global_id.get_name_leafdata())
                        if (self.destination_node_id.is_set or self.destination_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_node_id.get_name_leafdata())
                        if (self.destination_tunnel_id.is_set or self.destination_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_tunnel_id.get_name_leafdata())
                        if (self.forward_lsp_state.is_set or self.forward_lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_lsp_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.midpoint_name.is_set or self.midpoint_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.midpoint_name.get_name_leafdata())
                        if (self.reverse_lsp_state.is_set or self.reverse_lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_state.get_name_leafdata())
                        if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_global_id.get_name_leafdata())
                        if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_node_id.get_name_leafdata())
                        if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "destination-global-id" or name == "destination-node-id" or name == "destination-tunnel-id" or name == "forward-lsp-state" or name == "lsp-id" or name == "midpoint-name" or name == "reverse-lsp-state" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-global-id"):
                            self.destination_global_id = value
                            self.destination_global_id.value_namespace = name_space
                            self.destination_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-node-id"):
                            self.destination_node_id = value
                            self.destination_node_id.value_namespace = name_space
                            self.destination_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-tunnel-id"):
                            self.destination_tunnel_id = value
                            self.destination_tunnel_id.value_namespace = name_space
                            self.destination_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-lsp-state"):
                            self.forward_lsp_state = value
                            self.forward_lsp_state.value_namespace = name_space
                            self.forward_lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "midpoint-name"):
                            self.midpoint_name = value
                            self.midpoint_name.value_namespace = name_space
                            self.midpoint_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-state"):
                            self.reverse_lsp_state = value
                            self.reverse_lsp_state.value_namespace = name_space
                            self.reverse_lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-global-id"):
                            self.source_global_id = value
                            self.source_global_id.value_namespace = name_space
                            self.source_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-node-id"):
                            self.source_node_id = value
                            self.source_node_id.value_namespace = name_space
                            self.source_node_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-tunnel-id"):
                            self.source_tunnel_id = value
                            self.source_tunnel_id.value_namespace = name_space
                            self.source_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class ForwardLsp(Entity):
                    """
                    Forward LSP information
                    
                    .. attribute:: bandwidth
                    
                    	Configured bandwidth in Kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: in_label
                    
                    	Incoming label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_hop_address
                    
                    	Outgoing next\-hop in IPv4 address format
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: oam_refresh_interval
                    
                    	OAM Refresh time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_link
                    
                    	Outgoing TP link ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing interface
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp, self).__init__()

                        self.yang_name = "forward-lsp"
                        self.yang_parent_name = "tp-detail-midpoint"

                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                        self.in_label = YLeaf(YType.uint32, "in-label")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.oam_refresh_interval = YLeaf(YType.uint32, "oam-refresh-interval")

                        self.out_label = YLeaf(YType.uint32, "out-label")

                        self.out_link = YLeaf(YType.uint32, "out-link")

                        self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth",
                                        "in_label",
                                        "next_hop_address",
                                        "oam_refresh_interval",
                                        "out_label",
                                        "out_link",
                                        "outgoing_interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bandwidth.is_set or
                            self.in_label.is_set or
                            self.next_hop_address.is_set or
                            self.oam_refresh_interval.is_set or
                            self.out_label.is_set or
                            self.out_link.is_set or
                            self.outgoing_interface.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth.yfilter != YFilter.not_set or
                            self.in_label.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.oam_refresh_interval.yfilter != YFilter.not_set or
                            self.out_label.yfilter != YFilter.not_set or
                            self.out_link.yfilter != YFilter.not_set or
                            self.outgoing_interface.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "forward-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                        if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_label.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.oam_refresh_interval.is_set or self.oam_refresh_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oam_refresh_interval.get_name_leafdata())
                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_label.get_name_leafdata())
                        if (self.out_link.is_set or self.out_link.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_link.get_name_leafdata())
                        if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth" or name == "in-label" or name == "next-hop-address" or name == "oam-refresh-interval" or name == "out-label" or name == "out-link" or name == "outgoing-interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth"):
                            self.bandwidth = value
                            self.bandwidth.value_namespace = name_space
                            self.bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-label"):
                            self.in_label = value
                            self.in_label.value_namespace = name_space
                            self.in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "oam-refresh-interval"):
                            self.oam_refresh_interval = value
                            self.oam_refresh_interval.value_namespace = name_space
                            self.oam_refresh_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-label"):
                            self.out_label = value
                            self.out_label.value_namespace = name_space
                            self.out_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-link"):
                            self.out_link = value
                            self.out_link.value_namespace = name_space
                            self.out_link.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-interface"):
                            self.outgoing_interface = value
                            self.outgoing_interface.value_namespace = name_space
                            self.outgoing_interface.value_namespace_prefix = name_space_prefix


                class ReverseLsp(Entity):
                    """
                    Reverse LSP information
                    
                    .. attribute:: bandwidth
                    
                    	Configured bandwidth in Kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: in_label
                    
                    	Incoming label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_hop_address
                    
                    	Outgoing next\-hop in IPv4 address format
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: oam_refresh_interval
                    
                    	OAM Refresh time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: out_link
                    
                    	Outgoing TP link ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing interface
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp, self).__init__()

                        self.yang_name = "reverse-lsp"
                        self.yang_parent_name = "tp-detail-midpoint"

                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                        self.in_label = YLeaf(YType.uint32, "in-label")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.oam_refresh_interval = YLeaf(YType.uint32, "oam-refresh-interval")

                        self.out_label = YLeaf(YType.uint32, "out-label")

                        self.out_link = YLeaf(YType.uint32, "out-link")

                        self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth",
                                        "in_label",
                                        "next_hop_address",
                                        "oam_refresh_interval",
                                        "out_label",
                                        "out_link",
                                        "outgoing_interface") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bandwidth.is_set or
                            self.in_label.is_set or
                            self.next_hop_address.is_set or
                            self.oam_refresh_interval.is_set or
                            self.out_label.is_set or
                            self.out_link.is_set or
                            self.outgoing_interface.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth.yfilter != YFilter.not_set or
                            self.in_label.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.oam_refresh_interval.yfilter != YFilter.not_set or
                            self.out_label.yfilter != YFilter.not_set or
                            self.out_link.yfilter != YFilter.not_set or
                            self.outgoing_interface.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reverse-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                        if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.in_label.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.oam_refresh_interval.is_set or self.oam_refresh_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oam_refresh_interval.get_name_leafdata())
                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_label.get_name_leafdata())
                        if (self.out_link.is_set or self.out_link.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.out_link.get_name_leafdata())
                        if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_interface.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bandwidth" or name == "in-label" or name == "next-hop-address" or name == "oam-refresh-interval" or name == "out-label" or name == "out-link" or name == "outgoing-interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth"):
                            self.bandwidth = value
                            self.bandwidth.value_namespace = name_space
                            self.bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "in-label"):
                            self.in_label = value
                            self.in_label.value_namespace = name_space
                            self.in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "oam-refresh-interval"):
                            self.oam_refresh_interval = value
                            self.oam_refresh_interval.value_namespace = name_space
                            self.oam_refresh_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-label"):
                            self.out_label = value
                            self.out_label.value_namespace = name_space
                            self.out_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "out-link"):
                            self.out_link = value
                            self.out_link.value_namespace = name_space
                            self.out_link.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-interface"):
                            self.outgoing_interface = value
                            self.outgoing_interface.value_namespace = name_space
                            self.outgoing_interface.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tp_midpoint_name.is_set or
                        self.forward_lsp_reserved_bandwidth.is_set or
                        self.reverse_lsp_reserved_bandwidth.is_set or
                        (self.brief_lsp_information is not None and self.brief_lsp_information.has_data()) or
                        (self.forward_lsp is not None and self.forward_lsp.has_data()) or
                        (self.reverse_lsp is not None and self.reverse_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_midpoint_name.yfilter != YFilter.not_set or
                        self.forward_lsp_reserved_bandwidth.yfilter != YFilter.not_set or
                        self.reverse_lsp_reserved_bandwidth.yfilter != YFilter.not_set or
                        (self.brief_lsp_information is not None and self.brief_lsp_information.has_operation()) or
                        (self.forward_lsp is not None and self.forward_lsp.has_operation()) or
                        (self.reverse_lsp is not None and self.reverse_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-detail-midpoint" + "[tp-midpoint-name='" + self.tp_midpoint_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/tp-detail-midpoints/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_midpoint_name.is_set or self.tp_midpoint_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_midpoint_name.get_name_leafdata())
                    if (self.forward_lsp_reserved_bandwidth.is_set or self.forward_lsp_reserved_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forward_lsp_reserved_bandwidth.get_name_leafdata())
                    if (self.reverse_lsp_reserved_bandwidth.is_set or self.reverse_lsp_reserved_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_lsp_reserved_bandwidth.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "brief-lsp-information"):
                        if (self.brief_lsp_information is None):
                            self.brief_lsp_information = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation()
                            self.brief_lsp_information.parent = self
                            self._children_name_map["brief_lsp_information"] = "brief-lsp-information"
                        return self.brief_lsp_information

                    if (child_yang_name == "forward-lsp"):
                        if (self.forward_lsp is None):
                            self.forward_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp()
                            self.forward_lsp.parent = self
                            self._children_name_map["forward_lsp"] = "forward-lsp"
                        return self.forward_lsp

                    if (child_yang_name == "reverse-lsp"):
                        if (self.reverse_lsp is None):
                            self.reverse_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp()
                            self.reverse_lsp.parent = self
                            self._children_name_map["reverse_lsp"] = "reverse-lsp"
                        return self.reverse_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "brief-lsp-information" or name == "forward-lsp" or name == "reverse-lsp" or name == "tp-midpoint-name" or name == "forward-lsp-reserved-bandwidth" or name == "reverse-lsp-reserved-bandwidth"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-midpoint-name"):
                        self.tp_midpoint_name = value
                        self.tp_midpoint_name.value_namespace = name_space
                        self.tp_midpoint_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "forward-lsp-reserved-bandwidth"):
                        self.forward_lsp_reserved_bandwidth = value
                        self.forward_lsp_reserved_bandwidth.value_namespace = name_space
                        self.forward_lsp_reserved_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-lsp-reserved-bandwidth"):
                        self.reverse_lsp_reserved_bandwidth = value
                        self.reverse_lsp_reserved_bandwidth.value_namespace = name_space
                        self.reverse_lsp_reserved_bandwidth.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_detail_midpoint:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_detail_midpoint:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-detail-midpoints" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-detail-midpoint"):
                    for c in self.tp_detail_midpoint:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_detail_midpoint.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-detail-midpoint"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TpMidpointSummary(Entity):
            """
            Summary of transport profile mid\-points
            
            .. attribute:: down_forward_ls_ps
            
            	Total number of forward LSPs that are Down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: down_reverse_ls_ps
            
            	Total number of reverse LSPs that are Down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: mid_points
            
            	Total number of mid points
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_forward_ls_ps
            
            	Total number of forward LSPs that are Up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_reverse_ls_ps
            
            	Total number of reverse LSPs that are Up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpMidpoints.TpMidpointSummary, self).__init__()

                self.yang_name = "tp-midpoint-summary"
                self.yang_parent_name = "tp-midpoints"

                self.down_forward_ls_ps = YLeaf(YType.uint32, "down-forward-ls-ps")

                self.down_reverse_ls_ps = YLeaf(YType.uint32, "down-reverse-ls-ps")

                self.mid_points = YLeaf(YType.uint32, "mid-points")

                self.up_forward_ls_ps = YLeaf(YType.uint32, "up-forward-ls-ps")

                self.up_reverse_ls_ps = YLeaf(YType.uint32, "up-reverse-ls-ps")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("down_forward_ls_ps",
                                "down_reverse_ls_ps",
                                "mid_points",
                                "up_forward_ls_ps",
                                "up_reverse_ls_ps") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpMidpoints.TpMidpointSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpMidpoints.TpMidpointSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.down_forward_ls_ps.is_set or
                    self.down_reverse_ls_ps.is_set or
                    self.mid_points.is_set or
                    self.up_forward_ls_ps.is_set or
                    self.up_reverse_ls_ps.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.down_forward_ls_ps.yfilter != YFilter.not_set or
                    self.down_reverse_ls_ps.yfilter != YFilter.not_set or
                    self.mid_points.yfilter != YFilter.not_set or
                    self.up_forward_ls_ps.yfilter != YFilter.not_set or
                    self.up_reverse_ls_ps.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-midpoint-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.down_forward_ls_ps.is_set or self.down_forward_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.down_forward_ls_ps.get_name_leafdata())
                if (self.down_reverse_ls_ps.is_set or self.down_reverse_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.down_reverse_ls_ps.get_name_leafdata())
                if (self.mid_points.is_set or self.mid_points.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.mid_points.get_name_leafdata())
                if (self.up_forward_ls_ps.is_set or self.up_forward_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_forward_ls_ps.get_name_leafdata())
                if (self.up_reverse_ls_ps.is_set or self.up_reverse_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_reverse_ls_ps.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "down-forward-ls-ps" or name == "down-reverse-ls-ps" or name == "mid-points" or name == "up-forward-ls-ps" or name == "up-reverse-ls-ps"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "down-forward-ls-ps"):
                    self.down_forward_ls_ps = value
                    self.down_forward_ls_ps.value_namespace = name_space
                    self.down_forward_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "down-reverse-ls-ps"):
                    self.down_reverse_ls_ps = value
                    self.down_reverse_ls_ps.value_namespace = name_space
                    self.down_reverse_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "mid-points"):
                    self.mid_points = value
                    self.mid_points.value_namespace = name_space
                    self.mid_points.value_namespace_prefix = name_space_prefix
                if(value_path == "up-forward-ls-ps"):
                    self.up_forward_ls_ps = value
                    self.up_forward_ls_ps.value_namespace = name_space
                    self.up_forward_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "up-reverse-ls-ps"):
                    self.up_reverse_ls_ps = value
                    self.up_reverse_ls_ps.value_namespace = name_space
                    self.up_reverse_ls_ps.value_namespace_prefix = name_space_prefix


        class TpMidpoints(Entity):
            """
            Table of transport profile mid\-points
            
            .. attribute:: tp_midpoint
            
            	Brief information of transport profile mid\-point
            	**type**\: list of    :py:class:`TpMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpoints.TpMidpoint>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpMidpoints.TpMidpoints, self).__init__()

                self.yang_name = "tp-midpoints"
                self.yang_parent_name = "tp-midpoints"

                self.tp_midpoint = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpMidpoints.TpMidpoints, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpMidpoints.TpMidpoints, self).__setattr__(name, value)


            class TpMidpoint(Entity):
                """
                Brief information of transport profile
                mid\-point
                
                .. attribute:: tp_midpoint_name  <key>
                
                	Mid\-point name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: destination_global_id
                
                	Destination Global ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_node_id
                
                	Destination Node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_tunnel_id
                
                	Destination Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: forward_lsp_state
                
                	Forward LSP State
                	**type**\:   :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: midpoint_name
                
                	Mid Point Name
                	**type**\:  str
                
                .. attribute:: reverse_lsp_state
                
                	Reverse LSP State
                	**type**\:   :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                
                .. attribute:: source_global_id
                
                	Source Global ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: source_node_id
                
                	Source Node ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_tunnel_id
                
                	Source Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTp.TpMidpoints.TpMidpoints.TpMidpoint, self).__init__()

                    self.yang_name = "tp-midpoint"
                    self.yang_parent_name = "tp-midpoints"

                    self.tp_midpoint_name = YLeaf(YType.str, "tp-midpoint-name")

                    self.destination_global_id = YLeaf(YType.uint32, "destination-global-id")

                    self.destination_node_id = YLeaf(YType.str, "destination-node-id")

                    self.destination_tunnel_id = YLeaf(YType.uint32, "destination-tunnel-id")

                    self.forward_lsp_state = YLeaf(YType.enumeration, "forward-lsp-state")

                    self.lsp_id = YLeaf(YType.uint32, "lsp-id")

                    self.midpoint_name = YLeaf(YType.str, "midpoint-name")

                    self.reverse_lsp_state = YLeaf(YType.enumeration, "reverse-lsp-state")

                    self.source_global_id = YLeaf(YType.uint32, "source-global-id")

                    self.source_node_id = YLeaf(YType.str, "source-node-id")

                    self.source_tunnel_id = YLeaf(YType.uint32, "source-tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tp_midpoint_name",
                                    "destination_global_id",
                                    "destination_node_id",
                                    "destination_tunnel_id",
                                    "forward_lsp_state",
                                    "lsp_id",
                                    "midpoint_name",
                                    "reverse_lsp_state",
                                    "source_global_id",
                                    "source_node_id",
                                    "source_tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTp.TpMidpoints.TpMidpoints.TpMidpoint, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTp.TpMidpoints.TpMidpoints.TpMidpoint, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tp_midpoint_name.is_set or
                        self.destination_global_id.is_set or
                        self.destination_node_id.is_set or
                        self.destination_tunnel_id.is_set or
                        self.forward_lsp_state.is_set or
                        self.lsp_id.is_set or
                        self.midpoint_name.is_set or
                        self.reverse_lsp_state.is_set or
                        self.source_global_id.is_set or
                        self.source_node_id.is_set or
                        self.source_tunnel_id.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tp_midpoint_name.yfilter != YFilter.not_set or
                        self.destination_global_id.yfilter != YFilter.not_set or
                        self.destination_node_id.yfilter != YFilter.not_set or
                        self.destination_tunnel_id.yfilter != YFilter.not_set or
                        self.forward_lsp_state.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.midpoint_name.yfilter != YFilter.not_set or
                        self.reverse_lsp_state.yfilter != YFilter.not_set or
                        self.source_global_id.yfilter != YFilter.not_set or
                        self.source_node_id.yfilter != YFilter.not_set or
                        self.source_tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tp-midpoint" + "[tp-midpoint-name='" + self.tp_midpoint_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/tp-midpoints/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tp_midpoint_name.is_set or self.tp_midpoint_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tp_midpoint_name.get_name_leafdata())
                    if (self.destination_global_id.is_set or self.destination_global_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_global_id.get_name_leafdata())
                    if (self.destination_node_id.is_set or self.destination_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_node_id.get_name_leafdata())
                    if (self.destination_tunnel_id.is_set or self.destination_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_tunnel_id.get_name_leafdata())
                    if (self.forward_lsp_state.is_set or self.forward_lsp_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forward_lsp_state.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.midpoint_name.is_set or self.midpoint_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.midpoint_name.get_name_leafdata())
                    if (self.reverse_lsp_state.is_set or self.reverse_lsp_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_lsp_state.get_name_leafdata())
                    if (self.source_global_id.is_set or self.source_global_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_global_id.get_name_leafdata())
                    if (self.source_node_id.is_set or self.source_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_node_id.get_name_leafdata())
                    if (self.source_tunnel_id.is_set or self.source_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tp-midpoint-name" or name == "destination-global-id" or name == "destination-node-id" or name == "destination-tunnel-id" or name == "forward-lsp-state" or name == "lsp-id" or name == "midpoint-name" or name == "reverse-lsp-state" or name == "source-global-id" or name == "source-node-id" or name == "source-tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tp-midpoint-name"):
                        self.tp_midpoint_name = value
                        self.tp_midpoint_name.value_namespace = name_space
                        self.tp_midpoint_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-global-id"):
                        self.destination_global_id = value
                        self.destination_global_id.value_namespace = name_space
                        self.destination_global_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-node-id"):
                        self.destination_node_id = value
                        self.destination_node_id.value_namespace = name_space
                        self.destination_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-tunnel-id"):
                        self.destination_tunnel_id = value
                        self.destination_tunnel_id.value_namespace = name_space
                        self.destination_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "forward-lsp-state"):
                        self.forward_lsp_state = value
                        self.forward_lsp_state.value_namespace = name_space
                        self.forward_lsp_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "midpoint-name"):
                        self.midpoint_name = value
                        self.midpoint_name.value_namespace = name_space
                        self.midpoint_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-lsp-state"):
                        self.reverse_lsp_state = value
                        self.reverse_lsp_state.value_namespace = name_space
                        self.reverse_lsp_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-global-id"):
                        self.source_global_id = value
                        self.source_global_id.value_namespace = name_space
                        self.source_global_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-node-id"):
                        self.source_node_id = value
                        self.source_node_id.value_namespace = name_space
                        self.source_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-tunnel-id"):
                        self.source_tunnel_id = value
                        self.source_tunnel_id.value_namespace = name_space
                        self.source_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tp_midpoint:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tp_midpoint:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tp-midpoints" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tp-midpoint"):
                    for c in self.tp_midpoint:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTp.TpMidpoints.TpMidpoints.TpMidpoint()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tp_midpoint.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tp-midpoint"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.tp_detail_midpoints is not None and self.tp_detail_midpoints.has_data()) or
                (self.tp_midpoint_summary is not None and self.tp_midpoint_summary.has_data()) or
                (self.tp_midpoints is not None and self.tp_midpoints.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.tp_detail_midpoints is not None and self.tp_detail_midpoints.has_operation()) or
                (self.tp_midpoint_summary is not None and self.tp_midpoint_summary.has_operation()) or
                (self.tp_midpoints is not None and self.tp_midpoints.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tp-midpoints" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "tp-detail-midpoints"):
                if (self.tp_detail_midpoints is None):
                    self.tp_detail_midpoints = MplsTp.TpMidpoints.TpDetailMidpoints()
                    self.tp_detail_midpoints.parent = self
                    self._children_name_map["tp_detail_midpoints"] = "tp-detail-midpoints"
                return self.tp_detail_midpoints

            if (child_yang_name == "tp-midpoint-summary"):
                if (self.tp_midpoint_summary is None):
                    self.tp_midpoint_summary = MplsTp.TpMidpoints.TpMidpointSummary()
                    self.tp_midpoint_summary.parent = self
                    self._children_name_map["tp_midpoint_summary"] = "tp-midpoint-summary"
                return self.tp_midpoint_summary

            if (child_yang_name == "tp-midpoints"):
                if (self.tp_midpoints is None):
                    self.tp_midpoints = MplsTp.TpMidpoints.TpMidpoints()
                    self.tp_midpoints.parent = self
                    self._children_name_map["tp_midpoints"] = "tp-midpoints"
                return self.tp_midpoints

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "tp-detail-midpoints" or name == "tp-midpoint-summary" or name == "tp-midpoints"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TpGlobalParameters(Entity):
        """
        Transport profile global parameters
        
        .. attribute:: alarm_suppression
        
        	Tunnel/LSP alarm suppression
        	**type**\:  bool
        
        .. attribute:: bfd_interval
        
        	BFD interval
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: bfd_interval_in_micro_sec
        
        	Is global BFD interval in micro sec
        	**type**\:  bool
        
        .. attribute:: bfd_interval_standby
        
        	BFD interval for standby LSPs
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: bfd_interval_standby_in_micro_sec
        
        	Is global BFD interval for standby LSPs in micro sec
        	**type**\:  bool
        
        .. attribute:: bfd_multiplier
        
        	BFD multiplier
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: bfd_multiplier_standby
        
        	BFD multiplier for standby LSPs
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: global_id
        
        	Global ID
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: node_id
        
        	Node ID
        	**type**\:  str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        .. attribute:: oam_protection_triggers
        
        	OAM Protection Triggers
        	**type**\:   :py:class:`OamProtectionTriggers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpGlobalParameters.OamProtectionTriggers>`
        
        .. attribute:: oam_refresh
        
        	OAM refresh interval in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        .. attribute:: soak_time
        
        	Tunnel/LSP alarm soak time in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        .. attribute:: wait_to_restore_interval
        
        	Wait to restore interval for working LSP in seconds
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        	**units**\: second
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTp.TpGlobalParameters, self).__init__()

            self.yang_name = "tp-global-parameters"
            self.yang_parent_name = "mpls-tp"

            self.alarm_suppression = YLeaf(YType.boolean, "alarm-suppression")

            self.bfd_interval = YLeaf(YType.uint32, "bfd-interval")

            self.bfd_interval_in_micro_sec = YLeaf(YType.boolean, "bfd-interval-in-micro-sec")

            self.bfd_interval_standby = YLeaf(YType.uint32, "bfd-interval-standby")

            self.bfd_interval_standby_in_micro_sec = YLeaf(YType.boolean, "bfd-interval-standby-in-micro-sec")

            self.bfd_multiplier = YLeaf(YType.uint32, "bfd-multiplier")

            self.bfd_multiplier_standby = YLeaf(YType.uint32, "bfd-multiplier-standby")

            self.global_id = YLeaf(YType.uint32, "global-id")

            self.node_id = YLeaf(YType.str, "node-id")

            self.oam_refresh = YLeaf(YType.uint32, "oam-refresh")

            self.soak_time = YLeaf(YType.uint32, "soak-time")

            self.wait_to_restore_interval = YLeaf(YType.uint32, "wait-to-restore-interval")

            self.oam_protection_triggers = MplsTp.TpGlobalParameters.OamProtectionTriggers()
            self.oam_protection_triggers.parent = self
            self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
            self._children_yang_names.add("oam-protection-triggers")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("alarm_suppression",
                            "bfd_interval",
                            "bfd_interval_in_micro_sec",
                            "bfd_interval_standby",
                            "bfd_interval_standby_in_micro_sec",
                            "bfd_multiplier",
                            "bfd_multiplier_standby",
                            "global_id",
                            "node_id",
                            "oam_refresh",
                            "soak_time",
                            "wait_to_restore_interval") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTp.TpGlobalParameters, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTp.TpGlobalParameters, self).__setattr__(name, value)


        class OamProtectionTriggers(Entity):
            """
            OAM Protection Triggers
            
            .. attribute:: ais
            
            	Trigger due to AIS
            	**type**\:  bool
            
            .. attribute:: ldi
            
            	Trigger due to LDI
            	**type**\:  bool
            
            .. attribute:: lkr
            
            	Trigger due to LKR
            	**type**\:  bool
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTp.TpGlobalParameters.OamProtectionTriggers, self).__init__()

                self.yang_name = "oam-protection-triggers"
                self.yang_parent_name = "tp-global-parameters"

                self.ais = YLeaf(YType.boolean, "ais")

                self.ldi = YLeaf(YType.boolean, "ldi")

                self.lkr = YLeaf(YType.boolean, "lkr")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("ais",
                                "ldi",
                                "lkr") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTp.TpGlobalParameters.OamProtectionTriggers, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTp.TpGlobalParameters.OamProtectionTriggers, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.ais.is_set or
                    self.ldi.is_set or
                    self.lkr.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.ais.yfilter != YFilter.not_set or
                    self.ldi.yfilter != YFilter.not_set or
                    self.lkr.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "oam-protection-triggers" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-global-parameters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.ais.is_set or self.ais.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ais.get_name_leafdata())
                if (self.ldi.is_set or self.ldi.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ldi.get_name_leafdata())
                if (self.lkr.is_set or self.lkr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lkr.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ais" or name == "ldi" or name == "lkr"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "ais"):
                    self.ais = value
                    self.ais.value_namespace = name_space
                    self.ais.value_namespace_prefix = name_space_prefix
                if(value_path == "ldi"):
                    self.ldi = value
                    self.ldi.value_namespace = name_space
                    self.ldi.value_namespace_prefix = name_space_prefix
                if(value_path == "lkr"):
                    self.lkr = value
                    self.lkr.value_namespace = name_space
                    self.lkr.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                self.alarm_suppression.is_set or
                self.bfd_interval.is_set or
                self.bfd_interval_in_micro_sec.is_set or
                self.bfd_interval_standby.is_set or
                self.bfd_interval_standby_in_micro_sec.is_set or
                self.bfd_multiplier.is_set or
                self.bfd_multiplier_standby.is_set or
                self.global_id.is_set or
                self.node_id.is_set or
                self.oam_refresh.is_set or
                self.soak_time.is_set or
                self.wait_to_restore_interval.is_set or
                (self.oam_protection_triggers is not None and self.oam_protection_triggers.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.alarm_suppression.yfilter != YFilter.not_set or
                self.bfd_interval.yfilter != YFilter.not_set or
                self.bfd_interval_in_micro_sec.yfilter != YFilter.not_set or
                self.bfd_interval_standby.yfilter != YFilter.not_set or
                self.bfd_interval_standby_in_micro_sec.yfilter != YFilter.not_set or
                self.bfd_multiplier.yfilter != YFilter.not_set or
                self.bfd_multiplier_standby.yfilter != YFilter.not_set or
                self.global_id.yfilter != YFilter.not_set or
                self.node_id.yfilter != YFilter.not_set or
                self.oam_refresh.yfilter != YFilter.not_set or
                self.soak_time.yfilter != YFilter.not_set or
                self.wait_to_restore_interval.yfilter != YFilter.not_set or
                (self.oam_protection_triggers is not None and self.oam_protection_triggers.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tp-global-parameters" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.alarm_suppression.is_set or self.alarm_suppression.yfilter != YFilter.not_set):
                leaf_name_data.append(self.alarm_suppression.get_name_leafdata())
            if (self.bfd_interval.is_set or self.bfd_interval.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_interval.get_name_leafdata())
            if (self.bfd_interval_in_micro_sec.is_set or self.bfd_interval_in_micro_sec.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_interval_in_micro_sec.get_name_leafdata())
            if (self.bfd_interval_standby.is_set or self.bfd_interval_standby.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_interval_standby.get_name_leafdata())
            if (self.bfd_interval_standby_in_micro_sec.is_set or self.bfd_interval_standby_in_micro_sec.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_interval_standby_in_micro_sec.get_name_leafdata())
            if (self.bfd_multiplier.is_set or self.bfd_multiplier.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_multiplier.get_name_leafdata())
            if (self.bfd_multiplier_standby.is_set or self.bfd_multiplier_standby.yfilter != YFilter.not_set):
                leaf_name_data.append(self.bfd_multiplier_standby.get_name_leafdata())
            if (self.global_id.is_set or self.global_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.global_id.get_name_leafdata())
            if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                leaf_name_data.append(self.node_id.get_name_leafdata())
            if (self.oam_refresh.is_set or self.oam_refresh.yfilter != YFilter.not_set):
                leaf_name_data.append(self.oam_refresh.get_name_leafdata())
            if (self.soak_time.is_set or self.soak_time.yfilter != YFilter.not_set):
                leaf_name_data.append(self.soak_time.get_name_leafdata())
            if (self.wait_to_restore_interval.is_set or self.wait_to_restore_interval.yfilter != YFilter.not_set):
                leaf_name_data.append(self.wait_to_restore_interval.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "oam-protection-triggers"):
                if (self.oam_protection_triggers is None):
                    self.oam_protection_triggers = MplsTp.TpGlobalParameters.OamProtectionTriggers()
                    self.oam_protection_triggers.parent = self
                    self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
                return self.oam_protection_triggers

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "oam-protection-triggers" or name == "alarm-suppression" or name == "bfd-interval" or name == "bfd-interval-in-micro-sec" or name == "bfd-interval-standby" or name == "bfd-interval-standby-in-micro-sec" or name == "bfd-multiplier" or name == "bfd-multiplier-standby" or name == "global-id" or name == "node-id" or name == "oam-refresh" or name == "soak-time" or name == "wait-to-restore-interval"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "alarm-suppression"):
                self.alarm_suppression = value
                self.alarm_suppression.value_namespace = name_space
                self.alarm_suppression.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-interval"):
                self.bfd_interval = value
                self.bfd_interval.value_namespace = name_space
                self.bfd_interval.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-interval-in-micro-sec"):
                self.bfd_interval_in_micro_sec = value
                self.bfd_interval_in_micro_sec.value_namespace = name_space
                self.bfd_interval_in_micro_sec.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-interval-standby"):
                self.bfd_interval_standby = value
                self.bfd_interval_standby.value_namespace = name_space
                self.bfd_interval_standby.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-interval-standby-in-micro-sec"):
                self.bfd_interval_standby_in_micro_sec = value
                self.bfd_interval_standby_in_micro_sec.value_namespace = name_space
                self.bfd_interval_standby_in_micro_sec.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-multiplier"):
                self.bfd_multiplier = value
                self.bfd_multiplier.value_namespace = name_space
                self.bfd_multiplier.value_namespace_prefix = name_space_prefix
            if(value_path == "bfd-multiplier-standby"):
                self.bfd_multiplier_standby = value
                self.bfd_multiplier_standby.value_namespace = name_space
                self.bfd_multiplier_standby.value_namespace_prefix = name_space_prefix
            if(value_path == "global-id"):
                self.global_id = value
                self.global_id.value_namespace = name_space
                self.global_id.value_namespace_prefix = name_space_prefix
            if(value_path == "node-id"):
                self.node_id = value
                self.node_id.value_namespace = name_space
                self.node_id.value_namespace_prefix = name_space_prefix
            if(value_path == "oam-refresh"):
                self.oam_refresh = value
                self.oam_refresh.value_namespace = name_space
                self.oam_refresh.value_namespace_prefix = name_space_prefix
            if(value_path == "soak-time"):
                self.soak_time = value
                self.soak_time.value_namespace = name_space
                self.soak_time.value_namespace_prefix = name_space_prefix
            if(value_path == "wait-to-restore-interval"):
                self.wait_to_restore_interval = value
                self.wait_to_restore_interval.value_namespace = name_space
                self.wait_to_restore_interval.value_namespace_prefix = name_space_prefix

    def has_data(self):
        return (
            (self.tp_global_parameters is not None and self.tp_global_parameters.has_data()) or
            (self.tp_links is not None and self.tp_links.has_data()) or
            (self.tp_midpoints is not None and self.tp_midpoints.has_data()) or
            (self.tp_tunnels is not None and self.tp_tunnels.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.tp_global_parameters is not None and self.tp_global_parameters.has_operation()) or
            (self.tp_links is not None and self.tp_links.has_operation()) or
            (self.tp_midpoints is not None and self.tp_midpoints.has_operation()) or
            (self.tp_tunnels is not None and self.tp_tunnels.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-tp" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "tp-global-parameters"):
            if (self.tp_global_parameters is None):
                self.tp_global_parameters = MplsTp.TpGlobalParameters()
                self.tp_global_parameters.parent = self
                self._children_name_map["tp_global_parameters"] = "tp-global-parameters"
            return self.tp_global_parameters

        if (child_yang_name == "tp-links"):
            if (self.tp_links is None):
                self.tp_links = MplsTp.TpLinks()
                self.tp_links.parent = self
                self._children_name_map["tp_links"] = "tp-links"
            return self.tp_links

        if (child_yang_name == "tp-midpoints"):
            if (self.tp_midpoints is None):
                self.tp_midpoints = MplsTp.TpMidpoints()
                self.tp_midpoints.parent = self
                self._children_name_map["tp_midpoints"] = "tp-midpoints"
            return self.tp_midpoints

        if (child_yang_name == "tp-tunnels"):
            if (self.tp_tunnels is None):
                self.tp_tunnels = MplsTp.TpTunnels()
                self.tp_tunnels.parent = self
                self._children_name_map["tp_tunnels"] = "tp-tunnels"
            return self.tp_tunnels

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "tp-global-parameters" or name == "tp-links" or name == "tp-midpoints" or name == "tp-tunnels"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsTp()
        return self._top_entity

class MplsTeStandby(Entity):
    """
    mpls te standby
    
    .. attribute:: affinity_map
    
    	Affinity name to value mapping
    	**type**\:   :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap>`
    
    .. attribute:: announce_tunnels_info
    
    	Announced tunnels (forwarding adjacency and autoroute annonce)
    	**type**\:   :py:class:`AnnounceTunnelsInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo>`
    
    .. attribute:: attribute_sets
    
    	AttributeSet information
    	**type**\:   :py:class:`AttributeSets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets>`
    
    .. attribute:: auto_tunnel
    
    	Auto tunnel information
    	**type**\:   :py:class:`AutoTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel>`
    
    .. attribute:: auto_tunnel_services
    
    	MPLS TE Auto Tunnel Services
    	**type**\:   :py:class:`AutoTunnelServices <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices>`
    
    .. attribute:: bfd
    
    	MPLS TE BFD Oper Info
    	**type**\:   :py:class:`Bfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd>`
    
    .. attribute:: collaborator_timers
    
    	TE Collaborator timer status
    	**type**\:   :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.CollaboratorTimers>`
    
    .. attribute:: diff_serv_te_classes
    
    	The configured Diff Serv TE classes
    	**type**\:   :py:class:`DiffServTeClasses <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.DiffServTeClasses>`
    
    .. attribute:: fast_reroute
    
    	Represent all the fastreroute info in MPLS\-TE
    	**type**\:   :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute>`
    
    .. attribute:: fib_next_hop_label_routes
    
    	MPLS TE FIB nexthop label route database
    	**type**\:   :py:class:`FibNextHopLabelRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes>`
    
    .. attribute:: forwarding_adjacency_destinations
    
    	Announced Destination tunnel
    	**type**\:   :py:class:`ForwardingAdjacencyDestinations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations>`
    
    .. attribute:: hardware_out_of_resources
    
    	NPU Hardware OOR Information
    	**type**\:   :py:class:`HardwareOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources>`
    
    .. attribute:: igp_area_briefs
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:   :py:class:`IgpAreaBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs>`
    
    .. attribute:: igp_areas
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:   :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas>`
    
    .. attribute:: issu
    
    	MPLS TE ISSU information
    	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu>`
    
    .. attribute:: lsp_out_of_resources
    
    	LSP OOR information
    	**type**\:   :py:class:`LspOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources>`
    
    .. attribute:: maximum_tunnels
    
    	MPLS Traffic Engineering Tunnels
    	**type**\:   :py:class:`MaximumTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.MaximumTunnels>`
    
    .. attribute:: nsr
    
    	MPLS TE NSR information
    	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr>`
    
    .. attribute:: open_config
    
    	OpenConfig MPLS TE operational data
    	**type**\:   :py:class:`OpenConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.OpenConfig>`
    
    .. attribute:: p2mp
    
    	P2MP Information
    	**type**\:   :py:class:`P2Mp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp>`
    
    .. attribute:: p2p_p2mp_tunnel
    
    	P2P or P2MP tunnels
    	**type**\:   :py:class:`P2PP2MpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel>`
    
    .. attribute:: path_protection
    
    	MPLS TE path protection info
    	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection>`
    
    .. attribute:: signalling_counters
    
    	TE counters
    	**type**\:   :py:class:`SignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters>`
    
    .. attribute:: soft_preemption
    
    	Soft Preemption information
    	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SoftPreemption>`
    
    .. attribute:: topology
    
    	The topology information in MPLS\-TE
    	**type**\:   :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology>`
    
    .. attribute:: topology_briefs
    
    	MPLS\-TE topology brief table
    	**type**\:   :py:class:`TopologyBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs>`
    
    .. attribute:: topology_nodes
    
    	A node in the MPLS\-TE topology
    	**type**\:   :py:class:`TopologyNodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes>`
    
    .. attribute:: tunnels
    
    	Failure protection provided for tunnels
    	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels>`
    
    .. attribute:: wrap_protection
    
    	Represent all the LSP Wrap Protection info in MPLS\-TE
    	**type**\:   :py:class:`WrapProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection>`
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsTeStandby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-te-standby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"

        self.affinity_map = MplsTeStandby.AffinityMap()
        self.affinity_map.parent = self
        self._children_name_map["affinity_map"] = "affinity-map"
        self._children_yang_names.add("affinity-map")

        self.announce_tunnels_info = MplsTeStandby.AnnounceTunnelsInfo()
        self.announce_tunnels_info.parent = self
        self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"
        self._children_yang_names.add("announce-tunnels-info")

        self.attribute_sets = MplsTeStandby.AttributeSets()
        self.attribute_sets.parent = self
        self._children_name_map["attribute_sets"] = "attribute-sets"
        self._children_yang_names.add("attribute-sets")

        self.auto_tunnel = MplsTeStandby.AutoTunnel()
        self.auto_tunnel.parent = self
        self._children_name_map["auto_tunnel"] = "auto-tunnel"
        self._children_yang_names.add("auto-tunnel")

        self.auto_tunnel_services = MplsTeStandby.AutoTunnelServices()
        self.auto_tunnel_services.parent = self
        self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"
        self._children_yang_names.add("auto-tunnel-services")

        self.bfd = MplsTeStandby.Bfd()
        self.bfd.parent = self
        self._children_name_map["bfd"] = "bfd"
        self._children_yang_names.add("bfd")

        self.collaborator_timers = MplsTeStandby.CollaboratorTimers()
        self.collaborator_timers.parent = self
        self._children_name_map["collaborator_timers"] = "collaborator-timers"
        self._children_yang_names.add("collaborator-timers")

        self.diff_serv_te_classes = MplsTeStandby.DiffServTeClasses()
        self.diff_serv_te_classes.parent = self
        self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"
        self._children_yang_names.add("diff-serv-te-classes")

        self.fast_reroute = MplsTeStandby.FastReroute()
        self.fast_reroute.parent = self
        self._children_name_map["fast_reroute"] = "fast-reroute"
        self._children_yang_names.add("fast-reroute")

        self.fib_next_hop_label_routes = MplsTeStandby.FibNextHopLabelRoutes()
        self.fib_next_hop_label_routes.parent = self
        self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"
        self._children_yang_names.add("fib-next-hop-label-routes")

        self.forwarding_adjacency_destinations = MplsTeStandby.ForwardingAdjacencyDestinations()
        self.forwarding_adjacency_destinations.parent = self
        self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"
        self._children_yang_names.add("forwarding-adjacency-destinations")

        self.hardware_out_of_resources = MplsTeStandby.HardwareOutOfResources()
        self.hardware_out_of_resources.parent = self
        self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"
        self._children_yang_names.add("hardware-out-of-resources")

        self.igp_area_briefs = MplsTeStandby.IgpAreaBriefs()
        self.igp_area_briefs.parent = self
        self._children_name_map["igp_area_briefs"] = "igp-area-briefs"
        self._children_yang_names.add("igp-area-briefs")

        self.igp_areas = MplsTeStandby.IgpAreas()
        self.igp_areas.parent = self
        self._children_name_map["igp_areas"] = "igp-areas"
        self._children_yang_names.add("igp-areas")

        self.issu = MplsTeStandby.Issu()
        self.issu.parent = self
        self._children_name_map["issu"] = "issu"
        self._children_yang_names.add("issu")

        self.lsp_out_of_resources = MplsTeStandby.LspOutOfResources()
        self.lsp_out_of_resources.parent = self
        self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"
        self._children_yang_names.add("lsp-out-of-resources")

        self.maximum_tunnels = MplsTeStandby.MaximumTunnels()
        self.maximum_tunnels.parent = self
        self._children_name_map["maximum_tunnels"] = "maximum-tunnels"
        self._children_yang_names.add("maximum-tunnels")

        self.nsr = MplsTeStandby.Nsr()
        self.nsr.parent = self
        self._children_name_map["nsr"] = "nsr"
        self._children_yang_names.add("nsr")

        self.open_config = MplsTeStandby.OpenConfig()
        self.open_config.parent = self
        self._children_name_map["open_config"] = "open-config"
        self._children_yang_names.add("open-config")

        self.p2mp = MplsTeStandby.P2Mp()
        self.p2mp.parent = self
        self._children_name_map["p2mp"] = "p2mp"
        self._children_yang_names.add("p2mp")

        self.p2p_p2mp_tunnel = MplsTeStandby.P2PP2MpTunnel()
        self.p2p_p2mp_tunnel.parent = self
        self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"
        self._children_yang_names.add("p2p-p2mp-tunnel")

        self.path_protection = MplsTeStandby.PathProtection()
        self.path_protection.parent = self
        self._children_name_map["path_protection"] = "path-protection"
        self._children_yang_names.add("path-protection")

        self.signalling_counters = MplsTeStandby.SignallingCounters()
        self.signalling_counters.parent = self
        self._children_name_map["signalling_counters"] = "signalling-counters"
        self._children_yang_names.add("signalling-counters")

        self.soft_preemption = MplsTeStandby.SoftPreemption()
        self.soft_preemption.parent = self
        self._children_name_map["soft_preemption"] = "soft-preemption"
        self._children_yang_names.add("soft-preemption")

        self.topology = MplsTeStandby.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"
        self._children_yang_names.add("topology")

        self.topology_briefs = MplsTeStandby.TopologyBriefs()
        self.topology_briefs.parent = self
        self._children_name_map["topology_briefs"] = "topology-briefs"
        self._children_yang_names.add("topology-briefs")

        self.topology_nodes = MplsTeStandby.TopologyNodes()
        self.topology_nodes.parent = self
        self._children_name_map["topology_nodes"] = "topology-nodes"
        self._children_yang_names.add("topology-nodes")

        self.tunnels = MplsTeStandby.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._children_yang_names.add("tunnels")

        self.wrap_protection = MplsTeStandby.WrapProtection()
        self.wrap_protection.parent = self
        self._children_name_map["wrap_protection"] = "wrap-protection"
        self._children_yang_names.add("wrap-protection")


    class HardwareOutOfResources(Entity):
        """
        NPU Hardware OOR Information
        
        .. attribute:: summary
        
        	HW OOR Summary information
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.HardwareOutOfResources, self).__init__()

            self.yang_name = "hardware-out-of-resources"
            self.yang_parent_name = "mpls-te-standby"

            self.summary = MplsTeStandby.HardwareOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            HW OOR Summary information
            
            .. attribute:: hardware_out_of_resources_state
            
            	Array of NPU HW OOR info per state
            	**type**\: list of    :py:class:`HardwareOutOfResourcesState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.HardwareOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "hardware-out-of-resources"

                self.hardware_out_of_resources_state = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.HardwareOutOfResources.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.HardwareOutOfResources.Summary, self).__setattr__(name, value)


            class HardwareOutOfResourcesState(Entity):
                """
                Array of NPU HW OOR info per state
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the NPU HW OOR state
                	**type**\:  bool
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this  NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: percentage
                
                .. attribute:: hw_oor_state
                
                	The HW\-OOR state that this information belong to
                	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: node_protection_disable
                
                	Disable FRR node protection when the link is in this NPU HW OOR state
                	**type**\:  bool
                
                .. attribute:: statistics
                
                	NPU HW OOR Statistics per state
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics>`
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this NPU HW OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green OOR state is entered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: minute
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__init__()

                    self.yang_name = "hardware-out-of-resources-state"
                    self.yang_parent_name = "summary"

                    self.accept_reopt = YLeaf(YType.boolean, "accept-reopt")

                    self.available_bw_percentage = YLeaf(YType.uint32, "available-bw-percentage")

                    self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                    self.minimum_lsp_bandwidth = YLeaf(YType.uint32, "minimum-lsp-bandwidth")

                    self.node_protection_disable = YLeaf(YType.boolean, "node-protection-disable")

                    self.te_metric_penalty = YLeaf(YType.uint32, "te-metric-penalty")

                    self.transition_duration = YLeaf(YType.uint32, "transition-duration")

                    self.statistics = MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accept_reopt",
                                    "available_bw_percentage",
                                    "hw_oor_state",
                                    "minimum_lsp_bandwidth",
                                    "node_protection_disable",
                                    "te_metric_penalty",
                                    "transition_duration") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    NPU HW OOR Statistics per state
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hw_oor_state
                    
                    	The HW\-OOR state that these statistics belong to
                    	**type**\:   :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    .. attribute:: node_protection_disable_number
                    
                    	Number of times this OOR state disabled node protection assignment
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "hardware-out-of-resources-state"

                        self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                        self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                        self.hw_oor_state = YLeaf(YType.enumeration, "hw-oor-state")

                        self.node_protection_disable_number = YLeaf(YType.uint32, "node-protection-disable-number")

                        self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                        self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                        self.transitions = YLeaf(YType.uint32, "transitions")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("accepted_ls_ps_number",
                                        "accepted_reopt_ls_ps_number",
                                        "hw_oor_state",
                                        "node_protection_disable_number",
                                        "rejected_ls_ps_number",
                                        "rejected_reopt_ls_ps_number",
                                        "transitions") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.accepted_ls_ps_number.is_set or
                            self.accepted_reopt_ls_ps_number.is_set or
                            self.hw_oor_state.is_set or
                            self.node_protection_disable_number.is_set or
                            self.rejected_ls_ps_number.is_set or
                            self.rejected_reopt_ls_ps_number.is_set or
                            self.transitions.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                            self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.hw_oor_state.yfilter != YFilter.not_set or
                            self.node_protection_disable_number.yfilter != YFilter.not_set or
                            self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.transitions.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/summary/hardware-out-of-resources-state/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                        if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                        if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                        if (self.node_protection_disable_number.is_set or self.node_protection_disable_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_protection_disable_number.get_name_leafdata())
                        if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                        if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                        if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.transitions.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "hw-oor-state" or name == "node-protection-disable-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "accepted-ls-ps-number"):
                            self.accepted_ls_ps_number = value
                            self.accepted_ls_ps_number.value_namespace = name_space
                            self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "accepted-reopt-ls-ps-number"):
                            self.accepted_reopt_ls_ps_number = value
                            self.accepted_reopt_ls_ps_number.value_namespace = name_space
                            self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "hw-oor-state"):
                            self.hw_oor_state = value
                            self.hw_oor_state.value_namespace = name_space
                            self.hw_oor_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-protection-disable-number"):
                            self.node_protection_disable_number = value
                            self.node_protection_disable_number.value_namespace = name_space
                            self.node_protection_disable_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-ls-ps-number"):
                            self.rejected_ls_ps_number = value
                            self.rejected_ls_ps_number.value_namespace = name_space
                            self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-reopt-ls-ps-number"):
                            self.rejected_reopt_ls_ps_number = value
                            self.rejected_reopt_ls_ps_number.value_namespace = name_space
                            self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "transitions"):
                            self.transitions = value
                            self.transitions.value_namespace = name_space
                            self.transitions.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.accept_reopt.is_set or
                        self.available_bw_percentage.is_set or
                        self.hw_oor_state.is_set or
                        self.minimum_lsp_bandwidth.is_set or
                        self.node_protection_disable.is_set or
                        self.te_metric_penalty.is_set or
                        self.transition_duration.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accept_reopt.yfilter != YFilter.not_set or
                        self.available_bw_percentage.yfilter != YFilter.not_set or
                        self.hw_oor_state.yfilter != YFilter.not_set or
                        self.minimum_lsp_bandwidth.yfilter != YFilter.not_set or
                        self.node_protection_disable.yfilter != YFilter.not_set or
                        self.te_metric_penalty.yfilter != YFilter.not_set or
                        self.transition_duration.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "hardware-out-of-resources-state" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accept_reopt.is_set or self.accept_reopt.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accept_reopt.get_name_leafdata())
                    if (self.available_bw_percentage.is_set or self.available_bw_percentage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bw_percentage.get_name_leafdata())
                    if (self.hw_oor_state.is_set or self.hw_oor_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hw_oor_state.get_name_leafdata())
                    if (self.minimum_lsp_bandwidth.is_set or self.minimum_lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.minimum_lsp_bandwidth.get_name_leafdata())
                    if (self.node_protection_disable.is_set or self.node_protection_disable.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_protection_disable.get_name_leafdata())
                    if (self.te_metric_penalty.is_set or self.te_metric_penalty.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric_penalty.get_name_leafdata())
                    if (self.transition_duration.is_set or self.transition_duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transition_duration.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "statistics" or name == "accept-reopt" or name == "available-bw-percentage" or name == "hw-oor-state" or name == "minimum-lsp-bandwidth" or name == "node-protection-disable" or name == "te-metric-penalty" or name == "transition-duration"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accept-reopt"):
                        self.accept_reopt = value
                        self.accept_reopt.value_namespace = name_space
                        self.accept_reopt.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bw-percentage"):
                        self.available_bw_percentage = value
                        self.available_bw_percentage.value_namespace = name_space
                        self.available_bw_percentage.value_namespace_prefix = name_space_prefix
                    if(value_path == "hw-oor-state"):
                        self.hw_oor_state = value
                        self.hw_oor_state.value_namespace = name_space
                        self.hw_oor_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "minimum-lsp-bandwidth"):
                        self.minimum_lsp_bandwidth = value
                        self.minimum_lsp_bandwidth.value_namespace = name_space
                        self.minimum_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-protection-disable"):
                        self.node_protection_disable = value
                        self.node_protection_disable.value_namespace = name_space
                        self.node_protection_disable.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric-penalty"):
                        self.te_metric_penalty = value
                        self.te_metric_penalty.value_namespace = name_space
                        self.te_metric_penalty.value_namespace_prefix = name_space_prefix
                    if(value_path == "transition-duration"):
                        self.transition_duration = value
                        self.transition_duration.value_namespace = name_space
                        self.transition_duration.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.hardware_out_of_resources_state:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.hardware_out_of_resources_state:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "hardware-out-of-resources-state"):
                    for c in self.hardware_out_of_resources_state:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.hardware_out_of_resources_state.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "hardware-out-of-resources-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.summary is not None and self.summary.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "hardware-out-of-resources" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTeStandby.HardwareOutOfResources.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class P2PP2MpTunnel(Entity):
        """
        P2P or P2MP tunnels
        
        .. attribute:: nni_tunnels
        
        	GMPLS NNI tunnels
        	**type**\:   :py:class:`NniTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels>`
        
        .. attribute:: tunnel_heads
        
        	Restrict display to P2P or P2MP head tunnels
        	**type**\:   :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads>`
        
        .. attribute:: tunnel_remote_briefs
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:   :py:class:`TunnelRemoteBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs>`
        
        .. attribute:: tunnel_remotes
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:   :py:class:`TunnelRemotes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.P2PP2MpTunnel, self).__init__()

            self.yang_name = "p2p-p2mp-tunnel"
            self.yang_parent_name = "mpls-te-standby"

            self.nni_tunnels = MplsTeStandby.P2PP2MpTunnel.NniTunnels()
            self.nni_tunnels.parent = self
            self._children_name_map["nni_tunnels"] = "nni-tunnels"
            self._children_yang_names.add("nni-tunnels")

            self.tunnel_heads = MplsTeStandby.P2PP2MpTunnel.TunnelHeads()
            self.tunnel_heads.parent = self
            self._children_name_map["tunnel_heads"] = "tunnel-heads"
            self._children_yang_names.add("tunnel-heads")

            self.tunnel_remote_briefs = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs()
            self.tunnel_remote_briefs.parent = self
            self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"
            self._children_yang_names.add("tunnel-remote-briefs")

            self.tunnel_remotes = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes()
            self.tunnel_remotes.parent = self
            self._children_name_map["tunnel_remotes"] = "tunnel-remotes"
            self._children_yang_names.add("tunnel-remotes")


        class TunnelRemoteBriefs(Entity):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote_brief
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of    :py:class:`TunnelRemoteBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs, self).__init__()

                self.yang_name = "tunnel-remote-briefs"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_remote_brief = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs, self).__setattr__(name, value)


            class TunnelRemoteBrief(Entity):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec>`
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L>`
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: uptime
                
                	Time in seconds since the LSP was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__init__()

                    self.yang_name = "tunnel-remote-brief"
                    self.yang_parent_name = "tunnel-remote-briefs"

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                    self.s2l = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("lsp_id",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "ctype",
                                    "destination_address",
                                    "p2mp_id",
                                    "signaled_name",
                                    "uptime") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote-brief"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix


                class S2L(Entity):
                    """
                    array of S2L structures
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\:  str
                    
                    .. attribute:: oper_state
                    
                    	Oper state of S2L
                    	**type**\:  bool
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the S2L was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote-brief"

                        self.egress_interface = YLeaf(YType.str, "egress-interface")

                        self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                        self.oper_state = YLeaf(YType.boolean, "oper-state")

                        self.role = YLeaf(YType.enumeration, "role")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._children_yang_names.add("s2l-fec")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("egress_interface",
                                        "ingress_interface",
                                        "oper_state",
                                        "role",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L, self).__setattr__(name, value)


                    class S2LFec(Entity):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"

                            self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                            self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                            self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                            self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                            self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                            self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                            self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                            self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                            self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                            self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_fec_ctype",
                                            "s2l_fec_dest",
                                            "s2l_fec_extended_tunnel_id",
                                            "s2l_fec_lsp_id",
                                            "s2l_fec_p2mp_id",
                                            "s2l_fec_source",
                                            "s2l_fec_subgroup_id",
                                            "s2l_fec_subgroup_originator",
                                            "s2l_fec_tunnel_id",
                                            "s2l_fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.s2l_fec_ctype.is_set or
                                self.s2l_fec_dest.is_set or
                                self.s2l_fec_extended_tunnel_id.is_set or
                                self.s2l_fec_lsp_id.is_set or
                                self.s2l_fec_p2mp_id.is_set or
                                self.s2l_fec_source.is_set or
                                self.s2l_fec_subgroup_id.is_set or
                                self.s2l_fec_subgroup_originator.is_set or
                                self.s2l_fec_tunnel_id.is_set or
                                self.s2l_fec_vrf.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                self.s2l_fec_dest.yfilter != YFilter.not_set or
                                self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_source.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_vrf.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                            if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                            if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                            if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                            if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                            if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                            if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                            if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-fec-ctype"):
                                self.s2l_fec_ctype = value
                                self.s2l_fec_ctype.value_namespace = name_space
                                self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-dest"):
                                self.s2l_fec_dest = value
                                self.s2l_fec_dest.value_namespace = name_space
                                self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-extended-tunnel-id"):
                                self.s2l_fec_extended_tunnel_id = value
                                self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-lsp-id"):
                                self.s2l_fec_lsp_id = value
                                self.s2l_fec_lsp_id.value_namespace = name_space
                                self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-p2mp-id"):
                                self.s2l_fec_p2mp_id = value
                                self.s2l_fec_p2mp_id.value_namespace = name_space
                                self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-source"):
                                self.s2l_fec_source = value
                                self.s2l_fec_source.value_namespace = name_space
                                self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-id"):
                                self.s2l_fec_subgroup_id = value
                                self.s2l_fec_subgroup_id.value_namespace = name_space
                                self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-originator"):
                                self.s2l_fec_subgroup_originator = value
                                self.s2l_fec_subgroup_originator.value_namespace = name_space
                                self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-tunnel-id"):
                                self.s2l_fec_tunnel_id = value
                                self.s2l_fec_tunnel_id.value_namespace = name_space
                                self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-vrf"):
                                self.s2l_fec_vrf = value
                                self.s2l_fec_vrf.value_namespace = name_space
                                self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.egress_interface.is_set or
                            self.ingress_interface.is_set or
                            self.oper_state.is_set or
                            self.role.is_set or
                            self.uptime.is_set or
                            (self.s2l_fec is not None and self.s2l_fec.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.egress_interface.yfilter != YFilter.not_set or
                            self.ingress_interface.yfilter != YFilter.not_set or
                            self.oper_state.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.s2l_fec is not None and self.s2l_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface.get_name_leafdata())
                        if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                        if (self.oper_state.is_set or self.oper_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.oper_state.get_name_leafdata())
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-fec"):
                            if (self.s2l_fec is None):
                                self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L.S2LFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                            return self.s2l_fec

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-fec" or name == "egress-interface" or name == "ingress-interface" or name == "oper-state" or name == "role" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "egress-interface"):
                            self.egress_interface = value
                            self.egress_interface.value_namespace = name_space
                            self.egress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface"):
                            self.ingress_interface = value
                            self.ingress_interface.value_namespace = name_space
                            self.ingress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "oper-state"):
                            self.oper_state = value
                            self.oper_state.value_namespace = name_space
                            self.oper_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    return (
                        self.lsp_id.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.p2mp_id.is_set or
                        self.signaled_name.is_set or
                        self.uptime.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-remote-brief" + "[lsp-id='" + self.lsp_id.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-remote-briefs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "s2l" or name == "lsp-id" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "source-address" or name == "ctype" or name == "destination-address" or name == "p2mp-id" or name == "signaled-name" or name == "uptime"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_remote_brief:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_remote_brief:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-remote-briefs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-remote-brief"):
                    for c in self.tunnel_remote_brief:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_remote_brief.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-remote-brief"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelRemotes(Entity):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of    :py:class:`TunnelRemote <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes, self).__init__()

                self.yang_name = "tunnel-remotes"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_remote = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes, self).__setattr__(name, value)


            class TunnelRemote(Entity):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: dste_class_index
                
                	Matching DSTE class index
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: dste_class_match
                
                	Do the class type and priority match a DSTE class
                	**type**\:  bool
                
                .. attribute:: frr_active_reason
                
                	P2MP LSP FRR active reason
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_frr_failed
                
                	P2MP LSP has FRR Failed
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: lsp_bandwidth
                
                	P2MP LSP Bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_bandwidth_type
                
                	The LSP bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec>`
                
                .. attribute:: lsp_hold_priority
                
                	LSP hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: lsp_setup_priority
                
                	LSP setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: reoptimize_reason
                
                	Reason for re\-optimization
                	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                
                .. attribute:: reoptimize_trigger
                
                	Re\-optimize trigger
                	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                
                .. attribute:: s2_ls_down
                
                	Number of down S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2_ls_proceeding
                
                	Number of proceeding S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2_ls_up
                
                	Number of connected S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L>`
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: timer_left
                
                	Time in seconds left to take next action if any
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: type
                
                	The type of this LSP
                	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__init__()

                    self.yang_name = "tunnel-remote"
                    self.yang_parent_name = "tunnel-remotes"

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                    self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                    self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                    self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                    self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                    self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                    self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                    self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                    self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                    self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                    self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.timer_left = YLeaf(YType.uint32, "timer-left")

                    self.type = YLeaf(YType.enumeration, "type")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                    self.s2l = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("lsp_id",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "ctype",
                                    "destination_address",
                                    "p2mp_id",
                                    "dste_class_index",
                                    "dste_class_match",
                                    "frr_active_reason",
                                    "is_frr_failed",
                                    "is_interface",
                                    "is_passive",
                                    "last_path_change",
                                    "lsp_bandwidth",
                                    "lsp_bandwidth_type",
                                    "lsp_hold_priority",
                                    "lsp_setup_priority",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "reoptimize_reason",
                                    "reoptimize_trigger",
                                    "s2_ls_down",
                                    "s2_ls_proceeding",
                                    "s2_ls_up",
                                    "signaled_name",
                                    "timer_left",
                                    "type",
                                    "uptime") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix


                class S2L(Entity):
                    """
                    array of S2L structures
                    
                    .. attribute:: abr_auto_discovered
                    
                    	Next ABR auto discovered
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: active_path_option
                    
                    	The path option used to find the path for this S2L
                    	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption>`
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association>`
                    
                    .. attribute:: backup_tunnel_interface
                    
                    	Interface handle of the backup tunnel
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: diversity_info
                    
                    	S2L Diversity Information
                    	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo>`
                    
                    .. attribute:: downstream_router_id
                    
                    	Downstream router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\:  str
                    
                    .. attribute:: egress_interface_brief
                    
                    	Egress Interface in brief format
                    	**type**\:  str
                    
                    .. attribute:: egress_interface_state
                    
                    	State of Outgoing Interface
                    	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    .. attribute:: expanded_ero_affinity_bits
                    
                    	The Outgoing ERO's affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_affinity_mask
                    
                    	The Outgoing ERO's affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_area_id
                    
                    	Indicates the protocol and area used to find Outgoing ERO
                    	**type**\:  str
                    
                    .. attribute:: expanded_ero_metric
                    
                    	The metric value of the expanded path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: expanded_ero_metric_type
                    
                    	The Outgoing ERO's selection metric
                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    .. attribute:: flex_info
                    
                    	FlexLSP S2L Information
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo>`
                    
                    .. attribute:: frr_out_tunnel_interface
                    
                    	FRR out tunnel intface
                    	**type**\:  str
                    
                    .. attribute:: fspec
                    
                    	The F spec info
                    	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec>`
                    
                    .. attribute:: generic_fspec
                    
                    	Generic FSpec
                    	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec>`
                    
                    .. attribute:: generic_tspec
                    
                    	Generic TSpec
                    	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec>`
                    
                    .. attribute:: gmpls_labels
                    
                    	GMPLS labels
                    	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels>`
                    
                    .. attribute:: head_end_bfd_info
                    
                    	The Head\-end BFD info
                    	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo>`
                    
                    .. attribute:: in_ero
                    
                    	Incoming ERO for this S2L
                    	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro>`
                    
                    .. attribute:: in_xro
                    
                    	Incoming XRO for this S2L
                    	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro>`
                    
                    .. attribute:: incoming_address
                    
                    	Incoming interface address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: incoming_address_generic
                    
                    	Incoming interface address
                    	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric>`
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface_brief
                    
                    	Ingress Interface in brief format
                    	**type**\:  str
                    
                    .. attribute:: ingress_interface_state
                    
                    	State of Incoming Interface
                    	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    .. attribute:: is_bandwidth_protect
                    
                    	BW Protection Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_expanded_ero
                    
                    	TRUE if this LSR expanded a loose path
                    	**type**\:  bool
                    
                    .. attribute:: is_frr_enabled
                    
                    	FRR Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_node_protected
                    
                    	Node Protection Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: is_optical
                    
                    	Is Optical
                    	**type**\:  bool
                    
                    .. attribute:: local_router_id
                    
                    	Local router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_wrap_info
                    
                    	Lsp Wrap  Related information
                    	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo>`
                    
                    .. attribute:: next_hop_address
                    
                    	Next hop address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: next_hop_address_generic
                    
                    	Next hop address
                    	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric>`
                    
                    .. attribute:: node_hop_count
                    
                    	Hop count
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: otn_s2l
                    
                    	Otn S2L Information
                    	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L>`
                    
                    .. attribute:: out_ero
                    
                    	Outgoing ERO for this S2L
                    	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro>`
                    
                    .. attribute:: out_xro
                    
                    	Outgoing XRO for this S2L
                    	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro>`
                    
                    .. attribute:: outbound_frr_state
                    
                    	Indicates outbound FRR state
                    	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                    
                    .. attribute:: path_affinity_array
                    
                    	Tunnel's Path hops with affinity
                    	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray>`
                    
                    .. attribute:: path_reeval_query_mid
                    
                    	Loose path reevaluation query received at mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_rro
                    
                    	Path RRO for this S2L
                    	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro>`
                    
                    .. attribute:: path_rro_enabled
                    
                    	Path RRO Enabled or Disabled
                    	**type**\:  bool
                    
                    .. attribute:: path_using_strict_spf
                    
                    	Path is using Strict SPF
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_area
                    
                    	IGP\-area in which the S2L path was calculated
                    	**type**\:  str
                    
                    .. attribute:: previous_hop_address
                    
                    	Previous hop address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: previous_hop_address_generic
                    
                    	Previous hop address
                    	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric>`
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection>`
                    
                    .. attribute:: resv_rro
                    
                    	Resv RRO for this S2L
                    	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro>`
                    
                    .. attribute:: reverse_ero_in
                    
                    	 Reverse Incoming ERO for this S2L
                    	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn>`
                    
                    .. attribute:: reverse_lsp_connected
                    
                    	Reverse Associated Bidir LSP Connected
                    	**type**\:  bool
                    
                    .. attribute:: reverse_lsp_fec
                    
                    	Reverse Associated Bidir LSP FEC
                    	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec>`
                    
                    .. attribute:: reverse_lsp_name
                    
                    	Reverse Associated Bidir LSP Name
                    	**type**\:  str
                    
                    .. attribute:: reverse_lsp_present
                    
                    	Reverse Associated Bidir LSP Present
                    	**type**\:  bool
                    
                    .. attribute:: reverse_tspec
                    
                    	The Reverse T spec info
                    	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec>`
                    
                    .. attribute:: reverse_weight
                    
                    	The reverse path weight
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: s2l_convergence
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence>`
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec>`
                    
                    .. attribute:: s2l_local_label
                    
                    	Local label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_out_label
                    
                    	Outgoing label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_reverse_ero_obj_present
                    
                    	 S2l Reverse ERO Object Present
                    	**type**\:  bool
                    
                    .. attribute:: s2l_reverse_lsp_sub_obj
                    
                    	Reverse LSP Sub Objects
                    	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj>`
                    
                    .. attribute:: s2l_reverse_tspec_obj_present
                    
                    	 S2L Reverse TSpec Object Present
                    	**type**\:  bool
                    
                    .. attribute:: s2l_segment_routing_path
                    
                    	Segment\-Routing S2L path info
                    	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath>`
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The S2L's excluded srlg groups
                    	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup>`
                    
                    .. attribute:: signalling_status
                    
                    	Signaling status
                    	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                    
                    .. attribute:: soft_preemption
                    
                    	The soft preemption info for this LSP
                    	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption>`
                    
                    .. attribute:: srlg_collection
                    
                    	SRLG\-collection data
                    	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection>`
                    
                    .. attribute:: tail_end_bfd_info
                    
                    	The Tail\-end BFD info
                    	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo>`
                    
                    .. attribute:: time_since_last_preferred_path_exists_send_mid
                    
                    	Time since last preferred path exists msg send from mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: time_since_last_preferred_tree_exists_send_mid
                    
                    	Time since last preferred tree exists msg send from mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: time_since_last_query_received_mid
                    
                    	Time since last reevaluation query received at mid\-point
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tspec
                    
                    	The T spec info
                    	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec>`
                    
                    .. attribute:: upstream_router_id
                    
                    	Upstream router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weight
                    
                    	The path's weight
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote"

                        self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                        self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                        self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                        self.egress_interface = YLeaf(YType.str, "egress-interface")

                        self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                        self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                        self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                        self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                        self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                        self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                        self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                        self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                        self.incoming_address = YLeaf(YType.str, "incoming-address")

                        self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                        self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                        self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                        self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                        self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                        self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                        self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                        self.is_optical = YLeaf(YType.boolean, "is-optical")

                        self.local_router_id = YLeaf(YType.str, "local-router-id")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                        self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                        self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                        self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                        self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                        self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                        self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                        self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                        self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                        self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                        self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                        self.role = YLeaf(YType.enumeration, "role")

                        self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                        self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                        self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                        self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                        self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                        self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                        self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                        self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                        self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.weight = YLeaf(YType.uint64, "weight")

                        self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption()
                        self.active_path_option.parent = self
                        self._children_name_map["active_path_option"] = "active-path-option"
                        self._children_yang_names.add("active-path-option")

                        self.association = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo()
                        self.diversity_info.parent = self
                        self._children_name_map["diversity_info"] = "diversity-info"
                        self._children_yang_names.add("diversity-info")

                        self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec()
                        self.fspec.parent = self
                        self._children_name_map["fspec"] = "fspec"
                        self._children_yang_names.add("fspec")

                        self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec()
                        self.generic_fspec.parent = self
                        self._children_name_map["generic_fspec"] = "generic-fspec"
                        self._children_yang_names.add("generic-fspec")

                        self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec()
                        self.generic_tspec.parent = self
                        self._children_name_map["generic_tspec"] = "generic-tspec"
                        self._children_yang_names.add("generic-tspec")

                        self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels()
                        self.gmpls_labels.parent = self
                        self._children_name_map["gmpls_labels"] = "gmpls-labels"
                        self._children_yang_names.add("gmpls-labels")

                        self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo()
                        self.head_end_bfd_info.parent = self
                        self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                        self._children_yang_names.add("head-end-bfd-info")

                        self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro()
                        self.in_xro.parent = self
                        self._children_name_map["in_xro"] = "in-xro"
                        self._children_yang_names.add("in-xro")

                        self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric()
                        self.incoming_address_generic.parent = self
                        self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                        self._children_yang_names.add("incoming-address-generic")

                        self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo()
                        self.lsp_wrap_info.parent = self
                        self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                        self._children_yang_names.add("lsp-wrap-info")

                        self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric()
                        self.next_hop_address_generic.parent = self
                        self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                        self._children_yang_names.add("next-hop-address-generic")

                        self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L()
                        self.otn_s2l.parent = self
                        self._children_name_map["otn_s2l"] = "otn-s2l"
                        self._children_yang_names.add("otn-s2l")

                        self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro()
                        self.out_xro.parent = self
                        self._children_name_map["out_xro"] = "out-xro"
                        self._children_yang_names.add("out-xro")

                        self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric()
                        self.previous_hop_address_generic.parent = self
                        self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                        self._children_yang_names.add("previous-hop-address-generic")

                        self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec()
                        self.reverse_lsp_fec.parent = self
                        self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                        self._children_yang_names.add("reverse-lsp-fec")

                        self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec()
                        self.reverse_tspec.parent = self
                        self._children_name_map["reverse_tspec"] = "reverse-tspec"
                        self._children_yang_names.add("reverse-tspec")

                        self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence()
                        self.s2l_convergence.parent = self
                        self._children_name_map["s2l_convergence"] = "s2l-convergence"
                        self._children_yang_names.add("s2l-convergence")

                        self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._children_yang_names.add("s2l-fec")

                        self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption()
                        self.soft_preemption.parent = self
                        self._children_name_map["soft_preemption"] = "soft-preemption"
                        self._children_yang_names.add("soft-preemption")

                        self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection()
                        self.srlg_collection.parent = self
                        self._children_name_map["srlg_collection"] = "srlg-collection"
                        self._children_yang_names.add("srlg-collection")

                        self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo()
                        self.tail_end_bfd_info.parent = self
                        self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                        self._children_yang_names.add("tail-end-bfd-info")

                        self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec()
                        self.tspec.parent = self
                        self._children_name_map["tspec"] = "tspec"
                        self._children_yang_names.add("tspec")

                        self.in_ero = YList(self)
                        self.out_ero = YList(self)
                        self.path_affinity_array = YList(self)
                        self.path_rro = YList(self)
                        self.resv_rro = YList(self)
                        self.reverse_ero_in = YList(self)
                        self.s2l_reverse_lsp_sub_obj = YList(self)
                        self.s2l_segment_routing_path = YList(self)
                        self.shared_risk_link_group = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("abr_auto_discovered",
                                        "backup_tunnel_interface",
                                        "downstream_router_id",
                                        "egress_interface",
                                        "egress_interface_brief",
                                        "egress_interface_state",
                                        "expanded_ero_affinity_bits",
                                        "expanded_ero_affinity_mask",
                                        "expanded_ero_area_id",
                                        "expanded_ero_metric",
                                        "expanded_ero_metric_type",
                                        "frr_out_tunnel_interface",
                                        "incoming_address",
                                        "ingress_interface",
                                        "ingress_interface_brief",
                                        "ingress_interface_state",
                                        "is_bandwidth_protect",
                                        "is_expanded_ero",
                                        "is_frr_enabled",
                                        "is_node_protected",
                                        "is_optical",
                                        "local_router_id",
                                        "next_hop_address",
                                        "node_hop_count",
                                        "outbound_frr_state",
                                        "path_reeval_query_mid",
                                        "path_rro_enabled",
                                        "path_using_strict_spf",
                                        "pcalc_area",
                                        "previous_hop_address",
                                        "reverse_lsp_connected",
                                        "reverse_lsp_name",
                                        "reverse_lsp_present",
                                        "reverse_weight",
                                        "role",
                                        "s2l_local_label",
                                        "s2l_out_label",
                                        "s2l_reverse_ero_obj_present",
                                        "s2l_reverse_tspec_obj_present",
                                        "signalling_status",
                                        "time_since_last_preferred_path_exists_send_mid",
                                        "time_since_last_preferred_tree_exists_send_mid",
                                        "time_since_last_query_received_mid",
                                        "upstream_router_id",
                                        "uptime",
                                        "weight") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L, self).__setattr__(name, value)


                    class S2LFec(Entity):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"

                            self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                            self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                            self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                            self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                            self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                            self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                            self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                            self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                            self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                            self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_fec_ctype",
                                            "s2l_fec_dest",
                                            "s2l_fec_extended_tunnel_id",
                                            "s2l_fec_lsp_id",
                                            "s2l_fec_p2mp_id",
                                            "s2l_fec_source",
                                            "s2l_fec_subgroup_id",
                                            "s2l_fec_subgroup_originator",
                                            "s2l_fec_tunnel_id",
                                            "s2l_fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.s2l_fec_ctype.is_set or
                                self.s2l_fec_dest.is_set or
                                self.s2l_fec_extended_tunnel_id.is_set or
                                self.s2l_fec_lsp_id.is_set or
                                self.s2l_fec_p2mp_id.is_set or
                                self.s2l_fec_source.is_set or
                                self.s2l_fec_subgroup_id.is_set or
                                self.s2l_fec_subgroup_originator.is_set or
                                self.s2l_fec_tunnel_id.is_set or
                                self.s2l_fec_vrf.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                self.s2l_fec_dest.yfilter != YFilter.not_set or
                                self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                self.s2l_fec_source.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                self.s2l_fec_vrf.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                            if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                            if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                            if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                            if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                            if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                            if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                            if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                            if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-fec-ctype"):
                                self.s2l_fec_ctype = value
                                self.s2l_fec_ctype.value_namespace = name_space
                                self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-dest"):
                                self.s2l_fec_dest = value
                                self.s2l_fec_dest.value_namespace = name_space
                                self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-extended-tunnel-id"):
                                self.s2l_fec_extended_tunnel_id = value
                                self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-lsp-id"):
                                self.s2l_fec_lsp_id = value
                                self.s2l_fec_lsp_id.value_namespace = name_space
                                self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-p2mp-id"):
                                self.s2l_fec_p2mp_id = value
                                self.s2l_fec_p2mp_id.value_namespace = name_space
                                self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-source"):
                                self.s2l_fec_source = value
                                self.s2l_fec_source.value_namespace = name_space
                                self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-id"):
                                self.s2l_fec_subgroup_id = value
                                self.s2l_fec_subgroup_id.value_namespace = name_space
                                self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-subgroup-originator"):
                                self.s2l_fec_subgroup_originator = value
                                self.s2l_fec_subgroup_originator.value_namespace = name_space
                                self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-tunnel-id"):
                                self.s2l_fec_tunnel_id = value
                                self.s2l_fec_tunnel_id.value_namespace = name_space
                                self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-fec-vrf"):
                                self.s2l_fec_vrf = value
                                self.s2l_fec_vrf.value_namespace = name_space
                                self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                    class ActivePathOption(Entity):
                        """
                        The path option used to find the path for this
                        S2L
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__init__()

                            self.yang_name = "active-path-option"
                            self.yang_parent_name = "s2l"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "active-path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "active-path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "active-path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "active-path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "active-path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "active-path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class OutXro(Entity):
                        """
                        Outgoing XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__init__()

                            self.yang_name = "out-xro"
                            self.yang_parent_name = "s2l"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "out-xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                    class InXro(Entity):
                        """
                        Incoming XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__init__()

                            self.yang_name = "in-xro"
                            self.yang_parent_name = "s2l"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "in-xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "in-xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                    class Tspec(Entity):
                        """
                        The T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__init__()

                            self.yang_name = "tspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class GenericTspec(Entity):
                        """
                        Generic TSpec
                        
                        .. attribute:: otntspec
                        
                        	TE TSpec for G709 OTN
                        	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec>`
                        
                        .. attribute:: tspec_type
                        
                        	TSpecType
                        	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__init__()

                            self.yang_name = "generic-tspec"
                            self.yang_parent_name = "s2l"

                            self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                            self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec()
                            self.otntspec.parent = self
                            self._children_name_map["otntspec"] = "otntspec"
                            self._children_yang_names.add("otntspec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tspec_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec, self).__setattr__(name, value)


                        class Otntspec(Entity):
                            """
                            TE TSpec for G709 OTN
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__init__()

                                self.yang_name = "otntspec"
                                self.yang_parent_name = "generic-tspec"

                                self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                self.multiplier = YLeaf(YType.uint16, "multiplier")

                                self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                self.nvc = YLeaf(YType.uint16, "nvc")

                                self.signal_type = YLeaf(YType.uint8, "signal-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bit_rate",
                                                "multiplier",
                                                "nmc_or_tolerance",
                                                "nvc",
                                                "signal_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bit_rate.is_set or
                                    self.multiplier.is_set or
                                    self.nmc_or_tolerance.is_set or
                                    self.nvc.is_set or
                                    self.signal_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bit_rate.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                    self.nvc.yfilter != YFilter.not_set or
                                    self.signal_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otntspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nvc.get_name_leafdata())
                                if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signal_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bit-rate"):
                                    self.bit_rate = value
                                    self.bit_rate.value_namespace = name_space
                                    self.bit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "nmc-or-tolerance"):
                                    self.nmc_or_tolerance = value
                                    self.nmc_or_tolerance.value_namespace = name_space
                                    self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                if(value_path == "nvc"):
                                    self.nvc = value
                                    self.nvc.value_namespace = name_space
                                    self.nvc.value_namespace_prefix = name_space_prefix
                                if(value_path == "signal-type"):
                                    self.signal_type = value
                                    self.signal_type.value_namespace = name_space
                                    self.signal_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tspec_type.is_set or
                                (self.otntspec is not None and self.otntspec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tspec_type.yfilter != YFilter.not_set or
                                (self.otntspec is not None and self.otntspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "generic-tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tspec_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "otntspec"):
                                if (self.otntspec is None):
                                    self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec.Otntspec()
                                    self.otntspec.parent = self
                                    self._children_name_map["otntspec"] = "otntspec"
                                return self.otntspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "otntspec" or name == "tspec-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tspec-type"):
                                self.tspec_type = value
                                self.tspec_type.value_namespace = name_space
                                self.tspec_type.value_namespace_prefix = name_space_prefix


                    class Fspec(Entity):
                        """
                        The F spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__init__()

                            self.yang_name = "fspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class GenericFspec(Entity):
                        """
                        Generic FSpec
                        
                        .. attribute:: fspec_type
                        
                        	FSpecType
                        	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                        
                        .. attribute:: otnfspec
                        
                        	TE FSpec for G709 OTN
                        	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__init__()

                            self.yang_name = "generic-fspec"
                            self.yang_parent_name = "s2l"

                            self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                            self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec()
                            self.otnfspec.parent = self
                            self._children_name_map["otnfspec"] = "otnfspec"
                            self._children_yang_names.add("otnfspec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fspec_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec, self).__setattr__(name, value)


                        class Otnfspec(Entity):
                            """
                            TE FSpec for G709 OTN
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__init__()

                                self.yang_name = "otnfspec"
                                self.yang_parent_name = "generic-fspec"

                                self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                self.multiplier = YLeaf(YType.uint16, "multiplier")

                                self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                self.nvc = YLeaf(YType.uint16, "nvc")

                                self.signal_type = YLeaf(YType.uint8, "signal-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bit_rate",
                                                "multiplier",
                                                "nmc_or_tolerance",
                                                "nvc",
                                                "signal_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.bit_rate.is_set or
                                    self.multiplier.is_set or
                                    self.nmc_or_tolerance.is_set or
                                    self.nvc.is_set or
                                    self.signal_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bit_rate.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                    self.nvc.yfilter != YFilter.not_set or
                                    self.signal_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otnfspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nvc.get_name_leafdata())
                                if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signal_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bit-rate"):
                                    self.bit_rate = value
                                    self.bit_rate.value_namespace = name_space
                                    self.bit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "nmc-or-tolerance"):
                                    self.nmc_or_tolerance = value
                                    self.nmc_or_tolerance.value_namespace = name_space
                                    self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                if(value_path == "nvc"):
                                    self.nvc = value
                                    self.nvc.value_namespace = name_space
                                    self.nvc.value_namespace_prefix = name_space_prefix
                                if(value_path == "signal-type"):
                                    self.signal_type = value
                                    self.signal_type.value_namespace = name_space
                                    self.signal_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fspec_type.is_set or
                                (self.otnfspec is not None and self.otnfspec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fspec_type.yfilter != YFilter.not_set or
                                (self.otnfspec is not None and self.otnfspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "generic-fspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fspec_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "otnfspec"):
                                if (self.otnfspec is None):
                                    self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec.Otnfspec()
                                    self.otnfspec.parent = self
                                    self._children_name_map["otnfspec"] = "otnfspec"
                                return self.otnfspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "otnfspec" or name == "fspec-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fspec-type"):
                                self.fspec_type = value
                                self.fspec_type.value_namespace = name_space
                                self.fspec_type.value_namespace_prefix = name_space_prefix


                    class NextHopAddressGeneric(Entity):
                        """
                        Next hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric, self).__init__()

                            self.yang_name = "next-hop-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "next-hop-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "next-hop-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class PreviousHopAddressGeneric(Entity):
                        """
                        Previous hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric, self).__init__()

                            self.yang_name = "previous-hop-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "previous-hop-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-hop-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class IncomingAddressGeneric(Entity):
                        """
                        Incoming interface address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric, self).__init__()

                            self.yang_name = "incoming-address-generic"
                            self.yang_parent_name = "s2l"

                            self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._children_yang_names.add("te-addr")


                        class TeAddr(Entity):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "incoming-address-generic"

                                self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                self.type = YLeaf(YType.enumeration, "type")

                                self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._children_yang_names.add("ipv4-unnumbered-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ipv4_address",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                            class Ipv4UnnumberedAddress(Entity):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"

                                    self.interface_index = YLeaf(YType.uint32, "interface-index")

                                    self.router_id = YLeaf(YType.str, "router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_index",
                                                    "router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.interface_index.is_set or
                                        self.router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_index.yfilter != YFilter.not_set or
                                        self.router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-unnumbered-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_index.get_name_leafdata())
                                    if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-index" or name == "router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-index"):
                                        self.interface_index = value
                                        self.interface_index.value_namespace = name_space
                                        self.interface_index.value_namespace_prefix = name_space_prefix
                                    if(value_path == "router-id"):
                                        self.router_id = value
                                        self.router_id.value_namespace = name_space
                                        self.router_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ipv4_address.is_set or
                                    self.type.is_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ipv4_address.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "te-addr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4-unnumbered-address"):
                                    if (self.ipv4_unnumbered_address is None):
                                        self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    return self.ipv4_unnumbered_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ipv4-address"):
                                    self.ipv4_address = value
                                    self.ipv4_address.value_namespace = name_space
                                    self.ipv4_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.te_addr is not None and self.te_addr.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.te_addr is not None and self.te_addr.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "incoming-address-generic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "te-addr"):
                                if (self.te_addr is None):
                                    self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                return self.te_addr

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "te-addr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class S2LConvergence(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__init__()

                            self.yang_name = "s2l-convergence"
                            self.yang_parent_name = "s2l"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-convergence" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                    class SoftPreemption(Entity):
                        """
                        The soft preemption info for this LSP.
                        
                        .. attribute:: fr_rrewrite
                        
                        	FRR\-rewrite during soft preemption
                        	**type**\:  bool
                        
                        .. attribute:: fr_rrewrite_tunnel_name
                        
                        	The tunnel name of the backup
                        	**type**\:  str
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: soft_preemption_link
                        
                        	Name of the link where the soft preemption occurred
                        	**type**\:  str
                        
                        .. attribute:: soft_preemption_timestamp
                        
                        	The POSIX timestamp when the soft preemption occurred
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: status
                        
                        	The current state of the soft preemption operation
                        	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                        
                        .. attribute:: time_to_hard_preemption
                        
                        	The number of seconds until hard preemption is triggered
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__init__()

                            self.yang_name = "soft-preemption"
                            self.yang_parent_name = "s2l"

                            self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                            self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                            self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                            self.status = YLeaf(YType.enumeration, "status")

                            self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fr_rrewrite",
                                            "fr_rrewrite_tunnel_name",
                                            "preempting_link_address",
                                            "soft_preemption_link",
                                            "soft_preemption_timestamp",
                                            "status",
                                            "time_to_hard_preemption") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fr_rrewrite.is_set or
                                self.fr_rrewrite_tunnel_name.is_set or
                                self.preempting_link_address.is_set or
                                self.soft_preemption_link.is_set or
                                self.soft_preemption_timestamp.is_set or
                                self.status.is_set or
                                self.time_to_hard_preemption.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fr_rrewrite.yfilter != YFilter.not_set or
                                self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.soft_preemption_link.yfilter != YFilter.not_set or
                                self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                self.status.yfilter != YFilter.not_set or
                                self.time_to_hard_preemption.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                            if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                            if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                            if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.status.get_name_leafdata())
                            if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fr-rrewrite"):
                                self.fr_rrewrite = value
                                self.fr_rrewrite.value_namespace = name_space
                                self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "fr-rrewrite-tunnel-name"):
                                self.fr_rrewrite_tunnel_name = value
                                self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-link"):
                                self.soft_preemption_link = value
                                self.soft_preemption_link.value_namespace = name_space
                                self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-timestamp"):
                                self.soft_preemption_timestamp = value
                                self.soft_preemption_timestamp.value_namespace = name_space
                                self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "status"):
                                self.status = value
                                self.status.value_namespace = name_space
                                self.status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-to-hard-preemption"):
                                self.time_to_hard_preemption = value
                                self.time_to_hard_preemption.value_namespace = name_space
                                self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                    class GmplsLabels(Entity):
                        """
                        GMPLS labels
                        
                        .. attribute:: path_egress_label
                        
                        	Path message (upstream) egress label
                        	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel>`
                        
                        .. attribute:: path_ingress_label
                        
                        	Path message (upstream) ingress label
                        	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel>`
                        
                        .. attribute:: resv_egress_label
                        
                        	Resv message (downstream) egress label
                        	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel>`
                        
                        .. attribute:: resv_ingress_label
                        
                        	Resv message (downstream) ingress label
                        	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels, self).__init__()

                            self.yang_name = "gmpls-labels"
                            self.yang_parent_name = "s2l"

                            self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel()
                            self.path_egress_label.parent = self
                            self._children_name_map["path_egress_label"] = "path-egress-label"
                            self._children_yang_names.add("path-egress-label")

                            self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel()
                            self.path_ingress_label.parent = self
                            self._children_name_map["path_ingress_label"] = "path-ingress-label"
                            self._children_yang_names.add("path-ingress-label")

                            self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel()
                            self.resv_egress_label.parent = self
                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                            self._children_yang_names.add("resv-egress-label")

                            self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel()
                            self.resv_ingress_label.parent = self
                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                            self._children_yang_names.add("resv-ingress-label")


                        class PathIngressLabel(Entity):
                            """
                            Path message (upstream) ingress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                self.yang_name = "path-ingress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-ingress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-ingress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-ingress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class PathEgressLabel(Entity):
                            """
                            Path message (upstream) egress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                self.yang_name = "path-egress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-egress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-egress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-egress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class ResvIngressLabel(Entity):
                            """
                            Resv message (downstream) ingress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                self.yang_name = "resv-ingress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-ingress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-ingress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-ingress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix


                        class ResvEgressLabel(Entity):
                            """
                            Resv message (downstream) egress label
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                self.yang_name = "resv-egress-label"
                                self.yang_parent_name = "gmpls-labels"

                                self.label_type = YLeaf(YType.enumeration, "label-type")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")

                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"
                                self._children_yang_names.add("wdm")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                            class Wdm(Entity):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\:  int
                                
                                	**range:** \-32768..32767
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-egress-label"

                                    self.channel = YLeaf(YType.int16, "channel")

                                    self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                    self.grid = YLeaf(YType.enumeration, "grid")

                                    self.identifier = YLeaf(YType.uint16, "identifier")

                                    self.label_set = YLeaf(YType.boolean, "label-set")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("channel",
                                                    "channel_spacing",
                                                    "grid",
                                                    "identifier",
                                                    "label_set") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.channel.is_set or
                                        self.channel_spacing.is_set or
                                        self.grid.is_set or
                                        self.identifier.is_set or
                                        self.label_set.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.channel.yfilter != YFilter.not_set or
                                        self.channel_spacing.yfilter != YFilter.not_set or
                                        self.grid.yfilter != YFilter.not_set or
                                        self.identifier.yfilter != YFilter.not_set or
                                        self.label_set.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "wdm" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel.get_name_leafdata())
                                    if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                    if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.grid.get_name_leafdata())
                                    if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.identifier.get_name_leafdata())
                                    if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_set.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "channel"):
                                        self.channel = value
                                        self.channel.value_namespace = name_space
                                        self.channel.value_namespace_prefix = name_space_prefix
                                    if(value_path == "channel-spacing"):
                                        self.channel_spacing = value
                                        self.channel_spacing.value_namespace = name_space
                                        self.channel_spacing.value_namespace_prefix = name_space_prefix
                                    if(value_path == "grid"):
                                        self.grid = value
                                        self.grid.value_namespace = name_space
                                        self.grid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "identifier"):
                                        self.identifier = value
                                        self.identifier.value_namespace = name_space
                                        self.identifier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-set"):
                                        self.label_set = value
                                        self.label_set.value_namespace = name_space
                                        self.label_set.value_namespace_prefix = name_space_prefix


                            class Otn(Entity):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-egress-label"

                                    self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                    self.tpn = YLeaf(YType.uint16, "tpn")

                                    self.bit_map = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_map_length",
                                                    "tpn") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                class BitMap(Entity):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"

                                        self.entry = YLeaf(YType.uint8, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bit-map" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bit_map:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.bit_map_length.is_set or
                                        self.tpn.is_set)

                                def has_operation(self):
                                    for c in self.bit_map:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_map_length.yfilter != YFilter.not_set or
                                        self.tpn.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                    if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tpn.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bit-map"):
                                        for c in self.bit_map:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bit_map.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-map-length"):
                                        self.bit_map_length = value
                                        self.bit_map_length.value_namespace = name_space
                                        self.bit_map_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tpn"):
                                        self.tpn = value
                                        self.tpn.value_namespace = name_space
                                        self.tpn.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.label_type.is_set or
                                    (self.otn is not None and self.otn.has_data()) or
                                    (self.wdm is not None and self.wdm.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_type.yfilter != YFilter.not_set or
                                    (self.otn is not None and self.otn.has_operation()) or
                                    (self.wdm is not None and self.wdm.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-egress-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                if (child_yang_name == "wdm"):
                                    if (self.wdm is None):
                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                    return self.wdm

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otn" or name == "wdm" or name == "label-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-type"):
                                    self.label_type = value
                                    self.label_type.value_namespace = name_space
                                    self.label_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-labels" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-egress-label"):
                                if (self.path_egress_label is None):
                                    self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"
                                return self.path_egress_label

                            if (child_yang_name == "path-ingress-label"):
                                if (self.path_ingress_label is None):
                                    self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                return self.path_ingress_label

                            if (child_yang_name == "resv-egress-label"):
                                if (self.resv_egress_label is None):
                                    self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                return self.resv_egress_label

                            if (child_yang_name == "resv-ingress-label"):
                                if (self.resv_ingress_label is None):
                                    self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                return self.resv_ingress_label

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class OtnS2L(Entity):
                        """
                        Otn S2L Information
                        
                        .. attribute:: aps
                        
                        	APS Info for OTN S2L
                        	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps>`
                        
                        .. attribute:: otn
                        
                        	Info Related to OTN technology in S2L
                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L, self).__init__()

                            self.yang_name = "otn-s2l"
                            self.yang_parent_name = "s2l"

                            self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps()
                            self.aps.parent = self
                            self._children_name_map["aps"] = "aps"
                            self._children_yang_names.add("aps")

                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn()
                            self.otn.parent = self
                            self._children_name_map["otn"] = "otn"
                            self._children_yang_names.add("otn")


                        class Otn(Entity):
                            """
                            Info Related to OTN technology in S2L
                            
                            .. attribute:: bandwidth
                            
                            	OTN Bandwidth for s2l
                            	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth>`
                            
                            .. attribute:: cross_connect_id
                            
                            	Cross connect id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: gpid
                            
                            	Gpid Payload
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: incoming_controller
                            
                            	Incoming Controller
                            	**type**\:  str
                            
                            .. attribute:: incoming_controller_ifhandle
                            
                            	Incoming Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: incoming_controller_state
                            
                            	State of Incoming Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: incoming_sub_controller
                            
                            	Incoming Sub Controller
                            	**type**\:  str
                            
                            .. attribute:: incoming_sub_controller_ifhandle
                            
                            	Incoming Sub Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: incoming_sub_controller_state
                            
                            	State of Incoming Sub Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: is_connected
                            
                            	True if subcontrollers are connected
                            	**type**\:  bool
                            
                            .. attribute:: labels
                            
                            	Labels
                            	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels>`
                            
                            .. attribute:: outgoing_controller
                            
                            	Outgoing Controller
                            	**type**\:  str
                            
                            .. attribute:: outgoing_controller_ifhandle
                            
                            	Outgoing Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: outgoing_controller_state
                            
                            	State of Outgoing Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: outgoing_sub_controller
                            
                            	Outgoing Sub Controller
                            	**type**\:  str
                            
                            .. attribute:: outgoing_sub_controller_ifhandle
                            
                            	Outgoing Sub Controller Ifhandle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: outgoing_sub_controller_state
                            
                            	State of Outgoing Sub Controller
                            	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            .. attribute:: uptime
                            
                            	XC Uptime
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__init__()

                                self.yang_name = "otn"
                                self.yang_parent_name = "otn-s2l"

                                self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                self.gpid = YLeaf(YType.uint16, "gpid")

                                self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                self.is_connected = YLeaf(YType.boolean, "is-connected")

                                self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                self.uptime = YLeaf(YType.uint32, "uptime")

                                self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth()
                                self.bandwidth.parent = self
                                self._children_name_map["bandwidth"] = "bandwidth"
                                self._children_yang_names.add("bandwidth")

                                self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels()
                                self.labels.parent = self
                                self._children_name_map["labels"] = "labels"
                                self._children_yang_names.add("labels")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("cross_connect_id",
                                                "gpid",
                                                "incoming_controller",
                                                "incoming_controller_ifhandle",
                                                "incoming_controller_state",
                                                "incoming_sub_controller",
                                                "incoming_sub_controller_ifhandle",
                                                "incoming_sub_controller_state",
                                                "is_connected",
                                                "outgoing_controller",
                                                "outgoing_controller_ifhandle",
                                                "outgoing_controller_state",
                                                "outgoing_sub_controller",
                                                "outgoing_sub_controller_ifhandle",
                                                "outgoing_sub_controller_state",
                                                "uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                            class Bandwidth(Entity):
                                """
                                OTN Bandwidth for s2l
                                
                                .. attribute:: odu_flex_cbr
                                
                                	Odu flex CBR info
                                	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                
                                .. attribute:: odu_flex_gfp_f_non_res
                                
                                	Odu flex GFP\-F non\-resizable info
                                	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                
                                .. attribute:: odu_flex_gfp_f_res
                                
                                	Odu flex GFP\-F resizable info
                                	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                
                                .. attribute:: odu_level
                                
                                	ODULevel
                                	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                    self.yang_name = "bandwidth"
                                    self.yang_parent_name = "otn"

                                    self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                    self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                    self.odu_flex_cbr.parent = self
                                    self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    self._children_yang_names.add("odu-flex-cbr")

                                    self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                    self.odu_flex_gfp_f_non_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                    self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                    self.odu_flex_gfp_f_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    self._children_yang_names.add("odu-flex-gfp-f-res")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("odu_level") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                class OduFlexCbr(Entity):
                                    """
                                    Odu flex CBR info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tolerance
                                    
                                    	Tolerance
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                        self.yang_name = "odu-flex-cbr"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        self.tolerance = YLeaf(YType.uint16, "tolerance")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate",
                                                        "tolerance") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.bit_rate.is_set or
                                            self.tolerance.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set or
                                            self.tolerance.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-cbr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                        if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tolerance.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate" or name == "tolerance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tolerance"):
                                            self.tolerance = value
                                            self.tolerance.value_namespace = name_space
                                            self.tolerance.value_namespace_prefix = name_space_prefix


                                class OduFlexGfpFRes(Entity):
                                    """
                                    Odu flex GFP\-F resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-res"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.bit_rate.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix


                                class OduFlexGfpFNonRes(Entity):
                                    """
                                    Odu flex GFP\-F non\-resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-non-res"
                                        self.yang_parent_name = "bandwidth"

                                        self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.bit_rate.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_rate.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-rate"):
                                            self.bit_rate = value
                                            self.bit_rate.value_namespace = name_space
                                            self.bit_rate.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.odu_level.is_set or
                                        (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                        (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                        (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.odu_level.yfilter != YFilter.not_set or
                                        (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                        (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                        (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bandwidth" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.odu_level.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "odu-flex-cbr"):
                                        if (self.odu_flex_cbr is None):
                                            self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                            self.odu_flex_cbr.parent = self
                                            self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        return self.odu_flex_cbr

                                    if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                        if (self.odu_flex_gfp_f_non_res is None):
                                            self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                            self.odu_flex_gfp_f_non_res.parent = self
                                            self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        return self.odu_flex_gfp_f_non_res

                                    if (child_yang_name == "odu-flex-gfp-f-res"):
                                        if (self.odu_flex_gfp_f_res is None):
                                            self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                            self.odu_flex_gfp_f_res.parent = self
                                            self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        return self.odu_flex_gfp_f_res

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "odu-level"):
                                        self.odu_level = value
                                        self.odu_level.value_namespace = name_space
                                        self.odu_level.value_namespace_prefix = name_space_prefix


                            class Labels(Entity):
                                """
                                Labels
                                
                                .. attribute:: path_egress_label
                                
                                	Path message (upstream) egress label
                                	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                
                                .. attribute:: path_ingress_label
                                
                                	Path message (upstream) ingress label
                                	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                
                                .. attribute:: resv_egress_label
                                
                                	Resv message (downstream) egress label
                                	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                
                                .. attribute:: resv_ingress_label
                                
                                	Resv message (downstream) ingress label
                                	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels, self).__init__()

                                    self.yang_name = "labels"
                                    self.yang_parent_name = "otn"

                                    self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"
                                    self._children_yang_names.add("path-egress-label")

                                    self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    self._children_yang_names.add("path-ingress-label")

                                    self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    self._children_yang_names.add("resv-egress-label")

                                    self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    self._children_yang_names.add("resv-ingress-label")


                                class PathIngressLabel(Entity):
                                    """
                                    Path message (upstream) ingress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                        self.yang_name = "path-ingress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-ingress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-ingress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "path-ingress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class PathEgressLabel(Entity):
                                    """
                                    Path message (upstream) egress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                        self.yang_name = "path-egress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-egress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-egress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "path-egress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class ResvIngressLabel(Entity):
                                    """
                                    Resv message (downstream) ingress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                        self.yang_name = "resv-ingress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-ingress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-ingress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "resv-ingress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix


                                class ResvEgressLabel(Entity):
                                    """
                                    Resv message (downstream) egress label
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                        self.yang_name = "resv-egress-label"
                                        self.yang_parent_name = "labels"

                                        self.label_type = YLeaf(YType.enumeration, "label-type")

                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._children_yang_names.add("otn")

                                        self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"
                                        self._children_yang_names.add("wdm")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                    class Wdm(Entity):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\:  int
                                        
                                        	**range:** \-32768..32767
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-egress-label"

                                            self.channel = YLeaf(YType.int16, "channel")

                                            self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                            self.grid = YLeaf(YType.enumeration, "grid")

                                            self.identifier = YLeaf(YType.uint16, "identifier")

                                            self.label_set = YLeaf(YType.boolean, "label-set")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("channel",
                                                            "channel_spacing",
                                                            "grid",
                                                            "identifier",
                                                            "label_set") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.channel.is_set or
                                                self.channel_spacing.is_set or
                                                self.grid.is_set or
                                                self.identifier.is_set or
                                                self.label_set.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.channel.yfilter != YFilter.not_set or
                                                self.channel_spacing.yfilter != YFilter.not_set or
                                                self.grid.yfilter != YFilter.not_set or
                                                self.identifier.yfilter != YFilter.not_set or
                                                self.label_set.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wdm" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel.get_name_leafdata())
                                            if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                            if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.grid.get_name_leafdata())
                                            if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.identifier.get_name_leafdata())
                                            if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_set.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "channel"):
                                                self.channel = value
                                                self.channel.value_namespace = name_space
                                                self.channel.value_namespace_prefix = name_space_prefix
                                            if(value_path == "channel-spacing"):
                                                self.channel_spacing = value
                                                self.channel_spacing.value_namespace = name_space
                                                self.channel_spacing.value_namespace_prefix = name_space_prefix
                                            if(value_path == "grid"):
                                                self.grid = value
                                                self.grid.value_namespace = name_space
                                                self.grid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "identifier"):
                                                self.identifier = value
                                                self.identifier.value_namespace = name_space
                                                self.identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-set"):
                                                self.label_set = value
                                                self.label_set.value_namespace = name_space
                                                self.label_set.value_namespace_prefix = name_space_prefix


                                    class Otn(Entity):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-egress-label"

                                            self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                            self.tpn = YLeaf(YType.uint16, "tpn")

                                            self.bit_map = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_map_length",
                                                            "tpn") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                        class BitMap(Entity):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bit-map" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.bit_map:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bit_map_length.is_set or
                                                self.tpn.is_set)

                                        def has_operation(self):
                                            for c in self.bit_map:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_map_length.yfilter != YFilter.not_set or
                                                self.tpn.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "otn" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                            if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tpn.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bit-map"):
                                                for c in self.bit_map:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.bit_map.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-map-length"):
                                                self.bit_map_length = value
                                                self.bit_map_length.value_namespace = name_space
                                                self.bit_map_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tpn"):
                                                self.tpn = value
                                                self.tpn.value_namespace = name_space
                                                self.tpn.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_type.is_set or
                                            (self.otn is not None and self.otn.has_data()) or
                                            (self.wdm is not None and self.wdm.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_type.yfilter != YFilter.not_set or
                                            (self.otn is not None and self.otn.has_operation()) or
                                            (self.wdm is not None and self.wdm.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "resv-egress-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "otn"):
                                            if (self.otn is None):
                                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                self.otn.parent = self
                                                self._children_name_map["otn"] = "otn"
                                            return self.otn

                                        if (child_yang_name == "wdm"):
                                            if (self.wdm is None):
                                                self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                self.wdm.parent = self
                                                self._children_name_map["wdm"] = "wdm"
                                            return self.wdm

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "otn" or name == "wdm" or name == "label-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-type"):
                                            self.label_type = value
                                            self.label_type.value_namespace = name_space
                                            self.label_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                        (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                        (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                        (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                        (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                        (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                        (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "labels" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "path-egress-label"):
                                        if (self.path_egress_label is None):
                                            self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                            self.path_egress_label.parent = self
                                            self._children_name_map["path_egress_label"] = "path-egress-label"
                                        return self.path_egress_label

                                    if (child_yang_name == "path-ingress-label"):
                                        if (self.path_ingress_label is None):
                                            self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                            self.path_ingress_label.parent = self
                                            self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        return self.path_ingress_label

                                    if (child_yang_name == "resv-egress-label"):
                                        if (self.resv_egress_label is None):
                                            self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                            self.resv_egress_label.parent = self
                                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        return self.resv_egress_label

                                    if (child_yang_name == "resv-ingress-label"):
                                        if (self.resv_ingress_label is None):
                                            self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                            self.resv_ingress_label.parent = self
                                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        return self.resv_ingress_label

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.cross_connect_id.is_set or
                                    self.gpid.is_set or
                                    self.incoming_controller.is_set or
                                    self.incoming_controller_ifhandle.is_set or
                                    self.incoming_controller_state.is_set or
                                    self.incoming_sub_controller.is_set or
                                    self.incoming_sub_controller_ifhandle.is_set or
                                    self.incoming_sub_controller_state.is_set or
                                    self.is_connected.is_set or
                                    self.outgoing_controller.is_set or
                                    self.outgoing_controller_ifhandle.is_set or
                                    self.outgoing_controller_state.is_set or
                                    self.outgoing_sub_controller.is_set or
                                    self.outgoing_sub_controller_ifhandle.is_set or
                                    self.outgoing_sub_controller_state.is_set or
                                    self.uptime.is_set or
                                    (self.bandwidth is not None and self.bandwidth.has_data()) or
                                    (self.labels is not None and self.labels.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.cross_connect_id.yfilter != YFilter.not_set or
                                    self.gpid.yfilter != YFilter.not_set or
                                    self.incoming_controller.yfilter != YFilter.not_set or
                                    self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.incoming_controller_state.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                    self.is_connected.yfilter != YFilter.not_set or
                                    self.outgoing_controller.yfilter != YFilter.not_set or
                                    self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.outgoing_controller_state.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                    self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                    self.uptime.yfilter != YFilter.not_set or
                                    (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                    (self.labels is not None and self.labels.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.gpid.get_name_leafdata())
                                if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_connected.get_name_leafdata())
                                if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bandwidth"):
                                    if (self.bandwidth is None):
                                        self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Bandwidth()
                                        self.bandwidth.parent = self
                                        self._children_name_map["bandwidth"] = "bandwidth"
                                    return self.bandwidth

                                if (child_yang_name == "labels"):
                                    if (self.labels is None):
                                        self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn.Labels()
                                        self.labels.parent = self
                                        self._children_name_map["labels"] = "labels"
                                    return self.labels

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "cross-connect-id"):
                                    self.cross_connect_id = value
                                    self.cross_connect_id.value_namespace = name_space
                                    self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "gpid"):
                                    self.gpid = value
                                    self.gpid.value_namespace = name_space
                                    self.gpid.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller"):
                                    self.incoming_controller = value
                                    self.incoming_controller.value_namespace = name_space
                                    self.incoming_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller-ifhandle"):
                                    self.incoming_controller_ifhandle = value
                                    self.incoming_controller_ifhandle.value_namespace = name_space
                                    self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-controller-state"):
                                    self.incoming_controller_state = value
                                    self.incoming_controller_state.value_namespace = name_space
                                    self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller"):
                                    self.incoming_sub_controller = value
                                    self.incoming_sub_controller.value_namespace = name_space
                                    self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller-ifhandle"):
                                    self.incoming_sub_controller_ifhandle = value
                                    self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                    self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "incoming-sub-controller-state"):
                                    self.incoming_sub_controller_state = value
                                    self.incoming_sub_controller_state.value_namespace = name_space
                                    self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-connected"):
                                    self.is_connected = value
                                    self.is_connected.value_namespace = name_space
                                    self.is_connected.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller"):
                                    self.outgoing_controller = value
                                    self.outgoing_controller.value_namespace = name_space
                                    self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller-ifhandle"):
                                    self.outgoing_controller_ifhandle = value
                                    self.outgoing_controller_ifhandle.value_namespace = name_space
                                    self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-controller-state"):
                                    self.outgoing_controller_state = value
                                    self.outgoing_controller_state.value_namespace = name_space
                                    self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller"):
                                    self.outgoing_sub_controller = value
                                    self.outgoing_sub_controller.value_namespace = name_space
                                    self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller-ifhandle"):
                                    self.outgoing_sub_controller_ifhandle = value
                                    self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                    self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                if(value_path == "outgoing-sub-controller-state"):
                                    self.outgoing_sub_controller_state = value
                                    self.outgoing_sub_controller_state.value_namespace = name_space
                                    self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "uptime"):
                                    self.uptime = value
                                    self.uptime.value_namespace = name_space
                                    self.uptime.value_namespace_prefix = name_space_prefix


                        class Aps(Entity):
                            """
                            APS Info for OTN S2L
                            
                            .. attribute:: protection_info
                            
                            	Protection Info
                            	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps, self).__init__()

                                self.yang_name = "aps"
                                self.yang_parent_name = "otn-s2l"

                                self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo()
                                self.protection_info.parent = self
                                self._children_name_map["protection_info"] = "protection-info"
                                self._children_yang_names.add("protection-info")


                            class ProtectionInfo(Entity):
                                """
                                Protection Info
                                
                                .. attribute:: ho_timeout
                                
                                	Hold\-Off timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_hopresent
                                
                                	Is Hold\-Off timeout present
                                	**type**\:  bool
                                
                                .. attribute:: is_snc_mode_present
                                
                                	Is SNC mode present
                                	**type**\:  bool
                                
                                .. attribute:: is_wtr_present
                                
                                	Is Wait\-to\-Restore timeout present
                                	**type**\:  bool
                                
                                .. attribute:: nbit
                                
                                	Notification bit 
                                	**type**\:  bool
                                
                                .. attribute:: obit
                                
                                	Operational bit
                                	**type**\:  bool
                                
                                .. attribute:: path_prot_profile_type
                                
                                	Path protection profile type
                                	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                
                                .. attribute:: pbit
                                
                                	Protecting bit
                                	**type**\:  bool
                                
                                .. attribute:: protect_type
                                
                                	LSP Protect Type
                                	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                
                                .. attribute:: sbit
                                
                                	Secondary bit
                                	**type**\:  bool
                                
                                .. attribute:: snc_mode
                                
                                	SNC mode
                                	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                
                                .. attribute:: tcm_id
                                
                                	TCM ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wtr_timeout
                                
                                	Wait\-to\-Restore timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                    self.yang_name = "protection-info"
                                    self.yang_parent_name = "aps"

                                    self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                    self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                    self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                    self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                    self.nbit = YLeaf(YType.boolean, "nbit")

                                    self.obit = YLeaf(YType.boolean, "obit")

                                    self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                    self.pbit = YLeaf(YType.boolean, "pbit")

                                    self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                    self.sbit = YLeaf(YType.boolean, "sbit")

                                    self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                    self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                    self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ho_timeout",
                                                    "is_hopresent",
                                                    "is_snc_mode_present",
                                                    "is_wtr_present",
                                                    "nbit",
                                                    "obit",
                                                    "path_prot_profile_type",
                                                    "pbit",
                                                    "protect_type",
                                                    "sbit",
                                                    "snc_mode",
                                                    "tcm_id",
                                                    "wtr_timeout") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ho_timeout.is_set or
                                        self.is_hopresent.is_set or
                                        self.is_snc_mode_present.is_set or
                                        self.is_wtr_present.is_set or
                                        self.nbit.is_set or
                                        self.obit.is_set or
                                        self.path_prot_profile_type.is_set or
                                        self.pbit.is_set or
                                        self.protect_type.is_set or
                                        self.sbit.is_set or
                                        self.snc_mode.is_set or
                                        self.tcm_id.is_set or
                                        self.wtr_timeout.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ho_timeout.yfilter != YFilter.not_set or
                                        self.is_hopresent.yfilter != YFilter.not_set or
                                        self.is_snc_mode_present.yfilter != YFilter.not_set or
                                        self.is_wtr_present.yfilter != YFilter.not_set or
                                        self.nbit.yfilter != YFilter.not_set or
                                        self.obit.yfilter != YFilter.not_set or
                                        self.path_prot_profile_type.yfilter != YFilter.not_set or
                                        self.pbit.yfilter != YFilter.not_set or
                                        self.protect_type.yfilter != YFilter.not_set or
                                        self.sbit.yfilter != YFilter.not_set or
                                        self.snc_mode.yfilter != YFilter.not_set or
                                        self.tcm_id.yfilter != YFilter.not_set or
                                        self.wtr_timeout.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protection-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                    if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                    if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                    if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                    if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nbit.get_name_leafdata())
                                    if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.obit.get_name_leafdata())
                                    if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                    if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.pbit.get_name_leafdata())
                                    if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protect_type.get_name_leafdata())
                                    if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sbit.get_name_leafdata())
                                    if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                    if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                    if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ho-timeout"):
                                        self.ho_timeout = value
                                        self.ho_timeout.value_namespace = name_space
                                        self.ho_timeout.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-hopresent"):
                                        self.is_hopresent = value
                                        self.is_hopresent.value_namespace = name_space
                                        self.is_hopresent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-snc-mode-present"):
                                        self.is_snc_mode_present = value
                                        self.is_snc_mode_present.value_namespace = name_space
                                        self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-wtr-present"):
                                        self.is_wtr_present = value
                                        self.is_wtr_present.value_namespace = name_space
                                        self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nbit"):
                                        self.nbit = value
                                        self.nbit.value_namespace = name_space
                                        self.nbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "obit"):
                                        self.obit = value
                                        self.obit.value_namespace = name_space
                                        self.obit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-prot-profile-type"):
                                        self.path_prot_profile_type = value
                                        self.path_prot_profile_type.value_namespace = name_space
                                        self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "pbit"):
                                        self.pbit = value
                                        self.pbit.value_namespace = name_space
                                        self.pbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protect-type"):
                                        self.protect_type = value
                                        self.protect_type.value_namespace = name_space
                                        self.protect_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sbit"):
                                        self.sbit = value
                                        self.sbit.value_namespace = name_space
                                        self.sbit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "snc-mode"):
                                        self.snc_mode = value
                                        self.snc_mode.value_namespace = name_space
                                        self.snc_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tcm-id"):
                                        self.tcm_id = value
                                        self.tcm_id.value_namespace = name_space
                                        self.tcm_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wtr-timeout"):
                                        self.wtr_timeout = value
                                        self.wtr_timeout.value_namespace = name_space
                                        self.wtr_timeout.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.protection_info is not None and self.protection_info.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.protection_info is not None and self.protection_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "aps" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "protection-info"):
                                    if (self.protection_info is None):
                                        self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps.ProtectionInfo()
                                        self.protection_info.parent = self
                                        self._children_name_map["protection_info"] = "protection-info"
                                    return self.protection_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "protection-info"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.aps is not None and self.aps.has_data()) or
                                (self.otn is not None and self.otn.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.aps is not None and self.aps.has_operation()) or
                                (self.otn is not None and self.otn.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn-s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "aps"):
                                if (self.aps is None):
                                    self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Aps()
                                    self.aps.parent = self
                                    self._children_name_map["aps"] = "aps"
                                return self.aps

                            if (child_yang_name == "otn"):
                                if (self.otn is None):
                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                return self.otn

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "aps" or name == "otn"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HeadEndBfdInfo(Entity):
                        """
                        The Head\-end BFD info
                        
                        .. attribute:: bfd_reverse_path_label
                        
                        	BFD reverse path labels
                        	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                        
                        .. attribute:: bfd_reverse_path_stale
                        
                        	The BFD reverse path is stale compared to configuration
                        	**type**\:  bool
                        
                        .. attribute:: creation_time
                        
                        	Time in seconds since the BFD session created
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: deletion_history
                        
                        	BFD Session Deletion History
                        	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory>`
                        
                        .. attribute:: is_redundant
                        
                        	sBFD session is redundant
                        	**type**\:  bool
                        
                        .. attribute:: lspbfd_type
                        
                        	LSP BFD type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__init__()

                            self.yang_name = "head-end-bfd-info"
                            self.yang_parent_name = "s2l"

                            self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                            self.creation_time = YLeaf(YType.uint32, "creation-time")

                            self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                            self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                            self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory()
                            self.deletion_history.parent = self
                            self._children_name_map["deletion_history"] = "deletion-history"
                            self._children_yang_names.add("deletion-history")

                            self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._children_yang_names.add("session-info")

                            self.bfd_reverse_path_label = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_reverse_path_stale",
                                            "creation_time",
                                            "is_redundant",
                                            "lspbfd_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                        class SessionInfo(Entity):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("state",
                                                "state_change_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.state.is_set or
                                    self.state_change_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_change_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "session-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "state" or name == "state-change-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-change-time"):
                                    self.state_change_time = value
                                    self.state_change_time.value_namespace = name_space
                                    self.state_change_time.value_namespace_prefix = name_space_prefix


                        class DeletionHistory(Entity):
                            """
                            BFD Session Deletion History
                            
                            .. attribute:: deletion_diagnostic_code
                            
                            	Diagnostic Code for the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: deletion_reason
                            
                            	Reason for the BFD session get deleted
                            	**type**\:  str
                            
                            .. attribute:: deletion_time
                            
                            	Time stamp of the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID of the BFD session get deleted
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                self.yang_name = "deletion-history"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("deletion_diagnostic_code",
                                                "deletion_reason",
                                                "deletion_time",
                                                "lsp_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.deletion_diagnostic_code.is_set or
                                    self.deletion_reason.is_set or
                                    self.deletion_time.is_set or
                                    self.lsp_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                    self.deletion_reason.yfilter != YFilter.not_set or
                                    self.deletion_time.yfilter != YFilter.not_set or
                                    self.lsp_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "deletion-history" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "deletion-diagnostic-code"):
                                    self.deletion_diagnostic_code = value
                                    self.deletion_diagnostic_code.value_namespace = name_space
                                    self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "deletion-reason"):
                                    self.deletion_reason = value
                                    self.deletion_reason.value_namespace = name_space
                                    self.deletion_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "deletion-time"):
                                    self.deletion_time = value
                                    self.deletion_time.value_namespace = name_space
                                    self.deletion_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-id"):
                                    self.lsp_id = value
                                    self.lsp_id.value_namespace = name_space
                                    self.lsp_id.value_namespace_prefix = name_space_prefix


                        class BfdReversePathLabel(Entity):
                            """
                            BFD reverse path labels
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                self.yang_name = "bfd-reverse-path-label"
                                self.yang_parent_name = "head-end-bfd-info"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bfd-reverse-path-label" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.bfd_reverse_path_label:
                                if (c.has_data()):
                                    return True
                            return (
                                self.bfd_reverse_path_stale.is_set or
                                self.creation_time.is_set or
                                self.is_redundant.is_set or
                                self.lspbfd_type.is_set or
                                (self.deletion_history is not None and self.deletion_history.has_data()) or
                                (self.session_info is not None and self.session_info.has_data()))

                        def has_operation(self):
                            for c in self.bfd_reverse_path_label:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.is_redundant.yfilter != YFilter.not_set or
                                self.lspbfd_type.yfilter != YFilter.not_set or
                                (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                (self.session_info is not None and self.session_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "head-end-bfd-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_redundant.get_name_leafdata())
                            if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bfd-reverse-path-label"):
                                for c in self.bfd_reverse_path_label:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.bfd_reverse_path_label.append(c)
                                return c

                            if (child_yang_name == "deletion-history"):
                                if (self.deletion_history is None):
                                    self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.DeletionHistory()
                                    self.deletion_history.parent = self
                                    self._children_name_map["deletion_history"] = "deletion-history"
                                return self.deletion_history

                            if (child_yang_name == "session-info"):
                                if (self.session_info is None):
                                    self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo.SessionInfo()
                                    self.session_info.parent = self
                                    self._children_name_map["session_info"] = "session-info"
                                return self.session_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-reverse-path-stale"):
                                self.bfd_reverse_path_stale = value
                                self.bfd_reverse_path_stale.value_namespace = name_space
                                self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-redundant"):
                                self.is_redundant = value
                                self.is_redundant.value_namespace = name_space
                                self.is_redundant.value_namespace_prefix = name_space_prefix
                            if(value_path == "lspbfd-type"):
                                self.lspbfd_type = value
                                self.lspbfd_type.value_namespace = name_space
                                self.lspbfd_type.value_namespace_prefix = name_space_prefix


                    class TailEndBfdInfo(Entity):
                        """
                        The Tail\-end BFD info
                        
                        .. attribute:: failure_diagnostic_code
                        
                        	BFD session failure diagnostic code
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: failure_reason
                        
                        	BFD session failure reason
                        	**type**\:  str
                        
                        .. attribute:: local_discriminator
                        
                        	BFD Local Discriminator
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in mini second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: remote_discriminator
                        
                        	BFD Remote Discrminator
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__init__()

                            self.yang_name = "tail-end-bfd-info"
                            self.yang_parent_name = "s2l"

                            self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                            self.failure_reason = YLeaf(YType.str, "failure-reason")

                            self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                            self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._children_yang_names.add("session-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("failure_diagnostic_code",
                                            "failure_reason",
                                            "local_discriminator",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "remote_discriminator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                        class SessionInfo(Entity):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "tail-end-bfd-info"

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("state",
                                                "state_change_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.state.is_set or
                                    self.state_change_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_change_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "session-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "state" or name == "state-change-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-change-time"):
                                    self.state_change_time = value
                                    self.state_change_time.value_namespace = name_space
                                    self.state_change_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.failure_diagnostic_code.is_set or
                                self.failure_reason.is_set or
                                self.local_discriminator.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.remote_discriminator.is_set or
                                (self.session_info is not None and self.session_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                self.failure_reason.yfilter != YFilter.not_set or
                                self.local_discriminator.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.remote_discriminator.yfilter != YFilter.not_set or
                                (self.session_info is not None and self.session_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tail-end-bfd-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                            if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.failure_reason.get_name_leafdata())
                            if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "session-info"):
                                if (self.session_info is None):
                                    self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo.SessionInfo()
                                    self.session_info.parent = self
                                    self._children_name_map["session_info"] = "session-info"
                                return self.session_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "failure-diagnostic-code"):
                                self.failure_diagnostic_code = value
                                self.failure_diagnostic_code.value_namespace = name_space
                                self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                            if(value_path == "failure-reason"):
                                self.failure_reason = value
                                self.failure_reason.value_namespace = name_space
                                self.failure_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-discriminator"):
                                self.local_discriminator = value
                                self.local_discriminator.value_namespace = name_space
                                self.local_discriminator.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-discriminator"):
                                self.remote_discriminator = value
                                self.remote_discriminator.value_namespace = name_space
                                self.remote_discriminator.value_namespace_prefix = name_space_prefix


                    class SrlgCollection(Entity):
                        """
                        SRLG\-collection data
                        
                        .. attribute:: discovered_srlg
                        
                        	Discovered SRLGs
                        	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg>`
                        
                        .. attribute:: srlg_collect_type
                        
                        	SRLG\-collection mechanism
                        	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__init__()

                            self.yang_name = "srlg-collection"
                            self.yang_parent_name = "s2l"

                            self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                            self.discovered_srlg = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("srlg_collect_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection, self).__setattr__(name, value)


                        class DiscoveredSrlg(Entity):
                            """
                            Discovered SRLGs
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                self.yang_name = "discovered-srlg"
                                self.yang_parent_name = "srlg-collection"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovered-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.discovered_srlg:
                                if (c.has_data()):
                                    return True
                            return self.srlg_collect_type.is_set

                        def has_operation(self):
                            for c in self.discovered_srlg:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.srlg_collect_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlg-collection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "discovered-srlg"):
                                for c in self.discovered_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection.DiscoveredSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.discovered_srlg.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "srlg-collect-type"):
                                self.srlg_collect_type = value
                                self.srlg_collect_type.value_namespace = name_space
                                self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "s2l"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "s2l"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLspFec(Entity):
                        """
                        Reverse Associated Bidir LSP FEC
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__init__()

                            self.yang_name = "reverse-lsp-fec"
                            self.yang_parent_name = "s2l"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "reverse-lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class ReverseTspec(Entity):
                        """
                        The Reverse T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__init__()

                            self.yang_name = "reverse-tspec"
                            self.yang_parent_name = "s2l"

                            self.average_rate = YLeaf(YType.uint64, "average-rate")

                            self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                            self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("average_rate",
                                            "maximum_burst",
                                            "peak_rate") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.average_rate.is_set or
                                self.maximum_burst.is_set or
                                self.peak_rate.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.average_rate.yfilter != YFilter.not_set or
                                self.maximum_burst.yfilter != YFilter.not_set or
                                self.peak_rate.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-tspec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.average_rate.get_name_leafdata())
                            if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                            if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.peak_rate.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "average-rate"):
                                self.average_rate = value
                                self.average_rate.value_namespace = name_space
                                self.average_rate.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-burst"):
                                self.maximum_burst = value
                                self.maximum_burst.value_namespace = name_space
                                self.maximum_burst.value_namespace_prefix = name_space_prefix
                            if(value_path == "peak-rate"):
                                self.peak_rate = value
                                self.peak_rate.value_namespace = name_space
                                self.peak_rate.value_namespace_prefix = name_space_prefix


                    class FlexInfo(Entity):
                        """
                        FlexLSP S2L Information
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "s2l"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class LspWrapInfo(Entity):
                        """
                        Lsp Wrap  Related information
                        
                        .. attribute:: lsp_wrap_protection_enable
                        
                        	LSP Wrap protection enabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_wrap_protection_label
                        
                        	LSP Wrap Merge Point Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: lsp_wrap_protection_state
                        
                        	LSP wrap protection state
                        	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                        
                        .. attribute:: reverse_egress_interface
                        
                        	Reverse Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_label
                        
                        	Reverse LSP label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__init__()

                            self.yang_name = "lsp-wrap-info"
                            self.yang_parent_name = "s2l"

                            self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                            self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                            self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                            self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                            self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_wrap_protection_enable",
                                            "lsp_wrap_protection_label",
                                            "lsp_wrap_protection_state",
                                            "reverse_egress_interface",
                                            "reverse_lsp_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_wrap_protection_enable.is_set or
                                self.lsp_wrap_protection_label.is_set or
                                self.lsp_wrap_protection_state.is_set or
                                self.reverse_egress_interface.is_set or
                                self.reverse_lsp_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                self.reverse_egress_interface.yfilter != YFilter.not_set or
                                self.reverse_lsp_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-wrap-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                            if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                            if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                            if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                            if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-wrap-protection-enable"):
                                self.lsp_wrap_protection_enable = value
                                self.lsp_wrap_protection_enable.value_namespace = name_space
                                self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-wrap-protection-label"):
                                self.lsp_wrap_protection_label = value
                                self.lsp_wrap_protection_label.value_namespace = name_space
                                self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-wrap-protection-state"):
                                self.lsp_wrap_protection_state = value
                                self.lsp_wrap_protection_state.value_namespace = name_space
                                self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-egress-interface"):
                                self.reverse_egress_interface = value
                                self.reverse_egress_interface.value_namespace = name_space
                                self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-label"):
                                self.reverse_lsp_label = value
                                self.reverse_lsp_label.value_namespace = name_space
                                self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        S2L Diversity Information
                        
                        .. attribute:: diversity_type
                        
                        	S2L path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "s2l"

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.diversity_type.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class S2LReverseLspSubObj(Entity):
                        """
                        Reverse LSP Sub Objects
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__init__()

                            self.yang_name = "s2l-reverse-lsp-sub-obj"
                            self.yang_parent_name = "s2l"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class SharedRiskLinkGroup(Entity):
                        """
                        The S2L's excluded srlg groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "s2l"

                            self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                            self.srlg_name = YLeaf(YType.str, "srlg-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("shared_risk_group",
                                            "srlg_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.shared_risk_group.is_set or
                                self.srlg_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.shared_risk_group.yfilter != YFilter.not_set or
                                self.srlg_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-risk-link-group" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                            if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.srlg_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "shared-risk-group" or name == "srlg-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "shared-risk-group"):
                                self.shared_risk_group = value
                                self.shared_risk_group.value_namespace = name_space
                                self.shared_risk_group.value_namespace_prefix = name_space_prefix
                            if(value_path == "srlg-name"):
                                self.srlg_name = value
                                self.srlg_name.value_namespace = name_space
                                self.srlg_name.value_namespace_prefix = name_space_prefix


                    class OutEro(Entity):
                        """
                        Outgoing ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__init__()

                            self.yang_name = "out-ero"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "out-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "out-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "out-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class InEro(Entity):
                        """
                        Incoming ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__init__()

                            self.yang_name = "in-ero"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "in-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "in-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "in-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class PathRro(Entity):
                        """
                        Path RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject>`
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject>`
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject>`
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__init__()

                            self.yang_name = "path-rro"
                            self.yang_parent_name = "s2l"

                            self.rro_type = YLeaf(YType.enumeration, "rro-type")

                            self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                            self._children_yang_names.add("ipv4rro-sub-object")

                            self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                            self._children_yang_names.add("label-rro-sub-object")

                            self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._children_yang_names.add("srlg-rro-sub-object")

                            self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                            self._children_yang_names.add("unnumbered-rro-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rro_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro, self).__setattr__(name, value)


                        class Ipv4RroSubObject(Entity):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags>`
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.rro_address = YLeaf(YType.str, "rro-address")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.rro_address.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_address.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "rro-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-address"):
                                    self.rro_address = value
                                    self.rro_address.value_namespace = name_space
                                    self.rro_address.value_namespace_prefix = name_space_prefix


                        class LabelRroSubObject(Entity):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags>`
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\:  bool
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                self.label = YLeaf(YType.uint32, "label")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                                self.variable_length_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_label_variable_length",
                                                "label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_global_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.is_global_label.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_global_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-global-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-global-label"):
                                        self.is_global_label = value
                                        self.is_global_label.value_namespace = name_space
                                        self.is_global_label.value_namespace_prefix = name_space_prefix


                            class VariableLengthLabel(Entity):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "variable-length-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.variable_length_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_label_variable_length.is_set or
                                    self.label.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                for c in self.variable_length_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_label_variable_length.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                if (child_yang_name == "variable-length-label"):
                                    for c in self.variable_length_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.variable_length_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-label-variable-length"):
                                    self.is_label_variable_length = value
                                    self.is_label_variable_length.value_namespace = name_space
                                    self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix


                        class UnnumberedRroSubObject(Entity):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_id = YLeaf(YType.uint32, "interface-id")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_address",
                                                "interface_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_address.is_set or
                                    self.interface_id.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_id.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-id"):
                                    self.interface_id = value
                                    self.interface_id.value_namespace = name_space
                                    self.interface_id.value_namespace_prefix = name_space_prefix


                        class SrlgRroSubObject(Entity):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "path-rro"

                                self.srl_gs = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                            class SrlGs(Entity):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srl-gs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.srl_gs:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.srl_gs:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "srl-gs"):
                                    for c in self.srl_gs:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.srl_gs.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "srl-gs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.rro_type.is_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rro_type.yfilter != YFilter.not_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-rro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rro_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4rro-sub-object"):
                                if (self.ipv4rro_sub_object is None):
                                    self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.Ipv4RroSubObject()
                                    self.ipv4rro_sub_object.parent = self
                                    self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                return self.ipv4rro_sub_object

                            if (child_yang_name == "label-rro-sub-object"):
                                if (self.label_rro_sub_object is None):
                                    self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.LabelRroSubObject()
                                    self.label_rro_sub_object.parent = self
                                    self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                return self.label_rro_sub_object

                            if (child_yang_name == "srlg-rro-sub-object"):
                                if (self.srlg_rro_sub_object is None):
                                    self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.SrlgRroSubObject()
                                    self.srlg_rro_sub_object.parent = self
                                    self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                return self.srlg_rro_sub_object

                            if (child_yang_name == "unnumbered-rro-sub-object"):
                                if (self.unnumbered_rro_sub_object is None):
                                    self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro.UnnumberedRroSubObject()
                                    self.unnumbered_rro_sub_object.parent = self
                                    self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                return self.unnumbered_rro_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rro-type"):
                                self.rro_type = value
                                self.rro_type.value_namespace = name_space
                                self.rro_type.value_namespace_prefix = name_space_prefix


                    class ResvRro(Entity):
                        """
                        Resv RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject>`
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject>`
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject>`
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__init__()

                            self.yang_name = "resv-rro"
                            self.yang_parent_name = "s2l"

                            self.rro_type = YLeaf(YType.enumeration, "rro-type")

                            self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                            self._children_yang_names.add("ipv4rro-sub-object")

                            self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                            self._children_yang_names.add("label-rro-sub-object")

                            self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._children_yang_names.add("srlg-rro-sub-object")

                            self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                            self._children_yang_names.add("unnumbered-rro-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("rro_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro, self).__setattr__(name, value)


                        class Ipv4RroSubObject(Entity):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.rro_address = YLeaf(YType.str, "rro-address")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.rro_address.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_address.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "rro-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-address"):
                                    self.rro_address = value
                                    self.rro_address.value_namespace = name_space
                                    self.rro_address.value_namespace_prefix = name_space_prefix


                        class LabelRroSubObject(Entity):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags>`
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\:  bool
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                self.label = YLeaf(YType.uint32, "label")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                                self.variable_length_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_label_variable_length",
                                                "label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_global_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.is_global_label.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_global_label.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-global-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-global-label"):
                                        self.is_global_label = value
                                        self.is_global_label.value_namespace = name_space
                                        self.is_global_label.value_namespace_prefix = name_space_prefix


                            class VariableLengthLabel(Entity):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "variable-length-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.variable_length_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_label_variable_length.is_set or
                                    self.label.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                for c in self.variable_length_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_label_variable_length.yfilter != YFilter.not_set or
                                    self.label.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "label-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                if (child_yang_name == "variable-length-label"):
                                    for c in self.variable_length_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.variable_length_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-label-variable-length"):
                                    self.is_label_variable_length = value
                                    self.is_label_variable_length.value_namespace = name_space
                                    self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "label"):
                                    self.label = value
                                    self.label.value_namespace = name_space
                                    self.label.value_namespace_prefix = name_space_prefix


                        class UnnumberedRroSubObject(Entity):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.interface_address = YLeaf(YType.str, "interface-address")

                                self.interface_id = YLeaf(YType.uint32, "interface-id")

                                self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._children_yang_names.add("flags")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_address",
                                                "interface_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                            class Flags(Entity):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\:  bool
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\:  bool
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"

                                    self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                    self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                    self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                    self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                    self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_bandwidth_protected",
                                                    "is_node_id",
                                                    "is_node_protection_available",
                                                    "is_protection_available",
                                                    "is_protection_in_use") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_bandwidth_protected.is_set or
                                        self.is_node_id.is_set or
                                        self.is_node_protection_available.is_set or
                                        self.is_protection_available.is_set or
                                        self.is_protection_in_use.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                        self.is_node_id.yfilter != YFilter.not_set or
                                        self.is_node_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_available.yfilter != YFilter.not_set or
                                        self.is_protection_in_use.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flags" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                    if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                    if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                    if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                    if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-bandwidth-protected"):
                                        self.is_bandwidth_protected = value
                                        self.is_bandwidth_protected.value_namespace = name_space
                                        self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-id"):
                                        self.is_node_id = value
                                        self.is_node_id.value_namespace = name_space
                                        self.is_node_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-node-protection-available"):
                                        self.is_node_protection_available = value
                                        self.is_node_protection_available.value_namespace = name_space
                                        self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-available"):
                                        self.is_protection_available = value
                                        self.is_protection_available.value_namespace = name_space
                                        self.is_protection_available.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-protection-in-use"):
                                        self.is_protection_in_use = value
                                        self.is_protection_in_use.value_namespace = name_space
                                        self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.interface_address.is_set or
                                    self.interface_id.is_set or
                                    (self.flags is not None and self.flags.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_address.yfilter != YFilter.not_set or
                                    self.interface_id.yfilter != YFilter.not_set or
                                    (self.flags is not None and self.flags.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_address.get_name_leafdata())
                                if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flags"):
                                    if (self.flags is None):
                                        self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                        self.flags.parent = self
                                        self._children_name_map["flags"] = "flags"
                                    return self.flags

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-address"):
                                    self.interface_address = value
                                    self.interface_address.value_namespace = name_space
                                    self.interface_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-id"):
                                    self.interface_id = value
                                    self.interface_id.value_namespace = name_space
                                    self.interface_id.value_namespace_prefix = name_space_prefix


                        class SrlgRroSubObject(Entity):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "resv-rro"

                                self.srl_gs = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                            class SrlGs(Entity):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srl-gs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.srl_gs:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.srl_gs:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-rro-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "srl-gs"):
                                    for c in self.srl_gs:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.srl_gs.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "srl-gs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.rro_type.is_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.rro_type.yfilter != YFilter.not_set or
                                (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "resv-rro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rro_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4rro-sub-object"):
                                if (self.ipv4rro_sub_object is None):
                                    self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.Ipv4RroSubObject()
                                    self.ipv4rro_sub_object.parent = self
                                    self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                return self.ipv4rro_sub_object

                            if (child_yang_name == "label-rro-sub-object"):
                                if (self.label_rro_sub_object is None):
                                    self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.LabelRroSubObject()
                                    self.label_rro_sub_object.parent = self
                                    self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                return self.label_rro_sub_object

                            if (child_yang_name == "srlg-rro-sub-object"):
                                if (self.srlg_rro_sub_object is None):
                                    self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.SrlgRroSubObject()
                                    self.srlg_rro_sub_object.parent = self
                                    self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                return self.srlg_rro_sub_object

                            if (child_yang_name == "unnumbered-rro-sub-object"):
                                if (self.unnumbered_rro_sub_object is None):
                                    self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro.UnnumberedRroSubObject()
                                    self.unnumbered_rro_sub_object.parent = self
                                    self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                return self.unnumbered_rro_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "rro-type"):
                                self.rro_type = value
                                self.rro_type.value_namespace = name_space
                                self.rro_type.value_namespace_prefix = name_space_prefix


                    class PathAffinityArray(Entity):
                        """
                        Tunnel's Path hops with affinity
                        
                        .. attribute:: hop_address
                        
                        	Hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: hop_affinity
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hop_extended_affinity
                        
                        	Hop affinity
                        	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__init__()

                            self.yang_name = "path-affinity-array"
                            self.yang_parent_name = "s2l"

                            self.hop_address = YLeaf(YType.str, "hop-address")

                            self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                            self.hop_extended_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("hop_address",
                                            "hop_affinity") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray, self).__setattr__(name, value)


                        class HopExtendedAffinity(Entity):
                            """
                            Hop affinity
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                self.yang_name = "hop-extended-affinity"
                                self.yang_parent_name = "path-affinity-array"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "hop-extended-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.hop_extended_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.hop_address.is_set or
                                self.hop_affinity.is_set)

                        def has_operation(self):
                            for c in self.hop_extended_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.hop_address.yfilter != YFilter.not_set or
                                self.hop_affinity.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-affinity-array" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_address.get_name_leafdata())
                            if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "hop-extended-affinity"):
                                for c in self.hop_extended_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray.HopExtendedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.hop_extended_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "hop-address"):
                                self.hop_address = value
                                self.hop_address.value_namespace = name_space
                                self.hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "hop-affinity"):
                                self.hop_affinity = value
                                self.hop_affinity.value_namespace = name_space
                                self.hop_affinity.value_namespace_prefix = name_space_prefix


                    class ReverseEroIn(Entity):
                        """
                         Reverse Incoming ERO for this S2L
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__init__()

                            self.yang_name = "reverse-ero-in"
                            self.yang_parent_name = "s2l"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-in" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class S2LSegmentRoutingPath(Entity):
                        """
                        Segment\-Routing S2L path info
                        
                        .. attribute:: has_entropy_label
                        
                        	Hop has EL specified
                        	**type**\:  bool
                        
                        .. attribute:: has_ip_addresses
                        
                        	Node has IP addresses specified
                        	**type**\:  bool
                        
                        .. attribute:: has_mpls_label
                        
                        	Hop has MPLS label specified
                        	**type**\:  bool
                        
                        .. attribute:: local_addr
                        
                        	Local IP address of adjacency or Node ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: mpls_label_value
                        
                        	The MPLS label value
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remote_addr
                        
                        	Remote IP address of adjacency
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: sid_type
                        
                        	Type of the SID
                        	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__init__()

                            self.yang_name = "s2l-segment-routing-path"
                            self.yang_parent_name = "s2l"

                            self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                            self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                            self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                            self.local_addr = YLeaf(YType.str, "local-addr")

                            self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                            self.remote_addr = YLeaf(YType.str, "remote-addr")

                            self.sid_type = YLeaf(YType.enumeration, "sid-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("has_entropy_label",
                                            "has_ip_addresses",
                                            "has_mpls_label",
                                            "local_addr",
                                            "mpls_label_value",
                                            "remote_addr",
                                            "sid_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.has_entropy_label.is_set or
                                self.has_ip_addresses.is_set or
                                self.has_mpls_label.is_set or
                                self.local_addr.is_set or
                                self.mpls_label_value.is_set or
                                self.remote_addr.is_set or
                                self.sid_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.has_entropy_label.yfilter != YFilter.not_set or
                                self.has_ip_addresses.yfilter != YFilter.not_set or
                                self.has_mpls_label.yfilter != YFilter.not_set or
                                self.local_addr.yfilter != YFilter.not_set or
                                self.mpls_label_value.yfilter != YFilter.not_set or
                                self.remote_addr.yfilter != YFilter.not_set or
                                self.sid_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-segment-routing-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                            if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                            if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                            if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_addr.get_name_leafdata())
                            if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                            if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_addr.get_name_leafdata())
                            if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sid_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "has-entropy-label"):
                                self.has_entropy_label = value
                                self.has_entropy_label.value_namespace = name_space
                                self.has_entropy_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-ip-addresses"):
                                self.has_ip_addresses = value
                                self.has_ip_addresses.value_namespace = name_space
                                self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-mpls-label"):
                                self.has_mpls_label = value
                                self.has_mpls_label.value_namespace = name_space
                                self.has_mpls_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-addr"):
                                self.local_addr = value
                                self.local_addr.value_namespace = name_space
                                self.local_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label-value"):
                                self.mpls_label_value = value
                                self.mpls_label_value.value_namespace = name_space
                                self.mpls_label_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-addr"):
                                self.remote_addr = value
                                self.remote_addr.value_namespace = name_space
                                self.remote_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "sid-type"):
                                self.sid_type = value
                                self.sid_type.value_namespace = name_space
                                self.sid_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.in_ero:
                            if (c.has_data()):
                                return True
                        for c in self.out_ero:
                            if (c.has_data()):
                                return True
                        for c in self.path_affinity_array:
                            if (c.has_data()):
                                return True
                        for c in self.path_rro:
                            if (c.has_data()):
                                return True
                        for c in self.resv_rro:
                            if (c.has_data()):
                                return True
                        for c in self.reverse_ero_in:
                            if (c.has_data()):
                                return True
                        for c in self.s2l_reverse_lsp_sub_obj:
                            if (c.has_data()):
                                return True
                        for c in self.s2l_segment_routing_path:
                            if (c.has_data()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_data()):
                                return True
                        return (
                            self.abr_auto_discovered.is_set or
                            self.backup_tunnel_interface.is_set or
                            self.downstream_router_id.is_set or
                            self.egress_interface.is_set or
                            self.egress_interface_brief.is_set or
                            self.egress_interface_state.is_set or
                            self.expanded_ero_affinity_bits.is_set or
                            self.expanded_ero_affinity_mask.is_set or
                            self.expanded_ero_area_id.is_set or
                            self.expanded_ero_metric.is_set or
                            self.expanded_ero_metric_type.is_set or
                            self.frr_out_tunnel_interface.is_set or
                            self.incoming_address.is_set or
                            self.ingress_interface.is_set or
                            self.ingress_interface_brief.is_set or
                            self.ingress_interface_state.is_set or
                            self.is_bandwidth_protect.is_set or
                            self.is_expanded_ero.is_set or
                            self.is_frr_enabled.is_set or
                            self.is_node_protected.is_set or
                            self.is_optical.is_set or
                            self.local_router_id.is_set or
                            self.next_hop_address.is_set or
                            self.node_hop_count.is_set or
                            self.outbound_frr_state.is_set or
                            self.path_reeval_query_mid.is_set or
                            self.path_rro_enabled.is_set or
                            self.path_using_strict_spf.is_set or
                            self.pcalc_area.is_set or
                            self.previous_hop_address.is_set or
                            self.reverse_lsp_connected.is_set or
                            self.reverse_lsp_name.is_set or
                            self.reverse_lsp_present.is_set or
                            self.reverse_weight.is_set or
                            self.role.is_set or
                            self.s2l_local_label.is_set or
                            self.s2l_out_label.is_set or
                            self.s2l_reverse_ero_obj_present.is_set or
                            self.s2l_reverse_tspec_obj_present.is_set or
                            self.signalling_status.is_set or
                            self.time_since_last_preferred_path_exists_send_mid.is_set or
                            self.time_since_last_preferred_tree_exists_send_mid.is_set or
                            self.time_since_last_query_received_mid.is_set or
                            self.upstream_router_id.is_set or
                            self.uptime.is_set or
                            self.weight.is_set or
                            (self.active_path_option is not None and self.active_path_option.has_data()) or
                            (self.association is not None and self.association.has_data()) or
                            (self.diversity_info is not None and self.diversity_info.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.fspec is not None and self.fspec.has_data()) or
                            (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                            (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                            (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                            (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                            (self.in_xro is not None and self.in_xro.has_data()) or
                            (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                            (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                            (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                            (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                            (self.out_xro is not None and self.out_xro.has_data()) or
                            (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                            (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                            (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                            (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                            (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                            (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                            (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                            (self.tspec is not None and self.tspec.has_data()))

                    def has_operation(self):
                        for c in self.in_ero:
                            if (c.has_operation()):
                                return True
                        for c in self.out_ero:
                            if (c.has_operation()):
                                return True
                        for c in self.path_affinity_array:
                            if (c.has_operation()):
                                return True
                        for c in self.path_rro:
                            if (c.has_operation()):
                                return True
                        for c in self.resv_rro:
                            if (c.has_operation()):
                                return True
                        for c in self.reverse_ero_in:
                            if (c.has_operation()):
                                return True
                        for c in self.s2l_reverse_lsp_sub_obj:
                            if (c.has_operation()):
                                return True
                        for c in self.s2l_segment_routing_path:
                            if (c.has_operation()):
                                return True
                        for c in self.shared_risk_link_group:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.abr_auto_discovered.yfilter != YFilter.not_set or
                            self.backup_tunnel_interface.yfilter != YFilter.not_set or
                            self.downstream_router_id.yfilter != YFilter.not_set or
                            self.egress_interface.yfilter != YFilter.not_set or
                            self.egress_interface_brief.yfilter != YFilter.not_set or
                            self.egress_interface_state.yfilter != YFilter.not_set or
                            self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                            self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                            self.expanded_ero_area_id.yfilter != YFilter.not_set or
                            self.expanded_ero_metric.yfilter != YFilter.not_set or
                            self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                            self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                            self.incoming_address.yfilter != YFilter.not_set or
                            self.ingress_interface.yfilter != YFilter.not_set or
                            self.ingress_interface_brief.yfilter != YFilter.not_set or
                            self.ingress_interface_state.yfilter != YFilter.not_set or
                            self.is_bandwidth_protect.yfilter != YFilter.not_set or
                            self.is_expanded_ero.yfilter != YFilter.not_set or
                            self.is_frr_enabled.yfilter != YFilter.not_set or
                            self.is_node_protected.yfilter != YFilter.not_set or
                            self.is_optical.yfilter != YFilter.not_set or
                            self.local_router_id.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.node_hop_count.yfilter != YFilter.not_set or
                            self.outbound_frr_state.yfilter != YFilter.not_set or
                            self.path_reeval_query_mid.yfilter != YFilter.not_set or
                            self.path_rro_enabled.yfilter != YFilter.not_set or
                            self.path_using_strict_spf.yfilter != YFilter.not_set or
                            self.pcalc_area.yfilter != YFilter.not_set or
                            self.previous_hop_address.yfilter != YFilter.not_set or
                            self.reverse_lsp_connected.yfilter != YFilter.not_set or
                            self.reverse_lsp_name.yfilter != YFilter.not_set or
                            self.reverse_lsp_present.yfilter != YFilter.not_set or
                            self.reverse_weight.yfilter != YFilter.not_set or
                            self.role.yfilter != YFilter.not_set or
                            self.s2l_local_label.yfilter != YFilter.not_set or
                            self.s2l_out_label.yfilter != YFilter.not_set or
                            self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                            self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                            self.signalling_status.yfilter != YFilter.not_set or
                            self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                            self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                            self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                            self.upstream_router_id.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            self.weight.yfilter != YFilter.not_set or
                            (self.active_path_option is not None and self.active_path_option.has_operation()) or
                            (self.association is not None and self.association.has_operation()) or
                            (self.diversity_info is not None and self.diversity_info.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.fspec is not None and self.fspec.has_operation()) or
                            (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                            (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                            (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                            (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                            (self.in_xro is not None and self.in_xro.has_operation()) or
                            (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                            (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                            (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                            (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                            (self.out_xro is not None and self.out_xro.has_operation()) or
                            (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                            (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                            (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                            (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                            (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                            (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                            (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                            (self.tspec is not None and self.tspec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                        if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                        if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                        if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface.get_name_leafdata())
                        if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                        if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                        if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                        if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                        if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                        if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                        if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                        if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                        if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.incoming_address.get_name_leafdata())
                        if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                        if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                        if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                        if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                        if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                        if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                        if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                        if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_optical.get_name_leafdata())
                        if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_router_id.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                        if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                        if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                        if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                        if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                        if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                        if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                        if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                        if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                        if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                        if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                        if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role.get_name_leafdata())
                        if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                        if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                        if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                        if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                        if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signalling_status.get_name_leafdata())
                        if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                        if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                        if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                        if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())
                        if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.weight.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "active-path-option"):
                            if (self.active_path_option is None):
                                self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ActivePathOption()
                                self.active_path_option.parent = self
                                self._children_name_map["active_path_option"] = "active-path-option"
                            return self.active_path_option

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "diversity-info"):
                            if (self.diversity_info is None):
                                self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.DiversityInfo()
                                self.diversity_info.parent = self
                                self._children_name_map["diversity_info"] = "diversity-info"
                            return self.diversity_info

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "fspec"):
                            if (self.fspec is None):
                                self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Fspec()
                                self.fspec.parent = self
                                self._children_name_map["fspec"] = "fspec"
                            return self.fspec

                        if (child_yang_name == "generic-fspec"):
                            if (self.generic_fspec is None):
                                self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericFspec()
                                self.generic_fspec.parent = self
                                self._children_name_map["generic_fspec"] = "generic-fspec"
                            return self.generic_fspec

                        if (child_yang_name == "generic-tspec"):
                            if (self.generic_tspec is None):
                                self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GenericTspec()
                                self.generic_tspec.parent = self
                                self._children_name_map["generic_tspec"] = "generic-tspec"
                            return self.generic_tspec

                        if (child_yang_name == "gmpls-labels"):
                            if (self.gmpls_labels is None):
                                self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.GmplsLabels()
                                self.gmpls_labels.parent = self
                                self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            return self.gmpls_labels

                        if (child_yang_name == "head-end-bfd-info"):
                            if (self.head_end_bfd_info is None):
                                self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.HeadEndBfdInfo()
                                self.head_end_bfd_info.parent = self
                                self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            return self.head_end_bfd_info

                        if (child_yang_name == "in-ero"):
                            for c in self.in_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.in_ero.append(c)
                            return c

                        if (child_yang_name == "in-xro"):
                            if (self.in_xro is None):
                                self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.InXro()
                                self.in_xro.parent = self
                                self._children_name_map["in_xro"] = "in-xro"
                            return self.in_xro

                        if (child_yang_name == "incoming-address-generic"):
                            if (self.incoming_address_generic is None):
                                self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.IncomingAddressGeneric()
                                self.incoming_address_generic.parent = self
                                self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            return self.incoming_address_generic

                        if (child_yang_name == "lsp-wrap-info"):
                            if (self.lsp_wrap_info is None):
                                self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.LspWrapInfo()
                                self.lsp_wrap_info.parent = self
                                self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            return self.lsp_wrap_info

                        if (child_yang_name == "next-hop-address-generic"):
                            if (self.next_hop_address_generic is None):
                                self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.NextHopAddressGeneric()
                                self.next_hop_address_generic.parent = self
                                self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            return self.next_hop_address_generic

                        if (child_yang_name == "otn-s2l"):
                            if (self.otn_s2l is None):
                                self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OtnS2L()
                                self.otn_s2l.parent = self
                                self._children_name_map["otn_s2l"] = "otn-s2l"
                            return self.otn_s2l

                        if (child_yang_name == "out-ero"):
                            for c in self.out_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.out_ero.append(c)
                            return c

                        if (child_yang_name == "out-xro"):
                            if (self.out_xro is None):
                                self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.OutXro()
                                self.out_xro.parent = self
                                self._children_name_map["out_xro"] = "out-xro"
                            return self.out_xro

                        if (child_yang_name == "path-affinity-array"):
                            for c in self.path_affinity_array:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathAffinityArray()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_affinity_array.append(c)
                            return c

                        if (child_yang_name == "path-rro"):
                            for c in self.path_rro:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PathRro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_rro.append(c)
                            return c

                        if (child_yang_name == "previous-hop-address-generic"):
                            if (self.previous_hop_address_generic is None):
                                self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.PreviousHopAddressGeneric()
                                self.previous_hop_address_generic.parent = self
                                self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            return self.previous_hop_address_generic

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "resv-rro"):
                            for c in self.resv_rro:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ResvRro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.resv_rro.append(c)
                            return c

                        if (child_yang_name == "reverse-ero-in"):
                            for c in self.reverse_ero_in:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseEroIn()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.reverse_ero_in.append(c)
                            return c

                        if (child_yang_name == "reverse-lsp-fec"):
                            if (self.reverse_lsp_fec is None):
                                self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseLspFec()
                                self.reverse_lsp_fec.parent = self
                                self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            return self.reverse_lsp_fec

                        if (child_yang_name == "reverse-tspec"):
                            if (self.reverse_tspec is None):
                                self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.ReverseTspec()
                                self.reverse_tspec.parent = self
                                self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            return self.reverse_tspec

                        if (child_yang_name == "s2l-convergence"):
                            if (self.s2l_convergence is None):
                                self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LConvergence()
                                self.s2l_convergence.parent = self
                                self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            return self.s2l_convergence

                        if (child_yang_name == "s2l-fec"):
                            if (self.s2l_fec is None):
                                self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                            return self.s2l_fec

                        if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                            for c in self.s2l_reverse_lsp_sub_obj:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LReverseLspSubObj()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_reverse_lsp_sub_obj.append(c)
                            return c

                        if (child_yang_name == "s2l-segment-routing-path"):
                            for c in self.s2l_segment_routing_path:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.S2LSegmentRoutingPath()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_segment_routing_path.append(c)
                            return c

                        if (child_yang_name == "shared-risk-link-group"):
                            for c in self.shared_risk_link_group:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SharedRiskLinkGroup()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_risk_link_group.append(c)
                            return c

                        if (child_yang_name == "soft-preemption"):
                            if (self.soft_preemption is None):
                                self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SoftPreemption()
                                self.soft_preemption.parent = self
                                self._children_name_map["soft_preemption"] = "soft-preemption"
                            return self.soft_preemption

                        if (child_yang_name == "srlg-collection"):
                            if (self.srlg_collection is None):
                                self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.SrlgCollection()
                                self.srlg_collection.parent = self
                                self._children_name_map["srlg_collection"] = "srlg-collection"
                            return self.srlg_collection

                        if (child_yang_name == "tail-end-bfd-info"):
                            if (self.tail_end_bfd_info is None):
                                self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.TailEndBfdInfo()
                                self.tail_end_bfd_info.parent = self
                                self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            return self.tail_end_bfd_info

                        if (child_yang_name == "tspec"):
                            if (self.tspec is None):
                                self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L.Tspec()
                                self.tspec.parent = self
                                self._children_name_map["tspec"] = "tspec"
                            return self.tspec

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "abr-auto-discovered"):
                            self.abr_auto_discovered = value
                            self.abr_auto_discovered.value_namespace = name_space
                            self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-tunnel-interface"):
                            self.backup_tunnel_interface = value
                            self.backup_tunnel_interface.value_namespace = name_space
                            self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "downstream-router-id"):
                            self.downstream_router_id = value
                            self.downstream_router_id.value_namespace = name_space
                            self.downstream_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface"):
                            self.egress_interface = value
                            self.egress_interface.value_namespace = name_space
                            self.egress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface-brief"):
                            self.egress_interface_brief = value
                            self.egress_interface_brief.value_namespace = name_space
                            self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                        if(value_path == "egress-interface-state"):
                            self.egress_interface_state = value
                            self.egress_interface_state.value_namespace = name_space
                            self.egress_interface_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-affinity-bits"):
                            self.expanded_ero_affinity_bits = value
                            self.expanded_ero_affinity_bits.value_namespace = name_space
                            self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-affinity-mask"):
                            self.expanded_ero_affinity_mask = value
                            self.expanded_ero_affinity_mask.value_namespace = name_space
                            self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-area-id"):
                            self.expanded_ero_area_id = value
                            self.expanded_ero_area_id.value_namespace = name_space
                            self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-metric"):
                            self.expanded_ero_metric = value
                            self.expanded_ero_metric.value_namespace = name_space
                            self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "expanded-ero-metric-type"):
                            self.expanded_ero_metric_type = value
                            self.expanded_ero_metric_type.value_namespace = name_space
                            self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-out-tunnel-interface"):
                            self.frr_out_tunnel_interface = value
                            self.frr_out_tunnel_interface.value_namespace = name_space
                            self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "incoming-address"):
                            self.incoming_address = value
                            self.incoming_address.value_namespace = name_space
                            self.incoming_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface"):
                            self.ingress_interface = value
                            self.ingress_interface.value_namespace = name_space
                            self.ingress_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface-brief"):
                            self.ingress_interface_brief = value
                            self.ingress_interface_brief.value_namespace = name_space
                            self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                        if(value_path == "ingress-interface-state"):
                            self.ingress_interface_state = value
                            self.ingress_interface_state.value_namespace = name_space
                            self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-protect"):
                            self.is_bandwidth_protect = value
                            self.is_bandwidth_protect.value_namespace = name_space
                            self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-expanded-ero"):
                            self.is_expanded_ero = value
                            self.is_expanded_ero.value_namespace = name_space
                            self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-enabled"):
                            self.is_frr_enabled = value
                            self.is_frr_enabled.value_namespace = name_space
                            self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-node-protected"):
                            self.is_node_protected = value
                            self.is_node_protected.value_namespace = name_space
                            self.is_node_protected.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-optical"):
                            self.is_optical = value
                            self.is_optical.value_namespace = name_space
                            self.is_optical.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-router-id"):
                            self.local_router_id = value
                            self.local_router_id.value_namespace = name_space
                            self.local_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "node-hop-count"):
                            self.node_hop_count = value
                            self.node_hop_count.value_namespace = name_space
                            self.node_hop_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "outbound-frr-state"):
                            self.outbound_frr_state = value
                            self.outbound_frr_state.value_namespace = name_space
                            self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-reeval-query-mid"):
                            self.path_reeval_query_mid = value
                            self.path_reeval_query_mid.value_namespace = name_space
                            self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-rro-enabled"):
                            self.path_rro_enabled = value
                            self.path_rro_enabled.value_namespace = name_space
                            self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-using-strict-spf"):
                            self.path_using_strict_spf = value
                            self.path_using_strict_spf.value_namespace = name_space
                            self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-area"):
                            self.pcalc_area = value
                            self.pcalc_area.value_namespace = name_space
                            self.pcalc_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "previous-hop-address"):
                            self.previous_hop_address = value
                            self.previous_hop_address.value_namespace = name_space
                            self.previous_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-connected"):
                            self.reverse_lsp_connected = value
                            self.reverse_lsp_connected.value_namespace = name_space
                            self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-name"):
                            self.reverse_lsp_name = value
                            self.reverse_lsp_name.value_namespace = name_space
                            self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-lsp-present"):
                            self.reverse_lsp_present = value
                            self.reverse_lsp_present.value_namespace = name_space
                            self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-weight"):
                            self.reverse_weight = value
                            self.reverse_weight.value_namespace = name_space
                            self.reverse_weight.value_namespace_prefix = name_space_prefix
                        if(value_path == "role"):
                            self.role = value
                            self.role.value_namespace = name_space
                            self.role.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-local-label"):
                            self.s2l_local_label = value
                            self.s2l_local_label.value_namespace = name_space
                            self.s2l_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-out-label"):
                            self.s2l_out_label = value
                            self.s2l_out_label.value_namespace = name_space
                            self.s2l_out_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-reverse-ero-obj-present"):
                            self.s2l_reverse_ero_obj_present = value
                            self.s2l_reverse_ero_obj_present.value_namespace = name_space
                            self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-reverse-tspec-obj-present"):
                            self.s2l_reverse_tspec_obj_present = value
                            self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                            self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                        if(value_path == "signalling-status"):
                            self.signalling_status = value
                            self.signalling_status.value_namespace = name_space
                            self.signalling_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                            self.time_since_last_preferred_path_exists_send_mid = value
                            self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                            self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                            self.time_since_last_preferred_tree_exists_send_mid = value
                            self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                            self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-since-last-query-received-mid"):
                            self.time_since_last_query_received_mid = value
                            self.time_since_last_query_received_mid.value_namespace = name_space
                            self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                        if(value_path == "upstream-router-id"):
                            self.upstream_router_id = value
                            self.upstream_router_id.value_namespace = name_space
                            self.upstream_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "weight"):
                            self.weight = value
                            self.weight.value_namespace = name_space
                            self.weight.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    return (
                        self.lsp_id.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.p2mp_id.is_set or
                        self.dste_class_index.is_set or
                        self.dste_class_match.is_set or
                        self.frr_active_reason.is_set or
                        self.is_frr_failed.is_set or
                        self.is_interface.is_set or
                        self.is_passive.is_set or
                        self.last_path_change.is_set or
                        self.lsp_bandwidth.is_set or
                        self.lsp_bandwidth_type.is_set or
                        self.lsp_hold_priority.is_set or
                        self.lsp_setup_priority.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.reoptimize_reason.is_set or
                        self.reoptimize_trigger.is_set or
                        self.s2_ls_down.is_set or
                        self.s2_ls_proceeding.is_set or
                        self.s2_ls_up.is_set or
                        self.signaled_name.is_set or
                        self.timer_left.is_set or
                        self.type.is_set or
                        self.uptime.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.dste_class_index.yfilter != YFilter.not_set or
                        self.dste_class_match.yfilter != YFilter.not_set or
                        self.frr_active_reason.yfilter != YFilter.not_set or
                        self.is_frr_failed.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.lsp_bandwidth.yfilter != YFilter.not_set or
                        self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                        self.lsp_hold_priority.yfilter != YFilter.not_set or
                        self.lsp_setup_priority.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.reoptimize_reason.yfilter != YFilter.not_set or
                        self.reoptimize_trigger.yfilter != YFilter.not_set or
                        self.s2_ls_down.yfilter != YFilter.not_set or
                        self.s2_ls_proceeding.yfilter != YFilter.not_set or
                        self.s2_ls_up.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.timer_left.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-remote" + "[lsp-id='" + self.lsp_id.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-remotes/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                    if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                    if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                    if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                    if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                    if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                    if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                    if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                    if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                    if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                    if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_left.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "s2l" or name == "lsp-id" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "source-address" or name == "ctype" or name == "destination-address" or name == "p2mp-id" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "dste-class-index"):
                        self.dste_class_index = value
                        self.dste_class_index.value_namespace = name_space
                        self.dste_class_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "dste-class-match"):
                        self.dste_class_match = value
                        self.dste_class_match.value_namespace = name_space
                        self.dste_class_match.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-reason"):
                        self.frr_active_reason = value
                        self.frr_active_reason.value_namespace = name_space
                        self.frr_active_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-frr-failed"):
                        self.is_frr_failed = value
                        self.is_frr_failed.value_namespace = name_space
                        self.is_frr_failed.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth"):
                        self.lsp_bandwidth = value
                        self.lsp_bandwidth.value_namespace = name_space
                        self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth-type"):
                        self.lsp_bandwidth_type = value
                        self.lsp_bandwidth_type.value_namespace = name_space
                        self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-hold-priority"):
                        self.lsp_hold_priority = value
                        self.lsp_hold_priority.value_namespace = name_space
                        self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-setup-priority"):
                        self.lsp_setup_priority = value
                        self.lsp_setup_priority.value_namespace = name_space
                        self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-reason"):
                        self.reoptimize_reason = value
                        self.reoptimize_reason.value_namespace = name_space
                        self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-trigger"):
                        self.reoptimize_trigger = value
                        self.reoptimize_trigger.value_namespace = name_space
                        self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-down"):
                        self.s2_ls_down = value
                        self.s2_ls_down.value_namespace = name_space
                        self.s2_ls_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-proceeding"):
                        self.s2_ls_proceeding = value
                        self.s2_ls_proceeding.value_namespace = name_space
                        self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls-up"):
                        self.s2_ls_up = value
                        self.s2_ls_up.value_namespace = name_space
                        self.s2_ls_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-left"):
                        self.timer_left = value
                        self.timer_left.value_namespace = name_space
                        self.timer_left.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_remote:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_remote:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-remotes" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-remote"):
                    for c in self.tunnel_remote:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes.TunnelRemote()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_remote.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-remote"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class NniTunnels(Entity):
            """
            GMPLS NNI tunnels
            
            .. attribute:: nni_tunnel
            
            	GMPLS\-NNI tail tunnel
            	**type**\: list of    :py:class:`NniTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels, self).__init__()

                self.yang_name = "nni-tunnels"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.nni_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels, self).__setattr__(name, value)


            class NniTunnel(Entity):
                """
                GMPLS\-NNI tail tunnel
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:   :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\:  bool
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\:  str
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:   :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup>`
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:   :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh>`
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:   :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc>`
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\:  bool
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\:  bool
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:   :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo>`
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:   :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir>`
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\:  bool
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:   :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp>`
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config>`
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:   :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp>`
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination>`
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\:  bool
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:   :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo>`
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\:  bool
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:   :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History>`
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:   :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\:  bool
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\:  bool
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\:  bool
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\:  bool
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\:  bool
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:   :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\:  bool
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:   :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:   :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir>`
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo>`
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\:  str
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection>`
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:   :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation>`
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:   :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:   :py:class:`ReoptimizedP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp>`
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:   :py:class:`ReoptimizedStandbyP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp>`
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\:  bool
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption>`
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:   :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence>`
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:   :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo>`
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\:  str
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:   :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp>`
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\:  bool
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:   :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp>`
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:   :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:   :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel>`
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet>`
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__init__()

                    self.yang_name = "nni-tunnel"
                    self.yang_parent_name = "nni-tunnels"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.admin_state = YLeaf(YType.enumeration, "admin-state")

                    self.affinity_failure_delayed_tear_time_remained = YLeaf(YType.uint32, "affinity-failure-delayed-tear-time-remained")

                    self.affinity_failure_reopt_disabled = YLeaf(YType.boolean, "affinity-failure-reopt-disabled")

                    self.affinity_failure_reopt_time_remained = YLeaf(YType.uint32, "affinity-failure-reopt-time-remained")

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.auto_route = YLeaf(YType.boolean, "auto-route")

                    self.autoroute_announce_exclude_segment_routing = YLeaf(YType.boolean, "autoroute-announce-exclude-segment-routing")

                    self.bandwidth_requested = YLeaf(YType.uint32, "bandwidth-requested")

                    self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                    self.binding_label_exists = YLeaf(YType.boolean, "binding-label-exists")

                    self.create_time = YLeaf(YType.uint32, "create-time")

                    self.destination_disabled_count = YLeaf(YType.uint32, "destination-disabled-count")

                    self.destination_down_count = YLeaf(YType.uint32, "destination-down-count")

                    self.destination_up_count = YLeaf(YType.uint32, "destination-up-count")

                    self.drop_mode = YLeaf(YType.boolean, "drop-mode")

                    self.explicit_path_change = YLeaf(YType.boolean, "explicit-path-change")

                    self.fail_reason = YLeaf(YType.enumeration, "fail-reason")

                    self.forwarding_adjacency = YLeaf(YType.boolean, "forwarding-adjacency")

                    self.hop_limit_ignored_reason = YLeaf(YType.enumeration, "hop-limit-ignored-reason")

                    self.invalidation_time_remained = YLeaf(YType.uint32, "invalidation-time-remained")

                    self.is_auto_backup = YLeaf(YType.boolean, "is-auto-backup")

                    self.is_auto_pcc = YLeaf(YType.boolean, "is-auto-pcc")

                    self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                    self.is_hop_limit_ignore = YLeaf(YType.boolean, "is-hop-limit-ignore")

                    self.is_inter_area_tunnel = YLeaf(YType.boolean, "is-inter-area-tunnel")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_named = YLeaf(YType.boolean, "is-named")

                    self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.is_pce_delegated = YLeaf(YType.boolean, "is-pce-delegated")

                    self.last_hop_ifindex = YLeaf(YType.uint32, "last-hop-ifindex")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.load_share_factor = YLeaf(YType.uint32, "load-share-factor")

                    self.load_share_type = YLeaf(YType.enumeration, "load-share-type")

                    self.lsp_wrap_label = YLeaf(YType.uint32, "lsp-wrap-label")

                    self.lsp_wrap_protection_enabled = YLeaf(YType.boolean, "lsp-wrap-protection-enabled")

                    self.metric_qualifier = YLeaf(YType.enumeration, "metric-qualifier")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                    self.operational_state = YLeaf(YType.enumeration, "operational-state")

                    self.operational_state_changes = YLeaf(YType.uint32, "operational-state-changes")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.passive_tunnel_name = YLeaf(YType.str, "passive-tunnel-name")

                    self.path_option_change = YLeaf(YType.boolean, "path-option-change")

                    self.pce_fail_reason = YLeaf(YType.enumeration, "pce-fail-reason")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.re_opt_hold_down_timer_remaining = YLeaf(YType.uint32, "re-opt-hold-down-timer-remaining")

                    self.reroute_pending = YLeaf(YType.boolean, "reroute-pending")

                    self.role_standby = YLeaf(YType.boolean, "role-standby")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.snmp_index = YLeaf(YType.uint32, "snmp-index")

                    self.tie_breaker = YLeaf(YType.enumeration, "tie-breaker")

                    self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                    self.tiebreaker_type = YLeaf(YType.uint32, "tiebreaker-type")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                    self.tunnel_recovering = YLeaf(YType.boolean, "tunnel-recovering")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.xro_attribute_set_name = YLeaf(YType.str, "xro-attribute-set-name")

                    self.auto_backup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"
                    self._children_yang_names.add("auto-backup")

                    self.auto_mesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"
                    self._children_yang_names.add("auto-mesh")

                    self.auto_pcc = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"
                    self._children_yang_names.add("auto-pcc")

                    self.bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"
                    self._children_yang_names.add("bfd-info")

                    self.bidir = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"
                    self._children_yang_names.add("bidir")

                    self.cleaned_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                    self._children_yang_names.add("cleaned-lsp")

                    self.config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"
                    self._children_yang_names.add("config")

                    self.delay_clean_pp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                    self._children_yang_names.add("delay-clean-pp-lsp")

                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"
                    self._children_yang_names.add("flex-info")

                    self.history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"
                    self._children_yang_names.add("history")

                    self.otn_bidir = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"
                    self._children_yang_names.add("otn-bidir")

                    self.p2p_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"
                    self._children_yang_names.add("p2p-info")

                    self.path_protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.pce_delegation = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"
                    self._children_yang_names.add("pce-delegation")

                    self.reoptimized_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-p2mp-lsp")

                    self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-standby-p2mp-lsp")

                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"
                    self._children_yang_names.add("soft-preemption")

                    self.te_tunnel_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                    self._children_yang_names.add("te-tunnel-convergence")

                    self.transport_tunnel_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                    self._children_yang_names.add("transport-tunnel-info")

                    self.tunnel_current_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                    self._children_yang_names.add("tunnel-current-lsp")

                    self.tunnel_restoration_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                    self._children_yang_names.add("tunnel-restoration-lsp")

                    self.tunnel_standby_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                    self._children_yang_names.add("tunnel-standby-lsp")

                    self.wdm_unitunnel = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                    self._children_yang_names.add("wdm-unitunnel")

                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                    self._children_yang_names.add("xro-attribute-set")

                    self.destination = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "source_address",
                                    "destination_address",
                                    "admin_state",
                                    "affinity_failure_delayed_tear_time_remained",
                                    "affinity_failure_reopt_disabled",
                                    "affinity_failure_reopt_time_remained",
                                    "area_id",
                                    "auto_route",
                                    "autoroute_announce_exclude_segment_routing",
                                    "bandwidth_requested",
                                    "bandwidth_type",
                                    "binding_label",
                                    "binding_label_exists",
                                    "create_time",
                                    "destination_disabled_count",
                                    "destination_down_count",
                                    "destination_up_count",
                                    "drop_mode",
                                    "explicit_path_change",
                                    "fail_reason",
                                    "forwarding_adjacency",
                                    "hop_limit_ignored_reason",
                                    "invalidation_time_remained",
                                    "is_auto_backup",
                                    "is_auto_pcc",
                                    "is_bandwidth_protect",
                                    "is_hop_limit_ignore",
                                    "is_inter_area_tunnel",
                                    "is_interface",
                                    "is_named",
                                    "is_node_protected",
                                    "is_passive",
                                    "is_pce_delegated",
                                    "last_hop_ifindex",
                                    "last_path_change",
                                    "load_share_factor",
                                    "load_share_type",
                                    "lsp_wrap_label",
                                    "lsp_wrap_protection_enabled",
                                    "metric_qualifier",
                                    "metric_type",
                                    "operational_state",
                                    "operational_state_changes",
                                    "outbound_frr_state",
                                    "passive_tunnel_name",
                                    "path_option_change",
                                    "pce_fail_reason",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "re_opt_hold_down_timer_remaining",
                                    "reroute_pending",
                                    "role_standby",
                                    "signaled_name",
                                    "snmp_index",
                                    "tie_breaker",
                                    "tiebreaker_qualifier",
                                    "tiebreaker_type",
                                    "tunnel_attribute_set_name",
                                    "tunnel_attribute_set_type",
                                    "tunnel_interface_name",
                                    "tunnel_recovering",
                                    "uptime",
                                    "xro_attribute_set_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel, self).__setattr__(name, value)


                class Config(Entity):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity>`
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of    :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination>`
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:   :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig>`
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:   :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig>`
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\:  bool
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\:  bool
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\:  bool
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\:  bool
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\:  str
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\:  bool
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "nni-tunnel"

                        self.affinity_failure_reopt_timer = YLeaf(YType.uint32, "affinity-failure-reopt-timer")

                        self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                        self.backup_bandwidth_flags = YLeaf(YType.uint8, "backup-bandwidth-flags")

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.config_load_share = YLeaf(YType.uint32, "config-load-share")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.cost_limit_global = YLeaf(YType.uint32, "cost-limit-global")

                        self.disable_affinity_failure_reopt = YLeaf(YType.boolean, "disable-affinity-failure-reopt")

                        self.explicit_null_imposition = YLeaf(YType.boolean, "explicit-null-imposition")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.hop_limit = YLeaf(YType.uint8, "hop-limit")

                        self.interface_configured_bandwidth = YLeaf(YType.uint32, "interface-configured-bandwidth")

                        self.is_backup_tunnel = YLeaf(YType.boolean, "is-backup-tunnel")

                        self.is_in_config = YLeaf(YType.boolean, "is-in-config")

                        self.is_p2mp = YLeaf(YType.boolean, "is-p2mp")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_action_source = YLeaf(YType.uint32, "path-invalidation-action-source")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_invalidation_timeout_source = YLeaf(YType.uint32, "path-invalidation-timeout-source")

                        self.path_protection_enabled = YLeaf(YType.boolean, "path-protection-enabled")

                        self.payload_type = YLeaf(YType.uint16, "payload-type")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.segment_routing_path_selection = YLeaf(YType.enumeration, "segment-routing-path-selection")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.soft_preempt = YLeaf(YType.boolean, "soft-preempt")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"
                        self._children_yang_names.add("bfd-config")

                        self.bidirectional_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"
                        self._children_yang_names.add("bidirectional-config")

                        self.autoroute_destination = YList(self)
                        self.policy_class_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_failure_reopt_timer",
                                        "backup_bandwidth",
                                        "backup_bandwidth_flags",
                                        "bandwidth_type",
                                        "config_load_share",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "cost_limit_global",
                                        "disable_affinity_failure_reopt",
                                        "explicit_null_imposition",
                                        "fast_reroute",
                                        "forward_class",
                                        "hold_priority",
                                        "hop_limit",
                                        "interface_configured_bandwidth",
                                        "is_backup_tunnel",
                                        "is_in_config",
                                        "is_p2mp",
                                        "path_invalidation_action",
                                        "path_invalidation_action_source",
                                        "path_invalidation_timeout",
                                        "path_invalidation_timeout_source",
                                        "path_protection_enabled",
                                        "payload_type",
                                        "policy_class",
                                        "record_route",
                                        "segment_routing_path_selection",
                                        "setup_priority",
                                        "signaled_name",
                                        "soft_preempt",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BidirectionalConfig(Entity):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\:  bool
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: association_type
                        
                        	Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"

                            self.association_corouted = YLeaf(YType.boolean, "association-corouted")

                            self.association_global_id = YLeaf(YType.uint32, "association-global-id")

                            self.association_id = YLeaf(YType.uint16, "association-id")

                            self.association_source = YLeaf(YType.str, "association-source")

                            self.association_type = YLeaf(YType.uint16, "association-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("association_corouted",
                                            "association_global_id",
                                            "association_id",
                                            "association_source",
                                            "association_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.association_corouted.is_set or
                                self.association_global_id.is_set or
                                self.association_id.is_set or
                                self.association_source.is_set or
                                self.association_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.association_corouted.yfilter != YFilter.not_set or
                                self.association_global_id.yfilter != YFilter.not_set or
                                self.association_id.yfilter != YFilter.not_set or
                                self.association_source.yfilter != YFilter.not_set or
                                self.association_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bidirectional-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.association_corouted.is_set or self.association_corouted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_corouted.get_name_leafdata())
                            if (self.association_global_id.is_set or self.association_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_global_id.get_name_leafdata())
                            if (self.association_id.is_set or self.association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_id.get_name_leafdata())
                            if (self.association_source.is_set or self.association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_source.get_name_leafdata())
                            if (self.association_type.is_set or self.association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association-corouted" or name == "association-global-id" or name == "association-id" or name == "association-source" or name == "association-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "association-corouted"):
                                self.association_corouted = value
                                self.association_corouted.value_namespace = name_space
                                self.association_corouted.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-global-id"):
                                self.association_global_id = value
                                self.association_global_id.value_namespace = name_space
                                self.association_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-id"):
                                self.association_id = value
                                self.association_id.value_namespace = name_space
                                self.association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-source"):
                                self.association_source = value
                                self.association_source.value_namespace = name_space
                                self.association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-type"):
                                self.association_type = value
                                self.association_type.value_namespace = name_space
                                self.association_type.value_namespace_prefix = name_space_prefix


                    class BfdConfig(Entity):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:   :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\:  bool
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:   :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\:  bool
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\:  bool
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\:  bool
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"

                            self.bfd_encap_mode = YLeaf(YType.enumeration, "bfd-encap-mode")

                            self.bfd_fast_detecting_enabled = YLeaf(YType.boolean, "bfd-fast-detecting-enabled")

                            self.bfd_session_down_action = YLeaf(YType.enumeration, "bfd-session-down-action")

                            self.bfd_session_down_reopt_timeout = YLeaf(YType.uint32, "bfd-session-down-reopt-timeout")

                            self.bfd_type = YLeaf(YType.enumeration, "bfd-type")

                            self.bring_up_timeout = YLeaf(YType.uint16, "bring-up-timeout")

                            self.bring_up_timeout_default = YLeaf(YType.boolean, "bring-up-timeout-default")

                            self.dampening_initial_wait = YLeaf(YType.uint32, "dampening-initial-wait")

                            self.dampening_initial_wait_default = YLeaf(YType.boolean, "dampening-initial-wait-default")

                            self.dampening_max_wait = YLeaf(YType.uint32, "dampening-max-wait")

                            self.dampening_max_wait_default = YLeaf(YType.boolean, "dampening-max-wait-default")

                            self.dampening_secondary_wait = YLeaf(YType.uint32, "dampening-secondary-wait")

                            self.dampening_secondary_wait_default = YLeaf(YType.boolean, "dampening-secondary-wait-default")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.periodic_lsp_ping_disabled = YLeaf(YType.boolean, "periodic-lsp-ping-disabled")

                            self.periodic_lsp_ping_interval = YLeaf(YType.uint32, "periodic-lsp-ping-interval")

                            self.periodic_lsp_ping_interval_default = YLeaf(YType.boolean, "periodic-lsp-ping-interval-default")

                            self.sbfd_target_id = YLeaf(YType.str, "sbfd-target-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_encap_mode",
                                            "bfd_fast_detecting_enabled",
                                            "bfd_session_down_action",
                                            "bfd_session_down_reopt_timeout",
                                            "bfd_type",
                                            "bring_up_timeout",
                                            "bring_up_timeout_default",
                                            "dampening_initial_wait",
                                            "dampening_initial_wait_default",
                                            "dampening_max_wait",
                                            "dampening_max_wait_default",
                                            "dampening_secondary_wait",
                                            "dampening_secondary_wait_default",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "periodic_lsp_ping_disabled",
                                            "periodic_lsp_ping_interval",
                                            "periodic_lsp_ping_interval_default",
                                            "sbfd_target_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_encap_mode.is_set or
                                self.bfd_fast_detecting_enabled.is_set or
                                self.bfd_session_down_action.is_set or
                                self.bfd_session_down_reopt_timeout.is_set or
                                self.bfd_type.is_set or
                                self.bring_up_timeout.is_set or
                                self.bring_up_timeout_default.is_set or
                                self.dampening_initial_wait.is_set or
                                self.dampening_initial_wait_default.is_set or
                                self.dampening_max_wait.is_set or
                                self.dampening_max_wait_default.is_set or
                                self.dampening_secondary_wait.is_set or
                                self.dampening_secondary_wait_default.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.periodic_lsp_ping_disabled.is_set or
                                self.periodic_lsp_ping_interval.is_set or
                                self.periodic_lsp_ping_interval_default.is_set or
                                self.sbfd_target_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_encap_mode.yfilter != YFilter.not_set or
                                self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set or
                                self.bfd_session_down_action.yfilter != YFilter.not_set or
                                self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set or
                                self.bfd_type.yfilter != YFilter.not_set or
                                self.bring_up_timeout.yfilter != YFilter.not_set or
                                self.bring_up_timeout_default.yfilter != YFilter.not_set or
                                self.dampening_initial_wait.yfilter != YFilter.not_set or
                                self.dampening_initial_wait_default.yfilter != YFilter.not_set or
                                self.dampening_max_wait.yfilter != YFilter.not_set or
                                self.dampening_max_wait_default.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait_default.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set or
                                self.sbfd_target_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_encap_mode.is_set or self.bfd_encap_mode.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_encap_mode.get_name_leafdata())
                            if (self.bfd_fast_detecting_enabled.is_set or self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_fast_detecting_enabled.get_name_leafdata())
                            if (self.bfd_session_down_action.is_set or self.bfd_session_down_action.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_action.get_name_leafdata())
                            if (self.bfd_session_down_reopt_timeout.is_set or self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_reopt_timeout.get_name_leafdata())
                            if (self.bfd_type.is_set or self.bfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_type.get_name_leafdata())
                            if (self.bring_up_timeout.is_set or self.bring_up_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout.get_name_leafdata())
                            if (self.bring_up_timeout_default.is_set or self.bring_up_timeout_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout_default.get_name_leafdata())
                            if (self.dampening_initial_wait.is_set or self.dampening_initial_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait.get_name_leafdata())
                            if (self.dampening_initial_wait_default.is_set or self.dampening_initial_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait_default.get_name_leafdata())
                            if (self.dampening_max_wait.is_set or self.dampening_max_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait.get_name_leafdata())
                            if (self.dampening_max_wait_default.is_set or self.dampening_max_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait_default.get_name_leafdata())
                            if (self.dampening_secondary_wait.is_set or self.dampening_secondary_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait.get_name_leafdata())
                            if (self.dampening_secondary_wait_default.is_set or self.dampening_secondary_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait_default.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.periodic_lsp_ping_disabled.is_set or self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_disabled.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval.is_set or self.periodic_lsp_ping_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval_default.is_set or self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval_default.get_name_leafdata())
                            if (self.sbfd_target_id.is_set or self.sbfd_target_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sbfd_target_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-encap-mode" or name == "bfd-fast-detecting-enabled" or name == "bfd-session-down-action" or name == "bfd-session-down-reopt-timeout" or name == "bfd-type" or name == "bring-up-timeout" or name == "bring-up-timeout-default" or name == "dampening-initial-wait" or name == "dampening-initial-wait-default" or name == "dampening-max-wait" or name == "dampening-max-wait-default" or name == "dampening-secondary-wait" or name == "dampening-secondary-wait-default" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "periodic-lsp-ping-disabled" or name == "periodic-lsp-ping-interval" or name == "periodic-lsp-ping-interval-default" or name == "sbfd-target-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-encap-mode"):
                                self.bfd_encap_mode = value
                                self.bfd_encap_mode.value_namespace = name_space
                                self.bfd_encap_mode.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-fast-detecting-enabled"):
                                self.bfd_fast_detecting_enabled = value
                                self.bfd_fast_detecting_enabled.value_namespace = name_space
                                self.bfd_fast_detecting_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-action"):
                                self.bfd_session_down_action = value
                                self.bfd_session_down_action.value_namespace = name_space
                                self.bfd_session_down_action.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-reopt-timeout"):
                                self.bfd_session_down_reopt_timeout = value
                                self.bfd_session_down_reopt_timeout.value_namespace = name_space
                                self.bfd_session_down_reopt_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-type"):
                                self.bfd_type = value
                                self.bfd_type.value_namespace = name_space
                                self.bfd_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout"):
                                self.bring_up_timeout = value
                                self.bring_up_timeout.value_namespace = name_space
                                self.bring_up_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout-default"):
                                self.bring_up_timeout_default = value
                                self.bring_up_timeout_default.value_namespace = name_space
                                self.bring_up_timeout_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait"):
                                self.dampening_initial_wait = value
                                self.dampening_initial_wait.value_namespace = name_space
                                self.dampening_initial_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait-default"):
                                self.dampening_initial_wait_default = value
                                self.dampening_initial_wait_default.value_namespace = name_space
                                self.dampening_initial_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait"):
                                self.dampening_max_wait = value
                                self.dampening_max_wait.value_namespace = name_space
                                self.dampening_max_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait-default"):
                                self.dampening_max_wait_default = value
                                self.dampening_max_wait_default.value_namespace = name_space
                                self.dampening_max_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait"):
                                self.dampening_secondary_wait = value
                                self.dampening_secondary_wait.value_namespace = name_space
                                self.dampening_secondary_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait-default"):
                                self.dampening_secondary_wait_default = value
                                self.dampening_secondary_wait_default.value_namespace = name_space
                                self.dampening_secondary_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-disabled"):
                                self.periodic_lsp_ping_disabled = value
                                self.periodic_lsp_ping_disabled.value_namespace = name_space
                                self.periodic_lsp_ping_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval"):
                                self.periodic_lsp_ping_interval = value
                                self.periodic_lsp_ping_interval.value_namespace = name_space
                                self.periodic_lsp_ping_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval-default"):
                                self.periodic_lsp_ping_interval_default = value
                                self.periodic_lsp_ping_interval_default.value_namespace = name_space
                                self.periodic_lsp_ping_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "sbfd-target-id"):
                                self.sbfd_target_id = value
                                self.sbfd_target_id.value_namespace = name_space
                                self.sbfd_target_id.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class AutorouteDestination(Entity):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.prefix_length = YLeaf(YType.uint16, "prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "autoroute-destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.autoroute_destination:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_failure_reopt_timer.is_set or
                            self.backup_bandwidth.is_set or
                            self.backup_bandwidth_flags.is_set or
                            self.bandwidth_type.is_set or
                            self.config_load_share.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.cost_limit_global.is_set or
                            self.disable_affinity_failure_reopt.is_set or
                            self.explicit_null_imposition.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.hold_priority.is_set or
                            self.hop_limit.is_set or
                            self.interface_configured_bandwidth.is_set or
                            self.is_backup_tunnel.is_set or
                            self.is_in_config.is_set or
                            self.is_p2mp.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_action_source.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_invalidation_timeout_source.is_set or
                            self.path_protection_enabled.is_set or
                            self.payload_type.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.segment_routing_path_selection.is_set or
                            self.setup_priority.is_set or
                            self.signaled_name.is_set or
                            self.soft_preempt.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_name.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_config is not None and self.bfd_config.has_data()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_data()))

                    def has_operation(self):
                        for c in self.autoroute_destination:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_failure_reopt_timer.yfilter != YFilter.not_set or
                            self.backup_bandwidth.yfilter != YFilter.not_set or
                            self.backup_bandwidth_flags.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.config_load_share.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.cost_limit_global.yfilter != YFilter.not_set or
                            self.disable_affinity_failure_reopt.yfilter != YFilter.not_set or
                            self.explicit_null_imposition.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.hop_limit.yfilter != YFilter.not_set or
                            self.interface_configured_bandwidth.yfilter != YFilter.not_set or
                            self.is_backup_tunnel.yfilter != YFilter.not_set or
                            self.is_in_config.yfilter != YFilter.not_set or
                            self.is_p2mp.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_action_source.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout_source.yfilter != YFilter.not_set or
                            self.path_protection_enabled.yfilter != YFilter.not_set or
                            self.payload_type.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.segment_routing_path_selection.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.soft_preempt.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_config is not None and self.bfd_config.has_operation()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "config" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_failure_reopt_timer.is_set or self.affinity_failure_reopt_timer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_failure_reopt_timer.get_name_leafdata())
                        if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                        if (self.backup_bandwidth_flags.is_set or self.backup_bandwidth_flags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth_flags.get_name_leafdata())
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.config_load_share.is_set or self.config_load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.config_load_share.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.cost_limit_global.is_set or self.cost_limit_global.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit_global.get_name_leafdata())
                        if (self.disable_affinity_failure_reopt.is_set or self.disable_affinity_failure_reopt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.disable_affinity_failure_reopt.get_name_leafdata())
                        if (self.explicit_null_imposition.is_set or self.explicit_null_imposition.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.explicit_null_imposition.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hop_limit.get_name_leafdata())
                        if (self.interface_configured_bandwidth.is_set or self.interface_configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_configured_bandwidth.get_name_leafdata())
                        if (self.is_backup_tunnel.is_set or self.is_backup_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup_tunnel.get_name_leafdata())
                        if (self.is_in_config.is_set or self.is_in_config.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_in_config.get_name_leafdata())
                        if (self.is_p2mp.is_set or self.is_p2mp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_p2mp.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_action_source.is_set or self.path_invalidation_action_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action_source.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_invalidation_timeout_source.is_set or self.path_invalidation_timeout_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout_source.get_name_leafdata())
                        if (self.path_protection_enabled.is_set or self.path_protection_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_enabled.get_name_leafdata())
                        if (self.payload_type.is_set or self.payload_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.payload_type.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.segment_routing_path_selection.is_set or self.segment_routing_path_selection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_path_selection.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.soft_preempt.is_set or self.soft_preempt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preempt.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "autoroute-destination"):
                            for c in self.autoroute_destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.autoroute_destination.append(c)
                            return c

                        if (child_yang_name == "bfd-config"):
                            if (self.bfd_config is None):
                                self.bfd_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                                self.bfd_config.parent = self
                                self._children_name_map["bfd_config"] = "bfd-config"
                            return self.bfd_config

                        if (child_yang_name == "bidirectional-config"):
                            if (self.bidirectional_config is None):
                                self.bidirectional_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                                self.bidirectional_config.parent = self
                                self._children_name_map["bidirectional_config"] = "bidirectional-config"
                            return self.bidirectional_config

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "autoroute-destination" or name == "bfd-config" or name == "bidirectional-config" or name == "policy-class-entry" or name == "affinity-failure-reopt-timer" or name == "backup-bandwidth" or name == "backup-bandwidth-flags" or name == "bandwidth-type" or name == "config-load-share" or name == "configured-bandwidth" or name == "cost-limit" or name == "cost-limit-global" or name == "disable-affinity-failure-reopt" or name == "explicit-null-imposition" or name == "fast-reroute" or name == "forward-class" or name == "hold-priority" or name == "hop-limit" or name == "interface-configured-bandwidth" or name == "is-backup-tunnel" or name == "is-in-config" or name == "is-p2mp" or name == "path-invalidation-action" or name == "path-invalidation-action-source" or name == "path-invalidation-timeout" or name == "path-invalidation-timeout-source" or name == "path-protection-enabled" or name == "payload-type" or name == "policy-class" or name == "record-route" or name == "segment-routing-path-selection" or name == "setup-priority" or name == "signaled-name" or name == "soft-preempt" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-failure-reopt-timer"):
                            self.affinity_failure_reopt_timer = value
                            self.affinity_failure_reopt_timer.value_namespace = name_space
                            self.affinity_failure_reopt_timer.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth"):
                            self.backup_bandwidth = value
                            self.backup_bandwidth.value_namespace = name_space
                            self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth-flags"):
                            self.backup_bandwidth_flags = value
                            self.backup_bandwidth_flags.value_namespace = name_space
                            self.backup_bandwidth_flags.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "config-load-share"):
                            self.config_load_share = value
                            self.config_load_share.value_namespace = name_space
                            self.config_load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit-global"):
                            self.cost_limit_global = value
                            self.cost_limit_global.value_namespace = name_space
                            self.cost_limit_global.value_namespace_prefix = name_space_prefix
                        if(value_path == "disable-affinity-failure-reopt"):
                            self.disable_affinity_failure_reopt = value
                            self.disable_affinity_failure_reopt.value_namespace = name_space
                            self.disable_affinity_failure_reopt.value_namespace_prefix = name_space_prefix
                        if(value_path == "explicit-null-imposition"):
                            self.explicit_null_imposition = value
                            self.explicit_null_imposition.value_namespace = name_space
                            self.explicit_null_imposition.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "hop-limit"):
                            self.hop_limit = value
                            self.hop_limit.value_namespace = name_space
                            self.hop_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-configured-bandwidth"):
                            self.interface_configured_bandwidth = value
                            self.interface_configured_bandwidth.value_namespace = name_space
                            self.interface_configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup-tunnel"):
                            self.is_backup_tunnel = value
                            self.is_backup_tunnel.value_namespace = name_space
                            self.is_backup_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-in-config"):
                            self.is_in_config = value
                            self.is_in_config.value_namespace = name_space
                            self.is_in_config.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-p2mp"):
                            self.is_p2mp = value
                            self.is_p2mp.value_namespace = name_space
                            self.is_p2mp.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action-source"):
                            self.path_invalidation_action_source = value
                            self.path_invalidation_action_source.value_namespace = name_space
                            self.path_invalidation_action_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout-source"):
                            self.path_invalidation_timeout_source = value
                            self.path_invalidation_timeout_source.value_namespace = name_space
                            self.path_invalidation_timeout_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-enabled"):
                            self.path_protection_enabled = value
                            self.path_protection_enabled.value_namespace = name_space
                            self.path_protection_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "payload-type"):
                            self.payload_type = value
                            self.payload_type.value_namespace = name_space
                            self.payload_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-path-selection"):
                            self.segment_routing_path_selection = value
                            self.segment_routing_path_selection.value_namespace = name_space
                            self.segment_routing_path_selection.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preempt"):
                            self.soft_preempt = value
                            self.soft_preempt.value_namespace = name_space
                            self.soft_preempt.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class TunnelCurrentLsp(Entity):
                    """
                    Current LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedP2MpLsp(Entity):
                    """
                    Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelStandbyLsp(Entity):
                    """
                    Standby LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedStandbyP2MpLsp(Entity):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-standby-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelRestorationLsp(Entity):
                    """
                    Restoration LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-restoration-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class DelayCleanPpLsp(Entity):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "delay-clean-pp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class CleanedLsp(Entity):
                    """
                    Cleaned LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "nni-tunnel"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "cleaned-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class P2PInfo(Entity):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:   :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig>`
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:   :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper>`
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus>`
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.is_bidirectional = YLeaf(YType.boolean, "is-bidirectional")

                        self.auto_bandwidth_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                        self._children_yang_names.add("auto-bandwidth-config")

                        self.auto_bandwidth_oper = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._children_yang_names.add("auto-bandwidth-oper")

                        self.auto_bandwidth_status = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        self._children_yang_names.add("auto-bandwidth-status")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bidirectional") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo, self).__setattr__(name, value)


                    class AutoBandwidthStatus(Entity):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\:  bool
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"

                            self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                            self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_auto_bandwidth_enabled",
                                            "reactivation_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_auto_bandwidth_enabled.is_set or
                                self.reactivation_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                                self.reactivation_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-status" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                            if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-auto-bandwidth-enabled"):
                                self.is_auto_bandwidth_enabled = value
                                self.is_auto_bandwidth_enabled.value_namespace = name_space
                                self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "reactivation-time"):
                                self.reactivation_time = value
                                self.reactivation_time.value_namespace = name_space
                                self.reactivation_time.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthConfig(Entity):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\:  bool
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"

                            self.adjustment_threshold_percent = YLeaf(YType.uint32, "adjustment-threshold-percent")

                            self.adjustment_threshold_value = YLeaf(YType.uint32, "adjustment-threshold-value")

                            self.application_frequency = YLeaf(YType.uint32, "application-frequency")

                            self.collection_frequency = YLeaf(YType.uint32, "collection-frequency")

                            self.is_auto_bandwidth_collect_only = YLeaf(YType.boolean, "is-auto-bandwidth-collect-only")

                            self.maximum_bandwidth = YLeaf(YType.uint32, "maximum-bandwidth")

                            self.minimum_bandwidth = YLeaf(YType.uint32, "minimum-bandwidth")

                            self.overflow_threshold_limit = YLeaf(YType.uint32, "overflow-threshold-limit")

                            self.overflow_threshold_percent = YLeaf(YType.uint32, "overflow-threshold-percent")

                            self.overflow_threshold_value = YLeaf(YType.uint32, "overflow-threshold-value")

                            self.underflow_threshold_limit = YLeaf(YType.uint32, "underflow-threshold-limit")

                            self.underflow_threshold_percent = YLeaf(YType.uint32, "underflow-threshold-percent")

                            self.underflow_threshold_value = YLeaf(YType.uint32, "underflow-threshold-value")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_threshold_percent",
                                            "adjustment_threshold_value",
                                            "application_frequency",
                                            "collection_frequency",
                                            "is_auto_bandwidth_collect_only",
                                            "maximum_bandwidth",
                                            "minimum_bandwidth",
                                            "overflow_threshold_limit",
                                            "overflow_threshold_percent",
                                            "overflow_threshold_value",
                                            "underflow_threshold_limit",
                                            "underflow_threshold_percent",
                                            "underflow_threshold_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.adjustment_threshold_percent.is_set or
                                self.adjustment_threshold_value.is_set or
                                self.application_frequency.is_set or
                                self.collection_frequency.is_set or
                                self.is_auto_bandwidth_collect_only.is_set or
                                self.maximum_bandwidth.is_set or
                                self.minimum_bandwidth.is_set or
                                self.overflow_threshold_limit.is_set or
                                self.overflow_threshold_percent.is_set or
                                self.overflow_threshold_value.is_set or
                                self.underflow_threshold_limit.is_set or
                                self.underflow_threshold_percent.is_set or
                                self.underflow_threshold_value.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_threshold_percent.yfilter != YFilter.not_set or
                                self.adjustment_threshold_value.yfilter != YFilter.not_set or
                                self.application_frequency.yfilter != YFilter.not_set or
                                self.collection_frequency.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set or
                                self.maximum_bandwidth.yfilter != YFilter.not_set or
                                self.minimum_bandwidth.yfilter != YFilter.not_set or
                                self.overflow_threshold_limit.yfilter != YFilter.not_set or
                                self.overflow_threshold_percent.yfilter != YFilter.not_set or
                                self.overflow_threshold_value.yfilter != YFilter.not_set or
                                self.underflow_threshold_limit.yfilter != YFilter.not_set or
                                self.underflow_threshold_percent.yfilter != YFilter.not_set or
                                self.underflow_threshold_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_threshold_percent.is_set or self.adjustment_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_percent.get_name_leafdata())
                            if (self.adjustment_threshold_value.is_set or self.adjustment_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_value.get_name_leafdata())
                            if (self.application_frequency.is_set or self.application_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_frequency.get_name_leafdata())
                            if (self.collection_frequency.is_set or self.collection_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_frequency.get_name_leafdata())
                            if (self.is_auto_bandwidth_collect_only.is_set or self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_collect_only.get_name_leafdata())
                            if (self.maximum_bandwidth.is_set or self.maximum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_bandwidth.get_name_leafdata())
                            if (self.minimum_bandwidth.is_set or self.minimum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.minimum_bandwidth.get_name_leafdata())
                            if (self.overflow_threshold_limit.is_set or self.overflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_limit.get_name_leafdata())
                            if (self.overflow_threshold_percent.is_set or self.overflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_percent.get_name_leafdata())
                            if (self.overflow_threshold_value.is_set or self.overflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_value.get_name_leafdata())
                            if (self.underflow_threshold_limit.is_set or self.underflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_limit.get_name_leafdata())
                            if (self.underflow_threshold_percent.is_set or self.underflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_percent.get_name_leafdata())
                            if (self.underflow_threshold_value.is_set or self.underflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "adjustment-threshold-percent" or name == "adjustment-threshold-value" or name == "application-frequency" or name == "collection-frequency" or name == "is-auto-bandwidth-collect-only" or name == "maximum-bandwidth" or name == "minimum-bandwidth" or name == "overflow-threshold-limit" or name == "overflow-threshold-percent" or name == "overflow-threshold-value" or name == "underflow-threshold-limit" or name == "underflow-threshold-percent" or name == "underflow-threshold-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-threshold-percent"):
                                self.adjustment_threshold_percent = value
                                self.adjustment_threshold_percent.value_namespace = name_space
                                self.adjustment_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "adjustment-threshold-value"):
                                self.adjustment_threshold_value = value
                                self.adjustment_threshold_value.value_namespace = name_space
                                self.adjustment_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-frequency"):
                                self.application_frequency = value
                                self.application_frequency.value_namespace = name_space
                                self.application_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-frequency"):
                                self.collection_frequency = value
                                self.collection_frequency.value_namespace = name_space
                                self.collection_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-auto-bandwidth-collect-only"):
                                self.is_auto_bandwidth_collect_only = value
                                self.is_auto_bandwidth_collect_only.value_namespace = name_space
                                self.is_auto_bandwidth_collect_only.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-bandwidth"):
                                self.maximum_bandwidth = value
                                self.maximum_bandwidth.value_namespace = name_space
                                self.maximum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "minimum-bandwidth"):
                                self.minimum_bandwidth = value
                                self.minimum_bandwidth.value_namespace = name_space
                                self.minimum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-limit"):
                                self.overflow_threshold_limit = value
                                self.overflow_threshold_limit.value_namespace = name_space
                                self.overflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-percent"):
                                self.overflow_threshold_percent = value
                                self.overflow_threshold_percent.value_namespace = name_space
                                self.overflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-value"):
                                self.overflow_threshold_value = value
                                self.overflow_threshold_value.value_namespace = name_space
                                self.overflow_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-limit"):
                                self.underflow_threshold_limit = value
                                self.underflow_threshold_limit.value_namespace = name_space
                                self.underflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-percent"):
                                self.underflow_threshold_percent = value
                                self.underflow_threshold_percent.value_namespace = name_space
                                self.underflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-value"):
                                self.underflow_threshold_value = value
                                self.underflow_threshold_value.value_namespace = name_space
                                self.underflow_threshold_value.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthOper(Entity):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:   :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:   :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"

                            self.application_jitter = YLeaf(YType.uint32, "application-jitter")

                            self.application_reject_reason = YLeaf(YType.enumeration, "application-reject-reason")

                            self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                            self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                            self.collect_only_requested_bandwidth = YLeaf(YType.uint32, "collect-only-requested-bandwidth")

                            self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                            self.last_application_trigger = YLeaf(YType.enumeration, "last-application-trigger")

                            self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                            self.overflow_early_bw_applications = YLeaf(YType.uint32, "overflow-early-bw-applications")

                            self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                            self.threshold_overflows = YLeaf(YType.uint32, "threshold-overflows")

                            self.threshold_underflows = YLeaf(YType.uint32, "threshold-underflows")

                            self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                            self.time_left_collection = YLeaf(YType.uint32, "time-left-collection")

                            self.underflow_early_bw_applications = YLeaf(YType.uint32, "underflow-early-bw-applications")

                            self.underflow_highest_bandwidth = YLeaf(YType.uint32, "underflow-highest-bandwidth")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_jitter",
                                            "application_reject_reason",
                                            "bandwidth_applications",
                                            "bandwidth_pool_type",
                                            "collect_only_requested_bandwidth",
                                            "highest_bandwidth",
                                            "last_application_trigger",
                                            "last_bandwidth_applied",
                                            "overflow_early_bw_applications",
                                            "samples_collected",
                                            "threshold_overflows",
                                            "threshold_underflows",
                                            "time_left_application",
                                            "time_left_collection",
                                            "underflow_early_bw_applications",
                                            "underflow_highest_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_jitter.is_set or
                                self.application_reject_reason.is_set or
                                self.bandwidth_applications.is_set or
                                self.bandwidth_pool_type.is_set or
                                self.collect_only_requested_bandwidth.is_set or
                                self.highest_bandwidth.is_set or
                                self.last_application_trigger.is_set or
                                self.last_bandwidth_applied.is_set or
                                self.overflow_early_bw_applications.is_set or
                                self.samples_collected.is_set or
                                self.threshold_overflows.is_set or
                                self.threshold_underflows.is_set or
                                self.time_left_application.is_set or
                                self.time_left_collection.is_set or
                                self.underflow_early_bw_applications.is_set or
                                self.underflow_highest_bandwidth.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_jitter.yfilter != YFilter.not_set or
                                self.application_reject_reason.yfilter != YFilter.not_set or
                                self.bandwidth_applications.yfilter != YFilter.not_set or
                                self.bandwidth_pool_type.yfilter != YFilter.not_set or
                                self.collect_only_requested_bandwidth.yfilter != YFilter.not_set or
                                self.highest_bandwidth.yfilter != YFilter.not_set or
                                self.last_application_trigger.yfilter != YFilter.not_set or
                                self.last_bandwidth_applied.yfilter != YFilter.not_set or
                                self.overflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.samples_collected.yfilter != YFilter.not_set or
                                self.threshold_overflows.yfilter != YFilter.not_set or
                                self.threshold_underflows.yfilter != YFilter.not_set or
                                self.time_left_application.yfilter != YFilter.not_set or
                                self.time_left_collection.yfilter != YFilter.not_set or
                                self.underflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.underflow_highest_bandwidth.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-oper" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_jitter.is_set or self.application_jitter.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_jitter.get_name_leafdata())
                            if (self.application_reject_reason.is_set or self.application_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_reject_reason.get_name_leafdata())
                            if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                            if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                            if (self.collect_only_requested_bandwidth.is_set or self.collect_only_requested_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collect_only_requested_bandwidth.get_name_leafdata())
                            if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                            if (self.last_application_trigger.is_set or self.last_application_trigger.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_trigger.get_name_leafdata())
                            if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                            if (self.overflow_early_bw_applications.is_set or self.overflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_early_bw_applications.get_name_leafdata())
                            if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.samples_collected.get_name_leafdata())
                            if (self.threshold_overflows.is_set or self.threshold_overflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_overflows.get_name_leafdata())
                            if (self.threshold_underflows.is_set or self.threshold_underflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_underflows.get_name_leafdata())
                            if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_application.get_name_leafdata())
                            if (self.time_left_collection.is_set or self.time_left_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_collection.get_name_leafdata())
                            if (self.underflow_early_bw_applications.is_set or self.underflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_early_bw_applications.get_name_leafdata())
                            if (self.underflow_highest_bandwidth.is_set or self.underflow_highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_highest_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-jitter" or name == "application-reject-reason" or name == "bandwidth-applications" or name == "bandwidth-pool-type" or name == "collect-only-requested-bandwidth" or name == "highest-bandwidth" or name == "last-application-trigger" or name == "last-bandwidth-applied" or name == "overflow-early-bw-applications" or name == "samples-collected" or name == "threshold-overflows" or name == "threshold-underflows" or name == "time-left-application" or name == "time-left-collection" or name == "underflow-early-bw-applications" or name == "underflow-highest-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-jitter"):
                                self.application_jitter = value
                                self.application_jitter.value_namespace = name_space
                                self.application_jitter.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-reject-reason"):
                                self.application_reject_reason = value
                                self.application_reject_reason.value_namespace = name_space
                                self.application_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-applications"):
                                self.bandwidth_applications = value
                                self.bandwidth_applications.value_namespace = name_space
                                self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-pool-type"):
                                self.bandwidth_pool_type = value
                                self.bandwidth_pool_type.value_namespace = name_space
                                self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "collect-only-requested-bandwidth"):
                                self.collect_only_requested_bandwidth = value
                                self.collect_only_requested_bandwidth.value_namespace = name_space
                                self.collect_only_requested_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "highest-bandwidth"):
                                self.highest_bandwidth = value
                                self.highest_bandwidth.value_namespace = name_space
                                self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-trigger"):
                                self.last_application_trigger = value
                                self.last_application_trigger.value_namespace = name_space
                                self.last_application_trigger.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-bandwidth-applied"):
                                self.last_bandwidth_applied = value
                                self.last_bandwidth_applied.value_namespace = name_space
                                self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-early-bw-applications"):
                                self.overflow_early_bw_applications = value
                                self.overflow_early_bw_applications.value_namespace = name_space
                                self.overflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "samples-collected"):
                                self.samples_collected = value
                                self.samples_collected.value_namespace = name_space
                                self.samples_collected.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-overflows"):
                                self.threshold_overflows = value
                                self.threshold_overflows.value_namespace = name_space
                                self.threshold_overflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-underflows"):
                                self.threshold_underflows = value
                                self.threshold_underflows.value_namespace = name_space
                                self.threshold_underflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-application"):
                                self.time_left_application = value
                                self.time_left_application.value_namespace = name_space
                                self.time_left_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-collection"):
                                self.time_left_collection = value
                                self.time_left_collection.value_namespace = name_space
                                self.time_left_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-early-bw-applications"):
                                self.underflow_early_bw_applications = value
                                self.underflow_early_bw_applications.value_namespace = name_space
                                self.underflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-highest-bandwidth"):
                                self.underflow_highest_bandwidth = value
                                self.underflow_highest_bandwidth.value_namespace = name_space
                                self.underflow_highest_bandwidth.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.is_bidirectional.is_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_data()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_data()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bidirectional.yfilter != YFilter.not_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_operation()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_operation()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "p2p-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bidirectional.is_set or self.is_bidirectional.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bidirectional.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "auto-bandwidth-config"):
                            if (self.auto_bandwidth_config is None):
                                self.auto_bandwidth_config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthConfig()
                                self.auto_bandwidth_config.parent = self
                                self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                            return self.auto_bandwidth_config

                        if (child_yang_name == "auto-bandwidth-oper"):
                            if (self.auto_bandwidth_oper is None):
                                self.auto_bandwidth_oper = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthOper()
                                self.auto_bandwidth_oper.parent = self
                                self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                            return self.auto_bandwidth_oper

                        if (child_yang_name == "auto-bandwidth-status"):
                            if (self.auto_bandwidth_status is None):
                                self.auto_bandwidth_status = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo.AutoBandwidthStatus()
                                self.auto_bandwidth_status.parent = self
                                self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                            return self.auto_bandwidth_status

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-bandwidth-config" or name == "auto-bandwidth-oper" or name == "auto-bandwidth-status" or name == "is-bidirectional"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bidirectional"):
                            self.is_bidirectional = value
                            self.is_bidirectional.value_namespace = name_space
                            self.is_bidirectional.value_namespace_prefix = name_space_prefix


                class History(Entity):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:   :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup>`
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:   :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup>`
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:   :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup>`
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:   :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup>`
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:   :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail>`
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:   :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail>`
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:   :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup>`
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:   :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup>`
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:   :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup>`
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:   :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup>`
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:   :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "nni-tunnel"

                        self.current_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"
                        self._children_yang_names.add("current-setup")

                        self.gmpls_other_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                        self._children_yang_names.add("gmpls-other-protect-setup")

                        self.gmpls_other_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                        self._children_yang_names.add("gmpls-other-setup")

                        self.gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                        self._children_yang_names.add("gmpls-path-protect-setup")

                        self.last_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                        self._children_yang_names.add("last-re-opt-fail")

                        self.last_stdby_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._children_yang_names.add("last-stdby-re-opt-fail")

                        self.previous_gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                        self._children_yang_names.add("previous-gmpls-path-protect-setup")

                        self.previous_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"
                        self._children_yang_names.add("previous-setup")

                        self.reopt_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"
                        self._children_yang_names.add("reopt-setup")

                        self.standby_reopt_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                        self._children_yang_names.add("standby-reopt-setup")

                        self.standby_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"
                        self._children_yang_names.add("standby-setup")


                    class CurrentSetup(Entity):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:   :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes>`
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\:  str
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"

                            self.current_setup_last_error = YLeaf(YType.str, "current-setup-last-error")

                            self.current_setup_timer = YLeaf(YType.uint32, "current-setup-timer")

                            self.selection_reason = YLeaf(YType.str, "selection-reason")

                            self.connected_uptimes = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._children_yang_names.add("connected-uptimes")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("current_setup_last_error",
                                            "current_setup_timer",
                                            "selection_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__setattr__(name, value)


                        class ConnectedUptimes(Entity):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"

                                self.current_lsp_uptime = YLeaf(YType.uint32, "current-lsp-uptime")

                                self.current_uptime = YLeaf(YType.uint32, "current-uptime")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("current_lsp_uptime",
                                                "current_uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.current_lsp_uptime.is_set or
                                    self.current_uptime.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.current_lsp_uptime.yfilter != YFilter.not_set or
                                    self.current_uptime.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "connected-uptimes" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.current_lsp_uptime.is_set or self.current_lsp_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_lsp_uptime.get_name_leafdata())
                                if (self.current_uptime.is_set or self.current_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "current-lsp-uptime" or name == "current-uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "current-lsp-uptime"):
                                    self.current_lsp_uptime = value
                                    self.current_lsp_uptime.value_namespace = name_space
                                    self.current_lsp_uptime.value_namespace_prefix = name_space_prefix
                                if(value_path == "current-uptime"):
                                    self.current_uptime = value
                                    self.current_uptime.value_namespace = name_space
                                    self.current_uptime.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.current_setup_last_error.is_set or
                                self.current_setup_timer.is_set or
                                self.selection_reason.is_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.current_setup_last_error.yfilter != YFilter.not_set or
                                self.current_setup_timer.yfilter != YFilter.not_set or
                                self.selection_reason.yfilter != YFilter.not_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "current-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.current_setup_last_error.is_set or self.current_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_last_error.get_name_leafdata())
                            if (self.current_setup_timer.is_set or self.current_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_timer.get_name_leafdata())
                            if (self.selection_reason.is_set or self.selection_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.selection_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "connected-uptimes"):
                                if (self.connected_uptimes is None):
                                    self.connected_uptimes = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                                    self.connected_uptimes.parent = self
                                    self._children_name_map["connected_uptimes"] = "connected-uptimes"
                                return self.connected_uptimes

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "connected-uptimes" or name == "current-setup-last-error" or name == "current-setup-timer" or name == "selection-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "current-setup-last-error"):
                                self.current_setup_last_error = value
                                self.current_setup_last_error.value_namespace = name_space
                                self.current_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "current-setup-timer"):
                                self.current_setup_timer = value
                                self.current_setup_timer.value_namespace = name_space
                                self.current_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "selection-reason"):
                                self.selection_reason = value
                                self.selection_reason.value_namespace = name_space
                                self.selection_reason.value_namespace_prefix = name_space_prefix


                    class ReoptSetup(Entity):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class GmplsPathProtectSetup(Entity):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\:  str
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.protecting_setup_last_error = YLeaf(YType.str, "protecting-setup-last-error")

                            self.protecting_setup_timer = YLeaf(YType.uint32, "protecting-setup-timer")

                            self.protecting_setup_uptime = YLeaf(YType.uint32, "protecting-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protecting_setup_last_error",
                                            "protecting_setup_timer",
                                            "protecting_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.protecting_setup_last_error.is_set or
                                self.protecting_setup_timer.is_set or
                                self.protecting_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protecting_setup_last_error.yfilter != YFilter.not_set or
                                self.protecting_setup_timer.yfilter != YFilter.not_set or
                                self.protecting_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protecting_setup_last_error.is_set or self.protecting_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_last_error.get_name_leafdata())
                            if (self.protecting_setup_timer.is_set or self.protecting_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_timer.get_name_leafdata())
                            if (self.protecting_setup_uptime.is_set or self.protecting_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protecting-setup-last-error" or name == "protecting-setup-timer" or name == "protecting-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protecting-setup-last-error"):
                                self.protecting_setup_last_error = value
                                self.protecting_setup_last_error.value_namespace = name_space
                                self.protecting_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-timer"):
                                self.protecting_setup_timer = value
                                self.protecting_setup_timer.value_namespace = name_space
                                self.protecting_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-uptime"):
                                self.protecting_setup_uptime = value
                                self.protecting_setup_uptime.value_namespace = name_space
                                self.protecting_setup_uptime.value_namespace_prefix = name_space_prefix


                    class PreviousSetup(Entity):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"

                            self.previous_fail_reason = YLeaf(YType.str, "previous-fail-reason")

                            self.previous_path_option = YLeaf(YType.str, "previous-path-option")

                            self.previous_setup_last_error = YLeaf(YType.str, "previous-setup-last-error")

                            self.previous_tunnel_instance = YLeaf(YType.uint32, "previous-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_fail_reason",
                                            "previous_path_option",
                                            "previous_setup_last_error",
                                            "previous_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_fail_reason.is_set or
                                self.previous_path_option.is_set or
                                self.previous_setup_last_error.is_set or
                                self.previous_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_fail_reason.yfilter != YFilter.not_set or
                                self.previous_path_option.yfilter != YFilter.not_set or
                                self.previous_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_fail_reason.is_set or self.previous_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_fail_reason.get_name_leafdata())
                            if (self.previous_path_option.is_set or self.previous_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_path_option.get_name_leafdata())
                            if (self.previous_setup_last_error.is_set or self.previous_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_setup_last_error.get_name_leafdata())
                            if (self.previous_tunnel_instance.is_set or self.previous_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-fail-reason" or name == "previous-path-option" or name == "previous-setup-last-error" or name == "previous-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-fail-reason"):
                                self.previous_fail_reason = value
                                self.previous_fail_reason.value_namespace = name_space
                                self.previous_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-path-option"):
                                self.previous_path_option = value
                                self.previous_path_option.value_namespace = name_space
                                self.previous_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-setup-last-error"):
                                self.previous_setup_last_error = value
                                self.previous_setup_last_error.value_namespace = name_space
                                self.previous_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-tunnel-instance"):
                                self.previous_tunnel_instance = value
                                self.previous_tunnel_instance.value_namespace = name_space
                                self.previous_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class PreviousGmplsPathProtectSetup(Entity):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.previous_protect_fail_reason = YLeaf(YType.str, "previous-protect-fail-reason")

                            self.previous_protect_path_option = YLeaf(YType.str, "previous-protect-path-option")

                            self.previous_protect_setup_last_error = YLeaf(YType.str, "previous-protect-setup-last-error")

                            self.previous_protect_tunnel_instance = YLeaf(YType.uint32, "previous-protect-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_protect_fail_reason",
                                            "previous_protect_path_option",
                                            "previous_protect_setup_last_error",
                                            "previous_protect_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_protect_fail_reason.is_set or
                                self.previous_protect_path_option.is_set or
                                self.previous_protect_setup_last_error.is_set or
                                self.previous_protect_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_protect_fail_reason.yfilter != YFilter.not_set or
                                self.previous_protect_path_option.yfilter != YFilter.not_set or
                                self.previous_protect_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_protect_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_protect_fail_reason.is_set or self.previous_protect_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_fail_reason.get_name_leafdata())
                            if (self.previous_protect_path_option.is_set or self.previous_protect_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_path_option.get_name_leafdata())
                            if (self.previous_protect_setup_last_error.is_set or self.previous_protect_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_setup_last_error.get_name_leafdata())
                            if (self.previous_protect_tunnel_instance.is_set or self.previous_protect_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-protect-fail-reason" or name == "previous-protect-path-option" or name == "previous-protect-setup-last-error" or name == "previous-protect-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-protect-fail-reason"):
                                self.previous_protect_fail_reason = value
                                self.previous_protect_fail_reason.value_namespace = name_space
                                self.previous_protect_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-path-option"):
                                self.previous_protect_path_option = value
                                self.previous_protect_path_option.value_namespace = name_space
                                self.previous_protect_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-setup-last-error"):
                                self.previous_protect_setup_last_error = value
                                self.previous_protect_setup_last_error.value_namespace = name_space
                                self.previous_protect_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-tunnel-instance"):
                                self.previous_protect_tunnel_instance = value
                                self.previous_protect_tunnel_instance.value_namespace = name_space
                                self.previous_protect_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class GmplsOtherSetup(Entity):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class GmplsOtherProtectSetup(Entity):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class StandbySetup(Entity):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"

                            self.standby_lsp_uptime = YLeaf(YType.uint32, "standby-lsp-uptime")

                            self.standby_setup_timer = YLeaf(YType.uint32, "standby-setup-timer")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("standby_lsp_uptime",
                                            "standby_setup_timer") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.standby_lsp_uptime.is_set or
                                self.standby_setup_timer.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.standby_lsp_uptime.yfilter != YFilter.not_set or
                                self.standby_setup_timer.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.standby_lsp_uptime.is_set or self.standby_lsp_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_lsp_uptime.get_name_leafdata())
                            if (self.standby_setup_timer.is_set or self.standby_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_setup_timer.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "standby-lsp-uptime" or name == "standby-setup-timer"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "standby-lsp-uptime"):
                                self.standby_lsp_uptime = value
                                self.standby_lsp_uptime.value_namespace = name_space
                                self.standby_lsp_uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "standby-setup-timer"):
                                self.standby_setup_timer = value
                                self.standby_setup_timer.value_namespace = name_space
                                self.standby_setup_timer.value_namespace_prefix = name_space_prefix


                    class StandbyReoptSetup(Entity):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class LastReOptFail(Entity):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix


                    class LastStdbyReOptFail(Entity):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-stdby-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.current_setup is not None and self.current_setup.has_data()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_data()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_data()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_data()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_data()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_data()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_data()) or
                            (self.previous_setup is not None and self.previous_setup.has_data()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_data()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_data()) or
                            (self.standby_setup is not None and self.standby_setup.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.current_setup is not None and self.current_setup.has_operation()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_operation()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_operation()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_operation()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_operation()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_operation()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_operation()) or
                            (self.previous_setup is not None and self.previous_setup.has_operation()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_operation()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_operation()) or
                            (self.standby_setup is not None and self.standby_setup.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "current-setup"):
                            if (self.current_setup is None):
                                self.current_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                                self.current_setup.parent = self
                                self._children_name_map["current_setup"] = "current-setup"
                            return self.current_setup

                        if (child_yang_name == "gmpls-other-protect-setup"):
                            if (self.gmpls_other_protect_setup is None):
                                self.gmpls_other_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                                self.gmpls_other_protect_setup.parent = self
                                self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                            return self.gmpls_other_protect_setup

                        if (child_yang_name == "gmpls-other-setup"):
                            if (self.gmpls_other_setup is None):
                                self.gmpls_other_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                                self.gmpls_other_setup.parent = self
                                self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                            return self.gmpls_other_setup

                        if (child_yang_name == "gmpls-path-protect-setup"):
                            if (self.gmpls_path_protect_setup is None):
                                self.gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                                self.gmpls_path_protect_setup.parent = self
                                self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                            return self.gmpls_path_protect_setup

                        if (child_yang_name == "last-re-opt-fail"):
                            if (self.last_re_opt_fail is None):
                                self.last_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                                self.last_re_opt_fail.parent = self
                                self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                            return self.last_re_opt_fail

                        if (child_yang_name == "last-stdby-re-opt-fail"):
                            if (self.last_stdby_re_opt_fail is None):
                                self.last_stdby_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                                self.last_stdby_re_opt_fail.parent = self
                                self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                            return self.last_stdby_re_opt_fail

                        if (child_yang_name == "previous-gmpls-path-protect-setup"):
                            if (self.previous_gmpls_path_protect_setup is None):
                                self.previous_gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                                self.previous_gmpls_path_protect_setup.parent = self
                                self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                            return self.previous_gmpls_path_protect_setup

                        if (child_yang_name == "previous-setup"):
                            if (self.previous_setup is None):
                                self.previous_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                                self.previous_setup.parent = self
                                self._children_name_map["previous_setup"] = "previous-setup"
                            return self.previous_setup

                        if (child_yang_name == "reopt-setup"):
                            if (self.reopt_setup is None):
                                self.reopt_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                                self.reopt_setup.parent = self
                                self._children_name_map["reopt_setup"] = "reopt-setup"
                            return self.reopt_setup

                        if (child_yang_name == "standby-reopt-setup"):
                            if (self.standby_reopt_setup is None):
                                self.standby_reopt_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                                self.standby_reopt_setup.parent = self
                                self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                            return self.standby_reopt_setup

                        if (child_yang_name == "standby-setup"):
                            if (self.standby_setup is None):
                                self.standby_setup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                                self.standby_setup.parent = self
                                self._children_name_map["standby_setup"] = "standby-setup"
                            return self.standby_setup

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "current-setup" or name == "gmpls-other-protect-setup" or name == "gmpls-other-setup" or name == "gmpls-path-protect-setup" or name == "last-re-opt-fail" or name == "last-stdby-re-opt-fail" or name == "previous-gmpls-path-protect-setup" or name == "previous-setup" or name == "reopt-setup" or name == "standby-reopt-setup" or name == "standby-setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "nni-tunnel"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class AutoBackup(Entity):
                    """
                    Autobackup Information
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\:  str
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of    :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep>`
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\:  bool
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\:  bool
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\:  str
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:   :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "nni-tunnel"

                        self.ab_protected_interface = YLeaf(YType.str, "ab-protected-interface")

                        self.ab_protection_type = YLeaf(YType.enumeration, "ab-protection-type")

                        self.is_unused_removal_timer_running = YLeaf(YType.boolean, "is-unused-removal-timer-running")

                        self.is_using_srlg = YLeaf(YType.boolean, "is-using-srlg")

                        self.protected_address = YLeaf(YType.str, "protected-address")

                        self.protected_ls_ps = YLeaf(YType.uint32, "protected-ls-ps")

                        self.protected_s2_ls = YLeaf(YType.uint32, "protected-s2-ls")

                        self.sharing_families = YLeaf(YType.uint32, "sharing-families")

                        self.srlg_prot_type = YLeaf(YType.enumeration, "srlg-prot-type")

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.unused_removal_remaining_time = YLeaf(YType.uint32, "unused-removal-remaining-time")

                        self.weighted_srlg_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                        self._children_yang_names.add("weighted-srlg-info")

                        self.iep = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("ab_protected_interface",
                                        "ab_protection_type",
                                        "is_unused_removal_timer_running",
                                        "is_using_srlg",
                                        "protected_address",
                                        "protected_ls_ps",
                                        "protected_s2_ls",
                                        "sharing_families",
                                        "srlg_prot_type",
                                        "tunnel_attribute_set_name",
                                        "unused_removal_remaining_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__setattr__(name, value)


                    class WeightedSrlgInfo(Entity):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of    :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of    :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)


                        class ProtectedInterfaceSrlg(Entity):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                                self.srlg = YLeaf(YType.uint32, "srlg")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admin_weight",
                                                "srlg",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admin_weight.is_set or
                                    self.srlg.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admin_weight.yfilter != YFilter.not_set or
                                    self.srlg.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protected-interface-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                                if (self.srlg.is_set or self.srlg.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admin-weight" or name == "srlg" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admin-weight"):
                                    self.admin_weight = value
                                    self.admin_weight.value_namespace = name_space
                                    self.admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg"):
                                    self.srlg = value
                                    self.srlg.value_namespace = name_space
                                    self.srlg.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class WeightedSrlgHop(Entity):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of    :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.aggregate_admin_weight = YLeaf(YType.uint64, "aggregate-admin-weight")

                                self.from_address = YLeaf(YType.str, "from-address")

                                self.to_address = YLeaf(YType.str, "to-address")

                                self.common_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("aggregate_admin_weight",
                                                "from_address",
                                                "to_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)


                            class CommonSrlg(Entity):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "common-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.common_srlg:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.aggregate_admin_weight.is_set or
                                    self.from_address.is_set or
                                    self.to_address.is_set)

                            def has_operation(self):
                                for c in self.common_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.aggregate_admin_weight.yfilter != YFilter.not_set or
                                    self.from_address.yfilter != YFilter.not_set or
                                    self.to_address.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "weighted-srlg-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.aggregate_admin_weight.is_set or self.aggregate_admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.aggregate_admin_weight.get_name_leafdata())
                                if (self.from_address.is_set or self.from_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.from_address.get_name_leafdata())
                                if (self.to_address.is_set or self.to_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.to_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "common-srlg"):
                                    for c in self.common_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.common_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "common-srlg" or name == "aggregate-admin-weight" or name == "from-address" or name == "to-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "aggregate-admin-weight"):
                                    self.aggregate_admin_weight = value
                                    self.aggregate_admin_weight.value_namespace = name_space
                                    self.aggregate_admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "from-address"):
                                    self.from_address = value
                                    self.from_address.value_namespace = name_space
                                    self.from_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "to-address"):
                                    self.to_address = value
                                    self.to_address.value_namespace = name_space
                                    self.to_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_data()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_operation()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "weighted-srlg-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protected-interface-srlg"):
                                for c in self.protected_interface_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protected_interface_srlg.append(c)
                                return c

                            if (child_yang_name == "weighted-srlg-hop"):
                                for c in self.weighted_srlg_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.weighted_srlg_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface-srlg" or name == "weighted-srlg-hop"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Iep(Entity):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of    :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop>`
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"

                            self.path_option_id = YLeaf(YType.uint32, "path-option-id")

                            self.iep_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("path_option_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__setattr__(name, value)


                        class IepHop(Entity):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:   :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"

                                self.hop_index = YLeaf(YType.uint32, "hop-index")

                                self.iep_hop_address = YLeaf(YType.str, "iep-hop-address")

                                self.iep_hop_type = YLeaf(YType.enumeration, "iep-hop-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_index",
                                                "iep_hop_address",
                                                "iep_hop_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.hop_index.is_set or
                                    self.iep_hop_address.is_set or
                                    self.iep_hop_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_index.yfilter != YFilter.not_set or
                                    self.iep_hop_address.yfilter != YFilter.not_set or
                                    self.iep_hop_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iep-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_index.is_set or self.hop_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_index.get_name_leafdata())
                                if (self.iep_hop_address.is_set or self.iep_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_address.get_name_leafdata())
                                if (self.iep_hop_type.is_set or self.iep_hop_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-index" or name == "iep-hop-address" or name == "iep-hop-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-index"):
                                    self.hop_index = value
                                    self.hop_index.value_namespace = name_space
                                    self.hop_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-address"):
                                    self.iep_hop_address = value
                                    self.iep_hop_address.value_namespace = name_space
                                    self.iep_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-type"):
                                    self.iep_hop_type = value
                                    self.iep_hop_type.value_namespace = name_space
                                    self.iep_hop_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.iep_hop:
                                if (c.has_data()):
                                    return True
                            return self.path_option_id.is_set

                        def has_operation(self):
                            for c in self.iep_hop:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.path_option_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "iep" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.path_option_id.is_set or self.path_option_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "iep-hop"):
                                for c in self.iep_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.iep_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "iep-hop" or name == "path-option-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "path-option-id"):
                                self.path_option_id = value
                                self.path_option_id.value_namespace = name_space
                                self.path_option_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.iep:
                            if (c.has_data()):
                                return True
                        return (
                            self.ab_protected_interface.is_set or
                            self.ab_protection_type.is_set or
                            self.is_unused_removal_timer_running.is_set or
                            self.is_using_srlg.is_set or
                            self.protected_address.is_set or
                            self.protected_ls_ps.is_set or
                            self.protected_s2_ls.is_set or
                            self.sharing_families.is_set or
                            self.srlg_prot_type.is_set or
                            self.tunnel_attribute_set_name.is_set or
                            self.unused_removal_remaining_time.is_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_data()))

                    def has_operation(self):
                        for c in self.iep:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.ab_protected_interface.yfilter != YFilter.not_set or
                            self.ab_protection_type.yfilter != YFilter.not_set or
                            self.is_unused_removal_timer_running.yfilter != YFilter.not_set or
                            self.is_using_srlg.yfilter != YFilter.not_set or
                            self.protected_address.yfilter != YFilter.not_set or
                            self.protected_ls_ps.yfilter != YFilter.not_set or
                            self.protected_s2_ls.yfilter != YFilter.not_set or
                            self.sharing_families.yfilter != YFilter.not_set or
                            self.srlg_prot_type.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.unused_removal_remaining_time.yfilter != YFilter.not_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-backup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.ab_protected_interface.is_set or self.ab_protected_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protected_interface.get_name_leafdata())
                        if (self.ab_protection_type.is_set or self.ab_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protection_type.get_name_leafdata())
                        if (self.is_unused_removal_timer_running.is_set or self.is_unused_removal_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unused_removal_timer_running.get_name_leafdata())
                        if (self.is_using_srlg.is_set or self.is_using_srlg.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_using_srlg.get_name_leafdata())
                        if (self.protected_address.is_set or self.protected_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_address.get_name_leafdata())
                        if (self.protected_ls_ps.is_set or self.protected_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_ls_ps.get_name_leafdata())
                        if (self.protected_s2_ls.is_set or self.protected_s2_ls.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_s2_ls.get_name_leafdata())
                        if (self.sharing_families.is_set or self.sharing_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sharing_families.get_name_leafdata())
                        if (self.srlg_prot_type.is_set or self.srlg_prot_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_prot_type.get_name_leafdata())
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.unused_removal_remaining_time.is_set or self.unused_removal_remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unused_removal_remaining_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "iep"):
                            for c in self.iep:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.iep.append(c)
                            return c

                        if (child_yang_name == "weighted-srlg-info"):
                            if (self.weighted_srlg_info is None):
                                self.weighted_srlg_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                                self.weighted_srlg_info.parent = self
                                self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                            return self.weighted_srlg_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "iep" or name == "weighted-srlg-info" or name == "ab-protected-interface" or name == "ab-protection-type" or name == "is-unused-removal-timer-running" or name == "is-using-srlg" or name == "protected-address" or name == "protected-ls-ps" or name == "protected-s2-ls" or name == "sharing-families" or name == "srlg-prot-type" or name == "tunnel-attribute-set-name" or name == "unused-removal-remaining-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "ab-protected-interface"):
                            self.ab_protected_interface = value
                            self.ab_protected_interface.value_namespace = name_space
                            self.ab_protected_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ab-protection-type"):
                            self.ab_protection_type = value
                            self.ab_protection_type.value_namespace = name_space
                            self.ab_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unused-removal-timer-running"):
                            self.is_unused_removal_timer_running = value
                            self.is_unused_removal_timer_running.value_namespace = name_space
                            self.is_unused_removal_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-using-srlg"):
                            self.is_using_srlg = value
                            self.is_using_srlg.value_namespace = name_space
                            self.is_using_srlg.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-address"):
                            self.protected_address = value
                            self.protected_address.value_namespace = name_space
                            self.protected_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-ls-ps"):
                            self.protected_ls_ps = value
                            self.protected_ls_ps.value_namespace = name_space
                            self.protected_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-s2-ls"):
                            self.protected_s2_ls = value
                            self.protected_s2_ls.value_namespace = name_space
                            self.protected_s2_ls.value_namespace_prefix = name_space_prefix
                        if(value_path == "sharing-families"):
                            self.sharing_families = value
                            self.sharing_families.value_namespace = name_space
                            self.sharing_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-prot-type"):
                            self.srlg_prot_type = value
                            self.srlg_prot_type.value_namespace = name_space
                            self.srlg_prot_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "unused-removal-remaining-time"):
                            self.unused_removal_remaining_time = value
                            self.unused_removal_remaining_time.value_namespace = name_space
                            self.unused_removal_remaining_time.value_namespace_prefix = name_space_prefix


                class AutoMesh(Entity):
                    """
                    Automesh Information
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "nni-tunnel"

                        self.is_tunnel_unused_timer_running = YLeaf(YType.boolean, "is-tunnel-unused-timer-running")

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.mesh_group_type = YLeaf(YType.enumeration, "mesh-group-type")

                        self.remaining_unused_time = YLeaf(YType.uint32, "remaining-unused-time")

                        self.tunnel_destination_list_name = YLeaf(YType.str, "tunnel-destination-list-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_tunnel_unused_timer_running",
                                        "mesh_group_id",
                                        "mesh_group_type",
                                        "remaining_unused_time",
                                        "tunnel_destination_list_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_tunnel_unused_timer_running.is_set or
                            self.mesh_group_id.is_set or
                            self.mesh_group_type.is_set or
                            self.remaining_unused_time.is_set or
                            self.tunnel_destination_list_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.mesh_group_type.yfilter != YFilter.not_set or
                            self.remaining_unused_time.yfilter != YFilter.not_set or
                            self.tunnel_destination_list_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-mesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_tunnel_unused_timer_running.is_set or self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_tunnel_unused_timer_running.get_name_leafdata())
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.mesh_group_type.is_set or self.mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_type.get_name_leafdata())
                        if (self.remaining_unused_time.is_set or self.remaining_unused_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_unused_time.get_name_leafdata())
                        if (self.tunnel_destination_list_name.is_set or self.tunnel_destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_destination_list_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-tunnel-unused-timer-running" or name == "mesh-group-id" or name == "mesh-group-type" or name == "remaining-unused-time" or name == "tunnel-destination-list-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-tunnel-unused-timer-running"):
                            self.is_tunnel_unused_timer_running = value
                            self.is_tunnel_unused_timer_running.value_namespace = name_space
                            self.is_tunnel_unused_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-type"):
                            self.mesh_group_type = value
                            self.mesh_group_type.value_namespace = name_space
                            self.mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-unused-time"):
                            self.remaining_unused_time = value
                            self.remaining_unused_time.value_namespace = name_space
                            self.remaining_unused_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-destination-list-name"):
                            self.tunnel_destination_list_name = value
                            self.tunnel_destination_list_name.value_namespace = name_space
                            self.tunnel_destination_list_name.value_namespace_prefix = name_space_prefix


                class AutoPcc(Entity):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\:  str
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\:  bool
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "nni-tunnel"

                        self.creator_address = YLeaf(YType.str, "creator-address")

                        self.creator_id = YLeaf(YType.str, "creator-id")

                        self.has_creator_id = YLeaf(YType.boolean, "has-creator-id")

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plspid = YLeaf(YType.uint32, "plspid")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("creator_address",
                                        "creator_id",
                                        "has_creator_id",
                                        "operationally_up",
                                        "owner_address",
                                        "plspid",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.creator_address.is_set or
                            self.creator_id.is_set or
                            self.has_creator_id.is_set or
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plspid.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.creator_address.yfilter != YFilter.not_set or
                            self.creator_id.yfilter != YFilter.not_set or
                            self.has_creator_id.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plspid.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-pcc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.creator_address.is_set or self.creator_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_address.get_name_leafdata())
                        if (self.creator_id.is_set or self.creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_id.get_name_leafdata())
                        if (self.has_creator_id.is_set or self.has_creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_creator_id.get_name_leafdata())
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plspid.is_set or self.plspid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plspid.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "creator-address" or name == "creator-id" or name == "has-creator-id" or name == "operationally-up" or name == "owner-address" or name == "plspid" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "creator-address"):
                            self.creator_address = value
                            self.creator_address.value_namespace = name_space
                            self.creator_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "creator-id"):
                            self.creator_id = value
                            self.creator_id.value_namespace = name_space
                            self.creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-creator-id"):
                            self.has_creator_id = value
                            self.has_creator_id.value_namespace = name_space
                            self.has_creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plspid"):
                            self.plspid = value
                            self.plspid.value_namespace = name_space
                            self.plspid.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class PceDelegation(Entity):
                    """
                    PCE Delegation information
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "nni-tunnel"

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plsp_id = YLeaf(YType.uint32, "plsp-id")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("operationally_up",
                                        "owner_address",
                                        "plsp_id",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plsp_id.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plsp_id.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pce-delegation" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plsp_id.is_set or self.plsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plsp_id.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "operationally-up" or name == "owner-address" or name == "plsp-id" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plsp-id"):
                            self.plsp_id = value
                            self.plsp_id.value_namespace = name_space
                            self.plsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class SoftPreemption(Entity):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:   :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:   :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters>`
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of    :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError>`
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "nni-tunnel"

                        self.preemption_pending_resolution = YLeaf(YType.enumeration, "preemption-pending-resolution")

                        self.status = YLeaf(YType.enumeration, "status")

                        self.time_in_preemption_pending = YLeaf(YType.uint16, "time-in-preemption-pending")

                        self.soft_preemption_counters = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                        self._children_yang_names.add("soft-preemption-counters")

                        self.soft_preemption_path_error = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("preemption_pending_resolution",
                                        "status",
                                        "time_in_preemption_pending") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__setattr__(name, value)


                    class SoftPreemptionCounters(Entity):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"

                            self.frr_triggered_ls_ps = YLeaf(YType.uint32, "frr-triggered-ls-ps")

                            self.path_protection_switchover_ls_ps = YLeaf(YType.uint32, "path-protection-switchover-ls-ps")

                            self.reopt_completed_ls_ps = YLeaf(YType.uint32, "reopt-completed-ls-ps")

                            self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                            self.time_in_preemption_pending_avg = YLeaf(YType.uint16, "time-in-preemption-pending-avg")

                            self.time_in_preemption_pending_max = YLeaf(YType.uint16, "time-in-preemption-pending-max")

                            self.time_in_preemption_pending_min = YLeaf(YType.uint16, "time-in-preemption-pending-min")

                            self.torn_down_ls_ps = YLeaf(YType.uint32, "torn-down-ls-ps")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_triggered_ls_ps",
                                            "path_protection_switchover_ls_ps",
                                            "reopt_completed_ls_ps",
                                            "soft_preemption_events",
                                            "time_in_preemption_pending_avg",
                                            "time_in_preemption_pending_max",
                                            "time_in_preemption_pending_min",
                                            "torn_down_ls_ps") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_triggered_ls_ps.is_set or
                                self.path_protection_switchover_ls_ps.is_set or
                                self.reopt_completed_ls_ps.is_set or
                                self.soft_preemption_events.is_set or
                                self.time_in_preemption_pending_avg.is_set or
                                self.time_in_preemption_pending_max.is_set or
                                self.time_in_preemption_pending_min.is_set or
                                self.torn_down_ls_ps.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_triggered_ls_ps.yfilter != YFilter.not_set or
                                self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set or
                                self.reopt_completed_ls_ps.yfilter != YFilter.not_set or
                                self.soft_preemption_events.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_avg.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_max.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_min.yfilter != YFilter.not_set or
                                self.torn_down_ls_ps.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_triggered_ls_ps.is_set or self.frr_triggered_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_triggered_ls_ps.get_name_leafdata())
                            if (self.path_protection_switchover_ls_ps.is_set or self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_ls_ps.get_name_leafdata())
                            if (self.reopt_completed_ls_ps.is_set or self.reopt_completed_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reopt_completed_ls_ps.get_name_leafdata())
                            if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                            if (self.time_in_preemption_pending_avg.is_set or self.time_in_preemption_pending_avg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_avg.get_name_leafdata())
                            if (self.time_in_preemption_pending_max.is_set or self.time_in_preemption_pending_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_max.get_name_leafdata())
                            if (self.time_in_preemption_pending_min.is_set or self.time_in_preemption_pending_min.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_min.get_name_leafdata())
                            if (self.torn_down_ls_ps.is_set or self.torn_down_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.torn_down_ls_ps.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-triggered-ls-ps" or name == "path-protection-switchover-ls-ps" or name == "reopt-completed-ls-ps" or name == "soft-preemption-events" or name == "time-in-preemption-pending-avg" or name == "time-in-preemption-pending-max" or name == "time-in-preemption-pending-min" or name == "torn-down-ls-ps"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-triggered-ls-ps"):
                                self.frr_triggered_ls_ps = value
                                self.frr_triggered_ls_ps.value_namespace = name_space
                                self.frr_triggered_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-ls-ps"):
                                self.path_protection_switchover_ls_ps = value
                                self.path_protection_switchover_ls_ps.value_namespace = name_space
                                self.path_protection_switchover_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "reopt-completed-ls-ps"):
                                self.reopt_completed_ls_ps = value
                                self.reopt_completed_ls_ps.value_namespace = name_space
                                self.reopt_completed_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-events"):
                                self.soft_preemption_events = value
                                self.soft_preemption_events.value_namespace = name_space
                                self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-avg"):
                                self.time_in_preemption_pending_avg = value
                                self.time_in_preemption_pending_avg.value_namespace = name_space
                                self.time_in_preemption_pending_avg.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-max"):
                                self.time_in_preemption_pending_max = value
                                self.time_in_preemption_pending_max.value_namespace = name_space
                                self.time_in_preemption_pending_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-min"):
                                self.time_in_preemption_pending_min = value
                                self.time_in_preemption_pending_min.value_namespace = name_space
                                self.time_in_preemption_pending_min.value_namespace_prefix = name_space_prefix
                            if(value_path == "torn-down-ls-ps"):
                                self.torn_down_ls_ps = value
                                self.torn_down_ls_ps.value_namespace = name_space
                                self.torn_down_ls_ps.value_namespace_prefix = name_space_prefix


                    class SoftPreemptionPathError(Entity):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preempting_link_address",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preempting_link_address.is_set or
                                self.timestamp.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-path-error" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preempting-link-address" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_data()):
                                return True
                        return (
                            self.preemption_pending_resolution.is_set or
                            self.status.is_set or
                            self.time_in_preemption_pending.is_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_data()))

                    def has_operation(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.preemption_pending_resolution.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.time_in_preemption_pending.yfilter != YFilter.not_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "soft-preemption" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.preemption_pending_resolution.is_set or self.preemption_pending_resolution.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.preemption_pending_resolution.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.time_in_preemption_pending.is_set or self.time_in_preemption_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_in_preemption_pending.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "soft-preemption-counters"):
                            if (self.soft_preemption_counters is None):
                                self.soft_preemption_counters = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                                self.soft_preemption_counters.parent = self
                                self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                            return self.soft_preemption_counters

                        if (child_yang_name == "soft-preemption-path-error"):
                            for c in self.soft_preemption_path_error:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.soft_preemption_path_error.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "soft-preemption-counters" or name == "soft-preemption-path-error" or name == "preemption-pending-resolution" or name == "status" or name == "time-in-preemption-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "preemption-pending-resolution"):
                            self.preemption_pending_resolution = value
                            self.preemption_pending_resolution.value_namespace = name_space
                            self.preemption_pending_resolution.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-in-preemption-pending"):
                            self.time_in_preemption_pending = value
                            self.time_in_preemption_pending.value_namespace = name_space
                            self.time_in_preemption_pending.value_namespace_prefix = name_space_prefix


                class WdmUnitunnel(Entity):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\:  str
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "nni-tunnel"

                        self.controlled_interface = YLeaf(YType.str, "controlled-interface")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                        self.label_origin = YLeaf(YType.enumeration, "label-origin")

                        self.local_optical_router_id = YLeaf(YType.str, "local-optical-router-id")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                        self.remote_optical_router_id = YLeaf(YType.str, "remote-optical-router-id")

                        self.source_address = YLeaf(YType.str, "source-address")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        self.tunnel_role = YLeaf(YType.enumeration, "tunnel-role")

                        self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("controlled_interface",
                                        "destination_address",
                                        "extended_tunnel_id",
                                        "label_origin",
                                        "local_optical_router_id",
                                        "lsp_id",
                                        "remote_optical_router_id",
                                        "source_address",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_role",
                                        "tunnel_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.controlled_interface.is_set or
                            self.destination_address.is_set or
                            self.extended_tunnel_id.is_set or
                            self.label_origin.is_set or
                            self.local_optical_router_id.is_set or
                            self.lsp_id.is_set or
                            self.remote_optical_router_id.is_set or
                            self.source_address.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_role.is_set or
                            self.tunnel_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.controlled_interface.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.extended_tunnel_id.yfilter != YFilter.not_set or
                            self.label_origin.yfilter != YFilter.not_set or
                            self.local_optical_router_id.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.remote_optical_router_id.yfilter != YFilter.not_set or
                            self.source_address.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_role.yfilter != YFilter.not_set or
                            self.tunnel_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "wdm-unitunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.controlled_interface.is_set or self.controlled_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.controlled_interface.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                        if (self.label_origin.is_set or self.label_origin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_origin.get_name_leafdata())
                        if (self.local_optical_router_id.is_set or self.local_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_optical_router_id.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.remote_optical_router_id.is_set or self.remote_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_optical_router_id.get_name_leafdata())
                        if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_address.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_role.is_set or self.tunnel_role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_role.get_name_leafdata())
                        if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "controlled-interface" or name == "destination-address" or name == "extended-tunnel-id" or name == "label-origin" or name == "local-optical-router-id" or name == "lsp-id" or name == "remote-optical-router-id" or name == "source-address" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-role" or name == "tunnel-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "controlled-interface"):
                            self.controlled_interface = value
                            self.controlled_interface.value_namespace = name_space
                            self.controlled_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "extended-tunnel-id"):
                            self.extended_tunnel_id = value
                            self.extended_tunnel_id.value_namespace = name_space
                            self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "label-origin"):
                            self.label_origin = value
                            self.label_origin.value_namespace = name_space
                            self.label_origin.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-optical-router-id"):
                            self.local_optical_router_id = value
                            self.local_optical_router_id.value_namespace = name_space
                            self.local_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-optical-router-id"):
                            self.remote_optical_router_id = value
                            self.remote_optical_router_id.value_namespace = name_space
                            self.remote_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-address"):
                            self.source_address = value
                            self.source_address.value_namespace = name_space
                            self.source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-role"):
                            self.tunnel_role = value
                            self.tunnel_role.value_namespace = name_space
                            self.tunnel_role.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-state"):
                            self.tunnel_state = value
                            self.tunnel_state.value_namespace = name_space
                            self.tunnel_state.value_namespace_prefix = name_space_prefix


                class TransportTunnelInfo(Entity):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of    :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo>`
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:   :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni>`
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of    :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro>`
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn>`
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:   :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni>`
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.status_homepath_working = YLeaf(YType.boolean, "status-homepath-working")

                        self.egress_static_uni = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"
                        self._children_yang_names.add("egress-static-uni")

                        self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"
                        self._children_yang_names.add("otn")

                        self.static_uni = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"
                        self._children_yang_names.add("static-uni")

                        self.diversity_info = YList(self)
                        self.homepath_ero = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("status_homepath_working") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__setattr__(name, value)


                    class Otn(Entity):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:   :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.bandwidth_cfg = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._children_yang_names.add("bandwidth-cfg")


                        class BandwidthCfg(Entity):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"

                                self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                self._children_yang_names.add("odu-flex-cbr")

                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                self._children_yang_names.add("odu-flex-gfp-f-res")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("odu_level") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)


                            class OduFlexCbr(Entity):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.tolerance = YLeaf(YType.uint16, "tolerance")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "tolerance") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.tolerance.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.tolerance.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-cbr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tolerance.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "tolerance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tolerance"):
                                        self.tolerance = value
                                        self.tolerance.value_namespace = name_space
                                        self.tolerance.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFRes(Entity):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFNonRes(Entity):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.odu_level.is_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.odu_level.yfilter != YFilter.not_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-cfg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.odu_level.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "odu-flex-cbr"):
                                    if (self.odu_flex_cbr is None):
                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    return self.odu_flex_cbr

                                if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                    if (self.odu_flex_gfp_f_non_res is None):
                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    return self.odu_flex_gfp_f_non_res

                                if (child_yang_name == "odu-flex-gfp-f-res"):
                                    if (self.odu_flex_gfp_f_res is None):
                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    return self.odu_flex_gfp_f_res

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "odu-level"):
                                    self.odu_level = value
                                    self.odu_level.value_namespace = name_space
                                    self.odu_level.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-cfg"):
                                if (self.bandwidth_cfg is None):
                                    self.bandwidth_cfg = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                                    self.bandwidth_cfg.parent = self
                                    self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                                return self.bandwidth_cfg

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-cfg"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class StaticUni(Entity):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\:  str
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\:  bool
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.client_if_handle = YLeaf(YType.str, "client-if-handle")

                            self.client_odu_if_handle = YLeaf(YType.str, "client-odu-if-handle")

                            self.client_odu_name = YLeaf(YType.str, "client-odu-name")

                            self.client_port = YLeaf(YType.str, "client-port")

                            self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                            self.is_connected = YLeaf(YType.boolean, "is-connected")

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.static_uni_type = YLeaf(YType.enumeration, "static-uni-type")

                            self.term_client_if_handle = YLeaf(YType.str, "term-client-if-handle")

                            self.term_client_port = YLeaf(YType.str, "term-client-port")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("client_if_handle",
                                            "client_odu_if_handle",
                                            "client_odu_name",
                                            "client_port",
                                            "cross_connect_id",
                                            "is_connected",
                                            "local_termination",
                                            "static_uni_type",
                                            "term_client_if_handle",
                                            "term_client_port",
                                            "uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.client_if_handle.is_set or
                                self.client_odu_if_handle.is_set or
                                self.client_odu_name.is_set or
                                self.client_port.is_set or
                                self.cross_connect_id.is_set or
                                self.is_connected.is_set or
                                self.local_termination.is_set or
                                self.static_uni_type.is_set or
                                self.term_client_if_handle.is_set or
                                self.term_client_port.is_set or
                                self.uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.client_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_name.yfilter != YFilter.not_set or
                                self.client_port.yfilter != YFilter.not_set or
                                self.cross_connect_id.yfilter != YFilter.not_set or
                                self.is_connected.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.static_uni_type.yfilter != YFilter.not_set or
                                self.term_client_if_handle.yfilter != YFilter.not_set or
                                self.term_client_port.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.client_if_handle.is_set or self.client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_if_handle.get_name_leafdata())
                            if (self.client_odu_if_handle.is_set or self.client_odu_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_if_handle.get_name_leafdata())
                            if (self.client_odu_name.is_set or self.client_odu_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_name.get_name_leafdata())
                            if (self.client_port.is_set or self.client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_port.get_name_leafdata())
                            if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                            if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_connected.get_name_leafdata())
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.static_uni_type.is_set or self.static_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.static_uni_type.get_name_leafdata())
                            if (self.term_client_if_handle.is_set or self.term_client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_if_handle.get_name_leafdata())
                            if (self.term_client_port.is_set or self.term_client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_port.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "client-if-handle" or name == "client-odu-if-handle" or name == "client-odu-name" or name == "client-port" or name == "cross-connect-id" or name == "is-connected" or name == "local-termination" or name == "static-uni-type" or name == "term-client-if-handle" or name == "term-client-port" or name == "uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "client-if-handle"):
                                self.client_if_handle = value
                                self.client_if_handle.value_namespace = name_space
                                self.client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-if-handle"):
                                self.client_odu_if_handle = value
                                self.client_odu_if_handle.value_namespace = name_space
                                self.client_odu_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-name"):
                                self.client_odu_name = value
                                self.client_odu_name.value_namespace = name_space
                                self.client_odu_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-port"):
                                self.client_port = value
                                self.client_port.value_namespace = name_space
                                self.client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "cross-connect-id"):
                                self.cross_connect_id = value
                                self.cross_connect_id.value_namespace = name_space
                                self.cross_connect_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-connected"):
                                self.is_connected = value
                                self.is_connected.value_namespace = name_space
                                self.is_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "static-uni-type"):
                                self.static_uni_type = value
                                self.static_uni_type.value_namespace = name_space
                                self.static_uni_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-if-handle"):
                                self.term_client_if_handle = value
                                self.term_client_if_handle.value_namespace = name_space
                                self.term_client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-port"):
                                self.term_client_port = value
                                self.term_client_port.value_namespace = name_space
                                self.term_client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix


                    class EgressStaticUni(Entity):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:   :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:   :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.remote_uni_type = YLeaf(YType.enumeration, "remote-uni-type")

                            self.egress_port = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"
                            self._children_yang_names.add("egress-port")

                            self.term_egress_port = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._children_yang_names.add("term-egress-port")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("local_termination",
                                            "remote_uni_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)


                        class EgressPort(Entity):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class TermEgressPort(Entity):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "term-egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.local_termination.is_set or
                                self.remote_uni_type.is_set or
                                (self.egress_port is not None and self.egress_port.has_data()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.remote_uni_type.yfilter != YFilter.not_set or
                                (self.egress_port is not None and self.egress_port.has_operation()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "egress-static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.remote_uni_type.is_set or self.remote_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_uni_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "egress-port"):
                                if (self.egress_port is None):
                                    self.egress_port = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                                    self.egress_port.parent = self
                                    self._children_name_map["egress_port"] = "egress-port"
                                return self.egress_port

                            if (child_yang_name == "term-egress-port"):
                                if (self.term_egress_port is None):
                                    self.term_egress_port = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                                    self.term_egress_port.parent = self
                                    self._children_name_map["term_egress_port"] = "term-egress-port"
                                return self.term_egress_port

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "egress-port" or name == "term-egress-port" or name == "local-termination" or name == "remote-uni-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-uni-type"):
                                self.remote_uni_type = value
                                self.remote_uni_type.value_namespace = name_space
                                self.remote_uni_type.value_namespace_prefix = name_space_prefix


                    class HomepathEro(Entity):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "homepath-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.tunnel_id.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.diversity_info:
                            if (c.has_data()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_data()):
                                return True
                        return (
                            self.status_homepath_working.is_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_data()) or
                            (self.otn is not None and self.otn.has_data()) or
                            (self.static_uni is not None and self.static_uni.has_data()))

                    def has_operation(self):
                        for c in self.diversity_info:
                            if (c.has_operation()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.status_homepath_working.yfilter != YFilter.not_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_operation()) or
                            (self.otn is not None and self.otn.has_operation()) or
                            (self.static_uni is not None and self.static_uni.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transport-tunnel-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.status_homepath_working.is_set or self.status_homepath_working.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status_homepath_working.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "diversity-info"):
                            for c in self.diversity_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.diversity_info.append(c)
                            return c

                        if (child_yang_name == "egress-static-uni"):
                            if (self.egress_static_uni is None):
                                self.egress_static_uni = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                                self.egress_static_uni.parent = self
                                self._children_name_map["egress_static_uni"] = "egress-static-uni"
                            return self.egress_static_uni

                        if (child_yang_name == "homepath-ero"):
                            for c in self.homepath_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.homepath_ero.append(c)
                            return c

                        if (child_yang_name == "otn"):
                            if (self.otn is None):
                                self.otn = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                            return self.otn

                        if (child_yang_name == "static-uni"):
                            if (self.static_uni is None):
                                self.static_uni = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                                self.static_uni.parent = self
                                self._children_name_map["static_uni"] = "static-uni"
                            return self.static_uni

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "diversity-info" or name == "egress-static-uni" or name == "homepath-ero" or name == "otn" or name == "static-uni" or name == "status-homepath-working"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "status-homepath-working"):
                            self.status_homepath_working = value
                            self.status_homepath_working.value_namespace = name_space
                            self.status_homepath_working.value_namespace_prefix = name_space_prefix


                class BfdInfo(Entity):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\:  bool
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of    :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo>`
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:   :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters>`
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\:  str
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.bfd_session_up = YLeaf(YType.boolean, "bfd-session-up")

                        self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                        self.failure_reason = YLeaf(YType.str, "failure-reason")

                        self.maximum_session_up_interval = YLeaf(YType.uint32, "maximum-session-up-interval")

                        self.minimum_session_up_interval = YLeaf(YType.uint32, "minimum-session-up-interval")

                        self.session_up_time = YLeaf(YType.uint32, "session-up-time")

                        self.event_counters = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"
                        self._children_yang_names.add("event-counters")

                        self.dampening_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_up",
                                        "failure_diagnostic_code",
                                        "failure_reason",
                                        "maximum_session_up_interval",
                                        "minimum_session_up_interval",
                                        "session_up_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__setattr__(name, value)


                    class EventCounters(Entity):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"

                            self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                            self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                            self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                            self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                            self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                            self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                            self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                            self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                            self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("session_admin_down_events",
                                            "session_create_events",
                                            "session_create_timeout_events",
                                            "session_creation_failed_events",
                                            "session_down_events",
                                            "session_gracefully_delete_events",
                                            "session_non_gracefully_delete_events",
                                            "session_replay_events",
                                            "session_up_events") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.session_admin_down_events.is_set or
                                self.session_create_events.is_set or
                                self.session_create_timeout_events.is_set or
                                self.session_creation_failed_events.is_set or
                                self.session_down_events.is_set or
                                self.session_gracefully_delete_events.is_set or
                                self.session_non_gracefully_delete_events.is_set or
                                self.session_replay_events.is_set or
                                self.session_up_events.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.session_admin_down_events.yfilter != YFilter.not_set or
                                self.session_create_events.yfilter != YFilter.not_set or
                                self.session_create_timeout_events.yfilter != YFilter.not_set or
                                self.session_creation_failed_events.yfilter != YFilter.not_set or
                                self.session_down_events.yfilter != YFilter.not_set or
                                self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_replay_events.yfilter != YFilter.not_set or
                                self.session_up_events.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "event-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                            if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_events.get_name_leafdata())
                            if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                            if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                            if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_down_events.get_name_leafdata())
                            if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                            if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                            if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                            if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_up_events.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "session-admin-down-events"):
                                self.session_admin_down_events = value
                                self.session_admin_down_events.value_namespace = name_space
                                self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-events"):
                                self.session_create_events = value
                                self.session_create_events.value_namespace = name_space
                                self.session_create_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-timeout-events"):
                                self.session_create_timeout_events = value
                                self.session_create_timeout_events.value_namespace = name_space
                                self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-creation-failed-events"):
                                self.session_creation_failed_events = value
                                self.session_creation_failed_events.value_namespace = name_space
                                self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-down-events"):
                                self.session_down_events = value
                                self.session_down_events.value_namespace = name_space
                                self.session_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-gracefully-delete-events"):
                                self.session_gracefully_delete_events = value
                                self.session_gracefully_delete_events.value_namespace = name_space
                                self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-non-gracefully-delete-events"):
                                self.session_non_gracefully_delete_events = value
                                self.session_non_gracefully_delete_events.value_namespace = name_space
                                self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-replay-events"):
                                self.session_replay_events = value
                                self.session_replay_events.value_namespace = name_space
                                self.session_replay_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-up-events"):
                                self.session_up_events = value
                                self.session_up_events.value_namespace = name_space
                                self.session_up_events.value_namespace_prefix = name_space_prefix


                    class DampeningInfo(Entity):
                        """
                        Path option dampening info
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"

                            self.backoff_count = YLeaf(YType.uint32, "backoff-count")

                            self.hold_down_time = YLeaf(YType.uint32, "hold-down-time")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.remained_time = YLeaf(YType.uint32, "remained-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_count",
                                            "hold_down_time",
                                            "option_index",
                                            "remained_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_count.is_set or
                                self.hold_down_time.is_set or
                                self.option_index.is_set or
                                self.remained_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_count.yfilter != YFilter.not_set or
                                self.hold_down_time.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.remained_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "dampening-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_count.is_set or self.backoff_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_count.get_name_leafdata())
                            if (self.hold_down_time.is_set or self.hold_down_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_down_time.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.remained_time.is_set or self.remained_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remained_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-count" or name == "hold-down-time" or name == "option-index" or name == "remained-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-count"):
                                self.backoff_count = value
                                self.backoff_count.value_namespace = name_space
                                self.backoff_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-down-time"):
                                self.hold_down_time = value
                                self.hold_down_time.value_namespace = name_space
                                self.hold_down_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "remained-time"):
                                self.remained_time = value
                                self.remained_time.value_namespace = name_space
                                self.remained_time.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.dampening_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bfd_session_up.is_set or
                            self.failure_diagnostic_code.is_set or
                            self.failure_reason.is_set or
                            self.maximum_session_up_interval.is_set or
                            self.minimum_session_up_interval.is_set or
                            self.session_up_time.is_set or
                            (self.event_counters is not None and self.event_counters.has_data()))

                    def has_operation(self):
                        for c in self.dampening_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_up.yfilter != YFilter.not_set or
                            self.failure_diagnostic_code.yfilter != YFilter.not_set or
                            self.failure_reason.yfilter != YFilter.not_set or
                            self.maximum_session_up_interval.yfilter != YFilter.not_set or
                            self.minimum_session_up_interval.yfilter != YFilter.not_set or
                            self.session_up_time.yfilter != YFilter.not_set or
                            (self.event_counters is not None and self.event_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_up.is_set or self.bfd_session_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_up.get_name_leafdata())
                        if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                        if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_reason.get_name_leafdata())
                        if (self.maximum_session_up_interval.is_set or self.maximum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_session_up_interval.get_name_leafdata())
                        if (self.minimum_session_up_interval.is_set or self.minimum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.minimum_session_up_interval.get_name_leafdata())
                        if (self.session_up_time.is_set or self.session_up_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_up_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "dampening-info"):
                            for c in self.dampening_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.dampening_info.append(c)
                            return c

                        if (child_yang_name == "event-counters"):
                            if (self.event_counters is None):
                                self.event_counters = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                                self.event_counters.parent = self
                                self._children_name_map["event_counters"] = "event-counters"
                            return self.event_counters

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "dampening-info" or name == "event-counters" or name == "bfd-session-up" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "maximum-session-up-interval" or name == "minimum-session-up-interval" or name == "session-up-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-up"):
                            self.bfd_session_up = value
                            self.bfd_session_up.value_namespace = name_space
                            self.bfd_session_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-diagnostic-code"):
                            self.failure_diagnostic_code = value
                            self.failure_diagnostic_code.value_namespace = name_space
                            self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-reason"):
                            self.failure_reason = value
                            self.failure_reason.value_namespace = name_space
                            self.failure_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-session-up-interval"):
                            self.maximum_session_up_interval = value
                            self.maximum_session_up_interval.value_namespace = name_space
                            self.maximum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "minimum-session-up-interval"):
                            self.minimum_session_up_interval = value
                            self.minimum_session_up_interval.value_namespace = name_space
                            self.minimum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-up-time"):
                            self.session_up_time = value
                            self.session_up_time.value_namespace = name_space
                            self.session_up_time.value_namespace_prefix = name_space_prefix


                class OtnBidir(Entity):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps>`
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:   :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "nni-tunnel"

                        self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"
                        self._children_yang_names.add("aps")

                        self.restoration = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._children_yang_names.add("restoration")


                    class Aps(Entity):
                        """
                        APS Protection Info
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:   :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"

                            self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.protection_profile = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._children_yang_names.add("protection-profile")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("active_lsp",
                                            "diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__setattr__(name, value)


                        class ProtectionProfile(Entity):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection-profile" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.active_lsp.is_set or
                                self.diversity_type.is_set or
                                (self.protection_profile is not None and self.protection_profile.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.active_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                (self.protection_profile is not None and self.protection_profile.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "aps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.active_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protection-profile"):
                                if (self.protection_profile is None):
                                    self.protection_profile = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                                    self.protection_profile.parent = self
                                    self._children_name_map["protection_profile"] = "protection-profile"
                                return self.protection_profile

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protection-profile" or name == "active-lsp" or name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "active-lsp"):
                                self.active_lsp = value
                                self.active_lsp.value_namespace = name_space
                                self.active_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class Restoration(Entity):
                        """
                        Restoration Info
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"

                            self.diverse_lsp = YLeaf(YType.enumeration, "diverse-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.revert_option = YLeaf(YType.enumeration, "revert-option")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diverse_lsp",
                                            "diversity_type",
                                            "revert_option") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.diverse_lsp.is_set or
                                self.diversity_type.is_set or
                                self.revert_option.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diverse_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                self.revert_option.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "restoration" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diverse_lsp.is_set or self.diverse_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diverse_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())
                            if (self.revert_option.is_set or self.revert_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.revert_option.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diverse-lsp" or name == "diversity-type" or name == "revert-option"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diverse-lsp"):
                                self.diverse_lsp = value
                                self.diverse_lsp.value_namespace = name_space
                                self.diverse_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "revert-option"):
                                self.revert_option = value
                                self.revert_option.value_namespace = name_space
                                self.revert_option.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.aps is not None and self.aps.has_data()) or
                            (self.restoration is not None and self.restoration.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.aps is not None and self.aps.has_operation()) or
                            (self.restoration is not None and self.restoration.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "otn-bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "aps"):
                            if (self.aps is None):
                                self.aps = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                            return self.aps

                        if (child_yang_name == "restoration"):
                            if (self.restoration is None):
                                self.restoration = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                                self.restoration.parent = self
                                self._children_name_map["restoration"] = "restoration"
                            return self.restoration

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "aps" or name == "restoration"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Bidir(Entity):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:   :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent>`
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt>`
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby>`
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "nni-tunnel"

                        self.reverse_bandwidth = YLeaf(YType.uint32, "reverse-bandwidth")

                        self.reverse_bandwidth_standby = YLeaf(YType.uint32, "reverse-bandwidth-standby")

                        self.reverse_ero_error_current = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                        self._children_yang_names.add("reverse-ero-error-current")

                        self.reverse_ero_error_reopt = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                        self._children_yang_names.add("reverse-ero-error-reopt")

                        self.reverse_ero_error_standby = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                        self._children_yang_names.add("reverse-ero-error-standby")

                        self.reverse_ero_error_standby_reopt = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._children_yang_names.add("reverse-ero-error-standby-reopt")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("reverse_bandwidth",
                                        "reverse_bandwidth_standby") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir, self).__setattr__(name, value)


                    class ReverseEroErrorCurrent(Entity):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-current" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorReopt(Entity):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandby(Entity):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandbyReopt(Entity):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.reverse_bandwidth.is_set or
                            self.reverse_bandwidth_standby.is_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_data()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_data()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_data()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.reverse_bandwidth.yfilter != YFilter.not_set or
                            self.reverse_bandwidth_standby.yfilter != YFilter.not_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_operation()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_operation()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_operation()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.reverse_bandwidth.is_set or self.reverse_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth.get_name_leafdata())
                        if (self.reverse_bandwidth_standby.is_set or self.reverse_bandwidth_standby.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth_standby.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "reverse-ero-error-current"):
                            if (self.reverse_ero_error_current is None):
                                self.reverse_ero_error_current = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                                self.reverse_ero_error_current.parent = self
                                self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                            return self.reverse_ero_error_current

                        if (child_yang_name == "reverse-ero-error-reopt"):
                            if (self.reverse_ero_error_reopt is None):
                                self.reverse_ero_error_reopt = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                                self.reverse_ero_error_reopt.parent = self
                                self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                            return self.reverse_ero_error_reopt

                        if (child_yang_name == "reverse-ero-error-standby"):
                            if (self.reverse_ero_error_standby is None):
                                self.reverse_ero_error_standby = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                                self.reverse_ero_error_standby.parent = self
                                self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                            return self.reverse_ero_error_standby

                        if (child_yang_name == "reverse-ero-error-standby-reopt"):
                            if (self.reverse_ero_error_standby_reopt is None):
                                self.reverse_ero_error_standby_reopt = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                                self.reverse_ero_error_standby_reopt.parent = self
                                self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                            return self.reverse_ero_error_standby_reopt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "reverse-ero-error-current" or name == "reverse-ero-error-reopt" or name == "reverse-ero-error-standby" or name == "reverse-ero-error-standby-reopt" or name == "reverse-bandwidth" or name == "reverse-bandwidth-standby"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "reverse-bandwidth"):
                            self.reverse_bandwidth = value
                            self.reverse_bandwidth.value_namespace = name_space
                            self.reverse_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-bandwidth-standby"):
                            self.reverse_bandwidth_standby = value
                            self.reverse_bandwidth_standby.value_namespace = name_space
                            self.reverse_bandwidth_standby.value_namespace_prefix = name_space_prefix


                class XroAttributeSet(Entity):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "nni-tunnel"

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._children_yang_names.add("attribute-set-union")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("tunnel_attribute_set_name",
                                        "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__setattr__(name, value)


                    class AttributeSetUnion(Entity):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"

                            self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                            self._children_yang_names.add("attribute-set-aps-pp")

                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                            self._children_yang_names.add("attribute-set-autobackup")

                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                            self._children_yang_names.add("attribute-set-automesh")

                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                            self._children_yang_names.add("attribute-set-p2mpte")

                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._children_yang_names.add("attribute-set-p2p-te")

                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                            self._children_yang_names.add("attribute-set-path-option")

                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                            self._children_yang_names.add("attribute-set-xro")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                        class AttributeSetPathOption(Entity):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\:  str
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\:  bool
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"

                                self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                self.generation = YLeaf(YType.uint32, "generation")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                self._children_yang_names.add("bfd-reverse-path")

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bandwidth_type",
                                                "configured_bandwidth",
                                                "cost_limit",
                                                "dste_class_type",
                                                "exclude_list_name",
                                                "generation",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_bfd_reverse_pat_configured",
                                                "is_cost_limit_configured",
                                                "is_exclude_list_name_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "path_invalidation_action",
                                                "path_invalidation_timeout",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class BfdReversePath(Entity):
                                """
                                BFD reverse path
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                                    self.path_type = YLeaf(YType.enumeration, "path-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("binding_label",
                                                    "path_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.binding_label.is_set or
                                        self.path_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.binding_label.yfilter != YFilter.not_set or
                                        self.path_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding-label" or name == "path-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "binding-label"):
                                        self.binding_label = value
                                        self.binding_label.value_namespace = name_space
                                        self.binding_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-type"):
                                        self.path_type = value
                                        self.path_type.value_namespace = name_space
                                        self.path_type.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class VersionInfo(Entity):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\:  str
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.attribute_type = YLeaf(YType.str, "attribute-type")

                                    self.generation = YLeaf(YType.uint32, "generation")

                                    self.is_default = YLeaf(YType.boolean, "is-default")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute_type",
                                                    "generation",
                                                    "is_default") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute_type.is_set or
                                        self.generation.is_set or
                                        self.is_default.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute_type.yfilter != YFilter.not_set or
                                        self.generation.yfilter != YFilter.not_set or
                                        self.is_default.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "version-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                    if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.generation.get_name_leafdata())
                                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_default.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute-type"):
                                        self.attribute_type = value
                                        self.attribute_type.value_namespace = name_space
                                        self.attribute_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "generation"):
                                        self.generation = value
                                        self.generation.value_namespace = name_space
                                        self.generation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-default"):
                                        self.is_default = value
                                        self.is_default.value_namespace = name_space
                                        self.is_default.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bandwidth_type.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.cost_limit.is_set or
                                    self.dste_class_type.is_set or
                                    self.exclude_list_name.is_set or
                                    self.generation.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_bfd_reverse_pat_configured.is_set or
                                    self.is_cost_limit_configured.is_set or
                                    self.is_exclude_list_name_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.path_invalidation_action.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bandwidth_type.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.cost_limit.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.exclude_list_name.yfilter != YFilter.not_set or
                                    self.generation.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                    self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                    self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "bfd-reverse-path"):
                                    if (self.bfd_reverse_path is None):
                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                    return self.bfd_reverse_path

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                if (child_yang_name == "version-info"):
                                    for c in self.version_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.version_info.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bandwidth-type"):
                                    self.bandwidth_type = value
                                    self.bandwidth_type.value_namespace = name_space
                                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "cost-limit"):
                                    self.cost_limit = value
                                    self.cost_limit.value_namespace = name_space
                                    self.cost_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "exclude-list-name"):
                                    self.exclude_list_name = value
                                    self.exclude_list_name.value_namespace = name_space
                                    self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "generation"):
                                    self.generation = value
                                    self.generation.value_namespace = name_space
                                    self.generation.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bfd-reverse-pat-configured"):
                                    self.is_bfd_reverse_pat_configured = value
                                    self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                    self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-cost-limit-configured"):
                                    self.is_cost_limit_configured = value
                                    self.is_cost_limit_configured.value_namespace = name_space
                                    self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-exclude-list-name-configured"):
                                    self.is_exclude_list_name_configured = value
                                    self.is_exclude_list_name_configured.value_namespace = name_space
                                    self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-action"):
                                    self.path_invalidation_action = value
                                    self.path_invalidation_action.value_namespace = name_space
                                    self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutobackup(Entity):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                                self._children_yang_names.add("signalled-name")

                                self.policy_class_entry = YList(self)
                                self.protected_interface = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_priority",
                                                "is_affinity_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "is_signalled_name_configured",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                            class SignalledName(Entity):
                                """
                                Signalled name
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\:  bool
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\:  str
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                    self.name = YLeaf(YType.str, "name")

                                    self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                    self.source_type = YLeaf(YType.enumeration, "source-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_mp_addresses",
                                                    "name",
                                                    "protected_interface_type",
                                                    "source_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_mp_addresses.is_set or
                                        self.name.is_set or
                                        self.protected_interface_type.is_set or
                                        self.source_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_mp_addresses.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set or
                                        self.protected_interface_type.yfilter != YFilter.not_set or
                                        self.source_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalled-name" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())
                                    if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                    if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-mp-addresses"):
                                        self.is_mp_addresses = value
                                        self.is_mp_addresses.value_namespace = name_space
                                        self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protected-interface-type"):
                                        self.protected_interface_type = value
                                        self.protected_interface_type.value_namespace = name_space
                                        self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-type"):
                                        self.source_type = value
                                        self.source_type.value_namespace = name_space
                                        self.source_type.value_namespace_prefix = name_space_prefix


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ProtectedInterface(Entity):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.protected_interface = YLeaf(YType.str, "protected-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("protected_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.protected_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.protected_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protected-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protected-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "protected-interface"):
                                        self.protected_interface = value
                                        self.protected_interface.value_namespace = name_space
                                        self.protected_interface.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.is_signalled_name_configured.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.signalled_name is not None and self.signalled_name.has_data()))

                            def has_operation(self):
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.signalled_name is not None and self.signalled_name.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-autobackup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "protected-interface"):
                                    for c in self.protected_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protected_interface.append(c)
                                    return c

                                if (child_yang_name == "signalled-name"):
                                    if (self.signalled_name is None):
                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                    return self.signalled_name

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-signalled-name-configured"):
                                    self.is_signalled_name_configured = value
                                    self.is_signalled_name_configured.value_namespace = name_space
                                    self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutomesh(Entity):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\:  bool
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\:  bool
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\:  bool
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"

                                self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.forward_class = YLeaf(YType.uint32, "forward-class")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.load_share = YLeaf(YType.uint32, "load-share")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.mesh_group_id = YList(self)
                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_bandwidth_collect",
                                                "auto_route_announce",
                                                "bandwidth",
                                                "configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "forward_class",
                                                "frr_bandwidth_protection",
                                                "frr_node_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_interface_bw_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "load_share",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority",
                                                "soft_preemption_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class MeshGroupId(Entity):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mesh-group-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.mesh_group_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.auto_bandwidth_collect.is_set or
                                    self.auto_route_announce.is_set or
                                    self.bandwidth.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.forward_class.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.frr_node_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_interface_bw_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.load_share.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    self.soft_preemption_configured.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()))

                            def has_operation(self):
                                for c in self.mesh_group_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                    self.auto_route_announce.yfilter != YFilter.not_set or
                                    self.bandwidth.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.forward_class.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.frr_node_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.load_share.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    self.soft_preemption_configured.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-automesh" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_class.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.load_share.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "mesh-group-id"):
                                    for c in self.mesh_group_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.mesh_group_id.append(c)
                                    return c

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-bandwidth-collect"):
                                    self.auto_bandwidth_collect = value
                                    self.auto_bandwidth_collect.value_namespace = name_space
                                    self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-route-announce"):
                                    self.auto_route_announce = value
                                    self.auto_route_announce.value_namespace = name_space
                                    self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                if(value_path == "bandwidth"):
                                    self.bandwidth = value
                                    self.bandwidth.value_namespace = name_space
                                    self.bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-class"):
                                    self.forward_class = value
                                    self.forward_class.value_namespace = name_space
                                    self.forward_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-node-protection"):
                                    self.frr_node_protection = value
                                    self.frr_node_protection.value_namespace = name_space
                                    self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-bw-configured"):
                                    self.is_interface_bw_configured = value
                                    self.is_interface_bw_configured.value_namespace = name_space
                                    self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "load-share"):
                                    self.load_share = value
                                    self.load_share.value_namespace = name_space
                                    self.load_share.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-configured"):
                                    self.soft_preemption_configured = value
                                    self.soft_preemption_configured.value_namespace = name_space
                                    self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                        class AttributeSetXro(Entity):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"

                                self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._children_yang_names.add("xro")


                            class Xro(Entity):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\:  bool
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"

                                    self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                    self.xro_subobject = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("mutual_diversity_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                class XroSubobject(Entity):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                        self._children_yang_names.add("as-subobject")

                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        self._children_yang_names.add("ipv4-subobject")

                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        self._children_yang_names.add("ipv6-subobject")

                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._children_yang_names.add("lsp-subobject")

                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        self._children_yang_names.add("srlg-subobject")

                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        self._children_yang_names.add("unnumbered-subobject")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                    class Ipv4Subobject(Entity):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv4-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class Ipv6Subobject(Entity):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv6-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class UnnumberedSubobject(Entity):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.interface_id = YLeaf(YType.uint32, "interface-id")

                                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute",
                                                            "exclusion_type",
                                                            "interface_id",
                                                            "te_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.interface_id.is_set or
                                                self.te_router_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.interface_id.yfilter != YFilter.not_set or
                                                self.te_router_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unnumbered-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_id.get_name_leafdata())
                                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-id"):
                                                self.interface_id = value
                                                self.interface_id.value_namespace = name_space
                                                self.interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-router-id"):
                                                self.te_router_id = value
                                                self.te_router_id.value_namespace = name_space
                                                self.te_router_id.value_namespace_prefix = name_space_prefix


                                    class AsSubobject(Entity):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.as_number = YLeaf(YType.uint16, "as-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("as_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.as_number.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.as_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "as-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "as-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "as-number"):
                                                self.as_number = value
                                                self.as_number.value_namespace = name_space
                                                self.as_number.value_namespace_prefix = name_space_prefix


                                    class SrlgSubobject(Entity):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("exclusion_type",
                                                            "srlg_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.exclusion_type.is_set or
                                                self.srlg_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.srlg_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "srlg-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "exclusion-type" or name == "srlg-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "srlg-id"):
                                                self.srlg_id = value
                                                self.srlg_id.value_namespace = name_space
                                                self.srlg_id.value_namespace_prefix = name_space_prefix


                                    class LspSubobject(Entity):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\:  bool
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                            self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                            self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                            self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._children_yang_names.add("fec")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("destination_node_exception",
                                                            "exclusion_type",
                                                            "ignore_lsp_id",
                                                            "penultimate_node_exception",
                                                            "processing_node_exception") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                        class Fec(Entity):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"

                                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                self.fec_source = YLeaf(YType.str, "fec-source")

                                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._children_yang_names.add("fec-destination-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_extended_tunnel_id",
                                                                "fec_lsp_id",
                                                                "fec_source",
                                                                "fec_tunnel_id",
                                                                "fec_vrf") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                            class FecDestinationInfo(Entity):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"

                                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("fec_ctype",
                                                                    "fec_destination_p2mp_id",
                                                                    "p2p_lsp_destination") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.fec_ctype.is_set or
                                                        self.fec_destination_p2mp_id.is_set or
                                                        self.p2p_lsp_destination.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.fec_ctype.yfilter != YFilter.not_set or
                                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "fec-destination-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "fec-ctype"):
                                                        self.fec_ctype = value
                                                        self.fec_ctype.value_namespace = name_space
                                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fec-destination-p2mp-id"):
                                                        self.fec_destination_p2mp_id = value
                                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "p2p-lsp-destination"):
                                                        self.p2p_lsp_destination = value
                                                        self.p2p_lsp_destination.value_namespace = name_space
                                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.fec_extended_tunnel_id.is_set or
                                                    self.fec_lsp_id.is_set or
                                                    self.fec_source.is_set or
                                                    self.fec_tunnel_id.is_set or
                                                    self.fec_vrf.is_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                                    self.fec_source.yfilter != YFilter.not_set or
                                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_vrf.yfilter != YFilter.not_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "fec-destination-info"):
                                                    if (self.fec_destination_info is None):
                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                    return self.fec_destination_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-extended-tunnel-id"):
                                                    self.fec_extended_tunnel_id = value
                                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-lsp-id"):
                                                    self.fec_lsp_id = value
                                                    self.fec_lsp_id.value_namespace = name_space
                                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-source"):
                                                    self.fec_source = value
                                                    self.fec_source.value_namespace = name_space
                                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-tunnel-id"):
                                                    self.fec_tunnel_id = value
                                                    self.fec_tunnel_id.value_namespace = name_space
                                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-vrf"):
                                                    self.fec_vrf = value
                                                    self.fec_vrf.value_namespace = name_space
                                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.destination_node_exception.is_set or
                                                self.exclusion_type.is_set or
                                                self.ignore_lsp_id.is_set or
                                                self.penultimate_node_exception.is_set or
                                                self.processing_node_exception.is_set or
                                                (self.fec is not None and self.fec.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.destination_node_exception.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                self.processing_node_exception.yfilter != YFilter.not_set or
                                                (self.fec is not None and self.fec.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsp-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                            if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                            if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec"):
                                                if (self.fec is None):
                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                return self.fec

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "destination-node-exception"):
                                                self.destination_node_exception = value
                                                self.destination_node_exception.value_namespace = name_space
                                                self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ignore-lsp-id"):
                                                self.ignore_lsp_id = value
                                                self.ignore_lsp_id.value_namespace = name_space
                                                self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "penultimate-node-exception"):
                                                self.penultimate_node_exception = value
                                                self.penultimate_node_exception.value_namespace = name_space
                                                self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "processing-node-exception"):
                                                self.processing_node_exception = value
                                                self.processing_node_exception.value_namespace = name_space
                                                self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.type.is_set or
                                            (self.as_subobject is not None and self.as_subobject.has_data()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set or
                                            (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "xro-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "as-subobject"):
                                            if (self.as_subobject is None):
                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                            return self.as_subobject

                                        if (child_yang_name == "ipv4-subobject"):
                                            if (self.ipv4_subobject is None):
                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                            return self.ipv4_subobject

                                        if (child_yang_name == "ipv6-subobject"):
                                            if (self.ipv6_subobject is None):
                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                            return self.ipv6_subobject

                                        if (child_yang_name == "lsp-subobject"):
                                            if (self.lsp_subobject is None):
                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                            return self.lsp_subobject

                                        if (child_yang_name == "srlg-subobject"):
                                            if (self.srlg_subobject is None):
                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                            return self.srlg_subobject

                                        if (child_yang_name == "unnumbered-subobject"):
                                            if (self.unnumbered_subobject is None):
                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                            return self.unnumbered_subobject

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.xro_subobject:
                                        if (c.has_data()):
                                            return True
                                    return self.mutual_diversity_flag.is_set

                                def has_operation(self):
                                    for c in self.xro_subobject:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "xro-subobject"):
                                        for c in self.xro_subobject:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.xro_subobject.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "mutual-diversity-flag"):
                                        self.mutual_diversity_flag = value
                                        self.mutual_diversity_flag.value_namespace = name_space
                                        self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.xro is not None and self.xro.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.xro is not None and self.xro.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro"):
                                    if (self.xro is None):
                                        self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                    return self.xro

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class AttributeSetP2Mpte(Entity):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "frr_bandwidth_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_priority_configured",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2mpte" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetApsPp(Entity):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-aps-pp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                        class AttributeSetP2PTe(Entity):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                                self._children_yang_names.add("prepend-list")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_affinity_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_path_select_configured",
                                                "is_path_selection_metric_configured",
                                                "is_path_selection_segment_routing_adjacency_protection_configured",
                                                "is_path_selection_segment_routing_margin_configured",
                                                "is_path_selection_segment_routing_margin_relative",
                                                "is_path_selection_segment_routing_segment_limit_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "is_prepend_list_configured",
                                                "path_invalidation_timeout",
                                                "path_selection_invalidation_action",
                                                "path_selection_metric",
                                                "path_selection_segment_routing_adjacency_protection",
                                                "path_selection_segment_routing_margin",
                                                "path_selection_segment_routing_segment_limit",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PrependList(Entity):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.prepend_entry = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                class PrependEntry(Entity):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.next_label = YLeaf(YType.uint32, "next-label")

                                        self.type = YLeaf(YType.enumeration, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("index",
                                                        "next_label",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.index.is_set or
                                            self.next_label.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.next_label.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prepend-entry" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_label.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "index" or name == "next-label" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-label"):
                                            self.next_label = value
                                            self.next_label.value_namespace = name_space
                                            self.next_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.prepend_entry:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.prepend_entry:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "prepend-list" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "prepend-entry"):
                                        for c in self.prepend_entry:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.prepend_entry.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prepend-entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_affinity_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_path_select_configured.is_set or
                                    self.is_path_selection_metric_configured.is_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_relative.is_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.is_prepend_list_configured.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.path_selection_invalidation_action.is_set or
                                    self.path_selection_metric.is_set or
                                    self.path_selection_segment_routing_adjacency_protection.is_set or
                                    self.path_selection_segment_routing_margin.is_set or
                                    self.path_selection_segment_routing_segment_limit.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.prepend_list is not None and self.prepend_list.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_path_select_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_selection_metric.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.prepend_list is not None and self.prepend_list.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2p-te" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "prepend-list"):
                                    if (self.prepend_list is None):
                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                    return self.prepend_list

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-select-configured"):
                                    self.is_path_select_configured = value
                                    self.is_path_select_configured.value_namespace = name_space
                                    self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-metric-configured"):
                                    self.is_path_selection_metric_configured = value
                                    self.is_path_selection_metric_configured.value_namespace = name_space
                                    self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                    self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                    self.is_path_selection_segment_routing_margin_configured = value
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                    self.is_path_selection_segment_routing_margin_relative = value
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                    self.is_path_selection_segment_routing_segment_limit_configured = value
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-prepend-list-configured"):
                                    self.is_prepend_list_configured = value
                                    self.is_prepend_list_configured.value_namespace = name_space
                                    self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-invalidation-action"):
                                    self.path_selection_invalidation_action = value
                                    self.path_selection_invalidation_action.value_namespace = name_space
                                    self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-metric"):
                                    self.path_selection_metric = value
                                    self.path_selection_metric.value_namespace = name_space
                                    self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                    self.path_selection_segment_routing_adjacency_protection = value
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-margin"):
                                    self.path_selection_segment_routing_margin = value
                                    self.path_selection_segment_routing_margin.value_namespace = name_space
                                    self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-segment-limit"):
                                    self.path_selection_segment_routing_segment_limit = value
                                    self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                    self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tunnel_attribute_set_type.is_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attribute-set-union" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set-aps-pp"):
                                if (self.attribute_set_aps_pp is None):
                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                return self.attribute_set_aps_pp

                            if (child_yang_name == "attribute-set-autobackup"):
                                if (self.attribute_set_autobackup is None):
                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                return self.attribute_set_autobackup

                            if (child_yang_name == "attribute-set-automesh"):
                                if (self.attribute_set_automesh is None):
                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                return self.attribute_set_automesh

                            if (child_yang_name == "attribute-set-p2mpte"):
                                if (self.attribute_set_p2mpte is None):
                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                return self.attribute_set_p2mpte

                            if (child_yang_name == "attribute-set-p2p-te"):
                                if (self.attribute_set_p2p_te is None):
                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                return self.attribute_set_p2p_te

                            if (child_yang_name == "attribute-set-path-option"):
                                if (self.attribute_set_path_option is None):
                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                return self.attribute_set_path_option

                            if (child_yang_name == "attribute-set-xro"):
                                if (self.attribute_set_xro is None):
                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                return self.attribute_set_xro

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-attribute-set-type"):
                                self.tunnel_attribute_set_type = value
                                self.tunnel_attribute_set_type.value_namespace = name_space
                                self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.tunnel_attribute_set_name.is_set or
                            self.tunnel_attribute_set_name_crc32.is_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "xro-attribute-set" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attribute-set-union"):
                            if (self.attribute_set_union is None):
                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                            return self.attribute_set_union

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name-crc32"):
                            self.tunnel_attribute_set_name_crc32 = value
                            self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                            self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                class TeTunnelConvergence(Entity):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp>`
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "nni-tunnel"

                        self.binding_label_rewrite_time = YLeaf(YType.uint64, "binding-label-rewrite-time")

                        self.convergence_complete_time = YLeaf(YType.uint64, "convergence-complete-time")

                        self.frr_trigger_time = YLeaf(YType.uint64, "frr-trigger-time")

                        self.is_convergence_in_progress = YLeaf(YType.boolean, "is-convergence-in-progress")

                        self.pcalc_complete_time = YLeaf(YType.uint64, "pcalc-complete-time")

                        self.vif_creation_time = YLeaf(YType.uint64, "vif-creation-time")

                        self.convergence_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._children_yang_names.add("convergence-lsp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("binding_label_rewrite_time",
                                        "convergence_complete_time",
                                        "frr_trigger_time",
                                        "is_convergence_in_progress",
                                        "pcalc_complete_time",
                                        "vif_creation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__setattr__(name, value)


                    class ConvergenceLsp(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "convergence-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.binding_label_rewrite_time.is_set or
                            self.convergence_complete_time.is_set or
                            self.frr_trigger_time.is_set or
                            self.is_convergence_in_progress.is_set or
                            self.pcalc_complete_time.is_set or
                            self.vif_creation_time.is_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.binding_label_rewrite_time.yfilter != YFilter.not_set or
                            self.convergence_complete_time.yfilter != YFilter.not_set or
                            self.frr_trigger_time.yfilter != YFilter.not_set or
                            self.is_convergence_in_progress.yfilter != YFilter.not_set or
                            self.pcalc_complete_time.yfilter != YFilter.not_set or
                            self.vif_creation_time.yfilter != YFilter.not_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-tunnel-convergence" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.binding_label_rewrite_time.is_set or self.binding_label_rewrite_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_label_rewrite_time.get_name_leafdata())
                        if (self.convergence_complete_time.is_set or self.convergence_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.convergence_complete_time.get_name_leafdata())
                        if (self.frr_trigger_time.is_set or self.frr_trigger_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_trigger_time.get_name_leafdata())
                        if (self.is_convergence_in_progress.is_set or self.is_convergence_in_progress.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_convergence_in_progress.get_name_leafdata())
                        if (self.pcalc_complete_time.is_set or self.pcalc_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_complete_time.get_name_leafdata())
                        if (self.vif_creation_time.is_set or self.vif_creation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vif_creation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "convergence-lsp"):
                            if (self.convergence_lsp is None):
                                self.convergence_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                                self.convergence_lsp.parent = self
                                self._children_name_map["convergence_lsp"] = "convergence-lsp"
                            return self.convergence_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "convergence-lsp" or name == "binding-label-rewrite-time" or name == "convergence-complete-time" or name == "frr-trigger-time" or name == "is-convergence-in-progress" or name == "pcalc-complete-time" or name == "vif-creation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "binding-label-rewrite-time"):
                            self.binding_label_rewrite_time = value
                            self.binding_label_rewrite_time.value_namespace = name_space
                            self.binding_label_rewrite_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "convergence-complete-time"):
                            self.convergence_complete_time = value
                            self.convergence_complete_time.value_namespace = name_space
                            self.convergence_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-trigger-time"):
                            self.frr_trigger_time = value
                            self.frr_trigger_time.value_namespace = name_space
                            self.frr_trigger_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-convergence-in-progress"):
                            self.is_convergence_in_progress = value
                            self.is_convergence_in_progress.value_namespace = name_space
                            self.is_convergence_in_progress.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-complete-time"):
                            self.pcalc_complete_time = value
                            self.pcalc_complete_time.value_namespace = name_space
                            self.pcalc_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "vif-creation-time"):
                            self.vif_creation_time = value
                            self.vif_creation_time.value_namespace = name_space
                            self.vif_creation_time.value_namespace_prefix = name_space_prefix


                class FlexInfo(Entity):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\:  bool
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\:  bool
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\:  bool
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\:  bool
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\:  bool
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:   :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "nni-tunnel"

                        self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                        self.fault_in_label = YLeaf(YType.uint32, "fault-in-label")

                        self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                        self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                        self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                        self.fault_time = YLeaf(YType.uint32, "fault-time")

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_lsp_id = YLeaf(YType.uint16, "lockout-lsp-id")

                        self.lockout_timestamp = YLeaf(YType.uint32, "lockout-timestamp")

                        self.origination = YLeaf(YType.enumeration, "origination")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fault_ais",
                                        "fault_in_label",
                                        "fault_ldi",
                                        "fault_ldi_lockout",
                                        "fault_lkr",
                                        "fault_time",
                                        "is_lockout",
                                        "lockout_lsp_id",
                                        "lockout_timestamp",
                                        "origination") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.fault_ais.is_set or
                            self.fault_in_label.is_set or
                            self.fault_ldi.is_set or
                            self.fault_ldi_lockout.is_set or
                            self.fault_lkr.is_set or
                            self.fault_time.is_set or
                            self.is_lockout.is_set or
                            self.lockout_lsp_id.is_set or
                            self.lockout_timestamp.is_set or
                            self.origination.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fault_ais.yfilter != YFilter.not_set or
                            self.fault_in_label.yfilter != YFilter.not_set or
                            self.fault_ldi.yfilter != YFilter.not_set or
                            self.fault_ldi_lockout.yfilter != YFilter.not_set or
                            self.fault_lkr.yfilter != YFilter.not_set or
                            self.fault_time.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_lsp_id.yfilter != YFilter.not_set or
                            self.lockout_timestamp.yfilter != YFilter.not_set or
                            self.origination.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flex-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ais.get_name_leafdata())
                        if (self.fault_in_label.is_set or self.fault_in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_in_label.get_name_leafdata())
                        if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                        if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                        if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                        if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_time.get_name_leafdata())
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_lsp_id.is_set or self.lockout_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_lsp_id.get_name_leafdata())
                        if (self.lockout_timestamp.is_set or self.lockout_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_timestamp.get_name_leafdata())
                        if (self.origination.is_set or self.origination.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.origination.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fault-ais" or name == "fault-in-label" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "is-lockout" or name == "lockout-lsp-id" or name == "lockout-timestamp" or name == "origination"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fault-ais"):
                            self.fault_ais = value
                            self.fault_ais.value_namespace = name_space
                            self.fault_ais.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-in-label"):
                            self.fault_in_label = value
                            self.fault_in_label.value_namespace = name_space
                            self.fault_in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi"):
                            self.fault_ldi = value
                            self.fault_ldi.value_namespace = name_space
                            self.fault_ldi.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi-lockout"):
                            self.fault_ldi_lockout = value
                            self.fault_ldi_lockout.value_namespace = name_space
                            self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-lkr"):
                            self.fault_lkr = value
                            self.fault_lkr.value_namespace = name_space
                            self.fault_lkr.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-time"):
                            self.fault_time = value
                            self.fault_time.value_namespace = name_space
                            self.fault_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-lsp-id"):
                            self.lockout_lsp_id = value
                            self.lockout_lsp_id.value_namespace = name_space
                            self.lockout_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-timestamp"):
                            self.lockout_timestamp = value
                            self.lockout_timestamp.value_namespace = name_space
                            self.lockout_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "origination"):
                            self.origination = value
                            self.origination.value_namespace = name_space
                            self.origination.value_namespace_prefix = name_space_prefix


                class Destination(Entity):
                    """
                    Destinations array
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionCause>`
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:   :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:   :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization>`
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\:  bool
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of    :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption>`
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of    :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry>`
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\:  bool
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\:  bool
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "nni-tunnel"

                        self.active_path_option_index = YLeaf(YType.uint32, "active-path-option-index")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.destination_deletion_cause = YLeaf(YType.enumeration, "destination-deletion-cause")

                        self.destination_deletion_sub_cause = YLeaf(YType.enumeration, "destination-deletion-sub-cause")

                        self.destination_deletion_timestamp = YLeaf(YType.uint32, "destination-deletion-timestamp")

                        self.destination_state = YLeaf(YType.enumeration, "destination-state")

                        self.is_inter_area = YLeaf(YType.boolean, "is-inter-area")

                        self.path_change_time = YLeaf(YType.uint32, "path-change-time")

                        self.path_option_exhausted = YLeaf(YType.boolean, "path-option-exhausted")

                        self.s2l_exist = YLeaf(YType.boolean, "s2l-exist")

                        self.total_uptime = YLeaf(YType.uint32, "total-uptime")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.inter_area_reoptimization = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                        self._children_yang_names.add("inter-area-reoptimization")

                        self.path_option = YList(self)
                        self.path_option_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("active_path_option_index",
                                        "destination_address",
                                        "destination_deletion_cause",
                                        "destination_deletion_sub_cause",
                                        "destination_deletion_timestamp",
                                        "destination_state",
                                        "is_inter_area",
                                        "path_change_time",
                                        "path_option_exhausted",
                                        "s2l_exist",
                                        "total_uptime",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination, self).__setattr__(name, value)


                    class InterAreaReoptimization(Entity):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"

                            self.preferred_path_error_node = YLeaf(YType.str, "preferred-path-error-node")

                            self.preferred_tree_error_node = YLeaf(YType.str, "preferred-tree-error-node")

                            self.received_preferred_path_errors = YLeaf(YType.uint16, "received-preferred-path-errors")

                            self.received_preferred_tree_errors = YLeaf(YType.uint16, "received-preferred-tree-errors")

                            self.sent_path_queries = YLeaf(YType.uint16, "sent-path-queries")

                            self.time_since_last_preferred_path_error = YLeaf(YType.uint32, "time-since-last-preferred-path-error")

                            self.time_since_last_preferred_tree_error = YLeaf(YType.uint32, "time-since-last-preferred-tree-error")

                            self.time_since_last_query_sent = YLeaf(YType.uint32, "time-since-last-query-sent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preferred_path_error_node",
                                            "preferred_tree_error_node",
                                            "received_preferred_path_errors",
                                            "received_preferred_tree_errors",
                                            "sent_path_queries",
                                            "time_since_last_preferred_path_error",
                                            "time_since_last_preferred_tree_error",
                                            "time_since_last_query_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preferred_path_error_node.is_set or
                                self.preferred_tree_error_node.is_set or
                                self.received_preferred_path_errors.is_set or
                                self.received_preferred_tree_errors.is_set or
                                self.sent_path_queries.is_set or
                                self.time_since_last_preferred_path_error.is_set or
                                self.time_since_last_preferred_tree_error.is_set or
                                self.time_since_last_query_sent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preferred_path_error_node.yfilter != YFilter.not_set or
                                self.preferred_tree_error_node.yfilter != YFilter.not_set or
                                self.received_preferred_path_errors.yfilter != YFilter.not_set or
                                self.received_preferred_tree_errors.yfilter != YFilter.not_set or
                                self.sent_path_queries.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_error.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set or
                                self.time_since_last_query_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "inter-area-reoptimization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preferred_path_error_node.is_set or self.preferred_path_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_path_error_node.get_name_leafdata())
                            if (self.preferred_tree_error_node.is_set or self.preferred_tree_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_tree_error_node.get_name_leafdata())
                            if (self.received_preferred_path_errors.is_set or self.received_preferred_path_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_path_errors.get_name_leafdata())
                            if (self.received_preferred_tree_errors.is_set or self.received_preferred_tree_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_tree_errors.get_name_leafdata())
                            if (self.sent_path_queries.is_set or self.sent_path_queries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sent_path_queries.get_name_leafdata())
                            if (self.time_since_last_preferred_path_error.is_set or self.time_since_last_preferred_path_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_error.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_error.is_set or self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_error.get_name_leafdata())
                            if (self.time_since_last_query_sent.is_set or self.time_since_last_query_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preferred-path-error-node" or name == "preferred-tree-error-node" or name == "received-preferred-path-errors" or name == "received-preferred-tree-errors" or name == "sent-path-queries" or name == "time-since-last-preferred-path-error" or name == "time-since-last-preferred-tree-error" or name == "time-since-last-query-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preferred-path-error-node"):
                                self.preferred_path_error_node = value
                                self.preferred_path_error_node.value_namespace = name_space
                                self.preferred_path_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "preferred-tree-error-node"):
                                self.preferred_tree_error_node = value
                                self.preferred_tree_error_node.value_namespace = name_space
                                self.preferred_tree_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-path-errors"):
                                self.received_preferred_path_errors = value
                                self.received_preferred_path_errors.value_namespace = name_space
                                self.received_preferred_path_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-tree-errors"):
                                self.received_preferred_tree_errors = value
                                self.received_preferred_tree_errors.value_namespace = name_space
                                self.received_preferred_tree_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "sent-path-queries"):
                                self.sent_path_queries = value
                                self.sent_path_queries.value_namespace = name_space
                                self.sent_path_queries.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-error"):
                                self.time_since_last_preferred_path_error = value
                                self.time_since_last_preferred_path_error.value_namespace = name_space
                                self.time_since_last_preferred_path_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-error"):
                                self.time_since_last_preferred_tree_error = value
                                self.time_since_last_preferred_tree_error.value_namespace = name_space
                                self.time_since_last_preferred_tree_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-sent"):
                                self.time_since_last_query_sent = value
                                self.time_since_last_query_sent.value_namespace = name_space
                                self.time_since_last_query_sent.value_namespace_prefix = name_space_prefix


                    class PathOptionEntry(Entity):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class PathOption(Entity):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.path_option:
                            if (c.has_data()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.active_path_option_index.is_set or
                            self.destination_address.is_set or
                            self.destination_deletion_cause.is_set or
                            self.destination_deletion_sub_cause.is_set or
                            self.destination_deletion_timestamp.is_set or
                            self.destination_state.is_set or
                            self.is_inter_area.is_set or
                            self.path_change_time.is_set or
                            self.path_option_exhausted.is_set or
                            self.s2l_exist.is_set or
                            self.total_uptime.is_set or
                            self.uptime.is_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_data()))

                    def has_operation(self):
                        for c in self.path_option:
                            if (c.has_operation()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.active_path_option_index.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.destination_deletion_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_sub_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_timestamp.yfilter != YFilter.not_set or
                            self.destination_state.yfilter != YFilter.not_set or
                            self.is_inter_area.yfilter != YFilter.not_set or
                            self.path_change_time.yfilter != YFilter.not_set or
                            self.path_option_exhausted.yfilter != YFilter.not_set or
                            self.s2l_exist.yfilter != YFilter.not_set or
                            self.total_uptime.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.active_path_option_index.is_set or self.active_path_option_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active_path_option_index.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.destination_deletion_cause.is_set or self.destination_deletion_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_cause.get_name_leafdata())
                        if (self.destination_deletion_sub_cause.is_set or self.destination_deletion_sub_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_sub_cause.get_name_leafdata())
                        if (self.destination_deletion_timestamp.is_set or self.destination_deletion_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_timestamp.get_name_leafdata())
                        if (self.destination_state.is_set or self.destination_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_state.get_name_leafdata())
                        if (self.is_inter_area.is_set or self.is_inter_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_inter_area.get_name_leafdata())
                        if (self.path_change_time.is_set or self.path_change_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_change_time.get_name_leafdata())
                        if (self.path_option_exhausted.is_set or self.path_option_exhausted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_option_exhausted.get_name_leafdata())
                        if (self.s2l_exist.is_set or self.s2l_exist.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_exist.get_name_leafdata())
                        if (self.total_uptime.is_set or self.total_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_uptime.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "inter-area-reoptimization"):
                            if (self.inter_area_reoptimization is None):
                                self.inter_area_reoptimization = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                                self.inter_area_reoptimization.parent = self
                                self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                            return self.inter_area_reoptimization

                        if (child_yang_name == "path-option"):
                            for c in self.path_option:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOption()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option.append(c)
                            return c

                        if (child_yang_name == "path-option-entry"):
                            for c in self.path_option_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "inter-area-reoptimization" or name == "path-option" or name == "path-option-entry" or name == "active-path-option-index" or name == "destination-address" or name == "destination-deletion-cause" or name == "destination-deletion-sub-cause" or name == "destination-deletion-timestamp" or name == "destination-state" or name == "is-inter-area" or name == "path-change-time" or name == "path-option-exhausted" or name == "s2l-exist" or name == "total-uptime" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "active-path-option-index"):
                            self.active_path_option_index = value
                            self.active_path_option_index.value_namespace = name_space
                            self.active_path_option_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-cause"):
                            self.destination_deletion_cause = value
                            self.destination_deletion_cause.value_namespace = name_space
                            self.destination_deletion_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-sub-cause"):
                            self.destination_deletion_sub_cause = value
                            self.destination_deletion_sub_cause.value_namespace = name_space
                            self.destination_deletion_sub_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-timestamp"):
                            self.destination_deletion_timestamp = value
                            self.destination_deletion_timestamp.value_namespace = name_space
                            self.destination_deletion_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-state"):
                            self.destination_state = value
                            self.destination_state.value_namespace = name_space
                            self.destination_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-inter-area"):
                            self.is_inter_area = value
                            self.is_inter_area.value_namespace = name_space
                            self.is_inter_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-change-time"):
                            self.path_change_time = value
                            self.path_change_time.value_namespace = name_space
                            self.path_change_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-option-exhausted"):
                            self.path_option_exhausted = value
                            self.path_option_exhausted.value_namespace = name_space
                            self.path_option_exhausted.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-exist"):
                            self.s2l_exist = value
                            self.s2l_exist.value_namespace = name_space
                            self.s2l_exist.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-uptime"):
                            self.total_uptime = value
                            self.total_uptime.value_namespace = name_space
                            self.total_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.admin_state.is_set or
                        self.affinity_failure_delayed_tear_time_remained.is_set or
                        self.affinity_failure_reopt_disabled.is_set or
                        self.affinity_failure_reopt_time_remained.is_set or
                        self.area_id.is_set or
                        self.auto_route.is_set or
                        self.autoroute_announce_exclude_segment_routing.is_set or
                        self.bandwidth_requested.is_set or
                        self.bandwidth_type.is_set or
                        self.binding_label.is_set or
                        self.binding_label_exists.is_set or
                        self.create_time.is_set or
                        self.destination_disabled_count.is_set or
                        self.destination_down_count.is_set or
                        self.destination_up_count.is_set or
                        self.drop_mode.is_set or
                        self.explicit_path_change.is_set or
                        self.fail_reason.is_set or
                        self.forwarding_adjacency.is_set or
                        self.hop_limit_ignored_reason.is_set or
                        self.invalidation_time_remained.is_set or
                        self.is_auto_backup.is_set or
                        self.is_auto_pcc.is_set or
                        self.is_bandwidth_protect.is_set or
                        self.is_hop_limit_ignore.is_set or
                        self.is_inter_area_tunnel.is_set or
                        self.is_interface.is_set or
                        self.is_named.is_set or
                        self.is_node_protected.is_set or
                        self.is_passive.is_set or
                        self.is_pce_delegated.is_set or
                        self.last_hop_ifindex.is_set or
                        self.last_path_change.is_set or
                        self.load_share_factor.is_set or
                        self.load_share_type.is_set or
                        self.lsp_wrap_label.is_set or
                        self.lsp_wrap_protection_enabled.is_set or
                        self.metric_qualifier.is_set or
                        self.metric_type.is_set or
                        self.operational_state.is_set or
                        self.operational_state_changes.is_set or
                        self.outbound_frr_state.is_set or
                        self.passive_tunnel_name.is_set or
                        self.path_option_change.is_set or
                        self.pce_fail_reason.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.re_opt_hold_down_timer_remaining.is_set or
                        self.reroute_pending.is_set or
                        self.role_standby.is_set or
                        self.signaled_name.is_set or
                        self.snmp_index.is_set or
                        self.tie_breaker.is_set or
                        self.tiebreaker_qualifier.is_set or
                        self.tiebreaker_type.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_attribute_set_type.is_set or
                        self.tunnel_interface_name.is_set or
                        self.tunnel_recovering.is_set or
                        self.uptime.is_set or
                        self.xro_attribute_set_name.is_set or
                        (self.auto_backup is not None and self.auto_backup.has_data()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_data()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_data()) or
                        (self.bfd_info is not None and self.bfd_info.has_data()) or
                        (self.bidir is not None and self.bidir.has_data()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_data()) or
                        (self.config is not None and self.config.has_data()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_data()) or
                        (self.flex_info is not None and self.flex_info.has_data()) or
                        (self.history is not None and self.history.has_data()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_data()) or
                        (self.p2p_info is not None and self.p2p_info.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_data()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_data()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_data()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_data()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_data()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_data()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_data()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_data()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_data()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                def has_operation(self):
                    for c in self.destination:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.admin_state.yfilter != YFilter.not_set or
                        self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.auto_route.yfilter != YFilter.not_set or
                        self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set or
                        self.bandwidth_requested.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.binding_label.yfilter != YFilter.not_set or
                        self.binding_label_exists.yfilter != YFilter.not_set or
                        self.create_time.yfilter != YFilter.not_set or
                        self.destination_disabled_count.yfilter != YFilter.not_set or
                        self.destination_down_count.yfilter != YFilter.not_set or
                        self.destination_up_count.yfilter != YFilter.not_set or
                        self.drop_mode.yfilter != YFilter.not_set or
                        self.explicit_path_change.yfilter != YFilter.not_set or
                        self.fail_reason.yfilter != YFilter.not_set or
                        self.forwarding_adjacency.yfilter != YFilter.not_set or
                        self.hop_limit_ignored_reason.yfilter != YFilter.not_set or
                        self.invalidation_time_remained.yfilter != YFilter.not_set or
                        self.is_auto_backup.yfilter != YFilter.not_set or
                        self.is_auto_pcc.yfilter != YFilter.not_set or
                        self.is_bandwidth_protect.yfilter != YFilter.not_set or
                        self.is_hop_limit_ignore.yfilter != YFilter.not_set or
                        self.is_inter_area_tunnel.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_named.yfilter != YFilter.not_set or
                        self.is_node_protected.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.is_pce_delegated.yfilter != YFilter.not_set or
                        self.last_hop_ifindex.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.load_share_factor.yfilter != YFilter.not_set or
                        self.load_share_type.yfilter != YFilter.not_set or
                        self.lsp_wrap_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set or
                        self.metric_qualifier.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set or
                        self.operational_state.yfilter != YFilter.not_set or
                        self.operational_state_changes.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.passive_tunnel_name.yfilter != YFilter.not_set or
                        self.path_option_change.yfilter != YFilter.not_set or
                        self.pce_fail_reason.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set or
                        self.reroute_pending.yfilter != YFilter.not_set or
                        self.role_standby.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.snmp_index.yfilter != YFilter.not_set or
                        self.tie_breaker.yfilter != YFilter.not_set or
                        self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                        self.tiebreaker_type.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        self.tunnel_interface_name.yfilter != YFilter.not_set or
                        self.tunnel_recovering.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        self.xro_attribute_set_name.yfilter != YFilter.not_set or
                        (self.auto_backup is not None and self.auto_backup.has_operation()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_operation()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_operation()) or
                        (self.bfd_info is not None and self.bfd_info.has_operation()) or
                        (self.bidir is not None and self.bidir.has_operation()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_operation()) or
                        (self.config is not None and self.config.has_operation()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_operation()) or
                        (self.flex_info is not None and self.flex_info.has_operation()) or
                        (self.history is not None and self.history.has_operation()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_operation()) or
                        (self.p2p_info is not None and self.p2p_info.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_operation()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_operation()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_operation()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_operation()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_operation()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_operation()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_operation()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_operation()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_operation()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nni-tunnel" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/nni-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.admin_state.is_set or self.admin_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_state.get_name_leafdata())
                    if (self.affinity_failure_delayed_tear_time_remained.is_set or self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_delayed_tear_time_remained.get_name_leafdata())
                    if (self.affinity_failure_reopt_disabled.is_set or self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_disabled.get_name_leafdata())
                    if (self.affinity_failure_reopt_time_remained.is_set or self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_time_remained.get_name_leafdata())
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.auto_route.is_set or self.auto_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_route.get_name_leafdata())
                    if (self.autoroute_announce_exclude_segment_routing.is_set or self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autoroute_announce_exclude_segment_routing.get_name_leafdata())
                    if (self.bandwidth_requested.is_set or self.bandwidth_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_requested.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                    if (self.binding_label_exists.is_set or self.binding_label_exists.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label_exists.get_name_leafdata())
                    if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.create_time.get_name_leafdata())
                    if (self.destination_disabled_count.is_set or self.destination_disabled_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_disabled_count.get_name_leafdata())
                    if (self.destination_down_count.is_set or self.destination_down_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_down_count.get_name_leafdata())
                    if (self.destination_up_count.is_set or self.destination_up_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_up_count.get_name_leafdata())
                    if (self.drop_mode.is_set or self.drop_mode.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.drop_mode.get_name_leafdata())
                    if (self.explicit_path_change.is_set or self.explicit_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.explicit_path_change.get_name_leafdata())
                    if (self.fail_reason.is_set or self.fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fail_reason.get_name_leafdata())
                    if (self.forwarding_adjacency.is_set or self.forwarding_adjacency.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency.get_name_leafdata())
                    if (self.hop_limit_ignored_reason.is_set or self.hop_limit_ignored_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit_ignored_reason.get_name_leafdata())
                    if (self.invalidation_time_remained.is_set or self.invalidation_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.invalidation_time_remained.get_name_leafdata())
                    if (self.is_auto_backup.is_set or self.is_auto_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_backup.get_name_leafdata())
                    if (self.is_auto_pcc.is_set or self.is_auto_pcc.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_pcc.get_name_leafdata())
                    if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                    if (self.is_hop_limit_ignore.is_set or self.is_hop_limit_ignore.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_hop_limit_ignore.get_name_leafdata())
                    if (self.is_inter_area_tunnel.is_set or self.is_inter_area_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_inter_area_tunnel.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_named.is_set or self.is_named.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_named.get_name_leafdata())
                    if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.is_pce_delegated.is_set or self.is_pce_delegated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_delegated.get_name_leafdata())
                    if (self.last_hop_ifindex.is_set or self.last_hop_ifindex.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_hop_ifindex.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.load_share_factor.is_set or self.load_share_factor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_factor.get_name_leafdata())
                    if (self.load_share_type.is_set or self.load_share_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_type.get_name_leafdata())
                    if (self.lsp_wrap_label.is_set or self.lsp_wrap_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_enabled.is_set or self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enabled.get_name_leafdata())
                    if (self.metric_qualifier.is_set or self.metric_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_qualifier.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                    if (self.operational_state.is_set or self.operational_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state.get_name_leafdata())
                    if (self.operational_state_changes.is_set or self.operational_state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state_changes.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.passive_tunnel_name.is_set or self.passive_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.passive_tunnel_name.get_name_leafdata())
                    if (self.path_option_change.is_set or self.path_option_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_option_change.get_name_leafdata())
                    if (self.pce_fail_reason.is_set or self.pce_fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_fail_reason.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.re_opt_hold_down_timer_remaining.is_set or self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.re_opt_hold_down_timer_remaining.get_name_leafdata())
                    if (self.reroute_pending.is_set or self.reroute_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reroute_pending.get_name_leafdata())
                    if (self.role_standby.is_set or self.role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role_standby.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.snmp_index.is_set or self.snmp_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.snmp_index.get_name_leafdata())
                    if (self.tie_breaker.is_set or self.tie_breaker.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tie_breaker.get_name_leafdata())
                    if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                    if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())
                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())
                    if (self.tunnel_recovering.is_set or self.tunnel_recovering.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_recovering.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())
                    if (self.xro_attribute_set_name.is_set or self.xro_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.xro_attribute_set_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-backup"):
                        if (self.auto_backup is None):
                            self.auto_backup = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoBackup()
                            self.auto_backup.parent = self
                            self._children_name_map["auto_backup"] = "auto-backup"
                        return self.auto_backup

                    if (child_yang_name == "auto-mesh"):
                        if (self.auto_mesh is None):
                            self.auto_mesh = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoMesh()
                            self.auto_mesh.parent = self
                            self._children_name_map["auto_mesh"] = "auto-mesh"
                        return self.auto_mesh

                    if (child_yang_name == "auto-pcc"):
                        if (self.auto_pcc is None):
                            self.auto_pcc = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.AutoPcc()
                            self.auto_pcc.parent = self
                            self._children_name_map["auto_pcc"] = "auto-pcc"
                        return self.auto_pcc

                    if (child_yang_name == "bfd-info"):
                        if (self.bfd_info is None):
                            self.bfd_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.BfdInfo()
                            self.bfd_info.parent = self
                            self._children_name_map["bfd_info"] = "bfd-info"
                        return self.bfd_info

                    if (child_yang_name == "bidir"):
                        if (self.bidir is None):
                            self.bidir = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Bidir()
                            self.bidir.parent = self
                            self._children_name_map["bidir"] = "bidir"
                        return self.bidir

                    if (child_yang_name == "cleaned-lsp"):
                        if (self.cleaned_lsp is None):
                            self.cleaned_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                            self.cleaned_lsp.parent = self
                            self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                        return self.cleaned_lsp

                    if (child_yang_name == "config"):
                        if (self.config is None):
                            self.config = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Config()
                            self.config.parent = self
                            self._children_name_map["config"] = "config"
                        return self.config

                    if (child_yang_name == "delay-clean-pp-lsp"):
                        if (self.delay_clean_pp_lsp is None):
                            self.delay_clean_pp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                            self.delay_clean_pp_lsp.parent = self
                            self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                        return self.delay_clean_pp_lsp

                    if (child_yang_name == "destination"):
                        for c in self.destination:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.Destination()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination.append(c)
                        return c

                    if (child_yang_name == "flex-info"):
                        if (self.flex_info is None):
                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                        return self.flex_info

                    if (child_yang_name == "history"):
                        if (self.history is None):
                            self.history = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.History()
                            self.history.parent = self
                            self._children_name_map["history"] = "history"
                        return self.history

                    if (child_yang_name == "otn-bidir"):
                        if (self.otn_bidir is None):
                            self.otn_bidir = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.OtnBidir()
                            self.otn_bidir.parent = self
                            self._children_name_map["otn_bidir"] = "otn-bidir"
                        return self.otn_bidir

                    if (child_yang_name == "p2p-info"):
                        if (self.p2p_info is None):
                            self.p2p_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.P2PInfo()
                            self.p2p_info.parent = self
                            self._children_name_map["p2p_info"] = "p2p-info"
                        return self.p2p_info

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "pce-delegation"):
                        if (self.pce_delegation is None):
                            self.pce_delegation = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.PceDelegation()
                            self.pce_delegation.parent = self
                            self._children_name_map["pce_delegation"] = "pce-delegation"
                        return self.pce_delegation

                    if (child_yang_name == "reoptimized-p2mp-lsp"):
                        if (self.reoptimized_p2mp_lsp is None):
                            self.reoptimized_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedP2MpLsp()
                            self.reoptimized_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                        return self.reoptimized_p2mp_lsp

                    if (child_yang_name == "reoptimized-standby-p2mp-lsp"):
                        if (self.reoptimized_standby_p2mp_lsp is None):
                            self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2MpLsp()
                            self.reoptimized_standby_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                        return self.reoptimized_standby_p2mp_lsp

                    if (child_yang_name == "soft-preemption"):
                        if (self.soft_preemption is None):
                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                        return self.soft_preemption

                    if (child_yang_name == "te-tunnel-convergence"):
                        if (self.te_tunnel_convergence is None):
                            self.te_tunnel_convergence = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                            self.te_tunnel_convergence.parent = self
                            self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                        return self.te_tunnel_convergence

                    if (child_yang_name == "transport-tunnel-info"):
                        if (self.transport_tunnel_info is None):
                            self.transport_tunnel_info = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                            self.transport_tunnel_info.parent = self
                            self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                        return self.transport_tunnel_info

                    if (child_yang_name == "tunnel-current-lsp"):
                        if (self.tunnel_current_lsp is None):
                            self.tunnel_current_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                            self.tunnel_current_lsp.parent = self
                            self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                        return self.tunnel_current_lsp

                    if (child_yang_name == "tunnel-restoration-lsp"):
                        if (self.tunnel_restoration_lsp is None):
                            self.tunnel_restoration_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                            self.tunnel_restoration_lsp.parent = self
                            self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                        return self.tunnel_restoration_lsp

                    if (child_yang_name == "tunnel-standby-lsp"):
                        if (self.tunnel_standby_lsp is None):
                            self.tunnel_standby_lsp = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                            self.tunnel_standby_lsp.parent = self
                            self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                        return self.tunnel_standby_lsp

                    if (child_yang_name == "wdm-unitunnel"):
                        if (self.wdm_unitunnel is None):
                            self.wdm_unitunnel = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                            self.wdm_unitunnel.parent = self
                            self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                        return self.wdm_unitunnel

                    if (child_yang_name == "xro-attribute-set"):
                        if (self.xro_attribute_set is None):
                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                        return self.xro_attribute_set

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-backup" or name == "auto-mesh" or name == "auto-pcc" or name == "bfd-info" or name == "bidir" or name == "cleaned-lsp" or name == "config" or name == "delay-clean-pp-lsp" or name == "destination" or name == "flex-info" or name == "history" or name == "otn-bidir" or name == "p2p-info" or name == "path-protection" or name == "pce-delegation" or name == "reoptimized-p2mp-lsp" or name == "reoptimized-standby-p2mp-lsp" or name == "soft-preemption" or name == "te-tunnel-convergence" or name == "transport-tunnel-info" or name == "tunnel-current-lsp" or name == "tunnel-restoration-lsp" or name == "tunnel-standby-lsp" or name == "wdm-unitunnel" or name == "xro-attribute-set" or name == "tunnel-id" or name == "source-address" or name == "destination-address" or name == "admin-state" or name == "affinity-failure-delayed-tear-time-remained" or name == "affinity-failure-reopt-disabled" or name == "affinity-failure-reopt-time-remained" or name == "area-id" or name == "auto-route" or name == "autoroute-announce-exclude-segment-routing" or name == "bandwidth-requested" or name == "bandwidth-type" or name == "binding-label" or name == "binding-label-exists" or name == "create-time" or name == "destination-disabled-count" or name == "destination-down-count" or name == "destination-up-count" or name == "drop-mode" or name == "explicit-path-change" or name == "fail-reason" or name == "forwarding-adjacency" or name == "hop-limit-ignored-reason" or name == "invalidation-time-remained" or name == "is-auto-backup" or name == "is-auto-pcc" or name == "is-bandwidth-protect" or name == "is-hop-limit-ignore" or name == "is-inter-area-tunnel" or name == "is-interface" or name == "is-named" or name == "is-node-protected" or name == "is-passive" or name == "is-pce-delegated" or name == "last-hop-ifindex" or name == "last-path-change" or name == "load-share-factor" or name == "load-share-type" or name == "lsp-wrap-label" or name == "lsp-wrap-protection-enabled" or name == "metric-qualifier" or name == "metric-type" or name == "operational-state" or name == "operational-state-changes" or name == "outbound-frr-state" or name == "passive-tunnel-name" or name == "path-option-change" or name == "pce-fail-reason" or name == "persistent-bytes" or name == "persistent-packets" or name == "re-opt-hold-down-timer-remaining" or name == "reroute-pending" or name == "role-standby" or name == "signaled-name" or name == "snmp-index" or name == "tie-breaker" or name == "tiebreaker-qualifier" or name == "tiebreaker-type" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-type" or name == "tunnel-interface-name" or name == "tunnel-recovering" or name == "uptime" or name == "xro-attribute-set-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-state"):
                        self.admin_state = value
                        self.admin_state.value_namespace = name_space
                        self.admin_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-delayed-tear-time-remained"):
                        self.affinity_failure_delayed_tear_time_remained = value
                        self.affinity_failure_delayed_tear_time_remained.value_namespace = name_space
                        self.affinity_failure_delayed_tear_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-disabled"):
                        self.affinity_failure_reopt_disabled = value
                        self.affinity_failure_reopt_disabled.value_namespace = name_space
                        self.affinity_failure_reopt_disabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-time-remained"):
                        self.affinity_failure_reopt_time_remained = value
                        self.affinity_failure_reopt_time_remained.value_namespace = name_space
                        self.affinity_failure_reopt_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-route"):
                        self.auto_route = value
                        self.auto_route.value_namespace = name_space
                        self.auto_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "autoroute-announce-exclude-segment-routing"):
                        self.autoroute_announce_exclude_segment_routing = value
                        self.autoroute_announce_exclude_segment_routing.value_namespace = name_space
                        self.autoroute_announce_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-requested"):
                        self.bandwidth_requested = value
                        self.bandwidth_requested.value_namespace = name_space
                        self.bandwidth_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label"):
                        self.binding_label = value
                        self.binding_label.value_namespace = name_space
                        self.binding_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label-exists"):
                        self.binding_label_exists = value
                        self.binding_label_exists.value_namespace = name_space
                        self.binding_label_exists.value_namespace_prefix = name_space_prefix
                    if(value_path == "create-time"):
                        self.create_time = value
                        self.create_time.value_namespace = name_space
                        self.create_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-disabled-count"):
                        self.destination_disabled_count = value
                        self.destination_disabled_count.value_namespace = name_space
                        self.destination_disabled_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-down-count"):
                        self.destination_down_count = value
                        self.destination_down_count.value_namespace = name_space
                        self.destination_down_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-up-count"):
                        self.destination_up_count = value
                        self.destination_up_count.value_namespace = name_space
                        self.destination_up_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "drop-mode"):
                        self.drop_mode = value
                        self.drop_mode.value_namespace = name_space
                        self.drop_mode.value_namespace_prefix = name_space_prefix
                    if(value_path == "explicit-path-change"):
                        self.explicit_path_change = value
                        self.explicit_path_change.value_namespace = name_space
                        self.explicit_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "fail-reason"):
                        self.fail_reason = value
                        self.fail_reason.value_namespace = name_space
                        self.fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency"):
                        self.forwarding_adjacency = value
                        self.forwarding_adjacency.value_namespace = name_space
                        self.forwarding_adjacency.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit-ignored-reason"):
                        self.hop_limit_ignored_reason = value
                        self.hop_limit_ignored_reason.value_namespace = name_space
                        self.hop_limit_ignored_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "invalidation-time-remained"):
                        self.invalidation_time_remained = value
                        self.invalidation_time_remained.value_namespace = name_space
                        self.invalidation_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-backup"):
                        self.is_auto_backup = value
                        self.is_auto_backup.value_namespace = name_space
                        self.is_auto_backup.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-pcc"):
                        self.is_auto_pcc = value
                        self.is_auto_pcc.value_namespace = name_space
                        self.is_auto_pcc.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bandwidth-protect"):
                        self.is_bandwidth_protect = value
                        self.is_bandwidth_protect.value_namespace = name_space
                        self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-hop-limit-ignore"):
                        self.is_hop_limit_ignore = value
                        self.is_hop_limit_ignore.value_namespace = name_space
                        self.is_hop_limit_ignore.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-inter-area-tunnel"):
                        self.is_inter_area_tunnel = value
                        self.is_inter_area_tunnel.value_namespace = name_space
                        self.is_inter_area_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-named"):
                        self.is_named = value
                        self.is_named.value_namespace = name_space
                        self.is_named.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-node-protected"):
                        self.is_node_protected = value
                        self.is_node_protected.value_namespace = name_space
                        self.is_node_protected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-delegated"):
                        self.is_pce_delegated = value
                        self.is_pce_delegated.value_namespace = name_space
                        self.is_pce_delegated.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-hop-ifindex"):
                        self.last_hop_ifindex = value
                        self.last_hop_ifindex.value_namespace = name_space
                        self.last_hop_ifindex.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-factor"):
                        self.load_share_factor = value
                        self.load_share_factor.value_namespace = name_space
                        self.load_share_factor.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-type"):
                        self.load_share_type = value
                        self.load_share_type.value_namespace = name_space
                        self.load_share_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-label"):
                        self.lsp_wrap_label = value
                        self.lsp_wrap_label.value_namespace = name_space
                        self.lsp_wrap_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enabled"):
                        self.lsp_wrap_protection_enabled = value
                        self.lsp_wrap_protection_enabled.value_namespace = name_space
                        self.lsp_wrap_protection_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-qualifier"):
                        self.metric_qualifier = value
                        self.metric_qualifier.value_namespace = name_space
                        self.metric_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state"):
                        self.operational_state = value
                        self.operational_state.value_namespace = name_space
                        self.operational_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state-changes"):
                        self.operational_state_changes = value
                        self.operational_state_changes.value_namespace = name_space
                        self.operational_state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "passive-tunnel-name"):
                        self.passive_tunnel_name = value
                        self.passive_tunnel_name.value_namespace = name_space
                        self.passive_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-option-change"):
                        self.path_option_change = value
                        self.path_option_change.value_namespace = name_space
                        self.path_option_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-fail-reason"):
                        self.pce_fail_reason = value
                        self.pce_fail_reason.value_namespace = name_space
                        self.pce_fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "re-opt-hold-down-timer-remaining"):
                        self.re_opt_hold_down_timer_remaining = value
                        self.re_opt_hold_down_timer_remaining.value_namespace = name_space
                        self.re_opt_hold_down_timer_remaining.value_namespace_prefix = name_space_prefix
                    if(value_path == "reroute-pending"):
                        self.reroute_pending = value
                        self.reroute_pending.value_namespace = name_space
                        self.reroute_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "role-standby"):
                        self.role_standby = value
                        self.role_standby.value_namespace = name_space
                        self.role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "snmp-index"):
                        self.snmp_index = value
                        self.snmp_index.value_namespace = name_space
                        self.snmp_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "tie-breaker"):
                        self.tie_breaker = value
                        self.tie_breaker.value_namespace = name_space
                        self.tie_breaker.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-qualifier"):
                        self.tiebreaker_qualifier = value
                        self.tiebreaker_qualifier.value_namespace = name_space
                        self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-type"):
                        self.tiebreaker_type = value
                        self.tiebreaker_type.value_namespace = name_space
                        self.tiebreaker_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface-name"):
                        self.tunnel_interface_name = value
                        self.tunnel_interface_name.value_namespace = name_space
                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-recovering"):
                        self.tunnel_recovering = value
                        self.tunnel_recovering.value_namespace = name_space
                        self.tunnel_recovering.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix
                    if(value_path == "xro-attribute-set-name"):
                        self.xro_attribute_set_name = value
                        self.xro_attribute_set_name.value_namespace = name_space
                        self.xro_attribute_set_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.nni_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.nni_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nni-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nni-tunnel"):
                    for c in self.nni_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2PP2MpTunnel.NniTunnels.NniTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.nni_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nni-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelHeads(Entity):
            """
            Restrict display to P2P or P2MP head tunnels
            
            .. attribute:: tunnel_head
            
            	mpls te p2p or p2mp tunnels
            	**type**\: list of    :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads, self).__init__()

                self.yang_name = "tunnel-heads"
                self.yang_parent_name = "p2p-p2mp-tunnel"

                self.tunnel_head = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads, self).__setattr__(name, value)


            class TunnelHead(Entity):
                """
                mpls te p2p or p2mp tunnels
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:   :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\:  bool
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\:  str
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:   :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup>`
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:   :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh>`
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:   :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc>`
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\:  bool
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\:  bool
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:   :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo>`
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:   :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir>`
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\:  bool
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:   :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp>`
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config>`
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:   :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp>`
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination>`
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\:  bool
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:   :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo>`
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\:  bool
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:   :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History>`
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:   :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\:  bool
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\:  bool
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\:  bool
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\:  bool
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\:  bool
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\:  bool
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\:  bool
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\:  bool
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\:  bool
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:   :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\:  bool
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:   :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:   :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir>`
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo>`
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\:  str
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection>`
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:   :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation>`
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:   :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:   :py:class:`ReoptimizedP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp>`
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:   :py:class:`ReoptimizedStandbyP2MpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp>`
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\:  bool
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\:  bool
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption>`
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:   :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence>`
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:   :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo>`
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\:  str
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:   :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp>`
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\:  bool
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:   :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp>`
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:   :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp>`
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:   :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel>`
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet>`
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__init__()

                    self.yang_name = "tunnel-head"
                    self.yang_parent_name = "tunnel-heads"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.admin_state = YLeaf(YType.enumeration, "admin-state")

                    self.affinity_failure_delayed_tear_time_remained = YLeaf(YType.uint32, "affinity-failure-delayed-tear-time-remained")

                    self.affinity_failure_reopt_disabled = YLeaf(YType.boolean, "affinity-failure-reopt-disabled")

                    self.affinity_failure_reopt_time_remained = YLeaf(YType.uint32, "affinity-failure-reopt-time-remained")

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.auto_route = YLeaf(YType.boolean, "auto-route")

                    self.autoroute_announce_exclude_segment_routing = YLeaf(YType.boolean, "autoroute-announce-exclude-segment-routing")

                    self.bandwidth_requested = YLeaf(YType.uint32, "bandwidth-requested")

                    self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                    self.binding_label_exists = YLeaf(YType.boolean, "binding-label-exists")

                    self.create_time = YLeaf(YType.uint32, "create-time")

                    self.destination_disabled_count = YLeaf(YType.uint32, "destination-disabled-count")

                    self.destination_down_count = YLeaf(YType.uint32, "destination-down-count")

                    self.destination_up_count = YLeaf(YType.uint32, "destination-up-count")

                    self.drop_mode = YLeaf(YType.boolean, "drop-mode")

                    self.explicit_path_change = YLeaf(YType.boolean, "explicit-path-change")

                    self.fail_reason = YLeaf(YType.enumeration, "fail-reason")

                    self.forwarding_adjacency = YLeaf(YType.boolean, "forwarding-adjacency")

                    self.hop_limit_ignored_reason = YLeaf(YType.enumeration, "hop-limit-ignored-reason")

                    self.invalidation_time_remained = YLeaf(YType.uint32, "invalidation-time-remained")

                    self.is_auto_backup = YLeaf(YType.boolean, "is-auto-backup")

                    self.is_auto_pcc = YLeaf(YType.boolean, "is-auto-pcc")

                    self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                    self.is_hop_limit_ignore = YLeaf(YType.boolean, "is-hop-limit-ignore")

                    self.is_inter_area_tunnel = YLeaf(YType.boolean, "is-inter-area-tunnel")

                    self.is_interface = YLeaf(YType.boolean, "is-interface")

                    self.is_named = YLeaf(YType.boolean, "is-named")

                    self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                    self.is_passive = YLeaf(YType.boolean, "is-passive")

                    self.is_pce_delegated = YLeaf(YType.boolean, "is-pce-delegated")

                    self.last_hop_ifindex = YLeaf(YType.uint32, "last-hop-ifindex")

                    self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                    self.load_share_factor = YLeaf(YType.uint32, "load-share-factor")

                    self.load_share_type = YLeaf(YType.enumeration, "load-share-type")

                    self.lsp_wrap_label = YLeaf(YType.uint32, "lsp-wrap-label")

                    self.lsp_wrap_protection_enabled = YLeaf(YType.boolean, "lsp-wrap-protection-enabled")

                    self.metric_qualifier = YLeaf(YType.enumeration, "metric-qualifier")

                    self.metric_type = YLeaf(YType.enumeration, "metric-type")

                    self.operational_state = YLeaf(YType.enumeration, "operational-state")

                    self.operational_state_changes = YLeaf(YType.uint32, "operational-state-changes")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.passive_tunnel_name = YLeaf(YType.str, "passive-tunnel-name")

                    self.path_option_change = YLeaf(YType.boolean, "path-option-change")

                    self.pce_fail_reason = YLeaf(YType.enumeration, "pce-fail-reason")

                    self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                    self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                    self.re_opt_hold_down_timer_remaining = YLeaf(YType.uint32, "re-opt-hold-down-timer-remaining")

                    self.reroute_pending = YLeaf(YType.boolean, "reroute-pending")

                    self.role_standby = YLeaf(YType.boolean, "role-standby")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.snmp_index = YLeaf(YType.uint32, "snmp-index")

                    self.tie_breaker = YLeaf(YType.enumeration, "tie-breaker")

                    self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                    self.tiebreaker_type = YLeaf(YType.uint32, "tiebreaker-type")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                    self.tunnel_recovering = YLeaf(YType.boolean, "tunnel-recovering")

                    self.uptime = YLeaf(YType.uint32, "uptime")

                    self.xro_attribute_set_name = YLeaf(YType.str, "xro-attribute-set-name")

                    self.auto_backup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"
                    self._children_yang_names.add("auto-backup")

                    self.auto_mesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"
                    self._children_yang_names.add("auto-mesh")

                    self.auto_pcc = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"
                    self._children_yang_names.add("auto-pcc")

                    self.bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"
                    self._children_yang_names.add("bfd-info")

                    self.bidir = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"
                    self._children_yang_names.add("bidir")

                    self.cleaned_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                    self._children_yang_names.add("cleaned-lsp")

                    self.config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"
                    self._children_yang_names.add("config")

                    self.delay_clean_pp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                    self._children_yang_names.add("delay-clean-pp-lsp")

                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"
                    self._children_yang_names.add("flex-info")

                    self.history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"
                    self._children_yang_names.add("history")

                    self.otn_bidir = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"
                    self._children_yang_names.add("otn-bidir")

                    self.p2p_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"
                    self._children_yang_names.add("p2p-info")

                    self.path_protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.pce_delegation = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"
                    self._children_yang_names.add("pce-delegation")

                    self.reoptimized_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-p2mp-lsp")

                    self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                    self._children_yang_names.add("reoptimized-standby-p2mp-lsp")

                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"
                    self._children_yang_names.add("soft-preemption")

                    self.te_tunnel_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                    self._children_yang_names.add("te-tunnel-convergence")

                    self.transport_tunnel_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                    self._children_yang_names.add("transport-tunnel-info")

                    self.tunnel_current_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                    self._children_yang_names.add("tunnel-current-lsp")

                    self.tunnel_restoration_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                    self._children_yang_names.add("tunnel-restoration-lsp")

                    self.tunnel_standby_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                    self._children_yang_names.add("tunnel-standby-lsp")

                    self.wdm_unitunnel = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                    self._children_yang_names.add("wdm-unitunnel")

                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                    self._children_yang_names.add("xro-attribute-set")

                    self.destination = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "admin_state",
                                    "affinity_failure_delayed_tear_time_remained",
                                    "affinity_failure_reopt_disabled",
                                    "affinity_failure_reopt_time_remained",
                                    "area_id",
                                    "auto_route",
                                    "autoroute_announce_exclude_segment_routing",
                                    "bandwidth_requested",
                                    "bandwidth_type",
                                    "binding_label",
                                    "binding_label_exists",
                                    "create_time",
                                    "destination_disabled_count",
                                    "destination_down_count",
                                    "destination_up_count",
                                    "drop_mode",
                                    "explicit_path_change",
                                    "fail_reason",
                                    "forwarding_adjacency",
                                    "hop_limit_ignored_reason",
                                    "invalidation_time_remained",
                                    "is_auto_backup",
                                    "is_auto_pcc",
                                    "is_bandwidth_protect",
                                    "is_hop_limit_ignore",
                                    "is_inter_area_tunnel",
                                    "is_interface",
                                    "is_named",
                                    "is_node_protected",
                                    "is_passive",
                                    "is_pce_delegated",
                                    "last_hop_ifindex",
                                    "last_path_change",
                                    "load_share_factor",
                                    "load_share_type",
                                    "lsp_wrap_label",
                                    "lsp_wrap_protection_enabled",
                                    "metric_qualifier",
                                    "metric_type",
                                    "operational_state",
                                    "operational_state_changes",
                                    "outbound_frr_state",
                                    "passive_tunnel_name",
                                    "path_option_change",
                                    "pce_fail_reason",
                                    "persistent_bytes",
                                    "persistent_packets",
                                    "re_opt_hold_down_timer_remaining",
                                    "reroute_pending",
                                    "role_standby",
                                    "signaled_name",
                                    "snmp_index",
                                    "tie_breaker",
                                    "tiebreaker_qualifier",
                                    "tiebreaker_type",
                                    "tunnel_attribute_set_name",
                                    "tunnel_attribute_set_type",
                                    "tunnel_interface_name",
                                    "tunnel_recovering",
                                    "uptime",
                                    "xro_attribute_set_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead, self).__setattr__(name, value)


                class Config(Entity):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity>`
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of    :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination>`
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:   :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig>`
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:   :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig>`
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\:  bool
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\:  bool
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\:  bool
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\:  bool
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\:  str
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\:  bool
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "tunnel-head"

                        self.affinity_failure_reopt_timer = YLeaf(YType.uint32, "affinity-failure-reopt-timer")

                        self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                        self.backup_bandwidth_flags = YLeaf(YType.uint8, "backup-bandwidth-flags")

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.config_load_share = YLeaf(YType.uint32, "config-load-share")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.cost_limit_global = YLeaf(YType.uint32, "cost-limit-global")

                        self.disable_affinity_failure_reopt = YLeaf(YType.boolean, "disable-affinity-failure-reopt")

                        self.explicit_null_imposition = YLeaf(YType.boolean, "explicit-null-imposition")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.hop_limit = YLeaf(YType.uint8, "hop-limit")

                        self.interface_configured_bandwidth = YLeaf(YType.uint32, "interface-configured-bandwidth")

                        self.is_backup_tunnel = YLeaf(YType.boolean, "is-backup-tunnel")

                        self.is_in_config = YLeaf(YType.boolean, "is-in-config")

                        self.is_p2mp = YLeaf(YType.boolean, "is-p2mp")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_action_source = YLeaf(YType.uint32, "path-invalidation-action-source")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_invalidation_timeout_source = YLeaf(YType.uint32, "path-invalidation-timeout-source")

                        self.path_protection_enabled = YLeaf(YType.boolean, "path-protection-enabled")

                        self.payload_type = YLeaf(YType.uint16, "payload-type")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.segment_routing_path_selection = YLeaf(YType.enumeration, "segment-routing-path-selection")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.soft_preempt = YLeaf(YType.boolean, "soft-preempt")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"
                        self._children_yang_names.add("bfd-config")

                        self.bidirectional_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"
                        self._children_yang_names.add("bidirectional-config")

                        self.autoroute_destination = YList(self)
                        self.policy_class_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_failure_reopt_timer",
                                        "backup_bandwidth",
                                        "backup_bandwidth_flags",
                                        "bandwidth_type",
                                        "config_load_share",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "cost_limit_global",
                                        "disable_affinity_failure_reopt",
                                        "explicit_null_imposition",
                                        "fast_reroute",
                                        "forward_class",
                                        "hold_priority",
                                        "hop_limit",
                                        "interface_configured_bandwidth",
                                        "is_backup_tunnel",
                                        "is_in_config",
                                        "is_p2mp",
                                        "path_invalidation_action",
                                        "path_invalidation_action_source",
                                        "path_invalidation_timeout",
                                        "path_invalidation_timeout_source",
                                        "path_protection_enabled",
                                        "payload_type",
                                        "policy_class",
                                        "record_route",
                                        "segment_routing_path_selection",
                                        "setup_priority",
                                        "signaled_name",
                                        "soft_preempt",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BidirectionalConfig(Entity):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\:  bool
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: association_type
                        
                        	Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"

                            self.association_corouted = YLeaf(YType.boolean, "association-corouted")

                            self.association_global_id = YLeaf(YType.uint32, "association-global-id")

                            self.association_id = YLeaf(YType.uint16, "association-id")

                            self.association_source = YLeaf(YType.str, "association-source")

                            self.association_type = YLeaf(YType.uint16, "association-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("association_corouted",
                                            "association_global_id",
                                            "association_id",
                                            "association_source",
                                            "association_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.association_corouted.is_set or
                                self.association_global_id.is_set or
                                self.association_id.is_set or
                                self.association_source.is_set or
                                self.association_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.association_corouted.yfilter != YFilter.not_set or
                                self.association_global_id.yfilter != YFilter.not_set or
                                self.association_id.yfilter != YFilter.not_set or
                                self.association_source.yfilter != YFilter.not_set or
                                self.association_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bidirectional-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.association_corouted.is_set or self.association_corouted.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_corouted.get_name_leafdata())
                            if (self.association_global_id.is_set or self.association_global_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_global_id.get_name_leafdata())
                            if (self.association_id.is_set or self.association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_id.get_name_leafdata())
                            if (self.association_source.is_set or self.association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_source.get_name_leafdata())
                            if (self.association_type.is_set or self.association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.association_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association-corouted" or name == "association-global-id" or name == "association-id" or name == "association-source" or name == "association-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "association-corouted"):
                                self.association_corouted = value
                                self.association_corouted.value_namespace = name_space
                                self.association_corouted.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-global-id"):
                                self.association_global_id = value
                                self.association_global_id.value_namespace = name_space
                                self.association_global_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-id"):
                                self.association_id = value
                                self.association_id.value_namespace = name_space
                                self.association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-source"):
                                self.association_source = value
                                self.association_source.value_namespace = name_space
                                self.association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "association-type"):
                                self.association_type = value
                                self.association_type.value_namespace = name_space
                                self.association_type.value_namespace_prefix = name_space_prefix


                    class BfdConfig(Entity):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:   :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\:  bool
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:   :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\:  bool
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\:  bool
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\:  bool
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\:  bool
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\:  bool
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\:  bool
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"

                            self.bfd_encap_mode = YLeaf(YType.enumeration, "bfd-encap-mode")

                            self.bfd_fast_detecting_enabled = YLeaf(YType.boolean, "bfd-fast-detecting-enabled")

                            self.bfd_session_down_action = YLeaf(YType.enumeration, "bfd-session-down-action")

                            self.bfd_session_down_reopt_timeout = YLeaf(YType.uint32, "bfd-session-down-reopt-timeout")

                            self.bfd_type = YLeaf(YType.enumeration, "bfd-type")

                            self.bring_up_timeout = YLeaf(YType.uint16, "bring-up-timeout")

                            self.bring_up_timeout_default = YLeaf(YType.boolean, "bring-up-timeout-default")

                            self.dampening_initial_wait = YLeaf(YType.uint32, "dampening-initial-wait")

                            self.dampening_initial_wait_default = YLeaf(YType.boolean, "dampening-initial-wait-default")

                            self.dampening_max_wait = YLeaf(YType.uint32, "dampening-max-wait")

                            self.dampening_max_wait_default = YLeaf(YType.boolean, "dampening-max-wait-default")

                            self.dampening_secondary_wait = YLeaf(YType.uint32, "dampening-secondary-wait")

                            self.dampening_secondary_wait_default = YLeaf(YType.boolean, "dampening-secondary-wait-default")

                            self.min_interval = YLeaf(YType.uint32, "min-interval")

                            self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                            self.multiplier = YLeaf(YType.uint8, "multiplier")

                            self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                            self.periodic_lsp_ping_disabled = YLeaf(YType.boolean, "periodic-lsp-ping-disabled")

                            self.periodic_lsp_ping_interval = YLeaf(YType.uint32, "periodic-lsp-ping-interval")

                            self.periodic_lsp_ping_interval_default = YLeaf(YType.boolean, "periodic-lsp-ping-interval-default")

                            self.sbfd_target_id = YLeaf(YType.str, "sbfd-target-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_encap_mode",
                                            "bfd_fast_detecting_enabled",
                                            "bfd_session_down_action",
                                            "bfd_session_down_reopt_timeout",
                                            "bfd_type",
                                            "bring_up_timeout",
                                            "bring_up_timeout_default",
                                            "dampening_initial_wait",
                                            "dampening_initial_wait_default",
                                            "dampening_max_wait",
                                            "dampening_max_wait_default",
                                            "dampening_secondary_wait",
                                            "dampening_secondary_wait_default",
                                            "min_interval",
                                            "min_interval_default",
                                            "multiplier",
                                            "multiplier_default",
                                            "periodic_lsp_ping_disabled",
                                            "periodic_lsp_ping_interval",
                                            "periodic_lsp_ping_interval_default",
                                            "sbfd_target_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.bfd_encap_mode.is_set or
                                self.bfd_fast_detecting_enabled.is_set or
                                self.bfd_session_down_action.is_set or
                                self.bfd_session_down_reopt_timeout.is_set or
                                self.bfd_type.is_set or
                                self.bring_up_timeout.is_set or
                                self.bring_up_timeout_default.is_set or
                                self.dampening_initial_wait.is_set or
                                self.dampening_initial_wait_default.is_set or
                                self.dampening_max_wait.is_set or
                                self.dampening_max_wait_default.is_set or
                                self.dampening_secondary_wait.is_set or
                                self.dampening_secondary_wait_default.is_set or
                                self.min_interval.is_set or
                                self.min_interval_default.is_set or
                                self.multiplier.is_set or
                                self.multiplier_default.is_set or
                                self.periodic_lsp_ping_disabled.is_set or
                                self.periodic_lsp_ping_interval.is_set or
                                self.periodic_lsp_ping_interval_default.is_set or
                                self.sbfd_target_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_encap_mode.yfilter != YFilter.not_set or
                                self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set or
                                self.bfd_session_down_action.yfilter != YFilter.not_set or
                                self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set or
                                self.bfd_type.yfilter != YFilter.not_set or
                                self.bring_up_timeout.yfilter != YFilter.not_set or
                                self.bring_up_timeout_default.yfilter != YFilter.not_set or
                                self.dampening_initial_wait.yfilter != YFilter.not_set or
                                self.dampening_initial_wait_default.yfilter != YFilter.not_set or
                                self.dampening_max_wait.yfilter != YFilter.not_set or
                                self.dampening_max_wait_default.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait.yfilter != YFilter.not_set or
                                self.dampening_secondary_wait_default.yfilter != YFilter.not_set or
                                self.min_interval.yfilter != YFilter.not_set or
                                self.min_interval_default.yfilter != YFilter.not_set or
                                self.multiplier.yfilter != YFilter.not_set or
                                self.multiplier_default.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval.yfilter != YFilter.not_set or
                                self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set or
                                self.sbfd_target_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_encap_mode.is_set or self.bfd_encap_mode.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_encap_mode.get_name_leafdata())
                            if (self.bfd_fast_detecting_enabled.is_set or self.bfd_fast_detecting_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_fast_detecting_enabled.get_name_leafdata())
                            if (self.bfd_session_down_action.is_set or self.bfd_session_down_action.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_action.get_name_leafdata())
                            if (self.bfd_session_down_reopt_timeout.is_set or self.bfd_session_down_reopt_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_session_down_reopt_timeout.get_name_leafdata())
                            if (self.bfd_type.is_set or self.bfd_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_type.get_name_leafdata())
                            if (self.bring_up_timeout.is_set or self.bring_up_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout.get_name_leafdata())
                            if (self.bring_up_timeout_default.is_set or self.bring_up_timeout_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bring_up_timeout_default.get_name_leafdata())
                            if (self.dampening_initial_wait.is_set or self.dampening_initial_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait.get_name_leafdata())
                            if (self.dampening_initial_wait_default.is_set or self.dampening_initial_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_initial_wait_default.get_name_leafdata())
                            if (self.dampening_max_wait.is_set or self.dampening_max_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait.get_name_leafdata())
                            if (self.dampening_max_wait_default.is_set or self.dampening_max_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_max_wait_default.get_name_leafdata())
                            if (self.dampening_secondary_wait.is_set or self.dampening_secondary_wait.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait.get_name_leafdata())
                            if (self.dampening_secondary_wait_default.is_set or self.dampening_secondary_wait_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.dampening_secondary_wait_default.get_name_leafdata())
                            if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval.get_name_leafdata())
                            if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                            if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier.get_name_leafdata())
                            if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                            if (self.periodic_lsp_ping_disabled.is_set or self.periodic_lsp_ping_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_disabled.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval.is_set or self.periodic_lsp_ping_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval.get_name_leafdata())
                            if (self.periodic_lsp_ping_interval_default.is_set or self.periodic_lsp_ping_interval_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.periodic_lsp_ping_interval_default.get_name_leafdata())
                            if (self.sbfd_target_id.is_set or self.sbfd_target_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sbfd_target_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bfd-encap-mode" or name == "bfd-fast-detecting-enabled" or name == "bfd-session-down-action" or name == "bfd-session-down-reopt-timeout" or name == "bfd-type" or name == "bring-up-timeout" or name == "bring-up-timeout-default" or name == "dampening-initial-wait" or name == "dampening-initial-wait-default" or name == "dampening-max-wait" or name == "dampening-max-wait-default" or name == "dampening-secondary-wait" or name == "dampening-secondary-wait-default" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "periodic-lsp-ping-disabled" or name == "periodic-lsp-ping-interval" or name == "periodic-lsp-ping-interval-default" or name == "sbfd-target-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-encap-mode"):
                                self.bfd_encap_mode = value
                                self.bfd_encap_mode.value_namespace = name_space
                                self.bfd_encap_mode.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-fast-detecting-enabled"):
                                self.bfd_fast_detecting_enabled = value
                                self.bfd_fast_detecting_enabled.value_namespace = name_space
                                self.bfd_fast_detecting_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-action"):
                                self.bfd_session_down_action = value
                                self.bfd_session_down_action.value_namespace = name_space
                                self.bfd_session_down_action.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-session-down-reopt-timeout"):
                                self.bfd_session_down_reopt_timeout = value
                                self.bfd_session_down_reopt_timeout.value_namespace = name_space
                                self.bfd_session_down_reopt_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-type"):
                                self.bfd_type = value
                                self.bfd_type.value_namespace = name_space
                                self.bfd_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout"):
                                self.bring_up_timeout = value
                                self.bring_up_timeout.value_namespace = name_space
                                self.bring_up_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "bring-up-timeout-default"):
                                self.bring_up_timeout_default = value
                                self.bring_up_timeout_default.value_namespace = name_space
                                self.bring_up_timeout_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait"):
                                self.dampening_initial_wait = value
                                self.dampening_initial_wait.value_namespace = name_space
                                self.dampening_initial_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-initial-wait-default"):
                                self.dampening_initial_wait_default = value
                                self.dampening_initial_wait_default.value_namespace = name_space
                                self.dampening_initial_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait"):
                                self.dampening_max_wait = value
                                self.dampening_max_wait.value_namespace = name_space
                                self.dampening_max_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-max-wait-default"):
                                self.dampening_max_wait_default = value
                                self.dampening_max_wait_default.value_namespace = name_space
                                self.dampening_max_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait"):
                                self.dampening_secondary_wait = value
                                self.dampening_secondary_wait.value_namespace = name_space
                                self.dampening_secondary_wait.value_namespace_prefix = name_space_prefix
                            if(value_path == "dampening-secondary-wait-default"):
                                self.dampening_secondary_wait_default = value
                                self.dampening_secondary_wait_default.value_namespace = name_space
                                self.dampening_secondary_wait_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval"):
                                self.min_interval = value
                                self.min_interval.value_namespace = name_space
                                self.min_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "min-interval-default"):
                                self.min_interval_default = value
                                self.min_interval_default.value_namespace = name_space
                                self.min_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier"):
                                self.multiplier = value
                                self.multiplier.value_namespace = name_space
                                self.multiplier.value_namespace_prefix = name_space_prefix
                            if(value_path == "multiplier-default"):
                                self.multiplier_default = value
                                self.multiplier_default.value_namespace = name_space
                                self.multiplier_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-disabled"):
                                self.periodic_lsp_ping_disabled = value
                                self.periodic_lsp_ping_disabled.value_namespace = name_space
                                self.periodic_lsp_ping_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval"):
                                self.periodic_lsp_ping_interval = value
                                self.periodic_lsp_ping_interval.value_namespace = name_space
                                self.periodic_lsp_ping_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "periodic-lsp-ping-interval-default"):
                                self.periodic_lsp_ping_interval_default = value
                                self.periodic_lsp_ping_interval_default.value_namespace = name_space
                                self.periodic_lsp_ping_interval_default.value_namespace_prefix = name_space_prefix
                            if(value_path == "sbfd-target-id"):
                                self.sbfd_target_id = value
                                self.sbfd_target_id.value_namespace = name_space
                                self.sbfd_target_id.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class AutorouteDestination(Entity):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.prefix_length = YLeaf(YType.uint16, "prefix-length")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "prefix_length") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.prefix_length.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.prefix_length.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "autoroute-destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.prefix_length.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "prefix-length"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "prefix-length"):
                                self.prefix_length = value
                                self.prefix_length.value_namespace = name_space
                                self.prefix_length.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.autoroute_destination:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_failure_reopt_timer.is_set or
                            self.backup_bandwidth.is_set or
                            self.backup_bandwidth_flags.is_set or
                            self.bandwidth_type.is_set or
                            self.config_load_share.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.cost_limit_global.is_set or
                            self.disable_affinity_failure_reopt.is_set or
                            self.explicit_null_imposition.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.hold_priority.is_set or
                            self.hop_limit.is_set or
                            self.interface_configured_bandwidth.is_set or
                            self.is_backup_tunnel.is_set or
                            self.is_in_config.is_set or
                            self.is_p2mp.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_action_source.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_invalidation_timeout_source.is_set or
                            self.path_protection_enabled.is_set or
                            self.payload_type.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.segment_routing_path_selection.is_set or
                            self.setup_priority.is_set or
                            self.signaled_name.is_set or
                            self.soft_preempt.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_name.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_config is not None and self.bfd_config.has_data()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_data()))

                    def has_operation(self):
                        for c in self.autoroute_destination:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_failure_reopt_timer.yfilter != YFilter.not_set or
                            self.backup_bandwidth.yfilter != YFilter.not_set or
                            self.backup_bandwidth_flags.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.config_load_share.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.cost_limit_global.yfilter != YFilter.not_set or
                            self.disable_affinity_failure_reopt.yfilter != YFilter.not_set or
                            self.explicit_null_imposition.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.hop_limit.yfilter != YFilter.not_set or
                            self.interface_configured_bandwidth.yfilter != YFilter.not_set or
                            self.is_backup_tunnel.yfilter != YFilter.not_set or
                            self.is_in_config.yfilter != YFilter.not_set or
                            self.is_p2mp.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_action_source.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout_source.yfilter != YFilter.not_set or
                            self.path_protection_enabled.yfilter != YFilter.not_set or
                            self.payload_type.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.segment_routing_path_selection.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.soft_preempt.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_config is not None and self.bfd_config.has_operation()) or
                            (self.bidirectional_config is not None and self.bidirectional_config.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "config" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_failure_reopt_timer.is_set or self.affinity_failure_reopt_timer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_failure_reopt_timer.get_name_leafdata())
                        if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                        if (self.backup_bandwidth_flags.is_set or self.backup_bandwidth_flags.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_bandwidth_flags.get_name_leafdata())
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.config_load_share.is_set or self.config_load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.config_load_share.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.cost_limit_global.is_set or self.cost_limit_global.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit_global.get_name_leafdata())
                        if (self.disable_affinity_failure_reopt.is_set or self.disable_affinity_failure_reopt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.disable_affinity_failure_reopt.get_name_leafdata())
                        if (self.explicit_null_imposition.is_set or self.explicit_null_imposition.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.explicit_null_imposition.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hop_limit.get_name_leafdata())
                        if (self.interface_configured_bandwidth.is_set or self.interface_configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_configured_bandwidth.get_name_leafdata())
                        if (self.is_backup_tunnel.is_set or self.is_backup_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup_tunnel.get_name_leafdata())
                        if (self.is_in_config.is_set or self.is_in_config.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_in_config.get_name_leafdata())
                        if (self.is_p2mp.is_set or self.is_p2mp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_p2mp.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_action_source.is_set or self.path_invalidation_action_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action_source.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_invalidation_timeout_source.is_set or self.path_invalidation_timeout_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout_source.get_name_leafdata())
                        if (self.path_protection_enabled.is_set or self.path_protection_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_enabled.get_name_leafdata())
                        if (self.payload_type.is_set or self.payload_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.payload_type.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.segment_routing_path_selection.is_set or self.segment_routing_path_selection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_routing_path_selection.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.soft_preempt.is_set or self.soft_preempt.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preempt.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "autoroute-destination"):
                            for c in self.autoroute_destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.autoroute_destination.append(c)
                            return c

                        if (child_yang_name == "bfd-config"):
                            if (self.bfd_config is None):
                                self.bfd_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                                self.bfd_config.parent = self
                                self._children_name_map["bfd_config"] = "bfd-config"
                            return self.bfd_config

                        if (child_yang_name == "bidirectional-config"):
                            if (self.bidirectional_config is None):
                                self.bidirectional_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                                self.bidirectional_config.parent = self
                                self._children_name_map["bidirectional_config"] = "bidirectional-config"
                            return self.bidirectional_config

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "autoroute-destination" or name == "bfd-config" or name == "bidirectional-config" or name == "policy-class-entry" or name == "affinity-failure-reopt-timer" or name == "backup-bandwidth" or name == "backup-bandwidth-flags" or name == "bandwidth-type" or name == "config-load-share" or name == "configured-bandwidth" or name == "cost-limit" or name == "cost-limit-global" or name == "disable-affinity-failure-reopt" or name == "explicit-null-imposition" or name == "fast-reroute" or name == "forward-class" or name == "hold-priority" or name == "hop-limit" or name == "interface-configured-bandwidth" or name == "is-backup-tunnel" or name == "is-in-config" or name == "is-p2mp" or name == "path-invalidation-action" or name == "path-invalidation-action-source" or name == "path-invalidation-timeout" or name == "path-invalidation-timeout-source" or name == "path-protection-enabled" or name == "payload-type" or name == "policy-class" or name == "record-route" or name == "segment-routing-path-selection" or name == "setup-priority" or name == "signaled-name" or name == "soft-preempt" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-failure-reopt-timer"):
                            self.affinity_failure_reopt_timer = value
                            self.affinity_failure_reopt_timer.value_namespace = name_space
                            self.affinity_failure_reopt_timer.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth"):
                            self.backup_bandwidth = value
                            self.backup_bandwidth.value_namespace = name_space
                            self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "backup-bandwidth-flags"):
                            self.backup_bandwidth_flags = value
                            self.backup_bandwidth_flags.value_namespace = name_space
                            self.backup_bandwidth_flags.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "config-load-share"):
                            self.config_load_share = value
                            self.config_load_share.value_namespace = name_space
                            self.config_load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit-global"):
                            self.cost_limit_global = value
                            self.cost_limit_global.value_namespace = name_space
                            self.cost_limit_global.value_namespace_prefix = name_space_prefix
                        if(value_path == "disable-affinity-failure-reopt"):
                            self.disable_affinity_failure_reopt = value
                            self.disable_affinity_failure_reopt.value_namespace = name_space
                            self.disable_affinity_failure_reopt.value_namespace_prefix = name_space_prefix
                        if(value_path == "explicit-null-imposition"):
                            self.explicit_null_imposition = value
                            self.explicit_null_imposition.value_namespace = name_space
                            self.explicit_null_imposition.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "hop-limit"):
                            self.hop_limit = value
                            self.hop_limit.value_namespace = name_space
                            self.hop_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "interface-configured-bandwidth"):
                            self.interface_configured_bandwidth = value
                            self.interface_configured_bandwidth.value_namespace = name_space
                            self.interface_configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup-tunnel"):
                            self.is_backup_tunnel = value
                            self.is_backup_tunnel.value_namespace = name_space
                            self.is_backup_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-in-config"):
                            self.is_in_config = value
                            self.is_in_config.value_namespace = name_space
                            self.is_in_config.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-p2mp"):
                            self.is_p2mp = value
                            self.is_p2mp.value_namespace = name_space
                            self.is_p2mp.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action-source"):
                            self.path_invalidation_action_source = value
                            self.path_invalidation_action_source.value_namespace = name_space
                            self.path_invalidation_action_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout-source"):
                            self.path_invalidation_timeout_source = value
                            self.path_invalidation_timeout_source.value_namespace = name_space
                            self.path_invalidation_timeout_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-enabled"):
                            self.path_protection_enabled = value
                            self.path_protection_enabled.value_namespace = name_space
                            self.path_protection_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "payload-type"):
                            self.payload_type = value
                            self.payload_type.value_namespace = name_space
                            self.payload_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-routing-path-selection"):
                            self.segment_routing_path_selection = value
                            self.segment_routing_path_selection.value_namespace = name_space
                            self.segment_routing_path_selection.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preempt"):
                            self.soft_preempt = value
                            self.soft_preempt.value_namespace = name_space
                            self.soft_preempt.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix


                class TunnelCurrentLsp(Entity):
                    """
                    Current LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedP2MpLsp(Entity):
                    """
                    Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelStandbyLsp(Entity):
                    """
                    Standby LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
     